/* Mapbox GL JS is Copyright © 2020 Mapbox and subject to the Mapbox Terms of Service ((https://www.mapbox.com/legal/tos/). */
(function (global, factory) {
typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
typeof define === 'function' && define.amd ? define(factory) :
(global = typeof globalThis !== 'undefined' ? globalThis : global || self, global.mapboxgl = factory());
})(this, (function () { 'use strict';

/* eslint-disable */

var shared, worker, mapboxgl;
// define gets called three times: one for each chunk. we rely on the order
// they're imported to know which is which
function define(_, chunk) {
if (!shared) {
    shared = chunk;
} else if (!worker) {
    worker = chunk;
} else {
    var workerBundleString = "self.onerror = function() { console.error('An error occurred while parsing the WebWorker bundle. This is most likely due to improper transpilation by Babel; please see https://docs.mapbox.com/mapbox-gl-js/guides/install/#transpiling'); }; var sharedChunk = {}; (" + shared + ")(sharedChunk); (" + worker + ")(sharedChunk); self.onerror = null;"

    var sharedChunk = {};
    shared(sharedChunk);
    mapboxgl = chunk(sharedChunk);
    if (typeof window !== 'undefined' && window && window.URL && window.URL.createObjectURL) {
        mapboxgl.workerUrl = window.URL.createObjectURL(new Blob([workerBundleString], { type: 'text/javascript' }));
    }
}
}


define(["exports"],(function(t){"use strict";var e="undefined"!=typeof self?self:{},i="3.0.0-beta.3";let r;const n={API_URL:"https://api.mapbox.com",get API_URL_REGEX(){if(null==r){const t=/^((https?:)?\/\/)?([^\/]+\.)?mapbox\.c(n|om)(\/|\?|$)/i;try{r=null!=process.env.API_URL_REGEX?new RegExp(process.env.API_URL_REGEX):t;}catch(e){r=t;}}return r},get API_TILEJSON_REGEX(){return /^((https?:)?\/\/)?([^\/]+\.)?mapbox\.c(n|om)(\/v[0-9]*\/.*\.json.*$)/i},get API_SPRITE_REGEX(){return /^((https?:)?\/\/)?([^\/]+\.)?mapbox\.c(n|om)(\/styles\/v[0-9]*\/)(.*\/sprite.*\..*$)/i},get API_FONTS_REGEX(){return /^((https?:)?\/\/)?([^\/]+\.)?mapbox\.c(n|om)(\/fonts\/v[0-9]*\/)(.*\.pbf.*$)/i},get API_STYLE_REGEX(){return /^((https?:)?\/\/)?([^\/]+\.)?mapbox\.c(n|om)(\/styles\/v[0-9]*\/)(.*$)/i},get API_CDN_URL_REGEX(){return /^((https?:)?\/\/)?api\.mapbox\.c(n|om)(\/mapbox-gl-js\/)(.*$)/i},get EVENTS_URL(){if(!n.API_URL)return null;try{const t=new URL(n.API_URL);return "api.mapbox.cn"===t.hostname?"https://events.mapbox.cn/events/v2":"api.mapbox.com"===t.hostname?"https://events.mapbox.com/events/v2":null}catch(t){return null}},SESSION_PATH:"/map-sessions/v1",FEEDBACK_URL:"https://apps.mapbox.com/feedback",TILE_URL_VERSION:"v4",RASTER_URL_PREFIX:"raster/v1",REQUIRE_ACCESS_TOKEN:!0,ACCESS_TOKEN:null,DEFAULT_STYLE:"mapbox://styles/mapbox/standard-beta",MAX_PARALLEL_IMAGE_REQUESTS:16,LOADERS_URL:"https://api.mapbox.com/mapbox-gl-js/v3.0.0/mapbox-gl-loaders.js",GLYPHS_URL:"mapbox://fonts/mapbox/{fontstack}/{range}.pbf"},o={supported:!1,testSupport:function(t){!l&&a&&(c?h(t):s=t);}};let s,a,l=!1,c=!1;function h(t){const e=t.createTexture();t.bindTexture(t.TEXTURE_2D,e);try{if(t.texImage2D(t.TEXTURE_2D,0,t.RGBA,t.RGBA,t.UNSIGNED_BYTE,a),t.isContextLost())return;o.supported=!0;}catch(t){}t.deleteTexture(e),l=!0;}e.document&&(a=e.document.createElement("img"),a.onload=function(){s&&h(s),s=null,c=!0;},a.onerror=function(){l=!0,s=null;},a.src="data:image/webp;base64,UklGRh4AAABXRUJQVlA4TBEAAAAvAQAAAAfQ//73v/+BiOh/AAA=");const u="01";function d(t){return t&&t.__esModule&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t}var p=f;function f(t,e,i,r){this.cx=3*t,this.bx=3*(i-t)-this.cx,this.ax=1-this.cx-this.bx,this.cy=3*e,this.by=3*(r-e)-this.cy,this.ay=1-this.cy-this.by,this.p1x=t,this.p1y=e,this.p2x=i,this.p2y=r;}f.prototype={sampleCurveX:function(t){return ((this.ax*t+this.bx)*t+this.cx)*t},sampleCurveY:function(t){return ((this.ay*t+this.by)*t+this.cy)*t},sampleCurveDerivativeX:function(t){return (3*this.ax*t+2*this.bx)*t+this.cx},solveCurveX:function(t,e){if(void 0===e&&(e=1e-6),t<0)return 0;if(t>1)return 1;for(var i=t,r=0;r<8;r++){var n=this.sampleCurveX(i)-t;if(Math.abs(n)<e)return i;var o=this.sampleCurveDerivativeX(i);if(Math.abs(o)<1e-6)break;i-=n/o;}var s=0,a=1;for(i=t,r=0;r<20&&(n=this.sampleCurveX(i),!(Math.abs(n-t)<e));r++)t>n?s=i:a=i,i=.5*(a-s)+s;return i},solve:function(t,e){return this.sampleCurveY(this.solveCurveX(t,e))}};var m=d(p),_=g;function g(t,e){this.x=t,this.y=e;}g.prototype={clone:function(){return new g(this.x,this.y)},add:function(t){return this.clone()._add(t)},sub:function(t){return this.clone()._sub(t)},multByPoint:function(t){return this.clone()._multByPoint(t)},divByPoint:function(t){return this.clone()._divByPoint(t)},mult:function(t){return this.clone()._mult(t)},div:function(t){return this.clone()._div(t)},rotate:function(t){return this.clone()._rotate(t)},rotateAround:function(t,e){return this.clone()._rotateAround(t,e)},matMult:function(t){return this.clone()._matMult(t)},unit:function(){return this.clone()._unit()},perp:function(){return this.clone()._perp()},round:function(){return this.clone()._round()},mag:function(){return Math.sqrt(this.x*this.x+this.y*this.y)},equals:function(t){return this.x===t.x&&this.y===t.y},dist:function(t){return Math.sqrt(this.distSqr(t))},distSqr:function(t){var e=t.x-this.x,i=t.y-this.y;return e*e+i*i},angle:function(){return Math.atan2(this.y,this.x)},angleTo:function(t){return Math.atan2(this.y-t.y,this.x-t.x)},angleWith:function(t){return this.angleWithSep(t.x,t.y)},angleWithSep:function(t,e){return Math.atan2(this.x*e-this.y*t,this.x*t+this.y*e)},_matMult:function(t){var e=t[2]*this.x+t[3]*this.y;return this.x=t[0]*this.x+t[1]*this.y,this.y=e,this},_add:function(t){return this.x+=t.x,this.y+=t.y,this},_sub:function(t){return this.x-=t.x,this.y-=t.y,this},_mult:function(t){return this.x*=t,this.y*=t,this},_div:function(t){return this.x/=t,this.y/=t,this},_multByPoint:function(t){return this.x*=t.x,this.y*=t.y,this},_divByPoint:function(t){return this.x/=t.x,this.y/=t.y,this},_unit:function(){return this._div(this.mag()),this},_perp:function(){var t=this.y;return this.y=this.x,this.x=-t,this},_rotate:function(t){var e=Math.cos(t),i=Math.sin(t),r=i*this.x+e*this.y;return this.x=e*this.x-i*this.y,this.y=r,this},_rotateAround:function(t,e){var i=Math.cos(t),r=Math.sin(t),n=e.y+r*(this.x-e.x)+i*(this.y-e.y);return this.x=e.x+i*(this.x-e.x)-r*(this.y-e.y),this.y=n,this},_round:function(){return this.x=Math.round(this.x),this.y=Math.round(this.y),this}},g.convert=function(t){return t instanceof g?t:Array.isArray(t)?new g(t[0],t[1]):t};var y=d(_);function x(t,e){if(Array.isArray(t)){if(!Array.isArray(e)||t.length!==e.length)return !1;for(let i=0;i<t.length;i++)if(!x(t[i],e[i]))return !1;return !0}if("object"==typeof t&&null!==t&&null!==e){if("object"!=typeof e)return !1;if(Object.keys(t).length!==Object.keys(e).length)return !1;for(const i in t)if(!x(t[i],e[i]))return !1;return !0}return t===e}const v=Math.PI/180,b=180/Math.PI;function w(t){return t*v}function T(t){return t*b}const E=[[0,0],[1,0],[1,1],[0,1]];function M(t){if(t<=0)return 0;if(t>=1)return 1;const e=t*t,i=e*t;return 4*(t<.5?i:3*(t-e)+i-.75)}function A(t){let e=1/0,i=1/0,r=-1/0,n=-1/0;for(const o of t)e=Math.min(e,o.x),i=Math.min(i,o.y),r=Math.max(r,o.x),n=Math.max(n,o.y);return {min:new y(e,i),max:new y(r,n)}}function S(t,e,i=0,r=!0){const n=new y(i,i),o=t.sub(n),s=e.add(n),a=[o,new y(s.x,o.y),s,new y(o.x,s.y)];return r&&a.push(o.clone()),a}function I(t,e,i,r){const n=new m(t,e,i,r);return function(t){return n.solve(t)}}const C=I(.25,.1,.25,1);function z(t,e,i){return Math.min(i,Math.max(e,t))}function D(t,e,i){return (i=z((i-t)/(e-t),0,1))*i*(3-2*i)}function P(t,e,i){const r=i-e,n=((t-e)%r+r)%r+e;return n===e?i:n}function R(t,e,i){if(!t.length)return i(null,[]);let r=t.length;const n=new Array(t.length);let o=null;t.forEach(((t,s)=>{e(t,((t,e)=>{t&&(o=t),n[s]=e,0==--r&&i(o,n);}));}));}function L(t){const e=[];for(const i in t)e.push(t[i]);return e}function k(t,...e){for(const i of e)for(const e in i)t[e]=i[e];return t}function B(t,e){const i={};for(let r=0;r<e.length;r++){const n=e[r];n in t&&(i[n]=t[n]);}return i}let O=1;function F(){return O++}function N(){return function t(e){return e?(e^Math.random()*(16>>e/4)).toString(16):([1e7]+-[1e3]+-4e3+-8e3+-1e11).replace(/[018]/g,t)}()}function U(t){return t<=1?1:Math.pow(2,Math.ceil(Math.log(t)/Math.LN2))}function V(t){return !!t&&/^[0-9a-f]{8}-[0-9a-f]{4}-[4][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}$/i.test(t)}function j(t,e){t.forEach((t=>{e[t]&&(e[t]=e[t].bind(e));}));}function G(t,e){return -1!==t.indexOf(e,t.length-e.length)}function q(t,e,i){const r={};for(const n in t)r[n]=e.call(i||this,t[n],n,t);return r}function Z(t,e,i){const r={};for(const n in t)e.call(i||this,t[n],n,t)&&(r[n]=t[n]);return r}function $(t){return Array.isArray(t)?t.map($):"object"==typeof t&&t?q(t,$):t}const H={};function W(t){H[t]||("undefined"!=typeof console&&console.warn(t),H[t]=!0);}function X(t,e,i){return (i.y-t.y)*(e.x-t.x)>(e.y-t.y)*(i.x-t.x)}function Y(t){let e=0;for(let i,r,n=0,o=t.length,s=o-1;n<o;s=n++)i=t[n],r=t[s],e+=(r.x-i.x)*(i.y+r.y);return e}function K([t,e,i]){const r=w(e+90),n=w(i);return {x:t*Math.cos(r)*Math.sin(n),y:t*Math.sin(r)*Math.sin(n),z:t*Math.cos(n),azimuthal:e,polar:i}}function J(t,e,i){const r=Math.sqrt(t*t+e*e+i*i),n=r>0?Math.acos(i/r)*b:0;let o=0!==t||0!==e?Math.atan2(-e,-t)*b+90:0;return o<0&&(o+=360),[r,o,n]}function Q(){return "undefined"!=typeof WorkerGlobalScope&&"undefined"!=typeof self&&self instanceof WorkerGlobalScope}function tt(t){const e={};if(t.replace(/(?:^|(?:\s*\,\s*))([^\x00-\x20\(\)<>@\,;\:\\"\/\[\]\?\=\{\}\x7F]+)(?:\=(?:([^\x00-\x20\(\)<>@\,;\:\\"\/\[\]\?\=\{\}\x7F]+)|(?:\"((?:[^"\\]|\\.)*)\")))?/g,((t,i,r,n)=>{const o=r||n;return e[i]=!o||o.toLowerCase(),""})),e["max-age"]){const t=parseInt(e["max-age"],10);isNaN(t)?delete e["max-age"]:e["max-age"]=t;}return e}let et=null;function it(t){if(null==et){const e=t.navigator?t.navigator.userAgent:null;et=!!t.safari||!(!e||!(/\b(iPad|iPhone|iPod)\b/.test(e)||e.match("Safari")&&!e.match("Chrome")));}return et}function rt(){return !!e.document.fullscreenElement||!!e.document.webkitFullscreenElement}function nt(t){try{const i=e[t];return i.setItem("_mapbox_test_",1),i.removeItem("_mapbox_test_"),!0}catch(t){return !1}}function ot(t,e){return [t[4*e],t[4*e+1],t[4*e+2],t[4*e+3]]}function st(t,e,i){t[4*e+0]=i[0],t[4*e+1]=i[1],t[4*e+2]=i[2],t[4*e+3]=i[3];}function at(t,e){return [Math.pow(t[0],2.2)*e,Math.pow(t[1],2.2)*e,Math.pow(t[2],2.2)*e]}function lt(t){return [Math.pow(t[0],1/2.2),Math.pow(t[1],1/2.2),Math.pow(t[2],1/2.2)]}const ct="mapbox-tiles";let ht=500,ut=50;let dt,pt;function ft(){try{return e.caches}catch(t){}}function mt(){ft()&&!dt&&(dt=e.caches.open(ct));}function _t(t){const e=t.indexOf("?");if(e<0)return t;const i=function(t){const e=t.indexOf("?");return e>0?t.slice(e+1).split("&"):[]}(t),r=i.filter((t=>{const e=t.split("=");return "language"===e[0]||"worldview"===e[0]}));return r.length?`${t.slice(0,e)}?${r.join("&")}`:t.slice(0,e)}let gt=1/0;function yt(t){gt++,gt>ut&&(t.getActor().send("enforceCacheSizeLimit",ht),gt=0);}const xt={Unknown:"Unknown",Style:"Style",Source:"Source",Tile:"Tile",Glyphs:"Glyphs",SpriteImage:"SpriteImage",SpriteJSON:"SpriteJSON",Image:"Image",Model:"Model"};"function"==typeof Object.freeze&&Object.freeze(xt);class vt extends Error{constructor(t,e,i){401===e&&Rt(i)&&(t+=": you may have provided an invalid Mapbox access token. See https://docs.mapbox.com/api/overview/#access-tokens-and-token-scopes"),super(t),this.status=e,this.url=i;}toString(){return `${this.name}: ${this.message} (${this.status}): ${this.url}`}}const bt=Q()?()=>self.worker&&self.worker.referrer:()=>("blob:"===e.location.protocol?e.parent:e).location.href;const wt=function(t,i){if(!(/^file:/.test(r=t.url)||/^file:/.test(bt())&&!/^\w+:/.test(r))){if(e.fetch&&e.Request&&e.AbortController&&e.Request.prototype.hasOwnProperty("signal"))return function(t,i){const r=new e.AbortController,n=new e.Request(t.url,{method:t.method||"GET",body:t.body,credentials:t.credentials,headers:t.headers,referrer:bt(),referrerPolicy:t.referrerPolicy,signal:r.signal});let o=!1,s=!1;const a=(l=n.url).indexOf("sku=")>0&&Rt(l);var l;"json"===t.type&&n.headers.set("Accept","application/json");const c=(r,o,l)=>{if(s)return;if(r&&"SecurityError"!==r.message&&W(r.toString()),o&&l)return h(o);const c=Date.now();e.fetch(n).then((e=>{if(e.ok){const t=a?e.clone():null;return h(e,t,c)}return i(new vt(e.statusText,e.status,t.url))})).catch((e=>{"AbortError"!==e.name&&i(new Error(`${e.message} ${t.url}`));}));},h=(r,a,l)=>{("arrayBuffer"===t.type?r.arrayBuffer():"json"===t.type?r.json():r.text()).then((t=>{s||(a&&l&&function(t,i,r){if(mt(),!dt)return;const n={status:i.status,statusText:i.statusText,headers:new e.Headers};i.headers.forEach(((t,e)=>n.headers.set(e,t)));const o=tt(i.headers.get("Cache-Control")||"");if(o["no-store"])return;o["max-age"]&&n.headers.set("Expires",new Date(r+1e3*o["max-age"]).toUTCString());const s=n.headers.get("Expires");s&&(new Date(s).getTime()-r<42e4||function(t,e){if(void 0===pt)try{new Response(new ReadableStream),pt=!0;}catch(t){pt=!1;}pt?e(t.body):t.blob().then(e);}(i,(i=>{const r=new e.Response(i,n);mt(),dt&&dt.then((e=>e.put(_t(t.url),r))).catch((t=>W(t.message)));})));}(n,a,l),o=!0,i(null,t,r.headers.get("Cache-Control"),r.headers.get("Expires")));})).catch((t=>{s||i(new Error(t.message));}));};return a?function(t,e){if(mt(),!dt)return e(null);const i=_t(t.url);dt.then((t=>{t.match(i).then((r=>{const n=function(t){if(!t)return !1;const e=new Date(t.headers.get("Expires")||0),i=tt(t.headers.get("Cache-Control")||"");return e>Date.now()&&!i["no-cache"]}(r);t.delete(i),n&&t.put(i,r.clone()),e(null,r,n);})).catch(e);})).catch(e);}(n,c):c(null,null),{cancel:()=>{s=!0,o||r.abort();}}}(t,i);if(Q()&&self.worker&&self.worker.actor)return self.worker.actor.send("getResource",t,i,void 0,!0)}var r;return function(t,i){const r=new e.XMLHttpRequest;r.open(t.method||"GET",t.url,!0),"arrayBuffer"===t.type&&(r.responseType="arraybuffer");for(const e in t.headers)r.setRequestHeader(e,t.headers[e]);return "json"===t.type&&(r.responseType="text",r.setRequestHeader("Accept","application/json")),r.withCredentials="include"===t.credentials,r.onerror=()=>{i(new Error(r.statusText));},r.onload=()=>{if((r.status>=200&&r.status<300||0===r.status)&&null!==r.response){let e=r.response;if("json"===t.type)try{e=JSON.parse(r.response);}catch(t){return i(t)}i(null,e,r.getResponseHeader("Cache-Control"),r.getResponseHeader("Expires"));}else i(new vt(r.statusText,r.status,t.url));},r.send(t.body),{cancel:()=>r.abort()}}(t,i)},Tt=function(t,e){return wt(k(t,{type:"json"}),e)},Et=function(t,e){return wt(k(t,{type:"arrayBuffer"}),e)};function Mt(t){const i=e.document.createElement("a");return i.href=t,i.protocol===e.document.location.protocol&&i.host===e.document.location.host}const At="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAYAAAAfFcSJAAAAC0lEQVQYV2NgAAIAAAUAAarVyFEAAAAASUVORK5CYII=";let St,It;St=[],It=0;const Ct=function(t,i){if(o.supported&&(t.headers||(t.headers={}),t.headers.accept="image/webp,*/*"),It>=n.MAX_PARALLEL_IMAGE_REQUESTS){const e={requestParameters:t,callback:i,cancelled:!1,cancel(){this.cancelled=!0;}};return St.push(e),e}It++;let r=!1;const s=()=>{if(!r)for(r=!0,It--;St.length&&It<n.MAX_PARALLEL_IMAGE_REQUESTS;){const t=St.shift(),{requestParameters:e,callback:i,cancelled:r}=t;r||(t.cancel=Ct(e,i).cancel);}},a=Et(t,((t,r,n,o)=>{s(),t?i(t):r&&(e.createImageBitmap?function(t,i){const r=new e.Blob([new Uint8Array(t)],{type:"image/png"});e.createImageBitmap(r).then((t=>{i(null,t);})).catch((t=>{i(new Error(`Could not load image because of ${t.message}. Please make sure to use a supported image type such as PNG or JPEG. Note that SVGs are not supported.`));}));}(r,((t,e)=>i(t,e,n,o))):function(t,i){const r=new e.Image,n=e.URL;r.onload=()=>{i(null,r),n.revokeObjectURL(r.src),r.onload=null,e.requestAnimationFrame((()=>{r.src=At;}));},r.onerror=()=>i(new Error("Could not load image. Please make sure to use a supported image type such as PNG or JPEG. Note that SVGs are not supported."));const o=new e.Blob([new Uint8Array(t)],{type:"image/png"});r.src=t.byteLength?n.createObjectURL(o):At;}(r,((t,e)=>i(t,e,n,o))));}));return {cancel:()=>{a.cancel(),s();}}},zt="NO_ACCESS_TOKEN";class Dt{constructor(t,e,i){this._transformRequestFn=t,this._customAccessToken=e,this._silenceAuthErrors=!!i,this._createSkuToken();}_createSkuToken(){const t=function(){let t="";for(let e=0;e<10;e++)t+="0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"[Math.floor(62*Math.random())];return {token:["1",u,t].join(""),tokenExpiresAt:Date.now()+432e5}}();this._skuToken=t.token,this._skuTokenExpiresAt=t.tokenExpiresAt;}_isSkuTokenExpired(){return Date.now()>this._skuTokenExpiresAt}transformRequest(t,e){return this._transformRequestFn&&this._transformRequestFn(t,e)||{url:t}}normalizeStyleURL(t,e){if(!Pt(t))return t;const i=Ft(t);return i.path=`/styles/v1${i.path}`,this._makeAPIURL(i,this._customAccessToken||e)}normalizeGlyphsURL(t,e){if(!Pt(t))return t;const i=Ft(t);return i.path=`/fonts/v1${i.path}`,this._makeAPIURL(i,this._customAccessToken||e)}normalizeModelURL(t,e){if(!Pt(t))return t;const i=Ft(t);return i.path=`/models/v1${i.path}`,this._makeAPIURL(i,this._customAccessToken||e)}normalizeSourceURL(t,e,i,r){if(!Pt(t))return t;const n=Ft(t);return n.path=`/v4/${n.authority}.json`,n.params.push("secure"),i&&n.params.push(`language=${i}`),r&&n.params.push(`worldview=${r}`),this._makeAPIURL(n,this._customAccessToken||e)}normalizeSpriteURL(t,e,i,r){const n=Ft(t);return Pt(t)?(n.path=`/styles/v1${n.path}/sprite${e}${i}`,this._makeAPIURL(n,this._customAccessToken||r)):(n.path+=`${e}${i}`,Nt(n))}normalizeTileURL(t,e,i){if(this._isSkuTokenExpired()&&this._createSkuToken(),t&&!Pt(t))return t;const r=Ft(t);r.path=r.path.replace(/(\.(png|jpg)\d*)(?=$)/,`${e||i&&"raster"!==r.authority&&512===i?"@2x":""}${o.supported?".webp":"$1"}`),"raster"===r.authority?r.path=`/${n.RASTER_URL_PREFIX}${r.path}`:(r.path=r.path.replace(/^.+\/v4\//,"/"),r.path=`/${n.TILE_URL_VERSION}${r.path}`);const s=this._customAccessToken||function(t){for(const e of t){const t=e.match(/^access_token=(.*)$/);if(t)return t[1]}return null}(r.params)||n.ACCESS_TOKEN;return n.REQUIRE_ACCESS_TOKEN&&s&&this._skuToken&&r.params.push(`sku=${this._skuToken}`),this._makeAPIURL(r,s)}canonicalizeTileURL(t,e){const i=Ft(t);if(!i.path.match(/^(\/v4\/|\/raster\/v1\/)/)||!i.path.match(/\.[\w]+$/))return t;let r="mapbox://";i.path.match(/^\/raster\/v1\//)?r+=`raster/${i.path.replace(`/${n.RASTER_URL_PREFIX}/`,"")}`:r+=`tiles/${i.path.replace(`/${n.TILE_URL_VERSION}/`,"")}`;let o=i.params;return e&&(o=o.filter((t=>!t.match(/^access_token=/)))),o.length&&(r+=`?${o.join("&")}`),r}canonicalizeTileset(t,e){const i=!!e&&Pt(e),r=[];for(const e of t.tiles||[])Rt(e)?r.push(this.canonicalizeTileURL(e,i)):r.push(e);return r}_makeAPIURL(t,e){const i="See https://docs.mapbox.com/api/overview/#access-tokens-and-token-scopes",r=Ft(n.API_URL);if(t.protocol=r.protocol,t.authority=r.authority,"http"===t.protocol){const e=t.params.indexOf("secure");e>=0&&t.params.splice(e,1);}if("/"!==r.path&&(t.path=`${r.path}${t.path}`),!n.REQUIRE_ACCESS_TOKEN)return Nt(t);if(e=e||n.ACCESS_TOKEN,!this._silenceAuthErrors){if(!e)throw new Error(`An API access token is required to use Mapbox GL. ${i}`);if("s"===e[0])throw new Error(`Use a public access token (pk.*) with Mapbox GL, not a secret access token (sk.*). ${i}`)}return t.params=t.params.filter((t=>-1===t.indexOf("access_token"))),t.params.push(`access_token=${e||""}`),Nt(t)}}function Pt(t){return 0===t.indexOf("mapbox:")}function Rt(t){return n.API_URL_REGEX.test(t)}function Lt(t){return n.API_CDN_URL_REGEX.test(t)}function kt(t){return n.API_STYLE_REGEX.test(t)&&!Bt(t)}function Bt(t){return n.API_SPRITE_REGEX.test(t)}const Ot=/^(\w+):\/\/([^/?]*)(\/[^?]+)?\??(.+)?/;function Ft(t){const e=t.match(Ot);if(!e)throw new Error("Unable to parse URL object");return {protocol:e[1],authority:e[2],path:e[3]||"/",params:e[4]?e[4].split("&"):[]}}function Nt(t){const e=t.params.length?`?${t.params.join("&")}`:"";return `${t.protocol}://${t.authority}${t.path}${e}`}const Ut="mapbox.eventData";function Vt(t){if(!t)return null;const i=t.split(".");if(!i||3!==i.length)return null;try{return JSON.parse(decodeURIComponent(e.atob(i[1]).split("").map((t=>"%"+("00"+t.charCodeAt(0).toString(16)).slice(-2))).join("")))}catch(t){return null}}class jt{constructor(t){this.type=t,this.anonId=null,this.eventData={},this.queue=[],this.pendingRequest=null;}getStorageKey(t){const i=Vt(n.ACCESS_TOKEN);let r="";return r=i&&i.u?e.btoa(encodeURIComponent(i.u).replace(/%([0-9A-F]{2})/g,((t,e)=>String.fromCharCode(Number("0x"+e))))):n.ACCESS_TOKEN||"",t?`${Ut}.${t}:${r}`:`${Ut}:${r}`}fetchEventData(){const t=nt("localStorage"),i=this.getStorageKey(),r=this.getStorageKey("uuid");if(t)try{const t=e.localStorage.getItem(i);t&&(this.eventData=JSON.parse(t));const n=e.localStorage.getItem(r);n&&(this.anonId=n);}catch(t){W("Unable to read from LocalStorage");}}saveEventData(){const t=nt("localStorage"),i=this.getStorageKey(),r=this.getStorageKey("uuid");if(t)try{e.localStorage.setItem(r,this.anonId),Object.keys(this.eventData).length>=1&&e.localStorage.setItem(i,JSON.stringify(this.eventData));}catch(t){W("Unable to write to LocalStorage");}}processRequests(t){}postEvent(t,e,i,r){if(!n.EVENTS_URL)return;const o=Ft(n.EVENTS_URL);o.params.push(`access_token=${r||n.ACCESS_TOKEN||""}`);const s={event:this.type,created:new Date(t).toISOString()},a=e?k(s,e):s,l={url:Nt(o),headers:{"Content-Type":"text/plain"},body:JSON.stringify([a])};this.pendingRequest=function(t,e){return wt(k(t,{method:"POST"}),e)}(l,(t=>{this.pendingRequest=null,i(t),this.saveEventData(),this.processRequests(r);}));}queueRequest(t,e){this.queue.push(t),this.processRequests(e);}}const Gt=new class extends jt{constructor(t){super("appUserTurnstile"),this._customAccessToken=t;}postTurnstileEvent(t,e){n.EVENTS_URL&&n.ACCESS_TOKEN&&Array.isArray(t)&&t.some((t=>Pt(t)||Rt(t)))&&this.queueRequest(Date.now(),e);}processRequests(t){if(this.pendingRequest||0===this.queue.length)return;this.anonId&&this.eventData.lastSuccess&&this.eventData.tokenU||this.fetchEventData();const e=Vt(n.ACCESS_TOKEN),r=e?e.u:n.ACCESS_TOKEN;let o=r!==this.eventData.tokenU;V(this.anonId)||(this.anonId=N(),o=!0);const s=this.queue.shift();if(this.eventData.lastSuccess){const t=new Date(this.eventData.lastSuccess),e=new Date(s),i=(s-this.eventData.lastSuccess)/864e5;o=o||i>=1||i<-1||t.getDate()!==e.getDate();}else o=!0;o?this.postEvent(s,{sdkIdentifier:"mapbox-gl-js",sdkVersion:i,skuId:u,"enabled.telemetry":!1,userId:this.anonId},(t=>{t||(this.eventData.lastSuccess=s,this.eventData.tokenU=r);}),t):this.processRequests();}},qt=Gt.postTurnstileEvent.bind(Gt),Zt=new class extends jt{constructor(){super("map.load"),this.success={},this.skuToken="";}postMapLoadEvent(t,e,i,r){this.skuToken=e,this.errorCb=r,n.EVENTS_URL&&(i||n.ACCESS_TOKEN?this.queueRequest({id:t,timestamp:Date.now()},i):this.errorCb(new Error(zt)));}processRequests(t){if(this.pendingRequest||0===this.queue.length)return;const{id:e,timestamp:r}=this.queue.shift();e&&this.success[e]||(this.anonId||this.fetchEventData(),V(this.anonId)||(this.anonId=N()),this.postEvent(r,{sdkIdentifier:"mapbox-gl-js",sdkVersion:i,skuId:u,skuToken:this.skuToken,userId:this.anonId},(t=>{t?this.errorCb(t):e&&(this.success[e]=!0);}),t));}},$t=Zt.postMapLoadEvent.bind(Zt),Ht=new class extends jt{constructor(){super("gljs.performance");}postPerformanceEvent(t,e){n.EVENTS_URL&&(t||n.ACCESS_TOKEN)&&this.queueRequest({timestamp:Date.now(),performanceData:e},t);}processRequests(t){if(this.pendingRequest||0===this.queue.length)return;const{timestamp:r,performanceData:n}=this.queue.shift(),o=function(t){const r=e.performance.getEntriesByType("resource"),n=e.performance.getEntriesByType("mark"),o=function(t){const e={};if(t)for(const i in t)if("other"!==i)for(const r of t[i]){const t=`${i}ResolveRangeMin`,n=`${i}ResolveRangeMax`,o=`${i}RequestCount`,s=`${i}RequestCachedCount`;e[t]=Math.min(e[t]||1/0,r.startTime),e[n]=Math.max(e[n]||-1/0,r.responseEnd);const a=t=>{void 0===e[t]&&(e[t]=0),++e[t];};void 0!==r.transferSize&&0===r.transferSize&&a(s),a(o);}return e}(function(t,e){const i={};if(t)for(const r of t){const t=e(r);void 0===i[t]&&(i[t]=[]),i[t].push(r);}return i}(r,ee)),s=e.devicePixelRatio,a=e.navigator.connection||e.navigator.mozConnection||e.navigator.webkitConnection,l={counters:[],metadata:[],attributes:[]},c=(t,e,i)=>{null!=i&&t.push({name:e,value:i.toString()});};for(const t in o)c(l.counters,t,o[t]);if(t.interactionRange[0]!==1/0&&t.interactionRange[1]!==-1/0&&(c(l.counters,"interactionRangeMin",t.interactionRange[0]),c(l.counters,"interactionRangeMax",t.interactionRange[1])),n)for(const t of Object.keys(Qt)){const e=Qt[t],i=n.find((t=>t.name===e));i&&c(l.counters,e,i.startTime);}return c(l.counters,"visibilityHidden",t.visibilityHidden),c(l.attributes,"style",function(t){if(t)for(const e of t){const t=e.name.split("?")[0];if(kt(t)){const e=t.split("/").slice(-2);if(2===e.length)return `mapbox://styles/${e[0]}/${e[1]}`}}}(r)),c(l.attributes,"terrainEnabled",t.terrainEnabled?"true":"false"),c(l.attributes,"fogEnabled",t.fogEnabled?"true":"false"),c(l.attributes,"projection",t.projection),c(l.attributes,"zoom",t.zoom),c(l.metadata,"devicePixelRatio",s),c(l.metadata,"connectionEffectiveType",a?a.effectiveType:void 0),c(l.metadata,"navigatorUserAgent",e.navigator.userAgent),c(l.metadata,"screenWidth",e.screen.width),c(l.metadata,"screenHeight",e.screen.height),c(l.metadata,"windowWidth",e.innerWidth),c(l.metadata,"windowHeight",e.innerHeight),c(l.metadata,"mapWidth",t.width/s),c(l.metadata,"mapHeight",t.height/s),c(l.metadata,"webglRenderer",t.renderer),c(l.metadata,"webglVendor",t.vendor),c(l.metadata,"sdkVersion",i),c(l.metadata,"sdkIdentifier","mapbox-gl-js"),l}(n);for(const t of o.metadata);for(const t of o.counters);for(const t of o.attributes);this.postEvent(r,o,(()=>{}),t);}},Wt=Ht.postPerformanceEvent.bind(Ht),Xt=new class extends jt{constructor(){super("map.auth"),this.success={},this.skuToken="";}getSession(t,e,i,r){if(!n.API_URL||!n.SESSION_PATH)return;const o=Ft(n.API_URL+n.SESSION_PATH);o.params.push(`sku=${e||""}`),o.params.push(`access_token=${r||n.ACCESS_TOKEN||""}`);const s={url:Nt(o),headers:{"Content-Type":"text/plain"}};this.pendingRequest=function(t,e){return wt(k(t,{method:"GET"}),e)}(s,(t=>{this.pendingRequest=null,i(t),this.saveEventData(),this.processRequests(r);}));}getSessionAPI(t,e,i,r){this.skuToken=e,this.errorCb=r,n.SESSION_PATH&&n.API_URL&&(i||n.ACCESS_TOKEN?this.queueRequest({id:t,timestamp:Date.now()},i):this.errorCb(new Error(zt)));}processRequests(t){if(this.pendingRequest||0===this.queue.length)return;const{id:e,timestamp:i}=this.queue.shift();e&&this.success[e]||this.getSession(i,this.skuToken,(t=>{t?this.errorCb(t):e&&(this.success[e]=!0);}),t);}},Yt=Xt.getSessionAPI.bind(Xt),Kt=new Set;function Jt(t,e){e?Kt.add(t):Kt.delete(t);}const Qt={create:"create",load:"load",fullLoad:"fullLoad"},te={mark(t){e.performance.mark(t);},measure(t,i,r){e.performance.measure(t,i,r);}};function ee(t){const e=t.name.split("?")[0];return Lt(e)&&e.includes("mapbox-gl.js")?"javascript":Lt(e)&&e.includes("mapbox-gl.css")?"css":function(t){return n.API_FONTS_REGEX.test(t)}(e)?"fontRange":Bt(e)?"sprite":kt(e)?"style":function(t){return n.API_TILEJSON_REGEX.test(t)}(e)?"tilejson":"other"}const ie=e.performance;function re(t){const e=t?t.url.toString():void 0;return ie.getEntriesByName(e)}var ne=oe;function oe(t){return !function(t){return "undefined"==typeof window||"undefined"==typeof document?"not a browser":Array.prototype&&Array.prototype.every&&Array.prototype.filter&&Array.prototype.forEach&&Array.prototype.indexOf&&Array.prototype.lastIndexOf&&Array.prototype.map&&Array.prototype.some&&Array.prototype.reduce&&Array.prototype.reduceRight&&Array.isArray?Function.prototype&&Function.prototype.bind?Object.keys&&Object.create&&Object.getPrototypeOf&&Object.getOwnPropertyNames&&Object.isSealed&&Object.isFrozen&&Object.isExtensible&&Object.getOwnPropertyDescriptor&&Object.defineProperty&&Object.defineProperties&&Object.seal&&Object.freeze&&Object.preventExtensions?"JSON"in window&&"parse"in JSON&&"stringify"in JSON?function(){if(!("Worker"in window&&"Blob"in window&&"URL"in window))return !1;var t,e,i=new Blob([""],{type:"text/javascript"}),r=URL.createObjectURL(i);try{e=new Worker(r),t=!0;}catch(e){t=!1;}return e&&e.terminate(),URL.revokeObjectURL(r),t}()?"Uint8ClampedArray"in window?ArrayBuffer.isView?function(){var t=document.createElement("canvas");t.width=t.height=1;var e=t.getContext("2d");if(!e)return !1;var i=e.getImageData(0,0,1,1);return i&&i.width===t.width}()?(void 0===se[e=t&&t.failIfMajorPerformanceCaveat]&&(se[e]=function(t){var e,i=function(t){var e=document.createElement("canvas"),i=Object.create(oe.webGLContextAttributes);return i.failIfMajorPerformanceCaveat=t,e.getContext("webgl",i)||e.getContext("experimental-webgl",i)}(t);if(!i)return !1;try{e=i.createShader(i.VERTEX_SHADER);}catch(t){return !1}return !(!e||i.isContextLost())&&(i.shaderSource(e,"void main() {}"),i.compileShader(e),!0===i.getShaderParameter(e,i.COMPILE_STATUS))}(e)),se[e]?document.documentMode?"insufficient ECMAScript 6 support":void 0:"insufficient WebGL support"):"insufficient Canvas/getImageData support":"insufficient ArrayBuffer support":"insufficient Uint8ClampedArray support":"insufficient worker support":"insufficient JSON support":"insufficient Object support":"insufficient Function support":"insufficent Array support";var e;}(t)}var se={};let ae,le,ce,he;oe.webGLContextAttributes={antialias:!1,alpha:!0,stencil:!0,depth:!0};const ue={now:()=>void 0!==ce?ce:e.performance.now(),setNow(t){ce=t;},restoreNow(){ce=void 0;},frame(t){const i=e.requestAnimationFrame(t);return {cancel:()=>e.cancelAnimationFrame(i)}},getImageData(t,i=0){const{width:r,height:n}=t;he||(he=e.document.createElement("canvas"));const o=he.getContext("2d",{willReadFrequently:!0});if(!o)throw new Error("failed to create canvas 2d context");return (r>he.width||n>he.height)&&(he.width=r,he.height=n),o.clearRect(-i,-i,r+2*i,n+2*i),o.drawImage(t,0,0,r,n),o.getImageData(-i,-i,r+2*i,n+2*i)},resolveURL:t=>(ae||(ae=e.document.createElement("a")),ae.href=t,ae.href),get devicePixelRatio(){return e.devicePixelRatio},get prefersReducedMotion(){return !!e.matchMedia&&(null==le&&(le=e.matchMedia("(prefers-reduced-motion: reduce)")),le.matches)}};function de(t,i,r){const n=e.document.createElement(t);return void 0!==i&&(n.className=i),r&&r.appendChild(n),n}function pe(t,i,r){const n=e.document.createElementNS("http://www.w3.org/2000/svg",t);for(const t of Object.keys(i))n.setAttributeNS(null,t,i[t]);return r&&r.appendChild(n),n}const fe=e.document&&e.document.documentElement.style,me=fe&&void 0!==fe.userSelect?"userSelect":"WebkitUserSelect";let _e;function ge(){fe&&me&&(_e=fe[me],fe[me]="none");}function ye(){fe&&me&&(fe[me]=_e);}function xe(t){t.preventDefault(),t.stopPropagation(),e.removeEventListener("click",xe,!0);}function ve(){e.addEventListener("click",xe,!0),e.setTimeout((()=>{e.removeEventListener("click",xe,!0);}),0);}function be(t,e){const i=t.getBoundingClientRect();return Ee(t,i,e)}function we(t,e){const i=t.getBoundingClientRect(),r=[];for(let n=0;n<e.length;n++)r.push(Ee(t,i,e[n]));return r}function Te(t){return void 0!==e.InstallTrigger&&2===t.button&&t.ctrlKey&&e.navigator.platform.toUpperCase().indexOf("MAC")>=0?0:t.button}function Ee(t,e,i){const r=t.offsetWidth===e.width?1:t.offsetWidth/e.width;return new y((i.clientX-e.left)*r,(i.clientY-e.top)*r)}function Me(t,e,i){i[t]&&-1!==i[t].indexOf(e)||(i[t]=i[t]||[],i[t].push(e));}function Ae(t,e,i){if(i&&i[t]){const r=i[t].indexOf(e);-1!==r&&i[t].splice(r,1);}}class Se{constructor(t,e={}){k(this,e),this.type=t;}}class Ie extends Se{constructor(t,e={}){super("error",k({error:t},e));}}class Ce{on(t,e){return this._listeners=this._listeners||{},Me(t,e,this._listeners),this}off(t,e){return Ae(t,e,this._listeners),Ae(t,e,this._oneTimeListeners),this}once(t,e){return e?(this._oneTimeListeners=this._oneTimeListeners||{},Me(t,e,this._oneTimeListeners),this):new Promise((e=>this.once(t,e)))}fire(t,e){"string"==typeof t&&(t=new Se(t,e||{}));const i=t.type;if(this.listens(i)){t.target=this;const e=this._listeners&&this._listeners[i]?this._listeners[i].slice():[];for(const i of e)i.call(this,t);const r=this._oneTimeListeners&&this._oneTimeListeners[i]?this._oneTimeListeners[i].slice():[];for(const e of r)Ae(i,e,this._oneTimeListeners),e.call(this,t);const n=this._eventedParent;n&&(k(t,"function"==typeof this._eventedParentData?this._eventedParentData():this._eventedParentData),n.fire(t));}else t instanceof Ie&&console.error(t.error);return this}listens(t){return !!(this._listeners&&this._listeners[t]&&this._listeners[t].length>0||this._oneTimeListeners&&this._oneTimeListeners[t]&&this._oneTimeListeners[t].length>0||this._eventedParent&&this._eventedParent.listens(t))}setEventedParent(t,e){return this._eventedParent=t,this._eventedParentData=e,this}}var ze=JSON.parse('{"$version":8,"$root":{"version":{"required":true,"type":"enum","values":[8]},"fragment":{"type":"boolean"},"name":{"type":"string"},"metadata":{"type":"*"},"center":{"type":"array","value":"number"},"zoom":{"type":"number"},"bearing":{"type":"number","default":0,"period":360,"units":"degrees"},"pitch":{"type":"number","default":0,"units":"degrees"},"light":{"type":"light"},"lights":{"required":false,"type":"array","value":"light-3d"},"terrain":{"type":"terrain"},"fog":{"type":"fog"},"camera":{"type":"camera"},"imports":{"type":"array","value":"import"},"schema":{"type":"schema"},"sources":{"required":true,"type":"sources"},"sprite":{"type":"string"},"glyphs":{"type":"string","default":"mapbox://fonts/mapbox/{fontstack}/{range}.pbf"},"transition":{"type":"transition"},"projection":{"type":"projection"},"layers":{"required":true,"type":"array","value":"layer"},"models":{"type":"models"}},"model":{"type":"string","required":true},"import":{"id":{"type":"string","required":true},"url":{"type":"string","required":true},"config":{"type":"config"},"data":{"type":"$root"}},"config":{"*":{"type":"*"}},"schema":{"*":{"type":"option"}},"option":{"default":{"type":"*","required":true},"type":{"type":"enum","values":{"string":{},"number":{},"boolean":{},"color":{}}},"array":{"type":"boolean"},"minValue":{"type":"number"},"maxValue":{"type":"number"},"stepValue":{"type":"number"},"values":{"type":"array","value":"*"},"metadata":{"type":"*"}},"models":{"*":{"type":"model"}},"light-3d":{"id":{"type":"string","required":true},"properties":{"type":"properties"},"type":{"type":"enum","values":{"ambient":{},"directional":{},"flat":{}}}},"properties":["properties_light_directional","properties_light_ambient","properties_light_flat"],"properties_light_directional":{"direction":{"type":"array","default":[210,30],"minimum":[0,0],"maximum":[360,90],"length":2,"value":"number","property-type":"data-constant","transition":true,"expression":{"interpolated":true,"parameters":["zoom"]}},"color":{"type":"color","property-type":"data-constant","default":"#ffffff","expression":{"interpolated":true,"parameters":["zoom"]},"transition":true},"intensity":{"type":"number","property-type":"data-constant","default":0.5,"minimum":0,"maximum":1,"expression":{"interpolated":true,"parameters":["zoom"]},"transition":true},"cast-shadows":{"type":"boolean","default":false,"transition":false,"expression":{"interpolated":false},"property-type":"data-constant"},"shadow-intensity":{"type":"number","property-type":"data-constant","default":1,"minimum":0,"maximum":1,"expression":{"interpolated":true,"parameters":["zoom"]},"transition":true}},"properties_light_ambient":{"color":{"type":"color","property-type":"data-constant","default":"#ffffff","expression":{"interpolated":true,"parameters":["zoom"]},"transition":true},"intensity":{"type":"number","property-type":"data-constant","default":0.5,"minimum":0,"maximum":1,"expression":{"interpolated":true,"parameters":["zoom"]},"transition":true}},"properties_light_flat":{"anchor":{"type":"enum","default":"viewport","values":{"map":{},"viewport":{}},"property-type":"data-constant","transition":false,"expression":{"interpolated":false,"parameters":["zoom"]}},"position":{"type":"array","default":[1.15,210,30],"length":3,"value":"number","property-type":"data-constant","transition":true,"expression":{"interpolated":true,"parameters":["zoom"]}},"color":{"type":"color","property-type":"data-constant","default":"#ffffff","expression":{"interpolated":true,"parameters":["zoom"]},"transition":true},"intensity":{"type":"number","property-type":"data-constant","default":0.5,"minimum":0,"maximum":1,"expression":{"interpolated":true,"parameters":["zoom"]},"transition":true}},"sources":{"*":{"type":"source"}},"source":["source_vector","source_raster","source_raster_dem","source_geojson","source_video","source_image","source_model"],"source_vector":{"type":{"required":true,"type":"enum","values":{"vector":{}}},"url":{"type":"string"},"tiles":{"type":"array","value":"string"},"bounds":{"type":"array","value":"number","length":4,"default":[-180,-85.051129,180,85.051129]},"scheme":{"type":"enum","values":{"xyz":{},"tms":{}},"default":"xyz"},"minzoom":{"type":"number","default":0},"maxzoom":{"type":"number","default":22},"attribution":{"type":"string"},"promoteId":{"type":"promoteId"},"volatile":{"type":"boolean","default":false},"*":{"type":"*"}},"source_raster":{"type":{"required":true,"type":"enum","values":{"raster":{}}},"url":{"type":"string"},"tiles":{"type":"array","value":"string"},"bounds":{"type":"array","value":"number","length":4,"default":[-180,-85.051129,180,85.051129]},"minzoom":{"type":"number","default":0},"maxzoom":{"type":"number","default":22},"tileSize":{"type":"number","default":512,"units":"pixels"},"scheme":{"type":"enum","values":{"xyz":{},"tms":{}},"default":"xyz"},"attribution":{"type":"string"},"volatile":{"type":"boolean","default":false},"*":{"type":"*"}},"source_raster_dem":{"type":{"required":true,"type":"enum","values":{"raster-dem":{}}},"url":{"type":"string"},"tiles":{"type":"array","value":"string"},"bounds":{"type":"array","value":"number","length":4,"default":[-180,-85.051129,180,85.051129]},"minzoom":{"type":"number","default":0},"maxzoom":{"type":"number","default":22},"tileSize":{"type":"number","default":512,"units":"pixels"},"attribution":{"type":"string"},"encoding":{"type":"enum","values":{"terrarium":{},"mapbox":{}},"default":"mapbox"},"volatile":{"type":"boolean","default":false},"*":{"type":"*"}},"source_geojson":{"type":{"required":true,"type":"enum","values":{"geojson":{}}},"data":{"type":"*"},"maxzoom":{"type":"number","default":18},"attribution":{"type":"string"},"buffer":{"type":"number","default":128,"maximum":512,"minimum":0},"filter":{"type":"*"},"tolerance":{"type":"number","default":0.375},"cluster":{"type":"boolean","default":false},"clusterRadius":{"type":"number","default":50,"minimum":0},"clusterMaxZoom":{"type":"number"},"clusterMinPoints":{"type":"number"},"clusterProperties":{"type":"*"},"lineMetrics":{"type":"boolean","default":false},"generateId":{"type":"boolean","default":false},"promoteId":{"type":"promoteId"}},"source_video":{"type":{"required":true,"type":"enum","values":{"video":{}}},"urls":{"required":true,"type":"array","value":"string"},"coordinates":{"required":true,"type":"array","length":4,"value":{"type":"array","length":2,"value":"number"}}},"source_image":{"type":{"required":true,"type":"enum","values":{"image":{}}},"url":{"required":true,"type":"string"},"coordinates":{"required":true,"type":"array","length":4,"value":{"type":"array","length":2,"value":"number"}}},"source_model":{"type":{"required":true,"type":"enum","values":{"model":{},"batched-model":{}}},"maxzoom":{"type":"number","default":18},"minzoom":{"type":"number","default":0},"tiles":{"type":"array","value":"string"}},"layer":{"id":{"type":"string","required":true},"type":{"type":"enum","values":{"fill":{},"line":{},"symbol":{},"circle":{},"heatmap":{},"fill-extrusion":{},"raster":{},"hillshade":{},"model":{},"background":{},"sky":{},"slot":{}},"required":true},"metadata":{"type":"*"},"source":{"type":"string"},"source-layer":{"type":"string"},"slot":{"type":"string"},"minzoom":{"type":"number","minimum":0,"maximum":24},"maxzoom":{"type":"number","minimum":0,"maximum":24},"filter":{"type":"filter"},"layout":{"type":"layout"},"paint":{"type":"paint"}},"layout":["layout_fill","layout_line","layout_circle","layout_heatmap","layout_fill-extrusion","layout_symbol","layout_raster","layout_hillshade","layout_background","layout_sky","layout_model"],"layout_background":{"visibility":{"type":"enum","values":{"visible":{},"none":{}},"default":"visible","expression":{"interpolated":false},"property-type":"constant"}},"layout_sky":{"visibility":{"type":"enum","values":{"visible":{},"none":{}},"default":"visible","expression":{"interpolated":false},"property-type":"constant"}},"layout_model":{"visibility":{"type":"enum","values":{"visible":{},"none":{}},"default":"visible","expression":{"interpolated":false},"property-type":"constant"},"model-id":{"type":"string","property-type":"data-driven","expression":{"interpolated":false,"parameters":["zoom","feature"]},"transition":false,"requires":[{"source":["geojson","vector"]}]}},"layout_fill":{"fill-sort-key":{"type":"number","expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"visibility":{"type":"enum","values":{"visible":{},"none":{}},"default":"visible","expression":{"interpolated":false},"property-type":"constant"}},"layout_circle":{"circle-sort-key":{"type":"number","expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"visibility":{"type":"enum","values":{"visible":{},"none":{}},"default":"visible","expression":{"interpolated":false},"property-type":"constant"}},"layout_heatmap":{"visibility":{"type":"enum","values":{"visible":{},"none":{}},"default":"visible","expression":{"interpolated":false},"property-type":"constant"}},"layout_fill-extrusion":{"visibility":{"type":"enum","values":{"visible":{},"none":{}},"default":"visible","expression":{"interpolated":false},"property-type":"constant"},"fill-extrusion-edge-radius":{"type":"number","private":true,"default":0,"minimum":0,"maximum":1,"expression":{"interpolated":false},"property-type":"constant"}},"layout_line":{"line-cap":{"type":"enum","values":{"butt":{},"round":{},"square":{}},"default":"butt","expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"line-join":{"type":"enum","values":{"bevel":{},"round":{},"miter":{}},"default":"miter","expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"line-miter-limit":{"type":"number","default":2,"requires":[{"line-join":"miter"}],"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"line-round-limit":{"type":"number","default":1.05,"requires":[{"line-join":"round"}],"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"line-sort-key":{"type":"number","expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"visibility":{"type":"enum","values":{"visible":{},"none":{}},"default":"visible","expression":{"interpolated":false},"property-type":"constant"}},"layout_symbol":{"symbol-placement":{"type":"enum","values":{"point":{},"line":{},"line-center":{}},"default":"point","expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"symbol-spacing":{"type":"number","default":250,"minimum":1,"units":"pixels","requires":[{"symbol-placement":"line"}],"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"symbol-avoid-edges":{"type":"boolean","default":false,"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"symbol-sort-key":{"type":"number","expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"symbol-z-order":{"type":"enum","values":{"auto":{},"viewport-y":{},"source":{}},"default":"auto","expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"symbol-z-elevate":{"type":"boolean","default":false,"requires":[{"symbol-placement":["point"]},{"symbol-z-order":["auto"]}],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"icon-allow-overlap":{"type":"boolean","default":false,"requires":["icon-image"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"icon-ignore-placement":{"type":"boolean","default":false,"requires":["icon-image"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"icon-optional":{"type":"boolean","default":false,"requires":["icon-image","text-field"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"icon-rotation-alignment":{"type":"enum","values":{"map":{},"viewport":{},"auto":{}},"default":"auto","requires":["icon-image"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"icon-size":{"type":"number","default":1,"minimum":0,"units":"factor of the original icon size","requires":["icon-image"],"expression":{"interpolated":true,"parameters":["zoom","feature"]},"property-type":"data-driven"},"icon-text-fit":{"type":"enum","values":{"none":{},"width":{},"height":{},"both":{}},"default":"none","requires":["icon-image","text-field"],"expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"icon-text-fit-padding":{"type":"array","value":"number","length":4,"default":[0,0,0,0],"units":"pixels","requires":["icon-image","text-field",{"icon-text-fit":["both","width","height"]}],"expression":{"interpolated":true,"parameters":["zoom","feature"]},"property-type":"data-driven"},"icon-image":{"type":"resolvedImage","tokens":true,"expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"icon-rotate":{"type":"number","default":0,"period":360,"units":"degrees","requires":["icon-image"],"expression":{"interpolated":true,"parameters":["zoom","feature"]},"property-type":"data-driven"},"icon-padding":{"type":"number","default":2,"minimum":0,"units":"pixels","requires":["icon-image"],"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"icon-keep-upright":{"type":"boolean","default":false,"requires":["icon-image",{"icon-rotation-alignment":"map"},{"symbol-placement":["line","line-center"]}],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"icon-offset":{"type":"array","value":"number","length":2,"default":[0,0],"requires":["icon-image"],"expression":{"interpolated":true,"parameters":["zoom","feature"]},"property-type":"data-driven"},"icon-anchor":{"type":"enum","values":{"center":{},"left":{},"right":{},"top":{},"bottom":{},"top-left":{},"top-right":{},"bottom-left":{},"bottom-right":{}},"default":"center","requires":["icon-image"],"expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"icon-pitch-alignment":{"type":"enum","values":{"map":{},"viewport":{},"auto":{}},"default":"auto","requires":["icon-image"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"text-pitch-alignment":{"type":"enum","values":{"map":{},"viewport":{},"auto":{}},"default":"auto","requires":["text-field"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"text-rotation-alignment":{"type":"enum","values":{"map":{},"viewport":{},"auto":{}},"default":"auto","requires":["text-field"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"text-field":{"type":"formatted","default":"","tokens":true,"expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"text-font":{"type":"array","value":"string","default":["Open Sans Regular","Arial Unicode MS Regular"],"requires":["text-field"],"expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"text-size":{"type":"number","default":16,"minimum":0,"units":"pixels","requires":["text-field"],"expression":{"interpolated":true,"parameters":["zoom","feature"]},"property-type":"data-driven"},"text-max-width":{"type":"number","default":10,"minimum":0,"units":"ems","requires":["text-field",{"symbol-placement":["point"]}],"expression":{"interpolated":true,"parameters":["zoom","feature"]},"property-type":"data-driven"},"text-line-height":{"type":"number","default":1.2,"units":"ems","requires":["text-field"],"expression":{"interpolated":true,"parameters":["zoom","feature"]},"property-type":"data-driven"},"text-letter-spacing":{"type":"number","default":0,"units":"ems","requires":["text-field"],"expression":{"interpolated":true,"parameters":["zoom","feature"]},"property-type":"data-driven"},"text-justify":{"type":"enum","values":{"auto":{},"left":{},"center":{},"right":{}},"default":"center","requires":["text-field"],"expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"text-radial-offset":{"type":"number","units":"ems","default":0,"requires":["text-field"],"property-type":"data-driven","expression":{"interpolated":true,"parameters":["zoom","feature"]}},"text-variable-anchor":{"type":"array","value":"enum","values":{"center":{},"left":{},"right":{},"top":{},"bottom":{},"top-left":{},"top-right":{},"bottom-left":{},"bottom-right":{}},"requires":["text-field",{"symbol-placement":["point"]}],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"text-anchor":{"type":"enum","values":{"center":{},"left":{},"right":{},"top":{},"bottom":{},"top-left":{},"top-right":{},"bottom-left":{},"bottom-right":{}},"default":"center","requires":["text-field",{"!":"text-variable-anchor"}],"expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"text-max-angle":{"type":"number","default":45,"units":"degrees","requires":["text-field",{"symbol-placement":["line","line-center"]}],"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"text-writing-mode":{"type":"array","value":"enum","values":{"horizontal":{},"vertical":{}},"requires":["text-field"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"text-rotate":{"type":"number","default":0,"period":360,"units":"degrees","requires":["text-field"],"expression":{"interpolated":true,"parameters":["zoom","feature"]},"property-type":"data-driven"},"text-padding":{"type":"number","default":2,"minimum":0,"units":"pixels","requires":["text-field"],"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"text-keep-upright":{"type":"boolean","default":true,"requires":["text-field",{"text-rotation-alignment":"map"},{"symbol-placement":["line","line-center"]}],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"text-transform":{"type":"enum","values":{"none":{},"uppercase":{},"lowercase":{}},"default":"none","requires":["text-field"],"expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"text-offset":{"type":"array","value":"number","units":"ems","length":2,"default":[0,0],"requires":["text-field",{"!":"text-radial-offset"}],"expression":{"interpolated":true,"parameters":["zoom","feature"]},"property-type":"data-driven"},"text-allow-overlap":{"type":"boolean","default":false,"requires":["text-field"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"text-ignore-placement":{"type":"boolean","default":false,"requires":["text-field"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"text-optional":{"type":"boolean","default":false,"requires":["text-field","icon-image"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"visibility":{"type":"enum","values":{"visible":{},"none":{}},"default":"visible","expression":{"interpolated":false},"property-type":"constant"}},"layout_raster":{"visibility":{"type":"enum","values":{"visible":{},"none":{}},"default":"visible","expression":{"interpolated":false},"property-type":"constant"}},"layout_hillshade":{"visibility":{"type":"enum","values":{"visible":{},"none":{}},"default":"visible","expression":{"interpolated":false},"property-type":"constant"}},"filter":{"type":"array","value":"*"},"filter_symbol":{"type":"boolean","default":false,"transition":false,"property-type":"data-driven","expression":{"interpolated":false,"parameters":["zoom","feature","pitch","distance-from-center"]}},"filter_fill":{"type":"boolean","default":false,"transition":false,"property-type":"data-driven","expression":{"interpolated":false,"parameters":["zoom","feature"]}},"filter_line":{"type":"boolean","default":false,"transition":false,"property-type":"data-driven","expression":{"interpolated":false,"parameters":["zoom","feature"]}},"filter_circle":{"type":"boolean","default":false,"transition":false,"property-type":"data-driven","expression":{"interpolated":false,"parameters":["zoom","feature"]}},"filter_fill-extrusion":{"type":"boolean","default":false,"transition":false,"property-type":"data-driven","expression":{"interpolated":false,"parameters":["zoom","feature"]}},"filter_heatmap":{"type":"boolean","default":false,"transition":false,"property-type":"data-driven","expression":{"interpolated":false,"parameters":["zoom","feature"]}},"filter_operator":{"type":"enum","values":{"==":{},"!=":{},">":{},">=":{},"<":{},"<=":{},"in":{},"!in":{},"all":{},"any":{},"none":{},"has":{},"!has":{}}},"geometry_type":{"type":"enum","values":{"Point":{},"LineString":{},"Polygon":{}}},"function":{"expression":{"type":"expression"},"stops":{"type":"array","value":"function_stop"},"base":{"type":"number","default":1,"minimum":0},"property":{"type":"string","default":"$zoom"},"type":{"type":"enum","values":{"identity":{},"exponential":{},"interval":{},"categorical":{}},"default":"exponential"},"colorSpace":{"type":"enum","values":{"rgb":{},"lab":{},"hcl":{}},"default":"rgb"},"default":{"type":"*","required":false}},"function_stop":{"type":"array","minimum":0,"maximum":24,"value":["number","color"],"length":2},"expression":{"type":"array","value":"*","minimum":1},"fog":{"range":{"type":"array","default":[0.5,10],"minimum":-20,"maximum":20,"length":2,"value":"number","property-type":"data-constant","transition":true,"expression":{"interpolated":true,"parameters":["zoom","measure-light"],"relaxZoomRestriction":true}},"color":{"type":"color","property-type":"data-constant","default":"#ffffff","expression":{"interpolated":true,"parameters":["zoom","measure-light"],"relaxZoomRestriction":true},"transition":true},"high-color":{"type":"color","property-type":"data-constant","default":"#245cdf","expression":{"interpolated":true,"parameters":["zoom","measure-light"],"relaxZoomRestriction":true},"transition":true},"space-color":{"type":"color","property-type":"data-constant","default":["interpolate",["linear"],["zoom"],4,"#010b19",7,"#367ab9"],"expression":{"interpolated":true,"parameters":["zoom","measure-light"],"relaxZoomRestriction":true},"transition":true},"horizon-blend":{"type":"number","property-type":"data-constant","default":["interpolate",["linear"],["zoom"],4,0.2,7,0.1],"minimum":0,"maximum":1,"expression":{"interpolated":true,"parameters":["zoom","measure-light"],"relaxZoomRestriction":true},"transition":true},"star-intensity":{"type":"number","property-type":"data-constant","default":["interpolate",["linear"],["zoom"],5,0.35,6,0],"minimum":0,"maximum":1,"expression":{"interpolated":true,"parameters":["zoom","measure-light"],"relaxZoomRestriction":true},"transition":true},"vertical-range":{"type":"array","default":[0,0],"minimum":0,"length":2,"value":"number","property-type":"data-constant","transition":true,"expression":{"interpolated":true,"parameters":["zoom","measure-light"],"relaxZoomRestriction":true}}},"camera":{"camera-projection":{"type":"enum","values":{"perspective":{},"orthographic":{}},"transition":true,"expression":{"interpolated":true,"parameters":["zoom"]},"default":"perspective","property-type":"data-constant"}},"light":{"anchor":{"type":"enum","default":"viewport","values":{"map":{},"viewport":{}},"property-type":"data-constant","transition":false,"expression":{"interpolated":false,"parameters":["zoom"]}},"position":{"type":"array","default":[1.15,210,30],"length":3,"value":"number","property-type":"data-constant","transition":true,"expression":{"interpolated":true,"parameters":["zoom"]}},"color":{"type":"color","property-type":"data-constant","default":"#ffffff","expression":{"interpolated":true,"parameters":["zoom"]},"transition":true},"intensity":{"type":"number","property-type":"data-constant","default":0.5,"minimum":0,"maximum":1,"expression":{"interpolated":true,"parameters":["zoom"]},"transition":true}},"projection":{"name":{"type":"enum","values":{"albers":{},"equalEarth":{},"equirectangular":{},"lambertConformalConic":{},"mercator":{},"naturalEarth":{},"winkelTripel":{},"globe":{}},"default":"mercator","required":true},"center":{"type":"array","length":2,"value":"number","property-type":"data-constant","minimum":[-180,-90],"maximum":[180,90],"transition":false,"requires":[{"name":["albers","lambertConformalConic"]}]},"parallels":{"type":"array","length":2,"value":"number","property-type":"data-constant","minimum":[-90,-90],"maximum":[90,90],"transition":false,"requires":[{"name":["albers","lambertConformalConic"]}]}},"terrain":{"source":{"type":"string","required":true},"exaggeration":{"type":"number","property-type":"data-constant","default":1,"minimum":0,"maximum":1000,"expression":{"interpolated":true,"parameters":["zoom"]},"transition":true,"requires":["source"]}},"paint":["paint_fill","paint_line","paint_circle","paint_heatmap","paint_fill-extrusion","paint_symbol","paint_raster","paint_hillshade","paint_background","paint_sky","paint_model"],"paint_fill":{"fill-antialias":{"type":"boolean","default":true,"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"fill-opacity":{"type":"number","default":1,"minimum":0,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"fill-color":{"type":"color","default":"#000000","transition":true,"requires":[{"!":"fill-pattern"}],"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"fill-outline-color":{"type":"color","transition":true,"requires":[{"!":"fill-pattern"},{"fill-antialias":true}],"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"fill-translate":{"type":"array","value":"number","length":2,"default":[0,0],"transition":true,"units":"pixels","expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"fill-translate-anchor":{"type":"enum","values":{"map":{},"viewport":{}},"default":"map","requires":["fill-translate"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"fill-pattern":{"type":"resolvedImage","transition":false,"expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"fill-emissive-strength":{"type":"number","default":0,"minimum":0,"transition":true,"units":"intensity","expression":{"interpolated":true,"parameters":["zoom","measure-light"]},"property-type":"data-constant"}},"paint_fill-extrusion":{"fill-extrusion-opacity":{"type":"number","default":1,"minimum":0,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"fill-extrusion-color":{"type":"color","default":"#000000","transition":true,"requires":[{"!":"fill-extrusion-pattern"}],"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"fill-extrusion-translate":{"type":"array","value":"number","length":2,"default":[0,0],"transition":true,"units":"pixels","expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"fill-extrusion-translate-anchor":{"type":"enum","values":{"map":{},"viewport":{}},"default":"map","requires":["fill-extrusion-translate"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"fill-extrusion-pattern":{"type":"resolvedImage","transition":false,"expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"fill-extrusion-height":{"type":"number","default":0,"minimum":0,"units":"meters","transition":true,"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"fill-extrusion-base":{"type":"number","default":0,"minimum":0,"units":"meters","transition":true,"requires":["fill-extrusion-height"],"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"fill-extrusion-vertical-gradient":{"type":"boolean","default":true,"transition":false,"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"fill-extrusion-ambient-occlusion-intensity":{"property-type":"data-constant","type":"number","private":true,"default":0,"minimum":0,"maximum":1,"expression":{"interpolated":true,"parameters":["zoom"]},"transition":true},"fill-extrusion-ambient-occlusion-radius":{"property-type":"data-constant","type":"number","private":true,"default":3,"minimum":0,"expression":{"interpolated":true,"parameters":["zoom"]},"transition":true,"requires":["fill-extrusion-edge-radius"]},"fill-extrusion-ambient-occlusion-wall-radius":{"property-type":"data-constant","type":"number","default":3,"minimum":0,"expression":{"interpolated":true,"parameters":["zoom"]},"transition":true,"requires":["fill-extrusion-edge-radius"]},"fill-extrusion-ambient-occlusion-ground-radius":{"property-type":"data-constant","type":"number","default":3,"minimum":0,"expression":{"interpolated":true,"parameters":["zoom"]},"transition":true},"fill-extrusion-ambient-occlusion-ground-attenuation":{"property-type":"data-constant","type":"number","default":0.69,"minimum":0,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom"]}},"fill-extrusion-flood-light-color":{"property-type":"data-constant","type":"color","default":"#ffffff","transition":true,"expression":{"interpolated":true,"parameters":["zoom","measure-light"]}},"fill-extrusion-flood-light-intensity":{"property-type":"data-constant","type":"number","default":0,"minimum":0,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom","measure-light"]}},"fill-extrusion-flood-light-wall-radius":{"property-type":"data-driven","type":"number","units":"meters","default":0,"minimum":0,"transition":true,"expression":{"interpolated":true,"parameters":["feature","feature-state"]}},"fill-extrusion-flood-light-ground-radius":{"property-type":"data-driven","type":"number","units":"meters","default":0,"minimum":0,"transition":true,"expression":{"interpolated":true,"parameters":["feature","feature-state"]}},"fill-extrusion-flood-light-ground-attenuation":{"property-type":"data-constant","type":"number","default":0.69,"minimum":0,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom"]}},"fill-extrusion-vertical-scale":{"property-type":"data-constant","type":"number","default":1,"minimum":0,"transition":true,"expression":{"interpolated":true,"parameters":["zoom"]}},"fill-extrusion-rounded-roof":{"property-type":"data-constant","type":"boolean","default":true,"requires":["fill-extrusion-edge-radius"],"transition":false,"expression":{"interpolated":false,"parameters":["zoom"]}},"fill-extrusion-cutoff-fade-range":{"type":"number","default":0,"minimum":0,"maximum":1,"transition":false,"expression":{"interpolated":false},"property-type":"data-constant"}},"paint_line":{"line-opacity":{"type":"number","default":1,"minimum":0,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"line-color":{"type":"color","default":"#000000","transition":true,"requires":[{"!":"line-pattern"}],"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"line-translate":{"type":"array","value":"number","length":2,"default":[0,0],"transition":true,"units":"pixels","expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"line-translate-anchor":{"type":"enum","values":{"map":{},"viewport":{}},"default":"map","requires":["line-translate"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"line-width":{"type":"number","default":1,"minimum":0,"transition":true,"units":"pixels","expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"line-gap-width":{"type":"number","default":0,"minimum":0,"transition":true,"units":"pixels","expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"line-offset":{"type":"number","default":0,"transition":true,"units":"pixels","expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"line-blur":{"type":"number","default":0,"minimum":0,"transition":true,"units":"pixels","expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"line-dasharray":{"type":"array","value":"number","minimum":0,"transition":false,"units":"line widths","requires":[{"!":"line-pattern"}],"expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"line-pattern":{"type":"resolvedImage","transition":false,"expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"line-gradient":{"type":"color","transition":false,"requires":[{"!":"line-pattern"},{"source":"geojson","has":{"lineMetrics":true}}],"expression":{"interpolated":true,"parameters":["line-progress"]},"property-type":"color-ramp"},"line-trim-offset":{"type":"array","value":"number","length":2,"default":[0,0],"minimum":[0,0],"maximum":[1,1],"transition":false,"requires":[{"source":"geojson","has":{"lineMetrics":true}}],"property-type":"constant"},"line-emissive-strength":{"type":"number","default":0,"minimum":0,"transition":true,"units":"intensity","expression":{"interpolated":true,"parameters":["zoom","measure-light"]},"property-type":"data-constant"},"line-border-width":{"type":"number","private":true,"default":0,"minimum":0,"transition":true,"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"line-border-color":{"type":"color","private":true,"default":"rgba(0, 0, 0, 0)","transition":true,"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"}},"paint_circle":{"circle-radius":{"type":"number","default":5,"minimum":0,"transition":true,"units":"pixels","expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"circle-color":{"type":"color","default":"#000000","transition":true,"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"circle-blur":{"type":"number","default":0,"transition":true,"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"circle-opacity":{"type":"number","default":1,"minimum":0,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"circle-translate":{"type":"array","value":"number","length":2,"default":[0,0],"transition":true,"units":"pixels","expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"circle-translate-anchor":{"type":"enum","values":{"map":{},"viewport":{}},"default":"map","requires":["circle-translate"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"circle-pitch-scale":{"type":"enum","values":{"map":{},"viewport":{}},"default":"map","expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"circle-pitch-alignment":{"type":"enum","values":{"map":{},"viewport":{}},"default":"viewport","expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"circle-stroke-width":{"type":"number","default":0,"minimum":0,"transition":true,"units":"pixels","expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"circle-stroke-color":{"type":"color","default":"#000000","transition":true,"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"circle-stroke-opacity":{"type":"number","default":1,"minimum":0,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"circle-emissive-strength":{"type":"number","default":0,"minimum":0,"transition":true,"units":"intensity","expression":{"interpolated":true,"parameters":["zoom","measure-light"]},"property-type":"data-constant"}},"paint_heatmap":{"heatmap-radius":{"type":"number","default":30,"minimum":1,"transition":true,"units":"pixels","expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"heatmap-weight":{"type":"number","default":1,"minimum":0,"transition":false,"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"heatmap-intensity":{"type":"number","default":1,"minimum":0,"transition":true,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"heatmap-color":{"type":"color","default":["interpolate",["linear"],["heatmap-density"],0,"rgba(0, 0, 255, 0)",0.1,"royalblue",0.3,"cyan",0.5,"lime",0.7,"yellow",1,"red"],"transition":false,"expression":{"interpolated":true,"parameters":["heatmap-density"]},"property-type":"color-ramp"},"heatmap-opacity":{"type":"number","default":1,"minimum":0,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"}},"paint_symbol":{"icon-opacity":{"type":"number","default":1,"minimum":0,"maximum":1,"transition":true,"requires":["icon-image"],"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"icon-emissive-strength":{"type":"number","default":1,"minimum":0,"transition":true,"units":"intensity","expression":{"interpolated":true,"parameters":["zoom","measure-light"]},"property-type":"data-driven"},"text-emissive-strength":{"type":"number","default":1,"minimum":0,"transition":true,"units":"intensity","expression":{"interpolated":true,"parameters":["zoom","measure-light"]},"property-type":"data-driven"},"icon-color":{"type":"color","default":"#000000","transition":true,"requires":["icon-image"],"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"icon-halo-color":{"type":"color","default":"rgba(0, 0, 0, 0)","transition":true,"requires":["icon-image"],"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"icon-halo-width":{"type":"number","default":0,"minimum":0,"transition":true,"units":"pixels","requires":["icon-image"],"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"icon-halo-blur":{"type":"number","default":0,"minimum":0,"transition":true,"units":"pixels","requires":["icon-image"],"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"icon-translate":{"type":"array","value":"number","length":2,"default":[0,0],"transition":true,"units":"pixels","requires":["icon-image"],"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"icon-translate-anchor":{"type":"enum","values":{"map":{},"viewport":{}},"default":"map","requires":["icon-image","icon-translate"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"icon-image-cross-fade":{"type":"number","property-type":"data-driven","default":0,"minimum":0,"maximum":1,"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"transition":true},"text-opacity":{"type":"number","default":1,"minimum":0,"maximum":1,"transition":true,"requires":["text-field"],"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"text-color":{"type":"color","default":"#000000","transition":true,"overridable":true,"requires":["text-field"],"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"text-halo-color":{"type":"color","default":"rgba(0, 0, 0, 0)","transition":true,"requires":["text-field"],"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"text-halo-width":{"type":"number","default":0,"minimum":0,"transition":true,"units":"pixels","requires":["text-field"],"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"text-halo-blur":{"type":"number","default":0,"minimum":0,"transition":true,"units":"pixels","requires":["text-field"],"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state","measure-light"]},"property-type":"data-driven"},"text-translate":{"type":"array","value":"number","length":2,"default":[0,0],"transition":true,"units":"pixels","requires":["text-field"],"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"text-translate-anchor":{"type":"enum","values":{"map":{},"viewport":{}},"default":"map","requires":["text-field","text-translate"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"}},"paint_raster":{"raster-opacity":{"type":"number","default":1,"minimum":0,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"raster-color":{"type":"color","transition":false,"expression":{"interpolated":true,"parameters":["raster-value"]},"property-type":"color-ramp"},"raster-color-mix":{"type":"array","default":[0.2126,0.7152,0.0722,0],"length":4,"value":"number","property-type":"data-constant","transition":true,"requires":["raster-color"],"expression":{"interpolated":true,"parameters":["zoom"]}},"raster-color-range":{"type":"array","default":[0,1],"length":2,"value":"number","property-type":"data-constant","transition":true,"requires":["raster-color"],"expression":{"interpolated":true,"parameters":["zoom"]}},"raster-hue-rotate":{"type":"number","default":0,"period":360,"transition":true,"units":"degrees","expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"raster-brightness-min":{"type":"number","default":0,"minimum":0,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"raster-brightness-max":{"type":"number","default":1,"minimum":0,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"raster-saturation":{"type":"number","default":0,"minimum":-1,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"raster-contrast":{"type":"number","default":0,"minimum":-1,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"raster-resampling":{"type":"enum","values":{"linear":{},"nearest":{}},"default":"linear","expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"raster-fade-duration":{"type":"number","default":300,"minimum":0,"transition":false,"units":"milliseconds","expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"}},"paint_hillshade":{"hillshade-illumination-direction":{"type":"number","default":335,"minimum":0,"maximum":359,"transition":false,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"hillshade-illumination-anchor":{"type":"enum","values":{"map":{},"viewport":{}},"default":"viewport","expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"hillshade-exaggeration":{"type":"number","default":0.5,"minimum":0,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"hillshade-shadow-color":{"type":"color","default":"#000000","transition":true,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"hillshade-highlight-color":{"type":"color","default":"#FFFFFF","transition":true,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"hillshade-accent-color":{"type":"color","default":"#000000","transition":true,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"}},"paint_background":{"background-color":{"type":"color","default":"#000000","transition":true,"requires":[{"!":"background-pattern"}],"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"background-pattern":{"type":"resolvedImage","transition":false,"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"background-opacity":{"type":"number","default":1,"minimum":0,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"background-emissive-strength":{"type":"number","default":0,"minimum":0,"transition":true,"units":"intensity","expression":{"interpolated":true,"parameters":["zoom","measure-light"]},"property-type":"data-constant"}},"paint_sky":{"sky-type":{"type":"enum","values":{"gradient":{},"atmosphere":{}},"default":"atmosphere","expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"sky-atmosphere-sun":{"type":"array","value":"number","length":2,"units":"degrees","minimum":[0,0],"maximum":[360,180],"transition":false,"requires":[{"sky-type":"atmosphere"}],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"sky-atmosphere-sun-intensity":{"type":"number","requires":[{"sky-type":"atmosphere"}],"default":10,"minimum":0,"maximum":100,"transition":false,"property-type":"data-constant"},"sky-gradient-center":{"type":"array","requires":[{"sky-type":"gradient"}],"value":"number","default":[0,0],"length":2,"units":"degrees","minimum":[0,0],"maximum":[360,180],"transition":false,"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"sky-gradient-radius":{"type":"number","requires":[{"sky-type":"gradient"}],"default":90,"minimum":0,"maximum":180,"transition":false,"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"sky-gradient":{"type":"color","default":["interpolate",["linear"],["sky-radial-progress"],0.8,"#87ceeb",1,"white"],"transition":false,"requires":[{"sky-type":"gradient"}],"expression":{"interpolated":true,"parameters":["sky-radial-progress"]},"property-type":"color-ramp"},"sky-atmosphere-halo-color":{"type":"color","default":"white","transition":false,"requires":[{"sky-type":"atmosphere"}],"property-type":"data-constant"},"sky-atmosphere-color":{"type":"color","default":"white","transition":false,"requires":[{"sky-type":"atmosphere"}],"property-type":"data-constant"},"sky-opacity":{"type":"number","default":1,"minimum":0,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"}},"paint_model":{"model-opacity":{"type":"number","default":1,"minimum":0,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"model-rotation":{"type":"array","value":"number","length":3,"default":[0,0,0],"period":360,"units":"degrees","property-type":"data-driven","expression":{"interpolated":true,"parameters":["feature","feature-state"]},"transition":true},"model-scale":{"type":"array","value":"number","length":3,"default":[1,1,1],"property-type":"data-driven","expression":{"interpolated":true,"parameters":["feature","feature-state","zoom"]},"transition":true},"model-translation":{"type":"array","value":"number","length":3,"default":[0,0,0],"property-type":"data-driven","expression":{"interpolated":true,"parameters":["feature","feature-state"]},"transition":true},"model-color":{"type":"color","default":"#ffffff","property-type":"data-driven","expression":{"interpolated":true,"parameters":["feature","feature-state","measure-light"]},"transition":true},"model-color-mix-intensity":{"type":"number","property-type":"data-driven","default":0,"minimum":0,"maximum":1,"expression":{"interpolated":true,"parameters":["feature","feature-state","measure-light"]},"transition":true},"model-type":{"type":"enum","values":{"common-3d":{},"location-indicator":{}},"default":"common-3d","property-type":"data-constant"},"model-cast-shadows":{"type":"boolean","default":true,"transition":false,"expression":{"interpolated":false},"property-type":"data-constant"},"model-receive-shadows":{"type":"boolean","default":true,"transition":false,"expression":{"interpolated":false},"property-type":"data-constant"},"model-ambient-occlusion-intensity":{"type":"number","default":1,"minimum":0,"maximum":1,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant","transition":true},"model-emissive-strength":{"type":"number","property-type":"data-driven","default":0,"minimum":0,"maximum":5,"units":"number","expression":{"interpolated":true,"parameters":["feature","feature-state","measure-light"]},"transition":true},"model-roughness":{"type":"number","default":1,"minimum":0,"maximum":1,"property-type":"data-driven","expression":{"interpolated":true,"parameters":["feature","feature-state"]},"transition":true},"model-height-based-emissive-strength-multiplier":{"type":"array","default":[1,1,1,1,0],"length":5,"value":"number","property-type":"data-driven","expression":{"interpolated":true,"parameters":["feature","feature-state","measure-light"]},"transition":true},"model-cutoff-fade-range":{"type":"number","default":0,"minimum":0,"maximum":1,"transition":false,"expression":{"interpolated":false},"property-type":"data-constant"}},"transition":{"duration":{"type":"number","default":300,"minimum":0,"units":"milliseconds"},"delay":{"type":"number","default":0,"minimum":0,"units":"milliseconds"}},"property-type":{"data-driven":{"type":"property-type"},"color-ramp":{"type":"property-type"},"data-constant":{"type":"property-type"},"constant":{"type":"property-type"}},"promoteId":{"*":{"type":"string"}}}');function De(t,...e){for(const i of e)for(const e in i)t[e]=i[e];return t}class Pe{constructor(t,e,i,r){this.message=(t?`${t}: `:"")+i,r&&(this.identifier=r),null!=e&&e.__line__&&(this.line=e.__line__);}}function Re(t){return t instanceof Number||t instanceof String||t instanceof Boolean?t.valueOf():t}function Le(t){if(Array.isArray(t))return t.map(Le);if(t instanceof Object&&!(t instanceof Number||t instanceof String||t instanceof Boolean)){const e={};for(const i in t)e[i]=Le(t[i]);return e}return Re(t)}class ke extends Error{constructor(t,e){super(e),this.message=e,this.key=t;}}var Be=ke;class Oe{constructor(t,e=[]){this.parent=t,this.bindings={};for(const[t,i]of e)this.bindings[t]=i;}concat(t){return new Oe(this,t)}get(t){if(this.bindings[t])return this.bindings[t];if(this.parent)return this.parent.get(t);throw new Error(`${t} not found in scope.`)}has(t){return !!this.bindings[t]||!!this.parent&&this.parent.has(t)}}var Fe=Oe;const Ne={kind:"null"},Ue={kind:"number"},Ve={kind:"string"},je={kind:"boolean"},Ge={kind:"color"},qe={kind:"object"},Ze={kind:"value"},$e={kind:"collator"},He={kind:"formatted"},We={kind:"resolvedImage"};function Xe(t,e){return {kind:"array",itemType:t,N:e}}function Ye(t){if("array"===t.kind){const e=Ye(t.itemType);return "number"==typeof t.N?`array<${e}, ${t.N}>`:"value"===t.itemType.kind?"array":`array<${e}>`}return t.kind}const Ke=[Ne,Ue,Ve,je,Ge,He,qe,Xe(Ze),We];function Je(t,e){if("error"===e.kind)return null;if("array"===t.kind){if("array"===e.kind&&(0===e.N&&"value"===e.itemType.kind||!Je(t.itemType,e.itemType))&&("number"!=typeof t.N||t.N===e.N))return null}else {if(t.kind===e.kind)return null;if("value"===t.kind)for(const t of Ke)if(!Je(t,e))return null}return `Expected ${Ye(t)} but found ${Ye(e)} instead.`}function Qe(t,e){return e.some((e=>e.kind===t.kind))}function ti(t,e){return e.some((e=>"null"===e?null===t:"array"===e?Array.isArray(t):"object"===e?t&&!Array.isArray(t)&&"object"==typeof t:e===typeof t))}var ei,ii={transparent:[0,0,0,0],aliceblue:[240,248,255,1],antiquewhite:[250,235,215,1],aqua:[0,255,255,1],aquamarine:[127,255,212,1],azure:[240,255,255,1],beige:[245,245,220,1],bisque:[255,228,196,1],black:[0,0,0,1],blanchedalmond:[255,235,205,1],blue:[0,0,255,1],blueviolet:[138,43,226,1],brown:[165,42,42,1],burlywood:[222,184,135,1],cadetblue:[95,158,160,1],chartreuse:[127,255,0,1],chocolate:[210,105,30,1],coral:[255,127,80,1],cornflowerblue:[100,149,237,1],cornsilk:[255,248,220,1],crimson:[220,20,60,1],cyan:[0,255,255,1],darkblue:[0,0,139,1],darkcyan:[0,139,139,1],darkgoldenrod:[184,134,11,1],darkgray:[169,169,169,1],darkgreen:[0,100,0,1],darkgrey:[169,169,169,1],darkkhaki:[189,183,107,1],darkmagenta:[139,0,139,1],darkolivegreen:[85,107,47,1],darkorange:[255,140,0,1],darkorchid:[153,50,204,1],darkred:[139,0,0,1],darksalmon:[233,150,122,1],darkseagreen:[143,188,143,1],darkslateblue:[72,61,139,1],darkslategray:[47,79,79,1],darkslategrey:[47,79,79,1],darkturquoise:[0,206,209,1],darkviolet:[148,0,211,1],deeppink:[255,20,147,1],deepskyblue:[0,191,255,1],dimgray:[105,105,105,1],dimgrey:[105,105,105,1],dodgerblue:[30,144,255,1],firebrick:[178,34,34,1],floralwhite:[255,250,240,1],forestgreen:[34,139,34,1],fuchsia:[255,0,255,1],gainsboro:[220,220,220,1],ghostwhite:[248,248,255,1],gold:[255,215,0,1],goldenrod:[218,165,32,1],gray:[128,128,128,1],green:[0,128,0,1],greenyellow:[173,255,47,1],grey:[128,128,128,1],honeydew:[240,255,240,1],hotpink:[255,105,180,1],indianred:[205,92,92,1],indigo:[75,0,130,1],ivory:[255,255,240,1],khaki:[240,230,140,1],lavender:[230,230,250,1],lavenderblush:[255,240,245,1],lawngreen:[124,252,0,1],lemonchiffon:[255,250,205,1],lightblue:[173,216,230,1],lightcoral:[240,128,128,1],lightcyan:[224,255,255,1],lightgoldenrodyellow:[250,250,210,1],lightgray:[211,211,211,1],lightgreen:[144,238,144,1],lightgrey:[211,211,211,1],lightpink:[255,182,193,1],lightsalmon:[255,160,122,1],lightseagreen:[32,178,170,1],lightskyblue:[135,206,250,1],lightslategray:[119,136,153,1],lightslategrey:[119,136,153,1],lightsteelblue:[176,196,222,1],lightyellow:[255,255,224,1],lime:[0,255,0,1],limegreen:[50,205,50,1],linen:[250,240,230,1],magenta:[255,0,255,1],maroon:[128,0,0,1],mediumaquamarine:[102,205,170,1],mediumblue:[0,0,205,1],mediumorchid:[186,85,211,1],mediumpurple:[147,112,219,1],mediumseagreen:[60,179,113,1],mediumslateblue:[123,104,238,1],mediumspringgreen:[0,250,154,1],mediumturquoise:[72,209,204,1],mediumvioletred:[199,21,133,1],midnightblue:[25,25,112,1],mintcream:[245,255,250,1],mistyrose:[255,228,225,1],moccasin:[255,228,181,1],navajowhite:[255,222,173,1],navy:[0,0,128,1],oldlace:[253,245,230,1],olive:[128,128,0,1],olivedrab:[107,142,35,1],orange:[255,165,0,1],orangered:[255,69,0,1],orchid:[218,112,214,1],palegoldenrod:[238,232,170,1],palegreen:[152,251,152,1],paleturquoise:[175,238,238,1],palevioletred:[219,112,147,1],papayawhip:[255,239,213,1],peachpuff:[255,218,185,1],peru:[205,133,63,1],pink:[255,192,203,1],plum:[221,160,221,1],powderblue:[176,224,230,1],purple:[128,0,128,1],rebeccapurple:[102,51,153,1],red:[255,0,0,1],rosybrown:[188,143,143,1],royalblue:[65,105,225,1],saddlebrown:[139,69,19,1],salmon:[250,128,114,1],sandybrown:[244,164,96,1],seagreen:[46,139,87,1],seashell:[255,245,238,1],sienna:[160,82,45,1],silver:[192,192,192,1],skyblue:[135,206,235,1],slateblue:[106,90,205,1],slategray:[112,128,144,1],slategrey:[112,128,144,1],snow:[255,250,250,1],springgreen:[0,255,127,1],steelblue:[70,130,180,1],tan:[210,180,140,1],teal:[0,128,128,1],thistle:[216,191,216,1],tomato:[255,99,71,1],turquoise:[64,224,208,1],violet:[238,130,238,1],wheat:[245,222,179,1],white:[255,255,255,1],whitesmoke:[245,245,245,1],yellow:[255,255,0,1],yellowgreen:[154,205,50,1]};function ri(t){return (t=Math.round(t))<0?0:t>255?255:t}function ni(t){return ri("%"===t[t.length-1]?parseFloat(t)/100*255:parseInt(t))}function oi(t){return (e="%"===t[t.length-1]?parseFloat(t)/100:parseFloat(t))<0?0:e>1?1:e;var e;}function si(t,e,i){return i<0?i+=1:i>1&&(i-=1),6*i<1?t+(e-t)*i*6:2*i<1?e:3*i<2?t+(e-t)*(2/3-i)*6:t}try{ei={}.parseCSSColor=function(t){var e,i=t.replace(/ /g,"").toLowerCase();if(i in ii)return ii[i].slice();if("#"===i[0])return 4===i.length?(e=parseInt(i.substr(1),16))>=0&&e<=4095?[(3840&e)>>4|(3840&e)>>8,240&e|(240&e)>>4,15&e|(15&e)<<4,1]:null:7===i.length&&(e=parseInt(i.substr(1),16))>=0&&e<=16777215?[(16711680&e)>>16,(65280&e)>>8,255&e,1]:null;var r=i.indexOf("("),n=i.indexOf(")");if(-1!==r&&n+1===i.length){var o=i.substr(0,r),s=i.substr(r+1,n-(r+1)).split(","),a=1;switch(o){case"rgba":if(4!==s.length)return null;a=oi(s.pop());case"rgb":return 3!==s.length?null:[ni(s[0]),ni(s[1]),ni(s[2]),a];case"hsla":if(4!==s.length)return null;a=oi(s.pop());case"hsl":if(3!==s.length)return null;var l=(parseFloat(s[0])%360+360)%360/360,c=oi(s[1]),h=oi(s[2]),u=h<=.5?h*(c+1):h+c-h*c,d=2*h-u;return [ri(255*si(d,u,l+1/3)),ri(255*si(d,u,l)),ri(255*si(d,u,l-1/3)),a];default:return null}}return null};}catch(t){}class ai{constructor(t,e,i,r=1){this.r=t,this.g=e,this.b=i,this.a=r;}static parse(t){if(!t)return;if(t instanceof ai)return t;if("string"!=typeof t)return;const e=ei(t);return e?new ai(e[0]/255*e[3],e[1]/255*e[3],e[2]/255*e[3],e[3]):void 0}toString(){const[t,e,i,r]=this.toArray();return `rgba(${Math.round(t)},${Math.round(e)},${Math.round(i)},${r})`}toArray(){const{r:t,g:e,b:i,a:r}=this;return 0===r?[0,0,0,0]:[255*t/r,255*e/r,255*i/r,r]}toArray01(){const{r:t,g:e,b:i,a:r}=this;return 0===r?[0,0,0,0]:[t/r,e/r,i/r,r]}toArray01Scaled(t){const{r:e,g:i,b:r,a:n}=this;return 0===n?[0,0,0]:[e/n*t,i/n*t,r/n*t]}toArray01PremultipliedAlpha(){const{r:t,g:e,b:i,a:r}=this;return [t,e,i,r]}toArray01Linear(){const{r:t,g:e,b:i,a:r}=this;return 0===r?[0,0,0,0]:[Math.pow(t/r,2.2),Math.pow(e/r,2.2),Math.pow(i/r,2.2),r]}}ai.black=new ai(0,0,0,1),ai.white=new ai(1,1,1,1),ai.transparent=new ai(0,0,0,0),ai.red=new ai(1,0,0,1),ai.blue=new ai(0,0,1,1);var li=ai;class ci{constructor(t,e,i){this.sensitivity=t?e?"variant":"case":e?"accent":"base",this.locale=i,this.collator=new Intl.Collator(this.locale?this.locale:[],{sensitivity:this.sensitivity,usage:"search"});}compare(t,e){return this.collator.compare(t,e)}resolvedLocale(){return new Intl.Collator(this.locale?this.locale:[]).resolvedOptions().locale}}class hi{constructor(t,e,i,r,n){this.text=t.normalize?t.normalize():t,this.image=e,this.scale=i,this.fontStack=r,this.textColor=n;}}class ui{constructor(t){this.sections=t;}static fromString(t){return new ui([new hi(t,null,null,null,null)])}isEmpty(){return 0===this.sections.length||!this.sections.some((t=>0!==t.text.length||t.image&&0!==t.image.namePrimary.length))}static factory(t){return t instanceof ui?t:ui.fromString(t)}toString(){return 0===this.sections.length?"":this.sections.map((t=>t.text)).join("")}serialize(){const t=["format"];for(const e of this.sections){if(e.image){t.push(["image",e.image.namePrimary]);continue}t.push(e.text);const i={};e.fontStack&&(i["text-font"]=["literal",e.fontStack.split(",")]),e.scale&&(i["font-scale"]=e.scale),e.textColor&&(i["text-color"]=["rgba"].concat(e.textColor.toArray())),t.push(i);}return t}}class di{constructor(t){this.namePrimary=t.namePrimary,t.nameSecondary&&(this.nameSecondary=t.nameSecondary),this.available=t.available;}toString(){return this.nameSecondary?`[${this.namePrimary},${this.nameSecondary}]`:this.namePrimary}static fromString(t,e){return t?new di({namePrimary:t,nameSecondary:e,available:!1}):null}serialize(){return this.nameSecondary?["image",this.namePrimary,this.nameSecondary]:["image",this.namePrimary]}}function pi(t,e,i,r){return "number"==typeof t&&t>=0&&t<=255&&"number"==typeof e&&e>=0&&e<=255&&"number"==typeof i&&i>=0&&i<=255?void 0===r||"number"==typeof r&&r>=0&&r<=1?null:`Invalid rgba value [${[t,e,i,r].join(", ")}]: 'a' must be between 0 and 1.`:`Invalid rgba value [${("number"==typeof r?[t,e,i,r]:[t,e,i]).join(", ")}]: 'r', 'g', and 'b' must be between 0 and 255.`}function fi(t){if(null===t)return !0;if("string"==typeof t)return !0;if("boolean"==typeof t)return !0;if("number"==typeof t)return !0;if(t instanceof li)return !0;if(t instanceof ci)return !0;if(t instanceof ui)return !0;if(t instanceof di)return !0;if(Array.isArray(t)){for(const e of t)if(!fi(e))return !1;return !0}if("object"==typeof t){for(const e in t)if(!fi(t[e]))return !1;return !0}return !1}function mi(t){if(null===t)return Ne;if("string"==typeof t)return Ve;if("boolean"==typeof t)return je;if("number"==typeof t)return Ue;if(t instanceof li)return Ge;if(t instanceof ci)return $e;if(t instanceof ui)return He;if(t instanceof di)return We;if(Array.isArray(t)){const e=t.length;let i;for(const e of t){const t=mi(e);if(i){if(i===t)continue;i=Ze;break}i=t;}return Xe(i||Ze,e)}return qe}function _i(t){const e=typeof t;return null===t?"":"string"===e||"number"===e||"boolean"===e?String(t):t instanceof li||t instanceof ui||t instanceof di?t.toString():JSON.stringify(t)}class gi{constructor(t,e){this.type=t,this.value=e;}static parse(t,e){if(2!==t.length)return e.error(`'literal' expression requires exactly one argument, but found ${t.length-1} instead.`);if(!fi(t[1]))return e.error("invalid value");const i=t[1];let r=mi(i);const n=e.expectedType;return "array"!==r.kind||0!==r.N||!n||"array"!==n.kind||"number"==typeof n.N&&0!==n.N||(r=n),new gi(r,i)}evaluate(){return this.value}eachChild(){}outputDefined(){return !0}serialize(){return "array"===this.type.kind||"object"===this.type.kind?["literal",this.value]:this.value instanceof li?["rgba"].concat(this.value.toArray()):this.value instanceof ui?this.value.serialize():this.value}}var yi=gi,xi=class{constructor(t){this.name="ExpressionEvaluationError",this.message=t;}toJSON(){return this.message}};const vi={string:Ve,number:Ue,boolean:je,object:qe};class bi{constructor(t,e){this.type=t,this.args=e;}static parse(t,e){if(t.length<2)return e.error("Expected at least one argument.");let i,r=1;const n=t[0];if("array"===n){let n,o;if(t.length>2){const i=t[1];if("string"!=typeof i||!(i in vi)||"object"===i)return e.error('The item type argument of "array" must be one of string, number, boolean',1);n=vi[i],r++;}else n=Ze;if(t.length>3){if(null!==t[2]&&("number"!=typeof t[2]||t[2]<0||t[2]!==Math.floor(t[2])))return e.error('The length argument to "array" must be a positive integer literal',2);o=t[2],r++;}i=Xe(n,o);}else i=vi[n];const o=[];for(;r<t.length;r++){const i=e.parse(t[r],r,Ze);if(!i)return null;o.push(i);}return new bi(i,o)}evaluate(t){for(let e=0;e<this.args.length;e++){const i=this.args[e].evaluate(t);if(!Je(this.type,mi(i)))return i;if(e===this.args.length-1)throw new xi(`Expected value to be of type ${Ye(this.type)}, but found ${Ye(mi(i))} instead.`)}return null}eachChild(t){this.args.forEach(t);}outputDefined(){return this.args.every((t=>t.outputDefined()))}serialize(){const t=this.type,e=[t.kind];if("array"===t.kind){const i=t.itemType;if("string"===i.kind||"number"===i.kind||"boolean"===i.kind){e.push(i.kind);const r=t.N;("number"==typeof r||this.args.length>1)&&e.push(r);}}return e.concat(this.args.map((t=>t.serialize())))}}var wi=bi;class Ti{constructor(t){this.type=He,this.sections=t;}static parse(t,e){if(t.length<2)return e.error("Expected at least one argument.");const i=t[1];if(!Array.isArray(i)&&"object"==typeof i)return e.error("First argument must be an image or text section.");const r=[];let n=!1;for(let i=1;i<=t.length-1;++i){const o=t[i];if(n&&"object"==typeof o&&!Array.isArray(o)){n=!1;let t=null;if(o["font-scale"]&&(t=e.parse(o["font-scale"],1,Ue),!t))return null;let i=null;if(o["text-font"]&&(i=e.parse(o["text-font"],1,Xe(Ve)),!i))return null;let s=null;if(o["text-color"]&&(s=e.parse(o["text-color"],1,Ge),!s))return null;const a=r[r.length-1];a.scale=t,a.font=i,a.textColor=s;}else {const o=e.parse(t[i],1,Ze);if(!o)return null;const s=o.type.kind;if("string"!==s&&"value"!==s&&"null"!==s&&"resolvedImage"!==s)return e.error("Formatted text type must be 'string', 'value', 'image' or 'null'.");n=!0,r.push({content:o,scale:null,font:null,textColor:null});}}return new Ti(r)}evaluate(t){return new ui(this.sections.map((e=>{const i=e.content.evaluate(t);return mi(i)===We?new hi("",i,null,null,null):new hi(_i(i),null,e.scale?e.scale.evaluate(t):null,e.font?e.font.evaluate(t).join(","):null,e.textColor?e.textColor.evaluate(t):null)})))}eachChild(t){for(const e of this.sections)t(e.content),e.scale&&t(e.scale),e.font&&t(e.font),e.textColor&&t(e.textColor);}outputDefined(){return !1}serialize(){const t=["format"];for(const e of this.sections){t.push(e.content.serialize());const i={};e.scale&&(i["font-scale"]=e.scale.serialize()),e.font&&(i["text-font"]=e.font.serialize()),e.textColor&&(i["text-color"]=e.textColor.serialize()),t.push(i);}return t}}class Ei{constructor(t,e){this.type=We,this.inputPrimary=t,this.inputSecondary=e;}static parse(t,e){if(t.length<2)return e.error("Expected two or more arguments.");const i=e.parse(t[1],1,Ve);if(!i)return e.error("No image name provided.");if(2===t.length)return new Ei(i);const r=e.parse(t[2],1,Ve);return r?new Ei(i,r):e.error("Secondary image variant is not a string.")}evaluate(t){const e=di.fromString(this.inputPrimary.evaluate(t),this.inputSecondary?this.inputSecondary.evaluate(t):void 0);return e&&t.availableImages&&(e.available=t.availableImages.indexOf(e.namePrimary)>-1,e.nameSecondary&&e.available&&t.availableImages&&(e.available=t.availableImages.indexOf(e.nameSecondary)>-1)),e}eachChild(t){t(this.inputPrimary),this.inputSecondary&&t(this.inputSecondary);}outputDefined(){return !1}serialize(){return this.inputSecondary?["image",this.inputPrimary.serialize(),this.inputSecondary.serialize()]:["image",this.inputPrimary.serialize()]}}function Mi(t){return t instanceof Number?"number":t instanceof String?"string":t instanceof Boolean?"boolean":Array.isArray(t)?"array":null===t?"null":typeof t}const Ai={"to-boolean":je,"to-color":Ge,"to-number":Ue,"to-string":Ve};class Si{constructor(t,e){this.type=t,this.args=e;}static parse(t,e){if(t.length<2)return e.error("Expected at least one argument.");const i=t[0],r=[];let n=Ne;if("to-array"===i){if(!Array.isArray(t[1]))return null;const i=t[1].length;if(e.expectedType){if("array"!==e.expectedType.kind)return e.error(`Expected ${e.expectedType.kind} but found array.`);n=Xe(e.expectedType.itemType,i);}else {if(!(i>0&&fi(t[1][0])))return null;n=Xe(mi(t[1][0]),i);}for(let o=0;o<i;o++){const i=t[1][o];let s;if("array"===Mi(i))s=e.parse(i,void 0,n.itemType);else {const t=Mi(i);if(t!==n.itemType.kind)return e.error(`Expected ${n.itemType.kind} but found ${t}.`);s=e.registry.literal.parse(["literal",void 0===i?null:i],e);}if(!s)return null;r.push(s);}}else {if(("to-boolean"===i||"to-string"===i)&&2!==t.length)return e.error("Expected one argument.");n=Ai[i];for(let i=1;i<t.length;i++){const n=e.parse(t[i],i,Ze);if(!n)return null;r.push(n);}}return new Si(n,r)}evaluate(t){if("boolean"===this.type.kind)return Boolean(this.args[0].evaluate(t));if("color"===this.type.kind){let e,i;for(const r of this.args){if(e=r.evaluate(t),i=null,e instanceof li)return e;if("string"==typeof e){const i=t.parseColor(e);if(i)return i}else if(Array.isArray(e)&&(i=e.length<3||e.length>4?`Invalid rbga value ${JSON.stringify(e)}: expected an array containing either three or four numeric values.`:pi(e[0],e[1],e[2],e[3]),!i))return new li(e[0]/255,e[1]/255,e[2]/255,e[3])}throw new xi(i||`Could not parse color from value '${"string"==typeof e?e:String(JSON.stringify(e))}'`)}if("number"===this.type.kind){let e=null;for(const i of this.args){if(e=i.evaluate(t),null===e)return 0;const r=Number(e);if(!isNaN(r))return r}throw new xi(`Could not convert ${JSON.stringify(e)} to number.`)}return "formatted"===this.type.kind?ui.fromString(_i(this.args[0].evaluate(t))):"resolvedImage"===this.type.kind?di.fromString(_i(this.args[0].evaluate(t))):"array"===this.type.kind?this.args.map((e=>e.evaluate(t))):_i(this.args[0].evaluate(t))}eachChild(t){this.args.forEach(t);}outputDefined(){return this.args.every((t=>t.outputDefined()))}serialize(){if("formatted"===this.type.kind)return new Ti([{content:this.args[0],scale:null,font:null,textColor:null}]).serialize();if("resolvedImage"===this.type.kind)return new Ei(this.args[0]).serialize();const t="array"===this.type.kind?[]:[`to-${this.type.kind}`];return this.eachChild((e=>{t.push(e.serialize());})),t}}var Ii=Si;const Ci=["Unknown","Point","LineString","Polygon"];var zi=class{constructor(t){this.globals=null,this.feature=null,this.featureState=null,this.formattedSection=null,this._parseColorCache={},this.availableImages=null,this.canonical=null,this.featureTileCoord=null,this.featureDistanceData=null,this.options=t;}id(){return this.feature&&void 0!==this.feature.id?this.feature.id:null}geometryType(){return this.feature?"number"==typeof this.feature.type?Ci[this.feature.type]:this.feature.type:null}geometry(){return this.feature&&"geometry"in this.feature?this.feature.geometry:null}canonicalID(){return this.canonical}properties(){return this.feature&&this.feature.properties||{}}measureLight(t){return this.globals.brightness||0}distanceFromCenter(){if(this.featureTileCoord&&this.featureDistanceData){const t=this.featureDistanceData.center,e=this.featureDistanceData.scale,{x:i,y:r}=this.featureTileCoord;return this.featureDistanceData.bearing[0]*(i*e-t[0])+this.featureDistanceData.bearing[1]*(r*e-t[1])}return 0}parseColor(t){let e=this._parseColorCache[t];return e||(e=this._parseColorCache[t]=li.parse(t)),e}getConfig(t){return this.options?this.options.get(t):null}};class Di{constructor(t,e,i,r){this.name=t,this.type=e,this._evaluate=i,this.args=r;}evaluate(t){return this._evaluate(t,this.args)}eachChild(t){this.args.forEach(t);}outputDefined(){return !1}serialize(){return [this.name].concat(this.args.map((t=>t.serialize())))}static parse(t,e){const i=t[0],r=Di.definitions[i];if(!r)return e.error(`Unknown expression "${i}". If you wanted a literal array, use ["literal", [...]].`,0);const n=Array.isArray(r)?r[0]:r.type,o=Array.isArray(r)?[[r[1],r[2]]]:r.overloads,s=o.filter((([e])=>!Array.isArray(e)||e.length===t.length-1));let a=null;for(const[r,o]of s){a=new Gr(e.registry,e.path,null,e.scope,void 0,e.options);const s=[];let l=!1;for(let e=1;e<t.length;e++){const i=t[e],n=Array.isArray(r)?r[e-1]:r.type,o=a.parse(i,1+s.length,n);if(!o){l=!0;break}s.push(o);}if(!l)if(Array.isArray(r)&&r.length!==s.length)a.error(`Expected ${r.length} arguments, but found ${s.length} instead.`);else {for(let t=0;t<s.length;t++){const e=Array.isArray(r)?r[t]:r.type,i=s[t];a.concat(t+1).checkSubtype(e,i.type);}if(0===a.errors.length)return new Di(i,n,o,s)}}if(1===s.length)e.errors.push(...a.errors);else {const i=(s.length?s:o).map((([t])=>{return e=t,Array.isArray(e)?`(${e.map(Ye).join(", ")})`:`(${Ye(e.type)}...)`;var e;})).join(" | "),r=[];for(let i=1;i<t.length;i++){const n=e.parse(t[i],1+r.length);if(!n)return null;r.push(Ye(n.type));}e.error(`Expected arguments of type ${i}, but found (${r.join(", ")}) instead.`);}return null}static register(t,e){Di.definitions=e;for(const i in e)t[i]=Di;}}var Pi=Di;class Ri{constructor(t,e,i){this.type=$e,this.locale=i,this.caseSensitive=t,this.diacriticSensitive=e;}static parse(t,e){if(2!==t.length)return e.error("Expected one argument.");const i=t[1];if("object"!=typeof i||Array.isArray(i))return e.error("Collator options argument must be an object.");const r=e.parse(void 0!==i["case-sensitive"]&&i["case-sensitive"],1,je);if(!r)return null;const n=e.parse(void 0!==i["diacritic-sensitive"]&&i["diacritic-sensitive"],1,je);if(!n)return null;let o=null;return i.locale&&(o=e.parse(i.locale,1,Ve),!o)?null:new Ri(r,n,o)}evaluate(t){return new ci(this.caseSensitive.evaluate(t),this.diacriticSensitive.evaluate(t),this.locale?this.locale.evaluate(t):null)}eachChild(t){t(this.caseSensitive),t(this.diacriticSensitive),this.locale&&t(this.locale);}outputDefined(){return !1}serialize(){const t={};return t["case-sensitive"]=this.caseSensitive.serialize(),t["diacritic-sensitive"]=this.diacriticSensitive.serialize(),this.locale&&(t.locale=this.locale.serialize()),["collator",t]}}var Li={exports:{}};Li.exports=function(){function t(i,r,n,o,s){for(;o>n;){if(o-n>600){var a=o-n+1,l=r-n+1,c=Math.log(a),h=.5*Math.exp(2*c/3),u=.5*Math.sqrt(c*h*(a-h)/a)*(l-a/2<0?-1:1);t(i,r,Math.max(n,Math.floor(r-l*h/a+u)),Math.min(o,Math.floor(r+(a-l)*h/a+u)),s);}var d=i[r],p=n,f=o;for(e(i,n,r),s(i[o],d)>0&&e(i,n,o);p<f;){for(e(i,p,f),p++,f--;s(i[p],d)<0;)p++;for(;s(i[f],d)>0;)f--;}0===s(i[n],d)?e(i,n,f):e(i,++f,o),f<=r&&(n=f+1),r<=f&&(o=f-1);}}function e(t,e,i){var r=t[e];t[e]=t[i],t[i]=r;}function i(t,e){return t<e?-1:t>e?1:0}return function(e,r,n,o,s){t(e,r,n||0,o||e.length-1,s||i);}}();var ki=d(Li.exports);function Bi(t){let e=0;for(let i,r,n=0,o=t.length,s=o-1;n<o;s=n++)i=t[n],r=t[s],e+=(r.x-i.x)*(i.y+r.y);return e}function Oi(t,e){t[0]=Math.min(t[0],e[0]),t[1]=Math.min(t[1],e[1]),t[2]=Math.max(t[2],e[0]),t[3]=Math.max(t[3],e[1]);}function Fi(t,e){return !(t[0]<=e[0]||t[2]>=e[2]||t[1]<=e[1]||t[3]>=e[3])}function Ni(t,e,i){const r=t[0]-e[0],n=t[1]-e[1],o=t[0]-i[0],s=t[1]-i[1];return r*s-o*n==0&&r*o<=0&&n*s<=0}function Ui(t,e,i=!1){let r=!1;for(let a=0,l=e.length;a<l;a++){const l=e[a];for(let e=0,a=l.length,c=a-1;e<a;c=e++){const a=l[c],h=l[e];if(Ni(t,a,h))return i;(o=a)[1]>(n=t)[1]!=(s=h)[1]>n[1]&&n[0]<(s[0]-o[0])*(n[1]-o[1])/(s[1]-o[1])+o[0]&&(r=!r);}}var n,o,s;return r}function Vi(t,e,i,r){const n=r[0]-i[0],o=r[1]-i[1],s=(t[0]-i[0])*o-n*(t[1]-i[1]),a=(e[0]-i[0])*o-n*(e[1]-i[1]);return s>0&&a<0||s<0&&a>0}function ji(t,e,i,r){return 0!=(n=[r[0]-i[0],r[1]-i[1]])[0]*(o=[e[0]-t[0],e[1]-t[1]])[1]-n[1]*o[0]&&!(!Vi(t,e,i,r)||!Vi(i,r,t,e));var n,o;}const Gi=8192;function qi(t,e){const i=(180+t[0])/360,r=(180-180/Math.PI*Math.log(Math.tan(Math.PI/4+t[1]*Math.PI/360)))/360,n=Math.pow(2,e.z);return [Math.round(i*n*Gi),Math.round(r*n*Gi)]}function Zi(t,e){for(let i=0;i<e.length;i++)if(Ui(t,e[i]))return !0;return !1}function $i(t,e,i){for(const r of i)for(let i=0,n=r.length,o=n-1;i<n;o=i++)if(ji(t,e,r[o],r[i]))return !0;return !1}function Hi(t,e){for(let i=0;i<t.length;++i)if(!Ui(t[i],e))return !1;for(let i=0;i<t.length-1;++i)if($i(t[i],t[i+1],e))return !1;return !0}function Wi(t,e){for(let i=0;i<e.length;i++)if(Hi(t,e[i]))return !0;return !1}function Xi(t,e,i){const r=[];for(let n=0;n<t.length;n++){const o=[];for(let r=0;r<t[n].length;r++){const s=qi(t[n][r],i);Oi(e,s),o.push(s);}r.push(o);}return r}function Yi(t,e,i){const r=[];for(let n=0;n<t.length;n++){const o=Xi(t[n],e,i);r.push(o);}return r}function Ki(t,e,i,r){if(t[0]<i[0]||t[0]>i[2]){const e=.5*r;let n=t[0]-i[0]>e?-r:i[0]-t[0]>e?r:0;0===n&&(n=t[0]-i[2]>e?-r:i[2]-t[0]>e?r:0),t[0]+=n;}Oi(e,t);}function Ji(t,e,i,r){const n=Math.pow(2,r.z)*Gi,o=[r.x*Gi,r.y*Gi],s=[];if(!t)return s;for(const r of t)for(const t of r){const r=[t.x+o[0],t.y+o[1]];Ki(r,e,i,n),s.push(r);}return s}function Qi(t,e,i,r){const n=Math.pow(2,r.z)*Gi,o=[r.x*Gi,r.y*Gi],s=[];if(!t)return s;for(const i of t){const t=[];for(const r of i){const i=[r.x+o[0],r.y+o[1]];Oi(e,i),t.push(i);}s.push(t);}if(e[2]-e[0]<=n/2){(a=e)[0]=a[1]=1/0,a[2]=a[3]=-1/0;for(const t of s)for(const r of t)Ki(r,e,i,n);}var a;return s}class tr{constructor(t,e){this.type=je,this.geojson=t,this.geometries=e;}static parse(t,e){if(2!==t.length)return e.error(`'within' expression requires exactly one argument, but found ${t.length-1} instead.`);if(fi(t[1])){const e=t[1];if("FeatureCollection"===e.type)for(let t=0;t<e.features.length;++t){const i=e.features[t].geometry.type;if("Polygon"===i||"MultiPolygon"===i)return new tr(e,e.features[t].geometry)}else if("Feature"===e.type){const t=e.geometry.type;if("Polygon"===t||"MultiPolygon"===t)return new tr(e,e.geometry)}else if("Polygon"===e.type||"MultiPolygon"===e.type)return new tr(e,e)}return e.error("'within' expression requires valid geojson object that contains polygon geometry type.")}evaluate(t){if(null!=t.geometry()&&null!=t.canonicalID()){if("Point"===t.geometryType())return function(t,e){const i=[1/0,1/0,-1/0,-1/0],r=[1/0,1/0,-1/0,-1/0],n=t.canonicalID();if(!n)return !1;if("Polygon"===e.type){const o=Xi(e.coordinates,r,n),s=Ji(t.geometry(),i,r,n);if(!Fi(i,r))return !1;for(const t of s)if(!Ui(t,o))return !1}if("MultiPolygon"===e.type){const o=Yi(e.coordinates,r,n),s=Ji(t.geometry(),i,r,n);if(!Fi(i,r))return !1;for(const t of s)if(!Zi(t,o))return !1}return !0}(t,this.geometries);if("LineString"===t.geometryType())return function(t,e){const i=[1/0,1/0,-1/0,-1/0],r=[1/0,1/0,-1/0,-1/0],n=t.canonicalID();if(!n)return !1;if("Polygon"===e.type){const o=Xi(e.coordinates,r,n),s=Qi(t.geometry(),i,r,n);if(!Fi(i,r))return !1;for(const t of s)if(!Hi(t,o))return !1}if("MultiPolygon"===e.type){const o=Yi(e.coordinates,r,n),s=Qi(t.geometry(),i,r,n);if(!Fi(i,r))return !1;for(const t of s)if(!Wi(t,o))return !1}return !0}(t,this.geometries)}return !1}eachChild(){}outputDefined(){return !0}serialize(){return ["within",this.geojson]}}var er=tr,ir={exports:{}};ir.exports=function(){var t={kilometers:1,miles:1e3/1609.344,nauticalmiles:1e3/1852,meters:1e3,metres:1e3,yards:1e3/.9144,feet:1e3/.3048,inches:1e3/.0254},e=1/298.257223563,i=e*(2-e),r=Math.PI/180,n=function(e,n){if(void 0===e)throw new Error("No latitude given.");if(n&&!t[n])throw new Error("Unknown unit "+n+". Use one of: "+Object.keys(t).join(", "));var o=6378.137*r*(n?t[n]:1),s=Math.cos(e*r),a=1/(1-i*(1-s*s)),l=Math.sqrt(a);this.kx=o*l*s,this.ky=o*l*a*(1-i);},o={units:{configurable:!0}};function s(t,e){return t[0]===e[0]&&t[1]===e[1]}function a(t,e,i){var r=l(e[0]-t[0]);return [t[0]+r*i,t[1]+(e[1]-t[1])*i]}function l(t){for(;t<-180;)t+=360;for(;t>180;)t-=360;return t}return n.fromTile=function(t,e,i){var o=Math.PI*(1-2*(t+.5)/Math.pow(2,e)),s=Math.atan(.5*(Math.exp(o)-Math.exp(-o)))/r;return new n(s,i)},o.units.get=function(){return t},n.prototype.distance=function(t,e){var i=l(t[0]-e[0])*this.kx,r=(t[1]-e[1])*this.ky;return Math.sqrt(i*i+r*r)},n.prototype.bearing=function(t,e){var i=l(e[0]-t[0])*this.kx;return Math.atan2(i,(e[1]-t[1])*this.ky)/r},n.prototype.destination=function(t,e,i){var n=i*r;return this.offset(t,Math.sin(n)*e,Math.cos(n)*e)},n.prototype.offset=function(t,e,i){return [t[0]+e/this.kx,t[1]+i/this.ky]},n.prototype.lineDistance=function(t){for(var e=0,i=0;i<t.length-1;i++)e+=this.distance(t[i],t[i+1]);return e},n.prototype.area=function(t){for(var e=0,i=0;i<t.length;i++)for(var r=t[i],n=0,o=r.length,s=o-1;n<o;s=n++)e+=l(r[n][0]-r[s][0])*(r[n][1]+r[s][1])*(i?-1:1);return Math.abs(e)/2*this.kx*this.ky},n.prototype.along=function(t,e){var i=0;if(e<=0)return t[0];for(var r=0;r<t.length-1;r++){var n=t[r],o=t[r+1],s=this.distance(n,o);if((i+=s)>e)return a(n,o,(e-(i-s))/s)}return t[t.length-1]},n.prototype.pointToSegmentDistance=function(t,e,i){var r=e[0],n=e[1],o=l(i[0]-r)*this.kx,s=(i[1]-n)*this.ky,a=0;return 0===o&&0===s||((a=(l(t[0]-r)*this.kx*o+(t[1]-n)*this.ky*s)/(o*o+s*s))>1?(r=i[0],n=i[1]):a>0&&(r+=o/this.kx*a,n+=s/this.ky*a)),o=l(t[0]-r)*this.kx,s=(t[1]-n)*this.ky,Math.sqrt(o*o+s*s)},n.prototype.pointOnLine=function(t,e){for(var i,r,n,o,s=1/0,a=0;a<t.length-1;a++){var c=t[a][0],h=t[a][1],u=l(t[a+1][0]-c)*this.kx,d=(t[a+1][1]-h)*this.ky,p=0;0===u&&0===d||((p=(l(e[0]-c)*this.kx*u+(e[1]-h)*this.ky*d)/(u*u+d*d))>1?(c=t[a+1][0],h=t[a+1][1]):p>0&&(c+=u/this.kx*p,h+=d/this.ky*p));var f=(u=l(e[0]-c)*this.kx)*u+(d=(e[1]-h)*this.ky)*d;f<s&&(s=f,i=c,r=h,n=a,o=p);}return {point:[i,r],index:n,t:Math.max(0,Math.min(1,o))}},n.prototype.lineSlice=function(t,e,i){var r=this.pointOnLine(i,t),n=this.pointOnLine(i,e);if(r.index>n.index||r.index===n.index&&r.t>n.t){var o=r;r=n,n=o;}var a=[r.point],l=r.index+1,c=n.index;!s(i[l],a[0])&&l<=c&&a.push(i[l]);for(var h=l+1;h<=c;h++)a.push(i[h]);return s(i[c],n.point)||a.push(n.point),a},n.prototype.lineSliceAlong=function(t,e,i){for(var r=0,n=[],o=0;o<i.length-1;o++){var s=i[o],l=i[o+1],c=this.distance(s,l);if((r+=c)>t&&0===n.length&&n.push(a(s,l,(t-(r-c))/c)),r>=e)return n.push(a(s,l,(e-(r-c))/c)),n;r>t&&n.push(l);}return n},n.prototype.bufferPoint=function(t,e){var i=e/this.ky,r=e/this.kx;return [t[0]-r,t[1]-i,t[0]+r,t[1]+i]},n.prototype.bufferBBox=function(t,e){var i=e/this.ky,r=e/this.kx;return [t[0]-r,t[1]-i,t[2]+r,t[3]+i]},n.prototype.insideBBox=function(t,e){return l(t[0]-e[0])>=0&&l(t[0]-e[2])<=0&&t[1]>=e[1]&&t[1]<=e[3]},Object.defineProperties(n,o),n}();var rr=d(ir.exports),nr={exports:{}};nr.exports=function(){var t=function(t,i){if(void 0===t&&(t=[]),void 0===i&&(i=e),this.data=t,this.length=this.data.length,this.compare=i,this.length>0)for(var r=(this.length>>1)-1;r>=0;r--)this._down(r);};function e(t,e){return t<e?-1:t>e?1:0}return t.prototype.push=function(t){this.data.push(t),this.length++,this._up(this.length-1);},t.prototype.pop=function(){if(0!==this.length){var t=this.data[0],e=this.data.pop();return this.length--,this.length>0&&(this.data[0]=e,this._down(0)),t}},t.prototype.peek=function(){return this.data[0]},t.prototype._up=function(t){for(var e=this.data,i=this.compare,r=e[t];t>0;){var n=t-1>>1,o=e[n];if(i(r,o)>=0)break;e[t]=o,t=n;}e[t]=r;},t.prototype._down=function(t){for(var e=this.data,i=this.compare,r=this.length>>1,n=e[t];t<r;){var o=1+(t<<1),s=e[o],a=o+1;if(a<this.length&&i(e[a],s)<0&&(o=a,s=e[a]),i(s,n)>=0)break;e[t]=s,t=o;}e[t]=n;},t}();var or=d(nr.exports),sr=8192;function ar(t,e){return e.dist-t.dist}const lr=100,cr=50;function hr(t){const e=[1/0,1/0,-1/0,-1/0];if(e.length!==t.length)return !1;for(let i=0;i<e.length;i++)if(e[i]!==t[i])return !1;return !0}function ur(t){return t[1]-t[0]+1}function dr(t,e){const i=t[1]>=t[0]&&t[1]<e;return i||console.warn("Distance Expression: Index is out of range"),i}function pr(t,e){if(t[0]>t[1])return [null,null];const i=ur(t);if(e){if(2===i)return [t,null];const e=Math.floor(i/2);return [[t[0],t[0]+e],[t[0]+e,t[1]]]}{if(1===i)return [t,null];const e=Math.floor(i/2)-1;return [[t[0],t[0]+e],[t[0]+e+1,t[1]]]}}function fr(t,e){const i=[1/0,1/0,-1/0,-1/0];if(!dr(e,t.length))return i;for(let r=e[0];r<=e[1];++r)Oi(i,t[r]);return i}function mr(t){const e=[1/0,1/0,-1/0,-1/0];for(let i=0;i<t.length;++i)for(let r=0;r<t[i].length;++r)Oi(e,t[i][r]);return e}function _r(t,e,i){if(hr(t)||hr(e))return NaN;let r=0,n=0;return t[2]<e[0]&&(r=e[0]-t[2]),t[0]>e[2]&&(r=t[0]-e[2]),t[1]>e[3]&&(n=t[1]-e[3]),t[3]<e[1]&&(n=e[1]-t[3]),i.distance([0,0],[r,n])}function gr(t,e){const i=Math.pow(2,e.z);return [(n=(t.x/sr+e.x)/i,360*n-180),(r=(t.y/sr+e.y)/i,360/Math.PI*Math.atan(Math.exp((180-360*r)*Math.PI/180))-90)];var r,n;}function yr(t,e){const i=[];for(let r=0;r<t.length;++r)i.push(gr(t[r],e));return i}function xr(t,e,i){const r=i.pointOnLine(e,t).point;return i.distance(t,r)}function vr(t,e,i,r,n){const o=i.slice(r[0],r[1]+1);let s=1/0;for(let i=e[0];i<=e[1];++i)if(0===(s=Math.min(s,xr(t[i],o,n))))return 0;return s}function br(t,e,i,r,n){const o=Math.min(n.pointToSegmentDistance(t,i,r),n.pointToSegmentDistance(e,i,r)),s=Math.min(n.pointToSegmentDistance(i,t,e),n.pointToSegmentDistance(r,t,e));return Math.min(o,s)}function wr(t,e,i,r,n){if(!dr(e,t.length)||!dr(r,i.length))return NaN;let o=1/0;for(let s=e[0];s<e[1];++s)for(let e=r[0];e<r[1];++e){if(ji(t[s],t[s+1],i[e],i[e+1]))return 0;o=Math.min(o,br(t[s],t[s+1],i[e],i[e+1],n));}return o}function Tr(t,e,i,r,n){if(!dr(e,t.length)||!dr(r,i.length))return NaN;let o=1/0;for(let s=e[0];s<=e[1];++s)for(let e=r[0];e<=r[1];++e)if(0===(o=Math.min(o,n.distance(t[s],i[e]))))return o;return o}function Er(t,e,i){if(Ui(t,e,!0))return 0;let r=1/0;for(const n of e){const e=n.length;if(e<2)return console.warn("Distance Expression: Invalid polygon!"),NaN;if(n[0]!==n[e-1]&&0===(r=Math.min(r,i.pointToSegmentDistance(t,n[e-1],n[0]))))return r;if(0===(r=Math.min(r,xr(t,n,i))))return r}return r}function Mr(t,e,i,r){if(!dr(e,t.length))return NaN;for(let r=e[0];r<=e[1];++r)if(Ui(t[r],i,!0))return 0;let n=1/0;for(let o=e[0];o<e[1];++o)for(const e of i)for(let i=0,s=e.length,a=s-1;i<s;a=i++){if(ji(t[o],t[o+1],e[a],e[i]))return 0;n=Math.min(n,br(t[o],t[o+1],e[a],e[i],r));}return n}function Ar(t,e){for(const i of t)for(let t=0;t<=i.length-1;++t)if(Ui(i[t],e,!0))return !0;return !1}function Sr(t,e,i,r=1/0){const n=mr(t),o=mr(e);if(r!==1/0&&_r(n,o,i)>=r)return r;if(Fi(n,o)){if(Ar(t,e))return 0}else if(Ar(e,t))return 0;let s=r;for(const r of t)for(let t=0,n=r.length,o=n-1;t<n;o=t++)for(const n of e)for(let e=0,a=n.length,l=a-1;e<a;l=e++){if(ji(r[o],r[t],n[l],n[e]))return 0;s=Math.min(s,br(r[o],r[t],n[l],n[e],i));}return s}function Ir(t,e,i,r,n,o,s){if(null===o||null===s)return;const a=_r(fr(r,o),fr(n,s),i);a<e&&t.push({dist:a,range1:o,range2:s});}function Cr(t,e,i,r,n=1/0){let o=Math.min(r.distance(t[0],i[0][0]),n);if(0===o)return o;const s=new or([{dist:0,range1:[0,t.length-1],range2:[0,0]}],ar),a=e?cr:lr,l=mr(i);for(;s.length;){const n=s.pop();if(n.dist>=o)continue;const c=n.range1;if(ur(c)<=a){if(!dr(c,t.length))return NaN;if(e){const e=Mr(t,c,i,r);if(0===(o=Math.min(o,e)))return o}else for(let e=c[0];e<=c[1];++e){const n=Er(t[e],i,r);if(0===(o=Math.min(o,n)))return o}}else {const i=pr(c,e);if(null!==i[0]){const e=_r(fr(t,i[0]),l,r);e<o&&s.push({dist:e,range1:i[0],range2:[0,0]});}if(null!==i[1]){const e=_r(fr(t,i[1]),l,r);e<o&&s.push({dist:e,range1:i[1],range2:[0,0]});}}}return o}function zr(t,e,i,r,n,o=1/0){let s=Math.min(o,n.distance(t[0],i[0]));if(0===s)return s;const a=new or([{dist:0,range1:[0,t.length-1],range2:[0,i.length-1]}],ar),l=e?cr:lr,c=r?cr:lr;for(;a.length;){const o=a.pop();if(o.dist>=s)continue;const h=o.range1,u=o.range2;if(ur(h)<=l&&ur(u)<=c){if(!dr(h,t.length)||!dr(u,i.length))return NaN;if(e&&r?s=Math.min(s,wr(t,h,i,u,n)):e||r?e&&!r?s=Math.min(s,vr(i,u,t,h,n)):!e&&r&&(s=Math.min(s,vr(t,h,i,u,n))):s=Math.min(s,Tr(t,h,i,u,n)),0===s)return s}else {const o=pr(h,e),l=pr(u,r);Ir(a,s,n,t,i,o[0],l[0]),Ir(a,s,n,t,i,o[0],l[1]),Ir(a,s,n,t,i,o[1],l[0]),Ir(a,s,n,t,i,o[1],l[1]);}}return s}function Dr(t,e,i,r,n=1/0){let o=n;const s=fr(t,[0,t.length-1]);for(const n of i)if(!(o!==1/0&&_r(s,fr(n,[0,n.length-1]),r)>=o)&&(o=Math.min(o,zr(t,e,n,!0,r,o)),0===o))return o;return o}function Pr(t,e,i,r,n=1/0){let o=n;const s=fr(t,[0,t.length-1]);for(const n of i){if(o!==1/0&&_r(s,mr(n),r)>=o)continue;const i=Cr(t,e,n,r,o);if(isNaN(i))return i;if(0===(o=Math.min(o,i)))return o}return o}function Rr(t){return "Point"===t||"MultiPoint"===t||"LineString"===t||"MultiLineString"===t||"Polygon"===t||"MultiPolygon"===t}class Lr{constructor(t,e){this.type=Ue,this.geojson=t,this.geometries=e;}static parse(t,e){if(2!==t.length)return e.error(`'distance' expression requires either one argument, but found ' ${t.length-1} instead.`);if(fi(t[1])){const e=t[1];if("FeatureCollection"===e.type){for(let t=0;t<e.features.length;++t)if(Rr(e.features[t].geometry.type))return new Lr(e,e.features[t].geometry)}else if("Feature"===e.type){if(Rr(e.geometry.type))return new Lr(e,e.geometry)}else if(Rr(e.type))return new Lr(e,e)}return e.error("'distance' expression needs to be an array with format ['Distance', GeoJSONObj].")}evaluate(t){const e=t.geometry(),i=t.canonicalID();if(null!=e&&null!=i){if("Point"===t.geometryType())return function(t,e,i){const r=[];for(const i of t)for(const t of i)r.push(gr(t,e));const n=new rr(r[0][1],"meters");return "Point"===i.type||"MultiPoint"===i.type||"LineString"===i.type?zr(r,!1,"Point"===i.type?[i.coordinates]:i.coordinates,"LineString"===i.type,n):"MultiLineString"===i.type?Dr(r,!1,i.coordinates,n):"Polygon"===i.type||"MultiPolygon"===i.type?Pr(r,!1,"Polygon"===i.type?[i.coordinates]:i.coordinates,n):null}(e,i,this.geometries);if("LineString"===t.geometryType())return function(t,e,i){const r=[];for(const i of t){const t=[];for(const r of i)t.push(gr(r,e));r.push(t);}const n=new rr(r[0][0][1],"meters");if("Point"===i.type||"MultiPoint"===i.type||"LineString"===i.type)return Dr("Point"===i.type?[i.coordinates]:i.coordinates,"LineString"===i.type,r,n);if("MultiLineString"===i.type){let t=1/0;for(let e=0;e<i.coordinates.length;e++){const o=Dr(i.coordinates[e],!0,r,n,t);if(isNaN(o))return o;if(0===(t=Math.min(t,o)))return t}return t}if("Polygon"===i.type||"MultiPolygon"===i.type){let t=1/0;for(let e=0;e<r.length;e++){const o=Pr(r[e],!0,"Polygon"===i.type?[i.coordinates]:i.coordinates,n,t);if(isNaN(o))return o;if(0===(t=Math.min(t,o)))return t}return t}return null}(e,i,this.geometries);if("Polygon"===t.geometryType())return function(t,e,i){const r=[];for(const i of function(t,e){const i=t.length;if(i<=1)return [t];const r=[];let n,o;for(let e=0;e<i;e++){const i=Bi(t[e]);0!==i&&(t[e].area=Math.abs(i),void 0===o&&(o=i<0),o===i<0?(n&&r.push(n),n=[t[e]]):n.push(t[e]));}return n&&r.push(n),r}(t)){const t=[];for(let r=0;r<i.length;++r)t.push(yr(i[r],e));r.push(t);}const n=new rr(r[0][0][0][1],"meters");if("Point"===i.type||"MultiPoint"===i.type||"LineString"===i.type)return Pr("Point"===i.type?[i.coordinates]:i.coordinates,"LineString"===i.type,r,n);if("MultiLineString"===i.type){let t=1/0;for(let e=0;e<i.coordinates.length;e++){const o=Pr(i.coordinates[e],!0,r,n,t);if(isNaN(o))return o;if(0===(t=Math.min(t,o)))return t}return t}return "Polygon"===i.type||"MultiPolygon"===i.type?function(t,e,i){let r=1/0;for(const n of t)for(const t of e){const e=Sr(n,t,i,r);if(isNaN(e))return e;if(0===(r=Math.min(r,e)))return r}return r}("Polygon"===i.type?[i.coordinates]:i.coordinates,r,n):null}(e,i,this.geometries);console.warn("Distance Expression: currently only evaluates valid Point/LineString/Polygon geometries.");}else console.warn("Distance Expression: requirs valid feature and canonical information.");return null}eachChild(){}outputDefined(){return !0}serialize(){return ["distance",this.geojson]}}var kr=Lr;function Br(t){if(t instanceof Pi){if("get"===t.name&&1===t.args.length)return !1;if("feature-state"===t.name)return !1;if("has"===t.name&&1===t.args.length)return !1;if("properties"===t.name||"geometry-type"===t.name||"id"===t.name)return !1;if(/^filter-/.test(t.name))return !1}if(t instanceof er)return !1;if(t instanceof kr)return !1;let e=!0;return t.eachChild((t=>{e&&!Br(t)&&(e=!1);})),e}function Or(t){if(t instanceof Pi&&"feature-state"===t.name)return !1;let e=!0;return t.eachChild((t=>{e&&!Or(t)&&(e=!1);})),e}function Fr(t){if(t instanceof Pi&&"config"===t.name)return !1;let e=!0;return t.eachChild((t=>{e&&!Fr(t)&&(e=!1);})),e}function Nr(t,e){if(t instanceof Pi&&e.indexOf(t.name)>=0)return !1;let i=!0;return t.eachChild((t=>{i&&!Nr(t,e)&&(i=!1);})),i}class Ur{constructor(t,e){this.type=e.type,this.name=t,this.boundExpression=e;}static parse(t,e){if(2!==t.length||"string"!=typeof t[1])return e.error("'var' expression requires exactly one string literal argument.");const i=t[1];return e.scope.has(i)?new Ur(i,e.scope.get(i)):e.error(`Unknown variable "${i}". Make sure "${i}" has been bound in an enclosing "let" expression before using it.`,1)}evaluate(t){return this.boundExpression.evaluate(t)}eachChild(){}outputDefined(){return !1}serialize(){return ["var",this.name]}}var Vr=Ur;class jr{constructor(t,e=[],i,r=new Fe,n=[],o){this.registry=t,this.path=e,this.key=e.map((t=>`[${t}]`)).join(""),this.scope=r,this.errors=n,this.expectedType=i,this.options=o;}parse(t,e,i,r,n={}){return e||i?this.concat(e,i,r)._parse(t,n):this._parse(t,n)}_parse(t,e){function i(t,e,i){return "assert"===i?new wi(e,[t]):"coerce"===i?new Ii(e,[t]):t}if(null!==t&&"string"!=typeof t&&"boolean"!=typeof t&&"number"!=typeof t||(t=["literal",t]),Array.isArray(t)){if(0===t.length)return this.error('Expected an array with at least one element. If you wanted a literal array, use ["literal", []].');const r="string"==typeof t[0]?this.registry[t[0]]:void 0;if(r){let n=r.parse(t,this);if(!n)return null;if(this.expectedType){const t=this.expectedType,r=n.type;if("string"!==t.kind&&"number"!==t.kind&&"boolean"!==t.kind&&"object"!==t.kind&&"array"!==t.kind||"value"!==r.kind)if("color"!==t.kind&&"formatted"!==t.kind&&"resolvedImage"!==t.kind||"value"!==r.kind&&"string"!==r.kind){if(this.checkSubtype(t,r))return null}else n=i(n,t,e.typeAnnotation||"coerce");else n=i(n,t,e.typeAnnotation||"assert");}if(!(n instanceof yi)&&"resolvedImage"!==n.type.kind&&qr(n)){const t=new zi(this.options);try{n=new yi(n.type,n.evaluate(t));}catch(t){return this.error(t.message),null}}return n}return Ii.parse(["to-array",t],this)}return this.error(void 0===t?"'undefined' value invalid. Use null instead.":"object"==typeof t?'Bare objects invalid. Use ["literal", {...}] instead.':`Expected an array, but found ${typeof t} instead.`)}concat(t,e,i){const r="number"==typeof t?this.path.concat(t):this.path,n=i?this.scope.concat(i):this.scope;return new jr(this.registry,r,e||null,n,this.errors,this.options)}error(t,...e){const i=`${this.key}${e.map((t=>`[${t}]`)).join("")}`;this.errors.push(new Be(i,t));}checkSubtype(t,e){const i=Je(t,e);return i&&this.error(i),i}}var Gr=jr;function qr(t){if(t instanceof Vr)return qr(t.boundExpression);if(t instanceof Pi&&"error"===t.name)return !1;if(t instanceof Pi&&"config"===t.name)return !1;if(t instanceof Ri)return !1;if(t instanceof er)return !1;if(t instanceof kr)return !1;const e=t instanceof Ii||t instanceof wi;let i=!0;return t.eachChild((t=>{i=e?i&&qr(t):i&&t instanceof yi;})),!!i&&Br(t)&&Nr(t,["zoom","heatmap-density","line-progress","raster-value","sky-radial-progress","accumulated","is-supported-script","pitch","distance-from-center","measure-light"])}function Zr(t,e){const i=t.length-1;let r,n,o=0,s=i,a=0;for(;o<=s;)if(a=Math.floor((o+s)/2),r=t[a],n=t[a+1],r<=e){if(a===i||e<n)return a;o=a+1;}else {if(!(r>e))throw new xi("Input is not a number.");s=a-1;}return 0}class $r{constructor(t,e,i){this.type=t,this.input=e,this.labels=[],this.outputs=[];for(const[t,e]of i)this.labels.push(t),this.outputs.push(e);}static parse(t,e){if(t.length-1<4)return e.error(`Expected at least 4 arguments, but found only ${t.length-1}.`);if((t.length-1)%2!=0)return e.error("Expected an even number of arguments.");const i=e.parse(t[1],1,Ue);if(!i)return null;const r=[];let n=null;e.expectedType&&"value"!==e.expectedType.kind&&(n=e.expectedType);for(let i=1;i<t.length;i+=2){const o=1===i?-1/0:t[i],s=t[i+1],a=i,l=i+1;if("number"!=typeof o)return e.error('Input/output pairs for "step" expressions must be defined using literal numeric values (not computed expressions) for the input values.',a);if(r.length&&r[r.length-1][0]>=o)return e.error('Input/output pairs for "step" expressions must be arranged with input values in strictly ascending order.',a);const c=e.parse(s,l,n);if(!c)return null;n=n||c.type,r.push([o,c]);}return new $r(n,i,r)}evaluate(t){const e=this.labels,i=this.outputs;if(1===e.length)return i[0].evaluate(t);const r=this.input.evaluate(t);if(r<=e[0])return i[0].evaluate(t);const n=e.length;return r>=e[n-1]?i[n-1].evaluate(t):i[Zr(e,r)].evaluate(t)}eachChild(t){t(this.input);for(const e of this.outputs)t(e);}outputDefined(){return this.outputs.every((t=>t.outputDefined()))}serialize(){const t=["step",this.input.serialize()];for(let e=0;e<this.labels.length;e++)e>0&&t.push(this.labels[e]),t.push(this.outputs[e].serialize());return t}}var Hr=$r;function Wr(t,e,i){return t*(1-i)+e*i}var Xr=Object.freeze({__proto__:null,array:function(t,e,i){return t.map(((t,r)=>Wr(t,e[r],i)))},color:function(t,e,i){return new li(Wr(t.r,e.r,i),Wr(t.g,e.g,i),Wr(t.b,e.b,i),Wr(t.a,e.a,i))},number:Wr});const Yr=.95047,Kr=1.08883,Jr=4/29,Qr=6/29,tn=3*Qr*Qr,en=Qr*Qr*Qr,rn=Math.PI/180,nn=180/Math.PI;function on(t){return t>en?Math.pow(t,1/3):t/tn+Jr}function sn(t){return t>Qr?t*t*t:tn*(t-Jr)}function an(t){return 255*(t<=.0031308?12.92*t:1.055*Math.pow(t,1/2.4)-.055)}function ln(t){return (t/=255)<=.04045?t/12.92:Math.pow((t+.055)/1.055,2.4)}function cn(t){const e=ln(t.r),i=ln(t.g),r=ln(t.b),n=on((.4124564*e+.3575761*i+.1804375*r)/Yr),o=on((.2126729*e+.7151522*i+.072175*r)/1);return {l:116*o-16,a:500*(n-o),b:200*(o-on((.0193339*e+.119192*i+.9503041*r)/Kr)),alpha:t.a}}function hn(t){let e=(t.l+16)/116,i=isNaN(t.a)?e:e+t.a/500,r=isNaN(t.b)?e:e-t.b/200;return e=1*sn(e),i=Yr*sn(i),r=Kr*sn(r),new li(an(3.2404542*i-1.5371385*e-.4985314*r),an(-.969266*i+1.8760108*e+.041556*r),an(.0556434*i-.2040259*e+1.0572252*r),t.alpha)}function un(t,e,i){const r=e-t;return t+i*(r>180||r<-180?r-360*Math.round(r/360):r)}const dn={forward:cn,reverse:hn,interpolate:function(t,e,i){return {l:Wr(t.l,e.l,i),a:Wr(t.a,e.a,i),b:Wr(t.b,e.b,i),alpha:Wr(t.alpha,e.alpha,i)}}},pn={forward:function(t){const{l:e,a:i,b:r}=cn(t),n=Math.atan2(r,i)*nn;return {h:n<0?n+360:n,c:Math.sqrt(i*i+r*r),l:e,alpha:t.a}},reverse:function(t){const e=t.h*rn,i=t.c;return hn({l:t.l,a:Math.cos(e)*i,b:Math.sin(e)*i,alpha:t.alpha})},interpolate:function(t,e,i){return {h:un(t.h,e.h,i),c:Wr(t.c,e.c,i),l:Wr(t.l,e.l,i),alpha:Wr(t.alpha,e.alpha,i)}}};var fn=Object.freeze({__proto__:null,hcl:pn,lab:dn});class mn{constructor(t,e,i,r,n){this.type=t,this.operator=e,this.interpolation=i,this.input=r,this.labels=[],this.outputs=[];for(const[t,e]of n)this.labels.push(t),this.outputs.push(e);}static interpolationFactor(t,e,i,r){let n=0;if("exponential"===t.name)n=_n(e,t.base,i,r);else if("linear"===t.name)n=_n(e,1,i,r);else if("cubic-bezier"===t.name){const o=t.controlPoints;n=new m(o[0],o[1],o[2],o[3]).solve(_n(e,1,i,r));}return n}static parse(t,e){let[i,r,n,...o]=t;if(!Array.isArray(r)||0===r.length)return e.error("Expected an interpolation type expression.",1);if("linear"===r[0])r={name:"linear"};else if("exponential"===r[0]){const t=r[1];if("number"!=typeof t)return e.error("Exponential interpolation requires a numeric base.",1,1);r={name:"exponential",base:t};}else {if("cubic-bezier"!==r[0])return e.error(`Unknown interpolation type ${String(r[0])}`,1,0);{const t=r.slice(1);if(4!==t.length||t.some((t=>"number"!=typeof t||t<0||t>1)))return e.error("Cubic bezier interpolation requires four numeric arguments with values between 0 and 1.",1);r={name:"cubic-bezier",controlPoints:t};}}if(t.length-1<4)return e.error(`Expected at least 4 arguments, but found only ${t.length-1}.`);if((t.length-1)%2!=0)return e.error("Expected an even number of arguments.");if(n=e.parse(n,2,Ue),!n)return null;const s=[];let a=null;"interpolate-hcl"===i||"interpolate-lab"===i?a=Ge:e.expectedType&&"value"!==e.expectedType.kind&&(a=e.expectedType);for(let t=0;t<o.length;t+=2){const i=o[t],r=o[t+1],n=t+3,l=t+4;if("number"!=typeof i)return e.error('Input/output pairs for "interpolate" expressions must be defined using literal numeric values (not computed expressions) for the input values.',n);if(s.length&&s[s.length-1][0]>=i)return e.error('Input/output pairs for "interpolate" expressions must be arranged with input values in strictly ascending order.',n);const c=e.parse(r,l,a);if(!c)return null;a=a||c.type,s.push([i,c]);}return "number"===a.kind||"color"===a.kind||"array"===a.kind&&"number"===a.itemType.kind&&"number"==typeof a.N?new mn(a,i,r,n,s):e.error(`Type ${Ye(a)} is not interpolatable.`)}evaluate(t){const e=this.labels,i=this.outputs;if(1===e.length)return i[0].evaluate(t);const r=this.input.evaluate(t);if(r<=e[0])return i[0].evaluate(t);const n=e.length;if(r>=e[n-1])return i[n-1].evaluate(t);const o=Zr(e,r),s=mn.interpolationFactor(this.interpolation,r,e[o],e[o+1]),a=i[o].evaluate(t),l=i[o+1].evaluate(t);return "interpolate"===this.operator?Xr[this.type.kind.toLowerCase()](a,l,s):"interpolate-hcl"===this.operator?pn.reverse(pn.interpolate(pn.forward(a),pn.forward(l),s)):dn.reverse(dn.interpolate(dn.forward(a),dn.forward(l),s))}eachChild(t){t(this.input);for(const e of this.outputs)t(e);}outputDefined(){return this.outputs.every((t=>t.outputDefined()))}serialize(){let t;t="linear"===this.interpolation.name?["linear"]:"exponential"===this.interpolation.name?1===this.interpolation.base?["linear"]:["exponential",this.interpolation.base]:["cubic-bezier"].concat(this.interpolation.controlPoints);const e=[this.operator,t,this.input.serialize()];for(let t=0;t<this.labels.length;t++)e.push(this.labels[t],this.outputs[t].serialize());return e}}function _n(t,e,i,r){const n=r-i,o=t-i;return 0===n?0:1===e?o/n:(Math.pow(e,o)-1)/(Math.pow(e,n)-1)}var gn=mn;class yn{constructor(t,e){this.type=t,this.args=e;}static parse(t,e){if(t.length<2)return e.error("Expectected at least one argument.");let i=null;const r=e.expectedType;r&&"value"!==r.kind&&(i=r);const n=[];for(const r of t.slice(1)){const t=e.parse(r,1+n.length,i,void 0,{typeAnnotation:"omit"});if(!t)return null;i=i||t.type,n.push(t);}const o=r&&n.some((t=>Je(r,t.type)));return new yn(o?Ze:i,n)}evaluate(t){let e,i=null,r=0;for(const n of this.args){if(r++,i=n.evaluate(t),i&&i instanceof di&&!i.available&&(e||(e=i),i=null,r===this.args.length))return e;if(null!==i)break}return i}eachChild(t){this.args.forEach(t);}outputDefined(){return this.args.every((t=>t.outputDefined()))}serialize(){const t=["coalesce"];return this.eachChild((e=>{t.push(e.serialize());})),t}}var xn=yn;class vn{constructor(t,e){this.type=e.type,this.bindings=[].concat(t),this.result=e;}evaluate(t){return this.result.evaluate(t)}eachChild(t){for(const e of this.bindings)t(e[1]);t(this.result);}static parse(t,e){if(t.length<4)return e.error(`Expected at least 3 arguments, but found ${t.length-1} instead.`);const i=[];for(let r=1;r<t.length-1;r+=2){const n=t[r];if("string"!=typeof n)return e.error(`Expected string, but found ${typeof n} instead.`,r);if(/[^a-zA-Z0-9_]/.test(n))return e.error("Variable names must contain only alphanumeric characters or '_'.",r);const o=e.parse(t[r+1],r+1);if(!o)return null;i.push([n,o]);}const r=e.parse(t[t.length-1],t.length-1,e.expectedType,i);return r?new vn(i,r):null}outputDefined(){return this.result.outputDefined()}serialize(){const t=["let"];for(const[e,i]of this.bindings)t.push(e,i.serialize());return t.push(this.result.serialize()),t}}var bn=vn;class wn{constructor(t,e,i){this.type=t,this.index=e,this.input=i;}static parse(t,e){if(3!==t.length)return e.error(`Expected 2 arguments, but found ${t.length-1} instead.`);const i=e.parse(t[1],1,Ue),r=e.parse(t[2],2,Xe(e.expectedType||Ze));return i&&r?new wn(r.type.itemType,i,r):null}evaluate(t){const e=this.index.evaluate(t),i=this.input.evaluate(t);if(e<0)throw new xi(`Array index out of bounds: ${e} < 0.`);if(e>=i.length)throw new xi(`Array index out of bounds: ${e} > ${i.length-1}.`);if(e!==Math.floor(e))throw new xi(`Array index must be an integer, but found ${e} instead.`);return i[e]}eachChild(t){t(this.index),t(this.input);}outputDefined(){return !1}serialize(){return ["at",this.index.serialize(),this.input.serialize()]}}var Tn=wn;class En{constructor(t,e){this.type=je,this.needle=t,this.haystack=e;}static parse(t,e){if(3!==t.length)return e.error(`Expected 2 arguments, but found ${t.length-1} instead.`);const i=e.parse(t[1],1,Ze),r=e.parse(t[2],2,Ze);return i&&r?Qe(i.type,[je,Ve,Ue,Ne,Ze])?new En(i,r):e.error(`Expected first argument to be of type boolean, string, number or null, but found ${Ye(i.type)} instead`):null}evaluate(t){const e=this.needle.evaluate(t),i=this.haystack.evaluate(t);if(null==i)return !1;if(!ti(e,["boolean","string","number","null"]))throw new xi(`Expected first argument to be of type boolean, string, number or null, but found ${Ye(mi(e))} instead.`);if(!ti(i,["string","array"]))throw new xi(`Expected second argument to be of type array or string, but found ${Ye(mi(i))} instead.`);return i.indexOf(e)>=0}eachChild(t){t(this.needle),t(this.haystack);}outputDefined(){return !0}serialize(){return ["in",this.needle.serialize(),this.haystack.serialize()]}}var Mn=En;class An{constructor(t,e,i){this.type=Ue,this.needle=t,this.haystack=e,this.fromIndex=i;}static parse(t,e){if(t.length<=2||t.length>=5)return e.error(`Expected 3 or 4 arguments, but found ${t.length-1} instead.`);const i=e.parse(t[1],1,Ze),r=e.parse(t[2],2,Ze);if(!i||!r)return null;if(!Qe(i.type,[je,Ve,Ue,Ne,Ze]))return e.error(`Expected first argument to be of type boolean, string, number or null, but found ${Ye(i.type)} instead`);if(4===t.length){const n=e.parse(t[3],3,Ue);return n?new An(i,r,n):null}return new An(i,r)}evaluate(t){const e=this.needle.evaluate(t),i=this.haystack.evaluate(t);if(!ti(e,["boolean","string","number","null"]))throw new xi(`Expected first argument to be of type boolean, string, number or null, but found ${Ye(mi(e))} instead.`);if(!ti(i,["string","array"]))throw new xi(`Expected second argument to be of type array or string, but found ${Ye(mi(i))} instead.`);if(this.fromIndex){const r=this.fromIndex.evaluate(t);return i.indexOf(e,r)}return i.indexOf(e)}eachChild(t){t(this.needle),t(this.haystack),this.fromIndex&&t(this.fromIndex);}outputDefined(){return !1}serialize(){if(null!=this.fromIndex&&void 0!==this.fromIndex){const t=this.fromIndex.serialize();return ["index-of",this.needle.serialize(),this.haystack.serialize(),t]}return ["index-of",this.needle.serialize(),this.haystack.serialize()]}}var Sn=An;class In{constructor(t,e,i,r,n,o){this.inputType=t,this.type=e,this.input=i,this.cases=r,this.outputs=n,this.otherwise=o;}static parse(t,e){if(t.length<5)return e.error(`Expected at least 4 arguments, but found only ${t.length-1}.`);if(t.length%2!=1)return e.error("Expected an even number of arguments.");let i,r;e.expectedType&&"value"!==e.expectedType.kind&&(r=e.expectedType);const n={},o=[];for(let s=2;s<t.length-1;s+=2){let a=t[s];const l=t[s+1];Array.isArray(a)||(a=[a]);const c=e.concat(s);if(0===a.length)return c.error("Expected at least one branch label.");for(const t of a){if("number"!=typeof t&&"string"!=typeof t)return c.error("Branch labels must be numbers or strings.");if("number"==typeof t&&Math.abs(t)>Number.MAX_SAFE_INTEGER)return c.error(`Branch labels must be integers no larger than ${Number.MAX_SAFE_INTEGER}.`);if("number"==typeof t&&Math.floor(t)!==t)return c.error("Numeric branch labels must be integer values.");if(i){if(c.checkSubtype(i,mi(t)))return null}else i=mi(t);if(void 0!==n[String(t)])return c.error("Branch labels must be unique.");n[String(t)]=o.length;}const h=e.parse(l,s,r);if(!h)return null;r=r||h.type,o.push(h);}const s=e.parse(t[1],1,Ze);if(!s)return null;const a=e.parse(t[t.length-1],t.length-1,r);return a?"value"!==s.type.kind&&e.concat(1).checkSubtype(i,s.type)?null:new In(i,r,s,n,o,a):null}evaluate(t){const e=this.input.evaluate(t);return (mi(e)===this.inputType&&this.outputs[this.cases[e]]||this.otherwise).evaluate(t)}eachChild(t){t(this.input),this.outputs.forEach(t),t(this.otherwise);}outputDefined(){return this.outputs.every((t=>t.outputDefined()))&&this.otherwise.outputDefined()}serialize(){const t=["match",this.input.serialize()],e=Object.keys(this.cases).sort(),i=[],r={};for(const t of e){const e=r[this.cases[t]];void 0===e?(r[this.cases[t]]=i.length,i.push([this.cases[t],[t]])):i[e][1].push(t);}const n=t=>"number"===this.inputType.kind?Number(t):t;for(const[e,r]of i)t.push(1===r.length?n(r[0]):r.map(n)),t.push(this.outputs[e].serialize());return t.push(this.otherwise.serialize()),t}}var Cn=In;class zn{constructor(t,e,i){this.type=t,this.branches=e,this.otherwise=i;}static parse(t,e){if(t.length<4)return e.error(`Expected at least 3 arguments, but found only ${t.length-1}.`);if(t.length%2!=0)return e.error("Expected an odd number of arguments.");let i;e.expectedType&&"value"!==e.expectedType.kind&&(i=e.expectedType);const r=[];for(let n=1;n<t.length-1;n+=2){const o=e.parse(t[n],n,je);if(!o)return null;const s=e.parse(t[n+1],n+1,i);if(!s)return null;r.push([o,s]),i=i||s.type;}const n=e.parse(t[t.length-1],t.length-1,i);return n?new zn(i,r,n):null}evaluate(t){for(const[e,i]of this.branches)if(e.evaluate(t))return i.evaluate(t);return this.otherwise.evaluate(t)}eachChild(t){for(const[e,i]of this.branches)t(e),t(i);t(this.otherwise);}outputDefined(){return this.branches.every((([t,e])=>e.outputDefined()))&&this.otherwise.outputDefined()}serialize(){const t=["case"];return this.eachChild((e=>{t.push(e.serialize());})),t}}var Dn=zn;class Pn{constructor(t,e,i,r){this.type=t,this.input=e,this.beginIndex=i,this.endIndex=r;}static parse(t,e){if(t.length<=2||t.length>=5)return e.error(`Expected 3 or 4 arguments, but found ${t.length-1} instead.`);const i=e.parse(t[1],1,Ze),r=e.parse(t[2],2,Ue);if(!i||!r)return null;if(!Qe(i.type,[Xe(Ze),Ve,Ze]))return e.error(`Expected first argument to be of type array or string, but found ${Ye(i.type)} instead`);if(4===t.length){const n=e.parse(t[3],3,Ue);return n?new Pn(i.type,i,r,n):null}return new Pn(i.type,i,r)}evaluate(t){const e=this.input.evaluate(t),i=this.beginIndex.evaluate(t);if(!ti(e,["string","array"]))throw new xi(`Expected first argument to be of type array or string, but found ${Ye(mi(e))} instead.`);if(this.endIndex){const r=this.endIndex.evaluate(t);return e.slice(i,r)}return e.slice(i)}eachChild(t){t(this.input),t(this.beginIndex),this.endIndex&&t(this.endIndex);}outputDefined(){return !1}serialize(){if(null!=this.endIndex&&void 0!==this.endIndex){const t=this.endIndex.serialize();return ["slice",this.input.serialize(),this.beginIndex.serialize(),t]}return ["slice",this.input.serialize(),this.beginIndex.serialize()]}}var Rn=Pn;function Ln(t,e){return "=="===t||"!="===t?"boolean"===e.kind||"string"===e.kind||"number"===e.kind||"null"===e.kind||"value"===e.kind:"string"===e.kind||"number"===e.kind||"value"===e.kind}function kn(t,e,i,r){return 0===r.compare(e,i)}function Bn(t,e,i){const r="=="!==t&&"!="!==t;return class n{constructor(t,e,i){this.type=je,this.lhs=t,this.rhs=e,this.collator=i,this.hasUntypedArgument="value"===t.type.kind||"value"===e.type.kind;}static parse(t,e){if(3!==t.length&&4!==t.length)return e.error("Expected two or three arguments.");const i=t[0];let o=e.parse(t[1],1,Ze);if(!o)return null;if(!Ln(i,o.type))return e.concat(1).error(`"${i}" comparisons are not supported for type '${Ye(o.type)}'.`);let s=e.parse(t[2],2,Ze);if(!s)return null;if(!Ln(i,s.type))return e.concat(2).error(`"${i}" comparisons are not supported for type '${Ye(s.type)}'.`);if(o.type.kind!==s.type.kind&&"value"!==o.type.kind&&"value"!==s.type.kind)return e.error(`Cannot compare types '${Ye(o.type)}' and '${Ye(s.type)}'.`);r&&("value"===o.type.kind&&"value"!==s.type.kind?o=new wi(s.type,[o]):"value"!==o.type.kind&&"value"===s.type.kind&&(s=new wi(o.type,[s])));let a=null;if(4===t.length){if("string"!==o.type.kind&&"string"!==s.type.kind&&"value"!==o.type.kind&&"value"!==s.type.kind)return e.error("Cannot use collator to compare non-string types.");if(a=e.parse(t[3],3,$e),!a)return null}return new n(o,s,a)}evaluate(n){const o=this.lhs.evaluate(n),s=this.rhs.evaluate(n);if(r&&this.hasUntypedArgument){const e=mi(o),i=mi(s);if(e.kind!==i.kind||"string"!==e.kind&&"number"!==e.kind)throw new xi(`Expected arguments for "${t}" to be (string, string) or (number, number), but found (${e.kind}, ${i.kind}) instead.`)}if(this.collator&&!r&&this.hasUntypedArgument){const t=mi(o),i=mi(s);if("string"!==t.kind||"string"!==i.kind)return e(n,o,s)}return this.collator?i(n,o,s,this.collator.evaluate(n)):e(n,o,s)}eachChild(t){t(this.lhs),t(this.rhs),this.collator&&t(this.collator);}outputDefined(){return !0}serialize(){const e=[t];return this.eachChild((t=>{e.push(t.serialize());})),e}}}const On=Bn("==",(function(t,e,i){return e===i}),kn),Fn=Bn("!=",(function(t,e,i){return e!==i}),(function(t,e,i,r){return !kn(0,e,i,r)})),Nn=Bn("<",(function(t,e,i){return e<i}),(function(t,e,i,r){return r.compare(e,i)<0})),Un=Bn(">",(function(t,e,i){return e>i}),(function(t,e,i,r){return r.compare(e,i)>0})),Vn=Bn("<=",(function(t,e,i){return e<=i}),(function(t,e,i,r){return r.compare(e,i)<=0})),jn=Bn(">=",(function(t,e,i){return e>=i}),(function(t,e,i,r){return r.compare(e,i)>=0}));class Gn{constructor(t,e,i,r,n,o){this.type=Ve,this.number=t,this.locale=e,this.currency=i,this.unit=r,this.minFractionDigits=n,this.maxFractionDigits=o;}static parse(t,e){if(3!==t.length)return e.error("Expected two arguments.");const i=e.parse(t[1],1,Ue);if(!i)return null;const r=t[2];if("object"!=typeof r||Array.isArray(r))return e.error("NumberFormat options argument must be an object.");let n=null;if(r.locale&&(n=e.parse(r.locale,1,Ve),!n))return null;let o=null;if(r.currency&&(o=e.parse(r.currency,1,Ve),!o))return null;let s=null;if(r.unit&&(s=e.parse(r.unit,1,Ve),!s))return null;let a=null;if(r["min-fraction-digits"]&&(a=e.parse(r["min-fraction-digits"],1,Ue),!a))return null;let l=null;return r["max-fraction-digits"]&&(l=e.parse(r["max-fraction-digits"],1,Ue),!l)?null:new Gn(i,n,o,s,a,l)}evaluate(t){return new Intl.NumberFormat(this.locale?this.locale.evaluate(t):[],{style:(this.currency?"currency":this.unit&&"unit")||"decimal",currency:this.currency?this.currency.evaluate(t):void 0,unit:this.unit?this.unit.evaluate(t):void 0,minimumFractionDigits:this.minFractionDigits?this.minFractionDigits.evaluate(t):void 0,maximumFractionDigits:this.maxFractionDigits?this.maxFractionDigits.evaluate(t):void 0}).format(this.number.evaluate(t))}eachChild(t){t(this.number),this.locale&&t(this.locale),this.currency&&t(this.currency),this.unit&&t(this.unit),this.minFractionDigits&&t(this.minFractionDigits),this.maxFractionDigits&&t(this.maxFractionDigits);}outputDefined(){return !1}serialize(){const t={};return this.locale&&(t.locale=this.locale.serialize()),this.currency&&(t.currency=this.currency.serialize()),this.unit&&(t.unit=this.unit.serialize()),this.minFractionDigits&&(t["min-fraction-digits"]=this.minFractionDigits.serialize()),this.maxFractionDigits&&(t["max-fraction-digits"]=this.maxFractionDigits.serialize()),["number-format",this.number.serialize(),t]}}class qn{constructor(t){this.type=Ue,this.input=t;}static parse(t,e){if(2!==t.length)return e.error(`Expected 1 argument, but found ${t.length-1} instead.`);const i=e.parse(t[1],1);return i?"array"!==i.type.kind&&"string"!==i.type.kind&&"value"!==i.type.kind?e.error(`Expected argument of type string or array, but found ${Ye(i.type)} instead.`):new qn(i):null}evaluate(t){const e=this.input.evaluate(t);if("string"==typeof e)return e.length;if(Array.isArray(e))return e.length;throw new xi(`Expected value to be of type string or array, but found ${Ye(mi(e))} instead.`)}eachChild(t){t(this.input);}outputDefined(){return !1}serialize(){const t=["length"];return this.eachChild((e=>{t.push(e.serialize());})),t}}function Zn(t){return function(){t=1831565813+(t|=0)|0;let e=Math.imul(t^t>>>15,1|t);return e=e+Math.imul(e^e>>>7,61|e)^e,((e^e>>>14)>>>0)/4294967296}}const $n={"==":On,"!=":Fn,">":Un,"<":Nn,">=":jn,"<=":Vn,array:wi,at:Tn,boolean:wi,case:Dn,coalesce:xn,collator:Ri,format:Ti,image:Ei,in:Mn,"index-of":Sn,interpolate:gn,"interpolate-hcl":gn,"interpolate-lab":gn,length:qn,let:bn,literal:yi,match:Cn,number:wi,"number-format":Gn,object:wi,slice:Rn,step:Hr,string:wi,"to-boolean":Ii,"to-color":Ii,"to-number":Ii,"to-string":Ii,var:Vr,within:er,distance:kr};function Hn(t,[e,i,r,n]){e=e.evaluate(t),i=i.evaluate(t),r=r.evaluate(t);const o=n?n.evaluate(t):1,s=pi(e,i,r,o);if(s)throw new xi(s);return new li(e/255*o,i/255*o,r/255*o,o)}function Wn(t,[e,i,r,n]){e=e.evaluate(t),i=i.evaluate(t),r=r.evaluate(t);const o=n?n.evaluate(t):1,s=function(t,e,i,r){return "number"==typeof t&&t>=0&&t<=360?"number"==typeof e&&e>=0&&e<=100&&"number"==typeof i&&i>=0&&i<=100?void 0===r||"number"==typeof r&&r>=0&&r<=1?null:`Invalid hsla value [${[t,e,i,r].join(", ")}]: 'a' must be between 0 and 1.`:`Invalid hsla value [${("number"==typeof r?[t,e,i,r]:[t,e,i]).join(", ")}]: 's', and 'l' must be between 0 and 100.`:`Invalid hsla value [${("number"==typeof r?[t,e,i,r]:[t,e,i]).join(", ")}]: 'h' must be between 0 and 360.`}(e,i,r,o);if(s)throw new xi(s);const a=`hsla(${e}, ${i}%, ${r}%, ${o})`,l=li.parse(a);if(!l)throw new xi(`Failed to parse HSLA color: ${a}`);return l}function Xn(t,e){return t in e}function Yn(t,e){const i=e[t];return void 0===i?null:i}function Kn(t,e,i){i.length&&(e+=`${i}`);const r=t.getConfig(e);return r?r.evaluate(t):null}function Jn(t){return {type:t}}Pi.register($n,{error:[{kind:"error"},[Ve],(t,[e])=>{throw new xi(e.evaluate(t))}],typeof:[Ve,[Ze],(t,[e])=>Ye(mi(e.evaluate(t)))],"to-rgba":[Xe(Ue,4),[Ge],(t,[e])=>e.evaluate(t).toArray()],rgb:[Ge,[Ue,Ue,Ue],Hn],rgba:[Ge,[Ue,Ue,Ue,Ue],Hn],hsl:[Ge,[Ue,Ue,Ue],Wn],hsla:[Ge,[Ue,Ue,Ue,Ue],Wn],has:{type:je,overloads:[[[Ve],(t,[e])=>Xn(e.evaluate(t),t.properties())],[[Ve,qe],(t,[e,i])=>Xn(e.evaluate(t),i.evaluate(t))]]},get:{type:Ze,overloads:[[[Ve],(t,[e])=>Yn(e.evaluate(t),t.properties())],[[Ve,qe],(t,[e,i])=>Yn(e.evaluate(t),i.evaluate(t))]]},config:{type:Ze,overloads:[[[Ve],(t,[e])=>Kn(t,e.evaluate(t),"")],[[Ve,Ve],(t,[e,i])=>Kn(t,e.evaluate(t),i.evaluate(t))]]},"feature-state":[Ze,[Ve],(t,[e])=>Yn(e.evaluate(t),t.featureState||{})],properties:[qe,[],t=>t.properties()],"geometry-type":[Ve,[],t=>t.geometryType()],id:[Ze,[],t=>t.id()],zoom:[Ue,[],t=>t.globals.zoom],pitch:[Ue,[],t=>t.globals.pitch||0],"distance-from-center":[Ue,[],t=>t.distanceFromCenter()],"measure-light":[Ue,[Ve],(t,[e])=>t.measureLight(e.evaluate(t))],"heatmap-density":[Ue,[],t=>t.globals.heatmapDensity||0],"line-progress":[Ue,[],t=>t.globals.lineProgress||0],"raster-value":[Ue,[],t=>t.globals.rasterValue||0],"sky-radial-progress":[Ue,[],t=>t.globals.skyRadialProgress||0],accumulated:[Ze,[],t=>void 0===t.globals.accumulated?null:t.globals.accumulated],"+":[Ue,Jn(Ue),(t,e)=>{let i=0;for(const r of e)i+=r.evaluate(t);return i}],"*":[Ue,Jn(Ue),(t,e)=>{let i=1;for(const r of e)i*=r.evaluate(t);return i}],"-":{type:Ue,overloads:[[[Ue,Ue],(t,[e,i])=>e.evaluate(t)-i.evaluate(t)],[[Ue],(t,[e])=>-e.evaluate(t)]]},"/":[Ue,[Ue,Ue],(t,[e,i])=>e.evaluate(t)/i.evaluate(t)],"%":[Ue,[Ue,Ue],(t,[e,i])=>e.evaluate(t)%i.evaluate(t)],ln2:[Ue,[],()=>Math.LN2],pi:[Ue,[],()=>Math.PI],e:[Ue,[],()=>Math.E],"^":[Ue,[Ue,Ue],(t,[e,i])=>Math.pow(e.evaluate(t),i.evaluate(t))],sqrt:[Ue,[Ue],(t,[e])=>Math.sqrt(e.evaluate(t))],log10:[Ue,[Ue],(t,[e])=>Math.log(e.evaluate(t))/Math.LN10],ln:[Ue,[Ue],(t,[e])=>Math.log(e.evaluate(t))],log2:[Ue,[Ue],(t,[e])=>Math.log(e.evaluate(t))/Math.LN2],sin:[Ue,[Ue],(t,[e])=>Math.sin(e.evaluate(t))],cos:[Ue,[Ue],(t,[e])=>Math.cos(e.evaluate(t))],tan:[Ue,[Ue],(t,[e])=>Math.tan(e.evaluate(t))],asin:[Ue,[Ue],(t,[e])=>Math.asin(e.evaluate(t))],acos:[Ue,[Ue],(t,[e])=>Math.acos(e.evaluate(t))],atan:[Ue,[Ue],(t,[e])=>Math.atan(e.evaluate(t))],min:[Ue,Jn(Ue),(t,e)=>Math.min(...e.map((e=>e.evaluate(t))))],max:[Ue,Jn(Ue),(t,e)=>Math.max(...e.map((e=>e.evaluate(t))))],abs:[Ue,[Ue],(t,[e])=>Math.abs(e.evaluate(t))],round:[Ue,[Ue],(t,[e])=>{const i=e.evaluate(t);return i<0?-Math.round(-i):Math.round(i)}],floor:[Ue,[Ue],(t,[e])=>Math.floor(e.evaluate(t))],ceil:[Ue,[Ue],(t,[e])=>Math.ceil(e.evaluate(t))],"filter-==":[je,[Ve,Ze],(t,[e,i])=>t.properties()[e.value]===i.value],"filter-id-==":[je,[Ze],(t,[e])=>t.id()===e.value],"filter-type-==":[je,[Ve],(t,[e])=>t.geometryType()===e.value],"filter-<":[je,[Ve,Ze],(t,[e,i])=>{const r=t.properties()[e.value],n=i.value;return typeof r==typeof n&&r<n}],"filter-id-<":[je,[Ze],(t,[e])=>{const i=t.id(),r=e.value;return typeof i==typeof r&&i<r}],"filter->":[je,[Ve,Ze],(t,[e,i])=>{const r=t.properties()[e.value],n=i.value;return typeof r==typeof n&&r>n}],"filter-id->":[je,[Ze],(t,[e])=>{const i=t.id(),r=e.value;return typeof i==typeof r&&i>r}],"filter-<=":[je,[Ve,Ze],(t,[e,i])=>{const r=t.properties()[e.value],n=i.value;return typeof r==typeof n&&r<=n}],"filter-id-<=":[je,[Ze],(t,[e])=>{const i=t.id(),r=e.value;return typeof i==typeof r&&i<=r}],"filter->=":[je,[Ve,Ze],(t,[e,i])=>{const r=t.properties()[e.value],n=i.value;return typeof r==typeof n&&r>=n}],"filter-id->=":[je,[Ze],(t,[e])=>{const i=t.id(),r=e.value;return typeof i==typeof r&&i>=r}],"filter-has":[je,[Ze],(t,[e])=>e.value in t.properties()],"filter-has-id":[je,[],t=>null!==t.id()&&void 0!==t.id()],"filter-type-in":[je,[Xe(Ve)],(t,[e])=>e.value.indexOf(t.geometryType())>=0],"filter-id-in":[je,[Xe(Ze)],(t,[e])=>e.value.indexOf(t.id())>=0],"filter-in-small":[je,[Ve,Xe(Ze)],(t,[e,i])=>i.value.indexOf(t.properties()[e.value])>=0],"filter-in-large":[je,[Ve,Xe(Ze)],(t,[e,i])=>function(t,e,i,r){for(;i<=r;){const n=i+r>>1;if(e[n]===t)return !0;e[n]>t?r=n-1:i=n+1;}return !1}(t.properties()[e.value],i.value,0,i.value.length-1)],all:{type:je,overloads:[[[je,je],(t,[e,i])=>e.evaluate(t)&&i.evaluate(t)],[Jn(je),(t,e)=>{for(const i of e)if(!i.evaluate(t))return !1;return !0}]]},any:{type:je,overloads:[[[je,je],(t,[e,i])=>e.evaluate(t)||i.evaluate(t)],[Jn(je),(t,e)=>{for(const i of e)if(i.evaluate(t))return !0;return !1}]]},"!":[je,[je],(t,[e])=>!e.evaluate(t)],"is-supported-script":[je,[Ve],(t,[e])=>{const i=t.globals&&t.globals.isSupportedScript;return !i||i(e.evaluate(t))}],upcase:[Ve,[Ve],(t,[e])=>e.evaluate(t).toUpperCase()],downcase:[Ve,[Ve],(t,[e])=>e.evaluate(t).toLowerCase()],concat:[Ve,Jn(Ze),(t,e)=>e.map((e=>_i(e.evaluate(t)))).join("")],"resolved-locale":[Ve,[$e],(t,[e])=>e.evaluate(t).resolvedLocale()],random:[Ue,[Ue,Ue,Ze],(t,e)=>{const[i,r,n]=e.map((e=>e.evaluate(t)));if(i>r)return i;if(i===r)return i;let o;if("string"==typeof n)o=function(t){let e=0;if(0===t.length)return e;for(let i=0;i<t.length;i++)e=(e<<5)-e+t.charCodeAt(i),e&=e;return e}(n);else {if("number"!=typeof n)throw new xi(`Invalid seed input: ${n}`);o=n;}return i+Zn(o)()*(r-i)}]});var Qn=$n;function to(t){return {result:"success",value:t}}function eo(t){return {result:"error",value:t}}function io(t,e){return !!t&&!!t.parameters&&t.parameters.indexOf(e)>-1}function ro(t){return "data-driven"===t["property-type"]}function no(t){return io(t.expression,"measure-light")}function oo(t){return io(t.expression,"zoom")}function so(t){return !!t.expression&&t.expression.interpolated}function ao(t){return "object"==typeof t&&null!==t&&!Array.isArray(t)}function lo(t){return t}function co(t,e){const i="color"===e.type,r=t.stops&&"object"==typeof t.stops[0][0],n=r||!(r||void 0!==t.property),o=t.type||(so(e)?"exponential":"interval");if(i&&((t=De({},t)).stops&&(t.stops=t.stops.map((t=>[t[0],li.parse(t[1])]))),t.default=li.parse(t.default?t.default:e.default)),t.colorSpace&&"rgb"!==t.colorSpace&&!fn[t.colorSpace])throw new Error(`Unknown color space: ${t.colorSpace}`);let s,a,l;if("exponential"===o)s=fo;else if("interval"===o)s=po;else if("categorical"===o){s=uo,a=Object.create(null);for(const e of t.stops)a[e[0]]=e[1];l=typeof t.stops[0][0];}else {if("identity"!==o)throw new Error(`Unknown function type "${o}"`);s=mo;}if(r){const i={},r=[];for(let e=0;e<t.stops.length;e++){const n=t.stops[e],o=n[0].zoom;void 0===i[o]&&(i[o]={zoom:o,type:t.type,property:t.property,default:t.default,stops:[]},r.push(o)),i[o].stops.push([n[0].value,n[1]]);}const n=[];for(const t of r)n.push([i[t].zoom,co(i[t],e)]);const o={name:"linear"};return {kind:"composite",interpolationType:o,interpolationFactor:gn.interpolationFactor.bind(void 0,o),zoomStops:n.map((t=>t[0])),evaluate:({zoom:i},r)=>fo({stops:n,base:t.base},e,i).evaluate(i,r)}}if(n){const i="exponential"===o?{name:"exponential",base:void 0!==t.base?t.base:1}:null;return {kind:"camera",interpolationType:i,interpolationFactor:gn.interpolationFactor.bind(void 0,i),zoomStops:t.stops.map((t=>t[0])),evaluate:({zoom:i})=>s(t,e,i,a,l)}}return {kind:"source",evaluate(i,r){const n=r&&r.properties?r.properties[t.property]:void 0;return void 0===n?ho(t.default,e.default):s(t,e,n,a,l)}}}function ho(t,e,i){return void 0!==t?t:void 0!==e?e:void 0!==i?i:void 0}function uo(t,e,i,r,n){return ho(typeof i===n?r[i]:void 0,t.default,e.default)}function po(t,e,i){if("number"!==Mi(i))return ho(t.default,e.default);const r=t.stops.length;if(1===r)return t.stops[0][1];if(i<=t.stops[0][0])return t.stops[0][1];if(i>=t.stops[r-1][0])return t.stops[r-1][1];const n=Zr(t.stops.map((t=>t[0])),i);return t.stops[n][1]}function fo(t,e,i){const r=void 0!==t.base?t.base:1;if("number"!==Mi(i))return ho(t.default,e.default);const n=t.stops.length;if(1===n)return t.stops[0][1];if(i<=t.stops[0][0])return t.stops[0][1];if(i>=t.stops[n-1][0])return t.stops[n-1][1];const o=Zr(t.stops.map((t=>t[0])),i),s=function(t,e,i,r){const n=r-i,o=t-i;return 0===n?0:1===e?o/n:(Math.pow(e,o)-1)/(Math.pow(e,n)-1)}(i,r,t.stops[o][0],t.stops[o+1][0]),a=t.stops[o][1],l=t.stops[o+1][1];let c=Xr[e.type]||lo;if(t.colorSpace&&"rgb"!==t.colorSpace){const e=fn[t.colorSpace];c=(t,i)=>e.reverse(e.interpolate(e.forward(t),e.forward(i),s));}return "function"==typeof a.evaluate?{evaluate(...t){const e=a.evaluate.apply(void 0,t),i=l.evaluate.apply(void 0,t);if(void 0!==e&&void 0!==i)return c(e,i,s)}}:c(a,l,s)}function mo(t,e,i){return "color"===e.type?i=li.parse(i):"formatted"===e.type?i=ui.fromString(i.toString()):"resolvedImage"===e.type?i=di.fromString(i.toString()):Mi(i)===e.type||"enum"===e.type&&e.values[i]||(i=void 0),ho(i,t.default,e.default)}class _o{constructor(t,e,i){this.expression=t,this._warningHistory={},this._evaluator=new zi(i),this._defaultValue=e?function(t){return "color"===t.type&&(ao(t.default)||Array.isArray(t.default))?new li(0,0,0,0):"color"===t.type?li.parse(t.default)||null:void 0===t.default?null:t.default}(e):null,this._enumValues=e&&"enum"===e.type?e.values:null;}evaluateWithoutErrorHandling(t,e,i,r,n,o,s,a){return this._evaluator.globals=t,this._evaluator.feature=e,this._evaluator.featureState=i,this._evaluator.canonical=r||null,this._evaluator.availableImages=n||null,this._evaluator.formattedSection=o,this._evaluator.featureTileCoord=s||null,this._evaluator.featureDistanceData=a||null,this.expression.evaluate(this._evaluator)}evaluate(t,e,i,r,n,o,s,a){this._evaluator.globals=t,this._evaluator.feature=e||null,this._evaluator.featureState=i||null,this._evaluator.canonical=r||null,this._evaluator.availableImages=n||null,this._evaluator.formattedSection=o||null,this._evaluator.featureTileCoord=s||null,this._evaluator.featureDistanceData=a||null;try{const t=this.expression.evaluate(this._evaluator);if(null==t||"number"==typeof t&&t!=t)return this._defaultValue;if(this._enumValues&&!(t in this._enumValues))throw new xi(`Expected value to be one of ${Object.keys(this._enumValues).map((t=>JSON.stringify(t))).join(", ")}, but found ${JSON.stringify(t)} instead.`);return t}catch(t){return this._warningHistory[t.message]||(this._warningHistory[t.message]=!0,"undefined"!=typeof console&&console.warn(t.message)),this._defaultValue}}}function go(t){return Array.isArray(t)&&t.length>0&&"string"==typeof t[0]&&t[0]in Qn}function yo(t,e,i){const r=new Gr(Qn,[],e?function(t){const e={color:Ge,string:Ve,number:Ue,enum:Ve,boolean:je,formatted:He,resolvedImage:We};return "array"===t.type?Xe(e[t.value]||Ze,t.length):e[t.type]}(e):void 0,void 0,void 0,i),n=r.parse(t,void 0,void 0,void 0,e&&"string"===e.type?{typeAnnotation:"coerce"}:void 0);return n?to(new _o(n,e,i)):eo(r.errors)}class xo{constructor(t,e,i){this.kind=t,this._styleExpression=e,this.isLightConstant=i,this.isStateDependent="constant"!==t&&!Or(e.expression),this.isConfigDependent=!Fr(e.expression);}evaluateWithoutErrorHandling(t,e,i,r,n,o){return this._styleExpression.evaluateWithoutErrorHandling(t,e,i,r,n,o)}evaluate(t,e,i,r,n,o){return this._styleExpression.evaluate(t,e,i,r,n,o)}}class vo{constructor(t,e,i,r,n){this.kind=t,this.zoomStops=i,this._styleExpression=e,this.isStateDependent="camera"!==t&&!Or(e.expression),this.isLightConstant=n,this.isConfigDependent=!Fr(e.expression),this.interpolationType=r;}evaluateWithoutErrorHandling(t,e,i,r,n,o){return this._styleExpression.evaluateWithoutErrorHandling(t,e,i,r,n,o)}evaluate(t,e,i,r,n,o){return this._styleExpression.evaluate(t,e,i,r,n,o)}interpolationFactor(t,e,i){return this.interpolationType?gn.interpolationFactor(this.interpolationType,t,e,i):0}}function bo(t,e,i){if("error"===(t=yo(t,e,i)).result)return t;const r=t.value.expression,n=Br(r);if(!n&&!ro(e))return eo([new Be("","data expressions not supported")]);const o=Nr(r,["zoom","pitch","distance-from-center"]);if(!o&&!oo(e))return eo([new Be("","zoom expressions not supported")]);const s=Nr(r,["measure-light"]);if(!s&&!no(e))return eo([new Be("","measure-light expression not supported")]);const a=e.expression&&e.expression.relaxZoomRestriction,l=To(r);return l||o||a?l instanceof Be?eo([l]):l instanceof gn&&!so(e)?eo([new Be("",'"interpolate" expressions cannot be used with this property')]):to(l?new vo(n?"camera":"composite",t.value,l.labels,l instanceof gn?l.interpolation:void 0,s):new xo(n?"constant":"source",t.value,s)):eo([new Be("",'"zoom" expression may only be used as input to a top-level "step" or "interpolate" expression, or in the properties of atmosphere.')])}class wo{constructor(t,e){this._parameters=t,this._specification=e,De(this,co(this._parameters,this._specification));}static deserialize(t){return new wo(t._parameters,t._specification)}static serialize(t){return {_parameters:t._parameters,_specification:t._specification}}}function To(t){let e=null;if(t instanceof bn)e=To(t.result);else if(t instanceof xn){for(const i of t.args)if(e=To(i),e)break}else (t instanceof Hr||t instanceof gn)&&t.input instanceof Pi&&"zoom"===t.input.name&&(e=t);return e instanceof Be||t.eachChild((t=>{const i=To(t);i instanceof Be?e=i:e&&i&&e!==i&&(e=new Be("",'Only one zoom-based "step" or "interpolate" subexpression may be used in an expression.'));})),e}function Eo(t){const e=t.key,i=t.value,r=t.valueSpec||{},n=t.objectElementValidators||{},o=t.style,s=t.styleSpec;let a=[];const l=Mi(i);if("object"!==l)return [new Pe(e,i,`object expected, ${l} found`)];for(const t in i){const l=t.split(".")[0];let c;n[l]?c=n[l]:r[l]?c=ss:n["*"]?c=n["*"]:r["*"]&&(c=ss),c?a=a.concat(c({key:(e?`${e}.`:e)+t,value:i[t],valueSpec:r[l]||r["*"],style:o,styleSpec:s,object:i,objectKey:t},i)):a.push(new Pe(e,i[t],`unknown property "${t}"`));}for(const t in r)n[t]||r[t].required&&void 0===r[t].default&&void 0===i[t]&&a.push(new Pe(e,i,`missing required property "${t}"`));return a}function Mo(t){const e=t.value,i=t.valueSpec,r=t.style,n=t.styleSpec,o=t.key,s=t.arrayElementValidator||ss;if("array"!==Mi(e))return [new Pe(o,e,`array expected, ${Mi(e)} found`)];if(i.length&&e.length!==i.length)return [new Pe(o,e,`array length ${i.length} expected, length ${e.length} found`)];if(i["min-length"]&&e.length<i["min-length"])return [new Pe(o,e,`array length at least ${i["min-length"]} expected, length ${e.length} found`)];let a={type:i.value,values:i.values,minimum:i.minimum,maximum:i.maximum,function:void 0};n.$version<7&&(a.function=i.function),"object"===Mi(i.value)&&(a=i.value);let l=[];for(let t=0;t<e.length;t++)l=l.concat(s({array:e,arrayIndex:t,value:e[t],valueSpec:a,style:r,styleSpec:n,key:`${o}[${t}]`},!0));return l}function Ao(t){const e=t.key,i=t.value,r=t.valueSpec;let n=Mi(i);if("number"===n&&i!=i&&(n="NaN"),"number"!==n)return [new Pe(e,i,`number expected, ${n} found`)];if("minimum"in r){let n=r.minimum;if("array"===Mi(r.minimum)&&(n=r.minimum[t.arrayIndex]),i<n)return [new Pe(e,i,`${i} is less than the minimum value ${n}`)]}if("maximum"in r){let n=r.maximum;if("array"===Mi(r.maximum)&&(n=r.maximum[t.arrayIndex]),i>n)return [new Pe(e,i,`${i} is greater than the maximum value ${n}`)]}return []}function So(t){const e=t.valueSpec,i=Re(t.value.type);let r,n,o,s={};const a="categorical"!==i&&void 0===t.value.property,l=!a,c="array"===Mi(t.value.stops)&&"array"===Mi(t.value.stops[0])&&"object"===Mi(t.value.stops[0][0]),h=Eo({key:t.key,value:t.value,valueSpec:t.styleSpec.function,style:t.style,styleSpec:t.styleSpec,objectElementValidators:{stops:function(t){if("identity"===i)return [new Pe(t.key,t.value,'identity function may not have a "stops" property')];let e=[];const r=t.value;return e=e.concat(Mo({key:t.key,value:r,valueSpec:t.valueSpec,style:t.style,styleSpec:t.styleSpec,arrayElementValidator:u})),"array"===Mi(r)&&0===r.length&&e.push(new Pe(t.key,r,"array must have at least one stop")),e},default:function(t){return ss({key:t.key,value:t.value,valueSpec:e,style:t.style,styleSpec:t.styleSpec})}}});return "identity"===i&&a&&h.push(new Pe(t.key,t.value,'missing required property "property"')),"identity"===i||t.value.stops||h.push(new Pe(t.key,t.value,'missing required property "stops"')),"exponential"===i&&t.valueSpec.expression&&!so(t.valueSpec)&&h.push(new Pe(t.key,t.value,"exponential functions not supported")),t.styleSpec.$version>=8&&(l&&!ro(t.valueSpec)?h.push(new Pe(t.key,t.value,"property functions not supported")):a&&!oo(t.valueSpec)&&h.push(new Pe(t.key,t.value,"zoom functions not supported"))),"categorical"!==i&&!c||void 0!==t.value.property||h.push(new Pe(t.key,t.value,'"property" property is required')),h;function u(t){let i=[];const r=t.value,a=t.key;if("array"!==Mi(r))return [new Pe(a,r,`array expected, ${Mi(r)} found`)];if(2!==r.length)return [new Pe(a,r,`array length 2 expected, length ${r.length} found`)];if(c){if("object"!==Mi(r[0]))return [new Pe(a,r,`object expected, ${Mi(r[0])} found`)];if(void 0===r[0].zoom)return [new Pe(a,r,"object stop key must have zoom")];if(void 0===r[0].value)return [new Pe(a,r,"object stop key must have value")];const e=Re(r[0].zoom);if("number"!=typeof e)return [new Pe(a,r[0].zoom,"stop zoom values must be numbers")];if(o&&o>e)return [new Pe(a,r[0].zoom,"stop zoom values must appear in ascending order")];e!==o&&(o=e,n=void 0,s={}),i=i.concat(Eo({key:`${a}[0]`,value:r[0],valueSpec:{zoom:{}},style:t.style,styleSpec:t.styleSpec,objectElementValidators:{zoom:Ao,value:d}}));}else i=i.concat(d({key:`${a}[0]`,value:r[0],valueSpec:{},style:t.style,styleSpec:t.styleSpec},r));return go(Le(r[1]))?i.concat([new Pe(`${a}[1]`,r[1],"expressions are not allowed in function stops.")]):i.concat(ss({key:`${a}[1]`,value:r[1],valueSpec:e,style:t.style,styleSpec:t.styleSpec}))}function d(t,o){const a=Mi(t.value),l=Re(t.value),c=null!==t.value?t.value:o;if(r){if(a!==r)return [new Pe(t.key,c,`${a} stop domain type must match previous stop domain type ${r}`)]}else r=a;if("number"!==a&&"string"!==a&&"boolean"!==a&&"number"!=typeof l&&"string"!=typeof l&&"boolean"!=typeof l)return [new Pe(t.key,c,"stop domain value must be a number, string, or boolean")];if("number"!==a&&"categorical"!==i){let r=`number expected, ${a} found`;return ro(e)&&void 0===i&&(r+='\nIf you intended to use a categorical function, specify `"type": "categorical"`.'),[new Pe(t.key,c,r)]}return "categorical"!==i||"number"!==a||"number"==typeof l&&isFinite(l)&&Math.floor(l)===l?"categorical"!==i&&"number"===a&&"number"==typeof l&&"number"==typeof n&&void 0!==n&&l<n?[new Pe(t.key,c,"stop domain values must appear in ascending order")]:(n=l,"categorical"===i&&l in s?[new Pe(t.key,c,"stop domain values must be unique")]:(s[l]=!0,[])):[new Pe(t.key,c,`integer expected, found ${String(l)}`)]}}function Io(t){const e=("property"===t.expressionContext?bo:yo)(Le(t.value),t.valueSpec);if("error"===e.result)return e.value.map((e=>new Pe(`${t.key}${e.key}`,t.value,e.message)));const i=e.value.expression||e.value._styleExpression.expression;if("property"===t.expressionContext&&"text-font"===t.propertyKey&&!i.outputDefined())return [new Pe(t.key,t.value,`Invalid data expression for "${t.propertyKey}". Output values must be contained as literals within the expression.`)];if("property"===t.expressionContext&&"layout"===t.propertyType&&!Or(i))return [new Pe(t.key,t.value,'"feature-state" data expressions are not supported with layout properties.')];if("filter"===t.expressionContext)return Co(i,t);if(t.expressionContext&&0===t.expressionContext.indexOf("cluster")){if(!Nr(i,["zoom","feature-state"]))return [new Pe(t.key,t.value,'"zoom" and "feature-state" expressions are not supported with cluster properties.')];if("cluster-initial"===t.expressionContext&&!Br(i))return [new Pe(t.key,t.value,"Feature data expressions are not supported with initial expression part of cluster properties.")]}return []}function Co(t,e){const i=new Set(["zoom","feature-state","pitch","distance-from-center"]);if(e.valueSpec&&e.valueSpec.expression)for(const t of e.valueSpec.expression.parameters)i.delete(t);if(0===i.size)return [];const r=[];return t instanceof Pi&&i.has(t.name)?[new Pe(e.key,e.value,`["${t.name}"] expression is not supported in a filter for a ${e.object.type} layer with id: ${e.object.id}`)]:(t.eachChild((t=>{r.push(...Co(t,e));})),r)}function zo(t){const e=t.key,i=t.value,r=t.valueSpec,n=[];return Array.isArray(r.values)?-1===r.values.indexOf(Re(i))&&n.push(new Pe(e,i,`expected one of [${r.values.join(", ")}], ${JSON.stringify(i)} found`)):-1===Object.keys(r.values).indexOf(Re(i))&&n.push(new Pe(e,i,`expected one of [${Object.keys(r.values).join(", ")}], ${JSON.stringify(i)} found`)),n}function Do(t){if(!0===t||!1===t)return !0;if(!Array.isArray(t)||0===t.length)return !1;switch(t[0]){case"has":return t.length>=2&&"$id"!==t[1]&&"$type"!==t[1];case"in":return t.length>=3&&("string"!=typeof t[1]||Array.isArray(t[2]));case"!in":case"!has":case"none":return !1;case"==":case"!=":case">":case">=":case"<":case"<=":return 3!==t.length||Array.isArray(t[1])||Array.isArray(t[2]);case"any":case"all":for(const e of t.slice(1))if(!Do(e)&&"boolean"!=typeof e)return !1;return !0;default:return !0}}function Po(t,e="fill"){if(null==t)return {filter:()=>!0,needGeometry:!1,needFeature:!1};Do(t)||(t=No(t));const i=t;let r=!0;try{r=function(t){if(!ko(t))return t;let e=Le(t);return Lo(e),e=Ro(e),e}(i);}catch(t){console.warn(`Failed to extract static filter. Filter will continue working, but at higher memory usage and slower framerate.\nThis is most likely a bug, please report this via https://github.com/mapbox/mapbox-gl-js/issues/new?assignees=&labels=&template=Bug_report.md\nand paste the contents of this message in the report.\nThank you!\nFilter Expression:\n${JSON.stringify(i,null,2)}\n        `);}const n=ze[`filter_${e}`],o=yo(r,n);let s=null;if("error"===o.result)throw new Error(o.value.map((t=>`${t.key}: ${t.message}`)).join(", "));s=(t,e,i)=>o.value.evaluate(t,e,{},i);let a=null,l=null;if(r!==i){const t=yo(i,n);if("error"===t.result)throw new Error(t.value.map((t=>`${t.key}: ${t.message}`)).join(", "));a=(e,i,r,n,o)=>t.value.evaluate(e,i,{},r,void 0,void 0,n,o),l=!Br(t.value.expression);}return {filter:s,dynamicFilter:a||void 0,needGeometry:Fo(r),needFeature:!!l}}function Ro(t){if(!Array.isArray(t))return t;const e=function(t){if(Bo.has(t[0]))for(let e=1;e<t.length;e++)if(ko(t[e]))return !0;return t}(t);return !0===e?e:e.map((t=>Ro(t)))}function Lo(t){let e=!1;const i=[];if("case"===t[0]){for(let r=1;r<t.length-1;r+=2)e=e||ko(t[r]),i.push(t[r+1]);i.push(t[t.length-1]);}else if("match"===t[0]){e=e||ko(t[1]);for(let e=2;e<t.length-1;e+=2)i.push(t[e+1]);i.push(t[t.length-1]);}else if("step"===t[0]){e=e||ko(t[1]);for(let e=1;e<t.length-1;e+=2)i.push(t[e+1]);}e&&(t.length=0,t.push("any",...i));for(let e=1;e<t.length;e++)Lo(t[e]);}function ko(t){if(!Array.isArray(t))return !1;if("pitch"===(e=t[0])||"distance-from-center"===e)return !0;var e;for(let e=1;e<t.length;e++)if(ko(t[e]))return !0;return !1}const Bo=new Set(["in","==","!=",">",">=","<","<=","to-boolean"]);function Oo(t,e){return t<e?-1:t>e?1:0}function Fo(t){if(!Array.isArray(t))return !1;if("within"===t[0]||"distance"===t[0])return !0;for(let e=1;e<t.length;e++)if(Fo(t[e]))return !0;return !1}function No(t){if(!t)return !0;const e=t[0];return t.length<=1?"any"!==e:"=="===e?Uo(t[1],t[2],"=="):"!="===e?Go(Uo(t[1],t[2],"==")):"<"===e||">"===e||"<="===e||">="===e?Uo(t[1],t[2],e):"any"===e?(i=t.slice(1),["any"].concat(i.map(No))):"all"===e?["all"].concat(t.slice(1).map(No)):"none"===e?["all"].concat(t.slice(1).map(No).map(Go)):"in"===e?Vo(t[1],t.slice(2)):"!in"===e?Go(Vo(t[1],t.slice(2))):"has"===e?jo(t[1]):"!has"!==e||Go(jo(t[1]));var i;}function Uo(t,e,i){switch(t){case"$type":return [`filter-type-${i}`,e];case"$id":return [`filter-id-${i}`,e];default:return [`filter-${i}`,t,e]}}function Vo(t,e){if(0===e.length)return !1;switch(t){case"$type":return ["filter-type-in",["literal",e]];case"$id":return ["filter-id-in",["literal",e]];default:return e.length>200&&!e.some((t=>typeof t!=typeof e[0]))?["filter-in-large",t,["literal",e.sort(Oo)]]:["filter-in-small",t,["literal",e]]}}function jo(t){switch(t){case"$type":return !0;case"$id":return ["filter-has-id"];default:return ["filter-has",t]}}function Go(t){return ["!",t]}function qo(t){return Do(Le(t.value))?Io(De({},t,{expressionContext:"filter",valueSpec:t.styleSpec[`filter_${t.layerType||"fill"}`]})):Zo(t)}function Zo(t){const e=t.value,i=t.key;if("array"!==Mi(e))return [new Pe(i,e,`array expected, ${Mi(e)} found`)];const r=t.styleSpec;let n,o=[];if(e.length<1)return [new Pe(i,e,"filter array must have at least 1 element")];switch(o=o.concat(zo({key:`${i}[0]`,value:e[0],valueSpec:r.filter_operator,style:t.style,styleSpec:t.styleSpec})),Re(e[0])){case"<":case"<=":case">":case">=":e.length>=2&&"$type"===Re(e[1])&&o.push(new Pe(i,e,`"$type" cannot be use with operator "${e[0]}"`));case"==":case"!=":3!==e.length&&o.push(new Pe(i,e,`filter array for operator "${e[0]}" must have 3 elements`));case"in":case"!in":e.length>=2&&(n=Mi(e[1]),"string"!==n&&o.push(new Pe(`${i}[1]`,e[1],`string expected, ${n} found`)));for(let s=2;s<e.length;s++)n=Mi(e[s]),"$type"===Re(e[1])?o=o.concat(zo({key:`${i}[${s}]`,value:e[s],valueSpec:r.geometry_type,style:t.style,styleSpec:t.styleSpec})):"string"!==n&&"number"!==n&&"boolean"!==n&&o.push(new Pe(`${i}[${s}]`,e[s],`string, number, or boolean expected, ${n} found`));break;case"any":case"all":case"none":for(let r=1;r<e.length;r++)o=o.concat(Zo({key:`${i}[${r}]`,value:e[r],style:t.style,styleSpec:t.styleSpec}));break;case"has":case"!has":n=Mi(e[1]),2!==e.length?o.push(new Pe(i,e,`filter array for "${e[0]}" operator must have 2 elements`)):"string"!==n&&o.push(new Pe(`${i}[1]`,e[1],`string expected, ${n} found`));}return o}function $o(t,e){const i=t.key,r=t.style,n=t.layer,o=t.styleSpec,s=t.value,a=t.objectKey,l=o[`${e}_${t.layerType}`];if(!l)return [];const c=a.match(/^(.*)-transition$/);if("paint"===e&&c&&l[c[1]]&&l[c[1]].transition)return ss({key:i,value:s,valueSpec:o.transition,style:r,styleSpec:o});const h=t.valueSpec||l[a];if(!h)return [new Pe(i,s,`unknown property "${a}"`)];let u;if("string"===Mi(s)&&ro(h)&&!h.tokens&&(u=/^{([^}]+)}$/.exec(s))){const t=`\`{ "type": "identity", "property": ${u?JSON.stringify(u[1]):'"_"'} }\``;return [new Pe(i,s,`"${a}" does not support interpolation syntax\nUse an identity property function instead: ${t}.`)]}const d=[];if("symbol"===t.layerType)"text-field"!==a||!r||r.glyphs||r.imports||d.push(new Pe(i,s,'use of "text-field" requires a style "glyphs" property')),"text-font"===a&&ao(Le(s))&&"identity"===Re(s.type)&&d.push(new Pe(i,s,'"text-font" does not support identity functions'));else if("model"===t.layerType&&"paint"===e&&n&&n.layout&&n.layout.hasOwnProperty("model-id")&&ro(h)&&(no(h)||oo(h))){const t=bo(Le(s),h),e=t.value.expression||t.value._styleExpression.expression;!e||Nr(e,["zoom"])&&Nr(e,["measure-light"])||d.push(new Pe(i,s,`${a} does not support zoom or measure-light expressions when the model layer source is vector tile or GeoJSON.`));}return d.concat(ss({key:t.key,value:s,valueSpec:h,style:r,styleSpec:o,expressionContext:"property",propertyType:e,propertyKey:a}))}function Ho(t){return $o(t,"paint")}function Wo(t){return $o(t,"layout")}function Xo(t){let e=[];const i=t.value,r=t.key,n=t.style,o=t.styleSpec;i.type||i.ref||e.push(new Pe(r,i,'either "type" or "ref" is required'));let s=Re(i.type);const a=Re(i.ref);if(i.id){const o=Re(i.id);for(let s=0;s<t.arrayIndex;s++){const t=n.layers[s];Re(t.id)===o&&e.push(new Pe(r,i.id,`duplicate layer id "${i.id}", previously used at line ${t.id.__line__}`));}}if("ref"in i){let t;["type","source","source-layer","filter","layout"].forEach((t=>{t in i&&e.push(new Pe(r,i[t],`"${t}" is prohibited for ref layers`));})),n.layers.forEach((e=>{Re(e.id)===a&&(t=e);})),t?t.ref?e.push(new Pe(r,i.ref,"ref cannot reference another ref layer")):s=Re(t.type):"string"==typeof a&&e.push(new Pe(r,i.ref,`ref layer "${a}" not found`));}else if("background"!==s&&"sky"!==s&&"slot"!==s)if(i.source){const t=n.sources&&n.sources[i.source],o=t&&Re(t.type);t?"vector"===o&&"raster"===s?e.push(new Pe(r,i.source,`layer "${i.id}" requires a raster source`)):"raster"===o&&"raster"!==s?e.push(new Pe(r,i.source,`layer "${i.id}" requires a vector source`)):"vector"!==o||i["source-layer"]?"raster-dem"===o&&"hillshade"!==s?e.push(new Pe(r,i.source,"raster-dem source can only be used with layer type 'hillshade'.")):"line"!==s||!i.paint||!i.paint["line-gradient"]&&!i.paint["line-trim-offset"]||"geojson"===o&&t.lineMetrics||e.push(new Pe(r,i,`layer "${i.id}" specifies a line-gradient, which requires a GeoJSON source with \`lineMetrics\` enabled.`)):e.push(new Pe(r,i,`layer "${i.id}" must specify a "source-layer"`)):e.push(new Pe(r,i.source,`source "${i.source}" not found`));}else e.push(new Pe(r,i,'missing required property "source"'));return e=e.concat(Eo({key:r,value:i,valueSpec:o.layer,style:t.style,styleSpec:t.styleSpec,objectElementValidators:{"*":()=>[],type:()=>ss({key:`${r}.type`,value:i.type,valueSpec:o.layer.type,style:t.style,styleSpec:t.styleSpec,object:i,objectKey:"type"}),filter:t=>qo(De({layerType:s},t)),layout:t=>Eo({layer:i,key:t.key,value:t.value,valueSpec:{},style:t.style,styleSpec:t.styleSpec,objectElementValidators:{"*":t=>Wo(De({layerType:s},t))}}),paint:t=>Eo({layer:i,key:t.key,value:t.value,valueSpec:{},style:t.style,styleSpec:t.styleSpec,objectElementValidators:{"*":t=>Ho(De({layerType:s,layer:i},t))}})}})),e}function Yo(t){const e=t.value,i=t.key,r=Mi(e);return "string"!==r?[new Pe(i,e,`string expected, ${r} found`)]:[]}const Ko={promoteId:function({key:t,value:e}){if("string"===Mi(e))return Yo({key:t,value:e});{const i=[];for(const r in e)i.push(...Yo({key:`${t}.${r}`,value:e[r]}));return i}}};function Jo(t){const e=t.value,i=t.key,r=t.styleSpec,n=t.style;if(!e.type)return [new Pe(i,e,'"type" is required')];const o=Re(e.type);let s;switch(o){case"vector":case"raster":case"raster-dem":return s=Eo({key:i,value:e,valueSpec:r[`source_${o.replace("-","_")}`],style:t.style,styleSpec:r,objectElementValidators:Ko}),s;case"geojson":if(s=Eo({key:i,value:e,valueSpec:r.source_geojson,style:n,styleSpec:r,objectElementValidators:Ko}),e.cluster)for(const t in e.clusterProperties){const[r,n]=e.clusterProperties[t],o="string"==typeof r?[r,["accumulated"],["get",t]]:r;s.push(...Io({key:`${i}.${t}.map`,value:n,expressionContext:"cluster-map"})),s.push(...Io({key:`${i}.${t}.reduce`,value:o,expressionContext:"cluster-reduce"}));}return s;case"video":return Eo({key:i,value:e,valueSpec:r.source_video,style:n,styleSpec:r});case"image":return Eo({key:i,value:e,valueSpec:r.source_image,style:n,styleSpec:r});case"canvas":return [new Pe(i,null,"Please use runtime APIs to add canvas sources, rather than including them in stylesheets.","source.canvas")];default:return zo({key:`${i}.type`,value:e.type,valueSpec:{values:Qo(r)},style:n,styleSpec:r})}}function Qo(t){return t.source.reduce(((e,i)=>{const r=t[i];return "enum"===r.type.type&&(e=e.concat(Object.keys(r.type.values))),e}),[])}function ts(t){const e=t.value;let i=[];if(!e)return i;const r=Mi(e);return "string"!==r?(i=i.concat([new Pe(t.key,e,`string expected, "${r}" found`)]),i):(function(t){const e=-1===t.indexOf("://");try{return new URL(t,e?"http://example.com":void 0),!0}catch(t){return !1}}(e)||(i=i.concat([new Pe(t.key,e,`invalid url "${e}"`)])),i)}function es(t){const e=t.value,i=t.styleSpec,r=i.light,n=t.style;let o=[];const s=Mi(e);if(void 0===e)return o;if("object"!==s)return o=o.concat([new Pe("light",e,`object expected, ${s} found`)]),o;for(const t in e){const s=t.match(/^(.*)-transition$/);o=o.concat(s&&r[s[1]]&&r[s[1]].transition?ss({key:t,value:e[t],valueSpec:i.transition,style:n,styleSpec:i}):r[t]?ss({key:t,value:e[t],valueSpec:r[t],style:n,styleSpec:i}):[new Pe(t,e[t],`unknown property "${t}"`)]);}return o}function is(t){const e=t.value;let i=[];if(!e)return i;const r=Mi(e);if("object"!==r)return i=i.concat([new Pe("light-3d",e,`object expected, ${r} found`)]),i;const n=t.styleSpec,o=n["light-3d"],s=t.style;for(const t of ["type","id"])if(!(t in e))return i=i.concat([new Pe("light-3d",e,`missing property ${t} on light`)]),i;const a=`properties_light_${e.type}`;if(!(a in n))return i=i.concat([new Pe("light-3d",e,`Invalid light type ${e.type}`)]),i;const l=n[a];for(const t in e)if("properties"===t){const r=e[t],o=Mi(r);if("object"!==o)return i=i.concat([new Pe("properties",r,`object expected, ${o} found`)]),i;for(const t in r)i=i.concat(ss({key:t,value:r[t],valueSpec:l[t],style:s,styleSpec:n}));}else {const r=t.match(/^(.*)-transition$/);i=i.concat(r&&o[r[1]]&&o[r[1]].transition?ss({key:t,value:e[t],valueSpec:n.transition,style:s,styleSpec:n}):o[t]?ss({key:t,value:e[t],valueSpec:o[t],style:s,styleSpec:n}):[new Pe(t,e[t],`unknown property "${t}"`)]);}return i}function rs(t){const e=t.value,i=t.key,r=t.style,n=t.styleSpec,o=n.terrain;let s=[];const a=Mi(e);if(void 0===e)return s;if("object"!==a)return s=s.concat([new Pe("terrain",e,`object expected, ${a} found`)]),s;for(const t in e){const i=t.match(/^(.*)-transition$/);s=s.concat(i&&o[i[1]]&&o[i[1]].transition?ss({key:t,value:e[t],valueSpec:n.transition,style:r,styleSpec:n}):o[t]?ss({key:t,value:e[t],valueSpec:o[t],style:r,styleSpec:n}):[new Pe(t,e[t],`unknown property "${t}"`)]);}if(e.source){const t=r.sources&&r.sources[e.source],n=t&&Re(t.type);t?"raster-dem"!==n&&s.push(new Pe(i,e.source,`terrain cannot be used with a source of type ${String(n)}, it only be used with a "raster-dem" source type`)):s.push(new Pe(i,e.source,`source "${e.source}" not found`));}else s.push(new Pe(i,e,'terrain is missing required property "source"'));return s}function ns(t){const e=t.value,i=t.style,r=t.styleSpec,n=r.fog;let o=[];const s=Mi(e);if(void 0===e)return o;if("object"!==s)return o=o.concat([new Pe("fog",e,`object expected, ${s} found`)]),o;for(const t in e){const s=t.match(/^(.*)-transition$/);o=o.concat(s&&n[s[1]]&&n[s[1]].transition?ss({key:t,value:e[t],valueSpec:r.transition,style:i,styleSpec:r}):n[t]?ss({key:t,value:e[t],valueSpec:n[t],style:i,styleSpec:r}):[new Pe(t,e[t],`unknown property "${t}"`)]);}return o}const os={"*":()=>[],array:Mo,boolean:function(t){const e=t.value,i=t.key,r=Mi(e);return "boolean"!==r?[new Pe(i,e,`boolean expected, ${r} found`)]:[]},number:Ao,color:function(t){const e=t.key,i=t.value,r=Mi(i);return "string"!==r?[new Pe(e,i,`color expected, ${r} found`)]:null===ei(i)?[new Pe(e,i,`color expected, "${i}" found`)]:[]},enum:zo,filter:qo,function:So,layer:Xo,object:Eo,source:Jo,model:ts,light:es,"light-3d":is,terrain:rs,fog:ns,string:Yo,formatted:function(t){return 0===Yo(t).length?[]:Io(t)},resolvedImage:function(t){return 0===Yo(t).length?[]:Io(t)},projection:function(t){const e=t.value,i=t.styleSpec,r=i.projection,n=t.style;let o=[];const s=Mi(e);if("object"===s)for(const t in e)o=o.concat(ss({key:t,value:e[t],valueSpec:r[t],style:n,styleSpec:i}));else "string"!==s&&(o=o.concat([new Pe("projection",e,`object or string expected, ${s} found`)]));return o},import:function(t){const{value:e,styleSpec:i}=t,{data:r,...n}=e;Object.defineProperty(n,"__line__",{value:e.__line__,enumerable:!1});let o=Eo(De({},t,{value:n,valueSpec:i.import}));return r&&(o=o.concat(ls(r,i,{key:`${t.key}.data`}))),o}};function ss(t,e=!1){const i=t.value,r=t.valueSpec,n=t.styleSpec;if(r.expression&&ao(Re(i)))return So(t);if(r.expression&&go(Le(i)))return Io(t);if(r.type&&os[r.type]){const i=os[r.type](t);return !0===e&&i.length>0&&"array"===Mi(t.value)?Io(t):i}return Eo(De({},t,{valueSpec:r.type?n[r.type]:r}))}function as(t){const e=t.value,i=t.key,r=Yo(t);return r.length||(-1===e.indexOf("{fontstack}")&&r.push(new Pe(i,e,'"glyphs" url must include a "{fontstack}" token')),-1===e.indexOf("{range}")&&r.push(new Pe(i,e,'"glyphs" url must include a "{range}" token'))),r}function ls(t,e=ze,i={}){return ss({key:i.key||"",value:t,valueSpec:e.$root,styleSpec:e,style:t,objectElementValidators:{glyphs:as,"*":()=>[]}})}function cs(t,e=ze){return vs(ls(t,e))}const hs=t=>vs(Jo(t)),us=t=>vs(es(t)),ds=t=>vs(is(t)),ps=t=>vs(rs(t)),fs=t=>vs(ns(t)),ms=t=>vs(Xo(t)),_s=t=>vs(qo(t)),gs=t=>vs(Ho(t)),ys=t=>vs(Wo(t)),xs=t=>vs(ts(t));function vs(t){return t.slice().sort(((t,e)=>t.line&&e.line?t.line-e.line:0))}function bs(t,e){let i=!1;if(e&&e.length)for(const r of e)t.fire(new Ie(new Error(r.message))),i=!0;return i}var ws=Es,Ts=3;function Es(t,e,i){var r=this.cells=[];if(t instanceof ArrayBuffer){this.arrayBuffer=t;var n=new Int32Array(this.arrayBuffer);t=n[0],this.d=(e=n[1])+2*(i=n[2]);for(var o=0;o<this.d*this.d;o++){var s=n[Ts+o],a=n[Ts+o+1];r.push(s===a?null:n.subarray(s,a));}var l=n[Ts+r.length+1];this.keys=n.subarray(n[Ts+r.length],l),this.bboxes=n.subarray(l),this.insert=this._insertReadonly;}else {this.d=e+2*i;for(var c=0;c<this.d*this.d;c++)r.push([]);this.keys=[],this.bboxes=[];}this.n=e,this.extent=t,this.padding=i,this.scale=e/t,this.uid=0;var h=i/e*t;this.min=-h,this.max=t+h;}Es.prototype.insert=function(t,e,i,r,n){this._forEachCell(e,i,r,n,this._insertCell,this.uid++),this.keys.push(t),this.bboxes.push(e),this.bboxes.push(i),this.bboxes.push(r),this.bboxes.push(n);},Es.prototype._insertReadonly=function(){throw "Cannot insert into a GridIndex created from an ArrayBuffer."},Es.prototype._insertCell=function(t,e,i,r,n,o){this.cells[n].push(o);},Es.prototype.query=function(t,e,i,r,n){var o=this.min,s=this.max;if(t<=o&&e<=o&&s<=i&&s<=r&&!n)return Array.prototype.slice.call(this.keys);var a=[];return this._forEachCell(t,e,i,r,this._queryCell,a,{},n),a},Es.prototype._queryCell=function(t,e,i,r,n,o,s,a){var l=this.cells[n];if(null!==l)for(var c=this.keys,h=this.bboxes,u=0;u<l.length;u++){var d=l[u];if(void 0===s[d]){var p=4*d;(a?a(h[p+0],h[p+1],h[p+2],h[p+3]):t<=h[p+2]&&e<=h[p+3]&&i>=h[p+0]&&r>=h[p+1])?(s[d]=!0,o.push(c[d])):s[d]=!1;}}},Es.prototype._forEachCell=function(t,e,i,r,n,o,s,a){for(var l=this._convertToCellCoord(t),c=this._convertToCellCoord(e),h=this._convertToCellCoord(i),u=this._convertToCellCoord(r),d=l;d<=h;d++)for(var p=c;p<=u;p++){var f=this.d*p+d;if((!a||a(this._convertFromCellCoord(d),this._convertFromCellCoord(p),this._convertFromCellCoord(d+1),this._convertFromCellCoord(p+1)))&&n.call(this,t,e,i,r,f,o,s,a))return}},Es.prototype._convertFromCellCoord=function(t){return (t-this.padding)/this.scale},Es.prototype._convertToCellCoord=function(t){return Math.max(0,Math.min(this.d-1,Math.floor(t*this.scale)+this.padding))},Es.prototype.toArrayBuffer=function(){if(this.arrayBuffer)return this.arrayBuffer;for(var t=this.cells,e=Ts+this.cells.length+1+1,i=0,r=0;r<this.cells.length;r++)i+=this.cells[r].length;var n=new Int32Array(e+i+this.keys.length+this.bboxes.length);n[0]=this.extent,n[1]=this.n,n[2]=this.padding;for(var o=e,s=0;s<t.length;s++){var a=t[s];n[Ts+s]=o,n.set(a,o),o+=a.length;}return n[Ts+t.length]=o,n.set(this.keys,o),n[Ts+t.length+1]=o+=this.keys.length,n.set(this.bboxes,o),o+=this.bboxes.length,n.buffer};var Ms=d(ws);const As={};function Ss(t,e,i={}){Object.defineProperty(t,"_classRegistryKey",{value:e,writeable:!1}),As[e]={klass:t,omit:i.omit||[]};}Ss(Object,"Object"),Ms.serialize=function(t,e){const i=t.toArrayBuffer();return e&&e.push(i),{buffer:i}},Ms.deserialize=function(t){return new Ms(t.buffer)},Object.defineProperty(Ms,"name",{value:"Grid"}),Ss(Ms,"Grid"),Ss(li,"Color"),Ss(Error,"Error"),Ss(vt,"AJAXError"),Ss(di,"ResolvedImage"),Ss(wo,"StylePropertyFunction"),Ss(_o,"StyleExpression",{omit:["_evaluator"]}),Ss(vo,"ZoomDependentExpression"),Ss(xo,"ZoomConstantExpression"),Ss(Pi,"CompoundExpression",{omit:["_evaluate"]});for(const t in Qn)As[Qn[t]._classRegistryKey]||Ss(Qn[t],`Expression${t}`);function Is(t){return t&&"undefined"!=typeof ArrayBuffer&&(t instanceof ArrayBuffer||t.constructor&&"ArrayBuffer"===t.constructor.name)}function Cs(t){return e.ImageBitmap&&t instanceof e.ImageBitmap}function zs(t,i){if(null==t||"boolean"==typeof t||"number"==typeof t||"string"==typeof t||t instanceof Boolean||t instanceof Number||t instanceof String||t instanceof Date||t instanceof RegExp)return t;if(Is(t)||Cs(t))return i&&i.push(t),t;if(ArrayBuffer.isView(t)){const e=t;return i&&i.push(e.buffer),e}if(t instanceof e.ImageData)return i&&i.push(t.data.buffer),t;if(Array.isArray(t)){const e=[];for(const r of t)e.push(zs(r,i));return e}if(t instanceof Map){const e={$name:"Map"};for(const[i,r]of t.entries())e[i]=zs(r);return e}if("object"==typeof t){const e=t.constructor,r=e._classRegistryKey;if(!r)throw new Error(`can't serialize object of unregistered class ${r}`);const n=e.serialize?e.serialize(t,i):{};if(!e.serialize){for(const e in t)t.hasOwnProperty(e)&&(As[r].omit.indexOf(e)>=0||(n[e]=zs(t[e],i)));t instanceof Error&&(n.message=t.message);}if(n.$name)throw new Error("$name property is reserved for worker serialization logic.");return "Object"!==r&&(n.$name=r),n}throw new Error("can't serialize object of type "+typeof t)}function Ds(t){if(null==t||"boolean"==typeof t||"number"==typeof t||"string"==typeof t||t instanceof Boolean||t instanceof Number||t instanceof String||t instanceof Date||t instanceof RegExp||Is(t)||Cs(t)||ArrayBuffer.isView(t)||t instanceof e.ImageData)return t;if(Array.isArray(t))return t.map(Ds);if("object"==typeof t){const e=t.$name||"Object";if("Map"===e){const e=new Map;for(const i of Object.keys(t))"$name"!==i&&e.set(i,Ds(t[i]));return e}const{klass:i}=As[e];if(!i)throw new Error(`can't deserialize unregistered class ${e}`);if(i.deserialize)return i.deserialize(t);const r=Object.create(i.prototype);for(const e of Object.keys(t))"$name"!==e&&(r[e]=Ds(t[e]));return r}throw new Error("can't deserialize object of type "+typeof t)}const Ps={"Latin-1 Supplement":t=>t>=128&&t<=255,Arabic:t=>t>=1536&&t<=1791,"Arabic Supplement":t=>t>=1872&&t<=1919,"Arabic Extended-A":t=>t>=2208&&t<=2303,"Hangul Jamo":t=>t>=4352&&t<=4607,"Unified Canadian Aboriginal Syllabics":t=>t>=5120&&t<=5759,Khmer:t=>t>=6016&&t<=6143,"Unified Canadian Aboriginal Syllabics Extended":t=>t>=6320&&t<=6399,"General Punctuation":t=>t>=8192&&t<=8303,"Letterlike Symbols":t=>t>=8448&&t<=8527,"Number Forms":t=>t>=8528&&t<=8591,"Miscellaneous Technical":t=>t>=8960&&t<=9215,"Control Pictures":t=>t>=9216&&t<=9279,"Optical Character Recognition":t=>t>=9280&&t<=9311,"Enclosed Alphanumerics":t=>t>=9312&&t<=9471,"Geometric Shapes":t=>t>=9632&&t<=9727,"Miscellaneous Symbols":t=>t>=9728&&t<=9983,"Miscellaneous Symbols and Arrows":t=>t>=11008&&t<=11263,"CJK Radicals Supplement":t=>t>=11904&&t<=12031,"Kangxi Radicals":t=>t>=12032&&t<=12255,"Ideographic Description Characters":t=>t>=12272&&t<=12287,"CJK Symbols and Punctuation":t=>t>=12288&&t<=12351,Hiragana:t=>t>=12352&&t<=12447,Katakana:t=>t>=12448&&t<=12543,Bopomofo:t=>t>=12544&&t<=12591,"Hangul Compatibility Jamo":t=>t>=12592&&t<=12687,Kanbun:t=>t>=12688&&t<=12703,"Bopomofo Extended":t=>t>=12704&&t<=12735,"CJK Strokes":t=>t>=12736&&t<=12783,"Katakana Phonetic Extensions":t=>t>=12784&&t<=12799,"Enclosed CJK Letters and Months":t=>t>=12800&&t<=13055,"CJK Compatibility":t=>t>=13056&&t<=13311,"CJK Unified Ideographs Extension A":t=>t>=13312&&t<=19903,"Yijing Hexagram Symbols":t=>t>=19904&&t<=19967,"CJK Unified Ideographs":t=>t>=19968&&t<=40959,"Yi Syllables":t=>t>=40960&&t<=42127,"Yi Radicals":t=>t>=42128&&t<=42191,"Hangul Jamo Extended-A":t=>t>=43360&&t<=43391,"Hangul Syllables":t=>t>=44032&&t<=55215,"Hangul Jamo Extended-B":t=>t>=55216&&t<=55295,"Private Use Area":t=>t>=57344&&t<=63743,"CJK Compatibility Ideographs":t=>t>=63744&&t<=64255,"Arabic Presentation Forms-A":t=>t>=64336&&t<=65023,"Vertical Forms":t=>t>=65040&&t<=65055,"CJK Compatibility Forms":t=>t>=65072&&t<=65103,"Small Form Variants":t=>t>=65104&&t<=65135,"Arabic Presentation Forms-B":t=>t>=65136&&t<=65279,"Halfwidth and Fullwidth Forms":t=>t>=65280&&t<=65519,"CJK Unified Ideographs Extension B":t=>t>=131072&&t<=173791};function Rs(t){for(const e of t)if(Bs(e.charCodeAt(0)))return !0;return !1}function Ls(t){for(const e of t)if(!ks(e.charCodeAt(0)))return !1;return !0}function ks(t){return !(Ps.Arabic(t)||Ps["Arabic Supplement"](t)||Ps["Arabic Extended-A"](t)||Ps["Arabic Presentation Forms-A"](t)||Ps["Arabic Presentation Forms-B"](t))}function Bs(t){return !(746!==t&&747!==t&&(t<4352||!(Ps["Bopomofo Extended"](t)||Ps.Bopomofo(t)||Ps["CJK Compatibility Forms"](t)&&!(t>=65097&&t<=65103)||Ps["CJK Compatibility Ideographs"](t)||Ps["CJK Compatibility"](t)||Ps["CJK Radicals Supplement"](t)||Ps["CJK Strokes"](t)||!(!Ps["CJK Symbols and Punctuation"](t)||t>=12296&&t<=12305||t>=12308&&t<=12319||12336===t)||Ps["CJK Unified Ideographs Extension A"](t)||Ps["CJK Unified Ideographs"](t)||Ps["Enclosed CJK Letters and Months"](t)||Ps["Hangul Compatibility Jamo"](t)||Ps["Hangul Jamo Extended-A"](t)||Ps["Hangul Jamo Extended-B"](t)||Ps["Hangul Jamo"](t)||Ps["Hangul Syllables"](t)||Ps.Hiragana(t)||Ps["Ideographic Description Characters"](t)||Ps.Kanbun(t)||Ps["Kangxi Radicals"](t)||Ps["Katakana Phonetic Extensions"](t)||Ps.Katakana(t)&&12540!==t||!(!Ps["Halfwidth and Fullwidth Forms"](t)||65288===t||65289===t||65293===t||t>=65306&&t<=65310||65339===t||65341===t||65343===t||t>=65371&&t<=65503||65507===t||t>=65512&&t<=65519)||!(!Ps["Small Form Variants"](t)||t>=65112&&t<=65118||t>=65123&&t<=65126)||Ps["Unified Canadian Aboriginal Syllabics"](t)||Ps["Unified Canadian Aboriginal Syllabics Extended"](t)||Ps["Vertical Forms"](t)||Ps["Yijing Hexagram Symbols"](t)||Ps["Yi Syllables"](t)||Ps["Yi Radicals"](t))))}function Os(t){return !(Bs(t)||function(t){return !!(Ps["Latin-1 Supplement"](t)&&(167===t||169===t||174===t||177===t||188===t||189===t||190===t||215===t||247===t)||Ps["General Punctuation"](t)&&(8214===t||8224===t||8225===t||8240===t||8241===t||8251===t||8252===t||8258===t||8263===t||8264===t||8265===t||8273===t)||Ps["Letterlike Symbols"](t)||Ps["Number Forms"](t)||Ps["Miscellaneous Technical"](t)&&(t>=8960&&t<=8967||t>=8972&&t<=8991||t>=8996&&t<=9e3||9003===t||t>=9085&&t<=9114||t>=9150&&t<=9165||9167===t||t>=9169&&t<=9179||t>=9186&&t<=9215)||Ps["Control Pictures"](t)&&9251!==t||Ps["Optical Character Recognition"](t)||Ps["Enclosed Alphanumerics"](t)||Ps["Geometric Shapes"](t)||Ps["Miscellaneous Symbols"](t)&&!(t>=9754&&t<=9759)||Ps["Miscellaneous Symbols and Arrows"](t)&&(t>=11026&&t<=11055||t>=11088&&t<=11097||t>=11192&&t<=11243)||Ps["CJK Symbols and Punctuation"](t)||Ps.Katakana(t)||Ps["Private Use Area"](t)||Ps["CJK Compatibility Forms"](t)||Ps["Small Form Variants"](t)||Ps["Halfwidth and Fullwidth Forms"](t)||8734===t||8756===t||8757===t||t>=9984&&t<=10087||t>=10102&&t<=10131||65532===t||65533===t)}(t))}function Fs(t){return t>=1424&&t<=2303||Ps["Arabic Presentation Forms-A"](t)||Ps["Arabic Presentation Forms-B"](t)}function Ns(t,e){return !(!e&&Fs(t)||t>=2304&&t<=3583||t>=3840&&t<=4255||Ps.Khmer(t))}function Us(t){for(const e of t)if(Fs(e.charCodeAt(0)))return !0;return !1}const Vs="deferred",js="loading",Gs="loaded";let qs=null,Zs="unavailable",$s=null;const Hs=function(t){t&&"string"==typeof t&&t.indexOf("NetworkError")>-1&&(Zs="error"),qs&&qs(t);};function Ws(){Xs.fire(new Se("pluginStateChange",{pluginStatus:Zs,pluginURL:$s}));}const Xs=new Ce,Ys=function(){return Zs},Ks=function(){if(Zs!==Vs||!$s)throw new Error("rtl-text-plugin cannot be downloaded unless a pluginURL is specified");Zs=js,Ws(),$s&&Et({url:$s},(t=>{t?Hs(t):(Zs=Gs,Ws());}));},Js={applyArabicShaping:null,processBidirectionalText:null,processStyledBidirectionalText:null,isLoaded:()=>Zs===Gs||null!=Js.applyArabicShaping,isLoading:()=>Zs===js,setState(t){Zs=t.pluginStatus,$s=t.pluginURL;},isParsed:()=>null!=Js.applyArabicShaping&&null!=Js.processBidirectionalText&&null!=Js.processStyledBidirectionalText,getPluginURL:()=>$s};class Qs{constructor(t,e){this.zoom=t,e?(this.now=e.now,this.fadeDuration=e.fadeDuration,this.transition=e.transition,this.pitch=e.pitch,this.brightness=e.brightness):(this.now=0,this.fadeDuration=0,this.transition={},this.pitch=0,this.brightness=0);}isSupportedScript(t){return function(t,e){for(const i of t)if(!Ns(i.charCodeAt(0),e))return !1;return !0}(t,Js.isLoaded())}}class ta{constructor(t,e,i){this.property=t,this.value=e,this.expression=function(t,e,i){if(ao(t))return new wo(t,e);if(go(t)||Array.isArray(t)&&t.length>0){const r=bo(t,e,i);if("error"===r.result)throw new Error(r.value.map((t=>`${t.key}: ${t.message}`)).join(", "));return r.value}{let i=t;return "string"==typeof t&&"color"===e.type&&(i=li.parse(t)),{kind:"constant",isConfigDependent:!1,evaluate:()=>i}}}(void 0===e?t.specification.default:e,t.specification,i);}isDataDriven(){return "source"===this.expression.kind||"composite"===this.expression.kind}possiblyEvaluate(t,e,i){return this.property.possiblyEvaluate(this,t,e,i)}}class ea{constructor(t,e){this.property=t,this.value=new ta(t,void 0,e);}transitioned(t,e){return new ra(this.property,this.value,e,k({},t.transition,this.transition),t.now)}untransitioned(){return new ra(this.property,this.value,null,{},0)}}class ia{constructor(t,e){this._properties=t,this._values=Object.create(t.defaultTransitionablePropertyValues),this._options=e,this.isConfigDependent=!1;}getValue(t){return $(this._values[t].value.value)}setValue(t,e){this._values.hasOwnProperty(t)||(this._values[t]=new ea(this._values[t].property,this._options)),this._values[t].value=new ta(this._values[t].property,null===e?void 0:$(e),this._options),this.isConfigDependent=this.isConfigDependent||this._values[t].value.expression.isConfigDependent;}setTransitionOrValue(t,e){if(e&&(this._options=e),t)for(const e in t){const i=t[e];G(e,"-transition")?this.setTransition(e.slice(0,-11),i):this.setValue(e,i);}}getTransition(t){return $(this._values[t].transition)}setTransition(t,e){this._values.hasOwnProperty(t)||(this._values[t]=new ea(this._values[t].property)),this._values[t].transition=$(e)||void 0;}serialize(){const t={};for(const e of Object.keys(this._values)){const i=this.getValue(e);void 0!==i&&(t[e]=i);const r=this.getTransition(e);void 0!==r&&(t[`${e}-transition`]=r);}return t}transitioned(t,e){const i=new na(this._properties);for(const r of Object.keys(this._values))i._values[r]=this._values[r].transitioned(t,e._values[r]);return i}untransitioned(){const t=new na(this._properties);for(const e of Object.keys(this._values))t._values[e]=this._values[e].untransitioned();return t}}class ra{constructor(t,e,i,r,n){const o=r.delay||0,s=r.duration||0;n=n||0,this.property=t,this.value=e,this.begin=n+o,this.end=this.begin+s,t.specification.transition&&(r.delay||r.duration)&&(this.prior=i);}possiblyEvaluate(t,e,i){const r=t.now||0,n=this.value.possiblyEvaluate(t,e,i),o=this.prior;if(o){if(r>this.end)return this.prior=null,n;if(this.value.isDataDriven())return this.prior=null,n;if(r<this.begin)return o.possiblyEvaluate(t,e,i);{const s=(r-this.begin)/(this.end-this.begin);return this.property.interpolate(o.possiblyEvaluate(t,e,i),n,M(s))}}return n}}class na{constructor(t){this._properties=t,this._values=Object.create(t.defaultTransitioningPropertyValues);}possiblyEvaluate(t,e,i){const r=new aa(this._properties);for(const n of Object.keys(this._values))r._values[n]=this._values[n].possiblyEvaluate(t,e,i);return r}hasTransition(){for(const t of Object.keys(this._values))if(this._values[t].prior)return !0;return !1}}class oa{constructor(t,e){this._properties=t,this._values=Object.create(t.defaultPropertyValues),this._options=e,this.isConfigDependent=!1;}getValue(t){return $(this._values[t].value)}setValue(t,e){this._values[t]=new ta(this._values[t].property,null===e?void 0:$(e),this._options),this.isConfigDependent=this.isConfigDependent||this._values[t].expression.isConfigDependent;}serialize(){const t={};for(const e of Object.keys(this._values)){const i=this.getValue(e);void 0!==i&&(t[e]=i);}return t}possiblyEvaluate(t,e,i){const r=new aa(this._properties);for(const n of Object.keys(this._values))r._values[n]=this._values[n].possiblyEvaluate(t,e,i);return r}}class sa{constructor(t,e,i){this.property=t,this.value=e,this.parameters=i;}isConstant(){return "constant"===this.value.kind}constantOr(t){return "constant"===this.value.kind?this.value.value:t}evaluate(t,e,i,r){return this.property.evaluate(this.value,this.parameters,t,e,i,r)}}class aa{constructor(t){this._properties=t,this._values=Object.create(t.defaultPossiblyEvaluatedValues);}get(t){return this._values[t]}}class la{constructor(t){this.specification=t;}possiblyEvaluate(t,e){return t.expression.evaluate(e)}interpolate(t,e,i){const r=Xr[this.specification.type];return r?r(t,e,i):t}}class ca{constructor(t,e){this.specification=t,this.overrides=e;}possiblyEvaluate(t,e,i,r){return new sa(this,"constant"===t.expression.kind||"camera"===t.expression.kind?{kind:"constant",value:t.expression.evaluate(e,null,{},i,r)}:t.expression,e)}interpolate(t,e,i){if("constant"!==t.value.kind||"constant"!==e.value.kind)return t;if(void 0===t.value.value||void 0===e.value.value)return new sa(this,{kind:"constant",value:void 0},t.parameters);const r=Xr[this.specification.type];return r?new sa(this,{kind:"constant",value:r(t.value.value,e.value.value,i)},t.parameters):t}evaluate(t,e,i,r,n,o){return "constant"===t.kind?t.value:t.evaluate(e,i,r,n,o)}}class ha{constructor(t){this.specification=t;}possiblyEvaluate(t,e,i,r){return !!t.expression.evaluate(e,null,{},i,r)}interpolate(){return !1}}class ua{constructor(t){this.properties=t,this.defaultPropertyValues={},this.defaultTransitionablePropertyValues={},this.defaultTransitioningPropertyValues={},this.defaultPossiblyEvaluatedValues={},this.overridableProperties=[];const e=new Qs(0,{});for(const i in t){const r=t[i];r.specification.overridable&&this.overridableProperties.push(i);const n=this.defaultPropertyValues[i]=new ta(r,void 0),o=this.defaultTransitionablePropertyValues[i]=new ea(r);this.defaultTransitioningPropertyValues[i]=o.untransitioned(),this.defaultPossiblyEvaluatedValues[i]=n.possiblyEvaluate(e);}}}function da(t,e){return 256*(t=z(Math.floor(t),0,255))+z(Math.floor(e),0,255)}Ss(ca,"DataDrivenProperty"),Ss(la,"DataConstantProperty"),Ss(ha,"ColorRampProperty");const pa={Int8:Int8Array,Uint8:Uint8Array,Int16:Int16Array,Uint16:Uint16Array,Int32:Int32Array,Uint32:Uint32Array,Float32:Float32Array};class fa{constructor(t,e){this._structArray=t,this._pos1=e*this.size,this._pos2=this._pos1/2,this._pos4=this._pos1/4,this._pos8=this._pos1/8;}}class ma{constructor(){this.isTransferred=!1,this.capacity=-1,this.resize(0);}static serialize(t,e){return t._trim(),e&&(t.isTransferred=!0,e.push(t.arrayBuffer)),{length:t.length,arrayBuffer:t.arrayBuffer}}static deserialize(t){const e=Object.create(this.prototype);return e.arrayBuffer=t.arrayBuffer,e.length=t.length,e.capacity=t.arrayBuffer.byteLength/e.bytesPerElement,e._refreshViews(),e}_trim(){this.length!==this.capacity&&(this.capacity=this.length,this.arrayBuffer=this.arrayBuffer.slice(0,this.length*this.bytesPerElement),this._refreshViews());}clear(){this.length=0;}resize(t){this.reserve(t),this.length=t;}reserve(t){if(t>this.capacity){this.capacity=Math.max(t,Math.floor(5*this.capacity),128),this.arrayBuffer=new ArrayBuffer(this.capacity*this.bytesPerElement);const e=this.uint8;this._refreshViews(),e&&this.uint8.set(e);}}_refreshViews(){throw new Error("_refreshViews() must be implemented by each concrete StructArray layout")}destroy(){this.int8=this.uint8=this.int16=this.uint16=this.int32=this.uint32=this.float32=null,this.arrayBuffer=null;}}function _a(t,e=1){let i=0,r=0;return {members:t.map((t=>{const n=pa[t.type].BYTES_PER_ELEMENT,o=i=ga(i,Math.max(e,n)),s=t.components||1;return r=Math.max(r,n),i+=n*s,{name:t.name,type:t.type,components:s,offset:o}})),size:ga(i,Math.max(r,e)),alignment:e}}function ga(t,e){return Math.ceil(t/e)*e}class ya extends ma{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer);}emplaceBack(t,e){const i=this.length;return this.resize(i+1),this.emplace(i,t,e)}emplace(t,e,i){const r=2*t;return this.int16[r+0]=e,this.int16[r+1]=i,t}}ya.prototype.bytesPerElement=4,Ss(ya,"StructArrayLayout2i4");class xa extends ma{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer);}emplaceBack(t,e,i){const r=this.length;return this.resize(r+1),this.emplace(r,t,e,i)}emplace(t,e,i,r){const n=3*t;return this.int16[n+0]=e,this.int16[n+1]=i,this.int16[n+2]=r,t}}xa.prototype.bytesPerElement=6,Ss(xa,"StructArrayLayout3i6");class va extends ma{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer);}emplaceBack(t,e,i,r){const n=this.length;return this.resize(n+1),this.emplace(n,t,e,i,r)}emplace(t,e,i,r,n){const o=4*t;return this.int16[o+0]=e,this.int16[o+1]=i,this.int16[o+2]=r,this.int16[o+3]=n,t}}va.prototype.bytesPerElement=8,Ss(va,"StructArrayLayout4i8");class ba extends ma{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer);}emplaceBack(t,e,i,r,n){const o=this.length;return this.resize(o+1),this.emplace(o,t,e,i,r,n)}emplace(t,e,i,r,n,o){const s=5*t;return this.int16[s+0]=e,this.int16[s+1]=i,this.int16[s+2]=r,this.int16[s+3]=n,this.int16[s+4]=o,t}}ba.prototype.bytesPerElement=10,Ss(ba,"StructArrayLayout5i10");class wa extends ma{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer);}emplaceBack(t,e,i,r,n,o,s){const a=this.length;return this.resize(a+1),this.emplace(a,t,e,i,r,n,o,s)}emplace(t,e,i,r,n,o,s,a){const l=6*t,c=12*t,h=3*t;return this.int16[l+0]=e,this.int16[l+1]=i,this.uint8[c+4]=r,this.uint8[c+5]=n,this.uint8[c+6]=o,this.uint8[c+7]=s,this.float32[h+2]=a,t}}wa.prototype.bytesPerElement=12,Ss(wa,"StructArrayLayout2i4ub1f12");class Ta extends ma{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer);}emplaceBack(t,e,i,r){const n=this.length;return this.resize(n+1),this.emplace(n,t,e,i,r)}emplace(t,e,i,r,n){const o=4*t;return this.float32[o+0]=e,this.float32[o+1]=i,this.float32[o+2]=r,this.float32[o+3]=n,t}}Ta.prototype.bytesPerElement=16,Ss(Ta,"StructArrayLayout4f16");class Ea extends ma{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.uint16=new Uint16Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer);}emplaceBack(t,e,i,r,n){const o=this.length;return this.resize(o+1),this.emplace(o,t,e,i,r,n)}emplace(t,e,i,r,n,o){const s=6*t,a=3*t;return this.uint16[s+0]=e,this.uint16[s+1]=i,this.uint16[s+2]=r,this.uint16[s+3]=n,this.float32[a+2]=o,t}}Ea.prototype.bytesPerElement=12,Ss(Ea,"StructArrayLayout4ui1f12");class Ma extends ma{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.uint16=new Uint16Array(this.arrayBuffer);}emplaceBack(t,e,i,r){const n=this.length;return this.resize(n+1),this.emplace(n,t,e,i,r)}emplace(t,e,i,r,n){const o=4*t;return this.uint16[o+0]=e,this.uint16[o+1]=i,this.uint16[o+2]=r,this.uint16[o+3]=n,t}}Ma.prototype.bytesPerElement=8,Ss(Ma,"StructArrayLayout4ui8");class Aa extends ma{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer);}emplaceBack(t,e,i,r,n,o){const s=this.length;return this.resize(s+1),this.emplace(s,t,e,i,r,n,o)}emplace(t,e,i,r,n,o,s){const a=6*t;return this.int16[a+0]=e,this.int16[a+1]=i,this.int16[a+2]=r,this.int16[a+3]=n,this.int16[a+4]=o,this.int16[a+5]=s,t}}Aa.prototype.bytesPerElement=12,Ss(Aa,"StructArrayLayout6i12");class Sa extends ma{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer),this.uint16=new Uint16Array(this.arrayBuffer);}emplaceBack(t,e,i,r,n,o,s,a,l,c,h,u){const d=this.length;return this.resize(d+1),this.emplace(d,t,e,i,r,n,o,s,a,l,c,h,u)}emplace(t,e,i,r,n,o,s,a,l,c,h,u,d){const p=12*t;return this.int16[p+0]=e,this.int16[p+1]=i,this.int16[p+2]=r,this.int16[p+3]=n,this.uint16[p+4]=o,this.uint16[p+5]=s,this.uint16[p+6]=a,this.uint16[p+7]=l,this.int16[p+8]=c,this.int16[p+9]=h,this.int16[p+10]=u,this.int16[p+11]=d,t}}Sa.prototype.bytesPerElement=24,Ss(Sa,"StructArrayLayout4i4ui4i24");class Ia extends ma{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer);}emplaceBack(t,e,i,r,n,o){const s=this.length;return this.resize(s+1),this.emplace(s,t,e,i,r,n,o)}emplace(t,e,i,r,n,o,s){const a=10*t,l=5*t;return this.int16[a+0]=e,this.int16[a+1]=i,this.int16[a+2]=r,this.float32[l+2]=n,this.float32[l+3]=o,this.float32[l+4]=s,t}}Ia.prototype.bytesPerElement=20,Ss(Ia,"StructArrayLayout3i3f20");class Ca extends ma{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.uint32=new Uint32Array(this.arrayBuffer);}emplaceBack(t){const e=this.length;return this.resize(e+1),this.emplace(e,t)}emplace(t,e){return this.uint32[1*t+0]=e,t}}Ca.prototype.bytesPerElement=4,Ss(Ca,"StructArrayLayout1ul4");class za extends ma{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.uint16=new Uint16Array(this.arrayBuffer);}emplaceBack(t,e){const i=this.length;return this.resize(i+1),this.emplace(i,t,e)}emplace(t,e,i){const r=2*t;return this.uint16[r+0]=e,this.uint16[r+1]=i,t}}za.prototype.bytesPerElement=4,Ss(za,"StructArrayLayout2ui4");class Da extends ma{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer),this.uint32=new Uint32Array(this.arrayBuffer),this.uint16=new Uint16Array(this.arrayBuffer);}emplaceBack(t,e,i,r,n,o,s,a,l,c,h,u,d){const p=this.length;return this.resize(p+1),this.emplace(p,t,e,i,r,n,o,s,a,l,c,h,u,d)}emplace(t,e,i,r,n,o,s,a,l,c,h,u,d,p){const f=20*t,m=10*t;return this.int16[f+0]=e,this.int16[f+1]=i,this.int16[f+2]=r,this.int16[f+3]=n,this.int16[f+4]=o,this.float32[m+3]=s,this.float32[m+4]=a,this.float32[m+5]=l,this.float32[m+6]=c,this.int16[f+14]=h,this.uint32[m+8]=u,this.uint16[f+18]=d,this.uint16[f+19]=p,t}}Da.prototype.bytesPerElement=40,Ss(Da,"StructArrayLayout5i4f1i1ul2ui40");class Pa extends ma{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer);}emplaceBack(t,e,i,r,n,o,s){const a=this.length;return this.resize(a+1),this.emplace(a,t,e,i,r,n,o,s)}emplace(t,e,i,r,n,o,s,a){const l=8*t;return this.int16[l+0]=e,this.int16[l+1]=i,this.int16[l+2]=r,this.int16[l+4]=n,this.int16[l+5]=o,this.int16[l+6]=s,this.int16[l+7]=a,t}}Pa.prototype.bytesPerElement=16,Ss(Pa,"StructArrayLayout3i2i2i16");class Ra extends ma{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer);}emplaceBack(t,e,i,r,n){const o=this.length;return this.resize(o+1),this.emplace(o,t,e,i,r,n)}emplace(t,e,i,r,n,o){const s=4*t,a=8*t;return this.float32[s+0]=e,this.float32[s+1]=i,this.float32[s+2]=r,this.int16[a+6]=n,this.int16[a+7]=o,t}}Ra.prototype.bytesPerElement=16,Ss(Ra,"StructArrayLayout2f1f2i16");class La extends ma{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer);}emplaceBack(t,e,i,r){const n=this.length;return this.resize(n+1),this.emplace(n,t,e,i,r)}emplace(t,e,i,r,n){const o=12*t,s=3*t;return this.uint8[o+0]=e,this.uint8[o+1]=i,this.float32[s+1]=r,this.float32[s+2]=n,t}}La.prototype.bytesPerElement=12,Ss(La,"StructArrayLayout2ub2f12");class ka extends ma{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer);}emplaceBack(t,e,i){const r=this.length;return this.resize(r+1),this.emplace(r,t,e,i)}emplace(t,e,i,r){const n=3*t;return this.float32[n+0]=e,this.float32[n+1]=i,this.float32[n+2]=r,t}}ka.prototype.bytesPerElement=12,Ss(ka,"StructArrayLayout3f12");class Ba extends ma{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.uint16=new Uint16Array(this.arrayBuffer);}emplaceBack(t,e,i){const r=this.length;return this.resize(r+1),this.emplace(r,t,e,i)}emplace(t,e,i,r){const n=3*t;return this.uint16[n+0]=e,this.uint16[n+1]=i,this.uint16[n+2]=r,t}}Ba.prototype.bytesPerElement=6,Ss(Ba,"StructArrayLayout3ui6");class Oa extends ma{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer),this.uint16=new Uint16Array(this.arrayBuffer),this.uint32=new Uint32Array(this.arrayBuffer);}emplaceBack(t,e,i,r,n,o,s,a,l,c,h,u,d,p,f,m,_,g,y,x,v){const b=this.length;return this.resize(b+1),this.emplace(b,t,e,i,r,n,o,s,a,l,c,h,u,d,p,f,m,_,g,y,x,v)}emplace(t,e,i,r,n,o,s,a,l,c,h,u,d,p,f,m,_,g,y,x,v,b){const w=30*t,T=15*t,E=60*t;return this.int16[w+0]=e,this.int16[w+1]=i,this.int16[w+2]=r,this.float32[T+2]=n,this.float32[T+3]=o,this.uint16[w+8]=s,this.uint16[w+9]=a,this.uint32[T+5]=l,this.uint32[T+6]=c,this.uint32[T+7]=h,this.uint16[w+16]=u,this.uint16[w+17]=d,this.uint16[w+18]=p,this.float32[T+10]=f,this.float32[T+11]=m,this.uint8[E+48]=_,this.uint8[E+49]=g,this.uint8[E+50]=y,this.uint32[T+13]=x,this.int16[w+28]=v,this.uint8[E+58]=b,t}}Oa.prototype.bytesPerElement=60,Ss(Oa,"StructArrayLayout3i2f2ui3ul3ui2f3ub1ul1i1ub60");class Fa extends ma{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer),this.uint16=new Uint16Array(this.arrayBuffer),this.uint32=new Uint32Array(this.arrayBuffer);}emplaceBack(t,e,i,r,n,o,s,a,l,c,h,u,d,p,f,m,_,g,y,x,v,b,w,T,E,M,A,S,I,C,z,D){const P=this.length;return this.resize(P+1),this.emplace(P,t,e,i,r,n,o,s,a,l,c,h,u,d,p,f,m,_,g,y,x,v,b,w,T,E,M,A,S,I,C,z,D)}emplace(t,e,i,r,n,o,s,a,l,c,h,u,d,p,f,m,_,g,y,x,v,b,w,T,E,M,A,S,I,C,z,D,P){const R=20*t,L=40*t,k=80*t;return this.float32[R+0]=e,this.float32[R+1]=i,this.int16[L+4]=r,this.int16[L+5]=n,this.int16[L+6]=o,this.int16[L+7]=s,this.int16[L+8]=a,this.int16[L+9]=l,this.int16[L+10]=c,this.int16[L+11]=h,this.int16[L+12]=u,this.uint16[L+13]=d,this.uint16[L+14]=p,this.uint16[L+15]=f,this.uint16[L+16]=m,this.uint16[L+17]=_,this.uint16[L+18]=g,this.uint16[L+19]=y,this.uint16[L+20]=x,this.uint16[L+21]=v,this.uint16[L+22]=b,this.uint16[L+23]=w,this.uint16[L+24]=T,this.uint16[L+25]=E,this.uint16[L+26]=M,this.uint16[L+27]=A,this.uint32[R+14]=S,this.float32[R+15]=I,this.float32[R+16]=C,this.float32[R+17]=z,this.float32[R+18]=D,this.uint8[k+76]=P,t}}Fa.prototype.bytesPerElement=80,Ss(Fa,"StructArrayLayout2f9i15ui1ul4f1ub80");class Na extends ma{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer);}emplaceBack(t){const e=this.length;return this.resize(e+1),this.emplace(e,t)}emplace(t,e){return this.float32[1*t+0]=e,t}}Na.prototype.bytesPerElement=4,Ss(Na,"StructArrayLayout1f4");class Ua extends ma{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer);}emplaceBack(t,e,i,r,n){const o=this.length;return this.resize(o+1),this.emplace(o,t,e,i,r,n)}emplace(t,e,i,r,n,o){const s=5*t;return this.float32[s+0]=e,this.float32[s+1]=i,this.float32[s+2]=r,this.float32[s+3]=n,this.float32[s+4]=o,t}}Ua.prototype.bytesPerElement=20,Ss(Ua,"StructArrayLayout5f20");class Va extends ma{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer);}emplaceBack(t,e,i,r,n,o,s){const a=this.length;return this.resize(a+1),this.emplace(a,t,e,i,r,n,o,s)}emplace(t,e,i,r,n,o,s,a){const l=7*t;return this.float32[l+0]=e,this.float32[l+1]=i,this.float32[l+2]=r,this.float32[l+3]=n,this.float32[l+4]=o,this.float32[l+5]=s,this.float32[l+6]=a,t}}Va.prototype.bytesPerElement=28,Ss(Va,"StructArrayLayout7f28");class ja extends ma{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.uint32=new Uint32Array(this.arrayBuffer),this.uint16=new Uint16Array(this.arrayBuffer);}emplaceBack(t,e,i,r){const n=this.length;return this.resize(n+1),this.emplace(n,t,e,i,r)}emplace(t,e,i,r,n){const o=6*t;return this.uint32[3*t+0]=e,this.uint16[o+2]=i,this.uint16[o+3]=r,this.uint16[o+4]=n,t}}ja.prototype.bytesPerElement=12,Ss(ja,"StructArrayLayout1ul3ui12");class Ga extends ma{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.uint16=new Uint16Array(this.arrayBuffer);}emplaceBack(t){const e=this.length;return this.resize(e+1),this.emplace(e,t)}emplace(t,e){return this.uint16[1*t+0]=e,t}}Ga.prototype.bytesPerElement=2,Ss(Ga,"StructArrayLayout1ui2");class qa extends ma{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer);}emplaceBack(t,e){const i=this.length;return this.resize(i+1),this.emplace(i,t,e)}emplace(t,e,i){const r=2*t;return this.float32[r+0]=e,this.float32[r+1]=i,t}}qa.prototype.bytesPerElement=8,Ss(qa,"StructArrayLayout2f8");class Za extends ma{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer);}emplaceBack(t,e,i,r,n,o,s,a,l,c,h,u,d,p,f,m){const _=this.length;return this.resize(_+1),this.emplace(_,t,e,i,r,n,o,s,a,l,c,h,u,d,p,f,m)}emplace(t,e,i,r,n,o,s,a,l,c,h,u,d,p,f,m,_){const g=16*t;return this.float32[g+0]=e,this.float32[g+1]=i,this.float32[g+2]=r,this.float32[g+3]=n,this.float32[g+4]=o,this.float32[g+5]=s,this.float32[g+6]=a,this.float32[g+7]=l,this.float32[g+8]=c,this.float32[g+9]=h,this.float32[g+10]=u,this.float32[g+11]=d,this.float32[g+12]=p,this.float32[g+13]=f,this.float32[g+14]=m,this.float32[g+15]=_,t}}Za.prototype.bytesPerElement=64,Ss(Za,"StructArrayLayout16f64");class $a extends ma{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.uint16=new Uint16Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer);}emplaceBack(t,e,i,r,n,o,s){const a=this.length;return this.resize(a+1),this.emplace(a,t,e,i,r,n,o,s)}emplace(t,e,i,r,n,o,s,a){const l=10*t,c=5*t;return this.uint16[l+0]=e,this.uint16[l+1]=i,this.uint16[l+2]=r,this.uint16[l+3]=n,this.float32[c+2]=o,this.float32[c+3]=s,this.float32[c+4]=a,t}}$a.prototype.bytesPerElement=20,Ss($a,"StructArrayLayout4ui3f20");class Ha extends ma{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer);}emplaceBack(t){const e=this.length;return this.resize(e+1),this.emplace(e,t)}emplace(t,e){return this.uint8[1*t+0]=e,t}}Ha.prototype.bytesPerElement=1,Ss(Ha,"StructArrayLayout1ub1");class Wa extends fa{get projectedAnchorX(){return this._structArray.int16[this._pos2+0]}get projectedAnchorY(){return this._structArray.int16[this._pos2+1]}get projectedAnchorZ(){return this._structArray.int16[this._pos2+2]}get tileAnchorX(){return this._structArray.int16[this._pos2+3]}get tileAnchorY(){return this._structArray.int16[this._pos2+4]}get x1(){return this._structArray.float32[this._pos4+3]}get y1(){return this._structArray.float32[this._pos4+4]}get x2(){return this._structArray.float32[this._pos4+5]}get y2(){return this._structArray.float32[this._pos4+6]}get padding(){return this._structArray.int16[this._pos2+14]}get featureIndex(){return this._structArray.uint32[this._pos4+8]}get sourceLayerIndex(){return this._structArray.uint16[this._pos2+18]}get bucketIndex(){return this._structArray.uint16[this._pos2+19]}}Wa.prototype.size=40;class Xa extends Da{get(t){return new Wa(this,t)}}Ss(Xa,"CollisionBoxArray");class Ya extends fa{get projectedAnchorX(){return this._structArray.int16[this._pos2+0]}get projectedAnchorY(){return this._structArray.int16[this._pos2+1]}get projectedAnchorZ(){return this._structArray.int16[this._pos2+2]}get tileAnchorX(){return this._structArray.float32[this._pos4+2]}get tileAnchorY(){return this._structArray.float32[this._pos4+3]}get glyphStartIndex(){return this._structArray.uint16[this._pos2+8]}get numGlyphs(){return this._structArray.uint16[this._pos2+9]}get vertexStartIndex(){return this._structArray.uint32[this._pos4+5]}get lineStartIndex(){return this._structArray.uint32[this._pos4+6]}get lineLength(){return this._structArray.uint32[this._pos4+7]}get segment(){return this._structArray.uint16[this._pos2+16]}get lowerSize(){return this._structArray.uint16[this._pos2+17]}get upperSize(){return this._structArray.uint16[this._pos2+18]}get lineOffsetX(){return this._structArray.float32[this._pos4+10]}get lineOffsetY(){return this._structArray.float32[this._pos4+11]}get writingMode(){return this._structArray.uint8[this._pos1+48]}get placedOrientation(){return this._structArray.uint8[this._pos1+49]}set placedOrientation(t){this._structArray.uint8[this._pos1+49]=t;}get hidden(){return this._structArray.uint8[this._pos1+50]}set hidden(t){this._structArray.uint8[this._pos1+50]=t;}get crossTileID(){return this._structArray.uint32[this._pos4+13]}set crossTileID(t){this._structArray.uint32[this._pos4+13]=t;}get associatedIconIndex(){return this._structArray.int16[this._pos2+28]}get flipState(){return this._structArray.uint8[this._pos1+58]}set flipState(t){this._structArray.uint8[this._pos1+58]=t;}}Ya.prototype.size=60;class Ka extends Oa{get(t){return new Ya(this,t)}}Ss(Ka,"PlacedSymbolArray");class Ja extends fa{get tileAnchorX(){return this._structArray.float32[this._pos4+0]}get tileAnchorY(){return this._structArray.float32[this._pos4+1]}get projectedAnchorX(){return this._structArray.int16[this._pos2+4]}get projectedAnchorY(){return this._structArray.int16[this._pos2+5]}get projectedAnchorZ(){return this._structArray.int16[this._pos2+6]}get rightJustifiedTextSymbolIndex(){return this._structArray.int16[this._pos2+7]}get centerJustifiedTextSymbolIndex(){return this._structArray.int16[this._pos2+8]}get leftJustifiedTextSymbolIndex(){return this._structArray.int16[this._pos2+9]}get verticalPlacedTextSymbolIndex(){return this._structArray.int16[this._pos2+10]}get placedIconSymbolIndex(){return this._structArray.int16[this._pos2+11]}get verticalPlacedIconSymbolIndex(){return this._structArray.int16[this._pos2+12]}get key(){return this._structArray.uint16[this._pos2+13]}get textBoxStartIndex(){return this._structArray.uint16[this._pos2+14]}get textBoxEndIndex(){return this._structArray.uint16[this._pos2+15]}get verticalTextBoxStartIndex(){return this._structArray.uint16[this._pos2+16]}get verticalTextBoxEndIndex(){return this._structArray.uint16[this._pos2+17]}get iconBoxStartIndex(){return this._structArray.uint16[this._pos2+18]}get iconBoxEndIndex(){return this._structArray.uint16[this._pos2+19]}get verticalIconBoxStartIndex(){return this._structArray.uint16[this._pos2+20]}get verticalIconBoxEndIndex(){return this._structArray.uint16[this._pos2+21]}get featureIndex(){return this._structArray.uint16[this._pos2+22]}get numHorizontalGlyphVertices(){return this._structArray.uint16[this._pos2+23]}get numVerticalGlyphVertices(){return this._structArray.uint16[this._pos2+24]}get numIconVertices(){return this._structArray.uint16[this._pos2+25]}get numVerticalIconVertices(){return this._structArray.uint16[this._pos2+26]}get useRuntimeCollisionCircles(){return this._structArray.uint16[this._pos2+27]}get crossTileID(){return this._structArray.uint32[this._pos4+14]}set crossTileID(t){this._structArray.uint32[this._pos4+14]=t;}get textOffset0(){return this._structArray.float32[this._pos4+15]}get textOffset1(){return this._structArray.float32[this._pos4+16]}get collisionCircleDiameter(){return this._structArray.float32[this._pos4+17]}get zOffset(){return this._structArray.float32[this._pos4+18]}set zOffset(t){this._structArray.float32[this._pos4+18]=t;}get hasIconTextFit(){return this._structArray.uint8[this._pos1+76]}}Ja.prototype.size=80;class Qa extends Fa{get(t){return new Ja(this,t)}}Ss(Qa,"SymbolInstanceArray");class tl extends Na{getoffsetX(t){return this.float32[1*t+0]}}Ss(tl,"GlyphOffsetArray");class el extends ya{getx(t){return this.int16[2*t+0]}gety(t){return this.int16[2*t+1]}}Ss(el,"SymbolLineVertexArray");class il extends fa{get featureIndex(){return this._structArray.uint32[this._pos4+0]}get sourceLayerIndex(){return this._structArray.uint16[this._pos2+2]}get bucketIndex(){return this._structArray.uint16[this._pos2+3]}get layoutVertexArrayOffset(){return this._structArray.uint16[this._pos2+4]}}il.prototype.size=12;class rl extends ja{get(t){return new il(this,t)}}Ss(rl,"FeatureIndexArray");class nl extends za{geta_centroid_pos0(t){return this.uint16[2*t+0]}geta_centroid_pos1(t){return this.uint16[2*t+1]}}Ss(nl,"FillExtrusionCentroidArray");const ol=_a([{name:"a_pattern",components:4,type:"Uint16"},{name:"a_pixel_ratio",components:1,type:"Float32"}]),sl=_a([{name:"a_dash",components:4,type:"Uint16"}]);var al={exports:{}},ll={exports:{}};!function(t){t.exports=function(t,e){var i,r,n,o,s,a,l,c;for(r=t.length-(i=3&t.length),n=e,s=3432918353,a=461845907,c=0;c<r;)l=255&t.charCodeAt(c)|(255&t.charCodeAt(++c))<<8|(255&t.charCodeAt(++c))<<16|(255&t.charCodeAt(++c))<<24,++c,n=27492+(65535&(o=5*(65535&(n=(n^=l=(65535&(l=(l=(65535&l)*s+(((l>>>16)*s&65535)<<16)&4294967295)<<15|l>>>17))*a+(((l>>>16)*a&65535)<<16)&4294967295)<<13|n>>>19))+((5*(n>>>16)&65535)<<16)&4294967295))+((58964+(o>>>16)&65535)<<16);switch(l=0,i){case 3:l^=(255&t.charCodeAt(c+2))<<16;case 2:l^=(255&t.charCodeAt(c+1))<<8;case 1:n^=l=(65535&(l=(l=(65535&(l^=255&t.charCodeAt(c)))*s+(((l>>>16)*s&65535)<<16)&4294967295)<<15|l>>>17))*a+(((l>>>16)*a&65535)<<16)&4294967295;}return n^=t.length,n=2246822507*(65535&(n^=n>>>16))+((2246822507*(n>>>16)&65535)<<16)&4294967295,n=3266489909*(65535&(n^=n>>>13))+((3266489909*(n>>>16)&65535)<<16)&4294967295,(n^=n>>>16)>>>0};}(ll);var cl=ll.exports,hl={exports:{}};!function(t){t.exports=function(t,e){for(var i,r=t.length,n=e^r,o=0;r>=4;)i=1540483477*(65535&(i=255&t.charCodeAt(o)|(255&t.charCodeAt(++o))<<8|(255&t.charCodeAt(++o))<<16|(255&t.charCodeAt(++o))<<24))+((1540483477*(i>>>16)&65535)<<16),n=1540483477*(65535&n)+((1540483477*(n>>>16)&65535)<<16)^(i=1540483477*(65535&(i^=i>>>24))+((1540483477*(i>>>16)&65535)<<16)),r-=4,++o;switch(r){case 3:n^=(255&t.charCodeAt(o+2))<<16;case 2:n^=(255&t.charCodeAt(o+1))<<8;case 1:n=1540483477*(65535&(n^=255&t.charCodeAt(o)))+((1540483477*(n>>>16)&65535)<<16);}return n=1540483477*(65535&(n^=n>>>13))+((1540483477*(n>>>16)&65535)<<16),(n^=n>>>15)>>>0};}(hl);var ul=cl,dl=hl.exports;al.exports=ul,al.exports.murmur3=ul,al.exports.murmur2=dl;var pl=d(al.exports);class fl{constructor(){this.ids=[],this.uniqueIds=[],this.positions=[],this.indexed=!1;}add(t,e,i,r){this.ids.push(ml(t)),this.positions.push(e,i,r);}eachPosition(t,e){const i=ml(t);let r=0,n=this.ids.length-1;for(;r<n;){const t=r+n>>1;this.ids[t]>=i?n=t:r=t+1;}for(;this.ids[r]===i;)e(this.positions[3*r],this.positions[3*r+1],this.positions[3*r+2]),r++;}static serialize(t,e){const i=new Float64Array(t.ids),r=new Uint32Array(t.positions);return _l(i,r,0,i.length-1),e&&e.push(i.buffer,r.buffer),{ids:i,positions:r}}static deserialize(t){const e=new fl;let i;e.ids=t.ids,e.positions=t.positions;for(const t of e.ids)t!==i&&e.uniqueIds.push(t),i=t;return e.indexed=!0,e}}function ml(t){const e=+t;return !isNaN(e)&&Number.MIN_SAFE_INTEGER<=e&&e<=Number.MAX_SAFE_INTEGER?e:pl(String(t))}function _l(t,e,i,r){for(;i<r;){const n=t[i+r>>1];let o=i-1,s=r+1;for(;;){do{o++;}while(t[o]<n);do{s--;}while(t[s]>n);if(o>=s)break;gl(t,o,s),gl(e,3*o,3*s),gl(e,3*o+1,3*s+1),gl(e,3*o+2,3*s+2);}s-i<r-s?(_l(t,e,i,s),i=s+1):(_l(t,e,s+1,r),r=s);}}function gl(t,e,i){const r=t[e];t[e]=t[i],t[i]=r;}Ss(fl,"FeaturePositionMap");class yl{constructor(t){this.gl=t.gl,this.initialized=!1;}fetchUniformLocation(t,e){return this.location||this.initialized||(this.location=this.gl.getUniformLocation(t,e),this.initialized=!0),!!this.location}}class xl extends yl{constructor(t){super(t),this.current=0;}set(t,e,i){this.fetchUniformLocation(t,e)&&this.current!==i&&(this.current=i,this.gl.uniform1i(this.location,i));}}class vl extends yl{constructor(t){super(t),this.current=0;}set(t,e,i){this.fetchUniformLocation(t,e)&&this.current!==i&&(this.current=i,this.gl.uniform1f(this.location,i));}}class bl extends yl{constructor(t){super(t),this.current=[0,0];}set(t,e,i){this.fetchUniformLocation(t,e)&&(i[0]===this.current[0]&&i[1]===this.current[1]||(this.current=i,this.gl.uniform2f(this.location,i[0],i[1])));}}class wl extends yl{constructor(t){super(t),this.current=[0,0,0];}set(t,e,i){this.fetchUniformLocation(t,e)&&(i[0]===this.current[0]&&i[1]===this.current[1]&&i[2]===this.current[2]||(this.current=i,this.gl.uniform3f(this.location,i[0],i[1],i[2])));}}class Tl extends yl{constructor(t){super(t),this.current=[0,0,0,0];}set(t,e,i){this.fetchUniformLocation(t,e)&&(i[0]===this.current[0]&&i[1]===this.current[1]&&i[2]===this.current[2]&&i[3]===this.current[3]||(this.current=i,this.gl.uniform4f(this.location,i[0],i[1],i[2],i[3])));}}class El extends yl{constructor(t){super(t),this.current=li.transparent;}set(t,e,i){this.fetchUniformLocation(t,e)&&(i.r===this.current.r&&i.g===this.current.g&&i.b===this.current.b&&i.a===this.current.a||(this.current=i,this.gl.uniform4f(this.location,i.r,i.g,i.b,i.a)));}}const Ml=new Float32Array(16);class Al extends yl{constructor(t){super(t),this.current=Ml;}set(t,e,i){if(this.fetchUniformLocation(t,e)){if(i[12]!==this.current[12]||i[0]!==this.current[0])return this.current=i,void this.gl.uniformMatrix4fv(this.location,!1,i);for(let t=1;t<16;t++)if(i[t]!==this.current[t]){this.current=i,this.gl.uniformMatrix4fv(this.location,!1,i);break}}}}const Sl=new Float32Array(9);class Il extends yl{constructor(t){super(t),this.current=Sl;}set(t,e,i){if(this.fetchUniformLocation(t,e))for(let t=0;t<9;t++)if(i[t]!==this.current[t]){this.current=i,this.gl.uniformMatrix3fv(this.location,!1,i);break}}}const Cl=new Float32Array(4);class zl extends yl{constructor(t){super(t),this.current=Cl;}set(t,e,i){if(this.fetchUniformLocation(t,e))for(let t=0;t<4;t++)if(i[t]!==this.current[t]){this.current=i,this.gl.uniformMatrix2fv(this.location,!1,i);break}}}function Dl(t){return [da(255*t.r,255*t.g),da(255*t.b,255*t.a)]}class Pl{constructor(t,e,i){this.value=t,this.uniformNames=e.map((t=>`u_${t}`)),this.type=i;}setUniform(t,e,i,r,n){e.set(t,n,r.constantOr(this.value));}getBinding(t,e){return "color"===this.type?new El(t):new vl(t)}}class Rl{constructor(t,e){this.uniformNames=e.map((t=>`u_${t}`)),this.pattern=null,this.pixelRatio=1;}setConstantPatternPositions(t){this.pixelRatio=t.pixelRatio||1,this.pattern=t.tl.concat(t.br);}setUniform(t,e,i,r,n){const o="u_pattern"===n||"u_dash"===n?this.pattern:"u_pixel_ratio"===n?this.pixelRatio:null;o&&e.set(t,n,o);}getBinding(t,e){return "u_pattern"===e||"u_dash"===e?new Tl(t):new vl(t)}}class Ll{constructor(t,e,i,r){this.expression=t,this.type=i,this.maxValue=0,this.paintVertexAttributes=e.map((t=>({name:`a_${t}`,type:"Float32",components:"color"===i?2:1,offset:0}))),this.paintVertexArray=new r;}populatePaintArray(t,e,i,r,n,o,s){const a=this.paintVertexArray.length,l=this.expression.evaluate(new Qs(0,{brightness:o}),e,{},n,r,s);this.paintVertexArray.resize(t),this._setPaintValue(a,t,l);}updatePaintArray(t,e,i,r,n,o,s){const a=this.expression.evaluate({zoom:0,brightness:s},i,r,void 0,n);this._setPaintValue(t,e,a);}_setPaintValue(t,e,i){if("color"===this.type){const r=Dl(i);for(let i=t;i<e;i++)this.paintVertexArray.emplace(i,r[0],r[1]);}else {for(let r=t;r<e;r++)this.paintVertexArray.emplace(r,i);this.maxValue=Math.max(this.maxValue,Math.abs(i));}}upload(t){this.paintVertexArray&&this.paintVertexArray.arrayBuffer&&(this.paintVertexBuffer&&this.paintVertexBuffer.buffer?this.paintVertexBuffer.updateData(this.paintVertexArray):this.paintVertexBuffer=t.createVertexBuffer(this.paintVertexArray,this.paintVertexAttributes,this.expression.isStateDependent||!this.expression.isLightConstant));}destroy(){this.paintVertexBuffer&&this.paintVertexBuffer.destroy();}}class kl{constructor(t,e,i,r,n,o){this.expression=t,this.uniformNames=e.map((t=>`u_${t}_t`)),this.type=i,this.useIntegerZoom=r,this.zoom=n,this.maxValue=0,this.paintVertexAttributes=e.map((t=>({name:`a_${t}`,type:"Float32",components:"color"===i?4:2,offset:0}))),this.paintVertexArray=new o;}populatePaintArray(t,e,i,r,n,o,s){const a=this.expression.evaluate(new Qs(this.zoom,{brightness:o}),e,{},n,r,s),l=this.expression.evaluate(new Qs(this.zoom+1,{brightness:o}),e,{},n,r,s),c=this.paintVertexArray.length;this.paintVertexArray.resize(t),this._setPaintValue(c,t,a,l);}updatePaintArray(t,e,i,r,n,o,s){const a=this.expression.evaluate({zoom:this.zoom,brightness:s},i,r,void 0,n),l=this.expression.evaluate({zoom:this.zoom+1,brightness:s},i,r,void 0,n);this._setPaintValue(t,e,a,l);}_setPaintValue(t,e,i,r){if("color"===this.type){const n=Dl(i),o=Dl(r);for(let i=t;i<e;i++)this.paintVertexArray.emplace(i,n[0],n[1],o[0],o[1]);}else {for(let n=t;n<e;n++)this.paintVertexArray.emplace(n,i,r);this.maxValue=Math.max(this.maxValue,Math.abs(i),Math.abs(r));}}upload(t){this.paintVertexArray&&this.paintVertexArray.arrayBuffer&&(this.paintVertexBuffer&&this.paintVertexBuffer.buffer?this.paintVertexBuffer.updateData(this.paintVertexArray):this.paintVertexBuffer=t.createVertexBuffer(this.paintVertexArray,this.paintVertexAttributes,this.expression.isStateDependent||!this.expression.isLightConstant));}destroy(){this.paintVertexBuffer&&this.paintVertexBuffer.destroy();}setUniform(t,e,i,r,n){const o=this.useIntegerZoom?Math.floor(i.zoom):i.zoom,s=z(this.expression.interpolationFactor(o,this.zoom,this.zoom+1),0,1);e.set(t,n,s);}getBinding(t,e){return new vl(t)}}class Bl{constructor(t,e,i,r,n){this.expression=t,this.layerId=n,this.paintVertexAttributes=("array"===i?sl:ol).members;for(let t=0;t<e.length;++t);this.paintVertexArray=new r;}populatePaintArray(t,e,i){const r=this.paintVertexArray.length;this.paintVertexArray.resize(t),this._setPaintValues(r,t,e.patterns&&e.patterns[this.layerId],i);}updatePaintArray(t,e,i,r,n,o,s){this._setPaintValues(t,e,i.patterns&&i.patterns[this.layerId],o);}_setPaintValues(t,e,i,r){if(!r||!i)return;const n=r[i];if(!n)return;const{tl:o,br:s,pixelRatio:a}=n;for(let i=t;i<e;i++)this.paintVertexArray.emplace(i,o[0],o[1],s[0],s[1],a);}upload(t){this.paintVertexArray&&this.paintVertexArray.arrayBuffer&&(this.paintVertexBuffer=t.createVertexBuffer(this.paintVertexArray,this.paintVertexAttributes,this.expression.isStateDependent||!this.expression.isLightConstant));}destroy(){this.paintVertexBuffer&&this.paintVertexBuffer.destroy();}}class Ol{constructor(t,e,i=(()=>!0)){this.binders={},this._buffers=[];const r=[];for(const n in t.paint._values){if(!i(n))continue;const o=t.paint.get(n);if(!(o instanceof sa&&ro(o.property.specification)))continue;const s=Ul(n,t.type),a=o.value,l=o.property.specification.type,c=!!o.property.useIntegerZoom,h="line-dasharray"===n||n.endsWith("pattern"),u="line-dasharray"===n&&"constant"!==t.layout.get("line-cap").value.kind;if("constant"!==a.kind||u)if("source"===a.kind||u||h){const e=Gl(n,l,"source");this.binders[n]=h?new Bl(a,s,l,e,t.id):new Ll(a,s,l,e),r.push(`/a_${n}`);}else {const t=Gl(n,l,"composite");this.binders[n]=new kl(a,s,l,c,e,t),r.push(`/z_${n}`);}else this.binders[n]=h?new Rl(a.value,s):new Pl(a.value,s,l),r.push(`/u_${n}`);}this.cacheKey=r.sort().join("");}getMaxValue(t){const e=this.binders[t];return e instanceof Ll||e instanceof kl?e.maxValue:0}populatePaintArrays(t,e,i,r,n,o,s){for(const a in this.binders){const l=this.binders[a];(l instanceof Ll||l instanceof kl||l instanceof Bl)&&l.populatePaintArray(t,e,i,r,n,o,s);}}setConstantPatternPositions(t){for(const e in this.binders){const i=this.binders[e];i instanceof Rl&&i.setConstantPatternPositions(t);}}updatePaintArrays(t,e,i,r,n,o,s,a){let l=!1;const c=Object.keys(t),h=0!==c.length,u=h?c:e.uniqueIds;for(const c in this.binders){const d=this.binders[c];if((d instanceof Ll||d instanceof kl||d instanceof Bl)&&(!0===d.expression.isStateDependent||!1===d.expression.isLightConstant)){const p=n.paint.get(c);d.expression=p.value;for(const i of u){const n=t[i.toString()];e.eachPosition(i,((t,e,i)=>{const l=r.feature(t);d.updatePaintArray(e,i,l,n,o,s,a);}));}if(!h)for(const e of i.uniqueIds){const n=t[e.toString()];i.eachPosition(e,((t,e,i)=>{const l=r.feature(t);d.updatePaintArray(e,i,l,n,o,s,a);}));}l=!0;}}return l}defines(){const t=[];for(const e in this.binders){const i=this.binders[e];(i instanceof Pl||i instanceof Rl)&&t.push(...i.uniformNames.map((t=>`#define HAS_UNIFORM_${t}`)));}return t}getBinderAttributes(){const t=[];for(const e in this.binders){const i=this.binders[e];if(i instanceof Ll||i instanceof kl||i instanceof Bl)for(let e=0;e<i.paintVertexAttributes.length;e++)t.push(i.paintVertexAttributes[e].name);}return t}getBinderUniforms(){const t=[];for(const e in this.binders){const i=this.binders[e];if(i instanceof Pl||i instanceof Rl||i instanceof kl)for(const e of i.uniformNames)t.push(e);}return t}getPaintVertexBuffers(){return this._buffers}getUniforms(t){const e=[];for(const i in this.binders){const r=this.binders[i];if(r instanceof Pl||r instanceof Rl||r instanceof kl)for(const n of r.uniformNames)e.push({name:n,property:i,binding:r.getBinding(t,n)});}return e}setUniforms(t,e,i,r,n){for(const{name:e,property:o,binding:s}of i)this.binders[o].setUniform(t,s,n,r.get(o),e);}updatePaintBuffers(){this._buffers=[];for(const t in this.binders){const e=this.binders[t];(e instanceof Ll||e instanceof kl||e instanceof Bl)&&e.paintVertexBuffer&&this._buffers.push(e.paintVertexBuffer);}}upload(t){for(const e in this.binders){const i=this.binders[e];(i instanceof Ll||i instanceof kl||i instanceof Bl)&&i.upload(t);}this.updatePaintBuffers();}destroy(){for(const t in this.binders){const e=this.binders[t];(e instanceof Ll||e instanceof kl||e instanceof Bl)&&e.destroy();}}}class Fl{constructor(t,e,i=(()=>!0)){this.programConfigurations={};for(const r of t)this.programConfigurations[r.id]=new Ol(r,e,i);this.needsUpload=!1,this._featureMap=new fl,this._featureMapWithoutIds=new fl,this._bufferOffset=0,this._idlessCounter=0;}populatePaintArrays(t,e,i,r,n,o,s,a){for(const i in this.programConfigurations)this.programConfigurations[i].populatePaintArrays(t,e,r,n,o,s,a);void 0!==e.id?this._featureMap.add(e.id,i,this._bufferOffset,t):(this._featureMapWithoutIds.add(this._idlessCounter,i,this._bufferOffset,t),this._idlessCounter+=1),this._bufferOffset=t,this.needsUpload=!0;}updatePaintArrays(t,e,i,r,n,o){for(const s of i)this.needsUpload=this.programConfigurations[s.id].updatePaintArrays(t,this._featureMap,this._featureMapWithoutIds,e,s,r,n,o||0)||this.needsUpload;}get(t){return this.programConfigurations[t]}upload(t){if(this.needsUpload){for(const e in this.programConfigurations)this.programConfigurations[e].upload(t);this.needsUpload=!1;}}destroy(){for(const t in this.programConfigurations)this.programConfigurations[t].destroy();}}const Nl={"text-opacity":["opacity"],"icon-opacity":["opacity"],"text-color":["fill_color"],"icon-color":["fill_color"],"text-emissive-strength":["emissive_strength"],"icon-emissive-strength":["emissive_strength"],"text-halo-color":["halo_color"],"icon-halo-color":["halo_color"],"text-halo-blur":["halo_blur"],"icon-halo-blur":["halo_blur"],"text-halo-width":["halo_width"],"icon-halo-width":["halo_width"],"line-gap-width":["gapwidth"],"line-pattern":["pattern","pixel_ratio"],"fill-pattern":["pattern","pixel_ratio"],"fill-extrusion-pattern":["pattern","pixel_ratio"],"line-dasharray":["dash"]};function Ul(t,e){return Nl[t]||[t.replace(`${e}-`,"").replace(/-/g,"_")]}const Vl={"line-pattern":{source:Ea,composite:Ea},"fill-pattern":{source:Ea,composite:Ea},"fill-extrusion-pattern":{source:Ea,composite:Ea},"line-dasharray":{source:Ma,composite:Ma}},jl={color:{source:qa,composite:Ta},number:{source:Na,composite:qa}};function Gl(t,e,i){const r=Vl[t];return r&&r[i]||jl[e][i]}Ss(Pl,"ConstantBinder"),Ss(Rl,"PatternConstantBinder"),Ss(Ll,"SourceExpressionBinder"),Ss(Bl,"PatternCompositeBinder"),Ss(kl,"CompositeExpressionBinder"),Ss(Ol,"ProgramConfiguration",{omit:["_buffers"]}),Ss(Fl,"ProgramConfigurationSet");const ql="-transition";class Zl extends Ce{constructor(t,e,i){if(super(),this.id=t.id,this.type=t.type,this._featureFilter={filter:()=>!0,needGeometry:!1,needFeature:!1},this._filterCompiled=!1,this.isConfigDependent=!1,"custom"!==t.type&&(this.metadata=t.metadata,this.minzoom=t.minzoom,this.maxzoom=t.maxzoom,"background"!==t.type&&"sky"!==t.type&&"slot"!==t.type&&(this.source=t.source,this.sourceLayer=t["source-layer"],this.filter=t.filter),this.options=i,t.slot&&(this.slot=t.slot),e.layout&&(this._unevaluatedLayout=new oa(e.layout,i),this.isConfigDependent=this.isConfigDependent||this._unevaluatedLayout.isConfigDependent),e.paint)){this._transitionablePaint=new ia(e.paint,i);for(const e in t.paint)this.setPaintProperty(e,t.paint[e],{validate:!1});for(const e in t.layout)this.setLayoutProperty(e,t.layout[e],{validate:!1});this.isConfigDependent=this.isConfigDependent||this._transitionablePaint.isConfigDependent,this._transitioningPaint=this._transitionablePaint.untransitioned(),this.paint=new aa(e.paint);}}getLayoutProperty(t){return "visibility"===t?this.visibility:this._unevaluatedLayout.getValue(t)}setLayoutProperty(t,e,i={}){null!=e&&this._validate(ys,`layers.${this.id}.layout.${t}`,t,e,i)||("custom"!==this.type||"visibility"!==t?(this._unevaluatedLayout.setValue(t,e),this.isConfigDependent=this.isConfigDependent||this._unevaluatedLayout.isConfigDependent,"visibility"===t&&this.possiblyEvaluateVisibility()):this.visibility=e);}possiblyEvaluateVisibility(){this.visibility=this._unevaluatedLayout._values.visibility.possiblyEvaluate({zoom:0});}getPaintProperty(t){return G(t,ql)?this._transitionablePaint.getTransition(t.slice(0,-11)):this._transitionablePaint.getValue(t)}setPaintProperty(t,e,i={}){if(null!=e&&this._validate(gs,`layers.${this.id}.paint.${t}`,t,e,i))return !1;if(G(t,ql))return this._transitionablePaint.setTransition(t.slice(0,-11),e||void 0),!1;{const i=this._transitionablePaint._values[t],r=i.value.isDataDriven(),n=i.value;this._transitionablePaint.setValue(t,e),this.isConfigDependent=this.isConfigDependent||this._transitionablePaint.isConfigDependent,this._handleSpecialPaintPropertyUpdate(t);const o=this._transitionablePaint._values[t].value,s=o.isDataDriven(),a=G(t,"pattern")||"line-dasharray"===t;return s||r||a||this._handleOverridablePaintPropertyUpdate(t,n,o)}}_handleSpecialPaintPropertyUpdate(t){}getProgramIds(){return null}getProgramConfiguration(t){return null}_handleOverridablePaintPropertyUpdate(t,e,i){return !1}isHidden(t){return !!(this.minzoom&&t<this.minzoom)||!!(this.maxzoom&&t>=this.maxzoom)||"none"===this.visibility}updateTransitions(t){this._transitioningPaint=this._transitionablePaint.transitioned(t,this._transitioningPaint);}hasTransition(){return this._transitioningPaint.hasTransition()}recalculate(t,e){this._unevaluatedLayout&&(this.layout=this._unevaluatedLayout.possiblyEvaluate(t,void 0,e)),this.paint=this._transitioningPaint.possiblyEvaluate(t,void 0,e);}serialize(){return Z({id:this.id,type:this.type,source:this.source,"source-layer":this.sourceLayer,metadata:this.metadata,minzoom:this.minzoom,maxzoom:this.maxzoom,filter:this.filter,layout:this._unevaluatedLayout&&this._unevaluatedLayout.serialize(),paint:this._transitionablePaint&&this._transitionablePaint.serialize()},((t,e)=>!(void 0===t||"layout"===e&&!Object.keys(t).length||"paint"===e&&!Object.keys(t).length)))}_validate(t,e,i,r,n={}){return (!n||!1!==n.validate)&&bs(this,t.call(cs,{key:e,layerType:this.type,objectKey:i,value:r,styleSpec:ze,style:{glyphs:!0,sprite:!0}}))}is3D(){return !1}isSky(){return !1}isTileClipped(){return !1}hasOffscreenPass(){return !1}hasShadowPass(){return !1}canCastShadows(){return !1}hasLightBeamPass(){return !1}cutoffRange(){return 0}resize(){}isStateDependent(){for(const t in this.paint._values){const e=this.paint.get(t);if(e instanceof sa&&ro(e.property.specification)&&("source"===e.value.kind||"composite"===e.value.kind)&&e.value.isStateDependent)return !0}return !1}compileFilter(){this._filterCompiled||(this._featureFilter=Po(this.filter),this._filterCompiled=!0);}invalidateCompiledFilter(){this._filterCompiled=!1;}dynamicFilter(){return this._featureFilter.dynamicFilter}dynamicFilterNeedsFeature(){return this._featureFilter.needFeature}}const $l=_a([{name:"a_pos",components:2,type:"Int16"}],4),Hl=_a([{name:"a_pos_3",components:3,type:"Int16"},{name:"a_pos_normal_3",components:3,type:"Int16"}]);class Wl{constructor(t=[]){this.segments=t;}_prepareSegment(t,e,i,r){let n=this.segments[this.segments.length-1];return t>Wl.MAX_VERTEX_ARRAY_LENGTH&&W(`Max vertices per segment is ${Wl.MAX_VERTEX_ARRAY_LENGTH}: bucket requested ${t}`),(!n||n.vertexLength+t>Wl.MAX_VERTEX_ARRAY_LENGTH||n.sortKey!==r)&&(n={vertexOffset:e,primitiveOffset:i,vertexLength:0,primitiveLength:0},void 0!==r&&(n.sortKey=r),this.segments.push(n)),n}prepareSegment(t,e,i,r){return this._prepareSegment(t,e.length,i.length,r)}get(){return this.segments}destroy(){for(const t of this.segments)for(const e in t.vaos)t.vaos[e].destroy();}static simpleSegment(t,e,i,r){return new Wl([{vertexOffset:t,primitiveOffset:e,vertexLength:i,primitiveLength:r,vaos:{},sortKey:0}])}}Wl.MAX_VERTEX_ARRAY_LENGTH=Math.pow(2,16)-1,Ss(Wl,"SegmentVector");class Xl{constructor(t,e){t&&(e?this.setSouthWest(t).setNorthEast(e):4===t.length?this.setSouthWest([t[0],t[1]]).setNorthEast([t[2],t[3]]):this.setSouthWest(t[0]).setNorthEast(t[1]));}setNorthEast(t){return this._ne=t instanceof Id?new Id(t.lng,t.lat):Id.convert(t),this}setSouthWest(t){return this._sw=t instanceof Id?new Id(t.lng,t.lat):Id.convert(t),this}extend(t){const e=this._sw,i=this._ne;let r,n;if(t instanceof Id)r=t,n=t;else {if(!(t instanceof Xl))return Array.isArray(t)?4===t.length||t.every(Array.isArray)?this.extend(Xl.convert(t)):this.extend(Id.convert(t)):"object"==typeof t&&null!==t&&t.hasOwnProperty("lat")&&(t.hasOwnProperty("lon")||t.hasOwnProperty("lng"))?this.extend(Id.convert(t)):this;if(r=t._sw,n=t._ne,!r||!n)return this}return e||i?(e.lng=Math.min(r.lng,e.lng),e.lat=Math.min(r.lat,e.lat),i.lng=Math.max(n.lng,i.lng),i.lat=Math.max(n.lat,i.lat)):(this._sw=new Id(r.lng,r.lat),this._ne=new Id(n.lng,n.lat)),this}getCenter(){return new Id((this._sw.lng+this._ne.lng)/2,(this._sw.lat+this._ne.lat)/2)}getSouthWest(){return this._sw}getNorthEast(){return this._ne}getNorthWest(){return new Id(this.getWest(),this.getNorth())}getSouthEast(){return new Id(this.getEast(),this.getSouth())}getWest(){return this._sw.lng}getSouth(){return this._sw.lat}getEast(){return this._ne.lng}getNorth(){return this._ne.lat}toArray(){return [this._sw.toArray(),this._ne.toArray()]}toString(){return `LngLatBounds(${this._sw.toString()}, ${this._ne.toString()})`}isEmpty(){return !(this._sw&&this._ne)}contains(t){const{lng:e,lat:i}=Id.convert(t);let r=this._sw.lng<=e&&e<=this._ne.lng;return this._sw.lng>this._ne.lng&&(r=this._sw.lng>=e&&e>=this._ne.lng),this._sw.lat<=i&&i<=this._ne.lat&&r}static convert(t){return !t||t instanceof Xl?t:new Xl(t)}}var Yl={},Kl={};Object.defineProperty(Kl,"__esModule",{value:!0}),Kl.setMatrixArrayType=function(t){Kl.ARRAY_TYPE=Ql=t;},Kl.toRadian=function(t){return t*ec},Kl.equals=function(t,e){return Math.abs(t-e)<=Jl*Math.max(1,Math.abs(t),Math.abs(e))},Kl.RANDOM=Kl.ARRAY_TYPE=Kl.EPSILON=void 0;var Jl=1e-6;Kl.EPSILON=Jl;var Ql="undefined"!=typeof Float32Array?Float32Array:Array;Kl.ARRAY_TYPE=Ql;var tc=Math.random;Kl.RANDOM=tc;var ec=Math.PI/180;Math.hypot||(Math.hypot=function(){for(var t=0,e=arguments.length;e--;)t+=arguments[e]*arguments[e];return Math.sqrt(t)});var ic={};function rc(t){return rc="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t},rc(t)}Object.defineProperty(ic,"__esModule",{value:!0}),ic.create=function(){var t=new nc.ARRAY_TYPE(4);return nc.ARRAY_TYPE!=Float32Array&&(t[1]=0,t[2]=0),t[0]=1,t[3]=1,t},ic.clone=function(t){var e=new nc.ARRAY_TYPE(4);return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e},ic.copy=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t},ic.identity=function(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=1,t},ic.fromValues=function(t,e,i,r){var n=new nc.ARRAY_TYPE(4);return n[0]=t,n[1]=e,n[2]=i,n[3]=r,n},ic.set=function(t,e,i,r,n){return t[0]=e,t[1]=i,t[2]=r,t[3]=n,t},ic.transpose=function(t,e){if(t===e){var i=e[1];t[1]=e[2],t[2]=i;}else t[0]=e[0],t[1]=e[2],t[2]=e[1],t[3]=e[3];return t},ic.invert=function(t,e){var i=e[0],r=e[1],n=e[2],o=e[3],s=i*o-n*r;return s?(t[0]=o*(s=1/s),t[1]=-r*s,t[2]=-n*s,t[3]=i*s,t):null},ic.adjoint=function(t,e){var i=e[0];return t[0]=e[3],t[1]=-e[1],t[2]=-e[2],t[3]=i,t},ic.determinant=function(t){return t[0]*t[3]-t[2]*t[1]},ic.multiply=sc,ic.rotate=function(t,e,i){var r=e[0],n=e[1],o=e[2],s=e[3],a=Math.sin(i),l=Math.cos(i);return t[0]=r*l+o*a,t[1]=n*l+s*a,t[2]=r*-a+o*l,t[3]=n*-a+s*l,t},ic.scale=function(t,e,i){var r=e[1],n=e[2],o=e[3],s=i[0],a=i[1];return t[0]=e[0]*s,t[1]=r*s,t[2]=n*a,t[3]=o*a,t},ic.fromRotation=function(t,e){var i=Math.sin(e),r=Math.cos(e);return t[0]=r,t[1]=i,t[2]=-i,t[3]=r,t},ic.fromScaling=function(t,e){return t[0]=e[0],t[1]=0,t[2]=0,t[3]=e[1],t},ic.str=function(t){return "mat2("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+")"},ic.frob=function(t){return Math.hypot(t[0],t[1],t[2],t[3])},ic.LDU=function(t,e,i,r){return t[2]=r[2]/r[0],i[0]=r[0],i[1]=r[1],i[3]=r[3]-t[2]*i[1],[t,e,i]},ic.add=function(t,e,i){return t[0]=e[0]+i[0],t[1]=e[1]+i[1],t[2]=e[2]+i[2],t[3]=e[3]+i[3],t},ic.subtract=ac,ic.exactEquals=function(t,e){return t[0]===e[0]&&t[1]===e[1]&&t[2]===e[2]&&t[3]===e[3]},ic.equals=function(t,e){var i=t[0],r=t[1],n=t[2],o=t[3],s=e[0],a=e[1],l=e[2],c=e[3];return Math.abs(i-s)<=nc.EPSILON*Math.max(1,Math.abs(i),Math.abs(s))&&Math.abs(r-a)<=nc.EPSILON*Math.max(1,Math.abs(r),Math.abs(a))&&Math.abs(n-l)<=nc.EPSILON*Math.max(1,Math.abs(n),Math.abs(l))&&Math.abs(o-c)<=nc.EPSILON*Math.max(1,Math.abs(o),Math.abs(c))},ic.multiplyScalar=function(t,e,i){return t[0]=e[0]*i,t[1]=e[1]*i,t[2]=e[2]*i,t[3]=e[3]*i,t},ic.multiplyScalarAndAdd=function(t,e,i,r){return t[0]=e[0]+i[0]*r,t[1]=e[1]+i[1]*r,t[2]=e[2]+i[2]*r,t[3]=e[3]+i[3]*r,t},ic.sub=ic.mul=void 0;var nc=function(t,e){if(t&&t.__esModule)return t;if(null===t||"object"!==rc(t)&&"function"!=typeof t)return {default:t};var i=oc(void 0);if(i&&i.has(t))return i.get(t);var r={},n=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var o in t)if("default"!==o&&Object.prototype.hasOwnProperty.call(t,o)){var s=n?Object.getOwnPropertyDescriptor(t,o):null;s&&(s.get||s.set)?Object.defineProperty(r,o,s):r[o]=t[o];}return r.default=t,i&&i.set(t,r),r}(Kl);function oc(t){if("function"!=typeof WeakMap)return null;var e=new WeakMap,i=new WeakMap;return (oc=function(t){return t?i:e})(t)}function sc(t,e,i){var r=e[0],n=e[1],o=e[2],s=e[3],a=i[0],l=i[1],c=i[2],h=i[3];return t[0]=r*a+o*l,t[1]=n*a+s*l,t[2]=r*c+o*h,t[3]=n*c+s*h,t}function ac(t,e,i){return t[0]=e[0]-i[0],t[1]=e[1]-i[1],t[2]=e[2]-i[2],t[3]=e[3]-i[3],t}ic.mul=sc,ic.sub=ac;var lc={};function cc(t){return cc="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t},cc(t)}Object.defineProperty(lc,"__esModule",{value:!0}),lc.create=function(){var t=new hc.ARRAY_TYPE(6);return hc.ARRAY_TYPE!=Float32Array&&(t[1]=0,t[2]=0,t[4]=0,t[5]=0),t[0]=1,t[3]=1,t},lc.clone=function(t){var e=new hc.ARRAY_TYPE(6);return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e},lc.copy=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t},lc.identity=function(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=1,t[4]=0,t[5]=0,t},lc.fromValues=function(t,e,i,r,n,o){var s=new hc.ARRAY_TYPE(6);return s[0]=t,s[1]=e,s[2]=i,s[3]=r,s[4]=n,s[5]=o,s},lc.set=function(t,e,i,r,n,o,s){return t[0]=e,t[1]=i,t[2]=r,t[3]=n,t[4]=o,t[5]=s,t},lc.invert=function(t,e){var i=e[0],r=e[1],n=e[2],o=e[3],s=e[4],a=e[5],l=i*o-r*n;return l?(t[0]=o*(l=1/l),t[1]=-r*l,t[2]=-n*l,t[3]=i*l,t[4]=(n*a-o*s)*l,t[5]=(r*s-i*a)*l,t):null},lc.determinant=function(t){return t[0]*t[3]-t[1]*t[2]},lc.multiply=dc,lc.rotate=function(t,e,i){var r=e[0],n=e[1],o=e[2],s=e[3],a=e[4],l=e[5],c=Math.sin(i),h=Math.cos(i);return t[0]=r*h+o*c,t[1]=n*h+s*c,t[2]=r*-c+o*h,t[3]=n*-c+s*h,t[4]=a,t[5]=l,t},lc.scale=function(t,e,i){var r=e[1],n=e[2],o=e[3],s=e[4],a=e[5],l=i[0],c=i[1];return t[0]=e[0]*l,t[1]=r*l,t[2]=n*c,t[3]=o*c,t[4]=s,t[5]=a,t},lc.translate=function(t,e,i){var r=e[0],n=e[1],o=e[2],s=e[3],a=e[4],l=e[5],c=i[0],h=i[1];return t[0]=r,t[1]=n,t[2]=o,t[3]=s,t[4]=r*c+o*h+a,t[5]=n*c+s*h+l,t},lc.fromRotation=function(t,e){var i=Math.sin(e),r=Math.cos(e);return t[0]=r,t[1]=i,t[2]=-i,t[3]=r,t[4]=0,t[5]=0,t},lc.fromScaling=function(t,e){return t[0]=e[0],t[1]=0,t[2]=0,t[3]=e[1],t[4]=0,t[5]=0,t},lc.fromTranslation=function(t,e){return t[0]=1,t[1]=0,t[2]=0,t[3]=1,t[4]=e[0],t[5]=e[1],t},lc.str=function(t){return "mat2d("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+", "+t[4]+", "+t[5]+")"},lc.frob=function(t){return Math.hypot(t[0],t[1],t[2],t[3],t[4],t[5],1)},lc.add=function(t,e,i){return t[0]=e[0]+i[0],t[1]=e[1]+i[1],t[2]=e[2]+i[2],t[3]=e[3]+i[3],t[4]=e[4]+i[4],t[5]=e[5]+i[5],t},lc.subtract=pc,lc.multiplyScalar=function(t,e,i){return t[0]=e[0]*i,t[1]=e[1]*i,t[2]=e[2]*i,t[3]=e[3]*i,t[4]=e[4]*i,t[5]=e[5]*i,t},lc.multiplyScalarAndAdd=function(t,e,i,r){return t[0]=e[0]+i[0]*r,t[1]=e[1]+i[1]*r,t[2]=e[2]+i[2]*r,t[3]=e[3]+i[3]*r,t[4]=e[4]+i[4]*r,t[5]=e[5]+i[5]*r,t},lc.exactEquals=function(t,e){return t[0]===e[0]&&t[1]===e[1]&&t[2]===e[2]&&t[3]===e[3]&&t[4]===e[4]&&t[5]===e[5]},lc.equals=function(t,e){var i=t[0],r=t[1],n=t[2],o=t[3],s=t[4],a=t[5],l=e[0],c=e[1],h=e[2],u=e[3],d=e[4],p=e[5];return Math.abs(i-l)<=hc.EPSILON*Math.max(1,Math.abs(i),Math.abs(l))&&Math.abs(r-c)<=hc.EPSILON*Math.max(1,Math.abs(r),Math.abs(c))&&Math.abs(n-h)<=hc.EPSILON*Math.max(1,Math.abs(n),Math.abs(h))&&Math.abs(o-u)<=hc.EPSILON*Math.max(1,Math.abs(o),Math.abs(u))&&Math.abs(s-d)<=hc.EPSILON*Math.max(1,Math.abs(s),Math.abs(d))&&Math.abs(a-p)<=hc.EPSILON*Math.max(1,Math.abs(a),Math.abs(p))},lc.sub=lc.mul=void 0;var hc=function(t,e){if(t&&t.__esModule)return t;if(null===t||"object"!==cc(t)&&"function"!=typeof t)return {default:t};var i=uc(void 0);if(i&&i.has(t))return i.get(t);var r={},n=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var o in t)if("default"!==o&&Object.prototype.hasOwnProperty.call(t,o)){var s=n?Object.getOwnPropertyDescriptor(t,o):null;s&&(s.get||s.set)?Object.defineProperty(r,o,s):r[o]=t[o];}return r.default=t,i&&i.set(t,r),r}(Kl);function uc(t){if("function"!=typeof WeakMap)return null;var e=new WeakMap,i=new WeakMap;return (uc=function(t){return t?i:e})(t)}function dc(t,e,i){var r=e[0],n=e[1],o=e[2],s=e[3],a=e[4],l=e[5],c=i[0],h=i[1],u=i[2],d=i[3],p=i[4],f=i[5];return t[0]=r*c+o*h,t[1]=n*c+s*h,t[2]=r*u+o*d,t[3]=n*u+s*d,t[4]=r*p+o*f+a,t[5]=n*p+s*f+l,t}function pc(t,e,i){return t[0]=e[0]-i[0],t[1]=e[1]-i[1],t[2]=e[2]-i[2],t[3]=e[3]-i[3],t[4]=e[4]-i[4],t[5]=e[5]-i[5],t}lc.mul=dc,lc.sub=pc;var fc={};function mc(t){return mc="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t},mc(t)}Object.defineProperty(fc,"__esModule",{value:!0}),fc.create=function(){var t=new _c.ARRAY_TYPE(9);return _c.ARRAY_TYPE!=Float32Array&&(t[1]=0,t[2]=0,t[3]=0,t[5]=0,t[6]=0,t[7]=0),t[0]=1,t[4]=1,t[8]=1,t},fc.fromMat4=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[4],t[4]=e[5],t[5]=e[6],t[6]=e[8],t[7]=e[9],t[8]=e[10],t},fc.clone=function(t){var e=new _c.ARRAY_TYPE(9);return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e},fc.copy=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t},fc.fromValues=function(t,e,i,r,n,o,s,a,l){var c=new _c.ARRAY_TYPE(9);return c[0]=t,c[1]=e,c[2]=i,c[3]=r,c[4]=n,c[5]=o,c[6]=s,c[7]=a,c[8]=l,c},fc.set=function(t,e,i,r,n,o,s,a,l,c){return t[0]=e,t[1]=i,t[2]=r,t[3]=n,t[4]=o,t[5]=s,t[6]=a,t[7]=l,t[8]=c,t},fc.identity=function(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=1,t[5]=0,t[6]=0,t[7]=0,t[8]=1,t},fc.transpose=function(t,e){if(t===e){var i=e[1],r=e[2],n=e[5];t[1]=e[3],t[2]=e[6],t[3]=i,t[5]=e[7],t[6]=r,t[7]=n;}else t[0]=e[0],t[1]=e[3],t[2]=e[6],t[3]=e[1],t[4]=e[4],t[5]=e[7],t[6]=e[2],t[7]=e[5],t[8]=e[8];return t},fc.invert=function(t,e){var i=e[0],r=e[1],n=e[2],o=e[3],s=e[4],a=e[5],l=e[6],c=e[7],h=e[8],u=h*s-a*c,d=-h*o+a*l,p=c*o-s*l,f=i*u+r*d+n*p;return f?(t[0]=u*(f=1/f),t[1]=(-h*r+n*c)*f,t[2]=(a*r-n*s)*f,t[3]=d*f,t[4]=(h*i-n*l)*f,t[5]=(-a*i+n*o)*f,t[6]=p*f,t[7]=(-c*i+r*l)*f,t[8]=(s*i-r*o)*f,t):null},fc.adjoint=function(t,e){var i=e[0],r=e[1],n=e[2],o=e[3],s=e[4],a=e[5],l=e[6],c=e[7],h=e[8];return t[0]=s*h-a*c,t[1]=n*c-r*h,t[2]=r*a-n*s,t[3]=a*l-o*h,t[4]=i*h-n*l,t[5]=n*o-i*a,t[6]=o*c-s*l,t[7]=r*l-i*c,t[8]=i*s-r*o,t},fc.determinant=function(t){var e=t[3],i=t[4],r=t[5],n=t[6],o=t[7],s=t[8];return t[0]*(s*i-r*o)+t[1]*(-s*e+r*n)+t[2]*(o*e-i*n)},fc.multiply=yc,fc.translate=function(t,e,i){var r=e[0],n=e[1],o=e[2],s=e[3],a=e[4],l=e[5],c=e[6],h=e[7],u=e[8],d=i[0],p=i[1];return t[0]=r,t[1]=n,t[2]=o,t[3]=s,t[4]=a,t[5]=l,t[6]=d*r+p*s+c,t[7]=d*n+p*a+h,t[8]=d*o+p*l+u,t},fc.rotate=function(t,e,i){var r=e[0],n=e[1],o=e[2],s=e[3],a=e[4],l=e[5],c=e[6],h=e[7],u=e[8],d=Math.sin(i),p=Math.cos(i);return t[0]=p*r+d*s,t[1]=p*n+d*a,t[2]=p*o+d*l,t[3]=p*s-d*r,t[4]=p*a-d*n,t[5]=p*l-d*o,t[6]=c,t[7]=h,t[8]=u,t},fc.scale=function(t,e,i){var r=i[0],n=i[1];return t[0]=r*e[0],t[1]=r*e[1],t[2]=r*e[2],t[3]=n*e[3],t[4]=n*e[4],t[5]=n*e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t},fc.fromTranslation=function(t,e){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=1,t[5]=0,t[6]=e[0],t[7]=e[1],t[8]=1,t},fc.fromRotation=function(t,e){var i=Math.sin(e),r=Math.cos(e);return t[0]=r,t[1]=i,t[2]=0,t[3]=-i,t[4]=r,t[5]=0,t[6]=0,t[7]=0,t[8]=1,t},fc.fromScaling=function(t,e){return t[0]=e[0],t[1]=0,t[2]=0,t[3]=0,t[4]=e[1],t[5]=0,t[6]=0,t[7]=0,t[8]=1,t},fc.fromMat2d=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=0,t[3]=e[2],t[4]=e[3],t[5]=0,t[6]=e[4],t[7]=e[5],t[8]=1,t},fc.fromQuat=function(t,e){var i=e[0],r=e[1],n=e[2],o=e[3],s=i+i,a=r+r,l=n+n,c=i*s,h=r*s,u=r*a,d=n*s,p=n*a,f=n*l,m=o*s,_=o*a,g=o*l;return t[0]=1-u-f,t[3]=h-g,t[6]=d+_,t[1]=h+g,t[4]=1-c-f,t[7]=p-m,t[2]=d-_,t[5]=p+m,t[8]=1-c-u,t},fc.normalFromMat4=function(t,e){var i=e[0],r=e[1],n=e[2],o=e[3],s=e[4],a=e[5],l=e[6],c=e[7],h=e[8],u=e[9],d=e[10],p=e[11],f=e[12],m=e[13],_=e[14],g=e[15],y=i*a-r*s,x=i*l-n*s,v=i*c-o*s,b=r*l-n*a,w=r*c-o*a,T=n*c-o*l,E=h*m-u*f,M=h*_-d*f,A=h*g-p*f,S=u*_-d*m,I=u*g-p*m,C=d*g-p*_,z=y*C-x*I+v*S+b*A-w*M+T*E;return z?(t[0]=(a*C-l*I+c*S)*(z=1/z),t[1]=(l*A-s*C-c*M)*z,t[2]=(s*I-a*A+c*E)*z,t[3]=(n*I-r*C-o*S)*z,t[4]=(i*C-n*A+o*M)*z,t[5]=(r*A-i*I-o*E)*z,t[6]=(m*T-_*w+g*b)*z,t[7]=(_*v-f*T-g*x)*z,t[8]=(f*w-m*v+g*y)*z,t):null},fc.projection=function(t,e,i){return t[0]=2/e,t[1]=0,t[2]=0,t[3]=0,t[4]=-2/i,t[5]=0,t[6]=-1,t[7]=1,t[8]=1,t},fc.str=function(t){return "mat3("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+", "+t[4]+", "+t[5]+", "+t[6]+", "+t[7]+", "+t[8]+")"},fc.frob=function(t){return Math.hypot(t[0],t[1],t[2],t[3],t[4],t[5],t[6],t[7],t[8])},fc.add=function(t,e,i){return t[0]=e[0]+i[0],t[1]=e[1]+i[1],t[2]=e[2]+i[2],t[3]=e[3]+i[3],t[4]=e[4]+i[4],t[5]=e[5]+i[5],t[6]=e[6]+i[6],t[7]=e[7]+i[7],t[8]=e[8]+i[8],t},fc.subtract=xc,fc.multiplyScalar=function(t,e,i){return t[0]=e[0]*i,t[1]=e[1]*i,t[2]=e[2]*i,t[3]=e[3]*i,t[4]=e[4]*i,t[5]=e[5]*i,t[6]=e[6]*i,t[7]=e[7]*i,t[8]=e[8]*i,t},fc.multiplyScalarAndAdd=function(t,e,i,r){return t[0]=e[0]+i[0]*r,t[1]=e[1]+i[1]*r,t[2]=e[2]+i[2]*r,t[3]=e[3]+i[3]*r,t[4]=e[4]+i[4]*r,t[5]=e[5]+i[5]*r,t[6]=e[6]+i[6]*r,t[7]=e[7]+i[7]*r,t[8]=e[8]+i[8]*r,t},fc.exactEquals=function(t,e){return t[0]===e[0]&&t[1]===e[1]&&t[2]===e[2]&&t[3]===e[3]&&t[4]===e[4]&&t[5]===e[5]&&t[6]===e[6]&&t[7]===e[7]&&t[8]===e[8]},fc.equals=function(t,e){var i=t[0],r=t[1],n=t[2],o=t[3],s=t[4],a=t[5],l=t[6],c=t[7],h=t[8],u=e[0],d=e[1],p=e[2],f=e[3],m=e[4],_=e[5],g=e[6],y=e[7],x=e[8];return Math.abs(i-u)<=_c.EPSILON*Math.max(1,Math.abs(i),Math.abs(u))&&Math.abs(r-d)<=_c.EPSILON*Math.max(1,Math.abs(r),Math.abs(d))&&Math.abs(n-p)<=_c.EPSILON*Math.max(1,Math.abs(n),Math.abs(p))&&Math.abs(o-f)<=_c.EPSILON*Math.max(1,Math.abs(o),Math.abs(f))&&Math.abs(s-m)<=_c.EPSILON*Math.max(1,Math.abs(s),Math.abs(m))&&Math.abs(a-_)<=_c.EPSILON*Math.max(1,Math.abs(a),Math.abs(_))&&Math.abs(l-g)<=_c.EPSILON*Math.max(1,Math.abs(l),Math.abs(g))&&Math.abs(c-y)<=_c.EPSILON*Math.max(1,Math.abs(c),Math.abs(y))&&Math.abs(h-x)<=_c.EPSILON*Math.max(1,Math.abs(h),Math.abs(x))},fc.sub=fc.mul=void 0;var _c=function(t,e){if(t&&t.__esModule)return t;if(null===t||"object"!==mc(t)&&"function"!=typeof t)return {default:t};var i=gc(void 0);if(i&&i.has(t))return i.get(t);var r={},n=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var o in t)if("default"!==o&&Object.prototype.hasOwnProperty.call(t,o)){var s=n?Object.getOwnPropertyDescriptor(t,o):null;s&&(s.get||s.set)?Object.defineProperty(r,o,s):r[o]=t[o];}return r.default=t,i&&i.set(t,r),r}(Kl);function gc(t){if("function"!=typeof WeakMap)return null;var e=new WeakMap,i=new WeakMap;return (gc=function(t){return t?i:e})(t)}function yc(t,e,i){var r=e[0],n=e[1],o=e[2],s=e[3],a=e[4],l=e[5],c=e[6],h=e[7],u=e[8],d=i[0],p=i[1],f=i[2],m=i[3],_=i[4],g=i[5],y=i[6],x=i[7],v=i[8];return t[0]=d*r+p*s+f*c,t[1]=d*n+p*a+f*h,t[2]=d*o+p*l+f*u,t[3]=m*r+_*s+g*c,t[4]=m*n+_*a+g*h,t[5]=m*o+_*l+g*u,t[6]=y*r+x*s+v*c,t[7]=y*n+x*a+v*h,t[8]=y*o+x*l+v*u,t}function xc(t,e,i){return t[0]=e[0]-i[0],t[1]=e[1]-i[1],t[2]=e[2]-i[2],t[3]=e[3]-i[3],t[4]=e[4]-i[4],t[5]=e[5]-i[5],t[6]=e[6]-i[6],t[7]=e[7]-i[7],t[8]=e[8]-i[8],t}fc.mul=yc,fc.sub=xc;var vc={};function bc(t){return bc="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t},bc(t)}Object.defineProperty(vc,"__esModule",{value:!0}),vc.create=function(){var t=new wc.ARRAY_TYPE(16);return wc.ARRAY_TYPE!=Float32Array&&(t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[11]=0,t[12]=0,t[13]=0,t[14]=0),t[0]=1,t[5]=1,t[10]=1,t[15]=1,t},vc.clone=function(t){var e=new wc.ARRAY_TYPE(16);return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e[9]=t[9],e[10]=t[10],e[11]=t[11],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15],e},vc.copy=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t[9]=e[9],t[10]=e[10],t[11]=e[11],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15],t},vc.fromValues=function(t,e,i,r,n,o,s,a,l,c,h,u,d,p,f,m){var _=new wc.ARRAY_TYPE(16);return _[0]=t,_[1]=e,_[2]=i,_[3]=r,_[4]=n,_[5]=o,_[6]=s,_[7]=a,_[8]=l,_[9]=c,_[10]=h,_[11]=u,_[12]=d,_[13]=p,_[14]=f,_[15]=m,_},vc.set=function(t,e,i,r,n,o,s,a,l,c,h,u,d,p,f,m,_){return t[0]=e,t[1]=i,t[2]=r,t[3]=n,t[4]=o,t[5]=s,t[6]=a,t[7]=l,t[8]=c,t[9]=h,t[10]=u,t[11]=d,t[12]=p,t[13]=f,t[14]=m,t[15]=_,t},vc.identity=Ec,vc.transpose=function(t,e){if(t===e){var i=e[1],r=e[2],n=e[3],o=e[6],s=e[7],a=e[11];t[1]=e[4],t[2]=e[8],t[3]=e[12],t[4]=i,t[6]=e[9],t[7]=e[13],t[8]=r,t[9]=o,t[11]=e[14],t[12]=n,t[13]=s,t[14]=a;}else t[0]=e[0],t[1]=e[4],t[2]=e[8],t[3]=e[12],t[4]=e[1],t[5]=e[5],t[6]=e[9],t[7]=e[13],t[8]=e[2],t[9]=e[6],t[10]=e[10],t[11]=e[14],t[12]=e[3],t[13]=e[7],t[14]=e[11],t[15]=e[15];return t},vc.invert=function(t,e){var i=e[0],r=e[1],n=e[2],o=e[3],s=e[4],a=e[5],l=e[6],c=e[7],h=e[8],u=e[9],d=e[10],p=e[11],f=e[12],m=e[13],_=e[14],g=e[15],y=i*a-r*s,x=i*l-n*s,v=i*c-o*s,b=r*l-n*a,w=r*c-o*a,T=n*c-o*l,E=h*m-u*f,M=h*_-d*f,A=h*g-p*f,S=u*_-d*m,I=u*g-p*m,C=d*g-p*_,z=y*C-x*I+v*S+b*A-w*M+T*E;return z?(t[0]=(a*C-l*I+c*S)*(z=1/z),t[1]=(n*I-r*C-o*S)*z,t[2]=(m*T-_*w+g*b)*z,t[3]=(d*w-u*T-p*b)*z,t[4]=(l*A-s*C-c*M)*z,t[5]=(i*C-n*A+o*M)*z,t[6]=(_*v-f*T-g*x)*z,t[7]=(h*T-d*v+p*x)*z,t[8]=(s*I-a*A+c*E)*z,t[9]=(r*A-i*I-o*E)*z,t[10]=(f*w-m*v+g*y)*z,t[11]=(u*v-h*w-p*y)*z,t[12]=(a*M-s*S-l*E)*z,t[13]=(i*S-r*M+n*E)*z,t[14]=(m*x-f*b-_*y)*z,t[15]=(h*b-u*x+d*y)*z,t):null},vc.adjoint=function(t,e){var i=e[0],r=e[1],n=e[2],o=e[3],s=e[4],a=e[5],l=e[6],c=e[7],h=e[8],u=e[9],d=e[10],p=e[11],f=e[12],m=e[13],_=e[14],g=e[15];return t[0]=a*(d*g-p*_)-u*(l*g-c*_)+m*(l*p-c*d),t[1]=-(r*(d*g-p*_)-u*(n*g-o*_)+m*(n*p-o*d)),t[2]=r*(l*g-c*_)-a*(n*g-o*_)+m*(n*c-o*l),t[3]=-(r*(l*p-c*d)-a*(n*p-o*d)+u*(n*c-o*l)),t[4]=-(s*(d*g-p*_)-h*(l*g-c*_)+f*(l*p-c*d)),t[5]=i*(d*g-p*_)-h*(n*g-o*_)+f*(n*p-o*d),t[6]=-(i*(l*g-c*_)-s*(n*g-o*_)+f*(n*c-o*l)),t[7]=i*(l*p-c*d)-s*(n*p-o*d)+h*(n*c-o*l),t[8]=s*(u*g-p*m)-h*(a*g-c*m)+f*(a*p-c*u),t[9]=-(i*(u*g-p*m)-h*(r*g-o*m)+f*(r*p-o*u)),t[10]=i*(a*g-c*m)-s*(r*g-o*m)+f*(r*c-o*a),t[11]=-(i*(a*p-c*u)-s*(r*p-o*u)+h*(r*c-o*a)),t[12]=-(s*(u*_-d*m)-h*(a*_-l*m)+f*(a*d-l*u)),t[13]=i*(u*_-d*m)-h*(r*_-n*m)+f*(r*d-n*u),t[14]=-(i*(a*_-l*m)-s*(r*_-n*m)+f*(r*l-n*a)),t[15]=i*(a*d-l*u)-s*(r*d-n*u)+h*(r*l-n*a),t},vc.determinant=function(t){var e=t[0],i=t[1],r=t[2],n=t[3],o=t[4],s=t[5],a=t[6],l=t[7],c=t[8],h=t[9],u=t[10],d=t[11],p=t[12],f=t[13],m=t[14],_=t[15];return (e*s-i*o)*(u*_-d*m)-(e*a-r*o)*(h*_-d*f)+(e*l-n*o)*(h*m-u*f)+(i*a-r*s)*(c*_-d*p)-(i*l-n*s)*(c*m-u*p)+(r*l-n*a)*(c*f-h*p)},vc.multiply=Mc,vc.translate=function(t,e,i){var r,n,o,s,a,l,c,h,u,d,p,f,m=i[0],_=i[1],g=i[2];return e===t?(t[12]=e[0]*m+e[4]*_+e[8]*g+e[12],t[13]=e[1]*m+e[5]*_+e[9]*g+e[13],t[14]=e[2]*m+e[6]*_+e[10]*g+e[14],t[15]=e[3]*m+e[7]*_+e[11]*g+e[15]):(n=e[1],o=e[2],s=e[3],a=e[4],l=e[5],c=e[6],h=e[7],u=e[8],d=e[9],p=e[10],f=e[11],t[0]=r=e[0],t[1]=n,t[2]=o,t[3]=s,t[4]=a,t[5]=l,t[6]=c,t[7]=h,t[8]=u,t[9]=d,t[10]=p,t[11]=f,t[12]=r*m+a*_+u*g+e[12],t[13]=n*m+l*_+d*g+e[13],t[14]=o*m+c*_+p*g+e[14],t[15]=s*m+h*_+f*g+e[15]),t},vc.scale=function(t,e,i){var r=i[0],n=i[1],o=i[2];return t[0]=e[0]*r,t[1]=e[1]*r,t[2]=e[2]*r,t[3]=e[3]*r,t[4]=e[4]*n,t[5]=e[5]*n,t[6]=e[6]*n,t[7]=e[7]*n,t[8]=e[8]*o,t[9]=e[9]*o,t[10]=e[10]*o,t[11]=e[11]*o,t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15],t},vc.rotate=function(t,e,i,r){var n,o,s,a,l,c,h,u,d,p,f,m,_,g,y,x,v,b,w,T,E,M,A,S,I=r[0],C=r[1],z=r[2],D=Math.hypot(I,C,z);return D<wc.EPSILON?null:(I*=D=1/D,C*=D,z*=D,n=Math.sin(i),o=Math.cos(i),l=e[1],c=e[2],h=e[3],d=e[5],p=e[6],f=e[7],_=e[9],g=e[10],y=e[11],w=I*C*(s=1-o)-z*n,T=C*C*s+o,E=z*C*s+I*n,M=I*z*s+C*n,A=C*z*s-I*n,S=z*z*s+o,t[0]=(a=e[0])*(x=I*I*s+o)+(u=e[4])*(v=C*I*s+z*n)+(m=e[8])*(b=z*I*s-C*n),t[1]=l*x+d*v+_*b,t[2]=c*x+p*v+g*b,t[3]=h*x+f*v+y*b,t[4]=a*w+u*T+m*E,t[5]=l*w+d*T+_*E,t[6]=c*w+p*T+g*E,t[7]=h*w+f*T+y*E,t[8]=a*M+u*A+m*S,t[9]=l*M+d*A+_*S,t[10]=c*M+p*A+g*S,t[11]=h*M+f*A+y*S,e!==t&&(t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15]),t)},vc.rotateX=function(t,e,i){var r=Math.sin(i),n=Math.cos(i),o=e[4],s=e[5],a=e[6],l=e[7],c=e[8],h=e[9],u=e[10],d=e[11];return e!==t&&(t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15]),t[4]=o*n+c*r,t[5]=s*n+h*r,t[6]=a*n+u*r,t[7]=l*n+d*r,t[8]=c*n-o*r,t[9]=h*n-s*r,t[10]=u*n-a*r,t[11]=d*n-l*r,t},vc.rotateY=function(t,e,i){var r=Math.sin(i),n=Math.cos(i),o=e[0],s=e[1],a=e[2],l=e[3],c=e[8],h=e[9],u=e[10],d=e[11];return e!==t&&(t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15]),t[0]=o*n-c*r,t[1]=s*n-h*r,t[2]=a*n-u*r,t[3]=l*n-d*r,t[8]=o*r+c*n,t[9]=s*r+h*n,t[10]=a*r+u*n,t[11]=l*r+d*n,t},vc.rotateZ=function(t,e,i){var r=Math.sin(i),n=Math.cos(i),o=e[0],s=e[1],a=e[2],l=e[3],c=e[4],h=e[5],u=e[6],d=e[7];return e!==t&&(t[8]=e[8],t[9]=e[9],t[10]=e[10],t[11]=e[11],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15]),t[0]=o*n+c*r,t[1]=s*n+h*r,t[2]=a*n+u*r,t[3]=l*n+d*r,t[4]=c*n-o*r,t[5]=h*n-s*r,t[6]=u*n-a*r,t[7]=d*n-l*r,t},vc.fromTranslation=function(t,e){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=e[0],t[13]=e[1],t[14]=e[2],t[15]=1,t},vc.fromScaling=function(t,e){return t[0]=e[0],t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=e[1],t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=e[2],t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},vc.fromRotation=function(t,e,i){var r,n,o,s=i[0],a=i[1],l=i[2],c=Math.hypot(s,a,l);return c<wc.EPSILON?null:(s*=c=1/c,a*=c,l*=c,r=Math.sin(e),n=Math.cos(e),t[0]=s*s*(o=1-n)+n,t[1]=a*s*o+l*r,t[2]=l*s*o-a*r,t[3]=0,t[4]=s*a*o-l*r,t[5]=a*a*o+n,t[6]=l*a*o+s*r,t[7]=0,t[8]=s*l*o+a*r,t[9]=a*l*o-s*r,t[10]=l*l*o+n,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t)},vc.fromXRotation=function(t,e){var i=Math.sin(e),r=Math.cos(e);return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=r,t[6]=i,t[7]=0,t[8]=0,t[9]=-i,t[10]=r,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},vc.fromYRotation=function(t,e){var i=Math.sin(e),r=Math.cos(e);return t[0]=r,t[1]=0,t[2]=-i,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=i,t[9]=0,t[10]=r,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},vc.fromZRotation=function(t,e){var i=Math.sin(e),r=Math.cos(e);return t[0]=r,t[1]=i,t[2]=0,t[3]=0,t[4]=-i,t[5]=r,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},vc.fromRotationTranslation=Ac,vc.fromQuat2=function(t,e){var i=new wc.ARRAY_TYPE(3),r=-e[0],n=-e[1],o=-e[2],s=e[3],a=e[4],l=e[5],c=e[6],h=e[7],u=r*r+n*n+o*o+s*s;return u>0?(i[0]=2*(a*s+h*r+l*o-c*n)/u,i[1]=2*(l*s+h*n+c*r-a*o)/u,i[2]=2*(c*s+h*o+a*n-l*r)/u):(i[0]=2*(a*s+h*r+l*o-c*n),i[1]=2*(l*s+h*n+c*r-a*o),i[2]=2*(c*s+h*o+a*n-l*r)),Ac(t,e,i),t},vc.getTranslation=function(t,e){return t[0]=e[12],t[1]=e[13],t[2]=e[14],t},vc.getScaling=Sc,vc.getRotation=function(t,e){var i=new wc.ARRAY_TYPE(3);Sc(i,e);var r=1/i[0],n=1/i[1],o=1/i[2],s=e[0]*r,a=e[1]*n,l=e[2]*o,c=e[4]*r,h=e[5]*n,u=e[6]*o,d=e[8]*r,p=e[9]*n,f=e[10]*o,m=s+h+f,_=0;return m>0?(_=2*Math.sqrt(m+1),t[3]=.25*_,t[0]=(u-p)/_,t[1]=(d-l)/_,t[2]=(a-c)/_):s>h&&s>f?(_=2*Math.sqrt(1+s-h-f),t[3]=(u-p)/_,t[0]=.25*_,t[1]=(a+c)/_,t[2]=(d+l)/_):h>f?(_=2*Math.sqrt(1+h-s-f),t[3]=(d-l)/_,t[0]=(a+c)/_,t[1]=.25*_,t[2]=(u+p)/_):(_=2*Math.sqrt(1+f-s-h),t[3]=(a-c)/_,t[0]=(d+l)/_,t[1]=(u+p)/_,t[2]=.25*_),t},vc.fromRotationTranslationScale=function(t,e,i,r){var n=e[0],o=e[1],s=e[2],a=e[3],l=n+n,c=o+o,h=s+s,u=n*l,d=n*c,p=n*h,f=o*c,m=o*h,_=s*h,g=a*l,y=a*c,x=a*h,v=r[0],b=r[1],w=r[2];return t[0]=(1-(f+_))*v,t[1]=(d+x)*v,t[2]=(p-y)*v,t[3]=0,t[4]=(d-x)*b,t[5]=(1-(u+_))*b,t[6]=(m+g)*b,t[7]=0,t[8]=(p+y)*w,t[9]=(m-g)*w,t[10]=(1-(u+f))*w,t[11]=0,t[12]=i[0],t[13]=i[1],t[14]=i[2],t[15]=1,t},vc.fromRotationTranslationScaleOrigin=function(t,e,i,r,n){var o=e[0],s=e[1],a=e[2],l=e[3],c=o+o,h=s+s,u=a+a,d=o*c,p=o*h,f=o*u,m=s*h,_=s*u,g=a*u,y=l*c,x=l*h,v=l*u,b=r[0],w=r[1],T=r[2],E=n[0],M=n[1],A=n[2],S=(1-(m+g))*b,I=(p+v)*b,C=(f-x)*b,z=(p-v)*w,D=(1-(d+g))*w,P=(_+y)*w,R=(f+x)*T,L=(_-y)*T,k=(1-(d+m))*T;return t[0]=S,t[1]=I,t[2]=C,t[3]=0,t[4]=z,t[5]=D,t[6]=P,t[7]=0,t[8]=R,t[9]=L,t[10]=k,t[11]=0,t[12]=i[0]+E-(S*E+z*M+R*A),t[13]=i[1]+M-(I*E+D*M+L*A),t[14]=i[2]+A-(C*E+P*M+k*A),t[15]=1,t},vc.fromQuat=function(t,e){var i=e[0],r=e[1],n=e[2],o=e[3],s=i+i,a=r+r,l=n+n,c=i*s,h=r*s,u=r*a,d=n*s,p=n*a,f=n*l,m=o*s,_=o*a,g=o*l;return t[0]=1-u-f,t[1]=h+g,t[2]=d-_,t[3]=0,t[4]=h-g,t[5]=1-c-f,t[6]=p+m,t[7]=0,t[8]=d+_,t[9]=p-m,t[10]=1-c-u,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},vc.frustum=function(t,e,i,r,n,o,s){var a=1/(i-e),l=1/(n-r),c=1/(o-s);return t[0]=2*o*a,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=2*o*l,t[6]=0,t[7]=0,t[8]=(i+e)*a,t[9]=(n+r)*l,t[10]=(s+o)*c,t[11]=-1,t[12]=0,t[13]=0,t[14]=s*o*2*c,t[15]=0,t},vc.perspectiveNO=Ic,vc.perspectiveZO=function(t,e,i,r,n){var o,s=1/Math.tan(e/2);return t[0]=s/i,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=s,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[11]=-1,t[12]=0,t[13]=0,t[15]=0,null!=n&&n!==1/0?(t[10]=n*(o=1/(r-n)),t[14]=n*r*o):(t[10]=-1,t[14]=-r),t},vc.perspectiveFromFieldOfView=function(t,e,i,r){var n=Math.tan(e.upDegrees*Math.PI/180),o=Math.tan(e.downDegrees*Math.PI/180),s=Math.tan(e.leftDegrees*Math.PI/180),a=Math.tan(e.rightDegrees*Math.PI/180),l=2/(s+a),c=2/(n+o);return t[0]=l,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=c,t[6]=0,t[7]=0,t[8]=-(s-a)*l*.5,t[9]=(n-o)*c*.5,t[10]=r/(i-r),t[11]=-1,t[12]=0,t[13]=0,t[14]=r*i/(i-r),t[15]=0,t},vc.orthoNO=Cc,vc.orthoZO=function(t,e,i,r,n,o,s){var a=1/(e-i),l=1/(r-n),c=1/(o-s);return t[0]=-2*a,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=-2*l,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=c,t[11]=0,t[12]=(e+i)*a,t[13]=(n+r)*l,t[14]=o*c,t[15]=1,t},vc.lookAt=function(t,e,i,r){var n,o,s,a,l,c,h,u,d,p,f=e[0],m=e[1],_=e[2],g=r[0],y=r[1],x=r[2],v=i[0],b=i[1],w=i[2];return Math.abs(f-v)<wc.EPSILON&&Math.abs(m-b)<wc.EPSILON&&Math.abs(_-w)<wc.EPSILON?Ec(t):(h=f-v,u=m-b,d=_-w,n=y*(d*=p=1/Math.hypot(h,u,d))-x*(u*=p),o=x*(h*=p)-g*d,s=g*u-y*h,(p=Math.hypot(n,o,s))?(n*=p=1/p,o*=p,s*=p):(n=0,o=0,s=0),a=u*s-d*o,l=d*n-h*s,c=h*o-u*n,(p=Math.hypot(a,l,c))?(a*=p=1/p,l*=p,c*=p):(a=0,l=0,c=0),t[0]=n,t[1]=a,t[2]=h,t[3]=0,t[4]=o,t[5]=l,t[6]=u,t[7]=0,t[8]=s,t[9]=c,t[10]=d,t[11]=0,t[12]=-(n*f+o*m+s*_),t[13]=-(a*f+l*m+c*_),t[14]=-(h*f+u*m+d*_),t[15]=1,t)},vc.targetTo=function(t,e,i,r){var n=e[0],o=e[1],s=e[2],a=r[0],l=r[1],c=r[2],h=n-i[0],u=o-i[1],d=s-i[2],p=h*h+u*u+d*d;p>0&&(h*=p=1/Math.sqrt(p),u*=p,d*=p);var f=l*d-c*u,m=c*h-a*d,_=a*u-l*h;return (p=f*f+m*m+_*_)>0&&(f*=p=1/Math.sqrt(p),m*=p,_*=p),t[0]=f,t[1]=m,t[2]=_,t[3]=0,t[4]=u*_-d*m,t[5]=d*f-h*_,t[6]=h*m-u*f,t[7]=0,t[8]=h,t[9]=u,t[10]=d,t[11]=0,t[12]=n,t[13]=o,t[14]=s,t[15]=1,t},vc.str=function(t){return "mat4("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+", "+t[4]+", "+t[5]+", "+t[6]+", "+t[7]+", "+t[8]+", "+t[9]+", "+t[10]+", "+t[11]+", "+t[12]+", "+t[13]+", "+t[14]+", "+t[15]+")"},vc.frob=function(t){return Math.hypot(t[0],t[1],t[2],t[3],t[4],t[5],t[6],t[7],t[8],t[9],t[10],t[11],t[12],t[13],t[14],t[15])},vc.add=function(t,e,i){return t[0]=e[0]+i[0],t[1]=e[1]+i[1],t[2]=e[2]+i[2],t[3]=e[3]+i[3],t[4]=e[4]+i[4],t[5]=e[5]+i[5],t[6]=e[6]+i[6],t[7]=e[7]+i[7],t[8]=e[8]+i[8],t[9]=e[9]+i[9],t[10]=e[10]+i[10],t[11]=e[11]+i[11],t[12]=e[12]+i[12],t[13]=e[13]+i[13],t[14]=e[14]+i[14],t[15]=e[15]+i[15],t},vc.subtract=zc,vc.multiplyScalar=function(t,e,i){return t[0]=e[0]*i,t[1]=e[1]*i,t[2]=e[2]*i,t[3]=e[3]*i,t[4]=e[4]*i,t[5]=e[5]*i,t[6]=e[6]*i,t[7]=e[7]*i,t[8]=e[8]*i,t[9]=e[9]*i,t[10]=e[10]*i,t[11]=e[11]*i,t[12]=e[12]*i,t[13]=e[13]*i,t[14]=e[14]*i,t[15]=e[15]*i,t},vc.multiplyScalarAndAdd=function(t,e,i,r){return t[0]=e[0]+i[0]*r,t[1]=e[1]+i[1]*r,t[2]=e[2]+i[2]*r,t[3]=e[3]+i[3]*r,t[4]=e[4]+i[4]*r,t[5]=e[5]+i[5]*r,t[6]=e[6]+i[6]*r,t[7]=e[7]+i[7]*r,t[8]=e[8]+i[8]*r,t[9]=e[9]+i[9]*r,t[10]=e[10]+i[10]*r,t[11]=e[11]+i[11]*r,t[12]=e[12]+i[12]*r,t[13]=e[13]+i[13]*r,t[14]=e[14]+i[14]*r,t[15]=e[15]+i[15]*r,t},vc.exactEquals=function(t,e){return t[0]===e[0]&&t[1]===e[1]&&t[2]===e[2]&&t[3]===e[3]&&t[4]===e[4]&&t[5]===e[5]&&t[6]===e[6]&&t[7]===e[7]&&t[8]===e[8]&&t[9]===e[9]&&t[10]===e[10]&&t[11]===e[11]&&t[12]===e[12]&&t[13]===e[13]&&t[14]===e[14]&&t[15]===e[15]},vc.equals=function(t,e){var i=t[0],r=t[1],n=t[2],o=t[3],s=t[4],a=t[5],l=t[6],c=t[7],h=t[8],u=t[9],d=t[10],p=t[11],f=t[12],m=t[13],_=t[14],g=t[15],y=e[0],x=e[1],v=e[2],b=e[3],w=e[4],T=e[5],E=e[6],M=e[7],A=e[8],S=e[9],I=e[10],C=e[11],z=e[12],D=e[13],P=e[14],R=e[15];return Math.abs(i-y)<=wc.EPSILON*Math.max(1,Math.abs(i),Math.abs(y))&&Math.abs(r-x)<=wc.EPSILON*Math.max(1,Math.abs(r),Math.abs(x))&&Math.abs(n-v)<=wc.EPSILON*Math.max(1,Math.abs(n),Math.abs(v))&&Math.abs(o-b)<=wc.EPSILON*Math.max(1,Math.abs(o),Math.abs(b))&&Math.abs(s-w)<=wc.EPSILON*Math.max(1,Math.abs(s),Math.abs(w))&&Math.abs(a-T)<=wc.EPSILON*Math.max(1,Math.abs(a),Math.abs(T))&&Math.abs(l-E)<=wc.EPSILON*Math.max(1,Math.abs(l),Math.abs(E))&&Math.abs(c-M)<=wc.EPSILON*Math.max(1,Math.abs(c),Math.abs(M))&&Math.abs(h-A)<=wc.EPSILON*Math.max(1,Math.abs(h),Math.abs(A))&&Math.abs(u-S)<=wc.EPSILON*Math.max(1,Math.abs(u),Math.abs(S))&&Math.abs(d-I)<=wc.EPSILON*Math.max(1,Math.abs(d),Math.abs(I))&&Math.abs(p-C)<=wc.EPSILON*Math.max(1,Math.abs(p),Math.abs(C))&&Math.abs(f-z)<=wc.EPSILON*Math.max(1,Math.abs(f),Math.abs(z))&&Math.abs(m-D)<=wc.EPSILON*Math.max(1,Math.abs(m),Math.abs(D))&&Math.abs(_-P)<=wc.EPSILON*Math.max(1,Math.abs(_),Math.abs(P))&&Math.abs(g-R)<=wc.EPSILON*Math.max(1,Math.abs(g),Math.abs(R))},vc.sub=vc.mul=vc.ortho=vc.perspective=void 0;var wc=function(t,e){if(t&&t.__esModule)return t;if(null===t||"object"!==bc(t)&&"function"!=typeof t)return {default:t};var i=Tc(void 0);if(i&&i.has(t))return i.get(t);var r={},n=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var o in t)if("default"!==o&&Object.prototype.hasOwnProperty.call(t,o)){var s=n?Object.getOwnPropertyDescriptor(t,o):null;s&&(s.get||s.set)?Object.defineProperty(r,o,s):r[o]=t[o];}return r.default=t,i&&i.set(t,r),r}(Kl);function Tc(t){if("function"!=typeof WeakMap)return null;var e=new WeakMap,i=new WeakMap;return (Tc=function(t){return t?i:e})(t)}function Ec(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t}function Mc(t,e,i){var r=e[0],n=e[1],o=e[2],s=e[3],a=e[4],l=e[5],c=e[6],h=e[7],u=e[8],d=e[9],p=e[10],f=e[11],m=e[12],_=e[13],g=e[14],y=e[15],x=i[0],v=i[1],b=i[2],w=i[3];return t[0]=x*r+v*a+b*u+w*m,t[1]=x*n+v*l+b*d+w*_,t[2]=x*o+v*c+b*p+w*g,t[3]=x*s+v*h+b*f+w*y,t[4]=(x=i[4])*r+(v=i[5])*a+(b=i[6])*u+(w=i[7])*m,t[5]=x*n+v*l+b*d+w*_,t[6]=x*o+v*c+b*p+w*g,t[7]=x*s+v*h+b*f+w*y,t[8]=(x=i[8])*r+(v=i[9])*a+(b=i[10])*u+(w=i[11])*m,t[9]=x*n+v*l+b*d+w*_,t[10]=x*o+v*c+b*p+w*g,t[11]=x*s+v*h+b*f+w*y,t[12]=(x=i[12])*r+(v=i[13])*a+(b=i[14])*u+(w=i[15])*m,t[13]=x*n+v*l+b*d+w*_,t[14]=x*o+v*c+b*p+w*g,t[15]=x*s+v*h+b*f+w*y,t}function Ac(t,e,i){var r=e[0],n=e[1],o=e[2],s=e[3],a=r+r,l=n+n,c=o+o,h=r*a,u=r*l,d=r*c,p=n*l,f=n*c,m=o*c,_=s*a,g=s*l,y=s*c;return t[0]=1-(p+m),t[1]=u+y,t[2]=d-g,t[3]=0,t[4]=u-y,t[5]=1-(h+m),t[6]=f+_,t[7]=0,t[8]=d+g,t[9]=f-_,t[10]=1-(h+p),t[11]=0,t[12]=i[0],t[13]=i[1],t[14]=i[2],t[15]=1,t}function Sc(t,e){var i=e[4],r=e[5],n=e[6],o=e[8],s=e[9],a=e[10];return t[0]=Math.hypot(e[0],e[1],e[2]),t[1]=Math.hypot(i,r,n),t[2]=Math.hypot(o,s,a),t}function Ic(t,e,i,r,n){var o,s=1/Math.tan(e/2);return t[0]=s/i,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=s,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[11]=-1,t[12]=0,t[13]=0,t[15]=0,null!=n&&n!==1/0?(t[10]=(n+r)*(o=1/(r-n)),t[14]=2*n*r*o):(t[10]=-1,t[14]=-2*r),t}function Cc(t,e,i,r,n,o,s){var a=1/(e-i),l=1/(r-n),c=1/(o-s);return t[0]=-2*a,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=-2*l,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=2*c,t[11]=0,t[12]=(e+i)*a,t[13]=(n+r)*l,t[14]=(s+o)*c,t[15]=1,t}function zc(t,e,i){return t[0]=e[0]-i[0],t[1]=e[1]-i[1],t[2]=e[2]-i[2],t[3]=e[3]-i[3],t[4]=e[4]-i[4],t[5]=e[5]-i[5],t[6]=e[6]-i[6],t[7]=e[7]-i[7],t[8]=e[8]-i[8],t[9]=e[9]-i[9],t[10]=e[10]-i[10],t[11]=e[11]-i[11],t[12]=e[12]-i[12],t[13]=e[13]-i[13],t[14]=e[14]-i[14],t[15]=e[15]-i[15],t}vc.perspective=Ic,vc.ortho=Cc,vc.mul=Mc,vc.sub=zc;var Dc={},Pc={};function Rc(t){return Rc="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t},Rc(t)}Object.defineProperty(Pc,"__esModule",{value:!0}),Pc.create=Bc,Pc.clone=function(t){var e=new Lc.ARRAY_TYPE(3);return e[0]=t[0],e[1]=t[1],e[2]=t[2],e},Pc.length=Oc,Pc.fromValues=function(t,e,i){var r=new Lc.ARRAY_TYPE(3);return r[0]=t,r[1]=e,r[2]=i,r},Pc.copy=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t},Pc.set=function(t,e,i,r){return t[0]=e,t[1]=i,t[2]=r,t},Pc.add=function(t,e,i){return t[0]=e[0]+i[0],t[1]=e[1]+i[1],t[2]=e[2]+i[2],t},Pc.subtract=Fc,Pc.multiply=Nc,Pc.divide=Uc,Pc.ceil=function(t,e){return t[0]=Math.ceil(e[0]),t[1]=Math.ceil(e[1]),t[2]=Math.ceil(e[2]),t},Pc.floor=function(t,e){return t[0]=Math.floor(e[0]),t[1]=Math.floor(e[1]),t[2]=Math.floor(e[2]),t},Pc.min=function(t,e,i){return t[0]=Math.min(e[0],i[0]),t[1]=Math.min(e[1],i[1]),t[2]=Math.min(e[2],i[2]),t},Pc.max=function(t,e,i){return t[0]=Math.max(e[0],i[0]),t[1]=Math.max(e[1],i[1]),t[2]=Math.max(e[2],i[2]),t},Pc.round=function(t,e){return t[0]=Math.round(e[0]),t[1]=Math.round(e[1]),t[2]=Math.round(e[2]),t},Pc.scale=function(t,e,i){return t[0]=e[0]*i,t[1]=e[1]*i,t[2]=e[2]*i,t},Pc.scaleAndAdd=function(t,e,i,r){return t[0]=e[0]+i[0]*r,t[1]=e[1]+i[1]*r,t[2]=e[2]+i[2]*r,t},Pc.distance=Vc,Pc.squaredDistance=jc,Pc.squaredLength=Gc,Pc.negate=function(t,e){return t[0]=-e[0],t[1]=-e[1],t[2]=-e[2],t},Pc.inverse=function(t,e){return t[0]=1/e[0],t[1]=1/e[1],t[2]=1/e[2],t},Pc.normalize=function(t,e){var i=e[0],r=e[1],n=e[2],o=i*i+r*r+n*n;return o>0&&(o=1/Math.sqrt(o)),t[0]=e[0]*o,t[1]=e[1]*o,t[2]=e[2]*o,t},Pc.dot=qc,Pc.cross=function(t,e,i){var r=e[0],n=e[1],o=e[2],s=i[0],a=i[1],l=i[2];return t[0]=n*l-o*a,t[1]=o*s-r*l,t[2]=r*a-n*s,t},Pc.lerp=function(t,e,i,r){var n=e[0],o=e[1],s=e[2];return t[0]=n+r*(i[0]-n),t[1]=o+r*(i[1]-o),t[2]=s+r*(i[2]-s),t},Pc.hermite=function(t,e,i,r,n,o){var s=o*o,a=s*(2*o-3)+1,l=s*(o-2)+o,c=s*(o-1),h=s*(3-2*o);return t[0]=e[0]*a+i[0]*l+r[0]*c+n[0]*h,t[1]=e[1]*a+i[1]*l+r[1]*c+n[1]*h,t[2]=e[2]*a+i[2]*l+r[2]*c+n[2]*h,t},Pc.bezier=function(t,e,i,r,n,o){var s=1-o,a=s*s,l=o*o,c=a*s,h=3*o*a,u=3*l*s,d=l*o;return t[0]=e[0]*c+i[0]*h+r[0]*u+n[0]*d,t[1]=e[1]*c+i[1]*h+r[1]*u+n[1]*d,t[2]=e[2]*c+i[2]*h+r[2]*u+n[2]*d,t},Pc.random=function(t,e){e=e||1;var i=2*Lc.RANDOM()*Math.PI,r=2*Lc.RANDOM()-1,n=Math.sqrt(1-r*r)*e;return t[0]=Math.cos(i)*n,t[1]=Math.sin(i)*n,t[2]=r*e,t},Pc.transformMat4=function(t,e,i){var r=e[0],n=e[1],o=e[2],s=i[3]*r+i[7]*n+i[11]*o+i[15];return t[0]=(i[0]*r+i[4]*n+i[8]*o+i[12])/(s=s||1),t[1]=(i[1]*r+i[5]*n+i[9]*o+i[13])/s,t[2]=(i[2]*r+i[6]*n+i[10]*o+i[14])/s,t},Pc.transformMat3=function(t,e,i){var r=e[0],n=e[1],o=e[2];return t[0]=r*i[0]+n*i[3]+o*i[6],t[1]=r*i[1]+n*i[4]+o*i[7],t[2]=r*i[2]+n*i[5]+o*i[8],t},Pc.transformQuat=function(t,e,i){var r=i[0],n=i[1],o=i[2],s=e[0],a=e[1],l=e[2],c=n*l-o*a,h=o*s-r*l,u=r*a-n*s,d=n*u-o*h,p=o*c-r*u,f=r*h-n*c,m=2*i[3];return h*=m,u*=m,p*=2,f*=2,t[0]=s+(c*=m)+(d*=2),t[1]=a+h+p,t[2]=l+u+f,t},Pc.rotateX=function(t,e,i,r){var n=[],o=[];return n[0]=e[0]-i[0],n[1]=e[1]-i[1],n[2]=e[2]-i[2],o[0]=n[0],o[1]=n[1]*Math.cos(r)-n[2]*Math.sin(r),o[2]=n[1]*Math.sin(r)+n[2]*Math.cos(r),t[0]=o[0]+i[0],t[1]=o[1]+i[1],t[2]=o[2]+i[2],t},Pc.rotateY=function(t,e,i,r){var n=[],o=[];return n[0]=e[0]-i[0],n[1]=e[1]-i[1],n[2]=e[2]-i[2],o[0]=n[2]*Math.sin(r)+n[0]*Math.cos(r),o[1]=n[1],o[2]=n[2]*Math.cos(r)-n[0]*Math.sin(r),t[0]=o[0]+i[0],t[1]=o[1]+i[1],t[2]=o[2]+i[2],t},Pc.rotateZ=function(t,e,i,r){var n=[],o=[];return n[0]=e[0]-i[0],n[1]=e[1]-i[1],n[2]=e[2]-i[2],o[0]=n[0]*Math.cos(r)-n[1]*Math.sin(r),o[1]=n[0]*Math.sin(r)+n[1]*Math.cos(r),o[2]=n[2],t[0]=o[0]+i[0],t[1]=o[1]+i[1],t[2]=o[2]+i[2],t},Pc.angle=function(t,e){var i=t[0],r=t[1],n=t[2],o=e[0],s=e[1],a=e[2],l=Math.sqrt(i*i+r*r+n*n)*Math.sqrt(o*o+s*s+a*a),c=l&&qc(t,e)/l;return Math.acos(Math.min(Math.max(c,-1),1))},Pc.zero=function(t){return t[0]=0,t[1]=0,t[2]=0,t},Pc.str=function(t){return "vec3("+t[0]+", "+t[1]+", "+t[2]+")"},Pc.exactEquals=function(t,e){return t[0]===e[0]&&t[1]===e[1]&&t[2]===e[2]},Pc.equals=function(t,e){var i=t[0],r=t[1],n=t[2],o=e[0],s=e[1],a=e[2];return Math.abs(i-o)<=Lc.EPSILON*Math.max(1,Math.abs(i),Math.abs(o))&&Math.abs(r-s)<=Lc.EPSILON*Math.max(1,Math.abs(r),Math.abs(s))&&Math.abs(n-a)<=Lc.EPSILON*Math.max(1,Math.abs(n),Math.abs(a))},Pc.forEach=Pc.sqrLen=Pc.len=Pc.sqrDist=Pc.dist=Pc.div=Pc.mul=Pc.sub=void 0;var Lc=function(t,e){if(t&&t.__esModule)return t;if(null===t||"object"!==Rc(t)&&"function"!=typeof t)return {default:t};var i=kc(void 0);if(i&&i.has(t))return i.get(t);var r={},n=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var o in t)if("default"!==o&&Object.prototype.hasOwnProperty.call(t,o)){var s=n?Object.getOwnPropertyDescriptor(t,o):null;s&&(s.get||s.set)?Object.defineProperty(r,o,s):r[o]=t[o];}return r.default=t,i&&i.set(t,r),r}(Kl);function kc(t){if("function"!=typeof WeakMap)return null;var e=new WeakMap,i=new WeakMap;return (kc=function(t){return t?i:e})(t)}function Bc(){var t=new Lc.ARRAY_TYPE(3);return Lc.ARRAY_TYPE!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0),t}function Oc(t){return Math.hypot(t[0],t[1],t[2])}function Fc(t,e,i){return t[0]=e[0]-i[0],t[1]=e[1]-i[1],t[2]=e[2]-i[2],t}function Nc(t,e,i){return t[0]=e[0]*i[0],t[1]=e[1]*i[1],t[2]=e[2]*i[2],t}function Uc(t,e,i){return t[0]=e[0]/i[0],t[1]=e[1]/i[1],t[2]=e[2]/i[2],t}function Vc(t,e){return Math.hypot(e[0]-t[0],e[1]-t[1],e[2]-t[2])}function jc(t,e){var i=e[0]-t[0],r=e[1]-t[1],n=e[2]-t[2];return i*i+r*r+n*n}function Gc(t){var e=t[0],i=t[1],r=t[2];return e*e+i*i+r*r}function qc(t,e){return t[0]*e[0]+t[1]*e[1]+t[2]*e[2]}Pc.sub=Fc,Pc.mul=Nc,Pc.div=Uc,Pc.dist=Vc,Pc.sqrDist=jc,Pc.len=Oc,Pc.sqrLen=Gc;var Zc,$c=(Zc=Bc(),function(t,e,i,r,n,o){var s,a;for(e||(e=3),i||(i=0),a=r?Math.min(r*e+i,t.length):t.length,s=i;s<a;s+=e)Zc[0]=t[s],Zc[1]=t[s+1],Zc[2]=t[s+2],n(Zc,Zc,o),t[s]=Zc[0],t[s+1]=Zc[1],t[s+2]=Zc[2];return t});Pc.forEach=$c;var Hc={};function Wc(t){return Wc="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t},Wc(t)}Object.defineProperty(Hc,"__esModule",{value:!0}),Hc.create=Kc,Hc.clone=function(t){var e=new Xc.ARRAY_TYPE(4);return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e},Hc.fromValues=function(t,e,i,r){var n=new Xc.ARRAY_TYPE(4);return n[0]=t,n[1]=e,n[2]=i,n[3]=r,n},Hc.copy=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t},Hc.set=function(t,e,i,r,n){return t[0]=e,t[1]=i,t[2]=r,t[3]=n,t},Hc.add=function(t,e,i){return t[0]=e[0]+i[0],t[1]=e[1]+i[1],t[2]=e[2]+i[2],t[3]=e[3]+i[3],t},Hc.subtract=Jc,Hc.multiply=Qc,Hc.divide=th,Hc.ceil=function(t,e){return t[0]=Math.ceil(e[0]),t[1]=Math.ceil(e[1]),t[2]=Math.ceil(e[2]),t[3]=Math.ceil(e[3]),t},Hc.floor=function(t,e){return t[0]=Math.floor(e[0]),t[1]=Math.floor(e[1]),t[2]=Math.floor(e[2]),t[3]=Math.floor(e[3]),t},Hc.min=function(t,e,i){return t[0]=Math.min(e[0],i[0]),t[1]=Math.min(e[1],i[1]),t[2]=Math.min(e[2],i[2]),t[3]=Math.min(e[3],i[3]),t},Hc.max=function(t,e,i){return t[0]=Math.max(e[0],i[0]),t[1]=Math.max(e[1],i[1]),t[2]=Math.max(e[2],i[2]),t[3]=Math.max(e[3],i[3]),t},Hc.round=function(t,e){return t[0]=Math.round(e[0]),t[1]=Math.round(e[1]),t[2]=Math.round(e[2]),t[3]=Math.round(e[3]),t},Hc.scale=function(t,e,i){return t[0]=e[0]*i,t[1]=e[1]*i,t[2]=e[2]*i,t[3]=e[3]*i,t},Hc.scaleAndAdd=function(t,e,i,r){return t[0]=e[0]+i[0]*r,t[1]=e[1]+i[1]*r,t[2]=e[2]+i[2]*r,t[3]=e[3]+i[3]*r,t},Hc.distance=eh,Hc.squaredDistance=ih,Hc.length=rh,Hc.squaredLength=nh,Hc.negate=function(t,e){return t[0]=-e[0],t[1]=-e[1],t[2]=-e[2],t[3]=-e[3],t},Hc.inverse=function(t,e){return t[0]=1/e[0],t[1]=1/e[1],t[2]=1/e[2],t[3]=1/e[3],t},Hc.normalize=function(t,e){var i=e[0],r=e[1],n=e[2],o=e[3],s=i*i+r*r+n*n+o*o;return s>0&&(s=1/Math.sqrt(s)),t[0]=i*s,t[1]=r*s,t[2]=n*s,t[3]=o*s,t},Hc.dot=function(t,e){return t[0]*e[0]+t[1]*e[1]+t[2]*e[2]+t[3]*e[3]},Hc.cross=function(t,e,i,r){var n=i[0]*r[1]-i[1]*r[0],o=i[0]*r[2]-i[2]*r[0],s=i[0]*r[3]-i[3]*r[0],a=i[1]*r[2]-i[2]*r[1],l=i[1]*r[3]-i[3]*r[1],c=i[2]*r[3]-i[3]*r[2],h=e[0],u=e[1],d=e[2],p=e[3];return t[0]=u*c-d*l+p*a,t[1]=-h*c+d*s-p*o,t[2]=h*l-u*s+p*n,t[3]=-h*a+u*o-d*n,t},Hc.lerp=function(t,e,i,r){var n=e[0],o=e[1],s=e[2],a=e[3];return t[0]=n+r*(i[0]-n),t[1]=o+r*(i[1]-o),t[2]=s+r*(i[2]-s),t[3]=a+r*(i[3]-a),t},Hc.random=function(t,e){var i,r,n,o,s,a;e=e||1;do{s=(i=2*Xc.RANDOM()-1)*i+(r=2*Xc.RANDOM()-1)*r;}while(s>=1);do{a=(n=2*Xc.RANDOM()-1)*n+(o=2*Xc.RANDOM()-1)*o;}while(a>=1);var l=Math.sqrt((1-s)/a);return t[0]=e*i,t[1]=e*r,t[2]=e*n*l,t[3]=e*o*l,t},Hc.transformMat4=function(t,e,i){var r=e[0],n=e[1],o=e[2],s=e[3];return t[0]=i[0]*r+i[4]*n+i[8]*o+i[12]*s,t[1]=i[1]*r+i[5]*n+i[9]*o+i[13]*s,t[2]=i[2]*r+i[6]*n+i[10]*o+i[14]*s,t[3]=i[3]*r+i[7]*n+i[11]*o+i[15]*s,t},Hc.transformQuat=function(t,e,i){var r=e[0],n=e[1],o=e[2],s=i[0],a=i[1],l=i[2],c=i[3],h=c*r+a*o-l*n,u=c*n+l*r-s*o,d=c*o+s*n-a*r,p=-s*r-a*n-l*o;return t[0]=h*c+p*-s+u*-l-d*-a,t[1]=u*c+p*-a+d*-s-h*-l,t[2]=d*c+p*-l+h*-a-u*-s,t[3]=e[3],t},Hc.zero=function(t){return t[0]=0,t[1]=0,t[2]=0,t[3]=0,t},Hc.str=function(t){return "vec4("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+")"},Hc.exactEquals=function(t,e){return t[0]===e[0]&&t[1]===e[1]&&t[2]===e[2]&&t[3]===e[3]},Hc.equals=function(t,e){var i=t[0],r=t[1],n=t[2],o=t[3],s=e[0],a=e[1],l=e[2],c=e[3];return Math.abs(i-s)<=Xc.EPSILON*Math.max(1,Math.abs(i),Math.abs(s))&&Math.abs(r-a)<=Xc.EPSILON*Math.max(1,Math.abs(r),Math.abs(a))&&Math.abs(n-l)<=Xc.EPSILON*Math.max(1,Math.abs(n),Math.abs(l))&&Math.abs(o-c)<=Xc.EPSILON*Math.max(1,Math.abs(o),Math.abs(c))},Hc.forEach=Hc.sqrLen=Hc.len=Hc.sqrDist=Hc.dist=Hc.div=Hc.mul=Hc.sub=void 0;var Xc=function(t,e){if(t&&t.__esModule)return t;if(null===t||"object"!==Wc(t)&&"function"!=typeof t)return {default:t};var i=Yc(void 0);if(i&&i.has(t))return i.get(t);var r={},n=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var o in t)if("default"!==o&&Object.prototype.hasOwnProperty.call(t,o)){var s=n?Object.getOwnPropertyDescriptor(t,o):null;s&&(s.get||s.set)?Object.defineProperty(r,o,s):r[o]=t[o];}return r.default=t,i&&i.set(t,r),r}(Kl);function Yc(t){if("function"!=typeof WeakMap)return null;var e=new WeakMap,i=new WeakMap;return (Yc=function(t){return t?i:e})(t)}function Kc(){var t=new Xc.ARRAY_TYPE(4);return Xc.ARRAY_TYPE!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0,t[3]=0),t}function Jc(t,e,i){return t[0]=e[0]-i[0],t[1]=e[1]-i[1],t[2]=e[2]-i[2],t[3]=e[3]-i[3],t}function Qc(t,e,i){return t[0]=e[0]*i[0],t[1]=e[1]*i[1],t[2]=e[2]*i[2],t[3]=e[3]*i[3],t}function th(t,e,i){return t[0]=e[0]/i[0],t[1]=e[1]/i[1],t[2]=e[2]/i[2],t[3]=e[3]/i[3],t}function eh(t,e){return Math.hypot(e[0]-t[0],e[1]-t[1],e[2]-t[2],e[3]-t[3])}function ih(t,e){var i=e[0]-t[0],r=e[1]-t[1],n=e[2]-t[2],o=e[3]-t[3];return i*i+r*r+n*n+o*o}function rh(t){return Math.hypot(t[0],t[1],t[2],t[3])}function nh(t){var e=t[0],i=t[1],r=t[2],n=t[3];return e*e+i*i+r*r+n*n}Hc.sub=Jc,Hc.mul=Qc,Hc.div=th,Hc.dist=eh,Hc.sqrDist=ih,Hc.len=rh,Hc.sqrLen=nh;var oh=function(){var t=Kc();return function(e,i,r,n,o,s){var a,l;for(i||(i=4),r||(r=0),l=n?Math.min(n*i+r,e.length):e.length,a=r;a<l;a+=i)t[0]=e[a],t[1]=e[a+1],t[2]=e[a+2],t[3]=e[a+3],o(t,t,s),e[a]=t[0],e[a+1]=t[1],e[a+2]=t[2],e[a+3]=t[3];return e}}();function sh(t){return sh="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t},sh(t)}Hc.forEach=oh,Object.defineProperty(Dc,"__esModule",{value:!0}),Dc.create=ph,Dc.identity=function(t){return t[0]=0,t[1]=0,t[2]=0,t[3]=1,t},Dc.setAxisAngle=fh,Dc.getAxisAngle=function(t,e){var i=2*Math.acos(e[3]),r=Math.sin(i/2);return r>ah.EPSILON?(t[0]=e[0]/r,t[1]=e[1]/r,t[2]=e[2]/r):(t[0]=1,t[1]=0,t[2]=0),i},Dc.getAngle=function(t,e){var i=bh(t,e);return Math.acos(2*i*i-1)},Dc.multiply=mh,Dc.rotateX=function(t,e,i){i*=.5;var r=e[0],n=e[1],o=e[2],s=e[3],a=Math.sin(i),l=Math.cos(i);return t[0]=r*l+s*a,t[1]=n*l+o*a,t[2]=o*l-n*a,t[3]=s*l-r*a,t},Dc.rotateY=function(t,e,i){i*=.5;var r=e[0],n=e[1],o=e[2],s=e[3],a=Math.sin(i),l=Math.cos(i);return t[0]=r*l-o*a,t[1]=n*l+s*a,t[2]=o*l+r*a,t[3]=s*l-n*a,t},Dc.rotateZ=function(t,e,i){i*=.5;var r=e[0],n=e[1],o=e[2],s=e[3],a=Math.sin(i),l=Math.cos(i);return t[0]=r*l+n*a,t[1]=n*l-r*a,t[2]=o*l+s*a,t[3]=s*l-o*a,t},Dc.calculateW=function(t,e){var i=e[0],r=e[1],n=e[2];return t[0]=i,t[1]=r,t[2]=n,t[3]=Math.sqrt(Math.abs(1-i*i-r*r-n*n)),t},Dc.exp=_h,Dc.ln=gh,Dc.pow=function(t,e,i){return gh(t,e),vh(t,t,i),_h(t,t),t},Dc.slerp=yh,Dc.random=function(t){var e=ah.RANDOM(),i=ah.RANDOM(),r=ah.RANDOM(),n=Math.sqrt(1-e),o=Math.sqrt(e);return t[0]=n*Math.sin(2*Math.PI*i),t[1]=n*Math.cos(2*Math.PI*i),t[2]=o*Math.sin(2*Math.PI*r),t[3]=o*Math.cos(2*Math.PI*r),t},Dc.invert=function(t,e){var i=e[0],r=e[1],n=e[2],o=e[3],s=i*i+r*r+n*n+o*o,a=s?1/s:0;return t[0]=-i*a,t[1]=-r*a,t[2]=-n*a,t[3]=o*a,t},Dc.conjugate=function(t,e){return t[0]=-e[0],t[1]=-e[1],t[2]=-e[2],t[3]=e[3],t},Dc.fromMat3=xh,Dc.fromEuler=function(t,e,i,r){var n=.5*Math.PI/180;e*=n,i*=n,r*=n;var o=Math.sin(e),s=Math.cos(e),a=Math.sin(i),l=Math.cos(i),c=Math.sin(r),h=Math.cos(r);return t[0]=o*l*h-s*a*c,t[1]=s*a*h+o*l*c,t[2]=s*l*c-o*a*h,t[3]=s*l*h+o*a*c,t},Dc.str=function(t){return "quat("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+")"},Dc.setAxes=Dc.sqlerp=Dc.rotationTo=Dc.equals=Dc.exactEquals=Dc.normalize=Dc.sqrLen=Dc.squaredLength=Dc.len=Dc.length=Dc.lerp=Dc.dot=Dc.scale=Dc.mul=Dc.add=Dc.set=Dc.copy=Dc.fromValues=Dc.clone=void 0;var ah=dh(Kl),lh=dh(fc),ch=dh(Pc),hh=dh(Hc);function uh(t){if("function"!=typeof WeakMap)return null;var e=new WeakMap,i=new WeakMap;return (uh=function(t){return t?i:e})(t)}function dh(t,e){if(!e&&t&&t.__esModule)return t;if(null===t||"object"!==sh(t)&&"function"!=typeof t)return {default:t};var i=uh(e);if(i&&i.has(t))return i.get(t);var r={},n=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var o in t)if("default"!==o&&Object.prototype.hasOwnProperty.call(t,o)){var s=n?Object.getOwnPropertyDescriptor(t,o):null;s&&(s.get||s.set)?Object.defineProperty(r,o,s):r[o]=t[o];}return r.default=t,i&&i.set(t,r),r}function ph(){var t=new ah.ARRAY_TYPE(4);return ah.ARRAY_TYPE!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0),t[3]=1,t}function fh(t,e,i){i*=.5;var r=Math.sin(i);return t[0]=r*e[0],t[1]=r*e[1],t[2]=r*e[2],t[3]=Math.cos(i),t}function mh(t,e,i){var r=e[0],n=e[1],o=e[2],s=e[3],a=i[0],l=i[1],c=i[2],h=i[3];return t[0]=r*h+s*a+n*c-o*l,t[1]=n*h+s*l+o*a-r*c,t[2]=o*h+s*c+r*l-n*a,t[3]=s*h-r*a-n*l-o*c,t}function _h(t,e){var i=e[0],r=e[1],n=e[2],o=e[3],s=Math.sqrt(i*i+r*r+n*n),a=Math.exp(o),l=s>0?a*Math.sin(s)/s:0;return t[0]=i*l,t[1]=r*l,t[2]=n*l,t[3]=a*Math.cos(s),t}function gh(t,e){var i=e[0],r=e[1],n=e[2],o=e[3],s=Math.sqrt(i*i+r*r+n*n),a=s>0?Math.atan2(s,o)/s:0;return t[0]=i*a,t[1]=r*a,t[2]=n*a,t[3]=.5*Math.log(i*i+r*r+n*n+o*o),t}function yh(t,e,i,r){var n,o,s,a,l,c=e[0],h=e[1],u=e[2],d=e[3],p=i[0],f=i[1],m=i[2],_=i[3];return (o=c*p+h*f+u*m+d*_)<0&&(o=-o,p=-p,f=-f,m=-m,_=-_),1-o>ah.EPSILON?(n=Math.acos(o),s=Math.sin(n),a=Math.sin((1-r)*n)/s,l=Math.sin(r*n)/s):(a=1-r,l=r),t[0]=a*c+l*p,t[1]=a*h+l*f,t[2]=a*u+l*m,t[3]=a*d+l*_,t}function xh(t,e){var i,r=e[0]+e[4]+e[8];if(r>0)i=Math.sqrt(r+1),t[3]=.5*i,t[0]=(e[5]-e[7])*(i=.5/i),t[1]=(e[6]-e[2])*i,t[2]=(e[1]-e[3])*i;else {var n=0;e[4]>e[0]&&(n=1),e[8]>e[3*n+n]&&(n=2);var o=(n+1)%3,s=(n+2)%3;i=Math.sqrt(e[3*n+n]-e[3*o+o]-e[3*s+s]+1),t[n]=.5*i,t[3]=(e[3*o+s]-e[3*s+o])*(i=.5/i),t[o]=(e[3*o+n]+e[3*n+o])*i,t[s]=(e[3*s+n]+e[3*n+s])*i;}return t}Dc.clone=hh.clone,Dc.fromValues=hh.fromValues,Dc.copy=hh.copy,Dc.set=hh.set,Dc.add=hh.add,Dc.mul=mh;var vh=hh.scale;Dc.scale=vh;var bh=hh.dot;Dc.dot=bh,Dc.lerp=hh.lerp;var wh=hh.length;Dc.length=wh,Dc.len=wh;var Th=hh.squaredLength;Dc.squaredLength=Th,Dc.sqrLen=Th;var Eh=hh.normalize;Dc.normalize=Eh,Dc.exactEquals=hh.exactEquals,Dc.equals=hh.equals;var Mh,Ah,Sh,Ih=(Mh=ch.create(),Ah=ch.fromValues(1,0,0),Sh=ch.fromValues(0,1,0),function(t,e,i){var r=ch.dot(e,i);return r<-.999999?(ch.cross(Mh,Ah,e),ch.len(Mh)<1e-6&&ch.cross(Mh,Sh,e),ch.normalize(Mh,Mh),fh(t,Mh,Math.PI),t):r>.999999?(t[0]=0,t[1]=0,t[2]=0,t[3]=1,t):(ch.cross(Mh,e,i),t[0]=Mh[0],t[1]=Mh[1],t[2]=Mh[2],t[3]=1+r,Eh(t,t))});Dc.rotationTo=Ih;var Ch,zh,Dh=(Ch=ph(),zh=ph(),function(t,e,i,r,n,o){return yh(Ch,e,n,o),yh(zh,i,r,o),yh(t,Ch,zh,2*o*(1-o)),t});Dc.sqlerp=Dh;var Ph,Rh=(Ph=lh.create(),function(t,e,i,r){return Ph[0]=i[0],Ph[3]=i[1],Ph[6]=i[2],Ph[1]=r[0],Ph[4]=r[1],Ph[7]=r[2],Ph[2]=-e[0],Ph[5]=-e[1],Ph[8]=-e[2],Eh(t,xh(t,Ph))});Dc.setAxes=Rh;var Lh={};function kh(t){return kh="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t},kh(t)}Object.defineProperty(Lh,"__esModule",{value:!0}),Lh.create=function(){var t=new Bh.ARRAY_TYPE(8);return Bh.ARRAY_TYPE!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0,t[4]=0,t[5]=0,t[6]=0,t[7]=0),t[3]=1,t},Lh.clone=function(t){var e=new Bh.ARRAY_TYPE(8);return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e},Lh.fromValues=function(t,e,i,r,n,o,s,a){var l=new Bh.ARRAY_TYPE(8);return l[0]=t,l[1]=e,l[2]=i,l[3]=r,l[4]=n,l[5]=o,l[6]=s,l[7]=a,l},Lh.fromRotationTranslationValues=function(t,e,i,r,n,o,s){var a=new Bh.ARRAY_TYPE(8);a[0]=t,a[1]=e,a[2]=i,a[3]=r;var l=.5*n,c=.5*o,h=.5*s;return a[4]=l*r+c*i-h*e,a[5]=c*r+h*t-l*i,a[6]=h*r+l*e-c*t,a[7]=-l*t-c*e-h*i,a},Lh.fromRotationTranslation=Vh,Lh.fromTranslation=function(t,e){return t[0]=0,t[1]=0,t[2]=0,t[3]=1,t[4]=.5*e[0],t[5]=.5*e[1],t[6]=.5*e[2],t[7]=0,t},Lh.fromRotation=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=0,t[5]=0,t[6]=0,t[7]=0,t},Lh.fromMat4=function(t,e){var i=Oh.create();Fh.getRotation(i,e);var r=new Bh.ARRAY_TYPE(3);return Fh.getTranslation(r,e),Vh(t,i,r),t},Lh.copy=jh,Lh.identity=function(t){return t[0]=0,t[1]=0,t[2]=0,t[3]=1,t[4]=0,t[5]=0,t[6]=0,t[7]=0,t},Lh.set=function(t,e,i,r,n,o,s,a,l){return t[0]=e,t[1]=i,t[2]=r,t[3]=n,t[4]=o,t[5]=s,t[6]=a,t[7]=l,t},Lh.getDual=function(t,e){return t[0]=e[4],t[1]=e[5],t[2]=e[6],t[3]=e[7],t},Lh.setDual=function(t,e){return t[4]=e[0],t[5]=e[1],t[6]=e[2],t[7]=e[3],t},Lh.getTranslation=function(t,e){var i=e[4],r=e[5],n=e[6],o=e[7],s=-e[0],a=-e[1],l=-e[2],c=e[3];return t[0]=2*(i*c+o*s+r*l-n*a),t[1]=2*(r*c+o*a+n*s-i*l),t[2]=2*(n*c+o*l+i*a-r*s),t},Lh.translate=function(t,e,i){var r=e[0],n=e[1],o=e[2],s=e[3],a=.5*i[0],l=.5*i[1],c=.5*i[2],h=e[4],u=e[5],d=e[6],p=e[7];return t[0]=r,t[1]=n,t[2]=o,t[3]=s,t[4]=s*a+n*c-o*l+h,t[5]=s*l+o*a-r*c+u,t[6]=s*c+r*l-n*a+d,t[7]=-r*a-n*l-o*c+p,t},Lh.rotateX=function(t,e,i){var r=-e[0],n=-e[1],o=-e[2],s=e[3],a=e[4],l=e[5],c=e[6],h=e[7],u=a*s+h*r+l*o-c*n,d=l*s+h*n+c*r-a*o,p=c*s+h*o+a*n-l*r,f=h*s-a*r-l*n-c*o;return Oh.rotateX(t,e,i),t[4]=u*(s=t[3])+f*(r=t[0])+d*(o=t[2])-p*(n=t[1]),t[5]=d*s+f*n+p*r-u*o,t[6]=p*s+f*o+u*n-d*r,t[7]=f*s-u*r-d*n-p*o,t},Lh.rotateY=function(t,e,i){var r=-e[0],n=-e[1],o=-e[2],s=e[3],a=e[4],l=e[5],c=e[6],h=e[7],u=a*s+h*r+l*o-c*n,d=l*s+h*n+c*r-a*o,p=c*s+h*o+a*n-l*r,f=h*s-a*r-l*n-c*o;return Oh.rotateY(t,e,i),t[4]=u*(s=t[3])+f*(r=t[0])+d*(o=t[2])-p*(n=t[1]),t[5]=d*s+f*n+p*r-u*o,t[6]=p*s+f*o+u*n-d*r,t[7]=f*s-u*r-d*n-p*o,t},Lh.rotateZ=function(t,e,i){var r=-e[0],n=-e[1],o=-e[2],s=e[3],a=e[4],l=e[5],c=e[6],h=e[7],u=a*s+h*r+l*o-c*n,d=l*s+h*n+c*r-a*o,p=c*s+h*o+a*n-l*r,f=h*s-a*r-l*n-c*o;return Oh.rotateZ(t,e,i),t[4]=u*(s=t[3])+f*(r=t[0])+d*(o=t[2])-p*(n=t[1]),t[5]=d*s+f*n+p*r-u*o,t[6]=p*s+f*o+u*n-d*r,t[7]=f*s-u*r-d*n-p*o,t},Lh.rotateByQuatAppend=function(t,e,i){var r=i[0],n=i[1],o=i[2],s=i[3],a=e[0],l=e[1],c=e[2],h=e[3];return t[0]=a*s+h*r+l*o-c*n,t[1]=l*s+h*n+c*r-a*o,t[2]=c*s+h*o+a*n-l*r,t[3]=h*s-a*r-l*n-c*o,t[4]=(a=e[4])*s+(h=e[7])*r+(l=e[5])*o-(c=e[6])*n,t[5]=l*s+h*n+c*r-a*o,t[6]=c*s+h*o+a*n-l*r,t[7]=h*s-a*r-l*n-c*o,t},Lh.rotateByQuatPrepend=function(t,e,i){var r=e[0],n=e[1],o=e[2],s=e[3],a=i[0],l=i[1],c=i[2],h=i[3];return t[0]=r*h+s*a+n*c-o*l,t[1]=n*h+s*l+o*a-r*c,t[2]=o*h+s*c+r*l-n*a,t[3]=s*h-r*a-n*l-o*c,t[4]=r*(h=i[7])+s*(a=i[4])+n*(c=i[6])-o*(l=i[5]),t[5]=n*h+s*l+o*a-r*c,t[6]=o*h+s*c+r*l-n*a,t[7]=s*h-r*a-n*l-o*c,t},Lh.rotateAroundAxis=function(t,e,i,r){if(Math.abs(r)<Bh.EPSILON)return jh(t,e);var n=Math.hypot(i[0],i[1],i[2]);r*=.5;var o=Math.sin(r),s=o*i[0]/n,a=o*i[1]/n,l=o*i[2]/n,c=Math.cos(r),h=e[0],u=e[1],d=e[2],p=e[3];t[0]=h*c+p*s+u*l-d*a,t[1]=u*c+p*a+d*s-h*l,t[2]=d*c+p*l+h*a-u*s,t[3]=p*c-h*s-u*a-d*l;var f=e[4],m=e[5],_=e[6],g=e[7];return t[4]=f*c+g*s+m*l-_*a,t[5]=m*c+g*a+_*s-f*l,t[6]=_*c+g*l+f*a-m*s,t[7]=g*c-f*s-m*a-_*l,t},Lh.add=function(t,e,i){return t[0]=e[0]+i[0],t[1]=e[1]+i[1],t[2]=e[2]+i[2],t[3]=e[3]+i[3],t[4]=e[4]+i[4],t[5]=e[5]+i[5],t[6]=e[6]+i[6],t[7]=e[7]+i[7],t},Lh.multiply=Gh,Lh.scale=function(t,e,i){return t[0]=e[0]*i,t[1]=e[1]*i,t[2]=e[2]*i,t[3]=e[3]*i,t[4]=e[4]*i,t[5]=e[5]*i,t[6]=e[6]*i,t[7]=e[7]*i,t},Lh.lerp=function(t,e,i,r){var n=1-r;return qh(e,i)<0&&(r=-r),t[0]=e[0]*n+i[0]*r,t[1]=e[1]*n+i[1]*r,t[2]=e[2]*n+i[2]*r,t[3]=e[3]*n+i[3]*r,t[4]=e[4]*n+i[4]*r,t[5]=e[5]*n+i[5]*r,t[6]=e[6]*n+i[6]*r,t[7]=e[7]*n+i[7]*r,t},Lh.invert=function(t,e){var i=$h(e);return t[0]=-e[0]/i,t[1]=-e[1]/i,t[2]=-e[2]/i,t[3]=e[3]/i,t[4]=-e[4]/i,t[5]=-e[5]/i,t[6]=-e[6]/i,t[7]=e[7]/i,t},Lh.conjugate=function(t,e){return t[0]=-e[0],t[1]=-e[1],t[2]=-e[2],t[3]=e[3],t[4]=-e[4],t[5]=-e[5],t[6]=-e[6],t[7]=e[7],t},Lh.normalize=function(t,e){var i=$h(e);if(i>0){i=Math.sqrt(i);var r=e[0]/i,n=e[1]/i,o=e[2]/i,s=e[3]/i,a=e[4],l=e[5],c=e[6],h=e[7],u=r*a+n*l+o*c+s*h;t[0]=r,t[1]=n,t[2]=o,t[3]=s,t[4]=(a-r*u)/i,t[5]=(l-n*u)/i,t[6]=(c-o*u)/i,t[7]=(h-s*u)/i;}return t},Lh.str=function(t){return "quat2("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+", "+t[4]+", "+t[5]+", "+t[6]+", "+t[7]+")"},Lh.exactEquals=function(t,e){return t[0]===e[0]&&t[1]===e[1]&&t[2]===e[2]&&t[3]===e[3]&&t[4]===e[4]&&t[5]===e[5]&&t[6]===e[6]&&t[7]===e[7]},Lh.equals=function(t,e){var i=t[0],r=t[1],n=t[2],o=t[3],s=t[4],a=t[5],l=t[6],c=t[7],h=e[0],u=e[1],d=e[2],p=e[3],f=e[4],m=e[5],_=e[6],g=e[7];return Math.abs(i-h)<=Bh.EPSILON*Math.max(1,Math.abs(i),Math.abs(h))&&Math.abs(r-u)<=Bh.EPSILON*Math.max(1,Math.abs(r),Math.abs(u))&&Math.abs(n-d)<=Bh.EPSILON*Math.max(1,Math.abs(n),Math.abs(d))&&Math.abs(o-p)<=Bh.EPSILON*Math.max(1,Math.abs(o),Math.abs(p))&&Math.abs(s-f)<=Bh.EPSILON*Math.max(1,Math.abs(s),Math.abs(f))&&Math.abs(a-m)<=Bh.EPSILON*Math.max(1,Math.abs(a),Math.abs(m))&&Math.abs(l-_)<=Bh.EPSILON*Math.max(1,Math.abs(l),Math.abs(_))&&Math.abs(c-g)<=Bh.EPSILON*Math.max(1,Math.abs(c),Math.abs(g))},Lh.sqrLen=Lh.squaredLength=Lh.len=Lh.length=Lh.dot=Lh.mul=Lh.setReal=Lh.getReal=void 0;var Bh=Uh(Kl),Oh=Uh(Dc),Fh=Uh(vc);function Nh(t){if("function"!=typeof WeakMap)return null;var e=new WeakMap,i=new WeakMap;return (Nh=function(t){return t?i:e})(t)}function Uh(t,e){if(!e&&t&&t.__esModule)return t;if(null===t||"object"!==kh(t)&&"function"!=typeof t)return {default:t};var i=Nh(e);if(i&&i.has(t))return i.get(t);var r={},n=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var o in t)if("default"!==o&&Object.prototype.hasOwnProperty.call(t,o)){var s=n?Object.getOwnPropertyDescriptor(t,o):null;s&&(s.get||s.set)?Object.defineProperty(r,o,s):r[o]=t[o];}return r.default=t,i&&i.set(t,r),r}function Vh(t,e,i){var r=.5*i[0],n=.5*i[1],o=.5*i[2],s=e[0],a=e[1],l=e[2],c=e[3];return t[0]=s,t[1]=a,t[2]=l,t[3]=c,t[4]=r*c+n*l-o*a,t[5]=n*c+o*s-r*l,t[6]=o*c+r*a-n*s,t[7]=-r*s-n*a-o*l,t}function jh(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t}function Gh(t,e,i){var r=e[0],n=e[1],o=e[2],s=e[3],a=i[4],l=i[5],c=i[6],h=i[7],u=e[4],d=e[5],p=e[6],f=e[7],m=i[0],_=i[1],g=i[2],y=i[3];return t[0]=r*y+s*m+n*g-o*_,t[1]=n*y+s*_+o*m-r*g,t[2]=o*y+s*g+r*_-n*m,t[3]=s*y-r*m-n*_-o*g,t[4]=r*h+s*a+n*c-o*l+u*y+f*m+d*g-p*_,t[5]=n*h+s*l+o*a-r*c+d*y+f*_+p*m-u*g,t[6]=o*h+s*c+r*l-n*a+p*y+f*g+u*_-d*m,t[7]=s*h-r*a-n*l-o*c+f*y-u*m-d*_-p*g,t}Lh.getReal=Oh.copy,Lh.setReal=Oh.copy,Lh.mul=Gh;var qh=Oh.dot;Lh.dot=qh;var Zh=Oh.length;Lh.length=Zh,Lh.len=Zh;var $h=Oh.squaredLength;Lh.squaredLength=$h,Lh.sqrLen=$h;var Hh={};function Wh(t){return Wh="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t},Wh(t)}Object.defineProperty(Hh,"__esModule",{value:!0}),Hh.create=Kh,Hh.clone=function(t){var e=new Xh.ARRAY_TYPE(2);return e[0]=t[0],e[1]=t[1],e},Hh.fromValues=function(t,e){var i=new Xh.ARRAY_TYPE(2);return i[0]=t,i[1]=e,i},Hh.copy=function(t,e){return t[0]=e[0],t[1]=e[1],t},Hh.set=function(t,e,i){return t[0]=e,t[1]=i,t},Hh.add=function(t,e,i){return t[0]=e[0]+i[0],t[1]=e[1]+i[1],t},Hh.subtract=Jh,Hh.multiply=Qh,Hh.divide=tu,Hh.ceil=function(t,e){return t[0]=Math.ceil(e[0]),t[1]=Math.ceil(e[1]),t},Hh.floor=function(t,e){return t[0]=Math.floor(e[0]),t[1]=Math.floor(e[1]),t},Hh.min=function(t,e,i){return t[0]=Math.min(e[0],i[0]),t[1]=Math.min(e[1],i[1]),t},Hh.max=function(t,e,i){return t[0]=Math.max(e[0],i[0]),t[1]=Math.max(e[1],i[1]),t},Hh.round=function(t,e){return t[0]=Math.round(e[0]),t[1]=Math.round(e[1]),t},Hh.scale=function(t,e,i){return t[0]=e[0]*i,t[1]=e[1]*i,t},Hh.scaleAndAdd=function(t,e,i,r){return t[0]=e[0]+i[0]*r,t[1]=e[1]+i[1]*r,t},Hh.distance=eu,Hh.squaredDistance=iu,Hh.length=ru,Hh.squaredLength=nu,Hh.negate=function(t,e){return t[0]=-e[0],t[1]=-e[1],t},Hh.inverse=function(t,e){return t[0]=1/e[0],t[1]=1/e[1],t},Hh.normalize=function(t,e){var i=e[0],r=e[1],n=i*i+r*r;return n>0&&(n=1/Math.sqrt(n)),t[0]=e[0]*n,t[1]=e[1]*n,t},Hh.dot=function(t,e){return t[0]*e[0]+t[1]*e[1]},Hh.cross=function(t,e,i){var r=e[0]*i[1]-e[1]*i[0];return t[0]=t[1]=0,t[2]=r,t},Hh.lerp=function(t,e,i,r){var n=e[0],o=e[1];return t[0]=n+r*(i[0]-n),t[1]=o+r*(i[1]-o),t},Hh.random=function(t,e){e=e||1;var i=2*Xh.RANDOM()*Math.PI;return t[0]=Math.cos(i)*e,t[1]=Math.sin(i)*e,t},Hh.transformMat2=function(t,e,i){var r=e[0],n=e[1];return t[0]=i[0]*r+i[2]*n,t[1]=i[1]*r+i[3]*n,t},Hh.transformMat2d=function(t,e,i){var r=e[0],n=e[1];return t[0]=i[0]*r+i[2]*n+i[4],t[1]=i[1]*r+i[3]*n+i[5],t},Hh.transformMat3=function(t,e,i){var r=e[0],n=e[1];return t[0]=i[0]*r+i[3]*n+i[6],t[1]=i[1]*r+i[4]*n+i[7],t},Hh.transformMat4=function(t,e,i){var r=e[0],n=e[1];return t[0]=i[0]*r+i[4]*n+i[12],t[1]=i[1]*r+i[5]*n+i[13],t},Hh.rotate=function(t,e,i,r){var n=e[0]-i[0],o=e[1]-i[1],s=Math.sin(r),a=Math.cos(r);return t[0]=n*a-o*s+i[0],t[1]=n*s+o*a+i[1],t},Hh.angle=function(t,e){var i=t[0],r=t[1],n=e[0],o=e[1],s=Math.sqrt(i*i+r*r)*Math.sqrt(n*n+o*o);return Math.acos(Math.min(Math.max(s&&(i*n+r*o)/s,-1),1))},Hh.zero=function(t){return t[0]=0,t[1]=0,t},Hh.str=function(t){return "vec2("+t[0]+", "+t[1]+")"},Hh.exactEquals=function(t,e){return t[0]===e[0]&&t[1]===e[1]},Hh.equals=function(t,e){var i=t[0],r=t[1],n=e[0],o=e[1];return Math.abs(i-n)<=Xh.EPSILON*Math.max(1,Math.abs(i),Math.abs(n))&&Math.abs(r-o)<=Xh.EPSILON*Math.max(1,Math.abs(r),Math.abs(o))},Hh.forEach=Hh.sqrLen=Hh.sqrDist=Hh.dist=Hh.div=Hh.mul=Hh.sub=Hh.len=void 0;var Xh=function(t,e){if(t&&t.__esModule)return t;if(null===t||"object"!==Wh(t)&&"function"!=typeof t)return {default:t};var i=Yh(void 0);if(i&&i.has(t))return i.get(t);var r={},n=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var o in t)if("default"!==o&&Object.prototype.hasOwnProperty.call(t,o)){var s=n?Object.getOwnPropertyDescriptor(t,o):null;s&&(s.get||s.set)?Object.defineProperty(r,o,s):r[o]=t[o];}return r.default=t,i&&i.set(t,r),r}(Kl);function Yh(t){if("function"!=typeof WeakMap)return null;var e=new WeakMap,i=new WeakMap;return (Yh=function(t){return t?i:e})(t)}function Kh(){var t=new Xh.ARRAY_TYPE(2);return Xh.ARRAY_TYPE!=Float32Array&&(t[0]=0,t[1]=0),t}function Jh(t,e,i){return t[0]=e[0]-i[0],t[1]=e[1]-i[1],t}function Qh(t,e,i){return t[0]=e[0]*i[0],t[1]=e[1]*i[1],t}function tu(t,e,i){return t[0]=e[0]/i[0],t[1]=e[1]/i[1],t}function eu(t,e){return Math.hypot(e[0]-t[0],e[1]-t[1])}function iu(t,e){var i=e[0]-t[0],r=e[1]-t[1];return i*i+r*r}function ru(t){return Math.hypot(t[0],t[1])}function nu(t){var e=t[0],i=t[1];return e*e+i*i}Hh.len=ru,Hh.sub=Jh,Hh.mul=Qh,Hh.div=tu,Hh.dist=eu,Hh.sqrDist=iu,Hh.sqrLen=nu;var ou=function(){var t=Kh();return function(e,i,r,n,o,s){var a,l;for(i||(i=2),r||(r=0),l=n?Math.min(n*i+r,e.length):e.length,a=r;a<l;a+=i)t[0]=e[a],t[1]=e[a+1],o(t,t,s),e[a]=t[0],e[a+1]=t[1];return e}}();function su(t){return su="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t},su(t)}Hh.forEach=ou,Object.defineProperty(Yl,"__esModule",{value:!0});var au=Yl.vec4=bu=Yl.vec3=Yl.vec2=Yl.quat2=gu=Yl.quat=mu=Yl.mat4=pu=Yl.mat3=Yl.mat2d=hu=Yl.mat2=Yl.glMatrix=void 0,lu=Eu(Kl);Yl.glMatrix=lu;var cu=Eu(ic),hu=Yl.mat2=cu,uu=Eu(lc);Yl.mat2d=uu;var du=Eu(fc),pu=Yl.mat3=du,fu=Eu(vc),mu=Yl.mat4=fu,_u=Eu(Dc),gu=Yl.quat=_u,yu=Eu(Lh);Yl.quat2=yu;var xu=Eu(Hh);Yl.vec2=xu;var vu=Eu(Pc),bu=Yl.vec3=vu,wu=Eu(Hc);function Tu(t){if("function"!=typeof WeakMap)return null;var e=new WeakMap,i=new WeakMap;return (Tu=function(t){return t?i:e})(t)}function Eu(t,e){if(!e&&t&&t.__esModule)return t;if(null===t||"object"!==su(t)&&"function"!=typeof t)return {default:t};var i=Tu(e);if(i&&i.has(t))return i.get(t);var r={},n=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var o in t)if("default"!==o&&Object.prototype.hasOwnProperty.call(t,o)){var s=n?Object.getOwnPropertyDescriptor(t,o):null;s&&(s.get||s.set)?Object.defineProperty(r,o,s):r[o]=t[o];}return r.default=t,i&&i.set(t,r),r}au=Yl.vec4=wu;const Mu=_a([{type:"Float32",name:"a_globe_pos",components:3},{type:"Float32",name:"a_uv",components:2}]),{members:Au}=Mu,Su=_a([{name:"a_pos_3",components:3,type:"Int16"}]);var Iu=_a([{name:"a_pos",type:"Int16",components:2}]);class Cu{constructor(t,e){this.pos=t,this.dir=e;}intersectsPlane(t,e,i){const r=bu.dot(e,this.dir);if(Math.abs(r)<1e-6)return !1;const n=((t[0]-this.pos[0])*e[0]+(t[1]-this.pos[1])*e[1]+(t[2]-this.pos[2])*e[2])/r;return i[0]=this.pos[0]+this.dir[0]*n,i[1]=this.pos[1]+this.dir[1]*n,i[2]=this.pos[2]+this.dir[2]*n,!0}closestPointOnSphere(t,e,i){if(bu.equals(this.pos,t)||0===e)return i[0]=i[1]=i[2]=0,!1;const[r,n,o]=this.dir,s=this.pos[0]-t[0],a=this.pos[1]-t[1],l=this.pos[2]-t[2],c=r*r+n*n+o*o,h=2*(s*r+a*n+l*o),u=h*h-4*c*(s*s+a*a+l*l-e*e);if(u<0){const t=Math.max(-h/2,0),c=s+r*t,u=a+n*t,d=l+o*t,p=Math.hypot(c,u,d);return i[0]=c*e/p,i[1]=u*e/p,i[2]=d*e/p,!1}{const t=(-h-Math.sqrt(u))/(2*c);if(t<0){const t=Math.hypot(s,a,l);return i[0]=s*e/t,i[1]=a*e/t,i[2]=l*e/t,!1}return i[0]=s+r*t,i[1]=a+n*t,i[2]=l+o*t,!0}}}class zu{constructor(t,e,i,r,n){this.TL=t,this.TR=e,this.BR=i,this.BL=r,this.horizon=n;}static fromInvProjectionMatrix(t,e,i){const r=[-1,1,1],n=[1,1,1],o=[1,-1,1],s=[-1,-1,1],a=bu.transformMat4(r,r,t),l=bu.transformMat4(n,n,t),c=bu.transformMat4(o,o,t),h=bu.transformMat4(s,s,t);return new zu(a,l,c,h,e/i)}}function Du(t,e,i){let r=1/0,n=-1/0;const o=[];for(const s of t){bu.sub(o,s,e);const t=bu.dot(o,i);r=Math.min(r,t),n=Math.max(n,t);}return [r,n]}function Pu(t,e){let i=!0;for(let r=0;r<t.planes.length;r++){const n=t.planes[r];let o=0;for(let t=0;t<e.length;t++)o+=bu.dot(n,e[t])+n[3]>=0;if(0===o)return 0;o!==e.length&&(i=!1);}return i?2:1}function Ru(t,e){for(const i of t.projections){const r=Du(e,t.points[0],i.axis);if(i.projection[1]<r[0]||i.projection[0]>r[1])return 0}return 1}function Lu(t,e){let i=0;const r=[0,0,0,0];for(let n=0;n<t.length;n++)r[0]=t[n][0],r[1]=t[n][1],r[2]=t[n][2],r[3]=1,au.dot(r,e)>=0&&i++;return i}class ku{constructor(t,e){this.points=t||new Array(8).fill([0,0,0]),this.planes=e||new Array(6).fill([0,0,0,0]),this.bounds=Bu.fromPoints(this.points),this.projections=[],this.frustumEdges=[bu.sub([],this.points[2],this.points[3]),bu.sub([],this.points[0],this.points[3]),bu.sub([],this.points[4],this.points[0]),bu.sub([],this.points[5],this.points[1]),bu.sub([],this.points[6],this.points[2]),bu.sub([],this.points[7],this.points[3])];for(const t of this.frustumEdges){const e=[0,-t[2],t[1]],i=[t[2],0,-t[0]];this.projections.push({axis:e,projection:Du(this.points,this.points[0],e)}),this.projections.push({axis:i,projection:Du(this.points,this.points[0],i)});}}static fromInvProjectionMatrix(t,e,i,r){const n=Math.pow(2,i),o=[[-1,1,-1,1],[1,1,-1,1],[1,-1,-1,1],[-1,-1,-1,1],[-1,1,1,1],[1,1,1,1],[1,-1,1,1],[-1,-1,1,1]].map((i=>{const o=au.transformMat4([],i,t),s=1/o[3]/e*n;return au.mul(o,o,[s,s,r?1/o[3]:s,s])})),s=[[0,1,2],[6,5,4],[0,3,7],[2,1,5],[3,2,6],[0,4,5]].map((t=>{const e=bu.sub([],o[t[0]],o[t[1]]),i=bu.sub([],o[t[2]],o[t[1]]),r=bu.normalize([],bu.cross([],e,i)),n=-bu.dot(r,o[t[1]]);return r.concat(n)})),a=[];for(let t=0;t<o.length;t++)a.push([o[t][0],o[t][1],o[t][2]]);return new ku(a,s)}intersectsPrecise(t,e,i){for(let i=0;i<e.length;i++)if(!Lu(t,e[i]))return 0;for(let e=0;e<this.planes.length;e++)if(!Lu(t,this.planes[e]))return 0;for(const e of i)for(const i of this.frustumEdges){const r=bu.cross([],e,i),n=bu.length(r);if(0===n)continue;bu.scale(r,r,1/n);const o=Du(this.points,this.points[0],r),s=Du(t,this.points[0],r);if(o[0]>s[1]||s[0]>o[1])return 0}return 1}}class Bu{static fromPoints(t){const e=[1/0,1/0,1/0],i=[-1/0,-1/0,-1/0];for(const r of t)bu.min(e,e,r),bu.max(i,i,r);return new Bu(e,i)}static applyTransform(t,e){const i=t.getCorners();for(let t=0;t<i.length;++t)bu.transformMat4(i[t],i[t],e);return Bu.fromPoints(i)}static projectAabbCorners(t,e){const i=t.getCorners();for(let t=0;t<i.length;++t)bu.transformMat4(i[t],i[t],e);return i}constructor(t,e){this.min=t,this.max=e,this.center=bu.scale([],bu.add([],this.min,this.max),.5);}quadrant(t){const e=[t%2==0,t<2],i=bu.clone(this.min),r=bu.clone(this.max);for(let t=0;t<e.length;t++)i[t]=e[t]?this.min[t]:this.center[t],r[t]=e[t]?this.center[t]:this.max[t];return r[2]=this.max[2],new Bu(i,r)}distanceX(t){return Math.max(Math.min(this.max[0],t[0]),this.min[0])-t[0]}distanceY(t){return Math.max(Math.min(this.max[1],t[1]),this.min[1])-t[1]}distanceZ(t){return Math.max(Math.min(this.max[2],t[2]),this.min[2])-t[2]}getCorners(){const t=this.min,e=this.max;return [[t[0],t[1],t[2]],[e[0],t[1],t[2]],[e[0],e[1],t[2]],[t[0],e[1],t[2]],[t[0],t[1],e[2]],[e[0],t[1],e[2]],[e[0],e[1],e[2]],[t[0],e[1],e[2]]]}intersects(t){return this.intersectsAabb(t.bounds)?Pu(t,this.getCorners()):0}intersectsFlat(t){return this.intersectsAabb(t.bounds)?Pu(t,[[this.min[0],this.min[1],0],[this.max[0],this.min[1],0],[this.max[0],this.max[1],0],[this.min[0],this.max[1],0]]):0}intersectsPrecise(t,e){return e||this.intersects(t)?Ru(t,this.getCorners()):0}intersectsPreciseFlat(t,e){return e||this.intersectsFlat(t)?Ru(t,[[this.min[0],this.min[1],0],[this.max[0],this.min[1],0],[this.max[0],this.max[1],0],[this.min[0],this.max[1],0]]):0}intersectsAabb(t){for(let e=0;e<3;++e)if(this.min[e]>t.max[e]||t.min[e]>this.max[e])return !1;return !0}intersectsAabbXY(t){return !(this.min[0]>t.max[0]||t.min[0]>this.max[0]||this.min[1]>t.max[1]||t.min[1]>this.max[1])}encapsulate(t){for(let e=0;e<3;e++)this.min[e]=Math.min(this.min[e],t.min[e]),this.max[e]=Math.max(this.max[e],t.max[e]);}encapsulatePoint(t){for(let e=0;e<3;e++)this.min[e]=Math.min(this.min[e],t[e]),this.max[e]=Math.max(this.max[e],t[e]);}}Ss(Bu,"Aabb");const Ou=5,Fu=6,Nu=sr/Math.PI/2,Uu=16383,Vu=64,ju=[Vu,32,16],Gu=-Nu,qu=Nu,Zu=[new Bu([Gu,Gu,Gu],[qu,qu,qu]),new Bu([Gu,Gu,Gu],[0,0,qu]),new Bu([0,Gu,Gu],[qu,0,qu]),new Bu([Gu,0,Gu],[0,qu,qu]),new Bu([0,0,Gu],[qu,qu,qu])];function $u(t){return t*Nu/Md}function Hu(t,e,i,r=!0){const n=bu.scale([],t._camera.position,t.worldSize),o=[e,i,1,1];au.transformMat4(o,o,t.pixelMatrixInverse),au.scale(o,o,1/o[3]);const s=bu.sub([],o,n),a=bu.normalize([],s),l=t.globeMatrix,c=[l[12],l[13],l[14]],h=bu.sub([],c,n),u=bu.length(h),d=bu.normalize([],h),p=t.worldSize/(2*Math.PI),f=bu.dot(d,a),m=Math.asin(p/u);if(m<Math.acos(f)){if(!r)return null;const t=[],e=[];bu.scale(t,a,u/f),bu.normalize(e,bu.sub(e,t,h)),bu.normalize(a,bu.add(a,h,bu.scale(a,e,Math.tan(m)*u)));}const _=[];new Cu(n,a).closestPointOnSphere(c,p,_);const g=bu.normalize([],ot(l,0)),y=bu.normalize([],ot(l,1)),x=bu.normalize([],ot(l,2)),v=bu.dot(g,_),b=bu.dot(y,_),w=bu.dot(x,_),E=T(Math.asin(-b/p));let M=T(Math.atan2(v,w));M=t.center.lng+function(t,e){const i=(e-t+180)%360-180;return i<-180?i+360:i}(t.center.lng,M);const A=Nd(M),S=z(Ud(E),0,1);return new Yd(A,S)}class Wu{constructor(t,e,i){this.a=bu.sub([],t,i),this.b=bu.sub([],e,i),this.center=i;const r=bu.normalize([],this.a),n=bu.normalize([],this.b);this.angle=Math.acos(bu.dot(r,n));}}function Xu(t,e){if(0===t.angle)return null;let i;return i=0===t.a[e]?1/t.angle*.5*Math.PI:1/t.angle*Math.atan(t.b[e]/t.a[e]/Math.sin(t.angle)-1/Math.tan(t.angle)),i<0||i>1?null:function(t,e,i,r){const n=Math.sin(i);return t*(Math.sin((1-r)*i)/n)+e*(Math.sin(r*i)/n)}(t.a[e],t.b[e],t.angle,z(i,0,1))+t.center[e]}function Yu(t){if(t.z<=1)return Zu[t.z+2*t.y+t.x];const e=id(ed(t));return Bu.fromPoints(e)}function Ku(t,e,i){return bu.scale(t,t,1-i),bu.scaleAndAdd(t,t,e,i)}function Ju(t,e){const i=pd(e.zoom);if(0===i)return Yu(t);const r=ed(t),n=id(r),o=Nd(r.getWest())*e.worldSize,s=Nd(r.getEast())*e.worldSize,a=Ud(r.getNorth())*e.worldSize,l=Ud(r.getSouth())*e.worldSize,c=[o,a,0],h=[s,a,0],u=[o,l,0],d=[s,l,0],p=mu.invert([],e.globeMatrix);return bu.transformMat4(c,c,p),bu.transformMat4(h,h,p),bu.transformMat4(u,u,p),bu.transformMat4(d,d,p),n[0]=Ku(n[0],u,i),n[1]=Ku(n[1],d,i),n[2]=Ku(n[2],h,i),n[3]=Ku(n[3],c,i),Bu.fromPoints(n)}function Qu(t,e,i){for(const r of t)bu.transformMat4(r,r,e),bu.scale(r,r,i);}function td(t,e,i,r){const n=e/t.worldSize,o=t.globeMatrix;if(i.z<=1){const t=Yu(i).getCorners();return Qu(t,o,n),Bu.fromPoints(t)}const s=ed(i,r),a=id(s);Qu(a,o,n);const l=Number.MAX_VALUE,c=[-l,-l,-l],h=[l,l,l];if(s.contains(t.center)){for(const t of a)bu.min(h,h,t),bu.max(c,c,t);c[2]=0;const e=t.point,i=[e.x*n,e.y*n,0];return bu.min(h,h,i),bu.max(c,c,i),new Bu(h,c)}const u=[o[12]*n,o[13]*n,o[14]*n],d=s.getCenter(),p=z(t.center.lat,-Zd,Zd),f=z(d.lat,-Zd,Zd),m=Nd(t.center.lng),_=Ud(p);let g=m-Nd(d.lng);const y=_-Ud(f);g>.5?g-=1:g<-.5&&(g+=1);let x=0;if(Math.abs(g)>Math.abs(y))x=g>=0?1:3;else {x=y>=0?0:2;const t=[o[4]*n,o[5]*n,o[6]*n],e=-Math.sin(w(y>=0?s.getSouth():s.getNorth()))*Nu;bu.scaleAndAdd(u,u,t,e);}const v=a[x],b=a[(x+1)%4],T=new Wu(v,b,u),E=[Xu(T,0)||v[0],Xu(T,1)||v[1],Xu(T,2)||v[2]],M=pd(t.zoom);if(M>0){const r=function({x:t,y:e,z:i},r,n,o,s){const a=1/(1<<i);let l=t*a,c=l+a,h=e*a,u=h+a,d=0;const p=(l+c)/2-o;return p>.5?d=-1:p<-.5&&(d=1),l=((l+d)*r-(o*=r))*n+o,c=((c+d)*r-o)*n+o,h=(h*r-(s*=r))*n+s,u=(u*r-s)*n+s,[[l,u,0],[c,u,0],[c,h,0],[l,h,0]]}(i,e,t._pixelsPerMercatorPixel,m,_);for(let t=0;t<a.length;t++)Ku(a[t],r[t],M);const n=bu.add([],r[x],r[(x+1)%4]);bu.scale(n,n,.5),Ku(E,n,M);}for(const t of a)bu.min(h,h,t),bu.max(c,c,t);return h[2]=Math.min(v[2],b[2]),bu.min(h,h,E),bu.max(c,c,E),new Bu(h,c)}function ed({x:t,y:e,z:i},r=!1){const n=1/(1<<i),o=new Id(jd(t*n),e===(1<<i)-1&&r?-90:Gd((e+1)*n)),s=new Id(jd((t+1)*n),0===e&&r?90:Gd(e*n));return new Xl(o,s)}function id(t){const e=w(t.getNorth()),i=w(t.getSouth()),r=Math.cos(e),n=Math.cos(i),o=Math.sin(e),s=Math.sin(i),a=t.getWest(),l=t.getEast();return [rd(n,s,a),rd(n,s,l),rd(r,o,l),rd(r,o,a)]}function rd(t,e,i,r=Nu){return i=w(i),[t*Math.sin(i)*r,-e*r,t*Math.cos(i)*r]}function nd(t,e,i){return rd(Math.cos(w(t)),Math.sin(w(t)),e,i)}function od(t,e,i,r){const n=1<<i.z,o=(t/sr+i.x)/n;return nd(Gd((e/sr+i.y)/n),jd(o),r)}function sd({min:t,max:e}){return Uu/Math.max(e[0]-t[0],e[1]-t[1],e[2]-t[2])}const ad=new Float64Array(16);function ld(t){const e=sd(t),i=mu.fromScaling(ad,[e,e,e]);return mu.translate(i,i,bu.negate([],t.min))}function cd(t){const e=mu.fromTranslation(ad,t.min),i=1/sd(t);return mu.scale(e,e,[i,i,i])}function hd(t){const e=sr/(2*Math.PI);return t/(2*Math.PI)/e}function ud(t,e){return sr/(512*Math.pow(2,t))*sd(Yu(e))}function dd(t,e,i,r,n){const o=hd(i),s=[t,e,-i/(2*Math.PI)],a=mu.identity(new Float64Array(16));return mu.translate(a,a,s),mu.scale(a,a,[o,o,o]),mu.rotateX(a,a,w(-n)),mu.rotateY(a,a,w(-r)),a}function pd(t){return D(Ou,Fu,t)}function fd(t,e,i){const r=mu.identity(new Float64Array(16)),n=(e/(1<<t)-.5)*Math.PI*2;return mu.rotateY(r,i.globeMatrix,n),Float32Array.from(r)}function md(t,e,i){const r=pd(i.zoom),n=t.style.map._antialias,o=e.extStandardDerivativesForceOff||t.terrain&&t.terrain.exaggeration()>0;return 0===r&&!n&&!o}function _d(t,e,i,r){const n=e.getNorth(),o=e.getSouth(),s=e.getWest(),a=e.getEast(),l=1<<t.z,c=a-s,h=n-o,u=c/Vu,d=-h/ju[i],p=[0,u,0,d,0,0,n,s,0];if(t.z>0){const t=180/r;pu.multiply(p,p,[t/c+1,0,0,0,t/h+1,0,-.5*t/u,.5*t/d,1]);}return p[2]=l,p[5]=t.x,p[8]=t.y,p}function gd(t){const e=Zd-5;t=z(t,-e,e)/e*90;const i=Math.pow(Math.abs(Math.sin(w(t))),3);return Math.round(i*(ju.length-1))}function yd(t){const e=[0,0,0],i=mu.identity(new Float64Array(16));return mu.multiply(i,t.pixelMatrix,t.globeMatrix),bu.transformMat4(e,e,i),new y(e[0],e[1])}function xd(t,e){const i=nd(e.lat,e.lng),r=function(t){const e=nd(t._center.lat,t._center.lng),i=bu.fromValues(0,1,0);let r=bu.cross([],i,e);const n=mu.fromRotation([],-t.angle,e);r=bu.transformMat4(r,r,n),mu.fromRotation(n,-t._pitch,r);const o=bu.normalize([],e);return bu.scale(o,o,$u(t.cameraToCenterDistance/t.pixelsPerMeter)),bu.transformMat4(o,o,n),bu.add([],e,o)}(t),n=bu.subtract([],r,i);return bu.angle(n,i)}function vd(t,e){return xd(t,e)>Math.PI/2*1.01}const bd=w(85),wd=Math.cos(bd),Td=Math.sin(bd);class Ed{constructor(t){this._createGrid(t),this._createPoles(t);}destroy(){this._poleIndexBuffer.destroy(),this._gridBuffer.destroy(),this._gridIndexBuffer.destroy(),this._poleNorthVertexBuffer.destroy(),this._poleSouthVertexBuffer.destroy();for(const t of this._poleSegments)t.destroy();for(const t of this._gridSegments)t.withSkirts.destroy(),t.withoutSkirts.destroy();}_fillGridMeshWithLods(t,e){const i=new ya,r=new Ba,n=[],o=t+1+2,s=e[0]+1,a=e[0]+1+(1+e.length),l=(t,e,i)=>{let r=t===o-1?t-2:0===t?t:t-1;return r+=i?24575:0,[r,e]};for(let t=0;t<o;++t)i.emplaceBack(...l(t,0,!0));for(let t=0;t<s;++t)for(let e=0;e<o;++e)i.emplaceBack(...l(e,t,(0===e||e===o-1)&&!0));for(let t=0;t<e.length;++t){const r=e[t];for(let t=0;t<o;++t)i.emplaceBack(...l(t,r,!0));}for(let t=0;t<e.length;++t){const s=r.length,l=e[t]+1+2,c=new Ba;for(let i=0;i<l-1;i++){const n=i===l-2,s=n?o*(a-e.length+t-i):o;for(let t=0;t<o-1;t++){const e=i*o+t;0===i||n||0===t||t===o-2?(c.emplaceBack(e+1,e,e+s),c.emplaceBack(e+s,e+s+1,e+1)):(r.emplaceBack(e+1,e,e+s),r.emplaceBack(e+s,e+s+1,e+1));}}const h=Wl.simpleSegment(0,s,i.length,r.length-s);for(let t=0;t<c.uint16.length;t+=3)r.emplaceBack(c.uint16[t],c.uint16[t+1],c.uint16[t+2]);const u=Wl.simpleSegment(0,s,i.length,r.length-s);n.push({withoutSkirts:h,withSkirts:u});}return {vertices:i,indices:r,segments:n}}_createGrid(t){const e=this._fillGridMeshWithLods(Vu,ju);this._gridSegments=e.segments,this._gridBuffer=t.createVertexBuffer(e.vertices,Iu.members),this._gridIndexBuffer=t.createIndexBuffer(e.indices,!0);}_createPoles(t){const e=new Ba;for(let t=0;t<=Vu;t++)e.emplaceBack(0,t+1,t+2);this._poleIndexBuffer=t.createIndexBuffer(e,!0);const i=new Ua,r=new Ua;this._poleSegments=[];for(let t=0,e=0;t<Ou;t++){const n=360/(1<<t);i.emplaceBack(0,-Nu,0,.5,0),r.emplaceBack(0,-Nu,0,.5,1);for(let t=0;t<=Vu;t++){const e=t/Vu,o=Wr(0,n,e),[s,a,l]=rd(wd,Td,o,Nu);i.emplaceBack(s,a,l,e,0),r.emplaceBack(s,a,l,e,1);}this._poleSegments.push(Wl.simpleSegment(e,0,66,64)),e+=66;}this._poleNorthVertexBuffer=t.createVertexBuffer(i,Au,!1),this._poleSouthVertexBuffer=t.createVertexBuffer(r,Au,!1);}getGridBuffers(t,e){return [this._gridBuffer,this._gridIndexBuffer,e?this._gridSegments[t].withSkirts:this._gridSegments[t].withoutSkirts]}getPoleBuffers(t){return [this._poleNorthVertexBuffer,this._poleSouthVertexBuffer,this._poleIndexBuffer,this._poleSegments[t]]}}const Md=6371008.8,Ad=2*Math.PI*Md;class Sd{constructor(t,e){if(isNaN(t)||isNaN(e))throw new Error(`Invalid LngLat object: (${t}, ${e})`);if(this.lng=+t,this.lat=+e,this.lat>90||this.lat<-90)throw new Error("Invalid LngLat latitude value: must be between -90 and 90")}wrap(){return new Sd(P(this.lng,-180,180),this.lat)}toArray(){return [this.lng,this.lat]}toString(){return `LngLat(${this.lng}, ${this.lat})`}distanceTo(t){const e=Math.PI/180,i=this.lat*e,r=t.lat*e,n=Math.sin(i)*Math.sin(r)+Math.cos(i)*Math.cos(r)*Math.cos((t.lng-this.lng)*e);return Md*Math.acos(Math.min(n,1))}toBounds(t=0){const e=360*t/40075017,i=e/Math.cos(Math.PI/180*this.lat);return new Xl(new Sd(this.lng-i,this.lat-e),new Sd(this.lng+i,this.lat+e))}toEcef(t){const e=$u(t);return nd(this.lat,this.lng,Nu+e)}static convert(t){if(t instanceof Sd)return t;if(Array.isArray(t)&&(2===t.length||3===t.length))return new Sd(Number(t[0]),Number(t[1]));if(!Array.isArray(t)&&"object"==typeof t&&null!==t)return new Sd(Number("lng"in t?t.lng:t.lon),Number(t.lat));throw new Error("`LngLatLike` argument must be specified as a LngLat instance, an object {lng: <lng>, lat: <lat>}, an object {lon: <lng>, lat: <lat>}, or an array of [<lng>, <lat>]")}}var Id=Sd,Cd={};!function(t,e){!function(t){function e(t,e,r){var n=i(256*t,256*(e=Math.pow(2,r)-e-1),r),o=i(256*(t+1),256*(e+1),r);return n[0]+","+n[1]+","+o[0]+","+o[1]}function i(t,e,i){var r=2*Math.PI*6378137/256/Math.pow(2,i);return [t*r-2*Math.PI*6378137/2,e*r-2*Math.PI*6378137/2]}t.getURL=function(t,i,r,n,o,s){return s=s||{},t+"?"+["bbox="+e(r,n,o),"format="+(s.format||"image/png"),"service="+(s.service||"WMS"),"version="+(s.version||"1.1.1"),"request="+(s.request||"GetMap"),"srs="+(s.srs||"EPSG:3857"),"width="+(s.width||256),"height="+(s.height||256),"layers="+i].join("&")},t.getTileBBox=e,t.getMercCoords=i,Object.defineProperty(t,"__esModule",{value:!0});}(e);}(0,Cd);var zd=Cd;class Dd{constructor(t,e,i){this.z=t,this.x=e,this.y=i,this.key=Ld(0,t,t,e,i);}equals(t){return this.z===t.z&&this.x===t.x&&this.y===t.y}url(t,e){const i=zd.getTileBBox(this.x,this.y,this.z),r=function(t,e,i){let r,n="";for(let o=t;o>0;o--)r=1<<o-1,n+=(e&r?1:0)+(i&r?2:0);return n}(this.z,this.x,this.y);return t[(this.x+this.y)%t.length].replace("{prefix}",(this.x%16).toString(16)+(this.y%16).toString(16)).replace(/{z}/g,String(this.z)).replace(/{x}/g,String(this.x)).replace(/{y}/g,String("tms"===e?Math.pow(2,this.z)-this.y-1:this.y)).replace("{quadkey}",r).replace("{bbox-epsg-3857}",i)}toString(){return `${this.z}/${this.x}/${this.y}`}}class Pd{constructor(t,e){this.wrap=t,this.canonical=e,this.key=Ld(t,e.z,e.z,e.x,e.y);}}class Rd{constructor(t,e,i,r,n){this.overscaledZ=t,this.wrap=e,this.canonical=new Dd(i,+r,+n),this.key=0===e&&t===i?this.canonical.key:Ld(e,t,i,r,n);}equals(t){return this.overscaledZ===t.overscaledZ&&this.wrap===t.wrap&&this.canonical.equals(t.canonical)}scaledTo(t){const e=this.canonical.z-t;return t>this.canonical.z?new Rd(t,this.wrap,this.canonical.z,this.canonical.x,this.canonical.y):new Rd(t,this.wrap,t,this.canonical.x>>e,this.canonical.y>>e)}calculateScaledKey(t,e=!0){if(this.overscaledZ===t&&e)return this.key;if(t>this.canonical.z)return Ld(this.wrap*+e,t,this.canonical.z,this.canonical.x,this.canonical.y);{const i=this.canonical.z-t;return Ld(this.wrap*+e,t,t,this.canonical.x>>i,this.canonical.y>>i)}}isChildOf(t){if(t.wrap!==this.wrap)return !1;const e=this.canonical.z-t.canonical.z;return 0===t.overscaledZ||t.overscaledZ<this.overscaledZ&&t.canonical.z<this.canonical.z&&t.canonical.x===this.canonical.x>>e&&t.canonical.y===this.canonical.y>>e}children(t){if(this.overscaledZ>=t)return [new Rd(this.overscaledZ+1,this.wrap,this.canonical.z,this.canonical.x,this.canonical.y)];const e=this.canonical.z+1,i=2*this.canonical.x,r=2*this.canonical.y;return [new Rd(e,this.wrap,e,i,r),new Rd(e,this.wrap,e,i+1,r),new Rd(e,this.wrap,e,i,r+1),new Rd(e,this.wrap,e,i+1,r+1)]}isLessThan(t){return this.wrap<t.wrap||!(this.wrap>t.wrap)&&(this.overscaledZ<t.overscaledZ||!(this.overscaledZ>t.overscaledZ)&&(this.canonical.x<t.canonical.x||!(this.canonical.x>t.canonical.x)&&this.canonical.y<t.canonical.y))}wrapped(){return new Rd(this.overscaledZ,0,this.canonical.z,this.canonical.x,this.canonical.y)}unwrapTo(t){return new Rd(this.overscaledZ,t,this.canonical.z,this.canonical.x,this.canonical.y)}overscaleFactor(){return Math.pow(2,this.overscaledZ-this.canonical.z)}toUnwrapped(){return new Pd(this.wrap,this.canonical)}toString(){return `${this.overscaledZ}/${this.canonical.x}/${this.canonical.y}`}}function Ld(t,e,i,r,n){const o=1<<Math.min(i,22);let s=o*(n%o)+r%o;return t&&i<22&&(s+=o*o*((t<0?-2*t-1:2*t)%(1<<2*(22-i)))),16*(32*s+i)+(e-i)}const kd=[t=>{let e=t.canonical.x-1,i=t.wrap;return e<0&&(e=(1<<t.canonical.z)-1,i--),new Rd(t.overscaledZ,i,t.canonical.z,e,t.canonical.y)},t=>{let e=t.canonical.x+1,i=t.wrap;return e===1<<t.canonical.z&&(e=0,i++),new Rd(t.overscaledZ,i,t.canonical.z,e,t.canonical.y)},t=>new Rd(t.overscaledZ,t.wrap,t.canonical.z,t.canonical.x,(0===t.canonical.y?1<<t.canonical.z:t.canonical.y)-1),t=>new Rd(t.overscaledZ,t.wrap,t.canonical.z,t.canonical.x,t.canonical.y===(1<<t.canonical.z)-1?0:t.canonical.y+1)];Ss(Dd,"CanonicalTileID"),Ss(Rd,"OverscaledTileID",{omit:["projMatrix"]});const Bd=0,Od=25.5;function Fd(t){return Ad*Math.cos(t*Math.PI/180)}function Nd(t){return (180+t)/360}function Ud(t){return (180-180/Math.PI*Math.log(Math.tan(Math.PI/4+t*Math.PI/360)))/360}function Vd(t,e){return t/Fd(e)}function jd(t){return 360*t-180}function Gd(t){return 360/Math.PI*Math.atan(Math.exp((180-360*t)*Math.PI/180))-90}function qd(t,e){return t*Fd(Gd(e))}const Zd=85.051129;function $d(t){return Math.cos(w(z(t,-Zd,Zd)))}function Hd(t,e){const i=z(e,Bd,Od),r=Math.pow(2,i);return $d(t)*Ad/(512*r)}function Wd(t){return 1/Math.cos(t*Math.PI/180)}function Xd(t,e=0){const i=Math.exp(Math.PI*(1-(t.y+e/sr)/(1<<t.z)*2));return 80150034*i/(i*i+1)/sr/(1<<t.z)}class Yd{constructor(t,e,i=0){this.x=+t,this.y=+e,this.z=+i;}static fromLngLat(t,e=0){const i=Id.convert(t);return new Yd(Nd(i.lng),Ud(i.lat),Vd(e,i.lat))}toLngLat(){return new Id(jd(this.x),Gd(this.y))}toAltitude(){return qd(this.z,this.y)}meterInMercatorCoordinateUnits(){return 1/Ad*Wd(Gd(this.y))}}function Kd(t,e,i,r,n,o,s,a,l){const c=(e+r)/2,h=(i+n)/2,u=new y(c,h);a(u),function(t,e,i,r,n,o){const s=i-n,a=r-o;return Math.abs((r-e)*s-(i-t)*a)/Math.hypot(s,a)}(u.x,u.y,o.x,o.y,s.x,s.y)>=l?(Kd(t,e,i,c,h,o,u,a,l),Kd(t,c,h,r,n,u,s,a,l)):t.push(s);}function Jd(t,e,i){let r=t[0],n=r.x,o=r.y;e(r);const s=[r];for(let a=1;a<t.length;a++){const l=t[a],{x:c,y:h}=l;e(l),Kd(s,n,o,c,h,r,l,e,i),n=c,o=h,r=l;}return s}function Qd(t,e,i,r){if(r(e,i)){const n=e.add(i)._mult(.5);Qd(t,e,n,r),Qd(t,n,i,r);}else t.push(i);}function tp(t,e){let i=t[0];const r=[i];for(let n=1;n<t.length;n++){const o=t[n];Qd(r,i,o,e),i=o;}return r}const ep=Math.pow(2,14)-1,ip=-ep-1;function rp(t,e){const i=Math.round(t.x*e),r=Math.round(t.y*e);return t.x=z(i,ip,ep),t.y=z(r,ip,ep),(i<t.x||i>t.x+1||r<t.y||r>t.y+1)&&W("Geometry exceeds allowed extent, reduce your vector tile buffer size"),t}function np(t,e,i){const r=t.loadGeometry(),n=t.extent,o=sr/n;if(e&&i&&i.projection.isReprojectedInTileSpace){const o=1<<e.z,{scale:s,x:a,y:l,projection:c}=i,h=t=>{const i=jd((e.x+t.x/n)/o),r=Gd((e.y+t.y/n)/o),h=c.project(i,r);t.x=(h.x*s-a)*n,t.y=(h.y*s-l)*n;};for(let e=0;e<r.length;e++)if(1!==t.type)r[e]=Jd(r[e],h,1);else {const t=[];for(const i of r[e])i.x<0||i.x>=n||i.y<0||i.y>=n||(h(i),t.push(i));r[e]=t;}}for(const t of r)for(const e of t)rp(e,o);return r}function op(t,e){return {type:t.type,id:t.id,properties:t.properties,geometry:e?np(t):[]}}function sp(t,e,i,r,n){t.emplaceBack(2*e+(r+1)/2,2*i+(n+1)/2);}function ap(t,e,i){const r=16384;t.emplaceBack(e.x,e.y,e.z,i[0]*r,i[1]*r,i[2]*r);}class lp{constructor(t){this.zoom=t.zoom,this.overscaling=t.overscaling,this.layers=t.layers,this.layerIds=this.layers.map((t=>t.id)),this.index=t.index,this.hasPattern=!1,this.projection=t.projection,this.layoutVertexArray=new ya,this.indexArray=new Ba,this.segments=new Wl,this.programConfigurations=new Fl(t.layers,t.zoom),this.stateDependentLayerIds=this.layers.filter((t=>t.isStateDependent())).map((t=>t.id));}populate(t,e,i,r){const n=this.layers[0],o=[];let s=null;"circle"===n.type&&(s=n.layout.get("circle-sort-key"));for(const{feature:e,id:n,index:a,sourceLayerIndex:l}of t){const t=this.layers[0]._featureFilter.needGeometry,c=op(e,t);if(!this.layers[0]._featureFilter.filter(new Qs(this.zoom),c,i))continue;const h=s?s.evaluate(c,{},i):void 0,u={id:n,properties:e.properties,type:e.type,sourceLayerIndex:l,index:a,geometry:t?c.geometry:np(e,i,r),patterns:{},sortKey:h};o.push(u);}s&&o.sort(((t,e)=>t.sortKey-e.sortKey));let a=null;"globe"===r.projection.name&&(this.globeExtVertexArray=new Aa,a=r.projection);for(const r of o){const{geometry:n,index:o,sourceLayerIndex:s}=r,l=t[o].feature;this.addFeature(r,n,o,e.availableImages,i,a,e.brightness),e.featureIndex.insert(l,n,o,s,this.index);}}update(t,e,i,r,n){const o=0!==Object.keys(t).length;o&&!this.stateDependentLayers.length||this.programConfigurations.updatePaintArrays(t,e,o?this.stateDependentLayers:this.layers,i,r,n);}isEmpty(){return 0===this.layoutVertexArray.length}uploadPending(){return !this.uploaded||this.programConfigurations.needsUpload}upload(t){this.uploaded||(this.layoutVertexBuffer=t.createVertexBuffer(this.layoutVertexArray,$l.members),this.indexBuffer=t.createIndexBuffer(this.indexArray),this.globeExtVertexArray&&(this.globeExtVertexBuffer=t.createVertexBuffer(this.globeExtVertexArray,Hl.members))),this.programConfigurations.upload(t),this.uploaded=!0;}destroy(){this.layoutVertexBuffer&&(this.layoutVertexBuffer.destroy(),this.indexBuffer.destroy(),this.programConfigurations.destroy(),this.segments.destroy(),this.globeExtVertexBuffer&&this.globeExtVertexBuffer.destroy());}addFeature(t,e,i,r,n,o,s){for(const i of e)for(const e of i){const i=e.x,r=e.y;if(i<0||i>=sr||r<0||r>=sr)continue;if(o){const t=o.projectTilePoint(i,r,n),e=o.upVector(n,i,r),s=this.globeExtVertexArray;ap(s,t,e),ap(s,t,e),ap(s,t,e),ap(s,t,e);}const s=this.segments.prepareSegment(4,this.layoutVertexArray,this.indexArray,t.sortKey),a=s.vertexLength;sp(this.layoutVertexArray,i,r,-1,-1),sp(this.layoutVertexArray,i,r,1,-1),sp(this.layoutVertexArray,i,r,1,1),sp(this.layoutVertexArray,i,r,-1,1),this.indexArray.emplaceBack(a,a+1,a+2),this.indexArray.emplaceBack(a,a+2,a+3),s.vertexLength+=4,s.primitiveLength+=2;}this.programConfigurations.populatePaintArrays(this.layoutVertexArray.length,t,i,{},r,n,s);}}function cp(t,e){for(let i=0;i<t.length;i++)if(yp(e,t[i]))return !0;for(let i=0;i<e.length;i++)if(yp(t,e[i]))return !0;return !!pp(t,e)}function hp(t,e,i){return !!yp(t,e)||!!mp(e,t,i)}function up(t,e){if(1===t.length)return gp(e,t[0]);for(let i=0;i<e.length;i++){const r=e[i];for(let e=0;e<r.length;e++)if(yp(t,r[e]))return !0}for(let i=0;i<t.length;i++)if(gp(e,t[i]))return !0;for(let i=0;i<e.length;i++)if(pp(t,e[i]))return !0;return !1}function dp(t,e,i){if(t.length>1){if(pp(t,e))return !0;for(let r=0;r<e.length;r++)if(mp(e[r],t,i))return !0}for(let r=0;r<t.length;r++)if(mp(t[r],e,i))return !0;return !1}function pp(t,e){if(0===t.length||0===e.length)return !1;for(let i=0;i<t.length-1;i++){const r=t[i],n=t[i+1];for(let t=0;t<e.length-1;t++)if(fp(r,n,e[t],e[t+1]))return !0}return !1}function fp(t,e,i,r){return X(t,i,r)!==X(e,i,r)&&X(t,e,i)!==X(t,e,r)}function mp(t,e,i){const r=i*i;if(1===e.length)return t.distSqr(e[0])<r;for(let i=1;i<e.length;i++)if(_p(t,e[i-1],e[i])<r)return !0;return !1}function _p(t,e,i){const r=e.distSqr(i);if(0===r)return t.distSqr(e);const n=((t.x-e.x)*(i.x-e.x)+(t.y-e.y)*(i.y-e.y))/r;return t.distSqr(n<0?e:n>1?i:i.sub(e)._mult(n)._add(e))}function gp(t,e){let i,r,n,o=!1;for(let s=0;s<t.length;s++){i=t[s];for(let t=0,s=i.length-1;t<i.length;s=t++)r=i[t],n=i[s],r.y>e.y!=n.y>e.y&&e.x<(n.x-r.x)*(e.y-r.y)/(n.y-r.y)+r.x&&(o=!o);}return o}function yp(t,e){let i=!1;for(let r=0,n=t.length-1;r<t.length;n=r++){const o=t[r],s=t[n];o.y>e.y!=s.y>e.y&&e.x<(s.x-o.x)*(e.y-o.y)/(s.y-o.y)+o.x&&(i=!i);}return i}function xp(t,e,i,r,n){for(const o of t)if(e<=o.x&&i<=o.y&&r>=o.x&&n>=o.y)return !0;const o=[new y(e,i),new y(e,n),new y(r,n),new y(r,i)];if(t.length>2)for(const e of o)if(yp(t,e))return !0;for(let e=0;e<t.length-1;e++)if(vp(t[e],t[e+1],o))return !0;return !1}function vp(t,e,i){const r=i[0],n=i[2];if(t.x<r.x&&e.x<r.x||t.x>n.x&&e.x>n.x||t.y<r.y&&e.y<r.y||t.y>n.y&&e.y>n.y)return !1;const o=X(t,e,i[0]);return o!==X(t,e,i[1])||o!==X(t,e,i[2])||o!==X(t,e,i[3])}function bp(t,e,i,r,n,o){let s=e.y-t.y,a=t.x-e.x;if(o=o||0){const t=s*s+a*a;if(0===t)return !0;const e=Math.sqrt(t);s/=e,a/=e;}return !((i.x-t.x)*s+(i.y-t.y)*a-o<0||(r.x-t.x)*s+(r.y-t.y)*a-o<0||(n.x-t.x)*s+(n.y-t.y)*a-o<0)}function wp(t,e,i,r,n,o,s){return !(bp(t,e,r,n,o,s)||bp(e,i,r,n,o,s)||bp(i,t,r,n,o,s)||bp(r,n,t,e,i,s)||bp(n,o,t,e,i,s)||bp(o,r,t,e,i,s))}function Tp(t,e,i){const r=e.paint.get(t).value;return "constant"===r.kind?r.value:i.programConfigurations.get(e.id).getMaxValue(t)}function Ep(t){return Math.sqrt(t[0]*t[0]+t[1]*t[1])}function Mp(t,e,i,r,n){if(!e[0]&&!e[1])return t;const o=y.convert(e)._mult(n);"viewport"===i&&o._rotate(-r);const s=[];for(let e=0;e<t.length;e++)s.push(t[e].sub(o));return s}function Ap(t,e,i,r){const n=y.convert(t)._mult(r);return "viewport"===e&&n._rotate(-i),n}Ss(lp,"CircleBucket",{omit:["layers"]});const Sp=new ua({"circle-sort-key":new ca(ze.layout_circle["circle-sort-key"]),visibility:new la(ze.layout_circle.visibility)});var Ip={paint:new ua({"circle-radius":new ca(ze.paint_circle["circle-radius"]),"circle-color":new ca(ze.paint_circle["circle-color"]),"circle-blur":new ca(ze.paint_circle["circle-blur"]),"circle-opacity":new ca(ze.paint_circle["circle-opacity"]),"circle-translate":new la(ze.paint_circle["circle-translate"]),"circle-translate-anchor":new la(ze.paint_circle["circle-translate-anchor"]),"circle-pitch-scale":new la(ze.paint_circle["circle-pitch-scale"]),"circle-pitch-alignment":new la(ze.paint_circle["circle-pitch-alignment"]),"circle-stroke-width":new ca(ze.paint_circle["circle-stroke-width"]),"circle-stroke-color":new ca(ze.paint_circle["circle-stroke-color"]),"circle-stroke-opacity":new ca(ze.paint_circle["circle-stroke-opacity"]),"circle-emissive-strength":new la(ze.paint_circle["circle-emissive-strength"])}),layout:Sp};function Cp(t,e,i,r,n,o,s,a,l){if(o&&t.queryGeometry.isAboveHorizon)return !1;o&&(l*=t.pixelToTileUnitsFactor);const c=t.tileID.canonical,h=i.projection.upVectorScale(c,i.center.lat,i.worldSize).metersToTile;for(const u of e)for(const e of u){const u=e.add(a),d=n&&i.elevation?i.elevation.exaggeration()*n.getElevationAt(u.x,u.y,!0):0,p=i.projection.projectTilePoint(u.x,u.y,c);if(d>0){const t=i.projection.upVector(c,u.x,u.y);p.x+=t[0]*h*d,p.y+=t[1]*h*d,p.z+=t[2]*h*d;}const f=o?u:zp(p.x,p.y,p.z,r),m=o?t.tilespaceRays.map((t=>Rp(t,d))):t.queryGeometry.screenGeometry,_=au.transformMat4([],[p.x,p.y,p.z,1],r);if(!s&&o?l*=_[3]/i.cameraToCenterDistance:s&&!o&&(l*=i.cameraToCenterDistance/_[3]),o){const t=Gd((e.y/sr+c.y)/(1<<c.z));l/=i.projection.pixelsPerMeter(t,1)/Vd(1,t);}if(hp(m,f,l))return !0}return !1}function zp(t,e,i,r){const n=au.transformMat4([],[t,e,i,1],r);return new y(n[0]/n[3],n[1]/n[3])}const Dp=bu.fromValues(0,0,0),Pp=bu.fromValues(0,0,1);function Rp(t,e){const i=bu.create();return Dp[2]=e,t.intersectsPlane(Dp,Pp,i),new y(i[0],i[1])}class Lp extends lp{}function kp(t,{width:e,height:i},r,n){if(n){if(n instanceof Uint8ClampedArray)n=new Uint8Array(n.buffer);else if(n.length!==e*i*r)throw new RangeError("mismatched image size")}else n=new Uint8Array(e*i*r);return t.width=e,t.height=i,t.data=n,t}function Bp(t,e,i){const{width:r,height:n}=e;r===t.width&&n===t.height||(Op(t,e,{x:0,y:0},{x:0,y:0},{width:Math.min(t.width,r),height:Math.min(t.height,n)},i),t.width=r,t.height=n,t.data=e.data);}function Op(t,e,i,r,n,o){if(0===n.width||0===n.height)return e;if(n.width>t.width||n.height>t.height||i.x>t.width-n.width||i.y>t.height-n.height)throw new RangeError("out of range source coordinates for image copy");if(n.width>e.width||n.height>e.height||r.x>e.width-n.width||r.y>e.height-n.height)throw new RangeError("out of range destination coordinates for image copy");const s=t.data,a=e.data;for(let l=0;l<n.height;l++){const c=((i.y+l)*t.width+i.x)*o,h=((r.y+l)*e.width+r.x)*o;for(let t=0;t<n.width*o;t++)a[h+t]=s[c+t];}return e}Ss(Lp,"HeatmapBucket",{omit:["layers"]});class Fp{constructor(t,e){kp(this,t,1,e);}resize(t){Bp(this,new Fp(t),1);}clone(){return new Fp({width:this.width,height:this.height},new Uint8Array(this.data))}static copy(t,e,i,r,n){Op(t,e,i,r,n,1);}}class Np{constructor(t,e){kp(this,t,4,e);}resize(t){Bp(this,new Np(t),4);}replace(t,e){e?this.data.set(t):this.data=t instanceof Uint8ClampedArray?new Uint8Array(t.buffer):t;}clone(){return new Np({width:this.width,height:this.height},new Uint8Array(this.data))}static copy(t,e,i,r,n){Op(t,e,i,r,n,4);}}class Up{constructor(t,e){this.width=t.width,this.height=t.height,this.data=e instanceof Uint8Array?new Float32Array(e.buffer):e;}}Ss(Fp,"AlphaImage"),Ss(Np,"RGBAImage");const Vp=new ua({visibility:new la(ze.layout_heatmap.visibility)});var jp={paint:new ua({"heatmap-radius":new ca(ze.paint_heatmap["heatmap-radius"]),"heatmap-weight":new ca(ze.paint_heatmap["heatmap-weight"]),"heatmap-intensity":new la(ze.paint_heatmap["heatmap-intensity"]),"heatmap-color":new ha(ze.paint_heatmap["heatmap-color"]),"heatmap-opacity":new la(ze.paint_heatmap["heatmap-opacity"])}),layout:Vp};function Gp(t){const e={},i=t.resolution||256,r=t.clips?t.clips.length:1,n=t.image||new Np({width:i,height:r}),o=(i,r,o)=>{e[t.evaluationKey]=o;const s=t.expression.evaluate(e);n.data[i+r+0]=Math.floor(255*s.r/s.a),n.data[i+r+1]=Math.floor(255*s.g/s.a),n.data[i+r+2]=Math.floor(255*s.b/s.a),n.data[i+r+3]=Math.floor(255*s.a);};if(t.clips)for(let e=0,n=0;e<r;++e,n+=4*i)for(let r=0,s=0;r<i;r++,s+=4){const a=r/(i-1),{start:l,end:c}=t.clips[e];o(n,s,l*(1-a)+c*a);}else for(let t=0,e=0;t<i;t++,e+=4)o(0,e,t/(i-1));return n}const qp=new ua({visibility:new la(ze.layout_hillshade.visibility)});var Zp={paint:new ua({"hillshade-illumination-direction":new la(ze.paint_hillshade["hillshade-illumination-direction"]),"hillshade-illumination-anchor":new la(ze.paint_hillshade["hillshade-illumination-anchor"]),"hillshade-exaggeration":new la(ze.paint_hillshade["hillshade-exaggeration"]),"hillshade-shadow-color":new la(ze.paint_hillshade["hillshade-shadow-color"]),"hillshade-highlight-color":new la(ze.paint_hillshade["hillshade-highlight-color"]),"hillshade-accent-color":new la(ze.paint_hillshade["hillshade-accent-color"])}),layout:qp};const $p=_a([{name:"a_pos",components:2,type:"Int16"}],4),{members:Hp}=$p;var Wp={exports:{}};function Xp(t,e,i){i=i||2;var r,n,o,s,a,l,c,h=e&&e.length,u=h?e[0]*i:t.length,d=Yp(t,0,u,i,!0),p=[];if(!d||d.next===d.prev)return p;if(h&&(d=function(t,e,i,r){var n,o,s,a=[];for(n=0,o=e.length;n<o;n++)(s=Yp(t,e[n]*r,n<o-1?e[n+1]*r:t.length,r,!1))===s.next&&(s.steiner=!0),a.push(lf(s));for(a.sort(nf),n=0;n<a.length;n++)i=of(a[n],i);return i}(t,e,d,i)),t.length>80*i){r=o=t[0],n=s=t[1];for(var f=i;f<u;f+=i)(a=t[f])<r&&(r=a),(l=t[f+1])<n&&(n=l),a>o&&(o=a),l>s&&(s=l);c=0!==(c=Math.max(o-r,s-n))?32767/c:0;}return Jp(d,p,i,r,n,c,0),p}function Yp(t,e,i,r,n){var o,s;if(n===bf(t,e,i,r)>0)for(o=e;o<i;o+=r)s=yf(o,t[o],t[o+1],s);else for(o=i-r;o>=e;o-=r)s=yf(o,t[o],t[o+1],s);return s&&df(s,s.next)&&(xf(s),s=s.next),s}function Kp(t,e){if(!t)return t;e||(e=t);var i,r=t;do{if(i=!1,r.steiner||!df(r,r.next)&&0!==uf(r.prev,r,r.next))r=r.next;else {if(xf(r),(r=e=r.prev)===r.next)break;i=!0;}}while(i||r!==e);return e}function Jp(t,e,i,r,n,o,s){if(t){!s&&o&&function(t,e,i,r){var n=t;do{0===n.z&&(n.z=af(n.x,n.y,e,i,r)),n.prevZ=n.prev,n.nextZ=n.next,n=n.next;}while(n!==t);n.prevZ.nextZ=null,n.prevZ=null,function(t){var e,i,r,n,o,s,a,l,c=1;do{for(i=t,t=null,o=null,s=0;i;){for(s++,r=i,a=0,e=0;e<c&&(a++,r=r.nextZ);e++);for(l=c;a>0||l>0&&r;)0!==a&&(0===l||!r||i.z<=r.z)?(n=i,i=i.nextZ,a--):(n=r,r=r.nextZ,l--),o?o.nextZ=n:t=n,n.prevZ=o,o=n;i=r;}o.nextZ=null,c*=2;}while(s>1)}(n);}(t,r,n,o);for(var a,l,c=t;t.prev!==t.next;)if(a=t.prev,l=t.next,o?tf(t,r,n,o):Qp(t))e.push(a.i/i|0),e.push(t.i/i|0),e.push(l.i/i|0),xf(t),t=l.next,c=l.next;else if((t=l)===c){s?1===s?Jp(t=ef(Kp(t),e,i),e,i,r,n,o,2):2===s&&rf(t,e,i,r,n,o):Jp(Kp(t),e,i,r,n,o,1);break}}}function Qp(t){var e=t.prev,i=t,r=t.next;if(uf(e,i,r)>=0)return !1;for(var n=e.x,o=i.x,s=r.x,a=e.y,l=i.y,c=r.y,h=n<o?n<s?n:s:o<s?o:s,u=a<l?a<c?a:c:l<c?l:c,d=n>o?n>s?n:s:o>s?o:s,p=a>l?a>c?a:c:l>c?l:c,f=r.next;f!==e;){if(f.x>=h&&f.x<=d&&f.y>=u&&f.y<=p&&cf(n,a,o,l,s,c,f.x,f.y)&&uf(f.prev,f,f.next)>=0)return !1;f=f.next;}return !0}function tf(t,e,i,r){var n=t.prev,o=t,s=t.next;if(uf(n,o,s)>=0)return !1;for(var a=n.x,l=o.x,c=s.x,h=n.y,u=o.y,d=s.y,p=a<l?a<c?a:c:l<c?l:c,f=h<u?h<d?h:d:u<d?u:d,m=a>l?a>c?a:c:l>c?l:c,_=h>u?h>d?h:d:u>d?u:d,g=af(p,f,e,i,r),y=af(m,_,e,i,r),x=t.prevZ,v=t.nextZ;x&&x.z>=g&&v&&v.z<=y;){if(x.x>=p&&x.x<=m&&x.y>=f&&x.y<=_&&x!==n&&x!==s&&cf(a,h,l,u,c,d,x.x,x.y)&&uf(x.prev,x,x.next)>=0)return !1;if(x=x.prevZ,v.x>=p&&v.x<=m&&v.y>=f&&v.y<=_&&v!==n&&v!==s&&cf(a,h,l,u,c,d,v.x,v.y)&&uf(v.prev,v,v.next)>=0)return !1;v=v.nextZ;}for(;x&&x.z>=g;){if(x.x>=p&&x.x<=m&&x.y>=f&&x.y<=_&&x!==n&&x!==s&&cf(a,h,l,u,c,d,x.x,x.y)&&uf(x.prev,x,x.next)>=0)return !1;x=x.prevZ;}for(;v&&v.z<=y;){if(v.x>=p&&v.x<=m&&v.y>=f&&v.y<=_&&v!==n&&v!==s&&cf(a,h,l,u,c,d,v.x,v.y)&&uf(v.prev,v,v.next)>=0)return !1;v=v.nextZ;}return !0}function ef(t,e,i){var r=t;do{var n=r.prev,o=r.next.next;!df(n,o)&&pf(n,r,r.next,o)&&_f(n,o)&&_f(o,n)&&(e.push(n.i/i|0),e.push(r.i/i|0),e.push(o.i/i|0),xf(r),xf(r.next),r=t=o),r=r.next;}while(r!==t);return Kp(r)}function rf(t,e,i,r,n,o){var s=t;do{for(var a=s.next.next;a!==s.prev;){if(s.i!==a.i&&hf(s,a)){var l=gf(s,a);return s=Kp(s,s.next),l=Kp(l,l.next),Jp(s,e,i,r,n,o,0),void Jp(l,e,i,r,n,o,0)}a=a.next;}s=s.next;}while(s!==t)}function nf(t,e){return t.x-e.x}function of(t,e){var i=function(t,e){var i,r=e,n=t.x,o=t.y,s=-1/0;do{if(o<=r.y&&o>=r.next.y&&r.next.y!==r.y){var a=r.x+(o-r.y)*(r.next.x-r.x)/(r.next.y-r.y);if(a<=n&&a>s&&(s=a,i=r.x<r.next.x?r:r.next,a===n))return i}r=r.next;}while(r!==e);if(!i)return null;var l,c=i,h=i.x,u=i.y,d=1/0;r=i;do{n>=r.x&&r.x>=h&&n!==r.x&&cf(o<u?n:s,o,h,u,o<u?s:n,o,r.x,r.y)&&(l=Math.abs(o-r.y)/(n-r.x),_f(r,t)&&(l<d||l===d&&(r.x>i.x||r.x===i.x&&sf(i,r)))&&(i=r,d=l)),r=r.next;}while(r!==c);return i}(t,e);if(!i)return e;var r=gf(i,t);return Kp(r,r.next),Kp(i,i.next)}function sf(t,e){return uf(t.prev,t,e.prev)<0&&uf(e.next,t,t.next)<0}function af(t,e,i,r,n){return (t=1431655765&((t=858993459&((t=252645135&((t=16711935&((t=(t-i)*n|0)|t<<8))|t<<4))|t<<2))|t<<1))|(e=1431655765&((e=858993459&((e=252645135&((e=16711935&((e=(e-r)*n|0)|e<<8))|e<<4))|e<<2))|e<<1))<<1}function lf(t){var e=t,i=t;do{(e.x<i.x||e.x===i.x&&e.y<i.y)&&(i=e),e=e.next;}while(e!==t);return i}function cf(t,e,i,r,n,o,s,a){return (n-s)*(e-a)>=(t-s)*(o-a)&&(t-s)*(r-a)>=(i-s)*(e-a)&&(i-s)*(o-a)>=(n-s)*(r-a)}function hf(t,e){return t.next.i!==e.i&&t.prev.i!==e.i&&!function(t,e){var i=t;do{if(i.i!==t.i&&i.next.i!==t.i&&i.i!==e.i&&i.next.i!==e.i&&pf(i,i.next,t,e))return !0;i=i.next;}while(i!==t);return !1}(t,e)&&(_f(t,e)&&_f(e,t)&&function(t,e){var i=t,r=!1,n=(t.x+e.x)/2,o=(t.y+e.y)/2;do{i.y>o!=i.next.y>o&&i.next.y!==i.y&&n<(i.next.x-i.x)*(o-i.y)/(i.next.y-i.y)+i.x&&(r=!r),i=i.next;}while(i!==t);return r}(t,e)&&(uf(t.prev,t,e.prev)||uf(t,e.prev,e))||df(t,e)&&uf(t.prev,t,t.next)>0&&uf(e.prev,e,e.next)>0)}function uf(t,e,i){return (e.y-t.y)*(i.x-e.x)-(e.x-t.x)*(i.y-e.y)}function df(t,e){return t.x===e.x&&t.y===e.y}function pf(t,e,i,r){var n=mf(uf(t,e,i)),o=mf(uf(t,e,r)),s=mf(uf(i,r,t)),a=mf(uf(i,r,e));return n!==o&&s!==a||!(0!==n||!ff(t,i,e))||!(0!==o||!ff(t,r,e))||!(0!==s||!ff(i,t,r))||!(0!==a||!ff(i,e,r))}function ff(t,e,i){return e.x<=Math.max(t.x,i.x)&&e.x>=Math.min(t.x,i.x)&&e.y<=Math.max(t.y,i.y)&&e.y>=Math.min(t.y,i.y)}function mf(t){return t>0?1:t<0?-1:0}function _f(t,e){return uf(t.prev,t,t.next)<0?uf(t,e,t.next)>=0&&uf(t,t.prev,e)>=0:uf(t,e,t.prev)<0||uf(t,t.next,e)<0}function gf(t,e){var i=new vf(t.i,t.x,t.y),r=new vf(e.i,e.x,e.y),n=t.next,o=e.prev;return t.next=e,e.prev=t,i.next=n,n.prev=i,r.next=i,i.prev=r,o.next=r,r.prev=o,r}function yf(t,e,i,r){var n=new vf(t,e,i);return r?(n.next=r.next,n.prev=r,r.next.prev=n,r.next=n):(n.prev=n,n.next=n),n}function xf(t){t.next.prev=t.prev,t.prev.next=t.next,t.prevZ&&(t.prevZ.nextZ=t.nextZ),t.nextZ&&(t.nextZ.prevZ=t.prevZ);}function vf(t,e,i){this.i=t,this.x=e,this.y=i,this.prev=null,this.next=null,this.z=0,this.prevZ=null,this.nextZ=null,this.steiner=!1;}function bf(t,e,i,r){for(var n=0,o=e,s=i-r;o<i;o+=r)n+=(t[s]-t[o])*(t[o+1]+t[s+1]),s=o;return n}Wp.exports=Xp,Wp.exports.default=Xp,Xp.deviation=function(t,e,i,r){var n=e&&e.length,o=Math.abs(bf(t,0,n?e[0]*i:t.length,i));if(n)for(var s=0,a=e.length;s<a;s++)o-=Math.abs(bf(t,e[s]*i,s<a-1?e[s+1]*i:t.length,i));var l=0;for(s=0;s<r.length;s+=3){var c=r[s]*i,h=r[s+1]*i,u=r[s+2]*i;l+=Math.abs((t[c]-t[u])*(t[h+1]-t[c+1])-(t[c]-t[h])*(t[u+1]-t[c+1]));}return 0===o&&0===l?0:Math.abs((l-o)/o)},Xp.flatten=function(t){for(var e=t[0][0].length,i={vertices:[],holes:[],dimensions:e},r=0,n=0;n<t.length;n++){for(var o=0;o<t[n].length;o++)for(var s=0;s<e;s++)i.vertices.push(t[n][o][s]);n>0&&i.holes.push(r+=t[n-1].length);}return i};var wf=d(Wp.exports);function Tf(t,e){const i=t.length;if(i<=1)return [t];const r=[];let n,o;for(let e=0;e<i;e++){const i=Y(t[e]);0!==i&&(t[e].area=Math.abs(i),void 0===o&&(o=i<0),o===i<0?(n&&r.push(n),n=[t[e]]):n.push(t[e]));}if(n&&r.push(n),e>1)for(let t=0;t<r.length;t++)r[t].length<=e||(ki(r[t],e,1,r[t].length-1,Ef),r[t]=r[t].slice(0,e));return r}function Ef(t,e){return e.area-t.area}function Mf(t,e,i){const r=i.patternDependencies;let n=!1;for(const i of e){const e=i.paint.get(`${t}-pattern`);e.isConstant()||(n=!0);const o=e.constantOr(null);o&&(n=!0,r[o]=!0);}return n}function Af(t,e,i,r,n){const o=n.patternDependencies;for(const s of e){const e=s.paint.get(`${t}-pattern`).value;if("constant"!==e.kind){let t=e.evaluate({zoom:r},i,{},n.availableImages);t=t&&t.name?t.name:t,o[t]=!0,i.patterns[s.id]=t;}}return i}class Sf{constructor(t){this.zoom=t.zoom,this.overscaling=t.overscaling,this.layers=t.layers,this.layerIds=this.layers.map((t=>t.id)),this.index=t.index,this.hasPattern=!1,this.patternFeatures=[],this.layoutVertexArray=new ya,this.indexArray=new Ba,this.indexArray2=new za,this.programConfigurations=new Fl(t.layers,t.zoom),this.segments=new Wl,this.segments2=new Wl,this.stateDependentLayerIds=this.layers.filter((t=>t.isStateDependent())).map((t=>t.id)),this.projection=t.projection;}populate(t,e,i,r){this.hasPattern=Mf("fill",this.layers,e);const n=this.layers[0].layout.get("fill-sort-key"),o=[];for(const{feature:s,id:a,index:l,sourceLayerIndex:c}of t){const t=this.layers[0]._featureFilter.needGeometry,h=op(s,t);if(!this.layers[0]._featureFilter.filter(new Qs(this.zoom),h,i))continue;const u=n?n.evaluate(h,{},i,e.availableImages):void 0,d={id:a,properties:s.properties,type:s.type,sourceLayerIndex:c,index:l,geometry:t?h.geometry:np(s,i,r),patterns:{},sortKey:u};o.push(d);}n&&o.sort(((t,e)=>t.sortKey-e.sortKey));for(const r of o){const{geometry:n,index:o,sourceLayerIndex:s}=r;if(this.hasPattern){const t=Af("fill",this.layers,r,this.zoom,e);this.patternFeatures.push(t);}else this.addFeature(r,n,o,i,{},e.availableImages,e.brightness);e.featureIndex.insert(t[o].feature,n,o,s,this.index);}}update(t,e,i,r,n){const o=0!==Object.keys(t).length;o&&!this.stateDependentLayers.length||this.programConfigurations.updatePaintArrays(t,e,o?this.stateDependentLayers:this.layers,i,r,n);}addFeatures(t,e,i,r,n,o){for(const t of this.patternFeatures)this.addFeature(t,t.geometry,t.index,e,i,r,o);}isEmpty(){return 0===this.layoutVertexArray.length}uploadPending(){return !this.uploaded||this.programConfigurations.needsUpload}upload(t){this.uploaded||(this.layoutVertexBuffer=t.createVertexBuffer(this.layoutVertexArray,Hp),this.indexBuffer=t.createIndexBuffer(this.indexArray),this.indexBuffer2=t.createIndexBuffer(this.indexArray2)),this.programConfigurations.upload(t),this.uploaded=!0;}destroy(){this.layoutVertexBuffer&&(this.layoutVertexBuffer.destroy(),this.indexBuffer.destroy(),this.indexBuffer2.destroy(),this.programConfigurations.destroy(),this.segments.destroy(),this.segments2.destroy());}addFeature(t,e,i,r,n,o=[],s){for(const t of Tf(e,500)){let e=0;for(const i of t)e+=i.length;const i=this.segments.prepareSegment(e,this.layoutVertexArray,this.indexArray),r=i.vertexLength,n=[],o=[];for(const e of t){if(0===e.length)continue;e!==t[0]&&o.push(n.length/2);const i=this.segments2.prepareSegment(e.length,this.layoutVertexArray,this.indexArray2),r=i.vertexLength;this.layoutVertexArray.emplaceBack(e[0].x,e[0].y),this.indexArray2.emplaceBack(r+e.length-1,r),n.push(e[0].x),n.push(e[0].y);for(let t=1;t<e.length;t++)this.layoutVertexArray.emplaceBack(e[t].x,e[t].y),this.indexArray2.emplaceBack(r+t-1,r+t),n.push(e[t].x),n.push(e[t].y);i.vertexLength+=e.length,i.primitiveLength+=e.length;}const s=wf(n,o);for(let t=0;t<s.length;t+=3)this.indexArray.emplaceBack(r+s[t],r+s[t+1],r+s[t+2]);i.vertexLength+=e,i.primitiveLength+=s.length/3;}this.programConfigurations.populatePaintArrays(this.layoutVertexArray.length,t,i,n,o,r,s);}}Ss(Sf,"FillBucket",{omit:["layers","patternFeatures"]});const If=new ua({"fill-sort-key":new ca(ze.layout_fill["fill-sort-key"]),visibility:new la(ze.layout_fill.visibility)});var Cf={paint:new ua({"fill-antialias":new la(ze.paint_fill["fill-antialias"]),"fill-opacity":new ca(ze.paint_fill["fill-opacity"]),"fill-color":new ca(ze.paint_fill["fill-color"]),"fill-outline-color":new ca(ze.paint_fill["fill-outline-color"]),"fill-translate":new la(ze.paint_fill["fill-translate"]),"fill-translate-anchor":new la(ze.paint_fill["fill-translate-anchor"]),"fill-pattern":new ca(ze.paint_fill["fill-pattern"]),"fill-emissive-strength":new la(ze.paint_fill["fill-emissive-strength"])}),layout:If};const zf=_a([{name:"a_pos_normal_ed",components:4,type:"Int16"}]),Df=_a([{name:"a_pos_end",components:4,type:"Int16"},{name:"a_angular_offset_factor",components:1,type:"Int16"}]),Pf=_a([{name:"a_centroid_pos",components:2,type:"Uint16"}]),Rf=_a([{name:"a_hidden_by_landmark",components:1,type:"Uint8"}]),Lf=_a([{name:"a_pos_3",components:3,type:"Int16"},{name:"a_pos_normal_3",components:3,type:"Int16"}]),{members:kf}=zf;var Bf={},Of=_,Ff=Nf;function Nf(t,e,i,r,n){this.properties={},this.extent=i,this.type=0,this._pbf=t,this._geometry=-1,this._keys=r,this._values=n,t.readFields(Uf,this,e);}function Uf(t,e,i){1==t?e.id=i.readVarint():2==t?function(t,e){for(var i=t.readVarint()+t.pos;t.pos<i;){var r=e._keys[t.readVarint()],n=e._values[t.readVarint()];e.properties[r]=n;}}(i,e):3==t?e.type=i.readVarint():4==t&&(e._geometry=i.pos);}function Vf(t){for(var e,i,r=0,n=0,o=t.length,s=o-1;n<o;s=n++)r+=((i=t[s]).x-(e=t[n]).x)*(e.y+i.y);return r}Nf.types=["Unknown","Point","LineString","Polygon"],Nf.prototype.loadGeometry=function(){var t=this._pbf;t.pos=this._geometry;for(var e,i=t.readVarint()+t.pos,r=1,n=0,o=0,s=0,a=[];t.pos<i;){if(n<=0){var l=t.readVarint();r=7&l,n=l>>3;}if(n--,1===r||2===r)o+=t.readSVarint(),s+=t.readSVarint(),1===r&&(e&&a.push(e),e=[]),e.push(new Of(o,s));else {if(7!==r)throw new Error("unknown command "+r);e&&e.push(e[0].clone());}}return e&&a.push(e),a},Nf.prototype.bbox=function(){var t=this._pbf;t.pos=this._geometry;for(var e=t.readVarint()+t.pos,i=1,r=0,n=0,o=0,s=1/0,a=-1/0,l=1/0,c=-1/0;t.pos<e;){if(r<=0){var h=t.readVarint();i=7&h,r=h>>3;}if(r--,1===i||2===i)(n+=t.readSVarint())<s&&(s=n),n>a&&(a=n),(o+=t.readSVarint())<l&&(l=o),o>c&&(c=o);else if(7!==i)throw new Error("unknown command "+i)}return [s,l,a,c]},Nf.prototype.toGeoJSON=function(t,e,i){var r,n,o=this.extent*Math.pow(2,i),s=this.extent*t,a=this.extent*e,l=this.loadGeometry(),c=Nf.types[this.type];function h(t){for(var e=0;e<t.length;e++){var i=t[e];t[e]=[360*(i.x+s)/o-180,360/Math.PI*Math.atan(Math.exp((180-360*(i.y+a)/o)*Math.PI/180))-90];}}switch(this.type){case 1:var u=[];for(r=0;r<l.length;r++)u[r]=l[r][0];h(l=u);break;case 2:for(r=0;r<l.length;r++)h(l[r]);break;case 3:for(l=function(t){var e=t.length;if(e<=1)return [t];for(var i,r,n=[],o=0;o<e;o++){var s=Vf(t[o]);0!==s&&(void 0===r&&(r=s<0),r===s<0?(i&&n.push(i),i=[t[o]]):i.push(t[o]));}return i&&n.push(i),n}(l),r=0;r<l.length;r++)for(n=0;n<l[r].length;n++)h(l[r][n]);}1===l.length?l=l[0]:c="Multi"+c;var d={type:"Feature",geometry:{type:c,coordinates:l},properties:this.properties};return "id"in this&&(d.id=this.id),d};var jf=Ff,Gf=qf;function qf(t,e){this.version=1,this.name=null,this.extent=4096,this.length=0,this._pbf=t,this._keys=[],this._values=[],this._features=[],t.readFields(Zf,this,e),this.length=this._features.length;}function Zf(t,e,i){15===t?e.version=i.readVarint():1===t?e.name=i.readString():5===t?e.extent=i.readVarint():2===t?e._features.push(i.pos):3===t?e._keys.push(i.readString()):4===t&&e._values.push(function(t){for(var e=null,i=t.readVarint()+t.pos;t.pos<i;){var r=t.readVarint()>>3;e=1===r?t.readString():2===r?t.readFloat():3===r?t.readDouble():4===r?t.readVarint64():5===r?t.readVarint():6===r?t.readSVarint():7===r?t.readBoolean():null;}return e}(i));}qf.prototype.feature=function(t){if(t<0||t>=this._features.length)throw new Error("feature index out of bounds");this._pbf.pos=this._features[t];var e=this._pbf.readVarint()+this._pbf.pos;return new jf(this._pbf,e,this.extent,this._keys,this._values)};var $f=Gf;function Hf(t,e,i){if(3===t){var r=new $f(i,i.readVarint()+i.pos);r.length&&(e[r.name]=r);}}var Wf=Bf.VectorTile=function(t,e){this.layers=t.readFields(Hf,{},e);},Xf=Bf.VectorTileFeature=Ff;function Yf(t,e,i,r){const n=[],o=0===r?(t,e,i,r,n,o)=>{t.push(new y(o,i+(o-e)/(r-e)*(n-i)));}:(t,e,i,r,n,o)=>{t.push(new y(e+(o-i)/(n-i)*(r-e),o));};for(const s of t){const t=[];for(const n of s){if(n.length<=2)continue;const s=[];for(let t=0;t<n.length-1;t++){const a=n[t].x,l=n[t].y,c=n[t+1].x,h=n[t+1].y,u=0===r?a:l,d=0===r?c:h;u<e?d>e&&o(s,a,l,c,h,e):u>i?d<i&&o(s,a,l,c,h,i):s.push(n[t]),d<e&&u>=e&&o(s,a,l,c,h,e),d>i&&u<=i&&o(s,a,l,c,h,i);}let a=n[n.length-1];const l=0===r?a.x:a.y;l>=e&&l<=i&&s.push(a),s.length&&(a=s[s.length-1],s[0].x===a.x&&s[0].y===a.y||s.push(s[0]),t.push(s));}t.length&&n.push(t);}return n}Bf.VectorTileLayer=Gf;class Kf{constructor(t){this._stringToNumber={},this._numberToString=[];for(let e=0;e<t.length;e++){const i=t[e];this._stringToNumber[i]=e,this._numberToString[e]=i;}}encode(t){return this._stringToNumber[t]}decode(t){return this._numberToString[t]}}var Jf={
/*! ieee754. BSD-3-Clause License. Feross Aboukhadijeh <https://feross.org/opensource> */
read:function(t,e,i,r,n){var o,s,a=8*n-r-1,l=(1<<a)-1,c=l>>1,h=-7,u=i?n-1:0,d=i?-1:1,p=t[e+u];for(u+=d,o=p&(1<<-h)-1,p>>=-h,h+=a;h>0;o=256*o+t[e+u],u+=d,h-=8);for(s=o&(1<<-h)-1,o>>=-h,h+=r;h>0;s=256*s+t[e+u],u+=d,h-=8);if(0===o)o=1-c;else {if(o===l)return s?NaN:1/0*(p?-1:1);s+=Math.pow(2,r),o-=c;}return (p?-1:1)*s*Math.pow(2,o-r)},write:function(t,e,i,r,n,o){var s,a,l,c=8*o-n-1,h=(1<<c)-1,u=h>>1,d=23===n?Math.pow(2,-24)-Math.pow(2,-77):0,p=r?0:o-1,f=r?1:-1,m=e<0||0===e&&1/e<0?1:0;for(e=Math.abs(e),isNaN(e)||e===1/0?(a=isNaN(e)?1:0,s=h):(s=Math.floor(Math.log(e)/Math.LN2),e*(l=Math.pow(2,-s))<1&&(s--,l*=2),(e+=s+u>=1?d/l:d*Math.pow(2,1-u))*l>=2&&(s++,l/=2),s+u>=h?(a=0,s=h):s+u>=1?(a=(e*l-1)*Math.pow(2,n),s+=u):(a=e*Math.pow(2,u-1)*Math.pow(2,n),s=0));n>=8;t[i+p]=255&a,p+=f,a/=256,n-=8);for(s=s<<n|a,c+=n;c>0;t[i+p]=255&s,p+=f,s/=256,c-=8);t[i+p-f]|=128*m;}},Qf=em,tm=Jf;function em(t){this.buf=ArrayBuffer.isView&&ArrayBuffer.isView(t)?t:new Uint8Array(t||0),this.pos=0,this.type=0,this.length=this.buf.length;}em.Varint=0,em.Fixed64=1,em.Bytes=2,em.Fixed32=5;var im=4294967296,rm=1/im,nm="undefined"==typeof TextDecoder?null:new TextDecoder("utf8");function om(t){return t.type===em.Bytes?t.readVarint()+t.pos:t.pos+1}function sm(t,e,i){return i?4294967296*e+(t>>>0):4294967296*(e>>>0)+(t>>>0)}function am(t,e,i){var r=e<=16383?1:e<=2097151?2:e<=268435455?3:Math.floor(Math.log(e)/(7*Math.LN2));i.realloc(r);for(var n=i.pos-1;n>=t;n--)i.buf[n+r]=i.buf[n];}function lm(t,e){for(var i=0;i<t.length;i++)e.writeVarint(t[i]);}function cm(t,e){for(var i=0;i<t.length;i++)e.writeSVarint(t[i]);}function hm(t,e){for(var i=0;i<t.length;i++)e.writeFloat(t[i]);}function um(t,e){for(var i=0;i<t.length;i++)e.writeDouble(t[i]);}function dm(t,e){for(var i=0;i<t.length;i++)e.writeBoolean(t[i]);}function pm(t,e){for(var i=0;i<t.length;i++)e.writeFixed32(t[i]);}function fm(t,e){for(var i=0;i<t.length;i++)e.writeSFixed32(t[i]);}function mm(t,e){for(var i=0;i<t.length;i++)e.writeFixed64(t[i]);}function _m(t,e){for(var i=0;i<t.length;i++)e.writeSFixed64(t[i]);}function gm(t,e){return (t[e]|t[e+1]<<8|t[e+2]<<16)+16777216*t[e+3]}function ym(t,e,i){t[i]=e,t[i+1]=e>>>8,t[i+2]=e>>>16,t[i+3]=e>>>24;}function xm(t,e){return (t[e]|t[e+1]<<8|t[e+2]<<16)+(t[e+3]<<24)}em.prototype={destroy:function(){this.buf=null;},readFields:function(t,e,i){for(i=i||this.length;this.pos<i;){var r=this.readVarint(),n=r>>3,o=this.pos;this.type=7&r,t(n,e,this),this.pos===o&&this.skip(r);}return e},readMessage:function(t,e){return this.readFields(t,e,this.readVarint()+this.pos)},readFixed32:function(){var t=gm(this.buf,this.pos);return this.pos+=4,t},readSFixed32:function(){var t=xm(this.buf,this.pos);return this.pos+=4,t},readFixed64:function(){var t=gm(this.buf,this.pos)+gm(this.buf,this.pos+4)*im;return this.pos+=8,t},readSFixed64:function(){var t=gm(this.buf,this.pos)+xm(this.buf,this.pos+4)*im;return this.pos+=8,t},readFloat:function(){var t=tm.read(this.buf,this.pos,!0,23,4);return this.pos+=4,t},readDouble:function(){var t=tm.read(this.buf,this.pos,!0,52,8);return this.pos+=8,t},readVarint:function(t){var e,i,r=this.buf;return e=127&(i=r[this.pos++]),i<128?e:(e|=(127&(i=r[this.pos++]))<<7,i<128?e:(e|=(127&(i=r[this.pos++]))<<14,i<128?e:(e|=(127&(i=r[this.pos++]))<<21,i<128?e:function(t,e,i){var r,n,o=i.buf;if(r=(112&(n=o[i.pos++]))>>4,n<128)return sm(t,r,e);if(r|=(127&(n=o[i.pos++]))<<3,n<128)return sm(t,r,e);if(r|=(127&(n=o[i.pos++]))<<10,n<128)return sm(t,r,e);if(r|=(127&(n=o[i.pos++]))<<17,n<128)return sm(t,r,e);if(r|=(127&(n=o[i.pos++]))<<24,n<128)return sm(t,r,e);if(r|=(1&(n=o[i.pos++]))<<31,n<128)return sm(t,r,e);throw new Error("Expected varint not more than 10 bytes")}(e|=(15&(i=r[this.pos]))<<28,t,this))))},readVarint64:function(){return this.readVarint(!0)},readSVarint:function(){var t=this.readVarint();return t%2==1?(t+1)/-2:t/2},readBoolean:function(){return Boolean(this.readVarint())},readString:function(){var t=this.readVarint()+this.pos,e=this.pos;return this.pos=t,t-e>=12&&nm?function(t,e,i){return nm.decode(t.subarray(e,i))}(this.buf,e,t):function(t,e,i){for(var r="",n=e;n<i;){var o,s,a,l=t[n],c=null,h=l>239?4:l>223?3:l>191?2:1;if(n+h>i)break;1===h?l<128&&(c=l):2===h?128==(192&(o=t[n+1]))&&(c=(31&l)<<6|63&o)<=127&&(c=null):3===h?(s=t[n+2],128==(192&(o=t[n+1]))&&128==(192&s)&&((c=(15&l)<<12|(63&o)<<6|63&s)<=2047||c>=55296&&c<=57343)&&(c=null)):4===h&&(s=t[n+2],a=t[n+3],128==(192&(o=t[n+1]))&&128==(192&s)&&128==(192&a)&&((c=(15&l)<<18|(63&o)<<12|(63&s)<<6|63&a)<=65535||c>=1114112)&&(c=null)),null===c?(c=65533,h=1):c>65535&&(c-=65536,r+=String.fromCharCode(c>>>10&1023|55296),c=56320|1023&c),r+=String.fromCharCode(c),n+=h;}return r}(this.buf,e,t)},readBytes:function(){var t=this.readVarint()+this.pos,e=this.buf.subarray(this.pos,t);return this.pos=t,e},readPackedVarint:function(t,e){if(this.type!==em.Bytes)return t.push(this.readVarint(e));var i=om(this);for(t=t||[];this.pos<i;)t.push(this.readVarint(e));return t},readPackedSVarint:function(t){if(this.type!==em.Bytes)return t.push(this.readSVarint());var e=om(this);for(t=t||[];this.pos<e;)t.push(this.readSVarint());return t},readPackedBoolean:function(t){if(this.type!==em.Bytes)return t.push(this.readBoolean());var e=om(this);for(t=t||[];this.pos<e;)t.push(this.readBoolean());return t},readPackedFloat:function(t){if(this.type!==em.Bytes)return t.push(this.readFloat());var e=om(this);for(t=t||[];this.pos<e;)t.push(this.readFloat());return t},readPackedDouble:function(t){if(this.type!==em.Bytes)return t.push(this.readDouble());var e=om(this);for(t=t||[];this.pos<e;)t.push(this.readDouble());return t},readPackedFixed32:function(t){if(this.type!==em.Bytes)return t.push(this.readFixed32());var e=om(this);for(t=t||[];this.pos<e;)t.push(this.readFixed32());return t},readPackedSFixed32:function(t){if(this.type!==em.Bytes)return t.push(this.readSFixed32());var e=om(this);for(t=t||[];this.pos<e;)t.push(this.readSFixed32());return t},readPackedFixed64:function(t){if(this.type!==em.Bytes)return t.push(this.readFixed64());var e=om(this);for(t=t||[];this.pos<e;)t.push(this.readFixed64());return t},readPackedSFixed64:function(t){if(this.type!==em.Bytes)return t.push(this.readSFixed64());var e=om(this);for(t=t||[];this.pos<e;)t.push(this.readSFixed64());return t},skip:function(t){var e=7&t;if(e===em.Varint)for(;this.buf[this.pos++]>127;);else if(e===em.Bytes)this.pos=this.readVarint()+this.pos;else if(e===em.Fixed32)this.pos+=4;else {if(e!==em.Fixed64)throw new Error("Unimplemented type: "+e);this.pos+=8;}},writeTag:function(t,e){this.writeVarint(t<<3|e);},realloc:function(t){for(var e=this.length||16;e<this.pos+t;)e*=2;if(e!==this.length){var i=new Uint8Array(e);i.set(this.buf),this.buf=i,this.length=e;}},finish:function(){return this.length=this.pos,this.pos=0,this.buf.subarray(0,this.length)},writeFixed32:function(t){this.realloc(4),ym(this.buf,t,this.pos),this.pos+=4;},writeSFixed32:function(t){this.realloc(4),ym(this.buf,t,this.pos),this.pos+=4;},writeFixed64:function(t){this.realloc(8),ym(this.buf,-1&t,this.pos),ym(this.buf,Math.floor(t*rm),this.pos+4),this.pos+=8;},writeSFixed64:function(t){this.realloc(8),ym(this.buf,-1&t,this.pos),ym(this.buf,Math.floor(t*rm),this.pos+4),this.pos+=8;},writeVarint:function(t){(t=+t||0)>268435455||t<0?function(t,e){var i,r;if(t>=0?(i=t%4294967296|0,r=t/4294967296|0):(r=~(-t/4294967296),4294967295^(i=~(-t%4294967296))?i=i+1|0:(i=0,r=r+1|0)),t>=0x10000000000000000||t<-0x10000000000000000)throw new Error("Given varint doesn't fit into 10 bytes");e.realloc(10),function(t,e,i){i.buf[i.pos++]=127&t|128,t>>>=7,i.buf[i.pos++]=127&t|128,t>>>=7,i.buf[i.pos++]=127&t|128,t>>>=7,i.buf[i.pos++]=127&t|128,i.buf[i.pos]=127&(t>>>=7);}(i,0,e),function(t,e){var i=(7&t)<<4;e.buf[e.pos++]|=i|((t>>>=3)?128:0),t&&(e.buf[e.pos++]=127&t|((t>>>=7)?128:0),t&&(e.buf[e.pos++]=127&t|((t>>>=7)?128:0),t&&(e.buf[e.pos++]=127&t|((t>>>=7)?128:0),t&&(e.buf[e.pos++]=127&t|((t>>>=7)?128:0),t&&(e.buf[e.pos++]=127&t)))));}(r,e);}(t,this):(this.realloc(4),this.buf[this.pos++]=127&t|(t>127?128:0),t<=127||(this.buf[this.pos++]=127&(t>>>=7)|(t>127?128:0),t<=127||(this.buf[this.pos++]=127&(t>>>=7)|(t>127?128:0),t<=127||(this.buf[this.pos++]=t>>>7&127))));},writeSVarint:function(t){this.writeVarint(t<0?2*-t-1:2*t);},writeBoolean:function(t){this.writeVarint(Boolean(t));},writeString:function(t){t=String(t),this.realloc(4*t.length),this.pos++;var e=this.pos;this.pos=function(t,e,i){for(var r,n,o=0;o<e.length;o++){if((r=e.charCodeAt(o))>55295&&r<57344){if(!n){r>56319||o+1===e.length?(t[i++]=239,t[i++]=191,t[i++]=189):n=r;continue}if(r<56320){t[i++]=239,t[i++]=191,t[i++]=189,n=r;continue}r=n-55296<<10|r-56320|65536,n=null;}else n&&(t[i++]=239,t[i++]=191,t[i++]=189,n=null);r<128?t[i++]=r:(r<2048?t[i++]=r>>6|192:(r<65536?t[i++]=r>>12|224:(t[i++]=r>>18|240,t[i++]=r>>12&63|128),t[i++]=r>>6&63|128),t[i++]=63&r|128);}return i}(this.buf,t,this.pos);var i=this.pos-e;i>=128&&am(e,i,this),this.pos=e-1,this.writeVarint(i),this.pos+=i;},writeFloat:function(t){this.realloc(4),tm.write(this.buf,t,this.pos,!0,23,4),this.pos+=4;},writeDouble:function(t){this.realloc(8),tm.write(this.buf,t,this.pos,!0,52,8),this.pos+=8;},writeBytes:function(t){var e=t.length;this.writeVarint(e),this.realloc(e);for(var i=0;i<e;i++)this.buf[this.pos++]=t[i];},writeRawMessage:function(t,e){this.pos++;var i=this.pos;t(e,this);var r=this.pos-i;r>=128&&am(i,r,this),this.pos=i-1,this.writeVarint(r),this.pos+=r;},writeMessage:function(t,e,i){this.writeTag(t,em.Bytes),this.writeRawMessage(e,i);},writePackedVarint:function(t,e){e.length&&this.writeMessage(t,lm,e);},writePackedSVarint:function(t,e){e.length&&this.writeMessage(t,cm,e);},writePackedBoolean:function(t,e){e.length&&this.writeMessage(t,dm,e);},writePackedFloat:function(t,e){e.length&&this.writeMessage(t,hm,e);},writePackedDouble:function(t,e){e.length&&this.writeMessage(t,um,e);},writePackedFixed32:function(t,e){e.length&&this.writeMessage(t,pm,e);},writePackedSFixed32:function(t,e){e.length&&this.writeMessage(t,fm,e);},writePackedFixed64:function(t,e){e.length&&this.writeMessage(t,mm,e);},writePackedSFixed64:function(t,e){e.length&&this.writeMessage(t,_m,e);},writeBytesField:function(t,e){this.writeTag(t,em.Bytes),this.writeBytes(e);},writeFixed32Field:function(t,e){this.writeTag(t,em.Fixed32),this.writeFixed32(e);},writeSFixed32Field:function(t,e){this.writeTag(t,em.Fixed32),this.writeSFixed32(e);},writeFixed64Field:function(t,e){this.writeTag(t,em.Fixed64),this.writeFixed64(e);},writeSFixed64Field:function(t,e){this.writeTag(t,em.Fixed64),this.writeSFixed64(e);},writeVarintField:function(t,e){this.writeTag(t,em.Varint),this.writeVarint(e);},writeSVarintField:function(t,e){this.writeTag(t,em.Varint),this.writeSVarint(e);},writeStringField:function(t,e){this.writeTag(t,em.Bytes),this.writeString(e);},writeFloatField:function(t,e){this.writeTag(t,em.Fixed32),this.writeFloat(e);},writeDoubleField:function(t,e){this.writeTag(t,em.Fixed64),this.writeDouble(e);},writeBooleanField:function(t,e){this.writeVarintField(t,Boolean(e));}};var vm=d(Qf);const bm=["tile","layer","source","sourceLayer","state"];class wm{constructor(t,e,i,r,n){this.type="Feature",this._vectorTileFeature=t,this._z=e,this._x=i,this._y=r,this.properties=t.properties,this.id=n;}get geometry(){return void 0===this._geometry&&(this._geometry=this._vectorTileFeature.toGeoJSON(this._x,this._y,this._z).geometry),this._geometry}set geometry(t){this._geometry=t;}toJSON(){const t={type:"Feature",state:void 0,geometry:this.geometry,properties:this.properties};void 0!==this.id&&(t.id=this.id);for(const e of bm)void 0!==this[e]&&(t[e]=this[e]);return t}}class Tm{constructor(){this.state={},this.stateChanges={},this.deletedStates={};}updateState(t,e,i){const r=String(e);if(this.stateChanges[t]=this.stateChanges[t]||{},this.stateChanges[t][r]=this.stateChanges[t][r]||{},k(this.stateChanges[t][r],i),null===this.deletedStates[t]){this.deletedStates[t]={};for(const e in this.state[t])e!==r&&(this.deletedStates[t][e]=null);}else if(this.deletedStates[t]&&null===this.deletedStates[t][r]){this.deletedStates[t][r]={};for(const e in this.state[t][r])i[e]||(this.deletedStates[t][r][e]=null);}else for(const e in i)this.deletedStates[t]&&this.deletedStates[t][r]&&null===this.deletedStates[t][r][e]&&delete this.deletedStates[t][r][e];}removeFeatureState(t,e,i){if(null===this.deletedStates[t])return;const r=String(e);if(this.deletedStates[t]=this.deletedStates[t]||{},i&&void 0!==e)null!==this.deletedStates[t][r]&&(this.deletedStates[t][r]=this.deletedStates[t][r]||{},this.deletedStates[t][r][i]=null);else if(void 0!==e)if(this.stateChanges[t]&&this.stateChanges[t][r])for(i in this.deletedStates[t][r]={},this.stateChanges[t][r])this.deletedStates[t][r][i]=null;else this.deletedStates[t][r]=null;else this.deletedStates[t]=null;}getState(t,e){const i=String(e),r=k({},(this.state[t]||{})[i],(this.stateChanges[t]||{})[i]);if(null===this.deletedStates[t])return {};if(this.deletedStates[t]){const i=this.deletedStates[t][e];if(null===i)return {};for(const t in i)delete r[t];}return r}initializeTileState(t,e){t.setFeatureState(this.state,e);}coalesceChanges(t,e){const i={};for(const t in this.stateChanges){this.state[t]=this.state[t]||{};const e={};for(const i in this.stateChanges[t])this.state[t][i]||(this.state[t][i]={}),k(this.state[t][i],this.stateChanges[t][i]),e[i]=this.state[t][i];i[t]=e;}for(const t in this.deletedStates){this.state[t]=this.state[t]||{};const e={};if(null===this.deletedStates[t])for(const i in this.state[t])e[i]={},this.state[t][i]={};else for(const i in this.deletedStates[t]){if(null===this.deletedStates[t][i])this.state[t][i]={};else if(this.state[t][i])for(const e of Object.keys(this.deletedStates[t][i]))delete this.state[t][i][e];e[i]=this.state[t][i];}i[t]=i[t]||{},k(i[t],e);}if(this.stateChanges={},this.deletedStates={},0!==Object.keys(i).length)for(const r in t)t[r].setFeatureState(i,e);}}class Em{constructor(t){this.size=t,this.minimums=[],this.maximums=[],this.leaves=[];}getElevation(t,e){const i=this.toIdx(t,e);return {min:this.minimums[i],max:this.maximums[i]}}isLeaf(t,e){return this.leaves[this.toIdx(t,e)]}toIdx(t,e){return e*this.size+t}}function Mm(t,e,i,r){let n=0,o=Number.MAX_VALUE;for(let s=0;s<3;s++)if(Math.abs(r[s])<1e-15){if(i[s]<t[s]||i[s]>e[s])return null}else {const a=1/r[s];let l=(t[s]-i[s])*a,c=(e[s]-i[s])*a;if(l>c){const t=l;l=c,c=t;}if(l>n&&(n=l),c<o&&(o=c),n>o)return null}return n}function Am(t,e,i,r,n,o,s,a,l,c,h){const u=r-t,d=n-e,p=o-i,f=s-t,m=a-e,_=l-i,g=h[1]*_-h[2]*m,y=h[2]*f-h[0]*_,x=h[0]*m-h[1]*f,v=u*g+d*y+p*x;if(Math.abs(v)<1e-15)return null;const b=1/v,w=c[0]-t,T=c[1]-e,E=c[2]-i,M=(w*g+T*y+E*x)*b;if(M<0||M>1)return null;const A=T*p-E*d,S=E*u-w*p,I=w*d-T*u,C=(h[0]*A+h[1]*S+h[2]*I)*b;return C<0||M+C>1?null:(f*A+m*S+_*I)*b}function Sm(t,e,i){return (t-e)/(i-e)}function Im(t,e,i,r,n,o,s,a,l){const c=1<<i,h=o-r,u=s-n,d=(t+1)/c*h+r,p=(e+0)/c*u+n,f=(e+1)/c*u+n;a[0]=(t+0)/c*h+r,a[1]=p,l[0]=d,l[1]=f;}class Cm{constructor(t){if(this.maximums=[],this.minimums=[],this.leaves=[],this.childOffsets=[],this.nodeCount=0,this.dem=t,this._siblingOffset=[[0,0],[1,0],[0,1],[1,1]],!this.dem)return;const e=function(t){const e=Math.ceil(Math.log2(t.dim/8)),i=[];let r=Math.ceil(Math.pow(2,e));const n=1/r,o=(t,e,i,r,n)=>{const o=r?1:0,s=(t+1)*i-o,a=e*i,l=(e+1)*i-o;n[0]=t*i,n[1]=a,n[2]=s,n[3]=l;};let s=new Em(r);const a=[];for(let e=0;e<r*r;e++){o(e%r,Math.floor(e/r),n,!1,a);const i=Dm(a[0],a[1],t),l=Dm(a[2],a[1],t),c=Dm(a[2],a[3],t),h=Dm(a[0],a[3],t);s.minimums.push(Math.min(i,l,c,h)),s.maximums.push(Math.max(i,l,c,h)),s.leaves.push(1);}for(i.push(s),r/=2;r>=1;r/=2){const t=i[i.length-1];s=new Em(r);for(let e=0;e<r*r;e++){o(e%r,Math.floor(e/r),2,!0,a);const i=t.getElevation(a[0],a[1]),n=t.getElevation(a[2],a[1]),l=t.getElevation(a[2],a[3]),c=t.getElevation(a[0],a[3]),h=t.isLeaf(a[0],a[1]),u=t.isLeaf(a[2],a[1]),d=t.isLeaf(a[2],a[3]),p=t.isLeaf(a[0],a[3]),f=Math.min(i.min,n.min,l.min,c.min),m=Math.max(i.max,n.max,l.max,c.max),_=h&&u&&d&&p;s.maximums.push(m),s.minimums.push(f),s.leaves.push(m-f<=5&&_?1:0);}i.push(s);}return i}(this.dem),i=e.length-1,r=e[i];this._addNode(r.minimums[0],r.maximums[0],r.leaves[0]),this._construct(e,0,0,i,0);}raycastRoot(t,e,i,r,n,o,s=1){return Mm([t,e,-100],[i,r,this.maximums[0]*s],n,o)}raycast(t,e,i,r,n,o,s=1){if(!this.nodeCount)return null;const a=this.raycastRoot(t,e,i,r,n,o,s);if(null==a)return null;const l=[],c=[],h=[],u=[],d=[{idx:0,t:a,nodex:0,nodey:0,depth:0}];for(;d.length>0;){const{idx:a,t:p,nodex:f,nodey:m,depth:_}=d.pop();if(this.leaves[a]){Im(f,m,_,t,e,i,r,h,u);const a=1<<_,l=(f+0)/a,c=(f+1)/a,d=(m+0)/a,g=(m+1)/a,y=Dm(l,d,this.dem)*s,x=Dm(c,d,this.dem)*s,v=Dm(c,g,this.dem)*s,b=Dm(l,g,this.dem)*s,w=Am(h[0],h[1],y,u[0],h[1],x,u[0],u[1],v,n,o),T=Am(u[0],u[1],v,h[0],u[1],b,h[0],h[1],y,n,o),E=Math.min(null!==w?w:Number.MAX_VALUE,null!==T?T:Number.MAX_VALUE);if(E!==Number.MAX_VALUE)return E;{const t=bu.scaleAndAdd([],n,o,p);if(zm(y,x,b,v,Sm(t[0],h[0],u[0]),Sm(t[1],h[1],u[1]))>=t[2])return p}continue}let g=0;for(let d=0;d<this._siblingOffset.length;d++){Im((f<<1)+this._siblingOffset[d][0],(m<<1)+this._siblingOffset[d][1],_+1,t,e,i,r,h,u),h[2]=-100,u[2]=this.maximums[this.childOffsets[a]+d]*s;const p=Mm(h,u,n,o);if(null!=p){const t=p;l[d]=t;let e=!1;for(let i=0;i<g&&!e;i++)t>=l[c[i]]&&(c.splice(i,0,d),e=!0);e||(c[g]=d),g++;}}for(let t=0;t<g;t++){const e=c[t];d.push({idx:this.childOffsets[a]+e,t:l[e],nodex:(f<<1)+this._siblingOffset[e][0],nodey:(m<<1)+this._siblingOffset[e][1],depth:_+1});}}return null}_addNode(t,e,i){return this.minimums.push(t),this.maximums.push(e),this.leaves.push(i),this.childOffsets.push(0),this.nodeCount++}_construct(t,e,i,r,n){if(1===t[r].isLeaf(e,i))return;this.childOffsets[n]||(this.childOffsets[n]=this.nodeCount);const o=r-1,s=t[o];let a=0,l=0;for(let t=0;t<this._siblingOffset.length;t++){const r=2*e+this._siblingOffset[t][0],n=2*i+this._siblingOffset[t][1],o=s.getElevation(r,n),c=s.isLeaf(r,n),h=this._addNode(o.min,o.max,c);c&&(a|=1<<t),l||(l=h);}for(let r=0;r<this._siblingOffset.length;r++)a&1<<r||this._construct(t,2*e+this._siblingOffset[r][0],2*i+this._siblingOffset[r][1],o,l+r);}}function zm(t,e,i,r,n,o){return Wr(Wr(t,i,o),Wr(e,r,o),n)}function Dm(t,e,i){const r=i.dim,n=z(t*r-.5,0,r-1),o=z(e*r-.5,0,r-1),s=Math.floor(n),a=Math.floor(o),l=Math.min(s+1,r-1),c=Math.min(a+1,r-1);return zm(i.get(s,a),i.get(l,a),i.get(s,c),i.get(l,c),n-s,o-a)}const Pm={mapbox:[6553.6,25.6,.1,1e4],terrarium:[256,1,1/256,32768],float:[1,1,1,1]};function Rm(t,e,i){return (256*t*256+256*e+i)/10-1e4}function Lm(t,e,i){return 256*t+e+i/256-32768}class km{get tree(){return this._tree||this._buildQuadTree(),this._tree}constructor(t,e,i,r,n=!1,o=!1){if(this.uid=t,e.height!==e.width)throw new RangeError("DEM tiles must be square");if(i&&"mapbox"!==i&&"terrarium"!==i)return W(`"${i}" is not a valid encoding type. Valid types include "mapbox" and "terrarium".`);this.stride=e.height;const s=this.dim=e.height-2,a=new Uint32Array(e.data.buffer);if(this.pixels=new Uint8Array(e.data.buffer),this.encoding=i||"mapbox",this.borderReady=n,!n){for(let t=0;t<s;t++)a[this._idx(-1,t)]=a[this._idx(0,t)],a[this._idx(s,t)]=a[this._idx(s-1,t)],a[this._idx(t,-1)]=a[this._idx(t,0)],a[this._idx(t,s)]=a[this._idx(t,s-1)];a[this._idx(-1,-1)]=a[this._idx(0,0)],a[this._idx(s,-1)]=a[this._idx(s-1,0)],a[this._idx(-1,s)]=a[this._idx(0,s-1)],a[this._idx(s,s)]=a[this._idx(s-1,s-1)];}if(o&&this._buildQuadTree(),r){const t=new Float32Array(e.data.buffer),i="terrarium"===this.encoding?Lm:Rm;for(let e=0;e<a.length;++e){const r=4*e;t[e]=i(this.pixels[r],this.pixels[r+1],this.pixels[r+2]);}this.encoding="float";}}_buildQuadTree(){this._tree=new Cm(this);}get(t,e,i=!1){i&&(t=z(t,-1,this.dim),e=z(e,-1,this.dim));const r=this._idx(t,e);if("float"===this.encoding)return new Float32Array(this.pixels.buffer)[r];const n=4*r;return ("terrarium"===this.encoding?Lm:Rm)(this.pixels[n],this.pixels[n+1],this.pixels[n+2])}static getUnpackVector(t){return Pm[t]}get unpackVector(){return Pm[this.encoding]}_idx(t,e){if(t<-1||t>=this.dim+1||e<-1||e>=this.dim+1)throw new RangeError("out of range source coordinates for DEM data");return (e+1)*this.stride+(t+1)}static pack(t,e){const i=[0,0,0,0],r=km.getUnpackVector(e);let n=Math.floor((t+r[3])/r[2]);return i[2]=n%256,n=Math.floor(n/256),i[1]=n%256,n=Math.floor(n/256),i[0]=n,i}getPixels(){return "float"===this.encoding?new Up({width:this.stride,height:this.stride},this.pixels):new Np({width:this.stride,height:this.stride},this.pixels)}backfillBorder(t,e,i){if(this.dim!==t.dim)throw new Error("dem dimension mismatch");let r=e*this.dim,n=e*this.dim+this.dim,o=i*this.dim,s=i*this.dim+this.dim;switch(e){case-1:r=n-1;break;case 1:n=r+1;}switch(i){case-1:o=s-1;break;case 1:s=o+1;}const a=-e*this.dim,l=-i*this.dim;for(let e=o;e<s;e++)for(let i=r;i<n;i++){const r=4*this._idx(i,e),n=4*this._idx(i+a,e+l);this.pixels[r+0]=t.pixels[n+0],this.pixels[r+1]=t.pixels[n+1],this.pixels[r+2]=t.pixels[n+2],this.pixels[r+3]=t.pixels[n+3];}}onDeserialize(){this._tree&&(this._tree.dem=this);}}Ss(km,"DEMData"),Ss(Cm,"DemMinMaxQuadTree",{omit:["dem"]});class Bm{isDataAvailableAtPoint(t){const e=this._source();if(this.isUsingMockSource()||!e||t.y<0||t.y>1)return !1;const i=e.getSource().maxzoom,r=1<<i,n=Math.floor(t.x),o=Math.floor((t.x-n)*r),s=Math.floor(t.y*r),a=this.findDEMTileFor(new Rd(i,n,i,o,s));return !(!a||!a.dem)}getAtPointOrZero(t,e=0){return this.getAtPoint(t,e)||0}getAtPoint(t,e,i=!0){if(this.isUsingMockSource())return null;null==e&&(e=null);const r=this._source();if(!r)return e;if(t.y<0||t.y>1)return e;const n=r.getSource().maxzoom,o=1<<n,s=Math.floor(t.x),a=t.x-s,l=new Rd(n,s,n,Math.floor(a*o),Math.floor(t.y*o)),c=this.findDEMTileFor(l);if(!c||!c.dem)return e;const h=c.dem,u=1<<c.tileID.canonical.z,d=(a*u-c.tileID.canonical.x)*h.dim,p=(t.y*u-c.tileID.canonical.y)*h.dim,f=Math.floor(d),m=Math.floor(p);return (i?this.exaggeration():1)*Wr(Wr(h.get(f,m),h.get(f,m+1),p-m),Wr(h.get(f+1,m),h.get(f+1,m+1),p-m),d-f)}getAtTileOffset(t,e,i){const r=1<<t.canonical.z;return this.getAtPointOrZero(new Yd(t.wrap+(t.canonical.x+e/sr)/r,(t.canonical.y+i/sr)/r))}getAtTileOffsetFunc(t,e,i,r){return n=>{const o=this.getAtTileOffset(t,n.x,n.y),s=r.upVector(t.canonical,n.x,n.y),a=r.upVectorScale(t.canonical,e,i).metersToTile;return bu.scale(s,s,o*a),s}}getForTilePoints(t,e,i,r){if(this.isUsingMockSource())return !1;const n=Om.create(this,t,r);return !!n&&(e.forEach((t=>{t[2]=this.exaggeration()*n.getElevationAt(t[0],t[1],i);})),!0)}getMinMaxForTile(t){if(this.isUsingMockSource())return null;const e=this.findDEMTileFor(t);if(!e||!e.dem)return null;const i=e.dem.tree,r=e.tileID,n=1<<t.canonical.z-r.canonical.z;let o=t.canonical.x/n-r.canonical.x,s=t.canonical.y/n-r.canonical.y,a=0;for(let e=0;e<t.canonical.z-r.canonical.z&&!i.leaves[a];e++){o*=2,s*=2;const t=2*Math.floor(s)+Math.floor(o);a=i.childOffsets[a]+t,o%=1,s%=1;}return {min:this.exaggeration()*i.minimums[a],max:this.exaggeration()*i.maximums[a]}}getMinElevationBelowMSL(){throw new Error("Pure virtual method called.")}raycast(t,e,i){throw new Error("Pure virtual method called.")}pointCoordinate(t){throw new Error("Pure virtual method called.")}_source(){throw new Error("Pure virtual method called.")}isUsingMockSource(){throw new Error("Pure virtual method called.")}exaggeration(){throw new Error("Pure virtual method called.")}findDEMTileFor(t){throw new Error("Pure virtual method called.")}get visibleDemTiles(){throw new Error("Getter must be implemented in subclass.")}}class Om{constructor(t,e,i){this._demTile=t,this._dem=this._demTile.dem,this._scale=e,this._offset=i;}static create(t,e,i){const r=i||t.findDEMTileFor(e);if(!r||!r.dem)return;const n=r.dem,o=r.tileID,s=1<<e.canonical.z-o.canonical.z;return new Om(r,r.tileSize/sr/s,[(e.canonical.x/s-o.canonical.x)*n.dim,(e.canonical.y/s-o.canonical.y)*n.dim])}tileCoordToPixel(t,e){const i=e*this._scale+this._offset[1],r=Math.floor(t*this._scale+this._offset[0]),n=Math.floor(i);return new y(r,n)}getElevationAt(t,e,i,r){const n=t*this._scale+this._offset[0],o=e*this._scale+this._offset[1],s=Math.floor(n),a=Math.floor(o),l=this._dem;return r=!!r,i?Wr(Wr(l.get(s,a,r),l.get(s,a+1,r),o-a),Wr(l.get(s+1,a,r),l.get(s+1,a+1,r),o-a),n-s):l.get(s,a,r)}getElevationAtPixel(t,e,i){return this._dem.get(t,e,!!i)}getMeterToDEM(t){return (1<<this._demTile.tileID.canonical.z)*Vd(1,t)*this._dem.stride}}class Fm{constructor(t,e){this.tileID=t,this.x=t.canonical.x,this.y=t.canonical.y,this.z=t.canonical.z,this.grid=new Ms(sr,16,0),this.featureIndexArray=new rl,this.promoteId=e;}insert(t,e,i,r,n,o=0){const s=this.featureIndexArray.length;this.featureIndexArray.emplaceBack(i,r,n,o);const a=this.grid;for(let t=0;t<e.length;t++){const i=e[t],r=[1/0,1/0,-1/0,-1/0];for(let t=0;t<i.length;t++){const e=i[t];r[0]=Math.min(r[0],e.x),r[1]=Math.min(r[1],e.y),r[2]=Math.max(r[2],e.x),r[3]=Math.max(r[3],e.y);}r[0]<sr&&r[1]<sr&&r[2]>=0&&r[3]>=0&&a.insert(s,r[0],r[1],r[2],r[3]);}}loadVTLayers(){if(!this.vtLayers){this.vtLayers=new Wf(new vm(this.rawTileData)).layers,this.sourceLayerCoder=new Kf(this.vtLayers?Object.keys(this.vtLayers).sort():["_geojsonTileLayer"]),this.vtFeatures={};for(const t in this.vtLayers)this.vtFeatures[t]=[];}return this.vtLayers}query(t,e,i,r){this.loadVTLayers();const n=t.params||{},o=Po(n.filter),s=t.tileResult,a=t.transform,l=s.bufferedTilespaceBounds,c=this.grid.query(l.min.x,l.min.y,l.max.x,l.max.y,((t,e,i,r)=>xp(s.bufferedTilespaceGeometry,t,e,i,r)));c.sort(Um);let h=null;a.elevation&&c.length>0&&(h=Om.create(a.elevation,this.tileID));const u={};let d;for(let a=0;a<c.length;a++){const l=c[a];if(l===d)continue;d=l;const p=this.featureIndexArray.get(l);let f=null;this.loadMatchingFeature(u,p,o,n.layers,n.availableImages,e,i,r,((e,i,r,n=0)=>(f||(f=np(e,this.tileID.canonical,t.tileTransform)),i.queryIntersectsFeature(s,e,r,f,this.z,t.transform,t.pixelPosMatrix,h,n))));}return u}loadMatchingFeature(t,e,i,r,n,o,s,a,l){const{featureIndex:c,bucketIndex:h,sourceLayerIndex:u,layoutVertexArrayOffset:d}=e,p=this.bucketLayerIDs[h];if(r&&!function(t,e){for(let i=0;i<t.length;i++)if(e.indexOf(t[i])>=0)return !0;return !1}(r,p))return;const f=this.sourceLayerCoder.decode(u),m=this.vtLayers[f].feature(c);if(i.needGeometry){const t=op(m,!0);if(!i.filter(new Qs(this.tileID.overscaledZ),t,this.tileID.canonical))return}else if(!i.filter(new Qs(this.tileID.overscaledZ),m))return;const _=this.getId(m,f);for(let e=0;e<p.length;e++){const i=p[e];if(r&&r.indexOf(i)<0)continue;const h=o[i];if(!h)continue;let u={};void 0!==_&&a&&(u=a.getState(h.sourceLayer||"_geojsonTileLayer",_));const f=k({},s[i]);f.paint=Nm(f.paint,h.paint,m,u,n),f.layout=Nm(f.layout,h.layout,m,u,n);const g=!l||l(m,h,u,d);if(!g)continue;const y=new wm(m,this.z,this.x,this.y,_);y.layer=f;let x=t[i];void 0===x&&(x=t[i]=[]),x.push({featureIndex:c,feature:y,intersectionZ:g});}}lookupSymbolFeatures(t,e,i,r,n,o,s,a){const l={};this.loadVTLayers();const c=Po(n);for(const n of t)this.loadMatchingFeature(l,{bucketIndex:i,sourceLayerIndex:r,featureIndex:n,layoutVertexArrayOffset:0},c,o,s,a,e);return l}loadFeature(t){const{featureIndex:e,sourceLayerIndex:i}=t;this.loadVTLayers();const r=this.sourceLayerCoder.decode(i),n=this.vtFeatures[r];if(n[e])return n[e];const o=this.vtLayers[r].feature(e);return n[e]=o,o}hasLayer(t){for(const e of this.bucketLayerIDs)for(const i of e)if(t===i)return !0;return !1}getId(t,e){let i=t.id;if(this.promoteId){const r="string"==typeof this.promoteId?this.promoteId:this.promoteId[e];null!=r&&(i=t.properties[r]),"boolean"==typeof i&&(i=Number(i));}return i}}function Nm(t,e,i,r,n){return q(t,((t,o)=>{const s=e instanceof aa?e.get(o):null;return s&&s.evaluate?s.evaluate(i,r,n):s}))}function Um(t,e){return e-t}Ss(Fm,"FeatureIndex",{omit:["rawTileData","sourceLayerCoder"]});const Vm=_a([{name:"a_pos_offset",components:4,type:"Int16"},{name:"a_tex_size",components:4,type:"Uint16"},{name:"a_pixeloffset",components:4,type:"Int16"}],4),jm=_a([{name:"a_globe_anchor",components:3,type:"Int16"},{name:"a_globe_normal",components:3,type:"Float32"}],4),Gm=_a([{name:"a_projected_pos",components:4,type:"Float32"}],4);_a([{name:"a_fade_opacity",components:1,type:"Uint32"}],4);const qm=_a([{name:"a_z_offset",components:1,type:"Float32"}],4),Zm=_a([{name:"a_texb",components:2,type:"Uint16"}]),$m=_a([{name:"a_placed",components:2,type:"Uint8"},{name:"a_shift",components:2,type:"Float32"}]),Hm=_a([{name:"a_size_scale",components:1,type:"Float32"},{name:"a_padding",components:2,type:"Float32"}]);_a([{type:"Int16",name:"projectedAnchorX"},{type:"Int16",name:"projectedAnchorY"},{type:"Int16",name:"projectedAnchorZ"},{type:"Int16",name:"tileAnchorX"},{type:"Int16",name:"tileAnchorY"},{type:"Float32",name:"x1"},{type:"Float32",name:"y1"},{type:"Float32",name:"x2"},{type:"Float32",name:"y2"},{type:"Int16",name:"padding"},{type:"Uint32",name:"featureIndex"},{type:"Uint16",name:"sourceLayerIndex"},{type:"Uint16",name:"bucketIndex"}]);const Wm=_a([{name:"a_pos",components:3,type:"Int16"},{name:"a_anchor_pos",components:2,type:"Int16"},{name:"a_extrude",components:2,type:"Int16"}],4),Xm=_a([{name:"a_pos_2f",components:2,type:"Float32"},{name:"a_radius",components:1,type:"Float32"},{name:"a_flags",components:2,type:"Int16"}],4);_a([{name:"triangle",components:3,type:"Uint16"}]),_a([{type:"Int16",name:"projectedAnchorX"},{type:"Int16",name:"projectedAnchorY"},{type:"Int16",name:"projectedAnchorZ"},{type:"Float32",name:"tileAnchorX"},{type:"Float32",name:"tileAnchorY"},{type:"Uint16",name:"glyphStartIndex"},{type:"Uint16",name:"numGlyphs"},{type:"Uint32",name:"vertexStartIndex"},{type:"Uint32",name:"lineStartIndex"},{type:"Uint32",name:"lineLength"},{type:"Uint16",name:"segment"},{type:"Uint16",name:"lowerSize"},{type:"Uint16",name:"upperSize"},{type:"Float32",name:"lineOffsetX"},{type:"Float32",name:"lineOffsetY"},{type:"Uint8",name:"writingMode"},{type:"Uint8",name:"placedOrientation"},{type:"Uint8",name:"hidden"},{type:"Uint32",name:"crossTileID"},{type:"Int16",name:"associatedIconIndex"},{type:"Uint8",name:"flipState"}]),_a([{type:"Float32",name:"tileAnchorX"},{type:"Float32",name:"tileAnchorY"},{type:"Int16",name:"projectedAnchorX"},{type:"Int16",name:"projectedAnchorY"},{type:"Int16",name:"projectedAnchorZ"},{type:"Int16",name:"rightJustifiedTextSymbolIndex"},{type:"Int16",name:"centerJustifiedTextSymbolIndex"},{type:"Int16",name:"leftJustifiedTextSymbolIndex"},{type:"Int16",name:"verticalPlacedTextSymbolIndex"},{type:"Int16",name:"placedIconSymbolIndex"},{type:"Int16",name:"verticalPlacedIconSymbolIndex"},{type:"Uint16",name:"key"},{type:"Uint16",name:"textBoxStartIndex"},{type:"Uint16",name:"textBoxEndIndex"},{type:"Uint16",name:"verticalTextBoxStartIndex"},{type:"Uint16",name:"verticalTextBoxEndIndex"},{type:"Uint16",name:"iconBoxStartIndex"},{type:"Uint16",name:"iconBoxEndIndex"},{type:"Uint16",name:"verticalIconBoxStartIndex"},{type:"Uint16",name:"verticalIconBoxEndIndex"},{type:"Uint16",name:"featureIndex"},{type:"Uint16",name:"numHorizontalGlyphVertices"},{type:"Uint16",name:"numVerticalGlyphVertices"},{type:"Uint16",name:"numIconVertices"},{type:"Uint16",name:"numVerticalIconVertices"},{type:"Uint16",name:"useRuntimeCollisionCircles"},{type:"Uint32",name:"crossTileID"},{type:"Float32",components:2,name:"textOffset"},{type:"Float32",name:"collisionCircleDiameter"},{type:"Float32",name:"zOffset"},{type:"Uint8",name:"hasIconTextFit"}]),_a([{type:"Float32",name:"offsetX"}]),_a([{type:"Int16",name:"x"},{type:"Int16",name:"y"}]);var Ym=24;const Km=128;function Jm(t,e){const{expression:i}=e;if("constant"===i.kind)return {kind:"constant",layoutSize:i.evaluate(new Qs(t+1))};if("source"===i.kind)return {kind:"source"};{const{zoomStops:e,interpolationType:r}=i;let n=0;for(;n<e.length&&e[n]<=t;)n++;n=Math.max(0,n-1);let o=n;for(;o<e.length&&e[o]<t+1;)o++;o=Math.min(e.length-1,o);const s=e[n],a=e[o];return "composite"===i.kind?{kind:"composite",minZoom:s,maxZoom:a,interpolationType:r}:{kind:"camera",minZoom:s,maxZoom:a,minSize:i.evaluate(new Qs(s)),maxSize:i.evaluate(new Qs(a)),interpolationType:r}}}function Qm(t,{uSize:e,uSizeT:i},{lowerSize:r,upperSize:n}){return "source"===t.kind?r/Km:"composite"===t.kind?Wr(r/Km,n/Km,i):e}function t_(t,e){let i=0,r=0;if("constant"===t.kind)r=t.layoutSize;else if("source"!==t.kind){const{interpolationType:n,minZoom:o,maxZoom:s}=t,a=n?z(gn.interpolationFactor(n,e,o,s),0,1):0;"camera"===t.kind?r=Wr(t.minSize,t.maxSize,a):i=a;}return {uSizeT:i,uSize:r}}var e_=Object.freeze({__proto__:null,SIZE_PACK_FACTOR:Km,evaluateSizeForFeature:Qm,evaluateSizeForZoom:t_,getSizeData:Jm});function i_(t,e,i){return t.sections.forEach((t=>{t.text=function(t,e,i){const r=e.layout.get("text-transform").evaluate(i,{});return "uppercase"===r?t=t.toLocaleUpperCase():"lowercase"===r&&(t=t.toLocaleLowerCase()),Js.applyArabicShaping&&(t=Js.applyArabicShaping(t)),t}(t.text,e,i);})),t}const r_={"!":"︕","#":"＃",$:"＄","%":"％","&":"＆","(":"︵",")":"︶","*":"＊","+":"＋",",":"︐","-":"︲",".":"・","/":"／",":":"︓",";":"︔","<":"︿","=":"＝",">":"﹀","?":"︖","@":"＠","[":"﹇","\\":"＼","]":"﹈","^":"＾",_:"︳","`":"｀","{":"︷","|":"―","}":"︸","~":"～","¢":"￠","£":"￡","¥":"￥","¦":"￤","¬":"￢","¯":"￣","–":"︲","—":"︱","‘":"﹃","’":"﹄","“":"﹁","”":"﹂","…":"︙","‧":"・","₩":"￦","、":"︑","。":"︒","〈":"︿","〉":"﹀","《":"︽","》":"︾","「":"﹁","」":"﹂","『":"﹃","』":"﹄","【":"︻","】":"︼","〔":"︹","〕":"︺","〖":"︗","〗":"︘","！":"︕","（":"︵","）":"︶","，":"︐","－":"︲","．":"・","：":"︓","；":"︔","＜":"︿","＞":"﹀","？":"︖","［":"﹇","］":"﹈","＿":"︳","｛":"︷","｜":"―","｝":"︸","｟":"︵","｠":"︶","｡":"︒","｢":"﹁","｣":"﹂","←":"↑","→":"↓"};function n_(t){return "︶"===t||"﹈"===t||"︸"===t||"﹄"===t||"﹂"===t||"︾"===t||"︼"===t||"︺"===t||"︘"===t||"﹀"===t||"︐"===t||"︓"===t||"︔"===t||"｀"===t||"￣"===t||"︑"===t||"︒"===t}function o_(t){return "︵"===t||"﹇"===t||"︷"===t||"﹃"===t||"﹁"===t||"︽"===t||"︻"===t||"︹"===t||"︗"===t||"︿"===t}const s_=3;function a_(t,e,i){e.glyphs=[],1===t&&i.readMessage(l_,e);}function l_(t,e,i){if(3===t){const{id:t,bitmap:r,width:n,height:o,left:s,top:a,advance:l}=i.readMessage(c_,{});e.glyphs.push({id:t,bitmap:new Fp({width:n+2*s_,height:o+2*s_},r),metrics:{width:n,height:o,left:s,top:a,advance:l}});}else 4===t?e.ascender=i.readSVarint():5===t&&(e.descender=i.readSVarint());}function c_(t,e,i){1===t?e.id=i.readVarint():2===t?e.bitmap=i.readBytes():3===t?e.width=i.readVarint():4===t?e.height=i.readVarint():5===t?e.left=i.readSVarint():6===t?e.top=i.readSVarint():7===t&&(e.advance=i.readVarint());}const h_=s_;function u_(t){let e=0,i=0;for(const r of t)e+=r.w*r.h,i=Math.max(i,r.w);t.sort(((t,e)=>e.h-t.h));const r=[{x:0,y:0,w:Math.max(Math.ceil(Math.sqrt(e/.95)),i),h:1/0}];let n=0,o=0;for(const e of t)for(let t=r.length-1;t>=0;t--){const i=r[t];if(!(e.w>i.w||e.h>i.h)){if(e.x=i.x,e.y=i.y,o=Math.max(o,e.y+e.h),n=Math.max(n,e.x+e.w),e.w===i.w&&e.h===i.h){const e=r.pop();t<r.length&&(r[t]=e);}else e.h===i.h?(i.x+=e.w,i.w-=e.w):e.w===i.w?(i.y+=e.h,i.h-=e.h):(r.push({x:i.x+e.w,y:i.y,w:i.w-e.w,h:e.h}),i.y+=e.h,i.h-=e.h);break}}return {w:n,h:o,fill:e/(n*o)||0}}const d_=1;class p_{constructor(t,{pixelRatio:e,version:i,stretchX:r,stretchY:n,content:o}){this.paddedRect=t,this.pixelRatio=e,this.stretchX=r,this.stretchY=n,this.content=o,this.version=i;}get tl(){return [this.paddedRect.x+d_,this.paddedRect.y+d_]}get br(){return [this.paddedRect.x+this.paddedRect.w-d_,this.paddedRect.y+this.paddedRect.h-d_]}get displaySize(){return [(this.paddedRect.w-2*d_)/this.pixelRatio,(this.paddedRect.h-2*d_)/this.pixelRatio]}}class f_{constructor(t,e){const i={},r={};this.haveRenderCallbacks=[];const n=[];this.addImages(t,i,n),this.addImages(e,r,n);const{w:o,h:s}=u_(n),a=new Np({width:o||1,height:s||1});for(const e in t){const r=t[e],n=i[e].paddedRect;Np.copy(r.data,a,{x:0,y:0},{x:n.x+d_,y:n.y+d_},r.data);}for(const t in e){const i=e[t],n=r[t].paddedRect,o=n.x+d_,s=n.y+d_,l=i.data.width,c=i.data.height;Np.copy(i.data,a,{x:0,y:0},{x:o,y:s},i.data),Np.copy(i.data,a,{x:0,y:c-1},{x:o,y:s-1},{width:l,height:1}),Np.copy(i.data,a,{x:0,y:0},{x:o,y:s+c},{width:l,height:1}),Np.copy(i.data,a,{x:l-1,y:0},{x:o-1,y:s},{width:1,height:c}),Np.copy(i.data,a,{x:0,y:0},{x:o+l,y:s},{width:1,height:c});}this.image=a,this.iconPositions=i,this.patternPositions=r;}addImages(t,e,i){for(const r in t){const n=t[r],o={x:0,y:0,w:n.data.width+2*d_,h:n.data.height+2*d_};i.push(o),e[r]=new p_(o,n),n.hasRenderCallback&&this.haveRenderCallbacks.push(r);}}patchUpdatedImages(t,e,i){this.haveRenderCallbacks=this.haveRenderCallbacks.filter((e=>t.hasImage(e,i))),t.dispatchRenderCallbacks(this.haveRenderCallbacks,i);for(const r in t.getUpdatedImages(i))this.patchUpdatedImage(this.iconPositions[r],t.getImage(r,i),e),this.patchUpdatedImage(this.patternPositions[r],t.getImage(r,i),e);}patchUpdatedImage(t,e,i){if(!t||!e)return;if(t.version===e.version)return;t.version=e.version;const[r,n]=t.tl;i.update(e.data,void 0,{x:r,y:n});}}Ss(p_,"ImagePosition"),Ss(f_,"ImageAtlas");const m_={horizontal:1,vertical:2,horizontalOnly:3},__=-17;class g_{constructor(){this.scale=1,this.fontStack="",this.imageName=null;}static forText(t,e){const i=new g_;return i.scale=t||1,i.fontStack=e,i}static forImage(t){const e=new g_;return e.imageName=t,e}}class y_{constructor(){this.text="",this.sectionIndex=[],this.sections=[],this.imageSectionID=null;}static fromFeature(t,e){const i=new y_;for(let r=0;r<t.sections.length;r++){const n=t.sections[r];n.image?i.addImageSection(n):i.addTextSection(n,e);}return i}length(){return this.text.length}getSection(t){return this.sections[this.sectionIndex[t]]}getSections(){return this.sections}getSectionIndex(t){return this.sectionIndex[t]}getCodePoint(t){return this.text.codePointAt(t)}verticalizePunctuation(t){this.text=function(t,e){let i="";for(let r=0;r<t.length;r++){const n=t.charCodeAt(r+1)||null,o=t.charCodeAt(r-1)||null;i+=!e&&(n&&Os(n)&&!r_[t[r+1]]||o&&Os(o)&&!r_[t[r-1]])||!r_[t[r]]?t[r]:r_[t[r]];}return i}(this.text,t);}trim(){let t=0;for(let e=0;e<this.text.length&&v_[this.text.charCodeAt(e)];e++)t++;let e=this.text.length;for(let i=this.text.length-1;i>=0&&i>=t&&v_[this.text.charCodeAt(i)];i--)e--;this.text=this.text.substring(t,e),this.sectionIndex=this.sectionIndex.slice(t,e);}substring(t,e){const i=new y_;return i.text=this.text.substring(t,e),i.sectionIndex=this.sectionIndex.slice(t,e),i.sections=this.sections,i}toString(){return this.text}getMaxScale(){return this.sectionIndex.reduce(((t,e)=>Math.max(t,this.sections[e].scale)),0)}addTextSection(t,e){this.text+=t.text,this.sections.push(g_.forText(t.scale,t.fontStack||e));const i=this.sections.length-1;for(let e=0;e<t.text.length;++e)this.sectionIndex.push(i);}addImageSection(t){const e=t.image?t.image.namePrimary:"";if(0===e.length)return void W("Can't add FormattedSection with an empty image.");const i=this.getNextImageSectionCharCode();i?(this.text+=String.fromCodePoint(i),this.sections.push(g_.forImage(e)),this.sectionIndex.push(this.sections.length-1)):W("Reached maximum number of images 6401");}getNextImageSectionCharCode(){return this.imageSectionID?this.imageSectionID>=63743?null:++this.imageSectionID:(this.imageSectionID=57344,this.imageSectionID)}}function x_(t,e,i,r,n,o,s,a,l,c,h,u,d,p,f){const m=y_.fromFeature(t,n);u===m_.vertical&&m.verticalizePunctuation(d);let _=[];const g=function(t,e,i,r,n,o){if(!t)return [];const s=[],a=function(t,e,i,r,n,o){let s=0;for(let i=0;i<t.length();i++){const a=t.getSection(i);s+=w_(t.getCodePoint(i),a,r,n,e,o);}return s/Math.max(1,Math.ceil(s/i))}(t,e,i,r,n,o),l=t.text.indexOf("​")>=0;let c=0;for(let i=0;i<t.length();i++){const u=t.getSection(i),d=t.getCodePoint(i);if(v_[d]||(c+=w_(d,u,r,n,e,o)),i<t.length()-1){const e=!((h=d)<11904||!(Ps["Bopomofo Extended"](h)||Ps.Bopomofo(h)||Ps["CJK Compatibility Forms"](h)||Ps["CJK Compatibility Ideographs"](h)||Ps["CJK Compatibility"](h)||Ps["CJK Radicals Supplement"](h)||Ps["CJK Strokes"](h)||Ps["CJK Symbols and Punctuation"](h)||Ps["CJK Unified Ideographs Extension A"](h)||Ps["CJK Unified Ideographs"](h)||Ps["Enclosed CJK Letters and Months"](h)||Ps["Halfwidth and Fullwidth Forms"](h)||Ps.Hiragana(h)||Ps["Ideographic Description Characters"](h)||Ps["Kangxi Radicals"](h)||Ps["Katakana Phonetic Extensions"](h)||Ps.Katakana(h)||Ps["Vertical Forms"](h)||Ps["Yi Radicals"](h)||Ps["Yi Syllables"](h)));(b_[d]||e||u.imageName)&&s.push(M_(i+1,c,a,s,E_(d,t.getCodePoint(i+1),e&&l),!1));}}var h;return A_(M_(t.length(),c,a,s,0,!0))}(m,c,o,e,r,p),{processBidirectionalText:y,processStyledBidirectionalText:x}=Js;if(y&&1===m.sections.length){const t=y(m.toString(),g);for(const e of t){const t=new y_;t.text=e,t.sections=m.sections;for(let i=0;i<e.length;i++)t.sectionIndex.push(0);_.push(t);}}else if(x){const t=x(m.text,m.sectionIndex,g);for(const e of t){const t=new y_;t.text=e[0],t.sectionIndex=e[1],t.sections=m.sections,_.push(t);}}else _=function(t,e){const i=[],r=t.text;let n=0;for(const r of e)i.push(t.substring(n,r)),n=r;return n<r.length&&i.push(t.substring(n,r.length)),i}(m,g);const v=[],b={positionedLines:v,text:m.toString(),top:h[1],bottom:h[1],left:h[0],right:h[0],writingMode:u,iconsInText:!1,verticalizable:!1,hasBaseline:!1};return function(t,e,i,r,n,o,s,a,l,c,h,u){let d=0,p=0,f=0;const m="right"===a?1:"left"===a?0:.5;let _=!1;for(const t of n){const i=t.getSections();for(const t of i){if(t.imageName)continue;const i=e[t.fontStack];if(i&&(_=void 0!==i.ascender&&void 0!==i.descender,!_))break}if(!_)break}let g=0;for(const s of n){s.trim();const n=s.getMaxScale(),a=(n-1)*Ym,x={positionedGlyphs:[],lineOffset:0};t.positionedLines[g]=x;const v=x.positionedGlyphs;let b=0;if(!s.length()){p+=o,++g;continue}let w=0,T=0;for(let o=0;o<s.length();o++){const a=s.getSection(o),f=s.getSectionIndex(o),m=s.getCodePoint(o);let g=a.scale,x=null,E=null,M=null,A=Ym,S=0;const I=!(l===m_.horizontal||!h&&!Bs(m)||h&&(v_[m]||(y=m,Ps.Arabic(y)||Ps["Arabic Supplement"](y)||Ps["Arabic Extended-A"](y)||Ps["Arabic Presentation Forms-A"](y)||Ps["Arabic Presentation Forms-B"](y))));if(a.imageName){const e=r[a.imageName];if(!e)continue;M=a.imageName,t.iconsInText=t.iconsInText||!0,E=e.paddedRect;const i=e.displaySize;g=g*Ym/u,x={width:i[0],height:i[1],left:d_,top:-h_,advance:I?i[1]:i[0],localGlyph:!1},S=_?-x.height*g:__+n*Ym-i[1]*g,A=x.advance;const o=(I?i[0]:i[1])*g-Ym*n;o>0&&o>b&&(b=o);}else {const t=i[a.fontStack];if(!t)continue;t[m]&&(E=t[m]);const r=e[a.fontStack];if(!r)continue;const o=r.glyphs[m];if(!o)continue;if(x=o.metrics,A=8203!==m?Ym:0,_){const t=void 0!==r.ascender?Math.abs(r.ascender):0,e=void 0!==r.descender?Math.abs(r.descender):0,i=(t+e)*g;w<i&&(w=i,T=(t-e)/2*g),S=-t*g;}else S=__+(n-g)*Ym;}I?(t.verticalizable=!0,v.push({glyph:m,imageName:M,x:d,y:p+S,vertical:I,scale:g,localGlyph:x.localGlyph,fontStack:a.fontStack,sectionIndex:f,metrics:x,rect:E}),d+=A*g+c):(v.push({glyph:m,imageName:M,x:d,y:p+S,vertical:I,scale:g,localGlyph:x.localGlyph,fontStack:a.fontStack,sectionIndex:f,metrics:x,rect:E}),d+=x.advance*g+c);}0!==v.length&&(f=Math.max(d-c,f),_?I_(v,m,b,T,o*n/2):I_(v,m,b,0,o/2)),d=0;const E=o*n+b;x.lineOffset=Math.max(b,a),p+=E,++g;}var y;const x=p,{horizontalAlign:v,verticalAlign:b}=S_(s);((function(t,e,i,r,n,o){const s=(e-i)*n,a=-o*r;for(const e of t)for(const t of e.positionedGlyphs)t.x+=s,t.y+=a;}))(t.positionedLines,m,v,b,f,x),t.top+=-b*x,t.bottom=t.top+x,t.left+=-v*f,t.right=t.left+f,t.hasBaseline=_;}(b,e,i,r,_,s,a,l,u,c,d,f),!function(t){for(const e of t)if(0!==e.positionedGlyphs.length)return !1;return !0}(v)&&b}const v_={9:!0,10:!0,11:!0,12:!0,13:!0,32:!0},b_={10:!0,32:!0,38:!0,40:!0,41:!0,43:!0,45:!0,47:!0,173:!0,183:!0,8203:!0,8208:!0,8211:!0,8231:!0};function w_(t,e,i,r,n,o){if(e.imageName){const t=r[e.imageName];return t?t.displaySize[0]*e.scale*Ym/o+n:0}{const r=i[e.fontStack],o=r&&r.glyphs[t];return o?o.metrics.advance*e.scale+n:0}}function T_(t,e,i,r){const n=Math.pow(t-e,2);return r?t<e?n/2:2*n:n+Math.abs(i)*i}function E_(t,e,i){let r=0;return 10===t&&(r-=1e4),i&&(r+=150),40!==t&&65288!==t||(r+=50),41!==e&&65289!==e||(r+=50),r}function M_(t,e,i,r,n,o){let s=null,a=T_(e,i,n,o);for(const t of r){const r=T_(e-t.x,i,n,o)+t.badness;r<=a&&(s=t,a=r);}return {index:t,x:e,priorBreak:s,badness:a}}function A_(t){return t?A_(t.priorBreak).concat(t.index):[]}function S_(t){let e=.5,i=.5;switch(t){case"right":case"top-right":case"bottom-right":e=1;break;case"left":case"top-left":case"bottom-left":e=0;}switch(t){case"bottom":case"bottom-right":case"bottom-left":i=1;break;case"top":case"top-right":case"top-left":i=0;}return {horizontalAlign:e,verticalAlign:i}}function I_(t,e,i,r,n){if(!(e||i||r||n))return;const o=t.length-1,s=t[o],a=(s.x+s.metrics.advance*s.scale)*e;for(let e=0;e<=o;e++)t[e].x-=a,t[e].y+=i+r+n;}function C_(t,e,i,r){const{horizontalAlign:n,verticalAlign:o}=S_(r),s=i[0]-t.displaySize[0]*n,a=i[1]-t.displaySize[1]*o;return {imagePrimary:t,imageSecondary:e,top:a,bottom:a+t.displaySize[1],left:s,right:s+t.displaySize[0]}}function z_(t,e,i,r,n,o){const s=t.imagePrimary;let a;if(s.content){const t=s.content,e=s.pixelRatio||1;a=[t[0]/e,t[1]/e,s.displaySize[0]-t[2]/e,s.displaySize[1]-t[3]/e];}const l=e.left*o,c=e.right*o;let h,u,d,p;"width"===i||"both"===i?(p=n[0]+l-r[3],u=n[0]+c+r[1]):(p=n[0]+(l+c-s.displaySize[0])/2,u=p+s.displaySize[0]);const f=e.top*o,m=e.bottom*o;return "height"===i||"both"===i?(h=n[1]+f-r[0],d=n[1]+m+r[2]):(h=n[1]+(f+m-s.displaySize[1])/2,d=h+s.displaySize[1]),{imagePrimary:s,imageSecondary:void 0,top:h,right:u,bottom:d,left:p,collisionPadding:a}}class D_ extends y{constructor(t,e,i,r,n){super(t,e),this.angle=r,this.z=i,void 0!==n&&(this.segment=n);}clone(){return new D_(this.x,this.y,this.z,this.angle,this.segment)}}function P_(t,e,i,r,n){if(void 0===e.segment)return !0;let o=e,s=e.segment+1,a=0;for(;a>-i/2;){if(s--,s<0)return !1;a-=t[s].dist(o),o=t[s];}a+=t[s].dist(t[s+1]),s++;const l=[];let c=0;for(;a<i/2;){const e=t[s],i=t[s+1];if(!i)return !1;let o=t[s-1].angleTo(e)-e.angleTo(i);for(o=Math.abs((o+3*Math.PI)%(2*Math.PI)-Math.PI),l.push({distance:a,angleDelta:o}),c+=o;a-l[0].distance>r;)c-=l.shift().angleDelta;if(c>n)return !1;s++,a+=e.dist(i);}return !0}function R_(t){let e=0;for(let i=0;i<t.length-1;i++)e+=t[i].dist(t[i+1]);return e}function L_(t,e,i){return t?.6*e*i:0}function k_(t,e){return Math.max(t?t.right-t.left:0,e?e.right-e.left:0)}function B_(t,e,i,r,n,o){const s=L_(i,n,o),a=k_(i,r)*o;let l=0;const c=R_(t)/2;for(let i=0;i<t.length-1;i++){const r=t[i],n=t[i+1],o=r.dist(n);if(l+o>c){const h=(c-l)/o,u=Wr(r.x,n.x,h),d=Wr(r.y,n.y,h),p=new D_(u,d,0,n.angleTo(r),i);return !s||P_(t,p,a,s,e)?p:void 0}l+=o;}}function O_(t,e,i,r,n,o,s,a,l){const c=L_(r,o,s),h=k_(r,n),u=h*s,d=0===t[0].x||t[0].x===l||0===t[0].y||t[0].y===l;return e-u<e/4&&(e=u+e/4),F_(t,d?e/2*a%e:(h/2+2*o)*s*a%e,e,c,i,u,d,!1,l)}function F_(t,e,i,r,n,o,s,a,l){const c=o/2,h=R_(t);let u=0,d=e-i,p=[];for(let e=0;e<t.length-1;e++){const s=t[e],a=t[e+1],f=s.dist(a),m=a.angleTo(s);for(;d+i<u+f;){d+=i;const _=(d-u)/f,g=Wr(s.x,a.x,_),y=Wr(s.y,a.y,_);if(g>=0&&g<l&&y>=0&&y<l&&d-c>=0&&d+c<=h){const i=new D_(g,y,0,m,e);i._round(),r&&!P_(t,i,o,r,n)||p.push(i);}}u+=f;}return a||p.length||s||(p=F_(t,u/2,i,r,n,o,s,!0,l)),p}function N_(t,e,i,r,n){const o=[];for(let s=0;s<t.length;s++){const a=t[s];let l;for(let t=0;t<a.length-1;t++){let s=a[t],c=a[t+1];s.x<e&&c.x<e||(s.x<e?s=new y(e,s.y+(e-s.x)/(c.x-s.x)*(c.y-s.y))._round():c.x<e&&(c=new y(e,s.y+(e-s.x)/(c.x-s.x)*(c.y-s.y))._round()),s.y<i&&c.y<i||(s.y<i?s=new y(s.x+(i-s.y)/(c.y-s.y)*(c.x-s.x),i)._round():c.y<i&&(c=new y(s.x+(i-s.y)/(c.y-s.y)*(c.x-s.x),i)._round()),s.x>=r&&c.x>=r||(s.x>=r?s=new y(r,s.y+(r-s.x)/(c.x-s.x)*(c.y-s.y))._round():c.x>=r&&(c=new y(r,s.y+(r-s.x)/(c.x-s.x)*(c.y-s.y))._round()),s.y>=n&&c.y>=n||(s.y>=n?s=new y(s.x+(n-s.y)/(c.y-s.y)*(c.x-s.x),n)._round():c.y>=n&&(c=new y(s.x+(n-s.y)/(c.y-s.y)*(c.x-s.x),n)._round()),l&&s.equals(l[l.length-1])||(l=[s],o.push(l)),l.push(c)))));}}return o}Ss(D_,"Anchor");const U_=1e20;function V_(t,e,i,r,n,o,s,a,l){for(let c=e;c<e+r;c++)j_(t,i*o+c,o,n,s,a,l);for(let c=i;c<i+n;c++)j_(t,c*o+e,1,r,s,a,l);}function j_(t,e,i,r,n,o,s){o[0]=0,s[0]=-U_,s[1]=U_,n[0]=t[e];for(let a=1,l=0,c=0;a<r;a++){n[a]=t[e+a*i];const r=a*a;do{const t=o[l];c=(n[a]-n[t]+r-t*t)/(a-t)/2;}while(c<=s[l]&&--l>-1);l++,o[l]=a,s[l]=c,s[l+1]=U_;}for(let a=0,l=0;a<r;a++){for(;s[l+1]<a;)l++;const r=o[l],c=a-r;t[e+a*i]=n[r]+c*c;}}const G_=2;class q_{constructor(t,e,i){this.requestManager=t,this.localGlyphMode=e,this.localFontFamily=i,this.urls={},this.entries={},this.localGlyphs={200:{},400:{},500:{},900:{}};}setURL(t,e){this.urls[e]=t;}getGlyphs(t,e,i){const r=[],o=this.urls[e]||n.GLYPHS_URL;for(const e in t)for(const i of t[e])r.push({stack:e,id:i});R(r,(({stack:t,id:e},i)=>{let r=this.entries[t];r||(r=this.entries[t]={glyphs:{},requests:{},ranges:{},ascender:void 0,descender:void 0});let n=r.glyphs[e];if(void 0!==n)return void i(null,{stack:t,id:e,glyph:n});if(n=this._tinySDF(r,t,e),n)return r.glyphs[e]=n,void i(null,{stack:t,id:e,glyph:n});const s=Math.floor(e/256);if(256*s>65535)return void i(new Error("glyphs > 65535 not supported"));if(r.ranges[s])return void i(null,{stack:t,id:e,glyph:n});let a=r.requests[s];a||(a=r.requests[s]=[],q_.loadGlyphRange(t,s,o,this.requestManager,((t,e)=>{if(e){r.ascender=e.ascender,r.descender=e.descender;for(const t in e.glyphs)this._doesCharSupportLocalGlyph(+t)||(r.glyphs[+t]=e.glyphs[+t]);r.ranges[s]=!0;}for(const i of a)i(t,e);delete r.requests[s];}))),a.push(((r,n)=>{r?i(r):n&&i(null,{stack:t,id:e,glyph:n.glyphs[e]||null});}));}),((t,e)=>{if(t)i(t);else if(e){const t={};for(const{stack:i,id:r,glyph:n}of e)void 0===t[i]&&(t[i]={}),void 0===t[i].glyphs&&(t[i].glyphs={}),t[i].glyphs[r]=n&&{id:n.id,bitmap:n.bitmap.clone(),metrics:n.metrics},t[i].ascender=this.entries[i].ascender,t[i].descender=this.entries[i].descender;i(null,t);}}));}_doesCharSupportLocalGlyph(t){return 0!==this.localGlyphMode&&(2===this.localGlyphMode?!!this.localFontFamily:!!this.localFontFamily&&(Ps["CJK Unified Ideographs"](t)||Ps["Hangul Syllables"](t)||Ps.Hiragana(t)||Ps.Katakana(t)||Ps["CJK Symbols and Punctuation"](t)||Ps["CJK Unified Ideographs Extension A"](t)||Ps["CJK Unified Ideographs Extension B"](t)))}_tinySDF(t,e,i){const r=this.localFontFamily;if(!r||!this._doesCharSupportLocalGlyph(i))return;let n=t.tinySDF;if(!n){let i="400";/bold/i.test(e)?i="900":/medium/i.test(e)?i="500":/light/i.test(e)&&(i="200"),n=t.tinySDF=new q_.TinySDF({fontFamily:r,fontWeight:i,fontSize:24*G_,buffer:3*G_,radius:8*G_}),n.fontWeight=i;}if(this.localGlyphs[n.fontWeight][i])return this.localGlyphs[n.fontWeight][i];const o=String.fromCodePoint(i),{data:s,width:a,height:l,glyphWidth:c,glyphHeight:h,glyphLeft:u,glyphTop:d,glyphAdvance:p}=n.draw(o);return this.localGlyphs[n.fontWeight][i]={id:i,bitmap:new Fp({width:a,height:l},s),metrics:{width:c/G_,height:h/G_,left:u/G_,top:d/G_-27,advance:p/G_,localGlyph:!0}}}}q_.loadGlyphRange=function(t,e,i,r,n){const o=256*e,s=o+255,a=r.transformRequest(r.normalizeGlyphsURL(i).replace("{fontstack}",t).replace("{range}",`${o}-${s}`),xt.Glyphs);Et(a,((t,e)=>{if(t)n(t);else if(e){const t={},i=function(t){return new vm(t).readFields(a_,{})}(e);for(const e of i.glyphs)t[e.id]=e;n(null,{glyphs:t,ascender:i.ascender,descender:i.descender});}}));},q_.TinySDF=class{constructor({fontSize:t=24,buffer:e=3,radius:i=8,cutoff:r=.25,fontFamily:n="sans-serif",fontWeight:o="normal",fontStyle:s="normal"}={}){this.buffer=e,this.cutoff=r,this.radius=i;const a=this.size=t+4*e,l=this._createCanvas(a),c=this.ctx=l.getContext("2d",{willReadFrequently:!0});c.font=`${s} ${o} ${t}px ${n}`,c.textBaseline="alphabetic",c.textAlign="left",c.fillStyle="black",this.gridOuter=new Float64Array(a*a),this.gridInner=new Float64Array(a*a),this.f=new Float64Array(a),this.z=new Float64Array(a+1),this.v=new Uint16Array(a);}_createCanvas(t){const e=document.createElement("canvas");return e.width=e.height=t,e}draw(t){const{width:e,actualBoundingBoxAscent:i,actualBoundingBoxDescent:r,actualBoundingBoxLeft:n,actualBoundingBoxRight:o}=this.ctx.measureText(t),s=Math.ceil(i),a=Math.max(0,Math.min(this.size-this.buffer,Math.ceil(o-n))),l=Math.min(this.size-this.buffer,s+Math.ceil(r)),c=a+2*this.buffer,h=l+2*this.buffer,u=Math.max(c*h,0),d=new Uint8ClampedArray(u),p={data:d,width:c,height:h,glyphWidth:a,glyphHeight:l,glyphTop:s,glyphLeft:0,glyphAdvance:e};if(0===a||0===l)return p;const{ctx:f,buffer:m,gridInner:_,gridOuter:g}=this;f.clearRect(m,m,a,l),f.fillText(t,m,m+s);const y=f.getImageData(m,m,a,l);g.fill(U_,0,u),_.fill(0,0,u);for(let t=0;t<l;t++)for(let e=0;e<a;e++){const i=y.data[4*(t*a+e)+3]/255;if(0===i)continue;const r=(t+m)*c+e+m;if(1===i)g[r]=0,_[r]=U_;else {const t=.5-i;g[r]=t>0?t*t:0,_[r]=t<0?t*t:0;}}V_(g,0,0,c,h,c,this.f,this.v,this.z),V_(_,m,m,a,l,c,this.f,this.v,this.z);for(let t=0;t<u;t++){const e=Math.sqrt(g[t])-Math.sqrt(_[t]);d[t]=Math.round(255-255*(e/this.radius+this.cutoff));}return p}};const Z_=d_;function $_(t,e,i,r){const n=[],o=t.imagePrimary,s=o.pixelRatio,a=o.paddedRect.w-2*Z_,l=o.paddedRect.h-2*Z_,c=t.right-t.left,h=t.bottom-t.top,u=o.stretchX||[[0,a]],d=o.stretchY||[[0,l]],p=(t,e)=>t+e[1]-e[0],f=u.reduce(p,0),m=d.reduce(p,0),_=a-f,g=l-m;let x=0,v=f,b=0,w=m,T=0,E=_,M=0,A=g;if(o.content&&r){const t=o.content;x=H_(u,0,t[0]),b=H_(d,0,t[1]),v=H_(u,t[0],t[2]),w=H_(d,t[1],t[3]),T=t[0]-x,M=t[1]-b,E=t[2]-t[0]-v,A=t[3]-t[1]-w;}const S=(r,n,a,l)=>{const u=X_(r.stretch-x,v,c,t.left),d=Y_(r.fixed-T,E,r.stretch,f),p=X_(n.stretch-b,w,h,t.top),_=Y_(n.fixed-M,A,n.stretch,m),g=X_(a.stretch-x,v,c,t.left),S=Y_(a.fixed-T,E,a.stretch,f),I=X_(l.stretch-b,w,h,t.top),C=Y_(l.fixed-M,A,l.stretch,m),z=new y(u,p),D=new y(g,p),P=new y(g,I),R=new y(u,I),L=new y(d/s,_/s),k=new y(S/s,C/s),B=e*Math.PI/180;if(B){const t=Math.sin(B),e=Math.cos(B),i=[e,-t,t,e];z._matMult(i),D._matMult(i),R._matMult(i),P._matMult(i);}const O=r.stretch+r.fixed,F=a.stretch+a.fixed,N=n.stretch+n.fixed,U=l.stretch+l.fixed,V=t.imageSecondary;return {tl:z,tr:D,bl:R,br:P,texPrimary:{x:o.paddedRect.x+Z_+O,y:o.paddedRect.y+Z_+N,w:F-O,h:U-N},texSecondary:V?{x:V.paddedRect.x+Z_+O,y:V.paddedRect.y+Z_+N,w:F-O,h:U-N}:void 0,writingMode:void 0,glyphOffset:[0,0],sectionIndex:0,pixelOffsetTL:L,pixelOffsetBR:k,minFontScaleX:E/s/c,minFontScaleY:A/s/h,isSDF:i}};if(r&&(o.stretchX||o.stretchY)){const t=W_(u,_,f),e=W_(d,g,m);for(let i=0;i<t.length-1;i++){const r=t[i],o=t[i+1];for(let t=0;t<e.length-1;t++)n.push(S(r,e[t],o,e[t+1]));}}else n.push(S({fixed:0,stretch:-1},{fixed:0,stretch:-1},{fixed:0,stretch:a+1},{fixed:0,stretch:l+1}));return n}function H_(t,e,i){let r=0;for(const n of t)r+=Math.max(e,Math.min(i,n[1]))-Math.max(e,Math.min(i,n[0]));return r}function W_(t,e,i){const r=[{fixed:-Z_,stretch:0}];for(const[e,i]of t){const t=r[r.length-1];r.push({fixed:e-t.stretch,stretch:t.stretch}),r.push({fixed:e-t.stretch,stretch:t.stretch+(i-e)});}return r.push({fixed:e+Z_,stretch:i}),r}function X_(t,e,i,r){return t/e*i+r}function Y_(t,e,i,r){return t-e*i/r}function K_(t,e,i,r){const n=e+t.positionedLines[r].lineOffset;return 0===r?i+n/2:i+(n+(e+t.positionedLines[r-1].lineOffset))/2}function J_(t,e=1,i=!1){let r=1/0,n=1/0,o=-1/0,s=-1/0;const a=t[0];for(let t=0;t<a.length;t++){const e=a[t];(!t||e.x<r)&&(r=e.x),(!t||e.y<n)&&(n=e.y),(!t||e.x>o)&&(o=e.x),(!t||e.y>s)&&(s=e.y);}const l=Math.min(o-r,s-n);let c=l/2;const h=new or([],Q_);if(0===l)return new y(r,n);for(let e=r;e<o;e+=l)for(let i=n;i<s;i+=l)h.push(new tg(e+c,i+c,c,t));let u=function(t){let e=0,i=0,r=0;const n=t[0];for(let t=0,o=n.length,s=o-1;t<o;s=t++){const o=n[t],a=n[s],l=o.x*a.y-a.x*o.y;i+=(o.x+a.x)*l,r+=(o.y+a.y)*l,e+=3*l;}return new tg(i/e,r/e,0,t)}(t),d=h.length;for(;h.length;){const r=h.pop();(r.d>u.d||!u.d)&&(u=r,i&&console.log("found best %d after %d probes",Math.round(1e4*r.d)/1e4,d)),r.max-u.d<=e||(c=r.h/2,h.push(new tg(r.p.x-c,r.p.y-c,c,t)),h.push(new tg(r.p.x+c,r.p.y-c,c,t)),h.push(new tg(r.p.x-c,r.p.y+c,c,t)),h.push(new tg(r.p.x+c,r.p.y+c,c,t)),d+=4);}return i&&(console.log(`num probes: ${d}`),console.log(`best distance: ${u.d}`)),u.p}function Q_(t,e){return e.max-t.max}class tg{constructor(t,e,i,r){this.p=new y(t,e),this.h=i,this.d=function(t,e){let i=!1,r=1/0;for(let n=0;n<e.length;n++){const o=e[n];for(let e=0,n=o.length,s=n-1;e<n;s=e++){const n=o[e],a=o[s];n.y>t.y!=a.y>t.y&&t.x<(a.x-n.x)*(t.y-n.y)/(a.y-n.y)+n.x&&(i=!i),r=Math.min(r,_p(t,n,a));}}return (i?1:-1)*Math.sqrt(r)}(this.p,r),this.max=this.d+this.h*Math.SQRT2;}}const eg=7,ig=Number.POSITIVE_INFINITY,rg=Math.sqrt(2);function ng(t,[e,i]){let r=0,n=0;if(i===ig){e<0&&(e=0);const i=e/rg;switch(t){case"top-right":case"top-left":n=i-eg;break;case"bottom-right":case"bottom-left":n=-i+eg;break;case"bottom":n=-e+eg;break;case"top":n=e-eg;}switch(t){case"top-right":case"bottom-right":r=-i;break;case"top-left":case"bottom-left":r=i;break;case"left":r=e;break;case"right":r=-e;}}else {switch(e=Math.abs(e),i=Math.abs(i),t){case"top-right":case"top-left":case"top":n=i-eg;break;case"bottom-right":case"bottom-left":case"bottom":n=-i+eg;}switch(t){case"top-right":case"bottom-right":case"right":r=-e;break;case"top-left":case"bottom-left":case"left":r=e;}}return [r,n]}function og(t,e,i,r,n,o,s,a,l,c,h){t.createArrays(),t.tilePixelRatio=sr/(512*t.overscaling),t.compareText={},t.iconsNeedLinear=!1;const u=t.layers[0].layout,d=t.layers[0]._unevaluatedLayout._values,p={};if("composite"===t.textSizeData.kind){const{minZoom:e,maxZoom:i}=t.textSizeData;p.compositeTextSizes=[d["text-size"].possiblyEvaluate(new Qs(e),a),d["text-size"].possiblyEvaluate(new Qs(i),a)];}if("composite"===t.iconSizeData.kind){const{minZoom:e,maxZoom:i}=t.iconSizeData;p.compositeIconSizes=[d["icon-size"].possiblyEvaluate(new Qs(e),a),d["icon-size"].possiblyEvaluate(new Qs(i),a)];}p.layoutTextSize=d["text-size"].possiblyEvaluate(new Qs(l+1),a),p.layoutIconSize=d["icon-size"].possiblyEvaluate(new Qs(l+1),a),p.textMaxSize=d["text-size"].possiblyEvaluate(new Qs(18),a);const f="map"===u.get("text-rotation-alignment")&&"point"!==u.get("symbol-placement"),m=u.get("text-size");let _=!1;for(const e of t.features)if(e.icon&&e.icon.nameSecondary){_=!0;break}for(const o of t.features){const l=u.get("text-font").evaluate(o,{},a).join(","),d=m.evaluate(o,{},a),g=p.layoutTextSize.evaluate(o,{},a),y=(p.layoutIconSize.evaluate(o,{},a),{horizontal:{},vertical:void 0}),x=o.text;let v,b=[0,0];if(x){const r=x.toString(),s=u.get("text-letter-spacing").evaluate(o,{},a)*Ym,c=u.get("text-line-height").evaluate(o,{},a)*Ym,h=Ls(r)?s:0,p=u.get("text-anchor").evaluate(o,{},a),m=u.get("text-variable-anchor");if(!m){const t=u.get("text-radial-offset").evaluate(o,{},a);b=t?ng(p,[t*Ym,ig]):u.get("text-offset").evaluate(o,{},a).map((t=>t*Ym));}let _=f?"center":u.get("text-justify").evaluate(o,{},a);const v="point"===u.get("symbol-placement"),w=v?u.get("text-max-width").evaluate(o,{},a)*Ym:1/0,T=o=>{t.allowVerticalPlacement&&Rs(r)&&(y.vertical=x_(x,e,i,n,l,w,c,p,o,h,b,m_.vertical,!0,g,d));};if(!f&&m){const t="auto"===_?m.map((t=>sg(t))):[_];let r=!1;for(let o=0;o<t.length;o++){const s=t[o];if(!y.horizontal[s])if(r)y.horizontal[s]=y.horizontal[0];else {const t=x_(x,e,i,n,l,w,c,"center",s,h,b,m_.horizontal,!1,g,d);t&&(y.horizontal[s]=t,r=1===t.positionedLines.length);}}T("left");}else {if("auto"===_&&(_=sg(p)),v||u.get("text-writing-mode").indexOf("horizontal")>=0||!Rs(r)){const t=x_(x,e,i,n,l,w,c,p,_,h,b,m_.horizontal,!1,g,d);t&&(y.horizontal[_]=t);}T(v?"left":_);}}let w=!1;if(o.icon&&o.icon.namePrimary){const e=r[o.icon.namePrimary];e&&(v=C_(n[o.icon.namePrimary],o.icon.nameSecondary?n[o.icon.nameSecondary]:void 0,u.get("icon-offset").evaluate(o,{},a),u.get("icon-anchor").evaluate(o,{},a)),w=e.sdf,void 0===t.sdfIcons?t.sdfIcons=e.sdf:t.sdfIcons!==e.sdf&&W("Style sheet warning: Cannot mix SDF and non-SDF icons in one buffer"),(e.pixelRatio!==t.pixelRatio||0!==u.get("icon-rotate").constantOr(1))&&(t.iconsNeedLinear=!0));}const T=ug(y.horizontal)||y.vertical;t.iconsInText||(t.iconsInText=!!T&&T.iconsInText),(T||v)&&ag(t,o,y,v,r,p,g,0,b,w,s,a,c,h,_);}o&&t.generateCollisionDebugBuffers(l,t.collisionBoxArray);}function sg(t){switch(t){case"right":case"top-right":case"bottom-right":return "right";case"left":case"top-left":case"bottom-left":return "left"}return "center"}function ag(t,e,i,r,n,o,s,a,l,c,h,u,d,p,f){let m=o.textMaxSize.evaluate(e,{},u);void 0===m&&(m=s);const _=t.layers[0].layout,g=_.get("icon-offset").evaluate(e,{},u),y=ug(i.horizontal)||i.vertical,x="globe"===d.name,v=Ym,b=s/v,T=t.tilePixelRatio*m/v,E=(P=t.overscaling,t.zoom>18&&P>2&&(P>>=1),Math.max(sr/(512*P),1)*_.get("symbol-spacing")),M=_.get("text-padding")*t.tilePixelRatio,A=_.get("icon-padding")*t.tilePixelRatio,S=w(_.get("text-max-angle")),I="map"===_.get("text-rotation-alignment")&&"point"!==_.get("symbol-placement"),C="map"===_.get("icon-rotation-alignment")&&"point"!==_.get("symbol-placement"),z=_.get("symbol-placement"),D=E/2;var P;const R=_.get("icon-text-fit").evaluate(e,{},u),L=_.get("icon-text-fit-padding").evaluate(e,{},u),k="none"!==R;let B;!1===t.hasAnyIconTextFit&&k&&(t.hasAnyIconTextFit=!0),r&&k&&(t.allowVerticalPlacement&&i.vertical&&(B=z_(r,i.vertical,R,L,g,b)),y&&(r=z_(r,y,R,L,g,b)));const O=(s,a,m)=>{if(a.x<0||a.x>=sr||a.y<0||a.y>=sr)return;let _=null;if(x){const{x:t,y:e,z:i}=d.projectTilePoint(a.x,a.y,m);_={anchor:new D_(t,e,i,0,void 0),up:d.upVector(m,a.x,a.y)};}!function(t,e,i,r,n,o,s,a,l,c,h,u,d,p,f,m,_,g,y,x,v,b,w,T,E,M,A){const S=t.addToLineVertexArray(e,r);let I,C,z,D,P,R,L,k=0,B=0,O=0,F=0,N=-1,U=-1;const V={};let j=pl("");const G=i?i.anchor:e,q="none"!==l.layout.get("icon-text-fit").evaluate(v,{},E);let Z=0,$=0;if(void 0===l._unevaluatedLayout.getValue("text-radial-offset")?[Z,$]=l.layout.get("text-offset").evaluate(v,{},E).map((t=>t*Ym)):(Z=l.layout.get("text-radial-offset").evaluate(v,{},E)*Ym,$=ig),t.allowVerticalPlacement&&n.vertical){const t=n.vertical;if(f)R=pg(t),a&&(L=pg(a));else {const i=l.layout.get("text-rotate").evaluate(v,{},E)+90;z=dg(c,G,e,h,u,d,t,p,i,m),a&&(D=dg(c,G,e,h,u,d,a,g,i));}}if(o){const r=l.layout.get("icon-rotate").evaluate(v,{},E),n=$_(o,r,w,q),s=a?$_(a,r,w,q):void 0;C=dg(c,G,e,h,u,d,o,g,r),k=4*n.length;const p=t.iconSizeData;let f=null;"source"===p.kind?(f=[Km*l.layout.get("icon-size").evaluate(v,{},E)],f[0]>cg&&W(`${t.layerIds[0]}: Value for "icon-size" is >= ${lg}. Reduce your "icon-size".`)):"composite"===p.kind&&(f=[Km*b.compositeIconSizes[0].evaluate(v,{},E),Km*b.compositeIconSizes[1].evaluate(v,{},E)],(f[0]>cg||f[1]>cg)&&W(`${t.layerIds[0]}: Value for "icon-size" is >= ${lg}. Reduce your "icon-size".`)),t.addSymbols(t.icon,n,f,x,y,v,!1,i,e,S.lineStartIndex,S.lineLength,-1,T,E,M,A),N=t.icon.placedSymbolArray.length-1,s&&(B=4*s.length,t.addSymbols(t.icon,s,f,x,y,v,m_.vertical,i,e,S.lineStartIndex,S.lineLength,-1,T,E,M,A),U=t.icon.placedSymbolArray.length-1);}for(const r in n.horizontal){const o=n.horizontal[r];I||(j=pl(o.text),f?P=pg(o):I=dg(c,G,e,h,u,d,o,p,l.layout.get("text-rotate").evaluate(v,{},E),m));const a=1===o.positionedLines.length;if(O+=hg(t,i,e,o,s,l,f,v,m,S,n.vertical?m_.horizontal:m_.horizontalOnly,a?Object.keys(n.horizontal):[r],V,N,b,T,E,M),a)break}n.vertical&&(F+=hg(t,i,e,n.vertical,s,l,f,v,m,S,m_.vertical,["vertical"],V,U,b,T,E,M));let H=-1;const X=(t,e)=>t?Math.max(t,e):e;H=X(P,H),H=X(R,H),H=X(L,H);const Y=H>-1?1:0;t.glyphOffsetArray.length>=iy.MAX_GLYPHS&&W("Too many glyphs being rendered in a tile. See https://github.com/mapbox/mapbox-gl-js/issues/2907"),void 0!==v.sortKey&&t.addToSortKeyRanges(t.symbolInstances.length,v.sortKey),t.symbolInstances.emplaceBack(e.x,e.y,G.x,G.y,G.z,V.right>=0?V.right:-1,V.center>=0?V.center:-1,V.left>=0?V.left:-1,V.vertical>=0?V.vertical:-1,N,U,j,void 0!==I?I:t.collisionBoxArray.length,void 0!==I?I+1:t.collisionBoxArray.length,void 0!==z?z:t.collisionBoxArray.length,void 0!==z?z+1:t.collisionBoxArray.length,void 0!==C?C:t.collisionBoxArray.length,void 0!==C?C+1:t.collisionBoxArray.length,D||t.collisionBoxArray.length,D?D+1:t.collisionBoxArray.length,h,O,F,k,B,Y,0,Z,$,H,0,q?1:0);}(t,a,_,s,i,r,n,B,t.layers[0],t.collisionBoxArray,e.index,e.sourceLayerIndex,t.index,M,I,l,0,A,C,g,e,o,c,h,u,p,f);};if("line"===z)for(const n of N_(e.geometry,0,0,sr,sr)){const e=O_(n,E,S,i.vertical||y,r,v,T,t.overscaling,sr);for(const i of e)y&&fg(t,y.text,D,i)||O(n,i,u);}else if("line-center"===z){for(const t of e.geometry)if(t.length>1){const e=B_(t,S,i.vertical||y,r,v,T);e&&O(t,e,u);}}else if("Polygon"===e.type)for(const t of Tf(e.geometry,0)){const e=J_(t,16);O(t[0],new D_(e.x,e.y,0,0,void 0),u);}else if("LineString"===e.type)for(const t of e.geometry)O(t,new D_(t[0].x,t[0].y,0,0,void 0),u);else if("Point"===e.type)for(const t of e.geometry)for(const e of t)O([e],new D_(e.x,e.y,0,0,void 0),u);}const lg=255,cg=lg*Km;function hg(t,e,i,r,n,o,s,a,l,c,h,u,d,p,f,m,_,g){const x=function(t,e,i,r,n,o,s,a){const l=[];if(0===e.positionedLines.length)return l;const c=r.layout.get("text-rotate").evaluate(o,{})*Math.PI/180,h=function(t){const e=t[0],i=t[1],r=e*i;return r>0?[e,-i]:r<0?[-e,i]:0===e?[i,e]:[i,-e]}(i);let u=Math.abs(e.top-e.bottom);for(const t of e.positionedLines)u-=t.lineOffset;const d=e.positionedLines.length,p=u/d;let f=e.top-i[1];for(let t=0;t<d;++t){const r=e.positionedLines[t];f=K_(e,p,f,t);for(const t of r.positionedGlyphs){if(!t.rect)continue;const r=t.rect||{};let o=h_+1,u=!0,d=1,p=0;if(t.imageName){const e=s[t.imageName];if(!e)continue;if(e.sdf){W("SDF images are not supported in formatted text and will be ignored.");continue}u=!1,d=e.pixelRatio,o=d_/d;}const m=(n||a)&&t.vertical,_=t.metrics.advance*t.scale/2,g=t.metrics,x=t.rect;if(null===x)continue;a&&e.verticalizable&&(p=t.imageName?_-t.metrics.width*t.scale/2:0);const v=n?[t.x+_,t.y]:[0,0];let b=[0,0],w=[0,0],T=!1;n||(m?(w=[t.x+_+h[0],t.y+h[1]-p],T=!0):b=[t.x+_+i[0],t.y+i[1]-p]);const E=x.w*t.scale/(d*(t.localGlyph?G_:1)),M=x.h*t.scale/(d*(t.localGlyph?G_:1));let A,S,I,C;if(m){const e=t.y-f,i=new y(-_,_-e),r=-Math.PI/2,n=new y(...w);A=new y(-_+b[0],b[1]),A._rotateAround(r,i)._add(n),A.x+=-e+_,A.y-=(g.left-o)*t.scale;const s=t.imageName?g.advance*t.scale:Ym*t.scale,a=String.fromCodePoint(t.glyph);n_(a)?A.x+=(1-o)*t.scale:o_(a)?A.x+=s-g.height*t.scale+(-o-1)*t.scale:A.x+=t.imageName||g.width+2*o===x.w&&g.height+2*o===x.h?(s-M)/2:(s-(g.height+2*o)*t.scale)/2,S=new y(A.x,A.y-E),I=new y(A.x+M,A.y),C=new y(A.x+M,A.y-E);}else {const e=(g.left-o)*t.scale-_+b[0],i=(-g.top-o)*t.scale+b[1],r=e+E,n=i+M;A=new y(e,i),S=new y(r,i),I=new y(e,n),C=new y(r,n);}if(c){let t;t=n?new y(0,0):T?new y(h[0],h[1]):new y(i[0],i[1]),A._rotateAround(c,t),S._rotateAround(c,t),I._rotateAround(c,t),C._rotateAround(c,t);}const z=new y(0,0),D=new y(0,0);l.push({tl:A,tr:S,bl:I,br:C,texPrimary:r,texSecondary:void 0,writingMode:e.writingMode,glyphOffset:v,sectionIndex:t.sectionIndex,isSDF:u,pixelOffsetTL:z,pixelOffsetBR:D,minFontScaleX:0,minFontScaleY:0});}}return l}(0,r,l,o,s,a,n,t.allowVerticalPlacement),v=t.textSizeData;let b=null;"source"===v.kind?(b=[Km*o.layout.get("text-size").evaluate(a,{},_)],b[0]>cg&&W(`${t.layerIds[0]}: Value for "text-size" is >= ${lg}. Reduce your "text-size".`)):"composite"===v.kind&&(b=[Km*f.compositeTextSizes[0].evaluate(a,{},_),Km*f.compositeTextSizes[1].evaluate(a,{},_)],(b[0]>cg||b[1]>cg)&&W(`${t.layerIds[0]}: Value for "text-size" is >= ${lg}. Reduce your "text-size".`)),t.addSymbols(t.text,x,b,l,s,a,h,e,i,c.lineStartIndex,c.lineLength,p,m,_,g,!1);for(const e of u)d[e]=t.text.placedSymbolArray.length-1;return 4*x.length}function ug(t){for(const e in t)return t[e];return null}function dg(t,e,i,r,n,o,s,a,l,c){let h=s.top,u=s.bottom,d=s.left,p=s.right;const f=s.collisionPadding;if(f&&(d-=f[0],h-=f[1],p+=f[2],u+=f[3]),l){const t=new y(d,h),e=new y(p,h),i=new y(d,u),r=new y(p,u),n=w(l);let o=new y(0,0);c&&(o=new y(c[0],c[1])),t._rotateAround(n,o),e._rotateAround(n,o),i._rotateAround(n,o),r._rotateAround(n,o),d=Math.min(t.x,e.x,i.x,r.x),p=Math.max(t.x,e.x,i.x,r.x),h=Math.min(t.y,e.y,i.y,r.y),u=Math.max(t.y,e.y,i.y,r.y);}return t.emplaceBack(e.x,e.y,e.z,i.x,i.y,d,h,p,u,a,r,n,o),t.length-1}function pg(t){t.collisionPadding&&(t.top-=t.collisionPadding[1],t.bottom+=t.collisionPadding[3]);const e=t.bottom-t.top;return e>0?Math.max(10,e):null}function fg(t,e,i,r){const n=t.compareText;if(e in n){const t=n[e];for(let e=t.length-1;e>=0;e--)if(r.dist(t[e])<i)return !0}else n[e]=[];return n[e].push(r),!1}function mg(t,e){const i=t.fovAboveCenter,r=t.elevation?t.elevation.getMinElevationBelowMSL()*e:0,n=(t._camera.position[2]*t.worldSize-r)/Math.cos(t._pitch),o=Math.sin(i)*n/Math.sin(Math.max(Math.PI/2-t._pitch-i,.01)),s=Math.sin(t._pitch)*o+n;return Math.min(1.01*s,n*(1/t._horizonShift))}function _g(t,e){if(!e.isReprojectedInTileSpace)return {scale:1<<t.z,x:t.x,y:t.y,x2:t.x+1,y2:t.y+1,projection:e};const i=Math.pow(2,-t.z),r=t.x*i,n=(t.x+1)*i,o=t.y*i,s=(t.y+1)*i,a=jd(r),l=jd(n),c=Gd(o),h=Gd(s),u=e.project(a,c),d=e.project(l,c),p=e.project(l,h),f=e.project(a,h);let m=Math.min(u.x,d.x,p.x,f.x),_=Math.min(u.y,d.y,p.y,f.y),g=Math.max(u.x,d.x,p.x,f.x),y=Math.max(u.y,d.y,p.y,f.y);const x=i/16;function v(t,i,r,n,o,s){const a=(r+o)/2,l=(n+s)/2,c=e.project(jd(a),Gd(l)),h=Math.max(0,m-c.x,_-c.y,c.x-g,c.y-y);m=Math.min(m,c.x),g=Math.max(g,c.x),_=Math.min(_,c.y),y=Math.max(y,c.y),h>x&&(v(t,c,r,n,a,l),v(c,i,a,l,o,s));}v(u,d,r,o,n,o),v(d,p,n,o,n,s),v(p,f,n,s,r,s),v(f,u,r,s,r,o),m-=x,_-=x,g+=x,y+=x;const b=1/Math.max(g-m,y-_);return {scale:b,x:m*b,y:_*b,x2:g*b,y2:y*b,projection:e}}function gg(t,e,i,r,n,o,s,a,l){if("globe"===l.name)return td(t,e,new Dd(i,r,n),!1);const c=_g({z:i,x:r,y:n},l);return new Bu([(o+c.x/c.scale)*e,e*(c.y/c.scale),s],[(o+c.x2/c.scale)*e,e*(c.y2/c.scale),a])}function yg(t,{x:e,y:i},r=0){return new y(((e-r)*t.scale-t.x)*sr,(i*t.scale-t.y)*sr)}function xg(t,e,i=0){return bu.fromValues(((e.x-i)*t.scale-t.x)*sr,(e.y*t.scale-t.y)*sr,qd(e.z,e.y))}const vg=mu.identity(new Float32Array(16));class bg{constructor(t){this.spec=t,this.name=t.name,this.wrap=!1,this.requiresDraping=!1,this.supportsWorldCopies=!1,this.supportsTerrain=!1,this.supportsFog=!1,this.supportsFreeCamera=!1,this.zAxisUnit="meters",this.isReprojectedInTileSpace=!0,this.unsupportedLayers=["custom"],this.center=[0,0],this.range=[3.5,7];}project(t,e){return {x:0,y:0,z:0}}unproject(t,e){return new Id(0,0)}projectTilePoint(t,e,i){return {x:t,y:e,z:0}}locationPoint(t,e,i=!0){return t._coordinatePoint(t.locationCoordinate(e),i)}pixelsPerMeter(t,e){return Vd(1,t)*e}pixelSpaceConversion(t,e,i){return 1}farthestPixelDistance(t){return mg(t,t.pixelsPerMeter)}pointCoordinate(t,e,i,r){const n=t.horizonLineFromTop(!1),o=new y(e,Math.max(n,i));return t.rayIntersectionCoordinate(t.pointRayIntersection(o,r))}pointCoordinate3D(t,e,i){const r=new y(e,i);if(t.elevation)return t.elevation.pointCoordinate(r);{const e=this.pointCoordinate(t,r.x,r.y,0);return [e.x,e.y,e.z]}}isPointAboveHorizon(t,e){if(t.elevation)return !this.pointCoordinate3D(t,e.x,e.y);const i=t.horizonLineFromTop();return e.y<i}createInversionMatrix(t,e){return vg}createTileMatrix(t,e,i){let r,n,o;const s=i.canonical,a=mu.identity(new Float64Array(16));if(this.isReprojectedInTileSpace){const l=_g(s,this);r=1,n=l.x+i.wrap*l.scale,o=l.y,mu.scale(a,a,[r/l.scale,r/l.scale,t.pixelsPerMeter/e]);}else r=e/t.zoomScale(s.z),n=(s.x+Math.pow(2,s.z)*i.wrap)*r,o=s.y*r;return mu.translate(a,a,[n,o,0]),mu.scale(a,a,[r/sr,r/sr,1]),a}upVector(t,e,i){return [0,0,1]}upVectorScale(t,e,i){return {metersToTile:1}}}class wg extends bg{constructor(t){super(t),this.range=[4,7],this.center=t.center||[-96,37.5];const[e,i]=this.parallels=t.parallels||[29.5,45.5],r=Math.sin(w(e));this.n=(r+Math.sin(w(i)))/2,this.c=1+r*(2*this.n-r),this.r0=Math.sqrt(this.c)/this.n;}project(t,e){const{n:i,c:r,r0:n}=this,o=w(t-this.center[0]),s=w(e),a=Math.sqrt(r-2*i*Math.sin(s))/i;return {x:a*Math.sin(o*i),y:a*Math.cos(o*i)-n,z:0}}unproject(t,e){const{n:i,c:r,r0:n}=this,o=n+e;let s=Math.atan2(t,Math.abs(o))*Math.sign(o);o*i<0&&(s-=Math.PI*Math.sign(t)*Math.sign(o));const a=w(this.center[0])*i;s=P(s,-Math.PI-a,Math.PI-a);const l=z(T(s/i)+this.center[0],-180,180),c=Math.asin(z((r-(t*t+o*o)*i*i)/(2*i),-1,1)),h=z(T(c),-Zd,Zd);return new Id(l,h)}}const Tg=1.340264,Eg=-.081106,Mg=893e-6,Ag=.003796,Sg=Math.sqrt(3)/2;class Ig extends bg{project(t,e){e=e/180*Math.PI,t=t/180*Math.PI;const i=Math.asin(Sg*Math.sin(e)),r=i*i,n=r*r*r;return {x:.5*(t*Math.cos(i)/(Sg*(Tg+3*Eg*r+n*(7*Mg+9*Ag*r)))/Math.PI+.5),y:1-.5*(i*(Tg+Eg*r+n*(Mg+Ag*r))/Math.PI+1),z:0}}unproject(t,e){t=(2*t-.5)*Math.PI;let i=e=(2*(1-e)-1)*Math.PI,r=i*i,n=r*r*r;for(let t,o,s,a=0;a<12&&(o=i*(Tg+Eg*r+n*(Mg+Ag*r))-e,s=Tg+3*Eg*r+n*(7*Mg+9*Ag*r),t=o/s,i=z(i-t,-Math.PI/3,Math.PI/3),r=i*i,n=r*r*r,!(Math.abs(t)<1e-12));++a);const o=Sg*t*(Tg+3*Eg*r+n*(7*Mg+9*Ag*r))/Math.cos(i),s=Math.asin(Math.sin(i)/Sg),a=z(180*o/Math.PI,-180,180),l=z(180*s/Math.PI,-Zd,Zd);return new Id(a,l)}}class Cg extends bg{constructor(t){super(t),this.wrap=!0,this.supportsWorldCopies=!0;}project(t,e){return {x:.5+t/360,y:.5-e/360,z:0}}unproject(t,e){const i=360*(t-.5),r=z(360*(.5-e),-Zd,Zd);return new Id(i,r)}}const zg=Math.PI/2;function Dg(t){return Math.tan((zg+t)/2)}class Pg extends bg{constructor(t){super(t),this.center=t.center||[0,30];const[e,i]=this.parallels=t.parallels||[30,30];let r=w(e),n=w(i);this.southernCenter=r+n<0,this.southernCenter&&(r=-r,n=-n);const o=Math.cos(r),s=Dg(r);this.n=r===n?Math.sin(r):Math.log(o/Math.cos(n))/Math.log(Dg(n)/s),this.f=o*Math.pow(Dg(r),this.n)/this.n;}project(t,e){e=w(e),this.southernCenter&&(e=-e),t=w(t-this.center[0]);const i=1e-6,{n:r,f:n}=this;n>0?e<-zg+i&&(e=-zg+i):e>zg-i&&(e=zg-i);const o=n/Math.pow(Dg(e),r);let s=o*Math.sin(r*t),a=n-o*Math.cos(r*t);return s=.5*(s/Math.PI+.5),a=.5*(a/Math.PI+.5),{x:s,y:this.southernCenter?a:1-a,z:0}}unproject(t,e){t=(2*t-.5)*Math.PI,this.southernCenter&&(e=1-e),e=(2*(1-e)-.5)*Math.PI;const{n:i,f:r}=this,n=r-e,o=Math.sign(n),s=Math.sign(i)*Math.sqrt(t*t+n*n);let a=Math.atan2(t,Math.abs(n))*o;n*i<0&&(a-=Math.PI*Math.sign(t)*o);const l=z(T(a/i)+this.center[0],-180,180),c=z(T(2*Math.atan(Math.pow(r/s,1/i))-zg),-Zd,Zd);return new Id(l,this.southernCenter?-c:c)}}class Rg extends bg{constructor(t){super(t),this.wrap=!0,this.supportsWorldCopies=!0,this.supportsTerrain=!0,this.supportsFog=!0,this.supportsFreeCamera=!0,this.isReprojectedInTileSpace=!1,this.unsupportedLayers=[],this.range=null;}project(t,e){return {x:Nd(t),y:Ud(e),z:0}}unproject(t,e){const i=jd(t),r=Gd(e);return new Id(i,r)}}const Lg=w(Zd);class kg extends bg{project(t,e){const i=(e=w(e))*e,r=i*i;return {x:.5*((t=w(t))*(.8707-.131979*i+r*(r*(.003971*i-.001529*r)-.013791))/Math.PI+.5),y:1-.5*(e*(1.007226+i*(.015085+r*(.028874*i-.044475-.005916*r)))/Math.PI+1),z:0}}unproject(t,e){t=(2*t-.5)*Math.PI;let i=e=(2*(1-e)-1)*Math.PI,r=25,n=0,o=i*i;do{o=i*i;const t=o*o;n=(i*(1.007226+o*(.015085+t*(.028874*o-.044475-.005916*t)))-e)/(1.007226+o*(.045255+t*(.259866*o-.311325-.005916*11*t))),i=z(i-n,-Lg,Lg);}while(Math.abs(n)>1e-6&&--r>0);o=i*i;const s=z(T(t/(.8707+o*(o*(o*o*o*(.003971-.001529*o)-.013791)-.131979))),-180,180),a=T(i);return new Id(s,a)}}const Bg=w(Zd);class Og extends bg{project(t,e){e=w(e),t=w(t);const i=Math.cos(e),r=2/Math.PI,n=Math.acos(i*Math.cos(t/2)),o=Math.sin(n)/n,s=.5*(t*r+2*i*Math.sin(t/2)/o)||0,a=.5*(e+Math.sin(e)/o)||0;return {x:.5*(s/Math.PI+.5),y:1-.5*(a/Math.PI+1),z:0}}unproject(t,e){let i=t=(2*t-.5)*Math.PI,r=e=(2*(1-e)-1)*Math.PI,n=25;const o=1e-6;let s=0,a=0;do{const n=Math.cos(r),o=Math.sin(r),l=2*o*n,c=o*o,h=n*n,u=Math.cos(i/2),d=Math.sin(i/2),p=2*u*d,f=d*d,m=1-h*u*u,_=m?1/m:0,g=m?Math.acos(n*u)*Math.sqrt(1/m):0,y=.5*(2*g*n*d+2*i/Math.PI)-t,x=.5*(g*o+r)-e,v=.5*_*(h*f+g*n*u*c)+1/Math.PI,b=_*(p*l/4-g*o*d),w=.125*_*(l*d-g*o*h*p),T=.5*_*(c*u+g*f*n)+.5,E=b*w-T*v;s=(x*b-y*T)/E,a=(y*w-x*v)/E,i=z(i-s,-Math.PI,Math.PI),r=z(r-a,-Bg,Bg);}while((Math.abs(s)>o||Math.abs(a)>o)&&--n>0);return new Id(T(i),T(r))}}class Fg extends bg{constructor(t){super(t),this.center=t.center||[0,0],this.parallels=t.parallels||[0,0],this.cosPhi=Math.max(.01,Math.cos(w(this.parallels[0]))),this.scale=1/(2*Math.max(Math.PI*this.cosPhi,1/this.cosPhi)),this.wrap=!0,this.supportsWorldCopies=!0;}project(t,e){const{scale:i,cosPhi:r}=this;return {x:w(t)*r*i+.5,y:-Math.sin(w(e))/r*i+.5,z:0}}unproject(t,e){const{scale:i,cosPhi:r}=this,n=-(e-.5)/i,o=z(T((t-.5)/i)/r,-180,180),s=Math.asin(z(n*r,-1,1)),a=z(T(s),-Zd,Zd);return new Id(o,a)}}class Ng extends Rg{constructor(t){super(t),this.requiresDraping=!0,this.supportsWorldCopies=!1,this.supportsFog=!0,this.zAxisUnit="pixels",this.unsupportedLayers=["debug"],this.range=[3,5];}projectTilePoint(t,e,i){const r=od(t,e,i),n=ld(Yu(i));return bu.transformMat4(r,r,n),{x:r[0],y:r[1],z:r[2]}}locationPoint(t,e){const i=nd(e.lat,e.lng),r=bu.normalize([],i),n=t.elevation?t.elevation.getAtPointOrZero(t.locationCoordinate(e),t._centerAltitude):t._centerAltitude,o=Vd(1,0)*sr*n;bu.scaleAndAdd(i,i,r,o);const s=mu.identity(new Float64Array(16));return mu.multiply(s,t.pixelMatrix,t.globeMatrix),bu.transformMat4(i,i,s),new y(i[0],i[1])}pixelsPerMeter(t,e){return Vd(1,0)*e}pixelSpaceConversion(t,e,i){const r=Vd(1,t)*e,n=Wr(Vd(1,45)*e,r,i);return this.pixelsPerMeter(t,e)/n}createTileMatrix(t,e,i){const r=cd(Yu(i.canonical));return mu.multiply(new Float64Array(16),t.globeMatrix,r)}createInversionMatrix(t,e){const{center:i}=t,r=ld(Yu(e));return mu.rotateY(r,r,w(i.lng)),mu.rotateX(r,r,w(i.lat)),mu.scale(r,r,[t._pixelsPerMercatorPixel,t._pixelsPerMercatorPixel,1]),Float32Array.from(r)}pointCoordinate(t,e,i,r){return Hu(t,e,i,!0)||new Yd(0,0)}pointCoordinate3D(t,e,i){const r=this.pointCoordinate(t,e,i,0);return [r.x,r.y,r.z]}isPointAboveHorizon(t,e){return !Hu(t,e.x,e.y,!1)}farthestPixelDistance(t){const e=function(t,e){const i=t.cameraToCenterDistance,r=t._centerAltitude*e,n=t._camera,o=t._camera.forward(),s=bu.add([],bu.scale([],o,-i),[0,0,r]),a=t.worldSize/(2*Math.PI),l=[0,0,-a],c=t.width/t.height,h=Math.tan(t.fovAboveCenter),u=bu.scale([],n.up(),h),d=bu.scale([],n.right(),h*c),p=bu.normalize([],bu.add([],bu.add([],o,u),d)),f=[];let m;if(new Cu(s,p).closestPointOnSphere(l,a,f)){const e=bu.add([],f,l),i=bu.sub([],e,s);m=Math.cos(t.fovAboveCenter)*bu.length(i);}else {const t=bu.sub([],s,l),e=bu.sub([],l,s);bu.normalize(e,e);const i=bu.length(t)-a;m=Math.sqrt(i*(i+2*a));const r=Math.acos(m/(a+i))-Math.acos(bu.dot(o,e));m*=Math.cos(r);}return 1.01*m}(t,this.pixelsPerMeter(t.center.lat,t.worldSize)),i=pd(t.zoom);if(i>0){const r=mg(t,Vd(1,t.center.lat)*t.worldSize),n=t.worldSize/(2*Math.PI),o=Math.max(t.width,t.height)/t.worldSize*Math.PI;return Wr(e,r+n*(1-Math.cos(o)),Math.pow(i,10))}return e}upVector(t,e,i){return od(e,i,t,1)}upVectorScale(t){return {metersToTile:$u(sd(Yu(t)))}}}function Ug(t){const e=t.parallels,i=!!e&&Math.abs(e[0]+e[1])<.01;switch(t.name){case"mercator":return new Rg(t);case"equirectangular":return new Cg(t);case"naturalEarth":return new kg(t);case"equalEarth":return new Ig(t);case"winkelTripel":return new Og(t);case"albers":return i?new Fg(t):new wg(t);case"lambertConformalConic":return i?new Fg(t):new Pg(t);case"globe":return new Ng(t)}throw new Error(`Invalid projection name: ${t.name}`)}const Vg=new ua({"symbol-placement":new la(ze.layout_symbol["symbol-placement"]),"symbol-spacing":new la(ze.layout_symbol["symbol-spacing"]),"symbol-avoid-edges":new la(ze.layout_symbol["symbol-avoid-edges"]),"symbol-sort-key":new ca(ze.layout_symbol["symbol-sort-key"]),"symbol-z-order":new la(ze.layout_symbol["symbol-z-order"]),"symbol-z-elevate":new la(ze.layout_symbol["symbol-z-elevate"]),"icon-allow-overlap":new la(ze.layout_symbol["icon-allow-overlap"]),"icon-ignore-placement":new la(ze.layout_symbol["icon-ignore-placement"]),"icon-optional":new la(ze.layout_symbol["icon-optional"]),"icon-rotation-alignment":new la(ze.layout_symbol["icon-rotation-alignment"]),"icon-size":new ca(ze.layout_symbol["icon-size"]),"icon-text-fit":new ca(ze.layout_symbol["icon-text-fit"]),"icon-text-fit-padding":new ca(ze.layout_symbol["icon-text-fit-padding"]),"icon-image":new ca(ze.layout_symbol["icon-image"]),"icon-rotate":new ca(ze.layout_symbol["icon-rotate"]),"icon-padding":new la(ze.layout_symbol["icon-padding"]),"icon-keep-upright":new la(ze.layout_symbol["icon-keep-upright"]),"icon-offset":new ca(ze.layout_symbol["icon-offset"]),"icon-anchor":new ca(ze.layout_symbol["icon-anchor"]),"icon-pitch-alignment":new la(ze.layout_symbol["icon-pitch-alignment"]),"text-pitch-alignment":new la(ze.layout_symbol["text-pitch-alignment"]),"text-rotation-alignment":new la(ze.layout_symbol["text-rotation-alignment"]),"text-field":new ca(ze.layout_symbol["text-field"]),"text-font":new ca(ze.layout_symbol["text-font"]),"text-size":new ca(ze.layout_symbol["text-size"]),"text-max-width":new ca(ze.layout_symbol["text-max-width"]),"text-line-height":new ca(ze.layout_symbol["text-line-height"]),"text-letter-spacing":new ca(ze.layout_symbol["text-letter-spacing"]),"text-justify":new ca(ze.layout_symbol["text-justify"]),"text-radial-offset":new ca(ze.layout_symbol["text-radial-offset"]),"text-variable-anchor":new la(ze.layout_symbol["text-variable-anchor"]),"text-anchor":new ca(ze.layout_symbol["text-anchor"]),"text-max-angle":new la(ze.layout_symbol["text-max-angle"]),"text-writing-mode":new la(ze.layout_symbol["text-writing-mode"]),"text-rotate":new ca(ze.layout_symbol["text-rotate"]),"text-padding":new la(ze.layout_symbol["text-padding"]),"text-keep-upright":new la(ze.layout_symbol["text-keep-upright"]),"text-transform":new ca(ze.layout_symbol["text-transform"]),"text-offset":new ca(ze.layout_symbol["text-offset"]),"text-allow-overlap":new la(ze.layout_symbol["text-allow-overlap"]),"text-ignore-placement":new la(ze.layout_symbol["text-ignore-placement"]),"text-optional":new la(ze.layout_symbol["text-optional"]),visibility:new la(ze.layout_symbol.visibility)});var jg={paint:new ua({"icon-opacity":new ca(ze.paint_symbol["icon-opacity"]),"icon-emissive-strength":new ca(ze.paint_symbol["icon-emissive-strength"]),"text-emissive-strength":new ca(ze.paint_symbol["text-emissive-strength"]),"icon-color":new ca(ze.paint_symbol["icon-color"]),"icon-halo-color":new ca(ze.paint_symbol["icon-halo-color"]),"icon-halo-width":new ca(ze.paint_symbol["icon-halo-width"]),"icon-halo-blur":new ca(ze.paint_symbol["icon-halo-blur"]),"icon-translate":new la(ze.paint_symbol["icon-translate"]),"icon-translate-anchor":new la(ze.paint_symbol["icon-translate-anchor"]),"icon-image-cross-fade":new ca(ze.paint_symbol["icon-image-cross-fade"]),"text-opacity":new ca(ze.paint_symbol["text-opacity"]),"text-color":new ca(ze.paint_symbol["text-color"],{runtimeType:Ge,getOverride:t=>t.textColor,hasOverride:t=>!!t.textColor}),"text-halo-color":new ca(ze.paint_symbol["text-halo-color"]),"text-halo-width":new ca(ze.paint_symbol["text-halo-width"]),"text-halo-blur":new ca(ze.paint_symbol["text-halo-blur"]),"text-translate":new la(ze.paint_symbol["text-translate"]),"text-translate-anchor":new la(ze.paint_symbol["text-translate-anchor"])}),layout:Vg};class Gg{constructor(t){this.type=t.property.overrides?t.property.overrides.runtimeType:Ne,this.defaultValue=t;}evaluate(t){if(t.formattedSection){const e=this.defaultValue.property.overrides;if(e&&e.hasOverride(t.formattedSection))return e.getOverride(t.formattedSection)}return t.feature&&t.featureState?this.defaultValue.evaluate(t.feature,t.featureState):this.defaultValue.property.specification.default}eachChild(t){this.defaultValue.isConstant()||t(this.defaultValue.value._styleExpression.expression);}outputDefined(){return !1}serialize(){return null}}Ss(Gg,"FormatSectionOverride",{omit:["defaultValue"]});class qg extends Zl{constructor(t,e){super(t,jg,e);}recalculate(t,e){super.recalculate(t,e),"auto"===this.layout.get("icon-rotation-alignment")&&(this.layout._values["icon-rotation-alignment"]="point"!==this.layout.get("symbol-placement")?"map":"viewport"),"auto"===this.layout.get("text-rotation-alignment")&&(this.layout._values["text-rotation-alignment"]="point"!==this.layout.get("symbol-placement")?"map":"viewport"),"auto"===this.layout.get("text-pitch-alignment")&&(this.layout._values["text-pitch-alignment"]=this.layout.get("text-rotation-alignment")),"auto"===this.layout.get("icon-pitch-alignment")&&(this.layout._values["icon-pitch-alignment"]=this.layout.get("icon-rotation-alignment"));const i=this.layout.get("text-writing-mode");if(i){const t=[];for(const e of i)t.indexOf(e)<0&&t.push(e);this.layout._values["text-writing-mode"]=t;}else this.layout._values["text-writing-mode"]="point"===this.layout.get("symbol-placement")?["horizontal"]:["horizontal","vertical"];this._setPaintOverrides();}getValueAndResolveTokens(t,e,i,r){const n=this.layout.get(t).evaluate(e,{},i,r),o=this._unevaluatedLayout._values[t];return o.isDataDriven()||go(o.value)||!n?n:function(t,e){return e.replace(/{([^{}]+)}/g,((e,i)=>i in t?String(t[i]):""))}(e.properties,n)}createBucket(t){return new iy(t)}queryRadius(){return 0}queryIntersectsFeature(){return !1}_setPaintOverrides(){for(const t of jg.paint.overridableProperties){if(!qg.hasPaintOverride(this.layout,t))continue;const e=this.paint.get(t),i=new Gg(e),r=new _o(i,e.property.specification);let n=null;n="constant"===e.value.kind||"source"===e.value.kind?new xo("source",r):new vo("composite",r,e.value.zoomStops,e.value._interpolationType),this.paint._values[t]=new sa(e.property,n,e.parameters);}}_handleOverridablePaintPropertyUpdate(t,e,i){return !(!this.layout||e.isDataDriven()||i.isDataDriven())&&qg.hasPaintOverride(this.layout,t)}static hasPaintOverride(t,e){const i=t.get("text-field"),r=jg.paint.properties[e];let n=!1;const o=t=>{for(const e of t)if(r.overrides&&r.overrides.hasOverride(e))return void(n=!0)};if("constant"===i.value.kind&&i.value.value instanceof ui)o(i.value.value.sections);else if("source"===i.value.kind){const t=e=>{n||(e instanceof yi&&mi(e.value)===He?o(e.value.sections):e instanceof Ti?o(e.sections):e.eachChild(t));},e=i.value;e._styleExpression&&t(e._styleExpression.expression);}return n}getProgramConfiguration(t){return new Ol(this,t)}}const Zg=Xf.types,$g=[{name:"a_fade_opacity",components:1,type:"Uint8",offset:0}];function Hg(t,e,i,r,n,o,s,a,l,c,h,u,d){const p=a?Math.min(cg,Math.round(a[0])):0,f=a?Math.min(cg,Math.round(a[1])):0;t.emplaceBack(e,i,Math.round(32*r),Math.round(32*n),o,s,(p<<1)+(l?1:0),f,16*c,16*h,256*u,256*d);}function Wg(t,e,i){t.emplaceBack(e,i);}function Xg(t,e,i,r,n,o,s){t.emplaceBack(e,i,r,n,o,s);}function Yg(t,e,i,r,n){const o=5*e+2;t.float32[o+0]=i,t.float32[o+1]=r,t.float32[o+2]=n;}function Kg(t,e,i,r,n){t.emplaceBack(e,i,r,n),t.emplaceBack(e,i,r,n),t.emplaceBack(e,i,r,n),t.emplaceBack(e,i,r,n);}function Jg(t){for(const e of t.sections)if(Us(e.text))return !0;return !1}class Qg{constructor(t){this.layoutVertexArray=new Sa,this.indexArray=new Ba,this.programConfigurations=t,this.segments=new Wl,this.dynamicLayoutVertexArray=new Ta,this.opacityVertexArray=new Ca,this.placedSymbolArray=new Ka,this.iconTransitioningVertexArray=new za,this.globeExtVertexArray=new Ia,this.zOffsetVertexArray=new Na;}isEmpty(){return 0===this.layoutVertexArray.length&&0===this.indexArray.length&&0===this.dynamicLayoutVertexArray.length&&0===this.opacityVertexArray.length&&0===this.iconTransitioningVertexArray.length}upload(t,e,i,r,n){this.isEmpty()||(i&&(this.layoutVertexBuffer=t.createVertexBuffer(this.layoutVertexArray,Vm.members),this.indexBuffer=t.createIndexBuffer(this.indexArray,e),this.dynamicLayoutVertexBuffer=t.createVertexBuffer(this.dynamicLayoutVertexArray,Gm.members,!0),this.opacityVertexBuffer=t.createVertexBuffer(this.opacityVertexArray,$g,!0),this.iconTransitioningVertexArray.length>0&&(this.iconTransitioningVertexBuffer=t.createVertexBuffer(this.iconTransitioningVertexArray,Zm.members,!0)),this.globeExtVertexArray.length>0&&(this.globeExtVertexBuffer=t.createVertexBuffer(this.globeExtVertexArray,jm.members,!0)),!this.zOffsetVertexBuffer&&(this.zOffsetVertexArray.length>0||n)&&(this.zOffsetVertexBuffer=t.createVertexBuffer(this.zOffsetVertexArray,qm.members,!0)),this.opacityVertexBuffer.itemSize=1),(i||r)&&this.programConfigurations.upload(t));}destroy(){this.layoutVertexBuffer&&(this.layoutVertexBuffer.destroy(),this.indexBuffer.destroy(),this.programConfigurations.destroy(),this.segments.destroy(),this.dynamicLayoutVertexBuffer.destroy(),this.opacityVertexBuffer.destroy(),this.iconTransitioningVertexBuffer&&this.iconTransitioningVertexBuffer.destroy(),this.globeExtVertexBuffer&&this.globeExtVertexBuffer.destroy(),this.zOffsetVertexBuffer&&this.zOffsetVertexBuffer.destroy());}}Ss(Qg,"SymbolBuffers");class ty{constructor(t,e,i){this.layoutVertexArray=new t,this.layoutAttributes=e,this.indexArray=new i,this.segments=new Wl,this.collisionVertexArray=new La,this.collisionVertexArrayExt=new ka;}upload(t){this.layoutVertexBuffer=t.createVertexBuffer(this.layoutVertexArray,this.layoutAttributes),this.indexBuffer=t.createIndexBuffer(this.indexArray),this.collisionVertexBuffer=t.createVertexBuffer(this.collisionVertexArray,$m.members,!0),this.collisionVertexBufferExt=t.createVertexBuffer(this.collisionVertexArrayExt,Hm.members,!0);}destroy(){this.layoutVertexBuffer&&(this.layoutVertexBuffer.destroy(),this.indexBuffer.destroy(),this.segments.destroy(),this.collisionVertexBuffer.destroy(),this.collisionVertexBufferExt.destroy());}}Ss(ty,"CollisionBuffers");class ey{constructor(t){this.collisionBoxArray=t.collisionBoxArray,this.zoom=t.zoom,this.overscaling=t.overscaling,this.layers=t.layers,this.layerIds=this.layers.map((t=>t.id)),this.index=t.index,this.pixelRatio=t.pixelRatio,this.sourceLayerIndex=t.sourceLayerIndex,this.hasPattern=!1,this.hasRTLText=!1,this.fullyClipped=!1,this.hasAnyIconTextFit=!1,this.sortKeyRanges=[],this.collisionCircleArray=[],this.placementInvProjMatrix=mu.identity([]),this.placementViewportMatrix=mu.identity([]);const e=this.layers[0]._unevaluatedLayout._values;this.textSizeData=Jm(this.zoom,e["text-size"]),this.iconSizeData=Jm(this.zoom,e["icon-size"]);const i=this.layers[0].layout,r=i.get("symbol-sort-key"),n=i.get("symbol-z-order");this.canOverlap=i.get("text-allow-overlap")||i.get("icon-allow-overlap")||i.get("text-ignore-placement")||i.get("icon-ignore-placement"),this.sortFeaturesByKey="viewport-y"!==n&&void 0!==r.constantOr(1),this.sortFeaturesByY=("viewport-y"===n||"auto"===n&&!this.sortFeaturesByKey)&&this.canOverlap,this.writingModes=i.get("text-writing-mode").map((t=>m_[t])),this.stateDependentLayerIds=this.layers.filter((t=>t.isStateDependent())).map((t=>t.id)),this.sourceID=t.sourceID,this.projection=t.projection,this.hasAnyZOffset=!1,this.zOffsetSortDirty=!1,this.zOffsetBuffersNeedUpload=i.get("symbol-z-elevate");}createArrays(){this.text=new Qg(new Fl(this.layers,this.zoom,(t=>/^text/.test(t)))),this.icon=new Qg(new Fl(this.layers,this.zoom,(t=>/^icon/.test(t)))),this.glyphOffsetArray=new tl,this.lineVertexArray=new el,this.symbolInstances=new Qa;}calculateGlyphDependencies(t,e,i,r,n){for(let i=0;i<t.length;i++){const o=t.codePointAt(i);if(void 0===o)break;if(e[o]=!0,r&&n&&o<=65535){const r=r_[t.charAt(i)];r&&(e[r.charCodeAt(0)]=!0);}}}populate(t,e,i,r){const n=this.layers[0],o=n.layout,s="globe"===this.projection.name,a=o.get("text-font"),l=o.get("text-field"),c=o.get("icon-image"),h=("constant"!==l.value.kind||l.value.value instanceof ui&&!l.value.value.isEmpty()||l.value.value.toString().length>0)&&("constant"!==a.value.kind||a.value.value.length>0),u="constant"!==c.value.kind||!!c.value.value||Object.keys(c.parameters).length>0,d=o.get("symbol-sort-key");if(this.features=[],!h&&!u)return;const p=e.iconDependencies,f=e.glyphDependencies,m=e.availableImages,_=new Qs(this.zoom);for(const{feature:e,id:l,index:c,sourceLayerIndex:g}of t){const t=n._featureFilter.needGeometry,y=op(e,t);if(!n._featureFilter.filter(_,y,i))continue;if(t||(y.geometry=np(e,i,r)),s&&1!==e.type&&i.z<=5){const t=y.geometry,e=.98078528056,r=(t,r)=>{const n=od(t.x,t.y,i,1),o=od(r.x,r.y,i,1);return bu.dot(n,o)<e};for(let e=0;e<t.length;e++)t[e]=tp(t[e],r);}let x,v;if(h){const t=n.getValueAndResolveTokens("text-field",y,i,m),e=ui.factory(t);Jg(e)&&(this.hasRTLText=!0),(!this.hasRTLText||"unavailable"===Ys()||this.hasRTLText&&Js.isParsed())&&(x=i_(e,n,y));}if(u){const t=n.getValueAndResolveTokens("icon-image",y,i,m);v=t instanceof di?t:di.fromString(t);}if(!x&&!v)continue;const b=this.sortFeaturesByKey?d.evaluate(y,{},i):void 0;if(this.features.push({id:l,text:x,icon:v,index:c,sourceLayerIndex:g,geometry:y.geometry,properties:e.properties,type:Zg[e.type],sortKey:b}),v&&(p[v.namePrimary]=!0,v.nameSecondary&&(p[v.nameSecondary]=!0)),x){const t=a.evaluate(y,{},i).join(","),e="map"===o.get("text-rotation-alignment")&&"point"!==o.get("symbol-placement");this.allowVerticalPlacement=this.writingModes&&this.writingModes.indexOf(m_.vertical)>=0;for(const i of x.sections)if(i.image)p[i.image.namePrimary]=!0;else {const r=Rs(x.toString()),n=i.fontStack||t,o=f[n]=f[n]||{};this.calculateGlyphDependencies(i.text,o,e,this.allowVerticalPlacement,r);}}}"line"===o.get("symbol-placement")&&(this.features=function(t){const e={},i={},r=[];let n=0;function o(e){r.push(t[e]),n++;}function s(t,e,n){const o=i[t];return delete i[t],i[e]=o,r[o].geometry[0].pop(),r[o].geometry[0]=r[o].geometry[0].concat(n[0]),o}function a(t,i,n){const o=e[i];return delete e[i],e[t]=o,r[o].geometry[0].shift(),r[o].geometry[0]=n[0].concat(r[o].geometry[0]),o}function l(t,e,i){const r=i?e[0][e[0].length-1]:e[0][0];return `${t}:${r.x}:${r.y}`}for(let c=0;c<t.length;c++){const h=t[c],u=h.geometry,d=h.text?h.text.toString():null;if(!d){o(c);continue}const p=l(d,u),f=l(d,u,!0);if(p in i&&f in e&&i[p]!==e[f]){const t=a(p,f,u),n=s(p,f,r[t].geometry);delete e[p],delete i[f],i[l(d,r[n].geometry,!0)]=n,r[t].geometry=null;}else p in i?s(p,f,u):f in e?a(p,f,u):(o(c),e[p]=n-1,i[f]=n-1);}return r.filter((t=>t.geometry))}(this.features)),this.sortFeaturesByKey&&this.features.sort(((t,e)=>t.sortKey-e.sortKey));}update(t,e,i,r,n){const o=0!==Object.keys(t).length;if(o&&!this.stateDependentLayers.length)return;const s=o?this.stateDependentLayers:this.layers;this.text.programConfigurations.updatePaintArrays(t,e,s,i,r,n),this.icon.programConfigurations.updatePaintArrays(t,e,s,i,r,n);}isEmpty(){return 0===this.symbolInstances.length&&!this.hasRTLText}uploadPending(){return !this.uploaded||this.text.programConfigurations.needsUpload||this.icon.programConfigurations.needsUpload}upload(t){!this.uploaded&&this.hasDebugData()&&(this.textCollisionBox.upload(t),this.iconCollisionBox.upload(t)),this.text.upload(t,this.sortFeaturesByY,!this.uploaded,this.text.programConfigurations.needsUpload,this.zOffsetBuffersNeedUpload),this.icon.upload(t,this.sortFeaturesByY,!this.uploaded,this.icon.programConfigurations.needsUpload,this.zOffsetBuffersNeedUpload),this.uploaded=!0;}destroyDebugData(){this.textCollisionBox.destroy(),this.iconCollisionBox.destroy();}getProjection(){return this.projectionInstance||(this.projectionInstance=Ug(this.projection)),this.projectionInstance}destroy(){this.text.destroy(),this.icon.destroy(),this.hasDebugData()&&this.destroyDebugData();}addToLineVertexArray(t,e){const i=this.lineVertexArray.length;if(void 0!==t.segment)for(const{x:t,y:i}of e)this.lineVertexArray.emplaceBack(t,i);return {lineStartIndex:i,lineLength:this.lineVertexArray.length-i}}addSymbols(t,e,i,r,n,o,s,a,l,c,h,u,d,p,f,m){const _=t.indexArray,g=t.layoutVertexArray,y=t.globeExtVertexArray,x=t.segments.prepareSegment(4*e.length,g,_,this.canOverlap?o.sortKey:void 0),v=this.glyphOffsetArray.length,b=x.vertexLength,w=this.allowVerticalPlacement&&s===m_.vertical?Math.PI/2:0,T=o.text&&o.text.sections;for(let r=0;r<e.length;r++){const{tl:n,tr:s,bl:c,br:h,texPrimary:u,texSecondary:v,pixelOffsetTL:b,pixelOffsetBR:E,minFontScaleX:M,minFontScaleY:A,glyphOffset:S,isSDF:I,sectionIndex:C}=e[r],z=x.vertexLength,D=S[1];if(Hg(g,l.x,l.y,n.x,D+n.y,u.x,u.y,i,I,b.x,b.y,M,A),Hg(g,l.x,l.y,s.x,D+s.y,u.x+u.w,u.y,i,I,E.x,b.y,M,A),Hg(g,l.x,l.y,c.x,D+c.y,u.x,u.y+u.h,i,I,b.x,E.y,M,A),Hg(g,l.x,l.y,h.x,D+h.y,u.x+u.w,u.y+u.h,i,I,E.x,E.y,M,A),a){const{x:e,y:i,z:r}=a.anchor,[n,o,s]=a.up;Xg(y,e,i,r,n,o,s),Xg(y,e,i,r,n,o,s),Xg(y,e,i,r,n,o,s),Xg(y,e,i,r,n,o,s),Kg(t.dynamicLayoutVertexArray,e,i,r,w);}else Kg(t.dynamicLayoutVertexArray,l.x,l.y,l.z,w);if(m){const e=v||u;Wg(t.iconTransitioningVertexArray,e.x,e.y),Wg(t.iconTransitioningVertexArray,e.x+e.w,e.y),Wg(t.iconTransitioningVertexArray,e.x,e.y+e.h),Wg(t.iconTransitioningVertexArray,e.x+e.w,e.y+e.h);}_.emplaceBack(z,z+1,z+2),_.emplaceBack(z+1,z+2,z+3),x.vertexLength+=4,x.primitiveLength+=2,this.glyphOffsetArray.emplaceBack(S[0]),r!==e.length-1&&C===e[r+1].sectionIndex||t.programConfigurations.populatePaintArrays(g.length,o,o.index,{},d,p,f,T&&T[C]);}const E=a?a.anchor:l;t.placedSymbolArray.emplaceBack(E.x,E.y,E.z,l.x,l.y,v,this.glyphOffsetArray.length-v,b,c,h,l.segment,i?i[0]:0,i?i[1]:0,r[0],r[1],s,0,!1,0,u,0);}_commitLayoutVertex(t,e,i,r,n,o,s){t.emplaceBack(e,i,r,n,o,Math.round(s.x),Math.round(s.y));}_addCollisionDebugVertices(t,e,i,r,n,o,s){const a=i.segments.prepareSegment(4,i.layoutVertexArray,i.indexArray),l=a.vertexLength,c=s.tileAnchorX,h=s.tileAnchorY;for(let t=0;t<4;t++)i.collisionVertexArray.emplaceBack(0,0,0,0);i.collisionVertexArrayExt.emplaceBack(e,-t.padding,-t.padding),i.collisionVertexArrayExt.emplaceBack(e,t.padding,-t.padding),i.collisionVertexArrayExt.emplaceBack(e,t.padding,t.padding),i.collisionVertexArrayExt.emplaceBack(e,-t.padding,t.padding),this._commitLayoutVertex(i.layoutVertexArray,r,n,o,c,h,new y(t.x1,t.y1)),this._commitLayoutVertex(i.layoutVertexArray,r,n,o,c,h,new y(t.x2,t.y1)),this._commitLayoutVertex(i.layoutVertexArray,r,n,o,c,h,new y(t.x2,t.y2)),this._commitLayoutVertex(i.layoutVertexArray,r,n,o,c,h,new y(t.x1,t.y2)),a.vertexLength+=4;const u=i.indexArray;u.emplaceBack(l,l+1),u.emplaceBack(l+1,l+2),u.emplaceBack(l+2,l+3),u.emplaceBack(l+3,l),a.primitiveLength+=4;}_addTextDebugCollisionBoxes(t,e,i,r,n,o){for(let s=r;s<n;s++){const r=i.get(s),n=this.getSymbolInstanceTextSize(t,o,e,s);this._addCollisionDebugVertices(r,n,this.textCollisionBox,r.projectedAnchorX,r.projectedAnchorY,r.projectedAnchorZ,o);}}_addIconDebugCollisionBoxes(t,e,i,r,n,o){for(let s=r;s<n;s++){const r=i.get(s),n=this.getSymbolInstanceIconSize(t,e,o.placedIconSymbolIndex);this._addCollisionDebugVertices(r,n,this.iconCollisionBox,r.projectedAnchorX,r.projectedAnchorY,r.projectedAnchorZ,o);}}generateCollisionDebugBuffers(t,e){this.hasDebugData()&&this.destroyDebugData(),this.textCollisionBox=new ty(Pa,Wm.members,za),this.iconCollisionBox=new ty(Pa,Wm.members,za);const i=t_(this.iconSizeData,t),r=t_(this.textSizeData,t);for(let n=0;n<this.symbolInstances.length;n++){const o=this.symbolInstances.get(n);this._addTextDebugCollisionBoxes(r,t,e,o.textBoxStartIndex,o.textBoxEndIndex,o),this._addTextDebugCollisionBoxes(r,t,e,o.verticalTextBoxStartIndex,o.verticalTextBoxEndIndex,o),this._addIconDebugCollisionBoxes(i,t,e,o.iconBoxStartIndex,o.iconBoxEndIndex,o),this._addIconDebugCollisionBoxes(i,t,e,o.verticalIconBoxStartIndex,o.verticalIconBoxEndIndex,o);}}getSymbolInstanceTextSize(t,e,i,r){const n=this.text.placedSymbolArray.get(e.rightJustifiedTextSymbolIndex>=0?e.rightJustifiedTextSymbolIndex:e.centerJustifiedTextSymbolIndex>=0?e.centerJustifiedTextSymbolIndex:e.leftJustifiedTextSymbolIndex>=0?e.leftJustifiedTextSymbolIndex:e.verticalPlacedTextSymbolIndex>=0?e.verticalPlacedTextSymbolIndex:r),o=Qm(this.textSizeData,t,n)/Ym;return this.tilePixelRatio*o}getSymbolInstanceIconSize(t,e,i){const r=this.icon.placedSymbolArray.get(i),n=Qm(this.iconSizeData,t,r);return this.tilePixelRatio*n}_commitDebugCollisionVertexUpdate(t,e,i){t.emplaceBack(e,-i,-i),t.emplaceBack(e,i,-i),t.emplaceBack(e,i,i),t.emplaceBack(e,-i,i);}_updateTextDebugCollisionBoxes(t,e,i,r,n,o){for(let s=r;s<n;s++){const r=i.get(s),n=this.getSymbolInstanceTextSize(t,o,e,s);this._commitDebugCollisionVertexUpdate(this.textCollisionBox.collisionVertexArrayExt,n,r.padding);}}_updateIconDebugCollisionBoxes(t,e,i,r,n,o){for(let s=r;s<n;s++){const r=i.get(s),n=this.getSymbolInstanceIconSize(t,e,o);this._commitDebugCollisionVertexUpdate(this.iconCollisionBox.collisionVertexArrayExt,n,r.padding);}}updateCollisionDebugBuffers(t,e){if(!this.hasDebugData())return;this.hasTextCollisionBoxData()&&this.textCollisionBox.collisionVertexArrayExt.clear(),this.hasIconCollisionBoxData()&&this.iconCollisionBox.collisionVertexArrayExt.clear();const i=t_(this.iconSizeData,t),r=t_(this.textSizeData,t);for(let n=0;n<this.symbolInstances.length;n++){const o=this.symbolInstances.get(n);this._updateTextDebugCollisionBoxes(r,t,e,o.textBoxStartIndex,o.textBoxEndIndex,o),this._updateTextDebugCollisionBoxes(r,t,e,o.verticalTextBoxStartIndex,o.verticalTextBoxEndIndex,o),this._updateIconDebugCollisionBoxes(i,t,e,o.iconBoxStartIndex,o.iconBoxEndIndex,o.placedIconSymbolIndex),this._updateIconDebugCollisionBoxes(i,t,e,o.verticalIconBoxStartIndex,o.verticalIconBoxEndIndex,o.placedIconSymbolIndex);}this.hasTextCollisionBoxData()&&this.textCollisionBox.collisionVertexBufferExt&&this.textCollisionBox.collisionVertexBufferExt.updateData(this.textCollisionBox.collisionVertexArrayExt),this.hasIconCollisionBoxData()&&this.iconCollisionBox.collisionVertexBufferExt&&this.iconCollisionBox.collisionVertexBufferExt.updateData(this.iconCollisionBox.collisionVertexArrayExt);}_deserializeCollisionBoxesForSymbol(t,e,i,r,n,o,s,a,l){const c={};if(e<i){const{x1:i,y1:r,x2:n,y2:o,padding:s,projectedAnchorX:a,projectedAnchorY:l,projectedAnchorZ:h,tileAnchorX:u,tileAnchorY:d,featureIndex:p}=t.get(e);c.textBox={x1:i,y1:r,x2:n,y2:o,padding:s,projectedAnchorX:a,projectedAnchorY:l,projectedAnchorZ:h,tileAnchorX:u,tileAnchorY:d},c.textFeatureIndex=p;}if(r<n){const{x1:e,y1:i,x2:n,y2:o,padding:s,projectedAnchorX:a,projectedAnchorY:l,projectedAnchorZ:h,tileAnchorX:u,tileAnchorY:d,featureIndex:p}=t.get(r);c.verticalTextBox={x1:e,y1:i,x2:n,y2:o,padding:s,projectedAnchorX:a,projectedAnchorY:l,projectedAnchorZ:h,tileAnchorX:u,tileAnchorY:d},c.verticalTextFeatureIndex=p;}if(o<s){const{x1:e,y1:i,x2:r,y2:n,padding:s,projectedAnchorX:a,projectedAnchorY:l,projectedAnchorZ:h,tileAnchorX:u,tileAnchorY:d,featureIndex:p}=t.get(o);c.iconBox={x1:e,y1:i,x2:r,y2:n,padding:s,projectedAnchorX:a,projectedAnchorY:l,projectedAnchorZ:h,tileAnchorX:u,tileAnchorY:d},c.iconFeatureIndex=p;}if(a<l){const{x1:e,y1:i,x2:r,y2:n,padding:o,projectedAnchorX:s,projectedAnchorY:l,projectedAnchorZ:h,tileAnchorX:u,tileAnchorY:d,featureIndex:p}=t.get(a);c.verticalIconBox={x1:e,y1:i,x2:r,y2:n,padding:o,projectedAnchorX:s,projectedAnchorY:l,projectedAnchorZ:h,tileAnchorX:u,tileAnchorY:d},c.verticalIconFeatureIndex=p;}return c}deserializeCollisionBoxes(t){this.collisionArrays=[];for(let e=0;e<this.symbolInstances.length;e++){const i=this.symbolInstances.get(e);this.collisionArrays.push(this._deserializeCollisionBoxesForSymbol(t,i.textBoxStartIndex,i.textBoxEndIndex,i.verticalTextBoxStartIndex,i.verticalTextBoxEndIndex,i.iconBoxStartIndex,i.iconBoxEndIndex,i.verticalIconBoxStartIndex,i.verticalIconBoxEndIndex));}}hasTextData(){return this.text.segments.get().length>0}hasIconData(){return this.icon.segments.get().length>0}hasDebugData(){return this.textCollisionBox&&this.iconCollisionBox}hasTextCollisionBoxData(){return this.hasDebugData()&&this.textCollisionBox.segments.get().length>0}hasIconCollisionBoxData(){return this.hasDebugData()&&this.iconCollisionBox.segments.get().length>0}hasIconTextFit(){return this.hasAnyIconTextFit}addIndicesForPlacedSymbol(t,e){const i=t.placedSymbolArray.get(e),r=i.vertexStartIndex+4*i.numGlyphs;for(let e=i.vertexStartIndex;e<r;e+=4)t.indexArray.emplaceBack(e,e+1,e+2),t.indexArray.emplaceBack(e+1,e+2,e+3);}getSortedSymbolIndexes(t){if(this.sortedAngle===t&&void 0!==this.symbolInstanceIndexes)return this.symbolInstanceIndexes;const e=Math.sin(t),i=Math.cos(t),r=[],n=[],o=[];for(let t=0;t<this.symbolInstances.length;++t){o.push(t);const s=this.symbolInstances.get(t);r.push(0|Math.round(e*s.tileAnchorX+i*s.tileAnchorY)),n.push(s.featureIndex);}return o.sort(((t,e)=>r[t]-r[e]||n[e]-n[t])),o}getSortedIndexesByZOffset(){if(!this.zOffsetSortDirty)return this.symbolInstanceIndexesSortedZOffset;if(!this.symbolInstanceIndexesSortedZOffset){this.symbolInstanceIndexesSortedZOffset=[];for(let t=0;t<this.symbolInstances.length;++t)this.symbolInstanceIndexesSortedZOffset.push(t);}return this.zOffsetSortDirty=!1,this.symbolInstanceIndexesSortedZOffset.sort(((t,e)=>this.symbolInstances.get(e).zOffset-this.symbolInstances.get(t).zOffset))}addToSortKeyRanges(t,e){const i=this.sortKeyRanges[this.sortKeyRanges.length-1];i&&i.sortKey===e?i.symbolInstanceEnd=t+1:this.sortKeyRanges.push({sortKey:e,symbolInstanceStart:t,symbolInstanceEnd:t+1});}sortFeatures(t){if(this.sortFeaturesByY&&this.sortedAngle!==t&&!(this.text.segments.get().length>1||this.icon.segments.get().length>1)){this.symbolInstanceIndexes=this.getSortedSymbolIndexes(t),this.sortedAngle=t,this.text.indexArray.clear(),this.icon.indexArray.clear(),this.featureSortOrder=[];for(const t of this.symbolInstanceIndexes){const e=this.symbolInstances.get(t);this.featureSortOrder.push(e.featureIndex);const{rightJustifiedTextSymbolIndex:i,centerJustifiedTextSymbolIndex:r,leftJustifiedTextSymbolIndex:n,verticalPlacedTextSymbolIndex:o,placedIconSymbolIndex:s,verticalPlacedIconSymbolIndex:a}=e;i>=0&&this.addIndicesForPlacedSymbol(this.text,i),r>=0&&r!==i&&this.addIndicesForPlacedSymbol(this.text,r),n>=0&&n!==r&&n!==i&&this.addIndicesForPlacedSymbol(this.text,n),o>=0&&this.addIndicesForPlacedSymbol(this.text,o),s>=0&&this.addIndicesForPlacedSymbol(this.icon,s),a>=0&&this.addIndicesForPlacedSymbol(this.icon,a);}this.text.indexBuffer&&this.text.indexBuffer.updateData(this.text.indexArray),this.icon.indexBuffer&&this.icon.indexBuffer.updateData(this.icon.indexArray);}}}Ss(ey,"SymbolBucket",{omit:["layers","collisionBoxArray","features","compareText"]}),ey.MAX_GLYPHS=65535,ey.addDynamicAttributes=Kg;var iy=ey;const ry=_a([{name:"a_pos_normal",components:2,type:"Int16"},{name:"a_data",components:4,type:"Uint8"},{name:"a_linesofar",components:1,type:"Float32"}],4),{members:ny}=ry,oy=_a([{name:"a_packed",components:4,type:"Float32"}]),{members:sy}=oy,ay=Xf.types,ly=Math.cos(Math.PI/180*37.5);class cy{constructor(t){this.zoom=t.zoom,this.overscaling=t.overscaling,this.layers=t.layers,this.layerIds=this.layers.map((t=>t.id)),this.index=t.index,this.projection=t.projection,this.hasPattern=!1,this.patternFeatures=[],this.lineClipsArray=[],this.gradients={},this.layers.forEach((t=>{this.gradients[t.id]={};})),this.layoutVertexArray=new wa,this.layoutVertexArray2=new Ta,this.indexArray=new Ba,this.programConfigurations=new Fl(t.layers,t.zoom),this.segments=new Wl,this.maxLineLength=0,this.stateDependentLayerIds=this.layers.filter((t=>t.isStateDependent())).map((t=>t.id));}populate(t,e,i,r){this.hasPattern=Mf("line",this.layers,e);const n=this.layers[0].layout.get("line-sort-key"),o=[];for(const{feature:e,id:s,index:a,sourceLayerIndex:l}of t){const t=this.layers[0]._featureFilter.needGeometry,c=op(e,t);if(!this.layers[0]._featureFilter.filter(new Qs(this.zoom),c,i))continue;const h=n?n.evaluate(c,{},i):void 0,u={id:s,properties:e.properties,type:e.type,sourceLayerIndex:l,index:a,geometry:t?c.geometry:np(e,i,r),patterns:{},sortKey:h};o.push(u);}n&&o.sort(((t,e)=>t.sortKey-e.sortKey));const{lineAtlas:s,featureIndex:a}=e,l=this.addConstantDashes(s);for(const r of o){const{geometry:n,index:o,sourceLayerIndex:c}=r;if(l&&this.addFeatureDashes(r,s),this.hasPattern){const t=Af("line",this.layers,r,this.zoom,e);this.patternFeatures.push(t);}else this.addFeature(r,n,o,i,s.positions,e.availableImages,e.brightness);a.insert(t[o].feature,n,o,c,this.index);}}addConstantDashes(t){let e=!1;for(const i of this.layers){const r=i.paint.get("line-dasharray").value,n=i.layout.get("line-cap").value;if("constant"!==r.kind||"constant"!==n.kind)e=!0;else {const e=n.value,i=r.value;if(!i)continue;t.addDash(i,e);}}return e}addFeatureDashes(t,e){const i=this.zoom;for(const r of this.layers){const n=r.paint.get("line-dasharray").value,o=r.layout.get("line-cap").value;if("constant"===n.kind&&"constant"===o.kind)continue;let s,a;if("constant"===n.kind){if(s=n.value,!s)continue}else s=n.evaluate({zoom:i},t);a="constant"===o.kind?o.value:o.evaluate({zoom:i},t),e.addDash(s,a),t.patterns[r.id]=e.getKey(s,a);}}update(t,e,i,r,n){const o=0!==Object.keys(t).length;o&&!this.stateDependentLayers.length||this.programConfigurations.updatePaintArrays(t,e,o?this.stateDependentLayers:this.layers,i,r,n);}addFeatures(t,e,i,r,n,o){for(const t of this.patternFeatures)this.addFeature(t,t.geometry,t.index,e,i,r,o);}isEmpty(){return 0===this.layoutVertexArray.length}uploadPending(){return !this.uploaded||this.programConfigurations.needsUpload}upload(t){this.uploaded||(0!==this.layoutVertexArray2.length&&(this.layoutVertexBuffer2=t.createVertexBuffer(this.layoutVertexArray2,sy)),this.layoutVertexBuffer=t.createVertexBuffer(this.layoutVertexArray,ny),this.indexBuffer=t.createIndexBuffer(this.indexArray)),this.programConfigurations.upload(t),this.uploaded=!0;}destroy(){this.layoutVertexBuffer&&(this.layoutVertexBuffer.destroy(),this.indexBuffer.destroy(),this.programConfigurations.destroy(),this.segments.destroy());}lineFeatureClips(t){if(t.properties&&t.properties.hasOwnProperty("mapbox_clip_start")&&t.properties.hasOwnProperty("mapbox_clip_end"))return {start:+t.properties.mapbox_clip_start,end:+t.properties.mapbox_clip_end}}addFeature(t,e,i,r,n,o,s){const a=this.layers[0].layout,l=a.get("line-join").evaluate(t,{}),c=a.get("line-cap").evaluate(t,{}),h=a.get("line-miter-limit"),u=a.get("line-round-limit");this.lineClips=this.lineFeatureClips(t);for(const i of e)this.addLine(i,t,l,c,h,u);this.programConfigurations.populatePaintArrays(this.layoutVertexArray.length,t,i,n,o,r,s);}addLine(t,e,i,r,n,o){if(this.distance=0,this.scaledDistance=0,this.totalDistance=0,this.lineSoFar=0,this.lineClips){this.lineClipsArray.push(this.lineClips);for(let e=0;e<t.length-1;e++)this.totalDistance+=t[e].dist(t[e+1]);this.updateScaledDistance(),this.maxLineLength=Math.max(this.maxLineLength,this.totalDistance);}const s="Polygon"===ay[e.type];let a=t.length;for(;a>=2&&t[a-1].equals(t[a-2]);)a--;let l=0;for(;l<a-1&&t[l].equals(t[l+1]);)l++;if(a<(s?3:2))return;"bevel"===i&&(n=1.05);const c=this.overscaling<=16?15*sr/(512*this.overscaling):0,h=this.segments.prepareSegment(10*a,this.layoutVertexArray,this.indexArray);let u,d,p,f,m;this.e1=this.e2=-1,s&&(u=t[a-2],m=t[l].sub(u)._unit()._perp());for(let e=l;e<a;e++){if(p=e===a-1?s?t[l+1]:void 0:t[e+1],p&&t[e].equals(p))continue;m&&(f=m),u&&(d=u),u=t[e],m=p?p.sub(u)._unit()._perp():f,f=f||m;let _=f.add(m);0===_.x&&0===_.y||_._unit();const g=f.x*m.x+f.y*m.y,y=_.x*m.x+_.y*m.y,x=0!==y?1/y:1/0,v=2*Math.sqrt(2-2*y),b=y<ly&&d&&p,w=f.x*m.y-f.y*m.x>0;if(b&&e>l){const t=u.dist(d);if(t>2*c){const e=u.sub(u.sub(d)._mult(c/t)._round());this.updateDistance(d,e),this.addCurrentVertex(e,f,0,0,h),d=e;}}const T=d&&p;let E=T?i:s?"butt":r;if(T&&"round"===E&&(x<o?E="miter":x<=2&&(E="fakeround")),"miter"===E&&x>n&&(E="bevel"),"bevel"===E&&(x>2&&(E="flipbevel"),x<n&&(E="miter")),d&&this.updateDistance(d,u),"miter"===E)_._mult(x),this.addCurrentVertex(u,_,0,0,h);else if("flipbevel"===E){if(x>100)_=m.mult(-1);else {const t=x*f.add(m).mag()/f.sub(m).mag();_._perp()._mult(t*(w?-1:1));}this.addCurrentVertex(u,_,0,0,h),this.addCurrentVertex(u,_.mult(-1),0,0,h);}else if("bevel"===E||"fakeround"===E){const t=-Math.sqrt(x*x-1),e=w?t:0,i=w?0:t;if(d&&this.addCurrentVertex(u,f,e,i,h),"fakeround"===E){const t=Math.round(180*v/Math.PI/20);for(let e=1;e<t;e++){let i=e/t;if(.5!==i){const t=i-.5;i+=i*t*(i-1)*((1.0904+g*(g*(3.55645-1.43519*g)-3.2452))*t*t+(.848013+g*(.215638*g-1.06021)));}const r=m.sub(f)._mult(i)._add(f)._unit()._mult(w?-1:1);this.addHalfVertex(u,r.x,r.y,!1,w,0,h);}}p&&this.addCurrentVertex(u,m,-e,-i,h);}else if("butt"===E)this.addCurrentVertex(u,_,0,0,h);else if("square"===E){const t=d?1:-1;d||this.addCurrentVertex(u,_,t,t,h),this.addCurrentVertex(u,_,0,0,h),d&&this.addCurrentVertex(u,_,t,t,h);}else "round"===E&&(d&&(this.addCurrentVertex(u,f,0,0,h),this.addCurrentVertex(u,f,1,1,h,!0)),p&&(this.addCurrentVertex(u,m,-1,-1,h,!0),this.addCurrentVertex(u,m,0,0,h)));if(b&&e<a-1){const t=u.dist(p);if(t>2*c){const e=u.add(p.sub(u)._mult(c/t)._round());this.updateDistance(u,e),this.addCurrentVertex(e,m,0,0,h),u=e;}}}}addCurrentVertex(t,e,i,r,n,o=!1){const s=e.y*r-e.x,a=-e.y-e.x*r;this.addHalfVertex(t,e.x+e.y*i,e.y-e.x*i,o,!1,i,n),this.addHalfVertex(t,s,a,o,!0,-r,n);}addHalfVertex({x:t,y:e},i,r,n,o,s,a){this.layoutVertexArray.emplaceBack((t<<1)+(n?1:0),(e<<1)+(o?1:0),Math.round(63*i)+128,Math.round(63*r)+128,1+(0===s?0:s<0?-1:1),0,this.lineSoFar),this.lineClips&&this.layoutVertexArray2.emplaceBack(this.scaledDistance,this.lineClipsArray.length,this.lineClips.start,this.lineClips.end);const l=a.vertexLength++;this.e1>=0&&this.e2>=0&&(this.indexArray.emplaceBack(this.e1,this.e2,l),a.primitiveLength++),o?this.e2=l:this.e1=l;}updateScaledDistance(){if(this.lineClips){const t=this.totalDistance/(this.lineClips.end-this.lineClips.start);this.scaledDistance=this.distance/this.totalDistance,this.lineSoFar=t*this.lineClips.start+this.distance;}else this.lineSoFar=this.distance;}updateDistance(t,e){this.distance+=t.dist(e),this.updateScaledDistance();}}Ss(cy,"LineBucket",{omit:["layers","patternFeatures"]});class hy{constructor(t,e,i,r){this.context=t,this.format=i,this.texture=t.gl.createTexture(),this.update(e,r);}update(t,i,r){const{width:n,height:o}=t,{context:s}=this,{gl:a}=s,{HTMLImageElement:l,HTMLCanvasElement:c,HTMLVideoElement:h,ImageData:u,ImageBitmap:d}=e;if(a.bindTexture(a.TEXTURE_2D,this.texture),s.pixelStoreUnpackFlipY.set(!1),s.pixelStoreUnpack.set(1),s.pixelStoreUnpackPremultiplyAlpha.set(this.format===a.RGBA&&(!i||!1!==i.premultiply)),r||this.size&&this.size[0]===n&&this.size[1]===o){const{x:e,y:i}=r||{x:0,y:0};if(t instanceof l||t instanceof c||t instanceof h||t instanceof u||d&&t instanceof d)a.texSubImage2D(a.TEXTURE_2D,0,e,i,a.RGBA,a.UNSIGNED_BYTE,t);else {let r=this.format,s=a.UNSIGNED_BYTE;this.format===a.R32F&&(r=a.RED,s=a.FLOAT),a.texSubImage2D(a.TEXTURE_2D,0,e,i,n,o,r,s,t.data);}}else if(this.size=[n,o],t instanceof l||t instanceof c||t instanceof h||t instanceof u||d&&t instanceof d){let e=this.format;this.format===a.R8&&(e=a.RED),a.texImage2D(a.TEXTURE_2D,0,this.format,e,a.UNSIGNED_BYTE,t);}else {let e=this.format,i=this.format,r=a.UNSIGNED_BYTE;this.format===a.DEPTH_COMPONENT&&(e=a.DEPTH_COMPONENT16,r=a.UNSIGNED_SHORT),this.format===a.R32F&&(r=a.FLOAT,i=a.RED),a.texImage2D(a.TEXTURE_2D,0,e,n,o,0,i,r,t.data);}this.useMipmap=Boolean(i&&i.useMipmap),this.useMipmap&&a.generateMipmap(a.TEXTURE_2D);}bind(t,e){const{context:i}=this,{gl:r}=i;r.bindTexture(r.TEXTURE_2D,this.texture),t!==this.minFilter&&(r.texParameteri(r.TEXTURE_2D,r.TEXTURE_MAG_FILTER,t),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_MIN_FILTER,this.useMipmap?t===r.NEAREST?r.NEAREST_MIPMAP_NEAREST:r.LINEAR_MIPMAP_NEAREST:t),this.minFilter=t),e!==this.wrapS&&(r.texParameteri(r.TEXTURE_2D,r.TEXTURE_WRAP_S,e),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_WRAP_T,e),this.wrapS=e);}bindExtraParam(t,e,i,r){const{context:n}=this,{gl:o}=n;o.bindTexture(o.TEXTURE_2D,this.texture),e!==this.magFilter&&(o.texParameteri(o.TEXTURE_2D,o.TEXTURE_MAG_FILTER,e),this.magFilter=e),t!==this.minFilter&&(o.texParameteri(o.TEXTURE_2D,o.TEXTURE_MIN_FILTER,this.useMipmap?t===o.NEAREST?o.NEAREST_MIPMAP_NEAREST:o.LINEAR_MIPMAP_NEAREST:t),this.minFilter=t),i!==this.wrapS&&(o.texParameteri(o.TEXTURE_2D,o.TEXTURE_WRAP_S,i),this.wrapS=i),r!==this.wrapT&&(o.texParameteri(o.TEXTURE_2D,o.TEXTURE_WRAP_T,r),this.wrapT=r);}destroy(){const{gl:t}=this.context;t.deleteTexture(this.texture),this.texture=null;}}const uy=32,dy=33,py=new Uint16Array(8184);for(let t=0;t<2046;t++){let e=t+2,i=0,r=0,n=0,o=0,s=0,a=0;for(1&e?n=o=s=uy:i=r=a=uy;(e>>=1)>1;){const t=i+n>>1,l=r+o>>1;1&e?(n=i,o=r,i=s,r=a):(i=n,r=o,n=s,o=a),s=t,a=l;}const l=4*t;py[l+0]=i,py[l+1]=r,py[l+2]=n,py[l+3]=o;}const fy=new Uint16Array(2178),my=new Uint8Array(1089),_y=new Uint16Array(1089);function gy(t){return 0===t?-.03125:32===t?.03125:0}var yy=_a([{name:"a_pos",type:"Int16",components:2},{name:"a_texture_pos",type:"Int16",components:2}]);const xy={type:2,extent:sr,loadGeometry:()=>[[new y(0,0),new y(sr+1,0),new y(sr+1,sr+1),new y(0,sr+1),new y(0,0)]]};class vy{constructor(t,e,i,r,n){this.tileID=t,this.uid=F(),this.uses=0,this.tileSize=e,this.tileZoom=i,this.buckets={},this.expirationTime=null,this.queryPadding=0,this.hasSymbolBuckets=!1,this.hasRTLText=!1,this.dependencies={},this.isRaster=n,r&&r.style&&(this._lastUpdatedBrightness=r.style.getBrightness()),this.expiredRequestCount=0,this.state="loading",r&&r.transform&&(this.projection=r.transform.projection);}registerFadeDuration(t){const e=t+this.timeAdded;e<ue.now()||this.fadeEndTime&&e<this.fadeEndTime||(this.fadeEndTime=e);}wasRequested(){return "errored"===this.state||"loaded"===this.state||"reloading"===this.state}get tileTransform(){return this._tileTransform||(this._tileTransform=_g(this.tileID.canonical,this.projection)),this._tileTransform}loadVectorData(t,e,i){if(this.unloadVectorData(),this.state="loaded",t){t.featureIndex&&(this.latestFeatureIndex=t.featureIndex,t.rawTileData?(this.latestRawTileData=t.rawTileData,this.latestFeatureIndex.rawTileData=t.rawTileData):this.latestRawTileData&&(this.latestFeatureIndex.rawTileData=this.latestRawTileData)),this.collisionBoxArray=t.collisionBoxArray,this.buckets=function(t,e){const i={};if(!e)return i;for(const r of t){const t=r.layerIds.map((t=>e.getLayer(t))).filter(Boolean);if(0!==t.length){r.layers=t,r.stateDependentLayerIds&&(r.stateDependentLayers=r.stateDependentLayerIds.map((e=>t.filter((t=>t.id===e))[0])));for(const e of t)i[e.id]=r;}}return i}(t.buckets,e.style),this.hasSymbolBuckets=!1;for(const t in this.buckets){const e=this.buckets[t];if(e instanceof iy){if(this.hasSymbolBuckets=!0,!i)break;e.justReloaded=!0;}}if(this.hasRTLText=!1,this.hasSymbolBuckets)for(const t in this.buckets){const e=this.buckets[t];if(e instanceof iy&&e.hasRTLText){this.hasRTLText=!0,Js.isLoading()||Js.isLoaded()||"deferred"!==Ys()||Ks();break}}this.queryPadding=0;for(const t in this.buckets){const i=this.buckets[t];this.queryPadding=Math.max(this.queryPadding,e.style.getLayer(t).queryRadius(i));}t.imageAtlas&&(this.imageAtlas=t.imageAtlas),t.glyphAtlasImage&&(this.glyphAtlasImage=t.glyphAtlasImage),t.lineAtlas&&(this.lineAtlas=t.lineAtlas),this._lastUpdatedBrightness=t.brightness;}else this.collisionBoxArray=new Xa;}unloadVectorData(){if(this.hasData()){for(const t in this.buckets)this.buckets[t].destroy();this.buckets={},this.imageAtlas&&(this.imageAtlas=null),this.lineAtlas&&(this.lineAtlas=null),this.imageAtlasTexture&&this.imageAtlasTexture.destroy(),this.glyphAtlasTexture&&this.glyphAtlasTexture.destroy(),this.lineAtlasTexture&&this.lineAtlasTexture.destroy(),this._tileBoundsBuffer&&(this._tileBoundsBuffer.destroy(),this._tileBoundsIndexBuffer.destroy(),this._tileBoundsSegments.destroy(),this._tileBoundsBuffer=null),this._tileDebugBuffer&&(this._tileDebugBuffer.destroy(),this._tileDebugSegments.destroy(),this._tileDebugBuffer=null),this._tileDebugIndexBuffer&&(this._tileDebugIndexBuffer.destroy(),this._tileDebugIndexBuffer=null),this._globeTileDebugBorderBuffer&&(this._globeTileDebugBorderBuffer.destroy(),this._globeTileDebugBorderBuffer=null),this._tileDebugTextBuffer&&(this._tileDebugTextBuffer.destroy(),this._tileDebugTextSegments.destroy(),this._tileDebugTextIndexBuffer.destroy(),this._tileDebugTextBuffer=null),this._globeTileDebugTextBuffer&&(this._globeTileDebugTextBuffer.destroy(),this._globeTileDebugTextBuffer=null),this.latestFeatureIndex=null,this.state="unloaded";}}getBucket(t){return this.buckets[t.id]}upload(t){for(const e in this.buckets){const i=this.buckets[e];i.uploadPending()&&i.upload(t);}const e=t.gl;this.imageAtlas&&!this.imageAtlas.uploaded&&(this.imageAtlasTexture=new hy(t,this.imageAtlas.image,e.RGBA),this.imageAtlas.uploaded=!0),this.glyphAtlasImage&&(this.glyphAtlasTexture=new hy(t,this.glyphAtlasImage,e.ALPHA),this.glyphAtlasImage=null),this.lineAtlas&&!this.lineAtlas.uploaded&&(this.lineAtlasTexture=new hy(t,this.lineAtlas.image,e.ALPHA),this.lineAtlas.uploaded=!0);}prepare(t,e,i){if(this.imageAtlas&&this.imageAtlas.patchUpdatedImages(t,this.imageAtlasTexture,i),!e||!this.latestFeatureIndex||!this.latestFeatureIndex.rawTileData)return;const r=e.style.getBrightness();(this._lastUpdatedBrightness||r)&&(this._lastUpdatedBrightness&&r&&Math.abs(this._lastUpdatedBrightness-r)<.001||(this._lastUpdatedBrightness=r,this.updateBuckets(void 0,e)));}queryRenderedFeatures(t,e,i,r,n,o,s,a){return this.latestFeatureIndex&&this.latestFeatureIndex.rawTileData?this.latestFeatureIndex.query({tileResult:r,pixelPosMatrix:s,transform:o,params:n,tileTransform:this.tileTransform},t,e,i):{}}querySourceFeatures(t,e){const i=this.latestFeatureIndex;if(!i||!i.rawTileData)return;const r=i.loadVTLayers(),n=e?e.sourceLayer:"",o=r._geojsonTileLayer||r[n];if(!o)return;const s=Po(e&&e.filter),{z:a,x:l,y:c}=this.tileID.canonical,h={z:a,x:l,y:c};for(let e=0;e<o.length;e++){const r=o.feature(e);if(s.needGeometry){const t=op(r,!0);if(!s.filter(new Qs(this.tileID.overscaledZ),t,this.tileID.canonical))continue}else if(!s.filter(new Qs(this.tileID.overscaledZ),r))continue;const u=i.getId(r,n),d=new wm(r,a,l,c,u);d.tile=h,t.push(d);}}hasData(){return "loaded"===this.state||"reloading"===this.state||"expired"===this.state}bucketsLoaded(){for(const t in this.buckets)if(this.buckets[t].uploadPending())return !1;return !0}patternsLoaded(){return !!this.imageAtlas&&!!Object.keys(this.imageAtlas.patternPositions).length}setExpiryData(t){const e=this.expirationTime;if(t.cacheControl){const e=tt(t.cacheControl);e["max-age"]&&(this.expirationTime=Date.now()+1e3*e["max-age"]);}else t.expires&&(this.expirationTime=new Date(t.expires).getTime());if(this.expirationTime){const t=Date.now();let i=!1;if(this.expirationTime>t)i=!1;else if(e)if(this.expirationTime<e)i=!0;else {const r=this.expirationTime-e;r?this.expirationTime=t+Math.max(r,3e4):i=!0;}else i=!0;i?(this.expiredRequestCount++,this.state="expired"):this.expiredRequestCount=0;}}getExpiryTimeout(){if(this.expirationTime)return this.expiredRequestCount?1e3*(1<<Math.min(this.expiredRequestCount-1,31)):Math.min(this.expirationTime-(new Date).getTime(),Math.pow(2,31)-1)}setFeatureState(t,e){this.latestFeatureIndex&&this.latestFeatureIndex.rawTileData&&0!==Object.keys(t).length&&e&&this.updateBuckets(t,e);}updateBuckets(t,e){if(!this.latestFeatureIndex)return;const i=this.latestFeatureIndex.loadVTLayers(),r=e.style.listImages(),n=e.style.getBrightness();for(const o in this.buckets){if(!e.style.hasLayer(o))continue;const s=this.buckets[o],a=s.layers[0].sourceLayer||"_geojsonTileLayer",l=i[a];let c={};if(t&&(c=t[a],!l||!c||0===Object.keys(c).length))continue;if(s.update(c,l,r,this.imageAtlas&&this.imageAtlas.patternPositions||{},n),s instanceof cy||s instanceof Sf){const t=e.style._getSourceCache(s.layers[0].source);e._terrain&&e._terrain.enabled&&t&&s.programConfigurations.needsUpload&&e._terrain._clearRenderCacheForTile(t.id,this.tileID);}const h=e&&e.style&&e.style.getLayer(o);h&&(this.queryPadding=Math.max(this.queryPadding,h.queryRadius(s)));}}holdingForFade(){return void 0!==this.symbolFadeHoldUntil}symbolFadeFinished(){return !this.symbolFadeHoldUntil||this.symbolFadeHoldUntil<ue.now()}clearFadeHold(){this.symbolFadeHoldUntil=void 0;}setHoldDuration(t){this.symbolFadeHoldUntil=ue.now()+t;}setTexture(t,e){const i=e.context,r=i.gl;this.texture=this.texture||e.getTileTexture(t.width),this.texture?this.texture.update(t,{useMipmap:!0}):(this.texture=new hy(i,t,r.RGBA,{useMipmap:!0}),this.texture.bind(r.LINEAR,r.CLAMP_TO_EDGE));}setDependencies(t,e){const i={};for(const t of e)i[t]=!0;this.dependencies[t]=i;}hasDependency(t,e){for(const i of t){const t=this.dependencies[i];if(t)for(const i of e)if(t[i])return !0}return !1}clearQueryDebugViz(){}_makeDebugTileBoundsBuffers(t,e){if(!e||"mercator"===e.name||this._tileDebugBuffer)return;const i=np(xy,this.tileID.canonical,this.tileTransform)[0],r=new ya,n=new Ga;for(let t=0;t<i.length;t++){const{x:e,y:o}=i[t];r.emplaceBack(e,o),n.emplaceBack(t);}n.emplaceBack(0),this._tileDebugIndexBuffer=t.createIndexBuffer(n),this._tileDebugBuffer=t.createVertexBuffer(r,Iu.members),this._tileDebugSegments=Wl.simpleSegment(0,0,r.length,n.length);}_makeTileBoundsBuffers(t,e){if(this._tileBoundsBuffer||!e||"mercator"===e.name)return;const i=np(xy,this.tileID.canonical,this.tileTransform)[0];let r,n;if(this.isRaster){const t=function(t,e){const i=_g(t,e),r=Math.pow(2,t.z);for(let n=0;n<dy;n++)for(let o=0;o<dy;o++){const s=jd((t.x+(o+gy(o))/uy)/r),a=Gd((t.y+(n+gy(n))/uy)/r),l=e.project(s,a),c=n*dy+o;fy[2*c+0]=Math.round((l.x*i.scale-i.x)*sr),fy[2*c+1]=Math.round((l.y*i.scale-i.y)*sr);}my.fill(0),_y.fill(0);for(let t=2045;t>=0;t--){const e=4*t,i=py[e+0],r=py[e+1],n=py[e+2],o=py[e+3],s=i+n>>1,a=r+o>>1,l=s+a-r,c=a+i-s,h=r*dy+i,u=o*dy+n,d=a*dy+s,p=Math.hypot((fy[2*h+0]+fy[2*u+0])/2-fy[2*d+0],(fy[2*h+1]+fy[2*u+1])/2-fy[2*d+1])>=16;my[d]=my[d]||(p?1:0),t<1022&&(my[d]=my[d]||my[(r+c>>1)*dy+(i+l>>1)]||my[(o+c>>1)*dy+(n+l>>1)]);}const n=new va,o=new Ba;let s=0;function a(t,e){const i=e*dy+t;return 0===_y[i]&&(n.emplaceBack(fy[2*i+0],fy[2*i+1],t*sr/uy,e*sr/uy),_y[i]=++s),_y[i]-1}function l(t,e,i,r,n,s){const c=t+i>>1,h=e+r>>1;if(Math.abs(t-n)+Math.abs(e-s)>1&&my[h*dy+c])l(n,s,t,e,c,h),l(i,r,n,s,c,h);else {const l=a(t,e),c=a(i,r),h=a(n,s);o.emplaceBack(l,c,h);}}return l(0,0,uy,uy,uy,0),l(uy,uy,0,0,0,uy),{vertices:n,indices:o}}(this.tileID.canonical,e);r=t.vertices,n=t.indices;}else {r=new va,n=new Ba;for(const{x:t,y:e}of i)r.emplaceBack(t,e,0,0);const t=wf(r.int16,void 0,4);for(let e=0;e<t.length;e+=3)n.emplaceBack(t[e],t[e+1],t[e+2]);}this._tileBoundsBuffer=t.createVertexBuffer(r,yy.members),this._tileBoundsIndexBuffer=t.createIndexBuffer(n),this._tileBoundsSegments=Wl.simpleSegment(0,0,r.length,n.length);}_makeGlobeTileDebugBuffers(t,e){const i=e.projection;if(!i||"globe"!==i.name||e.freezeTileCoverage)return;const r=this.tileID.canonical,n=ld(Ju(r,e)),o=pd(e.zoom);let s;o>0&&(s=mu.invert(new Float64Array(16),e.globeMatrix)),this._makeGlobeTileDebugBorderBuffer(t,r,e,n,s,o),this._makeGlobeTileDebugTextBuffer(t,r,e,n,s,o);}_globePoint(t,e,i,r,n,o,s){let a=od(t,e,i);if(o){const n=1<<i.z,l=Nd(r.center.lng),c=Ud(r.center.lat),h=(i.x+.5)/n-l;let u=0;h>.5?u=-1:h<-.5&&(u=1);let d=(t/sr+i.x)/n+u,p=(e/sr+i.y)/n;d=(d-l)*r._pixelsPerMercatorPixel+l,p=(p-c)*r._pixelsPerMercatorPixel+c;const f=[d*r.worldSize,p*r.worldSize,0];bu.transformMat4(f,f,o),a=Ku(a,f,s);}return bu.transformMat4(a,a,n)}_makeGlobeTileDebugBorderBuffer(t,e,i,r,n,o){const s=new ya,a=new Ga,l=new xa,c=(t,c,h,u,d)=>{const p=(h-t)/(d-1),f=(u-c)/(d-1),m=s.length;for(let h=0;h<d;h++){const u=t+h*p,d=c+h*f;s.emplaceBack(u,d);const _=this._globePoint(u,d,e,i,r,n,o);l.emplaceBack(_[0],_[1],_[2]),a.emplaceBack(m+h);}},h=sr;c(0,0,h,0,16),c(h,0,h,h,16),c(h,h,0,h,16),c(0,h,0,0,16),this._tileDebugIndexBuffer=t.createIndexBuffer(a),this._tileDebugBuffer=t.createVertexBuffer(s,Iu.members),this._globeTileDebugBorderBuffer=t.createVertexBuffer(l,Su.members),this._tileDebugSegments=Wl.simpleSegment(0,0,s.length,a.length);}_makeGlobeTileDebugTextBuffer(t,e,i,r,n,o){const s=sr/4,a=new ya,l=new Ba,c=new xa,h=25;l.reserve(32),a.reserve(h),c.reserve(h);const u=(t,e)=>h*t+e;for(let t=0;t<h;t++){const l=t*s;for(let t=0;t<h;t++){const h=t*s;a.emplaceBack(h,l);const u=this._globePoint(h,l,e,i,r,n,o);c.emplaceBack(u[0],u[1],u[2]);}}for(let t=0;t<4;t++)for(let e=0;e<4;e++){const i=u(t,e),r=u(t,e+1),n=u(t+1,e),o=u(t+1,e+1);l.emplaceBack(i,r,n),l.emplaceBack(n,r,o);}this._tileDebugTextIndexBuffer=t.createIndexBuffer(l),this._tileDebugTextBuffer=t.createVertexBuffer(a,Iu.members),this._globeTileDebugTextBuffer=t.createVertexBuffer(c,Su.members),this._tileDebugTextSegments=Wl.simpleSegment(0,0,h,32);}}class by{constructor(t,e){this.max=t,this.onRemove=e,this.reset();}reset(){for(const t in this.data)for(const e of this.data[t])e.timeout&&clearTimeout(e.timeout),this.onRemove(e.value);return this.data={},this.order=[],this}add(t,e,i){const r=t.wrapped().key;void 0===this.data[r]&&(this.data[r]=[]);const n={value:e,timeout:void 0};if(void 0!==i&&(n.timeout=setTimeout((()=>{this.remove(t,n);}),i)),this.data[r].push(n),this.order.push(r),this.order.length>this.max){const t=this._getAndRemoveByKey(this.order[0]);t&&this.onRemove(t);}return this}has(t){return t.wrapped().key in this.data}getAndRemove(t){return this.has(t)?this._getAndRemoveByKey(t.wrapped().key):null}_getAndRemoveByKey(t){const e=this.data[t].shift();return e.timeout&&clearTimeout(e.timeout),0===this.data[t].length&&delete this.data[t],this.order.splice(this.order.indexOf(t),1),e.value}getByKey(t){const e=this.data[t];return e?e[0].value:null}get(t){return this.has(t)?this.data[t.wrapped().key][0].value:null}remove(t,e){if(!this.has(t))return this;const i=t.wrapped().key,r=void 0===e?0:this.data[i].indexOf(e),n=this.data[i][r];return this.data[i].splice(r,1),n.timeout&&clearTimeout(n.timeout),0===this.data[i].length&&delete this.data[i],this.onRemove(n.value),this.order.splice(this.order.indexOf(i),1),this}setMaxSize(t){for(this.max=t;this.order.length>this.max;){const t=this._getAndRemoveByKey(this.order[0]);t&&this.onRemove(t);}return this}filter(t){const e=[];for(const i in this.data)for(const r of this.data[i])t(r.value)||e.push(r);for(const t of e)this.remove(t.value.tileID,t);}}class wy{constructor(t,e,i,r){this.id=wy.uniqueIdxCounter,wy.uniqueIdxCounter++,this.context=t;const n=t.gl;this.buffer=n.createBuffer(),this.dynamicDraw=Boolean(i),this.context.unbindVAO(),t.bindElementBuffer.set(this.buffer),n.bufferData(n.ELEMENT_ARRAY_BUFFER,e.arrayBuffer,this.dynamicDraw?n.DYNAMIC_DRAW:n.STATIC_DRAW),this.dynamicDraw||r||e.destroy();}bind(){this.context.bindElementBuffer.set(this.buffer);}updateData(t){this.id=wy.uniqueIdxCounter,wy.uniqueIdxCounter++;const e=this.context.gl;this.context.unbindVAO(),this.bind(),e.bufferSubData(e.ELEMENT_ARRAY_BUFFER,0,t.arrayBuffer);}destroy(){this.buffer&&(this.context.gl.deleteBuffer(this.buffer),delete this.buffer);}}wy.uniqueIdxCounter=0;const Ty={Int8:"BYTE",Uint8:"UNSIGNED_BYTE",Int16:"SHORT",Uint16:"UNSIGNED_SHORT",Int32:"INT",Uint32:"UNSIGNED_INT",Float32:"FLOAT"};class Ey{constructor(t,e,i,r,n,o){this.length=e.length,this.attributes=i,this.itemSize=e.bytesPerElement,this.dynamicDraw=r,this.instanceCount=o,this.context=t;const s=t.gl;this.buffer=s.createBuffer(),t.bindVertexBuffer.set(this.buffer),s.bufferData(s.ARRAY_BUFFER,e.arrayBuffer,this.dynamicDraw?s.DYNAMIC_DRAW:s.STATIC_DRAW),this.dynamicDraw||n||e.destroy();}bind(){this.context.bindVertexBuffer.set(this.buffer);}updateData(t){const e=this.context.gl;this.bind(),e.bufferSubData(e.ARRAY_BUFFER,0,t.arrayBuffer);}enableAttributes(t,e){for(let i=0;i<this.attributes.length;i++){const r=e.attributes[this.attributes[i].name];void 0!==r&&t.enableVertexAttribArray(r);}}setVertexAttribPointers(t,e,i){for(let r=0;r<this.attributes.length;r++){const n=this.attributes[r],o=e.attributes[n.name];void 0!==o&&t.vertexAttribPointer(o,n.components,t[Ty[n.type]],!1,this.itemSize,n.offset+this.itemSize*(i||0));}}setVertexAttribDivisor(t,e,i){for(let r=0;r<this.attributes.length;r++){const n=e.attributes[this.attributes[r].name];void 0!==n&&this.instanceCount&&this.instanceCount>0&&t.vertexAttribDivisor(n,i);}}destroy(){this.buffer&&(this.context.gl.deleteBuffer(this.buffer),delete this.buffer);}}class My{constructor(t){this.gl=t.gl,this.default=this.getDefault(),this.current=this.default,this.dirty=!1;}get(){return this.current}set(t){}getDefault(){return this.default}setDefault(){this.set(this.default);}}class Ay extends My{getDefault(){return li.transparent}set(t){const e=this.current;(t.r!==e.r||t.g!==e.g||t.b!==e.b||t.a!==e.a||this.dirty)&&(this.gl.clearColor(t.r,t.g,t.b,t.a),this.current=t,this.dirty=!1);}}class Sy extends My{getDefault(){return 1}set(t){(t!==this.current||this.dirty)&&(this.gl.clearDepth(t),this.current=t,this.dirty=!1);}}class Iy extends My{getDefault(){return 0}set(t){(t!==this.current||this.dirty)&&(this.gl.clearStencil(t),this.current=t,this.dirty=!1);}}class Cy extends My{getDefault(){return [!0,!0,!0,!0]}set(t){const e=this.current;(t[0]!==e[0]||t[1]!==e[1]||t[2]!==e[2]||t[3]!==e[3]||this.dirty)&&(this.gl.colorMask(t[0],t[1],t[2],t[3]),this.current=t,this.dirty=!1);}}class zy extends My{getDefault(){return !0}set(t){(t!==this.current||this.dirty)&&(this.gl.depthMask(t),this.current=t,this.dirty=!1);}}class Dy extends My{getDefault(){return 255}set(t){(t!==this.current||this.dirty)&&(this.gl.stencilMask(t),this.current=t,this.dirty=!1);}}class Py extends My{getDefault(){return {func:this.gl.ALWAYS,ref:0,mask:255}}set(t){const e=this.current;(t.func!==e.func||t.ref!==e.ref||t.mask!==e.mask||this.dirty)&&(this.gl.stencilFunc(t.func,t.ref,t.mask),this.current=t,this.dirty=!1);}}class Ry extends My{getDefault(){const t=this.gl;return [t.KEEP,t.KEEP,t.KEEP]}set(t){const e=this.current;(t[0]!==e[0]||t[1]!==e[1]||t[2]!==e[2]||this.dirty)&&(this.gl.stencilOp(t[0],t[1],t[2]),this.current=t,this.dirty=!1);}}class Ly extends My{getDefault(){return !1}set(t){if(t===this.current&&!this.dirty)return;const e=this.gl;t?e.enable(e.STENCIL_TEST):e.disable(e.STENCIL_TEST),this.current=t,this.dirty=!1;}}class ky extends My{getDefault(){return [0,1]}set(t){const e=this.current;(t[0]!==e[0]||t[1]!==e[1]||this.dirty)&&(this.gl.depthRange(t[0],t[1]),this.current=t,this.dirty=!1);}}class By extends My{getDefault(){return !1}set(t){if(t===this.current&&!this.dirty)return;const e=this.gl;t?e.enable(e.DEPTH_TEST):e.disable(e.DEPTH_TEST),this.current=t,this.dirty=!1;}}class Oy extends My{getDefault(){return this.gl.LESS}set(t){(t!==this.current||this.dirty)&&(this.gl.depthFunc(t),this.current=t,this.dirty=!1);}}class Fy extends My{getDefault(){return !1}set(t){if(t===this.current&&!this.dirty)return;const e=this.gl;t?e.enable(e.BLEND):e.disable(e.BLEND),this.current=t,this.dirty=!1;}}class Ny extends My{getDefault(){const t=this.gl;return [t.ONE,t.ZERO,t.ONE,t.ZERO]}set(t){const e=this.current;(t[0]!==e[0]||t[1]!==e[1]||t[2]!==e[2]||t[3]!==e[3]||this.dirty)&&(this.gl.blendFuncSeparate(t[0],t[1],t[2],t[3]),this.current=t,this.dirty=!1);}}class Uy extends My{getDefault(){return li.transparent}set(t){const e=this.current;(t.r!==e.r||t.g!==e.g||t.b!==e.b||t.a!==e.a||this.dirty)&&(this.gl.blendColor(t.r,t.g,t.b,t.a),this.current=t,this.dirty=!1);}}class Vy extends My{getDefault(){return this.gl.FUNC_ADD}set(t){(t!==this.current||this.dirty)&&(this.gl.blendEquationSeparate(t,t),this.current=t,this.dirty=!1);}}class jy extends My{getDefault(){return !1}set(t){if(t===this.current&&!this.dirty)return;const e=this.gl;t?e.enable(e.CULL_FACE):e.disable(e.CULL_FACE),this.current=t,this.dirty=!1;}}class Gy extends My{getDefault(){return this.gl.BACK}set(t){(t!==this.current||this.dirty)&&(this.gl.cullFace(t),this.current=t,this.dirty=!1);}}class qy extends My{getDefault(){return this.gl.CCW}set(t){(t!==this.current||this.dirty)&&(this.gl.frontFace(t),this.current=t,this.dirty=!1);}}let Zy=class extends My{getDefault(){return null}set(t){(t!==this.current||this.dirty)&&(this.gl.useProgram(t),this.current=t,this.dirty=!1);}};class $y extends My{getDefault(){return this.gl.TEXTURE0}set(t){(t!==this.current||this.dirty)&&(this.gl.activeTexture(t),this.current=t,this.dirty=!1);}}class Hy extends My{getDefault(){const t=this.gl;return [0,0,t.drawingBufferWidth,t.drawingBufferHeight]}set(t){const e=this.current;(t[0]!==e[0]||t[1]!==e[1]||t[2]!==e[2]||t[3]!==e[3]||this.dirty)&&(this.gl.viewport(t[0],t[1],t[2],t[3]),this.current=t,this.dirty=!1);}}class Wy extends My{getDefault(){return null}set(t){if(t===this.current&&!this.dirty)return;const e=this.gl;e.bindFramebuffer(e.FRAMEBUFFER,t),this.current=t,this.dirty=!1;}}class Xy extends My{getDefault(){return null}set(t){if(t===this.current&&!this.dirty)return;const e=this.gl;e.bindRenderbuffer(e.RENDERBUFFER,t),this.current=t,this.dirty=!1;}}class Yy extends My{getDefault(){return null}set(t){if(t===this.current&&!this.dirty)return;const e=this.gl;e.bindTexture(e.TEXTURE_2D,t),this.current=t,this.dirty=!1;}}class Ky extends My{getDefault(){return null}set(t){if(t===this.current&&!this.dirty)return;const e=this.gl;e.bindBuffer(e.ARRAY_BUFFER,t),this.current=t,this.dirty=!1;}}class Jy extends My{getDefault(){return null}set(t){const e=this.gl;e.bindBuffer(e.ELEMENT_ARRAY_BUFFER,t),this.current=t,this.dirty=!1;}}class Qy extends My{getDefault(){return null}set(t){this.gl&&(t!==this.current||this.dirty)&&(this.gl.bindVertexArray(t),this.current=t,this.dirty=!1);}}class tx extends My{getDefault(){return 4}set(t){if(t===this.current&&!this.dirty)return;const e=this.gl;e.pixelStorei(e.UNPACK_ALIGNMENT,t),this.current=t,this.dirty=!1;}}class ex extends My{getDefault(){return !1}set(t){if(t===this.current&&!this.dirty)return;const e=this.gl;e.pixelStorei(e.UNPACK_PREMULTIPLY_ALPHA_WEBGL,t),this.current=t,this.dirty=!1;}}class ix extends My{getDefault(){return !1}set(t){if(t===this.current&&!this.dirty)return;const e=this.gl;e.pixelStorei(e.UNPACK_FLIP_Y_WEBGL,t),this.current=t,this.dirty=!1;}}class rx extends My{constructor(t,e){super(t),this.context=t,this.parent=e;}getDefault(){return null}}class nx extends rx{setDirty(){this.dirty=!0;}set(t){if(t===this.current&&!this.dirty)return;this.context.bindFramebuffer.set(this.parent);const e=this.gl;e.framebufferTexture2D(e.FRAMEBUFFER,e.COLOR_ATTACHMENT0,e.TEXTURE_2D,t,0),this.current=t,this.dirty=!1;}}class ox extends rx{attachment(){return this.gl.DEPTH_ATTACHMENT}set(t){if(t===this.current&&!this.dirty)return;this.context.bindFramebuffer.set(this.parent);const e=this.gl;e.framebufferRenderbuffer(e.FRAMEBUFFER,this.attachment(),e.RENDERBUFFER,t),this.current=t,this.dirty=!1;}}class sx extends rx{attachment(){return this.gl.DEPTH_ATTACHMENT}set(t){if(t===this.current&&!this.dirty)return;this.context.bindFramebuffer.set(this.parent);const e=this.gl;e.framebufferTexture2D(e.FRAMEBUFFER,this.attachment(),e.TEXTURE_2D,t,0),this.current=t,this.dirty=!1;}}class ax extends ox{attachment(){return this.gl.DEPTH_STENCIL_ATTACHMENT}}class lx{constructor(t,e,i,r,n){this.context=t,this.width=e,this.height=i;const o=this.framebuffer=t.gl.createFramebuffer();r&&(this.colorAttachment=new nx(t,o)),n&&(this.depthAttachmentType=n,this.depthAttachment="renderbuffer"===n?new ox(t,o):new sx(t,o));}destroy(){const t=this.context.gl;if(this.colorAttachment){const e=this.colorAttachment.get();e&&t.deleteTexture(e);}if(this.depthAttachment&&this.depthAttachmentType)if("renderbuffer"===this.depthAttachmentType){const e=this.depthAttachment.get();e&&t.deleteRenderbuffer(e);}else {const e=this.depthAttachment.get();e&&t.deleteTexture(e);}t.deleteFramebuffer(this.framebuffer);}}class cx{constructor(t,e,i){this.func=t,this.mask=e,this.range=i;}}cx.ReadOnly=!1,cx.ReadWrite=!0,cx.disabled=new cx(519,cx.ReadOnly,[0,1]);const hx=7680;class ux{constructor(t,e,i,r,n,o){this.test=t,this.ref=e,this.mask=i,this.fail=r,this.depthFail=n,this.pass=o;}}ux.disabled=new ux({func:519,mask:0},0,0,hx,hx,hx);const dx=771;class px{constructor(t,e,i,r){this.blendFunction=t,this.blendColor=e,this.mask=i,this.blendEquation=r;}}px.Replace=[1,0,1,0],px.disabled=new px(px.Replace,li.transparent,[!1,!1,!1,!1]),px.unblended=new px(px.Replace,li.transparent,[!0,!0,!0,!0]),px.alphaBlended=new px([1,dx,1,dx],li.transparent,[!0,!0,!0,!0]),px.multiply=new px([774,0,774,0],li.transparent,[!0,!0,!0,!0]);const fx=1029,mx=2305;class _x{constructor(t,e,i){this.enable=t,this.mode=e,this.frontFace=i;}}_x.disabled=new _x(!1,fx,mx),_x.backCCW=new _x(!0,fx,mx),_x.backCW=new _x(!0,fx,2304),_x.frontCW=new _x(!0,1028,2304),_x.frontCCW=new _x(!0,1028,mx);class gx{constructor(t){this.gl=t,this.clearColor=new Ay(this),this.clearDepth=new Sy(this),this.clearStencil=new Iy(this),this.colorMask=new Cy(this),this.depthMask=new zy(this),this.stencilMask=new Dy(this),this.stencilFunc=new Py(this),this.stencilOp=new Ry(this),this.stencilTest=new Ly(this),this.depthRange=new ky(this),this.depthTest=new By(this),this.depthFunc=new Oy(this),this.blend=new Fy(this),this.blendFunc=new Ny(this),this.blendColor=new Uy(this),this.blendEquation=new Vy(this),this.cullFace=new jy(this),this.cullFaceSide=new Gy(this),this.frontFace=new qy(this),this.program=new Zy(this),this.activeTexture=new $y(this),this.viewport=new Hy(this),this.bindFramebuffer=new Wy(this),this.bindRenderbuffer=new Xy(this),this.bindTexture=new Yy(this),this.bindVertexBuffer=new Ky(this),this.bindElementBuffer=new Jy(this),this.bindVertexArrayOES=new Qy(this),this.pixelStoreUnpack=new tx(this),this.pixelStoreUnpackPremultiplyAlpha=new ex(this),this.pixelStoreUnpackFlipY=new ix(this),this.extTextureFilterAnisotropic=t.getExtension("EXT_texture_filter_anisotropic")||t.getExtension("MOZ_EXT_texture_filter_anisotropic")||t.getExtension("WEBKIT_EXT_texture_filter_anisotropic"),this.extTextureFilterAnisotropic&&(this.extTextureFilterAnisotropicMax=t.getParameter(this.extTextureFilterAnisotropic.MAX_TEXTURE_MAX_ANISOTROPY_EXT)),this.extTextureFilterAnisotropicForceOff=!1,this.extStandardDerivativesForceOff=!1,this.extDebugRendererInfo=t.getExtension("WEBGL_debug_renderer_info"),this.extDebugRendererInfo&&(this.renderer=t.getParameter(this.extDebugRendererInfo.UNMASKED_RENDERER_WEBGL),this.vendor=t.getParameter(this.extDebugRendererInfo.UNMASKED_VENDOR_WEBGL)),this.extTextureFloatLinear=t.getExtension("OES_texture_float_linear"),this.extRenderToTextureHalfFloat=t.getExtension("EXT_color_buffer_half_float"),this.extTimerQuery=t.getExtension("EXT_disjoint_timer_query"),this.maxTextureSize=t.getParameter(t.MAX_TEXTURE_SIZE);}setDefault(){this.unbindVAO(),this.clearColor.setDefault(),this.clearDepth.setDefault(),this.clearStencil.setDefault(),this.colorMask.setDefault(),this.depthMask.setDefault(),this.stencilMask.setDefault(),this.stencilFunc.setDefault(),this.stencilOp.setDefault(),this.stencilTest.setDefault(),this.depthRange.setDefault(),this.depthTest.setDefault(),this.depthFunc.setDefault(),this.blend.setDefault(),this.blendFunc.setDefault(),this.blendColor.setDefault(),this.blendEquation.setDefault(),this.cullFace.setDefault(),this.cullFaceSide.setDefault(),this.frontFace.setDefault(),this.program.setDefault(),this.activeTexture.setDefault(),this.bindFramebuffer.setDefault(),this.pixelStoreUnpack.setDefault(),this.pixelStoreUnpackPremultiplyAlpha.setDefault(),this.pixelStoreUnpackFlipY.setDefault();}setDirty(){this.clearColor.dirty=!0,this.clearDepth.dirty=!0,this.clearStencil.dirty=!0,this.colorMask.dirty=!0,this.depthMask.dirty=!0,this.stencilMask.dirty=!0,this.stencilFunc.dirty=!0,this.stencilOp.dirty=!0,this.stencilTest.dirty=!0,this.depthRange.dirty=!0,this.depthTest.dirty=!0,this.depthFunc.dirty=!0,this.blend.dirty=!0,this.blendFunc.dirty=!0,this.blendColor.dirty=!0,this.blendEquation.dirty=!0,this.cullFace.dirty=!0,this.cullFaceSide.dirty=!0,this.frontFace.dirty=!0,this.program.dirty=!0,this.activeTexture.dirty=!0,this.viewport.dirty=!0,this.bindFramebuffer.dirty=!0,this.bindRenderbuffer.dirty=!0,this.bindTexture.dirty=!0,this.bindVertexBuffer.dirty=!0,this.bindElementBuffer.dirty=!0,this.bindVertexArrayOES.dirty=!0,this.pixelStoreUnpack.dirty=!0,this.pixelStoreUnpackPremultiplyAlpha.dirty=!0,this.pixelStoreUnpackFlipY.dirty=!0;}createIndexBuffer(t,e,i){return new wy(this,t,e,i)}createVertexBuffer(t,e,i,r,n){return new Ey(this,t,e,i,r,n)}createRenderbuffer(t,e,i){const r=this.gl,n=r.createRenderbuffer();return this.bindRenderbuffer.set(n),r.renderbufferStorage(r.RENDERBUFFER,t,e,i),this.bindRenderbuffer.set(null),n}createFramebuffer(t,e,i,r){return new lx(this,t,e,i,r)}clear({color:t,depth:e,stencil:i,colorMask:r}){const n=this.gl;let o=0;t&&(o|=n.COLOR_BUFFER_BIT,this.clearColor.set(t),this.colorMask.set(r||[!0,!0,!0,!0])),void 0!==e&&(o|=n.DEPTH_BUFFER_BIT,this.depthRange.set([0,1]),this.clearDepth.set(e),this.depthMask.set(!0)),void 0!==i&&(o|=n.STENCIL_BUFFER_BIT,this.clearStencil.set(i),this.stencilMask.set(255)),n.clear(o);}setCullFace(t){!1===t.enable?this.cullFace.set(!1):(this.cullFace.set(!0),this.cullFaceSide.set(t.mode),this.frontFace.set(t.frontFace));}setDepthMode(t){t.func!==this.gl.ALWAYS||t.mask?(this.depthTest.set(!0),this.depthFunc.set(t.func),this.depthMask.set(t.mask),this.depthRange.set(t.range)):this.depthTest.set(!1);}setStencilMode(t){t.test.func!==this.gl.ALWAYS||t.mask?(this.stencilTest.set(!0),this.stencilMask.set(t.mask),this.stencilOp.set([t.fail,t.depthFail,t.pass]),this.stencilFunc.set({func:t.test.func,ref:t.ref,mask:t.test.mask})):this.stencilTest.set(!1);}setColorMode(t){x(t.blendFunction,px.Replace)?this.blend.set(!1):(this.blend.set(!0),this.blendFunc.set(t.blendFunction),this.blendColor.set(t.blendColor),t.blendEquation?this.blendEquation.set(t.blendEquation):this.blendEquation.setDefault()),this.colorMask.set(t.mask);}unbindVAO(){this.bindVertexArrayOES.set(null);}}class yx extends Ce{constructor(t,e,i){super(),this.id=t,this._onlySymbols=i,e.on("data",(t=>{"source"===t.dataType&&"metadata"===t.sourceDataType&&(this._sourceLoaded=!0),this._sourceLoaded&&!this._paused&&"source"===t.dataType&&"content"===t.sourceDataType&&(this.reload(),this.transform&&this.update(this.transform));})),e.on("error",(()=>{this._sourceErrored=!0;})),this._source=e,this._tiles={},this._cache=new by(0,this._unloadTile.bind(this)),this._timers={},this._cacheTimers={},this._minTileCacheSize=e.minTileCacheSize,this._maxTileCacheSize=e.maxTileCacheSize,this._loadedParentTiles={},this.castsShadows=!1,this._coveredTiles={},this._shadowCasterTiles={},this._state=new Tm,this._isRaster="raster"===this._source.type||"raster-dem"===this._source.type||"custom"===this._source.type&&"raster"===this._source._dataType;}onAdd(t){this.map=t,this._minTileCacheSize=void 0===this._minTileCacheSize&&t?t._minTileCacheSize:this._minTileCacheSize,this._maxTileCacheSize=void 0===this._maxTileCacheSize&&t?t._maxTileCacheSize:this._maxTileCacheSize;}loaded(){if(this._sourceErrored)return !0;if(!this._sourceLoaded)return !1;if(!this._source.loaded())return !1;for(const t in this._tiles){const e=this._tiles[t];if("errored"!==e.state&&("loaded"!==e.state||!e.bucketsLoaded()))return !1}return !0}getSource(){return this._source}pause(){this._paused=!0;}resume(){if(!this._paused)return;const t=this._shouldReloadOnResume;this._paused=!1,this._shouldReloadOnResume=!1,t&&this.reload(),this.transform&&this.update(this.transform);}_loadTile(t,e){return t.isSymbolTile=this._onlySymbols,t.isExtraShadowCaster=this._shadowCasterTiles[t.tileID.key],this._source.loadTile(t,e)}_unloadTile(t){if(this._source.unloadTile)return this._source.unloadTile(t,(()=>{}))}_abortTile(t){if(this._source.abortTile)return this._source.abortTile(t,(()=>{}))}serialize(){return this._source.serialize()}prepare(t){this._source.prepare&&this._source.prepare(),this._state.coalesceChanges(this._tiles,this.map?this.map.painter:null);for(const e in this._tiles){const i=this._tiles[e];i.upload(t),i.prepare(this.map.style.imageManager,this.map?this.map.painter:null,this._source.scope);}}getIds(){return L(this._tiles).map((t=>t.tileID)).sort(xx).map((t=>t.key))}getRenderableIds(t,e){const i=[];for(const r in this._tiles)this._isIdRenderable(+r,t,e)&&i.push(this._tiles[r]);return t?i.sort(((t,e)=>{const i=t.tileID,r=e.tileID,n=new y(i.canonical.x,i.canonical.y)._rotate(this.transform.angle),o=new y(r.canonical.x,r.canonical.y)._rotate(this.transform.angle);return i.overscaledZ-r.overscaledZ||o.y-n.y||o.x-n.x})).map((t=>t.tileID.key)):i.map((t=>t.tileID)).sort(xx).map((t=>t.key))}hasRenderableParent(t){const e=this.findLoadedParent(t,0);return !!e&&this._isIdRenderable(e.tileID.key)}_isIdRenderable(t,e,i){return this._tiles[t]&&this._tiles[t].hasData()&&!this._coveredTiles[t]&&(e||!this._tiles[t].holdingForFade())&&(i||!this._shadowCasterTiles[t])}reload(){if(this._paused)this._shouldReloadOnResume=!0;else {this._cache.reset();for(const t in this._tiles)"errored"!==this._tiles[t].state&&this._reloadTile(+t,"reloading");}}_reloadTile(t,e){const i=this._tiles[t];i&&("loading"!==i.state&&(i.state=e),this._loadTile(i,this._tileLoaded.bind(this,i,t,e)));}_tileLoaded(t,e,i,r){if(r)if(t.state="errored",404!==r.status)this._source.fire(new Ie(r,{tile:t}));else if("raster-dem"===this._source.type&&this.usedForTerrain&&this.map.painter.terrain){const t=this.map.painter.terrain;this.update(this.transform,t.getScaledDemTileSize(),!0),t.resetTileLookupCache(this.id);}else this.update(this.transform);else t.timeAdded=ue.now(),"expired"===i&&(t.refreshedUponExpiration=!0),this._setTileReloadTimer(e,t),"raster-dem"===this._source.type&&t.dem&&this._backfillDEM(t),this._state.initializeTileState(t,this.map?this.map.painter:null),this._source.fire(new Se("data",{dataType:"source",tile:t,coord:t.tileID,sourceCacheId:this.id}));}_backfillDEM(t){const e=this.getRenderableIds();for(let r=0;r<e.length;r++){const n=e[r];if(t.neighboringTiles&&t.neighboringTiles[n]){const e=this.getTileByID(n);i(t,e),i(e,t);}}function i(t,e){if(!t.dem||t.dem.borderReady)return;t.needsHillshadePrepare=!0,t.needsDEMTextureUpload=!0;let i=e.tileID.canonical.x-t.tileID.canonical.x;const r=e.tileID.canonical.y-t.tileID.canonical.y,n=Math.pow(2,t.tileID.canonical.z),o=e.tileID.key;0===i&&0===r||Math.abs(r)>1||(Math.abs(i)>1&&(1===Math.abs(i+n)?i+=n:1===Math.abs(i-n)&&(i-=n)),e.dem&&t.dem&&(t.dem.backfillBorder(e.dem,i,r),t.neighboringTiles&&t.neighboringTiles[o]&&(t.neighboringTiles[o].backfilled=!0)));}}getTile(t){return this.getTileByID(t.key)}getTileByID(t){return this._tiles[t]}_retainLoadedChildren(t,e,i,r){for(const n in this._tiles){let o=this._tiles[n];if(r[n]||!o.hasData()||o.tileID.overscaledZ<=e||o.tileID.overscaledZ>i)continue;let s=o.tileID;for(;o&&o.tileID.overscaledZ>e+1;){const t=o.tileID.scaledTo(o.tileID.overscaledZ-1);o=this._tiles[t.key],o&&o.hasData()&&(s=t);}let a=s;for(;a.overscaledZ>e;)if(a=a.scaledTo(a.overscaledZ-1),t[a.key]){r[s.key]=s;break}}}findLoadedParent(t,e){if(t.key in this._loadedParentTiles){const i=this._loadedParentTiles[t.key];return i&&i.tileID.overscaledZ>=e?i:null}for(let i=t.overscaledZ-1;i>=e;i--){const e=t.scaledTo(i),r=this._getLoadedTile(e);if(r)return r}}_getLoadedTile(t){const e=this._tiles[t.key];return e&&e.hasData()?e:this._cache.getByKey(this._source.reparseOverscaled?t.wrapped().key:t.canonical.key)}updateCacheSize(t,e){e=e||this._source.tileSize;const i=Math.ceil(t.width/e)+1,r=Math.ceil(t.height/e)+1,n=Math.floor(i*r*5),o="number"==typeof this._minTileCacheSize?Math.max(this._minTileCacheSize,n):n,s="number"==typeof this._maxTileCacheSize?Math.min(this._maxTileCacheSize,o):o;this._cache.setMaxSize(s);}handleWrapJump(t){const e=Math.round((t-(void 0===this._prevLng?t:this._prevLng))/360);if(this._prevLng=t,e){const t={};for(const i in this._tiles){const r=this._tiles[i];r.tileID=r.tileID.unwrapTo(r.tileID.wrap+e),t[r.tileID.key]=r;}this._tiles=t;for(const t in this._timers)clearTimeout(this._timers[t]),delete this._timers[t];for(const t in this._tiles)this._setTileReloadTimer(+t,this._tiles[t]);}}update(t,e,i,r){if(this.transform=t,!this._sourceLoaded||this._paused||this.transform.freezeTileCoverage)return;if(this.usedForTerrain&&!i)return;let n;if(this.updateCacheSize(t,e),"globe"!==this.transform.projection.name&&this.handleWrapJump(this.transform.center.lng),this._shadowCasterTiles={},this._coveredTiles={},this.used||this.usedForTerrain?this._source.tileID?n=t.getVisibleUnwrappedCoordinates(this._source.tileID).map((t=>new Rd(t.canonical.z,t.wrap,t.canonical.z,t.canonical.x,t.canonical.y))):(n=t.coveringTiles({tileSize:e||this._source.tileSize,minzoom:this._source.minzoom,maxzoom:this._source.maxzoom,roundZoom:this._source.roundZoom&&!i,reparseOverscaled:this._source.reparseOverscaled,isTerrainDEM:this.usedForTerrain}),this._source.hasTile&&(n=n.filter((t=>this._source.hasTile(t))))):n=[],n.length>0&&this.castsShadows&&r&&"globe"!==this.transform.projection.name&&!this.usedForTerrain&&!vx(this._source.type)){const o=t.coveringZoomLevel({tileSize:e||this._source.tileSize,roundZoom:this._source.roundZoom&&!i}),s=Math.min(o,this._source.maxzoom),a=t.extendTileCoverForShadows(n,r,s);for(const t of a)this._shadowCasterTiles[t.key]=!0,n.push(t);}const o=this._updateRetainedTiles(n);if(vx(this._source.type)&&0!==n.length){const t={},e={},i=Object.keys(o);for(const r of i){const i=o[r],n=this._tiles[r];if(!n||n.fadeEndTime&&n.fadeEndTime<=ue.now())continue;const s=this.findLoadedParent(i,Math.max(i.overscaledZ-yx.maxOverzooming,this._source.minzoom));s&&(this._addTile(s.tileID),t[s.tileID.key]=s.tileID),e[r]=i;}const r=n[n.length-1].overscaledZ;for(const t in this._tiles){const i=this._tiles[t];if(o[t]||!i.hasData())continue;let n=i.tileID;for(;n.overscaledZ>r;){n=n.scaledTo(n.overscaledZ-1);const r=this._tiles[n.key];if(r&&r.hasData()&&e[n.key]){o[t]=i.tileID;break}}}for(const e in t)o[e]||(this._coveredTiles[e]=!0,o[e]=t[e]);}for(const t in o)this._tiles[t].clearFadeHold();const s=function(t,e){const i=[];for(const r in t)r in e||i.push(r);return i}(this._tiles,o);for(const t of s){const e=this._tiles[t];e.hasSymbolBuckets&&!e.holdingForFade()?e.setHoldDuration(this.map._fadeDuration):e.hasSymbolBuckets&&!e.symbolFadeFinished()||this._removeTile(+t);}this._updateLoadedParentTileCache(),this._onlySymbols&&this._source.afterUpdate&&this._source.afterUpdate();}releaseSymbolFadeTiles(){for(const t in this._tiles)this._tiles[t].holdingForFade()&&this._removeTile(+t);}_updateRetainedTiles(t){const e={};if(0===t.length)return e;const i={},r=t.reduce(((t,e)=>Math.min(t,e.overscaledZ)),1/0),n=t[0].overscaledZ,o=Math.max(n-yx.maxOverzooming,this._source.minzoom),s=Math.max(n+yx.maxUnderzooming,this._source.minzoom),a={};for(const i of t){const t=this._addTile(i);e[i.key]=i,t.hasData()||r<this._source.maxzoom&&(a[i.key]=i);}this._retainLoadedChildren(a,r,s,e);for(const r of t){let t=this._tiles[r.key];if(t.hasData())continue;if(r.canonical.z>=this._source.maxzoom){const t=r.children(this._source.maxzoom)[0],i=this.getTile(t);if(i&&i.hasData()){e[t.key]=t;continue}}else {const t=r.children(this._source.maxzoom);if(e[t[0].key]&&e[t[1].key]&&e[t[2].key]&&e[t[3].key])continue}let n=t.wasRequested();for(let s=r.overscaledZ-1;s>=o;--s){const o=r.scaledTo(s);if(i[o.key])break;if(i[o.key]=!0,t=this.getTile(o),!t&&n&&(t=this._addTile(o)),t&&(e[o.key]=o,n=t.wasRequested(),t.hasData()))break}}return e}_updateLoadedParentTileCache(){this._loadedParentTiles={};for(const t in this._tiles){const e=[];let i,r=this._tiles[t].tileID;for(;r.overscaledZ>0;){if(r.key in this._loadedParentTiles){i=this._loadedParentTiles[r.key];break}e.push(r.key);const t=r.scaledTo(r.overscaledZ-1);if(i=this._getLoadedTile(t),i)break;r=t;}for(const t of e)this._loadedParentTiles[t]=i;}}_addTile(t){let e=this._tiles[t.key];if(e)return e.isExtraShadowCaster!==this._shadowCasterTiles[t.key]&&this._reloadTile(t.key,"reloading"),e;e=this._cache.getAndRemove(t),e&&(this._setTileReloadTimer(t.key,e),e.tileID=t,this._state.initializeTileState(e,this.map?this.map.painter:null),this._cacheTimers[t.key]&&(clearTimeout(this._cacheTimers[t.key]),delete this._cacheTimers[t.key],this._setTileReloadTimer(t.key,e)));const i=Boolean(e);if(!i){const i=this.map?this.map.painter:null;e=new vy(t,this._source.tileSize*t.overscaleFactor(),this.transform.tileZoom,i,this._isRaster),this._loadTile(e,this._tileLoaded.bind(this,e,t.key,e.state));}return e?(e.uses++,this._tiles[t.key]=e,i||this._source.fire(new Se("dataloading",{tile:e,coord:e.tileID,dataType:"source"})),e):null}_setTileReloadTimer(t,e){t in this._timers&&(clearTimeout(this._timers[t]),delete this._timers[t]);const i=e.getExpiryTimeout();i&&(this._timers[t]=setTimeout((()=>{this._reloadTile(t,"expired"),delete this._timers[t];}),i));}_removeTile(t){const e=this._tiles[t];e&&(e.uses--,delete this._tiles[t],this._timers[t]&&(clearTimeout(this._timers[t]),delete this._timers[t]),e.uses>0||(e.hasData()&&"reloading"!==e.state?this._cache.add(e.tileID,e,e.getExpiryTimeout()):(e.aborted=!0,this._abortTile(e),this._unloadTile(e))));}clearTiles(){this._shouldReloadOnResume=!1,this._paused=!1;for(const t in this._tiles)this._removeTile(+t);this._source._clear&&this._source._clear(),this._cache.reset(),this.map&&this.usedForTerrain&&this.map.painter.terrain&&this.map.painter.terrain.resetTileLookupCache(this.id);}tilesIn(t,e,i){const r=[],n=this.transform;if(!n)return r;const o="globe"===n.projection.name,s=Nd(n.center.lng);for(const a in this._tiles){const l=this._tiles[a];if(i&&l.clearQueryDebugViz(),l.holdingForFade())continue;let c;if(o){const t=l.tileID.canonical;if(0===t.z){const e=[Math.abs(z(s,...bx(t,-1))-s),Math.abs(z(s,...bx(t,1))-s)];c=[0,2*e.indexOf(Math.min(...e))-1];}else {const e=[Math.abs(z(s,...bx(t,-1))-s),Math.abs(z(s,...bx(t,0))-s),Math.abs(z(s,...bx(t,1))-s)];c=[e.indexOf(Math.min(...e))-1];}}else c=[0];for(const i of c){const o=t.containsTile(l,n,e,i);o&&r.push(o);}}return r}getShadowCasterCoordinates(){return this._getRenderableCoordinates(!1,!0)}getVisibleCoordinates(t){return this._getRenderableCoordinates(t)}_getRenderableCoordinates(t,e){const i=this.getRenderableIds(t,e).map((t=>this._tiles[t].tileID));for(const t of i)t.projMatrix=this.transform.calculateProjMatrix(t.toUnwrapped());return i}hasTransition(){if(this._source.hasTransition())return !0;if(vx(this._source.type))for(const t in this._tiles){const e=this._tiles[t];if(void 0!==e.fadeEndTime&&e.fadeEndTime>=ue.now())return !0}return !1}setFeatureState(t,e,i){this._state.updateState(t=t||"_geojsonTileLayer",e,i);}removeFeatureState(t,e,i){this._state.removeFeatureState(t=t||"_geojsonTileLayer",e,i);}getFeatureState(t,e){return this._state.getState(t=t||"_geojsonTileLayer",e)}setDependencies(t,e,i){const r=this._tiles[t];r&&r.setDependencies(e,i);}reloadTilesForDependencies(t,e){for(const i in this._tiles)this._tiles[i].hasDependency(t,e)&&this._reloadTile(+i,"reloading");this._cache.filter((i=>!i.hasDependency(t,e)));}_preloadTiles(t,e){if(!this._sourceLoaded){const i=()=>{this._sourceLoaded&&(this._source.off("data",i),this._preloadTiles(t,e));};return void this._source.on("data",i)}const i=new Map,r=Array.isArray(t)?t:[t],n=this.map.painter.terrain,o=this.usedForTerrain&&n?n.getScaledDemTileSize():this._source.tileSize;for(const t of r){const e=t.coveringTiles({tileSize:o,minzoom:this._source.minzoom,maxzoom:this._source.maxzoom,roundZoom:this._source.roundZoom&&!this.usedForTerrain,reparseOverscaled:this._source.reparseOverscaled,isTerrainDEM:this.usedForTerrain});for(const t of e)i.set(t.key,t);this.usedForTerrain&&t.updateElevation(!1);}R(Array.from(i.values()),((t,e)=>{const i=new vy(t,this._source.tileSize*t.overscaleFactor(),this.transform.tileZoom,this.map.painter,this._isRaster);this._loadTile(i,(t=>{"raster-dem"===this._source.type&&i.dem&&this._backfillDEM(i),e(t,i);}));}),e);}}function xx(t,e){const i=Math.abs(2*t.wrap)-+(t.wrap<0),r=Math.abs(2*e.wrap)-+(e.wrap<0);return t.overscaledZ-e.overscaledZ||r-i||e.canonical.y-t.canonical.y||e.canonical.x-t.canonical.x}function vx(t){return "raster"===t||"image"===t||"video"===t||"custom"===t}function bx(t,e){const i=1<<t.z;return [t.x/i+e,(t.x+1)/i+e]}yx.maxOverzooming=10,yx.maxUnderzooming=3;const wx=_a([{name:"a_pos_3f",components:3,type:"Float32"}]),Tx=_a([{name:"a_color_3f",components:3,type:"Float32"}]),Ex=_a([{name:"a_color_4f",components:4,type:"Float32"}]),Mx=_a([{name:"a_uv_2f",components:2,type:"Float32"}]),Ax=_a([{name:"a_normal_3f",components:3,type:"Float32"}]),Sx=_a([{name:"a_normal_matrix0",components:4,type:"Float32"},{name:"a_normal_matrix1",components:4,type:"Float32"},{name:"a_normal_matrix2",components:4,type:"Float32"},{name:"a_normal_matrix3",components:4,type:"Float32"}]),Ix=_a([{name:"a_pbr",components:4,type:"Uint16"},{name:"a_heightBasedEmissiveStrength",components:3,type:"Float32"}]);class Cx{constructor(t=0,e=0,i=0,r=0){if(isNaN(t)||t<0||isNaN(e)||e<0||isNaN(i)||i<0||isNaN(r)||r<0)throw new Error("Invalid value for edge-insets, top, bottom, left and right must all be numbers");this.top=t,this.bottom=e,this.left=i,this.right=r;}interpolate(t,e,i){return null!=e.top&&null!=t.top&&(this.top=Wr(t.top,e.top,i)),null!=e.bottom&&null!=t.bottom&&(this.bottom=Wr(t.bottom,e.bottom,i)),null!=e.left&&null!=t.left&&(this.left=Wr(t.left,e.left,i)),null!=e.right&&null!=t.right&&(this.right=Wr(t.right,e.right,i)),this}getCenter(t,e){const i=z((this.left+t-this.right)/2,0,t),r=z((this.top+e-this.bottom)/2,0,e);return new y(i,r)}equals(t){return this.top===t.top&&this.bottom===t.bottom&&this.left===t.left&&this.right===t.right}clone(){return new Cx(this.top,this.bottom,this.left,this.right)}toJSON(){return {top:this.top,bottom:this.bottom,left:this.left,right:this.right}}}function zx(t,e){const i=ot(t,3);mu.fromQuat(t,e),st(t,3,i);}function Dx(t,e){const i=gu.identity([]);return gu.rotateZ(i,i,-e),gu.rotateX(i,i,-t),i}function Px(t,e){const i=[t[0],t[1],0],r=[e[0],e[1],0];if(bu.length(i)>=1e-15){const t=bu.normalize([],i);bu.scale(r,t,bu.dot(r,t)),e[0]=r[0],e[1]=r[1];}const n=bu.cross([],e,t);if(bu.len(n)<1e-15)return null;const o=Math.atan2(-n[1],n[0]);return Dx(Math.atan2(Math.sqrt(t[0]*t[0]+t[1]*t[1]),-t[2]),o)}class Rx{constructor(t,e){this.position=t,this.orientation=e;}get position(){return this._position}set position(t){if(t){const e=t instanceof Yd?t:new Yd(t[0],t[1],t[2]);this._renderWorldCopies&&(e.x=P(e.x,0,1)),this._position=e;}else this._position=null;}lookAtPoint(t,e){if(this.orientation=null,!this.position)return;const i=this.position,r=this._elevation?this._elevation.getAtPointOrZero(Yd.fromLngLat(t)):0,n=Yd.fromLngLat(t,r),o=[n.x-i.x,n.y-i.y,n.z-i.z];e||(e=[0,0,1]),e[2]=Math.abs(e[2]),this.orientation=Px(o,e);}setPitchBearing(t,e){this.orientation=Dx(w(t),w(-e));}}class Lx{constructor(t,e){this._transform=mu.identity([]),this.orientation=e,this.position=t;}get mercatorPosition(){const t=this.position;return new Yd(t[0],t[1],t[2])}get position(){const t=ot(this._transform,3);return [t[0],t[1],t[2]]}set position(t){var e;t&&st(this._transform,3,[(e=t)[0],e[1],e[2],1]);}get orientation(){return this._orientation}set orientation(t){this._orientation=t||gu.identity([]),t&&zx(this._transform,this._orientation);}getPitchBearing(){const t=this.forward(),e=this.right();return {bearing:Math.atan2(-e[1],e[0]),pitch:Math.atan2(Math.sqrt(t[0]*t[0]+t[1]*t[1]),-t[2])}}setPitchBearing(t,e){this._orientation=Dx(t,e),zx(this._transform,this._orientation);}forward(){const t=ot(this._transform,2);return [-t[0],-t[1],-t[2]]}up(){const t=ot(this._transform,1);return [-t[0],-t[1],-t[2]]}right(){const t=ot(this._transform,0);return [t[0],t[1],t[2]]}getCameraToWorld(t,e){const i=new Float64Array(16);return mu.invert(i,this.getWorldToCamera(t,e)),i}getCameraToWorldMercator(){return this._transform}getWorldToCameraPosition(t,e,i){const r=this.position;bu.scale(r,r,-t);const n=new Float64Array(16);return mu.fromScaling(n,[i,i,i]),mu.translate(n,n,r),n[10]*=e,n}getWorldToCamera(t,e){const i=new Float64Array(16),r=new Float64Array(4),n=this.position;return gu.conjugate(r,this._orientation),bu.scale(n,n,-t),mu.fromQuat(i,r),mu.translate(i,i,n),i[1]*=-1,i[5]*=-1,i[9]*=-1,i[13]*=-1,i[8]*=e,i[9]*=e,i[10]*=e,i[11]*=e,i}getCameraToClipPerspective(t,e,i,r){const n=new Float64Array(16);return mu.perspective(n,t,e,i,r),n}getCameraToClipOrthographic(t,e,i,r,n,o){const s=new Float64Array(16);return mu.ortho(s,t,e,i,r,n,o),s}getDistanceToElevation(t,e=!1){const i=0===t?0:Vd(t,e?Gd(this.position[1]):this.position[1]),r=this.forward();return (i-this.position[2])/r[2]}clone(){return new Lx([...this.position],[...this.orientation])}}function kx(t,e){const i=Ox(t.projection,t.zoom,t.width,t.height),r=function(t,e,i,r,n){const o=new Id(i.lng-180*Fx,i.lat),s=new Id(i.lng+180*Fx,i.lat),a=t.project(o.lng,o.lat),l=t.project(s.lng,s.lat),c=-Math.atan2(l.y-a.y,l.x-a.x),h=Yd.fromLngLat(i);h.y=z(h.y,-1+Fx,1-Fx);const u=h.toLngLat(),d=t.project(u.lng,u.lat),p=Yd.fromLngLat(u);p.x+=Fx;const f=p.toLngLat(),m=t.project(f.lng,f.lat),_=Ux(m.x-d.x,m.y-d.y,c),g=Yd.fromLngLat(u);g.y+=Fx;const y=g.toLngLat(),x=t.project(y.lng,y.lat),v=Ux(x.x-d.x,x.y-d.y,c),b=Math.abs(_.x)/Math.abs(v.y),w=mu.identity([]);mu.rotateZ(w,w,-c*(1-(n?0:r)));const T=mu.identity([]);return mu.scale(T,T,[1,1-(1-b)*r,1]),T[4]=-v.x/v.y*r,mu.rotateZ(T,T,c),mu.multiply(T,w,T),T}(t.projection,0,t.center,i,e),n=Bx(t);return mu.scale(r,r,[n,n,1]),r}function Bx(t){const e=t.projection,i=Ox(t.projection,t.zoom,t.width,t.height),r=Nx(e,t.center),n=Nx(e,Id.convert(e.center));return Math.pow(2,r*i+(1-i)*n)}function Ox(t,e,i,r,n=1/0){const o=t.range;if(!o)return 0;const s=Math.min(n,Math.max(i,r)),a=Math.log(s/1024)/Math.LN2;return D(o[0]+a,o[1]+a,e)}const Fx=1/4e4;function Nx(t,e){const i=z(e.lat,-Zd,Zd),r=new Id(e.lng-180*Fx,i),n=new Id(e.lng+180*Fx,i),o=t.project(r.lng,i),s=t.project(n.lng,i),a=Yd.fromLngLat(r),l=Yd.fromLngLat(n),c=s.x-o.x,h=s.y-o.y,u=l.x-a.x,d=l.y-a.y,p=Math.sqrt((u*u+d*d)/(c*c+h*h));return Math.log(p)/Math.LN2}function Ux(t,e,i){const r=Math.cos(i),n=Math.sin(i);return {x:t*r-e*n,y:t*n+e*r}}function Vx(t,e,i){return e*(sr/(t.tileSize*Math.pow(2,i-t.tileID.overscaledZ)))}const jx={unknown:0,flipRequired:1,flipNotRequired:2},Gx=Math.tan(85*Math.PI/180);function qx(t,e,i,r,n,o,s){const a=mu.create();if(i)if("globe"===o.name){const t=function(t,e){const{x:i,y:r}=t.point,n=dd(i,r,t.worldSize/t._pixelsPerMercatorPixel,0,0);return mu.multiply(n,n,cd(Yu(e)))}(n,e);mu.multiply(a,a,t);}else {const t=hu.invert([],s);a[0]=t[0],a[1]=t[1],a[4]=t[2],a[5]=t[3],r||mu.rotateZ(a,a,n.angle);}else mu.multiply(a,n.labelPlaneMatrix,t);return a}function Zx(t,e,i,r,n,o,s){const a=qx(t,e,i,r,n,o,s);return "globe"===o.name&&i||(a[2]=a[6]=a[10]=a[14]=0),a}function $x(t,e,i,r,n,o,s){if(i){if("globe"===o.name){const a=qx(t,e,i,r,n,o,s);return mu.invert(a,a),mu.multiply(a,t,a),a}{const e=mu.clone(t),i=mu.identity([]);return i[0]=s[0],i[1]=s[1],i[4]=s[2],i[5]=s[3],mu.multiply(e,e,i),r||mu.rotateZ(e,e,-n.angle),e}}return n.glCoordMatrix}function Hx(t,e,i,r){const n=[t,e,i,1];i?au.transformMat4(n,n,r):nv(n,n,r);const o=n[3];return n[0]/=o,n[1]/=o,n[2]/=o,n}function Wx(t,e){return Math.min(.5+t/e*.5,1.5)}function Xx(t,e){const i=t[0]/t[3],r=t[1]/t[3];return i>=-e[0]&&i<=e[0]&&r>=-e[1]&&r<=e[1]}function Yx(t,e,i,r,n,o,s,a,l,c){const h=i.transform,u=r?t.textSizeData:t.iconSizeData,d=t_(u,i.transform.zoom),p="globe"===h.projection.name,f=[256/i.width*2+1,256/i.height*2+1],m=r?t.text.dynamicLayoutVertexArray:t.icon.dynamicLayoutVertexArray;m.clear();let _=null;p&&(_=r?t.text.globeExtVertexArray:t.icon.globeExtVertexArray);const g=t.lineVertexArray,x=r?t.text.placedSymbolArray:t.icon.placedSymbolArray,v=i.transform.width/i.transform.height;let b,w=!1;for(let r=0;r<x.length;r++){const p=x.get(r),{numGlyphs:T,writingMode:E}=p;if(E!==m_.vertical||w||b===m_.horizontal||(w=!0),b=E,(p.hidden||E===m_.vertical)&&!w){rv(T,m);continue}w=!1;const M=new y(p.tileAnchorX,p.tileAnchorY);let{x:A,y:S,z:I}=h.projection.projectTilePoint(M.x,M.y,c.canonical);if(l){const[t,e,i]=l(M);A+=t,S+=e,I+=i;}const C=[A,S,I,1];if(au.transformMat4(C,C,e),!Xx(C,f)){rv(T,m);continue}const z=C[3],D=Wx(i.transform.getCameraToCenterDistance(h.projection),z),P=Qm(u,d,p),R=s?P/D:P*D,L=Hx(A,S,I,n);if(L[3]<=0){rv(T,m);continue}let k={};const B=s?null:l,O=Qx(p,R,!1,a,e,n,o,t.glyphOffsetArray,g,m,_,L,M,k,v,B,h.projection,c,s);w=O.useVertical,B&&O.needsFlipping&&(k={}),(O.notEnoughRoom||w||O.needsFlipping&&Qx(p,R,!0,a,e,n,o,t.glyphOffsetArray,g,m,_,L,M,k,v,B,h.projection,c,s).notEnoughRoom)&&rv(T,m);}r?(t.text.dynamicLayoutVertexBuffer.updateData(m),_&&t.text.globeExtVertexBuffer&&t.text.globeExtVertexBuffer.updateData(_)):(t.icon.dynamicLayoutVertexBuffer.updateData(m),_&&t.icon.globeExtVertexBuffer&&t.icon.globeExtVertexBuffer.updateData(_));}function Kx(t,e,i,r,n,o,s,a,l,c,h,u,d,p,f,m){const{lineStartIndex:_,glyphStartIndex:g,segment:y}=a,x=g+a.numGlyphs,v=_+a.lineLength,b=e.getoffsetX(g),w=e.getoffsetX(x-1),T=iv(t*b,i,r,n,o,s,y,_,v,l,c,h,u,d,!0,p,f,m);if(!T)return null;const E=iv(t*w,i,r,n,o,s,y,_,v,l,c,h,u,d,!0,p,f,m);return E?{first:T,last:E}:null}function Jx(t,e,i,r){return t===m_.horizontal&&Math.abs(r)>Math.abs(i)?{useVertical:!0}:t===m_.vertical?r>0?{needsFlipping:!0}:null:e!==jx.unknown&&function(t,e){return 0===t||Math.abs(e/t)>Gx}(i,r)?e===jx.flipRequired?{needsFlipping:!0}:null:i<0?{needsFlipping:!0}:null}function Qx(t,e,i,r,n,o,s,a,l,c,h,u,d,p,f,m,_,g,x){const v=e/24,b=t.lineOffsetX*v,w=t.lineOffsetY*v,{lineStartIndex:T,glyphStartIndex:E,numGlyphs:M,segment:A,writingMode:S,flipState:I}=t,C=T+t.lineLength,z=t=>{if(h){const[e,i,r]=t.up,n=c.length;Yg(h,n+0,e,i,r),Yg(h,n+1,e,i,r),Yg(h,n+2,e,i,r),Yg(h,n+3,e,i,r);}const[e,i,r]=t.point;Kg(c,e,i,r,t.angle);};if(M>1){const e=Kx(v,a,b,w,i,u,d,t,l,o,p,m,!1,_,g,x);if(!e)return {notEnoughRoom:!0};if(r&&!i){let[i,r,n]=e.first.point,[o,a,l]=e.last.point;[i,r]=Hx(i,r,n,s),[o,a]=Hx(o,a,l,s);const c=Jx(S,I,(o-i)*f,a-r);if(t.flipState=c&&c.needsFlipping?jx.flipRequired:jx.flipNotRequired,c)return c}z(e.first);for(let t=E+1;t<E+M-1;t++){const e=iv(v*a.getoffsetX(t),b,w,i,u,d,A,T,C,l,o,p,m,!1,!1,_,g,x);if(!e)return c.length-=4*(t-E),{notEnoughRoom:!0};z(e);}z(e.last);}else {if(r&&!i){const e=Hx(d.x,d.y,0,n),i=T+A+1,r=new y(l.getx(i),l.gety(i)),o=Hx(r.x,r.y,0,n),s=o[3]>0?o:ev(d,r,e,1,n,void 0,_,g.canonical),a=Jx(S,I,(s[0]-e[0])*f,s[1]-e[1]);if(t.flipState=a&&a.needsFlipping?jx.flipRequired:jx.flipNotRequired,a)return a}const e=iv(v*a.getoffsetX(E),b,w,i,u,d,A,T,C,l,o,p,m,!1,!1,_,g,x);if(!e)return {notEnoughRoom:!0};z(e);}return {}}function tv(t,e,i,r,n){const{x:o,y:s,z:a}=r.projectTilePoint(t.x,t.y,e);if(!n)return Hx(o,s,a,i);const[l,c,h]=n(t);return Hx(o+l,s+c,a+h,i)}function ev(t,e,i,r,n,o,s,a){const l=tv(t.sub(e)._unit()._add(t),a,n,s,o);return bu.sub(l,i,l),bu.normalize(l,l),bu.scaleAndAdd(l,i,l,r)}function iv(t,e,i,r,n,o,s,a,l,c,h,u,d,p,f,m,_,g){const x=r?t-e:t+e;let v=x>0?1:-1,b=0;r&&(v*=-1,b=Math.PI),v<0&&(b+=Math.PI);let w=a+s+(v>0?0:1)|0,T=n,E=n,M=0,A=0;const S=Math.abs(x),I=[],C=[];let z=o,D=z;const P=()=>ev(D,z,E,S-M+1,h,d,m,_.canonical);for(;M+A<=S;){if(w+=v,w<a||w>=l)return null;if(E=T,D=z,I.push(E),p&&C.push(D),z=new y(c.getx(w),c.gety(w)),T=u[w],!T){const t=tv(z,_.canonical,h,m,d);T=t[3]>0?u[w]=t:P();}M+=A,A=bu.distance(E,T);}f&&d&&(u[w]&&(T=P(),A=bu.distance(E,T)),u[w]=T);const R=(S-M)/A,L=z.sub(D)._mult(R)._add(D),k=bu.sub([],T,E),B=bu.scaleAndAdd([],E,k,R);let O=[0,0,1],F=k[0],N=k[1];if(g&&(O=m.upVector(_.canonical,L.x,L.y),0!==O[0]||0!==O[1]||1!==O[2])){const t=[O[2],0,-O[0]],e=bu.cross([],O,t);bu.normalize(t,t),bu.normalize(e,e),F=bu.dot(k,t),N=bu.dot(k,e);}if(i){const t=bu.cross([],O,k);bu.normalize(t,t),bu.scaleAndAdd(B,B,t,i*v);}const U=b+Math.atan2(N,F);return I.push(B),p&&C.push(L),{point:B,angle:U,path:I,tilePath:C,up:O}}function rv(t,e){const i=e.length,r=i+4*t;e.resize(r),e.float32.fill(-1/0,4*i,4*r);}function nv(t,e,i){const r=e[0],n=e[1];return t[0]=i[0]*r+i[4]*n+i[12],t[1]=i[1]*r+i[5]*n+i[13],t[3]=i[3]*r+i[7]*n+i[15],t}const ov=15,sv=(t,e,i)=>(1-i)*t+i*e,av=t=>t*t*t*t*t;class lv{constructor(t,e,i,r,n,o,s){this.tileSize=512,this._renderWorldCopies=void 0===n||n,this._minZoom=t||0,this._maxZoom=e||22,this._minPitch=null==i?0:i,this._maxPitch=null==r?60:r,this.setProjection(o),this.setMaxBounds(s),this.width=0,this.height=0,this._center=new Id(0,0),this.zoom=0,this.angle=0,this._fov=.6435011087932844,this._pitch=0,this._nearZ=0,this._farZ=0,this._unmodified=!0,this._edgeInsets=new Cx,this._projMatrixCache={},this._alignedProjMatrixCache={},this._fogTileMatrixCache={},this._distanceTileDataCache={},this._camera=new Lx,this._centerAltitude=0,this._averageElevation=0,this.cameraElevationReference="ground",this._pixelsPerMercatorPixel=1,this.globeRadius=0,this.globeCenterInViewSpace=[0,0,0],this._horizonShift=.1,this._orthographicProjectionAtLowPitch=!1;}clone(){const t=new lv(this._minZoom,this._maxZoom,this._minPitch,this.maxPitch,this._renderWorldCopies,this.getProjection());return t._elevation=this._elevation,t._centerAltitude=this._centerAltitude,t._centerAltitudeValidForExaggeration=this._centerAltitudeValidForExaggeration,t.tileSize=this.tileSize,t.mercatorFromTransition=this.mercatorFromTransition,t.width=this.width,t.height=this.height,t.cameraElevationReference=this.cameraElevationReference,t._center=this._center,t._setZoom(this.zoom),t._seaLevelZoom=this._seaLevelZoom,t.angle=this.angle,t._fov=this._fov,t._pitch=this._pitch,t._nearZ=this._nearZ,t._farZ=this._farZ,t._averageElevation=this._averageElevation,t._unmodified=this._unmodified,t._edgeInsets=this._edgeInsets.clone(),t._camera=this._camera.clone(),t._calcMatrices(),t.freezeTileCoverage=this.freezeTileCoverage,t.frustumCorners=this.frustumCorners,t}get elevation(){return this._elevation}set elevation(t){this._elevation!==t&&(this._elevation=t,this._updateCameraOnTerrain(),this._calcMatrices());}updateElevation(t,e=!1){const i=this._elevation&&this._elevation.exaggeration()!==this._centerAltitudeValidForExaggeration;(null==this._seaLevelZoom||i)&&this._updateCameraOnTerrain(),(t||i)&&this._constrainCamera(e),this._calcMatrices();}getProjection(){return B(this.projection,["name","center","parallels"])}setProjection(t){this.projectionOptions=t||{name:"mercator"};const e=this.projection?this.getProjection():void 0;this.projection=Ug(this.projectionOptions);const i=!x(e,this.getProjection());return i&&this._calcMatrices(),this.mercatorFromTransition=!1,i}setOrthographicProjectionAtLowPitch(t){return this._orthographicProjectionAtLowPitch!==t&&(this._orthographicProjectionAtLowPitch=t,this._calcMatrices(),!0)}setMercatorFromTransition(){const t=this.projection.name;this.mercatorFromTransition=!0,this.projectionOptions={name:"mercator"},this.projection=Ug({name:"mercator"});const e=t!==this.projection.name;return e&&this._calcMatrices(),e}get minZoom(){return this._minZoom}set minZoom(t){this._minZoom!==t&&(this._minZoom=t,this.zoom=Math.max(this.zoom,t));}get maxZoom(){return this._maxZoom}set maxZoom(t){this._maxZoom!==t&&(this._maxZoom=t,this.zoom=Math.min(this.zoom,t));}get minPitch(){return this._minPitch}set minPitch(t){this._minPitch!==t&&(this._minPitch=t,this.pitch=Math.max(this.pitch,t));}get maxPitch(){return this._maxPitch}set maxPitch(t){this._maxPitch!==t&&(this._maxPitch=t,this.pitch=Math.min(this.pitch,t));}get renderWorldCopies(){return this._renderWorldCopies&&!0===this.projection.supportsWorldCopies}set renderWorldCopies(t){void 0===t?t=!0:null===t&&(t=!1),this._renderWorldCopies=t;}get worldSize(){return this.tileSize*this.scale}get cameraWorldSizeForFog(){const t=Math.max(this._camera.getDistanceToElevation(this._averageElevation),Number.EPSILON);return this._worldSizeFromZoom(this._zoomFromMercatorZ(t))}get cameraWorldSize(){const t=Math.max(this._camera.getDistanceToElevation(this._averageElevation,!0),Number.EPSILON);return this._worldSizeFromZoom(this._zoomFromMercatorZ(t))}get pixelsPerMeter(){return this.projection.pixelsPerMeter(this.center.lat,this.worldSize)}get cameraPixelsPerMeter(){return Vd(this.center.lat,this.cameraWorldSizeForFog)}get centerOffset(){return this.centerPoint._sub(this.size._div(2))}get size(){return new y(this.width,this.height)}get bearing(){return P(this.rotation,-180,180)}set bearing(t){this.rotation=t;}get rotation(){return -this.angle/Math.PI*180}set rotation(t){const e=-t*Math.PI/180;this.angle!==e&&(this._unmodified=!1,this.angle=e,this._calcMatrices(),this.rotationMatrix=hu.create(),hu.rotate(this.rotationMatrix,this.rotationMatrix,this.angle));}get pitch(){return this._pitch/Math.PI*180}set pitch(t){const e=z(t,this.minPitch,this.maxPitch)/180*Math.PI;this._pitch!==e&&(this._unmodified=!1,this._pitch=e,this._calcMatrices());}get aspect(){return this.width/this.height}get fov(){return this._fov/Math.PI*180}get fovX(){return this._fov}get fovY(){const t=1/Math.tan(.5*this.fovX);return 2*Math.atan(1/this.aspect/t)}set fov(t){t=Math.max(.01,Math.min(60,t)),this._fov!==t&&(this._unmodified=!1,this._fov=w(t),this._calcMatrices());}get averageElevation(){return this._averageElevation}set averageElevation(t){this._averageElevation=t,this._calcFogMatrices(),this._distanceTileDataCache={};}get zoom(){return this._zoom}set zoom(t){const e=Math.min(Math.max(t,this.minZoom),this.maxZoom);this._zoom!==e&&(this._unmodified=!1,this._setZoom(e),this._updateSeaLevelZoom(),this._constrain(),this._calcMatrices());}_setZoom(t){this._zoom=t,this.scale=this.zoomScale(t),this.tileZoom=Math.floor(t),this.zoomFraction=t-this.tileZoom;}_updateCameraOnTerrain(){if(!this._elevation||!this._elevation.isDataAvailableAtPoint(this.locationCoordinate(this.center)))return this._centerAltitude=0,this._seaLevelZoom=null,void(this._centerAltitudeValidForExaggeration=void 0);const t=this._elevation;this._centerAltitude=t.getAtPointOrZero(this.locationCoordinate(this.center)),this._centerAltitudeValidForExaggeration=t.exaggeration(),this._updateSeaLevelZoom();}_updateSeaLevelZoom(){void 0!==this._centerAltitudeValidForExaggeration&&(this._seaLevelZoom=this._zoomFromMercatorZ((this.pixelsPerMeter*this._centerAltitude+this.cameraToCenterDistance)/this.worldSize));}sampleAverageElevation(){if(!this._elevation)return 0;const t=this._elevation,e=[[.5,.2],[.3,.5],[.5,.5],[.7,.5],[.5,.8]],i=this.horizonLineFromTop();let r=0,n=0;for(let o=0;o<e.length;o++){const s=new y(e[o][0]*this.width,i+e[o][1]*(this.height-i)),a=t.pointCoordinate(s);if(!a)continue;const l=1/Math.hypot(a[0]-this._camera.position[0],a[1]-this._camera.position[1]);r+=a[3]*l,n+=l;}return 0===n?NaN:r/n}get center(){return this._center}set center(t){t.lat===this._center.lat&&t.lng===this._center.lng||(this._unmodified=!1,this._center=t,this._terrainEnabled()&&("ground"===this.cameraElevationReference?this._updateCameraOnTerrain():this._updateZoomFromElevation()),this._constrain(),this._calcMatrices());}_updateZoomFromElevation(){if(null==this._seaLevelZoom||!this._elevation)return;const t=this._seaLevelZoom,e=this._elevation.getAtPointOrZero(this.locationCoordinate(this.center)),i=this.pixelsPerMeter/this.worldSize*e,r=this._mercatorZfromZoom(t),n=this._mercatorZfromZoom(this._maxZoom),o=Math.max(r-i,n);this._setZoom(this._zoomFromMercatorZ(o));}get padding(){return this._edgeInsets.toJSON()}set padding(t){this._edgeInsets.equals(t)||(this._unmodified=!1,this._edgeInsets.interpolate(this._edgeInsets,t,1),this._calcMatrices());}computeZoomRelativeTo(t){const e=this.rayIntersectionCoordinate(this.pointRayIntersection(this.centerPoint,t.toAltitude()));let i;i=t.z<this._camera.position[2]?[e.x,e.y,e.z]:[t.x,t.y,t.z];const r=bu.length(bu.sub([],this._camera.position,i));return z(this._zoomFromMercatorZ(r),this._minZoom,this._maxZoom)}setFreeCameraOptions(t){if(!this.height)return;if(!t.position&&!t.orientation)return;this._updateCameraState();let e=!1;if(t.orientation&&!gu.exactEquals(t.orientation,this._camera.orientation)&&(e=this._setCameraOrientation(t.orientation)),t.position){const i=[t.position.x,t.position.y,t.position.z];bu.exactEquals(i,this._camera.position)||(this._setCameraPosition(i),e=!0);}e&&(this._updateStateFromCamera(),this.recenterOnTerrain());}getFreeCameraOptions(){this._updateCameraState();const t=this._camera.position,e=new Rx;return e.position=new Yd(t[0],t[1],t[2]),e.orientation=this._camera.orientation,e._elevation=this.elevation,e._renderWorldCopies=this.renderWorldCopies,e}_setCameraOrientation(t){if(!gu.length(t))return !1;gu.normalize(t,t);const e=bu.transformQuat([],[0,0,-1],t),i=bu.transformQuat([],[0,-1,0],t);if(i[2]<0)return !1;const r=Px(e,i);return !!r&&(this._camera.orientation=r,!0)}_setCameraPosition(t){const e=this.zoomScale(this.minZoom)*this.tileSize,i=this.zoomScale(this.maxZoom)*this.tileSize,r=this.cameraToCenterDistance;t[2]=z(t[2],r/i,r/e),this._camera.position=t;}get centerPoint(){return this._edgeInsets.getCenter(this.width,this.height)}get fovAboveCenter(){return this._fov*(.5+this.centerOffset.y/this.height)}isPaddingEqual(t){return this._edgeInsets.equals(t)}interpolatePadding(t,e,i){this._unmodified=!1,this._edgeInsets.interpolate(t,e,i),this._constrain(),this._calcMatrices();}coveringZoomLevel(t){const e=(t.roundZoom?Math.round:Math.floor)(this.zoom+this.scaleZoom(this.tileSize/t.tileSize));return Math.max(0,e)}getVisibleUnwrappedCoordinates(t){const e=[new Pd(0,t)];if(this.renderWorldCopies){const i=this.pointCoordinate(new y(0,0)),r=this.pointCoordinate(new y(this.width,0)),n=this.pointCoordinate(new y(this.width,this.height)),o=this.pointCoordinate(new y(0,this.height)),s=Math.floor(Math.min(i.x,r.x,n.x,o.x)),a=Math.floor(Math.max(i.x,r.x,n.x,o.x)),l=1;for(let i=s-l;i<=a+l;i++)0!==i&&e.push(new Pd(i,t));}return e}isLODDisabled(t){return (!t||this.pitch<=60)&&this._edgeInsets.top<=this._edgeInsets.bottom&&!this._elevation&&!this.projection.isReprojectedInTileSpace}extendTileCoverForShadows(t,e,i){let r=[];if(0===e[0]&&0===e[1])return r;for(const i of t){const t=i.canonical,n=i.overscaledZ,o=i.wrap,s=1<<t.z,a=t.x+1<s,l=t.x>0,c=t.y+1<s,h=t.y>0,u=i.wrap-(l?0:1),d=i.wrap+(a?0:1),p=l?t.x-1:s-1,f=a?t.x+1:0;e[0]<0?(r.push(new Rd(n,d,t.z,f,t.y)),e[1]<0&&c&&(r.push(new Rd(n,o,t.z,t.x,t.y+1)),r.push(new Rd(n,d,t.z,f,t.y+1))),e[1]>0&&h&&(r.push(new Rd(n,o,t.z,t.x,t.y-1)),r.push(new Rd(n,d,t.z,f,t.y-1)))):e[0]>0?(r.push(new Rd(n,u,t.z,p,t.y)),e[1]<0&&c&&(r.push(new Rd(n,o,t.z,t.x,t.y+1)),r.push(new Rd(n,u,t.z,p,t.y+1))),e[1]>0&&h&&(r.push(new Rd(n,o,t.z,t.x,t.y-1)),r.push(new Rd(n,u,t.z,p,t.y-1)))):e[1]<0&&c?r.push(new Rd(n,o,t.z,t.x,t.y+1)):h&&r.push(new Rd(n,o,t.z,t.x,t.y-1));}if(r.length>1){r.sort(((t,e)=>t.overscaledZ-e.overscaledZ||t.wrap-e.wrap||t.canonical.z-e.canonical.z||t.canonical.x-e.canonical.x||t.canonical.y-e.canonical.y));let t=0,e=0;for(;e<r.length;)r[e].equals(r[t])?++e:r[++t]=r[e++];r.length=t+1;}const n=[];for(const t of r)r.some((e=>t.isChildOf(e)))||n.push(t);return r=n.filter((e=>!t.some((t=>!!(e.overscaledZ<i&&t.isChildOf(e))||e.equals(t)||e.isChildOf(t))))),r}coveringTiles(t){let e=this.coveringZoomLevel(t);const i=e,r=this.elevation&&this.elevation.exaggeration(),n=r&&!t.isTerrainDEM,o="mercator"===this.projection.name;if(void 0!==t.minzoom&&e<t.minzoom)return [];void 0!==t.maxzoom&&e>t.maxzoom&&(e=t.maxzoom);const s=this.locationCoordinate(this.center),a=this.center.lat,l=1<<e,c=[l*s.x,l*s.y,0],h="globe"===this.projection.name,u=!h,d=ku.fromInvProjectionMatrix(this.invProjMatrix,this.worldSize,e,u),p=h?this._camera.mercatorPosition:this.pointCoordinate(this.getCameraPoint()),f=l*Vd(1,this.center.lat),m=this._camera.position[2]/Vd(1,this.center.lat),_=[l*p.x,l*p.y,m*(u?1:f)],g=h||r,y=this.cameraToCenterDistance/t.tileSize*(t.roundZoom?1:.502),x=this.isLODDisabled(!0)?e:0,v=t.isTerrainDEM&&this._elevation?1e4*this._elevation.exaggeration():this._centerAltitude,b=t.isTerrainDEM?-v:this._elevation?this._elevation.getMinElevationBelowMSL():0,w=this.projection.isReprojectedInTileSpace?Bx(this):1,T=t=>{const e=1/4e4,i=new Yd(t.x+e,t.y,t.z),r=new Yd(t.x,t.y+e,t.z),n=t.toLngLat(),o=i.toLngLat(),s=r.toLngLat(),a=this.locationCoordinate(n),l=this.locationCoordinate(o),c=this.locationCoordinate(s),h=Math.hypot(l.x-a.x,l.y-a.y),u=Math.hypot(c.x-a.x,c.y-a.y);return Math.sqrt(h*u)*w/e},M=t=>{const e=v,i=b;return {aabb:gg(this,l,0,0,0,t,i,e,this.projection),zoom:0,x:0,y:0,minZ:i,maxZ:e,wrap:t,fullyVisible:!1}},A=[];let S=[];const I=e,C=t.reparseOverscaled?i:e,z=t=>t*t,D=z((m-this._centerAltitude)*f),P=t=>{if(!this._elevation||!t.tileID||!o)return;const e=this._elevation.getMinMaxForTile(t.tileID),i=t.aabb;e?(i.min[2]=e.min,i.max[2]=e.max,i.center[2]=(i.min[2]+i.max[2])/2):(t.shouldSplit=R(t),t.shouldSplit||(i.min[2]=i.max[2]=i.center[2]=this._centerAltitude));},R=t=>{if(t.zoom<x)return !0;if(t.zoom===I)return !1;if(null!=t.shouldSplit)return t.shouldSplit;const e=t.aabb.distanceX(_),r=t.aabb.distanceY(_);let o=D,s=1;if(h){o=z(t.aabb.distanceZ(_));const e=Math.pow(2,t.zoom),i=Gd((t.y+1)/e),r=Gd(t.y/e),n=Math.min(Math.max(a,i),r),l=Fd(n)/Fd(a);if(s=n===a?1/Math.max(1,this._mercatorScaleRatio-.3):Math.min(1,l/this._mercatorScaleRatio),this.zoom<=Ou&&t.zoom===I-1&&l>=.9)return !0}else if(n&&(o=z(t.aabb.distanceZ(_)*f)),this.projection.isReprojectedInTileSpace&&i<=5){const e=Math.pow(2,t.zoom),i=T(new Yd((t.x+.5)/e,(t.y+.5)/e));s=i>.85?1:i;}const l=e*e+r*r+o,c=z((1<<I-t.zoom)*y*s*((t,e)=>{if(e*z(.707)<t)return 1;const i=Math.sqrt(e/t);return i/(1.4144271570014144+(Math.pow(1.1,i-1.4144271570014144+1)-1)/(1.1-1)-1)})(Math.max(o,D),l));return l<c};if(this.renderWorldCopies)for(let t=1;t<=3;t++)A.push(M(-t)),A.push(M(t));for(A.push(M(0));A.length>0;){const i=A.pop(),r=i.x,s=i.y;let a=i.fullyVisible;const u=()=>"globe"===this.projection.name&&(0===i.y||i.y===(1<<i.zoom)-1);if(!a){let t=g?i.aabb.intersects(d):i.aabb.intersectsFlat(d);if(0===t&&u()){const e=new Dd(i.zoom,r,s);t=td(this,l,e,!0).intersects(d);}if(0===t)continue;a=2===t;}if(i.zoom!==I&&R(i))for(let t=0;t<4;t++){const e=(r<<1)+t%2,c=(s<<1)+(t>>1),u={aabb:o?i.aabb.quadrant(t):gg(this,l,i.zoom+1,e,c,i.wrap,i.minZ,i.maxZ,this.projection),zoom:i.zoom+1,x:e,y:c,wrap:i.wrap,fullyVisible:a,tileID:void 0,shouldSplit:void 0,minZ:i.minZ,maxZ:i.maxZ};n&&!h&&(u.tileID=new Rd(i.zoom+1===I?C:i.zoom+1,i.wrap,i.zoom+1,e,c),P(u)),A.push(u);}else {const n=i.zoom===I?C:i.zoom;if(t.minzoom&&t.minzoom>n)continue;if(!a){let t=g?i.aabb.intersectsPrecise(d):i.aabb.intersectsPreciseFlat(d);if(0===t&&u()){const e=new Dd(i.zoom,r,s);t=td(this,l,e,!0).intersectsPrecise(d);}if(0===t)continue}const o=c[0]-(.5+r+(i.wrap<<i.zoom))*(1<<e-i.zoom),h=c[1]-.5-s,p=i.tileID?i.tileID:new Rd(n,i.wrap,i.zoom,r,s);S.push({tileID:p,distanceSq:o*o+h*h});}}if(this.fogCullDistSq){const e=this.fogCullDistSq,i=this.horizonLineFromTop();S=S.filter((r=>{const n=[0,0,0,1],o=[sr,sr,0,1],s=this.calculateFogTileMatrix(r.tileID.toUnwrapped());au.transformMat4(n,n,s),au.transformMat4(o,o,s);const a=function(t,e,i){let r=0;for(let i=0;i<2;++i){const n=0;t[i]>n&&(r+=(t[i]-n)*(t[i]-n)),e[i]<n&&(r+=(n-e[i])*(n-e[i]));}return r}(n,o);if(0===a)return !0;let l=!1;const c=this._elevation;if(c&&a>e&&0!==i){const e=this.calculateProjMatrix(r.tileID.toUnwrapped());let n;t.isTerrainDEM||(n=c.getMinMaxForTile(r.tileID)),n||(n={min:b,max:v});const o=function(t){const e=Math.round((t+45+360)%360/90)%4;return E[e]}(this.rotation),s=[o[0]*sr,o[1]*sr,n.max];bu.transformMat4(s,s,e),l=(1-s[1])*this.height*.5<i;}return a<e||l}));}return S.sort(((t,e)=>t.distanceSq-e.distanceSq)).map((t=>t.tileID))}resize(t,e){this.width=t,this.height=e,this.pixelsToGLUnits=[2/t,-2/e],this._constrain(),this._calcMatrices();}get unmodified(){return this._unmodified}zoomScale(t){return Math.pow(2,t)}scaleZoom(t){return Math.log(t)/Math.LN2}project(t){const e=z(t.lat,-Zd,Zd),i=this.projection.project(t.lng,e);return new y(i.x*this.worldSize,i.y*this.worldSize)}unproject(t){return this.projection.unproject(t.x/this.worldSize,t.y/this.worldSize)}get point(){return this.project(this.center)}get pointMerc(){return this.point._div(this.worldSize)}get pixelsPerMeterRatio(){return this.pixelsPerMeter/Vd(1,this.center.lat)/this.worldSize}setLocationAtPoint(t,e){let i,r;const n=this.centerPoint;if("globe"===this.projection.name){const t=this.worldSize;i=(e.x-n.x)/t,r=(e.y-n.y)/t;}else {const t=this.pointCoordinate(e),o=this.pointCoordinate(n);i=t.x-o.x,r=t.y-o.y;}const o=this.locationCoordinate(t);this.setLocation(new Yd(o.x-i,o.y-r));}setLocation(t){this.center=this.coordinateLocation(t),this.projection.wrap&&(this.center=this.center.wrap());}locationPoint(t){return this.projection.locationPoint(this,t)}locationPoint3D(t){return this.projection.locationPoint(this,t,!0)}pointLocation(t){return this.coordinateLocation(this.pointCoordinate(t))}pointLocation3D(t){return this.coordinateLocation(this.pointCoordinate3D(t))}locationCoordinate(t,e){const i=e?Vd(e,t.lat):void 0,r=this.projection.project(t.lng,t.lat);return new Yd(r.x,r.y,i)}coordinateLocation(t){return this.projection.unproject(t.x,t.y)}pointRayIntersection(t,e){const i=null!=e?e:this._centerAltitude,r=[t.x,t.y,0,1],n=[t.x,t.y,1,1];au.transformMat4(r,r,this.pixelMatrixInverse),au.transformMat4(n,n,this.pixelMatrixInverse);const o=n[3];au.scale(r,r,1/r[3]),au.scale(n,n,1/o);const s=r[2],a=n[2];return {p0:r,p1:n,t:s===a?0:(i-s)/(a-s)}}screenPointToMercatorRay(t){const e=[t.x,t.y,0,1],i=[t.x,t.y,1,1];return au.transformMat4(e,e,this.pixelMatrixInverse),au.transformMat4(i,i,this.pixelMatrixInverse),au.scale(e,e,1/e[3]),au.scale(i,i,1/i[3]),e[2]=Vd(e[2],this._center.lat)*this.worldSize,i[2]=Vd(i[2],this._center.lat)*this.worldSize,au.scale(e,e,1/this.worldSize),au.scale(i,i,1/this.worldSize),new Cu([e[0],e[1],e[2]],bu.normalize([],bu.sub([],i,e)))}rayIntersectionCoordinate(t){const{p0:e,p1:i,t:r}=t,n=Vd(e[2],this._center.lat),o=Vd(i[2],this._center.lat);return new Yd(Wr(e[0],i[0],r)/this.worldSize,Wr(e[1],i[1],r)/this.worldSize,Wr(n,o,r))}pointCoordinate(t,e=this._centerAltitude){return this.projection.pointCoordinate(this,t.x,t.y,e)}pointCoordinate3D(t){if(!this.elevation)return this.pointCoordinate(t);let e=this.projection.pointCoordinate3D(this,t.x,t.y);if(e)return new Yd(e[0],e[1],e[2]);let i=0,r=this.horizonLineFromTop();if(t.y>r)return this.pointCoordinate(t);const n=.02*r,o=t.clone();for(let t=0;t<10&&r-i>n;t++){o.y=Wr(i,r,.66);const t=this.projection.pointCoordinate3D(this,o.x,o.y);t?(r=o.y,e=t):i=o.y;}return e?new Yd(e[0],e[1],e[2]):this.pointCoordinate(t)}isPointAboveHorizon(t){return this.projection.isPointAboveHorizon(this,t)}isPointOnSurface(t){if(t.y<0||t.y>this.height||t.x<0||t.x>this.width)return !1;if(this.elevation||this.zoom>=Fu)return !this.isPointAboveHorizon(t);const e=this.pointCoordinate(t);return e.y>=0&&e.y<=1}_coordinatePoint(t,e){const i=e&&this.elevation?this.elevation.getAtPointOrZero(t,this._centerAltitude):this._centerAltitude,r=[t.x*this.worldSize,t.y*this.worldSize,i+t.toAltitude(),1];return au.transformMat4(r,r,this.pixelMatrix),r[3]>0?new y(r[0]/r[3],r[1]/r[3]):new y(Number.MAX_VALUE,Number.MAX_VALUE)}_getBoundsNonRectangular(){const{top:t,left:e}=this._edgeInsets,i=this.height-this._edgeInsets.bottom,r=this.width-this._edgeInsets.right,n=this.pointLocation3D(new y(e,t)),o=this.pointLocation3D(new y(r,t)),s=this.pointLocation3D(new y(r,i)),a=this.pointLocation3D(new y(e,i));let l=Math.min(n.lng,o.lng,s.lng,a.lng),c=Math.max(n.lng,o.lng,s.lng,a.lng),h=Math.min(n.lat,o.lat,s.lat,a.lat),u=Math.max(n.lat,o.lat,s.lat,a.lat);const d=Math.pow(2,-this.zoom)/16*270,p="globe"===this.projection.name?1:4,f=(t,e,i,r,n)=>{const o=(t+i)/2,s=(e+r)/2,a=new y(o,s),{lng:m,lat:_}=this.pointLocation3D(a),g=Math.max(0,l-m,h-_,m-c,_-u);l=Math.min(l,m),c=Math.max(c,m),h=Math.min(h,_),u=Math.max(u,_),(n<p||g>d)&&(f(t,e,o,s,n+1),f(o,s,i,r,n+1));};if(f(e,t,r,t,1),f(r,t,r,i,1),f(r,i,e,i,1),f(e,i,e,t,1),"globe"===this.projection.name){const[t,e]=function(t){const e=mu.identity(new Float64Array(16));mu.multiply(e,t.pixelMatrix,t.globeMatrix);const i=[0,Gu,0],r=[0,qu,0];return bu.transformMat4(i,i,e),bu.transformMat4(r,r,e),[i[0]>0&&i[0]<=t.width&&i[1]>0&&i[1]<=t.height&&!vd(t,new Id(t.center.lat,90)),r[0]>0&&r[0]<=t.width&&r[1]>0&&r[1]<=t.height&&!vd(t,new Id(t.center.lat,-90))]}(this);t?(u=90,c=180,l=-180):e&&(h=-90,c=180,l=-180);}return new Xl(new Id(l,h),new Id(c,u))}_getBoundsRectangular(t,e){const{top:i,left:r}=this._edgeInsets,n=this.height-this._edgeInsets.bottom,o=this.width-this._edgeInsets.right,s=new y(r,i),a=new y(o,i),l=new y(o,n),c=new y(r,n);let h=this.pointCoordinate(s,t),u=this.pointCoordinate(a,t);const d=this.pointCoordinate(l,e),p=this.pointCoordinate(c,e),f=(t,e)=>(e.y-t.y)/(e.x-t.x);return h.y>1&&u.y>=0?h=new Yd((1-p.y)/f(p,h)+p.x,1):h.y<0&&u.y<=1&&(h=new Yd(-p.y/f(p,h)+p.x,0)),u.y>1&&h.y>=0?u=new Yd((1-d.y)/f(d,u)+d.x,1):u.y<0&&h.y<=1&&(u=new Yd(-d.y/f(d,u)+d.x,0)),(new Xl).extend(this.coordinateLocation(h)).extend(this.coordinateLocation(u)).extend(this.coordinateLocation(p)).extend(this.coordinateLocation(d))}_getBoundsRectangularTerrain(){const t=this.elevation;if(!t.visibleDemTiles.length||t.isUsingMockSource())return this._getBoundsRectangular(0,0);const e=t.visibleDemTiles.reduce(((t,e)=>{if(e.dem){const i=e.dem.tree;t.min=Math.min(t.min,i.minimums[0]),t.max=Math.max(t.max,i.maximums[0]);}return t}),{min:Number.MAX_VALUE,max:0});return this._getBoundsRectangular(e.min*t.exaggeration(),e.max*t.exaggeration())}getBounds(){return "mercator"===this.projection.name||"equirectangular"===this.projection.name?this._terrainEnabled()?this._getBoundsRectangularTerrain():this._getBoundsRectangular(0,0):this._getBoundsNonRectangular()}horizonLineFromTop(t=!0){const e=this.height/2/Math.tan(this._fov/2)/Math.tan(Math.max(this._pitch,.1))-this.centerOffset.y,i=this.height/2-e*(1-this._horizonShift);return t?Math.max(0,i):i}getMaxBounds(){return this.maxBounds}setMaxBounds(t){this.maxBounds=t,this.minLat=-Zd,this.maxLat=Zd,this.minLng=-180,this.maxLng=180,t&&(this.minLat=t.getSouth(),this.maxLat=t.getNorth(),this.minLng=t.getWest(),this.maxLng=t.getEast(),this.maxLng<this.minLng&&(this.maxLng+=360)),this.worldMinX=Nd(this.minLng)*this.tileSize,this.worldMaxX=Nd(this.maxLng)*this.tileSize,this.worldMinY=Ud(this.maxLat)*this.tileSize,this.worldMaxY=Ud(this.minLat)*this.tileSize,this._constrain();}calculatePosMatrix(t,e){return this.projection.createTileMatrix(this,e,t)}calculateDistanceTileData(t){const e=t.key,i=this._distanceTileDataCache;if(i[e])return i[e];const r=t.canonical,n=1/this.height,o=this.cameraWorldSize,s=o/this.zoomScale(r.z),a=(r.x+Math.pow(2,r.z)*t.wrap)*s,l=r.y*s,c=this.point;c.x*=o/this.worldSize,c.y*=o/this.worldSize;const h=this.angle,u=Math.sin(-h),d=-Math.cos(-h);return i[e]={bearing:[u,d],center:[(c.x-a)*n,(c.y-l)*n],scale:s/sr*n},i[e]}calculateFogTileMatrix(t){const e=t.key,i=this._fogTileMatrixCache;if(i[e])return i[e];const r=this.projection.createTileMatrix(this,this.cameraWorldSizeForFog,t);return mu.multiply(r,this.worldToFogMatrix,r),i[e]=new Float32Array(r),i[e]}calculateProjMatrix(t,e=!1){const i=t.key,r=e?this._alignedProjMatrixCache:this._projMatrixCache;if(r[i])return r[i];const n=this.calculatePosMatrix(t,this.worldSize);return mu.multiply(n,this.projection.isReprojectedInTileSpace?this.mercatorMatrix:e?this.alignedProjMatrix:this.projMatrix,n),r[i]=new Float32Array(n),r[i]}calculatePixelsToTileUnitsMatrix(t){const e=t.tileID.key,i=this._pixelsToTileUnitsCache;if(i[e])return i[e];const r=function(t,e){const{scale:i}=t.tileTransform,r=i*sr/(t.tileSize*Math.pow(2,e.zoom-t.tileID.overscaledZ+t.tileID.canonical.z));return hu.scale(new Float32Array(4),e.inverseAdjustmentMatrix,[r,r])}(t,this);return i[e]=r,i[e]}customLayerMatrix(){return this.mercatorMatrix.slice()}globeToMercatorMatrix(){if("globe"===this.projection.name){const t=1/this.worldSize,e=mu.fromScaling([],[t,t,t]);return mu.multiply(e,e,this.globeMatrix),e}}recenterOnTerrain(){if(!this._elevation||"globe"===this.projection.name)return;const t=this._elevation;this._updateCameraState();const e=Vd(1,this._center.lat)*this.worldSize,i=this._computeCameraPosition(e),r=this._camera.forward(),n=Vd(1,this._center.lat);i[2]/=n,r[2]/=n,bu.normalize(r,r);const o=t.raycast(i,r,t.exaggeration());if(o){const t=bu.scaleAndAdd([],i,r,o),e=new Yd(t[0],t[1],Vd(t[2],Gd(t[1]))),s=(e.z+bu.length([e.x-i[0],e.y-i[1],e.z-i[2]*n]))*this._pixelsPerMercatorPixel;this._seaLevelZoom=this._zoomFromMercatorZ(s),this._centerAltitude=e.toAltitude(),this._center=this.coordinateLocation(e),this._updateZoomFromElevation(),this._constrain(),this._calcMatrices();}}_constrainCamera(t=!1){if(!this._elevation)return;const e=this._elevation,i=Vd(1,this._center.lat)*this.worldSize,r=this._computeCameraPosition(i),n=e.getAtPointOrZero(new Yd(...r)),o=this.pixelsPerMeter/this.worldSize*n,s=this._minimumHeightOverTerrain(),a=r[2]-o;if(a<=s)if(a<0||t){const t=this.locationCoordinate(this._center,this._centerAltitude),e=[r[0],r[1],t.z-r[2]],i=bu.length(e);e[2]-=(s-a)/this._pixelsPerMercatorPixel;const n=bu.length(e);if(0===n)return;bu.scale(e,e,i/n*this._pixelsPerMercatorPixel),this._camera.position=[r[0],r[1],t.z*this._pixelsPerMercatorPixel-e[2]],this._updateStateFromCamera();}else this._isCameraConstrained=!0;}_constrain(){if(!this.center||!this.width||!this.height||this._constraining)return;this._constraining=!0;const t="globe"===this.projection.name||this.mercatorFromTransition;if(this.projection.isReprojectedInTileSpace||t){const e=this.center;return e.lat=z(e.lat,this.minLat,this.maxLat),(this.maxBounds||!this.renderWorldCopies&&!t)&&(e.lng=z(e.lng,this.minLng,this.maxLng)),this.center=e,void(this._constraining=!1)}const e=this._unmodified,{x:i,y:r}=this.point;let n=0,o=i,s=r;const a=this.width/2,l=this.height/2,c=this.worldMinY*this.scale,h=this.worldMaxY*this.scale;if(r-l<c&&(s=c+l),r+l>h&&(s=h-l),h-c<this.height&&(n=Math.max(n,this.height/(h-c)),s=(h+c)/2),this.maxBounds||!this._renderWorldCopies||!this.projection.wrap){const t=this.worldMinX*this.scale,e=this.worldMaxX*this.scale,r=this.worldSize/2-(t+e)/2;o=(i+r+this.worldSize)%this.worldSize-r,o-a<t&&(o=t+a),o+a>e&&(o=e-a),e-t<this.width&&(n=Math.max(n,this.width/(e-t)),o=(e+t)/2);}o===i&&s===r||(this.center=this.unproject(new y(o,s))),n&&(this.zoom+=this.scaleZoom(n)),this._constrainCamera(),this._unmodified=e,this._constraining=!1;}_minZoomForBounds(){let t=Math.max(0,this.scaleZoom(this.height/(this.worldMaxY-this.worldMinY)));return this.maxBounds&&(t=Math.max(t,this.scaleZoom(this.width/(this.worldMaxX-this.worldMinX)))),t}_maxCameraBoundsDistance(){return this._mercatorZfromZoom(this._minZoomForBounds())}_calcMatrices(){if(!this.height)return;const t=this.centerOffset,e=this.pixelsPerMeter;"globe"===this.projection.name&&(this._mercatorScaleRatio=Vd(1,this.center.lat)/Vd(1,45));const i=Ox(this.projection,this.zoom,this.width,this.height,1024);this._pixelsPerMercatorPixel=this.projection.pixelSpaceConversion(this.center.lat,this.worldSize,i),this.cameraToCenterDistance=.5/Math.tan(.5*this._fov)*this.height*this._pixelsPerMercatorPixel,this._updateCameraState(),this._farZ=this.projection.farthestPixelDistance(this),this._nearZ=this.height/50;const r="meters"===this.projection.zAxisUnit?e:1,n=this._camera.getWorldToCamera(this.worldSize,r);let o;const s=this._camera.getCameraToClipPerspective(this._fov,this.width/this.height,this._nearZ,this._farZ);if(s[8]=2*-t.x/this.width,s[9]=2*t.y/this.height,"globe"!==this.projection.name&&this._orthographicProjectionAtLowPitch&&this.pitch<ov){let e=.5*this.height/Math.tan(this._fov/2)*1*Math.tan(.5*this._fov),i=e*this.aspect,r=-i,n=-e;i-=t.x,r-=t.x,e+=t.y,n+=t.y,o=this._camera.getCameraToClipOrthographic(r,i,n,e,this._nearZ,this._farZ),((t,e,i,r)=>{for(let n=0;n<16;n++)t[n]=sv(e[n],i[n],r);})(o,o,s,av(this.pitch>=ov?1:this.pitch/ov));}else o=s;const a=mu.mul([],s,n);let l=mu.mul([],o,n);if(this.projection.isReprojectedInTileSpace){const t=this.locationCoordinate(this.center),e=mu.identity([]);mu.translate(e,e,[t.x*this.worldSize,t.y*this.worldSize,0]),mu.multiply(e,e,kx(this)),mu.translate(e,e,[-t.x*this.worldSize,-t.y*this.worldSize,0]),mu.multiply(l,l,e),mu.multiply(a,a,e),this.inverseAdjustmentMatrix=function(t){const e=kx(t,!0);return hu.invert([],[e[0],e[1],e[4],e[5]])}(this);}else this.inverseAdjustmentMatrix=[1,0,0,1];this.mercatorMatrix=mu.scale([],l,[this.worldSize,this.worldSize,this.worldSize/r,1]),this.projMatrix=l,this.invProjMatrix=mu.invert(new Float64Array(16),this.projMatrix);const c=mu.invert([],o);this.frustumCorners=zu.fromInvProjectionMatrix(c,this.horizonLineFromTop(),this.height);const h=new Float32Array(16);mu.identity(h),mu.scale(h,h,[1,-1,1]),mu.rotateX(h,h,this._pitch),mu.rotateZ(h,h,this.angle);const u=mu.perspective(new Float32Array(16),this._fov,this.width/this.height,this._nearZ,this._farZ);this.starsProjMatrix=mu.clone(u);const d=(Math.PI/2-this._pitch)*(this.height/this._fov)*this._horizonShift;u[8]=2*-t.x/this.width,u[9]=2*(t.y+d)/this.height,this.skyboxMatrix=mu.multiply(h,u,h);const p=this.point,f=p.x,m=p.y,_=this.width%2/2,g=this.height%2/2,y=Math.cos(this.angle),x=Math.sin(this.angle),v=f-Math.round(f)+y*_+x*g,b=m-Math.round(m)+y*g+x*_,w=new Float64Array(l);if(mu.translate(w,w,[v>.5?v-1:v,b>.5?b-1:b,0]),this.alignedProjMatrix=w,l=mu.create(),mu.scale(l,l,[this.width/2,-this.height/2,1]),mu.translate(l,l,[1,-1,0]),this.labelPlaneMatrix=l,l=mu.create(),mu.scale(l,l,[1,-1,1]),mu.translate(l,l,[-1,-1,0]),mu.scale(l,l,[2/this.width,2/this.height,1]),this.glCoordMatrix=l,this.pixelMatrix=mu.multiply(new Float64Array(16),this.labelPlaneMatrix,a),this._calcFogMatrices(),this._distanceTileDataCache={},l=mu.invert(new Float64Array(16),this.pixelMatrix),!l)throw new Error("failed to invert matrix");if(this.pixelMatrixInverse=l,"globe"===this.projection.name||this.mercatorFromTransition){this.globeMatrix=function(t){const{x:e,y:i}=t.point,{lng:r,lat:n}=t._center;return dd(e,i,t.worldSize,r,n)}(this);const t=[this.globeMatrix[12],this.globeMatrix[13],this.globeMatrix[14]];this.globeCenterInViewSpace=bu.transformMat4(t,t,n),this.globeRadius=this.worldSize/2/Math.PI-1;}else this.globeMatrix=l;this._projMatrixCache={},this._alignedProjMatrixCache={},this._pixelsToTileUnitsCache={};}_calcFogMatrices(){this._fogTileMatrixCache={};const t=this.cameraWorldSizeForFog,e=this.cameraPixelsPerMeter,i=this._camera.position,r=1/this.height/this._pixelsPerMercatorPixel,n=[t,t,e];bu.scale(n,n,r),bu.scale(i,i,-1),bu.multiply(i,i,n);const o=mu.create();mu.translate(o,o,i),mu.scale(o,o,n),this.mercatorFogMatrix=o,this.worldToFogMatrix=this._camera.getWorldToCameraPosition(t,e,r);}_computeCameraPosition(t){const e=(t=t||this.pixelsPerMeter)/this.pixelsPerMeter,i=this._camera.forward(),r=this.point,n=this._mercatorZfromZoom(this._seaLevelZoom?this._seaLevelZoom:this._zoom)*e-t/this.worldSize*this._centerAltitude;return [r.x/this.worldSize-i[0]*n,r.y/this.worldSize-i[1]*n,t/this.worldSize*this._centerAltitude-i[2]*n]}_updateCameraState(){this.height&&(this._camera.setPitchBearing(this._pitch,this.angle),this._camera.position=this._computeCameraPosition());}_translateCameraConstrained(t){const e=this._maxCameraBoundsDistance()*Math.cos(this._pitch),i=this._camera.position[2],r=t[2];let n=1;this.projection.wrap&&(this.center=this.center.wrap()),r>0&&(n=Math.min((e-i)/r,1)),this._camera.position=bu.scaleAndAdd([],this._camera.position,t,n),this._updateStateFromCamera();}_updateStateFromCamera(){const t=this._camera.position,e=this._camera.forward(),{pitch:i,bearing:r}=this._camera.getPitchBearing(),n=Vd(this._centerAltitude,this.center.lat)*this._pixelsPerMercatorPixel,o=this._mercatorZfromZoom(this._maxZoom)*Math.cos(w(this._maxPitch)),s=Math.max((t[2]-n)/Math.cos(i),o),a=this._zoomFromMercatorZ(s);bu.scaleAndAdd(t,t,e,s),this._pitch=z(i,w(this.minPitch),w(this.maxPitch)),this.angle=P(r,-Math.PI,Math.PI),this._setZoom(z(a,this._minZoom,this._maxZoom)),this._updateSeaLevelZoom(),this._center=this.coordinateLocation(new Yd(t[0],t[1],t[2])),this._unmodified=!1,this._constrain(),this._calcMatrices();}_worldSizeFromZoom(t){return Math.pow(2,t)*this.tileSize}_mercatorZfromZoom(t){return this.cameraToCenterDistance/this._worldSizeFromZoom(t)}_minimumHeightOverTerrain(){const t=Math.min((null!=this._seaLevelZoom?this._seaLevelZoom:this._zoom)+4,this._maxZoom);return this._mercatorZfromZoom(t)}_zoomFromMercatorZ(t){return this.scaleZoom(this.cameraToCenterDistance/(t*this.tileSize))}zoomFromMercatorZAdjusted(t){let e=0,i=Fu,r=0,n=1/0;for(;i-e>1e-6&&i>e;){const o=e+.5*(i-e),s=this.tileSize*Math.pow(2,o),a=this.getCameraToCenterDistance(this.projection,o,s),l=this.scaleZoom(a/(t*this.tileSize)),c=Math.abs(o-l);c<n&&(n=c,r=o),o<l?e=o:i=o;}return r}_terrainEnabled(){return !(!this._elevation||!this.projection.supportsTerrain&&(W("Terrain is not yet supported with alternate projections. Use mercator or globe to enable terrain."),1))}anyCornerOffEdge(t,e){const i=Math.min(t.x,e.x),r=Math.max(t.x,e.x),n=Math.min(t.y,e.y),o=Math.max(t.y,e.y);if(n<this.horizonLineFromTop(!1))return !0;if("mercator"!==this.projection.name)return !1;const s=[new y(i,n),new y(r,o),new y(i,o),new y(r,n)],a=this.renderWorldCopies?-3:0,l=this.renderWorldCopies?4:1;for(const t of s){const e=this.pointRayIntersection(t);if(e.t<0)return !0;const i=this.rayIntersectionCoordinate(e);if(i.x<a||i.y<0||i.x>l||i.y>1)return !0}return !1}isHorizonVisible(){return this.pitch+T(this.fovAboveCenter)>88||this.anyCornerOffEdge(new y(0,0),new y(this.width,this.height))}zoomDeltaToMovement(t,e){const i=bu.length(bu.sub([],this._camera.position,t)),r=this._zoomFromMercatorZ(i)+e;return i-this._mercatorZfromZoom(r)}getCameraPoint(){if("globe"===this.projection.name){const t=function([t,e,i],r){const n=[t,e,i,1];au.transformMat4(n,n,r);const o=n[3]=Math.max(n[3],1e-6);return n[0]/=o,n[1]/=o,n[2]/=o,n}([this.globeMatrix[12],this.globeMatrix[13],this.globeMatrix[14]],this.pixelMatrix);return new y(t[0],t[1])}{const t=Math.tan(this._pitch)*(this.cameraToCenterDistance||1);return this.centerPoint.add(new y(0,t))}}getCameraToCenterDistance(t,e=this.zoom,i=this.worldSize){const r=Ox(t,e,this.width,this.height,1024),n=t.pixelSpaceConversion(this.center.lat,i,r);let o=.5/Math.tan(.5*this._fov)*this.height*n;return this._orthographicProjectionAtLowPitch&&"globe"!==this.projection.name&&this.pitch<ov&&(o=sv(1,o,av(this.pitch>=ov?1:this.pitch/ov))),o}getWorldToCameraMatrix(){const t=this._camera.getWorldToCamera(this.worldSize,"meters"===this.projection.zAxisUnit?this.pixelsPerMeter:1);return "globe"===this.projection.name&&mu.multiply(t,t,this.globeMatrix),t}}function cv(t,e,i){mu.identity(t),mu.rotateZ(t,t,w(e[2])),mu.rotateX(t,t,w(e[0])),mu.rotateY(t,t,w(e[1])),mu.scale(t,t,i),mu.multiply(t,t,[1,0,0,0,0,0,1,0,0,1,0,0,0,0,0,1]);}function hv(t,e,i,r,n,o,s,a){const l=[i[0]-e[0],i[1]-e[1],0],c=[r[0]-e[0],r[1]-e[1],0];if(bu.length(l)<1e-12||bu.length(c)<1e-12)return gu.identity(t);const h=bu.cross([],l,c);bu.normalize(h,h),bu.subtract(c,r,e),l[2]=(o-n)*a,c[2]=(s-n)*a;const u=l;return bu.cross(u,l,c),bu.normalize(u,u),gu.rotationTo(t,h,u)}function uv(t,e,i=!1){const r=pd(e.zoom),n=function(t,e,i){const r=e.worldSize,n=[t[12],t[13],t[14]],o=Gd(n[1]/r),s=jd(n[0]/r),a=mu.identity([]),l=Vd(1,o)*r,c=Vd(1,0)*r*Hd(o,e.zoom),h=1/hd(r);let u=c*h;if(i){const t=Ox(e.projection,e.zoom,e.width,e.height,1024);u=h*e.projection.pixelSpaceConversion(e.center.lat,r,t);}const d=nd(o,s);bu.add(d,d,bu.scale([],bu.normalize([],d),l*u*n[2]));const p=function(t){const e=[t[0],t[1],t[2]];let i=[0,1,0];const r=bu.cross([],i,e);return bu.cross(i,e,r),0===bu.squaredLength(i)&&(i=[0,1,0],bu.cross(r,e,i)),bu.normalize(r,r),bu.normalize(i,i),bu.normalize(e,e),[r[0],r[1],r[2],0,i[0],i[1],i[2],0,e[0],e[1],e[2],0,t[0],t[1],t[2],1]}(d);mu.scale(a,a,[u,u,u*l]),mu.translate(a,a,[-n[0],-n[1],-n[2]]);const f=mu.multiply([],e.globeMatrix,p);return mu.multiply(f,f,a),mu.multiply(f,f,t),f}(t,e,i);if(r>0){const i=function(t,e){const i=e.worldSize,r=Vd(1,0)*i*Hd(e.center.lat,e.zoom)/hd(i),n=Vd(1,e.center.lat)*i,o=mu.identity([]);return mu.rotateY(o,o,w(e.center.lng)),mu.rotateX(o,o,w(e.center.lat)),mu.translate(o,o,[0,0,Nu]),mu.scale(o,o,[r,r,r*n]),mu.translate(o,o,[e.point.x-.5*i,e.point.y-.5*i,0]),mu.multiply(o,o,t),mu.multiply(o,e.globeMatrix,o)}(t,e);return function(t,e,i){const r=(t,e,i)=>{const r=bu.length(t),n=bu.length(e),o=Ku(t,e,i);return bu.scale(o,o,1/bu.length(o)*Wr(r,n,i))},n=r([t[0],t[1],t[2]],[e[0],e[1],e[2]],i),o=r([t[4],t[5],t[6]],[e[4],e[5],e[6]],i),s=r([t[8],t[9],t[10]],[e[8],e[9],e[10]],i),a=Ku([t[12],t[13],t[14]],[e[12],e[13],e[14]],i);return [n[0],n[1],n[2],0,o[0],o[1],o[2],0,s[0],s[1],s[2],0,a[0],a[1],a[2],1]}(n,i,r)}return n}const dv=64,pv=[1,1,1];class fv{constructor(t,e,i,r){this.id=t,this.position=null!=e?new Id(e[0],e[1]):new Id(0,0),this.orientation=null!=i?i:[0,0,0],this.nodes=r,this.uploaded=!1,this.aabb=new Bu([1/0,1/0,1/0],[-1/0,-1/0,-1/0]),this.matrix=[];}_applyTransformations(t,e){if(mu.multiply(t.matrix,e,t.matrix),t.meshes)for(const e of t.meshes){const i=Bu.applyTransform(e.aabb,t.matrix);this.aabb.encapsulate(i);}if(t.children)for(const e of t.children)this._applyTransformations(e,t.matrix);}computeBoundsAndApplyParent(){const t=mu.identity([]);for(const e of this.nodes)this._applyTransformations(e,t);}_positionModelOnTerrain(t,e){const i=t.elevation;if(!i)return 0;const r=Bu.projectAabbCorners(this.aabb,this.matrix),n=Vd(1,this.position.lat)*t.worldSize,o=function(t,e){const i=[0,0,1],r=[{corners:[0,1,3,2],dotProductWithUp:0},{corners:[1,5,2,6],dotProductWithUp:0},{corners:[0,4,1,5],dotProductWithUp:0},{corners:[2,6,3,7],dotProductWithUp:0},{corners:[4,7,5,6],dotProductWithUp:0},{corners:[0,3,4,7],dotProductWithUp:0}];for(const n of r){const r=t[n.corners[0]],o=t[n.corners[1]],s=t[n.corners[2]],a=[o[0]-r[0],o[1]-r[1],e*(o[2]-r[2])],l=bu.cross(a,a,[s[0]-r[0],s[1]-r[1],e*(s[2]-r[2])]);bu.normalize(l,l),n.dotProductWithUp=bu.dot(l,i);}return r.sort(((t,e)=>t.dotProductWithUp-e.dotProductWithUp)),r[0].corners}(r,n),s=r[o[0]],a=r[o[1]],l=r[o[2]],c=r[o[3]],h=i.getAtPointOrZero(new Yd(s[0]/t.worldSize,s[1]/t.worldSize),0),u=i.getAtPointOrZero(new Yd(a[0]/t.worldSize,a[1]/t.worldSize),0),d=i.getAtPointOrZero(new Yd(l[0]/t.worldSize,l[1]/t.worldSize),0),p=i.getAtPointOrZero(new Yd(c[0]/t.worldSize,c[1]/t.worldSize),0),f=(h+p)/2,m=(u+d)/2;return f>m?u<d?hv(e,a,c,s,u,p,h,n):hv(e,l,s,c,d,h,p,n):h<p?hv(e,s,a,l,h,u,d,n):hv(e,c,l,a,p,d,u,n),Math.max(f,m)}computeModelMatrix(t,e,i,r,n,o,s=!1){const a=t.transform,l=a.zoom,c=a.project(this.position),h=Hd(this.position.lat,l),u=1/h;mu.identity(this.matrix),mu.translate(this.matrix,this.matrix,[c.x+r[0]*u,c.y+r[1]*u,r[2]]);let d=1,p=1;const f=a.worldSize;if(s){if("mercator"===a.projection.name){let t=0;a.elevation&&(t=a.elevation.getAtPointOrZero(new Yd(c.x/f,c.y/f),0));const e=au.transformMat4([],[c.x,c.y,t,1],a.projMatrix)[3]/a.cameraToCenterDistance;d=e,p=e*Hd(a.center.lat,l);}else if("globe"===a.projection.name){const t=uv(this.matrix,a),e=mu.multiply([],a.projMatrix,t),i=[0,0,0,1];au.transformMat4(i,i,e);const r=i[3]/a.cameraToCenterDistance,n=pd(l),o=a.projection.pixelsPerMeter(this.position.lat,f)*Hd(this.position.lat,l),s=a.projection.pixelsPerMeter(a.center.lat,f)*Hd(a.center.lat,l);d=r/Wr(o,$d(a.center.lat),n),p=r*h/o,d*=s,p*=s;}}else d=u;mu.scale(this.matrix,this.matrix,[d,d,p]);const m=[...this.matrix],_=this.orientation,g=[];if(cv(g,[_[0]+e[0],_[1]+e[1],_[2]+e[2]],i),mu.multiply(this.matrix,m,g),n&&a.elevation){let t=0;const e=[];if(o&&a.elevation){t=this._positionModelOnTerrain(a,e);const i=mu.fromQuat([],e),r=mu.multiply([],i,g);mu.multiply(this.matrix,m,r);}else t=a.elevation.getAtPointOrZero(new Yd(c.x/f,c.y/f),0);0!==t&&(this.matrix[14]+=t);}}upload(t){if(!this.uploaded){for(const e of this.nodes)gv(e,t);for(const t of this.nodes)yv(t);this.uploaded=!0;}}destroy(){for(const t of this.nodes)xv(t);}}function mv(t,e,i=!1){t.uploaded||(t.gfxTexture=new hy(e,t.image,i?e.gl.R8:e.gl.RGBA,{useMipmap:t.sampler.mipmaps}),t.uploaded=!0,t.image=null);}function _v(t,e,i){t.indexBuffer=e.createIndexBuffer(t.indexArray,!1,!0),t.vertexBuffer=e.createVertexBuffer(t.vertexArray,wx.members,!1,!0),t.normalArray&&(t.normalBuffer=e.createVertexBuffer(t.normalArray,Ax.members,!1,!0)),t.texcoordArray&&(t.texcoordBuffer=e.createVertexBuffer(t.texcoordArray,Mx.members,!1,!0)),t.colorArray&&(t.colorBuffer=e.createVertexBuffer(t.colorArray,(12===t.colorArray.bytesPerElement?Tx:Ex).members,!1,!0)),t.featureArray&&(t.pbrBuffer=e.createVertexBuffer(t.featureArray,Ix.members,!0)),t.segments=Wl.simpleSegment(0,0,t.vertexArray.length,t.indexArray.length);const r=t.material;r.pbrMetallicRoughness.baseColorTexture&&mv(r.pbrMetallicRoughness.baseColorTexture,e),r.pbrMetallicRoughness.metallicRoughnessTexture&&mv(r.pbrMetallicRoughness.metallicRoughnessTexture,e),r.normalTexture&&mv(r.normalTexture,e),r.occlusionTexture&&mv(r.occlusionTexture,e,i),r.emissionTexture&&mv(r.emissionTexture,e);}function gv(t,e,i){if(t.meshes)for(const r of t.meshes)_v(r,e,i);if(t.children)for(const r of t.children)gv(r,e,i);}function yv(t){if(t.meshes)for(const e of t.meshes)e.indexArray.destroy(),e.vertexArray.destroy(),e.colorArray&&e.colorArray.destroy(),e.normalArray&&e.normalArray.destroy(),e.texcoordArray&&e.texcoordArray.destroy(),e.featureArray&&e.featureArray.destroy();if(t.children)for(const e of t.children)yv(e);}function xv(t){if(t.meshes)for(const i of t.meshes)i.vertexBuffer&&(i.vertexBuffer.destroy(),i.indexBuffer.destroy(),i.normalBuffer&&i.normalBuffer.destroy(),i.texcoordBuffer&&i.texcoordBuffer.destroy(),i.colorBuffer&&i.colorBuffer.destroy(),i.pbrBuffer&&i.pbrBuffer.destroy(),i.segments.destroy(),i.material&&((e=i.material).pbrMetallicRoughness.baseColorTexture&&e.pbrMetallicRoughness.baseColorTexture.gfxTexture&&e.pbrMetallicRoughness.baseColorTexture.gfxTexture.destroy(),e.pbrMetallicRoughness.metallicRoughnessTexture&&e.pbrMetallicRoughness.metallicRoughnessTexture.gfxTexture&&e.pbrMetallicRoughness.metallicRoughnessTexture.gfxTexture.destroy(),e.normalTexture&&e.normalTexture.gfxTexture&&e.normalTexture.gfxTexture.destroy(),e.emissionTexture&&e.emissionTexture.gfxTexture&&e.emissionTexture.gfxTexture.destroy(),e.occlusionTexture&&e.occlusionTexture.gfxTexture&&e.occlusionTexture.gfxTexture.destroy()));var e;if(t.children)for(const e of t.children)xv(e);}class vv{constructor(t,e){this.feature=t,this.instancedDataOffset=e,this.instancedDataCount=0;}}class bv{constructor(){this.instancedDataArray=new Za,this.instancesEvaluatedElevation=[],this.features=[],this.idToFeaturesIndex={};}}class wv{constructor(t){this.zoom=t.zoom,this.canonical=t.canonical,this.layers=t.layers,this.layerIds=this.layers.map((t=>t.id)),this.projection=t.projection,this.index=t.index,this.stateDependentLayerIds=this.layers.filter((t=>t.isStateDependent())).map((t=>t.id)),this.hasPattern=!1,this.instancesPerModel={},this.validForExaggeration=0,this.maxVerticalOffset=0,this.maxScale=0,this.maxHeight=0,this.lookupDim=this.zoom>this.canonical.z?256:this.zoom>15?75:100,this.instanceCount=0,this.terrainElevationMin=0,this.terrainElevationMax=0;}populate(t,e,i,r){this.tileToMeter=Xd(i);const n=this.layers[0]._featureFilter.needGeometry;this.lookup=new Uint8Array(this.lookupDim*this.lookupDim);for(const{feature:o,id:s,index:a,sourceLayerIndex:l}of t){const t=op(o,n);if(!this.layers[0]._featureFilter.filter(new Qs(this.zoom),t,i))continue;const c={id:s,sourceLayerIndex:l,index:a,geometry:n?t.geometry:np(o,i,r),properties:o.properties,type:o.type,patterns:{}},h=this.addFeature(c,c.geometry,t);h&&e.featureIndex.insert(o,c.geometry,a,l,this.index,this.instancesPerModel[h].instancedDataArray.length);}this.lookup=null;}update(t,e,i,r){for(const e in this.instancesPerModel){const i=this.instancesPerModel[e];for(const e in t)i.idToFeaturesIndex.hasOwnProperty(e)&&this.evaluate(i.features[i.idToFeaturesIndex[e]],t[e],i,!0);}this.maxHeight=0;}isEmpty(){for(const t in this.instancesPerModel)if(0!==this.instancesPerModel[t].instancedDataArray.length)return !1;return !0}uploadPending(){return !this.uploaded}upload(t){if(!this.uploaded)for(const e in this.instancesPerModel){const i=this.instancesPerModel[e];i.instancedDataArray.length<0||0===i.instancedDataArray.length||(i.instancedDataBuffer?i.instancedDataBuffer.updateData(i.instancedDataArray):i.instancedDataBuffer=t.createVertexBuffer(i.instancedDataArray,Sx.members,!0,void 0,this.instanceCount));}this.uploaded=!0;}destroy(){for(const t in this.instancesPerModel){const e=this.instancesPerModel[t];0!==e.instancedDataArray.length&&e.instancedDataBuffer&&e.instancedDataBuffer.destroy();}}addFeature(t,e,i){const r=this.layers[0],n=r.layout.get("model-id").evaluate(i,{},this.canonical);if(!n)return W(`modelId is not evaluated for layer ${r.id} and it is not going to get rendered.`),n;this.instancesPerModel[n]||(this.instancesPerModel[n]=new bv);const o=this.instancesPerModel[n],s=o.instancedDataArray,a=new vv(i,s.length);for(const t of e)for(const e of t){if(e.x<0||e.x>=sr||e.y<0||e.y>=sr)continue;const t=(this.lookupDim-1)/sr,i=this.lookupDim*(e.y*t|0)+e.x*t|0;if(this.lookup){if(0!==this.lookup[i])continue;this.lookup[i]=1;}this.instanceCount++;const r=s.length;s.resize(r+1),o.instancesEvaluatedElevation.push(0),s.float32[16*r]=e.x,s.float32[16*r+1]=e.y;}return a.instancedDataCount=o.instancedDataArray.length-a.instancedDataOffset,a.instancedDataCount>0&&(t.id&&(o.idToFeaturesIndex[t.id]=o.features.length),o.features.push(a),this.evaluate(a,{},o,!1)),n}evaluate(t,e,i,r){const n=this.layers[0],o=t.feature,s=this.canonical,a=n.paint.get("model-rotation").evaluate(o,e,s),l=n.paint.get("model-scale").evaluate(o,e,s),c=n.paint.get("model-translation").evaluate(o,e,s),h=n.paint.get("model-color").evaluate(o,e,s);h.a=n.paint.get("model-color-mix-intensity").evaluate(o,e,s);const u=[];this.maxVerticalOffset<c[2]&&(this.maxVerticalOffset=c[2]),this.maxScale=Math.max(Math.max(this.maxScale,l[0]),Math.max(l[1],l[2])),cv(u,a,l);const d=Math.round(100*h.a)+h.b/1.05;for(let e=0;e<t.instancedDataCount;++e){const n=t.instancedDataOffset+e,o=16*n,a=i.instancedDataArray.float32;let l=0;r&&(l=a[o+6]-i.instancesEvaluatedElevation[n]);const p=0|a[o+1];a[o]=(0|a[o])+h.r/1.05,a[o+1]=p+h.g/1.05,a[o+2]=d,a[o+3]=1/(s.z>10?this.tileToMeter:Xd(s,p)),a[o+4]=c[0],a[o+5]=c[1],a[o+6]=c[2]+l,a[o+7]=u[0],a[o+8]=u[1],a[o+9]=u[2],a[o+10]=u[4],a[o+11]=u[5],a[o+12]=u[6],a[o+13]=u[8],a[o+14]=u[9],a[o+15]=u[10],i.instancesEvaluatedElevation[n]=c[2];}}}Ss(wv,"ModelBucket",{omit:["layers"]}),Ss(bv,"PerModelAttributes"),Ss(vv,"ModelFeature");const Tv=new ua({visibility:new la(ze.layout_model.visibility),"model-id":new ca(ze.layout_model["model-id"])});var Ev={paint:new ua({"model-opacity":new la(ze.paint_model["model-opacity"]),"model-rotation":new ca(ze.paint_model["model-rotation"]),"model-scale":new ca(ze.paint_model["model-scale"]),"model-translation":new ca(ze.paint_model["model-translation"]),"model-color":new ca(ze.paint_model["model-color"]),"model-color-mix-intensity":new ca(ze.paint_model["model-color-mix-intensity"]),"model-type":new la(ze.paint_model["model-type"]),"model-cast-shadows":new la(ze.paint_model["model-cast-shadows"]),"model-receive-shadows":new la(ze.paint_model["model-receive-shadows"]),"model-ambient-occlusion-intensity":new la(ze.paint_model["model-ambient-occlusion-intensity"]),"model-emissive-strength":new ca(ze.paint_model["model-emissive-strength"]),"model-roughness":new ca(ze.paint_model["model-roughness"]),"model-height-based-emissive-strength-multiplier":new ca(ze.paint_model["model-height-based-emissive-strength-multiplier"]),"model-cutoff-fade-range":new la(ze.paint_model["model-cutoff-fade-range"])}),layout:Tv};function Mv(t){let e=0;if(t.meshes)for(const i of t.meshes)e=Math.max(e,i.aabb.max[2]);if(t.children)for(const i of t.children)e=Math.max(e,Mv(i));return e}const Av=["","wall","door","roof","window","lamp","logo"];class Sv{constructor(t){this.node=t,this.evaluatedRMEA=[[1,0,0,1],[1,0,0,1],[1,0,0,1],[1,0,0,1],[.4,1,0,1],[1,0,0,1],[1,0,0,1]],this.hiddenByReplacement=!1,this.evaluatedScale=[1,1,1],this.evaluatedColor=[],this.emissionHeightBasedParams=[],this.feature={type:"Point",id:t.id,geometry:[],properties:{height:Mv(t)}};}}class Iv{constructor(t,e,i,r){this.nodes=t,this.id=e,this.modelTraits|=1,this.uploaded=!1,this.hasPattern=!1,i&&(this.modelTraits|=4),this.zoom=-1,this.terrainExaggeration=1,this.projection={name:"mercator"},this.replacementUpdateTime=0,this.elevationReadFromZ=255,this.brightness=r,this.dirty=!0,this.needsUpload=!1;}update(){console.log("Update 3D model bucket");}populate(){console.log("populate 3D model bucket");}uploadPending(){return !this.uploaded||this.needsUpload}upload(t){if(!this.needsUpload)return;const e=this.getNodesInfo();for(const i of e){const e=i.node;this.uploaded?this.updatePbrBuffer(e):gv(e,t,!0);}for(const t of e)yv(t.node);this.uploaded=!0,this.needsUpload=!1;}updatePbrBuffer(t){let e=!1;if(!t.meshes)return e;for(const i of t.meshes)i.pbrBuffer&&(i.pbrBuffer.updateData(i.featureArray),e=!0);return e}needsReEvaluation(t,e,i){const r=t.transform.projectionOptions,n=t.style.getBrightness(),o=this.brightness!==n;return !!(!this.uploaded||this.dirty||r.name!==this.projection.name||Cv(i.paint.get("model-color").value,o)||Cv(i.paint.get("model-color-mix-intensity").value,o)||Cv(i.paint.get("model-roughness").value,o)||Cv(i.paint.get("model-emissive-strength").value,o)||Cv(i.paint.get("model-height-based-emissive-strength-multiplier").value,o))&&(this.dirty=!1,this.projection=r,this.brightness=n,!0)}evaluateScale(t,e){if(t.transform.zoom===this.zoom)return;this.zoom=t.transform.zoom;const i=this.getNodesInfo(),r=this.id.canonical;for(const t of i){const i=t.feature;t.evaluatedScale=e.paint.get("model-scale").evaluate(i,{},r);}}evaluate(t){const e=this.getNodesInfo();for(const i of e){if(!i.node.meshes)continue;const e=i.feature,r=i.node.meshes&&i.node.meshes[0].featureData,n=i.evaluatedColor[2],o=i.evaluatedRMEA[2],s=this.id.canonical;if(i.hasTranslucentParts=!1,r){for(let r=0;r<Av.length;r++){const n=Av[r];n.length&&(e.properties.part=n);const o=t.paint.get("model-color").evaluate(e,{},s),a=t.paint.get("model-color-mix-intensity").evaluate(e,{},s);i.evaluatedColor[r]=[o.r,o.g,o.b,a],i.evaluatedRMEA[r][0]=t.paint.get("model-roughness").evaluate(e,{},s),i.evaluatedRMEA[r][2]=t.paint.get("model-emissive-strength").evaluate(e,{},s),i.evaluatedRMEA[r][3]=o.a,i.emissionHeightBasedParams[r]=t.paint.get("model-height-based-emissive-strength-multiplier").evaluate(e,{},s),!i.hasTranslucentParts&&o.a<1&&(i.hasTranslucentParts=!0);}delete e.properties.part,Dv(i,n!==i.evaluatedColor[2]||o!==i.evaluatedRMEA[2]);}i.evaluatedScale=t.paint.get("model-scale").evaluate(e,{},s),this.updatePbrBuffer(i.node)||(this.needsUpload=!0);}}elevationUpdate(t,e,i){const r=t.findDEMTileFor(i);if((r!==this.terrainTile||e!==this.terrainExaggeration)&&t&&r&&r.dem&&r.tileID.overscaledZ!==this.elevationReadFromZ){this.elevationReadFromZ=r.tileID.overscaledZ;const e=Om.create(t,this.id,r);if(!e)return;for(const t of this.getNodesInfo()){const i=t.node;if(!i.footprint||!i.footprint.vertices||!i.footprint.vertices.length)continue;const r=i.footprint.vertices;let n=e.getElevationAt(r[0].x,r[0].y,!0,!0);for(let t=1;t<r.length;t++)n=Math.min(n,e.getElevationAt(r[t].x,r[t].y,!0,!0));i.elevation=n;}}}getNodesInfo(){if(!this.nodesInfo){this.nodesInfo=[];for(const t of this.nodes)this.nodesInfo.push(new Sv(t));this.freeNodes();}return this.nodesInfo}freeNodes(){if(this.nodes){for(const t of this.nodes)xv(t);this.nodes.splice(0,this.nodes.length);}}destroy(){this.freeNodes();const t=this.getNodesInfo();for(const e of t)yv(e.node),xv(e.node);}isEmpty(){return !this.nodes.length}updateReplacement(t,e){if(e.updateTime===this.replacementUpdateTime)return;this.replacementUpdateTime=e.updateTime;const i=e.getReplacementRegionsForTile(t.toUnwrapped()),r=this.getNodesInfo();for(let t=0;t<this.nodesInfo.length;t++){const e=r[t].node;r[t].hiddenByReplacement=!!e.footprint&&!i.find((t=>t.footprint===e.footprint));}}getHeightAtTileCoord(t,e){const i=this.getNodesInfo(),r=[];for(let n=0;n<this.nodesInfo.length;n++){const o=i[n],s=o.node.meshes[0];if(t<s.aabb.min[0]||e<s.aabb.min[1]||t>s.aabb.max[0]||e>s.aabb.max[1])continue;const a=(t-s.aabb.min[0])/(s.aabb.max[0]-s.aabb.min[0])*dv|0,l=Math.min(63,(e-s.aabb.min[1])/(s.aabb.max[1]-s.aabb.min[1])*dv|0)*dv+Math.min(63,a);if(!(s.heightmap[l]<0&&o.node.footprint)){if(o.hiddenByReplacement)return;return {height:s.heightmap[l],hidden:!1,verticalScale:o.evaluatedScale[2]}}if(o.node.footprint.grid.query(new y(t,e),new y(t,e),r),r.length>0)return {height:void 0,hidden:o.hiddenByReplacement,verticalScale:o.evaluatedScale[2]}}}}function Cv(t,e){return !t.isLightConstant&&e}function zv(t,e,i,r,n,o,s,a){let l=(61440&e|(61440&e)>>4)>>8,c=(3840&e|(3840&e)>>4)>>4,h=240&e|(240&e)>>4;i[3]>0&&(l=Wr(l,255*i[0],i[3]),c=Wr(c,255*i[1],i[3]),h=Wr(h,255*i[2],i[3]));const u=l<<8|c,d=h<<8|Math.floor(255*r[3]),p=function(t){const e=z(t,0,2);return Math.min(Math.round(.5*e*255),255)}(r[2])<<8|15*r[0]<<4|15*r[1],f=z(n[0],0,1),m=z(n[1],0,1),_=z(n[2],0,1),g=z(n[3],0,1);let y,x,v,b;if(f!==m&&s!==o&&m!==f){const t=s-o;x=1/(t*(m-f)),v=-(o+t*f)/(t*(m-f));const e=z(n[4],-1,1);b=Math.pow(10,e),y=255*_<<8|255*g;}else y=65535,x=0,v=1,b=1;if(t.emplaceBack(u,d,p,y,x,v,b),a){const t=a.length;a.clear();for(let e=0;e<t;e++)a.emplaceBack(u,d,p,y,x,v,b);}}function Dv(t,e){const i=t.node;let r=0;for(const n of i.meshes){if(i.lights&&i.lightMeshIndex===r)continue;if(!n.featureData)continue;n.featureArray=new $a,n.featureArray.reserve(n.featureData.length);let o=e;for(const e of n.featureData){let r;const s=65535&e,a=(15&s)<8?15&s:0,l=e>>16&65535,c=t.evaluatedRMEA[a],h=t.evaluatedColor[a],u=t.emissionHeightBasedParams[a];if(o&&2===a&&i.lights&&(r=new $a,r.resize(10*i.lights.length)),zv(n.featureArray,l,h,c,u,n.aabb.min[2],n.aabb.max[2],r),r&&o){o=!1;const t=i.meshes[i.lightMeshIndex];t.featureArray=r,t.featureArray._trim();}}n.featureArray._trim(),r++;}}Ss(Iv,"Tiled3dModelBucket",{omit:["layers"]}),Ss(Sv,"Tiled3dModelFeature");class Pv{constructor(){this._updateTime=0,this._sourceIds=[],this._activeRegions=[],this._prevRegions=[];}clear(){this._activeRegions.length>0&&++this._updateTime,this._activeRegions=[],this._prevRegions=[];}get updateTime(){return this._updateTime}getReplacementRegionsForTile(t){const e=Bv(new y(0,0),new y(sr,sr),t),i=[];for(const r of this._activeRegions){if(r.hiddenByOverlap)continue;if(!kv(e,r))continue;const n=Ov(r.min,r.max,t);i.push({min:n.min,max:n.max,sourceId:this._sourceIds[r.priority],footprint:r.footprint,footprintTileId:r.tileId});}return i}setSources(t){this._setSources(t.map((t=>({getSourceId:()=>t.cache.id,getFootprints:()=>{const e=[];for(const i of t.cache.getVisibleCoordinates()){const r=t.cache.getTile(i).buckets[t.layer];if(r)for(const t of r.getNodesInfo()){const r=t.node;r.footprint&&e.push({footprint:r.footprint,id:i.toUnwrapped()});}}return e}}))));}_addSource(t){const e=t.getFootprints();if(0!==e.length){for(const t of e){if(!t.footprint)continue;const e=Bv(t.footprint.min,t.footprint.max,t.id);this._activeRegions.push({min:e.min,max:e.max,hiddenByOverlap:!1,priority:this._sourceIds.length,tileId:t.id,footprint:t.footprint});}this._sourceIds.push(t.getSourceId());}}_computeReplacement(){this._activeRegions.sort(((t,e)=>t.priority-e.priority||Rv(t.min,e.min)||Rv(t.max,e.max)));let t=this._activeRegions.length!==this._prevRegions.length;if(!t){let e=0,i=0;for(;!t&&e!==this._activeRegions.length;){const r=this._activeRegions[e],n=this._prevRegions[i];t=r.priority!==n.priority||!Lv(r,n),++e,++i;}}if(t){++this._updateTime;const t=t=>{const e=this._activeRegions;if(t>=e.length)return t;const i=e[t].priority;for(;t<e.length&&e[t].priority===i;)++t;return t};if(this._sourceIds.length>1){let e=0,i=t(e);for(;e!==i;){let r=e;const n=e;for(;r!==i;){const t=this._activeRegions[r];t.hiddenByOverlap=!1;for(let e=0;e<n;e++){const i=this._activeRegions[e];if(!i.hiddenByOverlap&&kv(t,i)&&(t.hiddenByOverlap=Nv(t.footprint,t.tileId,i.footprint,i.tileId),t.hiddenByOverlap))break}++r;}e=i,i=t(e);}}}}_setSources(t){[this._prevRegions,this._activeRegions]=[this._activeRegions,[]],this._sourceIds=[];for(let e=t.length-1;e>=0;e--)this._addSource(t[e]);this._computeReplacement();}}function Rv(t,e){return t.x-e.x||t.y-e.y}function Lv(t,e){return 0===Rv(t.min,e.min)&&0===Rv(t.max,e.max)}function kv(t,e){return !(t.min.x>e.max.x||t.max.x<e.min.x||t.min.y>e.max.y||t.max.y<e.min.y)}function Bv(t,e,i){const r=1/sr,n=1/(1<<i.canonical.z),o=(e.x*r+i.canonical.x)*n+i.wrap,s=(e.y*r+i.canonical.y)*n;return {min:new y((t.x*r+i.canonical.x)*n+i.wrap,(t.y*r+i.canonical.y)*n),max:new y(o,s)}}function Ov(t,e,i){const r=1<<i.canonical.z,n=((e.x-i.wrap)*r-i.canonical.x)*sr,o=(e.y*r-i.canonical.y)*sr;return {min:new y(((t.x-i.wrap)*r-i.canonical.x)*sr,(t.y*r-i.canonical.y)*sr),max:new y(n,o)}}function Fv(t,e,i,r,n,o,s){const a=t.indices,l=t.vertices,c=[];for(let h=r;h<r+n;h+=3){const r=e[i[h+0]+o],n=e[i[h+1]+o],u=e[i[h+2]+o],d=Math.min(r.x,n.x,u.x),p=Math.max(r.x,n.x,u.x),f=Math.min(r.y,n.y,u.y),m=Math.max(r.y,n.y,u.y);c.length=0,t.grid.query(new y(d,f),new y(p,m),c);for(let t=0;t<c.length;t++){const e=c[t];if(wp(l[a[3*e+0]],l[a[3*e+1]],l[a[3*e+2]],r,n,u,s))return !0}}return !1}function Nv(t,e,i,r){if(!t||!i)return !1;let n=t.vertices;if(!e.canonical.equals(r.canonical)||e.wrap!==r.wrap){if(i.vertices.length<t.vertices.length)return Nv(i,r,t,e);const o=e.canonical,s=r.canonical,a=Math.pow(2,s.z-o.z);n=t.vertices.map((t=>new y(t.x*o.x*sr*a-s.x*sr,t.y*o.y*sr*a-s.y*sr)));}return Fv(i,n,t.indices,0,t.indices.length,0,0)}const Uv=Xf.types,Vv=Math.pow(2,13),jv=new y(0,1),Gv=2147483648;function qv(t,e,i,r,n,o,s,a){t.emplaceBack((e<<1)+s,(i<<1)+o,(Math.floor(r*Vv)<<1)+n,Math.round(a));}function Zv(t,e,i,r,n,o){t.emplaceBack(e.x,e.y,(i.x<<1)+r,(i.y<<1)+n,o);}function $v(t,e,i){const r=16384;t.emplaceBack(e.x,e.y,e.z,i[0]*r,i[1]*r,i[2]*r);}class Hv{constructor(){this.vertexOffset=0,this.vertexCount=0,this.indexOffset=0,this.indexCount=0;}}class Wv{constructor(){this.centroidXY=new y(0,0),this.vertexArrayOffset=0,this.vertexCount=0,this.groundVertexArrayOffset=0,this.groundVertexCount=0,this.flags=0,this.footprintSegIdx=-1,this.footprintSegLen=0,this.min=new y(Number.MAX_VALUE,Number.MAX_VALUE),this.max=new y(-Number.MAX_VALUE,-Number.MAX_VALUE),this.height=0;}span(){return new y(this.max.x-this.min.x,this.max.y-this.min.y)}}class Xv{constructor(){this.acc=new y(0,0),this.accCount=0,this.centroidDataIndex=0;}startRing(t,e){t.min.x===Number.MAX_VALUE&&(t.min.x=t.max.x=e.x,t.min.y=t.max.y=e.y);}appendEdge(t,e,i){this.accCount++,this.acc._add(e);let r=!!this.borders;e.x<t.min.x?(t.min.x=e.x,r=!0):e.x>t.max.x&&(t.max.x=e.x,r=!0),e.y<t.min.y?(t.min.y=e.y,r=!0):e.y>t.max.y&&(t.max.y=e.y,r=!0),((0===e.x||e.x===sr)&&e.x===i.x)!=((0===e.y||e.y===sr)&&e.y===i.y)&&this.processBorderOverlap(e,i),r&&this.checkBorderIntersection(e,i);}checkBorderIntersection(t,e){e.x<0!=t.x<0&&this.addBorderIntersection(0,Wr(e.y,t.y,(0-e.x)/(t.x-e.x))),e.x>sr!=t.x>sr&&this.addBorderIntersection(1,Wr(e.y,t.y,(sr-e.x)/(t.x-e.x))),e.y<0!=t.y<0&&this.addBorderIntersection(2,Wr(e.x,t.x,(0-e.y)/(t.y-e.y))),e.y>sr!=t.y>sr&&this.addBorderIntersection(3,Wr(e.x,t.x,(sr-e.y)/(t.y-e.y)));}addBorderIntersection(t,e){this.borders||(this.borders=[[Number.MAX_VALUE,-Number.MAX_VALUE],[Number.MAX_VALUE,-Number.MAX_VALUE],[Number.MAX_VALUE,-Number.MAX_VALUE],[Number.MAX_VALUE,-Number.MAX_VALUE]]);const i=this.borders[t];e<i[0]&&(i[0]=e),e>i[1]&&(i[1]=e);}processBorderOverlap(t,e){if(t.x===e.x){if(t.y===e.y)return;const i=0===t.x?0:1;this.addBorderIntersection(i,e.y),this.addBorderIntersection(i,t.y);}else {const i=0===t.y?2:3;this.addBorderIntersection(i,e.x),this.addBorderIntersection(i,t.x);}}centroid(){return 0===this.accCount?new y(0,0):new y(Math.floor(Math.max(0,this.acc.x)/this.accCount),Math.floor(Math.max(0,this.acc.y)/this.accCount))}intersectsCount(){return this.borders?this.borders.reduce(((t,e)=>t+ +(e[0]!==Number.MAX_VALUE)),0):0}}function Yv(t,e){const i=t.add(e)._unit(),r=z(t.x*i.x+t.y*i.y,-1,1);var n,o,s;return n=Math.acos(r),Math.min(4,Math.max(-4,Math.tan(n)))/4*Vv*((o=t).x*(s=e).y-o.y*s.x<0?-1:1)}const Kv=[t=>t.x<0,t=>t.x>sr,t=>t.y<0,t=>t.y>sr];function Jv(t,e,i,r){const n=[4];if(0===r)return n;i._mult(r);const o=t.sub(i),s=e.sub(i),a=[t,e,o,s];for(let t=0;t<4;t++)for(const e of a)if(Kv[t](e)){n.push(t);break}return n}class Qv{constructor(t){this.vertexArray=new ba,this.indexArray=new Ba,this.programConfigurations=new Fl(t.layers,t.zoom),this._segments=new Wl,this.hiddenByLandmarkVertexArray=new Ha,this.segmentToGroundQuads={},this.segmentToGroundQuads[0]=[],this.segmentToRegionTriCounts={},this.segmentToRegionTriCounts[0]=[0,0,0,0,0],this.regionSegments={},this.regionSegments[4]=new Wl;}getDefaultSegment(){return this.regionSegments[4]}hasData(){return 0!==this.vertexArray.length}addData(t,e,i){const r=t.length;if(r>2){let n=Math.max(0,this._segments.get().length-1);const o=this._segments._prepareSegment(4*r,this.vertexArray.length,2*this.segmentToGroundQuads[n].length);let s;n!==this._segments.get().length-1&&(n++,this.segmentToGroundQuads[n]=[],this.segmentToRegionTriCounts[n]=[0,0,0,0,0]);{const e=t[0],i=t[1];s=Yv(e.sub(t[r-1])._perp()._unit(),i.sub(e)._perp()._unit());}for(let a=0;a<r;a++){const l=a===r-1?0:a+1,c=t[a],h=t[l],u=t[l===r-1?0:l+1],d=h.sub(c)._perp()._unit(),p=Yv(d,u.sub(h)._perp()._unit()),f=s,m=p;if(nb(c,h,e)||ob(c,e)&&ob(h,e)){s=p;continue}const _=o.vertexLength;Zv(this.vertexArray,c,h,1,1,f),Zv(this.vertexArray,c,h,1,0,f),Zv(this.vertexArray,c,h,0,1,m),Zv(this.vertexArray,c,h,0,0,m),o.vertexLength+=4;const g=Jv(c,h,d,i);for(const t of g)this.segmentToGroundQuads[n].push({id:_,region:t}),this.segmentToRegionTriCounts[n][t]+=2,o.primitiveLength+=2;s=p;}}}prepareBorderSegments(){if(!this.hasData())return;const t=this._segments.get(),e=t.length;for(let t=0;t<e;t++)this.segmentToGroundQuads[t].sort(((t,e)=>t.region-e.region));for(let i=0;i<e;i++){const e=this.segmentToGroundQuads[i],r=t[i],n=this.segmentToRegionTriCounts[i];n.reduce(((t,e)=>t+e),0);let o=0;for(let t=0;t<=4;t++){const e=n[t];if(0!==e){let i=this.regionSegments[t];i||(i=this.regionSegments[t]=new Wl);const n={vertexOffset:r.vertexOffset,primitiveOffset:r.primitiveOffset+o,vertexLength:r.vertexLength,primitiveLength:e};i.get().push(n);}o+=e;}for(let t=0;t<e.length;t++){const i=e[t].id;this.indexArray.emplaceBack(i,i+1,i+3),this.indexArray.emplaceBack(i,i+3,i+2);}}this.segmentToGroundQuads=null,this.segmentToRegionTriCounts=null,this._segments.destroy(),this._segments=null;}addPaintPropertiesData(t,e,i,r,n,o){this.hasData()&&this.programConfigurations.populatePaintArrays(this.vertexArray.length,t,e,i,r,n,o);}upload(t){this.hasData()&&(this.vertexBuffer=t.createVertexBuffer(this.vertexArray,Df.members),this.indexBuffer=t.createIndexBuffer(this.indexArray));}uploadPaintProperties(t){this.hasData()&&this.programConfigurations.upload(t);}update(t,e,i,r,n,o){this.hasData()&&this.programConfigurations.updatePaintArrays(t,e,i,r,n,o);}updateHiddenByLandmark(t){if(!this.hasData())return;const e=t.groundVertexCount+t.groundVertexArrayOffset;if(0===t.groundVertexCount)return;const i=t.flags&Gv?1:0;for(let r=t.groundVertexArrayOffset;r<e;++r)this.hiddenByLandmarkVertexArray.emplace(r,i);this.needsHiddenByLandmarkUpdate=!0;}uploadHiddenByLandmark(t){this.hasData()&&this.needsHiddenByLandmarkUpdate&&(!this.hiddenByLandmarkVertexBuffer&&this.hiddenByLandmarkVertexArray.length>0?this.hiddenByLandmarkVertexBuffer=t.createVertexBuffer(this.hiddenByLandmarkVertexArray,Rf.members,!0):this.hiddenByLandmarkVertexBuffer&&this.hiddenByLandmarkVertexBuffer.updateData(this.hiddenByLandmarkVertexArray),this.needsHiddenByLandmarkUpdate=!1);}destroy(){if(this.vertexBuffer){this.vertexBuffer.destroy(),this.indexBuffer.destroy(),this.hiddenByLandmarkVertexBuffer&&this.hiddenByLandmarkVertexBuffer.destroy(),this._segments&&this._segments.destroy(),this.programConfigurations.destroy();for(let t=0;t<=4;t++){const e=this.regionSegments[t];e&&e.destroy();}}}}class tb{constructor(t){this.zoom=t.zoom,this.canonical=t.canonical,this.overscaling=t.overscaling,this.layers=t.layers,this.layerIds=this.layers.map((t=>t.id)),this.index=t.index,this.hasPattern=!1,this.edgeRadius=0,this.projection=t.projection,this.activeReplacements=[],this.replacementUpdateTime=0,this.centroidData=[],this.footprintIndices=new Ba,this.footprintVertices=new ya,this.footprintSegments=[],this.layoutVertexArray=new va,this.centroidVertexArray=new nl,this.indexArray=new Ba,this.programConfigurations=new Fl(t.layers,t.zoom),this.segments=new Wl,this.stateDependentLayerIds=this.layers.filter((t=>t.isStateDependent())).map((t=>t.id)),this.groundEffect=new Qv(t),this.maxHeight=0,this.partLookup={};}populate(t,e,i,r){this.features=[],this.hasPattern=Mf("fill-extrusion",this.layers,e),this.featuresOnBorder=[],this.borderFeatureIndices=[[],[],[],[]],this.borderDoneWithNeighborZ=[-1,-1,-1,-1],this.tileToMeter=Xd(i),this.edgeRadius=this.layers[0].layout.get("fill-extrusion-edge-radius")/this.tileToMeter;for(const{feature:n,id:o,index:s,sourceLayerIndex:a}of t){const t=this.layers[0]._featureFilter.needGeometry,l=op(n,t);if(!this.layers[0]._featureFilter.filter(new Qs(this.zoom),l,i))continue;const c={id:o,sourceLayerIndex:a,index:s,geometry:t?l.geometry:np(n,i,r),properties:n.properties,type:n.type,patterns:{}},h=this.layoutVertexArray.length;this.hasPattern?this.features.push(Af("fill-extrusion",this.layers,c,this.zoom,e)):this.addFeature(c,c.geometry,s,i,{},e.availableImages,r,e.brightness),e.featureIndex.insert(n,c.geometry,s,a,this.index,h);}this.sortBorders(),this.groundEffect.prepareBorderSegments();}addFeatures(t,e,i,r,n,o){for(const t of this.features){const{geometry:s}=t;this.addFeature(t,s,t.index,e,i,r,n,o);}this.sortBorders();}update(t,e,i,r,n){const o=0!==Object.keys(t).length;if(o&&!this.stateDependentLayers.length)return;const s=o?this.stateDependentLayers:this.layers;this.programConfigurations.updatePaintArrays(t,e,s,i,r,n),this.groundEffect.update(t,e,s,i,r,n);}isEmpty(){return 0===this.layoutVertexArray.length}uploadPending(){return !this.uploaded||this.programConfigurations.needsUpload||this.groundEffect.programConfigurations.needsUpload}upload(t){this.uploaded||(this.layoutVertexBuffer=t.createVertexBuffer(this.layoutVertexArray,kf),this.indexBuffer=t.createIndexBuffer(this.indexArray),this.layoutVertexExtArray&&(this.layoutVertexExtBuffer=t.createVertexBuffer(this.layoutVertexExtArray,Lf.members,!0)),this.groundEffect.upload(t)),this.groundEffect.uploadPaintProperties(t),this.programConfigurations.upload(t),this.uploaded=!0;}uploadCentroid(t){this.groundEffect.uploadHiddenByLandmark(t),this.needsCentroidUpdate&&(!this.centroidVertexBuffer&&this.centroidVertexArray.length>0?this.centroidVertexBuffer=t.createVertexBuffer(this.centroidVertexArray,Pf.members,!0):this.centroidVertexBuffer&&this.centroidVertexBuffer.updateData(this.centroidVertexArray),this.needsCentroidUpdate=!1);}destroy(){this.layoutVertexBuffer&&(this.layoutVertexBuffer.destroy(),this.centroidVertexBuffer&&this.centroidVertexBuffer.destroy(),this.layoutVertexExtBuffer&&this.layoutVertexExtBuffer.destroy(),this.groundEffect.destroy(),this.indexBuffer.destroy(),this.programConfigurations.destroy(),this.segments.destroy());}addFeature(t,e,i,r,n,o,s,a){const l=this.layers[0].paint.get("fill-extrusion-flood-light-ground-radius").evaluate(t,{})/this.tileToMeter,c=[new y(0,0),new y(sr,sr)],h=s.projection,u="globe"===h.name,d="Polygon"===Uv[t.type],p=new Xv;p.centroidDataIndex=this.centroidData.length;const f=new Wv,m=this.layers[0].paint.get("fill-extrusion-height").evaluate(t,{},r);f.height=m,f.vertexArrayOffset=this.layoutVertexArray.length,f.groundVertexArrayOffset=this.groundEffect.vertexArray.length,u&&!this.layoutVertexExtArray&&(this.layoutVertexExtArray=new Aa);const _=Tf(e,500);for(let t=_.length-1;t>=0;t--){const e=_[t];(0===e.length||(g=e[0]).every((t=>t.x<=0))||g.every((t=>t.x>=sr))||g.every((t=>t.y<=0))||g.every((t=>t.y>=sr)))&&_.splice(t,1);}var g;let x;if(u)x=cb(_,c,r);else {x=[];for(const t of _)x.push({polygon:t,bounds:c});}const v=d?this.edgeRadius:0,b=v>0&&this.zoom<17,w=(t,e)=>{if(0===t.length)return !1;const i=t[t.length-1];return e.x===i.x&&e.y===i.y};for(const{polygon:t,bounds:e}of x){let i=0,n=0;for(const e of t)d&&!e[0].equals(e[e.length-1])&&e.push(e[0]),n+=d?e.length-1:e.length;const o=this.segments.prepareSegment((d?5:4)*n,this.layoutVertexArray,this.indexArray);f.footprintSegIdx<0&&(f.footprintSegIdx=this.footprintSegments.length);const s=new Hv;if(s.vertexOffset=this.footprintVertices.length,s.indexOffset=3*this.footprintIndices.length,d){const n=[],a=[];i=o.vertexLength;for(let i=0;i<t.length;i++){const s=t[i];s.length&&0!==i&&a.push(n.length/2);const c=[];let d,p;d=s[1].sub(s[0])._perp()._unit();for(let t=1;t<s.length;t++){const e=s[t],i=s[t===s.length-1?1:t+1],a=e.clone();if(v){p=i.sub(e)._perp()._unit();const t=d.add(p)._unit(),r=v*Math.min(4,1/(d.x*t.x+d.y*t.y));a.x+=r*t.x,a.y+=r*t.y,a.x=Math.round(a.x),a.y=Math.round(a.y),d=p;}0!==v&&!b||w(c,a)||c.push(a),qv(this.layoutVertexArray,a.x,a.y,0,0,1,1,0),o.vertexLength++,this.footprintVertices.emplaceBack(e.x,e.y),n.push(e.x,e.y),u&&$v(this.layoutVertexExtArray,h.projectTilePoint(a.x,a.y,r),h.upVector(r,a.x,a.y));}(0===v||b)&&(0!==c.length&&w(c,c[0])&&c.pop(),this.groundEffect.addData(c,e,l));}const c=wf(n,a);for(let t=0;t<c.length;t+=3)this.footprintIndices.emplaceBack(s.vertexOffset+c[t+0],s.vertexOffset+c[t+1],s.vertexOffset+c[t+2]),this.indexArray.emplaceBack(i+c[t],i+c[t+2],i+c[t+1]),o.primitiveLength++;s.indexCount+=c.length,s.vertexCount+=this.footprintVertices.length-s.vertexOffset;}for(let n=0;n<t.length;n++){const s=t[n];p.startRing(f,s[0]);let a=s.length>4&&sb(s[s.length-2],s[0],s[1]),c=v?ib(s[s.length-2],s[0],s[1],v):0;const m=[];let _,g,y;g=s[1].sub(s[0])._perp()._unit();let x=!0;for(let t=1,n=0;t<s.length;t++){let l=s[t-1],d=s[t];const b=s[t===s.length-1?1:t+1];if(p.appendEdge(f,d,l),nb(d,l,e)){v&&(g=b.sub(d)._perp()._unit(),x=!x);continue}const T=d.sub(l)._perp(),E=T.x/(Math.abs(T.x)+Math.abs(T.y)),M=T.y>0?1:0,A=l.dist(d);if(n+A>32768&&(n=0),v){y=b.sub(d)._perp()._unit();let t=rb(l,d,b,eb(g,y),v);isNaN(t)&&(t=0);const e=d.sub(l)._unit();l=l.add(e.mult(c))._round(),d=d.add(e.mult(-t))._round(),c=t,g=y,this.zoom>=17&&(w(m,l)||m.push(l),w(m,d)||m.push(d));}const S=o.vertexLength,I=s.length>4&&sb(l,d,b);let C=ab(n,a,x);if(qv(this.layoutVertexArray,l.x,l.y,E,M,0,0,C),qv(this.layoutVertexArray,l.x,l.y,E,M,0,1,C),n+=A,C=ab(n,I,!x),a=I,qv(this.layoutVertexArray,d.x,d.y,E,M,0,0,C),qv(this.layoutVertexArray,d.x,d.y,E,M,0,1,C),o.vertexLength+=4,this.indexArray.emplaceBack(S+0,S+1,S+2),this.indexArray.emplaceBack(S+1,S+3,S+2),o.primitiveLength+=2,v){const r=i+(1===t?s.length-2:t-2),n=1===t?i:r+1;if(this.indexArray.emplaceBack(S+1,r,S+3),this.indexArray.emplaceBack(r,n,S+3),o.primitiveLength+=2,void 0===_&&(_=S),!nb(b,s[t],e)){const e=t===s.length-1?_:o.vertexLength;this.indexArray.emplaceBack(S+2,S+3,e),this.indexArray.emplaceBack(S+3,e+1,e),this.indexArray.emplaceBack(S+3,n,e+1),o.primitiveLength+=3;}x=!x;}if(u){const t=this.layoutVertexExtArray,e=h.projectTilePoint(l.x,l.y,r),i=h.projectTilePoint(d.x,d.y,r),n=h.upVector(r,l.x,l.y),o=h.upVector(r,d.x,d.y);$v(t,e,n),$v(t,e,n),$v(t,i,o),$v(t,i,o);}}d&&(i+=s.length-1),v&&this.zoom>=17&&(0!==m.length&&w(m,m[0])&&m.pop(),this.groundEffect.addData(m,e,l));}this.footprintSegments.push(s),++f.footprintSegLen;}if(f.vertexCount=this.layoutVertexArray.length-f.vertexArrayOffset,f.groundVertexCount=this.groundEffect.vertexArray.length-f.groundVertexArrayOffset,0!==f.vertexCount){if(f.centroidXY=p.borders?jv:this.encodeCentroid(p,f),this.centroidData.push(f),p.borders){this.featuresOnBorder.push(p);const t=this.featuresOnBorder.length-1;for(let e=0;e<p.borders.length;e++)p.borders[e][0]!==Number.MAX_VALUE&&this.borderFeatureIndices[e].push(t);}this.programConfigurations.populatePaintArrays(this.layoutVertexArray.length,t,i,n,o,r,a),this.groundEffect.addPaintPropertiesData(t,i,n,o,r,a),this.maxHeight=Math.max(this.maxHeight,m);}}sortBorders(){for(let t=0;t<this.borderFeatureIndices.length;t++)this.borderFeatureIndices[t].sort(((e,i)=>this.featuresOnBorder[e].borders[t][0]-this.featuresOnBorder[i].borders[t][0]));}encodeCentroid(t,e){const i=t.centroid(),r=e.span(),n=Math.min(7,Math.round(r.x*this.tileToMeter/10)),o=Math.min(7,Math.round(r.y*this.tileToMeter/10));return new y(z(i.x,1,sr-1)<<3|n,z(i.y,1,sr-1)<<3|o)}showCentroid(t){const e=this.centroidData[t.centroidDataIndex];e.flags&=Gv,e.centroidXY.x=0,e.centroidXY.y=0,this.writeCentroidToBuffer(e);}writeCentroidToBuffer(t){this.groundEffect.updateHiddenByLandmark(t);const e=t.vertexArrayOffset,i=t.vertexCount+t.vertexArrayOffset,r=t.flags&Gv?jv:t.centroidXY,n=this.centroidVertexArray.geta_centroid_pos0(e);if(this.centroidVertexArray.geta_centroid_pos1(e)!==r.y||n!==r.x){for(let t=e;t<i;++t)this.centroidVertexArray.emplace(t,r.x,r.y);this.needsCentroidUpdate=!0;}}createCentroidsBuffer(){this.centroidVertexArray.resize(this.layoutVertexArray.length),this.groundEffect.hiddenByLandmarkVertexArray.resize(this.groundEffect.vertexArray.length);for(const t of this.centroidData)this.writeCentroidToBuffer(t);}updateReplacement(t,e){if(e.updateTime===this.replacementUpdateTime)return;this.replacementUpdateTime=e.updateTime;const i=e.getReplacementRegionsForTile(t.toUnwrapped());if(function(t,e){if(t.length!==e.length)return !1;for(let i=0;i<t.length;i++)if(t[i].sourceId!==e[i].sourceId||!Lv(t[i],e[i]))return !1;return !0}(this.activeReplacements,i))return;if(this.activeReplacements=i,0===this.centroidVertexArray.length)this.createCentroidsBuffer();else for(const t of this.centroidData)t.flags&=2147483647;const r=[];for(const e of this.activeReplacements){const i=Math.pow(2,e.footprintTileId.canonical.z-t.canonical.z);for(const n of this.centroidData)if(!(n.flags&Gv||e.min.x>n.max.x||n.min.x>e.max.x||e.min.y>n.max.y||n.min.y>e.max.y))for(let o=0;o<n.footprintSegLen;o++){const s=this.footprintSegments[n.footprintSegIdx+o];if(r.length=0,hb(this.footprintVertices,s.vertexOffset,s.vertexCount,e.footprintTileId.canonical,t.canonical,r),Fv(e.footprint,r,this.footprintIndices.uint16,s.indexOffset,s.indexCount,-s.vertexOffset,-i)){n.flags|=Gv;break}}}for(const t of this.centroidData)this.writeCentroidToBuffer(t);this.borderDoneWithNeighborZ=[-1,-1,-1,-1];}footprintContainsPoint(t,e,i){let r=!1;for(let n=0,o=i.vertexCount-1;n<i.vertexCount;o=n++){const s=this.footprintVertices.int16[2*(n+i.vertexOffset)+0],a=this.footprintVertices.int16[2*(n+i.vertexOffset)+1],l=this.footprintVertices.int16[2*(o+i.vertexOffset)+1];a>e!=l>e&&t<(this.footprintVertices.int16[2*(o+i.vertexOffset)+0]-s)*(e-a)/(l-a)+s&&(r=!r);}return r}getHeightAtTileCoord(t,e){let i=0,r=!0;const n=4*(t+sr)*sr+(e+sr);if(this.partLookup.hasOwnProperty(n)){const t=this.partLookup[n];return t?{height:t.height,hidden:!!(t.flags&Gv)}:void 0}for(const o of this.centroidData)if(!(t>o.max.x||o.min.x>t||e>o.max.y||o.min.y>e))for(let s=0;s<o.footprintSegLen;s++)this.footprintContainsPoint(t,e,this.footprintSegments[o.footprintSegIdx+s])&&o&&o.height>i&&(i=o.height,this.partLookup[n]=o,r=!!(o.flags&Gv));if(void 0!==i)return {height:i,hidden:r};this.partLookup[n]=void 0;}}function eb(t,e){const i=t.add(e)._unit();return t.x*i.x+t.y*i.y}function ib(t,e,i,r){const n=e.sub(t)._perp()._unit(),o=i.sub(e)._perp()._unit();return rb(t,e,i,eb(n,o),r)}function rb(t,e,i,r,n){const o=Math.sqrt(1-r*r);return Math.min(t.dist(e)/3,e.dist(i)/3,n*o/r)}function nb(t,e,i){return t.x<i[0].x&&e.x<i[0].x||t.x>i[1].x&&e.x>i[1].x||t.y<i[0].y&&e.y<i[0].y||t.y>i[1].y&&e.y>i[1].y}function ob(t,e){return t.x<e[0].x||t.x>e[1].x||t.y<e[0].y||t.y>e[1].y}function sb(t,e,i){if(t.x<0||t.x>=sr||e.x<0||e.x>=sr||i.x<0||i.x>=sr)return !1;const r=i.sub(e),n=r.perp(),o=t.sub(e);return (r.x*o.x+r.y*o.y)/Math.sqrt((r.x*r.x+r.y*r.y)*(o.x*o.x+o.y*o.y))>-.866&&n.x*o.x+n.y*o.y<0}function ab(t,e,i){const r=e?2|t:-3&t;return i?1|r:-2&r}function lb(){const t=Math.PI/32,e=Math.tan(t),i=Md;return i*Math.sqrt(1+2*e*e)-i}function cb(t,e,i){const r=1<<i.z,n=jd(i.x/r),o=jd((i.x+1)/r),s=Gd(i.y/r),a=Gd((i.y+1)/r);return function(t,e,i,r,n=0,o){const s=[];if(!t.length||!i||!r)return s;const a=(t,e)=>{for(const i of t)s.push({polygon:i,bounds:e});},l=Math.ceil(Math.log2(i)),c=Math.ceil(Math.log2(r)),h=l-c,u=[];for(let t=0;t<Math.abs(h);t++)u.push(h>0?0:1);for(let t=0;t<Math.min(l,c);t++)u.push(0),u.push(1);let d=t;if(d=Yf(d,e[0].y-n,e[1].y+n,1),d=Yf(d,e[0].x-n,e[1].x+n,0),!d.length)return s;const p=[];for(u.length?p.push({polygons:d,bounds:e,depth:0}):a(d,e);p.length;){const t=p.pop(),e=t.depth,i=u[e],r=t.bounds[0],s=t.bounds[1],l=0===i?r.x:r.y,c=0===i?s.x:s.y,h=o?o(i,l,c):.5*(l+c),d=Yf(t.polygons,l-n,h+n,i),f=Yf(t.polygons,h-n,c+n,i);if(d.length){const t=[r,new y(0===i?h:s.x,1===i?h:s.y)];u.length>e+1?p.push({polygons:d,bounds:t,depth:e+1}):a(d,t);}if(f.length){const t=[new y(0===i?h:r.x,1===i?h:r.y),s];u.length>e+1?p.push({polygons:f,bounds:t,depth:e+1}):a(f,t);}}return s}(t,e,Math.ceil((o-n)/11.25),Math.ceil((s-a)/11.25),1,((t,e,n)=>{if(0===t)return .5*(e+n);{const t=Gd((i.y+e/sr)/r);return (Ud(.5*(Gd((i.y+n/sr)/r)+t))*r-i.y)*sr}}))}function hb(t,e,i,r,n,o){const s=Math.pow(2,r.z-n.z);for(let a=0;a<i;a++){let i=t.int16[2*(a+e)+0],l=t.int16[2*(a+e)+1];i=(i+n.x*sr)*s-r.x*sr,l=(l+n.y*sr)*s-r.y*sr,o.push(new y(i,l));}}Ss(tb,"FillExtrusionBucket",{omit:["layers","features"]}),Ss(Wv,"PartData"),Ss(Hv,"FootprintSegment"),Ss(Xv,"BorderCentroidData"),Ss(Qv,"GroundEffect");const ub=new ua({visibility:new la(ze["layout_fill-extrusion"].visibility),"fill-extrusion-edge-radius":new la(ze["layout_fill-extrusion"]["fill-extrusion-edge-radius"])});var db={paint:new ua({"fill-extrusion-opacity":new la(ze["paint_fill-extrusion"]["fill-extrusion-opacity"]),"fill-extrusion-color":new ca(ze["paint_fill-extrusion"]["fill-extrusion-color"]),"fill-extrusion-translate":new la(ze["paint_fill-extrusion"]["fill-extrusion-translate"]),"fill-extrusion-translate-anchor":new la(ze["paint_fill-extrusion"]["fill-extrusion-translate-anchor"]),"fill-extrusion-pattern":new ca(ze["paint_fill-extrusion"]["fill-extrusion-pattern"]),"fill-extrusion-height":new ca(ze["paint_fill-extrusion"]["fill-extrusion-height"]),"fill-extrusion-base":new ca(ze["paint_fill-extrusion"]["fill-extrusion-base"]),"fill-extrusion-vertical-gradient":new la(ze["paint_fill-extrusion"]["fill-extrusion-vertical-gradient"]),"fill-extrusion-ambient-occlusion-intensity":new la(ze["paint_fill-extrusion"]["fill-extrusion-ambient-occlusion-intensity"]),"fill-extrusion-ambient-occlusion-radius":new la(ze["paint_fill-extrusion"]["fill-extrusion-ambient-occlusion-radius"]),"fill-extrusion-ambient-occlusion-wall-radius":new la(ze["paint_fill-extrusion"]["fill-extrusion-ambient-occlusion-wall-radius"]),"fill-extrusion-ambient-occlusion-ground-radius":new la(ze["paint_fill-extrusion"]["fill-extrusion-ambient-occlusion-ground-radius"]),"fill-extrusion-ambient-occlusion-ground-attenuation":new la(ze["paint_fill-extrusion"]["fill-extrusion-ambient-occlusion-ground-attenuation"]),"fill-extrusion-flood-light-color":new la(ze["paint_fill-extrusion"]["fill-extrusion-flood-light-color"]),"fill-extrusion-flood-light-intensity":new la(ze["paint_fill-extrusion"]["fill-extrusion-flood-light-intensity"]),"fill-extrusion-flood-light-wall-radius":new ca(ze["paint_fill-extrusion"]["fill-extrusion-flood-light-wall-radius"]),"fill-extrusion-flood-light-ground-radius":new ca(ze["paint_fill-extrusion"]["fill-extrusion-flood-light-ground-radius"]),"fill-extrusion-flood-light-ground-attenuation":new la(ze["paint_fill-extrusion"]["fill-extrusion-flood-light-ground-attenuation"]),"fill-extrusion-vertical-scale":new la(ze["paint_fill-extrusion"]["fill-extrusion-vertical-scale"]),"fill-extrusion-rounded-roof":new la(ze["paint_fill-extrusion"]["fill-extrusion-rounded-roof"]),"fill-extrusion-cutoff-fade-range":new la(ze["paint_fill-extrusion"]["fill-extrusion-cutoff-fade-range"])}),layout:ub};class pb extends y{constructor(t,e,i){super(t,e),this.z=i;}}function fb(t,e){return t.x*e.x+t.y*e.y}function mb(t,e){if(1===t.length){let i=0;const r=e[i++];let n;for(;!n||r.equals(n);)if(n=e[i++],!n)return 1/0;for(;i<e.length;i++){const o=e[i],s=t[0],a=n.sub(r),l=o.sub(r),c=s.sub(r),h=fb(a,a),u=fb(a,l),d=fb(l,l),p=fb(c,a),f=fb(c,l),m=h*d-u*u,_=(d*p-u*f)/m,g=(h*f-u*p)/m,y=r.z*(1-_-g)+n.z*_+o.z*g;if(isFinite(y))return y}return 1/0}{let t=1/0;for(const i of e)t=Math.min(t,i.z);return t}}function _b(t,e,i,r,n,o,s,a){const l=s*n.getElevationAt(t,e,!0,!0),c=0!==o[0],h=c?0===o[1]?s*(o[0]/7-450):s*function(t,e,i){const r=Math.floor(e[0]/8),n=Math.floor(e[1]/8),o=10*(e[0]-8*r),s=10*(e[1]-8*n),a=t.getElevationAt(r,n,!0,!0),l=t.getMeterToDEM(i),c=Math.floor(.5*(o*l-1)),h=Math.floor(.5*(s*l-1)),u=t.tileCoordToPixel(r,n),d=2*c+1,p=2*h+1,f=function(t,e,i,r,n){return [t.getElevationAtPixel(e,i,!0),t.getElevationAtPixel(e+n,i,!0),t.getElevationAtPixel(e,i+n,!0),t.getElevationAtPixel(e+r,i+n,!0)]}(t,u.x-c,u.y-h,d,p),m=Math.abs(f[0]-f[1]),_=Math.abs(f[2]-f[3]),g=Math.abs(f[0]-f[2])+Math.abs(f[1]-f[3]),y=Math.min(.25,.5*l*(m+_)/d),x=Math.min(.25,.5*l*g/p);return a+Math.max(y*o,x*s)}(n,o,a):l;return {base:l+(0===i)?-1:i,top:c?Math.max(h+r,l+i+2):l+r}}const gb=new ua({"line-cap":new ca(ze.layout_line["line-cap"]),"line-join":new ca(ze.layout_line["line-join"]),"line-miter-limit":new la(ze.layout_line["line-miter-limit"]),"line-round-limit":new la(ze.layout_line["line-round-limit"]),"line-sort-key":new ca(ze.layout_line["line-sort-key"]),visibility:new la(ze.layout_line.visibility)});var yb={paint:new ua({"line-opacity":new ca(ze.paint_line["line-opacity"]),"line-color":new ca(ze.paint_line["line-color"]),"line-translate":new la(ze.paint_line["line-translate"]),"line-translate-anchor":new la(ze.paint_line["line-translate-anchor"]),"line-width":new ca(ze.paint_line["line-width"]),"line-gap-width":new ca(ze.paint_line["line-gap-width"]),"line-offset":new ca(ze.paint_line["line-offset"]),"line-blur":new ca(ze.paint_line["line-blur"]),"line-dasharray":new ca(ze.paint_line["line-dasharray"]),"line-pattern":new ca(ze.paint_line["line-pattern"]),"line-gradient":new ha(ze.paint_line["line-gradient"]),"line-trim-offset":new la(ze.paint_line["line-trim-offset"]),"line-emissive-strength":new la(ze.paint_line["line-emissive-strength"]),"line-border-width":new ca(ze.paint_line["line-border-width"]),"line-border-color":new ca(ze.paint_line["line-border-color"])}),layout:gb};const xb=new class extends ca{possiblyEvaluate(t,e){return e=new Qs(Math.floor(e.zoom),{now:e.now,fadeDuration:e.fadeDuration,transition:e.transition}),super.possiblyEvaluate(t,e)}evaluate(t,e,i,r){return e=k({},e,{zoom:Math.floor(e.zoom)}),super.evaluate(t,e,i,r)}}(yb.paint.properties["line-width"].specification);function vb(t,e){return e>0?e+2*t:t}xb.useIntegerZoom=!0;const bb=new ua({visibility:new la(ze.layout_background.visibility)});var wb={paint:new ua({"background-color":new la(ze.paint_background["background-color"]),"background-pattern":new la(ze.paint_background["background-pattern"]),"background-opacity":new la(ze.paint_background["background-opacity"]),"background-emissive-strength":new la(ze.paint_background["background-emissive-strength"])}),layout:bb};const Tb=new ua({visibility:new la(ze.layout_raster.visibility)});var Eb={paint:new ua({"raster-opacity":new la(ze.paint_raster["raster-opacity"]),"raster-color":new ha(ze.paint_raster["raster-color"]),"raster-color-mix":new la(ze.paint_raster["raster-color-mix"]),"raster-color-range":new la(ze.paint_raster["raster-color-range"]),"raster-hue-rotate":new la(ze.paint_raster["raster-hue-rotate"]),"raster-brightness-min":new la(ze.paint_raster["raster-brightness-min"]),"raster-brightness-max":new la(ze.paint_raster["raster-brightness-max"]),"raster-saturation":new la(ze.paint_raster["raster-saturation"]),"raster-contrast":new la(ze.paint_raster["raster-contrast"]),"raster-resampling":new la(ze.paint_raster["raster-resampling"]),"raster-fade-duration":new la(ze.paint_raster["raster-fade-duration"])}),layout:Tb};class Mb extends Zl{constructor(t){super(t,{}),this.implementation=t;}is3D(){return "3d"===this.implementation.renderingMode}hasOffscreenPass(){return void 0!==this.implementation.prerender}isLayerDraped(){return void 0!==this.implementation.renderToTile}shouldRedrape(){return !!this.implementation.shouldRerenderTiles&&this.implementation.shouldRerenderTiles()}recalculate(){}updateTransitions(){}hasTransition(){return !1}serialize(){}onAdd(t){this.implementation.onAdd&&this.implementation.onAdd(t,t.painter.context.gl);}onRemove(t){this.implementation.onRemove&&this.implementation.onRemove(t,t.painter.context.gl);}}const Ab=new ua({visibility:new la(ze.layout_sky.visibility)});var Sb={paint:new ua({"sky-type":new la(ze.paint_sky["sky-type"]),"sky-atmosphere-sun":new la(ze.paint_sky["sky-atmosphere-sun"]),"sky-atmosphere-sun-intensity":new la(ze.paint_sky["sky-atmosphere-sun-intensity"]),"sky-gradient-center":new la(ze.paint_sky["sky-gradient-center"]),"sky-gradient-radius":new la(ze.paint_sky["sky-gradient-radius"]),"sky-gradient":new ha(ze.paint_sky["sky-gradient"]),"sky-atmosphere-halo-color":new la(ze.paint_sky["sky-atmosphere-halo-color"]),"sky-atmosphere-color":new la(ze.paint_sky["sky-atmosphere-color"]),"sky-opacity":new la(ze.paint_sky["sky-opacity"])}),layout:Ab};function Ib(t,e,i){const r=[0,0,1],n=gu.identity([]);return gu.rotateY(n,n,i?-w(t)+Math.PI:w(t)),gu.rotateX(n,n,-w(e)),bu.transformQuat(r,r,n),bu.normalize(r,r)}var Cb={paint:new ua({})};const zb={circle:class extends Zl{constructor(t,e){super(t,Ip,e);}createBucket(t){return new lp(t)}queryRadius(t){const e=t;return Tp("circle-radius",this,e)+Tp("circle-stroke-width",this,e)+Ep(this.paint.get("circle-translate"))}queryIntersectsFeature(t,e,i,r,n,o,s,a){const l=Ap(this.paint.get("circle-translate"),this.paint.get("circle-translate-anchor"),o.angle,t.pixelToTileUnitsFactor),c=this.paint.get("circle-radius").evaluate(e,i)+this.paint.get("circle-stroke-width").evaluate(e,i);return Cp(t,r,o,s,a,"map"===this.paint.get("circle-pitch-alignment"),"map"===this.paint.get("circle-pitch-scale"),l,c)}getProgramIds(){return ["circle"]}getProgramConfiguration(t){return new Ol(this,t)}},heatmap:class extends Zl{createBucket(t){return new Lp(t)}constructor(t,e){super(t,jp,e),this._updateColorRamp();}_handleSpecialPaintPropertyUpdate(t){"heatmap-color"===t&&this._updateColorRamp();}_updateColorRamp(){this.colorRamp=Gp({expression:this._transitionablePaint._values["heatmap-color"].value.expression,evaluationKey:"heatmapDensity",image:this.colorRamp}),this.colorRampTexture=null;}resize(){this.heatmapFbo&&(this.heatmapFbo.destroy(),this.heatmapFbo=null);}queryRadius(t){return Tp("heatmap-radius",this,t)}queryIntersectsFeature(t,e,i,r,n,o,s,a){const l=this.paint.get("heatmap-radius").evaluate(e,i);return Cp(t,r,o,s,a,!0,!0,new y(0,0),l)}hasOffscreenPass(){return 0!==this.paint.get("heatmap-opacity")&&"none"!==this.visibility}getProgramIds(){return ["heatmap","heatmapTexture"]}getProgramConfiguration(t){return new Ol(this,t)}},hillshade:class extends Zl{constructor(t,e){super(t,Zp,e);}hasOffscreenPass(){return 0!==this.paint.get("hillshade-exaggeration")&&"none"!==this.visibility}getProgramIds(){return ["hillshade","hillshadePrepare"]}},fill:class extends Zl{constructor(t,e){super(t,Cf,e);}getProgramIds(){const t=this.paint.get("fill-pattern"),e=t&&t.constantOr(1),i=[e?"fillPattern":"fill"];return this.paint.get("fill-antialias")&&i.push(e&&!this.getPaintProperty("fill-outline-color")?"fillOutlinePattern":"fillOutline"),i}getProgramConfiguration(t){return new Ol(this,t)}recalculate(t,e){super.recalculate(t,e);const i=this.paint._values["fill-outline-color"];"constant"===i.value.kind&&void 0===i.value.value&&(this.paint._values["fill-outline-color"]=this.paint._values["fill-color"]);}createBucket(t){return new Sf(t)}queryRadius(){return Ep(this.paint.get("fill-translate"))}queryIntersectsFeature(t,e,i,r,n,o){return !t.queryGeometry.isAboveHorizon&&up(Mp(t.tilespaceGeometry,this.paint.get("fill-translate"),this.paint.get("fill-translate-anchor"),o.angle,t.pixelToTileUnitsFactor),r)}isTileClipped(){return !0}},"fill-extrusion":class extends Zl{constructor(t,e){super(t,db,e);}createBucket(t){return new tb(t)}queryRadius(){return Ep(this.paint.get("fill-extrusion-translate"))}is3D(){return !0}hasShadowPass(){return !0}cutoffRange(){return this.paint.get("fill-extrusion-cutoff-fade-range")}canCastShadows(){return !0}getProgramIds(){return [this.paint.get("fill-extrusion-pattern").constantOr(1)?"fillExtrusionPattern":"fillExtrusion"]}getProgramConfiguration(t){return new Ol(this,t)}queryIntersectsFeature(t,e,i,r,n,o,s,a,l){const c=Ap(this.paint.get("fill-extrusion-translate"),this.paint.get("fill-extrusion-translate-anchor"),o.angle,t.pixelToTileUnitsFactor),h=this.paint.get("fill-extrusion-height").evaluate(e,i),u=this.paint.get("fill-extrusion-base").evaluate(e,i),d=[0,0],p=a&&o.elevation,f=o.elevation?o.elevation.exaggeration():1,m=t.tile.getBucket(this);if(p&&m instanceof tb){const t=m.centroidVertexArray,e=l+1;e<t.length&&(d[0]=t.geta_centroid_pos0(e),d[1]=t.geta_centroid_pos1(e));}if(0===d[0]&&1===d[1])return !1;"globe"===o.projection.name&&(r=cb([r],[new y(0,0),new y(sr,sr)],t.tileID.canonical).map((t=>t.polygon)).flat());const _=p?a:null,[g,x]=function(t,e,i,r,n,o,s,a,l,c,h){return "globe"===t.projection.name?function(t,e,i,r,n,o,s,a,l,c,h){const u=[],d=[],p=t.projection.upVectorScale(h,t.center.lat,t.worldSize).metersToTile,f=[0,0,0,1],m=[0,0,0,1],_=(t,e,i,r)=>{t[0]=e,t[1]=i,t[2]=r,t[3]=1;},g=lb();i>0&&(i+=g),r+=g;for(const g of e){const e=[],y=[];for(const u of g){const d=u.x+n.x,g=u.y+n.y,x=t.projection.projectTilePoint(d,g,h),v=t.projection.upVector(h,u.x,u.y);let b=i,w=r;if(s){const t=_b(d,g,i,r,s,a,l,c);b+=t.base,w+=t.top;}0!==i?_(f,x.x+v[0]*p*b,x.y+v[1]*p*b,x.z+v[2]*p*b):_(f,x.x,x.y,x.z),_(m,x.x+v[0]*p*w,x.y+v[1]*p*w,x.z+v[2]*p*w),bu.transformMat4(f,f,o),bu.transformMat4(m,m,o),e.push(new pb(f[0],f[1],f[2])),y.push(new pb(m[0],m[1],m[2]));}u.push(e),d.push(y);}return [u,d]}(t,e,i,r,n,o,s,a,l,c,h):s?function(t,e,i,r,n,o,s,a,l){const c=[],h=[],u=[0,0,0,1];for(const d of t){const t=[],p=[];for(const c of d){const h=c.x+r.x,d=c.y+r.y,f=_b(h,d,e,i,o,s,a,l);u[0]=h,u[1]=d,u[2]=f.base,u[3]=1,au.transformMat4(u,u,n),u[3]=Math.max(u[3],1e-5);const m=new pb(u[0]/u[3],u[1]/u[3],u[2]/u[3]);u[0]=h,u[1]=d,u[2]=f.top,u[3]=1,au.transformMat4(u,u,n),u[3]=Math.max(u[3],1e-5);const _=new pb(u[0]/u[3],u[1]/u[3],u[2]/u[3]);t.push(m),p.push(_);}c.push(t),h.push(p);}return [c,h]}(e,i,r,n,o,s,a,l,c):function(t,e,i,r,n){const o=[],s=[],a=n[8]*e,l=n[9]*e,c=n[10]*e,h=n[11]*e,u=n[8]*i,d=n[9]*i,p=n[10]*i,f=n[11]*i;for(const e of t){const t=[],i=[];for(const o of e){const e=o.x+r.x,s=o.y+r.y,m=n[0]*e+n[4]*s+n[12],_=n[1]*e+n[5]*s+n[13],g=n[2]*e+n[6]*s+n[14],y=n[3]*e+n[7]*s+n[15],x=m+a,v=_+l,b=g+c,w=Math.max(y+h,1e-5),T=m+u,E=_+d,M=g+p,A=Math.max(y+f,1e-5);t.push(new pb(x/w,v/w,b/w)),i.push(new pb(T/A,E/A,M/A));}o.push(t),s.push(i);}return [o,s]}(e,i,r,n,o)}(o,r,u,h,c,s,_,d,f,o.center.lat,t.tileID.canonical),v=t.queryGeometry;return function(t,e,i){let r=1/0;up(i,e)&&(r=mb(i,e[0]));for(let n=0;n<e.length;n++){const o=e[n],s=t[n];for(let t=0;t<o.length-1;t++){const e=o[t],n=[e,o[t+1],s[t+1],s[t],e];cp(i,n)&&(r=Math.min(r,mb(i,n)));}}return r!==1/0&&r}(g,x,v.isPointQuery()?v.screenBounds:v.screenGeometry)}},line:class extends Zl{constructor(t,e){super(t,yb,e),this.gradientVersion=0;}_handleSpecialPaintPropertyUpdate(t){if("line-gradient"===t){const t=this._transitionablePaint._values["line-gradient"].value.expression;this.stepInterpolant=t._styleExpression&&t._styleExpression.expression instanceof Hr,this.gradientVersion=(this.gradientVersion+1)%Number.MAX_SAFE_INTEGER;}}gradientExpression(){return this._transitionablePaint._values["line-gradient"].value.expression}widthExpression(){return this._transitionablePaint._values["line-width"].value.expression}recalculate(t,e){super.recalculate(t,e),this.paint._values["line-floorwidth"]=xb.possiblyEvaluate(this._transitioningPaint._values["line-width"].value,t);}createBucket(t){return new cy(t)}getProgramIds(){return [this.paint.get("line-pattern").constantOr(1)?"linePattern":"line"]}getProgramConfiguration(t){return new Ol(this,t)}queryRadius(t){const e=t,i=vb(Tp("line-width",this,e),Tp("line-gap-width",this,e)),r=Tp("line-offset",this,e);return i/2+Math.abs(r)+Ep(this.paint.get("line-translate"))}queryIntersectsFeature(t,e,i,r,n,o){if(t.queryGeometry.isAboveHorizon)return !1;const s=Mp(t.tilespaceGeometry,this.paint.get("line-translate"),this.paint.get("line-translate-anchor"),o.angle,t.pixelToTileUnitsFactor),a=t.pixelToTileUnitsFactor/2*vb(this.paint.get("line-width").evaluate(e,i),this.paint.get("line-gap-width").evaluate(e,i)),l=this.paint.get("line-offset").evaluate(e,i);return l&&(r=function(t,e){const i=[],r=new y(0,0);for(let n=0;n<t.length;n++){const o=t[n],s=[];for(let t=0;t<o.length;t++){const i=o[t],n=o[t+1],a=0===t?r:i.sub(o[t-1])._unit()._perp(),l=t===o.length-1?r:n.sub(i)._unit()._perp(),c=a._add(l)._unit();c._mult(1/(c.x*l.x+c.y*l.y)),s.push(c._mult(e)._add(i));}i.push(s);}return i}(r,l*t.pixelToTileUnitsFactor)),function(t,e,i){for(let r=0;r<e.length;r++){const n=e[r];if(t.length>=3)for(let e=0;e<n.length;e++)if(yp(t,n[e]))return !0;if(dp(t,n,i))return !0}return !1}(s,r,a)}isTileClipped(){return !0}},symbol:qg,background:class extends Zl{constructor(t,e){super(t,wb,e);}getProgramIds(){return [this.paint.get("background-pattern")?"backgroundPattern":"background"]}},raster:class extends Zl{constructor(t,e){super(t,Eb,e),this._updateColorRamp();}getProgramIds(){return ["raster"]}hasColorMap(){return !!this._transitionablePaint._values["raster-color"].value.value}_handleSpecialPaintPropertyUpdate(t){"raster-color"!==t&&"raster-color-range"!==t||this._updateColorRamp();}_updateColorRamp(){if(!this.hasColorMap())return;const t=this._transitionablePaint._values["raster-color"].value.expression,[e,i]=this._transitionablePaint._values["raster-color-range"].value.expression.evaluate({zoom:0});this.colorRamp=Gp({expression:t,evaluationKey:"rasterValue",image:this.colorRamp,clips:[{start:e,end:i}]}),this.colorRampTexture=null;}},sky:class extends Zl{constructor(t,e){super(t,Sb,e),this._updateColorRamp();}_handleSpecialPaintPropertyUpdate(t){"sky-gradient"===t?this._updateColorRamp():"sky-atmosphere-sun"!==t&&"sky-atmosphere-halo-color"!==t&&"sky-atmosphere-color"!==t&&"sky-atmosphere-sun-intensity"!==t||(this._skyboxInvalidated=!0);}_updateColorRamp(){this.colorRamp=Gp({expression:this._transitionablePaint._values["sky-gradient"].value.expression,evaluationKey:"skyRadialProgress"}),this.colorRampTexture&&(this.colorRampTexture.destroy(),this.colorRampTexture=null);}needsSkyboxCapture(t){if(this._skyboxInvalidated||!this.skyboxTexture||!this.skyboxGeometry)return !0;if(!this.paint.get("sky-atmosphere-sun")){const e=t.style.light.properties.get("position");return this._lightPosition.azimuthal!==e.azimuthal||this._lightPosition.polar!==e.polar}return !1}getCenter(t,e){if("atmosphere"===this.paint.get("sky-type")){const i=this.paint.get("sky-atmosphere-sun"),r=!i,n=t.style.light,o=n.properties.get("position");return r&&"viewport"===n.properties.get("anchor")&&W("The sun direction is attached to a light with viewport anchor, lighting may behave unexpectedly."),r?Ib(o.azimuthal,90-o.polar,e):Ib(i[0],90-i[1],e)}const i=this.paint.get("sky-gradient-center");return Ib(i[0],90-i[1],e)}isSky(){return !0}markSkyboxValid(t){this._skyboxInvalidated=!1,this._lightPosition=t.style.light.properties.get("position");}hasOffscreenPass(){return !0}getProgramIds(){const t=this.paint.get("sky-type");return "atmosphere"===t?["skyboxCapture","skybox"]:"gradient"===t?["skyboxGradient"]:null}},slot:class extends Zl{constructor(t,e){super(t,Cb);}},model:class extends Zl{constructor(t,e){super(t,Ev,e);}createBucket(t){return new wv(t)}getProgramIds(){return ["model"]}is3D(){return !0}hasShadowPass(){return !0}canCastShadows(){return !0}hasLightBeamPass(){return !0}cutoffRange(){return this.paint.get("model-cutoff-fade-range")}queryRadius(){return 0}_handleOverridablePaintPropertyUpdate(t,e,i){return !(!this.layout||e.isDataDriven()||i.isDataDriven()||"model-color"!==t&&"model-color-mix-intensity"!==t&&"model-rotation"!==t&&"model-scale"!==t&&"model-translation"!==t&&"model-emissive-strength"!==t)}}};function Db(t,e){return "custom"===t.type?new Mb(t):new zb[t.type](t,e)}function Pb(t){const{userImage:e}=t;return !!(e&&e.render&&e.render())&&(t.data.replace(new Uint8Array(e.data.buffer)),!0)}class Rb extends Ce{constructor(){super(),this.images={},this.updatedImages={},this.callbackDispatchedThisFrame={},this.loaded={},this.requestors=[],this.patterns={},this.atlasImage={},this.atlasTexture={},this.dirty=!0;}createScope(t){this.images[t]={},this.loaded[t]=!1,this.updatedImages[t]={},this.patterns[t]={},this.callbackDispatchedThisFrame[t]={},this.atlasImage[t]=new Np({width:1,height:1});}isLoaded(){for(const t in this.loaded)if(!this.loaded[t])return !1;return !0}setLoaded(t,e){if(this.loaded[e]!==t&&(this.loaded[e]=t,t)){for(const{ids:t,callback:i}of this.requestors)this._notify(t,e,i);this.requestors=[];}}hasImage(t,e){return !!this.getImage(t,e)}getImage(t,e){return this.images[e][t]}addImage(t,e,i){this._validate(t,i)&&(this.images[e][t]=i);}_validate(t,e){let i=!0;return this._validateStretch(e.stretchX,e.data&&e.data.width)||(this.fire(new Ie(new Error(`Image "${t}" has invalid "stretchX" value`))),i=!1),this._validateStretch(e.stretchY,e.data&&e.data.height)||(this.fire(new Ie(new Error(`Image "${t}" has invalid "stretchY" value`))),i=!1),this._validateContent(e.content,e)||(this.fire(new Ie(new Error(`Image "${t}" has invalid "content" value`))),i=!1),i}_validateStretch(t,e){if(!t)return !0;let i=0;for(const r of t){if(r[0]<i||r[1]<r[0]||e<r[1])return !1;i=r[1];}return !0}_validateContent(t,e){return !(t&&(4!==t.length||t[0]<0||e.data.width<t[0]||t[1]<0||e.data.height<t[1]||t[2]<0||e.data.width<t[2]||t[3]<0||e.data.height<t[3]||t[2]<t[0]||t[3]<t[1]))}updateImage(t,e,i){i.version=this.images[e][t].version+1,this.images[e][t]=i,this.updatedImages[e][t]=!0;}removeImage(t,e){const i=this.images[e][t];delete this.images[e][t],delete this.patterns[e][t],i.userImage&&i.userImage.onRemove&&i.userImage.onRemove();}listImages(t){return Object.keys(this.images[t])}getImages(t,e,i){let r=!0;const n=!!this.loaded[e];if(!n)for(const i of t)this.images[e][i]||(r=!1);n||r?this._notify(t,e,i):this.requestors.push({ids:t,scope:e,callback:i});}getUpdatedImages(t){return this.updatedImages[t]}_notify(t,e,i){const r={};for(const i of t){this.images[e][i]||this.fire(new Se("styleimagemissing",{id:i}));const t=this.images[e][i];t?r[i]={data:t.data.clone(),pixelRatio:t.pixelRatio,sdf:t.sdf,version:t.version,stretchX:t.stretchX,stretchY:t.stretchY,content:t.content,hasRenderCallback:Boolean(t.userImage&&t.userImage.render)}:W(`Image "${i}" could not be loaded. Please make sure you have added the image with map.addImage() or a "sprite" property in your style. You can provide missing images by listening for the "styleimagemissing" map event.`);}i(null,r);}getPixelSize(t){const{width:e,height:i}=this.atlasImage[t];return {width:e,height:i}}getPattern(t,e){const i=this.patterns[e][t],r=this.getImage(t,e);if(!r)return null;if(i&&i.position.version===r.version)return i.position;if(i)i.position.version=r.version;else {const i={w:r.data.width+2,h:r.data.height+2,x:0,y:0},n=new p_(i,r);this.patterns[e][t]={bin:i,position:n};}return this._updatePatternAtlas(e),this.patterns[e][t].position}bind(t,e){const i=t.gl;let r=this.atlasTexture[e];r?this.dirty&&(r.update(this.atlasImage[e]),this.dirty=!1):(r=new hy(t,this.atlasImage[e],i.RGBA),this.atlasTexture[e]=r),r.bind(i.LINEAR,i.CLAMP_TO_EDGE);}_updatePatternAtlas(t){const e=[];for(const i in this.patterns[t])e.push(this.patterns[t][i].bin);const{w:i,h:r}=u_(e),n=this.atlasImage[t];n.resize({width:i||1,height:r||1});for(const e in this.patterns[t]){const{bin:i}=this.patterns[t][e],r=i.x+1,o=i.y+1,s=this.images[t][e].data,a=s.width,l=s.height;Np.copy(s,n,{x:0,y:0},{x:r,y:o},{width:a,height:l}),Np.copy(s,n,{x:0,y:l-1},{x:r,y:o-1},{width:a,height:1}),Np.copy(s,n,{x:0,y:0},{x:r,y:o+l},{width:a,height:1}),Np.copy(s,n,{x:a-1,y:0},{x:r-1,y:o},{width:1,height:l}),Np.copy(s,n,{x:0,y:0},{x:r+a,y:o},{width:1,height:l});}this.dirty=!0;}beginFrame(){for(const t in this.images)this.callbackDispatchedThisFrame[t]={};}dispatchRenderCallbacks(t,e){for(const i of t){if(this.callbackDispatchedThisFrame[e][i])continue;this.callbackDispatchedThisFrame[e][i]=!0;const t=this.images[e][i];Pb(t)&&this.updateImage(i,e,t);}}}const Lb=new ua({anchor:new la(ze.light.anchor),position:new class{constructor(t){this.specification=t;}possiblyEvaluate(t,e){return K(t.expression.evaluate(e))}interpolate(t,e,i){return {x:Wr(t.x,e.x,i),y:Wr(t.y,e.y,i),z:Wr(t.z,e.z,i),azimuthal:Wr(t.azimuthal,e.azimuthal,i),polar:Wr(t.polar,e.polar,i)}}}(ze.light.position),color:new la(ze.light.color),intensity:new la(ze.light.intensity)});class kb extends Ce{constructor(t,e="flat"){super(),this._transitionable=new ia(Lb),this.setLight(t,e),this._transitioning=this._transitionable.untransitioned();}getLight(){return this._transitionable.serialize()}setLight(t,e,i={}){this._validate(us,t,i)||(this._transitionable.setTransitionOrValue(t),this.id=e);}updateTransitions(t){this._transitioning=this._transitionable.transitioned(t,this._transitioning);}hasTransition(){return this._transitioning.hasTransition()}recalculate(t){this.properties=this._transitioning.possiblyEvaluate(t);}_validate(t,e,i){return (!i||!1!==i.validate)&&bs(this,t.call(cs,k({value:e,style:{glyphs:!0,sprite:!0},styleSpec:ze})))}}const Bb=new ua({source:new la(ze.terrain.source),exaggeration:new la(ze.terrain.exaggeration)});let Ob=class extends Ce{constructor(t,e){super(),this._transitionable=new ia(Bb),this.set(t),this._transitioning=this._transitionable.untransitioned(),this.drapeRenderMode=e;}get(){return this._transitionable.serialize()}set(t){this._transitionable.setTransitionOrValue(t);}updateTransitions(t){this._transitioning=this._transitionable.transitioned(t,this._transitioning);}hasTransition(){return this._transitioning.hasTransition()}recalculate(t){this.properties=this._transitioning.possiblyEvaluate(t);}};function Fb(t,e,i,r){const n=D(45,65,i),[o,s]=Nb(t,r),a=bu.length(e);let l=1-Math.min(1,Math.exp((a-o)/(s-o)*-6));return l*=l*l,l=Math.min(1,1.00747*l),l*n*t.alpha}function Nb(t,e){const i=.5/Math.tan(.5*e);return [t.range[0]+i,t.range[1]+i]}const Ub=new ua({range:new la(ze.fog.range),color:new la(ze.fog.color),"high-color":new la(ze.fog["high-color"]),"space-color":new la(ze.fog["space-color"]),"horizon-blend":new la(ze.fog["horizon-blend"]),"star-intensity":new la(ze.fog["star-intensity"]),"vertical-range":new la(ze.fog["vertical-range"])});class Vb extends Ce{constructor(t,e){super(),this._transitionable=new ia(Ub),this.set(t),this._transitioning=this._transitionable.untransitioned(),this._transform=e;}get state(){const t=this._transform,e="globe"===t.projection.name,i=pd(t.zoom),r=this.properties.get("range"),n=[.5,3];return {range:e?[Wr(n[0],r[0],i),Wr(n[1],r[1],i)]:r,horizonBlend:this.properties.get("horizon-blend"),alpha:this.properties.get("color").a}}get(){return this._transitionable.serialize()}set(t,e={}){if(!this._validate(fs,t,e)){for(const e of Object.keys(ze.fog))t&&void 0===t[e]&&(t[e]=ze.fog[e].default);this._transitionable.setTransitionOrValue(t);}}getOpacity(t){if(!this._transform.projection.supportsFog)return 0;const e=this.properties&&this.properties.get("color")||1;return ("globe"===this._transform.projection.name?1:D(45,65,t))*e.a}getOpacityAtLatLng(t,e){return this._transform.projection.supportsFog?function(t,e,i){const r=Yd.fromLngLat(e),n=i.elevation?i.elevation.getAtPointOrZero(r):0,o=[r.x,r.y,n];return bu.transformMat4(o,o,i.mercatorFogMatrix),Fb(t,o,i.pitch,i._fov)}(this.state,t,e):0}getFovAdjustedRange(t){return this._transform.projection.supportsFog?Nb(this.state,t):[0,1]}updateTransitions(t){this._transitioning=this._transitionable.transitioned(t,this._transitioning);}hasTransition(){return this._transitioning.hasTransition()}recalculate(t){this.properties=this._transitioning.possiblyEvaluate(t);}_validate(t,e,i){return (!i||!1!==i.validate)&&bs(this,t.call(cs,k({value:e,style:{glyphs:!0,sprite:!0},styleSpec:ze})))}}class jb{constructor(t){this._callback=t,this._triggered=!1,"undefined"!=typeof MessageChannel&&(this._channel=new MessageChannel,this._channel.port2.onmessage=()=>{this._triggered=!1,this._callback();});}trigger(){this._triggered||(this._triggered=!0,this._channel?this._channel.port1.postMessage(!0):setTimeout((()=>{this._triggered=!1,this._callback();}),0));}remove(){this._channel=void 0,this._callback=()=>{};}}class Gb{constructor(){this.tasks={},this.taskQueue=[],j(["process"],this),this.invoker=new jb(this.process),this.nextId=0;}add(t,e){const i=this.nextId++,r=function({type:t,isSymbolTile:e,zoom:i}){return i=i||0,"message"===t?0:"maybePrepare"!==t||e?"parseTile"!==t||e?"parseTile"===t&&e?300-i:"maybePrepare"===t&&e?400-i:500:200-i:100-i}(e);if(0===r){Q();try{t();}finally{}return {cancel:()=>{}}}return this.tasks[i]={fn:t,metadata:e,priority:r,id:i},this.taskQueue.push(i),this.invoker.trigger(),{cancel:()=>{delete this.tasks[i];}}}process(){Q();try{if(this.taskQueue=this.taskQueue.filter((t=>!!this.tasks[t])),!this.taskQueue.length)return;const t=this.pick();if(null===t)return;const e=this.tasks[t];if(delete this.tasks[t],this.taskQueue.length&&this.invoker.trigger(),!e)return;e.fn();}finally{}}pick(){let t=null,e=1/0;for(let i=0;i<this.taskQueue.length;i++){const r=this.tasks[this.taskQueue[i]];r.priority<e&&(e=r.priority,t=i);}if(null===t)return null;const i=this.taskQueue[t];return this.taskQueue.splice(t,1),i}remove(){this.invoker.remove();}}class qb{constructor(t,i,r){this.target=t,this.parent=i,this.mapId=r,this.callbacks={},this.cancelCallbacks={},j(["receive"],this),this.target.addEventListener("message",this.receive,!1),this.globalScope=Q()?t:e,this.scheduler=new Gb;}send(t,e,i,r,n=!1,o){const s=Math.round(1e18*Math.random()).toString(36).substring(0,10);i&&(i.metadata=o,this.callbacks[s]=i);const a=it(this.globalScope)?void 0:[];return this.target.postMessage({id:s,type:t,hasCallback:!!i,targetMapId:r,mustQueue:n,sourceMapId:this.mapId,data:zs(e,a)},a),{cancel:()=>{i&&delete this.callbacks[s],this.target.postMessage({id:s,type:"<cancel>",targetMapId:r,sourceMapId:this.mapId});}}}receive(t){const e=t.data,i=e.id;if(i&&(!e.targetMapId||this.mapId===e.targetMapId))if("<cancel>"===e.type){const t=this.cancelCallbacks[i];delete this.cancelCallbacks[i],t&&t.cancel();}else if(e.mustQueue||Q()){const t=this.callbacks[i];this.cancelCallbacks[i]=this.scheduler.add((()=>this.processTask(i,e)),t&&t.metadata||{type:"message"});}else this.processTask(i,e);}processTask(t,e){if("<response>"===e.type){const i=this.callbacks[t];delete this.callbacks[t],i&&(e.error?i(Ds(e.error)):i(null,Ds(e.data)));}else {const i=it(this.globalScope)?void 0:[],r=e.hasCallback?(e,r)=>{delete this.cancelCallbacks[t],this.target.postMessage({id:t,type:"<response>",sourceMapId:this.mapId,error:e?zs(e):null,data:zs(r,i)},i);}:t=>{},n=Ds(e.data);if(this.parent[e.type])this.parent[e.type](e.sourceMapId,n,r);else if(this.parent.getWorkerSource){const t=e.type.split(".");this.parent.getWorkerSource(e.sourceMapId,t[0],n.source,n.scope)[t[1]](n,r);}else r(new Error(`Could not find function ${e.type}`));}}remove(){this.scheduler.remove(),this.target.removeEventListener("message",this.receive,!1);}}class Zb{constructor(t,e){this.workerPool=t,this.actors=[],this.currentActor=0,this.id=F();const i=this.workerPool.acquire(this.id);for(let t=0;t<i.length;t++){const r=new Zb.Actor(i[t],e,this.id);r.name=`Worker ${t}`,this.actors.push(r);}this.ready=!1,this.broadcast("checkIfReady",null,(()=>{this.ready=!0;}));}broadcast(t,e,i){R(this.actors,((i,r)=>{i.send(t,e,r);}),i=i||function(){});}getActor(){return this.currentActor=(this.currentActor+1)%this.actors.length,this.actors[this.currentActor]}remove(){this.actors.forEach((t=>{t.remove();})),this.actors=[],this.workerPool.release(this.id);}}Zb.Actor=qb;class $b extends Ce{constructor(t,e,i,r){super(),this.scope=i,this._options=t,this.properties=new aa(e),this._transitionable=new ia(e,new Map(r)),this._transitionable.setTransitionOrValue(t.properties),this._transitioning=this._transitionable.untransitioned();}updateConfig(t){this._transitionable.setTransitionOrValue(this._options.properties,new Map(t));}updateTransitions(t){this._transitioning=this._transitionable.transitioned(t,this._transitioning);}hasTransition(){return this._transitioning.hasTransition()}recalculate(t){this.properties=this._transitioning.possiblyEvaluate(t);}get(){return this._options.properties=this._transitionable.serialize(),this._options}set(t,e){this._options=t,this._transitionable.setTransitionOrValue(t.properties,e);}shadowsEnabled(){return !!this.properties&&!0===this.properties.get("cast-shadows")}}const Hb=new ua({color:new la(ze.properties_light_ambient.color),intensity:new la(ze.properties_light_ambient.intensity)}),Wb=new ua({direction:new class{constructor(t){this.specification=t;}possiblyEvaluate(t,e){return function([t,e]){const i=K([1,t,e]);return {x:i.x,y:i.y,z:i.z}}(t.expression.evaluate(e))}interpolate(t,e,i){return {x:Wr(t.x,e.x,i),y:Wr(t.y,e.y,i),z:Wr(t.z,e.z,i)}}}(ze.properties_light_directional.direction),color:new la(ze.properties_light_directional.color),intensity:new la(ze.properties_light_directional.intensity),"cast-shadows":new la(ze.properties_light_directional["cast-shadows"]),"shadow-intensity":new la(ze.properties_light_directional["shadow-intensity"])});class Xb{constructor(t,e,i,r){this.screenBounds=t,this.cameraPoint=e,this._screenRaycastCache={},this._cameraRaycastCache={},this.isAboveHorizon=i,this.screenGeometry=this.bufferedScreenGeometry(0),this.screenGeometryMercator=this._bufferedScreenMercator(0,r);}static createFromScreenPoints(t,e){let i,r;if(t instanceof y||"number"==typeof t[0]){const n=y.convert(t);i=[n],r=e.isPointAboveHorizon(n);}else {const n=y.convert(t[0]),o=y.convert(t[1]);i=[n,o],r=S(n,o).every((t=>e.isPointAboveHorizon(t)));}return new Xb(i,e.getCameraPoint(),r,e)}isPointQuery(){return 1===this.screenBounds.length}bufferedScreenGeometry(t){return S(this.screenBounds[0],1===this.screenBounds.length?this.screenBounds[0]:this.screenBounds[1],t)}bufferedCameraGeometry(t){const e=this.screenBounds[0],i=1===this.screenBounds.length?this.screenBounds[0].add(new y(1,1)):this.screenBounds[1],r=S(e,i,0,!1);return this.cameraPoint.y>i.y&&(this.cameraPoint.x>e.x&&this.cameraPoint.x<i.x?r.splice(3,0,this.cameraPoint):this.cameraPoint.x>=i.x?r[2]=this.cameraPoint:this.cameraPoint.x<=e.x&&(r[3]=this.cameraPoint)),function(t,e){const i=[];for(let r=0;r<t.length;r++){const n=P(r-1,-1,t.length-1),o=P(r+1,-1,t.length-1),s=t[r],a=t[o],l=t[n].sub(s).unit(),c=a.sub(s).unit(),h=c.angleWithSep(l.x,l.y),u=l.add(c).unit().mult(-1*e/Math.sin(h/2));i.push(s.add(u));}return i}(r,t)}bufferedCameraGeometryGlobe(t){const e=this.screenBounds[0],i=1===this.screenBounds.length?this.screenBounds[0].add(new y(1,1)):this.screenBounds[1],r=S(e,i,t),n=this.cameraPoint.clone();switch(3*((n.y>e.y)+(n.y>i.y))+((n.x>e.x)+(n.x>i.x))){case 0:r[0]=n,r[4]=n.clone();break;case 1:r.splice(1,0,n);break;case 2:r[1]=n;break;case 3:r.splice(4,0,n);break;case 5:r.splice(2,0,n);break;case 6:r[3]=n;break;case 7:r.splice(3,0,n);break;case 8:r[2]=n;}return r}containsTile(t,e,i,r=0){const n=t.queryPadding/e._pixelsPerMercatorPixel+1,o=i?this._bufferedCameraMercator(n,e):this._bufferedScreenMercator(n,e);let s=t.tileID.wrap+(o.unwrapped?r:0);const a=o.polygon.map((e=>yg(t.tileTransform,e,s)));if(!xp(a,0,0,sr,sr))return;s=t.tileID.wrap+(this.screenGeometryMercator.unwrapped?r:0);const l=this.screenGeometryMercator.polygon.map((e=>xg(t.tileTransform,e,s))),c=l.map((t=>new y(t[0],t[1]))),h=e.getFreeCameraOptions().position||new Yd(0,0,0),u=xg(t.tileTransform,h,s),d=l.map((t=>{const e=bu.sub(t,t,u);return bu.normalize(e,e),new Cu(u,e)})),p=Vx(t,1,e.zoom)*e._pixelsPerMercatorPixel;return {queryGeometry:this,tilespaceGeometry:c,tilespaceRays:d,bufferedTilespaceGeometry:a,bufferedTilespaceBounds:(f=A(a),f.min.x=z(f.min.x,0,sr),f.min.y=z(f.min.y,0,sr),f.max.x=z(f.max.x,0,sr),f.max.y=z(f.max.y,0,sr),f),tile:t,tileID:t.tileID,pixelToTileUnitsFactor:p};var f;}_bufferedScreenMercator(t,e){const i=Jb(t);if(this._screenRaycastCache[i])return this._screenRaycastCache[i];{let r;return r="globe"===e.projection.name?this._projectAndResample(this.bufferedScreenGeometry(t),e):{polygon:this.bufferedScreenGeometry(t).map((t=>e.pointCoordinate3D(t))),unwrapped:!0},this._screenRaycastCache[i]=r,r}}_bufferedCameraMercator(t,e){const i=Jb(t);if(this._cameraRaycastCache[i])return this._cameraRaycastCache[i];{let r;return r="globe"===e.projection.name?this._projectAndResample(this.bufferedCameraGeometryGlobe(t),e):{polygon:this.bufferedCameraGeometry(t).map((t=>e.pointCoordinate3D(t))),unwrapped:!0},this._cameraRaycastCache[i]=r,r}}_projectAndResample(t,e){const i=function(t,e){const i=mu.multiply([],e.pixelMatrix,e.globeMatrix),r=[0,-Nu,0,1],n=[0,Nu,0,1],o=[0,0,0,1];au.transformMat4(r,r,i),au.transformMat4(n,n,i),au.transformMat4(o,o,i);const s=new y(r[0]/r[3],r[1]/r[3]),a=new y(n[0]/n[3],n[1]/n[3]),l=yp(t,s)&&r[3]<o[3],c=yp(t,a)&&n[3]<o[3];if(!l&&!c)return null;const h=function(t,e,i){for(let r=1;r<t.length;r++){const n=Kb(e.pointCoordinate3D(t[r-1]).x),o=Kb(e.pointCoordinate3D(t[r]).x);if(i<0){if(n<o)return {idx:r,t:-n/(o-1-n)}}else if(o<n)return {idx:r,t:(1-n)/(o+1-n)}}return null}(t,e,l?-1:1);if(!h)return null;const{idx:u,t:d}=h;let p=u>1?Yb(t.slice(0,u),e):[],f=u<t.length?Yb(t.slice(u),e):[];p=p.map((t=>new y(Kb(t.x),t.y))),f=f.map((t=>new y(Kb(t.x),t.y)));const m=[...p];0===m.length&&m.push(f[f.length-1]);const _=Wr(m[m.length-1].y,(0===f.length?p[0]:f[0]).y,d);let g;return g=l?[new y(0,_),new y(0,0),new y(1,0),new y(1,_)]:[new y(1,_),new y(1,1),new y(0,1),new y(0,_)],m.push(...g),0===f.length?m.push(p[0]):m.push(...f),{polygon:m.map((t=>new Yd(t.x,t.y))),unwrapped:!1}}(t,e);if(i)return i;const r=function(t,e){let i=!1,r=-1/0,n=0;for(let e=0;e<t.length-1;e++)t[e].x>r&&(r=t[e].x,n=e);for(let e=0;e<t.length-1;e++){const r=(n+e)%(t.length-1),o=t[r],s=t[r+1];Math.abs(o.x-s.x)>.5&&(o.x<s.x?(o.x+=1,0===r&&(t[t.length-1].x+=1)):(s.x+=1,r+1===t.length-1&&(t[0].x+=1)),i=!0);}const o=Nd(e.center.lng);return i&&o<Math.abs(o-1)&&t.forEach((t=>{t.x-=1;})),{polygon:t,unwrapped:i}}(Yb(t,e).map((t=>new y(Kb(t.x),t.y))),e);return {polygon:r.polygon.map((t=>new Yd(t.x,t.y))),unwrapped:r.unwrapped}}}function Yb(t,e){return Jd(t,(t=>{const i=e.pointCoordinate3D(t);t.x=i.x,t.y=i.y;}),1/256)}function Kb(t){return t<0?1+t%1:t%1}function Jb(t){return 100*t|0}function Qb(t,e,i,r,n){const o=function(i,r){if(i)return n(i);if(r){t.url&&r.tiles&&t.tiles&&delete t.tiles;const i=B(k(r,t),["tiles","minzoom","maxzoom","attribution","mapbox_logo","bounds","scheme","tileSize","encoding"]);r.vector_layers&&(i.vectorLayers=r.vector_layers,i.vectorLayerIds=i.vectorLayers.map((t=>t.id))),i.tiles=e.canonicalizeTileset(i,t.url),n(null,i);}};return t.url?Tt(e.transformRequest(e.normalizeSourceURL(t.url,null,i,r),xt.Source),o):ue.frame((()=>o(null,t)))}class tw{constructor(t,e,i){this.bounds=Xl.convert(this.validateBounds(t)),this.minzoom=e||0,this.maxzoom=i||24;}validateBounds(t){return Array.isArray(t)&&4===t.length?[Math.max(-180,t[0]),Math.max(-90,t[1]),Math.min(180,t[2]),Math.min(90,t[3])]:[-180,-90,180,90]}contains(t){const e=Math.pow(2,t.z),i=Math.floor(Nd(this.bounds.getWest())*e),r=Math.floor(Ud(this.bounds.getNorth())*e),n=Math.ceil(Nd(this.bounds.getEast())*e),o=Math.ceil(Ud(this.bounds.getSouth())*e);return t.x>=i&&t.x<n&&t.y>=r&&t.y<o}}class ew{constructor(t,e){this.width=t,this.height=e,this.nextRow=0,this.image=new Fp({width:t,height:e}),this.positions={},this.uploaded=!1;}getDash(t,e){const i=this.getKey(t,e);return this.positions[i]}trim(){const t=this.width,e=this.height=U(this.nextRow);this.image.resize({width:t,height:e});}getKey(t,e){return t.join(",")+e}getDashRanges(t,e,i){const r=[];let n=t.length%2==1?-t[t.length-1]*i:0,o=t[0]*i,s=!0;r.push({left:n,right:o,isDash:s,zeroLength:0===t[0]});let a=t[0];for(let e=1;e<t.length;e++){s=!s;const l=t[e];n=a*i,a+=l,o=a*i,r.push({left:n,right:o,isDash:s,zeroLength:0===l});}return r}addRoundDash(t,e,i){const r=e/2;for(let e=-i;e<=i;e++){const n=this.width*(this.nextRow+i+e);let o=0,s=t[o];for(let a=0;a<this.width;a++){a/s.right>1&&(s=t[++o]);const l=Math.abs(a-s.left),c=Math.abs(a-s.right),h=Math.min(l,c);let u;const d=e/i*(r+1);if(s.isDash){const t=r-Math.abs(d);u=Math.sqrt(h*h+t*t);}else u=r-Math.sqrt(h*h+d*d);this.image.data[n+a]=Math.max(0,Math.min(255,u+128));}}}addRegularDash(t,e){for(let e=t.length-1;e>=0;--e){const i=t[e],r=t[e+1];i.zeroLength?t.splice(e,1):r&&r.isDash===i.isDash&&(r.left=i.left,t.splice(e,1));}const i=t[0],r=t[t.length-1];i.isDash===r.isDash&&(i.left=r.left-this.width,r.right=i.right+this.width);const n=this.width*this.nextRow;let o=0,s=t[o];for(let i=0;i<this.width;i++){i/s.right>1&&(s=t[++o]);const r=Math.abs(i-s.left),a=Math.abs(i-s.right),l=Math.min(r,a);this.image.data[n+i]=Math.max(0,Math.min(255,(s.isDash?l:-l)+e+128));}}addDash(t,e){const i=this.getKey(t,e);if(this.positions[i])return this.positions[i];const r="round"===e,n=r?7:0,o=2*n+1;if(this.nextRow+o>this.height)return W("LineAtlas out of space"),null;0===t.length&&t.push(1);let s=0;for(let e=0;e<t.length;e++)t[e]<0&&(W("Negative value is found in line dasharray, replacing values with 0"),t[e]=0),s+=t[e];if(0!==s){const i=this.width/s,o=this.getDashRanges(t,this.width,i);r?this.addRoundDash(o,i,n):this.addRegularDash(o,"square"===e?.5*i:0);}const a=this.nextRow+n;this.nextRow+=o;const l={tl:[a,n],br:[s,0]};return this.positions[i]=l,l}}Ss(ew,"LineAtlas");const iw=1*G_;class rw{constructor(t){const e={},i=[];for(const r in t){const n=t[r],o=e[r]={};for(const t in n.glyphs){const e=n.glyphs[+t];if(!e||0===e.bitmap.width||0===e.bitmap.height)continue;const r=e.metrics.localGlyph?iw:1,s={x:0,y:0,w:e.bitmap.width+2*r,h:e.bitmap.height+2*r};i.push(s),o[t]=s;}}const{w:r,h:n}=u_(i),o=new Fp({width:r||1,height:n||1});for(const i in t){const r=t[i];for(const t in r.glyphs){const n=r.glyphs[+t];if(!n||0===n.bitmap.width||0===n.bitmap.height)continue;const s=e[i][t],a=n.metrics.localGlyph?iw:1;Fp.copy(n.bitmap,o,{x:0,y:0},{x:s.x+a,y:s.y+a},n.bitmap);}}this.image=o,this.positions=e;}}Ss(rw,"GlyphAtlas");class nw{constructor(t){this.tileID=new Rd(t.tileID.overscaledZ,t.tileID.wrap,t.tileID.canonical.z,t.tileID.canonical.x,t.tileID.canonical.y),this.tileZoom=t.tileZoom,this.uid=t.uid,this.zoom=t.zoom,this.canonical=t.tileID.canonical,this.pixelRatio=t.pixelRatio,this.tileSize=t.tileSize,this.source=t.source,this.scope=t.scope,this.overscaling=this.tileID.overscaleFactor(),this.showCollisionBoxes=t.showCollisionBoxes,this.collectResourceTiming=!!t.collectResourceTiming,this.returnDependencies=!!t.returnDependencies,this.promoteId=t.promoteId,this.enableTerrain=!!t.enableTerrain,this.isSymbolTile=t.isSymbolTile,this.tileTransform=_g(t.tileID.canonical,t.projection),this.projection=t.projection,this.brightness=t.brightness,this.extraShadowCaster=!!t.extraShadowCaster;}parse(t,e,i,r,n){this.status="parsing",this.data=t,this.collisionBoxArray=new Xa;const o=new Kf(Object.keys(t.layers).sort()),s=new Fm(this.tileID,this.promoteId);s.bucketLayerIDs=[];const a={},l=new ew(256,256),c={featureIndex:s,iconDependencies:{},patternDependencies:{},glyphDependencies:{},lineAtlas:l,availableImages:i,brightness:this.brightness},h=e.familiesBySource[this.source];for(const e in h){const r=t.layers[e];if(!r)continue;let n=!1,l=!1,u=!1;for(const t of h[e])"symbol"===t[0].type?n=!0:l=!0,t[0].is3D()&&"model"!==t[0].type&&(u=!0);if(this.extraShadowCaster&&!u)continue;if(!0===this.isSymbolTile&&!n)continue;if(!1===this.isSymbolTile&&!l)continue;1===r.version&&W(`Vector tile source "${this.source}" layer "${e}" does not use vector tile spec v2 and therefore may have some rendering errors.`);const d=o.encode(e),p=[];for(let t=0;t<r.length;t++){const i=r.feature(t),n=s.getId(i,e);p.push({feature:i,id:n,index:t,sourceLayerIndex:d});}for(const t of h[e]){const e=t[0];(!this.extraShadowCaster||e.is3D()&&"model"!==e.type)&&(void 0!==this.isSymbolTile&&"symbol"===e.type!==this.isSymbolTile||e.minzoom&&this.zoom<Math.floor(e.minzoom)||e.maxzoom&&this.zoom>=e.maxzoom||"none"!==e.visibility&&(ow(t,this.zoom,c.brightness,i),(a[e.id]=e.createBucket({index:s.bucketLayerIDs.length,layers:t,zoom:this.zoom,canonical:this.canonical,pixelRatio:this.pixelRatio,overscaling:this.overscaling,collisionBoxArray:this.collisionBoxArray,sourceLayerIndex:d,sourceID:this.source,enableTerrain:this.enableTerrain,projection:this.projection.spec})).populate(p,c,this.tileID.canonical,this.tileTransform),s.bucketLayerIDs.push(t.map((t=>t.id)))));}}let u,d,p,f;l.trim();const m={type:"maybePrepare",isSymbolTile:this.isSymbolTile,zoom:this.zoom},_=()=>{if(u)return n(u);if(d&&p&&f){const t=new rw(d),e=new f_(p,f);for(const r in a){const n=a[r];n instanceof iy?(ow(n.layers,this.zoom,c.brightness,i),og(n,d,t.positions,p,e.iconPositions,this.showCollisionBoxes,i,this.tileID.canonical,this.tileZoom,this.projection,this.brightness)):n.hasPattern&&(n instanceof cy||n instanceof Sf||n instanceof tb)&&(ow(n.layers,this.zoom,c.brightness,i),n.addFeatures(c,this.tileID.canonical,e.patternPositions,i,this.tileTransform,this.brightness));}this.status="done",n(null,{buckets:L(a).filter((t=>!t.isEmpty())),featureIndex:s,collisionBoxArray:this.collisionBoxArray,glyphAtlasImage:t.image,lineAtlas:l,imageAtlas:e,brightness:c.brightness,glyphMap:this.returnDependencies?d:null,iconMap:this.returnDependencies?p:null,glyphPositions:this.returnDependencies?t.positions:null});}},g=q(c.glyphDependencies,(t=>Object.keys(t).map(Number)));Object.keys(g).length?r.send("getGlyphs",{uid:this.uid,stacks:g,scope:this.scope},((t,e)=>{u||(u=t,d=e,_());}),void 0,!1,m):d={};const y=Object.keys(c.iconDependencies);y.length?r.send("getImages",{icons:y,source:this.source,scope:this.scope,tileID:this.tileID,type:"icons"},((t,e)=>{u||(u=t,p=e,_());}),void 0,!1,m):p={};const x=Object.keys(c.patternDependencies);x.length?r.send("getImages",{icons:x,source:this.source,scope:this.scope,tileID:this.tileID,type:"patterns"},((t,e)=>{u||(u=t,f=e,_());}),void 0,!1,m):f={},_();}}function ow(t,e,i,r){const n=new Qs(e,{brightness:i});for(const e of t)e.recalculate(n,r);}class sw{constructor(t){this.entries={},this.scheduler=t;}request(t,e,i,r){const n=this.entries[t]=this.entries[t]||{callbacks:[]};if(n.result){const[t,i]=n.result;return this.scheduler?this.scheduler.add((()=>{r(t,i);}),e):r(t,i),()=>{}}return n.callbacks.push(r),n.cancel||(n.cancel=i(((i,r)=>{n.result=[i,r];for(const t of n.callbacks)this.scheduler?this.scheduler.add((()=>{t(i,r);}),e):t(i,r);setTimeout((()=>delete this.entries[t]),3e3);}))),()=>{n.result||(n.callbacks=n.callbacks.filter((t=>t!==r)),n.callbacks.length||(n.cancel(),delete this.entries[t]));}}}function aw(t,e,i){const r=JSON.stringify(t.request);return t.data&&(this.deduped.entries[r]={result:[null,t.data]}),this.deduped.request(r,{type:"parseTile",isSymbolTile:t.isSymbolTile,zoom:t.tileZoom},(e=>{const r=Et(t.request,((t,r,n,o)=>{t?e(t):r&&e(null,{vectorTile:i?void 0:new Wf(new vm(r)),rawData:r,cacheControl:n,expires:o});}));return ()=>{r.cancel(),e();}}),e)}class lw extends Ce{constructor(t,e,i,r){if(super(),this.id=t,this.dispatcher=i,this.type="vector",this.minzoom=0,this.maxzoom=22,this.scheme="xyz",this.tileSize=512,this.reparseOverscaled=!0,this.isTileClipped=!0,this._loaded=!1,k(this,B(e,["url","scheme","tileSize","promoteId"])),this._options=k({type:"vector"},e),this._collectResourceTiming=!!e.collectResourceTiming,512!==this.tileSize)throw new Error("vector tile sources must have a tileSize of 512");this.setEventedParent(r),this._tileWorkers={},this._deduped=new sw;}load(t){this._loaded=!1,this.fire(new Se("dataloading",{dataType:"source"}));const e=Array.isArray(this.map._language)?this.map._language.join():this.map._language,i=this.map._worldview;this._tileJSONRequest=Qb(this._options,this.map._requestManager,e,i,((r,n)=>{this._tileJSONRequest=null,this._loaded=!0,r?(e&&console.warn(`Ensure that your requested language string is a valid BCP-47 code or list of codes. Found: ${e}`),i&&2!==i.length&&console.warn(`Requested worldview strings must be a valid ISO alpha-2 code. Found: ${i}`),this.fire(new Ie(r))):n&&(k(this,n),n.bounds&&(this.tileBounds=new tw(n.bounds,this.minzoom,this.maxzoom)),qt(n.tiles,this.map._requestManager._customAccessToken),this.fire(new Se("data",{dataType:"source",sourceDataType:"metadata"})),this.fire(new Se("data",{dataType:"source",sourceDataType:"content"}))),t&&t(r);}));}loaded(){return this._loaded}hasTile(t){return !this.tileBounds||this.tileBounds.contains(t.canonical)}onAdd(t){this.map=t,this.load();}reload(){this.cancelTileJSONRequest(),this.load((()=>this.map.style._clearSource(this.id)));}setTiles(t){return this._options.tiles=t,this.reload(),this}setUrl(t){return this.url=t,this._options.url=t,this.reload(),this}onRemove(){this.cancelTileJSONRequest();}serialize(){return k({},this._options)}loadTile(t,e){const i=this.map._requestManager.normalizeTileURL(t.tileID.canonical.url(this.tiles,this.scheme)),r={request:this.map._requestManager.transformRequest(i,xt.Tile),data:void 0,uid:t.uid,tileID:t.tileID,tileZoom:t.tileZoom,zoom:t.tileID.overscaledZ,tileSize:this.tileSize*t.tileID.overscaleFactor(),type:this.type,source:this.id,scope:this.scope,pixelRatio:ue.devicePixelRatio,showCollisionBoxes:this.map.showCollisionBoxes,promoteId:this.promoteId,isSymbolTile:t.isSymbolTile,brightness:this.map.style&&this.map.style.getBrightness()||0,extraShadowCaster:t.isExtraShadowCaster};if(r.request.collectResourceTiming=this._collectResourceTiming,t.actor&&"expired"!==t.state)"loading"===t.state?t.reloadCallback=e:t.request=t.actor.send("reloadTile",r,n.bind(this));else if(t.actor=this._tileWorkers[i]=this._tileWorkers[i]||this.dispatcher.getActor(),this.dispatcher.ready)t.request=t.actor.send("loadTile",r,n.bind(this),void 0,!0);else {const e=aw.call({deduped:this._deduped},r,((e,i)=>{e||!i?n.call(this,e):(r.data={cacheControl:i.cacheControl,expires:i.expires,rawData:i.rawData.slice(0)},t.actor&&t.actor.send("loadTile",r,n.bind(this),void 0,!0));}),!0);t.request={cancel:e};}function n(i,r){return delete t.request,t.aborted?e(null):i&&404!==i.status?e(i):(r&&r.resourceTiming&&(t.resourceTiming=r.resourceTiming),this.map._refreshExpiredTiles&&r&&t.setExpiryData(r),t.loadVectorData(r,this.map.painter),yt(this.dispatcher),e(null),void(t.reloadCallback&&(this.loadTile(t,t.reloadCallback),t.reloadCallback=null)))}}abortTile(t){t.request&&(t.request.cancel(),delete t.request),t.actor&&t.actor.send("abortTile",{uid:t.uid,type:this.type,source:this.id,scope:this.scope});}unloadTile(t){t.unloadVectorData(),t.actor&&t.actor.send("removeTile",{uid:t.uid,type:this.type,source:this.id,scope:this.scope});}hasTransition(){return !1}afterUpdate(){this._tileWorkers={};}cancelTileJSONRequest(){this._tileJSONRequest&&(this._tileJSONRequest.cancel(),this._tileJSONRequest=null);}}class cw extends Ce{constructor(t,e,i,r){super(),this.id=t,this.dispatcher=i,this.setEventedParent(r),this.type="raster",this.minzoom=0,this.maxzoom=22,this.roundZoom=!0,this.scheme="xyz",this.tileSize=512,this._loaded=!1,this._options=k({type:"raster"},e),k(this,B(e,["url","scheme","tileSize"]));}load(t){this._loaded=!1,this.fire(new Se("dataloading",{dataType:"source"})),this._tileJSONRequest=Qb(this._options,this.map._requestManager,null,null,((e,i)=>{this._tileJSONRequest=null,this._loaded=!0,e?this.fire(new Ie(e)):i&&(k(this,i),i.bounds&&(this.tileBounds=new tw(i.bounds,this.minzoom,this.maxzoom)),qt(i.tiles),this.fire(new Se("data",{dataType:"source",sourceDataType:"metadata"})),this.fire(new Se("data",{dataType:"source",sourceDataType:"content"}))),t&&t(e);}));}loaded(){return this._loaded}onAdd(t){this.map=t,this.load();}reload(){this.cancelTileJSONRequest(),this.load((()=>this.map.style._clearSource(this.id)));}setTiles(t){return this._options.tiles=t,this.reload(),this}setUrl(t){return this.url=t,this._options.url=t,this.reload(),this}onRemove(){this.cancelTileJSONRequest();}serialize(){return k({},this._options)}hasTile(t){return !this.tileBounds||this.tileBounds.contains(t.canonical)}loadTile(t,e){const i=ue.devicePixelRatio>=2,r=this.map._requestManager.normalizeTileURL(t.tileID.canonical.url(this.tiles,this.scheme),i,this.tileSize);t.request=Ct(this.map._requestManager.transformRequest(r,xt.Tile),((i,r,n,o)=>(delete t.request,t.aborted?(t.state="unloaded",e(null)):i?(t.state="errored",e(i)):r?(this.map._refreshExpiredTiles&&t.setExpiryData({cacheControl:n,expires:o}),t.setTexture(r,this.map.painter),t.state="loaded",yt(this.dispatcher),void e(null)):e(null))));}static loadTileData(t,e,i){t.setTexture(e,i);}static unloadTileData(t,e){t.texture&&e.saveTileTexture(t.texture);}abortTile(t,e){t.request&&(t.request.cancel(),delete t.request),e();}unloadTile(t,e){t.texture&&this.map.painter.saveTileTexture(t.texture),e();}hasTransition(){return !1}cancelTileJSONRequest(){this._tileJSONRequest&&(this._tileJSONRequest.cancel(),this._tileJSONRequest=null);}}let hw;function uw(t,e,i,r,n,o,s,a){const l=[t,i,n,e,r,o,1,1,1],c=[s,a,1],h=pu.adjoint([],l),[u,d,p]=bu.transformMat3(c,c,pu.transpose(h,h));return pu.multiply(l,[u,0,0,0,d,0,0,0,p],l)}class dw extends Ce{constructor(t,e,i,r){super(),this.id=t,this.dispatcher=i,this.coordinates=e.coordinates,this.type="image",this.minzoom=0,this.maxzoom=22,this.tileSize=512,this.tiles={},this._loaded=!1,this.setEventedParent(r),this.options=e,this._dirty=!1;}load(t,i){this._loaded=i||!1,this.fire(new Se("dataloading",{dataType:"source"})),this.url=this.options.url,this._imageRequest=Ct(this.map._requestManager.transformRequest(this.url,xt.Image),((i,r)=>{if(this._imageRequest=null,this._loaded=!0,i)this.fire(new Ie(i));else if(r){const{HTMLImageElement:i}=e;this.image=r instanceof i?ue.getImageData(r):r,this._dirty=!0,this.width=this.image.width,this.height=this.image.height,t&&(this.coordinates=t),this._finishLoading();}}));}loaded(){return this._loaded}updateImage(t){return this.image&&t.url?(this._imageRequest&&t.url!==this.options.url&&(this._imageRequest.cancel(),this._imageRequest=null),this.options.url=t.url,this.load(t.coordinates,this._loaded),this):this}_finishLoading(){this.map&&(this.setCoordinates(this.coordinates),this.fire(new Se("data",{dataType:"source",sourceDataType:"metadata"})));}onAdd(t){this.map=t,this.load();}onRemove(){this._imageRequest&&(this._imageRequest.cancel(),this._imageRequest=null),this.texture&&this.texture.destroy();}setCoordinates(t){this.coordinates=t,this._boundsArray=void 0;const e=t.map(Yd.fromLngLat);return this.tileID=function(t){let e=1/0,i=1/0,r=-1/0,n=-1/0;for(const o of t)e=Math.min(e,o.x),i=Math.min(i,o.y),r=Math.max(r,o.x),n=Math.max(n,o.y);const o=Math.max(r-e,n-i),s=Math.max(0,Math.floor(-Math.log(o)/Math.LN2)),a=Math.pow(2,s);return new Dd(s,Math.floor((e+r)/2*a),Math.floor((i+n)/2*a))}(e),this.minzoom=this.maxzoom=this.tileID.z,this.fire(new Se("data",{dataType:"source",sourceDataType:"content"})),this}_clear(){this._boundsArray=void 0;}_prepareData(t){for(const t in this.tiles){const e=this.tiles[t];"loaded"!==e.state&&(e.state="loaded",e.texture=this.texture);}if(this._boundsArray)return;const e=_g(this.tileID,this.map.transform.projection),[i,r,n,o]=this.coordinates.map((t=>{const i=e.projection.project(t[0],t[1]);return yg(e,i)._round()}));this.perspectiveTransform=function(t,e,i,r,n,o,s,a,l,c){const h=uw(0,0,t,0,0,e,t,e),u=uw(i,r,n,o,s,a,l,c);return pu.multiply(u,pu.adjoint(h,h),u),[u[6]/u[8]*t/sr,u[7]/u[8]*e/sr]}(this.width,this.height,i.x,i.y,r.x,r.y,o.x,o.y,n.x,n.y);const s=this._boundsArray=new va;s.emplaceBack(i.x,i.y,0,0),s.emplaceBack(r.x,r.y,sr,0),s.emplaceBack(o.x,o.y,0,sr),s.emplaceBack(n.x,n.y,sr,sr),this.boundsBuffer&&this.boundsBuffer.destroy(),this.boundsBuffer=t.createVertexBuffer(s,yy.members),this.boundsSegments=Wl.simpleSegment(0,0,4,2);}prepare(){if(0===Object.keys(this.tiles).length||!this.image)return;const t=this.map.painter.context,e=t.gl;this._dirty&&(this.texture?this.texture.update(this.image):(this.texture=new hy(t,this.image,e.RGBA),this.texture.bind(e.LINEAR,e.CLAMP_TO_EDGE)),this._dirty=!1),this._prepareData(t);}loadTile(t,e){this.tileID&&this.tileID.equals(t.tileID.canonical)?(this.tiles[String(t.tileID.wrap)]=t,t.buckets={},e(null)):(t.state="errored",e(null));}serialize(){return {type:"image",url:this.options.url,coordinates:this.coordinates}}hasTransition(){return !1}}class pw{constructor(t,e,i){if(this.triangleCount=e.length/3,this.min=new y(0,0),this.max=new y(0,0),this.xScale=0,this.yScale=0,this.cellsX=0,this.cellsY=0,this.cells=[],this.payload=[],0===this.triangleCount||0===t.length||0===i)return;const r=t.map((t=>t.x)),n=t.map((t=>t.y));this.min=new y(Math.min(...r),Math.min(...n)),this.max=new y(Math.max(...r),Math.max(...n));const o=this.max.sub(this.min);o.x=Math.max(o.x,1),o.y=Math.max(o.y,1);const s=Math.max(o.x,o.y)/i;this.cellsX=Math.max(1,Math.ceil(o.x/s)),this.cellsY=Math.max(1,Math.ceil(o.y/s)),this.xScale=1/s,this.yScale=1/s;const a=[];for(let i=0;i<this.triangleCount;i++){const r=t[e[3*i+0]].sub(this.min),n=t[e[3*i+1]].sub(this.min),o=t[e[3*i+2]].sub(this.min),l=fw(Math.floor(Math.min(r.x,n.x,o.x)),this.xScale,this.cellsX),c=fw(Math.floor(Math.max(r.x,n.x,o.x)),this.xScale,this.cellsX),h=fw(Math.floor(Math.min(r.y,n.y,o.y)),this.yScale,this.cellsY),u=fw(Math.floor(Math.max(r.y,n.y,o.y)),this.yScale,this.cellsY),d=new y(0,0),p=new y(0,0),f=new y(0,0),m=new y(0,0);for(let t=h;t<=u;++t){d.y=p.y=t*s,f.y=m.y=(t+1)*s;for(let e=l;e<=c;++e)d.x=f.x=e*s,p.x=m.x=(e+1)*s,(wp(r,n,o,d,p,m)||wp(r,n,o,d,m,f))&&a.push({cellIdx:t*this.cellsX+e,triIdx:i});}}if(0===a.length)return;a.sort(((t,e)=>t.cellIdx-e.cellIdx||t.triIdx-e.triIdx));let l=0;for(;l<a.length;){const t=a[l].cellIdx,e={start:this.payload.length,len:0};for(;l<a.length&&a[l].cellIdx===t;)++e.len,this.payload.push(a[l++].triIdx);this.cells[t]=e;}}query(t,e,i){if(0===this.triangleCount||0===this.cells.length)return;if(t.x>this.max.x||this.min.x>e.x)return;if(t.y>this.max.y||this.min.y>e.y)return;this.lookup||(this.lookup=new Uint8Array(Math.ceil(this.triangleCount/8)));for(let t=0;t<this.lookup.length;t++)this.lookup[t]=0;const r=fw(t.x-this.min.x,this.xScale,this.cellsX),n=fw(e.x-this.min.x,this.xScale,this.cellsX),o=fw(t.y-this.min.y,this.yScale,this.cellsY),s=fw(e.y-this.min.y,this.yScale,this.cellsY);for(let t=o;t<=s;t++)for(let e=r;e<=n;e++){const r=this.cells[t*this.cellsX+e];if(r)for(let t=0;t<r.len;t++){const e=this.payload[r.start+t],n=Math.floor(e/8),o=1<<e%8;if(!(this.lookup[n]&o)&&(this.lookup[n]|=o,i.push(e),i.length===this.triangleCount))return}}}}function fw(t,e,i){return Math.max(0,Math.min(i-1,Math.floor(t*e)))}Ss(pw,"TriangleGridIndex");const mw=5123,_w=5126,gw={5120:Int8Array,5121:Uint8Array,5122:Int16Array,5123:Uint16Array,5125:Uint32Array,5126:Float32Array},yw={SCALAR:1,VEC2:2,VEC3:3,VEC4:4,MAT2:4,MAT3:9,MAT4:16};function xw(t,e){if(e.value&&e.value.length)return e.value;const i=t.json.bufferViews[e.bufferView],r=t.buffers[i.buffer];return new(0,gw[e.componentType])(r.arrayBuffer,r.byteOffset+(e.byteOffset||0)+(i.byteOffset||0),e.count*yw[e.type])}function vw(t,e,i){const r=t.indices,n=t.attributes,o={};o.indexArray=new Ba;const s="object"==typeof r?r:e.json.accessors[r],a=s.count/3;o.indexArray.reserve(a);const l=xw(e,s);for(let t=0;t<a;t++)o.indexArray.emplaceBack(l[3*t],l[3*t+1],l[3*t+2]);o.indexArray._trim(),o.vertexArray=new ka;const c="object"==typeof n.POSITION?n.POSITION:e.json.accessors[n.POSITION];o.vertexArray.reserve(c.count);const h=xw(e,c);for(let t=0;t<c.count;t++)o.vertexArray.emplaceBack(h[3*t],h[3*t+1],h[3*t+2]);if(o.vertexArray._trim(),o.aabb=new Bu(c.min,c.max),o.centroid=function(t,e){const i=[0,0,0],r=t.length;if(r>0){for(let n=0;n<r;n++){const r=3*t[n];i[0]+=e[r],i[1]+=e[r+1],i[2]+=e[r+2];}i[0]/=r,i[1]/=r,i[2]/=r;}return i}(l,h),void 0!==n.COLOR_0){const t="object"==typeof n.COLOR_0?n.COLOR_0:e.json.accessors[n.COLOR_0],i=yw[t.type];if(t.componentType===_w){o.colorArray=3===i?new ka:new Ta,o.colorArray.reserve(t.count);const r=xw(e,t);if(3===i)for(let e=0;e<t.count;e++)o.colorArray.emplaceBack(r[3*e],r[3*e+1],r[3*e+2]);else for(let e=0;e<t.count;e++)o.colorArray.emplaceBack(r[4*e],r[4*e+1],r[4*e+2],r[4*e+3]);o.colorArray._trim();}else if(t.componentType===mw&&4===i){o.colorArray=new Ta,o.colorArray.resize(t.count);const i=xw(e,t),r=1/65535,n=o.colorArray.float32;for(let t=0;t<4*i.length;++t)n[t]=i[t]*r;}else W(`glTF color buffer parsing for accessor ${JSON.stringify(t)} is not supported`);}if(void 0!==n.NORMAL){o.normalArray=new ka;const t="object"==typeof n.NORMAL?n.NORMAL:e.json.accessors[n.NORMAL];o.normalArray.reserve(t.count);const i=xw(e,t);for(let e=0;e<t.count;e++)o.normalArray.emplaceBack(i[3*e],i[3*e+1],i[3*e+2]);o.normalArray._trim();}if(void 0!==n.TEXCOORD_0&&i.length>0){o.texcoordArray=new qa;const t="object"==typeof n.TEXCOORD_0?n.TEXCOORD_0:e.json.accessors[n.TEXCOORD_0];o.texcoordArray.reserve(t.count);const i=xw(e,t);for(let e=0;e<t.count;e++)o.texcoordArray.emplaceBack(i[2*e],i[2*e+1]);o.texcoordArray._trim();}const u=t.material;return o.material=function(t,e){const i=t.pbrMetallicRoughness?t.pbrMetallicRoughness:{},r={},n={},o=i.baseColorFactor?new li(i.baseColorFactor[0],i.baseColorFactor[1],i.baseColorFactor[2],i.baseColorFactor[3]):li.white;return n.baseColorFactor=o,n.metallicFactor=void 0!==i.metallicFactor?i.metallicFactor:1,n.roughnessFactor=void 0!==i.roughnessFactor?i.roughnessFactor:1,r.emissiveFactor=t.emissiveFactor?[t.emissiveFactor[0],t.emissiveFactor[1],t.emissiveFactor[2]]:[0,0,0],r.alphaMode=t.alphaMode?t.alphaMode:"OPAQUE",r.alphaCutoff=void 0!==t.alphaCutoff?t.alphaCutoff:.5,i.baseColorTexture&&(n.baseColorTexture=e[i.baseColorTexture.index]),i.metallicRoughnessTexture&&(n.metallicRoughnessTexture=e[i.metallicRoughnessTexture.index]),t.normalTexture&&(r.normalTexture=e[t.normalTexture.index]),t.occlusionTexture&&(r.occlusionTexture=e[t.occlusionTexture.index]),t.emissiveTexture&&(r.emissionTexture=e[t.emissiveTexture.index]),r.pbrMetallicRoughness=n,r.doubleSided=t.doubleSided,void 0===t.defined&&(r.defined=!0),r}(void 0!==u?e.json.materials[u]:{defined:!1},i),void 0!==n.CUSTOM_ATTRIBUTE_3&&(o.featureData=new Uint32Array(n.CUSTOM_ATTRIBUTE_3.value.buffer)),o}function bw(t,e,i){const r={};if(r.matrix=t.matrix?t.matrix:mu.identity([]),t.translation&&mu.translate(r.matrix,r.matrix,[t.translation[0],t.translation[1],t.translation[2]]),t.rotation){const e=mu.fromQuat([],[t.rotation[0],t.rotation[1],t.rotation[2],t.rotation[3]]);mu.multiply(r.matrix,r.matrix,e);}if(t.scale&&mu.scale(r.matrix,r.matrix,[t.scale[0],t.scale[1],t.scale[2]]),void 0!==t.mesh&&(r.meshes=i[t.mesh]),t.extras&&(t.extras.id&&(r.id=t.extras.id),t.extras.lights&&(r.lights=function(t){if(!t.length)return [];const e=function(t,e){const i=t.replace(/[^A-Za-z0-9+/]/g,""),r=i.length,n=3*r+1>>2,o=new Uint8Array(n);let s,a,l=0,c=0;for(let t=0;t<r;t++)if(a=3&t,l|=((h=i.charCodeAt(t))>64&&h<91?h-65:h>96&&h<123?h-71:h>47&&h<58?h+4:43===h?62:47===h?63:0)<<6*(3-a),3===a||r-t==1){for(s=0;s<3&&c<n;)o[c]=l>>>(16>>>s&24)&255,s++,c++;l=0;}var h;return o}(t),i=[],r=e.length/24,n=new Uint16Array(e.buffer),o=new Float32Array(e.buffer);for(let t=0;t<r;t++){const e=n[2*t*6]/30,r=n[2*t*6+1]/30,s=[o[6*t+1],o[6*t+2],r],a=[o[6*t+3],o[6*t+4],r],l=bu.sub([],a,s),c=bu.length(l);l[2]=-l[0],l[0]=l[1],l[1]=l[2],l[2]=0,bu.scale(l,l,1/c);const h=n[2*t*6+10]/100,u=bu.add([],s,a);bu.scale(u,u,.5),i.push({pos:u,normal:l,width:c,height:e,depth:h,points:[s[0],s[1],a[0],a[1]]});}return i}(t.extras.lights)),r.meshes)){const t=[0,0];for(const e of r.meshes){const i=e.aabb;t[0]+=i.min[0]+i.max[0],t[1]+=i.min[1]+i.max[1];}t[0]=Math.floor(t[0]/r.meshes.length/2),t[1]=Math.floor(t[1]/r.meshes.length/2),r.anchor=t;}if(t.children){const n=[];for(const r of t.children)n.push(bw(e.json.nodes[r],e,i));r.children=n;}return r}function ww(t){if(0===t.vertices.length||0===t.indices.length)return null;const[e,i]=[t.vertices[0].clone(),t.vertices[0].clone()];for(let r=1;r<t.vertices.length;++r){const n=t.vertices[r];e.x=Math.min(e.x,n.x),e.y=Math.min(e.y,n.y),i.x=Math.max(i.x,n.x),i.y=Math.max(i.y,n.y);}const r=Math.ceil(Math.max(i.x-e.x,i.y-e.y)/256),n=Math.max(8,r),o=new pw(t.vertices,t.indices,n);return {vertices:t.vertices,indices:t.indices,grid:o,min:e,max:i}}function Tw(t){if(!t.extras||!t.extras.ground)return null;const e=t.extras.ground;if(!e||!Array.isArray(e)||0===e.length)return null;const i=e[0];if(!i||!Array.isArray(i)||0===i.length)return null;const r=[];for(const t of i){if(!Array.isArray(t)||2!==t.length)continue;const e=t[0],i=t[1];"number"==typeof e&&"number"==typeof i&&r.push(new y(e,i));}if(r.length<3)return null;r.length>1&&r[r.length-1].equals(r[0])&&r.pop();let n=0;for(let t=0;t<r.length;t++){const e=r[t],i=r[(t+1)%r.length],o=r[(t+2)%r.length];n+=(e.x-i.x)*(o.y-i.y)-(o.x-i.x)*(e.y-i.y);}n>0&&r.reverse();const o=wf(r.flatMap((t=>[t.x,t.y])),[]);return 0===o.length?null:{vertices:r,indices:o}}function Ew(t){const e=[],i=[];let r=0;for(const n of t){r=e.length;const t=n.vertexArray.float32,o=n.indexArray.uint16;for(let i=0;i<n.vertexArray.length;i++)e.push(new y(t[3*i+0],t[3*i+1]));for(let t=0;t<3*n.indexArray.length;t++)i.push(o[t]+r);}if(i.length%3!=0)return null;for(let t=0;t<i.length;t+=3){const r=e[i[t+0]],n=e[i[t+1]],o=e[i[t+2]];(r.x-n.x)*(o.y-n.y)-(o.x-n.x)*(r.y-n.y)>0&&([i[t+1],i[t+2]]=[i[t+2],i[t+1]]);}return {vertices:e,indices:i}}function Mw(t){const i=function(t){const e=[];for(const i of t.images)e.push(i);return e}(t),r=function(t,i){const r=[],n=e.WebGL2RenderingContext,o=t.json.samplers;if(t.json.textures)for(const e of t.json.textures){const t={magFilter:n.LINEAR,minFilter:n.NEAREST,wrapS:n.REPEAT,wrapT:n.REPEAT,mipmaps:!1};void 0!==e.sampler&&(o[e.sampler].magFilter&&(t.magFilter=o[e.sampler].magFilter),o[e.sampler].minFilter&&(t.minFilter=o[e.sampler].minFilter),t.minFilter>=n.NEAREST_MIPMAP_NEAREST&&(t.mipmaps=!0),o[e.sampler].wrapS&&(t.wrapS=o[e.sampler].wrapS),o[e.sampler].wrapT&&(t.wrapT=o[e.sampler].wrapT)),r.push({image:i[e.source],sampler:t,uploaded:!1});}return r}(t,i),n=function(t,e){const i=[];for(const r of t.json.meshes){const n=[];for(const i of r.primitives){const r=vw(i,t,e);n.push(r);}i.push(n);}return i}(t,r),o=[],s=t.json.scene?t.json.scenes[t.json.scene]:t.json.scenes?t.json.scenes[0]:void 0,a=s?s.nodes:t.json.nodes;for(const e of a)o.push(bw(t.json.nodes[e],t,n));return function(t,e,i){const r={},n=new Set;for(let o=0;o<t.length;o++){const t=i[e[o]];if(!t.extras)continue;const s=t.extras["mapbox:footprint:version"],a=t.extras["mapbox:footprint:id"];(s||a)&&n.add(o),"1.0.0"===s&&a&&(r[a]=o);}for(let o=0;o<t.length;o++){if(n.has(o))continue;const s=t[o],a=i[e[o]];if(!a.extras)continue;let l=null;s.id in r&&(l=Ew(t[r[s.id]].meshes)),l||(l=Tw(a)),l&&(s.footprint=ww(l));}if(n.size>0){const e=Array.from(n.values()).sort(((t,e)=>t-e));for(let i=e.length-1;i>=0;i--)t.splice(e[i],1);}}(o,a,t.json.nodes),o}function Aw(t){t.heightmap=new Float32Array(4096),t.heightmap.fill(-1);const e=t.vertexArray.float32,i=t.aabb.min[0]-1,r=t.aabb.min[1]-1,n=dv/(t.aabb.max[0]-i+2),o=dv/(t.aabb.max[1]-r+2);for(let s=0;s<e.length;s+=3){const a=e[s+2],l=(e[s+0]-i)*n|0,c=(e[s+1]-r)*o|0;a>t.heightmap[c*dv+l]&&(t.heightmap[c*dv+l]=a);}}function Sw(t,e){const i={};i.indexArray=new Ba,i.indexArray.reserve(4*t.length),i.vertexArray=new ka,i.vertexArray.reserve(10*t.length),i.colorArray=new Ta,i.vertexArray.reserve(10*t.length);let r=0;for(const n of t){const t=Math.min(10,Math.max(4,1.3*n.height))*e,o=[-n.normal[1],n.normal[0],0],s=Math.min(.29,.1*n.width/n.depth),a=n.width-2*n.depth*e*(s+.01),l=bu.scaleAndAdd([],n.pos,o,a/2),c=bu.scaleAndAdd([],n.pos,o,-a/2),h=[l[0],l[1],l[2]+n.height],u=[c[0],c[1],c[2]+n.height],d=bu.scaleAndAdd([],n.normal,o,s);bu.scale(d,d,t);const p=bu.scaleAndAdd([],n.normal,o,-s);bu.scale(p,p,t),bu.add(d,l,d),bu.add(p,c,p),l[2]+=.1,c[2]+=.1,i.vertexArray.emplaceBack(d[0],d[1],d[2]),i.vertexArray.emplaceBack(p[0],p[1],p[2]),i.vertexArray.emplaceBack(l[0],l[1],l[2]),i.vertexArray.emplaceBack(c[0],c[1],c[2]),i.vertexArray.emplaceBack(h[0],h[1],h[2]),i.vertexArray.emplaceBack(u[0],u[1],u[2]),i.vertexArray.emplaceBack(l[0],l[1],l[2]),i.vertexArray.emplaceBack(c[0],c[1],c[2]),i.vertexArray.emplaceBack(d[0],d[1],d[2]),i.vertexArray.emplaceBack(p[0],p[1],p[2]);const f=a/t/2;i.colorArray.emplaceBack(-f-s,-1,f,.8),i.colorArray.emplaceBack(f+s,-1,f,.8),i.colorArray.emplaceBack(-f,0,f,1.3),i.colorArray.emplaceBack(f,0,f,1.3),i.colorArray.emplaceBack(f+s,-.8,f,.7),i.colorArray.emplaceBack(f+s,-.8,f,.7),i.colorArray.emplaceBack(0,0,f,1.3),i.colorArray.emplaceBack(0,0,f,1.3),i.colorArray.emplaceBack(f+s,-1.2,f,.8),i.colorArray.emplaceBack(f+s,-1.2,f,.8),i.indexArray.emplaceBack(6+r,4+r,8+r),i.indexArray.emplaceBack(7+r,9+r,5+r),i.indexArray.emplaceBack(0+r,1+r,2+r),i.indexArray.emplaceBack(1+r,3+r,2+r),r+=10;}const n={defined:!0,emissiveFactor:[0,0,0]},o={};return o.baseColorFactor=li.white,n.pbrMetallicRoughness=o,i.material=n,i.aabb=new Bu([1/0,1/0,1/0],[-1/0,-1/0,-1/0]),i}function Iw(){return null!=GS.workerClass?new GS.workerClass:new e.Worker(GS.workerUrl)}const Cw="mapboxgl_preloaded_worker_pool";class zw{constructor(){this.active={};}acquire(t){if(!this.workers)for(this.workers=[];this.workers.length<zw.workerCount;)this.workers.push(new Iw);return this.active[t]=!0,this.workers.slice()}release(t){delete this.active[t],this.workers&&0===this.numActive()&&(this.workers.forEach((t=>{t.terminate();})),this.workers=null);}isPreloaded(){return !!this.active[Cw]}numActive(){return Object.keys(this.active).length}}let Dw;function Pw(){return Dw||(Dw=new zw),Dw}zw.workerCount=2;let Rw,Lw,kw=null;const Bw=n.LOADERS_URL;function Ow(){return Q()&&self.worker&&self.worker.loadersUrl?self.worker.loadersUrl:Lw||Bw}async function Fw(){if(Rw&&await Rw,"undefined"==typeof mapboxglLoaders){const e=Ow();try{t=e,Rw=Q()?(importScripts(t),new Promise((t=>t()))):new Promise(((e,i)=>{const r=document.createElement("script");r.src=t,r.onload=e,r.onerror=i,document.head.appendChild(r),r.src=t;})),await Rw;}catch(t){W(`Could not load bundle from ${e}.`);}}var t;Rw=void 0;}async function Nw(t){return await Fw(),mapboxglLoaders.load(t,mapboxglLoaders.GLTFLoader,{gltf:{postProcess:!1,loadBuffers:!0,loadImages:!0}})}const Uw={vector:lw,raster:cw,"raster-dem":class extends cw{constructor(t,e,i,r){super(t,e,i,r),this.type="raster-dem",this.maxzoom=22,this._options=k({type:"raster-dem"},e),this.encoding=e.encoding||"mapbox";}loadTile(t,i){const r=this.map._requestManager.normalizeTileURL(t.tileID.canonical.url(this.tiles,this.scheme),!1,this.tileSize);t.request=Ct(this.map._requestManager.transformRequest(r,xt.Tile),function(r,s,a,l){if(delete t.request,t.aborted)t.state="unloaded",i(null);else if(r)t.state="errored",i(r);else if(s){this.map._refreshExpiredTiles&&t.setExpiryData({cacheControl:a,expires:l});const i=e.ImageBitmap&&s instanceof e.ImageBitmap&&(null==hw&&(hw=e.OffscreenCanvas&&new e.OffscreenCanvas(1,1).getContext("2d")&&"function"==typeof e.createImageBitmap),hw),r=1-(s.width-((c=s.width)<=1?1:Math.pow(2,Math.floor(Math.log(c)/Math.LN2))))/2;r<1||t.neighboringTiles||(t.neighboringTiles=this._getNeighboringTiles(t.tileID));const h=i?s:ue.getImageData(s,r),u={uid:t.uid,coord:t.tileID,source:this.id,scope:this.scope,rawImageData:h,encoding:this.encoding,padding:r,convertToFloat:n};t.actor&&"expired"!==t.state||(t.actor=this.dispatcher.getActor(),t.actor.send("loadDEMTile",u,o.bind(this),void 0,!0));}var c;}.bind(this));const n=this.map?.painter?.terrainUseFloatDEM();function o(e,r){e&&(t.state="errored",i(e)),r&&(t.dem=r,t.dem.onDeserialize(),t.needsHillshadePrepare=!0,t.needsDEMTextureUpload=!0,t.state="loaded",i(null));}}_getNeighboringTiles(t){const e=t.canonical,i=Math.pow(2,e.z),r=(e.x-1+i)%i,n=0===e.x?t.wrap-1:t.wrap,o=(e.x+1+i)%i,s=e.x+1===i?t.wrap+1:t.wrap,a={};return a[new Rd(t.overscaledZ,n,e.z,r,e.y).key]={backfilled:!1},a[new Rd(t.overscaledZ,s,e.z,o,e.y).key]={backfilled:!1},e.y>0&&(a[new Rd(t.overscaledZ,n,e.z,r,e.y-1).key]={backfilled:!1},a[new Rd(t.overscaledZ,t.wrap,e.z,e.x,e.y-1).key]={backfilled:!1},a[new Rd(t.overscaledZ,s,e.z,o,e.y-1).key]={backfilled:!1}),e.y+1<i&&(a[new Rd(t.overscaledZ,n,e.z,r,e.y+1).key]={backfilled:!1},a[new Rd(t.overscaledZ,t.wrap,e.z,e.x,e.y+1).key]={backfilled:!1},a[new Rd(t.overscaledZ,s,e.z,o,e.y+1).key]={backfilled:!1}),a}unloadTile(t){t.demTexture&&this.map.painter.saveTileTexture(t.demTexture),t.fbo&&(t.fbo.destroy(),delete t.fbo),t.dem&&delete t.dem,delete t.neighboringTiles,t.state="unloaded";}},geojson:class extends Ce{constructor(t,e,i,r){super(),this.id=t,this.type="geojson",this.minzoom=0,this.maxzoom=18,this.tileSize=512,this.isTileClipped=!0,this.reparseOverscaled=!0,this._loaded=!1,this.actor=i.getActor(),this.setEventedParent(r),this._data=e.data,this._options=k({},e),this._collectResourceTiming=e.collectResourceTiming,void 0!==e.maxzoom&&(this.maxzoom=e.maxzoom),e.type&&(this.type=e.type),e.attribution&&(this.attribution=e.attribution),this.promoteId=e.promoteId;const n=sr/this.tileSize;this.workerOptions=k({source:this.id,scope:this.scope,cluster:e.cluster||!1,geojsonVtOptions:{buffer:(void 0!==e.buffer?e.buffer:128)*n,tolerance:(void 0!==e.tolerance?e.tolerance:.375)*n,extent:sr,maxZoom:this.maxzoom,lineMetrics:e.lineMetrics||!1,generateId:e.generateId||!1},superclusterOptions:{maxZoom:void 0!==e.clusterMaxZoom?e.clusterMaxZoom:this.maxzoom-1,minPoints:Math.max(2,e.clusterMinPoints||2),extent:sr,radius:(void 0!==e.clusterRadius?e.clusterRadius:50)*n,log:!1,generateId:e.generateId||!1},clusterProperties:e.clusterProperties,filter:e.filter},e.workerOptions);}onAdd(t){this.map=t,this.setData(this._data);}setData(t){return this._data=t,this._updateWorkerData(),this}getClusterExpansionZoom(t,e){return this.actor.send("geojson.getClusterExpansionZoom",{clusterId:t,source:this.id,scope:this.scope},e),this}getClusterChildren(t,e){return this.actor.send("geojson.getClusterChildren",{clusterId:t,source:this.id,scope:this.scope},e),this}getClusterLeaves(t,e,i,r){return this.actor.send("geojson.getClusterLeaves",{source:this.id,scope:this.scope,clusterId:t,limit:e,offset:i},r),this}_updateWorkerData(){if(this._pendingLoad)return void(this._coalesce=!0);this.fire(new Se("dataloading",{dataType:"source"})),this._loaded=!1;const t=k({},this.workerOptions);t.scope=this.scope;const e=this._data;"string"==typeof e?(t.request=this.map._requestManager.transformRequest(ue.resolveURL(e),xt.Source),t.request.collectResourceTiming=this._collectResourceTiming):t.data=JSON.stringify(e),this._pendingLoad=this.actor.send(`${this.type}.loadData`,t,((t,e)=>{if(this._loaded=!0,this._pendingLoad=null,t)this.fire(new Ie(t));else {const t={dataType:"source",sourceDataType:this._metadataFired?"content":"metadata"};this._collectResourceTiming&&e&&e.resourceTiming&&e.resourceTiming[this.id]&&(t.resourceTiming=e.resourceTiming[this.id]),this.fire(new Se("data",t)),this._metadataFired=!0;}this._coalesce&&(this._updateWorkerData(),this._coalesce=!1);}));}loaded(){return this._loaded}loadTile(t,e){const i=t.actor?"reloadTile":"loadTile";t.actor=this.actor;const r={type:this.type,uid:t.uid,tileID:t.tileID,tileZoom:t.tileZoom,zoom:t.tileID.overscaledZ,maxZoom:this.maxzoom,tileSize:this.tileSize,source:this.id,scope:this.scope,pixelRatio:ue.devicePixelRatio,showCollisionBoxes:this.map.showCollisionBoxes,promoteId:this.promoteId,brightness:this.map.style&&this.map.style.getBrightness()||0};t.request=this.actor.send(i,r,((r,n)=>(delete t.request,t.unloadVectorData(),t.aborted?e(null):r?e(r):(t.loadVectorData(n,this.map.painter,"reloadTile"===i),e(null)))),void 0,"loadTile"===i);}abortTile(t){t.request&&(t.request.cancel(),delete t.request),t.aborted=!0;}unloadTile(t){t.unloadVectorData(),this.actor.send("removeTile",{uid:t.uid,type:this.type,source:this.id,scope:this.scope});}onRemove(){this._pendingLoad&&this._pendingLoad.cancel();}serialize(){return k({},this._options,{type:this.type,data:this._data})}hasTransition(){return !1}},video:class extends dw{constructor(t,e,i,r){super(t,e,i,r),this.roundZoom=!0,this.type="video",this.options=e;}load(){this._loaded=!1;const t=this.options;this.urls=[];for(const e of t.urls)this.urls.push(this.map._requestManager.transformRequest(e,xt.Source).url);!function(t,i){const r=e.document.createElement("video");r.muted=!0,r.onloadstart=function(){i(null,r);};for(let i=0;i<t.length;i++){const n=e.document.createElement("source");Mt(t[i])||(r.crossOrigin="Anonymous"),n.src=t[i],r.appendChild(n);}}(this.urls,((t,e)=>{this._loaded=!0,t?this.fire(new Ie(t)):e&&(this.video=e,this.video.loop=!0,this.video.setAttribute("playsinline",""),this.video.addEventListener("playing",(()=>{this.map.triggerRepaint();})),this.map&&this.video.play(),this._finishLoading());}));}pause(){this.video&&this.video.pause();}play(){this.video&&this.video.play();}seek(t){if(this.video){const e=this.video.seekable;t<e.start(0)||t>e.end(0)?this.fire(new Ie(new Pe(`sources.${this.id}`,null,`Playback for this video can be set only between the ${e.start(0)} and ${e.end(0)}-second mark.`))):this.video.currentTime=t;}}getVideo(){return this.video}onAdd(t){this.map||(this.map=t,this.load(),this.video&&(this.video.play(),this.setCoordinates(this.coordinates)));}prepare(){if(0===Object.keys(this.tiles).length||this.video.readyState<2)return;const t=this.map.painter.context,e=t.gl;this.texture?this.video.paused||(this.texture.bind(e.LINEAR,e.CLAMP_TO_EDGE),e.texSubImage2D(e.TEXTURE_2D,0,0,0,e.RGBA,e.UNSIGNED_BYTE,this.video)):(this.texture=new hy(t,this.video,e.RGBA),this.texture.bind(e.LINEAR,e.CLAMP_TO_EDGE),this.width=this.video.videoWidth,this.height=this.video.videoHeight),this._prepareData(t);}serialize(){return {type:"video",urls:this.urls,coordinates:this.coordinates}}hasTransition(){return this.video&&!this.video.paused}},image:dw,model:class extends Ce{constructor(t,e,i,r){super(),this.id=t,this.type="model",this.models=[],this._loaded=!1,this._options=e;}async load(){for(const t in this._options.models){const e=this._options.models[t],i=await Nw(this.map._requestManager.transformRequest(e.uri,xt.Model).url).catch((i=>{this.fire(new Ie(new Error(`Could not load model ${t} from ${e.uri}: ${i.message}`)));}));if(!i)continue;const r=Mw(i),n=new fv(t,e.position,e.orientation,r);n.computeBoundsAndApplyParent(),this.models.push(n);}this._loaded=!0,this.fire(new Se("data",{dataType:"source",sourceDataType:"metadata"}));}onAdd(t){this.map=t,this.load();}hasTransition(){return !1}loaded(){return this._loaded}getModels(){return this.models}loadTile(t,e){}serialize(){return {type:"model"}}},"batched-model":class extends Ce{constructor(t,e,i,r){super(),this.type="batched-model",this.id=t,this.tileSize=512,this._options=e,this.tiles=this._options.tiles,this.maxzoom=e.maxzoom||19,this.minzoom=e.minzoom||0,this.roundZoom=!0,this.usedInConflation=!0,this.dispatcher=i,this.reparseOverscaled=!1,this.scheme="xyz",this._loaded=!1,this.setEventedParent(r);}onAdd(t){this.map=t,this.load();}load(t){this._loaded=!1,this.fire(new Se("dataloading",{dataType:"source"}));const e=Array.isArray(this.map._language)?this.map._language.join():this.map._language,i=this.map._worldview;this._tileJSONRequest=Qb(this._options,this.map._requestManager,e,i,((r,n)=>{this._tileJSONRequest=null,this._loaded=!0,r?(e&&console.warn(`Ensure that your requested language string is a valid BCP-47 code or list of codes. Found: ${e}`),i&&2!==i.length&&console.warn(`Requested worldview strings must be a valid ISO alpha-2 code. Found: ${i}`),this.fire(new Ie(r))):n&&(k(this,n),n.bounds&&(this.tileBounds=new tw(n.bounds,this.minzoom,this.maxzoom)),qt(n.tiles,this.map._requestManager._customAccessToken),this.fire(new Se("data",{dataType:"source",sourceDataType:"metadata"})),this.fire(new Se("data",{dataType:"source",sourceDataType:"content"}))),t&&t(r);}));}hasTransition(){return !1}hasTile(t){return !this.tileBounds||this.tileBounds.contains(t.canonical)}loaded(){return this._loaded}loadTile(t,e){const i=this.map._requestManager.normalizeTileURL(t.tileID.canonical.url(this.tiles,this.scheme)),r={request:this.map._requestManager.transformRequest(i,xt.Tile),data:void 0,uid:t.uid,tileID:t.tileID,tileZoom:t.tileZoom,zoom:t.tileID.overscaledZ,tileSize:this.tileSize*t.tileID.overscaleFactor(),type:this.type,source:this.id,scope:this.scope,showCollisionBoxes:this.map.showCollisionBoxes,isSymbolTile:t.isSymbolTile,brightness:this.map.style&&this.map.style.getBrightness()||0};if(t.actor&&"expired"!==t.state)if("loading"===t.state)t.reloadCallback=e;else {if(t.buckets){const e=Object.values(t.buckets);for(const t of e)t.dirty=!0;return void(t.state="loaded")}t.request=t.actor.send("reloadTile",r,n.bind(this));}else t.actor=this.dispatcher.getActor(),t.request=t.actor.send("loadTile",r,n.bind(this),void 0,!0);function n(i,r){return t.aborted?e(null):i&&404!==i.status?e(i):(r&&(r.resourceTiming&&(t.resourceTiming=r.resourceTiming),this.map._refreshExpiredTiles&&t.setExpiryData(r),t.buckets={...t.buckets,...r.buckets}),t.state="loaded",void e(null))}}serialize(){return {type:"batched-model"}}},canvas:class extends dw{constructor(t,i,r,n){super(t,i,r,n),i.coordinates?Array.isArray(i.coordinates)&&4===i.coordinates.length&&!i.coordinates.some((t=>!Array.isArray(t)||2!==t.length||t.some((t=>"number"!=typeof t))))||this.fire(new Ie(new Pe(`sources.${t}`,null,'"coordinates" property must be an array of 4 longitude/latitude array pairs'))):this.fire(new Ie(new Pe(`sources.${t}`,null,'missing required property "coordinates"'))),i.animate&&"boolean"!=typeof i.animate&&this.fire(new Ie(new Pe(`sources.${t}`,null,'optional "animate" property must be a boolean value'))),i.canvas?"string"==typeof i.canvas||i.canvas instanceof e.HTMLCanvasElement||this.fire(new Ie(new Pe(`sources.${t}`,null,'"canvas" must be either a string representing the ID of the canvas element from which to read, or an HTMLCanvasElement instance'))):this.fire(new Ie(new Pe(`sources.${t}`,null,'missing required property "canvas"'))),this.options=i,this.animate=void 0===i.animate||i.animate;}load(){this._loaded=!0,this.canvas||(this.canvas=this.options.canvas instanceof e.HTMLCanvasElement?this.options.canvas:e.document.getElementById(this.options.canvas)),this.width=this.canvas.width,this.height=this.canvas.height,this._hasInvalidDimensions()?this.fire(new Ie(new Error("Canvas dimensions cannot be less than or equal to zero."))):(this.play=function(){this._playing=!0,this.map.triggerRepaint();},this.pause=function(){this._playing&&(this.prepare(),this._playing=!1);},this._finishLoading());}getCanvas(){return this.canvas}onAdd(t){this.map=t,this.load(),this.canvas&&this.animate&&this.play();}onRemove(){this.pause();}prepare(){let t=!1;if(this.canvas.width!==this.width&&(this.width=this.canvas.width,t=!0),this.canvas.height!==this.height&&(this.height=this.canvas.height,t=!0),this._hasInvalidDimensions())return;if(0===Object.keys(this.tiles).length)return;const e=this.map.painter.context;this.texture?(t||this._playing)&&this.texture.update(this.canvas,{premultiply:!0}):this.texture=new hy(e,this.canvas,e.gl.RGBA,{premultiply:!0}),this._prepareData(e);}serialize(){return {type:"canvas",coordinates:this.coordinates}}hasTransition(){return this._playing}_hasInvalidDimensions(){for(const t of [this.canvas.width,this.canvas.height])if(isNaN(t)||t<=0)return !0;return !1}},custom:class extends Ce{constructor(t,e,i,r){super(),this.id=t,this.type="custom",this._dataType="raster",this._dispatcher=i,this._implementation=e,this.setEventedParent(r),this.scheme="xyz",this.minzoom=0,this.maxzoom=22,this.tileSize=512,this._loaded=!1,this.roundZoom=!0,this._implementation||this.fire(new Ie(new Error(`Missing implementation for ${this.id} custom source`))),this._implementation.loadTile||this.fire(new Ie(new Error(`Missing loadTile implementation for ${this.id} custom source`))),this._implementation.bounds&&(this.tileBounds=new tw(this._implementation.bounds,this.minzoom,this.maxzoom)),e.update=this._update.bind(this),e.clearTiles=this._clearTiles.bind(this),e.coveringTiles=this._coveringTiles.bind(this),k(this,B(e,["dataType","scheme","minzoom","maxzoom","tileSize","attribution","minTileCacheSize","maxTileCacheSize"]));}serialize(){return B(this,["type","scheme","minzoom","maxzoom","tileSize","attribution"])}load(){this._loaded=!0,this.fire(new Se("data",{dataType:"source",sourceDataType:"metadata"})),this.fire(new Se("data",{dataType:"source",sourceDataType:"content"}));}loaded(){return this._loaded}onAdd(t){this._map=t,this._loaded=!1,this.fire(new Se("dataloading",{dataType:"source"})),this._implementation.onAdd&&this._implementation.onAdd(t),this.load();}onRemove(t){this._implementation.onRemove&&this._implementation.onRemove(t);}hasTile(t){if(this._implementation.hasTile){const{x:e,y:i,z:r}=t.canonical;return this._implementation.hasTile({x:e,y:i,z:r})}return !this.tileBounds||this.tileBounds.contains(t.canonical)}loadTile(t,i){const{x:r,y:n,z:o}=t.tileID.canonical,s=new e.AbortController;t.request=Promise.resolve(this._implementation.loadTile({x:r,y:n,z:o},{signal:s.signal})).then(function(r){return delete t.request,t.aborted?(t.state="unloaded",i(null)):void 0===r?(t.state="errored",i(null)):null===r?(this.loadTileData(t,{width:this.tileSize,height:this.tileSize,data:null}),t.state="loaded",i(null)):function(t){return t instanceof e.ImageData||t instanceof e.HTMLCanvasElement||t instanceof e.ImageBitmap||t instanceof e.HTMLImageElement}(r)?(this.loadTileData(t,r),t.state="loaded",void i(null)):(t.state="errored",i(new Error(`Can't infer data type for ${this.id}, only raster data supported at the moment`)))}.bind(this)).catch((e=>{20!==e.code&&(t.state="errored",i(e));})),t.request.cancel=()=>s.abort();}loadTileData(t,e){cw.loadTileData(t,e,this._map.painter);}unloadTileData(t){cw.unloadTileData(t,this._map.painter);}unloadTile(t,e){if(this.unloadTileData(t),this._implementation.unloadTile){const{x:e,y:i,z:r}=t.tileID.canonical;this._implementation.unloadTile({x:e,y:i,z:r});}e();}abortTile(t,e){t.request&&t.request.cancel&&(t.request.cancel(),delete t.request),e();}hasTransition(){return !1}_coveringTiles(){return this._map.transform.coveringTiles({tileSize:this.tileSize,minzoom:this.minzoom,maxzoom:this.maxzoom,roundZoom:this.roundZoom}).map((t=>({x:t.canonical.x,y:t.canonical.y,z:t.canonical.z})))}_clearTiles(){this._map.style._clearSource(this.id);}_update(){this.fire(new Se("data",{dataType:"source",sourceDataType:"content"}));}}},Vw=function(t,e,i,r){const n=new Uw[e.type](t,e,i,r);if(n.id!==t)throw new Error(`Expected Source id to be ${t} instead of ${n.id}`);return j(["load","abort","unload","serialize","prepare"],n),n};function jw(t,e){const i=mu.identity([]);return mu.scale(i,i,[.5*t.width,.5*-t.height,1]),mu.translate(i,i,[1,-1,0]),mu.multiply(i,i,t.calculateProjMatrix(e.toUnwrapped())),Float32Array.from(i)}function Gw(t,e,i,r,n,o,s,a=!1){const l=t.tilesIn(r,s,a);l.sort(Zw);const c=[];for(const r of l)c.push({wrappedTileID:r.tile.tileID.wrapped().key,queryResults:r.tile.queryRenderedFeatures(e,i,t._state,r,n,o,jw(t.transform,r.tile.tileID),a)});const h=function(t){const e={},i={};for(const r of t){const t=r.queryResults,n=r.wrappedTileID,o=i[n]=i[n]||{};for(const i in t){const r=t[i],n=o[i]=o[i]||{},s=e[i]=e[i]||[];for(const t of r)n[t.featureIndex]||(n[t.featureIndex]=!0,s.push(t));}}return e}(c);for(const e in h)h[e].forEach((e=>{const i=e.feature,r=i.layer;r&&"background"!==r.type&&"sky"!==r.type&&"slot"!==r.type&&(i.source=r.source,r["source-layer"]&&(i.sourceLayer=r["source-layer"]),i.state=void 0!==i.id?t.getFeatureState(r["source-layer"],i.id):{});}));return h}function qw(t,e){const i=t.getRenderableIds().map((e=>t.getTileByID(e))),r=[],n={};for(let t=0;t<i.length;t++){const o=i[t],s=o.tileID.canonical.key;n[s]||(n[s]=!0,o.querySourceFeatures(r,e));}return r}function Zw(t,e){const i=t.tileID,r=e.tileID;return i.overscaledZ-r.overscaledZ||i.canonical.y-r.canonical.y||i.wrap-r.wrap||i.canonical.x-r.canonical.x}class $w{constructor(t){this.style=t;}processLayersChanged(){this.layers=[];for(const t in this.style._layers){const e=this.style._layers[t];if("fill-extrusion"===e.type)this.layers.push(e);else if("model"===e.type){const t=this.style.getSource(e.source);t&&"batched-model"===t.type&&this.layers.push(e);}}}updateZOffset(t,e){this.currentBuildingBuckets=[];for(let t=0;t<this.layers.length;++t){const i=this.layers[t],r=this.style._getSourceCache(i.source);let n=r?r.getTile(e):null;if(!n&&r&&e.canonical.z>r.getSource().minzoom){let t=e.scaledTo(Math.min(r.getSource().maxzoom,e.overscaledZ-1));for(;t.overscaledZ>=r.getSource().minzoom&&(n=r.getTile(t),!n&&0!==t.overscaledZ);)t=t.scaledTo(t.overscaledZ-1);}this.currentBuildingBuckets.push({bucket:n?n.getBucket(i):null,tileID:n?n.tileID:e});}t.hasAnyZOffset=!1;let i=!1;for(let r=0;r<t.symbolInstances.length;r++){const n=t.symbolInstances.get(r),o=n.zOffset;n.zOffset=this._getHeightAtTileOffset(e,n.tileAnchorX,n.tileAnchorY),i||o===n.zOffset||(i=!0),t.hasAnyZOffset||0===n.zOffset||(t.hasAnyZOffset=!0);}i&&(t.zOffsetBuffersNeedUpload=!0,t.zOffsetSortDirty=!0);}_mapCoordToOverlappingTile(t,e,i,r){let n=e,o=i;if(t.canonical.z!==r.canonical.z){const s=r.canonical,a=1/(1<<t.canonical.z-s.z);n=(e+t.canonical.x*sr)*a-s.x*sr|0,o=(i+t.canonical.y*sr)*a-s.y*sr|0;}return {tileX:n,tileY:o}}_getHeightAtTileOffset(t,e,i){let r;for(let n=0;n<this.layers.length;++n){const o=this.layers[n];if("fill-extrusion"!==o.type)continue;const{bucket:s,tileID:a}=this.currentBuildingBuckets[n];if(!s)continue;const{tileX:l,tileY:c}=this._mapCoordToOverlappingTile(t,e,i,a),h=s.getHeightAtTileCoord(l,c);if(!h||void 0===h.height)continue;if(h.hidden){r=h.height;continue}const u=o.paint.get("fill-extrusion-vertical-scale");return h.height*u}for(let n=0;n<this.layers.length;++n){if("model"!==this.layers[n].type)continue;const{bucket:o,tileID:s}=this.currentBuildingBuckets[n];if(!o)continue;const{tileX:a,tileY:l}=this._mapCoordToOverlappingTile(t,e,i,s),c=o.getHeightAtTileCoord(a,l);if(c&&!c.hidden)return void 0===c.height&&void 0!==r?r*c.verticalScale:(c.height||0)*c.verticalScale}return 0}}var Hw=["type","source","source-layer","minzoom","maxzoom","filter","layout"];function Ww(t,e){const i={};for(const e in t)"ref"!==e&&(i[e]=t[e]);return Hw.forEach((t=>{t in e&&(i[t]=e[t]);})),i}function Xw(t){t=t.slice();const e=Object.create(null);for(let i=0;i<t.length;i++)e[t[i].id]=t[i];for(let i=0;i<t.length;i++)"ref"in t[i]&&(t[i]=Ww(t[i],e[t[i].ref]));return t}const Yw={setStyle:"setStyle",addLayer:"addLayer",removeLayer:"removeLayer",setPaintProperty:"setPaintProperty",setLayoutProperty:"setLayoutProperty",setFilter:"setFilter",addSource:"addSource",removeSource:"removeSource",setGeoJSONSourceData:"setGeoJSONSourceData",setLayerZoomRange:"setLayerZoomRange",setLayerProperty:"setLayerProperty",setCenter:"setCenter",setZoom:"setZoom",setBearing:"setBearing",setPitch:"setPitch",setSprite:"setSprite",setGlyphs:"setGlyphs",setTransition:"setTransition",setLight:"setLight",setTerrain:"setTerrain",setFog:"setFog",setCamera:"setCamera",setLights:"setLights",setProjection:"setProjection",addImport:"addImport",removeImport:"removeImport"};function Kw(t,e,i){i.push({command:Yw.addSource,args:[t,e[t]]});}function Jw(t,e,i){e.push({command:Yw.removeSource,args:[t]}),i[t]=!0;}function Qw(t,e,i,r){Jw(t,i,r),Kw(t,e,i);}function tT(t,e,i){let r;for(r in t[i])if(t[i].hasOwnProperty(r)&&"data"!==r&&!x(t[i][r],e[i][r]))return !1;for(r in e[i])if(e[i].hasOwnProperty(r)&&"data"!==r&&!x(t[i][r],e[i][r]))return !1;return !0}function eT(t,e,i,r,n,o){let s;for(s in e=e||{},t=t||{})t.hasOwnProperty(s)&&(x(t[s],e[s])||i.push({command:o,args:[r,s,e[s],n]}));for(s in e)e.hasOwnProperty(s)&&!t.hasOwnProperty(s)&&(x(t[s],e[s])||i.push({command:o,args:[r,s,e[s],n]}));}function iT(t){return t.id}function rT(t,e){return t[e.id]=e,t}class nT{constructor(t,e){this.reset(t,e);}reset(t,e){this.points=t||[],this._distances=[0];for(let t=1;t<this.points.length;t++)this._distances[t]=this._distances[t-1]+this.points[t].dist(this.points[t-1]);this.length=this._distances[this._distances.length-1],this.padding=Math.min(e||0,.5*this.length),this.paddedLength=this.length-2*this.padding;}lerp(t){if(1===this.points.length)return this.points[0];t=z(t,0,1);let e=1,i=this._distances[e];const r=t*this.paddedLength+this.padding;for(;i<r&&e<this._distances.length;)i=this._distances[++e];const n=e-1,o=this._distances[n],s=i-o,a=s>0?(r-o)/s:0;return this.points[n].mult(1-a).add(this.points[e].mult(a))}}class oT{constructor(t,e,i){const r=this.boxCells=[],n=this.circleCells=[];this.xCellCount=Math.ceil(t/i),this.yCellCount=Math.ceil(e/i);for(let t=0;t<this.xCellCount*this.yCellCount;t++)r.push([]),n.push([]);this.circleKeys=[],this.boxKeys=[],this.bboxes=[],this.circles=[],this.width=t,this.height=e,this.xScale=this.xCellCount/t,this.yScale=this.yCellCount/e,this.boxUid=0,this.circleUid=0;}keysLength(){return this.boxKeys.length+this.circleKeys.length}insert(t,e,i,r,n){this._forEachCell(e,i,r,n,this._insertBoxCell,this.boxUid++),this.boxKeys.push(t),this.bboxes.push(e),this.bboxes.push(i),this.bboxes.push(r),this.bboxes.push(n);}insertCircle(t,e,i,r){this._forEachCell(e-r,i-r,e+r,i+r,this._insertCircleCell,this.circleUid++),this.circleKeys.push(t),this.circles.push(e),this.circles.push(i),this.circles.push(r);}_insertBoxCell(t,e,i,r,n,o){this.boxCells[n].push(o);}_insertCircleCell(t,e,i,r,n,o){this.circleCells[n].push(o);}_query(t,e,i,r,n,o){if(i<0||t>this.width||r<0||e>this.height)return !n&&[];const s=[];if(t<=0&&e<=0&&this.width<=i&&this.height<=r){if(n)return !0;for(let t=0;t<this.boxKeys.length;t++)s.push({key:this.boxKeys[t],x1:this.bboxes[4*t],y1:this.bboxes[4*t+1],x2:this.bboxes[4*t+2],y2:this.bboxes[4*t+3]});for(let t=0;t<this.circleKeys.length;t++){const e=this.circles[3*t],i=this.circles[3*t+1],r=this.circles[3*t+2];s.push({key:this.circleKeys[t],x1:e-r,y1:i-r,x2:e+r,y2:i+r});}return o?s.filter(o):s}return this._forEachCell(t,e,i,r,this._queryCell,s,{hitTest:n,seenUids:{box:{},circle:{}}},o),n?s.length>0:s}_queryCircle(t,e,i,r,n){const o=t-i,s=t+i,a=e-i,l=e+i;if(s<0||o>this.width||l<0||a>this.height)return !r&&[];const c=[];return this._forEachCell(o,a,s,l,this._queryCellCircle,c,{hitTest:r,circle:{x:t,y:e,radius:i},seenUids:{box:{},circle:{}}},n),r?c.length>0:c}query(t,e,i,r,n){return this._query(t,e,i,r,!1,n)}hitTest(t,e,i,r,n){return this._query(t,e,i,r,!0,n)}hitTestCircle(t,e,i,r){return this._queryCircle(t,e,i,!0,r)}_queryCell(t,e,i,r,n,o,s,a){const l=s.seenUids,c=this.boxCells[n];if(null!==c){const n=this.bboxes;for(const h of c)if(!l.box[h]){l.box[h]=!0;const c=4*h;if(t<=n[c+2]&&e<=n[c+3]&&i>=n[c+0]&&r>=n[c+1]&&(!a||a(this.boxKeys[h]))){if(s.hitTest)return o.push(!0),!0;o.push({key:this.boxKeys[h],x1:n[c],y1:n[c+1],x2:n[c+2],y2:n[c+3]});}}}const h=this.circleCells[n];if(null!==h){const n=this.circles;for(const c of h)if(!l.circle[c]){l.circle[c]=!0;const h=3*c;if(this._circleAndRectCollide(n[h],n[h+1],n[h+2],t,e,i,r)&&(!a||a(this.circleKeys[c]))){if(s.hitTest)return o.push(!0),!0;{const t=n[h],e=n[h+1],i=n[h+2];o.push({key:this.circleKeys[c],x1:t-i,y1:e-i,x2:t+i,y2:e+i});}}}}}_queryCellCircle(t,e,i,r,n,o,s,a){const l=s.circle,c=s.seenUids,h=this.boxCells[n];if(null!==h){const t=this.bboxes;for(const e of h)if(!c.box[e]){c.box[e]=!0;const i=4*e;if(this._circleAndRectCollide(l.x,l.y,l.radius,t[i+0],t[i+1],t[i+2],t[i+3])&&(!a||a(this.boxKeys[e])))return o.push(!0),!0}}const u=this.circleCells[n];if(null!==u){const t=this.circles;for(const e of u)if(!c.circle[e]){c.circle[e]=!0;const i=3*e;if(this._circlesCollide(t[i],t[i+1],t[i+2],l.x,l.y,l.radius)&&(!a||a(this.circleKeys[e])))return o.push(!0),!0}}}_forEachCell(t,e,i,r,n,o,s,a){const l=this._convertToXCellCoord(t),c=this._convertToYCellCoord(e),h=this._convertToXCellCoord(i),u=this._convertToYCellCoord(r);for(let d=l;d<=h;d++)for(let l=c;l<=u;l++)if(n.call(this,t,e,i,r,this.xCellCount*l+d,o,s,a))return}_convertToXCellCoord(t){return Math.max(0,Math.min(this.xCellCount-1,Math.floor(t*this.xScale)))}_convertToYCellCoord(t){return Math.max(0,Math.min(this.yCellCount-1,Math.floor(t*this.yScale)))}_circlesCollide(t,e,i,r,n,o){const s=r-t,a=n-e,l=i+o;return l*l>s*s+a*a}_circleAndRectCollide(t,e,i,r,n,o,s){const a=(o-r)/2,l=Math.abs(t-(r+a));if(l>a+i)return !1;const c=(s-n)/2,h=Math.abs(e-(n+c));if(h>c+i)return !1;if(l<=a||h<=c)return !0;const u=l-a,d=h-c;return u*u+d*d<=i*i}}const sT=100;class aT{constructor(t,e,i=new oT(t.width+200,t.height+200,25),r=new oT(t.width+200,t.height+200,25)){this.transform=t,this.grid=i,this.ignoredGrid=r,this.pitchfactor=Math.cos(t._pitch)*t.cameraToCenterDistance,this.screenRightBoundary=t.width+sT,this.screenBottomBoundary=t.height+sT,this.gridRightBoundary=t.width+200,this.gridBottomBoundary=t.height+200,this.fogState=e;}placeCollisionBox(t,e,i,r,n,o,s,a){let l=i.projectedAnchorX,c=i.projectedAnchorY,h=i.projectedAnchorZ;const u=i.elevation,d=i.tileID,p=t.getProjection();if(u&&d){const[t,e,r]=p.upVector(d.canonical,i.tileAnchorX,i.tileAnchorY),n=p.upVectorScale(d.canonical,this.transform.center.lat,this.transform.worldSize).metersToTile;l+=t*u*n,c+=e*u*n,h+=r*u*n;}const f=this.projectAndGetPerspectiveRatio(s,l,c,h,i.tileID,"globe"===p.name||!!u||this.transform.pitch>0,p),m=o*f.perspectiveRatio,_=(i.x1*e+r.x-i.padding)*m+f.point.x,g=(i.y1*e+r.y-i.padding)*m+f.point.y,y=(i.x2*e+r.x+i.padding)*m+f.point.x,x=(i.y2*e+r.y+i.padding)*m+f.point.y,v=f.perspectiveRatio<=.55||f.occluded;return !this.isInsideGrid(_,g,y,x)||!n&&this.grid.hitTest(_,g,y,x,a)||v?{box:[],offscreen:!1,occluded:f.occluded}:{box:[_,g,y,x],offscreen:this.isOffscreen(_,g,y,x),occluded:!1}}placeCollisionCircles(t,e,i,r,n,o,s,a,l,c,h,u,d,p,f){const m=[],_=this.transform.elevation,g=t.getProjection(),x=_?_.getAtTileOffsetFunc(f,this.transform.center.lat,this.transform.worldSize,g):null,v=new y(i.tileAnchorX,i.tileAnchorY);let{x:b,y:w,z:T}=g.projectTilePoint(v.x,v.y,f.canonical);if(x){const[t,e,i]=x(v);b+=t,w+=e,T+=i;}const E="globe"===g.name,M=this.projectAndGetPerspectiveRatio(s,b,w,T,f,E||!!_||this.transform.pitch>0,g),{perspectiveRatio:A}=M,S=(h?o/A:o*A)/Ym,I=Hx(b,w,T,a),C=M.signedDistanceFromCamera>0?Kx(S,n,i.lineOffsetX*S,i.lineOffsetY*S,!1,I,v,i,r,a,{},_&&!h?x:null,h&&!!_,g,f,h):null;let z=!1,D=!1,P=!0;if(C&&!M.occluded){const t=.5*d*A+p,i=new y(-100,-100),r=new y(this.screenRightBoundary,this.screenBottomBoundary),n=new nT,{first:o,last:s}=C,a=o.path.length;let h=[];for(let t=a-1;t>=1;t--)h.push(o.path[t]);for(let t=1;t<s.path.length;t++)h.push(s.path[t]);const f=2.5*t;l&&(h=h.map((([t,e,i],r)=>(x&&!E&&(i=x(r<a-1?o.tilePath[a-1-r]:s.tilePath[r-a+2])[2]),Hx(t,e,i,l)))),h.some((t=>t[3]<=0))&&(h=[]));let _=[];if(h.length>0){let t=1/0,e=-1/0,n=1/0,o=-1/0;for(const i of h)t=Math.min(t,i[0]),n=Math.min(n,i[1]),e=Math.max(e,i[0]),o=Math.max(o,i[1]);e>=i.x&&t<=r.x&&o>=i.y&&n<=r.y&&(_=[h.map((t=>new y(t[0],t[1])))],(t<i.x||e>r.x||n<i.y||o>r.y)&&(_=N_(_,i.x,i.y,r.x,r.y)));}for(const i of _){n.reset(i,.25*t);let r=0;r=n.length<=.5*t?1:Math.ceil(n.paddedLength/f)+1;for(let i=0;i<r;i++){const o=i/Math.max(r-1,1),s=n.lerp(o),a=s.x+sT,l=s.y+sT;m.push(a,l,t,0);const h=a-t,d=l-t,p=a+t,f=l+t;if(P=P&&this.isOffscreen(h,d,p,f),D=D||this.isInsideGrid(h,d,p,f),!e&&this.grid.hitTestCircle(a,l,t,u)&&(z=!0,!c))return {circles:[],offscreen:!1,collisionDetected:z,occluded:!1}}}}return {circles:!c&&z||!D?[]:m,offscreen:P,collisionDetected:z,occluded:M.occluded}}queryRenderedSymbols(t){if(0===t.length||0===this.grid.keysLength()&&0===this.ignoredGrid.keysLength())return {};const e=[];let i=1/0,r=1/0,n=-1/0,o=-1/0;for(const s of t){const t=new y(s.x+sT,s.y+sT);i=Math.min(i,t.x),r=Math.min(r,t.y),n=Math.max(n,t.x),o=Math.max(o,t.y),e.push(t);}const s=this.grid.query(i,r,n,o).concat(this.ignoredGrid.query(i,r,n,o)),a={},l={};for(const t of s){const i=t.key;void 0===a[i.bucketInstanceId]&&(a[i.bucketInstanceId]={}),a[i.bucketInstanceId][i.featureIndex]||cp(e,[new y(t.x1,t.y1),new y(t.x2,t.y1),new y(t.x2,t.y2),new y(t.x1,t.y2)])&&(a[i.bucketInstanceId][i.featureIndex]=!0,void 0===l[i.bucketInstanceId]&&(l[i.bucketInstanceId]=[]),l[i.bucketInstanceId].push(i.featureIndex));}return l}insertCollisionBox(t,e,i,r,n){(e?this.ignoredGrid:this.grid).insert({bucketInstanceId:i,featureIndex:r,collisionGroupID:n},t[0],t[1],t[2],t[3]);}insertCollisionCircles(t,e,i,r,n){const o=e?this.ignoredGrid:this.grid,s={bucketInstanceId:i,featureIndex:r,collisionGroupID:n};for(let e=0;e<t.length;e+=4)o.insertCircle(s,t[e],t[e+1],t[e+2]);}projectAndGetPerspectiveRatio(t,e,i,r,n,o,s){const a=[e,i,r,1];let l=!1;if(r||this.transform.pitch>0){if(au.transformMat4(a,a,t),this.fogState&&n&&"globe"!==s.name){const t=function(t,e,i,r,n,o){const s=o.calculateFogTileMatrix(n),a=[e,i,r];return bu.transformMat4(a,a,s),Fb(t,a,o.pitch,o._fov)}(this.fogState,e,i,r,n.toUnwrapped(),this.transform);l=t>.9;}}else nv(a,a,t);const c=a[3];return {point:new y((a[0]/c+1)/2*this.transform.width+sT,(-a[1]/c+1)/2*this.transform.height+sT),perspectiveRatio:Math.min(.5+this.transform.getCameraToCenterDistance(s)/c*.5,1.5),signedDistanceFromCamera:c,occluded:o&&a[2]>c||l}}isOffscreen(t,e,i,r){return i<sT||t>=this.screenRightBoundary||r<sT||e>this.screenBottomBoundary}isInsideGrid(t,e,i,r){return i>=0&&t<this.gridRightBoundary&&r>=0&&e<this.gridBottomBoundary}getViewportMatrix(){const t=mu.identity([]);return mu.translate(t,t,[-100,-100,0]),t}}function lT(t,e,i){const r=e.createTileMatrix(t,t.worldSize,i.toUnwrapped());return mu.multiply(new Float32Array(16),t.projMatrix,r)}function cT(t,e,i){if(e.projection.name===i.projection.name)return t.projMatrix;const r=i.clone();return r.setProjection(e.projection),lT(r,e.getProjection(),t)}function hT(t,e,i){return e.name===i.projection.name?t.projMatrix:lT(i,e,t)}class uT{constructor(t,e,i,r){this.opacity=t?Math.max(0,Math.min(1,t.opacity+(t.placed?e:-e))):r&&i?1:0,this.placed=i;}isHidden(){return 0===this.opacity&&!this.placed}}class dT{constructor(t,e,i,r,n,o=!1){this.text=new uT(t?t.text:null,e,i,n),this.icon=new uT(t?t.icon:null,e,r,n),this.clipped=o;}isHidden(){return this.text.isHidden()&&this.icon.isHidden()}}class pT{constructor(t,e,i,r=!1){this.text=t,this.icon=e,this.skipFade=i,this.clipped=r;}}class fT{constructor(){this.invProjMatrix=mu.create(),this.viewportMatrix=mu.create(),this.circles=[];}}class mT{constructor(t,e,i,r,n){this.bucketInstanceId=t,this.featureIndex=e,this.sourceLayerIndex=i,this.bucketIndex=r,this.tileID=n;}}class _T{constructor(t){this.crossSourceCollisions=t,this.maxGroupID=0,this.collisionGroups={};}get(t){if(this.crossSourceCollisions)return {ID:0,predicate:null};if(!this.collisionGroups[t]){const e=++this.maxGroupID;this.collisionGroups[t]={ID:e,predicate:t=>t.collisionGroupID===e};}return this.collisionGroups[t]}}function gT(t,e,i,r,n){const{horizontalAlign:o,verticalAlign:s}=S_(t),a=-(o-.5)*e,l=-(s-.5)*i,c=ng(t,r);return new y(a+c[0]*n,l+c[1]*n)}function yT(t,e,i,r,n){const o=new y(t,e);return i&&o._rotate(r?n:-n),o}class xT{constructor(t,e,i,r,n,o){this.transform=t.clone(),this.projection=t.projection.name,this.collisionIndex=new aT(this.transform,n),this.buildingIndex=o,this.placements={},this.opacities={},this.variableOffsets={},this.stale=!1,this.commitTime=0,this.fadeDuration=e,this.retainedQueryData={},this.collisionGroups=new _T(i),this.collisionCircleArrays={},this.prevPlacement=r,r&&(r.prevPlacement=void 0),this.placedOrientations={};}getBucketParts(t,e,i,r){const n=i.getBucket(e),o=i.latestFeatureIndex;if(!n||!o||e.id!==n.layerIds[0])return;const s=n.layers[0].layout,a=i.collisionBoxArray,l=Math.pow(2,this.transform.zoom-i.tileID.overscaledZ),c=i.tileSize/sr,h=i.tileID.toUnwrapped();this.transform.setProjection(n.projection);const u=(d=i.tileID,p=n.getProjection(),f=this.transform,p.name===this.projection?f.calculateProjMatrix(d.toUnwrapped()):lT(f,p,d));var d,p,f;const m="map"===s.get("text-pitch-alignment"),_="map"===s.get("text-rotation-alignment");e.compileFilter();const g=e.dynamicFilter(),y=e.dynamicFilterNeedsFeature(),x=this.transform.calculatePixelsToTileUnitsMatrix(i),v=Zx(u,i.tileID.canonical,m,_,this.transform,n.getProjection(),x);let b=null;if(m){const t=$x(u,i.tileID.canonical,m,_,this.transform,n.getProjection(),x);b=mu.multiply([],this.transform.labelPlaneMatrix,t);}let w=null;g&&i.latestFeatureIndex&&(w={unwrappedTileID:h,dynamicFilter:g,dynamicFilterNeedsFeature:y,featureIndex:i.latestFeatureIndex}),this.retainedQueryData[n.bucketInstanceId]=new mT(n.bucketInstanceId,o,n.sourceLayerIndex,n.index,i.tileID);const T={bucket:n,layout:s,posMatrix:u,textLabelPlaneMatrix:v,labelToScreenMatrix:b,clippingData:w,scale:l,textPixelRatio:c,holdingForFade:i.holdingForFade(),collisionBoxArray:a,partiallyEvaluatedTextSize:t_(n.textSizeData,this.transform.zoom),partiallyEvaluatedIconSize:t_(n.iconSizeData,this.transform.zoom),collisionGroup:this.collisionGroups.get(n.sourceID)};if(r)for(const e of n.sortKeyRanges){const{sortKey:i,symbolInstanceStart:r,symbolInstanceEnd:n}=e;t.push({sortKey:i,symbolInstanceStart:r,symbolInstanceEnd:n,parameters:T});}else t.push({symbolInstanceStart:0,symbolInstanceEnd:n.symbolInstances.length,parameters:T});}attemptAnchorPlacement(t,e,i,r,n,o,s,a,l,c,h,u,d,p,f,m,_,g){const{textOffset0:y,textOffset1:x,crossTileID:v}=u,b=[y,x],w=gT(t,i,r,b,n),T=this.collisionIndex.placeCollisionBox(p,n,e,yT(w.x,w.y,o,s,this.transform.angle),h,a,l,c.predicate);if(m){const t=p.getSymbolInstanceIconSize(g,this.transform.zoom,u.placedIconSymbolIndex);if(0===this.collisionIndex.placeCollisionBox(p,t,m,yT(w.x,w.y,o,s,this.transform.angle),h,a,l,c.predicate).box.length)return}if(T.box.length>0){let e;return this.prevPlacement&&this.prevPlacement.variableOffsets[v]&&this.prevPlacement.placements[v]&&this.prevPlacement.placements[v].text&&(e=this.prevPlacement.variableOffsets[v].anchor),this.variableOffsets[v]={textOffset:b,width:i,height:r,anchor:t,textScale:n,prevAnchor:e},this.markUsedJustification(p,t,u,f),p.allowVerticalPlacement&&(this.markUsedOrientation(p,f,u),this.placedOrientations[v]=f),{shift:w,placedGlyphBoxes:T}}}placeLayerBucketPart(t,e,i,r){const{bucket:n,layout:o,posMatrix:s,textLabelPlaneMatrix:a,labelToScreenMatrix:l,clippingData:c,textPixelRatio:h,holdingForFade:u,collisionBoxArray:d,partiallyEvaluatedTextSize:p,partiallyEvaluatedIconSize:f,collisionGroup:m}=t.parameters,_=o.get("text-optional"),g=o.get("icon-optional"),x=o.get("text-allow-overlap"),v=o.get("icon-allow-overlap"),b="map"===o.get("text-rotation-alignment"),w="map"===o.get("text-pitch-alignment"),T="viewport-y"===o.get("symbol-z-order"),E=o.get("symbol-z-elevate");this.transform.setProjection(n.projection);let M=x&&(v||!n.hasIconData()||g),A=v&&(x||!n.hasTextData()||_);!n.collisionArrays&&d&&n.deserializeCollisionBoxes(d),i&&r&&n.updateCollisionDebugBuffers(this.transform.zoom,d);const S=(t,r,d)=>{const{crossTileID:T,numVerticalGlyphVertices:E}=t;if(c){const i={zoom:this.transform.zoom,pitch:this.transform.pitch};let r=null;if(c.dynamicFilterNeedsFeature){const e=this.retainedQueryData[n.bucketInstanceId];r=c.featureIndex.loadFeature({featureIndex:t.featureIndex,bucketIndex:e.bucketIndex,sourceLayerIndex:e.sourceLayerIndex,layoutVertexArrayOffset:0});}if(!(0,c.dynamicFilter)(i,r,this.retainedQueryData[n.bucketInstanceId].tileID.canonical,new y(t.tileAnchorX,t.tileAnchorY),this.transform.calculateDistanceTileData(c.unwrappedTileID)))return this.placements[T]=new pT(!1,!1,!1,!0),void e.add(T)}if(e.has(T))return;if(u)return void(this.placements[T]=new pT(!1,!1,!1));let S=!1,I=!1,C=!0,z=!1,D=!1,P=null,R={box:null,offscreen:null,occluded:null},L={box:null,offscreen:null,occluded:null},k=null,B=null,O=null,F=0,N=0,U=0;d.textFeatureIndex?F=d.textFeatureIndex:t.useRuntimeCollisionCircles&&(F=t.featureIndex),d.verticalTextFeatureIndex&&(N=d.verticalTextFeatureIndex);const V=e=>{e.tileID=this.retainedQueryData[n.bucketInstanceId].tileID;const i=this.transform.elevation;e.elevation=t.zOffset+(i?i.getAtTileOffset(e.tileID,e.tileAnchorX,e.tileAnchorY):0);},j=d.textBox;if(j){V(j);const e=e=>{let i=m_.horizontal;if(n.allowVerticalPlacement&&!e&&this.prevPlacement){const e=this.prevPlacement.placedOrientations[T];e&&(this.placedOrientations[T]=e,i=e,this.markUsedOrientation(n,i,t));}return i},i=(t,e)=>{if(n.allowVerticalPlacement&&E>0&&d.verticalTextBox){for(const i of n.writingModes)if(i===m_.vertical?(R=e(),L=R):R=t(),R&&R.box&&R.box.length)break}else R=t();};if(o.get("text-variable-anchor")){let a=o.get("text-variable-anchor");if(this.prevPlacement&&this.prevPlacement.variableOffsets[T]){const t=this.prevPlacement.variableOffsets[T];a.indexOf(t.anchor)>0&&(a=a.filter((e=>e!==t.anchor)),a.unshift(t.anchor));}const l=(e,i,o)=>{const l=n.getSymbolInstanceTextSize(p,t,this.transform.zoom,r),c=(e.x2-e.x1)*l+2*e.padding,u=(e.y2-e.y1)*l+2*e.padding,d=t.hasIconTextFit&&!v?i:null;d&&V(d);let _={box:[],offscreen:!1,occluded:!1};const g=x?2*a.length:a.length;for(let i=0;i<g;++i){const g=this.attemptAnchorPlacement(a[i%a.length],e,c,u,l,b,w,h,s,m,i>=a.length,t,r,n,o,d,p,f);if(g&&(_=g.placedGlyphBoxes,_&&_.box&&_.box.length)){S=!0,P=g.shift;break}}return _};i((()=>l(j,d.iconBox,m_.horizontal)),(()=>{const t=d.verticalTextBox;return t&&V(t),n.allowVerticalPlacement&&!(R&&R.box&&R.box.length)&&E>0&&t?l(t,d.verticalIconBox,m_.vertical):{box:null,offscreen:null,occluded:null}})),R&&(S=R.box,C=R.offscreen,z=R.occluded);const c=e(!(!R||!R.box));if(!S&&this.prevPlacement){const e=this.prevPlacement.variableOffsets[T];e&&(this.variableOffsets[T]=e,this.markUsedJustification(n,e.anchor,t,c));}}else {const o=(e,i)=>{const o=n.getSymbolInstanceTextSize(p,t,this.transform.zoom,r),a=this.collisionIndex.placeCollisionBox(n,o,e,new y(0,0),x,h,s,m.predicate);return a&&a.box&&a.box.length&&(this.markUsedOrientation(n,i,t),this.placedOrientations[T]=i),a};i((()=>o(j,m_.horizontal)),(()=>{const t=d.verticalTextBox;return n.allowVerticalPlacement&&E>0&&t?(V(t),o(t,m_.vertical)):{box:null,offscreen:null,occluded:null}})),e(!!(R&&R.box&&R.box.length));}}if(k=R,S=k&&k.box&&k.box.length>0,C=k&&k.offscreen,z=k&&k.occluded,t.useRuntimeCollisionCircles){const e=n.text.placedSymbolArray.get(t.centerJustifiedTextSymbolIndex>=0?t.centerJustifiedTextSymbolIndex:t.verticalPlacedTextSymbolIndex),r=Qm(n.textSizeData,p,e),c=o.get("text-padding");B=this.collisionIndex.placeCollisionCircles(n,x,e,n.lineVertexArray,n.glyphOffsetArray,r,s,a,l,i,w,m.predicate,t.collisionCircleDiameter*r/Ym,c,this.retainedQueryData[n.bucketInstanceId].tileID),S=x||B.circles.length>0&&!B.collisionDetected,C=C&&B.offscreen,z=B.occluded;}if(d.iconFeatureIndex&&(U=d.iconFeatureIndex),d.iconBox){const e=e=>{V(e);const i=t.hasIconTextFit&&P?yT(P.x,P.y,b,w,this.transform.angle):new y(0,0),r=n.getSymbolInstanceIconSize(f,this.transform.zoom,t.placedIconSymbolIndex);return this.collisionIndex.placeCollisionBox(n,r,e,i,v,h,s,m.predicate)};L&&L.box&&L.box.length&&d.verticalIconBox?(O=e(d.verticalIconBox),I=O.box.length>0):(O=e(d.iconBox),I=O.box.length>0),C=C&&O.offscreen,D=O.occluded;}const G=_||0===t.numHorizontalGlyphVertices&&0===E,q=g||0===t.numIconVertices;if(G||q?q?G||(I=I&&S):S=I&&S:I=S=I&&S,S&&k&&k.box&&this.collisionIndex.insertCollisionBox(k.box,o.get("text-ignore-placement"),n.bucketInstanceId,L&&L.box&&N?N:F,m.ID),I&&O&&this.collisionIndex.insertCollisionBox(O.box,o.get("icon-ignore-placement"),n.bucketInstanceId,U,m.ID),B&&(S&&this.collisionIndex.insertCollisionCircles(B.circles,o.get("text-ignore-placement"),n.bucketInstanceId,F,m.ID),i)){const t=n.bucketInstanceId;let e=this.collisionCircleArrays[t];void 0===e&&(e=this.collisionCircleArrays[t]=new fT);for(let t=0;t<B.circles.length;t+=4)e.circles.push(B.circles[t+0]),e.circles.push(B.circles[t+1]),e.circles.push(B.circles[t+2]),e.circles.push(B.collisionDetected?1:0);}const Z="globe"!==n.projection.name;M=M&&(Z||!z),A=A&&(Z||!D),this.placements[T]=new pT(S||M,I||A,C||n.justReloaded),e.add(T);};if(E&&this.buildingIndex&&this.buildingIndex.updateZOffset(n,this.retainedQueryData[n.bucketInstanceId].tileID),T){const t=n.getSortedSymbolIndexes(this.transform.angle);for(let e=t.length-1;e>=0;--e){const i=t[e];S(n.symbolInstances.get(i),i,n.collisionArrays[i]);}n.hasAnyZOffset&&W(`${n.layerIds[0]} layer symbol-z-elevate: symbols are not sorted by elevation if symbol-z-order is evaluated to viewport-y`);}else if(n.hasAnyZOffset){const t=n.getSortedIndexesByZOffset();for(let e=0;e<t.length;++e){const i=t[e];S(n.symbolInstances.get(i),i,n.collisionArrays[i]);}}else for(let e=t.symbolInstanceStart;e<t.symbolInstanceEnd;e++)S(n.symbolInstances.get(e),e,n.collisionArrays[e]);if(i&&n.bucketInstanceId in this.collisionCircleArrays){const t=this.collisionCircleArrays[n.bucketInstanceId];mu.invert(t.invProjMatrix,s),t.viewportMatrix=this.collisionIndex.getViewportMatrix();}n.justReloaded=!1;}markUsedJustification(t,e,i,r){const{leftJustifiedTextSymbolIndex:n,centerJustifiedTextSymbolIndex:o,rightJustifiedTextSymbolIndex:s,verticalPlacedTextSymbolIndex:a,crossTileID:l}=i,c=sg(e),h=r===m_.vertical?a:"left"===c?n:"center"===c?o:"right"===c?s:-1;n>=0&&(t.text.placedSymbolArray.get(n).crossTileID=h>=0&&n!==h?0:l),o>=0&&(t.text.placedSymbolArray.get(o).crossTileID=h>=0&&o!==h?0:l),s>=0&&(t.text.placedSymbolArray.get(s).crossTileID=h>=0&&s!==h?0:l),a>=0&&(t.text.placedSymbolArray.get(a).crossTileID=h>=0&&a!==h?0:l);}markUsedOrientation(t,e,i){const r=e===m_.horizontal||e===m_.horizontalOnly?e:0,n=e===m_.vertical?e:0,{leftJustifiedTextSymbolIndex:o,centerJustifiedTextSymbolIndex:s,rightJustifiedTextSymbolIndex:a,verticalPlacedTextSymbolIndex:l}=i,c=t.text.placedSymbolArray;o>=0&&(c.get(o).placedOrientation=r),s>=0&&(c.get(s).placedOrientation=r),a>=0&&(c.get(a).placedOrientation=r),l>=0&&(c.get(l).placedOrientation=n);}commit(t){this.commitTime=t,this.zoomAtLastRecencyCheck=this.transform.zoom;const e=this.prevPlacement;let i=!1;this.prevZoomAdjustment=e?e.zoomAdjustment(this.transform.zoom):0;const r=e?e.symbolFadeChange(t):1,n=e?e.opacities:{},o=e?e.variableOffsets:{},s=e?e.placedOrientations:{};for(const t in this.placements){const e=this.placements[t],o=n[t];o?(this.opacities[t]=new dT(o,r,e.text,e.icon,null,e.clipped),i=i||e.text!==o.text.placed||e.icon!==o.icon.placed):(this.opacities[t]=new dT(null,r,e.text,e.icon,e.skipFade,e.clipped),i=i||e.text||e.icon);}for(const t in n){const e=n[t];if(!this.opacities[t]){const n=new dT(e,r,!1,!1);n.isHidden()||(this.opacities[t]=n,i=i||e.text.placed||e.icon.placed);}}for(const t in o)this.variableOffsets[t]||!this.opacities[t]||this.opacities[t].isHidden()||(this.variableOffsets[t]=o[t]);for(const t in s)this.placedOrientations[t]||!this.opacities[t]||this.opacities[t].isHidden()||(this.placedOrientations[t]=s[t]);i?this.lastPlacementChangeTime=t:"number"!=typeof this.lastPlacementChangeTime&&(this.lastPlacementChangeTime=e?e.lastPlacementChangeTime:t);}updateLayerOpacities(t,e){const i=new Set;for(const r of e){const e=r.getBucket(t);e&&r.latestFeatureIndex&&t.id===e.layerIds[0]&&this.updateBucketOpacities(e,i,r.collisionBoxArray);}}updateBucketOpacities(t,e,i){t.hasTextData()&&t.text.opacityVertexArray.clear(),t.hasIconData()&&t.icon.opacityVertexArray.clear(),t.hasIconCollisionBoxData()&&t.iconCollisionBox.collisionVertexArray.clear(),t.hasTextCollisionBoxData()&&t.textCollisionBox.collisionVertexArray.clear();const r=t.layers[0].layout,n=!!t.layers[0].dynamicFilter(),o=new dT(null,0,!1,!1,!0),s=r.get("text-allow-overlap"),a=r.get("icon-allow-overlap"),l=r.get("text-variable-anchor"),c="map"===r.get("text-rotation-alignment"),h="map"===r.get("text-pitch-alignment"),u=t.zOffsetBuffersNeedUpload;t.zOffsetBuffersNeedUpload=!1;let d=0,p=0;const f=new dT(null,0,s&&(a||!t.hasIconData()||r.get("icon-optional")),a&&(s||!t.hasTextData()||r.get("text-optional")),!0);!t.collisionArrays&&i&&(t.hasIconCollisionBoxData()||t.hasTextCollisionBoxData())&&t.deserializeCollisionBoxes(i);const m=(t,e,i)=>{for(let r=0;r<e/4;r++)t.opacityVertexArray.emplaceBack(i);},_=(t,e,i)=>{d+=e,d>t.length&&t.resize(d);for(let r=-e;r<0;r++)t.emplace(r+d,i);},g=(t,e,i)=>{p+=e,p>t.length&&t.resize(p);for(let r=-e;r<0;r++)t.emplace(r+p,i);};let x=0;for(let i=0;i<t.symbolInstances.length;i++){const r=t.symbolInstances.get(i),{numHorizontalGlyphVertices:s,numVerticalGlyphVertices:a,crossTileID:d,numIconVertices:p}=r,v=e.has(d);let b=this.opacities[d];v?b=o:b||(b=f,this.opacities[d]=b);const w=u?r.zOffset:0;e.add(d);const T=s>0||a>0,E=p>0,M=this.placedOrientations[d],A=M===m_.vertical,S=M===m_.horizontal||M===m_.horizontalOnly;if(!T&&!E||b.isHidden()||x++,T){const e=IT(b.text);m(t.text,s,A?CT:e),m(t.text,a,S?CT:e),u&&(_(t.text.zOffsetVertexArray,s,w),_(t.text.zOffsetVertexArray,a,w));const i=b.text.isHidden(),{leftJustifiedTextSymbolIndex:n,centerJustifiedTextSymbolIndex:o,rightJustifiedTextSymbolIndex:l,verticalPlacedTextSymbolIndex:c}=r,h=t.text.placedSymbolArray,p=i||A?1:0;n>=0&&(h.get(n).hidden=p),o>=0&&(h.get(o).hidden=p),l>=0&&(h.get(l).hidden=p),c>=0&&(h.get(c).hidden=i||S?1:0);const f=this.variableOffsets[d];f&&this.markUsedJustification(t,f.anchor,r,M);const g=this.placedOrientations[d];g&&(this.markUsedJustification(t,"left",r,g),this.markUsedOrientation(t,g,r));}if(E){const e=IT(b.icon),{placedIconSymbolIndex:i,verticalPlacedIconSymbolIndex:n}=r,o=t.icon.placedSymbolArray,s=b.icon.isHidden()?1:0;i>=0&&(m(t.icon,p,A?CT:e),o.get(i).hidden=s,u&&g(t.icon.zOffsetVertexArray,p,w)),n>=0&&(m(t.icon,r.numVerticalIconVertices,S?CT:e),o.get(n).hidden=s,u&&g(t.icon.zOffsetVertexArray,r.numVerticalIconVertices,w));}if(t.hasIconCollisionBoxData()||t.hasTextCollisionBoxData()){const e=t.collisionArrays[i];if(e){let i=new y(0,0),o=!0;if(e.textBox||e.verticalTextBox){if(l){const t=this.variableOffsets[d];t?(i=gT(t.anchor,t.width,t.height,t.textOffset,t.textScale),c&&i._rotate(h?this.transform.angle:-this.transform.angle)):o=!1;}n&&(o=!b.clipped),e.textBox&&vT(t.textCollisionBox.collisionVertexArray,b.text.placed,!o||A,i.x,i.y),e.verticalTextBox&&vT(t.textCollisionBox.collisionVertexArray,b.text.placed,!o||S,i.x,i.y);}const s=o&&Boolean(!S&&e.verticalIconBox);e.iconBox&&vT(t.iconCollisionBox.collisionVertexArray,b.icon.placed,s,r.hasIconTextFit?i.x:0,r.hasIconTextFit?i.y:0),e.verticalIconBox&&vT(t.iconCollisionBox.collisionVertexArray,b.icon.placed,!s,r.hasIconTextFit?i.x:0,r.hasIconTextFit?i.y:0);}}}if(t.fullyClipped=0===x,t.sortFeatures(this.transform.angle),this.retainedQueryData[t.bucketInstanceId]&&(this.retainedQueryData[t.bucketInstanceId].featureSortOrder=t.featureSortOrder),t.hasTextData()&&t.text.opacityVertexBuffer&&t.text.opacityVertexBuffer.updateData(t.text.opacityVertexArray),t.hasIconData()&&t.icon.opacityVertexBuffer&&t.icon.opacityVertexBuffer.updateData(t.icon.opacityVertexArray),t.hasIconCollisionBoxData()&&t.iconCollisionBox.collisionVertexBuffer&&t.iconCollisionBox.collisionVertexBuffer.updateData(t.iconCollisionBox.collisionVertexArray),t.hasTextCollisionBoxData()&&t.textCollisionBox.collisionVertexBuffer&&t.textCollisionBox.collisionVertexBuffer.updateData(t.textCollisionBox.collisionVertexArray),u&&t.text.zOffsetVertexBuffer&&t.text.zOffsetVertexBuffer.updateData(t.text.zOffsetVertexArray),u&&t.icon.zOffsetVertexBuffer&&t.icon.zOffsetVertexBuffer.updateData(t.icon.zOffsetVertexArray),t.bucketInstanceId in this.collisionCircleArrays){const e=this.collisionCircleArrays[t.bucketInstanceId];t.placementInvProjMatrix=e.invProjMatrix,t.placementViewportMatrix=e.viewportMatrix,t.collisionCircleArray=e.circles,delete this.collisionCircleArrays[t.bucketInstanceId];}}symbolFadeChange(t){return 0===this.fadeDuration?1:(t-this.commitTime)/this.fadeDuration+this.prevZoomAdjustment}zoomAdjustment(t){return Math.max(0,(this.transform.zoom-t)/1.5)}hasTransitions(t){return this.stale||t-this.lastPlacementChangeTime<this.fadeDuration}stillRecent(t,e){const i=this.zoomAtLastRecencyCheck===e?1-this.zoomAdjustment(e):1;return this.zoomAtLastRecencyCheck=e,this.commitTime+this.fadeDuration*i>t}setStale(){this.stale=!0;}}function vT(t,e,i,r,n){t.emplaceBack(e?1:0,i?1:0,r||0,n||0),t.emplaceBack(e?1:0,i?1:0,r||0,n||0),t.emplaceBack(e?1:0,i?1:0,r||0,n||0),t.emplaceBack(e?1:0,i?1:0,r||0,n||0);}const bT=Math.pow(2,25),wT=Math.pow(2,24),TT=Math.pow(2,17),ET=Math.pow(2,16),MT=Math.pow(2,9),AT=Math.pow(2,8),ST=Math.pow(2,1);function IT(t){if(0===t.opacity&&!t.placed)return 0;if(1===t.opacity&&t.placed)return 4294967295;const e=t.placed?1:0,i=Math.floor(127*t.opacity);return i*bT+e*wT+i*TT+e*ET+i*MT+e*AT+i*ST+e}const CT=0;class zT{constructor(t){this._sortAcrossTiles="viewport-y"!==t.layout.get("symbol-z-order")&&void 0!==t.layout.get("symbol-sort-key").constantOr(1),this._currentTileIndex=0,this._currentPartIndex=0,this._seenCrossTileIDs=new Set,this._bucketParts=[];}continuePlacement(t,e,i,r,n){const o=this._bucketParts;for(;this._currentTileIndex<t.length;)if(e.getBucketParts(o,r,t[this._currentTileIndex],this._sortAcrossTiles),this._currentTileIndex++,n())return !0;for(this._sortAcrossTiles&&(this._sortAcrossTiles=!1,o.sort(((t,e)=>t.sortKey-e.sortKey)));this._currentPartIndex<o.length;){const t=o[this._currentPartIndex];if(e.placeLayerBucketPart(t,this._seenCrossTileIDs,i,0===t.symbolInstanceStart),this._currentPartIndex++,n())return !0}return !1}}class DT{constructor(t,e,i,r,n,o,s,a,l){this.placement=new xT(t,n,o,s,a,l),this._currentPlacementIndex=e.length-1,this._forceFullPlacement=i,this._showCollisionBoxes=r,this._done=!1;}isDone(){return this._done}continuePlacement(t,e,i,r){const n=ue.now(),o=()=>{const t=ue.now()-n;return !this._forceFullPlacement&&t>2};for(;this._currentPlacementIndex>=0;){const n=e[t[this._currentPlacementIndex]],s=this.placement.collisionIndex.transform.zoom;if("symbol"===n.type&&(!n.minzoom||n.minzoom<=s)&&(!n.maxzoom||n.maxzoom>s)){const t=n,e=t.layout.get("symbol-z-elevate");if(this._inProgressLayer||(this._inProgressLayer=new zT(t)),this._inProgressLayer.continuePlacement(e?r[n.source]:i[n.source],this.placement,this._showCollisionBoxes,n,o))return;delete this._inProgressLayer;}this._currentPlacementIndex--;}this._done=!0;}commit(t){return this.placement.commit(t),this.placement}}const PT=[Int8Array,Uint8Array,Uint8ClampedArray,Int16Array,Uint16Array,Int32Array,Uint32Array,Float32Array,Float64Array];class RT{static from(t){if(!(t instanceof ArrayBuffer))throw new Error("Data must be an instance of ArrayBuffer.");const[e,i]=new Uint8Array(t,0,2);if(219!==e)throw new Error("Data does not appear to be in a KDBush format.");const r=i>>4;if(1!==r)throw new Error(`Got v${r} data when expected v1.`);const n=PT[15&i];if(!n)throw new Error("Unrecognized array type.");const[o]=new Uint16Array(t,2,1),[s]=new Uint32Array(t,4,1);return new RT(s,o,n,t)}constructor(t,e=64,i=Float64Array,r){if(isNaN(t)||t<0)throw new Error(`Unpexpected numItems value: ${t}.`);this.numItems=+t,this.nodeSize=Math.min(Math.max(+e,2),65535),this.ArrayType=i,this.IndexArrayType=t<65536?Uint16Array:Uint32Array;const n=PT.indexOf(this.ArrayType),o=2*t*this.ArrayType.BYTES_PER_ELEMENT,s=t*this.IndexArrayType.BYTES_PER_ELEMENT,a=(8-s%8)%8;if(n<0)throw new Error(`Unexpected typed array class: ${i}.`);r&&r instanceof ArrayBuffer?(this.data=r,this.ids=new this.IndexArrayType(this.data,8,t),this.coords=new this.ArrayType(this.data,8+s+a,2*t),this._pos=2*t,this._finished=!0):(this.data=new ArrayBuffer(8+o+s+a),this.ids=new this.IndexArrayType(this.data,8,t),this.coords=new this.ArrayType(this.data,8+s+a,2*t),this._pos=0,this._finished=!1,new Uint8Array(this.data,0,2).set([219,16+n]),new Uint16Array(this.data,2,1)[0]=e,new Uint32Array(this.data,4,1)[0]=t);}add(t,e){const i=this._pos>>1;return this.ids[i]=i,this.coords[this._pos++]=t,this.coords[this._pos++]=e,i}finish(){const t=this._pos>>1;if(t!==this.numItems)throw new Error(`Added ${t} items when expected ${this.numItems}.`);return LT(this.ids,this.coords,this.nodeSize,0,this.numItems-1,0),this._finished=!0,this}range(t,e,i,r){if(!this._finished)throw new Error("Data not yet indexed - call index.finish().");const{ids:n,coords:o,nodeSize:s}=this,a=[0,n.length-1,0],l=[];for(;a.length;){const c=a.pop()||0,h=a.pop()||0,u=a.pop()||0;if(h-u<=s){for(let s=u;s<=h;s++){const a=o[2*s],c=o[2*s+1];a>=t&&a<=i&&c>=e&&c<=r&&l.push(n[s]);}continue}const d=u+h>>1,p=o[2*d],f=o[2*d+1];p>=t&&p<=i&&f>=e&&f<=r&&l.push(n[d]),(0===c?t<=p:e<=f)&&(a.push(u),a.push(d-1),a.push(1-c)),(0===c?i>=p:r>=f)&&(a.push(d+1),a.push(h),a.push(1-c));}return l}within(t,e,i){if(!this._finished)throw new Error("Data not yet indexed - call index.finish().");const{ids:r,coords:n,nodeSize:o}=this,s=[0,r.length-1,0],a=[],l=i*i;for(;s.length;){const c=s.pop()||0,h=s.pop()||0,u=s.pop()||0;if(h-u<=o){for(let i=u;i<=h;i++)FT(n[2*i],n[2*i+1],t,e)<=l&&a.push(r[i]);continue}const d=u+h>>1,p=n[2*d],f=n[2*d+1];FT(p,f,t,e)<=l&&a.push(r[d]),(0===c?t-i<=p:e-i<=f)&&(s.push(u),s.push(d-1),s.push(1-c)),(0===c?t+i>=p:e+i>=f)&&(s.push(d+1),s.push(h),s.push(1-c));}return a}}function LT(t,e,i,r,n,o){if(n-r<=i)return;const s=r+n>>1;kT(t,e,s,r,n,o),LT(t,e,i,r,s-1,1-o),LT(t,e,i,s+1,n,1-o);}function kT(t,e,i,r,n,o){for(;n>r;){if(n-r>600){const s=n-r+1,a=i-r+1,l=Math.log(s),c=.5*Math.exp(2*l/3),h=.5*Math.sqrt(l*c*(s-c)/s)*(a-s/2<0?-1:1);kT(t,e,i,Math.max(r,Math.floor(i-a*c/s+h)),Math.min(n,Math.floor(i+(s-a)*c/s+h)),o);}const s=e[2*i+o];let a=r,l=n;for(BT(t,e,r,i),e[2*n+o]>s&&BT(t,e,r,n);a<l;){for(BT(t,e,a,l),a++,l--;e[2*a+o]<s;)a++;for(;e[2*l+o]>s;)l--;}e[2*r+o]===s?BT(t,e,r,l):(l++,BT(t,e,l,n)),l<=i&&(r=l+1),i<=l&&(n=l-1);}}function BT(t,e,i,r){OT(t,i,r),OT(e,2*i,2*r),OT(e,2*i+1,2*r+1);}function OT(t,e,i){const r=t[e];t[e]=t[i],t[i]=r;}function FT(t,e,i,r){const n=t-i,o=e-r;return n*n+o*o}const NT=512/sr/2;class UT{constructor(t,e,i){this.tileID=t,this.bucketInstanceId=i,this.index=new RT(e.length,16,Int32Array),this.keys=[],this.crossTileIDs=[];const r=t.canonical.x*sr,n=t.canonical.y*sr;for(let t=0;t<e.length;t++){const{key:i,crossTileID:o,tileAnchorX:s,tileAnchorY:a}=e.get(t),l=Math.floor((r+s)*NT),c=Math.floor((n+a)*NT);this.index.add(l,c),this.keys.push(i),this.crossTileIDs.push(o);}this.index.finish();}findMatches(t,e,i){const r=this.tileID.canonical.z<e.canonical.z?1:Math.pow(2,this.tileID.canonical.z-e.canonical.z),n=NT/Math.pow(2,e.canonical.z-this.tileID.canonical.z),o=e.canonical.x*sr,s=e.canonical.y*sr;for(let e=0;e<t.length;e++){const a=t.get(e);if(a.crossTileID)continue;const{key:l,tileAnchorX:c,tileAnchorY:h}=a,u=Math.floor((o+c)*n),d=Math.floor((s+h)*n),p=this.index.range(u-r,d-r,u+r,d+r);for(const t of p){const e=this.crossTileIDs[t];if(this.keys[t]===l&&!i.has(e)){i.add(e),a.crossTileID=e;break}}}}}class VT{constructor(){this.maxCrossTileID=0;}generate(){return ++this.maxCrossTileID}}class jT{constructor(){this.indexes={},this.usedCrossTileIDs={},this.lng=0;}handleWrapJump(t){const e=Math.round((t-this.lng)/360);if(0!==e)for(const t in this.indexes){const i=this.indexes[t],r={};for(const t in i){const n=i[t];n.tileID=n.tileID.unwrapTo(n.tileID.wrap+e),r[n.tileID.key]=n;}this.indexes[t]=r;}this.lng=t;}addBucket(t,e,i){if(this.indexes[t.overscaledZ]&&this.indexes[t.overscaledZ][t.key]){if(this.indexes[t.overscaledZ][t.key].bucketInstanceId===e.bucketInstanceId)return !1;this.removeBucketCrossTileIDs(t.overscaledZ,this.indexes[t.overscaledZ][t.key]);}for(let t=0;t<e.symbolInstances.length;t++)e.symbolInstances.get(t).crossTileID=0;this.usedCrossTileIDs[t.overscaledZ]||(this.usedCrossTileIDs[t.overscaledZ]=new Set);const r=this.usedCrossTileIDs[t.overscaledZ];for(const i in this.indexes){const n=this.indexes[i];if(Number(i)>t.overscaledZ)for(const i in n){const o=n[i];o.tileID.isChildOf(t)&&o.findMatches(e.symbolInstances,t,r);}else {const o=n[t.scaledTo(Number(i)).key];o&&o.findMatches(e.symbolInstances,t,r);}}for(let t=0;t<e.symbolInstances.length;t++){const n=e.symbolInstances.get(t);n.crossTileID||(n.crossTileID=i.generate(),r.add(n.crossTileID));}return void 0===this.indexes[t.overscaledZ]&&(this.indexes[t.overscaledZ]={}),this.indexes[t.overscaledZ][t.key]=new UT(t,e.symbolInstances,e.bucketInstanceId),!0}removeBucketCrossTileIDs(t,e){for(const i of e.crossTileIDs)this.usedCrossTileIDs[t].delete(i);}removeStaleBuckets(t){let e=!1;for(const i in this.indexes){const r=this.indexes[i];for(const n in r)t[r[n].bucketInstanceId]||(this.removeBucketCrossTileIDs(i,r[n]),delete r[n],e=!0);}return e}}class GT{constructor(){this.layerIndexes={},this.crossTileIDs=new VT,this.maxBucketInstanceId=0,this.bucketsInCurrentPlacement={};}addLayer(t,e,i,r){let n=this.layerIndexes[t.id];void 0===n&&(n=this.layerIndexes[t.id]=new jT);let o=!1;const s={};"globe"!==r.name&&n.handleWrapJump(i);for(const i of e){const e=i.getBucket(t);e&&t.id===e.layerIds[0]&&(e.bucketInstanceId||(e.bucketInstanceId=++this.maxBucketInstanceId),n.addBucket(i.tileID,e,this.crossTileIDs)&&(o=!0),s[e.bucketInstanceId]=!0);}return n.removeStaleBuckets(s)&&(o=!0),o}pruneUnusedLayers(t){const e={};t.forEach((t=>{e[t]=!0;}));for(const t in this.layerIndexes)e[t]||delete this.layerIndexes[t];}}const qT="";function ZT(t,e){return e?`${t}${qT}${e}`:t}function $T(t){const e=t.indexOf(qT);return e>=0?t.slice(0,e):t}function HT(t){const e=t.indexOf(qT);return e>=0?t.slice(e+1):""}var WT="\n#define EPSILON 0.0000001\n#define PI 3.141592653589793\n#define EXTENT 8192.0\n#define HALF_PI PI/2.0\n#define QUARTER_PI PI/4.0\n#define RAD_TO_DEG 180.0/PI\n#define DEG_TO_RAD PI/180.0\n#define GLOBE_RADIUS EXTENT/PI/2.0\nvec3 linearTosRGB(vec3 color)\n{return pow(color,vec3(1./2.2));}vec3 sRGBToLinear(vec3 srgbIn)\n{return pow(srgbIn,vec3(2.2));}vec3 linearProduct(vec3 srgbIn,vec3 k)\n{return srgbIn*pow(k,vec3(1./2.2));}\n#if __VERSION__ >=300\n#define _HANDLE_WIREFRAME_DEPTH gl_FragDepth=gl_FragCoord.z-0.0001;\n#else\n#define _HANDLE_WIREFRAME_DEPTH\n#endif\n#ifdef DEBUG_WIREFRAME\n#define HANDLE_WIREFRAME_DEBUG \\\ngl_FragColor=vec4(0.7,0.0,0.0,0.7); \\\n_HANDLE_WIREFRAME_DEPTH;\n#else\n#define HANDLE_WIREFRAME_DEBUG\n#endif\n#ifdef RENDER_CUTOFF\nfloat cutoff_opacity(vec4 cutoff_params,float depth) {float near=cutoff_params.x;float far=cutoff_params.y;float cutoffStart=cutoff_params.z;float cutoffEnd=cutoff_params.w-0.0001;float linearDepth=(depth-near)/(far-near);return clamp((linearDepth-cutoffStart)/(cutoffEnd-cutoffStart),0.0,1.0);}\n#endif",XT="attribute highp vec3 a_pos_3f;uniform lowp mat4 u_matrix;varying highp vec3 v_uv;void main() {const mat3 half_neg_pi_around_x=mat3(1.0,0.0, 0.0,0.0,0.0,-1.0,0.0,1.0, 0.0);v_uv=half_neg_pi_around_x*a_pos_3f;vec4 pos=u_matrix*vec4(a_pos_3f,1.0);gl_Position=pos.xyww;}",YT="\n#define ELEVATION_SCALE 7.0\n#define ELEVATION_OFFSET 450.0\n#ifdef PROJECTION_GLOBE_VIEW\nuniform vec3 u_tile_tl_up;uniform vec3 u_tile_tr_up;uniform vec3 u_tile_br_up;uniform vec3 u_tile_bl_up;uniform float u_tile_up_scale;vec3 elevationVector(vec2 pos) {vec2 uv=pos/EXTENT;vec3 up=normalize(mix(\nmix(u_tile_tl_up,u_tile_tr_up,uv.xxx),mix(u_tile_bl_up,u_tile_br_up,uv.xxx),uv.yyy));return up*u_tile_up_scale;}\n#else\nvec3 elevationVector(vec2 pos) { return vec3(0,0,1); }\n#endif\nconst float skirtOffset=24575.0;vec3 decomposeToPosAndSkirt(vec2 posWithComposedSkirt)\n{float skirt=float(posWithComposedSkirt.x >=skirtOffset);vec2 pos=posWithComposedSkirt-vec2(skirt*skirtOffset,0.0);return vec3(pos,skirt);}\n#ifdef TERRAIN\n#ifdef TERRAIN_DEM_FLOAT_FORMAT\nuniform highp sampler2D u_dem;uniform highp sampler2D u_dem_prev;\n#else\nuniform highp sampler2D u_dem;uniform highp sampler2D u_dem_prev;\n#endif\nuniform vec4 u_dem_unpack;uniform vec2 u_dem_tl;uniform vec2 u_dem_tl_prev;uniform float u_dem_scale;uniform float u_dem_scale_prev;uniform float u_dem_size;uniform float u_dem_lerp;uniform float u_exaggeration;uniform float u_meter_to_dem;uniform mat4 u_label_plane_matrix_inv;uniform sampler2D u_depth;uniform vec2 u_depth_size_inv;vec4 tileUvToDemSample(vec2 uv,float dem_size,float dem_scale,vec2 dem_tl) {vec2 pos=dem_size*(uv*dem_scale+dem_tl)+1.0;vec2 f=fract(pos);return vec4((pos-f+0.5)/(dem_size+2.0),f);}float decodeElevation(vec4 v) {return dot(vec4(v.xyz*255.0,-1.0),u_dem_unpack);}float currentElevation(vec2 apos) {\n#ifdef TERRAIN_DEM_FLOAT_FORMAT\nvec2 pos=(u_dem_size*(apos/8192.0*u_dem_scale+u_dem_tl)+1.5)/(u_dem_size+2.0);return u_exaggeration*texture(u_dem,pos).r;\n#else\nfloat dd=1.0/(u_dem_size+2.0);vec4 r=tileUvToDemSample(apos/8192.0,u_dem_size,u_dem_scale,u_dem_tl);vec2 pos=r.xy;vec2 f=r.zw;float tl=decodeElevation(texture2D(u_dem,pos));float tr=decodeElevation(texture2D(u_dem,pos+vec2(dd,0.0)));float bl=decodeElevation(texture2D(u_dem,pos+vec2(0.0,dd)));float br=decodeElevation(texture2D(u_dem,pos+vec2(dd,dd)));return u_exaggeration*mix(mix(tl,tr,f.x),mix(bl,br,f.x),f.y);\n#endif\n}float prevElevation(vec2 apos) {\n#ifdef TERRAIN_DEM_FLOAT_FORMAT\nvec2 pos=(u_dem_size*(apos/8192.0*u_dem_scale_prev+u_dem_tl_prev)+1.5)/(u_dem_size+2.0);return u_exaggeration*texture(u_dem_prev,pos).r;\n#else\nfloat dd=1.0/(u_dem_size+2.0);vec4 r=tileUvToDemSample(apos/8192.0,u_dem_size,u_dem_scale_prev,u_dem_tl_prev);vec2 pos=r.xy;vec2 f=r.zw;float tl=decodeElevation(texture2D(u_dem_prev,pos));float tr=decodeElevation(texture2D(u_dem_prev,pos+vec2(dd,0.0)));float bl=decodeElevation(texture2D(u_dem_prev,pos+vec2(0.0,dd)));float br=decodeElevation(texture2D(u_dem_prev,pos+vec2(dd,dd)));return u_exaggeration*mix(mix(tl,tr,f.x),mix(bl,br,f.x),f.y);\n#endif\n}\n#ifdef TERRAIN_VERTEX_MORPHING\nfloat elevation(vec2 apos) {\n#ifdef ZERO_EXAGGERATION\nreturn 0.0;\n#endif\nfloat nextElevation=currentElevation(apos);float prevElevation=prevElevation(apos);return mix(prevElevation,nextElevation,u_dem_lerp);}\n#else\nfloat elevation(vec2 apos) {\n#ifdef ZERO_EXAGGERATION\nreturn 0.0;\n#endif\nreturn currentElevation(apos);}\n#endif\nhighp float unpack_depth(highp vec4 rgba_depth)\n{const highp vec4 bit_shift=vec4(1.0/(255.0*255.0*255.0),1.0/(255.0*255.0),1.0/255.0,1.0);return dot(rgba_depth,bit_shift)*2.0-1.0;}bool isOccluded(vec4 frag) {vec3 coord=frag.xyz/frag.w;float depth=unpack_depth(texture2D(u_depth,(coord.xy+1.0)*0.5));return coord.z > depth+0.0005;}float occlusionFade(vec4 frag) {vec3 coord=frag.xyz/frag.w;vec3 df=vec3(5.0*u_depth_size_inv,0.0);vec2 uv=0.5*coord.xy+0.5;vec4 depth=vec4(\nunpack_depth(texture2D(u_depth,uv-df.xz)),unpack_depth(texture2D(u_depth,uv+df.xz)),unpack_depth(texture2D(u_depth,uv-df.zy)),unpack_depth(texture2D(u_depth,uv+df.zy))\n);return dot(vec4(0.25),vec4(1.0)-clamp(300.0*(vec4(coord.z-0.001)-depth),0.0,1.0));}vec4 fourSample(vec2 pos,vec2 off) {\n#ifdef TERRAIN_DEM_FLOAT_FORMAT\nfloat tl=texture(u_dem,pos).r;float tr=texture(u_dem,pos+vec2(off.x,0.0)).r;float bl=texture(u_dem,pos+vec2(0.0,off.y)).r;float br=texture(u_dem,pos+off).r;\n#else\nvec4 demtl=vec4(texture2D(u_dem,pos).xyz*255.0,-1.0);float tl=dot(demtl,u_dem_unpack);vec4 demtr=vec4(texture2D(u_dem,pos+vec2(off.x,0.0)).xyz*255.0,-1.0);float tr=dot(demtr,u_dem_unpack);vec4 dembl=vec4(texture2D(u_dem,pos+vec2(0.0,off.y)).xyz*255.0,-1.0);float bl=dot(dembl,u_dem_unpack);vec4 dembr=vec4(texture2D(u_dem,pos+off).xyz*255.0,-1.0);float br=dot(dembr,u_dem_unpack);\n#endif\nreturn vec4(tl,tr,bl,br);}float flatElevation(vec2 pack) {vec2 apos=floor(pack/8.0);vec2 span=10.0*(pack-apos*8.0);vec2 uvTex=(apos-vec2(1.0,1.0))/8190.0;float size=u_dem_size+2.0;float dd=1.0/size;vec2 pos=u_dem_size*(uvTex*u_dem_scale+u_dem_tl)+1.0;vec2 f=fract(pos);pos=(pos-f+0.5)*dd;vec4 h=fourSample(pos,vec2(dd));float z=mix(mix(h.x,h.y,f.x),mix(h.z,h.w,f.x),f.y);vec2 w=floor(0.5*(span*u_meter_to_dem-1.0));vec2 d=dd*w;h=fourSample(pos-d,2.0*d+vec2(dd));vec4 diff=abs(h.xzxy-h.ywzw);vec2 slope=min(vec2(0.25),u_meter_to_dem*0.5*(diff.xz+diff.yw)/(2.0*w+vec2(1.0)));vec2 fix=slope*span;float base=z+max(fix.x,fix.y);return u_exaggeration*base;}float elevationFromUint16(float word) {return u_exaggeration*(word/ELEVATION_SCALE-ELEVATION_OFFSET);}\n#else\nfloat elevation(vec2 pos) { return 0.0; }bool isOccluded(vec4 frag) { return false; }float occlusionFade(vec4 frag) { return 1.0; }\n#endif",KT="#ifdef FOG\nuniform mediump vec4 u_fog_color;uniform mediump vec2 u_fog_range;uniform mediump float u_fog_horizon_blend;uniform mediump mat4 u_fog_matrix;varying vec3 v_fog_pos;float fog_range(float depth) {return (depth-u_fog_range[0])/(u_fog_range[1]-u_fog_range[0]);}float fog_horizon_blending(vec3 camera_dir) {float t=max(0.0,camera_dir.z/u_fog_horizon_blend);return u_fog_color.a*exp(-3.0*t*t);}float fog_opacity(float t) {const float decay=6.0;float falloff=1.0-min(1.0,exp(-decay*t));falloff*=falloff*falloff;return u_fog_color.a*min(1.0,1.00747*falloff);}vec3 fog_position(vec3 pos) {return (u_fog_matrix*vec4(pos,1.0)).xyz;}vec3 fog_position(vec2 pos) {return fog_position(vec3(pos,0.0));}float fog(vec3 pos) {float depth=length(pos);float opacity=fog_opacity(fog_range(depth));return opacity*fog_horizon_blending(pos/depth);}\n#endif",JT="#ifdef FOG\nuniform mediump vec4 u_fog_color;uniform mediump vec2 u_fog_range;uniform mediump float u_fog_horizon_blend;uniform mediump vec2 u_fog_vertical_limit;uniform mediump float u_fog_temporal_offset;varying vec3 v_fog_pos;uniform highp vec3 u_frustum_tl;uniform highp vec3 u_frustum_tr;uniform highp vec3 u_frustum_br;uniform highp vec3 u_frustum_bl;uniform highp vec3 u_globe_pos;uniform highp float u_globe_radius;uniform highp vec2 u_viewport;uniform float u_globe_transition;uniform int u_is_globe;float fog_range(float depth) {return (depth-u_fog_range[0])/(u_fog_range[1]-u_fog_range[0]);}float fog_horizon_blending(vec3 camera_dir) {float t=max(0.0,camera_dir.z/u_fog_horizon_blend);return u_fog_color.a*exp(-3.0*t*t);}float fog_opacity(float t) {const float decay=6.0;float falloff=1.0-min(1.0,exp(-decay*t));falloff*=falloff*falloff;return u_fog_color.a*min(1.0,1.00747*falloff);}float globe_glow_progress() {highp vec2 uv=gl_FragCoord.xy/u_viewport;highp vec3 ray_dir=mix(\nmix(u_frustum_tl,u_frustum_tr,uv.x),mix(u_frustum_bl,u_frustum_br,uv.x),1.0-uv.y);highp vec3 dir=normalize(ray_dir);highp vec3 closest_point=dot(u_globe_pos,dir)*dir;highp float sdf=length(closest_point-u_globe_pos)/u_globe_radius;return sdf+PI*0.5;}float fog_opacity(vec3 pos) {float depth=length(pos);return fog_opacity(fog_range(depth));}vec3 fog_apply(vec3 color,vec3 pos) {float depth=length(pos);float opacity;if (u_is_globe==1) {float glow_progress=globe_glow_progress();float t=mix(glow_progress,depth,u_globe_transition);opacity=fog_opacity(fog_range(t));} else {opacity=fog_opacity(fog_range(depth));opacity*=fog_horizon_blending(pos/depth);}return mix(color,u_fog_color.rgb,opacity);}vec4 fog_apply_from_vert(vec4 color,float fog_opac) {float alpha=EPSILON+color.a;color.rgb=mix(color.rgb/alpha,u_fog_color.rgb,fog_opac)*alpha;return color;}vec3 fog_apply_sky_gradient(vec3 camera_ray,vec3 sky_color) {float horizon_blend=fog_horizon_blending(normalize(camera_ray));return mix(sky_color,u_fog_color.rgb,horizon_blend);}vec4 fog_apply_premultiplied(vec4 color,vec3 pos) {float alpha=EPSILON+color.a;color.rgb=fog_apply(color.rgb/alpha,pos)*alpha;return color;}vec4 fog_apply_premultiplied(vec4 color,vec3 pos,float heightMeters) {float verticalProgress=(u_fog_vertical_limit.x > 0.0 || u_fog_vertical_limit.y > 0.0) ? smoothstep(u_fog_vertical_limit.x,u_fog_vertical_limit.y,heightMeters) : 0.0;float opacityLimit=1.0-smoothstep(0.9,1.0,fog_opacity(pos));return mix(fog_apply_premultiplied(color,pos),color,min(verticalProgress,opacityLimit));}vec3 fog_dither(vec3 color) {\n#ifdef FOG_DITHERING\nvec2 dither_seed=gl_FragCoord.xy+u_fog_temporal_offset;return dither(color,dither_seed);\n#else\nreturn color;\n#endif\n}vec4 fog_dither(vec4 color) {return vec4(fog_dither(color.rgb),color.a);}\n#endif",QT="\n#ifdef LIGHTING_3D_MODE\nuniform mediump vec3 u_lighting_ambient_color;uniform mediump vec3 u_lighting_directional_dir;uniform mediump vec3 u_lighting_directional_color;uniform mediump vec3 u_ground_radiance;float calculate_ambient_directional_factor(vec3 normal) {float NdotL=dot(normal,u_lighting_directional_dir);const float factor_reduction_max=0.3;float dir_luminance=dot(u_lighting_directional_color,vec3(0.2126,0.7152,0.0722));float directional_factor_min=1.0-factor_reduction_max*min(dir_luminance,1.0);float ambient_directional_factor=mix(directional_factor_min,1.0,min((NdotL+1.0),1.0));const float vertical_factor_min=0.92;float vertical_factor=mix(vertical_factor_min,1.0,normal.z*0.5+0.5);return vertical_factor*ambient_directional_factor;}vec3 apply_lighting(vec3 color,vec3 normal,float dir_factor) {float ambient_directional_factor=calculate_ambient_directional_factor(normal);vec3 ambient_contrib=ambient_directional_factor*u_lighting_ambient_color;vec3 directional_contrib=u_lighting_directional_color*dir_factor;return linearProduct(color,ambient_contrib+directional_contrib);}vec4 apply_lighting(vec4 color,vec3 normal,float dir_factor) {return vec4(apply_lighting(color.rgb,normal,dir_factor),color.a);}vec3 apply_lighting(vec3 color,vec3 normal) {float dir_factor=max(dot(normal,u_lighting_directional_dir),0.0);return apply_lighting(color.rgb,normal,dir_factor);}vec4 apply_lighting(vec4 color,vec3 normal) {float dir_factor=max(dot(normal,u_lighting_directional_dir),0.0);return vec4(apply_lighting(color.rgb,normal,dir_factor),color.a);}vec3 apply_lighting_ground(vec3 color) {return color*u_ground_radiance;}vec4 apply_lighting_ground(vec4 color) {return vec4(apply_lighting_ground(color.rgb),color.a);}float calculate_NdotL(vec3 normal) {const float ext=0.70710678118;return (clamp(dot(normal,u_lighting_directional_dir),-ext,1.0)+ext)/(1.0+ext);}vec4 apply_lighting_with_emission_ground(vec4 color,float emissive_strength) {return mix(apply_lighting_ground(color),color,emissive_strength);}vec3 compute_flood_lighting(vec3 flood_light_color,float fully_occluded_factor,float occlusion,vec3 ground_shadow_factor) {vec3 fully_occluded_color=flood_light_color*mix(ground_shadow_factor,vec3(1.0),fully_occluded_factor);float occlusion_ramp=smoothstep(0.0,0.2,1.0-occlusion);return mix(fully_occluded_color,flood_light_color,occlusion_ramp);}vec3 compute_emissive_draped(vec3 unlit_color,float fully_occluded_factor,float occlusion,vec3 ground_shadow_factor) {vec3 fully_occluded_color=unlit_color*mix(ground_shadow_factor,vec3(1.0),fully_occluded_factor);return mix(fully_occluded_color,unlit_color,1.0-occlusion);}\n#endif//LIGHTING_3D_MODE",tE="#ifdef RENDER_SHADOWS\nuniform mediump vec3 u_shadow_direction;uniform highp vec3 u_shadow_normal_offset;vec3 shadow_normal_offset(vec3 normal) {float tileInMeters=u_shadow_normal_offset[0];vec3 n=vec3(-normal.xy,tileInMeters*normal.z);float dotScale=min(1.0-dot(normal,u_shadow_direction),1.0)*0.5+0.5;return n*dotScale;}vec3 shadow_normal_offset_model(vec3 normal) {float dotScale=min(1.0-dot(normal,u_shadow_direction),1.0)*0.5+0.5;return normal*dotScale;}float shadow_normal_offset_multiplier0() {return u_shadow_normal_offset[1];}float shadow_normal_offset_multiplier1() {return u_shadow_normal_offset[2];}\n#endif//RENDER_SHADOWS",eE="#ifdef RENDER_SHADOWS\n#if defined(NATIVE) && __VERSION__ >=300\n#define TEXTURE_GATHER\n#endif\n#ifdef DEPTH_TEXTURE\nuniform highp sampler2D u_shadowmap_0;uniform highp sampler2D u_shadowmap_1;\n#else\nuniform sampler2D u_shadowmap_0;uniform sampler2D u_shadowmap_1;\n#endif\nuniform float u_shadow_intensity;uniform float u_texel_size;uniform highp vec3 u_shadow_normal_offset;uniform vec2 u_fade_range;uniform mediump vec3 u_shadow_direction;uniform highp vec3 u_shadow_bias;highp float shadow_sample_1(highp vec2 uv,highp float compare) {highp float shadow_depth;\n#ifdef DEPTH_TEXTURE\nshadow_depth=texture2D(u_shadowmap_1,uv).r;\n#else\nshadow_depth=unpack_depth(texture2D(u_shadowmap_1,uv))*0.5+0.5;\n#endif\nreturn step(shadow_depth,compare);}highp float shadow_sample_0(highp vec2 uv,highp float compare) {highp float shadow_depth;\n#ifdef DEPTH_TEXTURE\nshadow_depth=texture2D(u_shadowmap_0,uv).r;\n#else\nshadow_depth=unpack_depth(texture2D(u_shadowmap_0,uv))*0.5+0.5;\n#endif\nreturn step(shadow_depth,compare);}highp float shadow_occlusion_1(highp vec4 pos,highp float bias) {highp float compare1=pos.z-bias;highp vec2 texel=pos.xy/u_texel_size-vec2(0.5);highp vec2 f=fract(texel);highp float s=u_texel_size;\n#ifdef TEXTURE_GATHER\nvec2 uv00=(texel-f+0.5)*s;highp vec4 d00=textureGather(u_shadowmap_1,uv00,0);highp vec4 c00=step(d00,vec4(compare1));highp float o00=c00.a;highp float o10=c00.b;highp float o01=c00.r;highp float o11=c00.g;\n#else\nhighp vec2 uv00=(texel-f+0.5)*s;highp vec2 uv10=uv00+vec2(1.0*s,0.0);highp vec2 uv01=uv00+vec2(0.0,1.0*s);highp vec2 uv11=uv01+vec2(1.0*s,0.0);highp float o00=shadow_sample_1(uv00,compare1);highp float o10=shadow_sample_1(uv10,compare1);highp float o01=shadow_sample_1(uv01,compare1);highp float o11=shadow_sample_1(uv11,compare1);\n#endif\nhighp float value=\n(1.0-f.x)*(1.0-f.y)*o00+f.x*(1.0-f.y)*o10+(1.0-f.x)*f.y*o01+f.x*f.y*o11;return clamp(value,0.0,1.0);}highp float shadow_occlusion_0(highp vec4 pos,highp float bias) {highp float compare0=pos.z-bias;highp vec2 texel=pos.xy/u_texel_size-vec2(0.5);highp vec2 f=fract(texel);highp float s=u_texel_size;\n#ifdef TEXTURE_GATHER\nhighp vec2 uv00=(texel-f+0.5)*s;highp vec4 samples=textureGather(u_shadowmap_0,uv00,0);highp vec4 stepSamples=step(samples,vec4(compare0));\n#else\nhighp vec2 uv00=(texel-f+0.5)*s;highp vec2 uv10=uv00+vec2(1.0*s,0.0);highp vec2 uv01=uv00+vec2(0.0,1.0*s);highp vec2 uv11=uv01+vec2(1.0*s,0.0);highp vec4 stepSamples=vec4(\nshadow_sample_0(uv01,compare0),shadow_sample_0(uv11,compare0),shadow_sample_0(uv10,compare0),shadow_sample_0(uv00,compare0)\n);\n#endif\nvec4 v0=vec4(1.0-f.x,f.x,f.x,1.0-f.x);vec4 v1=vec4(f.y,f.y,1.0-f.y,1.0-f.y);return clamp(dot(v0*v1,stepSamples),0.0,1.0);}float shadow_occlusion(highp vec4 light_view_pos0,highp vec4 light_view_pos1,float view_depth,highp float bias) {light_view_pos0.xyz/=light_view_pos0.w;light_view_pos1.xyz/=light_view_pos1.w;vec4 uv=vec4(light_view_pos0.xy,light_view_pos1.xy);vec4 abs_bounds=abs(uv);if (abs_bounds.x < 1.0 && abs_bounds.y < 1.0) {light_view_pos0.xyz=light_view_pos0.xyz*0.5+0.5;return shadow_occlusion_0(light_view_pos0,bias);}if (abs_bounds.z >=1.0 || abs_bounds.w >=1.0) {return 0.0;}light_view_pos1.xyz=light_view_pos1.xyz*0.5+0.5;float occlusion1=shadow_occlusion_1(light_view_pos1,bias);return mix(occlusion1,0.0,smoothstep(u_fade_range.x,u_fade_range.y,view_depth));}highp float calculate_shadow_bias(float NDotL) {\n#ifdef NORMAL_OFFSET\nreturn 0.5*u_shadow_bias.x;\n#else\nreturn 0.5*(u_shadow_bias.x+clamp(u_shadow_bias.y*tan(acos(NDotL)),0.0,u_shadow_bias.z));\n#endif\n}float shadowed_light_factor_normal(vec3 N,highp vec4 light_view_pos0,highp vec4 light_view_pos1,float view_depth) {float NDotL=dot(N,u_shadow_direction);float bias=calculate_shadow_bias(NDotL);float occlusion=shadow_occlusion(light_view_pos0,light_view_pos1,view_depth,bias);return mix(0.0,(1.0-(u_shadow_intensity*occlusion))*NDotL,step(0.0,NDotL));}float shadowed_light_factor_normal_unbiased(vec3 N,highp vec4 light_view_pos0,highp vec4 light_view_pos1,float view_depth) {float NDotL=dot(N,u_shadow_direction);float bias=0.0;float occlusion=shadow_occlusion(light_view_pos0,light_view_pos1,view_depth,bias);return mix(0.0,(1.0-(u_shadow_intensity*occlusion))*NDotL,step(0.0,NDotL));}float shadowed_light_factor(highp vec4 light_view_pos0,highp vec4 light_view_pos1,float view_depth) {float bias=0.0;float occlusion=shadow_occlusion(light_view_pos0,light_view_pos1,view_depth,bias);return 1.0-(u_shadow_intensity*occlusion);}float shadow_occlusion(float ndotl,highp vec4 light_view_pos0,highp vec4 light_view_pos1,float view_depth) {float bias=calculate_shadow_bias(ndotl);return shadow_occlusion(light_view_pos0,light_view_pos1,view_depth,bias);}\n#endif";let iE={},rE={},nE={};const oE=[];uE(WT,oE),uE(QT,oE),uE(YT,oE),uE(KT,oE),uE(JT,oE),uE(tE,oE),uE(eE,oE),iE=dE("",YT),rE=dE(JT,KT),nE=dE(eE,tE);const sE=dE("\n#if __VERSION__ >=300\n#define varying in\n#define gl_FragColor glFragColor\n#define texture2D texture\n#define textureCube texture\nout vec4 glFragColor;\n#endif\nhighp vec3 hash(highp vec2 p) {highp vec3 p3=fract(p.xyx*vec3(443.8975,397.2973,491.1871));p3+=dot(p3,p3.yxz+19.19);return fract((p3.xxy+p3.yzz)*p3.zyx);}vec3 dither(vec3 color,highp vec2 seed) {vec3 rnd=hash(seed)+hash(seed+0.59374)-0.5;return color+rnd/255.0;}highp float unpack_depth(highp vec4 rgba_depth)\n{const highp vec4 bit_shift=vec4(1.0/(255.0*255.0*255.0),1.0/(255.0*255.0),1.0/255.0,1.0);return dot(rgba_depth,bit_shift)*2.0-1.0;}highp vec4 pack_depth(highp float ndc_z) {highp float depth=ndc_z*0.5+0.5;const highp vec4 bit_shift=vec4(255.0*255.0*255.0,255.0*255.0,255.0,1.0);const highp vec4 bit_mask =vec4(0.0,1.0/255.0,1.0/255.0,1.0/255.0);highp vec4 res=fract(depth*bit_shift);res-=res.xxyz*bit_mask;return res;}\n#ifdef INDICATOR_CUTOUT\nuniform vec2 u_indicator_cutout_centers;uniform vec4 u_indicator_cutout_params;\n#endif\nvec4 applyCutout(vec4 color) {\n#ifdef INDICATOR_CUTOUT\nfloat holeMinOpacity=u_indicator_cutout_params.x;float holeRadius=max(u_indicator_cutout_params.y,0.0);float holeAspectRatio=u_indicator_cutout_params.z;float fadeStart=u_indicator_cutout_params.w;float distA=distance(vec2(gl_FragCoord.x,gl_FragCoord.y*holeAspectRatio),vec2(u_indicator_cutout_centers[0],u_indicator_cutout_centers[1]*holeAspectRatio));return color*min(smoothstep(fadeStart,holeRadius,distA)+holeMinOpacity,1.0);\n#else\nreturn color;\n#endif\n}\n#ifdef RENDER_CUTOFF\nuniform highp vec4 u_cutoff_params;varying float v_cutoff_opacity;\n#endif","\n#if __VERSION__ >=300\n#define attribute in\n#define varying out\n#define texture2D texture\n#endif\nfloat wrap(float n,float min,float max) {float d=max-min;float w=mod(mod(n-min,d)+d,d)+min;return (w==min) ? max : w;}\n#ifdef PROJECTION_GLOBE_VIEW\nvec3 mercator_tile_position(mat4 matrix,vec2 tile_anchor,vec3 tile_id,vec2 mercator_center) {\n#ifndef PROJECTED_POS_ON_VIEWPORT\nfloat tiles=tile_id.z;vec2 mercator=(tile_anchor/EXTENT+tile_id.xy)/tiles;mercator-=mercator_center;mercator.x=wrap(mercator.x,-0.5,0.5);vec4 mercator_tile=vec4(mercator.xy*EXTENT,EXTENT/(2.0*PI),1.0);mercator_tile=matrix*mercator_tile;return mercator_tile.xyz;\n#else\nreturn vec3(0.0);\n#endif\n}vec3 mix_globe_mercator(vec3 globe,vec3 mercator,float t) {return mix(globe,mercator,t);}mat3 globe_mercator_surface_vectors(vec3 pos_normal,vec3 up_dir,float zoom_transition) {vec3 normal=zoom_transition==0.0 ? pos_normal : normalize(mix(pos_normal,up_dir,zoom_transition));vec3 xAxis=normalize(vec3(normal.z,0.0,-normal.x));vec3 yAxis=normalize(cross(normal,xAxis));return mat3(xAxis,yAxis,normal);}\n#endif\nvec2 unpack_float(const float packedValue) {int packedIntValue=int(packedValue);int v0=packedIntValue/256;return vec2(v0,packedIntValue-v0*256);}vec2 unpack_opacity(const float packedOpacity) {int intOpacity=int(packedOpacity)/2;return vec2(float(intOpacity)/127.0,mod(packedOpacity,2.0));}vec4 decode_color(const vec2 encodedColor) {return vec4(\nunpack_float(encodedColor[0])/255.0,unpack_float(encodedColor[1])/255.0\n);}float unpack_mix_vec2(const vec2 packedValue,const float t) {return mix(packedValue[0],packedValue[1],t);}vec4 unpack_mix_color(const vec4 packedColors,const float t) {vec4 minColor=decode_color(vec2(packedColors[0],packedColors[1]));vec4 maxColor=decode_color(vec2(packedColors[2],packedColors[3]));return mix(minColor,maxColor,t);}vec2 get_pattern_pos(const vec2 pixel_coord_upper,const vec2 pixel_coord_lower,const vec2 pattern_size,const float tile_units_to_pixels,const vec2 pos) {vec2 offset=mod(mod(mod(pixel_coord_upper,pattern_size)*256.0,pattern_size)*256.0+pixel_coord_lower,pattern_size);return (tile_units_to_pixels*pos+offset)/pattern_size;}\n#ifdef RENDER_CUTOFF\nuniform vec4 u_cutoff_params;varying float v_cutoff_opacity;\n#endif\nconst vec4 AWAY=vec4(-1000.0,-1000.0,-1000.0,1);//Normalized device coordinate that is not rendered."),aE=WT,lE=QT,cE="\n#ifdef GL_ES\nprecision mediump float;\n#else\n\n#if !defined(lowp)\n#define lowp\n#endif\n\n#if !defined(mediump)\n#define mediump\n#endif\n\n#if !defined(highp)\n#define highp\n#endif\n\n#endif";var hE={background:dE("uniform vec4 u_color;uniform float u_opacity;\n#ifdef LIGHTING_3D_MODE\nvarying vec4 v_color;\n#endif\nvoid main() {vec4 out_color;\n#ifdef LIGHTING_3D_MODE\nout_color=v_color;\n#else\nout_color=u_color;\n#endif\n#ifdef FOG\nout_color=fog_dither(fog_apply_premultiplied(out_color,v_fog_pos));\n#endif\ngl_FragColor=out_color*u_opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\nHANDLE_WIREFRAME_DEBUG;}","attribute vec2 a_pos;uniform mat4 u_matrix;\n#ifdef LIGHTING_3D_MODE\nuniform mediump vec4 u_color;varying vec4 v_color;uniform float u_emissive_strength;\n#endif\nvoid main() {gl_Position=u_matrix*vec4(a_pos,0,1);\n#ifdef LIGHTING_3D_MODE\nv_color=apply_lighting_with_emission_ground(u_color,u_emissive_strength);\n#endif\n#ifdef FOG\nv_fog_pos=fog_position(a_pos);\n#endif\n}"),backgroundPattern:dE("uniform vec2 u_pattern_tl;uniform vec2 u_pattern_br;uniform vec2 u_texsize;uniform float u_opacity;uniform float u_emissive_strength;uniform sampler2D u_image;varying vec2 v_pos;void main() {vec2 imagecoord=mod(v_pos,1.0);vec2 pos=mix(u_pattern_tl/u_texsize,u_pattern_br/u_texsize,imagecoord);vec4 out_color=texture2D(u_image,pos);\n#ifdef LIGHTING_3D_MODE\nout_color=apply_lighting_with_emission_ground(out_color,u_emissive_strength);\n#endif\n#ifdef FOG\nout_color=fog_dither(fog_apply_premultiplied(out_color,v_fog_pos));\n#endif\ngl_FragColor=out_color*u_opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\nHANDLE_WIREFRAME_DEBUG;}","uniform mat4 u_matrix;uniform vec2 u_pattern_size;uniform vec2 u_pixel_coord_upper;uniform vec2 u_pixel_coord_lower;uniform float u_tile_units_to_pixels;attribute vec2 a_pos;varying vec2 v_pos;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);v_pos=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,u_pattern_size,u_tile_units_to_pixels,a_pos);\n#ifdef FOG\nv_fog_pos=fog_position(a_pos);\n#endif\n}"),circle:dE("varying vec3 v_data;varying float v_visibility;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define mediump float radius\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define highp vec4 stroke_color\n#pragma mapbox: define mediump float stroke_width\n#pragma mapbox: define lowp float stroke_opacity\nuniform float u_emissive_strength;void main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize mediump float radius\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize highp vec4 stroke_color\n#pragma mapbox: initialize mediump float stroke_width\n#pragma mapbox: initialize lowp float stroke_opacity\nvec2 extrude=v_data.xy;float extrude_length=length(extrude);lowp float antialiasblur=v_data.z;float antialiased_blur=-max(blur,antialiasblur);float opacity_t=smoothstep(0.0,antialiased_blur,extrude_length-1.0);float color_t=stroke_width < 0.01 ? 0.0 : smoothstep(\nantialiased_blur,0.0,extrude_length-radius/(radius+stroke_width)\n);vec4 out_color=mix(color*opacity,stroke_color*stroke_opacity,color_t);\n#ifdef LIGHTING_3D_MODE\nout_color=apply_lighting_with_emission_ground(out_color,u_emissive_strength);\n#endif\n#ifdef FOG\nout_color=fog_apply_premultiplied(out_color,v_fog_pos);\n#endif\ngl_FragColor=out_color*(v_visibility*opacity_t);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","#define NUM_VISIBILITY_RINGS 2\n#define INV_SQRT2 0.70710678\n#define ELEVATION_BIAS 0.0001\n#define NUM_SAMPLES_PER_RING 16\nuniform mat4 u_matrix;uniform mat2 u_extrude_scale;uniform lowp float u_device_pixel_ratio;uniform highp float u_camera_to_center_distance;attribute vec2 a_pos;\n#ifdef PROJECTION_GLOBE_VIEW\nattribute vec3 a_pos_3;attribute vec3 a_pos_normal_3;uniform mat4 u_inv_rot_matrix;uniform vec2 u_merc_center;uniform vec3 u_tile_id;uniform float u_zoom_transition;uniform vec3 u_up_dir;\n#endif\nvarying vec3 v_data;varying float v_visibility;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define mediump float radius\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define highp vec4 stroke_color\n#pragma mapbox: define mediump float stroke_width\n#pragma mapbox: define lowp float stroke_opacity\nvec2 calc_offset(vec2 extrusion,float radius,float stroke_width, float view_scale) {return extrusion*(radius+stroke_width)*u_extrude_scale*view_scale;}float cantilevered_elevation(vec2 pos,float radius,float stroke_width,float view_scale) {vec2 c1=pos+calc_offset(vec2(-1,-1),radius,stroke_width,view_scale);vec2 c2=pos+calc_offset(vec2(1,-1),radius,stroke_width,view_scale);vec2 c3=pos+calc_offset(vec2(1,1),radius,stroke_width,view_scale);vec2 c4=pos+calc_offset(vec2(-1,1),radius,stroke_width,view_scale);float h1=elevation(c1)+ELEVATION_BIAS;float h2=elevation(c2)+ELEVATION_BIAS;float h3=elevation(c3)+ELEVATION_BIAS;float h4=elevation(c4)+ELEVATION_BIAS;return max(h4,max(h3,max(h1,h2)));}float circle_elevation(vec2 pos) {\n#if defined(TERRAIN)\nreturn elevation(pos)+ELEVATION_BIAS;\n#else\nreturn 0.0;\n#endif\n}vec4 project_vertex(vec2 extrusion,vec4 world_center,vec4 projected_center,float radius,float stroke_width, float view_scale,mat3 surface_vectors) {vec2 sample_offset=calc_offset(extrusion,radius,stroke_width,view_scale);\n#ifdef PITCH_WITH_MAP\n#ifdef PROJECTION_GLOBE_VIEW\nreturn u_matrix*( world_center+vec4(sample_offset.x*surface_vectors[0]+sample_offset.y*surface_vectors[1],0) );\n#else\nreturn u_matrix*( world_center+vec4(sample_offset,0,0) );\n#endif\n#else\nreturn projected_center+vec4(sample_offset,0,0);\n#endif\n}float get_sample_step() {\n#ifdef PITCH_WITH_MAP\nreturn 2.0*PI/float(NUM_SAMPLES_PER_RING);\n#else\nreturn PI/float(NUM_SAMPLES_PER_RING);\n#endif\n}void main(void) {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize mediump float radius\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize highp vec4 stroke_color\n#pragma mapbox: initialize mediump float stroke_width\n#pragma mapbox: initialize lowp float stroke_opacity\nvec2 extrude=vec2(mod(a_pos,2.0)*2.0-1.0);vec2 circle_center=floor(a_pos*0.5);vec4 world_center;mat3 surface_vectors;\n#ifdef PROJECTION_GLOBE_VIEW\nvec3 pos_normal_3=a_pos_normal_3/16384.0;surface_vectors=globe_mercator_surface_vectors(pos_normal_3,u_up_dir,u_zoom_transition);vec3 surface_extrusion=extrude.x*surface_vectors[0]+extrude.y*surface_vectors[1];vec3 globe_elevation=elevationVector(circle_center)*circle_elevation(circle_center);vec3 globe_pos=a_pos_3+surface_extrusion+globe_elevation;vec3 mercator_elevation=u_up_dir*u_tile_up_scale*circle_elevation(circle_center);vec3 merc_pos=mercator_tile_position(u_inv_rot_matrix,circle_center,u_tile_id,u_merc_center)+surface_extrusion+mercator_elevation;vec3 pos=mix_globe_mercator(globe_pos,merc_pos,u_zoom_transition);world_center=vec4(pos,1);\n#else \nsurface_vectors=mat3(1.0);float height=circle_elevation(circle_center);world_center=vec4(circle_center,height,1);\n#endif\nvec4 projected_center=u_matrix*world_center;float view_scale=0.0;\n#ifdef PITCH_WITH_MAP\n#ifdef SCALE_WITH_MAP\nview_scale=1.0;\n#else\nview_scale=projected_center.w/u_camera_to_center_distance;\n#endif\n#else\n#ifdef SCALE_WITH_MAP\nview_scale=u_camera_to_center_distance;\n#else\nview_scale=projected_center.w;\n#endif\n#endif\ngl_Position=project_vertex(extrude,world_center,projected_center,radius,stroke_width,view_scale,surface_vectors);float visibility=0.0;\n#ifdef TERRAIN\nfloat step=get_sample_step();vec4 occlusion_world_center;vec4 occlusion_projected_center;\n#ifdef PITCH_WITH_MAP\nfloat cantilevered_height=cantilevered_elevation(circle_center,radius,stroke_width,view_scale);occlusion_world_center=vec4(circle_center,cantilevered_height,1);occlusion_projected_center=u_matrix*occlusion_world_center;\n#else\nocclusion_world_center=world_center;occlusion_projected_center=projected_center;\n#endif\nfor(int ring=0; ring < NUM_VISIBILITY_RINGS; ring++) {float scale=(float(ring)+1.0)/float(NUM_VISIBILITY_RINGS);for(int i=0; i < NUM_SAMPLES_PER_RING; i++) {vec2 extrusion=vec2(cos(step*float(i)),-sin(step*float(i)))*scale;vec4 frag_pos=project_vertex(extrusion,occlusion_world_center,occlusion_projected_center,radius,stroke_width,view_scale,surface_vectors);visibility+=float(!isOccluded(frag_pos));}}visibility/=float(NUM_VISIBILITY_RINGS)*float(NUM_SAMPLES_PER_RING);\n#else\nvisibility=1.0;\n#endif\n#ifdef PROJECTION_GLOBE_VIEW\nvisibility=1.0;\n#endif\nv_visibility=visibility;lowp float antialiasblur=1.0/u_device_pixel_ratio/(radius+stroke_width);v_data=vec3(extrude.x,extrude.y,antialiasblur);\n#ifdef FOG\nv_fog_pos=fog_position(world_center.xyz);\n#endif\n}"),clippingMask:dE("void main() {gl_FragColor=vec4(1.0);}","attribute vec2 a_pos;uniform mat4 u_matrix;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);}"),heatmap:dE("uniform highp float u_intensity;varying vec2 v_extrude;\n#pragma mapbox: define highp float weight\n#define GAUSS_COEF 0.3989422804014327\nvoid main() {\n#pragma mapbox: initialize highp float weight\nfloat d=-0.5*3.0*3.0*dot(v_extrude,v_extrude);float val=weight*u_intensity*GAUSS_COEF*exp(d);gl_FragColor=vec4(val,1.0,1.0,1.0);\n#ifdef FOG\nif (u_is_globe==0) {gl_FragColor.r*=pow(1.0-fog_opacity(v_fog_pos),2.0);}\n#endif\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\nHANDLE_WIREFRAME_DEBUG;}","uniform mat4 u_matrix;uniform float u_extrude_scale;uniform float u_opacity;uniform float u_intensity;attribute vec2 a_pos;\n#ifdef PROJECTION_GLOBE_VIEW\nattribute vec3 a_pos_3;attribute vec3 a_pos_normal_3;uniform mat4 u_inv_rot_matrix;uniform vec2 u_merc_center;uniform vec3 u_tile_id;uniform float u_zoom_transition;uniform vec3 u_up_dir;\n#endif\nvarying vec2 v_extrude;\n#pragma mapbox: define highp float weight\n#pragma mapbox: define mediump float radius\nconst highp float ZERO=1.0/255.0/16.0;\n#define GAUSS_COEF 0.3989422804014327\nvoid main(void) {\n#pragma mapbox: initialize highp float weight\n#pragma mapbox: initialize mediump float radius\nvec2 unscaled_extrude=vec2(mod(a_pos,2.0)*2.0-1.0);float S=sqrt(-2.0*log(ZERO/weight/u_intensity/GAUSS_COEF))/3.0;v_extrude=S*unscaled_extrude;vec2 extrude=v_extrude*radius*u_extrude_scale;vec2 tilePos=floor(a_pos*0.5);vec3 pos;\n#ifdef PROJECTION_GLOBE_VIEW\nvec3 pos_normal_3=a_pos_normal_3/16384.0;mat3 surface_vectors=globe_mercator_surface_vectors(pos_normal_3,u_up_dir,u_zoom_transition);vec3 surface_extrusion=extrude.x*surface_vectors[0]+extrude.y*surface_vectors[1];vec3 globe_elevation=elevationVector(tilePos)*elevation(tilePos);vec3 globe_pos=a_pos_3+surface_extrusion+globe_elevation;vec3 mercator_elevation=u_up_dir*u_tile_up_scale*elevation(tilePos);vec3 merc_pos=mercator_tile_position(u_inv_rot_matrix,tilePos,u_tile_id,u_merc_center)+surface_extrusion+mercator_elevation;pos=mix_globe_mercator(globe_pos,merc_pos,u_zoom_transition);\n#else\npos=vec3(tilePos+extrude,elevation(tilePos));\n#endif\ngl_Position=u_matrix*vec4(pos,1);\n#ifdef FOG\nv_fog_pos=fog_position(pos);\n#endif\n}"),heatmapTexture:dE("uniform sampler2D u_image;uniform sampler2D u_color_ramp;uniform float u_opacity;varying vec2 v_pos;void main() {float t=texture2D(u_image,v_pos).r;vec4 color=texture2D(u_color_ramp,vec2(t,0.5));gl_FragColor=color*u_opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(0.0);\n#endif\nHANDLE_WIREFRAME_DEBUG;}","attribute vec2 a_pos;varying vec2 v_pos;void main() {gl_Position=vec4(a_pos,0,1);v_pos=a_pos*0.5+0.5;}"),collisionBox:dE("varying float v_placed;varying float v_notUsed;void main() {vec4 red =vec4(1.0,0.0,0.0,1.0);vec4 blue=vec4(0.0,0.0,1.0,0.5);gl_FragColor =mix(red,blue,step(0.5,v_placed))*0.5;gl_FragColor*=mix(1.0,0.1,step(0.5,v_notUsed));}","attribute vec3 a_pos;attribute vec2 a_anchor_pos;attribute vec2 a_extrude;attribute vec2 a_placed;attribute vec2 a_shift;attribute float a_size_scale;attribute vec2 a_padding;uniform mat4 u_matrix;uniform vec2 u_extrude_scale;uniform float u_camera_to_center_distance;varying float v_placed;varying float v_notUsed;void main() {vec4 projectedPoint=u_matrix*vec4(a_pos+elevationVector(a_anchor_pos)*elevation(a_anchor_pos),1);highp float camera_to_anchor_distance=projectedPoint.w;highp float collision_perspective_ratio=clamp(\n0.5+0.5*(u_camera_to_center_distance/camera_to_anchor_distance),0.0,1.5);gl_Position=projectedPoint;gl_Position.xy+=(a_extrude*a_size_scale+a_shift+a_padding)*u_extrude_scale*gl_Position.w*collision_perspective_ratio;v_placed=a_placed.x;v_notUsed=a_placed.y;}"),collisionCircle:dE("varying float v_radius;varying vec2 v_extrude;varying float v_perspective_ratio;varying float v_collision;void main() {float alpha=0.5*min(v_perspective_ratio,1.0);float stroke_radius=0.9*max(v_perspective_ratio,1.0);float distance_to_center=length(v_extrude);float distance_to_edge=abs(distance_to_center-v_radius);float opacity_t=smoothstep(-stroke_radius,0.0,-distance_to_edge);vec4 color=mix(vec4(0.0,0.0,1.0,0.5),vec4(1.0,0.0,0.0,1.0),v_collision);gl_FragColor=color*alpha*opacity_t;}","attribute vec2 a_pos_2f;attribute float a_radius;attribute vec2 a_flags;uniform mat4 u_matrix;uniform mat4 u_inv_matrix;uniform vec2 u_viewport_size;uniform float u_camera_to_center_distance;varying float v_radius;varying vec2 v_extrude;varying float v_perspective_ratio;varying float v_collision;vec3 toTilePosition(vec2 screenPos) {vec4 rayStart=u_inv_matrix*vec4(screenPos,-1.0,1.0);vec4 rayEnd  =u_inv_matrix*vec4(screenPos, 1.0,1.0);rayStart.xyz/=rayStart.w;rayEnd.xyz  /=rayEnd.w;highp float t=(0.0-rayStart.z)/(rayEnd.z-rayStart.z);return mix(rayStart.xyz,rayEnd.xyz,t);}void main() {vec2 quadCenterPos=a_pos_2f;float radius=a_radius;float collision=a_flags.x;float vertexIdx=a_flags.y;vec2 quadVertexOffset=vec2(\nmix(-1.0,1.0,float(vertexIdx >=2.0)),mix(-1.0,1.0,float(vertexIdx >=1.0 && vertexIdx <=2.0)));vec2 quadVertexExtent=quadVertexOffset*radius;vec3 tilePos=toTilePosition(quadCenterPos);vec4 clipPos=u_matrix*vec4(tilePos,1.0);highp float camera_to_anchor_distance=clipPos.w;highp float collision_perspective_ratio=clamp(\n0.5+0.5*(u_camera_to_center_distance/camera_to_anchor_distance),0.0,4.0);float padding_factor=1.2;v_radius=radius;v_extrude=quadVertexExtent*padding_factor;v_perspective_ratio=collision_perspective_ratio;v_collision=collision;gl_Position=vec4(clipPos.xyz/clipPos.w,1.0)+vec4(quadVertexExtent*padding_factor/u_viewport_size*2.0,0.0,0.0);}"),debug:dE("uniform highp vec4 u_color;uniform sampler2D u_overlay;varying vec2 v_uv;void main() {vec4 overlay_color=texture2D(u_overlay,v_uv);gl_FragColor=mix(u_color,overlay_color,overlay_color.a);}","attribute vec2 a_pos;\n#ifdef PROJECTION_GLOBE_VIEW\nattribute vec3 a_pos_3;\n#endif\nvarying vec2 v_uv;uniform mat4 u_matrix;uniform float u_overlay_scale;void main() {float h=elevation(a_pos);v_uv=a_pos/8192.0;\n#ifdef PROJECTION_GLOBE_VIEW\ngl_Position=u_matrix*vec4(a_pos_3+elevationVector(a_pos)*h,1);\n#else\ngl_Position=u_matrix*vec4(a_pos*u_overlay_scale,h,1);\n#endif\n}"),fill:dE("#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float opacity\nuniform float u_emissive_strength;void main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float opacity\nvec4 out_color=color;\n#ifdef LIGHTING_3D_MODE\nout_color=apply_lighting_with_emission_ground(out_color,u_emissive_strength);\n#endif\n#ifdef FOG\nout_color=fog_dither(fog_apply_premultiplied(out_color,v_fog_pos));\n#endif\ngl_FragColor=out_color*opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\nHANDLE_WIREFRAME_DEBUG;}","attribute vec2 a_pos;uniform mat4 u_matrix;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float opacity\ngl_Position=u_matrix*vec4(a_pos,0,1);\n#ifdef FOG\nv_fog_pos=fog_position(a_pos);\n#endif\n}"),fillOutline:dE("varying vec2 v_pos;uniform float u_emissive_strength;\n#pragma mapbox: define highp vec4 outline_color\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 outline_color\n#pragma mapbox: initialize lowp float opacity\nfloat dist=length(v_pos-gl_FragCoord.xy);float alpha=1.0-smoothstep(0.0,1.0,dist);vec4 out_color=outline_color;\n#ifdef LIGHTING_3D_MODE\nout_color=apply_lighting_with_emission_ground(out_color,u_emissive_strength);\n#endif\n#ifdef FOG\nout_color=fog_dither(fog_apply_premultiplied(out_color,v_fog_pos));\n#endif\ngl_FragColor=out_color*(alpha*opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\nHANDLE_WIREFRAME_DEBUG;}","attribute vec2 a_pos;uniform mat4 u_matrix;uniform vec2 u_world;varying vec2 v_pos;\n#pragma mapbox: define highp vec4 outline_color\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 outline_color\n#pragma mapbox: initialize lowp float opacity\ngl_Position=u_matrix*vec4(a_pos,0,1);v_pos=(gl_Position.xy/gl_Position.w+1.0)/2.0*u_world;\n#ifdef FOG\nv_fog_pos=fog_position(a_pos);\n#endif\n}"),fillOutlinePattern:dE("uniform vec2 u_texsize;uniform sampler2D u_image;uniform float u_emissive_strength;varying vec2 v_pos;varying vec2 v_pos_world;\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp vec4 pattern\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump vec4 pattern\nvec2 pattern_tl=pattern.xy;vec2 pattern_br=pattern.zw;vec2 imagecoord=mod(v_pos,1.0);vec2 pos=mix(pattern_tl/u_texsize,pattern_br/u_texsize,imagecoord);float dist=length(v_pos_world-gl_FragCoord.xy);float alpha=1.0-smoothstep(0.0,1.0,dist);vec4 out_color=texture2D(u_image,pos);\n#ifdef LIGHTING_3D_MODE\nout_color=apply_lighting_with_emission_ground(out_color,u_emissive_strength);\n#endif\n#ifdef FOG\nout_color=fog_dither(fog_apply_premultiplied(out_color,v_fog_pos));\n#endif\ngl_FragColor=out_color*(alpha*opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\nHANDLE_WIREFRAME_DEBUG;}","uniform mat4 u_matrix;uniform vec2 u_world;uniform vec2 u_pixel_coord_upper;uniform vec2 u_pixel_coord_lower;uniform float u_tile_units_to_pixels;attribute vec2 a_pos;varying vec2 v_pos;varying vec2 v_pos_world;\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp vec4 pattern\n#pragma mapbox: define lowp float pixel_ratio\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump vec4 pattern\n#pragma mapbox: initialize lowp float pixel_ratio\nvec2 pattern_tl=pattern.xy;vec2 pattern_br=pattern.zw;gl_Position=u_matrix*vec4(a_pos,0,1);vec2 display_size=(pattern_br-pattern_tl)/pixel_ratio;v_pos=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,display_size,u_tile_units_to_pixels,a_pos);v_pos_world=(gl_Position.xy/gl_Position.w+1.0)/2.0*u_world;\n#ifdef FOG\nv_fog_pos=fog_position(a_pos);\n#endif\n}"),fillPattern:dE("uniform vec2 u_texsize;uniform sampler2D u_image;varying vec2 v_pos;uniform float u_emissive_strength;\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp vec4 pattern\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump vec4 pattern\nvec2 pattern_tl=pattern.xy;vec2 pattern_br=pattern.zw;vec2 imagecoord=mod(v_pos,1.0);vec2 pos=mix(pattern_tl/u_texsize,pattern_br/u_texsize,imagecoord);vec4 out_color=texture2D(u_image,pos);\n#ifdef LIGHTING_3D_MODE\nout_color=apply_lighting_with_emission_ground(out_color,u_emissive_strength);\n#endif\n#ifdef FOG\nout_color=fog_dither(fog_apply_premultiplied(out_color,v_fog_pos));\n#endif\ngl_FragColor=out_color*opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\nHANDLE_WIREFRAME_DEBUG;}","uniform mat4 u_matrix;uniform vec2 u_pixel_coord_upper;uniform vec2 u_pixel_coord_lower;uniform float u_tile_units_to_pixels;attribute vec2 a_pos;varying vec2 v_pos;\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp vec4 pattern\n#pragma mapbox: define lowp float pixel_ratio\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump vec4 pattern\n#pragma mapbox: initialize lowp float pixel_ratio\nvec2 pattern_tl=pattern.xy;vec2 pattern_br=pattern.zw;vec2 display_size=(pattern_br-pattern_tl)/pixel_ratio;gl_Position=u_matrix*vec4(a_pos,0,1);v_pos=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,display_size,u_tile_units_to_pixels,a_pos);\n#ifdef FOG\nv_fog_pos=fog_position(a_pos);\n#endif\n}"),fillExtrusion:dE("varying vec4 v_color;\n#ifdef RENDER_SHADOWS\nvarying highp vec4 v_pos_light_view_0;varying highp vec4 v_pos_light_view_1;varying float v_depth;\n#endif\nuniform lowp float u_opacity;\n#ifdef FAUX_AO\nuniform lowp vec2 u_ao;varying vec2 v_ao;\n#endif\n#if defined(ZERO_ROOF_RADIUS) && !defined(LIGHTING_3D_MODE)\nvarying vec4 v_roof_color;\n#endif\n#if defined(ZERO_ROOF_RADIUS) || defined(RENDER_SHADOWS) || defined(LIGHTING_3D_MODE)\nvarying highp vec3 v_normal;\n#endif\nuniform vec3 u_flood_light_color;uniform highp float u_vertical_scale;uniform float u_flood_light_intensity;uniform vec3 u_ground_shadow_factor;\n#if defined(LIGHTING_3D_MODE) && defined(FLOOD_LIGHT)\nvarying float v_flood_radius;varying float v_has_floodlight;\n#endif\nvarying float v_height;void main() {\n#if defined(ZERO_ROOF_RADIUS) || defined(RENDER_SHADOWS) || defined(LIGHTING_3D_MODE)\nvec3 normal=normalize(v_normal);\n#endif\nfloat z;vec4 color=v_color;\n#ifdef ZERO_ROOF_RADIUS\nz=float(normal.z > 0.00001);\n#ifdef LIGHTING_3D_MODE\nnormal=mix(normal,vec3(0.0,0.0,1.0),z);\n#else\ncolor=mix(v_color,v_roof_color,z);\n#endif\n#endif\nfloat h=max(0.0,v_height);float ao_shade=1.0;\n#ifdef FAUX_AO\nfloat intensity=u_ao[0];float h_floors=h/(u_ao[1]*u_vertical_scale);float y_shade=1.0-0.9*intensity*min(v_ao.y,1.0);ao_shade=(1.0-0.08*intensity)*(y_shade+(1.0-y_shade)*(1.0-pow(1.0-min(h_floors/16.0,1.0),16.0)))+0.08*intensity*min(h_floors/160.0,1.0);float concave=v_ao.x*v_ao.x;\n#ifdef ZERO_ROOF_RADIUS\nconcave*=(1.0-z);\n#endif\nfloat x_shade=mix(1.0,mix(0.6,0.75,min(h_floors/30.0,1.0)),intensity)+0.1*intensity*min(h,1.0);ao_shade*=mix(1.0,x_shade*x_shade*x_shade,concave);\n#ifdef LIGHTING_3D_MODE\n#ifdef FLOOD_LIGHT\ncolor.rgb*=mix(ao_shade,1.0,v_has_floodlight);\n#else\ncolor.rgb*=ao_shade;\n#endif\n#else\ncolor.rgb*=ao_shade;\n#endif\n#endif\n#ifdef LIGHTING_3D_MODE\nfloat flood_radiance=0.0;\n#ifdef FLOOD_LIGHT\nflood_radiance=(1.0-min(h/v_flood_radius,1.0))*u_flood_light_intensity*v_has_floodlight;\n#endif\n#ifdef RENDER_SHADOWS\n#ifdef FLOOD_LIGHT\nfloat ndotl_unclamped=dot(normal,u_shadow_direction);float ndotl=max(0.0,ndotl_unclamped);float occlusion=ndotl_unclamped < 0.0 ? 1.0 : shadow_occlusion(ndotl,v_pos_light_view_0,v_pos_light_view_1,v_depth);vec3 litColor=apply_lighting(color.rgb,normal,(1.0-u_shadow_intensity*occlusion)*ndotl);vec3 floodLitColor=compute_flood_lighting(u_flood_light_color*u_opacity,1.0-u_shadow_intensity,occlusion,u_ground_shadow_factor);color.rgb=mix(litColor,floodLitColor,flood_radiance);\n#else\nfloat shadowed_lighting_factor=shadowed_light_factor_normal(normal,v_pos_light_view_0,v_pos_light_view_1,v_depth);color.rgb=apply_lighting(color.rgb,normal,shadowed_lighting_factor);\n#endif\n#else\ncolor.rgb=apply_lighting(color.rgb,normal);\n#ifdef FLOOD_LIGHT\ncolor.rgb=mix(color.rgb,u_flood_light_color*u_opacity,flood_radiance);\n#endif\n#endif\ncolor*=u_opacity;\n#endif\n#ifdef FOG\ncolor=fog_dither(fog_apply_premultiplied(color,v_fog_pos,h));\n#endif\n#ifdef RENDER_CUTOFF\ncolor*=v_cutoff_opacity;\n#endif\n#ifdef INDICATOR_CUTOUT\ncolor=applyCutout(color);\n#endif\ngl_FragColor=color;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\nHANDLE_WIREFRAME_DEBUG;}","#if __VERSION__ >=300\n#ifdef RENDER_CUTOFF\ninvariant gl_Position;\n#endif\n#endif\nuniform mat4 u_matrix;uniform vec3 u_lightcolor;uniform lowp vec3 u_lightpos;uniform lowp float u_lightintensity;uniform float u_vertical_gradient;uniform lowp float u_opacity;uniform float u_edge_radius;attribute vec4 a_pos_normal_ed;attribute vec2 a_centroid_pos;\n#ifdef PROJECTION_GLOBE_VIEW\nattribute vec3 a_pos_3;attribute vec3 a_pos_normal_3;uniform mat4 u_inv_rot_matrix;uniform vec2 u_merc_center;uniform vec3 u_tile_id;uniform float u_zoom_transition;uniform vec3 u_up_dir;uniform float u_height_lift;\n#endif\nuniform highp float u_vertical_scale;varying vec4 v_color;\n#ifdef RENDER_SHADOWS\nuniform mat4 u_light_matrix_0;uniform mat4 u_light_matrix_1;varying highp vec4 v_pos_light_view_0;varying highp vec4 v_pos_light_view_1;varying float v_depth;\n#endif\n#if defined(ZERO_ROOF_RADIUS) && !defined(LIGHTING_3D_MODE)\nvarying vec4 v_roof_color;\n#endif\n#if defined(ZERO_ROOF_RADIUS) || defined(RENDER_SHADOWS) || defined(LIGHTING_3D_MODE)\nvarying highp vec3 v_normal;\n#endif\n#ifdef FAUX_AO\nuniform lowp vec2 u_ao;varying vec2 v_ao;\n#endif\n#if defined(LIGHTING_3D_MODE) && defined(FLOOD_LIGHT)\nvarying float v_flood_radius;varying float v_has_floodlight;\n#endif\nvarying float v_height;\n#pragma mapbox: define highp float base\n#pragma mapbox: define highp float height\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define highp float flood_light_wall_radius\nvoid main() {\n#pragma mapbox: initialize highp float base\n#pragma mapbox: initialize highp float height\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize highp float flood_light_wall_radius\nbase*=u_vertical_scale;height*=u_vertical_scale;vec4 pos_nx=floor(a_pos_normal_ed*0.5);vec4 top_up_ny_start=a_pos_normal_ed-2.0*pos_nx;vec3 top_up_ny=top_up_ny_start.xyz;float x_normal=pos_nx.z/8192.0;vec3 normal=top_up_ny.y==1.0 ? vec3(0.0,0.0,1.0) : normalize(vec3(x_normal,(2.0*top_up_ny.z-1.0)*(1.0-abs(x_normal)),0.0));\n#if defined(ZERO_ROOF_RADIUS) || defined(RENDER_SHADOWS) || defined(LIGHTING_3D_MODE)\nv_normal=normal;\n#endif\nbase=max(0.0,base);height=max(0.0,top_up_ny.y==0.0 && top_up_ny.x==1.0 ? height-u_edge_radius : height);float t=top_up_ny.x;vec2 centroid_pos=vec2(0.0);\n#if defined(HAS_CENTROID) || defined(TERRAIN)\ncentroid_pos=a_centroid_pos;\n#endif\nfloat ele=0.0;float h=0.0;float c_ele;vec3 pos;\n#ifdef TERRAIN\nbool flat_roof=centroid_pos.x !=0.0 && t > 0.0;ele=elevation(pos_nx.xy);c_ele=flat_roof ? centroid_pos.y==0.0 ? elevationFromUint16(centroid_pos.x) : flatElevation(centroid_pos) : ele;h=flat_roof ? max(c_ele+height,ele+base+2.0) : ele+(t > 0.0 ? height : base==0.0 ?-5.0 : base);pos=vec3(pos_nx.xy,h);\n#else\nh=t > 0.0 ? height : base;pos=vec3(pos_nx.xy,h);\n#endif\n#ifdef PROJECTION_GLOBE_VIEW\nfloat lift=float((t+base) > 0.0)*u_height_lift;h+=lift;vec3 globe_normal=normalize(mix(a_pos_normal_3/16384.0,u_up_dir,u_zoom_transition));vec3 globe_pos=a_pos_3+globe_normal*(u_tile_up_scale*h);vec3 merc_pos=mercator_tile_position(u_inv_rot_matrix,pos.xy,u_tile_id,u_merc_center)+u_up_dir*u_tile_up_scale*pos.z;pos=mix_globe_mercator(globe_pos,merc_pos,u_zoom_transition);\n#endif\nfloat hidden=float(centroid_pos.x==0.0 && centroid_pos.y==1.0);gl_Position=mix(u_matrix*vec4(pos,1),AWAY,hidden);h=h-ele;v_height=h;\n#ifdef RENDER_SHADOWS\nvec3 shd_pos0=pos;vec3 shd_pos1=pos;\n#ifdef NORMAL_OFFSET\nvec3 offset=shadow_normal_offset(normal);shd_pos0+=offset*shadow_normal_offset_multiplier0();shd_pos1+=offset*shadow_normal_offset_multiplier1();\n#endif\nv_pos_light_view_0=u_light_matrix_0*vec4(shd_pos0,1);v_pos_light_view_1=u_light_matrix_1*vec4(shd_pos1,1);v_depth=gl_Position.w;\n#endif\nfloat NdotL=0.0;float colorvalue=0.0;\n#ifndef LIGHTING_3D_MODE\ncolorvalue=color.r*0.2126+color.g*0.7152+color.b*0.0722;vec4 ambientlight=vec4(0.03,0.03,0.03,1.0);color+=ambientlight;NdotL=clamp(dot(normal,u_lightpos),0.0,1.0);NdotL=mix((1.0-u_lightintensity),max((1.0-colorvalue+u_lightintensity),1.0),NdotL);if (normal.y !=0.0) {float r=0.84;r=mix(0.7,0.98,1.0-u_lightintensity);NdotL*=(\n(1.0-u_vertical_gradient)+(u_vertical_gradient*clamp((t+base)*pow(height/150.0,0.5),r,1.0)));}\n#endif\n#ifdef FAUX_AO\nfloat concave=pos_nx.w-floor(pos_nx.w*0.5)*2.0;float start=top_up_ny_start.w;float y_ground=1.0-clamp(t+base,0.0,1.0);float top_height=height;\n#ifdef TERRAIN\ntop_height=mix(max(c_ele+height,ele+base+2.0),ele+height,float(centroid_pos.x==0.0))-ele;y_ground+=y_ground*5.0/max(3.0,top_height);\n#endif\nv_ao=vec2(mix(concave,-concave,start),y_ground);NdotL*=(1.0+0.05*(1.0-top_up_ny.y)*u_ao[0]);\n#ifdef PROJECTION_GLOBE_VIEW\ntop_height+=u_height_lift;\n#endif\ngl_Position.z-=(0.0000006*(min(top_height,500.)+2.0*min(base,500.0)+60.0*concave+3.0*start))*gl_Position.w;\n#endif\n#ifdef LIGHTING_3D_MODE\n#ifdef FLOOD_LIGHT\nfloat is_wall=1.0-float(t > 0.0 && top_up_ny.y > 0.0);v_has_floodlight=float(flood_light_wall_radius > 0.0 && is_wall > 0.0);v_flood_radius=flood_light_wall_radius*u_vertical_scale;\n#endif\nv_color=color;\n#else\nv_color=vec4(0.0,0.0,0.0,1.0);v_color.rgb+=clamp(color.rgb*NdotL*u_lightcolor,mix(vec3(0.0),vec3(0.3),1.0-u_lightcolor),vec3(1.0));v_color*=u_opacity;\n#endif\n#if defined(ZERO_ROOF_RADIUS) && !defined(LIGHTING_3D_MODE)\nfloat roofNdotL=clamp(u_lightpos.z,0.0,1.0);roofNdotL=mix((1.0-u_lightintensity),max((1.0-colorvalue+u_lightintensity),1.0),roofNdotL);v_roof_color=vec4(0.0,0.0,0.0,1.0);v_roof_color.rgb+=clamp(color.rgb*roofNdotL*u_lightcolor,mix(vec3(0.0),vec3(0.3),1.0-u_lightcolor),vec3(1.0));v_roof_color*=u_opacity;\n#endif\n#ifdef FOG\nv_fog_pos=fog_position(pos);\n#endif\n#ifdef RENDER_CUTOFF\nv_cutoff_opacity=cutoff_opacity(u_cutoff_params,gl_Position.z);\n#endif\n}"),fillExtrusionDepth:dE("varying highp float v_depth;void main() {\n#ifndef DEPTH_TEXTURE\ngl_FragColor=pack_depth(v_depth);\n#endif\n}","uniform mat4 u_matrix;uniform float u_edge_radius;uniform float u_vertical_scale;attribute vec4 a_pos_normal_ed;attribute vec2 a_centroid_pos;\n#pragma mapbox: define highp float base\n#pragma mapbox: define highp float height\nvarying highp float v_depth;void main() {\n#pragma mapbox: initialize highp float base\n#pragma mapbox: initialize highp float height\nbase*=u_vertical_scale;height*=u_vertical_scale;vec3 pos_nx=floor(a_pos_normal_ed.xyz*0.5);mediump vec3 top_up_ny=a_pos_normal_ed.xyz-2.0*pos_nx;base=max(0.0,base);height=max(0.0,top_up_ny.y==0.0 && top_up_ny.x==1.0 ? height-u_edge_radius : height);float t=top_up_ny.x;vec2 centroid_pos=vec2(0.0);\n#if defined(HAS_CENTROID) || defined(TERRAIN)\ncentroid_pos=a_centroid_pos;\n#endif\nvec3 pos;\n#ifdef TERRAIN\nbool flat_roof=centroid_pos.x !=0.0 && t > 0.0;float ele=elevation(pos_nx.xy);float c_ele=flat_roof ? centroid_pos.y==0.0 ? elevationFromUint16(centroid_pos.x) : flatElevation(centroid_pos) : ele;float h=flat_roof ? max(c_ele+height,ele+base+2.0) : ele+(t > 0.0 ? height : base);pos=vec3(pos_nx.xy,h);\n#else\npos=vec3(pos_nx.xy,t > 0.0 ? height : base);\n#endif\nfloat hidden=float(centroid_pos.x==0.0 && centroid_pos.y==1.0);gl_Position=mix(u_matrix*vec4(pos,1),AWAY,hidden);v_depth=gl_Position.z/gl_Position.w;}"),fillExtrusionPattern:dE("uniform vec2 u_texsize;uniform sampler2D u_image;\n#ifdef FAUX_AO\nuniform lowp vec2 u_ao;varying vec3 v_ao;\n#endif\n#ifdef LIGHTING_3D_MODE\nvarying vec3 v_normal;\n#endif\nvarying vec2 v_pos;varying vec4 v_lighting;uniform lowp float u_opacity;\n#pragma mapbox: define highp float base\n#pragma mapbox: define highp float height\n#pragma mapbox: define mediump vec4 pattern\n#pragma mapbox: define highp float pixel_ratio\nvoid main() {\n#pragma mapbox: initialize highp float base\n#pragma mapbox: initialize highp float height\n#pragma mapbox: initialize mediump vec4 pattern\n#pragma mapbox: initialize highp float pixel_ratio\nvec2 pattern_tl=pattern.xy;vec2 pattern_br=pattern.zw;vec2 imagecoord=mod(v_pos,1.0);vec2 pos=mix(pattern_tl/u_texsize,pattern_br/u_texsize,imagecoord);vec4 out_color=texture2D(u_image,pos);\n#ifdef LIGHTING_3D_MODE\nout_color=apply_lighting(out_color,normalize(v_normal))*u_opacity;\n#else\nout_color=out_color*v_lighting;\n#endif\n#ifdef FAUX_AO\nfloat intensity=u_ao[0];float h=max(0.0,v_ao.z);float h_floors=h/u_ao[1];float y_shade=1.0-0.9*intensity*min(v_ao.y,1.0);float shade=(1.0-0.08*intensity)*(y_shade+(1.0-y_shade)*(1.0-pow(1.0-min(h_floors/16.0,1.0),16.0)))+0.08*intensity*min(h_floors/160.0,1.0);float concave=v_ao.x*v_ao.x;float x_shade=mix(1.0,mix(0.6,0.75,min(h_floors/30.0,1.0)),intensity)+0.1*intensity*min(h,1.0);shade*=mix(1.0,x_shade*x_shade*x_shade,concave);out_color.rgb=out_color.rgb*shade;\n#endif\n#ifdef FOG\nout_color=fog_dither(fog_apply_premultiplied(out_color,v_fog_pos));\n#endif\n#ifdef INDICATOR_CUTOUT\nout_color=applyCutout(out_color);\n#endif\ngl_FragColor=out_color;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\nHANDLE_WIREFRAME_DEBUG;}","uniform mat4 u_matrix;uniform vec2 u_pixel_coord_upper;uniform vec2 u_pixel_coord_lower;uniform float u_height_factor;uniform float u_tile_units_to_pixels;uniform float u_vertical_gradient;uniform lowp float u_opacity;uniform vec3 u_lightcolor;uniform lowp vec3 u_lightpos;uniform lowp float u_lightintensity;attribute vec4 a_pos_normal_ed;attribute vec2 a_centroid_pos;\n#ifdef PROJECTION_GLOBE_VIEW\nattribute vec3 a_pos_3;attribute vec3 a_pos_normal_3;uniform mat4 u_inv_rot_matrix;uniform vec2 u_merc_center;uniform vec3 u_tile_id;uniform float u_zoom_transition;uniform vec3 u_up_dir;uniform float u_height_lift;\n#endif\nvarying vec2 v_pos;varying vec4 v_lighting;\n#ifdef FAUX_AO\nuniform lowp vec2 u_ao;varying vec3 v_ao;\n#endif\n#ifdef LIGHTING_3D_MODE\nvarying vec3 v_normal;\n#endif\n#pragma mapbox: define highp float base\n#pragma mapbox: define highp float height\n#pragma mapbox: define mediump vec4 pattern\n#pragma mapbox: define highp float pixel_ratio\nvoid main() {\n#pragma mapbox: initialize highp float base\n#pragma mapbox: initialize highp float height\n#pragma mapbox: initialize mediump vec4 pattern\n#pragma mapbox: initialize highp float pixel_ratio\nvec2 pattern_tl=pattern.xy;vec2 pattern_br=pattern.zw;vec4 pos_nx=floor(a_pos_normal_ed*0.5);mediump vec4 top_up_ny_start=a_pos_normal_ed-2.0*pos_nx;mediump vec3 top_up_ny=top_up_ny_start.xyz;float x_normal=pos_nx.z/8192.0;vec3 normal=top_up_ny.y==1.0 ? vec3(0.0,0.0,1.0) : normalize(vec3(x_normal,(2.0*top_up_ny.z-1.0)*(1.0-abs(x_normal)),0.0));float edgedistance=a_pos_normal_ed.w;vec2 display_size=(pattern_br-pattern_tl)/pixel_ratio;base=max(0.0,base);height=max(0.0,height);float t=top_up_ny.x;float z=t > 0.0 ? height : base;vec2 centroid_pos=vec2(0.0);\n#if defined(HAS_CENTROID) || defined(TERRAIN)\ncentroid_pos=a_centroid_pos;\n#endif\nfloat ele=0.0;float h=z;vec3 p;float c_ele;\n#ifdef TERRAIN\nbool flat_roof=centroid_pos.x !=0.0 && t > 0.0;ele=elevation(pos_nx.xy);c_ele=flat_roof ? centroid_pos.y==0.0 ? elevationFromUint16(centroid_pos.x) : flatElevation(centroid_pos) : ele;h=flat_roof ? max(c_ele+height,ele+base+2.0) : ele+(t > 0.0 ? height : base==0.0 ?-5.0 : base);p=vec3(pos_nx.xy,h);\n#else\np=vec3(pos_nx.xy,z);\n#endif\n#ifdef PROJECTION_GLOBE_VIEW\nfloat lift=float((t+base) > 0.0)*u_height_lift;h+=lift;vec3 globe_normal=normalize(mix(a_pos_normal_3/16384.0,u_up_dir,u_zoom_transition));vec3 globe_pos=a_pos_3+globe_normal*(u_tile_up_scale*(p.z+lift));vec3 merc_pos=mercator_tile_position(u_inv_rot_matrix,p.xy,u_tile_id,u_merc_center)+u_up_dir*u_tile_up_scale*p.z;p=mix_globe_mercator(globe_pos,merc_pos,u_zoom_transition);\n#endif\nfloat hidden=float(centroid_pos.x==0.0 && centroid_pos.y==1.0);gl_Position=mix(u_matrix*vec4(p,1),AWAY,hidden);vec2 pos=normal.z==1.0\n? pos_nx.xy\n: vec2(edgedistance,z*u_height_factor);v_pos=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,display_size,u_tile_units_to_pixels,pos);v_lighting=vec4(0.0,0.0,0.0,1.0);float NdotL=0.0;\n#ifdef LIGHTING_3D_MODE\nNdotL=calculate_NdotL(normal);\n#else\nNdotL=clamp(dot(normal,u_lightpos),0.0,1.0);NdotL=mix((1.0-u_lightintensity),max((0.5+u_lightintensity),1.0),NdotL);\n#endif\nif (normal.y !=0.0) {float r=0.84;\n#ifndef LIGHTING_3D_MODE\nr=mix(0.7,0.98,1.0-u_lightintensity);\n#endif\nNdotL*=(\n(1.0-u_vertical_gradient)+(u_vertical_gradient*clamp((t+base)*pow(height/150.0,0.5),r,1.0)));}\n#ifdef FAUX_AO\nfloat concave=pos_nx.w-floor(pos_nx.w*0.5)*2.0;float start=top_up_ny_start.w;float y_ground=1.0-clamp(t+base,0.0,1.0);float top_height=height;\n#ifdef TERRAIN\ntop_height=mix(max(c_ele+height,ele+base+2.0),ele+height,float(centroid_pos.x==0.0))-ele;y_ground+=y_ground*5.0/max(3.0,top_height);\n#endif\nv_ao=vec3(mix(concave,-concave,start),y_ground,h-ele);NdotL*=(1.0+0.05*(1.0-top_up_ny.y)*u_ao[0]);\n#ifdef PROJECTION_GLOBE_VIEW\ntop_height+=u_height_lift;\n#endif\ngl_Position.z-=(0.0000006*(min(top_height,500.)+2.0*min(base,500.0)+60.0*concave+3.0*start))*gl_Position.w;\n#endif\n#ifdef LIGHTING_3D_MODE\nv_normal=normal;\n#else\nv_lighting.rgb+=clamp(NdotL*u_lightcolor,mix(vec3(0.0),vec3(0.3),1.0-u_lightcolor),vec3(1.0));v_lighting*=u_opacity;\n#endif \n#ifdef FOG\nv_fog_pos=fog_position(p);\n#endif\n}"),groundShadow:dE("#ifdef GL_ES\nprecision highp float;\n#endif\nuniform vec3 u_ground_shadow_factor;varying vec4 v_pos_light_view_0;varying vec4 v_pos_light_view_1;varying float v_depth;\n#ifdef FOG\nvarying float v_fog_opacity;\n#endif\nvoid main() {float light=shadowed_light_factor(v_pos_light_view_0,v_pos_light_view_1,v_depth);vec3 shadow=mix(u_ground_shadow_factor,vec3(1.0),light);\n#ifdef RENDER_CUTOFF\nshadow=mix(vec3(1.0),shadow,cutoff_opacity(u_cutoff_params,v_depth));\n#endif\n#ifdef FOG\nshadow=mix(shadow,vec3(1.0),v_fog_opacity);\n#endif\n#ifdef INDICATOR_CUTOUT\nshadow=mix(shadow,vec3(1.0),1.0-applyCutout(vec4(1.0)).r);\n#endif\ngl_FragColor=vec4(shadow,1.0);}","uniform mat4 u_matrix;uniform mat4 u_light_matrix_0;uniform mat4 u_light_matrix_1;attribute vec2 a_pos;varying vec4 v_pos_light_view_0;varying vec4 v_pos_light_view_1;varying float v_depth;\n#ifdef FOG\nvarying float v_fog_opacity;\n#endif\nvoid main() {gl_Position=u_matrix*vec4(a_pos,0.0,1.0);v_pos_light_view_0=u_light_matrix_0*vec4(a_pos,0.0,1.0);v_pos_light_view_1=u_light_matrix_1*vec4(a_pos,0.0,1.0);v_depth=gl_Position.w;\n#ifdef FOG\nv_fog_pos=fog_position(a_pos);v_fog_opacity=fog(v_fog_pos);\n#endif\n}"),fillExtrusionGroundEffect:dE("uniform highp float u_ao_pass;uniform highp float u_opacity;uniform highp float u_flood_light_intensity;uniform highp vec3 u_flood_light_color;uniform highp float u_attenuation;uniform sampler2D u_fb;uniform float u_fb_size;\n#ifdef SDF_SUBPASS\nvarying highp vec2 v_pos;varying highp vec4 v_line_segment;varying highp float v_flood_light_radius_tile;varying highp vec2 v_ao;float line_df(highp vec2 a,highp vec2 b,highp vec2 p) {highp vec2 ba=b-a;highp vec2 pa=p-a;highp float r=clamp(dot(pa,ba)/dot(ba,ba),0.0,1.0);return length(pa-r*ba);}\n#ifdef FOG\nvarying highp float v_fog;\n#endif\n#endif\nvoid main() {\n#ifdef CLEAR_SUBPASS\nvec4 color=vec4(1.0);\n#ifdef CLEAR_FROM_TEXTURE\ncolor=texture2D(u_fb,gl_FragCoord.xy/vec2(u_fb_size));\n#endif\ngl_FragColor=color;\n#else\n#ifdef SDF_SUBPASS\nhighp float d=line_df(v_line_segment.xy,v_line_segment.zw,v_pos);highp float effect_radius=mix(v_flood_light_radius_tile,v_ao.y,u_ao_pass);d/=effect_radius;d=min(d,1.0);d=1.0-pow(1.0-d,u_attenuation);highp float effect_intensity=mix(u_flood_light_intensity,v_ao.x,u_ao_pass);highp float fog=1.0;\n#ifdef FOG\nfog=v_fog;\n#endif\n#ifdef RENDER_CUTOFF\nfog*=v_cutoff_opacity;\n#endif\ngl_FragColor=vec4(vec3(0.0),mix(1.0,d,effect_intensity*u_opacity*fog));\n#else\nvec4 color=mix(vec4(u_flood_light_color,1.0),vec4(vec3(0.0),1.0),u_ao_pass);\n#ifdef OVERDRAW_INSPECTOR\ncolor=vec4(1.0);\n#endif\ngl_FragColor=color;HANDLE_WIREFRAME_DEBUG;\n#endif\n#endif\n}","attribute highp vec4 a_pos_end;attribute highp float a_angular_offset_factor;attribute highp float a_hidden_by_landmark;\n#ifdef SDF_SUBPASS\nvarying highp vec2 v_pos;varying highp vec4 v_line_segment;varying highp float v_flood_light_radius_tile;varying highp vec2 v_ao;\n#ifdef FOG\nvarying highp float v_fog;\n#endif\n#endif\nuniform highp float u_flood_light_intensity;uniform highp mat4 u_matrix;uniform highp float u_ao_pass;uniform highp float u_meter_to_tile;uniform highp float u_edge_radius;uniform highp vec2 u_ao;\n#pragma mapbox: define highp float flood_light_ground_radius\n#pragma mapbox: define highp float base\nconst float TANGENT_CUTOFF=4.0;void main() {\n#pragma mapbox: initialize highp float flood_light_ground_radius\n#pragma mapbox: initialize highp float base\nvec2 p=a_pos_end.xy;vec2 q=floor(a_pos_end.zw*0.5);vec2 start_bottom=a_pos_end.zw-q*2.0;float flood_radius_tile=flood_light_ground_radius*u_meter_to_tile;vec2 v=normalize(q-p);float ao_radius=u_ao.y/3.5;float effect_radius=mix(flood_radius_tile,ao_radius,u_ao_pass)+u_edge_radius;float angular_offset_factor=a_angular_offset_factor/EXTENT*TANGENT_CUTOFF;float angular_offset=angular_offset_factor*effect_radius;float top=1.0-start_bottom.y;float side=(0.5-start_bottom.x)*2.0;vec2 extrusion_parallel=v*side*mix(effect_radius/10.0,angular_offset,top);vec2 perp=vec2(v.y,-v.x);vec2 extrusion_perp=perp*effect_radius*top;vec3 pos=vec3(mix(q,p,start_bottom.x),0.0);pos.xy+=extrusion_parallel+extrusion_perp;\n#ifdef SDF_SUBPASS\nv_pos=pos.xy;v_line_segment=vec4(p,q)+perp.xyxy*u_edge_radius;v_flood_light_radius_tile=flood_radius_tile;v_ao=vec2(u_ao.x,ao_radius);\n#ifdef FOG\nv_fog_pos=fog_position(pos);v_fog=1.0-fog(v_fog_pos);\n#endif\n#endif\nfloat hidden_by_landmark=0.0;\n#ifdef HAS_CENTROID\nhidden_by_landmark=a_hidden_by_landmark;\n#endif\nfloat isFloodlit=float(flood_light_ground_radius > 0.0 && u_flood_light_intensity > 0.0);float hidden=mix(1.0-isFloodlit,isFloodlit,u_ao_pass);hidden+=float(base > 0.0);hidden+=hidden_by_landmark;gl_Position=mix(u_matrix*vec4(pos,1.0),AWAY,float(hidden > 0.0));\n#ifdef RENDER_CUTOFF\nv_cutoff_opacity=cutoff_opacity(u_cutoff_params,gl_Position.z);\n#endif\n}"),hillshadePrepare:dE("#ifdef GL_ES\nprecision highp float;\n#endif\nuniform sampler2D u_image;varying vec2 v_pos;uniform vec2 u_dimension;uniform float u_zoom;uniform vec4 u_unpack;float getElevation(vec2 coord) {\n#ifdef TERRAIN_DEM_FLOAT_FORMAT\nreturn texture(u_image,coord).r/4.0;\n#else\nvec4 data=texture2D(u_image,coord)*255.0;data.a=-1.0;return dot(data,u_unpack)/4.0;\n#endif\n}void main() {vec2 epsilon=1.0/u_dimension;float a=getElevation(v_pos+vec2(-epsilon.x,-epsilon.y));float b=getElevation(v_pos+vec2(0,-epsilon.y));float c=getElevation(v_pos+vec2(epsilon.x,-epsilon.y));float d=getElevation(v_pos+vec2(-epsilon.x,0));float e=getElevation(v_pos+vec2(epsilon.x,0));float f=getElevation(v_pos+vec2(-epsilon.x,epsilon.y));float g=getElevation(v_pos+vec2(0,epsilon.y));float h=getElevation(v_pos+vec2(epsilon.x,epsilon.y));float exaggerationFactor=u_zoom < 2.0 ? 0.4 : u_zoom < 4.5 ? 0.35 : 0.3;float exaggeration=u_zoom < 15.0 ? (u_zoom-15.0)*exaggerationFactor : 0.0;vec2 deriv=vec2(\n(c+e+e+h)-(a+d+d+f),(f+g+g+h)-(a+b+b+c)\n)/pow(2.0,exaggeration+(19.2562-u_zoom));gl_FragColor=clamp(vec4(\nderiv.x/2.0+0.5,deriv.y/2.0+0.5,1.0,1.0),0.0,1.0);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","uniform mat4 u_matrix;uniform vec2 u_dimension;attribute vec2 a_pos;attribute vec2 a_texture_pos;varying vec2 v_pos;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);highp vec2 epsilon=1.0/u_dimension;float scale=(u_dimension.x-2.0)/u_dimension.x;v_pos=(a_texture_pos/8192.0)*scale+epsilon;}"),hillshade:dE("uniform sampler2D u_image;varying vec2 v_pos;uniform vec2 u_latrange;uniform vec2 u_light;uniform vec4 u_shadow;uniform vec4 u_highlight;uniform vec4 u_accent;void main() {vec4 pixel=texture2D(u_image,v_pos);vec2 deriv=((pixel.rg*2.0)-1.0);float scaleFactor=cos(radians((u_latrange[0]-u_latrange[1])*(1.0-v_pos.y)+u_latrange[1]));float slope=atan(1.25*length(deriv)/scaleFactor);float aspect=deriv.x !=0.0 ? atan(deriv.y,-deriv.x) : PI/2.0*(deriv.y > 0.0 ? 1.0 :-1.0);float intensity=u_light.x;float azimuth=u_light.y+PI;float base=1.875-intensity*1.75;float maxValue=0.5*PI;float scaledSlope=intensity !=0.5 ? ((pow(base,slope)-1.0)/(pow(base,maxValue)-1.0))*maxValue : slope;float accent=cos(scaledSlope);vec4 accent_color=(1.0-accent)*u_accent*clamp(intensity*2.0,0.0,1.0);float shade=abs(mod((aspect+azimuth)/PI+0.5,2.0)-1.0);vec4 shade_color=mix(u_shadow,u_highlight,shade)*sin(scaledSlope)*clamp(intensity*2.0,0.0,1.0);gl_FragColor=accent_color*(1.0-shade_color.a)+shade_color;\n#ifdef LIGHTING_3D_MODE\ngl_FragColor=apply_lighting_ground(gl_FragColor);\n#endif\n#ifdef FOG\ngl_FragColor=fog_dither(fog_apply_premultiplied(gl_FragColor,v_fog_pos));\n#endif\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\nHANDLE_WIREFRAME_DEBUG;}","uniform mat4 u_matrix;attribute vec2 a_pos;attribute vec2 a_texture_pos;varying vec2 v_pos;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);v_pos=a_texture_pos/8192.0;\n#ifdef FOG\nv_fog_pos=fog_position(a_pos);\n#endif\n}"),line:dE("uniform lowp float u_device_pixel_ratio;uniform float u_alpha_discard_threshold;uniform highp vec2 u_trim_offset;varying vec2 v_width2;varying vec2 v_normal;varying float v_gamma_scale;varying highp vec4 v_uv;\n#ifdef RENDER_LINE_DASH\nuniform sampler2D u_dash_image;varying vec2 v_tex;\n#endif\n#ifdef RENDER_LINE_GRADIENT\nuniform sampler2D u_gradient_image;\n#endif\nfloat luminance(vec3 c) {return (c.r+c.r+c.b+c.g+c.g+c.g)*0.1667;}uniform float u_emissive_strength;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float floorwidth\n#pragma mapbox: define lowp vec4 dash\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float border_width\n#pragma mapbox: define lowp vec4 border_color\nfloat linearstep(float edge0,float edge1,float x) {return  clamp((x-edge0)/(edge1-edge0),0.0,1.0);}void main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float floorwidth\n#pragma mapbox: initialize lowp vec4 dash\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float border_width\n#pragma mapbox: initialize lowp vec4 border_color\nfloat dist=length(v_normal)*v_width2.s;float blur2=(blur+1.0/u_device_pixel_ratio)*v_gamma_scale;float alpha=clamp(min(dist-(v_width2.t-blur2),v_width2.s-dist)/blur2,0.0,1.0);\n#ifdef RENDER_LINE_DASH\nfloat sdfdist=texture2D(u_dash_image,v_tex).a;float sdfgamma=1.0/(2.0*u_device_pixel_ratio)/dash.z;alpha*=linearstep(0.5-sdfgamma/floorwidth,0.5+sdfgamma/floorwidth,sdfdist);\n#endif\nhighp vec4 out_color;\n#ifdef RENDER_LINE_GRADIENT\nout_color=texture2D(u_gradient_image,v_uv.xy);\n#else\nout_color=color;\n#endif\nfloat trimmed=1.0;\n#ifdef RENDER_LINE_TRIM_OFFSET\nhighp float start=v_uv[2];highp float end=v_uv[3];highp float trim_start=u_trim_offset[0];highp float trim_end=u_trim_offset[1];highp float line_progress=(start+(v_uv.x)*(end-start));if (trim_end > trim_start) {if (line_progress <=trim_end && line_progress >=trim_start) {out_color=vec4(0,0,0,0);trimmed=0.0;}}\n#endif\n#ifdef RENDER_LINE_ALPHA_DISCARD\nif (alpha < u_alpha_discard_threshold) {discard;}\n#endif\n#ifdef RENDER_LINE_BORDER\nfloat edgeBlur=(border_width+1.0/u_device_pixel_ratio);float alpha2=clamp(min(dist-(v_width2.t-edgeBlur),v_width2.s-dist)/edgeBlur,0.0,1.0);if (alpha2 < 1.) {float smoothAlpha=smoothstep(0.6,1.0,alpha2);\n#ifdef RENDER_LINE_BORDER_AUTO\nfloat Y=(out_color.a > 0.01) ? luminance(out_color.rgb/out_color.a) : 1.;float adjustment=(Y > 0.) ? 0.5/Y : 0.45;if (out_color.a > 0.25 && Y < 0.25) {vec3 borderColor=(Y > 0.) ? out_color.rgb : vec3(1,1,1)*out_color.a;out_color.rgb=out_color.rgb+borderColor*(adjustment*(1.0-smoothAlpha));} else {out_color.rgb*=(0.6 +0.4*smoothAlpha);}\n#else\nout_color.rgb=mix(border_color.rgb*border_color.a*trimmed,out_color.rgb,smoothAlpha);\n#endif\n}\n#endif\n#ifdef LIGHTING_3D_MODE\nout_color=apply_lighting_with_emission_ground(out_color,u_emissive_strength);\n#endif\n#ifdef FOG\nout_color=fog_dither(fog_apply_premultiplied(out_color,v_fog_pos));\n#endif\nout_color*=(alpha*opacity);\n#ifdef INDICATOR_CUTOUT\nout_color=applyCutout(out_color);\n#endif\ngl_FragColor=out_color;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\nHANDLE_WIREFRAME_DEBUG;}","\n#define EXTRUDE_SCALE 0.015873016\nattribute vec2 a_pos_normal;attribute vec4 a_data;\n#if defined(RENDER_LINE_GRADIENT) || defined(RENDER_LINE_TRIM_OFFSET)\nattribute highp vec4 a_packed;\n#endif\n#ifdef RENDER_LINE_DASH\nattribute float a_linesofar;\n#endif\nuniform mat4 u_matrix;uniform mat2 u_pixels_to_tile_units;uniform vec2 u_units_to_pixels;uniform lowp float u_device_pixel_ratio;varying vec2 v_normal;varying vec2 v_width2;varying float v_gamma_scale;varying highp vec4 v_uv;\n#ifdef RENDER_LINE_DASH\nuniform vec2 u_texsize;uniform float u_tile_units_to_pixels;varying vec2 v_tex;\n#endif\n#ifdef RENDER_LINE_GRADIENT\nuniform float u_image_height;\n#endif\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float floorwidth\n#pragma mapbox: define lowp vec4 dash\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define mediump float gapwidth\n#pragma mapbox: define lowp float offset\n#pragma mapbox: define mediump float width\n#pragma mapbox: define lowp float border_width\n#pragma mapbox: define lowp vec4 border_color\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float floorwidth\n#pragma mapbox: initialize lowp vec4 dash\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump float gapwidth\n#pragma mapbox: initialize lowp float offset\n#pragma mapbox: initialize mediump float width\n#pragma mapbox: initialize lowp float border_width\n#pragma mapbox: initialize lowp vec4 border_color\nfloat ANTIALIASING=1.0/u_device_pixel_ratio/2.0;vec2 a_extrude=a_data.xy-128.0;float a_direction=mod(a_data.z,4.0)-1.0;vec2 pos=floor(a_pos_normal*0.5);mediump vec2 normal=a_pos_normal-2.0*pos;normal.y=normal.y*2.0-1.0;v_normal=normal;gapwidth=gapwidth/2.0;float halfwidth=width/2.0;offset=-1.0*offset;float inset=gapwidth+(gapwidth > 0.0 ? ANTIALIASING : 0.0);float outset=gapwidth+halfwidth*(gapwidth > 0.0 ? 2.0 : 1.0)+(halfwidth==0.0 ? 0.0 : ANTIALIASING);mediump vec2 dist=outset*a_extrude*EXTRUDE_SCALE;mediump float u=0.5*a_direction;mediump float t=1.0-abs(u);mediump vec2 offset2=offset*a_extrude*EXTRUDE_SCALE*normal.y*mat2(t,-u,u,t);vec4 projected_extrude=u_matrix*vec4(dist*u_pixels_to_tile_units,0.0,0.0);gl_Position=u_matrix*vec4(pos+offset2*u_pixels_to_tile_units,0.0,1.0)+projected_extrude;\n#ifndef RENDER_TO_TEXTURE\nfloat extrude_length_without_perspective=length(dist);float extrude_length_with_perspective=length(projected_extrude.xy/gl_Position.w*u_units_to_pixels);v_gamma_scale=extrude_length_without_perspective/extrude_length_with_perspective;\n#else\nv_gamma_scale=1.0;\n#endif\n#if defined(RENDER_LINE_GRADIENT) || defined(RENDER_LINE_TRIM_OFFSET)\nfloat a_uv_x=a_packed[0];float a_split_index=a_packed[1];highp float a_clip_start=a_packed[2];highp float a_clip_end=a_packed[3];\n#ifdef RENDER_LINE_GRADIENT\nhighp float texel_height=1.0/u_image_height;highp float half_texel_height=0.5*texel_height;v_uv=vec4(a_uv_x,a_split_index*texel_height-half_texel_height,a_clip_start,a_clip_end);\n#else\nv_uv=vec4(a_uv_x,0.0,a_clip_start,a_clip_end);\n#endif\n#endif\n#ifdef RENDER_LINE_DASH\nfloat scale=dash.z==0.0 ? 0.0 : u_tile_units_to_pixels/dash.z;float height=dash.y;v_tex=vec2(a_linesofar*scale/floorwidth,(-normal.y*height+dash.x+0.5)/u_texsize.y);\n#endif\nv_width2=vec2(outset,inset);\n#ifdef FOG\nv_fog_pos=fog_position(pos);\n#endif\n}"),linePattern:dE("uniform lowp float u_device_pixel_ratio;uniform vec2 u_texsize;uniform float u_tile_units_to_pixels;uniform sampler2D u_image;varying vec2 v_normal;varying vec2 v_width2;varying float v_linesofar;varying float v_gamma_scale;varying float v_width;\n#pragma mapbox: define lowp vec4 pattern\n#pragma mapbox: define lowp float pixel_ratio\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize mediump vec4 pattern\n#pragma mapbox: initialize lowp float pixel_ratio\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\nvec2 pattern_tl=pattern.xy;vec2 pattern_br=pattern.zw;vec2 display_size=(pattern_br-pattern_tl)/pixel_ratio;vec2 pattern_size=vec2(display_size.x/u_tile_units_to_pixels,display_size.y);float aspect=display_size.y/v_width;float dist=length(v_normal)*v_width2.s;float blur2=(blur+1.0/u_device_pixel_ratio)*v_gamma_scale;float alpha=clamp(min(dist-(v_width2.t-blur2),v_width2.s-dist)/blur2,0.0,1.0);float x=mod(v_linesofar/pattern_size.x*aspect,1.0);float y=0.5*v_normal.y+0.5;vec2 texel_size=1.0/u_texsize;vec2 pos=mix(pattern_tl*texel_size-texel_size,pattern_br*texel_size+texel_size,vec2(x,y));vec4 color=texture2D(u_image,pos);\n#ifdef LIGHTING_3D_MODE\ncolor=apply_lighting_ground(color);\n#endif\n#ifdef FOG\ncolor=fog_dither(fog_apply_premultiplied(color,v_fog_pos));\n#endif\ncolor*=(alpha*opacity);\n#ifdef INDICATOR_CUTOUT\ncolor=applyCutout(color);\n#endif\ngl_FragColor=color;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\nHANDLE_WIREFRAME_DEBUG;}","\n#define scale 0.015873016\nattribute vec2 a_pos_normal;attribute vec4 a_data;attribute float a_linesofar;uniform mat4 u_matrix;uniform vec2 u_units_to_pixels;uniform mat2 u_pixels_to_tile_units;uniform lowp float u_device_pixel_ratio;varying vec2 v_normal;varying vec2 v_width2;varying float v_linesofar;varying float v_gamma_scale;varying float v_width;\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float offset\n#pragma mapbox: define mediump float gapwidth\n#pragma mapbox: define mediump float width\n#pragma mapbox: define lowp float floorwidth\n#pragma mapbox: define lowp vec4 pattern\n#pragma mapbox: define lowp float pixel_ratio\nvoid main() {\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float offset\n#pragma mapbox: initialize mediump float gapwidth\n#pragma mapbox: initialize mediump float width\n#pragma mapbox: initialize lowp float floorwidth\n#pragma mapbox: initialize mediump vec4 pattern\n#pragma mapbox: initialize lowp float pixel_ratio\nfloat ANTIALIASING=1.0/u_device_pixel_ratio/2.0;vec2 a_extrude=a_data.xy-128.0;float a_direction=mod(a_data.z,4.0)-1.0;vec2 pos=floor(a_pos_normal*0.5);mediump vec2 normal=a_pos_normal-2.0*pos;normal.y=normal.y*2.0-1.0;v_normal=normal;gapwidth=gapwidth/2.0;float halfwidth=width/2.0;offset=-1.0*offset;float inset=gapwidth+(gapwidth > 0.0 ? ANTIALIASING : 0.0);float outset=gapwidth+halfwidth*(gapwidth > 0.0 ? 2.0 : 1.0)+(halfwidth==0.0 ? 0.0 : ANTIALIASING);mediump vec2 dist=outset*a_extrude*scale;mediump float u=0.5*a_direction;mediump float t=1.0-abs(u);mediump vec2 offset2=offset*a_extrude*scale*normal.y*mat2(t,-u,u,t);vec4 projected_extrude=u_matrix*vec4(dist*u_pixels_to_tile_units,0.0,0.0);gl_Position=u_matrix*vec4(pos+offset2*u_pixels_to_tile_units,0.0,1.0)+projected_extrude;\n#ifndef RENDER_TO_TEXTURE\nfloat extrude_length_without_perspective=length(dist);float extrude_length_with_perspective=length(projected_extrude.xy/gl_Position.w*u_units_to_pixels);v_gamma_scale=extrude_length_without_perspective/extrude_length_with_perspective;\n#else\nv_gamma_scale=1.0;\n#endif\nv_linesofar=a_linesofar;v_width2=vec2(outset,inset);v_width=floorwidth;\n#ifdef FOG\nv_fog_pos=fog_position(pos);\n#endif\n}"),raster:dE("uniform float u_fade_t;uniform float u_opacity;uniform sampler2D u_image0;uniform sampler2D u_image1;varying vec2 v_pos0;varying vec2 v_pos1;uniform float u_brightness_low;uniform float u_brightness_high;uniform float u_saturation_factor;uniform float u_contrast_factor;uniform vec3 u_spin_weights;\n#ifdef RASTER_COLOR\nuniform sampler2D u_color_ramp;uniform highp vec2 u_colorization_scale;uniform highp vec4 u_colorization_mix;highp vec4 colormap (highp float value) {highp float scaled_value=value*u_colorization_scale.y+u_colorization_scale.x;highp vec2 coords=vec2(scaled_value,0.5);return texture2D(u_color_ramp,coords);}\n#endif\nvoid main() {vec4 color0=texture2D(u_image0,v_pos0);vec4 color1=texture2D(u_image1,v_pos1);vec4 color;\n#ifdef RASTER_COLOR\nhighp vec4 fadedColor=mix(color0,color1,u_fade_t);color=colormap(dot(vec4(fadedColor.rgb,1),u_colorization_mix));color.a*=fadedColor.a;if (color.a > 0.0) {color.rgb/=color.a;}\n#else\nif (color0.a > 0.0) {color0.rgb/=color0.a;}if (color1.a > 0.0) {color1.rgb/=color1.a;}color=mix(color0,color1,u_fade_t);\n#endif\ncolor.a*=u_opacity;vec3 rgb=color.rgb;rgb=vec3(\ndot(rgb,u_spin_weights.xyz),dot(rgb,u_spin_weights.zxy),dot(rgb,u_spin_weights.yzx));float average=(color.r+color.g+color.b)/3.0;rgb+=(average-rgb)*u_saturation_factor;rgb=(rgb-0.5)*u_contrast_factor+0.5;vec3 u_high_vec=vec3(u_brightness_low,u_brightness_low,u_brightness_low);vec3 u_low_vec=vec3(u_brightness_high,u_brightness_high,u_brightness_high);vec3 out_color=mix(u_high_vec,u_low_vec,rgb);\n#ifdef LIGHTING_3D_MODE\nout_color=apply_lighting_ground(out_color);\n#endif\n#ifdef FOG\nout_color=fog_dither(fog_apply(out_color,v_fog_pos));\n#endif\ngl_FragColor=vec4(out_color*color.a,color.a);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\nHANDLE_WIREFRAME_DEBUG;}","uniform mat4 u_matrix;uniform vec2 u_tl_parent;uniform float u_scale_parent;uniform vec2 u_perspective_transform;attribute vec2 a_pos;attribute vec2 a_texture_pos;varying vec2 v_pos0;varying vec2 v_pos1;void main() {float w=1.0+dot(a_texture_pos,u_perspective_transform);gl_Position=u_matrix*vec4(a_pos*w,0,w);v_pos0=a_texture_pos/8192.0;v_pos1=(v_pos0*u_scale_parent)+u_tl_parent;\n#ifdef FOG\nv_fog_pos=fog_position(a_pos);\n#endif\n}"),symbolIcon:dE("uniform sampler2D u_texture;\n#ifdef ICON_TRANSITION\nuniform float u_icon_transition;\n#endif\nvarying float v_fade_opacity;varying vec2 v_tex_a;\n#ifdef ICON_TRANSITION\nvarying vec2 v_tex_b;\n#endif\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float emissive_strength\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float emissive_strength\nlowp float alpha=opacity*v_fade_opacity;vec4 out_color;\n#ifdef ICON_TRANSITION\nvec4 a=texture2D(u_texture,v_tex_a)*(1.0-u_icon_transition);vec4 b=texture2D(u_texture,v_tex_b)*u_icon_transition;out_color=(a+b)*alpha;\n#else\nout_color=texture2D(u_texture,v_tex_a)*alpha;\n#endif\n#ifdef LIGHTING_3D_MODE\nout_color=apply_lighting_with_emission_ground(out_color,emissive_strength);\n#endif\ngl_FragColor=out_color;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\nHANDLE_WIREFRAME_DEBUG;}","attribute vec4 a_pos_offset;attribute vec4 a_tex_size;attribute vec4 a_pixeloffset;attribute vec4 a_projected_pos;attribute float a_fade_opacity;\n#ifdef Z_OFFSET\nattribute float a_z_offset;\n#endif\n#ifdef PROJECTION_GLOBE_VIEW\nattribute vec3 a_globe_anchor;attribute vec3 a_globe_normal;\n#endif\n#ifdef ICON_TRANSITION\nattribute vec2 a_texb;\n#endif\nuniform bool u_is_size_zoom_constant;uniform bool u_is_size_feature_constant;uniform highp float u_size_t;uniform highp float u_size;uniform highp float u_camera_to_center_distance;uniform bool u_rotate_symbol;uniform highp float u_aspect_ratio;uniform float u_fade_change;uniform mat4 u_matrix;uniform mat4 u_label_plane_matrix;uniform mat4 u_coord_matrix;uniform bool u_is_text;uniform bool u_pitch_with_map;uniform vec2 u_texsize;uniform vec3 u_up_vector;\n#ifdef PROJECTION_GLOBE_VIEW\nuniform vec3 u_tile_id;uniform mat4 u_inv_rot_matrix;uniform vec2 u_merc_center;uniform vec3 u_camera_forward;uniform float u_zoom_transition;uniform vec3 u_ecef_origin;uniform mat4 u_tile_matrix;\n#endif\nvarying vec2 v_tex_a;\n#ifdef ICON_TRANSITION\nvarying vec2 v_tex_b;\n#endif\nvarying float v_fade_opacity;\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float emissive_strength\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float emissive_strength\nvec2 a_pos=a_pos_offset.xy;vec2 a_offset=a_pos_offset.zw;vec2 a_tex=a_tex_size.xy;vec2 a_size=a_tex_size.zw;float a_size_min=floor(a_size[0]*0.5);vec2 a_pxoffset=a_pixeloffset.xy;vec2 a_min_font_scale=a_pixeloffset.zw/256.0;highp float segment_angle=-a_projected_pos[3];float size;if (!u_is_size_zoom_constant && !u_is_size_feature_constant) {size=mix(a_size_min,a_size[1],u_size_t)/128.0;} else if (u_is_size_zoom_constant && !u_is_size_feature_constant) {size=a_size_min/128.0;} else {size=u_size;}vec2 tile_anchor=a_pos;float e=elevation(tile_anchor);\n#ifdef Z_OFFSET\ne+=a_z_offset;\n#endif\nvec3 h=elevationVector(tile_anchor)*e;float globe_occlusion_fade;vec3 world_pos;vec3 mercator_pos;\n#ifdef PROJECTION_GLOBE_VIEW\nmercator_pos=mercator_tile_position(u_inv_rot_matrix,tile_anchor,u_tile_id,u_merc_center);world_pos=mix_globe_mercator(a_globe_anchor+h,mercator_pos,u_zoom_transition);vec4 ecef_point=u_tile_matrix*vec4(world_pos,1.0);vec3 origin_to_point=ecef_point.xyz-u_ecef_origin;globe_occlusion_fade=dot(origin_to_point,u_camera_forward) >=0.0 ? 0.0 : 1.0;\n#else\nworld_pos=vec3(tile_anchor,0)+h;globe_occlusion_fade=1.0;\n#endif\nvec4 projected_point=u_matrix*vec4(world_pos,1);highp float camera_to_anchor_distance=projected_point.w;highp float distance_ratio=u_pitch_with_map ?\ncamera_to_anchor_distance/u_camera_to_center_distance :\nu_camera_to_center_distance/camera_to_anchor_distance;highp float perspective_ratio=clamp(\n0.5+0.5*distance_ratio,0.0,1.5);size*=perspective_ratio;float font_scale=u_is_text ? size/24.0 : size;highp float symbol_rotation=0.0;if (u_rotate_symbol) {vec4 offsetProjected_point;\n#ifdef PROJECTION_GLOBE_VIEW\nvec3 displacement=vec3(a_globe_normal.z,0,-a_globe_normal.x);offsetProjected_point=u_matrix*vec4(a_globe_anchor+displacement,1);\n#else\noffsetProjected_point=u_matrix*vec4(tile_anchor+vec2(1,0),0,1);\n#endif\nvec2 a=projected_point.xy/projected_point.w;vec2 b=offsetProjected_point.xy/offsetProjected_point.w;symbol_rotation=atan((b.y-a.y)/u_aspect_ratio,b.x-a.x);}vec4 projected_pos;\n#ifdef PROJECTION_GLOBE_VIEW\nvec3 proj_pos=mix_globe_mercator(a_projected_pos.xyz+h,mercator_pos,u_zoom_transition);projected_pos=u_label_plane_matrix*vec4(proj_pos,1.0);\n#else\nprojected_pos=u_label_plane_matrix*vec4(a_projected_pos.xy,h.z,1.0);\n#endif\nhighp float angle_sin=sin(segment_angle+symbol_rotation);highp float angle_cos=cos(segment_angle+symbol_rotation);mat2 rotation_matrix=mat2(angle_cos,-1.0*angle_sin,angle_sin,angle_cos);float z=0.0;vec2 offset=rotation_matrix*(a_offset/32.0*max(a_min_font_scale,font_scale)+a_pxoffset/16.0);\n#ifdef TERRAIN\n#ifdef PITCH_WITH_MAP_TERRAIN\nvec4 tile_pos=u_label_plane_matrix_inv*vec4(a_projected_pos.xy+offset,0.0,1.0);z=elevation(tile_pos.xy);\n#endif\n#endif\nfloat occlusion_fade=occlusionFade(projected_point)*globe_occlusion_fade;float projection_transition_fade=1.0;\n#if defined(PROJECTED_POS_ON_VIEWPORT) && defined(PROJECTION_GLOBE_VIEW)\nprojection_transition_fade=1.0-step(EPSILON,u_zoom_transition);\n#endif\nvec2 fade_opacity=unpack_opacity(a_fade_opacity);float fade_change=fade_opacity[1] > 0.5 ? u_fade_change :-u_fade_change;float out_fade_opacity=max(0.0,min(occlusion_fade,fade_opacity[0]+fade_change))*projection_transition_fade;float alpha=opacity*out_fade_opacity;float hidden=float(alpha==0.0 || projected_point.w <=0.0 || occlusion_fade==0.0);\n#ifdef PROJECTION_GLOBE_VIEW\nvec3 xAxis=u_pitch_with_map ? normalize(cross(a_globe_normal,u_up_vector)) : vec3(1,0,0);vec3 yAxis=u_pitch_with_map ? normalize(cross(a_globe_normal,xAxis)) : vec3(0,1,0);gl_Position=mix(u_coord_matrix*vec4(projected_pos.xyz/projected_pos.w+xAxis*offset.x+yAxis*offset.y,1.0),AWAY,hidden);\n#else\ngl_Position=mix(u_coord_matrix*vec4(projected_pos.xy/projected_pos.w+offset,z,1.0),AWAY,hidden);\n#endif\nv_tex_a=a_tex/u_texsize;\n#ifdef ICON_TRANSITION\nv_tex_b=a_texb/u_texsize;\n#endif\nv_fade_opacity=out_fade_opacity;}"),symbolSDF:dE("#define SDF_PX 8.0\nuniform sampler2D u_texture;uniform highp float u_gamma_scale;uniform lowp float u_device_pixel_ratio;uniform bool u_is_text;uniform bool u_is_halo;\n#if __VERSION__ >=300\nflat varying float v_draw_halo;\n#endif\nvarying vec2 v_data0;varying vec3 v_data1;\n#pragma mapbox: define highp vec4 fill_color\n#pragma mapbox: define highp vec4 halo_color\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float halo_width\n#pragma mapbox: define lowp float halo_blur\n#pragma mapbox: define lowp float emissive_strength\nvoid main() {\n#pragma mapbox: initialize highp vec4 fill_color\n#pragma mapbox: initialize highp vec4 halo_color\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float halo_width\n#pragma mapbox: initialize lowp float halo_blur\n#pragma mapbox: initialize lowp float emissive_strength\nfloat EDGE_GAMMA=0.105/u_device_pixel_ratio;vec2 tex=v_data0.xy;float gamma_scale=v_data1.x;float size=v_data1.y;float fade_opacity=v_data1[2];float fontScale=u_is_text ? size/24.0 : size;lowp vec4 color=fill_color;highp float gamma=EDGE_GAMMA/(fontScale*u_gamma_scale);lowp float buff=(256.0-64.0)/256.0;bool draw_halo;\n#if __VERSION__ >=300\ndraw_halo=v_draw_halo > 0.0;\n#else\ndraw_halo=u_is_halo;\n#endif\nif (draw_halo) {color=halo_color;gamma=(halo_blur*1.19/SDF_PX+EDGE_GAMMA)/(fontScale*u_gamma_scale);buff=(6.0-halo_width/fontScale)/SDF_PX;}lowp float dist=texture2D(u_texture,tex).a;highp float gamma_scaled=gamma*gamma_scale;highp float alpha=smoothstep(buff-gamma_scaled,buff+gamma_scaled,dist);vec4 out_color=color*(alpha*opacity*fade_opacity);\n#ifdef LIGHTING_3D_MODE\nout_color=apply_lighting_with_emission_ground(out_color,emissive_strength);\n#endif\ngl_FragColor=out_color;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\nHANDLE_WIREFRAME_DEBUG;}","attribute vec4 a_pos_offset;attribute vec4 a_tex_size;attribute vec4 a_pixeloffset;attribute vec4 a_projected_pos;attribute float a_fade_opacity;\n#ifdef Z_OFFSET\nattribute float a_z_offset;\n#endif\n#ifdef PROJECTION_GLOBE_VIEW\nattribute vec3 a_globe_anchor;attribute vec3 a_globe_normal;\n#endif\nuniform bool u_is_size_zoom_constant;uniform bool u_is_size_feature_constant;uniform highp float u_size_t;uniform highp float u_size;uniform mat4 u_matrix;uniform mat4 u_label_plane_matrix;uniform mat4 u_coord_matrix;uniform bool u_is_text;uniform bool u_pitch_with_map;uniform bool u_rotate_symbol;uniform highp float u_aspect_ratio;uniform highp float u_camera_to_center_distance;uniform float u_fade_change;uniform vec2 u_texsize;uniform vec3 u_up_vector;uniform bool u_is_halo;\n#ifdef PROJECTION_GLOBE_VIEW\nuniform vec3 u_tile_id;uniform mat4 u_inv_rot_matrix;uniform vec2 u_merc_center;uniform vec3 u_camera_forward;uniform float u_zoom_transition;uniform vec3 u_ecef_origin;uniform mat4 u_tile_matrix;\n#endif\n#if __VERSION__ >=300\nflat varying float v_draw_halo;\n#endif\nvarying vec2 v_data0;varying vec3 v_data1;\n#pragma mapbox: define highp vec4 fill_color\n#pragma mapbox: define highp vec4 halo_color\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float halo_width\n#pragma mapbox: define lowp float halo_blur\n#pragma mapbox: define lowp float emissive_strength\nvoid main() {\n#pragma mapbox: initialize highp vec4 fill_color\n#pragma mapbox: initialize highp vec4 halo_color\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float halo_width\n#pragma mapbox: initialize lowp float halo_blur\n#pragma mapbox: initialize lowp float emissive_strength\nvec2 a_pos=a_pos_offset.xy;vec2 a_offset=a_pos_offset.zw;vec2 a_tex=a_tex_size.xy;vec2 a_size=a_tex_size.zw;float a_size_min=floor(a_size[0]*0.5);vec2 a_pxoffset=a_pixeloffset.xy;highp float segment_angle=-a_projected_pos[3];float size;if (!u_is_size_zoom_constant && !u_is_size_feature_constant) {size=mix(a_size_min,a_size[1],u_size_t)/128.0;} else if (u_is_size_zoom_constant && !u_is_size_feature_constant) {size=a_size_min/128.0;} else {size=u_size;}vec2 tile_anchor=a_pos;float e=elevation(tile_anchor);\n#ifdef Z_OFFSET\ne+=a_z_offset;\n#endif\nvec3 h=elevationVector(tile_anchor)*e;float globe_occlusion_fade;vec3 world_pos;vec3 mercator_pos;\n#ifdef PROJECTION_GLOBE_VIEW\nmercator_pos=mercator_tile_position(u_inv_rot_matrix,tile_anchor,u_tile_id,u_merc_center);world_pos=mix_globe_mercator(a_globe_anchor+h,mercator_pos,u_zoom_transition);vec4 ecef_point=u_tile_matrix*vec4(world_pos,1.0);vec3 origin_to_point=ecef_point.xyz-u_ecef_origin;globe_occlusion_fade=dot(origin_to_point,u_camera_forward) >=0.0 ? 0.0 : 1.0;\n#else\nworld_pos=vec3(tile_anchor,0)+h;globe_occlusion_fade=1.0;\n#endif\nvec4 projected_point=u_matrix*vec4(world_pos,1);highp float camera_to_anchor_distance=projected_point.w;highp float distance_ratio=u_pitch_with_map ?\ncamera_to_anchor_distance/u_camera_to_center_distance :\nu_camera_to_center_distance/camera_to_anchor_distance;highp float perspective_ratio=clamp(\n0.5+0.5*distance_ratio,0.0,1.5);size*=perspective_ratio;float fontScale=u_is_text ? size/24.0 : size;highp float symbol_rotation=0.0;if (u_rotate_symbol) {vec4 offsetprojected_point;\n#ifdef PROJECTION_GLOBE_VIEW\nvec3 displacement=vec3(a_globe_normal.z,0,-a_globe_normal.x);offsetprojected_point=u_matrix*vec4(a_globe_anchor+displacement,1);\n#else\noffsetprojected_point=u_matrix*vec4(tile_anchor+vec2(1,0),0,1);\n#endif\nvec2 a=projected_point.xy/projected_point.w;vec2 b=offsetprojected_point.xy/offsetprojected_point.w;symbol_rotation=atan((b.y-a.y)/u_aspect_ratio,b.x-a.x);}vec4 projected_pos;\n#ifdef PROJECTION_GLOBE_VIEW\nvec3 proj_pos=mix_globe_mercator(a_projected_pos.xyz+h,mercator_pos,u_zoom_transition);projected_pos=u_label_plane_matrix*vec4(proj_pos,1.0);\n#else\nprojected_pos=u_label_plane_matrix*vec4(a_projected_pos.xy,h.z,1.0);\n#endif\nhighp float angle_sin=sin(segment_angle+symbol_rotation);highp float angle_cos=cos(segment_angle+symbol_rotation);mat2 rotation_matrix=mat2(angle_cos,-1.0*angle_sin,angle_sin,angle_cos);float z=0.0;vec2 offset=rotation_matrix*(a_offset/32.0*fontScale+a_pxoffset);\n#ifdef TERRAIN\n#ifdef PITCH_WITH_MAP_TERRAIN\nvec4 tile_pos=u_label_plane_matrix_inv*vec4(a_projected_pos.xy+offset,0.0,1.0);z=elevation(tile_pos.xy);\n#endif\n#endif\nfloat occlusion_fade=occlusionFade(projected_point)*globe_occlusion_fade;float projection_transition_fade=1.0;\n#if defined(PROJECTED_POS_ON_VIEWPORT) && defined(PROJECTION_GLOBE_VIEW)\nprojection_transition_fade=1.0-step(EPSILON,u_zoom_transition);\n#endif\nvec2 fade_opacity=unpack_opacity(a_fade_opacity);float fade_change=fade_opacity[1] > 0.5 ? u_fade_change :-u_fade_change;float interpolated_fade_opacity=max(0.0,min(occlusion_fade,fade_opacity[0]+fade_change));float out_fade_opacity=interpolated_fade_opacity*projection_transition_fade;float alpha=opacity*out_fade_opacity;float hidden=float(alpha==0.0 || projected_point.w <=0.0 || occlusion_fade==0.0);\n#ifdef PROJECTION_GLOBE_VIEW\nvec3 xAxis=u_pitch_with_map ? normalize(cross(a_globe_normal,u_up_vector)) : vec3(1,0,0);vec3 yAxis=u_pitch_with_map ? normalize(cross(a_globe_normal,xAxis)) : vec3(0,1,0);gl_Position=mix(u_coord_matrix*vec4(projected_pos.xyz/projected_pos.w+xAxis*offset.x+yAxis*offset.y,1.0),AWAY,hidden);\n#else\ngl_Position=mix(u_coord_matrix*vec4(projected_pos.xy/projected_pos.w+offset,z,1.0),AWAY,hidden);\n#endif\nfloat gamma_scale=gl_Position.w;\n#if __VERSION__ >=300\nv_draw_halo=(u_is_halo && float(gl_InstanceID)==0.0) ? 1.0 : 0.0;\n#endif\nv_data0=a_tex/u_texsize;v_data1=vec3(gamma_scale,size,out_fade_opacity);}"),symbolTextAndIcon:dE("#define SDF_PX 8.0\n#define SDF 1.0\n#define ICON 0.0\nuniform sampler2D u_texture;uniform sampler2D u_texture_icon;uniform highp float u_gamma_scale;uniform lowp float u_device_pixel_ratio;uniform bool u_is_halo;\n#if __VERSION__ >=300\nflat varying float v_draw_halo;\n#endif\nvarying vec4 v_data0;varying vec4 v_data1;\n#pragma mapbox: define highp vec4 fill_color\n#pragma mapbox: define highp vec4 halo_color\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float halo_width\n#pragma mapbox: define lowp float halo_blur\n#pragma mapbox: define lowp float emissive_strength\nvoid main() {\n#pragma mapbox: initialize highp vec4 fill_color\n#pragma mapbox: initialize highp vec4 halo_color\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float halo_width\n#pragma mapbox: initialize lowp float halo_blur\n#pragma mapbox: initialize lowp float emissive_strength\nfloat fade_opacity=v_data1[2];if (v_data1.w==ICON) {vec2 tex_icon=v_data0.zw;lowp float alpha=opacity*fade_opacity;gl_FragColor=texture2D(u_texture_icon,tex_icon)*alpha;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\nreturn;}vec2 tex=v_data0.xy;float EDGE_GAMMA=0.105/u_device_pixel_ratio;float gamma_scale=v_data1.x;float size=v_data1.y;float fontScale=size/24.0;lowp vec4 color=fill_color;highp float gamma=EDGE_GAMMA/(fontScale*u_gamma_scale);lowp float buff=(256.0-64.0)/256.0;bool draw_halo;\n#if __VERSION__ >=300\ndraw_halo=v_draw_halo > 0.0;\n#else\ndraw_halo=u_is_halo;\n#endif\nif (draw_halo) {color=halo_color;gamma=(halo_blur*1.19/SDF_PX+EDGE_GAMMA)/(fontScale*u_gamma_scale);buff=(6.0-halo_width/fontScale)/SDF_PX;}lowp float dist=texture2D(u_texture,tex).a;highp float gamma_scaled=gamma*gamma_scale;highp float alpha=smoothstep(buff-gamma_scaled,buff+gamma_scaled,dist);vec4 out_color=color*(alpha*opacity*fade_opacity);\n#ifdef LIGHTING_3D_MODE\nout_color=apply_lighting_with_emission_ground(out_color,emissive_strength);\n#endif\ngl_FragColor=out_color;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\nHANDLE_WIREFRAME_DEBUG;}","attribute vec4 a_pos_offset;attribute vec4 a_tex_size;attribute vec4 a_projected_pos;attribute float a_fade_opacity;\n#ifdef Z_OFFSET\nattribute float a_z_offset;\n#endif\n#ifdef PROJECTION_GLOBE_VIEW\nattribute vec3 a_globe_anchor;attribute vec3 a_globe_normal;\n#endif\nuniform bool u_is_size_zoom_constant;uniform bool u_is_size_feature_constant;uniform highp float u_size_t;uniform highp float u_size;uniform mat4 u_matrix;uniform mat4 u_label_plane_matrix;uniform mat4 u_coord_matrix;uniform bool u_is_text;uniform bool u_pitch_with_map;uniform bool u_rotate_symbol;uniform highp float u_aspect_ratio;uniform highp float u_camera_to_center_distance;uniform float u_fade_change;uniform vec2 u_texsize;uniform vec3 u_up_vector;uniform vec2 u_texsize_icon;uniform bool u_is_halo;\n#ifdef PROJECTION_GLOBE_VIEW\nuniform vec3 u_tile_id;uniform mat4 u_inv_rot_matrix;uniform vec2 u_merc_center;uniform vec3 u_camera_forward;uniform float u_zoom_transition;uniform vec3 u_ecef_origin;uniform mat4 u_tile_matrix;\n#endif\n#if __VERSION__ >=300\nflat varying float v_draw_halo;\n#endif\nvarying vec4 v_data0;varying vec4 v_data1;\n#pragma mapbox: define highp vec4 fill_color\n#pragma mapbox: define highp vec4 halo_color\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float halo_width\n#pragma mapbox: define lowp float halo_blur\n#pragma mapbox: define lowp float emissive_strength\nvoid main() {\n#pragma mapbox: initialize highp vec4 fill_color\n#pragma mapbox: initialize highp vec4 halo_color\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float halo_width\n#pragma mapbox: initialize lowp float halo_blur\n#pragma mapbox: initialize lowp float emissive_strength\nvec2 a_pos=a_pos_offset.xy;vec2 a_offset=a_pos_offset.zw;vec2 a_tex=a_tex_size.xy;vec2 a_size=a_tex_size.zw;float a_size_min=floor(a_size[0]*0.5);float is_sdf=a_size[0]-2.0*a_size_min;highp float segment_angle=-a_projected_pos[3];float size;if (!u_is_size_zoom_constant && !u_is_size_feature_constant) {size=mix(a_size_min,a_size[1],u_size_t)/128.0;} else if (u_is_size_zoom_constant && !u_is_size_feature_constant) {size=a_size_min/128.0;} else {size=u_size;}vec2 tile_anchor=a_pos;float e=elevation(tile_anchor);\n#ifdef Z_OFFSET\ne+=a_z_offset;\n#endif\nvec3 h=elevationVector(tile_anchor)*e;float globe_occlusion_fade;vec3 world_pos;vec3 mercator_pos;\n#ifdef PROJECTION_GLOBE_VIEW\nmercator_pos=mercator_tile_position(u_inv_rot_matrix,tile_anchor,u_tile_id,u_merc_center);world_pos=mix_globe_mercator(a_globe_anchor+h,mercator_pos,u_zoom_transition);vec4 ecef_point=u_tile_matrix*vec4(world_pos,1.0);vec3 origin_to_point=ecef_point.xyz-u_ecef_origin;globe_occlusion_fade=dot(origin_to_point,u_camera_forward) >=0.0 ? 0.0 : 1.0;\n#else\nworld_pos=vec3(tile_anchor,0)+h;globe_occlusion_fade=1.0;\n#endif\nvec4 projected_point=u_matrix*vec4(world_pos,1);highp float camera_to_anchor_distance=projected_point.w;highp float distance_ratio=u_pitch_with_map ?\ncamera_to_anchor_distance/u_camera_to_center_distance :\nu_camera_to_center_distance/camera_to_anchor_distance;highp float perspective_ratio=clamp(\n0.5+0.5*distance_ratio,0.0,1.5);size*=perspective_ratio;float font_scale=size/24.0;highp float symbol_rotation=0.0;if (u_rotate_symbol) {vec4 offset_projected_point=u_matrix*vec4(a_pos+vec2(1,0),0,1);vec2 a=projected_point.xy/projected_point.w;vec2 b=offset_projected_point.xy/offset_projected_point.w;symbol_rotation=atan((b.y-a.y)/u_aspect_ratio,b.x-a.x);}vec4 projected_pos;\n#ifdef PROJECTION_GLOBE_VIEW\nvec3 proj_pos=mix_globe_mercator(a_projected_pos.xyz+h,mercator_pos,u_zoom_transition);projected_pos=u_label_plane_matrix*vec4(proj_pos,1.0);\n#else\nprojected_pos=u_label_plane_matrix*vec4(a_projected_pos.xy,h.z,1.0);\n#endif\nhighp float angle_sin=sin(segment_angle+symbol_rotation);highp float angle_cos=cos(segment_angle+symbol_rotation);mat2 rotation_matrix=mat2(angle_cos,-1.0*angle_sin,angle_sin,angle_cos);float z=0.0;vec2 offset=rotation_matrix*(a_offset/32.0*font_scale);\n#ifdef TERRAIN\n#ifdef PITCH_WITH_MAP_TERRAIN\nvec4 tile_pos=u_label_plane_matrix_inv*vec4(a_projected_pos.xy+offset,0.0,1.0);z=elevation(tile_pos.xy);\n#endif\n#endif\nfloat occlusion_fade=occlusionFade(projected_point)*globe_occlusion_fade;vec2 fade_opacity=unpack_opacity(a_fade_opacity);float fade_change=fade_opacity[1] > 0.5 ? u_fade_change :-u_fade_change;float interpolated_fade_opacity=max(0.0,min(occlusion_fade,fade_opacity[0]+fade_change));float projection_transition_fade=1.0;\n#if defined(PROJECTED_POS_ON_VIEWPORT) && defined(PROJECTION_GLOBE_VIEW)\nprojection_transition_fade=1.0-step(EPSILON,u_zoom_transition);\n#endif\nfloat out_fade_opacity=interpolated_fade_opacity*projection_transition_fade;float alpha=opacity*out_fade_opacity;float hidden=float(alpha==0.0 || projected_point.w <=0.0 || occlusion_fade==0.0);\n#ifdef PROJECTION_GLOBE_VIEW\nvec3 xAxis=u_pitch_with_map ? normalize(cross(a_globe_normal,u_up_vector)) : vec3(1,0,0);vec3 yAxis=u_pitch_with_map ? normalize(cross(a_globe_normal,xAxis)) : vec3(0,1,0);gl_Position=mix(u_coord_matrix*vec4(projected_pos.xyz/projected_pos.w+xAxis*offset.x+yAxis*offset.y,1.0),AWAY,hidden);\n#else\ngl_Position=mix(u_coord_matrix*vec4(projected_pos.xy/projected_pos.w+offset,z,1.0),AWAY,hidden);\n#endif\nfloat gamma_scale=gl_Position.w;\n#if __VERSION__ >=300\nv_draw_halo=(u_is_halo && float(gl_InstanceID)==0.0) ? 1.0 : 0.0;\n#endif\nv_data0.xy=a_tex/u_texsize;v_data0.zw=a_tex/u_texsize_icon;v_data1=vec4(gamma_scale,size,out_fade_opacity,is_sdf);}"),terrainRaster:dE("uniform sampler2D u_image0;varying vec2 v_pos0;\n#ifdef FOG\nvarying float v_fog_opacity;\n#endif\n#ifdef RENDER_SHADOWS\nvarying vec4 v_pos_light_view_0;varying vec4 v_pos_light_view_1;varying float v_depth;\n#endif\nuniform vec3 u_ground_shadow_factor;void main() {vec4 image_color=texture2D(u_image0,v_pos0);vec4 color;\n#ifdef LIGHTING_3D_MODE\nconst vec3 normal=vec3(0.0,0.0,1.0);\n#ifdef RENDER_SHADOWS\nfloat cutoffOpacity=1.0;\n#ifdef RENDER_CUTOFF\ncutoffOpacity=cutoff_opacity(u_cutoff_params,v_depth);\n#endif\n#ifdef LIGHTING_3D_ALPHA_EMISSIVENESS\nvec3 unlit_base=image_color.rgb*(1.0-image_color.a);vec3 emissive_base=image_color.rgb*image_color.a;float ndotl=u_shadow_direction.z;float occlusion=ndotl < 0.0 ? 1.0 : shadow_occlusion(v_pos_light_view_0,v_pos_light_view_1,v_depth,0.0);ndotl=max(0.0,ndotl);vec3 lit=apply_lighting(unlit_base,normal,mix(1.0,(1.0-(u_shadow_intensity*occlusion))*ndotl,cutoffOpacity));vec3 emissive=compute_emissive_draped(emissive_base,1.0-u_shadow_intensity,occlusion,u_ground_shadow_factor);color.rgb=lit+emissive;color.a=1.0;\n#else\nfloat lighting_factor=shadowed_light_factor_normal_unbiased(normal,v_pos_light_view_0,v_pos_light_view_1,v_depth);color=apply_lighting(image_color,normal,mix(1.0,lighting_factor,cutoffOpacity));\n#endif\n#else\nfloat lighting_factor=calculate_NdotL(normal);color=apply_lighting(image_color,normal,lighting_factor);\n#ifdef LIGHTING_3D_ALPHA_EMISSIVENESS\ncolor.rgb=mix(color.rgb,image_color.rgb,image_color.a);color.a=1.0;\n#endif\n#endif\n#else\ncolor=image_color;\n#endif\n#ifdef FOG\n#ifdef ZERO_EXAGGERATION\ncolor=fog_dither(fog_apply_premultiplied(color,v_fog_pos));\n#else\ncolor=fog_dither(fog_apply_from_vert(color,v_fog_opacity));\n#endif\n#endif\ngl_FragColor=color;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\nHANDLE_WIREFRAME_DEBUG;}","uniform mat4 u_matrix;uniform float u_skirt_height;attribute vec2 a_pos;varying vec2 v_pos0;\n#ifdef FOG\nvarying float v_fog_opacity;\n#endif\n#ifdef RENDER_SHADOWS\nuniform mat4 u_light_matrix_0;uniform mat4 u_light_matrix_1;varying vec4 v_pos_light_view_0;varying vec4 v_pos_light_view_1;varying float v_depth;\n#endif\nvoid main() {vec3 decomposedPosAndSkirt=decomposeToPosAndSkirt(a_pos);float skirt=decomposedPosAndSkirt.z;vec2 decodedPos=decomposedPosAndSkirt.xy;float elevation=elevation(decodedPos)-skirt*u_skirt_height;v_pos0=decodedPos/8192.0;gl_Position=u_matrix*vec4(decodedPos,elevation,1.0);\n#ifdef FOG\n#ifdef ZERO_EXAGGERATION\nv_fog_pos=fog_position(decodedPos);\n#else\nv_fog_opacity=fog(fog_position(vec3(decodedPos,elevation)));\n#endif\n#endif\n#ifdef RENDER_SHADOWS\nvec3 pos=vec3(decodedPos,elevation);v_pos_light_view_0=u_light_matrix_0*vec4(pos,1.);v_pos_light_view_1=u_light_matrix_1*vec4(pos,1.);v_depth=gl_Position.w;\n#endif\n}"),terrainDepth:dE("#ifdef GL_ES\nprecision highp float;\n#endif\nvarying float v_depth;void main() {gl_FragColor=pack_depth(v_depth);}","uniform mat4 u_matrix;attribute vec2 a_pos;varying float v_depth;void main() {float elevation=elevation(a_pos);gl_Position=u_matrix*vec4(a_pos,elevation,1.0);v_depth=gl_Position.z/gl_Position.w;}"),skybox:dE("\nvarying lowp vec3 v_uv;uniform lowp samplerCube u_cubemap;uniform lowp float u_opacity;uniform highp float u_temporal_offset;uniform highp vec3 u_sun_direction;float sun_disk(highp vec3 ray_direction,highp vec3 sun_direction) {highp float cos_angle=dot(normalize(ray_direction),sun_direction);const highp float cos_sun_angular_diameter=0.99996192306;const highp float smoothstep_delta=1e-5;return smoothstep(\ncos_sun_angular_diameter-smoothstep_delta,cos_sun_angular_diameter+smoothstep_delta,cos_angle);}float map(float value,float start,float end,float new_start,float new_end) {return ((value-start)*(new_end-new_start))/(end-start)+new_start;}void main() {vec3 uv=v_uv;const float y_bias=0.015;uv.y+=y_bias;uv.y=pow(abs(uv.y),1.0/5.0);uv.y=map(uv.y,0.0,1.0,-1.0,1.0);vec3 sky_color=textureCube(u_cubemap,uv).rgb;\n#ifdef FOG\nsky_color=fog_apply_sky_gradient(v_uv.xzy,sky_color);\n#endif\nsky_color.rgb=dither(sky_color.rgb,gl_FragCoord.xy+u_temporal_offset);sky_color+=0.1*sun_disk(v_uv,u_sun_direction);gl_FragColor=vec4(sky_color*u_opacity,u_opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}",XT),skyboxGradient:dE("varying highp vec3 v_uv;uniform lowp sampler2D u_color_ramp;uniform highp vec3 u_center_direction;uniform lowp float u_radius;uniform lowp float u_opacity;uniform highp float u_temporal_offset;void main() {float progress=acos(dot(normalize(v_uv),u_center_direction))/u_radius;vec4 color=texture2D(u_color_ramp,vec2(progress,0.5));\n#ifdef FOG\ncolor.rgb=fog_apply_sky_gradient(v_uv.xzy,color.rgb/color.a)*color.a;\n#endif\ncolor*=u_opacity;color.rgb=dither(color.rgb,gl_FragCoord.xy+u_temporal_offset);gl_FragColor=color;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}",XT),skyboxCapture:dE("\nvarying highp vec3 v_position;uniform highp float u_sun_intensity;uniform highp float u_luminance;uniform lowp vec3 u_sun_direction;uniform highp vec4 u_color_tint_r;uniform highp vec4 u_color_tint_m;\n#ifdef GL_ES\nprecision highp float;\n#endif\n#define BETA_R                  vec3(5.5e-6,13.0e-6,22.4e-6)\n#define BETA_M                  vec3(21e-6,21e-6,21e-6)\n#define MIE_G                   0.76\n#define DENSITY_HEIGHT_SCALE_R  8000.0\n#define DENSITY_HEIGHT_SCALE_M  1200.0\n#define PLANET_RADIUS           6360e3\n#define ATMOSPHERE_RADIUS       6420e3\n#define SAMPLE_STEPS            10\n#define DENSITY_STEPS           4\nfloat ray_sphere_exit(vec3 orig,vec3 dir,float radius) {float a=dot(dir,dir);float b=2.0*dot(dir,orig);float c=dot(orig,orig)-radius*radius;float d=sqrt(b*b-4.0*a*c);return (-b+d)/(2.0*a);}vec3 extinction(vec2 density) {return exp(-vec3(BETA_R*u_color_tint_r.a*density.x+BETA_M*u_color_tint_m.a*density.y));}vec2 local_density(vec3 point) {float height=max(length(point)-PLANET_RADIUS,0.0);float exp_r=exp(-height/DENSITY_HEIGHT_SCALE_R);float exp_m=exp(-height/DENSITY_HEIGHT_SCALE_M);return vec2(exp_r,exp_m);}float phase_ray(float cos_angle) {return (3.0/(16.0*PI))*(1.0+cos_angle*cos_angle);}float phase_mie(float cos_angle) {return (3.0/(8.0*PI))*((1.0-MIE_G*MIE_G)*(1.0+cos_angle*cos_angle))/((2.0+MIE_G*MIE_G)*pow(1.0+MIE_G*MIE_G-2.0*MIE_G*cos_angle,1.5));}vec2 density_to_atmosphere(vec3 point,vec3 light_dir) {float ray_len=ray_sphere_exit(point,light_dir,ATMOSPHERE_RADIUS);float step_len=ray_len/float(DENSITY_STEPS);vec2 density_point_to_atmosphere=vec2(0.0);for (int i=0; i < DENSITY_STEPS;++i) {vec3 point_on_ray=point+light_dir*((float(i)+0.5)*step_len);density_point_to_atmosphere+=local_density(point_on_ray)*step_len;;}return density_point_to_atmosphere;}vec3 atmosphere(vec3 ray_dir,vec3 sun_direction,float sun_intensity) {vec2 density_orig_to_point=vec2(0.0);vec3 scatter_r=vec3(0.0);vec3 scatter_m=vec3(0.0);vec3 origin=vec3(0.0,PLANET_RADIUS,0.0);float ray_len=ray_sphere_exit(origin,ray_dir,ATMOSPHERE_RADIUS);float step_len=ray_len/float(SAMPLE_STEPS);for (int i=0; i < SAMPLE_STEPS;++i) {vec3 point_on_ray=origin+ray_dir*((float(i)+0.5)*step_len);vec2 density=local_density(point_on_ray)*step_len;density_orig_to_point+=density;vec2 density_point_to_atmosphere=density_to_atmosphere(point_on_ray,sun_direction);vec2 density_orig_to_atmosphere=density_orig_to_point+density_point_to_atmosphere;vec3 extinction=extinction(density_orig_to_atmosphere);scatter_r+=density.x*extinction;scatter_m+=density.y*extinction;}float cos_angle=dot(ray_dir,sun_direction);float phase_r=phase_ray(cos_angle);float phase_m=phase_mie(cos_angle);vec3 beta_r=BETA_R*u_color_tint_r.rgb*u_color_tint_r.a;vec3 beta_m=BETA_M*u_color_tint_m.rgb*u_color_tint_m.a;return (scatter_r*phase_r*beta_r+scatter_m*phase_m*beta_m)*sun_intensity;}const float A=0.15;const float B=0.50;const float C=0.10;const float D=0.20;const float E=0.02;const float F=0.30;vec3 uncharted2_tonemap(vec3 x) {return ((x*(A*x+C*B)+D*E)/(x*(A*x+B)+D*F))-E/F;}void main() {vec3 ray_direction=v_position;ray_direction.y=pow(ray_direction.y,5.0);const float y_bias=0.015;ray_direction.y+=y_bias;vec3 color=atmosphere(normalize(ray_direction),u_sun_direction,u_sun_intensity);float white_scale=1.0748724675633854;color=uncharted2_tonemap((log2(2.0/pow(u_luminance,4.0)))*color)*white_scale;gl_FragColor=vec4(color,1.0);}","attribute highp vec3 a_pos_3f;uniform mat3 u_matrix_3f;varying highp vec3 v_position;float map(float value,float start,float end,float new_start,float new_end) {return ((value-start)*(new_end-new_start))/(end-start)+new_start;}void main() {vec4 pos=vec4(u_matrix_3f*a_pos_3f,1.0);v_position=pos.xyz;v_position.y*=-1.0;v_position.y=map(v_position.y,-1.0,1.0,0.0,1.0);gl_Position=vec4(a_pos_3f.xy,0.0,1.0);}"),globeRaster:dE("uniform sampler2D u_image0;varying vec2 v_pos0;\n#ifndef FOG\nuniform highp vec3 u_frustum_tl;uniform highp vec3 u_frustum_tr;uniform highp vec3 u_frustum_br;uniform highp vec3 u_frustum_bl;uniform highp vec3 u_globe_pos;uniform highp float u_globe_radius;uniform vec2 u_viewport;\n#endif\nvoid main() {vec4 color;\n#ifdef CUSTOM_ANTIALIASING\nvec2 uv=gl_FragCoord.xy/u_viewport;highp vec3 ray_dir=mix(\nmix(u_frustum_tl,u_frustum_tr,uv.x),mix(u_frustum_bl,u_frustum_br,uv.x),1.0-uv.y);vec3 dir=normalize(ray_dir);vec3 closest_point=dot(u_globe_pos,dir)*dir;float norm_dist_from_center=1.0-length(closest_point-u_globe_pos)/u_globe_radius;const float antialias_pixel=2.0;float antialias_factor=antialias_pixel*fwidth(norm_dist_from_center);float antialias=smoothstep(0.0,antialias_factor,norm_dist_from_center);vec4 raster=texture2D(u_image0,v_pos0);\n#ifdef LIGHTING_3D_MODE\n#ifdef LIGHTING_3D_ALPHA_EMISSIVENESS\nraster=apply_lighting_with_emission_ground(raster,raster.a);color=vec4(raster.rgb*antialias,antialias);\n#else\nraster=apply_lighting_ground(raster);color=vec4(raster.rgb*antialias,raster.a*antialias);\n#endif\n#else\ncolor=vec4(raster.rgb*antialias,raster.a*antialias);\n#endif\n#else\ncolor=texture2D(u_image0,v_pos0);\n#ifdef LIGHTING_3D_MODE\n#ifdef LIGHTING_3D_ALPHA_EMISSIVENESS\ncolor=apply_lighting_with_emission_ground(color,color.a);color.a=1.0;\n#else\ncolor=apply_lighting_ground(color);\n#endif\n#endif\n#endif\n#ifdef FOG\ncolor=fog_dither(fog_apply_premultiplied(color,v_fog_pos));\n#endif\ngl_FragColor=color;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\nHANDLE_WIREFRAME_DEBUG;}","uniform mat4 u_proj_matrix;uniform mat4 u_normalize_matrix;uniform mat4 u_globe_matrix;uniform mat4 u_merc_matrix;uniform float u_zoom_transition;uniform vec2 u_merc_center;uniform mat3 u_grid_matrix;uniform float u_skirt_height;\n#ifdef GLOBE_POLES\nattribute vec3 a_globe_pos;attribute vec2 a_uv;\n#else\nattribute vec2 a_pos;\n#endif\nvarying vec2 v_pos0;float mercatorXfromLng(float lng) {return (180.0+lng)/360.0;}float mercatorYfromLat(float lat) {return (180.0-(RAD_TO_DEG*log(tan(QUARTER_PI+lat/2.0*DEG_TO_RAD))))/360.0;}vec3 latLngToECEF(vec2 latLng) {latLng=DEG_TO_RAD*latLng;float cosLat=cos(latLng[0]);float sinLat=sin(latLng[0]);float cosLng=cos(latLng[1]);float sinLng=sin(latLng[1]);float sx=cosLat*sinLng*GLOBE_RADIUS;float sy=-sinLat*GLOBE_RADIUS;float sz=cosLat*cosLng*GLOBE_RADIUS;return vec3(sx,sy,sz);}void main() {\n#ifdef GLOBE_POLES\nvec3 globe_pos=a_globe_pos;vec2 uv=a_uv;\n#else\nfloat tiles=u_grid_matrix[0][2];float idx=u_grid_matrix[1][2];float idy=u_grid_matrix[2][2];vec3 decomposed_pos_and_skirt=decomposeToPosAndSkirt(a_pos);vec3 latLng=u_grid_matrix*vec3(decomposed_pos_and_skirt.xy,1.0);float mercatorY=mercatorYfromLat(latLng[0]);float uvY=mercatorY*tiles-idy;float mercatorX=mercatorXfromLng(latLng[1]);float uvX=mercatorX*tiles-idx;vec3 globe_pos=latLngToECEF(latLng.xy);vec2 merc_pos=vec2(mercatorX,mercatorY);vec2 uv=vec2(uvX,uvY);\n#endif\nv_pos0=uv;vec2 tile_pos=uv*EXTENT;vec3 globe_derived_up_vector=normalize(globe_pos)*u_tile_up_scale;\n#ifdef GLOBE_POLES\nvec3 up_vector=globe_derived_up_vector;\n#else\nvec3 up_vector=elevationVector(tile_pos);\n#endif\nfloat height=elevation(tile_pos);globe_pos+=up_vector*height;\n#ifndef GLOBE_POLES\nglobe_pos-=globe_derived_up_vector*u_skirt_height*decomposed_pos_and_skirt.z;\n#endif\n#ifdef GLOBE_POLES\nvec4 interpolated_pos=u_globe_matrix*vec4(globe_pos,1.0);\n#else\nvec4 globe_world_pos=u_globe_matrix*vec4(globe_pos,1.0);vec4 merc_world_pos=vec4(0.0);if (u_zoom_transition > 0.0) {merc_world_pos=vec4(merc_pos,height-u_skirt_height*decomposed_pos_and_skirt.z,1.0);merc_world_pos.xy-=u_merc_center;merc_world_pos.x=wrap(merc_world_pos.x,-0.5,0.5);merc_world_pos=u_merc_matrix*merc_world_pos;}vec4 interpolated_pos=vec4(mix(globe_world_pos.xyz,merc_world_pos.xyz,u_zoom_transition),1.0);\n#endif\ngl_Position=u_proj_matrix*interpolated_pos;\n#ifdef FOG\nv_fog_pos=fog_position((u_normalize_matrix*vec4(globe_pos,1.0)).xyz);\n#endif\n}"),globeAtmosphere:dE("uniform float u_transition;uniform highp float u_fadeout_range;uniform highp float u_temporal_offset;uniform vec4 u_color;uniform vec4 u_high_color;uniform vec4 u_space_color;uniform float u_horizon_angle;varying highp vec3 v_ray_dir;varying highp vec3 v_horizon_dir;void main() {highp vec3 dir=normalize(v_ray_dir);float globe_pos_dot_dir;\n#ifdef PROJECTION_GLOBE_VIEW\nglobe_pos_dot_dir=dot(u_globe_pos,dir);highp vec3 closest_point_forward=abs(globe_pos_dot_dir)*dir;float norm_dist_from_center=length(closest_point_forward-u_globe_pos)/u_globe_radius;if (norm_dist_from_center < 0.98) {\n#ifdef ALPHA_PASS\ngl_FragColor=vec4(0,0,0,0);return;\n#else\n#ifdef NATIVE\ngl_FragColor=vec4(1,1,1,1);\n#else\ngl_FragColor=vec4(0,0,0,1);\n#endif\nreturn;\n#endif\n}\n#endif\nhighp vec3 horizon_dir=normalize(v_horizon_dir);float horizon_angle_mercator=dir.y < horizon_dir.y ?\n0.0 : max(acos(clamp(dot(dir,horizon_dir),-1.0,1.0)),0.0);float horizon_angle;\n#ifdef PROJECTION_GLOBE_VIEW\nhighp vec3 closest_point=globe_pos_dot_dir*dir;highp float closest_point_to_center=length(closest_point-u_globe_pos);highp float theta=asin(clamp(closest_point_to_center/length(u_globe_pos),-1.0,1.0));horizon_angle=globe_pos_dot_dir < 0.0 ?\nPI-theta-u_horizon_angle : theta-u_horizon_angle;float angle_t=pow(u_transition,10.0);horizon_angle=mix(horizon_angle,horizon_angle_mercator,angle_t);\n#else\nhorizon_angle=horizon_angle_mercator;\n#endif\nhorizon_angle/=PI;float t=exp(-horizon_angle/u_fadeout_range);float alpha_0=u_color.a;float alpha_1=u_high_color.a;float alpha_2=u_space_color.a;vec3 color_stop_0=u_color.rgb;vec3 color_stop_1=u_high_color.rgb;vec3 color_stop_2=u_space_color.rgb;\n#ifdef ALPHA_PASS\nfloat a0=mix(alpha_2,1.0,alpha_1);float a1=mix(a0,1.0,alpha_0);float a2=mix(a0,a1,t);float a =mix(alpha_2,a2,t);gl_FragColor=vec4(1.0,1.0,1.0,a);\n#else\nvec3 c0=mix(color_stop_2,color_stop_1,alpha_1);vec3 c1=mix(c0,color_stop_0,alpha_0);vec3 c2=mix(c0,c1,t);vec3 c=c2;\n#ifndef NATIVE\nc=dither(c,gl_FragCoord.xy+u_temporal_offset);\n#endif\ngl_FragColor=vec4(c*t,t);\n#endif\n}","attribute vec3 a_pos;attribute vec2 a_uv;uniform vec3 u_frustum_tl;uniform vec3 u_frustum_tr;uniform vec3 u_frustum_br;uniform vec3 u_frustum_bl;uniform float u_horizon;varying highp vec3 v_ray_dir;varying highp vec3 v_horizon_dir;void main() {v_ray_dir=mix(\nmix(u_frustum_tl,u_frustum_tr,a_uv.x),mix(u_frustum_bl,u_frustum_br,a_uv.x),a_uv.y);v_horizon_dir=mix(\nmix(u_frustum_tl,u_frustum_bl,u_horizon),mix(u_frustum_tr,u_frustum_br,u_horizon),a_uv.x);gl_Position=vec4(a_pos,1.0);}"),model:dE("uniform float u_opacity;uniform vec3 u_lightcolor;uniform vec3 u_lightpos;uniform float u_lightintensity;uniform vec4 u_baseColorFactor;uniform vec4 u_emissiveFactor;uniform float u_metallicFactor;uniform float u_roughnessFactor;varying highp vec4 v_position_height;varying lowp vec4 v_color_mix;\n#ifdef RENDER_SHADOWS\nvarying vec4 v_pos_light_view_0;varying vec4 v_pos_light_view_1;varying float v_depth_shadows;\n#endif\n#pragma mapbox: define-attribute highp vec3 normal_3f\n#pragma mapbox: define-attribute highp vec3 color_3f\n#pragma mapbox: define-attribute highp vec4 color_4f\n#pragma mapbox: define-attribute highp vec2 uv_2f\n#pragma mapbox: initialize-attribute highp vec3 normal_3f\n#pragma mapbox: initialize-attribute highp vec3 color_3f\n#pragma mapbox: initialize-attribute highp vec4 color_4f\n#pragma mapbox: initialize-attribute highp vec2 uv_2f\n#ifdef HAS_ATTRIBUTE_a_pbr\nvarying lowp vec4 v_roughness_metallic_emissive_alpha;varying mediump vec4 v_height_based_emission_params;\n#endif\n#ifdef HAS_TEXTURE_u_baseColorTexture\nuniform sampler2D u_baseColorTexture;uniform bool u_baseTextureIsAlpha;uniform bool u_alphaMask;uniform float u_alphaCutoff;\n#endif\n#ifdef HAS_TEXTURE_u_metallicRoughnessTexture\nuniform sampler2D u_metallicRoughnessTexture;\n#endif\n#ifdef HAS_TEXTURE_u_occlusionTexture\nuniform sampler2D u_occlusionTexture;uniform float u_aoIntensity;\n#endif\n#ifdef HAS_TEXTURE_u_normalTexture\nuniform sampler2D u_normalTexture;\n#endif\n#ifdef HAS_TEXTURE_u_emissionTexture\nuniform sampler2D u_emissionTexture;\n#endif\n#ifdef TERRAIN_FRAGMENT_OCCLUSION\nvarying highp float v_depth;uniform sampler2D u_depthTexture;uniform vec2 u_inv_depth_size;bool isOccluded() {vec2 coord=gl_FragCoord.xy*u_inv_depth_size;highp float depth=unpack_depth(texture2D(u_depthTexture,coord));return v_depth > depth+0.0005;}\n#endif\nconst float M_PI=3.141592653589793;\n#define saturate(_x) clamp(_x,0.,1.)\nfloat calculate_NdotL(vec3 normal,vec3 lightDir) {const float ext=0.70710678118;return (clamp(dot(normal,lightDir),-ext,1.0)+ext)/(1.0+ext);}vec3 getDiffuseShadedColor(vec3 albedo,vec3 normal,vec3 lightDir,vec3 lightColor)\n{\n#ifdef LIGHTING_3D_MODE\nvec3 transformed_normal=vec3(-normal.xy,normal.z);float lighting_factor;\n#ifdef RENDER_SHADOWS\nlighting_factor=shadowed_light_factor_normal(transformed_normal,v_pos_light_view_0,v_pos_light_view_1,v_depth_shadows);\n#else\nlighting_factor=saturate(dot(transformed_normal,u_lighting_directional_dir));\n#endif\nreturn apply_lighting(albedo,transformed_normal,lighting_factor);\n#else\nvec3 n=normal;float colorvalue=((albedo.x*0.2126)+(albedo.y*0.7152))+(albedo.z*0.0722);vec3 c=vec3(0.03,0.03,0.03);float directional=clamp(dot(n,vec3(lightDir)),0.0,1.0);directional=mix(1.0-u_lightintensity,max((1.0-colorvalue)+u_lightintensity,1.0),directional);vec3 c3=c+clamp((albedo*directional)*lightColor,mix(vec3(0.0),vec3(0.3),vec3(1.0)-lightColor),vec3(1.0));return c3;\n#endif\n}vec4 getBaseColor() {vec4 albedo=u_baseColorFactor;\n#ifdef HAS_ATTRIBUTE_a_color_3f\nalbedo*=vec4(color_3f,1.0);\n#endif\n#ifdef HAS_ATTRIBUTE_a_pbr\n#else\n#ifdef HAS_ATTRIBUTE_a_color_4f\nalbedo*=color_4f;\n#endif\n#endif\n#if defined (HAS_TEXTURE_u_baseColorTexture) && defined (HAS_ATTRIBUTE_a_uv_2f)\nvec4 texColor=texture2D(u_baseColorTexture,uv_2f);if(u_alphaMask) {if (texColor.w < u_alphaCutoff) {discard;}}\n#ifdef UNPREMULT_TEXTURE_IN_SHADER\nif(texColor.w > 0.0) {texColor.rgb/=texColor.w;}texColor.w=1.0;\n#endif\ntexColor.rgb=sRGBToLinear(texColor.rgb);if(u_baseTextureIsAlpha) {if (texColor.w < 0.5) {discard;}albedo*=mix(vec4(texColor.rgb,texColor.a),vec4(texColor.a),float(u_baseTextureIsAlpha));} else {albedo*=texColor;}\n#endif\nreturn vec4(mix(albedo.rgb,v_color_mix.rgb,v_color_mix.a),albedo.a);}highp mat3 cotangentFrame(highp vec3 N,highp vec3 p,highp vec2 uv ) {\n#ifdef HAS_TEXTURE_u_normalTexture\nhighp vec3 dp1=vec3(dFdx(p.x),dFdx(p.y),dFdx(p.z));highp vec3 dp2=vec3(dFdy(p.x),dFdy(p.y),dFdy(p.z));highp vec2 duv1=vec2(dFdx(uv.x),dFdx(uv.y));highp vec2 duv2=vec2(dFdy(uv.x),dFdy(uv.y));highp vec3 dp2perp=cross( dp2,N );highp vec3 dp1perp=cross( N,dp1 );highp vec3 T=dp2perp*duv1.x+dp1perp*duv2.x;highp vec3 B=dp2perp*duv1.y+dp1perp*duv2.y;highp float lengthT=dot(T,T);highp float lengthB=dot(B,B);highp float maxLength=max(lengthT,lengthB);highp float invmax=inversesqrt( maxLength );highp mat3 res=mat3( T*invmax,B*invmax,N );return res;\n#else\nreturn mat3(1.0);\n#endif\n}highp vec3 getNormal(){highp vec3 n;\n#ifdef HAS_ATTRIBUTE_a_normal_3f\nn=normalize(normal_3f);\n#else\nhighp vec3 fdx=vec3(dFdx(v_position_height.x),dFdx(v_position_height.y),dFdx(v_position_height.z));highp vec3 fdy=vec3(dFdy(v_position_height.x),dFdy(v_position_height.y),dFdy(v_position_height.z));n=normalize(cross(fdx,fdy))*-1.0;\n#endif\n#if defined(HAS_TEXTURE_u_normalTexture) && defined(HAS_ATTRIBUTE_a_uv_2f)\nvec3 nMap=texture2D( u_normalTexture,uv_2f).xyz;nMap=normalize(2.0*nMap-vec3(1.0));highp vec3 v=normalize(-v_position_height.xyz);highp mat3 TBN=cotangentFrame(n,v,uv_2f);n=normalize(TBN*nMap);\n#endif\nreturn n;}struct Material {float perceptualRoughness;float alphaRoughness;float metallic;vec3 f90;vec4 baseColor;vec3 diffuseColor;vec3 specularColor;highp vec3 normal;};Material getPBRMaterial() {Material mat;mat.baseColor=getBaseColor();mat.perceptualRoughness=u_roughnessFactor;mat.metallic=u_metallicFactor;\n#ifdef HAS_ATTRIBUTE_a_pbr\nmat.perceptualRoughness=v_roughness_metallic_emissive_alpha.x;mat.metallic=v_roughness_metallic_emissive_alpha.y;mat.baseColor.w*=v_roughness_metallic_emissive_alpha.w;\n#endif\n#if defined(HAS_TEXTURE_u_metallicRoughnessTexture) && defined(HAS_ATTRIBUTE_a_uv_2f) \nvec4 mrSample=texture2D(u_metallicRoughnessTexture,uv_2f);mat.perceptualRoughness*=mrSample.g;mat.metallic*=mrSample.b;\n#endif\nconst float c_minRoughness=0.04;mat.perceptualRoughness=clamp(mat.perceptualRoughness,c_minRoughness,1.0);mat.metallic=saturate(mat.metallic);mat.alphaRoughness=mat.perceptualRoughness*mat.perceptualRoughness;const vec3 f0=vec3(0.04);mat.diffuseColor=mat.baseColor.rgb*(vec3(1.0)-f0);mat.diffuseColor*=1.0-mat.metallic;mat.specularColor=mix(f0,mat.baseColor.rgb,mat.metallic);highp float reflectance=max(max(mat.specularColor.r,mat.specularColor.g),mat.specularColor.b);highp float reflectance90=saturate(reflectance*25.0);mat.f90=vec3(reflectance90);mat.normal=getNormal();return mat;}float V_GGX(float NdotL,float NdotV,float roughness)\n{float a2=roughness*roughness;float GGXV=NdotL*sqrt(NdotV*NdotV*(1.0-a2)+a2);float GGXL=NdotV*sqrt(NdotL*NdotL*(1.0-a2)+a2);return 0.5/(GGXV+GGXL);}float V_GGXFast(float NdotL,float NdotV,float roughness) {float a=roughness;float GGXV=NdotL*(NdotV*(1.0-a)+a);float GGXL=NdotV*(NdotL*(1.0-a)+a);return 0.5/(GGXV+GGXL);}vec3 F_Schlick(vec3 specularColor,vec3 f90,float VdotH)\n{return specularColor+(f90-specularColor)*pow(clamp(1.0-VdotH,0.0,1.0),5.0);}vec3 F_SchlickFast(vec3 specularColor,float VdotH)\n{float x=1.0-VdotH;float x4=x*x*x*x;return specularColor+(1.0-specularColor)*x4*x;}float D_GGX(highp float NdotH,float alphaRoughness)\n{highp float a4=alphaRoughness*alphaRoughness;highp float f=(NdotH*a4-NdotH)*NdotH+1.0;return a4/(M_PI*f*f);}vec3 diffuseBurley(Material mat,float LdotH,float NdotL,float NdotV)\n{float f90=2.0*LdotH*LdotH*mat.alphaRoughness-0.5;return (mat.diffuseColor/M_PI)*(1.0+f90*pow((1.0-NdotL),5.0))*(1.0+f90*pow((1.0-NdotV),5.0));}vec3 diffuseLambertian(Material mat)\n{\n#ifdef LIGHTING_3D_MODE\nreturn mat.diffuseColor;\n#else\nreturn mat.diffuseColor/M_PI;\n#endif\n}vec3 EnvBRDFApprox(vec3 specularColor,float roughness,highp float NdotV)\n{vec4 c0=vec4(-1,-0.0275,-0.572,0.022);vec4 c1=vec4(1,0.0425,1.04,-0.04);highp vec4 r=roughness*c0+c1;highp float a004=min(r.x*r.x,exp2(-9.28*NdotV))*r.x+r.y;vec2 AB=vec2(-1.04,1.04)*a004+r.zw;return specularColor*AB.x+AB.y;}vec3 computeIndirectLightContribution(Material mat,float NdotV,vec3 normal)\n{vec3 env_light=vec3(0.65,0.65,0.65);\n#ifdef LIGHTING_3D_MODE\nfloat ambient_factor=calculate_ambient_directional_factor(normal);env_light=u_lighting_ambient_color*ambient_factor;\n#endif\nvec3 envBRDF=EnvBRDFApprox(mat.specularColor,mat.perceptualRoughness,NdotV);vec3 indirectSpecular= envBRDF*env_light;vec3 indirectDiffuse=mat.diffuseColor*env_light;return indirectSpecular+indirectDiffuse;}vec3 computeLightContribution(Material mat,vec3 lightPosition,vec3 lightColor)\n{highp vec3 n=mat.normal;highp vec3 v=normalize(-v_position_height.xyz);highp vec3 l=normalize(lightPosition);highp vec3 h=normalize(v+l);float NdotV=clamp(abs(dot(n,v)),0.001,1.0);float NdotL=saturate(dot(n,l));highp float NdotH=saturate(dot(n,h));float VdotH=saturate(dot(v,h));vec3 f=F_SchlickFast(mat.specularColor,VdotH);float g=V_GGXFast(NdotL,NdotV,mat.alphaRoughness);float d=D_GGX(NdotH,mat.alphaRoughness);vec3 diffuseTerm=(1.0-f)*diffuseLambertian(mat);vec3 specularTerm=f*g*d;vec3 transformed_normal=vec3(-n.xy,n.z);float lighting_factor;\n#ifdef RENDER_SHADOWS\nlighting_factor=shadowed_light_factor_normal(transformed_normal,v_pos_light_view_0,v_pos_light_view_1,v_depth_shadows);\n#else\nlighting_factor=NdotL;\n#endif\nvec3 directLightColor=(specularTerm+diffuseTerm)*lighting_factor*lightColor;vec3 indirectLightColor=computeIndirectLightContribution(mat,NdotV,transformed_normal);vec3 color=(saturate(directLightColor)+indirectLightColor);float intensityFactor=1.0;\n#if !defined(LIGHTING_3D_MODE)\nconst vec3 luminosityFactor=vec3(0.2126,0.7152,0.0722);float luminance=dot(diffuseTerm,luminosityFactor);intensityFactor=mix((1.0-u_lightintensity),max((1.0-luminance+u_lightintensity),1.0),NdotL);\n#endif\ncolor*=intensityFactor;return color;}void main() {\n#ifdef TERRAIN_FRAGMENT_OCCLUSION\nif (isOccluded()) {discard;}\n#endif\nvec3 lightDir=u_lightpos;vec3 lightColor=u_lightcolor;\n#ifdef LIGHTING_3D_MODE\nlightDir=u_lighting_directional_dir;lightDir.xy=-lightDir.xy;lightColor=u_lighting_directional_color;\n#endif\nvec4 finalColor;\n#ifdef DIFFUSE_SHADED\nvec3 N=getNormal();vec3 diffuse=getDiffuseShadedColor(getBaseColor().rgb,N,lightDir,lightColor);\n#ifdef HAS_TEXTURE_u_occlusionTexture\nfloat ao=(texture2D(u_occlusionTexture,uv_2f).r-1.0)*u_aoIntensity+1.0;diffuse*=ao;\n#endif\nfinalColor=vec4(diffuse,1.0)*u_opacity;\n#else\nMaterial mat=getPBRMaterial();vec3 color=computeLightContribution(mat,lightDir,lightColor);\n#if defined (HAS_TEXTURE_u_occlusionTexture) && defined(HAS_ATTRIBUTE_a_uv_2f)\nfloat ao=(texture2D(u_occlusionTexture,uv_2f).x-1.0)*u_aoIntensity+1.0;color*=ao;\n#endif\nvec4 emissive=u_emissiveFactor;\n#if defined(HAS_TEXTURE_u_emissionTexture) && defined(HAS_ATTRIBUTE_a_uv_2f)\nemissive.rgb*=sRGBToLinear(texture2D(u_emissionTexture,uv_2f).rgb);\n#endif\ncolor+=emissive.rgb;float opacity=mat.baseColor.w*u_opacity;\n#ifdef HAS_ATTRIBUTE_a_pbr\nfloat resEmission=v_roughness_metallic_emissive_alpha.z;resEmission*=v_height_based_emission_params.z+v_height_based_emission_params.w*pow(clamp(v_height_based_emission_params.x,0.0,1.0),v_height_based_emission_params.y);color=mix(color,v_color_mix.rgb,min(1.0,resEmission));\n#ifdef HAS_ATTRIBUTE_a_color_4f\nfloat distance=length(vec2(1.3*max(0.0,abs(color_4f.x)-color_4f.z),color_4f.y));distance+= mix(0.5,0.0,clamp(resEmission-1.0,0.0,1.0));opacity*=v_roughness_metallic_emissive_alpha.w*saturate(1.0-distance*distance);\n#endif\n#endif\ncolor=linearTosRGB(color);color*=opacity;finalColor=vec4(color,opacity);\n#endif\n#ifdef FOG\nfinalColor=fog_dither(fog_apply_premultiplied(finalColor,v_fog_pos,v_position_height.w));\n#endif\n#ifdef RENDER_CUTOFF\nfinalColor*=v_cutoff_opacity;\n#endif\n#ifdef INDICATOR_CUTOUT\nfinalColor=applyCutout(finalColor);\n#endif\ngl_FragColor=finalColor;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\nHANDLE_WIREFRAME_DEBUG;}","attribute vec3 a_pos_3f;\n#pragma mapbox: define-attribute highp vec3 normal_3f\n#pragma mapbox: define-attribute highp vec2 uv_2f\n#pragma mapbox: define-attribute highp vec3 color_3f\n#pragma mapbox: define-attribute highp vec4 color_4f\n#pragma mapbox: define-attribute-vertex-shader-only highp vec4 pbr\n#pragma mapbox: define-attribute-vertex-shader-only highp vec3 heightBasedEmissiveStrength\nuniform mat4 u_matrix;uniform mat4 u_lighting_matrix;uniform vec3 u_camera_pos;uniform vec4 u_color_mix;\n#ifdef INSTANCED_ARRAYS\nattribute vec4 a_normal_matrix0;attribute vec4 a_normal_matrix1;attribute vec4 a_normal_matrix2;attribute vec4 a_normal_matrix3;\n#else\nuniform highp mat4 u_normal_matrix;\n#endif\n#ifdef RENDER_SHADOWS\nuniform mat4 u_light_matrix_0;uniform mat4 u_light_matrix_1;varying vec4 v_pos_light_view_0;varying vec4 v_pos_light_view_1;varying float v_depth_shadows;\n#endif\nvarying vec4 v_position_height;varying lowp vec4 v_color_mix;\n#ifdef TERRAIN_FRAGMENT_OCCLUSION\nvarying highp float v_depth;\n#endif\n#ifdef HAS_ATTRIBUTE_a_pbr\nvarying lowp vec4 v_roughness_metallic_emissive_alpha;varying mediump vec4 v_height_based_emission_params;\n#endif\nvoid main() {\n#pragma mapbox: initialize-attribute highp vec3 normal_3f\n#pragma mapbox: initialize-attribute highp vec2 uv_2f\n#pragma mapbox: initialize-attribute highp vec3 color_3f\n#pragma mapbox: initialize-attribute highp vec4 color_4f\n#pragma mapbox: initialize-attribute-custom highp vec4 pbr\n#pragma mapbox: initialize-attribute-custom highp vec3 heightBasedEmissiveStrength\nhighp mat4 normal_matrix;\n#ifdef INSTANCED_ARRAYS\nnormal_matrix=mat4(a_normal_matrix0,a_normal_matrix1,a_normal_matrix2,a_normal_matrix3);\n#else\nnormal_matrix=u_normal_matrix;\n#endif\nvec3 local_pos;mat3 rs;\n#ifdef MODEL_POSITION_ON_GPU\nvec3 pos_color=normal_matrix[0].xyz;vec4 translate=normal_matrix[1];vec3 pos_a=floor(pos_color);vec3 rgb=1.05*(pos_color-pos_a);float color_mix=pos_a.z/100.0;v_color_mix=vec4(sRGBToLinear(rgb),color_mix);float meter_to_tile=normal_matrix[0].w;vec4 pos=vec4(pos_a.xy,translate.z,1.0);rs[0].x=normal_matrix[1].w;rs[0].yz=normal_matrix[2].xy;rs[1].xy=normal_matrix[2].zw;rs[1].z=normal_matrix[3].x;rs[2].xyz=normal_matrix[3].yzw;vec4 pos_node=u_lighting_matrix*vec4(a_pos_3f,1.0);vec3 rotated_pos_node=rs*pos_node.xyz;vec3 pos_model_tile=(rotated_pos_node+vec3(translate.xy,0.0))*vec3(meter_to_tile,meter_to_tile,1.0);pos.xyz+=pos_model_tile;local_pos=pos.xyz;gl_Position=u_matrix*pos;pos.z*=meter_to_tile;v_position_height.xyz=pos.xyz-u_camera_pos;\n#else\nlocal_pos=a_pos_3f;gl_Position=u_matrix*vec4(a_pos_3f,1);v_position_height.xyz=vec3(u_lighting_matrix*vec4(a_pos_3f,1));v_color_mix=vec4(sRGBToLinear(u_color_mix.rgb),u_color_mix.a);\n#endif\nv_position_height.w=a_pos_3f.z;\n#ifdef HAS_ATTRIBUTE_a_pbr\nvec4 albedo_c=decode_color(pbr.xy);vec2 e_r_m=unpack_float(pbr.z);vec2 r_m= unpack_float(e_r_m.y*16.0);r_m.r=r_m.r*16.0;v_color_mix=vec4(albedo_c.rgb,1.0);v_roughness_metallic_emissive_alpha=vec4(vec3(r_m,e_r_m.x)/255.0,albedo_c.a);v_roughness_metallic_emissive_alpha.z*=2.0;float heightBasedRelativeIntepolation=a_pos_3f.z*heightBasedEmissiveStrength.x+heightBasedEmissiveStrength.y;v_height_based_emission_params.x=heightBasedRelativeIntepolation;v_height_based_emission_params.y=heightBasedEmissiveStrength.z;vec2 emissionMultiplierValues=unpack_float(pbr.w)/256.0;v_height_based_emission_params.z=emissionMultiplierValues.x;v_height_based_emission_params.w=emissionMultiplierValues.y-emissionMultiplierValues.x;\n#endif\n#ifdef FOG\nv_fog_pos=fog_position(local_pos);\n#endif\n#ifdef RENDER_CUTOFF\nv_cutoff_opacity=cutoff_opacity(u_cutoff_params,gl_Position.z);\n#endif\n#ifdef TERRAIN_FRAGMENT_OCCLUSION\nv_depth=gl_Position.z/gl_Position.w;\n#endif\n#ifdef HAS_ATTRIBUTE_a_normal_3f\n#ifdef MODEL_POSITION_ON_GPU\nfloat x_squared_scale=dot(rs[0],rs[0]);float y_squared_scale=dot(rs[1],rs[1]);float z_squared_scale=dot(rs[2],rs[2]);vec3 squared_scale=vec3(x_squared_scale,y_squared_scale,z_squared_scale);normal_3f=rs*((u_lighting_matrix*vec4(normal_3f,0.0)).xyz/squared_scale);normal_3f=normalize(normal_3f);\n#else\nnormal_3f=vec3(normal_matrix*vec4(normal_3f,0));\n#endif\n#endif\n#ifdef HAS_ATTRIBUTE_a_pbr\n#ifdef HAS_ATTRIBUTE_a_color_4f\nv_roughness_metallic_emissive_alpha.w=clamp(color_4f.a*v_roughness_metallic_emissive_alpha.w*(v_roughness_metallic_emissive_alpha.z-1.0),0.0,1.0);\n#endif\n#endif\n#ifdef RENDER_SHADOWS\nvec3 shadow_pos=local_pos;\n#ifdef NORMAL_OFFSET\n#ifdef HAS_ATTRIBUTE_a_normal_3f\n#ifdef MODEL_POSITION_ON_GPU\nvec3 offset=shadow_normal_offset(vec3(-normal_3f.xy,normal_3f.z));shadow_pos+=offset*shadow_normal_offset_multiplier0();\n#else\nvec3 offset=shadow_normal_offset_model(normalize(normal_3f));shadow_pos+=offset*shadow_normal_offset_multiplier0();\n#endif\n#endif\n#endif\nv_pos_light_view_0=u_light_matrix_0*vec4(shadow_pos,1);v_pos_light_view_1=u_light_matrix_1*vec4(shadow_pos,1);v_depth_shadows=gl_Position.w;\n#endif\n}"),modelDepth:dE("varying highp float v_depth;void main() {\n#ifndef DEPTH_TEXTURE\ngl_FragColor=pack_depth(v_depth);\n#endif\n}","attribute vec3 a_pos_3f;uniform mat4 u_matrix;varying highp float v_depth;\n#ifdef MODEL_POSITION_ON_GPU\n#ifdef INSTANCED_ARRAYS\nattribute vec4 a_normal_matrix0;attribute vec4 a_normal_matrix1;attribute vec4 a_normal_matrix2;attribute vec4 a_normal_matrix3;\n#else\nuniform highp mat4 u_instance;\n#endif\nuniform highp mat4 u_node_matrix;\n#endif\nvoid main() {\n#ifdef MODEL_POSITION_ON_GPU\nhighp mat4 instance;\n#ifdef INSTANCED_ARRAYS\ninstance=mat4(a_normal_matrix0,a_normal_matrix1,a_normal_matrix2,a_normal_matrix3);\n#else\ninstance=u_instance;\n#endif\nvec3 pos_color=instance[0].xyz;vec4 translate=instance[1];vec3 pos_a=floor(pos_color);float meter_to_tile=instance[0].w;vec4 pos=vec4(pos_a.xy,translate.z,1.0);mat3 rs;rs[0].x=instance[1].w;rs[0].yz=instance[2].xy;rs[1].xy=instance[2].zw;rs[1].z=instance[3].x;rs[2].xyz=instance[3].yzw;vec4 pos_node=u_node_matrix*vec4(a_pos_3f,1.0);vec3 rotated_pos_node=rs*pos_node.xyz;vec3 pos_model_tile=(rotated_pos_node+vec3(translate.xy,0.0))*vec3(meter_to_tile,meter_to_tile,1.0);pos.xyz+=pos_model_tile;gl_Position=u_matrix*pos;\n#else\ngl_Position=u_matrix*vec4(a_pos_3f,1);\n#endif\nv_depth=gl_Position.z/gl_Position.w;}"),stars:dE("varying highp vec2 v_uv;varying mediump float v_intensity;float shapeCircle(in vec2 uv)\n{float beginFade=0.6;float lengthFromCenter=length(v_uv);return 1.0-clamp((lengthFromCenter-beginFade)/(1.0-beginFade),0.0,1.0);}void main() {float alpha=shapeCircle(v_uv);vec3 color=vec3(1.0,1.0,1.0);alpha*=v_intensity;gl_FragColor=vec4(color*alpha,alpha);HANDLE_WIREFRAME_DEBUG;}","\nattribute vec3 a_pos_3f;attribute vec2 a_uv;attribute float a_size_scale;attribute float a_fade_opacity;uniform mat4 u_matrix;uniform vec3 u_up;uniform vec3 u_right;uniform float u_intensity_multiplier;varying highp vec2 v_uv;varying mediump float v_intensity;void main() {v_uv=a_uv;v_intensity=a_fade_opacity*u_intensity_multiplier;vec3 pos=a_pos_3f;pos+=a_uv.x*u_right*a_size_scale;pos+=a_uv.y*u_up*a_size_scale;gl_Position=u_matrix*vec4(pos,1.0);}")};function uE(t,e){const i=t.replace(/\s*\/\/[^\n]*\n/g,"\n").split("\n");for(let t of i)if(t=t.trim(),"#"===t[0]&&t.includes("if")&&!t.includes("endif")){t=t.replace("#","").replace(/ifdef|ifndef|elif|if/g,"").replace(/!|defined|\(|\)|\|\||&&/g,"").replace(/\s+/g," ").trim();const i=t.split(" ");for(const t of i)e.includes(t)||e.push(t);}}function dE(t,e){const i=/#pragma mapbox: ([\w\-]+) ([\w]+) ([\w]+) ([\w]+)/g;let r=e.match(/attribute(\S*) (highp |mediump |lowp )?([\w]+) ([\w]+)/g);r&&(r=r.filter(((t,e)=>r.indexOf(t)===e)));const n={},o=[...oE];return uE(t,o),uE(e,o),{fragmentSource:t=t.replace(i,((t,e,i,r,o)=>(n[o]=!0,"define"===e?`\n#ifndef HAS_UNIFORM_u_${o}\nvarying ${i} ${r} ${o};\n#else\nuniform ${i} ${r} u_${o};\n#endif\n`:"initialize"===e?`\n#ifdef HAS_UNIFORM_u_${o}\n    ${i} ${r} ${o} = u_${o};\n#endif\n`:"define-attribute"===e?`\n#ifdef HAS_ATTRIBUTE_a_${o}\n    varying ${i} ${r} ${o};\n#endif\n`:"initialize-attribute"===e?"":void 0))),vertexSource:e=e.replace(i,((t,e,i,r,o)=>{const s="float"===r?"vec2":r,a=o.match(/color/)?"color":s;return "define-attribute-vertex-shader-only"===e?`\n#ifdef HAS_ATTRIBUTE_a_${o}\nattribute ${i} ${r} a_${o};\n#endif\n`:n[o]?"define"===e?`\n#ifndef HAS_UNIFORM_u_${o}\nuniform lowp float u_${o}_t;\nattribute ${i} ${s} a_${o};\nvarying ${i} ${r} ${o};\n#else\nuniform ${i} ${r} u_${o};\n#endif\n`:"initialize"===e?"vec4"===a?`\n#ifndef HAS_UNIFORM_u_${o}\n    ${o} = a_${o};\n#else\n    ${i} ${r} ${o} = u_${o};\n#endif\n`:`\n#ifndef HAS_UNIFORM_u_${o}\n    ${o} = unpack_mix_${a}(a_${o}, u_${o}_t);\n#else\n    ${i} ${r} ${o} = u_${o};\n#endif\n`:"define-attribute"===e?`\n#ifdef HAS_ATTRIBUTE_a_${o}\n    attribute ${i} ${r} a_${o};\n    varying ${i} ${r} ${o};\n#endif\n`:"initialize-attribute"===e?`\n#ifdef HAS_ATTRIBUTE_a_${o}\n    ${o} = a_${o};\n#endif\n`:void 0:"define"===e?`\n#ifndef HAS_UNIFORM_u_${o}\nuniform lowp float u_${o}_t;\nattribute ${i} ${s} a_${o};\n#else\nuniform ${i} ${r} u_${o};\n#endif\n`:"define-instanced"===e?"mat4"===a?`\n#ifdef INSTANCED_ARRAYS\nattribute vec4 a_${o}0;\nattribute vec4 a_${o}1;\nattribute vec4 a_${o}2;\nattribute vec4 a_${o}3;\n#else\nuniform ${i} ${r} u_${o};\n#endif\n`:`\n#ifdef INSTANCED_ARRAYS\nattribute ${i} ${s} a_${o};\n#else\nuniform ${i} ${r} u_${o};\n#endif\n`:"initialize-attribute-custom"===e?`\n#ifdef HAS_ATTRIBUTE_a_${o}\n    ${i} ${r} ${o} = a_${o};\n#endif\n`:"vec4"===a?`\n#ifndef HAS_UNIFORM_u_${o}\n    ${i} ${r} ${o} = a_${o};\n#else\n    ${i} ${r} ${o} = u_${o};\n#endif\n`:`\n#ifndef HAS_UNIFORM_u_${o}\n    ${i} ${r} ${o} = unpack_mix_${a}(a_${o}, u_${o}_t);\n#else\n    ${i} ${r} ${o} = u_${o};\n#endif\n`})),staticAttributes:r,usedDefines:o}}class pE{constructor(){this.boundProgram=null,this.boundLayoutVertexBuffer=null,this.boundPaintVertexBuffers=[],this.boundIndexBuffer=null,this.boundVertexOffset=null,this.boundDynamicVertexBuffers=[],this.vao=null;}bind(t,e,i,r,n,o,s,a){this.context=t;let l=this.boundPaintVertexBuffers.length!==r.length;for(let t=0;!l&&t<r.length;t++)this.boundPaintVertexBuffers[t]!==r[t]&&(l=!0);let c=this.boundDynamicVertexBuffers.length!==s.length;for(let t=0;!c&&t<s.length;t++)this.boundDynamicVertexBuffers[t]!==s[t]&&(c=!0);if(!this.vao||this.boundProgram!==e||this.boundLayoutVertexBuffer!==i||l||c||this.boundIndexBuffer!==n||this.boundVertexOffset!==o)this.freshBind(e,i,r,n,o,s,a);else {t.bindVertexArrayOES.set(this.vao);for(const i of s)i&&(i.bind(),a&&i.instanceCount&&i.setVertexAttribDivisor(t.gl,e,a));n&&n.dynamicDraw&&n.bind();}}freshBind(t,e,i,r,n,o,s){const a=t.numAttributes,l=this.context,c=l.gl;this.vao&&this.destroy(),this.vao=l.gl.createVertexArray(),l.bindVertexArrayOES.set(this.vao),this.boundProgram=t,this.boundLayoutVertexBuffer=e,this.boundPaintVertexBuffers=i,this.boundIndexBuffer=r,this.boundVertexOffset=n,this.boundDynamicVertexBuffers=o,e.enableAttributes(c,t),e.bind(),e.setVertexAttribPointers(c,t,n);for(const e of i)e.enableAttributes(c,t),e.bind(),e.setVertexAttribPointers(c,t,n);for(const e of o)e&&(e.enableAttributes(c,t),e.bind(),e.setVertexAttribPointers(c,t,n),s&&e.instanceCount&&e.setVertexAttribDivisor(c,t,s));r&&r.bind(),l.currentNumAttributes=a;}destroy(){this.vao&&(this.context.gl.deleteVertexArray(this.vao),this.vao=null);}}function fE(t,e){const i=Math.pow(2,e.canonical.z),r=e.canonical.y;return [new Yd(0,r/i).toLngLat().lat,new Yd(0,(r+1)/i).toLngLat().lat]}function mE(t,e,i,r,n,o,s){const a=t.context,l=a.gl,c=i.fbo;if(!c)return;t.prepareDrawTile();const h=t.useProgram("hillshade");a.activeTexture.set(l.TEXTURE0),l.bindTexture(l.TEXTURE_2D,c.colorAttachment.get());const u=((t,e,i,r)=>{const n=i.paint.get("hillshade-shadow-color"),o=i.paint.get("hillshade-highlight-color"),s=i.paint.get("hillshade-accent-color");let a=i.paint.get("hillshade-illumination-direction")*(Math.PI/180);"viewport"===i.paint.get("hillshade-illumination-anchor")&&(a-=t.transform.angle);const l=!t.options.moving;return {u_matrix:r||t.transform.calculateProjMatrix(e.tileID.toUnwrapped(),l),u_image:0,u_latrange:fE(0,e.tileID),u_light:[i.paint.get("hillshade-exaggeration"),a],u_shadow:n,u_highlight:o,u_accent:s}})(t,i,r,t.terrain?e.projMatrix:null);t.uploadCommonUniforms(a,h,e.toUnwrapped());const{tileBoundsBuffer:d,tileBoundsIndexBuffer:p,tileBoundsSegments:f}=t.getTileBoundsBuffers(i);h.draw(t,l.TRIANGLES,n,o,s,_x.disabled,u,r.id,d,p,f);}function _E(t,e,i){if(!e.needsDEMTextureUpload)return;const r=t.context,n=r.gl;r.pixelStoreUnpackPremultiplyAlpha.set(!1),e.demTexture=e.demTexture||t.getTileTexture(i.stride);const o=i.getPixels();e.demTexture?e.demTexture.update(o,{premultiply:!1}):e.demTexture=new hy(r,o,t.terrainUseFloatDEM()?n.R32F:n.RGBA,{premultiply:!1}),e.needsDEMTextureUpload=!1;}function gE(t,e,i,r,n,o){const s=t.context,a=s.gl;if(!e.dem)return;const l=e.dem;if(s.activeTexture.set(a.TEXTURE1),_E(t,e,l),!e.demTexture)return;e.demTexture.bind(a.NEAREST,a.CLAMP_TO_EDGE);const c=l.dim;s.activeTexture.set(a.TEXTURE0);let h=e.fbo;if(!h){const t=new hy(s,{width:c,height:c,data:null},a.RGBA);t.bind(a.LINEAR,a.CLAMP_TO_EDGE),h=e.fbo=s.createFramebuffer(c,c,!0,"renderbuffer"),h.colorAttachment.set(t.texture);}s.bindFramebuffer.set(h.framebuffer),s.viewport.set([0,0,c,c]);const{tileBoundsBuffer:u,tileBoundsIndexBuffer:d,tileBoundsSegments:p}=t.getMercatorTileBoundsBuffers();t.useProgram("hillshadePrepare").draw(t,a.TRIANGLES,r,n,o,_x.disabled,((t,e)=>{const i=e.stride,r=mu.create();return mu.ortho(r,0,sr,-sr,0,0,1),mu.translate(r,r,[0,-sr,0]),{u_matrix:r,u_image:1,u_dimension:[i,i],u_zoom:t.overscaledZ,u_unpack:e.unpackVector}})(e.tileID,l),i.id,u,d,p),e.needsHillshadePrepare=!1;}const yE=t=>({u_matrix:new Al(t),u_image0:new xl(t),u_skirt_height:new vl(t),u_ground_shadow_factor:new wl(t)}),xE=(t,e,i)=>({u_matrix:t,u_image0:0,u_skirt_height:e,u_ground_shadow_factor:i}),vE=(t,e,i,r,n,o,s,a,l,c,h,u,d,p,f)=>({u_proj_matrix:Float32Array.from(t),u_globe_matrix:e,u_normalize_matrix:Float32Array.from(r),u_merc_matrix:i,u_zoom_transition:n,u_merc_center:o,u_image0:0,u_frustum_tl:s,u_frustum_tr:a,u_frustum_br:l,u_frustum_bl:c,u_globe_pos:h,u_globe_radius:u,u_viewport:d,u_grid_matrix:f?Float32Array.from(f):new Float32Array(9),u_skirt_height:p}),bE=(t,e)=>{if(e>0&&t.terrain&&W("Cutoff is currently disabled on terrain"),e<=0||t.terrain)return {shouldRenderCutoff:!1,uniformValues:{u_cutoff_params:[0,0,0,0]}};const i=t.transform,r=Math.max(Math.abs(i._zoom-(t.minCutoffZoom-1)),1),n=i.isLODDisabled(!1)?D(60,45,i.pitch):D(30,15,i.pitch),o=i._farZ-i._nearZ,s=e*i.height,a=((1-(l=n))*(.75*i.cameraToCenterDistance)+l*(i._farZ+s))*r;var l;return {shouldRenderCutoff:n<1,uniformValues:{u_cutoff_params:[i._nearZ,i._farZ,(a-i._nearZ)/o,(a-s-i._nearZ)/o]}}};function wE(t,e){return null!=t&&null!=e&&!(!t.hasData()||!e.hasData())&&null!=t.demTexture&&null!=e.demTexture&&t.tileID.key!==e.tileID.key}const TE=new class{constructor(){this.operations={};}newMorphing(t,e,i,r,n){if(t in this.operations){const e=this.operations[t];e.to.tileID.key!==i.tileID.key&&(e.queued=i);}else this.operations[t]={startTime:r,phase:0,duration:n,from:e,to:i,queued:null};}getMorphValuesForProxy(t){if(!(t in this.operations))return null;const e=this.operations[t];return {from:e.from,to:e.to,phase:e.phase}}update(t){for(const e in this.operations){const i=this.operations[e];for(i.phase=(t-i.startTime)/i.duration;i.phase>=1||!this._validOp(i);)if(!this._nextOp(i,t)){delete this.operations[e];break}}}_nextOp(t,e){return !!t.queued&&(t.from=t.to,t.to=t.queued,t.queued=null,t.phase=0,t.startTime=e,!0)}_validOp(t){return t.from.hasData()&&t.to.hasData()}},EE={0:null,1:"TERRAIN_VERTEX_MORPHING"};function ME(t,e,i){if(0===e)return 0;const r=e<1&&514===i?.25/e:1;return 6*Math.pow(1.5,22-t)*Math.max(e,1)*r}function AE(t,e){const i=1<<t.z;return !e&&(0===t.x||t.x===i-1)||0===t.y||t.y===i-1}const SE=t=>({u_matrix:t});function IE(t,e,i,r,n){if(n>0){const o=ue.now(),s=(o-t.timeAdded)/n,a=e?(o-e.timeAdded)/n:-1,l=i.getSource(),c=r.coveringZoomLevel({tileSize:l.tileSize,roundZoom:l.roundZoom}),h=!e||Math.abs(e.tileID.overscaledZ-c)>Math.abs(t.tileID.overscaledZ-c),u=h&&t.refreshedUponExpiration?1:z(h?s:1-a,0,1);return t.refreshedUponExpiration&&s>=1&&(t.refreshedUponExpiration=!1),e?{opacity:1,mix:1-u}:{opacity:u,mix:0}}return {opacity:1,mix:0}}class CE extends yx{constructor(t){const e={type:"raster-dem",maxzoom:t.transform.maxZoom},i=new Zb(Pw(),null),r=Vw("mock-dem",e,i,t.style);super("mock-dem",r,!1),r.setEventedParent(this),this._sourceLoaded=!0;}_loadTile(t,e){t.state="loaded",e(null);}}class zE extends yx{constructor(t){const e=Vw("proxy",{type:"geojson",maxzoom:t.transform.maxZoom},new Zb(Pw(),null),t.style);super("proxy",e,!1),e.setEventedParent(this),this.map=this.getSource().map=t,this.used=this._sourceLoaded=!0,this.renderCache=[],this.renderCachePool=[],this.proxyCachedFBO={};}update(t,e,i){if(t.freezeTileCoverage)return;this.transform=t;const r=t.coveringTiles({tileSize:this._source.tileSize,minzoom:this._source.minzoom,maxzoom:this._source.maxzoom,roundZoom:this._source.roundZoom,reparseOverscaled:this._source.reparseOverscaled}).reduce(((e,i)=>{if(e[i.key]="",!this._tiles[i.key]){const e=new vy(i,this._source.tileSize*i.overscaleFactor(),t.tileZoom);e.state="loaded",this._tiles[i.key]=e;}return e}),{});for(const t in this._tiles)t in r||(this.freeFBO(t),this._tiles[t].unloadVectorData(),delete this._tiles[t]);}freeFBO(t){const e=this.proxyCachedFBO[t];if(void 0!==e){const i=Object.values(e);this.renderCachePool.push(...i),delete this.proxyCachedFBO[t];}}deallocRenderCache(){this.renderCache.forEach((t=>t.fb.destroy())),this.renderCache=[],this.renderCachePool=[],this.proxyCachedFBO={};}}class DE extends Rd{constructor(t,e,i){super(t.overscaledZ,t.wrap,t.canonical.z,t.canonical.x,t.canonical.y),this.proxyTileKey=e,this.projMatrix=i;}}class PE extends Bm{constructor(t,e){super(),this.painter=t,this.terrainTileForTile={},this.prevTerrainTileForTile={};const[i,r,n]=function(t){const e=new ya,i=new Ba,r=131;e.reserve(17161),i.reserve(33800);const n=sr/128,o=sr+n/2,s=o+n;for(let t=-n;t<s;t+=n)for(let i=-n;i<s;i+=n){const r=i<0||i>o||t<0||t>o?24575:0,n=z(Math.round(i),0,sr),s=z(Math.round(t),0,sr);e.emplaceBack(n+r,s);}const a=(t,e)=>{const n=e*r+t;i.emplaceBack(n+1,n,n+r),i.emplaceBack(n+r,n+r+1,n+1);};for(let t=1;t<129;t++)for(let e=1;e<129;e++)a(e,t);return [0,129].forEach((t=>{for(let e=0;e<130;e++)a(e,t),a(t,e);})),[e,i,32768]}(),o=t.context;this.gridBuffer=o.createVertexBuffer(i,Iu.members),this.gridIndexBuffer=o.createIndexBuffer(r),this.gridSegments=Wl.simpleSegment(0,0,i.length,r.length),this.gridNoSkirtSegments=Wl.simpleSegment(0,0,i.length,n),this.proxyCoords=[],this.proxiedCoords={},this._visibleDemTiles=[],this._drapedRenderBatches=[],this._sourceTilesOverlap={},this.proxySourceCache=new zE(e.map),this.orthoMatrix=mu.create(),mu.ortho(this.orthoMatrix,"globe"===this.painter.transform.projection.name?.015:0,sr,0,sr,0,1);const s=o.gl;this._overlapStencilMode=new ux({func:s.GEQUAL,mask:255},0,255,s.KEEP,s.KEEP,s.REPLACE),this._previousZoom=t.transform.zoom,this.pool=[],this._findCoveringTileCache={},this._tilesDirty={},this.style=e,this._useVertexMorphing=!0,this._exaggeration=1,this._mockSourceCache=new CE(e.map),this._pendingGroundEffectLayers=[];}set style(t){t.on("data",this._onStyleDataEvent.bind(this)),this._style=t,this._style.map.on("moveend",(()=>{this._clearLineLayersFromRenderCache();}));}update(t,e,i){if(t&&t.terrain){this._style!==t&&(this.style=t),this.enabled=!0;const r=t.terrain.properties;this.sourceCache=0===t.terrain.drapeRenderMode?this._mockSourceCache:t._getSourceCache(r.get("source")),this._exaggeration=r.get("exaggeration");const n=()=>{this.sourceCache.used&&W(`Raster DEM source '${this.sourceCache.id}' is used both for terrain and as layer source.\nThis leads to lower resolution of hillshade. For full hillshade resolution but higher memory consumption, define another raster DEM source.`);const t=this.getScaledDemTileSize();this.sourceCache.update(e,t,!0),this.resetTileLookupCache(this.sourceCache.id);};this.sourceCache.usedForTerrain||(this.resetTileLookupCache(this.sourceCache.id),this.sourceCache.usedForTerrain=!0,n(),this._initializing=!0),n(),e.updateElevation(!0,i),this.resetTileLookupCache(this.proxySourceCache.id),this.proxySourceCache.update(e),this._emptyDEMTextureDirty=!0;}else this._disable();}resetTileLookupCache(t){this._findCoveringTileCache[t]={};}getScaledDemTileSize(){return this.sourceCache.getSource().tileSize/128*this.proxySourceCache.getSource().tileSize}_onStyleDataEvent(t){t.coord&&"source"===t.dataType?this._clearRenderCacheForTile(t.sourceCacheId,t.coord):"style"===t.dataType&&(this.invalidateRenderCache=!0);}_disable(){if(this.enabled&&(this.enabled=!1,this._sharedDepthStencil=void 0,this.proxySourceCache.deallocRenderCache(),this._style))for(const t in this._style._sourceCaches)this._style._sourceCaches[t].usedForTerrain=!1;}destroy(){this._disable(),this._emptyDEMTexture&&this._emptyDEMTexture.destroy(),this._emptyDepthBufferTexture&&this._emptyDepthBufferTexture.destroy(),this.pool.forEach((t=>t.fb.destroy())),this.pool=[],this._depthFBO&&(this._depthFBO.destroy(),this._depthFBO=void 0,this._depthTexture=void 0),this.framebufferCopyTexture&&this.framebufferCopyTexture.destroy();}_source(){return this.enabled?this.sourceCache:null}isUsingMockSource(){return this.sourceCache===this._mockSourceCache}exaggeration(){return this._exaggeration}get visibleDemTiles(){return this._visibleDemTiles}get drapeBufferSize(){const t=2*this.proxySourceCache.getSource().tileSize;return [t,t]}set useVertexMorphing(t){this._useVertexMorphing=t;}updateTileBinding(t){if(!this.enabled)return;this.prevTerrainTileForTile=this.terrainTileForTile;const e=this.proxySourceCache,i=this.painter.transform;this._initializing&&(this._initializing=0===i._centerAltitude&&-1===this.getAtPointOrZero(Yd.fromLngLat(i.center),-1),this._emptyDEMTextureDirty=!this._initializing);const r=this.proxyCoords=e.getIds().map((t=>{const r=e.getTileByID(t).tileID;return r.projMatrix=i.calculateProjMatrix(r.toUnwrapped()),r}));!function(t,e){const i=e.transform.pointCoordinate(e.transform.getCameraPoint()),r=new y(i.x,i.y);t.sort(((t,e)=>{if(e.overscaledZ-t.overscaledZ)return e.overscaledZ-t.overscaledZ;const i=new y(t.canonical.x+(1<<t.canonical.z)*t.wrap,t.canonical.y),n=new y(e.canonical.x+(1<<e.canonical.z)*e.wrap,e.canonical.y),o=r.mult(1<<t.canonical.z);return o.x-=.5,o.y-=.5,o.distSqr(i)-o.distSqr(n)}));}(r,this.painter),this._previousZoom=i.zoom;const n=this.proxyToSource||{};this.proxyToSource={},r.forEach((t=>{this.proxyToSource[t.key]={};})),this.terrainTileForTile={};const o=this._style._sourceCaches;for(const e in o){const i=o[e];if(!i.used)continue;if(i!==this.sourceCache&&this.resetTileLookupCache(i.id),this._setupProxiedCoordsForOrtho(i,t[e],n),i.usedForTerrain)continue;const r=t[e];i.getSource().reparseOverscaled&&this._assignTerrainTiles(r);}this.proxiedCoords[e.id]=r.map((t=>new DE(t,t.key,this.orthoMatrix))),this._assignTerrainTiles(r),this._prepareDEMTextures(),this._setupDrapedRenderBatches(),this._initFBOPool(),this._setupRenderCache(n),this.renderingToTexture=!1,this._updateTimestamp=ue.now();const s={};this._visibleDemTiles=[];for(const t of this.proxyCoords){const e=this.terrainTileForTile[t.key];if(!e)continue;const i=e.tileID.key;i in s||(this._visibleDemTiles.push(e),s[i]=i);}}_assignTerrainTiles(t){this._initializing||t.forEach((t=>{if(this.terrainTileForTile[t.key])return;const e=this._findTileCoveringTileID(t,this.sourceCache);e&&(this.terrainTileForTile[t.key]=e);}));}_prepareDEMTextures(){const t=this.painter.context,e=t.gl;for(const i in this.terrainTileForTile){const r=this.terrainTileForTile[i],n=r.dem;!n||r.demTexture&&!r.needsDEMTextureUpload||(t.activeTexture.set(e.TEXTURE1),_E(this.painter,r,n));}}_prepareDemTileUniforms(t,e,i,r){if(!e||null==e.demTexture)return !1;const n=t.tileID.canonical,o=Math.pow(2,e.tileID.canonical.z-n.z),s=r||"";return i[`u_dem_tl${s}`]=[n.x*o%1,n.y*o%1],i[`u_dem_scale${s}`]=o,!0}get emptyDEMTexture(){return !this._emptyDEMTextureDirty&&this._emptyDEMTexture?this._emptyDEMTexture:this._updateEmptyDEMTexture()}get emptyDepthBufferTexture(){const t=this.painter.context,e=t.gl;if(!this._emptyDepthBufferTexture){const i=new Np({width:1,height:1},Uint8Array.of(255,255,255,255));this._emptyDepthBufferTexture=new hy(t,i,e.RGBA,{premultiply:!1});}return this._emptyDepthBufferTexture}_getLoadedAreaMinimum(){let t=0;const e=this._visibleDemTiles.reduce(((e,i)=>{if(!i.dem)return e;const r=i.dem.tree.minimums[0];return r>0&&t++,e+r}),0);return t?e/t:0}_updateEmptyDEMTexture(){const t=this.painter.context,e=t.gl;t.activeTexture.set(e.TEXTURE2);const i=this._getLoadedAreaMinimum(),[r,n]=(()=>{if(this.painter.terrainUseFloatDEM()){const t=new Up({width:1,height:1},new Float32Array([i]));return [e.R32F,t]}{const t=new Np({width:1,height:1},new Uint8Array(km.pack(i,this.sourceCache.getSource().encoding)));return [e.RGBA,t]}})();this._emptyDEMTextureDirty=!1;let o=this._emptyDEMTexture;return o?o.update(n,{premultiply:!1}):o=this._emptyDEMTexture=new hy(t,n,r,{premultiply:!1}),o}setupElevationDraw(t,e,i){const r=this.painter.context,n=r.gl,o=(s=this.sourceCache.getSource().encoding,{u_dem:2,u_dem_prev:4,u_dem_unpack:km.getUnpackVector(s),u_dem_tl:[0,0],u_dem_tl_prev:[0,0],u_dem_scale:0,u_dem_scale_prev:0,u_dem_size:0,u_dem_lerp:1,u_depth:3,u_depth_size_inv:[0,0],u_exaggeration:0});var s;o.u_exaggeration=this.exaggeration();let a=null,l=null,c=1;if(i&&i.morphing&&this._useVertexMorphing){const e=i.morphing.srcDemTile,r=i.morphing.dstDemTile;c=i.morphing.phase,e&&r&&(this._prepareDemTileUniforms(t,e,o,"_prev")&&(l=e),this._prepareDemTileUniforms(t,r,o)&&(a=r));}const h=t=>t&&t.demTexture&&this.painter.terrainUseFloatDEM()?n.LINEAR:n.NEAREST,u=t=>{o.u_dem_size=1===t.size[0]?1:t.size[0]-2;};if(l&&a)r.activeTexture.set(n.TEXTURE2),a.demTexture.bind(h(a),n.CLAMP_TO_EDGE),r.activeTexture.set(n.TEXTURE4),l.demTexture.bind(h(l),n.CLAMP_TO_EDGE),a.demTexture&&u(a.demTexture),o.u_dem_lerp=c;else {a=this.terrainTileForTile[t.tileID.key],r.activeTexture.set(n.TEXTURE2);const e=this._prepareDemTileUniforms(t,a,o)?a.demTexture:this.emptyDEMTexture;e.bind(h(a),n.CLAMP_TO_EDGE),u(e);}if(r.activeTexture.set(n.TEXTURE3),i&&i.useDepthForOcclusion?(this._depthTexture&&this._depthTexture.bind(n.NEAREST,n.CLAMP_TO_EDGE),this._depthFBO&&(o.u_depth_size_inv=[1/this._depthFBO.width,1/this._depthFBO.height])):(this.emptyDepthBufferTexture.bind(n.NEAREST,n.CLAMP_TO_EDGE),o.u_depth_size_inv=[1,1]),i&&i.useMeterToDem&&a){const t=(1<<a.tileID.canonical.z)*Vd(1,this.painter.transform.center.lat)*this.sourceCache.getSource().tileSize;o.u_meter_to_dem=t;}if(i&&i.labelPlaneMatrixInv&&(o.u_label_plane_matrix_inv=i.labelPlaneMatrixInv),e.setTerrainUniformValues(r,o),"globe"===this.painter.transform.projection.name){const n=this.globeUniformValues(this.painter.transform,t.tileID.canonical,i&&i.useDenormalizedUpVectorScale);e.setGlobeUniformValues(r,n);}}globeUniformValues(t,e,i){const r=t.projection;return {u_tile_tl_up:r.upVector(e,0,0),u_tile_tr_up:r.upVector(e,sr,0),u_tile_br_up:r.upVector(e,sr,sr),u_tile_bl_up:r.upVector(e,0,sr),u_tile_up_scale:i?$u(1):r.upVectorScale(e,t.center.lat,t.worldSize).metersToTile}}renderToBackBuffer(t){const e=this.painter,i=this.painter.context;0!==t.length&&(i.bindFramebuffer.set(null),i.viewport.set([0,0,e.width,e.height]),e.gpuTimingDeferredRenderStart(),this.renderingToTexture=!1,function(t,e,i,r,n){if("globe"===t.transform.projection.name)!function(t,e,i,r,n){const o=t.context,s=o.gl;let a,l;const c=t.transform,h=md(t,o,c),u=e=>{if(l===e)return;const i=[EE[e],"PROJECTION_GLOBE_VIEW"];h&&i.push("CUSTOM_ANTIALIASING"),a=t.useProgram("globeRaster",null,i),l=e;},d=t.colorModeForRenderPass(),p=new cx(s.LEQUAL,cx.ReadWrite,t.depthRangeFor3D);TE.update(n);const f=function(t){const e=t.pixelsPerMeter,i=e/Vd(1,t.center.lat),r=mu.identity(new Float64Array(16));return mu.translate(r,r,[t.point.x,t.point.y,0]),mu.scale(r,r,[i,i,e]),Float32Array.from(r)}(c),m=[Nd(c.center.lng),Ud(c.center.lat)],_=t.globeSharedBuffers,g=[c.width*ue.devicePixelRatio,c.height*ue.devicePixelRatio],y=Float32Array.from(c.globeMatrix),x={useDenormalizedUpVectorScale:!0};{const c=t.transform,h=ME(c.zoom,e.exaggeration(),e.sourceCache._source.tileSize);l=-1;const v=s.TRIANGLES;for(const l of r){const r=i.getTile(l),b=ux.disabled,w=e.prevTerrainTileForTile[l.key],T=e.terrainTileForTile[l.key];wE(w,T)&&TE.newMorphing(l.key,w,T,n,250),o.activeTexture.set(s.TEXTURE0),r.texture.bind(s.LINEAR,s.CLAMP_TO_EDGE);const E=TE.getMorphValuesForProxy(l.key),A=E?1:0;E&&De(x,{morphing:{srcDemTile:E.from,dstDemTile:E.to,phase:M(E.phase)}});const S=ed(l.canonical),I=gd(S.getCenter().lat),C=_d(l.canonical,S,I,c.worldSize/c._pixelsPerMercatorPixel),z=ld(Yu(l.canonical)),D=vE(c.projMatrix,y,f,z,pd(c.zoom),m,c.frustumCorners.TL,c.frustumCorners.TR,c.frustumCorners.BR,c.frustumCorners.BL,c.globeCenterInViewSpace,c.globeRadius,g,h,C);if(u(A),a&&(e.setupElevationDraw(r,a,x),t.uploadCommonUniforms(o,a,l.toUnwrapped()),_)){const[e,i,r]=_.getGridBuffers(I,0!==h);a.draw(t,v,p,b,d,_x.backCCW,D,"globe_raster",e,i,r);}}}if(_){const n=["GLOBE_POLES","PROJECTION_GLOBE_VIEW"];h&&n.push("CUSTOM_ANTIALIASING"),a=t.useProgram("globeRaster",null,n);for(const n of r){const{x:r,y:l,z:h}=n.canonical,u=0===l,f=l===(1<<h)-1,[y,v,b,w]=_.getPoleBuffers(h);if(w&&(u||f)){const l=i.getTile(n);o.activeTexture.set(s.TEXTURE0),l.texture.bind(s.LINEAR,s.CLAMP_TO_EDGE);let _=fd(h,r,c);const T=ld(Yu(n.canonical)),E=(e,i)=>e.draw(t,s.TRIANGLES,p,ux.disabled,d,_x.disabled,vE(c.projMatrix,_,_,T,0,m,c.frustumCorners.TL,c.frustumCorners.TR,c.frustumCorners.BR,c.frustumCorners.BL,c.globeCenterInViewSpace,c.globeRadius,g,0),"globe_pole_raster",i,b,w);e.setupElevationDraw(l,a,x),t.uploadCommonUniforms(o,a,n.toUnwrapped()),u&&E(a,y),f&&(_=mu.scale(mu.create(),_,[1,-1,1]),E(a,v));}}}}(t,e,i,r,n);else {const o=t.context,s=o.gl;let a,l;const c=t.shadowRenderer,h=bE(t,t.longestCutoffRange),u=e=>{if(l===e)return;const i=[];i.push(EE[e]),h.shouldRenderCutoff&&i.push("RENDER_CUTOFF"),a=t.useProgram("terrainRaster",null,i),l=e;},d=t.colorModeForRenderPass(),p=new cx(s.LEQUAL,cx.ReadWrite,t.depthRangeFor3D);TE.update(n);const f=t.transform,m=ME(f.zoom,e.exaggeration(),e.sourceCache._source.tileSize);let _=[0,0,0];if(c){const e=t.style.directionalLight,i=t.style.ambientLight;e&&i&&(_=gA(e,i));}{l=-1;const g=s.TRIANGLES,[y,x]=[e.gridIndexBuffer,e.gridSegments];for(const l of r){const r=i.getTile(l),v=ux.disabled,b=e.prevTerrainTileForTile[l.key],w=e.terrainTileForTile[l.key];wE(b,w)&&TE.newMorphing(l.key,b,w,n,250),o.activeTexture.set(s.TEXTURE0),r.texture.bind(s.LINEAR,s.CLAMP_TO_EDGE,s.LINEAR_MIPMAP_NEAREST);const T=TE.getMorphValuesForProxy(l.key),E=T?1:0;let A;T&&(A={morphing:{srcDemTile:T.from,dstDemTile:T.to,phase:M(T.phase)}});const S=xE(l.projMatrix,AE(l.canonical,f.renderWorldCopies)?m/10:m,_);if(u(E),!a)continue;e.setupElevationDraw(r,a,A);const I=l.toUnwrapped();c&&c.setupShadows(I,a),t.uploadCommonUniforms(o,a,I,null,h),a.draw(t,g,p,v,d,_x.backCCW,S,"terrain_raster",e.gridBuffer,y,x);}}}}(e,this,this.proxySourceCache,t,this._updateTimestamp),this.renderingToTexture=!0,e.gpuTimingDeferredRenderEnd(),t.splice(0,t.length));}renderBatch(t){if(0===this._drapedRenderBatches.length)return t+1;this.renderingToTexture=!0;const e=this.painter,i=this.painter.context,r=this.proxySourceCache,n=this.proxiedCoords[r.id],o=this._drapedRenderBatches.shift(),s=e.style.order,a=[];let l=0;for(const c of n){const n=r.getTileByID(c.proxyTileKey),h=r.proxyCachedFBO[c.key]?r.proxyCachedFBO[c.key][t]:void 0,u=void 0!==h?r.renderCache[h]:this.pool[l++],d=void 0!==h;if(n.texture=u.tex,d&&!u.dirty){a.push(n.tileID);continue}let p;i.bindFramebuffer.set(u.fb.framebuffer),this.renderedToTile=!1,u.dirty&&(i.clear({color:li.transparent,stencil:0}),u.dirty=!1);for(let t=o.start;t<=o.end;++t){const r=e.style._layers[s[t]];if(r.isHidden(e.transform.zoom))continue;const n=e.style._getLayerSourceCache(r),o=n?this.proxyToSource[c.key][n.id]:[c];if(!o)continue;const a=o;i.viewport.set([0,0,u.fb.width,u.fb.height]),p!==(n?n.id:null)&&(this._setupStencil(u,o,r,n),p=n?n.id:null),e.renderLayer(e,n,r,a);}if(0===this._drapedRenderBatches.length)for(const t of this._pendingGroundEffectLayers){const r=e.style._layers[s[t]];if(r.isHidden(e.transform.zoom))continue;const n=e.style._getLayerSourceCache(r),o=n?this.proxyToSource[c.key][n.id]:[c];if(!o)continue;const a=o;i.viewport.set([0,0,u.fb.width,u.fb.height]),p!==(n?n.id:null)&&(this._setupStencil(u,o,r,n),p=n?n.id:null),e.renderLayer(e,n,r,a);}this.renderedToTile?(u.dirty=!0,a.push(n.tileID)):d||--l,5===l&&(l=0,this.renderToBackBuffer(a));}return this.renderToBackBuffer(a),this.renderingToTexture=!1,i.bindFramebuffer.set(null),i.viewport.set([0,0,e.width,e.height]),o.end+1}postRender(){}isLayerOrderingCorrect(t){const e=t.order.length;let i=-1,r=e;for(let n=0;n<e;++n)this._style.isLayerDraped(t._layers[t.order[n]])?i=Math.max(i,n):r=Math.min(r,n);return r>i}getMinElevationBelowMSL(){let t=0;return this._visibleDemTiles.filter((t=>t.dem)).forEach((e=>{t=Math.min(t,e.dem.tree.minimums[0]);})),0===t?t:(t-30)*this._exaggeration}raycast(t,e,i){if(!this._visibleDemTiles)return null;const r=this._visibleDemTiles.filter((t=>t.dem)).map((r=>{const n=r.tileID,o=1<<n.overscaledZ,{x:s,y:a}=n.canonical,l=s/o,c=(s+1)/o,h=a/o,u=(a+1)/o;return {minx:l,miny:h,maxx:c,maxy:u,t:r.dem.tree.raycastRoot(l,h,c,u,t,e,i),tile:r}}));r.sort(((t,e)=>(null!==t.t?t.t:Number.MAX_VALUE)-(null!==e.t?e.t:Number.MAX_VALUE)));for(const n of r){if(null==n.t)return null;const r=n.tile.dem.tree.raycast(n.minx,n.miny,n.maxx,n.maxy,t,e,i);if(null!=r)return r}return null}_createFBO(){const t=this.painter.context,e=t.gl,i=this.drapeBufferSize;t.activeTexture.set(e.TEXTURE0);const r=new hy(t,{width:i[0],height:i[1],data:null},e.RGBA);r.bind(e.LINEAR,e.CLAMP_TO_EDGE);const n=t.createFramebuffer(i[0],i[1],!0,null);return n.colorAttachment.set(r.texture),n.depthAttachment=new ax(t,n.framebuffer),void 0===this._sharedDepthStencil?(this._sharedDepthStencil=t.createRenderbuffer(t.gl.DEPTH_STENCIL,i[0],i[1]),this._stencilRef=0,n.depthAttachment.set(this._sharedDepthStencil),t.clear({stencil:0})):n.depthAttachment.set(this._sharedDepthStencil),t.extTextureFilterAnisotropic&&!t.extTextureFilterAnisotropicForceOff&&e.texParameterf(e.TEXTURE_2D,t.extTextureFilterAnisotropic.TEXTURE_MAX_ANISOTROPY_EXT,t.extTextureFilterAnisotropicMax),{fb:n,tex:r,dirty:!1}}_initFBOPool(){for(;this.pool.length<Math.min(5,this.proxyCoords.length);)this.pool.push(this._createFBO());}_shouldDisableRenderCache(){if(this._style.light&&this._style.light.hasTransition())return !0;for(const t in this._style._sourceCaches)if(this._style._sourceCaches[t].hasTransition())return !0;return this._style.order.some((t=>{const e=this._style._layers[t],i=e.isHidden(this.painter.transform.zoom);return "custom"===e.type?!i&&e.shouldRedrape():!i&&e.hasTransition()}))}_clearLineLayersFromRenderCache(){let t=!1;for(const e of this._style._getSources())if(e instanceof lw){t=!0;break}if(!t)return;const e={};for(let t=0;t<this._style.order.length;++t){const i=this._style._layers[this._style.order[t]],r=this._style._getLayerSourceCache(i);if(r&&!e[r.id]&&!i.isHidden(this.painter.transform.zoom)&&"line"===i.type&&i.widthExpression()instanceof vo){e[r.id]=!0;for(const t of this.proxyCoords){const e=this.proxyToSource[t.key][r.id];if(e)for(const t of e)this._clearRenderCacheForTile(r.id,t);}}}}_clearRasterLayersFromRenderCache(){let t=!1;for(const e in this._style._sourceCaches)if(this._style._sourceCaches[e]._source instanceof cw){t=!0;break}if(!t)return;const e={};for(let t=0;t<this._style.order.length;++t){const i=this._style._layers[this._style.order[t]],r=this._style._getLayerSourceCache(i);if(!r||e[r.id])continue;if(i.isHidden(this.painter.transform.zoom)||"raster"!==i.type)continue;const n=i.paint.get("raster-fade-duration");for(const t of this.proxyCoords){const e=this.proxyToSource[t.key][r.id];if(e)for(const t of e){const e=IE(r.getTile(t),r.findLoadedParent(t,0),r,this.painter.transform,n);(1!==e.opacity||0!==e.mix)&&this._clearRenderCacheForTile(r.id,t);}}}}_setupDrapedRenderBatches(){const t=this._style.order,e=t.length;if(0===e)return;const i=[];this._pendingGroundEffectLayers=[];let r,n=0,o=this._style._layers[t[n]];for(;!this._style.isLayerDraped(o)&&o.isHidden(this.painter.transform.zoom)&&++n<e;)o=this._style._layers[t[n]];for(;n<e;++n){const e=this._style._layers[t[n]];e.isHidden(this.painter.transform.zoom)||(this._style.isLayerDraped(e)?void 0===r&&(r=n):("fill-extrusion"===e.type&&this._pendingGroundEffectLayers.push(n),void 0!==r&&(i.push({start:r,end:n-1}),r=void 0)));}if(void 0!==r&&i.push({start:r,end:n-1}),0!==i.length){const t=i[i.length-1],e=this._pendingGroundEffectLayers.every((e=>e>t.end));e||W("fill-extrusion with flood lighting and/or ground ambient occlusion should be moved to be on top of all draped layers.");}this._drapedRenderBatches=i;}_setupRenderCache(t){const e=this.proxySourceCache;if(this._shouldDisableRenderCache()||this.invalidateRenderCache){if(this.invalidateRenderCache=!1,e.renderCache.length>e.renderCachePool.length){const t=Object.values(e.proxyCachedFBO);e.proxyCachedFBO={};for(let i=0;i<t.length;++i){const r=Object.values(t[i]);e.renderCachePool.push(...r);}}return}this._clearRasterLayersFromRenderCache();const i=this.proxyCoords,r=this._tilesDirty;for(let n=i.length-1;n>=0;n--){const o=i[n];if(e.getTileByID(o.key),void 0!==e.proxyCachedFBO[o.key]){const i=t[o.key],n=this.proxyToSource[o.key];let s=0;for(const t in n){const e=n[t],o=i[t];if(!o||o.length!==e.length||e.some(((e,i)=>e!==o[i]||r[t]&&r[t].hasOwnProperty(e.key)))){s=-1;break}++s;}for(const t in e.proxyCachedFBO[o.key])e.renderCache[e.proxyCachedFBO[o.key][t]].dirty=s<0||s!==Object.values(i).length;}}const n=[...this._drapedRenderBatches];n.sort(((t,e)=>e.end-e.start-(t.end-t.start)));for(const t of n)for(const r of i){if(e.proxyCachedFBO[r.key])continue;let i=e.renderCachePool.pop();void 0===i&&e.renderCache.length<50&&(i=e.renderCache.length,e.renderCache.push(this._createFBO())),void 0!==i&&(e.proxyCachedFBO[r.key]={},e.proxyCachedFBO[r.key][t.start]=i,e.renderCache[i].dirty=!0);}this._tilesDirty={};}_setupStencil(t,e,i,r){if(!r||!this._sourceTilesOverlap[r.id])return void(this._overlapStencilType&&(this._overlapStencilType=!1));const n=this.painter.context,o=n.gl;if(e.length<=1)return void(this._overlapStencilType=!1);let s;if(i.isTileClipped())s=e.length,this._overlapStencilMode.test={func:o.EQUAL,mask:255},this._overlapStencilType="Clip";else {if(!(e[0].overscaledZ>e[e.length-1].overscaledZ))return void(this._overlapStencilType=!1);s=1,this._overlapStencilMode.test={func:o.GREATER,mask:255},this._overlapStencilType="Mask";}this._stencilRef+s>255&&(n.clear({stencil:0}),this._stencilRef=0),this._stencilRef+=s,this._overlapStencilMode.ref=this._stencilRef,i.isTileClipped()&&this._renderTileClippingMasks(e,this._overlapStencilMode.ref);}clipOrMaskOverlapStencilType(){return "Clip"===this._overlapStencilType||"Mask"===this._overlapStencilType}stencilModeForRTTOverlap(t){return this.renderingToTexture&&this._overlapStencilType?("Clip"===this._overlapStencilType&&(this._overlapStencilMode.ref=this.painter._tileClippingMaskIDs[t.key]),this._overlapStencilMode):ux.disabled}_renderTileClippingMasks(t,e){const i=this.painter,r=this.painter.context,n=r.gl;i._tileClippingMaskIDs={},r.setColorMode(px.disabled),r.setDepthMode(cx.disabled);const o=i.useProgram("clippingMask");for(const r of t){const t=i._tileClippingMaskIDs[r.key]=--e;o.draw(i,n.TRIANGLES,cx.disabled,new ux({func:n.ALWAYS,mask:0},t,255,n.KEEP,n.KEEP,n.REPLACE),px.disabled,_x.disabled,SE(r.projMatrix),"$clipping",i.tileExtentBuffer,i.quadTriangleIndexBuffer,i.tileExtentSegments);}}pointCoordinate(t){const e=this.painter.transform;if(t.x<0||t.x>e.width||t.y<0||t.y>e.height)return null;const i=[t.x,t.y,1,1];au.transformMat4(i,i,e.pixelMatrixInverse),au.scale(i,i,1/i[3]),i[0]/=e.worldSize,i[1]/=e.worldSize;const r=e._camera.position,n=Vd(1,e.center.lat),o=[r[0],r[1],r[2]/n,0],s=bu.subtract([],i.slice(0,3),o);bu.normalize(s,s);const a=this.raycast(o,s,this._exaggeration);return null!==a&&a?(bu.scaleAndAdd(o,o,s,a),o[3]=o[2],o[2]*=n,o):null}drawDepth(){const t=this.painter,e=t.context,i=this.proxySourceCache,r=Math.ceil(t.width),n=Math.ceil(t.height);if(!this._depthFBO||this._depthFBO.width===r&&this._depthFBO.height===n||(this._depthFBO.destroy(),this._depthFBO=void 0,this._depthTexture=void 0),!this._depthFBO){const t=e.gl,i=e.createFramebuffer(r,n,!0,"renderbuffer");e.activeTexture.set(t.TEXTURE0);const o=new hy(e,{width:r,height:n,data:null},t.RGBA);o.bind(t.NEAREST,t.CLAMP_TO_EDGE),i.colorAttachment.set(o.texture);const s=e.createRenderbuffer(e.gl.DEPTH_COMPONENT16,r,n);i.depthAttachment.set(s),this._depthFBO=i,this._depthTexture=o;}e.bindFramebuffer.set(this._depthFBO.framebuffer),e.viewport.set([0,0,r,n]),function(t,e,i,r){if("globe"===t.transform.projection.name)return;const n=t.context,o=n.gl;n.clear({depth:1});const s=t.useProgram("terrainDepth"),a=new cx(o.LESS,cx.ReadWrite,t.depthRangeFor3D);for(const n of r){const r=i.getTile(n),l=xE(n.projMatrix,0,[0,0,0]);e.setupElevationDraw(r,s),s.draw(t,o.TRIANGLES,a,ux.disabled,px.unblended,_x.backCCW,l,"terrain_depth",e.gridBuffer,e.gridIndexBuffer,e.gridNoSkirtSegments);}}(t,this,i,this.proxyCoords);}_setupProxiedCoordsForOrtho(t,e,i){if(t.getSource()instanceof dw)return this._setupProxiedCoordsForImageSource(t,e,i);this._findCoveringTileCache[t.id]=this._findCoveringTileCache[t.id]||{};const r=this.proxiedCoords[t.id]=[],n=this.proxyCoords;for(let e=0;e<n.length;e++){const o=n[e],s=this._findTileCoveringTileID(o,t);if(s){const e=this._createProxiedId(o,s,i[o.key]&&i[o.key][t.id]);r.push(e),this.proxyToSource[o.key][t.id]=[e];}}let o=!1;for(let n=0;n<e.length;n++){const s=t.getTile(e[n]);if(!s||!s.hasData())continue;const a=this._findTileCoveringTileID(s.tileID,this.proxySourceCache);if(a&&a.tileID.canonical.z!==s.tileID.canonical.z){const e=this.proxyToSource[a.tileID.key][t.id],n=this._createProxiedId(a.tileID,s,i[a.tileID.key]&&i[a.tileID.key][t.id]);e?e.splice(e.length-1,0,n):this.proxyToSource[a.tileID.key][t.id]=[n],r.push(n),o=!0;}}this._sourceTilesOverlap[t.id]=o;}_setupProxiedCoordsForImageSource(t,e,i){if(!t.getSource().loaded())return;const r=this.proxiedCoords[t.id]=[],n=this.proxyCoords,o=t.getSource(),s=new y(o.tileID.x,o.tileID.y)._div(1<<o.tileID.z),a=o.coordinates.map(Yd.fromLngLat).reduce(((t,e)=>(t.min.x=Math.min(t.min.x,e.x-s.x),t.min.y=Math.min(t.min.y,e.y-s.y),t.max.x=Math.max(t.max.x,e.x-s.x),t.max.y=Math.max(t.max.y,e.y-s.y),t)),{min:new y(Number.MAX_VALUE,Number.MAX_VALUE),max:new y(-Number.MAX_VALUE,-Number.MAX_VALUE)}),l=(t,e)=>{const i=t.wrap+t.canonical.x/(1<<t.canonical.z),r=t.canonical.y/(1<<t.canonical.z),n=sr/(1<<t.canonical.z),o=e.wrap+e.canonical.x/(1<<e.canonical.z),s=e.canonical.y/(1<<e.canonical.z);return i+n<o+a.min.x||i>o+a.max.x||r+n<s+a.min.y||r>s+a.max.y};for(let o=0;o<n.length;o++){const s=n[o];for(let n=0;n<e.length;n++){const o=t.getTile(e[n]);if(!o||!o.hasData())continue;if(l(s,o.tileID))continue;const a=this._createProxiedId(s,o,i[s.key]&&i[s.key][t.id]),c=this.proxyToSource[s.key][t.id];c?c.push(a):this.proxyToSource[s.key][t.id]=[a],r.push(a);}}}_createProxiedId(t,e,i){let r=this.orthoMatrix;if(i){const t=i.find((t=>t.key===e.tileID.key));if(t)return t}if(e.tileID.key!==t.key){const i=t.canonical.z-e.tileID.canonical.z;let n,o,s;r=mu.create();const a=e.tileID.wrap-t.wrap<<t.overscaledZ;i>0?(n=sr>>i,o=n*((e.tileID.canonical.x<<i)-t.canonical.x+a),s=n*((e.tileID.canonical.y<<i)-t.canonical.y)):(n=sr<<-i,o=sr*(e.tileID.canonical.x-(t.canonical.x+a<<-i)),s=sr*(e.tileID.canonical.y-(t.canonical.y<<-i))),mu.ortho(r,0,n,0,n,0,1),mu.translate(r,r,[o,s,0]);}return new DE(e.tileID,t.key,r)}_findTileCoveringTileID(t,e){let i=e.getTile(t);if(i&&i.hasData())return i;const r=this._findCoveringTileCache[e.id],n=r[t.key];if(i=n?e.getTileByID(n):null,i&&i.hasData()||null===n)return i;let o=i?i.tileID:t,s=o.overscaledZ;const a=e.getSource().minzoom,l=[];if(!n){const r=e.getSource().maxzoom;if(t.canonical.z>=r){const i=t.canonical.z-r;e.getSource().reparseOverscaled?(s=Math.max(t.canonical.z+2,e.transform.tileZoom),o=new Rd(s,t.wrap,r,t.canonical.x>>i,t.canonical.y>>i)):0!==i&&(s=r,o=new Rd(s,t.wrap,r,t.canonical.x>>i,t.canonical.y>>i));}o.key!==t.key&&(l.push(o.key),i=e.getTile(o));}const c=t=>{l.forEach((e=>{r[e]=t;})),l.length=0;};for(s-=1;s>=a&&(!i||!i.hasData());s--){i&&c(i.tileID.key);const t=o.calculateScaledKey(s);if(i=e.getTileByID(t),i&&i.hasData())break;const n=r[t];if(null===n)break;void 0===n?l.push(t):i=e.getTileByID(n);}return c(i?i.tileID.key:null),i&&i.hasData()?i:null}findDEMTileFor(t){return this.enabled?this._findTileCoveringTileID(t,this.sourceCache):null}prepareDrawTile(){this.renderedToTile=!0;}_clearRenderCacheForTile(t,e){let i=this._tilesDirty[t];i||(i=this._tilesDirty[t]={}),i[e.key]=!0;}}function RE(t,e,i){const r=function(t,e,i){const r=bu.dot(e,t),n=bu.dot(i,[.2126,.7152,.0722]),o=(t,e,i)=>(1-i)*t+i*e,s=o(1-.3*Math.min(n,1),1,Math.min(r+1,1));return o(.92,1,Math.asin(z(e[2],-1,1))/Math.PI+.5)*s}(t,[0,0,1],e),n=[0,0,0];bu.scale(n,i.slice(0,3),r);const o=[0,0,0];bu.scale(o,e.slice(0,3),t[2]);const s=[0,0,0];return bu.add(s,n,o),lt(s)}const LE=["fill","fillOutline","fillPattern","line","linePattern","background","backgroundPattern","hillshade","raster"],kE=["stars","fillExtrusion","fillExtrusionGroundEffect","model","symbolSDF","symbolIcon","symbolTextAndIcon"];class BE{static cacheKey(t,e,i,r){let n=`${e}${r?r.cacheKey:""}`;for(const e of i)t.usedDefines.includes(e)&&(n+=`/${e}`);return n}constructor(t,e,i,r,n,o){const s=t.gl;this.program=s.createProgram(),this.configuration=r,this.name=e,this.fixedDefines=[...o];const a=function(t){const e=[];for(let i=0;i<t.length;i++){if(null===t[i])continue;const r=t[i].split(" ");e.push(r.pop());}return e}(i.staticAttributes),l=r?r.getBinderAttributes():[],c=a.concat(l);let h=r?r.defines():[];h=h.concat(o.map((t=>`#define ${t}`)));const u="#version 300 es\n",d=u+h.concat(cE,cE,aE,lE,sE.fragmentSource,rE.fragmentSource,nE.fragmentSource,i.fragmentSource).join("\n"),p=u+h.concat("\n#ifdef GL_ES\nprecision highp float;\n#else\n\n#if !defined(lowp)\n#define lowp\n#endif\n\n#if !defined(mediump)\n#define mediump\n#endif\n\n#if !defined(highp)\n#define highp\n#endif\n\n#endif",aE,lE,sE.vertexSource,rE.vertexSource,nE.vertexSource,iE.vertexSource,i.vertexSource).join("\n"),f=s.createShader(s.FRAGMENT_SHADER);if(s.isContextLost())return void(this.failedToCreate=!0);s.shaderSource(f,d),s.compileShader(f),s.attachShader(this.program,f);const m=s.createShader(s.VERTEX_SHADER);if(s.isContextLost())this.failedToCreate=!0;else {s.shaderSource(m,p),s.compileShader(m),s.attachShader(this.program,m),this.attributes={},this.numAttributes=c.length;for(let t=0;t<this.numAttributes;t++)if(c[t]){const e=c[t].startsWith("a_")?c[t]:`a_${c[t]}`;s.bindAttribLocation(this.program,t,e),this.attributes[e]=t;}s.linkProgram(this.program),s.deleteShader(m),s.deleteShader(f),this.fixedUniforms=n(t),this.binderUniforms=r?r.getUniforms(t):[],o.includes("TERRAIN")&&(this.terrainUniforms=(t=>({u_dem:new xl(t),u_dem_prev:new xl(t),u_dem_unpack:new Tl(t),u_dem_tl:new bl(t),u_dem_scale:new vl(t),u_dem_tl_prev:new bl(t),u_dem_scale_prev:new vl(t),u_dem_size:new vl(t),u_dem_lerp:new vl(t),u_exaggeration:new vl(t),u_depth:new xl(t),u_depth_size_inv:new bl(t),u_meter_to_dem:new vl(t),u_label_plane_matrix_inv:new Al(t)}))(t)),o.includes("GLOBE")&&(this.globeUniforms=(t=>({u_tile_tl_up:new wl(t),u_tile_tr_up:new wl(t),u_tile_br_up:new wl(t),u_tile_bl_up:new wl(t),u_tile_up_scale:new vl(t)}))(t)),o.includes("FOG")&&(this.fogUniforms=(t=>({u_fog_matrix:new Al(t),u_fog_range:new bl(t),u_fog_color:new Tl(t),u_fog_horizon_blend:new vl(t),u_fog_vertical_limit:new bl(t),u_fog_temporal_offset:new vl(t),u_frustum_tl:new wl(t),u_frustum_tr:new wl(t),u_frustum_br:new wl(t),u_frustum_bl:new wl(t),u_globe_pos:new wl(t),u_globe_radius:new vl(t),u_globe_transition:new vl(t),u_is_globe:new xl(t),u_viewport:new bl(t)}))(t)),o.includes("RENDER_CUTOFF")&&(this.cutoffUniforms=(t=>({u_cutoff_params:new Tl(t)}))(t)),o.includes("LIGHTING_3D_MODE")&&(this.lightsUniforms=(t=>({u_lighting_ambient_color:new wl(t),u_lighting_directional_dir:new wl(t),u_lighting_directional_color:new wl(t),u_ground_radiance:new wl(t)}))(t)),o.includes("RENDER_SHADOWS")&&(this.shadowUniforms=(t=>({u_light_matrix_0:new Al(t),u_light_matrix_1:new Al(t),u_fade_range:new bl(t),u_shadow_normal_offset:new wl(t),u_shadow_intensity:new vl(t),u_texel_size:new vl(t),u_shadow_direction:new wl(t),u_shadow_bias:new wl(t),u_shadowmap_0:new xl(t),u_shadowmap_1:new xl(t)}))(t));}}setTerrainUniformValues(t,e){if(!this.terrainUniforms)return;const i=this.terrainUniforms;if(!this.failedToCreate){t.program.set(this.program);for(const t in e)i[t]&&i[t].set(this.program,t,e[t]);}}setGlobeUniformValues(t,e){if(!this.globeUniforms)return;const i=this.globeUniforms;if(!this.failedToCreate){t.program.set(this.program);for(const t in e)i[t]&&i[t].set(this.program,t,e[t]);}}setFogUniformValues(t,e){if(!this.fogUniforms)return;const i=this.fogUniforms;if(!this.failedToCreate){t.program.set(this.program);for(const t in e)i[t].set(this.program,t,e[t]);}}setCutoffUniformValues(t,e){if(!this.cutoffUniforms)return;const i=this.cutoffUniforms;if(!this.failedToCreate){t.program.set(this.program);for(const t in e)i[t].set(this.program,t,e[t]);}}setLightsUniformValues(t,e){if(!this.lightsUniforms)return;const i=this.lightsUniforms;if(!this.failedToCreate){t.program.set(this.program);for(const t in e)i[t].set(this.program,t,e[t]);}}setShadowUniformValues(t,e){if(this.failedToCreate||!this.shadowUniforms)return;const i=this.shadowUniforms;t.program.set(this.program);for(const t in e)i[t].set(this.program,t,e[t]);}_drawDebugWireframe(t,e,i,r,n,o,s,a,l){const c=t.options.wireframe;if(!1===c.terrain&&!1===c.layers2D&&!1===c.layers3D)return;const h=t.context;if(!(()=>!(!c.terrain||"terrainRaster"!==this.name&&"globeRaster"!==this.name)||!(!c.layers2D||t._terrain&&t._terrain.renderingToTexture||!LE.includes(this.name))||!(!c.layers3D||!kE.includes(this.name)))())return;const u=h.gl,d=t.wireframeDebugCache.getLinesFromTrianglesBuffer(t.frameCounter,n,h);if(!d)return;const p=[...this.fixedDefines];p.push("DEBUG_WIREFRAME");const f=t.useProgram(this.name,this.configuration,p);h.program.set(f.program);const m=(t,e,i)=>{if(e[t]&&i[t])for(const r in e[t])i[t][r]&&i[t][r].set(i.program,r,e[t][r].current);};l&&l.setUniforms(f.program,h,f.binderUniforms,s,{zoom:a}),m("fixedUniforms",this,f),m("terrainUniforms",this,f),m("globeUniforms",this,f),m("fogUniforms",this,f),m("lightsUniforms",this,f),m("shadowUniforms",this,f),d.bind(),h.setColorMode(new px([u.ONE,u.ONE_MINUS_SRC_ALPHA,u.ZERO,u.ONE],li.transparent,[!0,!0,!0,!1])),h.setDepthMode(new cx(e.func===u.LESS?u.LEQUAL:e.func,cx.ReadOnly,e.range)),h.setStencilMode(ux.disabled),u.drawElements(u.LINES,3*o.primitiveLength*2,u.UNSIGNED_SHORT,3*o.primitiveOffset*2*2),n.bind(),h.program.set(this.program),h.setDepthMode(e),h.setStencilMode(i),h.setColorMode(r);}draw(t,e,i,r,n,o,s,a,l,c,h,u,d,p,f,m){const _=t.context,g=_.gl;if(this.failedToCreate)return;_.program.set(this.program),_.setDepthMode(i),_.setStencilMode(r),_.setColorMode(n),_.setCullFace(o);for(const t of Object.keys(this.fixedUniforms))this.fixedUniforms[t].set(this.program,t,s[t]);p&&p.setUniforms(this.program,_,this.binderUniforms,u,{zoom:d});const y={[g.LINES]:2,[g.TRIANGLES]:3,[g.LINE_STRIP]:1}[e],x=m&&m>0?1:void 0;for(const o of h.get()){const s=o.vaos||(o.vaos={});(s[a]||(s[a]=new pE)).bind(_,this,l,p?p.getPaintVertexBuffers():[],c,o.vertexOffset,f||[],x),m&&m>1?g.drawElementsInstanced(e,o.primitiveLength*y,g.UNSIGNED_SHORT,o.primitiveOffset*y*2,m):g.drawElements(e,o.primitiveLength*y,g.UNSIGNED_SHORT,o.primitiveOffset*y*2),e===g.TRIANGLES&&this._drawDebugWireframe(t,i,r,n,c,o,u,d,p);}}}function OE(t,e){const i=Math.pow(2,e.tileID.overscaledZ),r=e.tileSize*Math.pow(2,t.transform.tileZoom)/i,n=r*(e.tileID.canonical.x+e.tileID.wrap*i),o=r*e.tileID.canonical.y;return {u_image:0,u_texsize:e.imageAtlasTexture.size,u_tile_units_to_pixels:1/Vx(e,1,t.transform.tileZoom),u_pixel_coord_upper:[n>>16,o>>16],u_pixel_coord_lower:[65535&n,65535&o]}}const FE=mu.create(),NE=(t,e,i,r,n,o,s,a,l,c,h,u,d,p,f)=>{const m=e.style.light,_=m.properties.get("position"),g=[_.x,_.y,_.z],y=pu.create();"viewport"===m.properties.get("anchor")&&(pu.fromRotation(y,-e.transform.angle),bu.transformMat3(g,g,y));const x=m.properties.get("color"),v=e.transform,b={u_matrix:t,u_lightpos:g,u_lightintensity:m.properties.get("intensity"),u_lightcolor:[x.r,x.g,x.b],u_vertical_gradient:+i,u_opacity:r,u_tile_id:[0,0,0],u_zoom_transition:0,u_inv_rot_matrix:FE,u_merc_center:[0,0],u_up_dir:[0,0,0],u_height_lift:0,u_ao:n,u_edge_radius:o,u_flood_light_color:u,u_vertical_scale:d,u_flood_light_intensity:p,u_ground_shadow_factor:f};return "globe"===v.projection.name&&(b.u_tile_id=[s.canonical.x,s.canonical.y,1<<s.canonical.z],b.u_zoom_transition=l,b.u_inv_rot_matrix=h,b.u_merc_center=c,b.u_up_dir=v.projection.upVector(new Dd(0,0,0),c[0]*sr,c[1]*sr),b.u_height_lift=a),b},UE=(t,e,i)=>({u_matrix:t,u_edge_radius:e,u_vertical_scale:i}),VE=(t,e,i,r,n,o,s,a,l,c,h,u,d,p)=>{const f=NE(t,e,i,r,n,o,s,l,c,h,u,d,p,1,[0,0,0]),m={u_height_factor:-Math.pow(2,s.overscaledZ)/a.tileSize/8};return k(f,OE(e,a),m)},jE=(t,e)=>({u_matrix:t,u_emissive_strength:e}),GE=(t,e,i,r)=>k(jE(t,e),OE(i,r)),qE=(t,e,i)=>({u_matrix:t,u_world:i,u_emissive_strength:e}),ZE=(t,e,i,r,n)=>k(GE(t,e,i,r),{u_world:n}),$E=mu.create(),HE=(t,e,i,r,n,o)=>{const s=t.transform,a="globe"===s.projection.name;let l;if("map"===o.paint.get("circle-pitch-alignment"))if(a){const t=ud(s.zoom,e.canonical)*s._pixelsPerMercatorPixel;l=Float32Array.from([t,0,0,t]);}else l=s.calculatePixelsToTileUnitsMatrix(i);else l=new Float32Array([s.pixelsToGLUnits[0],0,0,s.pixelsToGLUnits[1]]);const c={u_camera_to_center_distance:t.transform.getCameraToCenterDistance(s.projection),u_matrix:t.translatePosMatrix(e.projMatrix,i,o.paint.get("circle-translate"),o.paint.get("circle-translate-anchor")),u_device_pixel_ratio:ue.devicePixelRatio,u_extrude_scale:l,u_inv_rot_matrix:$E,u_merc_center:[0,0],u_tile_id:[0,0,0],u_zoom_transition:0,u_up_dir:[0,0,0],u_emissive_strength:o.paint.get("circle-emissive-strength")};if(a){c.u_inv_rot_matrix=r,c.u_merc_center=n,c.u_tile_id=[e.canonical.x,e.canonical.y,1<<e.canonical.z],c.u_zoom_transition=pd(s.zoom);const t=n[0]*sr,i=n[1]*sr;c.u_up_dir=s.projection.upVector(new Dd(0,0,0),t,i);}return c},WE=t=>{const e=[];return "map"===t.paint.get("circle-pitch-alignment")&&e.push("PITCH_WITH_MAP"),"map"===t.paint.get("circle-pitch-scale")&&e.push("SCALE_WITH_MAP"),e},XE=(t,e,i,r)=>{const n=sr/i.tileSize;return {u_matrix:t,u_camera_to_center_distance:e.getCameraToCenterDistance(r),u_extrude_scale:[e.pixelsToGLUnits[0]/n,e.pixelsToGLUnits[1]/n]}},YE=(t,e,i=1)=>({u_matrix:t,u_color:e,u_overlay:0,u_overlay_scale:i}),KE=mu.create(),JE=(t,e,i,r,n,o,s)=>{const a=t.transform,l="globe"===a.projection.name,c=l?ud(a.zoom,e.canonical)*a._pixelsPerMercatorPixel:Vx(i,1,o),h={u_matrix:e.projMatrix,u_extrude_scale:c,u_intensity:s,u_inv_rot_matrix:KE,u_merc_center:[0,0],u_tile_id:[0,0,0],u_zoom_transition:0,u_up_dir:[0,0,0]};if(l){h.u_inv_rot_matrix=r,h.u_merc_center=n,h.u_tile_id=[e.canonical.x,e.canonical.y,1<<e.canonical.z],h.u_zoom_transition=pd(a.zoom);const t=n[0]*sr,i=n[1]*sr;h.u_up_dir=a.projection.upVector(new Dd(0,0,0),t,i);}return h},QE=(t,e,i,r,n,o,s)=>{const a=t.transform,l=a.calculatePixelsToTileUnitsMatrix(e);return {u_matrix:iM(t,e,i,r),u_pixels_to_tile_units:l,u_device_pixel_ratio:o,u_units_to_pixels:[1/a.pixelsToGLUnits[0],1/a.pixelsToGLUnits[1]],u_dash_image:0,u_gradient_image:1,u_image_height:n,u_texsize:rM(i)?e.lineAtlasTexture.size:[0,0],u_tile_units_to_pixels:eM(e,t.transform),u_alpha_discard_threshold:0,u_trim_offset:s,u_emissive_strength:i.paint.get("line-emissive-strength")}},tM=(t,e,i,r,n)=>{const o=t.transform;return {u_matrix:iM(t,e,i,r),u_texsize:e.imageAtlasTexture.size,u_pixels_to_tile_units:o.calculatePixelsToTileUnitsMatrix(e),u_device_pixel_ratio:n,u_image:0,u_tile_units_to_pixels:eM(e,o),u_units_to_pixels:[1/o.pixelsToGLUnits[0],1/o.pixelsToGLUnits[1]],u_alpha_discard_threshold:0}};function eM(t,e){return 1/Vx(t,1,e.tileZoom)}function iM(t,e,i,r){return t.translatePosMatrix(r||e.tileID.projMatrix,e,i.paint.get("line-translate"),i.paint.get("line-translate-anchor"))}function rM(t){const e=t.paint.get("line-dasharray").value;return e.value||"constant"!==e.kind}const nM=(t,e,i,r,n,o,s,a,l)=>{return {u_matrix:t,u_tl_parent:e,u_scale_parent:i,u_fade_t:r.mix,u_opacity:r.opacity*n.paint.get("raster-opacity"),u_image0:0,u_image1:1,u_brightness_low:n.paint.get("raster-brightness-min"),u_brightness_high:n.paint.get("raster-brightness-max"),u_saturation_factor:(h=n.paint.get("raster-saturation"),h>0?1-1/(1.001-h):-h),u_contrast_factor:(c=n.paint.get("raster-contrast"),c>0?1/(1-c):1+c),u_spin_weights:oM(n.paint.get("raster-hue-rotate")),u_perspective_transform:o,u_colorization_mix:a,u_colorization_scale:sM(l),u_color_ramp:s};var c,h;};function oM(t){t*=Math.PI/180;const e=Math.sin(t),i=Math.cos(t);return [(2*i+1)/3,(-Math.sqrt(3)*e-i+1)/3,(Math.sqrt(3)*e-i+1)/3]}function sM([t,e]){return t===e?[t,e]:[-t/(e-t),1/(e-t)]}const aM=mu.create(),lM=(t,e,i,r,n,o,s,a,l,c,h,u,d,p,f,m,_)=>{const g=n.transform,y={u_is_size_zoom_constant:+("constant"===t||"source"===t),u_is_size_feature_constant:+("constant"===t||"camera"===t),u_size_t:e?e.uSizeT:0,u_size:e?e.uSize:0,u_camera_to_center_distance:g.getCameraToCenterDistance(m),u_rotate_symbol:+i,u_aspect_ratio:g.width/g.height,u_fade_change:n.options.fadeDuration?n.symbolFadeChange:1,u_matrix:o,u_label_plane_matrix:s,u_coord_matrix:a,u_is_text:+l,u_pitch_with_map:+r,u_texsize:c,u_texture:0,u_tile_id:[0,0,0],u_zoom_transition:0,u_inv_rot_matrix:aM,u_merc_center:[0,0],u_camera_forward:[0,0,0],u_ecef_origin:[0,0,0],u_tile_matrix:aM,u_up_vector:[0,-1,0],u_icon_transition:_||0};return "globe"===m.name&&(y.u_tile_id=[h.canonical.x,h.canonical.y,1<<h.canonical.z],y.u_zoom_transition=u,y.u_inv_rot_matrix=p,y.u_merc_center=d,y.u_camera_forward=g._camera.forward(),y.u_ecef_origin=function(t,e){const i=[0,0,0],r=ld(Yu(e.canonical));return bu.transformMat4(i,i,r),bu.transformMat4(i,i,t),i}(g.globeMatrix,h.toUnwrapped()),y.u_tile_matrix=Float32Array.from(g.globeMatrix),y.u_up_vector=f),y},cM=(t,e,i,r,n,o,s,a,l,c,h,u,d,p,f,m,_)=>k(lM(t,e,i,r,n,o,s,a,l,c,u,d,p,f,m,_),{u_gamma_scale:r?n.transform.getCameraToCenterDistance(_)*Math.cos(n.terrain?0:n.transform._pitch):1,u_device_pixel_ratio:ue.devicePixelRatio,u_is_halo:+h,undefined:void 0}),hM=(t,e,i,r,n,o,s,a,l,c,h,u,d,p,f,m)=>k(cM(t,e,i,r,n,o,s,a,!0,l,!0,h,u,d,p,f,m),{u_texsize_icon:c,u_texture_icon:1}),uM=(t,e,i,r)=>({u_matrix:t,u_emissive_strength:e,u_opacity:i,u_color:r}),dM=(t,e,i,r,n,o,s)=>k(function(t,e,i,r){const n=i.imageManager.getPattern(t.toString(),e),{width:o,height:s}=i.imageManager.getPixelSize(e),a=Math.pow(2,r.tileID.overscaledZ),l=r.tileSize*Math.pow(2,i.transform.tileZoom)/a,c=l*(r.tileID.canonical.x+r.tileID.wrap*a),h=l*r.tileID.canonical.y;return {u_image:0,u_pattern_tl:n.tl,u_pattern_br:n.br,u_texsize:[o,s],u_pattern_size:n.displaySize,u_tile_units_to_pixels:1/Vx(r,1,i.transform.tileZoom),u_pixel_coord_upper:[c>>16,h>>16],u_pixel_coord_lower:[65535&c,65535&h]}}(n,o,r,s),{u_matrix:t,u_emissive_strength:e,u_opacity:i}),pM={BaseColor:5,MetallicRoughness:6,Normal:7,Occlusion:8,Emission:9,ShadowMap0:10},fM=(t,e,i,r,n,o,s,a,l,c,h,u=[0,0,0])=>{const d=r.style.light,p=d.properties.get("position"),f=[-p.x,-p.y,p.z],m=pu.create();"viewport"===d.properties.get("anchor")&&(pu.fromRotation(m,-r.transform.angle),bu.transformMat3(f,f,m));const _="MASK"===c.alphaMode,g=d.properties.get("color"),y=h.paint.get("model-ambient-occlusion-intensity"),x=h.paint.get("model-color").constantOr(li.white),v=h.paint.get("model-color-mix-intensity").constantOr(0);return {u_matrix:t,u_lighting_matrix:e,u_normal_matrix:i,u_lightpos:f,u_lightintensity:d.properties.get("intensity"),u_lightcolor:[g.r,g.g,g.b],u_camera_pos:u,u_opacity:n,u_baseTextureIsAlpha:0,u_alphaMask:+_,u_alphaCutoff:c.alphaCutoff,u_baseColorFactor:[o.r,o.g,o.b,o.a],u_emissiveFactor:[s[0],s[1],s[2],1],u_metallicFactor:a,u_roughnessFactor:l,u_baseColorTexture:pM.BaseColor,u_metallicRoughnessTexture:pM.MetallicRoughness,u_normalTexture:pM.Normal,u_occlusionTexture:pM.Occlusion,u_emissionTexture:pM.Emission,u_color_mix:[x.r,x.g,x.b,v],u_aoIntensity:y}},mM=new Float32Array(16),_M=(t,e=mM,i=mM)=>({u_matrix:t,u_instance:e,u_node_matrix:i}),gM={fillExtrusion:t=>({u_matrix:new Al(t),u_lightpos:new wl(t),u_lightintensity:new vl(t),u_lightcolor:new wl(t),u_vertical_gradient:new vl(t),u_opacity:new vl(t),u_edge_radius:new vl(t),u_ao:new bl(t),u_tile_id:new wl(t),u_zoom_transition:new vl(t),u_inv_rot_matrix:new Al(t),u_merc_center:new bl(t),u_up_dir:new wl(t),u_height_lift:new vl(t),u_flood_light_color:new wl(t),u_vertical_scale:new vl(t),u_flood_light_intensity:new vl(t),u_ground_shadow_factor:new wl(t)}),fillExtrusionDepth:t=>({u_matrix:new Al(t),u_edge_radius:new vl(t),u_vertical_scale:new vl(t)}),fillExtrusionPattern:t=>({u_matrix:new Al(t),u_lightpos:new wl(t),u_lightintensity:new vl(t),u_lightcolor:new wl(t),u_vertical_gradient:new vl(t),u_height_factor:new vl(t),u_edge_radius:new vl(t),u_ao:new bl(t),u_tile_id:new wl(t),u_zoom_transition:new vl(t),u_inv_rot_matrix:new Al(t),u_merc_center:new bl(t),u_up_dir:new wl(t),u_height_lift:new vl(t),u_image:new xl(t),u_texsize:new bl(t),u_pixel_coord_upper:new bl(t),u_pixel_coord_lower:new bl(t),u_tile_units_to_pixels:new vl(t),u_opacity:new vl(t)}),fillExtrusionGroundEffect:t=>({u_matrix:new Al(t),u_opacity:new vl(t),u_ao_pass:new vl(t),u_meter_to_tile:new vl(t),u_ao:new bl(t),u_flood_light_intensity:new vl(t),u_flood_light_color:new wl(t),u_attenuation:new vl(t),u_edge_radius:new vl(t),u_fb:new xl(t),u_fb_size:new vl(t)}),fill:t=>({u_matrix:new Al(t),u_emissive_strength:new vl(t)}),fillPattern:t=>({u_matrix:new Al(t),u_emissive_strength:new vl(t),u_image:new xl(t),u_texsize:new bl(t),u_pixel_coord_upper:new bl(t),u_pixel_coord_lower:new bl(t),u_tile_units_to_pixels:new vl(t)}),fillOutline:t=>({u_matrix:new Al(t),u_emissive_strength:new vl(t),u_world:new bl(t)}),fillOutlinePattern:t=>({u_matrix:new Al(t),u_emissive_strength:new vl(t),u_world:new bl(t),u_image:new xl(t),u_texsize:new bl(t),u_pixel_coord_upper:new bl(t),u_pixel_coord_lower:new bl(t),u_tile_units_to_pixels:new vl(t)}),circle:t=>({u_camera_to_center_distance:new vl(t),u_extrude_scale:new zl(t),u_device_pixel_ratio:new vl(t),u_matrix:new Al(t),u_inv_rot_matrix:new Al(t),u_merc_center:new bl(t),u_tile_id:new wl(t),u_zoom_transition:new vl(t),u_up_dir:new wl(t),u_emissive_strength:new vl(t)}),collisionBox:t=>({u_matrix:new Al(t),u_camera_to_center_distance:new vl(t),u_extrude_scale:new bl(t)}),collisionCircle:t=>({u_matrix:new Al(t),u_inv_matrix:new Al(t),u_camera_to_center_distance:new vl(t),u_viewport_size:new bl(t)}),debug:t=>({u_color:new El(t),u_matrix:new Al(t),u_overlay:new xl(t),u_overlay_scale:new vl(t)}),clippingMask:t=>({u_matrix:new Al(t)}),heatmap:t=>({u_extrude_scale:new vl(t),u_intensity:new vl(t),u_matrix:new Al(t),u_inv_rot_matrix:new Al(t),u_merc_center:new bl(t),u_tile_id:new wl(t),u_zoom_transition:new vl(t),u_up_dir:new wl(t)}),heatmapTexture:t=>({u_image:new xl(t),u_color_ramp:new xl(t),u_opacity:new vl(t)}),hillshade:t=>({u_matrix:new Al(t),u_image:new xl(t),u_latrange:new bl(t),u_light:new bl(t),u_shadow:new El(t),u_highlight:new El(t),u_accent:new El(t)}),hillshadePrepare:t=>({u_matrix:new Al(t),u_image:new xl(t),u_dimension:new bl(t),u_zoom:new vl(t),u_unpack:new Tl(t)}),line:t=>({u_matrix:new Al(t),u_pixels_to_tile_units:new zl(t),u_device_pixel_ratio:new vl(t),u_units_to_pixels:new bl(t),u_dash_image:new xl(t),u_gradient_image:new xl(t),u_image_height:new vl(t),u_texsize:new bl(t),u_tile_units_to_pixels:new vl(t),u_alpha_discard_threshold:new vl(t),u_trim_offset:new bl(t),u_emissive_strength:new vl(t)}),linePattern:t=>({u_matrix:new Al(t),u_texsize:new bl(t),u_pixels_to_tile_units:new zl(t),u_device_pixel_ratio:new vl(t),u_image:new xl(t),u_units_to_pixels:new bl(t),u_tile_units_to_pixels:new vl(t),u_alpha_discard_threshold:new vl(t)}),raster:t=>({u_matrix:new Al(t),u_tl_parent:new bl(t),u_scale_parent:new vl(t),u_fade_t:new vl(t),u_opacity:new vl(t),u_image0:new xl(t),u_image1:new xl(t),u_brightness_low:new vl(t),u_brightness_high:new vl(t),u_saturation_factor:new vl(t),u_contrast_factor:new vl(t),u_spin_weights:new wl(t),u_perspective_transform:new bl(t),u_colorization_mix:new Tl(t),u_colorization_scale:new bl(t),u_color_ramp:new xl(t)}),symbolIcon:t=>({u_is_size_zoom_constant:new xl(t),u_is_size_feature_constant:new xl(t),u_size_t:new vl(t),u_size:new vl(t),u_camera_to_center_distance:new vl(t),u_rotate_symbol:new xl(t),u_aspect_ratio:new vl(t),u_fade_change:new vl(t),u_matrix:new Al(t),u_label_plane_matrix:new Al(t),u_coord_matrix:new Al(t),u_is_text:new xl(t),u_pitch_with_map:new xl(t),u_texsize:new bl(t),u_tile_id:new wl(t),u_zoom_transition:new vl(t),u_inv_rot_matrix:new Al(t),u_merc_center:new bl(t),u_camera_forward:new wl(t),u_tile_matrix:new Al(t),u_up_vector:new wl(t),u_ecef_origin:new wl(t),u_texture:new xl(t),u_icon_transition:new vl(t)}),symbolSDF:t=>({u_is_size_zoom_constant:new xl(t),u_is_size_feature_constant:new xl(t),u_size_t:new vl(t),u_size:new vl(t),u_camera_to_center_distance:new vl(t),u_rotate_symbol:new xl(t),u_aspect_ratio:new vl(t),u_fade_change:new vl(t),u_matrix:new Al(t),u_label_plane_matrix:new Al(t),u_coord_matrix:new Al(t),u_is_text:new xl(t),u_pitch_with_map:new xl(t),u_texsize:new bl(t),u_texture:new xl(t),u_gamma_scale:new vl(t),u_device_pixel_ratio:new vl(t),u_tile_id:new wl(t),u_zoom_transition:new vl(t),u_inv_rot_matrix:new Al(t),u_merc_center:new bl(t),u_camera_forward:new wl(t),u_tile_matrix:new Al(t),u_up_vector:new wl(t),u_ecef_origin:new wl(t),u_is_halo:new xl(t)}),symbolTextAndIcon:t=>({u_is_size_zoom_constant:new xl(t),u_is_size_feature_constant:new xl(t),u_size_t:new vl(t),u_size:new vl(t),u_camera_to_center_distance:new vl(t),u_rotate_symbol:new xl(t),u_aspect_ratio:new vl(t),u_fade_change:new vl(t),u_matrix:new Al(t),u_label_plane_matrix:new Al(t),u_coord_matrix:new Al(t),u_is_text:new xl(t),u_pitch_with_map:new xl(t),u_texsize:new bl(t),u_texsize_icon:new bl(t),u_texture:new xl(t),u_texture_icon:new xl(t),u_gamma_scale:new vl(t),u_device_pixel_ratio:new vl(t),u_is_halo:new xl(t)}),background:t=>({u_matrix:new Al(t),u_emissive_strength:new vl(t),u_opacity:new vl(t),u_color:new El(t)}),backgroundPattern:t=>({u_matrix:new Al(t),u_emissive_strength:new vl(t),u_opacity:new vl(t),u_image:new xl(t),u_pattern_tl:new bl(t),u_pattern_br:new bl(t),u_texsize:new bl(t),u_pattern_size:new bl(t),u_pixel_coord_upper:new bl(t),u_pixel_coord_lower:new bl(t),u_tile_units_to_pixels:new vl(t)}),terrainRaster:yE,terrainDepth:yE,skybox:t=>({u_matrix:new Al(t),u_sun_direction:new wl(t),u_cubemap:new xl(t),u_opacity:new vl(t),u_temporal_offset:new vl(t)}),skyboxGradient:t=>({u_matrix:new Al(t),u_color_ramp:new xl(t),u_center_direction:new wl(t),u_radius:new vl(t),u_opacity:new vl(t),u_temporal_offset:new vl(t)}),skyboxCapture:t=>({u_matrix_3f:new Il(t),u_sun_direction:new wl(t),u_sun_intensity:new vl(t),u_color_tint_r:new Tl(t),u_color_tint_m:new Tl(t),u_luminance:new vl(t)}),globeRaster:t=>({u_proj_matrix:new Al(t),u_globe_matrix:new Al(t),u_normalize_matrix:new Al(t),u_merc_matrix:new Al(t),u_zoom_transition:new vl(t),u_merc_center:new bl(t),u_image0:new xl(t),u_grid_matrix:new Il(t),u_skirt_height:new vl(t),u_frustum_tl:new wl(t),u_frustum_tr:new wl(t),u_frustum_br:new wl(t),u_frustum_bl:new wl(t),u_globe_pos:new wl(t),u_globe_radius:new vl(t),u_viewport:new bl(t)}),globeAtmosphere:t=>({u_frustum_tl:new wl(t),u_frustum_tr:new wl(t),u_frustum_br:new wl(t),u_frustum_bl:new wl(t),u_horizon:new vl(t),u_transition:new vl(t),u_fadeout_range:new vl(t),u_color:new Tl(t),u_high_color:new Tl(t),u_space_color:new Tl(t),u_temporal_offset:new vl(t),u_horizon_angle:new vl(t)}),model:t=>({u_matrix:new Al(t),u_lighting_matrix:new Al(t),u_normal_matrix:new Al(t),u_lightpos:new wl(t),u_lightintensity:new vl(t),u_lightcolor:new wl(t),u_camera_pos:new wl(t),u_opacity:new vl(t),u_baseColorFactor:new Tl(t),u_emissiveFactor:new Tl(t),u_metallicFactor:new vl(t),u_roughnessFactor:new vl(t),u_baseTextureIsAlpha:new xl(t),u_alphaMask:new xl(t),u_alphaCutoff:new vl(t),u_baseColorTexture:new xl(t),u_metallicRoughnessTexture:new xl(t),u_normalTexture:new xl(t),u_occlusionTexture:new xl(t),u_emissionTexture:new xl(t),u_color_mix:new Tl(t),u_aoIntensity:new vl(t)}),modelDepth:t=>({u_matrix:new Al(t),u_instance:new Al(t),u_node_matrix:new Al(t)}),groundShadow:t=>({u_matrix:new Al(t),u_ground_shadow_factor:new wl(t)}),stars:t=>({u_matrix:new Al(t),u_up:new wl(t),u_right:new wl(t),u_intensity_multiplier:new vl(t)})};let yM;function xM(t,e,i,r,n,o,s){const a=t.context,l=a.gl,c=t.transform,h=t.useProgram("collisionBox"),u=[];let d=0,p=0;for(let a=0;a<r.length;a++){const f=r[a],m=e.getTile(f),_=m.getBucket(i);if(!_)continue;const g=cT(f,_,c);let y=g;0===n[0]&&0===n[1]||(y=t.translatePosMatrix(g,m,n,o));const x=s?_.textCollisionBox:_.iconCollisionBox,v=_.collisionCircleArray;if(v.length>0){const t=mu.create(),e=y;mu.mul(t,_.placementInvProjMatrix,c.glCoordMatrix),mu.mul(t,t,_.placementViewportMatrix),u.push({circleArray:v,circleOffset:p,transform:e,invTransform:t,projection:_.getProjection()}),d+=v.length/4,p=d;}x&&(t.terrain&&t.terrain.setupElevationDraw(m,h),h.draw(t,l.LINES,cx.disabled,ux.disabled,t.colorModeForRenderPass(),_x.disabled,XE(y,c,m,_.getProjection()),i.id,x.layoutVertexBuffer,x.indexBuffer,x.segments,null,c.zoom,null,[x.collisionVertexBuffer,x.collisionVertexBufferExt]));}if(!s||!u.length)return;const f=t.useProgram("collisionCircle"),m=new Ra;m.resize(4*d),m._trim();let _=0;for(const t of u)for(let e=0;e<t.circleArray.length/4;e++){const i=4*e,r=t.circleArray[i+0],n=t.circleArray[i+1],o=t.circleArray[i+2],s=t.circleArray[i+3];m.emplace(_++,r,n,o,s,0),m.emplace(_++,r,n,o,s,1),m.emplace(_++,r,n,o,s,2),m.emplace(_++,r,n,o,s,3);}(!yM||yM.length<2*d)&&(yM=function(t){const e=2*t,i=new Ba;i.resize(e),i._trim();for(let t=0;t<e;t++){const e=6*t;i.uint16[e+0]=4*t+0,i.uint16[e+1]=4*t+1,i.uint16[e+2]=4*t+2,i.uint16[e+3]=4*t+2,i.uint16[e+4]=4*t+3,i.uint16[e+5]=4*t+0;}return i}(d));const g=a.createIndexBuffer(yM,!0),y=a.createVertexBuffer(m,Xm.members,!0);for(const e of u){const r={u_matrix:e.transform,u_inv_matrix:e.invTransform,u_camera_to_center_distance:(x=c).getCameraToCenterDistance(e.projection),u_viewport_size:[x.width,x.height]};f.draw(t,l.TRIANGLES,cx.disabled,ux.disabled,t.colorModeForRenderPass(),_x.disabled,r,i.id,y,g,Wl.simpleSegment(0,2*e.circleOffset,e.circleArray.length,e.circleArray.length/2),null,c.zoom);}var x;y.destroy(),g.destroy();}const vM=mu.create();function bM({width:t,height:e,anchor:i,textOffset:r,textScale:n},o){const{horizontalAlign:s,verticalAlign:a}=S_(i),l=-(s-.5)*t,c=-(a-.5)*e,h=ng(i,r);return new y((l/n+h[0])*o,(c/n+h[1])*o)}function wM(t,e,i,r,n,o,s,a,l,c,h){const u=t.text.placedSymbolArray,d=t.text.dynamicLayoutVertexArray,p=t.icon.dynamicLayoutVertexArray,f={},m=t.getProjection(),_=hT(a,m,o),g=o.elevation,y=m.upVectorScale(a.canonical,o.center.lat,o.worldSize).metersToTile;d.clear();for(let p=0;p<u.length;p++){const x=u.get(p),{tileAnchorX:v,tileAnchorY:b,numGlyphs:w}=x,T=x.hidden||!x.crossTileID||t.allowVerticalPlacement&&!x.placedOrientation?null:r[x.crossTileID];if(T){let r=0,u=0,p=0;if(g){const t=g?g.getAtTileOffset(a,v,b):0,[e,i,n]=m.upVector(a.canonical,v,b);r=t*e*y,u=t*i*y,p=t*n*y;}let[E,M,A,S]=Hx(x.projectedAnchorX+r,x.projectedAnchorY+u,x.projectedAnchorZ+p,i?_:s);const I=Wx(o.getCameraToCenterDistance(m),S);let C=n.evaluateSizeForFeature(t.textSizeData,c,x)*I/Ym;i&&(C*=t.tilePixelRatio/l);const z=bM(T,C);i?(({x:E,y:M,z:A}=m.projectTilePoint(v+z.x,b+z.y,a.canonical)),[E,M,A]=Hx(E+r,M+u,A+p,s)):(e&&z._rotate(-o.angle),E+=z.x,M+=z.y,A=0);const D=t.allowVerticalPlacement&&x.placedOrientation===m_.vertical?Math.PI/2:0;for(let t=0;t<w;t++)Kg(d,E,M,A,D);h&&x.associatedIconIndex>=0&&(f[x.associatedIconIndex]={x:E,y:M,z:A,angle:D});}else rv(w,d);}if(h){p.clear();const e=t.icon.placedSymbolArray;for(let t=0;t<e.length;t++){const i=e.get(t),{numGlyphs:r}=i,n=f[t];if(i.hidden||!n)rv(r,p);else {const{x:t,y:e,z:i,angle:o}=n;for(let n=0;n<r;n++)Kg(p,t,e,i,o);}}t.icon.dynamicLayoutVertexBuffer.updateData(p);}t.text.dynamicLayoutVertexBuffer.updateData(d);}function TM(t,e,i){return i.iconsInText&&e?"symbolTextAndIcon":t?"symbolSDF":"symbolIcon"}function EM(t,e,i,r,n,o,s,a,l,c,h,u){const d=t.context,p=d.gl,f=t.transform,m="map"===a,_="map"===l,g=m&&"point"!==i.layout.get("symbol-placement"),y=m&&!_&&!g,x=void 0!==i.layout.get("symbol-sort-key").constantOr(1);let v=!1;const b=t.depthModeForSublayer(0,cx.ReadOnly),w=[Nd(f.center.lng),Ud(f.center.lat)],T=i.layout.get("text-variable-anchor"),E="globe"===f.projection.name,M=[],A=[0,-1,0];let S=A;!E&&!f.mercatorFromTransition||m||(S=function(t){const e=t._camera.getWorldToCamera(t.worldSize,1),i=mu.multiply([],e,t.globeMatrix);mu.invert(i,i);const r=[0,0,0],n=[0,1,0,0];return au.transformMat4(n,n,i),r[0]=n[0],r[1]=n[1],r[2]=n[2],bu.normalize(r,r),r}(f));for(const a of r){const r=e.getTile(a),l=r.getBucket(i);if(!l)continue;if("mercator"===l.projection.name&&E)continue;const h=n?l.text:l.icon;if(!h||l.fullyClipped||!h.segments.get().length)continue;const u=h.programConfigurations.get(i.id),d=n||l.sdfIcons,b=n?l.textSizeData:l.iconSizeData,I=_||0!==f.pitch,C=t_(b,f.zoom);let z,D,P,R,L=[0,0],k=null;if(n)D=r.glyphAtlasTexture,P=p.LINEAR,z=r.glyphAtlasTexture.size,l.iconsInText&&(L=r.imageAtlasTexture.size,k=r.imageAtlasTexture,R=I||t.options.rotating||t.options.zooming||"composite"===b.kind||"camera"===b.kind?p.LINEAR:p.NEAREST);else {const e=1!==i.layout.get("icon-size").constantOr(0)||l.iconsNeedLinear;D=r.imageAtlasTexture,P=d||t.options.rotating||t.options.zooming||e||I?p.LINEAR:p.NEAREST,z=r.imageAtlasTexture.size;}const B="globe"===l.projection.name,O=B?S:A,F=B?pd(f.zoom):0,N=hT(a,l.getProjection(),f),U=f.calculatePixelsToTileUnitsMatrix(r),V=qx(N,r.tileID.canonical,_,m,f,l.getProjection(),U),j=t.terrain&&_&&g?mu.invert(mu.create(),V):vM,G=$x(N,r.tileID.canonical,_,m,f,l.getProjection(),U),q=T&&l.hasTextData(),Z=l.hasIconTextFit()&&q&&l.hasIconData();if(g){const e=f.elevation,i=e?e.getAtTileOffsetFunc(a,f.center.lat,f.worldSize,l.getProjection()):null,o=Zx(N,r.tileID.canonical,_,m,f,l.getProjection(),U);Yx(l,N,t,n,o,G,_,c,i,a);}const $=g||n&&T||Z,H=t.translatePosMatrix(N,r,o,s),W=$?vM:V,X=t.translatePosMatrix(G,r,o,s,!0),Y=l.getProjection().createInversionMatrix(f,a.canonical),K=i.paint.get("icon-image-cross-fade").constantOr(0),J=[];t.terrainRenderModeElevated()&&_&&J.push("PITCH_WITH_MAP_TERRAIN"),B&&J.push("PROJECTION_GLOBE_VIEW"),$&&J.push("PROJECTED_POS_ON_VIEWPORT"),K>0&&J.push("ICON_TRANSITION"),h.zOffsetVertexBuffer&&J.push("Z_OFFSET");const Q=d&&0!==i.paint.get(n?"text-halo-width":"icon-halo-width").constantOr(1);let tt;tt=d?l.iconsInText?hM(b.kind,C,y,_,t,H,W,X,z,L,a,F,w,Y,O,l.getProjection()):cM(b.kind,C,y,_,t,H,W,X,n,z,!0,a,F,w,Y,O,l.getProjection()):lM(b.kind,C,y,_,t,H,W,X,n,z,a,F,w,Y,O,l.getProjection(),K);const et={program:t.useProgram(TM(d,n,l),u,J),buffers:h,uniformValues:tt,atlasTexture:D,atlasTextureIcon:k,atlasInterpolation:P,atlasInterpolationIcon:R,isSDF:d,hasHalo:Q,tile:r,labelPlaneMatrixInv:j};if(x&&l.canOverlap){v=!0;const t=h.segments.get();for(const e of t)M.push({segments:new Wl([e]),sortKey:e.sortKey,state:et});}else M.push({segments:h.segments,sortKey:0,state:et});}v&&M.sort(((t,e)=>t.sortKey-e.sortKey));for(const e of M){const r=e.state;if(t.terrain&&t.terrain.setupElevationDraw(r.tile,r.program,{useDepthForOcclusion:!E,labelPlaneMatrixInv:r.labelPlaneMatrixInv}),d.activeTexture.set(p.TEXTURE0),r.atlasTexture.bind(r.atlasInterpolation,p.CLAMP_TO_EDGE),r.atlasTextureIcon&&(d.activeTexture.set(p.TEXTURE1),r.atlasTextureIcon&&r.atlasTextureIcon.bind(r.atlasInterpolationIcon,p.CLAMP_TO_EDGE)),t.uploadCommonLightUniforms(t.context,r.program),r.hasHalo){const n=r.uniformValues;n.u_is_halo=1,MM(r.buffers,e.segments,i,t,r.program,b,h,u,n,2),n.u_is_halo=0;}else {if(r.isSDF){const n=r.uniformValues;r.hasHalo&&(n.u_is_halo=1,MM(r.buffers,e.segments,i,t,r.program,b,h,u,n,1)),n.u_is_halo=0;}MM(r.buffers,e.segments,i,t,r.program,b,h,u,r.uniformValues,1);}}}function MM(t,e,i,r,n,o,s,a,l,c){const h=[t.dynamicLayoutVertexBuffer,t.opacityVertexBuffer,t.iconTransitioningVertexBuffer,t.globeExtVertexBuffer,t.zOffsetVertexBuffer];n.draw(r,r.context.gl.TRIANGLES,o,s,a,_x.disabled,l,i.id,t.layoutVertexBuffer,t.indexBuffer,e,i.paint,r.transform.zoom,t.programConfigurations.get(i.id),h,c);}function AM(t,e,i,r,n,o,s){const a=t.context.gl,l=i.paint.get("fill-pattern"),c=l&&l.constantOr(1);let h,u,d,p,f;s?(u=c&&!i.getPaintProperty("fill-outline-color")?"fillOutlinePattern":"fillOutline",h=a.LINES):(u=c?"fillPattern":"fill",h=a.TRIANGLES);for(const m of r){const r=e.getTile(m);if(c&&!r.patternsLoaded())continue;const _=r.getBucket(i);if(!_)continue;t.prepareDrawTile();const g=_.programConfigurations.get(i.id),y=t.useProgram(u,g);c&&(t.context.activeTexture.set(a.TEXTURE0),r.imageAtlasTexture.bind(a.LINEAR,a.CLAMP_TO_EDGE),g.updatePaintBuffers());const x=l.constantOr(null);if(x&&r.imageAtlas){const t=r.imageAtlas.patternPositions[x.toString()];t&&g.setConstantPatternPositions(t);}const v=t.translatePosMatrix(m.projMatrix,r,i.paint.get("fill-translate"),i.paint.get("fill-translate-anchor")),b=i.paint.get("fill-emissive-strength");if(s){p=_.indexBuffer2,f=_.segments2;const e=t.terrain&&t.terrain.renderingToTexture?t.terrain.drapeBufferSize:[a.drawingBufferWidth,a.drawingBufferHeight];d="fillOutlinePattern"===u&&c?ZE(v,b,t,r,e):qE(v,b,e);}else p=_.indexBuffer,f=_.segments,d=c?GE(v,b,t,r):jE(v,b);t.uploadCommonUniforms(t.context,y,m.toUnwrapped()),y.draw(t,h,n,t.stencilModeForClipping(m),o,_x.disabled,d,i.id,_.layoutVertexBuffer,p,f,i.paint,t.transform.zoom,g,void 0);}}function SM(t,e,i,r,n,o,s,a){const l=t.context,c=l.gl,h=t.transform,u=i.paint.get("fill-extrusion-pattern"),d=u.constantOr(1),p=i.paint.get("fill-extrusion-opacity"),f=t.style.enable3dLights(),m=i.paint.get(f&&!d?"fill-extrusion-ambient-occlusion-wall-radius":"fill-extrusion-ambient-occlusion-radius"),_=[i.paint.get("fill-extrusion-ambient-occlusion-intensity"),m],g=i.layout.get("fill-extrusion-edge-radius"),y=g>0&&!i.paint.get("fill-extrusion-rounded-roof"),x=y?0:g,v="globe"===h.projection.name?lb():0,b="globe"===h.projection.name,w=b?pd(h.zoom):0,T=[Nd(h.center.lng),Ud(h.center.lat)],E=i.paint.get("fill-extrusion-flood-light-color").toArray01().slice(0,3),M=i.paint.get("fill-extrusion-flood-light-intensity"),A=i.paint.get("fill-extrusion-vertical-scale"),S=bE(t,i.paint.get("fill-extrusion-cutoff-fade-range")),I=[];b&&I.push("PROJECTION_GLOBE_VIEW"),_[0]>0&&I.push("FAUX_AO"),y&&I.push("ZERO_ROOF_RADIUS"),a&&I.push("HAS_CENTROID"),M>0&&I.push("FLOOD_LIGHT"),S.shouldRenderCutoff&&I.push("RENDER_CUTOFF");const C="shadow"===t.renderPass,z=t.shadowRenderer,D=C&&!!z;t.shadowRenderer&&(t.shadowRenderer.useNormalOffset=!0);let P=[0,0,0];if(z){const e=t.style.directionalLight,i=t.style.ambientLight;e&&i&&(P=gA(e,i));}for(const f of r){const r=e.getTile(f),m=r.getBucket(i);if(!m||m.projection.name!==h.projection.name)continue;const g=m.programConfigurations.get(i.id),y=t.useProgram(D?"fillExtrusionDepth":d?"fillExtrusionPattern":"fillExtrusion",g,I);if(t.terrain){const e=t.terrain;t.style.terrainSetForDrapingOnly(),e.setupElevationDraw(r,y,{useMeterToDem:!0});}if(!m.centroidVertexBuffer){const t=y.attributes.a_centroid_pos;void 0!==t&&c.vertexAttrib2f(t,0,0);}!C&&z&&z.setupShadows(r.tileID.toUnwrapped(),y,"vector-tile",r.tileID.overscaledZ),d&&(t.context.activeTexture.set(c.TEXTURE0),r.imageAtlasTexture.bind(c.LINEAR,c.CLAMP_TO_EDGE),g.updatePaintBuffers());const R=u.constantOr(null);if(R&&r.imageAtlas){const t=r.imageAtlas.patternPositions[R.toString()];t&&g.setConstantPatternPositions(t);}const L=i.paint.get("fill-extrusion-vertical-gradient");let k;if(C&&z){if(RM(r.tileID,m,t))continue;const e=z.calculateShadowPassMatrixFromTile(r.tileID.toUnwrapped());k=UE(e,x,A);}else {const e=t.translatePosMatrix(f.projMatrix,r,i.paint.get("fill-extrusion-translate"),i.paint.get("fill-extrusion-translate-anchor")),n=h.projection.createInversionMatrix(h,f.canonical);k=d?VE(e,t,L,p,_,x,f,r,v,w,T,n,E,A):NE(e,t,L,p,_,x,f,v,w,T,n,E,A,M,P);}t.uploadCommonUniforms(l,y,f.toUnwrapped(),null,S);const B=[];(t.terrain||a)&&B.push(m.centroidVertexBuffer),b&&B.push(m.layoutVertexExtBuffer),y.draw(t,l.gl.TRIANGLES,n,o,s,_x.backCCW,k,i.id,m.layoutVertexBuffer,m.indexBuffer,m.segments,i.paint,t.transform.zoom,g,B);}t.shadowRenderer&&(t.shadowRenderer.useNormalOffset=!1);}function IM(t,e,i,r,n,o,s,a,l,c,h,u,d,p,f,m,_,g,y){const x=t.context,v=x.gl,b=t.transform,w=t.transform.zoom,T=[],E=bE(t,i.paint.get("fill-extrusion-cutoff-fade-range"));"clear"===c?(T.push("CLEAR_SUBPASS"),y&&(T.push("CLEAR_FROM_TEXTURE"),x.activeTexture.set(v.TEXTURE0),y.bind(v.LINEAR,v.CLAMP_TO_EDGE))):"sdf"===c&&T.push("SDF_SUBPASS"),_&&T.push("HAS_CENTROID"),E.shouldRenderCutoff&&T.push("RENDER_CUTOFF");const M=i.layout.get("fill-extrusion-edge-radius"),A=(e,r,c,g,v)=>{const b=r.programConfigurations.get(i.id),A=t.useProgram("fillExtrusionGroundEffect",b,T),S=((t,e,i,r,n,o,s,a,l,c,h)=>({u_matrix:e,u_opacity:i,u_ao_pass:r?1:0,u_meter_to_tile:n,u_ao:o,u_flood_light_intensity:s,u_flood_light_color:a,u_attenuation:l,u_edge_radius:c,u_fb:0,u_fb_size:h}))(0,g,h,l,v,[u,d*v],p,f,m,w>=17?0:M*v,y?y.size[0]:0),I=[];_&&I.push(r.hiddenByLandmarkVertexBuffer),t.uploadCommonUniforms(x,A,e.toUnwrapped(),null,E),A.draw(t,x.gl.TRIANGLES,n,o,s,a,S,i.id,r.vertexBuffer,r.indexBuffer,c,i.paint,w,b,I);};for(const n of r){const r=e.getTile(n),o=r.getBucket(i);if(!o||o.projection.name!==b.projection.name||!o.groundEffect||o.groundEffect&&!o.groundEffect.hasData())continue;const s=o.groundEffect,a=1/o.tileToMeter;{const e=t.translatePosMatrix(n.projMatrix,r,i.paint.get("fill-extrusion-translate"),i.paint.get("fill-extrusion-translate-anchor")),o=s.getDefaultSegment();A(n,s,o,e,a);}if(g)for(let o=0;o<4;o++){const s=kd[o](n),l=e.getTile(s);if(!l)continue;const c=l.getBucket(i);if(!c||c.projection.name!==b.projection.name||!c.groundEffect||c.groundEffect&&!c.groundEffect.hasData())continue;const h=c.groundEffect;let u,d;0===o?(u=[-sr,0,0],d=1):1===o?(u=[sr,0,0],d=0):2===o?(u=[0,-sr,0],d=3):(u=[0,sr,0],d=2);const p=h.regionSegments[d];if(!p)continue;const f=new Float32Array(16);mu.translate(f,n.projMatrix,u),A(n,h,p,t.translatePosMatrix(f,r,i.paint.get("fill-extrusion-translate"),i.paint.get("fill-extrusion-translate-anchor")),a);}}}function CM(t,e,i,r,n,o,s){0===r.centroidVertexArray.length&&r.createCentroidsBuffer();const a=o?o.findDEMTileFor(i):null;if(!(a&&a.dem||s))return;const l=t=>{const i=e.getSource().minzoom,r=t=>{const i=e.getTileByID(t);if(i&&i.hasData())return i.getBucket(n)},o=[0,-1,1];for(const e of o){if(t.overscaledZ+e<i)continue;const n=r(t.calculateScaledKey(t.overscaledZ+e));if(n)return n}},c=[0,0,0],h=(t,e)=>(c[0]=Math.min(t.min.y,e.min.y),c[1]=Math.max(t.max.y,e.max.y),c[2]=sr-e.min.x>t.max.x?e.min.x-sr:t.max.x,c),u=(t,e)=>(c[0]=Math.min(t.min.x,e.min.x),c[1]=Math.max(t.max.x,e.max.x),c[2]=sr-e.min.y>t.max.y?e.min.y-sr:t.max.y,c),d=[(t,e)=>h(t,e),(t,e)=>h(e,t),(t,e)=>u(t,e),(t,e)=>u(e,t)],p=(t,e,r,n,s,l,c)=>{if(!o)return 0;const h=[[l?r:t,l?t:r,0],[l?r:e,l?e:r,0]],u=c<0?sr+c:c,d=[l?u:(t+e)/2,l?(t+e)/2:u,0];return 0===r&&c<0||0!==r&&c>0?o.getForTilePoints(s,[d],!0,n):h.push(d),o.getForTilePoints(i,h,!0,a),Math.max(h[0][2],h[1][2],d[2])/o.exaggeration()};for(let t=0;t<4;t++){const e=r.borderFeatureIndices[t];if(0===e.length)continue;const n=kd[t](i),a=l(n);if(!(a&&a instanceof tb))continue;if(r.borderDoneWithNeighborZ[t]===a.canonical.z)continue;0===a.centroidVertexArray.length&&a.createCentroidsBuffer();const c=o?o.findDEMTileFor(n):null;if(!(c&&c.dem||s))continue;const h=(t<2?1:5)-t,u=a.borderDoneWithNeighborZ[h]!==r.canonical.z,g=a.borderFeatureIndices[h];let x=0;if(r.canonical.z!==a.canonical.z){for(const t of e)r.showCentroid(r.featuresOnBorder[t]);if(u)for(const t of g)a.showCentroid(a.featuresOnBorder[t]);r.borderDoneWithNeighborZ[t]=a.canonical.z,a.borderDoneWithNeighborZ[h]=r.canonical.z;}for(const i of e){const e=r.featuresOnBorder[i],o=r.centroidData[e.centroidDataIndex],l=e.borders[t];let u;for(;x<g.length;){u=a.featuresOnBorder[g[x]];const t=u.borders[h];if(t[1]>l[0]+3||t[0]>l[0]-3)break;a.showCentroid(u),x++;}if(u&&x<g.length){const i=x;let v=0;for(;!(u.borders[h][0]>l[1]-3)&&(v++,++x!==g.length);)u=a.featuresOnBorder[g[x]];if(u=a.featuresOnBorder[g[i]],v>1){const t=u.borders[h];Math.abs(l[0]-t[0])<3&&Math.abs(l[1]-t[1])<3&&(v=1,x=i+1);}else if(0===v){r.showCentroid(e);continue}const b=a.centroidData[u.centroidDataIndex];s&&1===v&&(((m=o).flags|(_=b).flags)&Gv?(m.flags|=Gv,_.flags|=Gv):(m.flags&=2147483647,_.flags&=2147483647));let w=new y(0,0);if(v>1)x=i;else if(c&&c.dem&&!(e.intersectsCount()>1||u.intersectsCount()>1)){const e=d[t](o,b),i=t%2?sr-1:0;f=p(e[0],Math.min(sr-1,e[1]),i,c,n,t<2,e[2]),w=new y(Math.ceil(7*(f+450)),0);}o.centroidXY=b.centroidXY=w,r.writeCentroidToBuffer(o),a.writeCentroidToBuffer(b);}else r.showCentroid(e);}r.borderDoneWithNeighborZ[t]=a.canonical.z,a.borderDoneWithNeighborZ[h]=r.canonical.z;}var f,m,_;(r.needsCentroidUpdate||!r.centroidVertexBuffer&&0!==r.centroidVertexArray.length)&&r.uploadCentroid(t);}const zM=[1,0,0],DM=[0,1,0],PM=[0,0,1];function RM(t,e,i){const r=i.transform,n=i.shadowRenderer;if(!n)return !0;const o=t.toUnwrapped(),s=r.tileSize*n._cascades[i.currentShadowCascade].scale;let a=e.maxHeight;if(r.elevation){const e=r.elevation.getMinMaxForTile(t);e&&(a+=e.max);}const l=[...n.shadowDirection];l[2]=-l[2];const c=n.computeSimplifiedTileShadowVolume(o,a,s,l);if(!c)return !1;const h=[zM,DM,PM,l,[l[0],0,l[2]],[0,l[1],l[2]]],u="globe"===r.projection.name,d=r.scaleZoom(s),p=ku.fromInvProjectionMatrix(r.invProjMatrix,r.worldSize,d,!u),f=n.getCurrentCascadeFrustum();return 0===p.intersectsPrecise(c.vertices,c.planes,h)||0===f.intersectsPrecise(c.vertices,c.planes,h)}const LM=new li(1,0,0,1),kM=new li(0,1,0,1),BM=new li(0,0,1,1),OM=new li(1,0,1,1),FM=new li(0,1,1,1);function NM(t,e,i){const r=t.context,n=t.transform,o=r.gl,s="globe"===n.projection.name,a=s?["PROJECTION_GLOBE_VIEW"]:null;let l=i.projMatrix;if(s&&pd(n.zoom)>0){const t=cd(Ju(i.canonical,n));l=mu.multiply(new Float32Array(16),n.globeMatrix,t),mu.multiply(l,n.projMatrix,l);}const c=t.useProgram("debug",null,a),h=e.getTileByID(i.key);t.terrain&&t.terrain.setupElevationDraw(h,c);const u=cx.disabled,d=ux.disabled,p=t.colorModeForRenderPass(),f="$debug";r.activeTexture.set(o.TEXTURE0),t.emptyTexture.bind(o.LINEAR,o.CLAMP_TO_EDGE),s?h._makeGlobeTileDebugBuffers(t.context,n):h._makeDebugTileBoundsBuffers(t.context,n.projection);const m=h._tileDebugBuffer||t.debugBuffer,_=h._tileDebugIndexBuffer||t.debugIndexBuffer,g=h._tileDebugSegments||t.debugSegments;c.draw(t,o.LINE_STRIP,u,d,p,_x.disabled,YE(l,li.red),f,m,_,g,null,null,null,[h._globeTileDebugBorderBuffer]);const y=h.latestRawTileData,x=Math.floor((y&&y.byteLength||0)/1024),v=e.getTile(i).tileSize,b=512/Math.min(v,512)*(i.overscaledZ/n.zoom)*.5;let w=i.canonical.toString();i.overscaledZ!==i.canonical.z&&(w+=` => ${i.overscaledZ}`),w+=` ${x}kb`,function(t,e){t.initDebugOverlayCanvas();const i=t.debugOverlayCanvas,r=t.context.gl,n=t.debugOverlayCanvas.getContext("2d");n.clearRect(0,0,i.width,i.height),n.shadowColor="white",n.shadowBlur=2,n.lineWidth=1.5,n.strokeStyle="white",n.textBaseline="top",n.font="bold 36px Open Sans, sans-serif",n.fillText(e,5,5),n.strokeText(e,5,5),t.debugOverlayTexture.update(i),t.debugOverlayTexture.bind(r.LINEAR,r.CLAMP_TO_EDGE);}(t,w);const T=h._tileDebugTextBuffer||t.debugBuffer,E=h._tileDebugTextIndexBuffer||t.quadTriangleIndexBuffer,M=h._tileDebugTextSegments||t.debugSegments;c.draw(t,o.TRIANGLES,u,d,px.alphaBlended,_x.disabled,YE(l,li.transparent,b),f,T,E,M,null,null,null,[h._globeTileDebugTextBuffer]);}function UM(t,e,i,r){jM(t,0,e+i/2,t.transform.width,i,r);}function VM(t,e,i,r){jM(t,e-i/2,0,i,t.transform.height,r);}function jM(t,e,i,r,n,o){const s=t.context,a=s.gl;a.enable(a.SCISSOR_TEST),a.scissor(e*ue.devicePixelRatio,i*ue.devicePixelRatio,r*ue.devicePixelRatio,n*ue.devicePixelRatio),s.clear({color:o}),a.disable(a.SCISSOR_TEST);}const GM=_a([{name:"a_pos_3f",components:3,type:"Float32"}]),{members:qM}=GM;function ZM(t,e,i,r){t.emplaceBack(e,i,r);}class $M{constructor(t){this.vertexArray=new ka,this.indices=new Ba,ZM(this.vertexArray,-1,-1,1),ZM(this.vertexArray,1,-1,1),ZM(this.vertexArray,-1,1,1),ZM(this.vertexArray,1,1,1),ZM(this.vertexArray,-1,-1,-1),ZM(this.vertexArray,1,-1,-1),ZM(this.vertexArray,-1,1,-1),ZM(this.vertexArray,1,1,-1),this.indices.emplaceBack(5,1,3),this.indices.emplaceBack(3,7,5),this.indices.emplaceBack(6,2,0),this.indices.emplaceBack(0,4,6),this.indices.emplaceBack(2,6,7),this.indices.emplaceBack(7,3,2),this.indices.emplaceBack(5,4,0),this.indices.emplaceBack(0,1,5),this.indices.emplaceBack(0,2,3),this.indices.emplaceBack(3,1,0),this.indices.emplaceBack(7,6,4),this.indices.emplaceBack(4,5,7),this.vertexBuffer=t.createVertexBuffer(this.vertexArray,qM),this.indexBuffer=t.createIndexBuffer(this.indices),this.segment=Wl.simpleSegment(0,0,36,12);}}function HM(t,e,i,r,n,o){const s=t.context.gl,a=e.paint.get("sky-atmosphere-color"),l=e.paint.get("sky-atmosphere-halo-color"),c=e.paint.get("sky-atmosphere-sun-intensity"),h=((t,e,i,r,n)=>({u_matrix_3f:t,u_sun_direction:e,u_sun_intensity:i,u_color_tint_r:[r.r,r.g,r.b,r.a],u_color_tint_m:[n.r,n.g,n.b,n.a],u_luminance:5e-5}))(pu.fromMat4(pu.create(),r),n,c,a,l);s.framebufferTexture2D(s.FRAMEBUFFER,s.COLOR_ATTACHMENT0,s.TEXTURE_CUBE_MAP_POSITIVE_X+o,e.skyboxTexture,0),i.draw(t,s.TRIANGLES,cx.disabled,ux.disabled,px.unblended,_x.frontCW,h,"skyboxCapture",e.skyboxGeometry.vertexBuffer,e.skyboxGeometry.indexBuffer,e.skyboxGeometry.segment);}const WM=_a([{type:"Float32",name:"a_pos",components:3},{type:"Float32",name:"a_uv",components:2}]);class XM{constructor(t){const e=new Ua;e.emplaceBack(-1,1,1,0,0),e.emplaceBack(1,1,1,1,0),e.emplaceBack(1,-1,1,1,1),e.emplaceBack(-1,-1,1,0,1);const i=new Ba;i.emplaceBack(0,1,2),i.emplaceBack(2,3,0),this.vertexBuffer=t.createVertexBuffer(e,WM.members),this.indexBuffer=t.createIndexBuffer(i),this.segments=Wl.simpleSegment(0,0,4,2);}destroy(){this.vertexBuffer.destroy(),this.indexBuffer.destroy(),this.segments.destroy();}}const YM=_a([{type:"Float32",name:"a_pos_3f",components:3},{type:"Float32",name:"a_uv",components:2},{type:"Float32",name:"a_size_scale",components:1},{type:"Float32",name:"a_fade_opacity",components:1}]);class KM{constructor(){this.colorModeAlphaBlendedWriteRGB=new px([1,dx,1,dx],li.transparent,[!0,!0,!0,!1]),this.colorModeWriteAlpha=new px([1,0,1,0],li.transparent,[!1,!1,!1,!0]);}update(t){const e=t.context;if(!this.atmosphereBuffer){this.atmosphereBuffer=new XM(e);const t=100,i=100,r=function(t){const e=Zn(30),i=[];for(let t=0;t<16e3;++t){const t=2*Math.PI*e(),r=Math.acos(1-2*e())-.5*Math.PI;i.push(bu.fromValues(Math.cos(r)*Math.cos(t),Math.cos(r)*Math.sin(t),Math.sin(r)));}return i}(),n=Zn(300),o=new Va,s=new Ba;let a=0;for(let e=0;e<r.length;++e){const l=bu.scale([],r[e],200),c=1+.01*t*(1*n()-.5),h=1+.01*i*(1*n()-.5);o.emplaceBack(l[0],l[1],l[2],-1,-1,c,h),o.emplaceBack(l[0],l[1],l[2],1,-1,c,h),o.emplaceBack(l[0],l[1],l[2],1,1,c,h),o.emplaceBack(l[0],l[1],l[2],-1,1,c,h),s.emplaceBack(a+0,a+1,a+2),s.emplaceBack(a+0,a+2,a+3),a+=4;}this.starsVx=e.createVertexBuffer(o,YM.members),this.starsIdx=e.createIndexBuffer(s),this.starsSegments=Wl.simpleSegment(0,0,o.length,s.length);}}destroy(){this.atmosphereBuffer&&this.atmosphereBuffer.destroy(),this.starsVx&&this.starsVx.destroy(),this.starsIdx&&this.starsIdx.destroy();}drawAtmosphereGlow(t,e){const i=t.context,r=i.gl,n=t.transform,o=new cx(r.LEQUAL,cx.ReadOnly,[0,1]),s=pd(n.zoom),a=e.properties.get("color").toArray01(),l=e.properties.get("high-color").toArray01(),c=e.properties.get("space-color").toArray01PremultipliedAlpha(),h=5e-4,u=z((e.properties.get("horizon-blend")-0)/1*.2495+h,5e-4,.25),d=md(t,i,n)&&u===h?n.worldSize/(2*Math.PI*1.025)-1:n.globeRadius,p=t.frameCounter/1e3%1,f=bu.length(n.globeCenterInViewSpace),m=Math.sqrt(Math.pow(f,2)-Math.pow(d,2)),_=Math.acos(m/f),g=e=>{const h="globe"===n.projection.name?["PROJECTION_GLOBE_VIEW","FOG"]:["FOG"];e&&h.push("ALPHA_PASS");const d=t.useProgram("globeAtmosphere",null,h),f=((t,e,i,r,n,o,s,a,l,c,h,u)=>({u_frustum_tl:t,u_frustum_tr:e,u_frustum_br:i,u_frustum_bl:r,u_horizon:n,u_transition:o,u_fadeout_range:s,u_color:a,u_high_color:l,u_space_color:c,u_temporal_offset:h,u_horizon_angle:u}))(n.frustumCorners.TL,n.frustumCorners.TR,n.frustumCorners.BR,n.frustumCorners.BL,n.frustumCorners.horizon,s,u,a,l,c,p,_);t.uploadCommonUniforms(i,d);const m=this.atmosphereBuffer;m&&d.draw(t,r.TRIANGLES,o,ux.disabled,e?this.colorModeWriteAlpha:this.colorModeAlphaBlendedWriteRGB,_x.backCW,f,e?"atmosphere_glow_alpha":"atmosphere_glow",m.vertexBuffer,m.indexBuffer,m.segments);};g(!1),g(!0);}drawStars(t,e){const i=z(e.properties.get("star-intensity"),0,1);if(0===i)return;const r=t.context,n=r.gl,o=t.transform,s=t.useProgram("stars"),a=gu.identity([]);gu.rotateX(a,a,-o._pitch),gu.rotateZ(a,a,-o.angle),gu.rotateX(a,a,w(o._center.lat)),gu.rotateY(a,a,-w(o._center.lng));const l=mu.fromQuat(new Float32Array(16),a),c=mu.multiply([],o.starsProjMatrix,l),h=pu.fromMat4([],l),u=pu.invert([],h),d=[0,1,0];bu.transformMat3(d,d,u),bu.scale(d,d,.2);const p=[1,0,0];bu.transformMat3(p,p,u),bu.scale(p,p,.2);const f=((t,e,i,r)=>({u_matrix:Float32Array.from(t),u_up:e,u_right:i,u_intensity_multiplier:r}))(c,d,p,i);t.uploadCommonUniforms(r,s),this.starsVx&&this.starsIdx&&s.draw(t,n.TRIANGLES,cx.disabled,ux.disabled,this.colorModeAlphaBlendedWriteRGB,_x.disabled,f,"atmosphere_stars",this.starsVx,this.starsIdx,this.starsSegments);}}function JM(t,e){const i=[...t],r=e.cameraWorldSizeForFog/e.worldSize,n=mu.identity([]);return mu.scale(n,n,[r,r,1]),mu.multiply(i,n,i),mu.multiply(i,e.worldToFogMatrix,i),i}function QM(t,e,i,r){const n=i.material,o=n.pbrMetallicRoughness,s=r.context;if(o.baseColorTexture){t.push("HAS_TEXTURE_u_baseColorTexture"),s.activeTexture.set(s.gl.TEXTURE0+pM.BaseColor);const e=o.baseColorTexture.sampler;o.baseColorTexture.gfxTexture&&o.baseColorTexture.gfxTexture.bindExtraParam(e.minFilter,e.magFilter,e.wrapS,e.wrapT);}if(o.metallicRoughnessTexture){t.push("HAS_TEXTURE_u_metallicRoughnessTexture"),s.activeTexture.set(s.gl.TEXTURE0+pM.MetallicRoughness);const e=o.metallicRoughnessTexture.sampler;o.metallicRoughnessTexture.gfxTexture&&o.metallicRoughnessTexture.gfxTexture.bindExtraParam(e.minFilter,e.magFilter,e.wrapS,e.wrapT);}if(n.normalTexture){t.push("HAS_TEXTURE_u_normalTexture"),s.activeTexture.set(s.gl.TEXTURE0+pM.Normal);const e=n.normalTexture.sampler;n.normalTexture.gfxTexture&&n.normalTexture.gfxTexture.bindExtraParam(e.minFilter,e.magFilter,e.wrapS,e.wrapT);}if(n.occlusionTexture){t.push("HAS_TEXTURE_u_occlusionTexture"),s.activeTexture.set(s.gl.TEXTURE0+pM.Occlusion);const e=n.occlusionTexture.sampler;n.occlusionTexture.gfxTexture&&n.occlusionTexture.gfxTexture.bindExtraParam(e.minFilter,e.magFilter,e.wrapS,e.wrapT);}if(n.emissionTexture){t.push("HAS_TEXTURE_u_emissionTexture"),s.activeTexture.set(s.gl.TEXTURE0+pM.Emission);const e=n.emissionTexture.sampler;n.emissionTexture.gfxTexture&&n.emissionTexture.gfxTexture.bindExtraParam(e.minFilter,e.magFilter,e.wrapS,e.wrapT);}i.texcoordBuffer&&(t.push("HAS_ATTRIBUTE_a_uv_2f"),e.push(i.texcoordBuffer)),i.colorBuffer&&(t.push(12===i.colorBuffer.itemSize?"HAS_ATTRIBUTE_a_color_3f":"HAS_ATTRIBUTE_a_color_4f"),e.push(i.colorBuffer)),i.normalBuffer&&(t.push("HAS_ATTRIBUTE_a_normal_3f"),e.push(i.normalBuffer)),i.pbrBuffer&&(t.push("HAS_ATTRIBUTE_a_pbr"),t.push("HAS_ATTRIBUTE_a_heightBasedEmissiveStrength"),e.push(i.pbrBuffer)),"OPAQUE"!==n.alphaMode&&"MASK"!==n.alphaMode||t.push("UNPREMULT_TEXTURE_IN_SHADER"),n.defined||t.push("DIFFUSE_SHADED"),t.push("USE_STANDARD_DERIVATIVES");}function tA(t,e,i,r,n,o){const s=i.paint.get("model-opacity"),a=e.context,l=new cx(e.context.gl.LEQUAL,cx.ReadWrite,e.depthRangeFor3D),c=t.mesh,h=c.material,u=h.pbrMetallicRoughness;let d;d="pixels"===e.transform.projection.zAxisUnit?[...t.nodeModelMatrix]:mu.multiply([],r.zScaleMatrix,t.nodeModelMatrix),mu.multiply(d,r.negCameraPosMatrix,d);const p=mu.invert([],d);mu.transpose(p,p);const f=fM(new Float32Array(t.worldViewProjection),new Float32Array(d),new Float32Array(p),e,s,u.baseColorFactor,h.emissiveFactor,u.metallicFactor,u.roughnessFactor,h,i),m=[],_=[];QM(m,_,c,e);const g=e.shadowRenderer;g&&(g.useNormalOffset=!1);let y=null;if(e.style.fog){const i=JM(t.nodeModelMatrix,e.transform);m.push("FOG","FOG_DITHERING"),y=new Float32Array(i);}const x=bE(e,i.paint.get("model-cutoff-fade-range"));x.shouldRenderCutoff&&m.push("RENDER_CUTOFF");const v=e.useProgram("model",null,m);e.uploadCommonUniforms(a,v,null,y,x),"shadow"!==e.renderPass&&g&&g.setupShadowsFromMatrix(t.nodeModelMatrix,v),v.draw(e,a.gl.TRIANGLES,l,n,o,c.material.doubleSided?_x.disabled:_x.backCCW,f,i.id,c.vertexBuffer,c.indexBuffer,c.segments,i.paint,e.transform.zoom,void 0,_);}function eA(t,e,i,r,n,o,s){let a;a="globe"===t.projection.name?uv(i,t):[...i],mu.multiply(a,a,e.matrix);const l=mu.multiply([],r,a);if(e.meshes)for(const t of e.meshes){if("BLEND"!==t.material.alphaMode){s.push({mesh:t,depth:0,modelIndex:n,worldViewProjection:l,nodeModelMatrix:a});continue}const e=bu.transformMat4([],t.centroid,l);e[2]>0&&o.push({mesh:t,depth:e[2],modelIndex:n,worldViewProjection:l,nodeModelMatrix:a});}if(e.children)for(const a of e.children)eA(t,a,i,r,n,o,s);}function iA(t,e,i,r){const n=i.shadowRenderer;if(!n)return;const o=n.getShadowPassDepthMode(),s=n.getShadowPassColorMode(),a=n.calculateShadowPassMatrixFromMatrix(e),l=_M(a);i.useProgram("modelDepth",null,["DEPTH_TEXTURE"]).draw(i,i.context.gl.TRIANGLES,o,ux.disabled,s,_x.backCCW,l,r.id,t.vertexBuffer,t.indexBuffer,t.segments,r.paint,i.transform.zoom,void 0,void 0);}function rA(t,e,i){let r,n,o,s=t.terrain?t.terrain.exaggeration():0;if(t.terrain&&s>0){const e=t.terrain,n=e.findDEMTileFor(i);n&&n.dem?r=Om.create(e,i,n):s=0;}if(0===s&&(e.terrainElevationMin=0,e.terrainElevationMax=0),s!==e.validForExaggeration||!(0===s||r&&r._demTile&&r._demTile.tileID===e.validForDEMTile)){for(const t in e.instancesPerModel){const i=e.instancesPerModel[t];for(let t=0;t<i.instancedDataArray.length;++t){const a=(r?s*r.getElevationAt(0|i.instancedDataArray.float32[16*t],0|i.instancedDataArray.float32[16*t+1],!0,!0):0)+i.instancesEvaluatedElevation[t];i.instancedDataArray.float32[16*t+6]=a,n=n?Math.min(e.terrainElevationMin,a):a,o=o?Math.max(e.terrainElevationMax,a):a;}}e.terrainElevationMin=n||0,e.terrainElevationMax=o||0,e.validForExaggeration=s,e.validForDEMTile=r&&r._demTile?r._demTile.tileID:void 0,e.uploaded=!1,e.upload(t.context);}}const nA={shadowUniformsInitialized:!1,tileMatrix:new Float64Array(16),shadowTileMatrix:new Float32Array(16),aabb:new Bu([0,0,0],[sr,sr,0])};function oA(t,e,i,r,n,o,s){const a=t.context,l="shadow"===t.renderPass,c=t.shadowRenderer,h=l&&c?c.getShadowPassDepthMode():new cx(a.gl.LEQUAL,cx.ReadWrite,t.depthRangeFor3D);if(i.meshes)for(const u of i.meshes){const d=["MODEL_POSITION_ON_GPU"],p=[];let f,m,_;r.instancedDataArray.length>20&&d.push("INSTANCED_ARRAYS");const g=bE(t,e.paint.get("model-cutoff-fade-range"));if(g.shouldRenderCutoff&&d.push("RENDER_CUTOFF"),l&&c)f=t.useProgram("modelDepth",null,d),m=_M(s.shadowTileMatrix,s.shadowTileMatrix,Float32Array.from(i.matrix)),_=c.getShadowPassColorMode();else {QM(d,p,u,t),f=t.useProgram("model",null,d);const r=u.material,l=r.pbrMetallicRoughness,h=e.paint.get("model-opacity");m=fM(o.projMatrix,Float32Array.from(i.matrix),new Float32Array(16),t,h,l.baseColorFactor,r.emissiveFactor,l.metallicFactor,l.roughnessFactor,r,e,n),c&&(s.shadowUniformsInitialized?f.setShadowUniformValues(a,c.getShadowUniformValues()):(c.setupShadows(o.toUnwrapped(),f,"model-tile",o.overscaledZ),s.shadowUniformsInitialized=!0)),_=g.shouldRenderCutoff||h<1||"OPAQUE"!==r.alphaMode?px.alphaBlended:px.unblended;}t.uploadCommonUniforms(a,f,o.toUnwrapped(),null,g);const y=u.material.doubleSided?_x.disabled:_x.backCCW;if(r.instancedDataArray.length>20)p.push(r.instancedDataBuffer),f.draw(t,a.gl.TRIANGLES,h,ux.disabled,_,y,m,e.id,u.vertexBuffer,u.indexBuffer,u.segments,e.paint,t.transform.zoom,void 0,p,r.instancedDataArray.length);else {const i=l?"u_instance":"u_normal_matrix";for(let n=0;n<r.instancedDataArray.length;++n)m[i]=new Float32Array(r.instancedDataArray.arrayBuffer,64*n,16),f.draw(t,a.gl.TRIANGLES,h,ux.disabled,_,y,m,e.id,u.vertexBuffer,u.indexBuffer,u.segments,e.paint,t.transform.zoom,void 0,p);}}if(i.children)for(const a of i.children)oA(t,e,a,r,n,o,s);}const sA=[1,-1,1];function aA(t,e,i,r){if(!i.modelManager)return !0;const n=i.modelManager;if(!i.shadowRenderer)return !0;const o=i.shadowRenderer,s=e.aabb;let a=!0,l=t.maxHeight;if(0===l){let e=0;for(const i in t.instancesPerModel){const t=n.getModel(i,r);t?e=Math.max(e,Math.max(Math.max(t.aabb.max[0],t.aabb.max[1]),t.aabb.max[2])):a=!1;}l=t.maxScale*e*1.41+t.maxVerticalOffset,a&&(t.maxHeight=l);}s.max[2]=l,s.min[2]+=t.terrainElevationMin,s.max[2]+=t.terrainElevationMax,bu.transformMat4(s.min,s.min,e.tileMatrix),bu.transformMat4(s.max,s.max,e.tileMatrix);const c=s.intersects(o.getCurrentCascadeFrustum());return 0===i.currentShadowCascade&&(t.isInsideFirstShadowMapFrustum=2===c),0===c}class lA{}class cA{constructor(){this._storage=new Map;}getLinesFromTrianglesBuffer(t,e,i){{const i=this._storage.get(e.id);if(i)return i.lastUsedFrameIdx=t,i.buf}const r=i.gl,n=r.getBufferParameter(r.ELEMENT_ARRAY_BUFFER,r.BUFFER_SIZE),o=new ArrayBuffer(n),s=new Int16Array(o);r.getBufferSubData(r.ELEMENT_ARRAY_BUFFER,0,new Int16Array(o));const a=new za;for(let t=0;t<n/2;t+=3){const e=s[t],i=s[t+1],r=s[t+2];a.emplaceBack(e,i),a.emplaceBack(i,r),a.emplaceBack(r,e);}const l=i.bindVertexArrayOES.current,c=new lA;return c.buf=new wy(i,a),c.lastUsedFrameIdx=t,this._storage.set(e.id,c),i.bindVertexArrayOES.set(l),c.buf}update(t){for(const[e,i]of this._storage)t-i.lastUsedFrameIdx>30&&(i.buf.destroy(),this._storage.delete(e));}destroy(){for(const[t,e]of this._storage)e.buf.destroy(),this._storage.delete(t);}}const hA={symbol:function(t,e,i,r,n){if("translucent"!==t.renderPass)return;const o=ux.disabled,s=t.colorModeForRenderPass();i.layout.get("text-variable-anchor")&&function(t,e,i,r,n,o,s){const a=e.transform,l="map"===n,c="map"===o;for(const e of t){const t=r.getTile(e),n=t.getBucket(i);if(!n||!n.text||!n.text.segments.get().length)continue;const o=t_(n.textSizeData,a.zoom),h=hT(e,n.getProjection(),a),u=a.calculatePixelsToTileUnitsMatrix(t),d=qx(h,t.tileID.canonical,c,l,a,n.getProjection(),u),p=n.hasIconTextFit()&&n.hasIconData();if(o){const i=Math.pow(2,a.zoom-t.tileID.overscaledZ);wM(n,l,c,s,e_,a,d,e,i,o,p);}}}(r,t,i,e,i.layout.get("text-rotation-alignment"),i.layout.get("text-pitch-alignment"),n),0!==i.paint.get("icon-opacity").constantOr(1)&&EM(t,e,i,r,!1,i.paint.get("icon-translate"),i.paint.get("icon-translate-anchor"),i.layout.get("icon-rotation-alignment"),i.layout.get("icon-pitch-alignment"),i.layout.get("icon-keep-upright"),o,s),0!==i.paint.get("text-opacity").constantOr(1)&&EM(t,e,i,r,!0,i.paint.get("text-translate"),i.paint.get("text-translate-anchor"),i.layout.get("text-rotation-alignment"),i.layout.get("text-pitch-alignment"),i.layout.get("text-keep-upright"),o,s),e.map.showCollisionBoxes&&(xM(t,e,i,r,i.paint.get("text-translate"),i.paint.get("text-translate-anchor"),!0),xM(t,e,i,r,i.paint.get("icon-translate"),i.paint.get("icon-translate-anchor"),!1));},circle:function(t,e,i,r){if("translucent"!==t.renderPass)return;const n=i.paint.get("circle-opacity"),o=i.paint.get("circle-stroke-width"),s=i.paint.get("circle-stroke-opacity"),a=void 0!==i.layout.get("circle-sort-key").constantOr(1),l=i.paint.get("circle-emissive-strength");if(0===n.constantOr(1)&&(0===o.constantOr(1)||0===s.constantOr(1)))return;const c=t.context,h=c.gl,u=t.transform,d=t.depthModeForSublayer(0,cx.ReadOnly),p=ux.disabled,f=t.colorModeForDrapableLayerRenderPass(l),m="globe"===u.projection.name,_=[Nd(u.center.lng),Ud(u.center.lat)],g=[];for(let n=0;n<r.length;n++){const o=r[n],s=e.getTile(o),l=s.getBucket(i);if(!l||l.projection.name!==u.projection.name)continue;const c=l.programConfigurations.get(i.id),h=WE(i);m&&h.push("PROJECTION_GLOBE_VIEW");const d=t.useProgram("circle",c,h),p=l.layoutVertexBuffer,f=l.globeExtVertexBuffer,y=l.indexBuffer,x=u.projection.createInversionMatrix(u,o.canonical),v={programConfiguration:c,program:d,layoutVertexBuffer:p,globeExtVertexBuffer:f,indexBuffer:y,uniformValues:HE(t,o,s,x,_,i),tile:s};if(a){const t=l.segments.get();for(const e of t)g.push({segments:new Wl([e]),sortKey:e.sortKey,state:v});}else g.push({segments:l.segments,sortKey:0,state:v});}a&&g.sort(((t,e)=>t.sortKey-e.sortKey));const y={useDepthForOcclusion:!m};for(const e of g){const{programConfiguration:r,program:n,layoutVertexBuffer:o,globeExtVertexBuffer:s,indexBuffer:a,uniformValues:l,tile:m}=e.state,_=e.segments;t.terrain&&t.terrain.setupElevationDraw(m,n,y),t.uploadCommonUniforms(c,n,m.tileID.toUnwrapped()),n.draw(t,h.TRIANGLES,d,p,f,_x.disabled,l,i.id,o,a,_,i.paint,u.zoom,r,[s]);}},heatmap:function(t,e,i,r){if(0!==i.paint.get("heatmap-opacity"))if("offscreen"===t.renderPass){const n=t.context,o=n.gl,s=ux.disabled,a=new px([o.ONE,o.ONE,o.ONE,o.ONE],li.transparent,[!0,!0,!0,!0]);!function(t,e,i,r){const n=t.gl,o=e.width*r,s=e.height*r;t.activeTexture.set(n.TEXTURE1),t.viewport.set([0,0,o,s]);let a=i.heatmapFbo;if(!a||a&&(a.width!==o||a.height!==s)){a&&a.destroy();const e=n.createTexture();n.bindTexture(n.TEXTURE_2D,e),n.texParameteri(n.TEXTURE_2D,n.TEXTURE_WRAP_S,n.CLAMP_TO_EDGE),n.texParameteri(n.TEXTURE_2D,n.TEXTURE_WRAP_T,n.CLAMP_TO_EDGE),n.texParameteri(n.TEXTURE_2D,n.TEXTURE_MIN_FILTER,n.LINEAR),n.texParameteri(n.TEXTURE_2D,n.TEXTURE_MAG_FILTER,n.LINEAR),a=i.heatmapFbo=t.createFramebuffer(o,s,!0,null),function(t,e,i,r,n,o){const s=t.gl;s.texImage2D(s.TEXTURE_2D,0,t.extRenderToTextureHalfFloat?s.RGBA16F:s.RGBA,n,o,0,s.RGBA,t.extRenderToTextureHalfFloat?s.HALF_FLOAT:s.UNSIGNED_BYTE,null),r.colorAttachment.set(i);}(t,0,e,a,o,s);}else n.bindTexture(n.TEXTURE_2D,a.colorAttachment.get()),t.bindFramebuffer.set(a.framebuffer);}(n,t,i,"globe"===t.transform.projection.name?.5:.25),n.clear({color:li.transparent});const l=t.transform,c="globe"===l.projection.name,h=c?["PROJECTION_GLOBE_VIEW"]:null,u=c?_x.frontCCW:_x.disabled,d=[Nd(l.center.lng),Ud(l.center.lat)];for(let p=0;p<r.length;p++){const f=r[p];if(e.hasRenderableParent(f))continue;const m=e.getTile(f),_=m.getBucket(i);if(!_||_.projection.name!==l.projection.name)continue;const g=_.programConfigurations.get(i.id),y=t.useProgram("heatmap",g,h),{zoom:x}=t.transform;t.terrain&&t.terrain.setupElevationDraw(m,y),t.uploadCommonUniforms(n,y,f.toUnwrapped());const v=l.projection.createInversionMatrix(l,f.canonical);y.draw(t,o.TRIANGLES,cx.disabled,s,a,u,JE(t,f,m,v,d,x,i.paint.get("heatmap-intensity")),i.id,_.layoutVertexBuffer,_.indexBuffer,_.segments,i.paint,t.transform.zoom,g,c?[_.globeExtVertexBuffer]:null);}n.viewport.set([0,0,t.width,t.height]);}else "translucent"===t.renderPass&&(t.context.setColorMode(t.colorModeForRenderPass()),function(t,e){const i=t.context,r=i.gl,n=e.heatmapFbo;if(!n)return;i.activeTexture.set(r.TEXTURE0),r.bindTexture(r.TEXTURE_2D,n.colorAttachment.get()),i.activeTexture.set(r.TEXTURE1);let o=e.colorRampTexture;o||(o=e.colorRampTexture=new hy(i,e.colorRamp,r.RGBA)),o.bind(r.LINEAR,r.CLAMP_TO_EDGE),t.useProgram("heatmapTexture").draw(t,r.TRIANGLES,cx.disabled,ux.disabled,t.colorModeForRenderPass(),_x.disabled,((t,e,i,r)=>({u_image:0,u_color_ramp:1,u_opacity:e.paint.get("heatmap-opacity")}))(0,e),e.id,t.viewportBuffer,t.quadTriangleIndexBuffer,t.viewportSegments,e.paint,t.transform.zoom);}(t,i));},line:function(t,e,i,r){if("translucent"!==t.renderPass)return;const n=i.paint.get("line-opacity"),o=i.paint.get("line-width");if(0===n.constantOr(1)||0===o.constantOr(1))return;const s=i.paint.get("line-emissive-strength"),a=t.depthModeForSublayer(0,cx.ReadOnly),l=t.colorModeForDrapableLayerRenderPass(s),c=t.terrain&&t.terrain.renderingToTexture?1:ue.devicePixelRatio,h=i.paint.get("line-dasharray"),u=h.constantOr(1),d=i.layout.get("line-cap"),p=i.paint.get("line-pattern"),f=p.constantOr(1),m=i.paint.get("line-gradient"),_=f?"linePattern":"line",g=t.context,y=g.gl,x=(t=>{const e=[];rM(t)&&e.push("RENDER_LINE_DASH"),t.paint.get("line-gradient")&&e.push("RENDER_LINE_GRADIENT");const i=t.paint.get("line-trim-offset");0===i[0]&&0===i[1]||e.push("RENDER_LINE_TRIM_OFFSET");const r=t.paint.get("line-pattern").constantOr(1),n=1!==t.paint.get("line-opacity").constantOr(1);return !r&&n&&e.push("RENDER_LINE_ALPHA_DISCARD"),t.paint.get("line-border-width").constantOr(0)>0&&e.push("RENDER_LINE_BORDER"),0===t.paint.get("line-border-color").constantOr(li.transparent).a&&e.push("RENDER_LINE_BORDER_AUTO"),e})(i);let v=x.includes("RENDER_LINE_ALPHA_DISCARD");t.terrain&&t.terrain.clipOrMaskOverlapStencilType()&&(v=!1);for(const n of r){const r=e.getTile(n);if(f&&!r.patternsLoaded())continue;const o=r.getBucket(i);if(!o)continue;t.prepareDrawTile();const s=o.programConfigurations.get(i.id),b=t.useProgram(_,s,x),w=p.constantOr(null);if(w&&r.imageAtlas){const t=r.imageAtlas.patternPositions[w.toString()];t&&s.setConstantPatternPositions(t);}const T=h.constantOr(null),E=d.constantOr(null);if(!f&&T&&E&&r.lineAtlas){const t=r.lineAtlas.getDash(T,E);t&&s.setConstantPatternPositions(t);}let[M,A]=i.paint.get("line-trim-offset");if("round"===E||"square"===E){const t=1;M!==A&&(0===M&&(M-=t),1===A&&(A+=t));}const S=t.terrain?n.projMatrix:null,I=f?tM(t,r,i,S,c):QE(t,r,i,S,o.lineClipsArray.length,c,[M,A]);if(m){const r=o.gradients[i.id];let s=r.texture;if(i.gradientVersion!==r.version){let a=256;if(i.stepInterpolant){const i=e.getSource().maxzoom,r=n.canonical.z===i?Math.ceil(1<<t.transform.maxZoom-n.canonical.z):1;a=z(U(o.maxLineLength/sr*1024*r),256,g.maxTextureSize);}r.gradient=Gp({expression:i.gradientExpression(),evaluationKey:"lineProgress",resolution:a,image:r.gradient||void 0,clips:o.lineClipsArray}),r.texture?r.texture.update(r.gradient):r.texture=new hy(g,r.gradient,y.RGBA),r.version=i.gradientVersion,s=r.texture;}g.activeTexture.set(y.TEXTURE1),s.bind(i.stepInterpolant?y.NEAREST:y.LINEAR,y.CLAMP_TO_EDGE);}u&&(g.activeTexture.set(y.TEXTURE0),r.lineAtlasTexture.bind(y.LINEAR,y.REPEAT),s.updatePaintBuffers()),f&&(g.activeTexture.set(y.TEXTURE0),r.imageAtlasTexture.bind(y.LINEAR,y.CLAMP_TO_EDGE),s.updatePaintBuffers()),t.uploadCommonUniforms(g,b,n.toUnwrapped());const C=e=>{b.draw(t,y.TRIANGLES,a,e,l,_x.disabled,I,i.id,o.layoutVertexBuffer,o.indexBuffer,o.segments,i.paint,t.transform.zoom,s,[o.layoutVertexBuffer2]);};if(v){const e=t.stencilModeForClipping(n).ref;0===e&&t.terrain&&g.clear({stencil:0});const i={func:y.EQUAL,mask:255};I.u_alpha_discard_threshold=.8,C(new ux(i,e,255,y.KEEP,y.KEEP,y.INVERT)),I.u_alpha_discard_threshold=0,C(new ux(i,e,255,y.KEEP,y.KEEP,y.KEEP));}else C(t.stencilModeForClipping(n));}v&&(t.resetStencilClippingMasks(),t.terrain&&g.clear({stencil:0}));},fill:function(t,e,i,r){const n=i.paint.get("fill-color"),o=i.paint.get("fill-opacity");if(0===o.constantOr(1))return;const s=i.paint.get("fill-emissive-strength"),a=t.colorModeForDrapableLayerRenderPass(s),l=i.paint.get("fill-pattern"),c=t.opaquePassEnabledForLayer()&&!l.constantOr(1)&&1===n.constantOr(li.transparent).a&&1===o.constantOr(0)?"opaque":"translucent";if(t.renderPass===c){const n=t.depthModeForSublayer(1,"opaque"===t.renderPass?cx.ReadWrite:cx.ReadOnly);AM(t,e,i,r,n,a,!1);}if("translucent"===t.renderPass&&i.paint.get("fill-antialias")){const n=t.depthModeForSublayer(i.getPaintProperty("fill-outline-color")?2:0,cx.ReadOnly);AM(t,e,i,r,n,a,!0);}},"fill-extrusion":function(t,e,i,r){const n=i.paint.get("fill-extrusion-opacity"),o=t.context,s=o.gl,a=t.terrain,l=a&&a.renderingToTexture,c=i.paint.get("fill-extrusion-cutoff-fade-range");if(0===n)return;const h=t.conflationActive&&t.layerUsedInConflation(i,e.getSource());if(h&&function(t,e,i,r){for(const n of r){const r=e.getTile(n).getBucket(i);r&&(r.updateReplacement(n,t.replacementSource),r.uploadCentroid(t.context));}}(t,e,i,r),a||h)for(const n of r){const r=e.getTile(n).getBucket(i);r&&CM(t.context,e,n,r,i,a,h);}if("shadow"===t.renderPass&&t.shadowRenderer){const n=t.shadowRenderer,o=n.getShadowPassDepthMode(),s=n.getShadowPassColorMode();SM(t,e,i,r,o,ux.disabled,s,h);}else if("translucent"===t.renderPass){const u=!i.paint.get("fill-extrusion-pattern").constantOr(1);if(!l){const o=new cx(t.context.gl.LEQUAL,cx.ReadWrite,t.depthRangeFor3D);0===c&&1===n&&u?SM(t,e,i,r,o,ux.disabled,px.unblended,h):(SM(t,e,i,r,o,ux.disabled,px.disabled,h),SM(t,e,i,r,o,t.stencilModeFor3D(),t.colorModeForRenderPass(),h),t.resetStencilClippingMasks());}if(t.style.enable3dLights()&&u&&(!a&&"globe"!==t.transform.projection.name||l)){const n=i.paint.get("fill-extrusion-opacity"),c=i.paint.get("fill-extrusion-ambient-occlusion-intensity"),u=i.paint.get("fill-extrusion-ambient-occlusion-ground-radius"),d=i.paint.get("fill-extrusion-flood-light-intensity"),p=i.paint.get("fill-extrusion-flood-light-color").toArray01().slice(0,3),f=c>0&&u>0,m=d>0,_=(t,e,i)=>(1-i)*t+i*e,g=o=>{const a=t.depthModeForSublayer(1,cx.ReadOnly,s.LEQUAL,!0),l=i.paint.get(o?"fill-extrusion-ambient-occlusion-ground-attenuation":"fill-extrusion-flood-light-ground-attenuation"),f=_(.1,3,l),m=t._showOverdrawInspector;if(!m){const l=new ux({func:s.ALWAYS,mask:255},255,255,s.KEEP,s.KEEP,s.REPLACE),m=new px([s.ONE,s.ONE,s.ONE,s.ONE],li.transparent,[!1,!1,!1,!0],s.MIN);IM(t,e,i,r,a,l,m,_x.disabled,o,"sdf",n,c,u,d,p,f,h,!1);}{const l=m?ux.disabled:new ux({func:s.EQUAL,mask:255},255,255,s.KEEP,s.DECR,s.DECR),_=m?t.colorModeForRenderPass():new px([s.ONE_MINUS_DST_ALPHA,s.DST_ALPHA,s.ONE,s.ONE],li.transparent,[!0,!0,!0,!0]);IM(t,e,i,r,a,l,_,_x.disabled,o,"color",n,c,u,d,p,f,h,!1);}};if(l){const l=(o,a,l)=>{const f=t.depthModeForSublayer(1,cx.ReadOnly,s.LEQUAL,!1),m=i.paint.get(o?"fill-extrusion-ambient-occlusion-ground-attenuation":"fill-extrusion-flood-light-ground-attenuation"),g=_(.1,3,m);{const l=new px([s.ONE,s.ONE,s.ONE,s.ONE],li.transparent,[!1,!1,!1,!0]);IM(t,e,i,r,f,ux.disabled,l,_x.disabled,o,"clear",n,c,u,d,p,g,h,a);}{const l=new ux({func:s.ALWAYS,mask:255},255,255,s.KEEP,s.KEEP,s.REPLACE),m=new px([s.ONE,s.ONE,s.ONE,s.ONE],li.transparent,[!1,!1,!1,!0],s.MIN);IM(t,e,i,r,f,l,m,_x.disabled,o,"sdf",n,c,u,d,p,g,h,a);}{const l=o?s.ZERO:s.ONE_MINUS_DST_ALPHA,m=new ux({func:s.EQUAL,mask:255},255,255,s.KEEP,s.DECR,s.DECR),_=new px([l,s.DST_ALPHA,s.ONE_MINUS_DST_ALPHA,s.ZERO],li.transparent,[!0,!0,!0,!0]);IM(t,e,i,r,f,m,_,_x.disabled,o,"color",n,c,u,d,p,g,h,a);}{const m=new px([s.ONE,s.ONE,s.ONE,o?s.ZERO:s.ONE],li.transparent,[!1,!1,!1,!0],o?s.FUNC_ADD:s.MAX);IM(t,e,i,r,f,ux.disabled,m,_x.disabled,o,"clear",n,c,u,d,p,g,h,a,l);}};if(f||m){let e;if(t.prepareDrawTile(),a){const t=a.drapeBufferSize[0],i=a.drapeBufferSize[1];e=a.framebufferCopyTexture,e&&(!e||e.size[0]===t&&e.size[1]===i)||(e&&e.destroy(),e=a.framebufferCopyTexture=new hy(o,new Np({width:t,height:i}),s.RGBA)),e.bind(s.LINEAR,s.CLAMP_TO_EDGE),s.copyTexImage2D(s.TEXTURE_2D,0,s.RGBA,0,0,t,i,0);}f&&l(!0,!1,e),m&&l(!1,!0,e);}}else f&&g(!0),m&&g(!1);}}},hillshade:function(t,e,i,r){if("offscreen"!==t.renderPass&&"translucent"!==t.renderPass)return;const n=t.context,o=t.depthModeForSublayer(0,cx.ReadOnly),s=t.colorModeForDrapableLayerRenderPass(0),a=t.terrain&&t.terrain.renderingToTexture,[l,c]="translucent"!==t.renderPass||a?[{},r]:t.stencilConfigForOverlap(r);for(const r of c){const n=e.getTile(r);if(n.needsHillshadePrepare&&"offscreen"===t.renderPass)gE(t,n,i,o,ux.disabled,s);else if("translucent"===t.renderPass){const e=a&&t.terrain?t.terrain.stencilModeForRTTOverlap(r):l[r.overscaledZ];mE(t,r,n,i,o,e,s);}}n.viewport.set([0,0,t.width,t.height]),t.resetStencilClippingMasks();},raster:function(t,e,i,r,n,o){if("translucent"!==t.renderPass)return;if(0===i.paint.get("raster-opacity"))return;if(!r.length)return;const s=t.context,a=s.gl,l=e.getSource(),c=function(t,e,i){const r=[];let n,o;if(t.paint.get("raster-color")){r.push("RASTER_COLOR"),n=t.paint.get("raster-color-mix"),o=t.paint.get("raster-color-range"),e.activeTexture.set(i.TEXTURE2);let s=t.colorRampTexture;s||(s=t.colorRampTexture=new hy(e,t.colorRamp,i.RGBA)),s.bind(i.LINEAR,i.CLAMP_TO_EDGE);}return {mix:n,range:o,defines:r}}(i,s,a),h=t.useProgram("raster",null,c.defines),u=t.colorModeForDrapableLayerRenderPass(),d=t.terrain&&t.terrain.renderingToTexture,[p,f]=l instanceof dw||d?[{},r]:t.stencilConfigForOverlap(r),m=f[f.length-1].overscaledZ,_=!t.options.moving;for(const r of f){const n=d?cx.disabled:t.depthModeForSublayer(r.overscaledZ-m,1===i.paint.get("raster-opacity")?cx.ReadWrite:cx.ReadOnly,a.LESS),f=r.toUnwrapped(),g=e.getTile(r);if(d&&(!g||!g.hasData()))continue;const y=d?r.projMatrix:t.transform.calculateProjMatrix(f,_),x=t.terrain&&d?t.terrain.stencilModeForRTTOverlap(r):p[r.overscaledZ],v=o?0:i.paint.get("raster-fade-duration");g.registerFadeDuration(v);const b=e.findLoadedParent(r,0),w=IE(g,b,e,t.transform,v);let T,E;t.terrain&&t.terrain.prepareDrawTile();const M="nearest"===i.paint.get("raster-resampling")?a.NEAREST:a.LINEAR;s.activeTexture.set(a.TEXTURE0),g.texture.bind(M,a.CLAMP_TO_EDGE),s.activeTexture.set(a.TEXTURE1),b?(b.texture.bind(M,a.CLAMP_TO_EDGE),T=Math.pow(2,b.tileID.overscaledZ-g.tileID.overscaledZ),E=[g.tileID.canonical.x*T%1,g.tileID.canonical.y*T%1]):g.texture.bind(M,a.CLAMP_TO_EDGE),g.texture.useMipmap&&s.extTextureFilterAnisotropic&&t.transform.pitch>20&&a.texParameterf(a.TEXTURE_2D,s.extTextureFilterAnisotropic.TEXTURE_MAX_ANISOTROPY_EXT,s.extTextureFilterAnisotropicMax);const A=nM(y,E||[0,0],T||1,w,i,l instanceof dw?l.perspectiveTransform:[0,0],2,c.mix||[0,0,0,0],c.range||[0,0]);if(t.uploadCommonUniforms(s,h,f),l instanceof dw)l.boundsBuffer&&l.boundsSegments&&h.draw(t,a.TRIANGLES,n,ux.disabled,u,_x.disabled,A,i.id,l.boundsBuffer,t.quadTriangleIndexBuffer,l.boundsSegments);else {const{tileBoundsBuffer:e,tileBoundsIndexBuffer:r,tileBoundsSegments:o}=t.getTileBoundsBuffers(g);h.draw(t,a.TRIANGLES,n,x,u,_x.disabled,A,i.id,e,r,o);}}t.resetStencilClippingMasks();},background:function(t,e,i,r){const n=i.paint.get("background-color"),o=i.paint.get("background-opacity"),s=i.paint.get("background-emissive-strength");if(0===o)return;const a=t.context,l=a.gl,c=t.transform,h=c.tileSize,u=i.paint.get("background-pattern");if(t.isPatternMissing(u,i.scope))return;const d=!u&&1===n.a&&1===o&&t.opaquePassEnabledForLayer()?"opaque":"translucent";if(t.renderPass!==d)return;const p=ux.disabled,f=t.depthModeForSublayer(0,"opaque"===d?cx.ReadWrite:cx.ReadOnly),m=t.colorModeForDrapableLayerRenderPass(s),_=t.useProgram(u?"backgroundPattern":"background");let g,y=r;y||(g=t.getBackgroundTiles(),y=Object.values(g).map((t=>t.tileID))),u&&(a.activeTexture.set(l.TEXTURE0),t.imageManager.bind(t.context,i.scope));for(const d of y){const y=d.toUnwrapped(),x=r?d.projMatrix:t.transform.calculateProjMatrix(y);t.prepareDrawTile();const v=e?e.getTile(d):g?g[d.key]:new vy(d,h,c.zoom,t),b=u?dM(x,s,o,t,u,i.scope,{tileID:d,tileSize:h}):uM(x,s,o,n);t.uploadCommonUniforms(a,_,y);const{tileBoundsBuffer:w,tileBoundsIndexBuffer:T,tileBoundsSegments:E}=t.getTileBoundsBuffers(v);_.draw(t,l.TRIANGLES,f,p,m,_x.disabled,b,i.id,w,T,E);}},sky:function(t,e,i){const r=t._atmosphere?pd(t.transform.zoom):1,n=i.paint.get("sky-opacity")*r;if(0===n)return;const o=t.context,s=i.paint.get("sky-type"),a=new cx(o.gl.LEQUAL,cx.ReadOnly,[0,1]),l=t.frameCounter/1e3%1;"atmosphere"===s?"offscreen"===t.renderPass?i.needsSkyboxCapture(t)&&(function(t,e,i,r){const n=t.context,o=n.gl;let s=e.skyboxFbo;if(!s){s=e.skyboxFbo=n.createFramebuffer(32,32,!0,null),e.skyboxGeometry=new $M(n),e.skyboxTexture=n.gl.createTexture(),o.bindTexture(o.TEXTURE_CUBE_MAP,e.skyboxTexture),o.texParameteri(o.TEXTURE_CUBE_MAP,o.TEXTURE_WRAP_S,o.CLAMP_TO_EDGE),o.texParameteri(o.TEXTURE_CUBE_MAP,o.TEXTURE_WRAP_T,o.CLAMP_TO_EDGE),o.texParameteri(o.TEXTURE_CUBE_MAP,o.TEXTURE_MIN_FILTER,o.LINEAR),o.texParameteri(o.TEXTURE_CUBE_MAP,o.TEXTURE_MAG_FILTER,o.LINEAR);for(let t=0;t<6;++t)o.texImage2D(o.TEXTURE_CUBE_MAP_POSITIVE_X+t,0,o.RGBA,32,32,0,o.RGBA,o.UNSIGNED_BYTE,null);}n.bindFramebuffer.set(s.framebuffer),n.viewport.set([0,0,32,32]);const a=e.getCenter(t,!0),l=t.useProgram("skyboxCapture"),c=new Float64Array(16);mu.identity(c),mu.rotateY(c,c,.5*-Math.PI),HM(t,e,l,c,a,0),mu.identity(c),mu.rotateY(c,c,.5*Math.PI),HM(t,e,l,c,a,1),mu.identity(c),mu.rotateX(c,c,.5*-Math.PI),HM(t,e,l,c,a,2),mu.identity(c),mu.rotateX(c,c,.5*Math.PI),HM(t,e,l,c,a,3),mu.identity(c),HM(t,e,l,c,a,4),mu.identity(c),mu.rotateY(c,c,Math.PI),HM(t,e,l,c,a,5),n.viewport.set([0,0,t.width,t.height]);}(t,i),i.markSkyboxValid(t)):"sky"===t.renderPass&&function(t,e,i,r,n){const o=t.context,s=o.gl,a=t.transform,l=t.useProgram("skybox");o.activeTexture.set(s.TEXTURE0),s.bindTexture(s.TEXTURE_CUBE_MAP,e.skyboxTexture);const c=((t,e,i,r,n)=>({u_matrix:t,u_sun_direction:e,u_cubemap:0,u_opacity:r,u_temporal_offset:n}))(a.skyboxMatrix,e.getCenter(t,!1),0,r,n);t.uploadCommonUniforms(o,l),l.draw(t,s.TRIANGLES,i,ux.disabled,t.colorModeForRenderPass(),_x.backCW,c,"skybox",e.skyboxGeometry.vertexBuffer,e.skyboxGeometry.indexBuffer,e.skyboxGeometry.segment);}(t,i,a,n,l):"gradient"===s&&"sky"===t.renderPass&&function(t,e,i,r,n){const o=t.context,s=o.gl,a=t.transform,l=t.useProgram("skyboxGradient");e.skyboxGeometry||(e.skyboxGeometry=new $M(o)),o.activeTexture.set(s.TEXTURE0);let c=e.colorRampTexture;c||(c=e.colorRampTexture=new hy(o,e.colorRamp,s.RGBA)),c.bind(s.LINEAR,s.CLAMP_TO_EDGE);const h=((t,e,i,r,n)=>({u_matrix:t,u_color_ramp:0,u_center_direction:e,u_radius:w(i),u_opacity:r,u_temporal_offset:n}))(a.skyboxMatrix,e.getCenter(t,!1),e.paint.get("sky-gradient-radius"),r,n);t.uploadCommonUniforms(o,l),l.draw(t,s.TRIANGLES,i,ux.disabled,t.colorModeForRenderPass(),_x.backCW,h,"skyboxGradient",e.skyboxGeometry.vertexBuffer,e.skyboxGeometry.indexBuffer,e.skyboxGeometry.segment);}(t,i,a,n,l);},debug:function(t,e,i){for(let r=0;r<i.length;r++)NM(t,e,i[r]);},custom:function(t,e,i,r){const n=t.context,o=i.implementation;if(!t.transform.projection.unsupportedLayers||!t.transform.projection.unsupportedLayers.includes("custom")||t.terrain&&(t.terrain.renderingToTexture||"offscreen"===t.renderPass)&&i.isLayerDraped()){if("offscreen"===t.renderPass){const e=o.prerender;if(e){if(t.setCustomLayerDefaults(),n.setColorMode(t.colorModeForRenderPass()),"globe"===t.transform.projection.name){const i=t.transform.pointMerc;e.call(o,n.gl,t.transform.customLayerMatrix(),t.transform.getProjection(),t.transform.globeToMercatorMatrix(),pd(t.transform.zoom),[i.x,i.y],t.transform.pixelsPerMeterRatio);}else e.call(o,n.gl,t.transform.customLayerMatrix());n.setDirty(),t.setBaseState();}}else if("translucent"===t.renderPass){if(t.terrain&&t.terrain.renderingToTexture){const e=o.renderToTile;if(e){const i=r[0].canonical,s=new Yd(i.x+r[0].wrap*(1<<i.z),i.y,i.z);n.setDepthMode(cx.disabled),n.setStencilMode(ux.disabled),n.setColorMode(t.colorModeForRenderPass()),t.setCustomLayerDefaults(),e.call(o,n.gl,s),n.setDirty(),t.setBaseState();}return}t.setCustomLayerDefaults(),n.setColorMode(t.colorModeForRenderPass()),n.setStencilMode(ux.disabled);const e="3d"===o.renderingMode?new cx(t.context.gl.LEQUAL,cx.ReadWrite,t.depthRangeFor3D):t.depthModeForSublayer(0,cx.ReadOnly);if(n.setDepthMode(e),"globe"===t.transform.projection.name){const e=t.transform.pointMerc;o.render(n.gl,t.transform.customLayerMatrix(),t.transform.getProjection(),t.transform.globeToMercatorMatrix(),pd(t.transform.zoom),[e.x,e.y],t.transform.pixelsPerMeterRatio);}else o.render(n.gl,t.transform.customLayerMatrix());n.setDirty(),t.setBaseState(),n.bindFramebuffer.set(null);}}else W("Custom layers are not yet supported with this projection. Use mercator or globe to enable usage of custom layers.");},model:function(t,e,i,r){if("opaque"===t.renderPass)return;const n=i.paint.get("model-opacity");if(0===n)return;const o=i.paint.get("model-cast-shadows");if("shadow"===t.renderPass&&!o)return;const s=t.shadowRenderer,a=i.paint.get("model-receive-shadows");s&&(s.useNormalOffset=!0,a||(s.enabled=!1));const l=()=>{s&&(s.useNormalOffset=!0,a||(s.enabled=!0));},c=e.getSource();if("light-beam"===t.renderPass&&"batched-model"!==c.type)return;if(!c.loaded())return;if("vector"===c.type||"geojson"===c.type)return function(t,e,i,r){const n=t.transform;if("mercator"!==n.projection.name)return void W(`Drawing 3D models for ${n.projection.name} projection is not yet implemented`);const o=n.getFreeCameraOptions().position,s=[o.x,o.y,o.z-n.pixelsPerMeter/n.worldSize*n._centerAltitude],a=t.transform._camera.forward(),l=[0,0,0],c=[0,0,0];if(!t.modelManager)return;const h=t.modelManager;if(!i._unevaluatedLayout._values.hasOwnProperty("model-id"))return;const u=i._unevaluatedLayout._values["model-id"],d={...i.layout.get("model-id").parameters};for(const o of r){const r=e.getTile(o).getBucket(i);if(!r||r.projection.name!==n.projection.name)continue;let p=r.zoom;c[0]=o.wrap+(o.canonical.x+(t.transform.bearing<0?.75:.25))/(1<<o.canonical.z),c[1]=(o.canonical.y+(Math.abs(t.transform.bearing)<90?.75:.25))/(1<<o.canonical.z),bu.sub(l,c,s);const f=Math.max(0,bu.dot(l,a));p=t.transform._zoomFromMercatorZ(f),t.transform.pitch>30&&p<t.transform.zoom&&r.instanceCount>400&&(p-=.5),d.zoom=p;const m=u.possiblyEvaluate(d);if(rA(t,r,o),nA.shadowUniformsInitialized=!1,"shadow"===t.renderPass&&t.shadowRenderer){const e=t.shadowRenderer;if(1===t.currentShadowCascade&&r.isInsideFirstShadowMapFrustum)continue;const s=n.calculatePosMatrix(o.toUnwrapped(),n.worldSize);if(nA.tileMatrix.set(s),nA.shadowTileMatrix=Float32Array.from(e.calculateShadowPassMatrixFromMatrix(s)),nA.aabb.min.fill(0),nA.aabb.max[0]=nA.aabb.max[1]=sr,nA.aabb.max[2]=0,aA(r,nA,t,i.scope))continue}let _=bu.scale([],s,1<<o.canonical.z);_=[(_[0]-o.canonical.x-o.wrap*(1<<o.canonical.z))*sr,(_[1]-o.canonical.y)*sr,_[2]*sr];for(let e in r.instancesPerModel){const n=r.instancesPerModel[e];n.features.length>0&&(e=m.evaluate(n.features[0].feature,{}));const s=h.getModel(e,i.scope);if(s)for(const e of s.nodes)oA(t,i,e,n,_,o,nA);}}}(t,e,i,r),void l();if("batched-model"===c.type)return function(t,e,i,r){const n=t.context,o=t.transform;if("mercator"!==o.projection.name)return void W(`Drawing 3D landmark models for ${o.projection.name} projection is not yet implemented`);const s=t.transform.getFreeCameraOptions().position,a=bu.scale([],[s.x,s.y,s.z],t.transform.worldSize);bu.negate(a,a);const l=mu.identity([]),c=Hd(o.center.lat,o.zoom),h=mu.fromScaling([],[1,1,1/c]);mu.translate(l,l,a);const u=i.paint.get("model-opacity"),d=new cx(n.gl.LEQUAL,cx.ReadWrite,t.depthRangeFor3D),p=new cx(n.gl.LEQUAL,cx.ReadOnly,t.depthRangeFor3D),f=function(s,a){for(const c of r){const r=e.getTile(c).getBucket(i);if(!r||!r.uploaded)continue;const f=o.calculatePosMatrix(c.toUnwrapped(),o.worldSize),m=r.modelTraits;for(const e of r.getNodesInfo()){if(e.hiddenByReplacement)continue;if(!e.node.meshes)continue;const r=e.node,_="light-beam"===t.renderPass,g=[...f],y=e.evaluatedScale;let x=0;t.terrain&&r.elevation&&(x=r.elevation*t.terrain.exaggeration()),mu.translate(g,g,[(r.anchor?r.anchor[0]:0)*(y[0]-1),(r.anchor?r.anchor[1]:0)*(y[1]-1),x]),y!==pv&&mu.scale(g,g,y),mu.multiply(g,g,r.matrix);const v=mu.multiply([],h,g);mu.multiply(v,l,v);const b=mu.invert([],v);mu.transpose(b,b),mu.scale(b,b,sA);const w=mu.multiply([],o.projMatrix,g);for(let o=0;o<r.meshes.length;++o){const l=r.meshes[o],h=o===r.lightMeshIndex;if(h){if(!_&&!t.terrain&&t.shadowRenderer){t.currentLayer<t.firstLightBeamLayer&&(t.firstLightBeamLayer=t.currentLayer);continue}}else if(_)continue;const f=[],y=[];QM(f,y,l,t),4&m||f.push("DIFFUSE_SHADED");const x="shadow"===t.renderPass;if(x){iA(l,g,t,i);continue}let T=null;if(t.style.fog){const e=JM(g,t.transform);f.push("FOG","FOG_DITHERING"),T=new Float32Array(e);}const E=t.useProgram("model",null,f),M=t.shadowRenderer;!x&&M&&(M.useNormalOffset=!!l.normalBuffer,M.setupShadowsFromMatrix(g,E,M.useNormalOffset)),t.uploadCommonUniforms(n,E,c.toUnwrapped(),T);const A=l.material,S=A.pbrMetallicRoughness;S.metallicFactor=.9,S.roughnessFactor=.5;const I=fM(new Float32Array(w),new Float32Array(v),new Float32Array(b),t,u,S.baseColorFactor,A.emissiveFactor,S.metallicFactor,S.roughnessFactor,A,i);E.draw(t,n.gl.TRIANGLES,a&&!h?d:p,ux.disabled,s?h||u<1||e.hasTranslucentParts?px.alphaBlended:px.unblended:px.disabled,_x.backCCW,I,i.id,l.vertexBuffer,l.indexBuffer,l.segments,i.paint,t.transform.zoom,void 0,y);}}}};((function(t,e,i,r){const n=t.terrain?t.terrain.exaggeration():0,o=t.transform.zoom;for(const s of r){const r=e.getTile(s).getBucket(i);r&&(t.conflationActive&&r.updateReplacement(s,t.replacementSource),r.evaluateScale(t,i),t.terrain&&n>0&&r.elevationUpdate(t.terrain,n,s),r.needsReEvaluation(t,o,i)&&r.evaluate(i));}}))(t,e,i,r),1===u?f(!0,!0):(f(!1,!0),f(!0,!1));}(t,e,i,r),void l();const h=c.getModels(),u=[],d=t.transform.getFreeCameraOptions().position,p=bu.scale([],[d.x,d.y,d.z],t.transform.worldSize);bu.negate(p,p);const f=[],m=[];let _=0;for(const e of h){const r=i.paint.get("model-rotation").constantOr(null),n=i.paint.get("model-scale").constantOr(null),o=i.paint.get("model-translation").constantOr(null);e.computeModelMatrix(t,r,n,o,!0,!0,!1);const s=mu.identity([]),a=Hd(e.position.lat,t.transform.zoom),l=mu.fromScaling([],[1,1,1/a]);mu.translate(s,s,p),u.push({zScaleMatrix:l,negCameraPosMatrix:s});for(const i of e.nodes)eA(t.transform,i,e.matrix,t.transform.projMatrix,_,f,m);_++;}if(f.sort(((t,e)=>e.depth-t.depth)),"shadow"!==t.renderPass){if(1===n)for(const e of m)tA(e,t,i,u[e.modelIndex],ux.disabled,t.colorModeForRenderPass());else {for(const e of m)tA(e,t,i,u[e.modelIndex],ux.disabled,px.disabled);for(const e of m)tA(e,t,i,u[e.modelIndex],t.stencilModeFor3D(),t.colorModeForRenderPass());t.resetStencilClippingMasks();}for(const e of f)tA(e,t,i,u[e.modelIndex],ux.disabled,t.colorModeForRenderPass());l();}else {for(const e of m)iA(e.mesh,e.nodeModelMatrix,t,i);for(const e of f)iA(e.mesh,e.nodeModelMatrix,t,i);l();}}},uA={modelUpload:function(t,e,i){const r=e.getSource();if(!r.loaded())return;if("vector"===r.type||"geojson"===r.type)return void(t.modelManager&&t.modelManager.upload(t,i));if("batched-model"===r.type)return;const n=r.getModels();for(const e of n)e.upload(t.context);}};class dA{constructor(t,e){this.context=new gx(t),this.transform=e,this._tileTextures={},this.frameCopies=[],this.loadTimeStamps=[],this.setup(),this.numSublayers=yx.maxUnderzooming+yx.maxOverzooming+1,this.depthEpsilon=1/Math.pow(2,16),this.deferredRenderGpuTimeQueries=[],this.gpuTimers={},this.frameCounter=0,this._backgroundTiles={},this.conflationActive=!1,this.replacementSource=new Pv,this.longestCutoffRange=0,this.minCutoffZoom=0,this._shadowRenderer=new fA(this),this._wireframeDebugCache=new cA;}updateTerrain(t,e){const i=!!t&&!!t.terrain&&this.transform.projection.supportsTerrain;if(!(i||this._terrain&&this._terrain.enabled))return;this._terrain||(this._terrain=new PE(this,t));const r=this._terrain;this.transform.elevation=i?r:null,r.update(t,this.transform,e);}_updateFog(t){const e=t.fog;if(!e||"globe"===this.transform.projection.name||e.getOpacity(this.transform.pitch)<1||e.properties.get("horizon-blend")<.03)return void(this.transform.fogCullDistSq=null);const[i,r]=e.getFovAdjustedRange(this.transform._fov);if(i>r)return void(this.transform.fogCullDistSq=null);const n=i+.78*(r-i);this.transform.fogCullDistSq=n*n;}get terrain(){return this.transform._terrainEnabled()&&this._terrain&&this._terrain.enabled?this._terrain:null}get shadowRenderer(){return this._shadowRenderer&&this._shadowRenderer.enabled?this._shadowRenderer:null}get wireframeDebugCache(){return this._wireframeDebugCache}resize(t,e){if(this.width=t*ue.devicePixelRatio,this.height=e*ue.devicePixelRatio,this.context.viewport.set([0,0,this.width,this.height]),this.style)for(const t of this.style.order)this.style._layers[t].resize();}setup(){const t=this.context,i=new ya;i.emplaceBack(0,0),i.emplaceBack(sr,0),i.emplaceBack(0,sr),i.emplaceBack(sr,sr),this.tileExtentBuffer=t.createVertexBuffer(i,Iu.members),this.tileExtentSegments=Wl.simpleSegment(0,0,4,2);const r=new ya;r.emplaceBack(0,0),r.emplaceBack(sr,0),r.emplaceBack(0,sr),r.emplaceBack(sr,sr),this.debugBuffer=t.createVertexBuffer(r,Iu.members),this.debugSegments=Wl.simpleSegment(0,0,4,5);const n=new ya;n.emplaceBack(-1,-1),n.emplaceBack(1,-1),n.emplaceBack(-1,1),n.emplaceBack(1,1),this.viewportBuffer=t.createVertexBuffer(n,Iu.members),this.viewportSegments=Wl.simpleSegment(0,0,4,2);const o=new va;o.emplaceBack(0,0,0,0),o.emplaceBack(sr,0,sr,0),o.emplaceBack(0,sr,0,sr),o.emplaceBack(sr,sr,sr,sr),this.mercatorBoundsBuffer=t.createVertexBuffer(o,yy.members),this.mercatorBoundsSegments=Wl.simpleSegment(0,0,4,2);const s=new Ba;s.emplaceBack(0,1,2),s.emplaceBack(2,1,3),this.quadTriangleIndexBuffer=t.createIndexBuffer(s);const a=new Ga;for(const t of [0,1,3,2,0])a.emplaceBack(t);this.debugIndexBuffer=t.createIndexBuffer(a),this.emptyTexture=new hy(t,new Np({width:1,height:1},Uint8Array.of(0,0,0,0)),t.gl.RGBA),this.identityMat=mu.create();const l=this.context.gl;this.stencilClearMode=new ux({func:l.ALWAYS,mask:0},0,255,l.ZERO,l.ZERO,l.ZERO),this.loadTimeStamps.push(e.performance.now());}getMercatorTileBoundsBuffers(){return {tileBoundsBuffer:this.mercatorBoundsBuffer,tileBoundsIndexBuffer:this.quadTriangleIndexBuffer,tileBoundsSegments:this.mercatorBoundsSegments}}getTileBoundsBuffers(t){return t._makeTileBoundsBuffers(this.context,this.transform.projection),t._tileBoundsBuffer?{tileBoundsBuffer:t._tileBoundsBuffer,tileBoundsIndexBuffer:t._tileBoundsIndexBuffer,tileBoundsSegments:t._tileBoundsSegments}:this.getMercatorTileBoundsBuffers()}clearStencil(){const t=this.context.gl;this.nextStencilID=1,this.currentStencilSource=void 0,this._tileClippingMaskIDs={},this.useProgram("clippingMask").draw(this,t.TRIANGLES,cx.disabled,this.stencilClearMode,px.disabled,_x.disabled,SE(this.identityMat),"$clipping",this.viewportBuffer,this.quadTriangleIndexBuffer,this.viewportSegments);}resetStencilClippingMasks(){this.terrain||(this.currentStencilSource=void 0,this._tileClippingMaskIDs={});}_renderTileClippingMasks(t,e,i){if(!e||this.currentStencilSource===e.id||!t.isTileClipped()||!i||0===i.length)return;if(this._tileClippingMaskIDs&&!this.terrain){let t=!1;for(const e of i)if(void 0===this._tileClippingMaskIDs[e.key]){t=!0;break}if(!t)return}this.currentStencilSource=e.id;const r=this.context,n=r.gl;this.nextStencilID+i.length>256&&this.clearStencil(),r.setColorMode(px.disabled),r.setDepthMode(cx.disabled);const o=this.useProgram("clippingMask");this._tileClippingMaskIDs={};for(const t of i){const i=e.getTile(t),r=this._tileClippingMaskIDs[t.key]=this.nextStencilID++,{tileBoundsBuffer:s,tileBoundsIndexBuffer:a,tileBoundsSegments:l}=this.getTileBoundsBuffers(i);o.draw(this,n.TRIANGLES,cx.disabled,new ux({func:n.ALWAYS,mask:0},r,255,n.KEEP,n.KEEP,n.REPLACE),px.disabled,_x.disabled,SE(t.projMatrix),"$clipping",s,a,l);}}stencilModeFor3D(){this.currentStencilSource=void 0,this.nextStencilID+1>256&&this.clearStencil();const t=this.nextStencilID++,e=this.context.gl;return new ux({func:e.NOTEQUAL,mask:255},t,255,e.KEEP,e.KEEP,e.REPLACE)}stencilModeForClipping(t){if(this.terrain)return this.terrain.stencilModeForRTTOverlap(t);const e=this.context.gl;return new ux({func:e.EQUAL,mask:255},this._tileClippingMaskIDs[t.key],0,e.KEEP,e.KEEP,e.REPLACE)}stencilConfigForOverlap(t){const e=this.context.gl,i=t.sort(((t,e)=>e.overscaledZ-t.overscaledZ)),r=i[i.length-1].overscaledZ,n=i[0].overscaledZ-r+1;if(n>1){this.currentStencilSource=void 0,this.nextStencilID+n>256&&this.clearStencil();const t={};for(let i=0;i<n;i++)t[i+r]=new ux({func:e.GEQUAL,mask:255},i+this.nextStencilID,255,e.KEEP,e.KEEP,e.REPLACE);return this.nextStencilID+=n,[t,i]}return [{[r]:ux.disabled},i]}colorModeForRenderPass(){const t=this.context.gl;if(this._showOverdrawInspector){const e=1/8;return new px([t.CONSTANT_COLOR,t.ONE,t.CONSTANT_COLOR,t.ONE],new li(e,e,e,0),[!0,!0,!0,!0])}return "opaque"===this.renderPass?px.unblended:px.alphaBlended}colorModeForDrapableLayerRenderPass(t){const e=this.context.gl;return (()=>this.style&&this.style.enable3dLights()&&this.terrain&&this.terrain.renderingToTexture)()&&"translucent"===this.renderPass?new px([e.ONE,e.ONE_MINUS_SRC_ALPHA,e.CONSTANT_ALPHA,e.ONE_MINUS_SRC_ALPHA],new li(0,0,0,void 0===t?0:t),[!0,!0,!0,!0]):this.colorModeForRenderPass()}depthModeForSublayer(t,e,i,r=!1){if(!this.opaquePassEnabledForLayer()&&!r)return cx.disabled;const n=1-((1+this.currentLayer)*this.numSublayers+t)*this.depthEpsilon;return new cx(i||this.context.gl.LEQUAL,e,[n,n])}opaquePassEnabledForLayer(){return this.currentLayer<this.opaquePassCutoff}render(t,i){this._wireframeDebugCache.update(this.frameCounter),this.style=t,this.options=i;const r=this.style._layers,n=this.style.order,o=n.map((t=>r[t])),s=this.style._sourceCaches;this.imageManager=t.imageManager,this.modelManager=t.modelManager,this.symbolFadeChange=t.placement.symbolFadeChange(ue.now()),this.imageManager.beginFrame();let a=0,l=!1;for(const t in s){const e=s[t];e.used&&(e.prepare(this.context),e.getSource().usedInConflation&&++a);}const c={},h={},u={},d={};for(const t in s){const e=s[t];c[t]=e.getVisibleCoordinates(),h[t]=c[t].slice().reverse(),u[t]=e.getVisibleCoordinates(!0).reverse(),d[t]=e.getShadowCasterCoordinates();}const p=t=>{const e=this.style._getLayerSourceCache(t);return e&&e.used?e.getSource():null};if(a){const t=[];for(const e of o)this.layerUsedInConflation(e,p(e))&&t.push(e);if(t&&t.length>1){const e=[];for(const i of t){const t=this.style._getLayerSourceCache(i);t&&t.used&&t.getSource().usedInConflation&&e.push({layer:i.id,cache:t});}this.replacementSource.setSources(e),l=!0;}}l||this.replacementSource.clear(),this.conflationActive=l,this.minCutoffZoom=0,this.longestCutoffRange=0;for(const t of o){const e=t.cutoffRange();if(this.longestCutoffRange=Math.max(e,this.longestCutoffRange),e>0){const e=p(t);e&&(this.minCutoffZoom=Math.max(e.minzoom,this.minCutoffZoom)),t.minzoom&&(this.minCutoffZoom=Math.max(t.minzoom,this.minCutoffZoom));}}this.opaquePassCutoff=1/0;for(let t=0;t<o.length;t++)if(o[t].is3D()){this.opaquePassCutoff=t;break}this.terrain&&(this.terrain.updateTileBinding(u),this.opaquePassCutoff=0),this._shadowRenderer&&this._shadowRenderer.updateShadowParameters(this.transform,this.style.directionalLight),"globe"!==this.transform.projection.name||this.globeSharedBuffers||(this.globeSharedBuffers=new Ed(this.context));for(const e of o){if(e.isHidden(this.transform.zoom))continue;const i=t._getLayerSourceCache(e);this.uploadLayer(this,e,i);}if(this.style.fog&&this.transform.projection.supportsFog?(this._atmosphere||(this._atmosphere=new KM),this._atmosphere.update(this)):this._atmosphere&&(this._atmosphere.destroy(),this._atmosphere=void 0),!Kt.has(this.context.gl))return;this.renderPass="offscreen";for(const e of o){const i=t._getLayerSourceCache(e);if(!e.hasOffscreenPass()||e.isHidden(this.transform.zoom))continue;const r=i?h[i.id]:void 0;("custom"===e.type||e.isSky()||r&&r.length)&&this.renderLayer(this,i,e,r);}this.depthRangeFor3D=[0,1-(o.length+2)*this.numSublayers*this.depthEpsilon];const f=this.terrain;f&&(this.style.hasSymbolLayers()||this.style.hasCircleLayers())&&f.drawDepth(),this._shadowRenderer&&(this.renderPass="shadow",this._shadowRenderer.drawShadowPass(this.style,d)),this.context.bindFramebuffer.set(null),this.context.viewport.set([0,0,this.width,this.height]);const m=(()=>{if(i.showOverdrawInspector)return li.black;if(this.style.fog&&this.transform.projection.supportsFog){const t=this.style.fog.properties.get("space-color").toArray01();return new li(...t)}return li.transparent})();if(this.context.clear({color:m,depth:1}),this.clearStencil(),this._showOverdrawInspector=i.showOverdrawInspector,this.renderPass="opaque",this.style.fog&&this.transform.projection.supportsFog&&this._atmosphere&&!this._showOverdrawInspector&&this._atmosphere.drawStars(this,this.style.fog),!this.terrain)for(this.currentLayer=n.length-1;this.currentLayer>=0;this.currentLayer--){const e=o[this.currentLayer],i=t._getLayerSourceCache(e);if(e.isSky())continue;const r=i?h[i.id]:void 0;this._renderTileClippingMasks(e,i,r),this.renderLayer(this,i,e,r);}if(this.style.fog&&this.transform.projection.supportsFog&&this._atmosphere&&!this._showOverdrawInspector&&this._atmosphere.drawAtmosphereGlow(this,this.style.fog),this.renderPass="sky",(!this._atmosphere||pd(this.transform.zoom)>0)&&("globe"===this.transform.projection.name||this.transform.isHorizonVisible()))for(this.currentLayer=0;this.currentLayer<n.length;this.currentLayer++){const e=o[this.currentLayer],i=t._getLayerSourceCache(e);e.isSky()&&this.renderLayer(this,i,e,i?h[i.id]:void 0);}this.renderPass="translucent",this.currentLayer=0,this.firstLightBeamLayer=Number.MAX_SAFE_INTEGER;let _=0;const g=this.shadowRenderer;for(g&&(_=g.getShadowCastingLayerCount());this.currentLayer<n.length;){const e=o[this.currentLayer],i=t._getLayerSourceCache(e);if(e.isSky()){++this.currentLayer;continue}if(f&&this.style.isLayerDraped(e)){if(e.isHidden(this.transform.zoom)){++this.currentLayer;continue}this.currentLayer=f.renderBatch(this.currentLayer);continue}const r=i?("symbol"===e.type?u:h)[i.id]:void 0;if(this._renderTileClippingMasks(e,i,i?c[i.id]:void 0),this.renderLayer(this,i,e,r),!f&&g&&_>0&&e.hasShadowPass()&&0==--_&&(g.drawGroundShadows(),this.firstLightBeamLayer<=this.currentLayer)){const e=this.currentLayer;for(this.renderPass="light-beam",this.currentLayer=this.firstLightBeamLayer;this.currentLayer<=e;this.currentLayer++){const e=o[this.currentLayer];if(!e.hasLightBeamPass())continue;const i=t._getLayerSourceCache(e);this.renderLayer(this,i,e,i?h[i.id]:void 0);}this.currentLayer=e,this.renderPass="translucent";}++this.currentLayer;}if(this.terrain&&this.terrain.postRender(),this.options.showTileBoundaries||this.options.showQueryGeometry||this.options.showTileAABBs){let e=null;o.forEach((i=>{const r=t._getLayerSourceCache(i);r&&!i.isHidden(this.transform.zoom)&&(!e||e.getSource().maxzoom<r.getSource().maxzoom)&&(e=r);})),e&&this.options.showTileBoundaries&&hA.debug(this,e,e.getVisibleCoordinates());}this.options.showPadding&&function(t){const e=t.transform.padding;UM(t,t.transform.height-(e.top||0),3,LM),UM(t,e.bottom||0,3,kM),VM(t,e.left||0,3,BM),VM(t,t.transform.width-(e.right||0),3,OM);const i=t.transform.centerPoint;!function(t,e,i,r){jM(t,e-1,i-10,2,20,r),jM(t,e-10,i-1,20,2,r);}(t,i.x,t.transform.height-i.y,FM);}(this),this.context.setDefault(),this.frameCounter=(this.frameCounter+1)%Number.MAX_SAFE_INTEGER,this.tileLoaded&&this.options.speedIndexTiming&&(this.loadTimeStamps.push(e.performance.now()),this.saveCanvasCopy()),l||(this.conflationActive=!1);}uploadLayer(t,e,i){this.gpuTimingStart(e),(!t.transform.projection.unsupportedLayers||!t.transform.projection.unsupportedLayers.includes(e.type)||t.terrain&&"custom"===e.type)&&uA[`${e.type}Upload`]&&uA[`${e.type}Upload`](t,i,e.scope),this.gpuTimingEnd();}renderLayer(t,e,i,r){i.isHidden(this.transform.zoom)||("background"===i.type||"sky"===i.type||"custom"===i.type||"model"===i.type||r&&r.length)&&(this.id=i.id,this.gpuTimingStart(i),(!t.transform.projection.unsupportedLayers||!t.transform.projection.unsupportedLayers.includes(i.type)||t.terrain&&"custom"===i.type)&&hA[i.type](t,e,i,r,this.style.placement.variableOffsets,this.options.isInitialLoad),this.gpuTimingEnd());}gpuTimingStart(t){if(!this.options.gpuTiming)return;const e=this.context.extTimerQuery;let i=this.gpuTimers[t.id];i||(i=this.gpuTimers[t.id]={calls:0,cpuTime:0,query:e.createQueryEXT()}),i.calls++,e.beginQueryEXT(e.TIME_ELAPSED_EXT,i.query);}gpuTimingDeferredRenderStart(){if(this.options.gpuTimingDeferredRender){const t=this.context.extTimerQuery,e=t.createQueryEXT();this.deferredRenderGpuTimeQueries.push(e),t.beginQueryEXT(t.TIME_ELAPSED_EXT,e);}}gpuTimingDeferredRenderEnd(){if(!this.options.gpuTimingDeferredRender)return;const t=this.context.extTimerQuery;t.endQueryEXT(t.TIME_ELAPSED_EXT);}gpuTimingEnd(){if(!this.options.gpuTiming)return;const t=this.context.extTimerQuery;t.endQueryEXT(t.TIME_ELAPSED_EXT);}collectGpuTimers(){const t=this.gpuTimers;return this.gpuTimers={},t}collectDeferredRenderGpuQueries(){const t=this.deferredRenderGpuTimeQueries;return this.deferredRenderGpuTimeQueries=[],t}queryGpuTimers(t){const e={};for(const i in t){const r=t[i],n=this.context.extTimerQuery,o=n.getQueryObjectEXT(r.query,n.QUERY_RESULT_EXT)/1e6;n.deleteQueryEXT(r.query),e[i]=o;}return e}queryGpuTimeDeferredRender(t){if(!this.options.gpuTimingDeferredRender)return 0;const e=this.context.extTimerQuery;let i=0;for(const r of t)i+=e.getQueryObjectEXT(r,e.QUERY_RESULT_EXT)/1e6,e.deleteQueryEXT(r);return i}translatePosMatrix(t,e,i,r,n){if(!i[0]&&!i[1])return t;const o=n?"map"===r?this.transform.angle:0:"viewport"===r?-this.transform.angle:0;if(o){const t=Math.sin(o),e=Math.cos(o);i=[i[0]*e-i[1]*t,i[0]*t+i[1]*e];}const s=[n?i[0]:Vx(e,i[0],this.transform.zoom),n?i[1]:Vx(e,i[1],this.transform.zoom),0],a=new Float32Array(16);return mu.translate(a,t,s),a}saveTileTexture(t){const e=this._tileTextures[t.size[0]];e?e.push(t):this._tileTextures[t.size[0]]=[t];}getTileTexture(t){const e=this._tileTextures[t];return e&&e.length>0?e.pop():null}isPatternMissing(t,e){return null===t||void 0!==t&&!this.imageManager.getPattern(t.toString(),e)}terrainRenderModeElevated(){return this.style&&!!this.style.getTerrain()&&!!this.terrain&&!this.terrain.renderingToTexture}terrainUseFloatDEM(){return null!=this.context.extTextureFloatLinear}currentGlobalDefines(t){const e=this.terrain&&this.terrain.renderingToTexture,i=this.terrain&&0===this.terrain.exaggeration(),r=this.style&&this.style.fog,n=[];return this.style&&this.style.enable3dLights()&&("globeRaster"===t||"terrainRaster"===t?(n.push("LIGHTING_3D_MODE"),n.push("LIGHTING_3D_ALPHA_EMISSIVENESS")):e||n.push("LIGHTING_3D_MODE")),"shadow"===this.renderPass?this._shadowMapDebug||n.push("DEPTH_TEXTURE"):this.shadowRenderer&&(this.shadowRenderer.useNormalOffset?n.push("RENDER_SHADOWS","DEPTH_TEXTURE","NORMAL_OFFSET"):n.push("RENDER_SHADOWS","DEPTH_TEXTURE")),this.terrainRenderModeElevated()&&n.push("TERRAIN"),this.terrainUseFloatDEM()&&n.push("TERRAIN_DEM_FLOAT_FORMAT"),"globe"===this.transform.projection.name&&n.push("GLOBE"),i&&n.push("ZERO_EXAGGERATION"),r&&!e&&0!==r.getOpacity(this.transform.pitch)&&n.push("FOG","FOG_DITHERING"),e&&n.push("RENDER_TO_TEXTURE"),this._showOverdrawInspector&&n.push("OVERDRAW_INSPECTOR"),n}useProgram(t,e,i){this.cache=this.cache||{};const r=i||[],n=this.currentGlobalDefines(t).concat(r),o=BE.cacheKey(hE[t],t,n,e);return this.cache[o]||(this.cache[o]=new BE(this.context,t,hE[t],e,gM[t],n)),this.cache[o]}setCustomLayerDefaults(){this.context.unbindVAO(),this.context.cullFace.setDefault(),this.context.frontFace.setDefault(),this.context.cullFaceSide.setDefault(),this.context.activeTexture.setDefault(),this.context.pixelStoreUnpack.setDefault(),this.context.pixelStoreUnpackPremultiplyAlpha.setDefault(),this.context.pixelStoreUnpackFlipY.setDefault();}setBaseState(){const t=this.context.gl;this.context.cullFace.set(!1),this.context.viewport.set([0,0,this.width,this.height]),this.context.blendEquation.set(t.FUNC_ADD);}initDebugOverlayCanvas(){null==this.debugOverlayCanvas&&(this.debugOverlayCanvas=e.document.createElement("canvas"),this.debugOverlayCanvas.width=512,this.debugOverlayCanvas.height=512,this.debugOverlayTexture=new hy(this.context,this.debugOverlayCanvas,this.context.gl.RGBA));}destroy(){this._terrain&&this._terrain.destroy(),this._atmosphere&&(this._atmosphere.destroy(),this._atmosphere=void 0),this.globeSharedBuffers&&this.globeSharedBuffers.destroy(),this.emptyTexture.destroy(),this.debugOverlayTexture&&this.debugOverlayTexture.destroy(),this._wireframeDebugCache.destroy();}prepareDrawTile(){this.terrain&&this.terrain.prepareDrawTile();}uploadCommonLightUniforms(t,e){if(this.style.enable3dLights()){const i=this.style.directionalLight,r=this.style.ambientLight;if(i&&r){const n=((t,e)=>{const i=t.properties.get("direction"),r=t.properties.get("color").toArray01(),n=t.properties.get("intensity"),o=e.properties.get("color").toArray01(),s=e.properties.get("intensity"),a=[i.x,i.y,i.z],l=at(o,s),c=at(r,n);return {u_lighting_ambient_color:l,u_lighting_directional_dir:a,u_lighting_directional_color:c,u_ground_radiance:RE(a,c,l)}})(i,r);e.setLightsUniformValues(t,n);}}}uploadCommonUniforms(t,e,i,r,n){if(this.uploadCommonLightUniforms(t,e),this.terrain&&this.terrain.renderingToTexture)return;const o=this.style.fog;if(o){const n=o.getOpacity(this.transform.pitch),s=((t,e,i,r,n,o,s,a,l,c,h,u)=>{const d=t.transform,p=e.properties.get("color").toArray01();p[3]=r;const f=t.frameCounter/1e3%1,[m,_]=e.properties.get("vertical-range");return {u_fog_matrix:i?d.calculateFogTileMatrix(i):u||t.identityMat,u_fog_range:e.getFovAdjustedRange(d._fov),u_fog_color:p,u_fog_horizon_blend:e.properties.get("horizon-blend"),u_fog_vertical_limit:[Math.min(m,_),_],u_fog_temporal_offset:f,u_frustum_tl:n,u_frustum_tr:o,u_frustum_br:s,u_frustum_bl:a,u_globe_pos:l,u_globe_radius:c,u_viewport:h,u_globe_transition:pd(d.zoom),u_is_globe:+("globe"===d.projection.name)}})(this,o,i,n,this.transform.frustumCorners.TL,this.transform.frustumCorners.TR,this.transform.frustumCorners.BR,this.transform.frustumCorners.BL,this.transform.globeCenterInViewSpace,this.transform.globeRadius,[this.transform.width*ue.devicePixelRatio,this.transform.height*ue.devicePixelRatio],r);e.setFogUniformValues(t,s);}n&&e.setCutoffUniformValues(t,n.uniformValues);}setTileLoadedFlag(t){this.tileLoaded=t;}saveCanvasCopy(){const t=this.canvasCopy();t&&(this.frameCopies.push(t),this.tileLoaded=!1);}canvasCopy(){const t=this.context.gl,e=t.createTexture();return t.bindTexture(t.TEXTURE_2D,e),t.copyTexImage2D(t.TEXTURE_2D,0,t.RGBA,0,0,t.drawingBufferWidth,t.drawingBufferHeight,0),e}getCanvasCopiesAndTimestamps(){return {canvasCopies:this.frameCopies,timeStamps:this.loadTimeStamps}}averageElevationNeedsEasing(){if(!this.transform._elevation)return !1;const t=this.style&&this.style.fog;return !!t&&0!==t.getOpacity(this.transform.pitch)}getBackgroundTiles(){const t=this._backgroundTiles,e=this._backgroundTiles={},i=this.transform.coveringTiles({tileSize:512});for(const r of i)e[r.key]=t[r.key]||new vy(r,512,this.transform.tileZoom,this);return e}clearBackgroundTiles(){this._backgroundTiles={};}layerUsedInConflation(t,e){return !(!t.is3D()||t.minzoom&&t.minzoom>this.transform.zoom||"building"!==t.sourceLayer&&(!e||"batched-model"!==e.type))}}const pA=2048;class fA{constructor(t){this.painter=t,this._enabled=!1,this._shadowLayerCount=0,this._cascades=[],this._depthMode=new cx(t.context.gl.LEQUAL,cx.ReadWrite,[0,1]),this._uniformValues={u_light_matrix_0:new Float32Array(16),u_light_matrix_1:new Float32Array(16),u_shadow_intensity:0,u_fade_range:[0,0],u_shadow_normal_offset:[1,1,1],u_texel_size:1,u_shadow_direction:[0,0,1],u_shadow_bias:[36e-5,.0012,.012],u_shadowmap_0:0,u_shadowmap_1:0},this.useNormalOffset=!1;}destroy(){for(const t of this._cascades)t.texture.destroy(),t.framebuffer.destroy();this._cascades=[];}updateShadowParameters(t,e){const i=this.painter;if(this._enabled=!1,this._shadowLayerCount=0,!e||!e.properties)return;const r=e.properties.get("shadow-intensity");if(!e.shadowsEnabled()||r<=0)return;if(this._shadowLayerCount=i.style.order.reduce(((e,r)=>{const n=i.style._layers[r];return e+(n.hasShadowPass()&&!n.isHidden(t.zoom)?1:0)}),0),this._enabled=this._shadowLayerCount>0,!this._enabled)return;const n=i.context,o=pA,s=pA;if(0===this._cascades.length)for(let t=0;t<2;++t){const t=i._shadowMapDebug,e=n.gl,r=n.createFramebuffer(o,s,t,"texture"),a=new hy(n,{width:o,height:s,data:null},e.DEPTH_COMPONENT);if(r.depthAttachment.set(a.texture),t){const t=new hy(n,{width:o,height:s,data:null},e.RGBA);r.colorAttachment.set(t.texture);}this._cascades.push({framebuffer:r,texture:a,matrix:[],far:0,boundingSphereRadius:0,frustum:new ku,scale:0});}this.shadowDirection=_A(e);let a=0;if(t.elevation){const e=t.elevation,i=[1e4,-1e4];e.visibleDemTiles.filter((t=>t.dem)).forEach((t=>{const e=t.dem.tree;i[0]=Math.min(i[0],e.minimums[0]),i[1]=Math.max(i[1],e.maximums[0]);})),1e4!==i[0]&&(a=(i[1]-i[0])*e.exaggeration());}const l=1.5*t.cameraToCenterDistance,c=3*l,h=new Float64Array(16);for(let e=0;e<2;++e){const i=this._cascades[e];let r=t.height/50,n=1;0===e?n=l:(r=l,n=c);const[o,s]=yA(t,this.shadowDirection,r,n,pA,a);i.scale=t.scale,i.matrix=o,i.boundingSphereRadius=s,mu.invert(h,i.matrix),i.frustum=ku.fromInvProjectionMatrix(h,1,0,!0),i.far=n;}this._uniformValues.u_fade_range=[.75*this._cascades[1].far,this._cascades[1].far],this._uniformValues.u_shadow_intensity=r,this._uniformValues.u_shadow_direction=[this.shadowDirection[0],this.shadowDirection[1],this.shadowDirection[2]],this._uniformValues.u_texel_size=.00048828125,this._uniformValues.u_shadowmap_0=pM.ShadowMap0,this._uniformValues.u_shadowmap_1=pM.ShadowMap0+1;}get enabled(){return this._enabled}set enabled(t){this._enabled=t;}drawShadowPass(t,e){if(!this._enabled)return;const i=this.painter,r=i.context;r.viewport.set([0,0,pA,pA]);for(let n=0;n<2;++n){i.currentShadowCascade=n,r.bindFramebuffer.set(this._cascades[n].framebuffer.framebuffer),r.clear({color:li.white,depth:1});for(const r of t.order){const n=t._layers[r];if(!n.hasShadowPass()||n.isHidden(i.transform.zoom))continue;const o=t._getLayerSourceCache(n),s=o?e[o.id]:void 0;("model"===n.type||s&&s.length)&&i.renderLayer(i,o,n,s);}}i.currentShadowCascade=0;}drawGroundShadows(){if(!this._enabled)return;const t=this.painter,e=t.style,i=t.context,r=e.directionalLight,n=e.ambientLight;if(!r||!n)return;const o=[],s=bE(t,t.longestCutoffRange);s.shouldRenderCutoff&&o.push("RENDER_CUTOFF");const a=t.useProgram("groundShadow",null,o),l=t.transform.coveringTiles({tileSize:512,renderWorldCopies:!0}),c=gA(r,n),h=new cx(i.gl.LEQUAL,cx.ReadOnly,t.depthRangeFor3D);for(const e of l){const r=e.toUnwrapped();this.setupShadows(r,a),t.uploadCommonUniforms(i,a,r,null,s);const n={u_matrix:t.transform.calculateProjMatrix(r),u_ground_shadow_factor:c};a.draw(t,i.gl.TRIANGLES,h,ux.disabled,px.multiply,_x.disabled,n,"ground_shadow",t.tileExtentBuffer,t.quadTriangleIndexBuffer,t.tileExtentSegments,{},t.transform.zoom,null,null);}}getShadowPassColorMode(){return this.painter._shadowMapDebug?px.unblended:px.disabled}getShadowPassDepthMode(){return this._depthMode}getShadowCastingLayerCount(){return this._shadowLayerCount}calculateShadowPassMatrixFromTile(t){const e=this.painter.transform,i=e.calculatePosMatrix(t,e.worldSize);return mu.multiply(i,this._cascades[this.painter.currentShadowCascade].matrix,i),Float32Array.from(i)}calculateShadowPassMatrixFromMatrix(t){return mu.multiply(t,this._cascades[this.painter.currentShadowCascade].matrix,t),Float32Array.from(t)}setupShadows(t,e,i,r=0){if(!this._enabled)return;const n=this.painter.transform,o=this.painter.context,s=o.gl,a=this._uniformValues,l=new Float64Array(16),c=n.calculatePosMatrix(t,n.worldSize);for(let t=0;t<2;t++)mu.multiply(l,this._cascades[t].matrix,c),a[0===t?"u_light_matrix_0":"u_light_matrix_1"]=Float32Array.from(l),o.activeTexture.set(s.TEXTURE0+pM.ShadowMap0+t),this._cascades[t].texture.bind(s.NEAREST,s.CLAMP_TO_EDGE);if(this.useNormalOffset=!!i,this.useNormalOffset){const e=Xd(t.canonical),o=2/n.tileSize*sr/pA,s=o*this._cascades[0].boundingSphereRadius,l=o*this._cascades[1].boundingSphereRadius,c=("vector-tile"===i?1:3)/Math.pow(2,r-t.canonical.z-(1-n.zoom+Math.floor(n.zoom)));a.u_shadow_normal_offset=[e,s*c,l*c],a.u_shadow_bias=[6e-5,.0012,.012];}else a.u_shadow_bias=[36e-5,.0012,.012];e.setShadowUniformValues(o,a);}setupShadowsFromMatrix(t,e,i=!1){if(!this._enabled)return;const r=this.painter.context,n=r.gl,o=this._uniformValues,s=new Float64Array(16);for(let e=0;e<2;e++)mu.multiply(s,this._cascades[e].matrix,t),o[0===e?"u_light_matrix_0":"u_light_matrix_1"]=Float32Array.from(s),r.activeTexture.set(n.TEXTURE0+pM.ShadowMap0+e),this._cascades[e].texture.bind(n.NEAREST,n.CLAMP_TO_EDGE);if(this.useNormalOffset=i,i){const t=5;o.u_shadow_normal_offset=[1,t,t],o.u_shadow_bias=[6e-5,.0012,.012];}else o.u_shadow_bias=[36e-5,.0012,.012];e.setShadowUniformValues(r,o);}getShadowUniformValues(){return this._uniformValues}getCurrentCascadeFrustum(){return this._cascades[this.painter.currentShadowCascade].frustum}computeSimplifiedTileShadowVolume(t,e,i,r){if(r[2]>=0)return {};const n=function(t,e,i){const r=i/(1<<t.canonical.z);return new Bu([t.canonical.x*r+t.wrap*i,t.canonical.y*r+t.wrap*i,0],[(t.canonical.x+1)*r+t.wrap*i,(t.canonical.y+1)*r+t.wrap*i,e])}(t,e,i).getCorners(),o=e/-r[2];r[0]<0?(bu.add(n[0],n[0],[r[0]*o,0,0]),bu.add(n[3],n[3],[r[0]*o,0,0])):r[0]>0&&(bu.add(n[1],n[1],[r[0]*o,0,0]),bu.add(n[2],n[2],[r[0]*o,0,0])),r[1]<0?(bu.add(n[0],n[0],[0,r[1]*o,0]),bu.add(n[1],n[1],[0,r[1]*o,0])):r[1]>0&&(bu.add(n[2],n[2],[0,r[1]*o,0]),bu.add(n[3],n[3],[0,r[1]*o,0]));const s={};return s.vertices=n,s.planes=[mA(n[1],n[0],n[4]),mA(n[2],n[1],n[5]),mA(n[3],n[2],n[6]),mA(n[0],n[3],n[7])],s}}function mA(t,e,i){const r=bu.sub([],i,e),n=bu.sub([],t,e),o=bu.cross([],r,n),s=bu.length(o);return 0===s?[0,0,1,0]:(bu.scale(o,o,1/s),[o[0],o[1],o[2],-bu.dot(o,e)])}function _A(t){const e=t.properties.get("direction"),i=J(e.x,e.y,e.z);i[2]=z(i[2],0,75);const r=K([i[0],i[1],i[2]]);return bu.fromValues(r.x,r.y,r.z)}function gA(t,e){const i=t.properties.get("color"),r=t.properties.get("intensity"),n=t.properties.get("direction"),o=[n.x,n.y,n.z],s=e.properties.get("color"),a=e.properties.get("intensity"),l=Math.max(bu.dot([0,0,1],o),0),c=[0,0,0];bu.scale(c,s.toArray01Linear().slice(0,3),a);const h=[0,0,0];return bu.scale(h,i.toArray01Linear().slice(0,3),l*r),lt([c[0]>0?c[0]/(c[0]+h[0]):0,c[1]>0?c[1]/(c[1]+h[1]):0,c[2]>0?c[2]/(c[2]+h[2]):0])}function yA(t,e,i,r,n,o){const s=t.zoom,a=t.scale,l=t.worldSize,c=1/l,h=t.aspect,u=Math.sqrt(1+h*h)*Math.tan(.5*t.fovX),d=u*u,p=r-i,f=r+i;let m,_;d>p/f?(m=r,_=r*u):(m=.5*f*(1+d),_=.5*Math.sqrt(p*p+2*(r*r+i*i)*d+f*f*d*d));const g=t.projection.pixelsPerMeter(t.center.lat,l),y=t._camera.getCameraToWorldMercator(),x=[0,0,-m*c];bu.transformMat4(x,x,y);let v=_*c;const b=t._edgeInsets;if(!(0===b.left&&0===b.top&&0===b.right&&0===b.bottom||b.left===b.right&&b.top===b.bottom)){const e=t._camera.getWorldToCamera(t.worldSize,"meters"===t.projection.zAxisUnit?g:1),n=t._camera.getCameraToClipPerspective(t._fov,t.width/t.height,i,r);n[8]=2*-t.centerOffset.x/t.width,n[9]=2*t.centerOffset.y/t.height;const o=new Float64Array(16);mu.mul(o,n,e);const c=new Float64Array(16);mu.invert(c,o);const h=ku.fromInvProjectionMatrix(c,l,s,!0);for(const e of h.points){const i=((w=e)[0]/=a,w[1]/=a,w[2]=Vd(w[2],t._center.lat),w);v=Math.max(v,bu.len(bu.subtract([],x,i)));}}var w;v*=n/(n-1);const T=Math.acos(e[2]),E=Math.atan2(-e[0],-e[1]),M=new Lx;M.position=x,M.setPitchBearing(T,E);const A=M.getWorldToCamera(l,g),S=v*l,I=Math.min(t._mercatorZfromZoom(17)*l*-2,-2*S),C=M.getCameraToClipOrthographic(-S,S,-S,S,I,(S+o*g)/e[2]),z=new Float64Array(16);mu.multiply(z,C,A);const D=bu.fromValues(Math.floor(1e6*x[0])/1e6*l,Math.floor(1e6*x[1])/1e6*l,0),P=.5*n,R=[0,0,0];bu.transformMat4(R,D,z),bu.scale(R,R,P);const L=[Math.floor(R[0]),Math.floor(R[1]),Math.floor(R[2])],k=[0,0,0];bu.sub(k,R,L),bu.scale(k,k,-1/P);const B=new Float64Array(16);return mu.identity(B),mu.translate(B,B,k),mu.multiply(z,B,z),[z,S]}class xA extends Ce{constructor(t){super(),this.requestManager=t,this.models={"":{}},this.numModelsLoading={};}async loadModel(t,e){const i=await Nw(this.requestManager.transformRequest(e,xt.Model).url).catch((i=>{this.fire(new Ie(new Error(`Could not load model ${t} from ${e}: ${i.message}`)));}));if(!i)return;const r=Mw(i),n=new fv(t,void 0,void 0,r);return n.computeBoundsAndApplyParent(),n}async load(t,e){this.models[e]||(this.models[e]={}),void 0===this.numModelsLoading[e]&&(this.numModelsLoading[e]=0);for(const i in t){const r=t[i];this.numModelsLoading[e]+=1;const n=await this.loadModel(i,r);this.numModelsLoading[e]-=1,n&&(this.models[e][i]=n);}this.fire(new Se("data",{dataType:"style"}));}isLoaded(){for(const t in this.numModelsLoading)if(this.numModelsLoading[t]>0)return !1;return !0}hasModel(t,e){return !!this.getModel(t,e)}getModel(t,e){return this.models[e]||(this.models[e]={}),this.models[e][t]}async addModel(t,e,i){this.models[i]||(this.models[i]={}),this.hasModel(t,i)&&this.removeModel(t,i),this.load({[t]:this.requestManager.normalizeModelURL(e)},i);}addModels(t,e){const i={};for(const e in t)i[e]=this.requestManager.normalizeModelURL(t[e]);this.load(i,e);}removeModel(t,e){this.models[e]||(this.models[e]={});const i=this.models[e][t];delete this.models[e][t],i.destroy();}listModels(t){return this.models[t]||(this.models[t]={}),Object.keys(this.models[t])}upload(t,e){this.models[e]||(this.models[e]={});for(const i in this.models[e])this.models[e][i].upload(t.context);}}const vA=(t,e)=>bs(t,e&&e.filter((t=>"source.canvas"!==t.identifier))),bA=B(Yw,["addLayer","removeLayer","setLights","setPaintProperty","setLayoutProperty","setFilter","addSource","removeSource","setLayerZoomRange","setLight","setTransition","setGeoJSONSourceData","setTerrain","setFog","setProjection","setCamera"]),wA=B(Yw,["setCenter","setZoom","setBearing","setPitch"]),TA={version:8,layers:[],sources:{}},EA={duration:300,delay:0},MA=new Set(["fill","line","background","hillshade","raster"]);class AA extends Ce{constructor(t,e={}){super(),this.map=t,this.imports=[],this.scope=e.scope||"",this.importDepth=e.importDepth||0,this.importsCache=e.importsCache||new Map,this.resolvedImports=e.resolvedImports||new Set,this.parentCamera=e.camera,this._ownOrder=[],this._ownLayers={},this._ownSources={},this.dispatcher=e.dispatcher?e.dispatcher:new Zb(Pw(),this),e.imageManager?this.imageManager=e.imageManager:(this.imageManager=new Rb,this.imageManager.setEventedParent(this)),this.imageManager.createScope(this.scope),this.glyphManager=e.glyphManager?e.glyphManager:new q_(t._requestManager,e.localFontFamily?2:e.localIdeographFontFamily?1:0,e.localFontFamily||e.localIdeographFontFamily),e.modelManager?this.modelManager=e.modelManager:(this.modelManager=new xA(t._requestManager),this.modelManager.setEventedParent(this)),this.crossTileSymbolIndex=new GT,this._layers={},this._num3DLayers=0,this._numSymbolLayers=0,this._numCircleLayers=0,this._serializedLayers={},this._sourceCaches={},this._otherSourceCaches={},this._symbolSourceCaches={},this._loaded=!1,this._availableImages=[],this._order=[],this._drapedFirstOrder=[],this._markersNeedUpdate=!1,this._buildingIndex=new $w(this),this._transition=k({},EA),this.options=e.config||new Map,this._configDependentLayers=new Set,this._resetUpdates(),this.dispatcher.broadcast("setReferrer",bt());const i=this;this._rtlTextPluginCallback=AA.registerForPluginStateChange((t=>{i.dispatcher.broadcast("syncRTLPluginState",{pluginStatus:t.pluginStatus,pluginURL:t.pluginURL},((t,e)=>{if(Hs(t),e&&e.every((t=>t)))for(const t in i._sourceCaches){const e=i._sourceCaches[t],r=e.getSource().type;"vector"!==r&&"geojson"!==r||e.reload();}}));})),this.on("data",(t=>{if("source"!==t.dataType||"metadata"!==t.sourceDataType)return;const e=this.getSource(t.sourceId);if(e&&e.vectorLayerIds)for(const t in this._layers){const i=this._layers[t];i.source===e.id&&this._validateLayer(i);}}));}loadURL(t,e={}){this.fire(new Se("dataloading",{dataType:"style"}));const i="boolean"==typeof e.validate?e.validate:!Pt(t);t=this.map._requestManager.normalizeStyleURL(t,e.accessToken),this.resolvedImports.add(t);const r=this.importsCache.get(t);if(r)return this._load(r,i);const n=this.map._requestManager.transformRequest(t,xt.Style);this._request=Tt(n,((e,r)=>{if(this._request=null,e)this.fire(new Ie(e));else if(r)return this.importsCache.set(t,r),this._load(r,i)}));}loadJSON(t,e={}){this.fire(new Se("dataloading",{dataType:"style"})),this._request=ue.frame((()=>{this._request=null,this._load(t,!1!==e.validate);}));}loadEmpty(){this.fire(new Se("dataloading",{dataType:"style"})),this._load(TA,!1);}_updateLayerCount(t,e){const i=e?1:-1;t.is3D()&&(this._num3DLayers+=i),"circle"===t.type&&(this._numCircleLayers+=i),"symbol"===t.type&&(this._numSymbolLayers+=i);}_loadImports(t,e){const i=()=>{this._mergeLayers(),this._mergeSources();for(const{style:t,id:e}of this.imports){for(const[i,r]of t.options.entries())this.options.set(ZT(i,e),r);null!=t.stylesheet.camera&&(this.stylesheet.camera=t.stylesheet.camera),null!=t.stylesheet.projection&&(this.stylesheet.projection=t.stylesheet.projection),null!=t.stylesheet.light&&(this.light=t.light),null!=t.ambientLight&&(this.ambientLight=t.ambientLight),null!=t.directionalLight&&(this.directionalLight=t.directionalLight),null!=t.terrain&&(this.terrain=t.terrain),null!=t.fog&&(this.fog=t.fog),null!=t._transition&&this.setTransition(t._transition);}this.dispatcher.broadcast("setLayers",{layers:this._serializeLayers(this._ownOrder),scope:this.scope,options:this.options}),this.fire(new Se("data",{dataType:"style"})),this.fire(new Se(0===this.importDepth?"style.load":"style.import.load"));};if(this.importDepth>=4)return W("Style doesn't support nesting deeper than 5"),i();const r=[];for(const i of t){const t=this.scope?ZT(i.id,this.scope):i.id,n=new Map,o=i.config;if(o)for(const t of Object.keys(o)){const e=yo(o[t]);"success"===e.result&&n.set(t,e.value.expression);}const s=new AA(this.map,{scope:t,importDepth:this.importDepth+1,importsCache:this.importsCache,resolvedImports:new Set(this.resolvedImports),dispatcher:this.dispatcher,imageManager:this.imageManager,glyphManager:this.glyphManager,modelManager:this.modelManager,camera:this.stylesheet.camera,config:n});s.setEventedParent(this.map,{style:s});const a=new Promise((t=>s.on("style.import.load",t)));if(r.push(a),this.resolvedImports.has(i.url)){s.loadEmpty();continue}const l=i.data||this.importsCache.get(i.url);l?s.loadJSON(l,{validate:e}):i.url?s.loadURL(i.url,{validate:e}):s.loadEmpty(),this.imports.push({id:i.id,style:s,config:i.config});}Promise.all(r).then(i);}_load(t,e){const i=t.schema;if(0===this.importDepth&&(t.fragment||i)){const i=k({},TA,{imports:[{id:"basemap",data:t,url:""}]});return void this._load(i,e)}if(i)for(const t of Object.keys(i)){if(this.options.has(t))continue;const e=yo(i[t].default);"success"===e.result&&this.options.set(t,e.value.expression);}if(e&&vA(this,cs(t)))return;this._loaded=!0,this.stylesheet=$(t),this._updateMapProjection();for(const e in t.sources){const i=ZT(e,this.scope);this.addSource(i,t.sources[e],{validate:!1});}this._changed=!1,t.sprite?this._loadSprite(t.sprite):(this.imageManager.setLoaded(!0,this.scope),this.dispatcher.broadcast("spriteLoaded",{scope:this.scope,isLoaded:!0})),this.glyphManager.setURL(t.glyphs,this.scope);const r=Xw(this.stylesheet.layers);if(this._ownOrder=r.map((t=>ZT(t.id,this.scope))),this.stylesheet.light&&W("The `light` root property is deprecated, prefer using `lights` with `flat` light type instead."),this.stylesheet.lights)if(1===this.stylesheet.lights.length&&"flat"===this.stylesheet.lights[0].type){const t=this.stylesheet.lights[0];this.light=new kb(t.properties,t.id);}else this.setLights(this.stylesheet.lights);this.light||(this.light=new kb(this.stylesheet.light)),this._ownLayers={},this._serializedLayers={};for(const t of r){const e=Db(t,this.options);e.id=ZT(e.id,this.scope),e.scope=this.scope,e.isConfigDependent&&this._configDependentLayers.add(e.id),e.source&&(e.source=ZT(e.source,this.scope)),e.setEventedParent(this,{layer:{id:e.id}}),this._layers[e.id]=e,this._ownLayers[e.id]=e,this._serializedLayers[e.id]=e.serialize(),this._updateLayerCount(e,!0);const i=this._getLayerSourceCache(e),r=!!this.directionalLight&&this.directionalLight.shadowsEnabled();i&&e.canCastShadows()&&r&&(i.castsShadows=!0);}this.stylesheet.models&&this.modelManager.addModels(this.stylesheet.models,this.scope);const n=this.stylesheet.terrain;n&&!this.terrainSetForDrapingOnly()&&this._createTerrain(n,1),this.stylesheet.fog&&this._createFog(this.stylesheet.fog),this.stylesheet.transition&&this.setTransition(this.stylesheet.transition);const o=this.stylesheet.camera=this.stylesheet.camera||this.parentCamera||{"camera-projection":"perspective"};this.map.setCamera(o),this._mergeLayers(),this._mergeSources(),this.fire(new Se("data",{dataType:"style"})),t.imports?this._loadImports(t.imports,e):(this.dispatcher.broadcast("setLayers",{layers:this._serializeLayers(this._ownOrder),scope:this.scope,options:this.options}),this.fire(new Se(0===this.importDepth?"style.load":"style.import.load")));}_mergeSources(){const t={},e={},i={};!function r(n){for(const t of n.imports)r(t.style);for(const e in n._sourceCaches)t[e]=n._sourceCaches[e];for(const t in n._otherSourceCaches)e[t]=n._otherSourceCaches[t];for(const t in n._symbolSourceCaches)i[t]=n._symbolSourceCaches[t];}(this),this._sourceCaches=t,this._otherSourceCaches=e,this._symbolSourceCaches=i;}_mergeLayers(){const t={},e=[],i={};!function i(r){for(const t of r.imports)i(t.style);for(const i of r._ownOrder){const n=r._ownLayers[i];if("slot"===n.type){const e=$T(i);if(t[e])continue;t[e]=[];}n.slot&&t[n.slot]?t[n.slot].push(n):e.push(n);}}(this),this._order=[];const r=(e=[])=>{for(const n of e)if("slot"===n.type){const e=$T(n.id);t[e]&&r(t[e]);}else this._order.push(n.id),i[n.id]=n;};r(e),this._layers=i,this._updateDrapeFirstLayers(),this._buildingIndex.processLayersChanged();}terrainSetForDrapingOnly(){return !!this.terrain&&0===this.terrain.drapeRenderMode}setProjection(t){t?this.stylesheet.projection=t:delete this.stylesheet.projection,this._updateMapProjection();}applyProjectionUpdate(){this._loaded&&(this.dispatcher.broadcast("setProjection",this.map.transform.projectionOptions),this.map.transform.projection.requiresDraping?this.getTerrain()||this.stylesheet.terrain||this.setTerrainForDraping():this.terrainSetForDrapingOnly()&&this.setTerrain(null));}_updateMapProjection(){this.map._useExplicitProjection?this.applyProjectionUpdate():this.map._prioritizeAndUpdateProjection(null,this.stylesheet.projection);}_loadSprite(t){this._spriteRequest=function(t,e,i){let r,n,o;const s=ue.devicePixelRatio>1?"@2x":"";let a=Tt(e.transformRequest(e.normalizeSpriteURL(t,s,".json"),xt.SpriteJSON),((t,e)=>{a=null,o||(o=t,r=e,c());})),l=Ct(e.transformRequest(e.normalizeSpriteURL(t,s,".png"),xt.SpriteImage),((t,e)=>{l=null,o||(o=t,n=e,c());}));function c(){if(o)i(o);else if(r&&n){const t=ue.getImageData(n),e={};for(const i in r){const{width:n,height:o,x:s,y:a,sdf:l,pixelRatio:c,stretchX:h,stretchY:u,content:d}=r[i],p=new Np({width:n,height:o});Np.copy(t,p,{x:s,y:a},{x:0,y:0},{width:n,height:o}),e[i]={data:p,pixelRatio:c,sdf:l,stretchX:h,stretchY:u,content:d};}i(null,e);}}return {cancel(){a&&(a.cancel(),a=null),l&&(l.cancel(),l=null);}}}(t,this.map._requestManager,((t,e)=>{if(this._spriteRequest=null,t)this.fire(new Ie(t));else if(e)for(const t in e)this.imageManager.addImage(t,this.scope,e[t]);this.imageManager.setLoaded(!0,this.scope),this._availableImages=this.imageManager.listImages(this.scope),this.dispatcher.broadcast("setImages",{scope:this.scope,images:this._availableImages}),this.dispatcher.broadcast("spriteLoaded",{scope:this.scope,isLoaded:!0}),this.fire(new Se("data",{dataType:"style"}));}));}_validateLayer(t){const e=this.getSource(t.source);if(!e)return;const i=t.sourceLayer;i&&("geojson"===e.type||e.vectorLayerIds&&-1===e.vectorLayerIds.indexOf(i))&&this.fire(new Ie(new Error(`Source layer "${i}" does not exist on source "${e.id}" as specified by style layer "${t.id}"`)));}loaded(){if(!this._loaded)return !1;if(Object.keys(this._updatedSources).length)return !1;for(const t in this._sourceCaches)if(!this._sourceCaches[t].loaded())return !1;if(!this.imageManager.isLoaded())return !1;if(!this.modelManager.isLoaded())return !1;for(const{style:t}of this.imports)if(!t.loaded())return !1;return !0}_serializeLayers(t){const e=[];for(const i of t){const t=this._layers[i];t&&"custom"!==t.type&&e.push(t.serialize());}return e}hasLightTransitions(){return !(!this.light||!this.light.hasTransition())||!(!this.ambientLight||!this.ambientLight.hasTransition())||!(!this.directionalLight||!this.directionalLight.hasTransition())}hasFogTransition(){return !!this.fog&&this.fog.hasTransition()}hasTransitions(){if(this.hasLightTransitions())return !0;if(this.hasFogTransition())return !0;for(const t in this._sourceCaches)if(this._sourceCaches[t].hasTransition())return !0;for(const t in this._layers)if(this._layers[t].hasTransition())return !0;return !1}get order(){return this.terrain?this._drapedFirstOrder:this._order}isLayerDraped(t){return !!this.terrain&&("function"==typeof t.isLayerDraped?t.isLayerDraped():MA.has(t.type))}_checkLoaded(){if(!this._loaded)throw new Error("Style is not done loading")}update(t){if(!this._loaded)return;this.ambientLight&&this.ambientLight.recalculate(t),this.directionalLight&&this.directionalLight.recalculate(t);const e=this.calculateLightsBrightness();t.brightness=e||0,e!==this._brightness&&(this._brightness=e,this.dispatcher.broadcast("setBrightness",e));const i=this._changed;if(this._changed){const e=Object.keys(this._updatedLayers),i=Object.keys(this._removedLayers);if(e.length||i.length){const t={};for(const i of e){const e=HT(i);(t[e]=t[e]||{updatedIds:[],removedIds:[]}).updatedIds.push(i);}for(const e of i){const i=HT(e);(t[i]=t[i]||{updatedIds:[],removedIds:[]}).removedIds.push(e);}for(const[e,{updatedIds:i,removedIds:r}]of Object.entries(t))this.getFragmentById(e)._updateWorkerLayers(i,r);}for(const t in this._updatedSources){const e=this._updatedSources[t];"reload"===e?this._reloadSource(t):"clear"===e&&this._clearSource(t);}this._updateTilesForChangedImages();for(const e in this._updatedPaintProps)this._layers[e].updateTransitions(t);this.light&&this.light.updateTransitions(t),this.ambientLight&&this.ambientLight.updateTransitions(t),this.directionalLight&&this.directionalLight.updateTransitions(t),this.fog&&this.fog.updateTransitions(t),this._resetUpdates();}const r={};for(const t in this._sourceCaches){const e=this._sourceCaches[t];r[t]=e.used,e.used=!1;}for(const e of this._order){const i=this._layers[e];if(i.recalculate(t,this._availableImages),!i.isHidden(t.zoom)){const t=this._getLayerSourceCache(i);t&&(t.used=!0);}const r=this.map.painter;if(r){const e=i.getProgramIds();if(!e)continue;const n=i.getProgramConfiguration(t.zoom);for(const t of e)r.useProgram(t,n);}}for(const t in r){const e=this._sourceCaches[t];r[t]!==e.used&&e.getSource().fire(new Se("data",{sourceDataType:"visibility",dataType:"source",sourceId:e.getSource().id}));}this.light&&this.light.recalculate(t),this.terrain&&this.terrain.recalculate(t),this.fog&&this.fog.recalculate(t),this.z=t.zoom,this._markersNeedUpdate&&(this._updateMarkersOpacity(),this._markersNeedUpdate=!1),i&&this.fire(new Se("data",{dataType:"style"}));}_updateTilesForChangedImages(){const t=Object.keys(this._changedImages);if(t.length){for(const e in this._sourceCaches)this._sourceCaches[e].reloadTilesForDependencies(["icons","patterns"],t);this._changedImages={};}}_updateWorkerLayers(t,e){this.dispatcher.broadcast("updateLayers",{layers:this._serializeLayers(t),scope:this.scope,removedIds:e,options:this.options});}_resetUpdates(){this._changed=!1,this._updatedLayers={},this._removedLayers={},this._updatedSources={},this._updatedPaintProps={},this._changedImages={};}setState(t){if(this._checkLoaded(),vA(this,cs(t)))return !1;(t=$(t)).layers=Xw(t.layers);const e=function(t,e){if(!t)return [{command:Yw.setStyle,args:[e]}];let i=[];try{if(!x(t.version,e.version))return [{command:Yw.setStyle,args:[e]}];x(t.center,e.center)||i.push({command:Yw.setCenter,args:[e.center]}),x(t.zoom,e.zoom)||i.push({command:Yw.setZoom,args:[e.zoom]}),x(t.bearing,e.bearing)||i.push({command:Yw.setBearing,args:[e.bearing]}),x(t.pitch,e.pitch)||i.push({command:Yw.setPitch,args:[e.pitch]}),x(t.sprite,e.sprite)||i.push({command:Yw.setSprite,args:[e.sprite]}),x(t.glyphs,e.glyphs)||i.push({command:Yw.setGlyphs,args:[e.glyphs]}),x(t.transition,e.transition)||i.push({command:Yw.setTransition,args:[e.transition]}),x(t.light,e.light)||i.push({command:Yw.setLight,args:[e.light]}),x(t.fog,e.fog)||i.push({command:Yw.setFog,args:[e.fog]}),x(t.projection,e.projection)||i.push({command:Yw.setProjection,args:[e.projection]}),x(t.lights,e.lights)||i.push({command:Yw.setLights,args:[e.lights]}),x(t.camera,e.camera)||i.push({command:Yw.setCamera,args:[e.camera]});const r={},n=[];!function(t,e,i,r){let n;for(n in e=e||{},t=t||{})t.hasOwnProperty(n)&&(e.hasOwnProperty(n)||Jw(n,i,r));for(n in e){if(!e.hasOwnProperty(n))continue;const o=e[n];t.hasOwnProperty(n)?x(t[n],o)||("geojson"===t[n].type&&"geojson"===o.type&&tT(t,e,n)?i.push({command:Yw.setGeoJSONSourceData,args:[n,o.data]}):Qw(n,e,i,r)):Kw(n,e,i);}}(t.sources,e.sources,n,r);const o=[];t.layers&&t.layers.forEach((t=>{t.source&&r[t.source]?i.push({command:Yw.removeLayer,args:[t.id]}):o.push(t);}));let s=t.terrain;s&&r[s.source]&&(i.push({command:Yw.setTerrain,args:[void 0]}),s=void 0),i=i.concat(n),x(s,e.terrain)||i.push({command:Yw.setTerrain,args:[e.terrain]}),function(t,e,i){e=e||[];const r=(t=t||[]).map(iT),n=e.map(iT),o=t.reduce(rT,{}),s=e.reduce(rT,{}),a=r.slice(),l=Object.create(null);let c,h,u,d,p,f,m;for(c=0,h=0;c<r.length;c++)u=r[c],s.hasOwnProperty(u)?h++:(i.push({command:Yw.removeLayer,args:[u]}),a.splice(a.indexOf(u,h),1));for(c=0,h=0;c<n.length;c++)u=n[n.length-1-c],a[a.length-1-c]!==u&&(o.hasOwnProperty(u)?(i.push({command:Yw.removeLayer,args:[u]}),a.splice(a.lastIndexOf(u,a.length-h),1)):h++,f=a[a.length-c],i.push({command:Yw.addLayer,args:[s[u],f]}),a.splice(a.length-c,0,u),l[u]=!0);for(c=0;c<n.length;c++)if(u=n[c],d=o[u],p=s[u],!l[u]&&!x(d,p))if(x(d.source,p.source)&&x(d["source-layer"],p["source-layer"])&&x(d.type,p.type)){for(m in eT(d.layout,p.layout,i,u,null,Yw.setLayoutProperty),eT(d.paint,p.paint,i,u,null,Yw.setPaintProperty),x(d.filter,p.filter)||i.push({command:Yw.setFilter,args:[u,p.filter]}),x(d.minzoom,p.minzoom)&&x(d.maxzoom,p.maxzoom)||i.push({command:Yw.setLayerZoomRange,args:[u,p.minzoom,p.maxzoom]}),d)d.hasOwnProperty(m)&&"layout"!==m&&"paint"!==m&&"filter"!==m&&"metadata"!==m&&"minzoom"!==m&&"maxzoom"!==m&&(0===m.indexOf("paint.")?eT(d[m],p[m],i,u,m.slice(6),Yw.setPaintProperty):x(d[m],p[m])||i.push({command:Yw.setLayerProperty,args:[u,m,p[m]]}));for(m in p)p.hasOwnProperty(m)&&!d.hasOwnProperty(m)&&"layout"!==m&&"paint"!==m&&"filter"!==m&&"metadata"!==m&&"minzoom"!==m&&"maxzoom"!==m&&(0===m.indexOf("paint.")?eT(d[m],p[m],i,u,m.slice(6),Yw.setPaintProperty):x(d[m],p[m])||i.push({command:Yw.setLayerProperty,args:[u,m,p[m]]}));}else i.push({command:Yw.removeLayer,args:[u]}),f=a[a.lastIndexOf(u)+1],i.push({command:Yw.addLayer,args:[p,f]});}(o,e.layers,i),function(t=[],e=[],i){for(const e of t)i.push({command:Yw.removeImport,args:[e.id]});for(const t of e)i.push({command:Yw.addImport,args:[t]});}(t.imports,e.imports,i);}catch(t){console.warn("Unable to compute style diff:",t),i=[{command:Yw.setStyle,args:[e]}];}return i}(this.serialize(),t).filter((t=>!(t.command in wA)));if(0===e.length)return !1;const i=e.filter((t=>!(t.command in bA)));if(i.length>0)throw new Error(`Unimplemented: ${i.map((t=>t.command)).join(", ")}.`);return e.forEach((t=>{"setTransition"!==t.command&&"setProjection"!==t.command&&this[t.command].apply(this,t.args);})),this.stylesheet=t,this._updateMapProjection(),!0}addImage(t,e){return this.getImage(t)?this.fire(new Ie(new Error("An image with this name already exists."))):(this.imageManager.addImage(t,this.scope,e),this._afterImageUpdated(t),this)}updateImage(t,e){this.imageManager.updateImage(t,this.scope,e);}getImage(t){return this.imageManager.getImage(t,this.scope)}removeImage(t){return this.getImage(t)?(this.imageManager.removeImage(t,this.scope),this._afterImageUpdated(t),this):this.fire(new Ie(new Error("No image with this name exists.")))}_afterImageUpdated(t){this._availableImages=this.imageManager.listImages(this.scope),this._changedImages[t]=!0,this._changed=!0,this.dispatcher.broadcast("setImages",{scope:this.scope,images:this._availableImages}),this.fire(new Se("data",{dataType:"style"}));}listImages(){return this._checkLoaded(),this._availableImages.slice()}addModel(t,e,i={}){return this._checkLoaded(),this._validate(xs,`models.${t}`,e,null,i)||(this.modelManager.addModel(t,e,this.scope),this._changed=!0),this}hasModel(t){return this.modelManager.hasModel(t,this.scope)}removeModel(t){return this.hasModel(t)?(this.modelManager.removeModel(t,this.scope),this):this.fire(new Ie(new Error("No model with this ID exists.")))}listModels(){return this._checkLoaded(),this.modelManager.listModels(this.scope)}addSource(t,e,i={}){if(this._checkLoaded(),void 0!==this.getOwnSource(t))throw new Error("There is already a source with this ID");if(!e.type)throw new Error(`The type property must be defined, but only the following properties were given: ${Object.keys(e).join(", ")}.`);if(["vector","raster","geojson","video","image"].indexOf(e.type)>=0&&this._validate(hs,`sources.${t}`,e,null,i))return;this.map&&this.map._collectResourceTiming&&(e.collectResourceTiming=!0);const r=this._ownSources[t]=Vw(t,e,this.dispatcher,this);r.scope=this.scope,r.setEventedParent(this,(()=>({isSourceLoaded:this._isSourceCacheLoaded(t),source:r.serialize(),sourceId:t})));const n=e=>{const i=(e?"symbol:":"other:")+t,n=this._sourceCaches[i]=new yx(i,r,e);(e?this._symbolSourceCaches:this._otherSourceCaches)[t]=n,n.onAdd(this.map);};n(!1),"vector"!==e.type&&"geojson"!==e.type||n(!0),r.onAdd&&r.onAdd(this.map),this._mergeSources(),this._changed=!0;}removeSource(t){this._checkLoaded();const e=this.getOwnSource(t);if(!e)throw new Error("There is no source with this ID");for(const e in this._layers)if(this._layers[e].source===t)return this.fire(new Ie(new Error(`Source "${t}" cannot be removed while layer "${e}" is using it.`)));if(this.terrain&&this.terrain.get().source===t)return this.fire(new Ie(new Error(`Source "${t}" cannot be removed while terrain is using it.`)));const i=this._getSourceCaches(t);for(const t of i)delete this._sourceCaches[t.id],delete this._updatedSources[t.id],t.fire(new Se("data",{sourceDataType:"metadata",dataType:"source",sourceId:t.getSource().id})),t.setEventedParent(null),t.clearTiles();return delete this._ownSources[t],delete this._otherSourceCaches[t],delete this._symbolSourceCaches[t],this._mergeSources(),e.setEventedParent(null),e.onRemove&&e.onRemove(this.map),this._changed=!0,this}setGeoJSONSourceData(t,e){this._checkLoaded(),this.getOwnSource(t).setData(e),this._changed=!0;}getSource(t){const e=this._getSourceCache(t);return e&&e.getSource()}getOwnSource(t){return this._ownSources[t]}_getSources(){const t=[];for(const e in this._otherSourceCaches){const i=this._getSourceCache(e);i&&t.push(i.getSource());}return t}setLights(t){if(this._checkLoaded(),!t)return delete this.ambientLight,void delete this.directionalLight;const e=this._getTransitionParameters();for(const i of t){if(this._validate(ds,"lights",i))return;switch(i.type){case"ambient":if(this.ambientLight){const t=this.ambientLight;t.set(i),t.updateTransitions(e);}else this.ambientLight=new $b(i,Hb,this.scope,this.options);break;case"directional":if(this.directionalLight){const t=this.directionalLight;t.set(i),t.updateTransitions(e);}else this.directionalLight=new $b(i,Wb,this.scope,this.options);}}const i=new Qs(this.z||0,e);this.ambientLight&&this.ambientLight.recalculate(i),this.directionalLight&&this.directionalLight.recalculate(i),this._brightness=this.calculateLightsBrightness(),this.dispatcher.broadcast("setBrightness",this._brightness);}calculateLightsBrightness(){const t=this.directionalLight,e=this.ambientLight;if(!t||!e)return;const i=t=>.2126*(t[0]<=.03928?t[0]/12.92:Math.pow((t[0]+.055)/1.055,2.4))+.7152*(t[1]<=.03928?t[1]/12.92:Math.pow((t[1]+.055)/1.055,2.4))+.0722*(t[2]<=.03928?t[2]/12.92:Math.pow((t[2]+.055)/1.055,2.4)),r=t.properties.get("color").toArray01(),n=t.properties.get("intensity"),o=t.properties.get("direction"),s=1-J(o.x,o.y,o.z)[2]/90,a=i(r)*n*s,l=e.properties.get("color").toArray01(),c=e.properties.get("intensity");return (a+i(l)*c)/2}getBrightness(){return this._brightness}getLights(){if(!this.enable3dLights())return null;const t=[];return this.directionalLight&&t.push(this.directionalLight.get()),this.ambientLight&&t.push(this.ambientLight.get()),t}enable3dLights(){return !!this.ambientLight&&!!this.directionalLight}getFragmentById(t){if(!t)return this;const e=this.imports.find((({id:e})=>e===t));if(!e)throw new Error(`Style import not found: ${t}`);return e.style}setConfigProperty(t,e,i){const r=yo(i);if("success"!==r.result)return void vA(this,r.value);const n=r.value.expression,o=this.getFragmentById(t);o.options.set(e,n);for(const t of o._configDependentLayers){const e=this.getLayer(t);e&&(e.possiblyEvaluateVisibility(),this._updateLayer(e));}this.ambientLight&&this.ambientLight.scope===t&&this.ambientLight.updateConfig(o.options),this.directionalLight&&this.directionalLight.scope===t&&this.directionalLight.updateConfig(o.options),this._changed=!0;}addLayer(t,e,i={}){this._checkLoaded();const r=t.id;if(this._ownLayers[r])return void this.fire(new Ie(new Error(`Layer with id "${r}" already exists on this map`)));let n;if("custom"===t.type){if(vA(this,function(t){const e=[],i=t.id;return void 0===i&&e.push({message:`layers.${i}: missing required property "id"`}),void 0===t.render&&e.push({message:`layers.${i}: missing required method "render"`}),t.renderingMode&&"2d"!==t.renderingMode&&"3d"!==t.renderingMode&&e.push({message:`layers.${i}: property "renderingMode" must be either "2d" or "3d"`}),e}(t)))return;n=Db(t,this.options);}else {if("object"==typeof t.source&&(this.addSource(r,t.source),t=k(t=$(t),{source:r})),this._validate(ms,`layers.${r}`,t,{arrayIndex:-1},i))return;n=Db(t,this.options),this._validateLayer(n),n.setEventedParent(this,{layer:{id:r}}),this._serializedLayers[n.id]=n.serialize(),this._updateLayerCount(n,!0);}n.isConfigDependent&&this._configDependentLayers.add(n.id);const o=e?this._ownOrder.indexOf(e):this._ownOrder.length;if(e&&-1===o)return void this.fire(new Ie(new Error(`Layer with id "${e}" does not exist on this map.`)));this._ownOrder.splice(o,0,r),this._layerOrderChanged=!0,this._ownLayers[r]=n;const s=this._getLayerSourceCache(n),a=!!this.directionalLight&&this.directionalLight.shadowsEnabled();if(s&&n.canCastShadows()&&a&&(s.castsShadows=!0),this._removedLayers[r]&&n.source&&s&&"custom"!==n.type){const t=this._removedLayers[r];delete this._removedLayers[r],t.type!==n.type?this._updatedSources[n.source]="clear":(this._updatedSources[n.source]="reload",s.pause());}this._updateLayer(n),n.onAdd&&n.onAdd(this.map),n.scope=this.scope,this._mergeLayers();}moveLayer(t,e){if(this._checkLoaded(),this._changed=!0,!this._ownLayers[t])return void this.fire(new Ie(new Error(`The layer '${t}' does not exist in the map's style and cannot be moved.`)));if(t===e)return;const i=this._ownOrder.indexOf(t);this._ownOrder.splice(i,1);const r=e?this._ownOrder.indexOf(e):this._ownOrder.length;e&&-1===r?this.fire(new Ie(new Error(`Layer with id "${e}" does not exist on this map.`))):(this._ownOrder.splice(r,0,t),this._layerOrderChanged=!0,this._mergeLayers());}removeLayer(t){this._checkLoaded();const e=this._ownLayers[t];if(!e)return void this.fire(new Ie(new Error(`The layer '${t}' does not exist in the map's style and cannot be removed.`)));e.setEventedParent(null),this._updateLayerCount(e,!1);const i=this._ownOrder.indexOf(t);this._ownOrder.splice(i,1),this._layerOrderChanged=!0,this._changed=!0,this._removedLayers[t]=e,delete this._ownLayers[t],delete this._serializedLayers[t],delete this._updatedLayers[t],delete this._updatedPaintProps[t],this._configDependentLayers.delete(t);const r=this._getLayerSourceCache(e);if(r&&r.castsShadows){let t=!1;for(const i in this._ownLayers)if(this._layers[i].source===e.source&&this._layers[i].canCastShadows()){t=!0;break}r.castsShadows=t;}e.onRemove&&e.onRemove(this.map),this._mergeLayers();}getLayer(t){return this._layers[t]}getOwnLayer(t){return this._ownLayers[t]}hasLayer(t){return t in this._layers}hasLayerType(t){for(const e in this._layers)if(this._layers[e].type===t)return !0;return !1}setLayerZoomRange(t,e,i){this._checkLoaded();const r=this.getOwnLayer(t);r?r.minzoom===e&&r.maxzoom===i||(null!=e&&(r.minzoom=e),null!=i&&(r.maxzoom=i),this._updateLayer(r)):this.fire(new Ie(new Error(`The layer '${t}' does not exist in the map's style and cannot have zoom extent.`)));}setFilter(t,e,i={}){this._checkLoaded();const r=this.getOwnLayer(t);if(r){if(!x(r.filter,e))return null==e?(r.filter=void 0,void this._updateLayer(r)):void(this._validate(_s,`layers.${r.id}.filter`,e,{layerType:r.type},i)||(r.filter=$(e),this._updateLayer(r)))}else this.fire(new Ie(new Error(`The layer '${t}' does not exist in the map's style and cannot be filtered.`)));}getFilter(t){const e=this.getOwnLayer(t);if(e)return $(e.filter);this.fire(new Ie(new Error(`The layer '${t}' does not exist in the map's style and cannot be filtered.`)));}setLayoutProperty(t,e,i,r={}){this._checkLoaded();const n=this.getOwnLayer(t);n?x(n.getLayoutProperty(e),i)||(n.setLayoutProperty(e,i,r),n.isConfigDependent&&this._configDependentLayers.add(n.id),this._updateLayer(n)):this.fire(new Ie(new Error(`The layer '${t}' does not exist in the map's style and cannot be styled.`)));}getLayoutProperty(t,e){const i=this.getOwnLayer(t);if(i)return i.getLayoutProperty(e);this.fire(new Ie(new Error(`The layer '${t}' does not exist in the map's style.`)));}setPaintProperty(t,e,i,r={}){this._checkLoaded();const n=this.getOwnLayer(t);if(!n)return void this.fire(new Ie(new Error(`The layer '${t}' does not exist in the map's style and cannot be styled.`)));if(x(n.getPaintProperty(e),i))return;const o=n.setPaintProperty(e,i,r);n.isConfigDependent&&this._configDependentLayers.add(n.id),o&&this._updateLayer(n),this._changed=!0,this._updatedPaintProps[t]=!0;}getPaintProperty(t,e){const i=this.getOwnLayer(t);if(i)return i.getPaintProperty(e);this.fire(new Ie(new Error(`The layer '${t}' does not exist in the map's style and cannot be styled.`)));}setFeatureState(t,e){this._checkLoaded();const i=t.source,r=t.sourceLayer,n=this.getOwnSource(i);if(!n)return void this.fire(new Ie(new Error(`The source '${i}' does not exist in the map's style.`)));const o=n.type;if("geojson"===o&&r)return void this.fire(new Ie(new Error("GeoJSON sources cannot have a sourceLayer parameter.")));if("vector"===o&&!r)return void this.fire(new Ie(new Error("The sourceLayer parameter must be provided for vector source types.")));void 0===t.id&&this.fire(new Ie(new Error("The feature id parameter must be provided.")));const s=this._getSourceCaches(i);for(const i of s)i.setFeatureState(r,t.id,e);}removeFeatureState(t,e){this._checkLoaded();const i=t.source,r=this.getOwnSource(i);if(!r)return void this.fire(new Ie(new Error(`The source '${i}' does not exist in the map's style.`)));const n=r.type,o="vector"===n?t.sourceLayer:void 0;if("vector"===n&&!o)return void this.fire(new Ie(new Error("The sourceLayer parameter must be provided for vector source types.")));if(e&&"string"!=typeof t.id&&"number"!=typeof t.id)return void this.fire(new Ie(new Error("A feature id is required to remove its specific state property.")));const s=this._getSourceCaches(i);for(const i of s)i.removeFeatureState(o,t.id,e);}getFeatureState(t){this._checkLoaded();const e=t.source,i=t.sourceLayer,r=this.getOwnSource(e);if(r){if("vector"!==r.type||i)return void 0===t.id&&this.fire(new Ie(new Error("The feature id parameter must be provided."))),this._getSourceCaches(e)[0].getFeatureState(i,t.id);this.fire(new Ie(new Error("The sourceLayer parameter must be provided for vector source types.")));}else this.fire(new Ie(new Error(`The source '${e}' does not exist in the map's style.`)));}setTransition(t){this._transition=k({},EA,this._transition,t);}getTransition(){return k({},this._transition)}serialize(){this._checkLoaded();const t={};for(const e in this._ownSources){const i=this._ownSources[e];t[i.id]=i.serialize();}return Z({version:this.stylesheet.version,name:this.stylesheet.name,metadata:this.stylesheet.metadata,imports:this.stylesheet.imports,light:this.stylesheet.light,lights:this.stylesheet.lights,terrain:this.getTerrain()||void 0,fog:this.stylesheet.fog,center:this.stylesheet.center,zoom:this.stylesheet.zoom,bearing:this.stylesheet.bearing,pitch:this.stylesheet.pitch,sprite:this.stylesheet.sprite,glyphs:this.stylesheet.glyphs,transition:this.stylesheet.transition,projection:this.stylesheet.projection,sources:t,layers:this._serializeLayers(this._ownOrder)},(t=>void 0!==t))}_updateLayer(t){this._updatedLayers[t.id]=!0;const e=this._getLayerSourceCache(t);t.source&&!this._updatedSources[t.source]&&e&&"raster"!==e.getSource().type&&(this._updatedSources[t.source]="reload",e.pause()),this._changed=!0,t.invalidateCompiledFilter();}_flattenAndSortRenderedFeatures(t){const e=t=>"fill-extrusion"===this._layers[t].type,i={},r=[];for(let n=this._order.length-1;n>=0;n--){const o=this._order[n];if(e(o)){i[o]=n;for(const e of t){const t=e[o];if(t)for(const e of t)r.push(e);}}}r.sort(((t,e)=>e.intersectionZ-t.intersectionZ));const n=[];for(let o=this._order.length-1;o>=0;o--){const s=this._order[o];if(e(s))for(let t=r.length-1;t>=0;t--){const e=r[t].feature;if(i[e.layer.id]<o)break;n.push(e),r.pop();}else for(const e of t){const t=e[s];if(t)for(const e of t)n.push(e.feature);}}return n}queryRenderedFeatures(t,e,i){e&&e.filter&&this._validate(_s,"queryRenderedFeatures.filter",e.filter,null,e);const r={};if(e&&e.layers){if(!Array.isArray(e.layers))return this.fire(new Ie(new Error("parameters.layers must be an Array."))),[];for(const t of e.layers){const e=this._layers[t];if(!e)return this.fire(new Ie(new Error(`The layer '${t}' does not exist in the map's style and cannot be queried for features.`))),[];r[e.source]=!0;}}const n=[];e.availableImages=this._availableImages;const o=e&&e.layers?e.layers.some((t=>{const e=this.getLayer(t);return e&&e.is3D()})):this.has3DLayers(),s=Xb.createFromScreenPoints(t,i);for(const t in this._sourceCaches){const a=this._sourceCaches[t].getSource().id;this._ownSources[a]&&(e.layers&&!r[a]||n.push(Gw(this._sourceCaches[t],this._ownLayers,this._serializedLayers,s,e,i,o,!!this.map._showQueryGeometry)));}return this.placement&&n.push(function(t,e,i,r,n,o,s){const a={},l=o.queryRenderedSymbols(r),c=[];for(const t of Object.keys(l).map(Number))c.push(s[t]);c.sort(Zw);for(const i of c){const r=i.featureIndex.lookupSymbolFeatures(l[i.bucketInstanceId],e,i.bucketIndex,i.sourceLayerIndex,n.filter,n.layers,n.availableImages,t);for(const t in r){const e=a[t]=a[t]||[],n=r[t];n.sort(((t,e)=>{const r=i.featureSortOrder;if(r){const i=r.indexOf(t.featureIndex);return r.indexOf(e.featureIndex)-i}return e.featureIndex-t.featureIndex}));for(const t of n)e.push(t);}}for(const e in a)a[e].forEach((r=>{const n=r.feature,o=i(t[e]);if(!o)return;const s=o.getFeatureState(n.layer["source-layer"],n.id);n.source=n.layer.source,n.layer["source-layer"]&&(n.sourceLayer=n.layer["source-layer"]),n.state=s;}));return a}(this._ownLayers,this._serializedLayers,this._getLayerSourceCache.bind(this),s.screenGeometry,e,this.placement.collisionIndex,this.placement.retainedQueryData)),this._flattenAndSortRenderedFeatures(n)}querySourceFeatures(t,e){e&&e.filter&&this._validate(_s,"querySourceFeatures.filter",e.filter,null,e);const i=this._getSourceCaches(t);let r=[];for(const t of i)r=r.concat(qw(t,e));return r}addSourceType(t,e,i){return AA.getSourceType(t)?i(new Error(`A source type called "${t}" already exists.`)):(AA.setSourceType(t,e),e.workerSourceURL?void this.dispatcher.broadcast("loadWorkerSource",{name:t,url:e.workerSourceURL},i):i(null,null))}getFlatLight(){return this.light.getLight()}setFlatLight(t,e,i={}){this._checkLoaded();const r=this.light.getLight();let n=!1;for(const e in t)if(!x(t[e],r[e])){n=!0;break}if(!n)return;const o=this._getTransitionParameters();this.light.setLight(t,e,i),this.light.updateTransitions(o);}getTerrain(){return this.terrain&&1===this.terrain.drapeRenderMode?this.terrain.get():null}setTerrainForDraping(){this.setTerrain({source:"",exaggeration:0},0);}setTerrain(t,e=1){if(this._checkLoaded(),!t)return delete this.terrain,delete this.stylesheet.terrain,this.dispatcher.broadcast("enableTerrain",!1),this._force3DLayerUpdate(),void(this._markersNeedUpdate=!0);let i=t;if(1===e){if("object"==typeof i.source){const t="terrain-dem-src";this.addSource(t,i.source),i=$(i),i=k(i,{source:t});}if(this._validate(ps,"terrain",i))return}if(!this.terrain||this.terrain&&e!==this.terrain.drapeRenderMode){if(!i)return;this._createTerrain(i,e);}else {const e=this.terrain,r=e.get();for(const t of Object.keys(ze.terrain))!i.hasOwnProperty(t)&&ze.terrain[t].default&&(i[t]=ze.terrain[t].default);for(const i in t)if(!x(t[i],r[i])){e.set(t),this.stylesheet.terrain=t;const i=this._getTransitionParameters({duration:0});e.updateTransitions(i);break}}this._updateDrapeFirstLayers(),this._markersNeedUpdate=!0;}_createFog(t){const e=this.fog=new Vb(t,this.map.transform);this.stylesheet.fog=t;const i=this._getTransitionParameters({duration:0});e.updateTransitions(i);}_updateMarkersOpacity(){0!==this.map._markers.length&&this.map._requestDomTask((()=>{for(const t of this.map._markers)t._evaluateOpacity();}));}getFog(){return this.fog?this.fog.get():null}setFog(t){if(this._checkLoaded(),!t)return delete this.fog,delete this.stylesheet.fog,void(this._markersNeedUpdate=!0);if(this.fog){const e=this.fog,i=e.get();0===Object.keys(t).length&&e.set(t);for(const r in t)if(!x(t[r],i[r])){e.set(t),this.stylesheet.fog=t;const i=this._getTransitionParameters({duration:0});e.updateTransitions(i);break}}else this._createFog(t);this._markersNeedUpdate=!0;}_getTransitionParameters(t){return {now:ue.now(),transition:k(this.getTransition(),t)}}_updateDrapeFirstLayers(){if(!this.terrain)return;const t=[],e=[];for(const i in this._layers){const r=this._layers[i];this.isLayerDraped(r)?t.push(r.id):e.push(r.id);}this._drapedFirstOrder=[],this._drapedFirstOrder.push(...t),this._drapedFirstOrder.push(...e);}_createTerrain(t,e){const i=this.terrain=new Ob(t,e);this.stylesheet.terrain=t,this.dispatcher.broadcast("enableTerrain",!this.terrainSetForDrapingOnly()),this._updateDrapeFirstLayers(),this._force3DLayerUpdate();const r=this._getTransitionParameters({duration:0});i.updateTransitions(r);}_force3DLayerUpdate(){for(const t in this._layers){const e=this._layers[t];"fill-extrusion"===e.type&&this._updateLayer(e);}}_forceSymbolLayerUpdate(){for(const t in this._layers){const e=this._layers[t];"symbol"===e.type&&this._updateLayer(e);}}_validate(t,e,i,r,n={}){if(n&&!1===n.validate)return !1;const o=k({},this.serialize());return vA(this,t.call(cs,k({key:e,style:o,value:i,styleSpec:ze},r)))}_remove(){for(const{style:t}of this.imports)t._remove();this._request&&(this._request.cancel(),this._request=null),this._spriteRequest&&(this._spriteRequest.cancel(),this._spriteRequest=null),Xs.off("pluginStateChange",this._rtlTextPluginCallback),this._mergeLayers(),this._mergeSources();for(const t in this._layers)this._layers[t].setEventedParent(null);for(const t in this._sourceCaches)this._sourceCaches[t].clearTiles(),this._sourceCaches[t].setEventedParent(null);this.modelManager&&this.modelManager.setEventedParent(null),this.imageManager.setEventedParent(null),this.setEventedParent(null),this.dispatcher.remove(),delete this.ambientLight,delete this.directionalLight;}_clearSource(t){const e=this._getSourceCaches(t);for(const t of e)t.clearTiles();}_reloadSource(t){const e=this._getSourceCaches(t);for(const t of e)t.resume(),t.reload();}_reloadSources(){for(const t of this._getSources())t.reload&&t.reload();}_updateSources(t){let e;this.directionalLight&&(e=_A(this.directionalLight));for(const i in this._sourceCaches)this._sourceCaches[i].update(t,void 0,void 0,e);}_generateCollisionBoxes(){for(const t in this._sourceCaches){const e=this._sourceCaches[t];e.resume(),e.reload();}}_updatePlacement(t,e,i,r,n=!1){let o=!1,s=!1;const a={},l={};for(const e of this._order){const i=this._layers[e];if("symbol"!==i.type)continue;if(!a[i.source]){const t=this._getLayerSourceCache(i);if(!t)continue;const e=t.getRenderableIds(!0).map((e=>t.getTileByID(e)));l[i.source]=e.slice(),a[i.source]=e.sort(((t,e)=>e.tileID.overscaledZ-t.tileID.overscaledZ||(t.tileID.isLessThan(e.tileID)?-1:1)));}const r=this.crossTileSymbolIndex.addLayer(i,a[i.source],t.center.lng,t.projection);o=o||r;}if(this.crossTileSymbolIndex.pruneUnusedLayers(this._order),n=n||this._layerOrderChanged||0===i,this._layerOrderChanged&&this.fire(new Se("neworder")),(n||!this.pauseablePlacement||this.pauseablePlacement.isDone()&&!this.placement.stillRecent(ue.now(),t.zoom))&&(this.pauseablePlacement=new DT(t,this._order,n,e,i,r,this.placement,this.fog&&t.projection.supportsFog?this.fog.state:null,this._buildingIndex),this._layerOrderChanged=!1),this.pauseablePlacement.isDone()?this.placement.setStale():(this.pauseablePlacement.continuePlacement(this._order,this._layers,a,l),this.pauseablePlacement.isDone()&&(this.placement=this.pauseablePlacement.commit(ue.now()),s=!0),o&&this.pauseablePlacement.placement.setStale()),s||o)for(const t of this._order){const e=this._layers[t];"symbol"===e.type&&this.placement.updateLayerOpacities(e,a[e.source]);}return !this.pauseablePlacement.isDone()||this.placement.hasTransitions(ue.now())}_releaseSymbolFadeTiles(){for(const t in this._sourceCaches)this._sourceCaches[t].releaseSymbolFadeTiles();}getImages(t,e,i){this.imageManager.getImages(e.icons,e.scope,i),this._updateTilesForChangedImages();const r=t=>{t&&t.setDependencies(e.tileID.key,e.type,e.icons);};r(this._otherSourceCaches[e.source]),r(this._symbolSourceCaches[e.source]);}getGlyphs(t,e,i){this.glyphManager.getGlyphs(e.stacks,e.scope,i);}getResource(t,e,i){return wt(e,i)}_getSourceCache(t){return this._otherSourceCaches[t]}_getLayerSourceCache(t){return "symbol"===t.type?this._symbolSourceCaches[t.source]:this._otherSourceCaches[t.source]}_getSourceCaches(t){const e=[];return this._otherSourceCaches[t]&&e.push(this._otherSourceCaches[t]),this._symbolSourceCaches[t]&&e.push(this._symbolSourceCaches[t]),e}_isSourceCacheLoaded(t){const e=this._getSourceCaches(t);return 0===e.length?(this.fire(new Ie(new Error(`There is no source with ID '${t}'`))),!1):e.every((t=>t.loaded()))}has3DLayers(){return this._num3DLayers>0}hasSymbolLayers(){return this._numSymbolLayers>0}hasCircleLayers(){return this._numCircleLayers>0}_clearWorkerCaches(){this.dispatcher.broadcast("clearCaches");}destroy(){this._clearWorkerCaches(),this.terrainSetForDrapingOnly()&&(delete this.terrain,delete this.stylesheet.terrain);}}function SA(t,e){let i=!1,r=null;const n=()=>{r=null,i&&(t(),r=setTimeout(n,e),i=!1);};return ()=>(i=!0,r||n(),r)}AA.getSourceType=function(t){return Uw[t]},AA.setSourceType=function(t,e){Uw[t]=e;},AA.registerForPluginStateChange=function(t){return t({pluginStatus:Zs,pluginURL:$s}),Xs.on("pluginStateChange",t),t};class IA{constructor(t){this._hashName=t&&encodeURIComponent(t),j(["_getCurrentHash","_onHashChange","_updateHash"],this),this._updateHash=SA(this._updateHashUnthrottled.bind(this),300);}addTo(t){return this._map=t,e.addEventListener("hashchange",this._onHashChange,!1),t.on("moveend",this._updateHash),this}remove(){return this._map?(this._map.off("moveend",this._updateHash),e.removeEventListener("hashchange",this._onHashChange,!1),clearTimeout(this._updateHash()),this._map=void 0,this):this}getHashString(){const t=this._map;if(!t)return "";const i=CA(t);if(this._hashName){const t=this._hashName;let r=!1;const n=e.location.hash.slice(1).split("&").map((e=>{const n=e.split("=")[0];return n===t?(r=!0,`${n}=${i}`):e})).filter((t=>t));return r||n.push(`${t}=${i}`),`#${n.join("&")}`}return `#${i}`}_getCurrentHash(){const t=e.location.hash.replace("#","");if(this._hashName){let e;return t.split("&").map((t=>t.split("="))).forEach((t=>{t[0]===this._hashName&&(e=t);})),(e&&e[1]||"").split("/")}return t.split("/")}_onHashChange(){const t=this._map;if(!t)return !1;const e=this._getCurrentHash();if(e.length>=3&&!e.some((t=>isNaN(t)))){const i=t.dragRotate.isEnabled()&&t.touchZoomRotate.isEnabled()?+(e[3]||0):t.getBearing();return t.jumpTo({center:[+e[2],+e[1]],zoom:+e[0],bearing:i,pitch:+(e[4]||0)}),!0}return !1}_updateHashUnthrottled(){const t=e.location.href.replace(/(#.+)?$/,this.getHashString());e.history.replaceState(e.history.state,null,t);}}function CA(t,e){const i=t.getCenter(),r=Math.round(100*t.getZoom())/100,n=Math.ceil((r*Math.LN2+Math.log(512/360/.5))/Math.LN10),o=Math.pow(10,n),s=Math.round(i.lng*o)/o,a=Math.round(i.lat*o)/o,l=t.getBearing(),c=t.getPitch();let h=e?`/${s}/${a}/${r}`:`${r}/${a}/${s}`;return (l||c)&&(h+="/"+Math.round(10*l)/10),c&&(h+=`/${Math.round(c)}`),h}const zA={linearity:.3,easing:I(0,0,.3,1)},DA=k({deceleration:2500,maxSpeed:1400},zA),PA=k({deceleration:20,maxSpeed:1400},zA),RA=k({deceleration:1e3,maxSpeed:360},zA),LA=k({deceleration:1e3,maxSpeed:90},zA);class kA{constructor(t){this._map=t,this.clear();}clear(){this._inertiaBuffer=[];}record(t){this._drainInertiaBuffer(),this._inertiaBuffer.push({time:ue.now(),settings:t});}_drainInertiaBuffer(){const t=this._inertiaBuffer,e=ue.now();for(;t.length>0&&e-t[0].time>160;)t.shift();}_onMoveEnd(t){if(this._map._prefersReducedMotion())return;if(this._drainInertiaBuffer(),this._inertiaBuffer.length<2)return;const e={zoom:0,bearing:0,pitch:0,pan:new y(0,0),pinchAround:void 0,around:void 0};for(const{settings:t}of this._inertiaBuffer)e.zoom+=t.zoomDelta||0,e.bearing+=t.bearingDelta||0,e.pitch+=t.pitchDelta||0,t.panDelta&&e.pan._add(t.panDelta),t.around&&(e.around=t.around),t.pinchAround&&(e.pinchAround=t.pinchAround);const i=this._inertiaBuffer[this._inertiaBuffer.length-1].time-this._inertiaBuffer[0].time,r={};if(e.pan.mag()){const n=OA(e.pan.mag(),i,k({},DA,t||{}));r.offset=e.pan.mult(n.amount/e.pan.mag()),r.center=this._map.transform.center,BA(r,n);}if(e.zoom){const t=OA(e.zoom,i,PA);r.zoom=this._map.transform.zoom+t.amount,BA(r,t);}if(e.bearing){const t=OA(e.bearing,i,RA);r.bearing=this._map.transform.bearing+z(t.amount,-179,179),BA(r,t);}if(e.pitch){const t=OA(e.pitch,i,LA);r.pitch=this._map.transform.pitch+t.amount,BA(r,t);}if(r.zoom||r.bearing){const t=void 0===e.pinchAround?e.around:e.pinchAround;r.around=t?this._map.unproject(t):this._map.getCenter();}return this.clear(),r.noMoveStart=!0,r}}function BA(t,e){(!t.duration||t.duration<e.duration)&&(t.duration=e.duration,t.easing=e.easing);}function OA(t,e,i){const{maxSpeed:r,linearity:n,deceleration:o}=i,s=z(t*n/(e/1e3),-r,r),a=Math.abs(s)/(o*n);return {easing:i.easing,duration:1e3*a,amount:s*(a/2)}}class FA extends Se{preventDefault(){this._defaultPrevented=!0;}get defaultPrevented(){return this._defaultPrevented}constructor(t,e,i,r={}){const n=be(e.getCanvasContainer(),i);super(t,k({point:n,lngLat:e.unproject(n),originalEvent:i},r)),this._defaultPrevented=!1,this.target=e;}}class NA extends Se{preventDefault(){this._defaultPrevented=!0;}get defaultPrevented(){return this._defaultPrevented}constructor(t,e,i){const r="touchend"===t?i.changedTouches:i.touches,n=we(e.getCanvasContainer(),r),o=n.map((t=>e.unproject(t))),s=n.reduce(((t,e,i,r)=>t.add(e.div(r.length))),new y(0,0));super(t,{points:n,point:s,lngLats:o,lngLat:e.unproject(s),originalEvent:i}),this._defaultPrevented=!1;}}class UA extends Se{preventDefault(){this._defaultPrevented=!0;}get defaultPrevented(){return this._defaultPrevented}constructor(t,e,i){super(t,{originalEvent:i}),this._defaultPrevented=!1;}}class VA{constructor(t,e){this._map=t,this._clickTolerance=e.clickTolerance;}reset(){this._mousedownPos=void 0;}wheel(t){return this._firePreventable(new UA(t.type,this._map,t))}mousedown(t,e){return this._mousedownPos=e,this._firePreventable(new FA(t.type,this._map,t))}mouseup(t){this._map.fire(new FA(t.type,this._map,t));}preclick(t){const e=k({},t);e.type="preclick",this._map.fire(new FA(e.type,this._map,e));}click(t,e){this._mousedownPos&&this._mousedownPos.dist(e)>=this._clickTolerance||(this.preclick(t),this._map.fire(new FA(t.type,this._map,t)));}dblclick(t){return this._firePreventable(new FA(t.type,this._map,t))}mouseover(t){this._map.fire(new FA(t.type,this._map,t));}mouseout(t){this._map.fire(new FA(t.type,this._map,t));}touchstart(t){return this._firePreventable(new NA(t.type,this._map,t))}touchmove(t){this._map.fire(new NA(t.type,this._map,t));}touchend(t){this._map.fire(new NA(t.type,this._map,t));}touchcancel(t){this._map.fire(new NA(t.type,this._map,t));}_firePreventable(t){if(this._map.fire(t),t.defaultPrevented)return {}}isEnabled(){return !0}isActive(){return !1}enable(){}disable(){}}class jA{constructor(t){this._map=t;}reset(){this._delayContextMenu=!1,this._contextMenuEvent=void 0;}mousemove(t){this._map.fire(new FA(t.type,this._map,t));}mousedown(){this._delayContextMenu=!0;}mouseup(){this._delayContextMenu=!1,this._contextMenuEvent&&(this._map.fire(new FA("contextmenu",this._map,this._contextMenuEvent)),delete this._contextMenuEvent);}contextmenu(t){this._delayContextMenu?this._contextMenuEvent=t:this._map.fire(new FA(t.type,this._map,t)),this._map.listens("contextmenu")&&t.preventDefault();}isEnabled(){return !0}isActive(){return !1}enable(){}disable(){}}class GA{constructor(t,e){this._map=t,this._el=t.getCanvasContainer(),this._container=t.getContainer(),this._clickTolerance=e.clickTolerance||1;}isEnabled(){return !!this._enabled}isActive(){return !!this._active}enable(){this.isEnabled()||(this._enabled=!0);}disable(){this.isEnabled()&&(this._enabled=!1);}mousedown(t,e){this.isEnabled()&&t.shiftKey&&0===t.button&&(ge(),this._startPos=this._lastPos=e,this._active=!0);}mousemoveWindow(t,e){if(!this._active)return;const i=e,r=this._startPos,n=this._lastPos;if(!r||!n||n.equals(i)||!this._box&&i.dist(r)<this._clickTolerance)return;this._lastPos=i,this._box||(this._box=de("div","mapboxgl-boxzoom",this._container),this._container.classList.add("mapboxgl-crosshair"),this._fireEvent("boxzoomstart",t));const o=Math.min(r.x,i.x),s=Math.max(r.x,i.x),a=Math.min(r.y,i.y),l=Math.max(r.y,i.y);this._map._requestDomTask((()=>{this._box&&(this._box.style.transform=`translate(${o}px,${a}px)`,this._box.style.width=s-o+"px",this._box.style.height=l-a+"px");}));}mouseupWindow(t,e){if(!this._active)return;const i=this._startPos,r=e;if(i&&0===t.button){if(this.reset(),ve(),i.x!==r.x||i.y!==r.y)return this._map.fire(new Se("boxzoomend",{originalEvent:t})),{cameraAnimation:t=>t.fitScreenCoordinates(i,r,this._map.getBearing(),{linear:!1})};this._fireEvent("boxzoomcancel",t);}}keydown(t){this._active&&27===t.keyCode&&(this.reset(),this._fireEvent("boxzoomcancel",t));}blur(){this.reset();}reset(){this._active=!1,this._container.classList.remove("mapboxgl-crosshair"),this._box&&(this._box.remove(),this._box=null),ye(),delete this._startPos,delete this._lastPos;}_fireEvent(t,e){return this._map.fire(new Se(t,{originalEvent:e}))}}function qA(t,e){const i={};for(let r=0;r<t.length;r++)i[t[r].identifier]=e[r];return i}class ZA{constructor(t){this.reset(),this.numTouches=t.numTouches;}reset(){this.centroid=void 0,this.startTime=0,this.touches={},this.aborted=!1;}touchstart(t,e,i){(this.centroid||i.length>this.numTouches)&&(this.aborted=!0),this.aborted||(0===this.startTime&&(this.startTime=t.timeStamp),i.length===this.numTouches&&(this.centroid=function(t){const e=new y(0,0);for(const i of t)e._add(i);return e.div(t.length)}(e),this.touches=qA(i,e)));}touchmove(t,e,i){if(this.aborted||!this.centroid)return;const r=qA(i,e);for(const t in this.touches){const e=r[t];(!e||e.dist(this.touches[t])>30)&&(this.aborted=!0);}}touchend(t,e,i){if((!this.centroid||t.timeStamp-this.startTime>500)&&(this.aborted=!0),0===i.length){const t=!this.aborted&&this.centroid;if(this.reset(),t)return t}}}class $A{constructor(t){this.singleTap=new ZA(t),this.numTaps=t.numTaps,this.reset();}reset(){this.lastTime=1/0,this.lastTap=void 0,this.count=0,this.singleTap.reset();}touchstart(t,e,i){this.singleTap.touchstart(t,e,i);}touchmove(t,e,i){this.singleTap.touchmove(t,e,i);}touchend(t,e,i){const r=this.singleTap.touchend(t,e,i);if(r){const e=t.timeStamp-this.lastTime<500,i=!this.lastTap||this.lastTap.dist(r)<30;if(e&&i||this.reset(),this.count++,this.lastTime=t.timeStamp,this.lastTap=r,this.count===this.numTaps)return this.reset(),r}}}class HA{constructor(){this._zoomIn=new $A({numTouches:1,numTaps:2}),this._zoomOut=new $A({numTouches:2,numTaps:1}),this.reset();}reset(){this._active=!1,this._zoomIn.reset(),this._zoomOut.reset();}touchstart(t,e,i){this._zoomIn.touchstart(t,e,i),this._zoomOut.touchstart(t,e,i);}touchmove(t,e,i){this._zoomIn.touchmove(t,e,i),this._zoomOut.touchmove(t,e,i);}touchend(t,e,i){const r=this._zoomIn.touchend(t,e,i),n=this._zoomOut.touchend(t,e,i);return r?(this._active=!0,t.preventDefault(),setTimeout((()=>this.reset()),0),{cameraAnimation:e=>e.easeTo({duration:300,zoom:e.getZoom()+1,around:e.unproject(r)},{originalEvent:t})}):n?(this._active=!0,t.preventDefault(),setTimeout((()=>this.reset()),0),{cameraAnimation:e=>e.easeTo({duration:300,zoom:e.getZoom()-1,around:e.unproject(n)},{originalEvent:t})}):void 0}touchcancel(){this.reset();}enable(){this._enabled=!0;}disable(){this._enabled=!1,this.reset();}isEnabled(){return this._enabled}isActive(){return this._active}}const WA={0:1,2:2};class XA{constructor(t){this.reset(),this._clickTolerance=t.clickTolerance||1;}blur(){this.reset();}reset(){this._active=!1,this._moved=!1,this._lastPoint=void 0,this._eventButton=void 0;}_correctButton(t,e){return !1}_move(t,e){return {}}mousedown(t,e){if(this._lastPoint)return;const i=Te(t);this._correctButton(t,i)&&(this._lastPoint=e,this._eventButton=i);}mousemoveWindow(t,e){const i=this._lastPoint;if(i)if(t.preventDefault(),null!=this._eventButton&&function(t,e){const i=WA[e];return void 0===t.buttons||(t.buttons&i)!==i}(t,this._eventButton))this.reset();else if(this._moved||!(e.dist(i)<this._clickTolerance))return this._moved=!0,this._lastPoint=e,this._move(i,e)}mouseupWindow(t){this._lastPoint&&Te(t)===this._eventButton&&(this._moved&&ve(),this.reset());}enable(){this._enabled=!0;}disable(){this._enabled=!1,this.reset();}isEnabled(){return this._enabled}isActive(){return this._active}}class YA extends XA{mousedown(t,e){super.mousedown(t,e),this._lastPoint&&(this._active=!0);}_correctButton(t,e){return 0===e&&!t.ctrlKey}_move(t,e){return {around:e,panDelta:e.sub(t)}}}class KA extends XA{_correctButton(t,e){return 0===e&&t.ctrlKey||2===e}_move(t,e){const i=.8*(e.x-t.x);if(i)return this._active=!0,{bearingDelta:i}}contextmenu(t){t.preventDefault();}}class JA extends XA{_correctButton(t,e){return 0===e&&t.ctrlKey||2===e}_move(t,e){const i=-.5*(e.y-t.y);if(i)return this._active=!0,{pitchDelta:i}}contextmenu(t){t.preventDefault();}}class QA{constructor(t,e){this._map=t,this._el=t.getCanvasContainer(),this._minTouches=1,this._clickTolerance=e.clickTolerance||1,this.reset(),j(["_addTouchPanBlocker","_showTouchPanBlockerAlert"],this);}reset(){this._active=!1,this._touches={},this._sum=new y(0,0);}touchstart(t,e,i){return this._calculateTransform(t,e,i)}touchmove(t,e,i){if(this._active&&!(i.length<this._minTouches)){if(this._map._cooperativeGestures&&!this._map.isMoving()){if(1===i.length&&!rt())return void this._showTouchPanBlockerAlert();"hidden"!==this._alertContainer.style.visibility&&(this._alertContainer.style.visibility="hidden",clearTimeout(this._alertTimer));}return t.cancelable&&t.preventDefault(),this._calculateTransform(t,e,i)}}touchend(t,e,i){this._calculateTransform(t,e,i),this._active&&i.length<this._minTouches&&this.reset();}touchcancel(){this.reset();}_calculateTransform(t,e,i){i.length>0&&(this._active=!0);const r=qA(i,e),n=new y(0,0),o=new y(0,0);let s=0;for(const t in r){const e=r[t],i=this._touches[t];i&&(n._add(e),o._add(e.sub(i)),s++,r[t]=e);}if(this._touches=r,s<this._minTouches||!o.mag())return;const a=o.div(s);return this._sum._add(a),this._sum.mag()<this._clickTolerance?void 0:{around:n.div(s),panDelta:a}}enable(){this._enabled=!0,this._map._cooperativeGestures&&(this._addTouchPanBlocker(),this._el.classList.add("mapboxgl-touch-pan-blocker-override","mapboxgl-scrollable-page"));}disable(){this._enabled=!1,this._map._cooperativeGestures&&(clearTimeout(this._alertTimer),this._alertContainer.remove(),this._el.classList.remove("mapboxgl-touch-pan-blocker-override","mapboxgl-scrollable-page")),this.reset();}isEnabled(){return !!this._enabled}isActive(){return !!this._active}_addTouchPanBlocker(){this._map&&!this._alertContainer&&(this._alertContainer=de("div","mapboxgl-touch-pan-blocker",this._map._container),this._alertContainer.textContent=this._map._getUIString("TouchPanBlocker.Message"),this._alertContainer.style.fontSize=`${Math.max(10,Math.min(24,Math.floor(.05*this._el.clientWidth)))}px`);}_showTouchPanBlockerAlert(){this._alertContainer.style.visibility="visible",this._alertContainer.classList.add("mapboxgl-touch-pan-blocker-show"),this._alertContainer.setAttribute("role","alert"),clearTimeout(this._alertTimer),this._alertTimer=setTimeout((()=>{this._alertContainer.classList.remove("mapboxgl-touch-pan-blocker-show"),this._alertContainer.setAttribute("role","null");}),500);}}class tS{constructor(){this.reset();}reset(){this._active=!1,this._firstTwoTouches=void 0;}_start(t){}_move(t,e,i){return {}}touchstart(t,e,i){this._firstTwoTouches||i.length<2||(this._firstTwoTouches=[i[0].identifier,i[1].identifier],this._start([e[0],e[1]]));}touchmove(t,e,i){const r=this._firstTwoTouches;if(!r)return;t.preventDefault();const[n,o]=r,s=eS(i,e,n),a=eS(i,e,o);if(!s||!a)return;const l=this._aroundCenter?null:s.add(a).div(2);return this._move([s,a],l,t)}touchend(t,e,i){if(!this._firstTwoTouches)return;const[r,n]=this._firstTwoTouches,o=eS(i,e,r),s=eS(i,e,n);o&&s||(this._active&&ve(),this.reset());}touchcancel(){this.reset();}enable(t){this._enabled=!0,this._aroundCenter=!!t&&"center"===t.around;}disable(){this._enabled=!1,this.reset();}isEnabled(){return this._enabled}isActive(){return this._active}}function eS(t,e,i){for(let r=0;r<t.length;r++)if(t[r].identifier===i)return e[r]}function iS(t,e){return Math.log(t/e)/Math.LN2}class rS extends tS{reset(){super.reset(),this._distance=0,this._startDistance=0;}_start(t){this._startDistance=this._distance=t[0].dist(t[1]);}_move(t,e){const i=this._distance;if(this._distance=t[0].dist(t[1]),this._active||!(Math.abs(iS(this._distance,this._startDistance))<.1))return this._active=!0,{zoomDelta:iS(this._distance,i),pinchAround:e}}}function nS(t,e){return 180*t.angleWith(e)/Math.PI}class oS extends tS{reset(){super.reset(),this._minDiameter=0,this._startVector=void 0,this._vector=void 0;}_start(t){this._startVector=this._vector=t[0].sub(t[1]),this._minDiameter=t[0].dist(t[1]);}_move(t,e){const i=this._vector;if(this._vector=t[0].sub(t[1]),i&&(this._active||!this._isBelowThreshold(this._vector)))return this._active=!0,{bearingDelta:nS(this._vector,i),pinchAround:e}}_isBelowThreshold(t){this._minDiameter=Math.min(this._minDiameter,t.mag());const e=25/(Math.PI*this._minDiameter)*360,i=this._startVector;if(!i)return !1;const r=nS(t,i);return Math.abs(r)<e}}function sS(t){return Math.abs(t.y)>Math.abs(t.x)}class aS extends tS{constructor(t){super(),this._map=t;}reset(){super.reset(),this._valid=void 0,this._firstMove=void 0,this._lastPoints=void 0;}_start(t){this._lastPoints=t,sS(t[0].sub(t[1]))&&(this._valid=!1);}_move(t,e,i){const r=this._lastPoints;if(!r)return;const n=t[0].sub(r[0]),o=t[1].sub(r[1]);return this._map._cooperativeGestures&&!rt()&&i.touches.length<3||(this._valid=this.gestureBeginsVertically(n,o,i.timeStamp),!this._valid)?void 0:(this._lastPoints=t,this._active=!0,{pitchDelta:(n.y+o.y)/2*-.5})}gestureBeginsVertically(t,e,i){if(void 0!==this._valid)return this._valid;const r=t.mag()>=2,n=e.mag()>=2;if(!r&&!n)return;if(!r||!n)return null==this._firstMove&&(this._firstMove=i),i-this._firstMove<100&&void 0;const o=t.y>0==e.y>0;return sS(t)&&sS(e)&&o}}const lS={panStep:100,bearingStep:15,pitchStep:10};class cS{constructor(){const t=lS;this._panStep=t.panStep,this._bearingStep=t.bearingStep,this._pitchStep=t.pitchStep,this._rotationDisabled=!1;}blur(){this.reset();}reset(){this._active=!1;}keydown(t){if(t.altKey||t.ctrlKey||t.metaKey)return;let e=0,i=0,r=0,n=0,o=0;switch(t.keyCode){case 61:case 107:case 171:case 187:e=1;break;case 189:case 109:case 173:e=-1;break;case 37:t.shiftKey?i=-1:(t.preventDefault(),n=-1);break;case 39:t.shiftKey?i=1:(t.preventDefault(),n=1);break;case 38:t.shiftKey?r=1:(t.preventDefault(),o=-1);break;case 40:t.shiftKey?r=-1:(t.preventDefault(),o=1);break;default:return}return this._rotationDisabled&&(i=0,r=0),{cameraAnimation:s=>{const a=s.getZoom();s.easeTo({duration:300,easeId:"keyboardHandler",easing:hS,zoom:e?Math.round(a)+e*(t.shiftKey?2:1):a,bearing:s.getBearing()+i*this._bearingStep,pitch:s.getPitch()+r*this._pitchStep,offset:[-n*this._panStep,-o*this._panStep],center:s.getCenter()},{originalEvent:t});}}}enable(){this._enabled=!0;}disable(){this._enabled=!1,this.reset();}isEnabled(){return this._enabled}isActive(){return this._active}disableRotation(){this._rotationDisabled=!0;}enableRotation(){this._rotationDisabled=!1;}}function hS(t){return t*(2-t)}const uS=4.000244140625;class dS{constructor(t,e){this._map=t,this._el=t.getCanvasContainer(),this._handler=e,this._delta=0,this._defaultZoomRate=.01,this._wheelZoomRate=.0022222222222222222,j(["_onTimeout","_addScrollZoomBlocker","_showBlockerAlert"],this);}setZoomRate(t){this._defaultZoomRate=t;}setWheelZoomRate(t){this._wheelZoomRate=t;}isEnabled(){return !!this._enabled}isActive(){return this._active||void 0!==this._finishTimeout}isZooming(){return !!this._zooming}enable(t){this.isEnabled()||(this._enabled=!0,this._aroundCenter=!!t&&"center"===t.around,this._map._cooperativeGestures&&this._addScrollZoomBlocker());}disable(){this.isEnabled()&&(this._enabled=!1,this._map._cooperativeGestures&&(clearTimeout(this._alertTimer),this._alertContainer.remove()));}wheel(t){if(!this.isEnabled())return;if(this._map._cooperativeGestures){if(!(t.ctrlKey||t.metaKey||this.isZooming()||rt()))return void this._showBlockerAlert();"hidden"!==this._alertContainer.style.visibility&&(this._alertContainer.style.visibility="hidden",clearTimeout(this._alertTimer));}let i=t.deltaMode===e.WheelEvent.DOM_DELTA_LINE?40*t.deltaY:t.deltaY;const r=ue.now(),n=r-(this._lastWheelEventTime||0);this._lastWheelEventTime=r,0!==i&&i%uS==0?this._type="wheel":0!==i&&Math.abs(i)<4?this._type="trackpad":n>400?(this._type=null,this._lastValue=i,this._timeout=setTimeout(this._onTimeout,40,t)):this._type||(this._type=Math.abs(n*i)<200?"trackpad":"wheel",this._timeout&&(clearTimeout(this._timeout),this._timeout=null,i+=this._lastValue)),t.shiftKey&&i&&(i/=4),this._type&&(this._lastWheelEvent=t,this._delta-=i,this._active||this._start(t)),t.preventDefault();}_onTimeout(t){this._type="wheel",this._delta-=this._lastValue,this._active||this._start(t);}_start(t){if(!this._delta)return;this._frameId&&(this._frameId=null),this._active=!0,this.isZooming()||(this._zooming=!0),this._finishTimeout&&(clearTimeout(this._finishTimeout),delete this._finishTimeout);const e=be(this._el,t);this._aroundPoint=this._aroundCenter?this._map.transform.centerPoint:e,this._aroundCoord=this._map.transform.pointCoordinate3D(this._aroundPoint),this._targetZoom=void 0,this._frameId||(this._frameId=!0,this._handler._triggerRenderFrame());}renderFrame(){if(!this._frameId)return;if(this._frameId=null,!this.isActive())return;const t=this._map.transform;"wheel"===this._type&&t.projection.wrap&&(t._center.lng>=180||t._center.lng<=-180)&&(this._prevEase=null,this._easing=null,this._lastWheelEvent=null,this._lastWheelEventTime=0);const e=()=>t._terrainEnabled()&&this._aroundCoord?t.computeZoomRelativeTo(this._aroundCoord):t.zoom;if(0!==this._delta){const i="wheel"===this._type&&Math.abs(this._delta)>uS?this._wheelZoomRate:this._defaultZoomRate;let r=2/(1+Math.exp(-Math.abs(this._delta*i)));this._delta<0&&0!==r&&(r=1/r);const n=e(),o=Math.pow(2,n),s="number"==typeof this._targetZoom?t.zoomScale(this._targetZoom):o;this._targetZoom=Math.min(t.maxZoom,Math.max(t.minZoom,t.scaleZoom(s*r))),"wheel"===this._type&&(this._startZoom=n,this._easing=this._smoothOutEasing(200)),this._delta=0;}const i="number"==typeof this._targetZoom?this._targetZoom:e(),r=this._startZoom,n=this._easing;let o,s=!1;if("wheel"===this._type&&r&&n){const t=Math.min((ue.now()-this._lastWheelEventTime)/200,1);o=Wr(r,i,n(t)),t<1?this._frameId||(this._frameId=!0):s=!0;}else o=i,s=!0;return this._active=!0,s&&(this._active=!1,this._finishTimeout=setTimeout((()=>{this._zooming=!1,this._handler._triggerRenderFrame(),delete this._targetZoom,delete this._finishTimeout;}),200)),{noInertia:!0,needsRenderFrame:!s,zoomDelta:o-e(),around:this._aroundPoint,aroundCoord:this._aroundCoord,originalEvent:this._lastWheelEvent}}_smoothOutEasing(t){let e=C;if(this._prevEase){const t=this._prevEase,i=(ue.now()-t.start)/t.duration,r=t.easing(i+.01)-t.easing(i),n=.27/Math.sqrt(r*r+1e-4)*.01;e=I(n,Math.sqrt(.0729-n*n),.25,1);}return this._prevEase={start:ue.now(),duration:t,easing:e},e}blur(){this.reset();}reset(){this._active=!1;}_addScrollZoomBlocker(){this._map&&!this._alertContainer&&(this._alertContainer=de("div","mapboxgl-scroll-zoom-blocker",this._map._container),this._alertContainer.textContent=/(Mac|iPad)/i.test(e.navigator.userAgent)?this._map._getUIString("ScrollZoomBlocker.CmdMessage"):this._map._getUIString("ScrollZoomBlocker.CtrlMessage"),this._alertContainer.style.fontSize=`${Math.max(10,Math.min(24,Math.floor(.05*this._el.clientWidth)))}px`);}_showBlockerAlert(){this._alertContainer.style.visibility="visible",this._alertContainer.classList.add("mapboxgl-scroll-zoom-blocker-show"),this._alertContainer.setAttribute("role","alert"),clearTimeout(this._alertTimer),this._alertTimer=setTimeout((()=>{this._alertContainer.classList.remove("mapboxgl-scroll-zoom-blocker-show"),this._alertContainer.setAttribute("role","null");}),200);}}class pS{constructor(t,e){this._clickZoom=t,this._tapZoom=e;}enable(){this._clickZoom.enable(),this._tapZoom.enable();}disable(){this._clickZoom.disable(),this._tapZoom.disable();}isEnabled(){return this._clickZoom.isEnabled()&&this._tapZoom.isEnabled()}isActive(){return this._clickZoom.isActive()||this._tapZoom.isActive()}}class fS{constructor(){this.reset();}reset(){this._active=!1;}blur(){this.reset();}dblclick(t,e){return t.preventDefault(),{cameraAnimation:i=>{i.easeTo({duration:300,zoom:i.getZoom()+(t.shiftKey?-1:1),around:i.unproject(e)},{originalEvent:t});}}}enable(){this._enabled=!0;}disable(){this._enabled=!1,this.reset();}isEnabled(){return this._enabled}isActive(){return this._active}}class mS{constructor(){this._tap=new $A({numTouches:1,numTaps:1}),this.reset();}reset(){this._active=!1,this._swipePoint=void 0,this._swipeTouch=0,this._tapTime=0,this._tap.reset();}touchstart(t,e,i){this._swipePoint||(this._tapTime&&t.timeStamp-this._tapTime>500&&this.reset(),this._tapTime?i.length>0&&(this._swipePoint=e[0],this._swipeTouch=i[0].identifier):this._tap.touchstart(t,e,i));}touchmove(t,e,i){if(this._tapTime){if(this._swipePoint){if(i[0].identifier!==this._swipeTouch)return;const r=e[0],n=r.y-this._swipePoint.y;return this._swipePoint=r,t.preventDefault(),this._active=!0,{zoomDelta:n/128}}}else this._tap.touchmove(t,e,i);}touchend(t,e,i){this._tapTime?this._swipePoint&&0===i.length&&this.reset():this._tap.touchend(t,e,i)&&(this._tapTime=t.timeStamp);}touchcancel(){this.reset();}enable(){this._enabled=!0;}disable(){this._enabled=!1,this.reset();}isEnabled(){return this._enabled}isActive(){return this._active}}class _S{constructor(t,e,i){this._el=t,this._mousePan=e,this._touchPan=i;}enable(t){this._inertiaOptions=t||{},this._mousePan.enable(),this._touchPan.enable(),this._el.classList.add("mapboxgl-touch-drag-pan");}disable(){this._mousePan.disable(),this._touchPan.disable(),this._el.classList.remove("mapboxgl-touch-drag-pan");}isEnabled(){return this._mousePan.isEnabled()&&this._touchPan.isEnabled()}isActive(){return this._mousePan.isActive()||this._touchPan.isActive()}}class gS{constructor(t,e,i){this._pitchWithRotate=t.pitchWithRotate,this._mouseRotate=e,this._mousePitch=i;}enable(){this._mouseRotate.enable(),this._pitchWithRotate&&this._mousePitch.enable();}disable(){this._mouseRotate.disable(),this._mousePitch.disable();}isEnabled(){return this._mouseRotate.isEnabled()&&(!this._pitchWithRotate||this._mousePitch.isEnabled())}isActive(){return this._mouseRotate.isActive()||this._mousePitch.isActive()}}class yS{constructor(t,e,i,r){this._el=t,this._touchZoom=e,this._touchRotate=i,this._tapDragZoom=r,this._rotationDisabled=!1,this._enabled=!0;}enable(t){this._touchZoom.enable(t),this._rotationDisabled||this._touchRotate.enable(t),this._tapDragZoom.enable(),this._el.classList.add("mapboxgl-touch-zoom-rotate");}disable(){this._touchZoom.disable(),this._touchRotate.disable(),this._tapDragZoom.disable(),this._el.classList.remove("mapboxgl-touch-zoom-rotate");}isEnabled(){return this._touchZoom.isEnabled()&&(this._rotationDisabled||this._touchRotate.isEnabled())&&this._tapDragZoom.isEnabled()}isActive(){return this._touchZoom.isActive()||this._touchRotate.isActive()||this._tapDragZoom.isActive()}disableRotation(){this._rotationDisabled=!0,this._touchRotate.disable();}enableRotation(){this._rotationDisabled=!1,this._touchZoom.isEnabled()&&this._touchRotate.enable();}}const xS=t=>t.zoom||t.drag||t.pitch||t.rotate;class vS extends Se{}class bS{constructor(){this.constants=[1,1,.01],this.radius=0;}setup(t,e){const i=bu.sub([],e,t);this.radius=bu.length(i[2]<0?bu.div([],i,this.constants):[i[0],i[1],0]);}projectRay(t){bu.div(t,t,this.constants),bu.normalize(t,t),bu.mul(t,t,this.constants);const e=bu.scale([],t,this.radius);if(e[2]>0){const t=bu.scale([],[0,0,1],bu.dot(e,[0,0,1])),i=bu.scale([],bu.normalize([],[e[0],e[1],0]),this.radius),r=bu.add([],e,bu.scale([],bu.sub([],bu.add([],i,t),e),2));e[0]=r[0],e[1]=r[1];}return e}}function wS(t){return t.panDelta&&t.panDelta.mag()||t.zoomDelta||t.bearingDelta||t.pitchDelta}class TS{constructor(t,i){this._map=t,this._el=this._map.getCanvasContainer(),this._handlers=[],this._handlersById={},this._changes=[],this._inertia=new kA(t),this._bearingSnap=i.bearingSnap,this._previousActiveHandlers={},this._trackingEllipsoid=new bS,this._dragOrigin=null,this._eventsInProgress={},this._addDefaultHandlers(i),j(["handleEvent","handleWindowEvent"],this);const r=this._el;this._listeners=[[r,"touchstart",{passive:!0}],[r,"touchmove",{passive:!1}],[r,"touchend",void 0],[r,"touchcancel",void 0],[r,"mousedown",void 0],[r,"mousemove",void 0],[r,"mouseup",void 0],[e.document,"mousemove",{capture:!0}],[e.document,"mouseup",void 0],[r,"mouseover",void 0],[r,"mouseout",void 0],[r,"dblclick",void 0],[r,"click",void 0],[r,"keydown",{capture:!1}],[r,"keyup",void 0],[r,"wheel",{passive:!1}],[r,"contextmenu",void 0],[e,"blur",void 0]];for(const[t,i,r]of this._listeners)t.addEventListener(i,t===e.document?this.handleWindowEvent:this.handleEvent,r);}destroy(){for(const[t,i,r]of this._listeners)t.removeEventListener(i,t===e.document?this.handleWindowEvent:this.handleEvent,r);}_addDefaultHandlers(t){const e=this._map,i=e.getCanvasContainer();this._add("mapEvent",new VA(e,t));const r=e.boxZoom=new GA(e,t);this._add("boxZoom",r);const n=new HA,o=new fS;e.doubleClickZoom=new pS(o,n),this._add("tapZoom",n),this._add("clickZoom",o);const s=new mS;this._add("tapDragZoom",s);const a=e.touchPitch=new aS(e);this._add("touchPitch",a);const l=new KA(t),c=new JA(t);e.dragRotate=new gS(t,l,c),this._add("mouseRotate",l,["mousePitch"]),this._add("mousePitch",c,["mouseRotate"]);const h=new YA(t),u=new QA(e,t);e.dragPan=new _S(i,h,u),this._add("mousePan",h),this._add("touchPan",u,["touchZoom","touchRotate"]);const d=new oS,p=new rS;e.touchZoomRotate=new yS(i,p,d,s),this._add("touchRotate",d,["touchPan","touchZoom"]),this._add("touchZoom",p,["touchPan","touchRotate"]),this._add("blockableMapEvent",new jA(e));const f=e.scrollZoom=new dS(e,this);this._add("scrollZoom",f,["mousePan"]);const m=e.keyboard=new cS;this._add("keyboard",m);for(const i of ["boxZoom","doubleClickZoom","tapDragZoom","touchPitch","dragRotate","dragPan","touchZoomRotate","scrollZoom","keyboard"])t.interactive&&t[i]&&e[i].enable(t[i]);}_add(t,e,i){this._handlers.push({handlerName:t,handler:e,allowed:i}),this._handlersById[t]=e;}stop(t){if(!this._updatingCamera){for(const{handler:t}of this._handlers)t.reset();this._inertia.clear(),this._fireEvents({},{},t),this._changes=[];}}isActive(){for(const{handler:t}of this._handlers)if(t.isActive())return !0;return !1}isZooming(){return !!this._eventsInProgress.zoom||this._map.scrollZoom.isZooming()}isRotating(){return !!this._eventsInProgress.rotate}isMoving(){return !!xS(this._eventsInProgress)||this.isZooming()}_isDragging(){return !!this._eventsInProgress.drag}_blockedByActive(t,e,i){for(const r in t)if(r!==i&&(!e||e.indexOf(r)<0))return !0;return !1}handleWindowEvent(t){this.handleEvent(t,`${t.type}Window`);}_getMapTouches(t){const e=[];for(const i of t)this._el.contains(i.target)&&e.push(i);return e}handleEvent(t,e){this._updatingCamera=!0;const i="renderFrame"===t.type,r=i?void 0:t,n={needsRenderFrame:!1},o={},s={},a=t.touches?this._getMapTouches(t.touches):void 0,l=a?we(this._el,a):i?void 0:be(this._el,t);for(const{handlerName:i,handler:c,allowed:h}of this._handlers){if(!c.isEnabled())continue;let u;this._blockedByActive(s,h,i)?c.reset():c[e||t.type]&&(u=c[e||t.type](t,l,a),this.mergeHandlerResult(n,o,u,i,r),u&&u.needsRenderFrame&&this._triggerRenderFrame()),(u||c.isActive())&&(s[i]=c);}const c={};for(const t in this._previousActiveHandlers)s[t]||(c[t]=r);this._previousActiveHandlers=s,(Object.keys(c).length||wS(n))&&(this._changes.push([n,o,c]),this._triggerRenderFrame()),(Object.keys(s).length||wS(n))&&this._map._stop(!0),this._updatingCamera=!1;const{cameraAnimation:h}=n;h&&(this._inertia.clear(),this._fireEvents({},{},!0),this._changes=[],h(this._map));}mergeHandlerResult(t,e,i,r,n){if(!i)return;k(t,i);const o={handlerName:r,originalEvent:i.originalEvent||n};void 0!==i.zoomDelta&&(e.zoom=o),void 0!==i.panDelta&&(e.drag=o),void 0!==i.pitchDelta&&(e.pitch=o),void 0!==i.bearingDelta&&(e.rotate=o);}_applyChanges(){const t={},e={},i={};for(const[r,n,o]of this._changes)r.panDelta&&(t.panDelta=(t.panDelta||new y(0,0))._add(r.panDelta)),r.zoomDelta&&(t.zoomDelta=(t.zoomDelta||0)+r.zoomDelta),r.bearingDelta&&(t.bearingDelta=(t.bearingDelta||0)+r.bearingDelta),r.pitchDelta&&(t.pitchDelta=(t.pitchDelta||0)+r.pitchDelta),void 0!==r.around&&(t.around=r.around),void 0!==r.aroundCoord&&(t.aroundCoord=r.aroundCoord),void 0!==r.pinchAround&&(t.pinchAround=r.pinchAround),r.noInertia&&(t.noInertia=r.noInertia),k(e,n),k(i,o);this._updateMapTransform(t,e,i),this._changes=[];}_updateMapTransform(t,e,i){const r=this._map,n=r.transform,o=t=>[t.x,t.y,t.z];if((t=>{const e=this._eventsInProgress.drag;return e&&!this._handlersById[e.handlerName].isActive()})()&&!wS(t)){const t=n.zoom;n.cameraElevationReference="sea",n.recenterOnTerrain(),n.cameraElevationReference="ground",t!==n.zoom&&this._map._update(!0);}if(n._isCameraConstrained&&r._stop(!0),!wS(t))return void this._fireEvents(e,i,!0);let{panDelta:s,zoomDelta:a,bearingDelta:l,pitchDelta:c,around:h,aroundCoord:u,pinchAround:d}=t;n._isCameraConstrained&&(a>0&&(a=0),n._isCameraConstrained=!1),void 0!==d&&(h=d),(a||(t=>e[t]&&!this._eventsInProgress[t])("drag"))&&h&&(this._dragOrigin=o(n.pointCoordinate3D(h)),this._trackingEllipsoid.setup(n._camera.position,this._dragOrigin)),n.cameraElevationReference="sea",r._stop(!0),h=h||r.transform.centerPoint,l&&(n.bearing+=l),c&&(n.pitch+=c),n._updateCameraState();const p=[0,0,0];if(s)if("mercator"===n.projection.name){const t=this._trackingEllipsoid.projectRay(n.screenPointToMercatorRay(h).dir),e=this._trackingEllipsoid.projectRay(n.screenPointToMercatorRay(h.sub(s)).dir);p[0]=e[0]-t[0],p[1]=e[1]-t[1];}else {const t=n.pointCoordinate(h);if("globe"===n.projection.name){s=s.rotate(-n.angle);const e=n._pixelsPerMercatorPixel/n.worldSize;p[0]=-s.x*Wd(Gd(t.y))*e,p[1]=-s.y*Wd(n.center.lat)*e;}else {const e=n.pointCoordinate(h.sub(s));t&&e&&(p[0]=e.x-t.x,p[1]=e.y-t.y);}}const f=n.zoom,m=[0,0,0];if(a){const t=o(u||n.pointCoordinate3D(h)),e={dir:bu.normalize([],bu.sub([],t,n._camera.position))};if(e.dir[2]<0){const i=n.zoomDeltaToMovement(t,a);bu.scale(m,e.dir,i);}}const _=bu.add(p,p,m);n._translateCameraConstrained(_),a&&Math.abs(n.zoom-f)>1e-4&&n.recenterOnTerrain(),n.cameraElevationReference="ground",this._map._update(),t.noInertia||this._inertia.record(t),this._fireEvents(e,i,!0);}_fireEvents(t,e,i){const r=xS(this._eventsInProgress),n=xS(t),o={};for(const e in t){const{originalEvent:i}=t[e];this._eventsInProgress[e]||(o[`${e}start`]=i),this._eventsInProgress[e]=t[e];}!r&&n&&this._fireEvent("movestart",n.originalEvent);for(const t in o)this._fireEvent(t,o[t]);n&&this._fireEvent("move",n.originalEvent);for(const e in t){const{originalEvent:i}=t[e];this._fireEvent(e,i);}const s={};let a;for(const t in this._eventsInProgress){const{handlerName:i,originalEvent:r}=this._eventsInProgress[t];this._handlersById[i].isActive()||(delete this._eventsInProgress[t],a=e[i]||r,s[`${t}end`]=a);}for(const t in s)this._fireEvent(t,s[t]);const l=xS(this._eventsInProgress);if(i&&(r||n)&&!l){this._updatingCamera=!0;const t=this._inertia._onMoveEnd(this._map.dragPan._inertiaOptions),e=t=>0!==t&&-this._bearingSnap<t&&t<this._bearingSnap;t?(e(t.bearing||this._map.getBearing())&&(t.bearing=0),this._map.easeTo(t,{originalEvent:a})):(this._map.fire(new Se("moveend",{originalEvent:a})),e(this._map.getBearing())&&this._map.resetNorth()),this._updatingCamera=!1;}}_fireEvent(t,e){this._map.fire(new Se(t,e?{originalEvent:e}:{}));}_requestFrame(){return this._map.triggerRepaint(),this._map._renderTaskQueue.add((t=>{this._frameId=void 0,this.handleEvent(new vS("renderFrame",{timeStamp:t})),this._applyChanges();}))}_triggerRenderFrame(){void 0===this._frameId&&(this._frameId=this._requestFrame());}}const ES="map.setFreeCameraOptions(...) and map.getFreeCameraOptions() are not yet supported for non-mercator projections.";class MS extends Ce{constructor(t,e){super(),this._moving=!1,this._zooming=!1,this.transform=t,this._bearingSnap=e.bearingSnap,this._respectPrefersReducedMotion=!1!==e.respectPrefersReducedMotion,j(["_renderFrameCallback"],this);}getCenter(){return new Id(this.transform.center.lng,this.transform.center.lat)}setCenter(t,e){return this.jumpTo({center:t},e)}panBy(t,e,i){return t=y.convert(t).mult(-1),this.panTo(this.transform.center,k({offset:t},e),i)}panTo(t,e,i){return this.easeTo(k({center:t},e),i)}getZoom(){return this.transform.zoom}setZoom(t,e){return this.jumpTo({zoom:t},e),this}zoomTo(t,e,i){return this.easeTo(k({zoom:t},e),i)}zoomIn(t,e){return this.zoomTo(this.getZoom()+1,t,e),this}zoomOut(t,e){return this.zoomTo(this.getZoom()-1,t,e),this}getBearing(){return this.transform.bearing}setBearing(t,e){return this.jumpTo({bearing:t},e),this}getPadding(){return this.transform.padding}setPadding(t,e){return this.jumpTo({padding:t},e),this}rotateTo(t,e,i){return this.easeTo(k({bearing:t},e),i)}resetNorth(t,e){return this.rotateTo(0,k({duration:1e3},t),e),this}resetNorthPitch(t,e){return this.easeTo(k({bearing:0,pitch:0,duration:1e3},t),e),this}snapToNorth(t,e){return Math.abs(this.getBearing())<this._bearingSnap?this.resetNorth(t,e):this}getPitch(){return this.transform.pitch}setPitch(t,e){return this.jumpTo({pitch:t},e),this}cameraForBounds(t,e){t=Xl.convert(t);const i=e&&e.bearing||0,r=e&&e.pitch||0,n=t.getNorthWest(),o=t.getSouthEast();return this._cameraForBounds(this.transform,n,o,i,r,e)}_extendCameraOptions(t){const e={top:0,bottom:0,right:0,left:0};if("number"==typeof(t=k({padding:e,offset:[0,0],maxZoom:this.transform.maxZoom},t)).padding){const e=t.padding;t.padding={top:e,bottom:e,right:e,left:e};}return t.padding=k(e,t.padding),t}_minimumAABBFrustumDistance(t,e){const i=e.max[0]-e.min[0],r=e.max[1]-e.min[1];return i/r>t.aspect?i/(2*Math.tan(.5*t.fovX)*t.aspect):r/(2*Math.tan(.5*t.fovY)*t.aspect)}_cameraForBoundsOnGlobe(t,e,i,r,n,o){const s=t.clone(),a=this._extendCameraOptions(o);s.bearing=r,s.pitch=n;const l=Id.convert(e),c=Id.convert(i),h=.5*(l.lat+c.lat),u=.5*(l.lng+c.lng),d=nd(h,u),p=bu.normalize([],d),f=bu.normalize([],bu.cross([],p,[0,1,0])),m=bu.cross([],f,p),_=[f[0],f[1],f[2],0,m[0],m[1],m[2],0,p[0],p[1],p[2],0,0,0,0,1],g=[d,nd(l.lat,l.lng),nd(c.lat,l.lng),nd(c.lat,c.lng),nd(l.lat,c.lng),nd(h,l.lng),nd(h,c.lng),nd(l.lat,u),nd(c.lat,u)];let y=Bu.fromPoints(g.map((t=>[bu.dot(f,t),bu.dot(m,t),bu.dot(p,t)])));const x=bu.transformMat4([],y.center,_);0===bu.squaredLength(x)&&bu.set(x,0,0,1),bu.normalize(x,x),bu.scale(x,x,Nu),s.center=function([t,e,i]){const r=Math.hypot(t,e,i),n=Math.atan2(t,i),o=.5*Math.PI-Math.acos(-e/r);return new Id(T(n),T(o))}(x);const v=s.getWorldToCameraMatrix(),b=mu.invert(new Float64Array(16),v);y=Bu.applyTransform(y,mu.multiply([],v,_)),bu.transformMat4(x,x,v);const w=.5*(y.max[2]-y.min[2]),E=this._minimumAABBFrustumDistance(s,y),M=bu.scale([],[0,0,1],w),A=bu.add(M,x,M),S=E+(0===s.pitch?0:bu.distance(x,A)),I=s.globeCenterInViewSpace,C=bu.sub([],x,[I[0],I[1],I[2]]);bu.normalize(C,C),bu.scale(C,C,S);const z=bu.add([],x,C);bu.transformMat4(z,z,b);const D=Md/Nu,P=bu.length(z),R=Vd(Math.max(P*D-Md,Number.EPSILON),0),L=Math.min(s.zoomFromMercatorZAdjusted(R),a.maxZoom);return L>.5*(Ou+Fu)?(s.setProjection({name:"mercator"}),s.zoom=L,this._cameraForBounds(s,e,i,r,n,o)):{center:s.center,zoom:L,bearing:r,pitch:n}}queryTerrainElevation(t,e){const i=this.transform.elevation;return i?(e=k({},{exaggerated:!0},e),i.getAtPoint(Yd.fromLngLat(t),null,e.exaggerated)):null}_cameraForBounds(t,e,i,r,n,o){if("globe"===t.projection.name)return this._cameraForBoundsOnGlobe(t,e,i,r,n,o);const s=t.clone(),a=this._extendCameraOptions(o),l=s.padding;s.bearing=r,s.pitch=n;const c=Id.convert(e),h=Id.convert(i),u=new Id(c.lng,h.lat),d=new Id(h.lng,c.lat),p=s.project(c),f=s.project(h),m=this.queryTerrainElevation(c),_=this.queryTerrainElevation(h),g=this.queryTerrainElevation(u),x=this.queryTerrainElevation(d),v=[[p.x,p.y,Math.min(m||0,_||0,g||0,x||0)],[f.x,f.y,Math.max(m||0,_||0,g||0,x||0)]];let b=Bu.fromPoints(v);const T=s.getWorldToCameraMatrix(),E=mu.invert(new Float64Array(16),T);b=Bu.applyTransform(b,T);const M=bu.sub([],b.max,b.min),A=l.left||0,S=l.right||0,I=l.bottom||0,C=l.top||0,{left:z,right:D,top:P,bottom:R}=a.padding,L=.5*(A+S),k=.5*(C+I),B=Math.min(s.scaleZoom(s.scale*Math.min((s.width-(A+S+z+D))/M[0],(s.height-(I+C+R+P))/M[1])),a.maxZoom),O=s.scale/s.zoomScale(B);b=new Bu([b.min[0]-(z+L)*O,b.min[1]-(R+k)*O,b.min[2]],[b.max[0]+(D+L)*O,b.max[1]+(P+k)*O,b.max[2]]);const F=.5*M[2],N=this._minimumAABBFrustumDistance(s,b),U=[0,0,1,0];au.transformMat4(U,U,T),au.normalize(U,U);const V=bu.scale([],U,N+F),j=bu.add([],b.center,V),G=("number"==typeof a.offset.x&&"number"==typeof a.offset.y?new y(a.offset.x,a.offset.y):y.convert(a.offset)).rotate(-w(r));b.center[0]-=G.x*O,b.center[1]+=G.y*O,bu.transformMat4(b.center,b.center,E),bu.transformMat4(j,j,E);const q=[b.center[0],b.center[1],j[2]*s.pixelsPerMeter];bu.scale(q,q,1/s.worldSize);const Z=jd(q[0]),$=Gd(q[1]),H=Math.min(s._zoomFromMercatorZ(q[2]),a.maxZoom),W=new Id(Z,$);return s.mercatorFromTransition&&H<.5*(Ou+Fu)?(s.setProjection({name:"globe"}),s.zoom=H,this._cameraForBounds(s,e,i,r,n,o)):{center:W,zoom:H,bearing:r,pitch:n}}fitBounds(t,e,i){const r=this.cameraForBounds(t,e);return this._fitInternal(r,e,i)}fitScreenCoordinates(t,e,i,r,n){const o=y.convert(t),s=y.convert(e),a=new y(Math.min(o.x,s.x),Math.min(o.y,s.y)),l=new y(Math.max(o.x,s.x),Math.max(o.y,s.y));if("mercator"===this.transform.projection.name&&this.transform.anyCornerOffEdge(o,s))return this;const c=this.transform.pointLocation3D(a),h=this.transform.pointLocation3D(l),u=this.transform.pointLocation3D(new y(a.x,l.y)),d=this.transform.pointLocation3D(new y(l.x,a.y)),p=[Math.min(c.lng,h.lng,u.lng,d.lng),Math.min(c.lat,h.lat,u.lat,d.lat)],f=[Math.max(c.lng,h.lng,u.lng,d.lng),Math.max(c.lat,h.lat,u.lat,d.lat)],m=r&&r.pitch?r.pitch:this.getPitch(),_=this._cameraForBounds(this.transform,p,f,i,m,r);return this._fitInternal(_,r,n)}_fitInternal(t,e,i){return t?(delete(e=k(t,e)).padding,e.linear?this.easeTo(e,i):this.flyTo(e,i)):this}jumpTo(t,e){this.stop();const i=t.preloadOnly?this.transform.clone():this.transform;let r=!1,n=!1,o=!1;return "zoom"in t&&i.zoom!==+t.zoom&&(r=!0,i.zoom=+t.zoom),void 0!==t.center&&(i.center=Id.convert(t.center)),"bearing"in t&&i.bearing!==+t.bearing&&(n=!0,i.bearing=+t.bearing),"pitch"in t&&i.pitch!==+t.pitch&&(o=!0,i.pitch=+t.pitch),null==t.padding||i.isPaddingEqual(t.padding)||(i.padding=t.padding),t.preloadOnly?(this._preloadTiles(i),this):(this.fire(new Se("movestart",e)).fire(new Se("move",e)),r&&this.fire(new Se("zoomstart",e)).fire(new Se("zoom",e)).fire(new Se("zoomend",e)),n&&this.fire(new Se("rotatestart",e)).fire(new Se("rotate",e)).fire(new Se("rotateend",e)),o&&this.fire(new Se("pitchstart",e)).fire(new Se("pitch",e)).fire(new Se("pitchend",e)),this.fire(new Se("moveend",e)))}getFreeCameraOptions(){return this.transform.projection.supportsFreeCamera||W(ES),this.transform.getFreeCameraOptions()}setFreeCameraOptions(t,e){const i=this.transform;if(!i.projection.supportsFreeCamera)return W(ES),this;this.stop();const r=i.zoom,n=i.pitch,o=i.bearing;i.setFreeCameraOptions(t);const s=r!==i.zoom,a=n!==i.pitch,l=o!==i.bearing;return this.fire(new Se("movestart",e)).fire(new Se("move",e)),s&&this.fire(new Se("zoomstart",e)).fire(new Se("zoom",e)).fire(new Se("zoomend",e)),l&&this.fire(new Se("rotatestart",e)).fire(new Se("rotate",e)).fire(new Se("rotateend",e)),a&&this.fire(new Se("pitchstart",e)).fire(new Se("pitch",e)).fire(new Se("pitchend",e)),this.fire(new Se("moveend",e)),this}easeTo(t,e){this._stop(!1,t.easeId),(!1===(t=k({offset:[0,0],duration:500,easing:C},t)).animate||this._prefersReducedMotion(t))&&(t.duration=0);const i=this.transform,r=this.getZoom(),n=this.getBearing(),o=this.getPitch(),s=this.getPadding(),a="zoom"in t?+t.zoom:r,l="bearing"in t?this._normalizeBearing(t.bearing,n):n,c="pitch"in t?+t.pitch:o,h="padding"in t?t.padding:i.padding,u=y.convert(t.offset);let d,p,f;if("globe"===i.projection.name){const e=Yd.fromLngLat(i.center),r=u.rotate(-i.angle);e.x+=r.x/i.worldSize,e.y+=r.y/i.worldSize;const n=e.toLngLat(),o=Id.convert(t.center||n);this._normalizeCenter(o),d=i.centerPoint.add(r),p=new y(e.x,e.y).mult(i.worldSize),f=new y(Nd(o.lng),Ud(o.lat)).mult(i.worldSize).sub(p);}else {d=i.centerPoint.add(u);const e=i.pointLocation(d),r=Id.convert(t.center||e);this._normalizeCenter(r),p=i.project(e),f=i.project(r).sub(p);}const m=i.zoomScale(a-r);let _,g;t.around&&(_=Id.convert(t.around),g=i.locationPoint(_));const x=this._zooming||a!==r,v=this._rotating||n!==l,b=this._pitching||c!==o,w=!i.isPaddingEqual(h),T=i=>y=>{if(x&&(i.zoom=Wr(r,a,y)),v&&(i.bearing=Wr(n,l,y)),b&&(i.pitch=Wr(o,c,y)),w&&(i.interpolatePadding(s,h,y),d=i.centerPoint.add(u)),_)i.setLocationAtPoint(_,g);else {const t=i.zoomScale(i.zoom-r),e=a>r?Math.min(2,m):Math.max(.5,m),n=Math.pow(e,1-y),o=i.unproject(p.add(f.mult(y*n)).mult(t));i.setLocationAtPoint(i.renderWorldCopies?o.wrap():o,d);}return t.preloadOnly||this._fireMoveEvents(e),i};if(t.preloadOnly){const e=this._emulate(T,t.duration,i);return this._preloadTiles(e),this}const E={moving:this._moving,zooming:this._zooming,rotating:this._rotating,pitching:this._pitching};return this._zooming=x,this._rotating=v,this._pitching=b,this._padding=w,this._easeId=t.easeId,this._prepareEase(e,t.noMoveStart,E),this._ease(T(i),(t=>{i.recenterOnTerrain(),this._afterEase(e,t);}),t),this}_prepareEase(t,e,i={}){this._moving=!0,this.transform.cameraElevationReference="sea",e||i.moving||this.fire(new Se("movestart",t)),this._zooming&&!i.zooming&&this.fire(new Se("zoomstart",t)),this._rotating&&!i.rotating&&this.fire(new Se("rotatestart",t)),this._pitching&&!i.pitching&&this.fire(new Se("pitchstart",t));}_fireMoveEvents(t){this.fire(new Se("move",t)),this._zooming&&this.fire(new Se("zoom",t)),this._rotating&&this.fire(new Se("rotate",t)),this._pitching&&this.fire(new Se("pitch",t));}_afterEase(t,e){if(this._easeId&&e&&this._easeId===e)return;this._easeId=void 0,this.transform.cameraElevationReference="ground";const i=this._zooming,r=this._rotating,n=this._pitching;this._moving=!1,this._zooming=!1,this._rotating=!1,this._pitching=!1,this._padding=!1,i&&this.fire(new Se("zoomend",t)),r&&this.fire(new Se("rotateend",t)),n&&this.fire(new Se("pitchend",t)),this.fire(new Se("moveend",t));}flyTo(t,e){if(this._prefersReducedMotion(t)){const i=B(t,["center","zoom","bearing","pitch","around"]);return this.jumpTo(i,e)}this.stop(),t=k({offset:[0,0],speed:1.2,curve:1.42,easing:C},t);const i=this.transform,r=this.getZoom(),n=this.getBearing(),o=this.getPitch(),s=this.getPadding(),a="zoom"in t?z(+t.zoom,i.minZoom,i.maxZoom):r,l="bearing"in t?this._normalizeBearing(t.bearing,n):n,c="pitch"in t?+t.pitch:o,h="padding"in t?t.padding:i.padding,u=i.zoomScale(a-r),d=y.convert(t.offset);let p=i.centerPoint.add(d);const f=i.pointLocation(p),m=Id.convert(t.center||f);this._normalizeCenter(m);const _=i.project(f),g=i.project(m).sub(_);let x=t.curve;const v=Math.max(i.width,i.height),b=v/u,w=g.mag();if("minZoom"in t){const e=z(Math.min(t.minZoom,r,a),i.minZoom,i.maxZoom),n=v/i.zoomScale(e-r);x=Math.sqrt(n/w*2);}const T=x*x;function E(t){const e=(b*b-v*v+(t?-1:1)*T*T*w*w)/(2*(t?b:v)*T*w);return Math.log(Math.sqrt(e*e+1)-e)}function M(t){return (Math.exp(t)-Math.exp(-t))/2}function A(t){return (Math.exp(t)+Math.exp(-t))/2}const S=E(0);let I=function(t){return A(S)/A(S+x*t)},D=function(t){return v*((A(S)*(M(e=S+x*t)/A(e))-M(S))/T)/w;var e;},P=(E(1)-S)/x;if(Math.abs(w)<1e-6||!isFinite(P)){if(Math.abs(v-b)<1e-6)return this.easeTo(t,e);const i=b<v?-1:1;P=Math.abs(Math.log(b/v))/x,D=function(){return 0},I=function(t){return Math.exp(i*x*t)};}t.duration="duration"in t?+t.duration:1e3*P/("screenSpeed"in t?+t.screenSpeed/x:+t.speed),t.maxDuration&&t.duration>t.maxDuration&&(t.duration=0);const R=n!==l,L=c!==o,O=!i.isPaddingEqual(h),F=i=>u=>{const f=u*P,y=1/I(f);i.zoom=1===u?a:r+i.scaleZoom(y),R&&(i.bearing=Wr(n,l,u)),L&&(i.pitch=Wr(o,c,u)),O&&(i.interpolatePadding(s,h,u),p=i.centerPoint.add(d));const x=1===u?m:i.unproject(_.add(g.mult(D(f))).mult(y));return i.setLocationAtPoint(i.renderWorldCopies?x.wrap():x,p),i._updateCameraOnTerrain(),t.preloadOnly||this._fireMoveEvents(e),i};if(t.preloadOnly){const e=this._emulate(F,t.duration,i);return this._preloadTiles(e),this}return this._zooming=!0,this._rotating=R,this._pitching=L,this._padding=O,this._prepareEase(e,!1),this._ease(F(i),(()=>this._afterEase(e)),t),this}isEasing(){return !!this._easeFrameId}stop(){return this._stop()}_stop(t,e){if(this._easeFrameId&&(this._cancelRenderFrame(this._easeFrameId),this._easeFrameId=void 0,this._onEaseFrame=void 0),this._onEaseEnd){const t=this._onEaseEnd;this._onEaseEnd=void 0,t.call(this,e);}if(!t){const t=this.handlers;t&&t.stop(!1);}return this}_ease(t,e,i){!1===i.animate||0===i.duration?(t(1),e()):(this._easeStart=ue.now(),this._easeOptions=i,this._onEaseFrame=t,this._onEaseEnd=e,this._easeFrameId=this._requestRenderFrame(this._renderFrameCallback));}_renderFrameCallback(){const t=Math.min((ue.now()-this._easeStart)/this._easeOptions.duration,1),e=this._onEaseFrame;e&&e(this._easeOptions.easing(t)),t<1?this._easeFrameId=this._requestRenderFrame(this._renderFrameCallback):this.stop();}_normalizeBearing(t,e){t=P(t,-180,180);const i=Math.abs(t-e);return Math.abs(t-360-e)<i&&(t-=360),Math.abs(t+360-e)<i&&(t+=360),t}_normalizeCenter(t){const e=this.transform;if(!e.renderWorldCopies||e.maxBounds)return;const i=t.lng-e.center.lng;t.lng+=i>180?-360:i<-180?360:0;}_prefersReducedMotion(t){return this._respectPrefersReducedMotion&&ue.prefersReducedMotion&&!(t&&t.essential)}_emulate(t,e,i){const r=Math.ceil(15*e/1e3),n=[],o=t(i.clone());for(let t=0;t<=r;t++){const e=o(t/r);n.push(e.clone());}return n}}class AS{constructor(t={}){this.options=t,j(["_toggleAttribution","_updateEditLink","_updateData","_updateCompact"],this);}getDefaultPosition(){return "bottom-right"}onAdd(t){const e=this.options&&this.options.compact;return this._map=t,this._container=de("div","mapboxgl-ctrl mapboxgl-ctrl-attrib"),this._compactButton=de("button","mapboxgl-ctrl-attrib-button",this._container),de("span","mapboxgl-ctrl-icon",this._compactButton).setAttribute("aria-hidden","true"),this._compactButton.type="button",this._compactButton.addEventListener("click",this._toggleAttribution),this._setElementTitle(this._compactButton,"ToggleAttribution"),this._innerContainer=de("div","mapboxgl-ctrl-attrib-inner",this._container),e&&this._container.classList.add("mapboxgl-compact"),this._updateAttributions(),this._updateEditLink(),this._map.on("styledata",this._updateData),this._map.on("sourcedata",this._updateData),this._map.on("moveend",this._updateEditLink),void 0===e&&(this._map.on("resize",this._updateCompact),this._updateCompact()),this._container}onRemove(){this._container.remove(),this._map.off("styledata",this._updateData),this._map.off("sourcedata",this._updateData),this._map.off("moveend",this._updateEditLink),this._map.off("resize",this._updateCompact),this._map=void 0,this._attribHTML=void 0;}_setElementTitle(t,e){const i=this._map._getUIString(`AttributionControl.${e}`);t.setAttribute("aria-label",i),t.removeAttribute("title"),t.firstElementChild&&t.firstElementChild.setAttribute("title",i);}_toggleAttribution(){this._container.classList.contains("mapboxgl-compact-show")?(this._container.classList.remove("mapboxgl-compact-show"),this._compactButton.setAttribute("aria-expanded","false")):(this._container.classList.add("mapboxgl-compact-show"),this._compactButton.setAttribute("aria-expanded","true"));}_updateEditLink(){let t=this._editLink;t||(t=this._editLink=this._container.querySelector(".mapbox-improve-map"));const e=[{key:"owner",value:this.styleOwner},{key:"id",value:this.styleId},{key:"access_token",value:this._map._requestManager._customAccessToken||n.ACCESS_TOKEN}];if(t){const i=e.reduce(((t,i,r)=>(i.value&&(t+=`${i.key}=${i.value}${r<e.length-1?"&":""}`),t)),"?");t.href=`${n.FEEDBACK_URL}/${i}#${CA(this._map,!0)}`,t.rel="noopener nofollow",this._setElementTitle(t,"MapFeedback");}}_updateData(t){!t||"metadata"!==t.sourceDataType&&"visibility"!==t.sourceDataType&&"style"!==t.dataType||(this._updateAttributions(),this._updateEditLink());}_updateAttributions(){if(!this._map.style)return;let t=[];if(this._map.style.stylesheet){const t=this._map.style.stylesheet;this.styleOwner=t.owner,this.styleId=t.id;}const e=this._map.style._sourceCaches;for(const i in e){const r=e[i];if(r.used){const e=r.getSource();e.attribution&&t.indexOf(e.attribution)<0&&t.push(e.attribution);}}t.sort(((t,e)=>t.length-e.length)),t=t.filter(((e,i)=>{for(let r=i+1;r<t.length;r++)if(t[r].indexOf(e)>=0)return !1;return !0})),this.options.customAttribution&&(Array.isArray(this.options.customAttribution)?t=[...this.options.customAttribution,...t]:t.unshift(this.options.customAttribution));const i=t.join(" | ");i!==this._attribHTML&&(this._attribHTML=i,t.length?(this._innerContainer.innerHTML=i,this._container.classList.remove("mapboxgl-attrib-empty")):this._container.classList.add("mapboxgl-attrib-empty"),this._editLink=null);}_updateCompact(){this._map.getCanvasContainer().offsetWidth<=640?this._container.classList.add("mapboxgl-compact"):this._container.classList.remove("mapboxgl-compact","mapboxgl-compact-show");}}class SS{constructor(){j(["_updateLogo","_updateCompact"],this);}onAdd(t){this._map=t,this._container=de("div","mapboxgl-ctrl");const e=de("a","mapboxgl-ctrl-logo");return e.target="_blank",e.rel="noopener nofollow",e.href="https://www.mapbox.com/",e.setAttribute("aria-label",this._map._getUIString("LogoControl.Title")),e.setAttribute("rel","noopener nofollow"),this._container.appendChild(e),this._container.style.display="none",this._map.on("sourcedata",this._updateLogo),this._updateLogo(),this._map.on("resize",this._updateCompact),this._updateCompact(),this._container}onRemove(){this._container.remove(),this._map.off("sourcedata",this._updateLogo),this._map.off("resize",this._updateCompact);}getDefaultPosition(){return "bottom-left"}_updateLogo(t){t&&"metadata"!==t.sourceDataType||(this._container.style.display=this._logoRequired()?"block":"none");}_logoRequired(){if(!this._map.style)return !0;const t=this._map.style._sourceCaches;if(0===Object.entries(t).length)return !0;for(const e in t){const i=t[e].getSource();if(i.hasOwnProperty("mapbox_logo")&&!i.mapbox_logo)return !1}return !0}_updateCompact(){const t=this._container.children;if(t.length){const e=t[0];this._map.getCanvasContainer().offsetWidth<250?e.classList.add("mapboxgl-compact"):e.classList.remove("mapboxgl-compact");}}}class IS{constructor(){this._queue=[],this._id=0,this._cleared=!1,this._currentlyRunning=!1;}add(t){const e=++this._id;return this._queue.push({callback:t,id:e,cancelled:!1}),e}remove(t){const e=this._currentlyRunning,i=e?this._queue.concat(e):this._queue;for(const e of i)if(e.id===t)return void(e.cancelled=!0)}run(t=0){const e=this._currentlyRunning=this._queue;this._queue=[];for(const i of e)if(!i.cancelled&&(i.callback(t),this._cleared))break;this._cleared=!1,this._currentlyRunning=!1;}clear(){this._currentlyRunning&&(this._cleared=!0),this._queue=[];}}function CS(t,e,i){if(t=new Id(t.lng,t.lat),e){const r=new Id(t.lng-360,t.lat),n=new Id(t.lng+360,t.lat),o=360*Math.ceil(Math.abs(t.lng-i.center.lng)/360),s=i.locationPoint(t).distSqr(e),a=e.x<0||e.y<0||e.x>i.width||e.y>i.height;i.locationPoint(r).distSqr(e)<s&&(a||Math.abs(r.lng-i.center.lng)<o)?t=r:i.locationPoint(n).distSqr(e)<s&&(a||Math.abs(n.lng-i.center.lng)<o)&&(t=n);}for(;Math.abs(t.lng-i.center.lng)>180;){const e=i.locationPoint(t);if(e.x>=0&&e.y>=0&&e.x<=i.width&&e.y<=i.height)break;t.lng>i.center.lng?t.lng-=360:t.lng+=360;}return t}const zS={center:"translate(-50%,-50%)",top:"translate(-50%,0)","top-left":"translate(0,0)","top-right":"translate(-100%,0)",bottom:"translate(-50%,-100%)","bottom-left":"translate(0,-100%)","bottom-right":"translate(-100%,-100%)",left:"translate(0,-50%)",right:"translate(-100%,-50%)"};class DS extends Ce{constructor(t,i){if(super(),(t instanceof e.HTMLElement||i)&&(t=k({element:t},i)),j(["_update","_onMove","_onUp","_addDragHandler","_onMapClick","_onKeyPress","_clearFadeTimer"],this),this._anchor=t&&t.anchor||"center",this._color=t&&t.color||"#3FB1CE",this._scale=t&&t.scale||1,this._draggable=t&&t.draggable||!1,this._clickTolerance=t&&t.clickTolerance||0,this._isDragging=!1,this._state="inactive",this._rotation=t&&t.rotation||0,this._rotationAlignment=t&&t.rotationAlignment||"auto",this._pitchAlignment=t&&t.pitchAlignment&&t.pitchAlignment||"auto",this._updateMoving=()=>this._update(!0),this._occludedOpacity=t&&t.occludedOpacity||.2,t&&t.element)this._element=t.element,this._offset=y.convert(t&&t.offset||[0,0]);else {this._defaultMarker=!0,this._element=de("div");const e=41,i=27,r=pe("svg",{display:"block",height:e*this._scale+"px",width:i*this._scale+"px",viewBox:`0 0 ${i} ${e}`},this._element),n=pe("radialGradient",{id:"shadowGradient"},pe("defs",{},r));pe("stop",{offset:"10%","stop-opacity":.4},n),pe("stop",{offset:"100%","stop-opacity":.05},n),pe("ellipse",{cx:13.5,cy:34.8,rx:10.5,ry:5.25,fill:"url(#shadowGradient)"},r),pe("path",{fill:this._color,d:"M27,13.5C27,19.07 20.25,27 14.75,34.5C14.02,35.5 12.98,35.5 12.25,34.5C6.75,27 0,19.22 0,13.5C0,6.04 6.04,0 13.5,0C20.96,0 27,6.04 27,13.5Z"},r),pe("path",{opacity:.25,d:"M13.5,0C6.04,0 0,6.04 0,13.5C0,19.22 6.75,27 12.25,34.5C13,35.52 14.02,35.5 14.75,34.5C20.25,27 27,19.07 27,13.5C27,6.04 20.96,0 13.5,0ZM13.5,1C20.42,1 26,6.58 26,13.5C26,15.9 24.5,19.18 22.22,22.74C19.95,26.3 16.71,30.14 13.94,33.91C13.74,34.18 13.61,34.32 13.5,34.44C13.39,34.32 13.26,34.18 13.06,33.91C10.28,30.13 7.41,26.31 5.02,22.77C2.62,19.23 1,15.95 1,13.5C1,6.58 6.58,1 13.5,1Z"},r),pe("circle",{fill:"white",cx:13.5,cy:13.5,r:5.5},r),this._offset=y.convert(t&&t.offset||[0,-14]);}this._element.hasAttribute("aria-label")||this._element.setAttribute("aria-label","Map marker"),this._element.hasAttribute("role")||this._element.setAttribute("role","img"),this._element.classList.add("mapboxgl-marker"),this._element.addEventListener("dragstart",(t=>{t.preventDefault();})),this._element.addEventListener("mousedown",(t=>{t.preventDefault();}));const r=this._element.classList;for(const t in zS)r.remove(`mapboxgl-marker-anchor-${t}`);r.add(`mapboxgl-marker-anchor-${this._anchor}`);const n=t&&t.className?t.className.trim().split(/\s+/):[];r.add(...n),this._popup=null;}addTo(t){return t===this._map||(this.remove(),this._map=t,t.getCanvasContainer().appendChild(this._element),t.on("move",this._updateMoving),t.on("moveend",this._update),t.on("remove",this._clearFadeTimer),t._addMarker(this),this.setDraggable(this._draggable),this._update(),t.on("click",this._onMapClick)),this}remove(){const t=this._map;return t&&(t.off("click",this._onMapClick),t.off("move",this._updateMoving),t.off("moveend",this._update),t.off("mousedown",this._addDragHandler),t.off("touchstart",this._addDragHandler),t.off("mouseup",this._onUp),t.off("touchend",this._onUp),t.off("mousemove",this._onMove),t.off("touchmove",this._onMove),t.off("remove",this._clearFadeTimer),t._removeMarker(this),this._map=void 0),this._clearFadeTimer(),this._element.remove(),this._popup&&this._popup.remove(),this}getLngLat(){return this._lngLat}setLngLat(t){return this._lngLat=Id.convert(t),this._pos=null,this._popup&&this._popup.setLngLat(this._lngLat),this._update(!0),this}getElement(){return this._element}setPopup(t){if(this._popup&&(this._popup.remove(),this._popup=null,this._element.removeAttribute("role"),this._element.removeEventListener("keypress",this._onKeyPress),this._originalTabIndex||this._element.removeAttribute("tabindex")),t){if(!("offset"in t.options)){const e=38.1,i=13.5,r=Math.sqrt(Math.pow(i,2)/2);t.options.offset=this._defaultMarker?{top:[0,0],"top-left":[0,0],"top-right":[0,0],bottom:[0,-e],"bottom-left":[r,-1*(e-i+r)],"bottom-right":[-r,-1*(e-i+r)],left:[i,-1*(e-i)],right:[-i,-1*(e-i)]}:this._offset;}this._popup=t,t._marker=this,this._lngLat&&this._popup.setLngLat(this._lngLat),this._element.setAttribute("role","button"),this._originalTabIndex=this._element.getAttribute("tabindex"),this._originalTabIndex||this._element.setAttribute("tabindex","0"),this._element.addEventListener("keypress",this._onKeyPress),this._element.setAttribute("aria-expanded","false");}return this}_onKeyPress(t){const e=t.code,i=t.charCode||t.keyCode;"Space"!==e&&"Enter"!==e&&32!==i&&13!==i||this.togglePopup();}_onMapClick(t){const e=t.originalEvent.target,i=this._element;this._popup&&(e===i||i.contains(e))&&this.togglePopup();}getPopup(){return this._popup}togglePopup(){const t=this._popup;return t?(t.isOpen()?(t.remove(),this._element.setAttribute("aria-expanded","false")):this._map&&(t.addTo(this._map),this._element.setAttribute("aria-expanded","true")),this):this}_behindTerrain(){const t=this._map,e=this._pos;if(!t||!e)return !1;const i=t.unproject(e),r=t.getFreeCameraOptions();if(!r.position)return !1;const n=r.position.toLngLat();return n.distanceTo(i)<.9*n.distanceTo(this._lngLat)}_evaluateOpacity(){const t=this._map;if(!t)return;const e=this._pos;if(!e||e.x<0||e.x>t.transform.width||e.y<0||e.y>t.transform.height)return void this._clearFadeTimer();const i=t.unproject(e);let r;t._showingGlobe()&&vd(t.transform,this._lngLat)?r=0:(r=1-t._queryFogOpacity(i),t.transform._terrainEnabled()&&t.getTerrain()&&this._behindTerrain()&&(r*=this._occludedOpacity)),this._element.style.opacity=`${r}`,this._element.style.pointerEvents=r>0?"auto":"none",this._popup&&this._popup._setOpacity(r),this._fadeTimer=null;}_clearFadeTimer(){this._fadeTimer&&(clearTimeout(this._fadeTimer),this._fadeTimer=null);}_updateDOM(){const t=this._pos;if(!t||!this._map)return;const e=this._offset.mult(this._scale);this._element.style.transform=`\n            translate(${t.x}px,${t.y}px)\n            ${zS[this._anchor]}\n            ${this._calculateXYTransform()} ${this._calculateZTransform()}\n            translate(${e.x}px,${e.y}px)\n        `;}_calculateXYTransform(){const t=this._pos,e=this._map,i=this.getPitchAlignment();if(!e||!t||"map"!==i)return "";if(!e._showingGlobe()){const t=e.getPitch();return t?`rotateX(${t}deg)`:""}const r=T(xd(e.transform,this._lngLat)),n=t.sub(yd(e.transform)),o=Math.abs(n.x)+Math.abs(n.y);if(0===o)return "";const s=r/o;return `rotateX(${-n.y*s}deg) rotateY(${n.x*s}deg)`}_calculateZTransform(){const t=this._pos,e=this._map;if(!e||!t)return "";let i=0;const r=this.getRotationAlignment();if("map"===r)if(e._showingGlobe()){const t=e.project(new Id(this._lngLat.lng,this._lngLat.lat+.001)),r=e.project(new Id(this._lngLat.lng,this._lngLat.lat-.001)).sub(t);i=T(Math.atan2(r.y,r.x))-90;}else i=-e.getBearing();else if("horizon"===r){const r=D(4,6,e.getZoom()),n=yd(e.transform);n.y+=r*e.transform.height;const o=t.sub(n),s=T(Math.atan2(o.y,o.x));i=(s>90?s-270:s+90)*(1-r);}return i+=this._rotation,i?`rotateZ(${i}deg)`:""}_update(t){e.cancelAnimationFrame(this._updateFrameId);const i=this._map;i&&(i.transform.renderWorldCopies&&(this._lngLat=CS(this._lngLat,this._pos,i.transform)),this._pos=i.project(this._lngLat),!0===t?this._updateFrameId=e.requestAnimationFrame((()=>{this._element&&this._pos&&this._anchor&&(this._pos=this._pos.round(),this._updateDOM());})):this._pos=this._pos.round(),i._requestDomTask((()=>{this._map&&(this._element&&this._pos&&this._anchor&&this._updateDOM(),(i._showingGlobe()||i.getTerrain()||i.getFog())&&!this._fadeTimer&&(this._fadeTimer=setTimeout(this._evaluateOpacity.bind(this),60)));})));}getOffset(){return this._offset}setOffset(t){return this._offset=y.convert(t),this._update(),this}addClassName(t){return this._element.classList.add(t),this}removeClassName(t){return this._element.classList.remove(t),this}toggleClassName(t){return this._element.classList.toggle(t)}_onMove(t){const e=this._map;if(!e)return;const i=this._pointerdownPos,r=this._positionDelta;if(i&&r){if(!this._isDragging){const r=this._clickTolerance||e._clickTolerance;if(t.point.dist(i)<r)return;this._isDragging=!0;}this._pos=t.point.sub(r),this._lngLat=e.unproject(this._pos),this.setLngLat(this._lngLat),this._element.style.pointerEvents="none","pending"===this._state&&(this._state="active",this.fire(new Se("dragstart"))),this.fire(new Se("drag"));}}_onUp(){this._element.style.pointerEvents="auto",this._positionDelta=null,this._pointerdownPos=null,this._isDragging=!1;const t=this._map;t&&(t.off("mousemove",this._onMove),t.off("touchmove",this._onMove)),"active"===this._state&&this.fire(new Se("dragend")),this._state="inactive";}_addDragHandler(t){const e=this._map,i=this._pos;e&&i&&this._element.contains(t.originalEvent.target)&&(t.preventDefault(),this._positionDelta=t.point.sub(i),this._pointerdownPos=t.point,this._state="pending",e.on("mousemove",this._onMove),e.on("touchmove",this._onMove),e.once("mouseup",this._onUp),e.once("touchend",this._onUp));}setDraggable(t){this._draggable=!!t;const e=this._map;return e&&(t?(e.on("mousedown",this._addDragHandler),e.on("touchstart",this._addDragHandler)):(e.off("mousedown",this._addDragHandler),e.off("touchstart",this._addDragHandler))),this}isDraggable(){return this._draggable}setRotation(t){return this._rotation=t||0,this._update(),this}getRotation(){return this._rotation}setRotationAlignment(t){return this._rotationAlignment=t||"auto",this._update(),this}getRotationAlignment(){return "auto"===this._rotationAlignment||"horizon"===this._rotationAlignment&&this._map&&!this._map._showingGlobe()?"viewport":this._rotationAlignment}setPitchAlignment(t){return this._pitchAlignment=t||"auto",this._update(),this}getPitchAlignment(){return "auto"===this._pitchAlignment?this.getRotationAlignment():this._pitchAlignment}setOccludedOpacity(t){return this._occludedOpacity=t||.2,this._update(),this}getOccludedOpacity(){return this._occludedOpacity}}const PS={closeButton:!0,closeOnClick:!0,focusAfterOpen:!0,className:"",maxWidth:"240px"},RS=["a[href]","[tabindex]:not([tabindex='-1'])","[contenteditable]:not([contenteditable='false'])","button:not([disabled])","input:not([disabled])","select:not([disabled])","textarea:not([disabled])"].join(", ");function LS(t=new y(0,0),e="bottom"){if("number"==typeof t){const i=Math.round(Math.sqrt(.5*Math.pow(t,2)));switch(e){case"top":return new y(0,t);case"top-left":return new y(i,i);case"top-right":return new y(-i,i);case"bottom":return new y(0,-t);case"bottom-left":return new y(i,-i);case"bottom-right":return new y(-i,-i);case"left":return new y(t,0);case"right":return new y(-t,0)}return new y(0,0)}return t instanceof y||Array.isArray(t)?y.convert(t):y.convert(t[e]||[0,0])}class kS{constructor(t){this.jumpTo(t);}getValue(t){if(t<=this._startTime)return this._start;if(t>=this._endTime)return this._end;const e=M((t-this._startTime)/(this._endTime-this._startTime));return this._start*(1-e)+this._end*e}isEasing(t){return t>=this._startTime&&t<=this._endTime}jumpTo(t){this._startTime=-1/0,this._endTime=-1/0,this._start=t,this._end=t;}easeTo(t,e,i){this._start=this.getValue(e),this._end=t,this._startTime=e,this._endTime=e+i;}}const BS={"AttributionControl.ToggleAttribution":"Toggle attribution","AttributionControl.MapFeedback":"Map feedback","FullscreenControl.Enter":"Enter fullscreen","FullscreenControl.Exit":"Exit fullscreen","GeolocateControl.FindMyLocation":"Find my location","GeolocateControl.LocationNotAvailable":"Location not available","LogoControl.Title":"Mapbox logo","Map.Title":"Map","NavigationControl.ResetBearing":"Reset bearing to north","NavigationControl.ZoomIn":"Zoom in","NavigationControl.ZoomOut":"Zoom out","ScrollZoomBlocker.CtrlMessage":"Use ctrl + scroll to zoom the map","ScrollZoomBlocker.CmdMessage":"Use ⌘ + scroll to zoom the map","TouchPanBlocker.Message":"Use two fingers to move the map"},OS={center:[0,0],zoom:0,bearing:0,pitch:0,minZoom:-2,maxZoom:22,minPitch:0,maxPitch:85,interactive:!0,scrollZoom:!0,boxZoom:!0,dragRotate:!0,dragPan:!0,keyboard:!0,doubleClickZoom:!0,touchZoomRotate:!0,touchPitch:!0,cooperativeGestures:!1,performanceMetricsCollection:!0,bearingSnap:7,clickTolerance:3,pitchWithRotate:!0,hash:!1,attributionControl:!0,antialias:!1,failIfMajorPerformanceCaveat:!1,preserveDrawingBuffer:!1,trackResize:!0,renderWorldCopies:!0,refreshExpiredTiles:!0,minTileCacheSize:null,maxTileCacheSize:null,localIdeographFontFamily:"sans-serif",localFontFamily:null,transformRequest:null,accessToken:null,fadeDuration:300,respectPrefersReducedMotion:!0,crossSourceCollisions:!0,collectResourceTiming:!1,testMode:!1},FS={showCompass:!0,showZoom:!0,visualizePitch:!1};class NS{constructor(t,e,i=!1){this._clickTolerance=10,this.element=e,this.mouseRotate=new KA({clickTolerance:t.dragRotate._mouseRotate._clickTolerance}),this.map=t,i&&(this.mousePitch=new JA({clickTolerance:t.dragRotate._mousePitch._clickTolerance})),j(["mousedown","mousemove","mouseup","touchstart","touchmove","touchend","reset"],this),e.addEventListener("mousedown",this.mousedown),e.addEventListener("touchstart",this.touchstart,{passive:!1}),e.addEventListener("touchmove",this.touchmove),e.addEventListener("touchend",this.touchend),e.addEventListener("touchcancel",this.reset);}down(t,e){this.mouseRotate.mousedown(t,e),this.mousePitch&&this.mousePitch.mousedown(t,e),ge();}move(t,e){const i=this.map,r=this.mouseRotate.mousemoveWindow(t,e),n=r&&r.bearingDelta;if(n&&i.setBearing(i.getBearing()+n),this.mousePitch){const r=this.mousePitch.mousemoveWindow(t,e),n=r&&r.pitchDelta;n&&i.setPitch(i.getPitch()+n);}}off(){const t=this.element;t.removeEventListener("mousedown",this.mousedown),t.removeEventListener("touchstart",this.touchstart,{passive:!1}),t.removeEventListener("touchmove",this.touchmove),t.removeEventListener("touchend",this.touchend),t.removeEventListener("touchcancel",this.reset),this.offTemp();}offTemp(){ye(),e.removeEventListener("mousemove",this.mousemove),e.removeEventListener("mouseup",this.mouseup);}mousedown(t){this.down(k({},t,{ctrlKey:!0,preventDefault:()=>t.preventDefault()}),be(this.element,t)),e.addEventListener("mousemove",this.mousemove),e.addEventListener("mouseup",this.mouseup);}mousemove(t){this.move(t,be(this.element,t));}mouseup(t){this.mouseRotate.mouseupWindow(t),this.mousePitch&&this.mousePitch.mouseupWindow(t),this.offTemp();}touchstart(t){1!==t.targetTouches.length?this.reset():(this._startPos=this._lastPos=we(this.element,t.targetTouches)[0],this.down({type:"mousedown",button:0,ctrlKey:!0,preventDefault:()=>t.preventDefault()},this._startPos));}touchmove(t){1!==t.targetTouches.length?this.reset():(this._lastPos=we(this.element,t.targetTouches)[0],this.move({preventDefault:()=>t.preventDefault()},this._lastPos));}touchend(t){0===t.targetTouches.length&&this._startPos&&this._lastPos&&this._startPos.dist(this._lastPos)<this._clickTolerance&&this.element.click(),this.reset();}reset(){this.mouseRotate.reset(),this.mousePitch&&this.mousePitch.reset(),delete this._startPos,delete this._lastPos,this.offTemp();}}const US={positionOptions:{enableHighAccuracy:!1,maximumAge:0,timeout:6e3},fitBoundsOptions:{maxZoom:15},trackUserLocation:!1,showAccuracyCircle:!0,showUserLocation:!0,showUserHeading:!1},VS={maxWidth:100,unit:"metric"},jS={kilometer:"km",meter:"m",mile:"mi",foot:"ft","nautical-mile":"nm"},GS={version:i,supported:ne,setRTLTextPlugin:function(t,e,i=!1){if(Zs===Vs||Zs===js||Zs===Gs)throw new Error("setRTLTextPlugin cannot be called multiple times.");$s=ue.resolveURL(t),Zs=Vs,qs=e,Ws(),i||Ks();},getRTLTextPluginStatus:Ys,Map:class extends MS{constructor(t){if(te.mark(Qt.create),null!=(t=k({},OS,t)).minZoom&&null!=t.maxZoom&&t.minZoom>t.maxZoom)throw new Error("maxZoom must be greater than or equal to minZoom");if(null!=t.minPitch&&null!=t.maxPitch&&t.minPitch>t.maxPitch)throw new Error("maxPitch must be greater than or equal to minPitch");if(null!=t.minPitch&&t.minPitch<0)throw new Error("minPitch must be greater than or equal to 0");if(null!=t.maxPitch&&t.maxPitch>85)throw new Error("maxPitch must be less than or equal to 85");if(t.antialias&&function(t){const e=t.navigator?t.navigator.userAgent:null;return !!it(t)&&e&&(e.match("Version/15.4")||e.match("Version/15.5")||e.match(/CPU (OS|iPhone OS) (15_4|15_5) like Mac OS X/))}(e)&&(t.antialias=!1,W("Antialiasing is disabled for this WebGL context to avoid browser bug: https://github.com/mapbox/mapbox-gl-js/issues/11609")),super(new lv(t.minZoom,t.maxZoom,t.minPitch,t.maxPitch,t.renderWorldCopies),t),this._interactive=t.interactive,this._minTileCacheSize=t.minTileCacheSize,this._maxTileCacheSize=t.maxTileCacheSize,this._failIfMajorPerformanceCaveat=t.failIfMajorPerformanceCaveat,this._preserveDrawingBuffer=t.preserveDrawingBuffer,this._antialias=t.antialias,this._trackResize=t.trackResize,this._bearingSnap=t.bearingSnap,this._refreshExpiredTiles=t.refreshExpiredTiles,this._fadeDuration=t.fadeDuration,this._isInitialLoad=!0,this._crossSourceCollisions=t.crossSourceCollisions,this._collectResourceTiming=t.collectResourceTiming,this._language=this._parseLanguage(t.language),this._worldview=t.worldview,this._renderTaskQueue=new IS,this._domRenderTaskQueue=new IS,this._controls=[],this._markers=[],this._popups=[],this._mapId=F(),this._locale=k({},BS,t.locale),this._clickTolerance=t.clickTolerance,this._cooperativeGestures=t.cooperativeGestures,this._performanceMetricsCollection=t.performanceMetricsCollection,this._containerWidth=0,this._containerHeight=0,this._averageElevationLastSampledAt=-1/0,this._averageElevationExaggeration=0,this._averageElevation=new kS(0),this._interactionRange=[1/0,-1/0],this._visibilityHidden=0,this._useExplicitProjection=!1,this._requestManager=new Dt(t.transformRequest,t.accessToken,t.testMode),this._silenceAuthErrors=!!t.testMode,"string"==typeof t.container){if(this._container=e.document.getElementById(t.container),!this._container)throw new Error(`Container '${t.container.toString()}' not found.`)}else {if(!(t.container instanceof e.HTMLElement))throw new Error("Invalid type: 'container' must be a String or HTMLElement.");this._container=t.container;}if(this._container.childNodes.length>0&&W("The map container element should be empty, otherwise the map's interactivity will be negatively impacted. If you want to display a message when WebGL is not supported, use the Mapbox GL Supported plugin instead."),t.maxBounds&&this.setMaxBounds(t.maxBounds),j(["_onWindowOnline","_onWindowResize","_onVisibilityChange","_onMapScroll","_contextLost","_contextRestored"],this),this._setupContainer(),this._setupPainter(),void 0===this.painter)throw new Error("Failed to initialize WebGL.");if(this.on("move",(()=>this._update(!1))),this.on("moveend",(()=>this._update(!1))),this.on("zoom",(()=>this._update(!0))),void 0!==e&&(this._fullscreenchangeEvent="onfullscreenchange"in e.document?"fullscreenchange":"webkitfullscreenchange",e.addEventListener("online",this._onWindowOnline,!1),e.addEventListener("resize",this._onWindowResize,!1),e.addEventListener("orientationchange",this._onWindowResize,!1),e.addEventListener(this._fullscreenchangeEvent,this._onWindowResize,!1),e.addEventListener("visibilitychange",this._onVisibilityChange,!1)),this.handlers=new TS(this,t),this._localFontFamily=t.localFontFamily,this._localIdeographFontFamily=t.localIdeographFontFamily,(t.style||!t.testMode)&&this.setStyle(t.style||n.DEFAULT_STYLE,{localFontFamily:this._localFontFamily,localIdeographFontFamily:this._localIdeographFontFamily}),t.projection&&this.setProjection(t.projection),t.hash&&(this._hash=new IA("string"==typeof t.hash&&t.hash||void 0).addTo(this)),!this._hash||!this._hash._onHashChange()){this.jumpTo({center:t.center,zoom:t.zoom,bearing:t.bearing,pitch:t.pitch});const e=t.bounds;e&&(this.resize(),this.fitBounds(e,k({},t.fitBoundsOptions,{duration:0})));}this.resize(),t.attributionControl&&this.addControl(new AS({customAttribution:t.customAttribution})),this._logoControl=new SS,this.addControl(this._logoControl,t.logoPosition),this.on("style.load",(()=>{this.transform.unmodified&&this.jumpTo(this.style.stylesheet);})),this.on("data",(t=>{this._update("style"===t.dataType),this.fire(new Se(`${t.dataType}data`,t));})),this.on("dataloading",(t=>{this.fire(new Se(`${t.dataType}dataloading`,t));}));}_getMapId(){return this._mapId}addControl(t,e){if(void 0===e&&(e=t.getDefaultPosition?t.getDefaultPosition():"top-right"),!t||!t.onAdd)return this.fire(new Ie(new Error("Invalid argument to map.addControl(). Argument must be a control with onAdd and onRemove methods.")));const i=t.onAdd(this);this._controls.push(t);const r=this._controlPositions[e];return -1!==e.indexOf("bottom")?r.insertBefore(i,r.firstChild):r.appendChild(i),this}removeControl(t){if(!t||!t.onRemove)return this.fire(new Ie(new Error("Invalid argument to map.removeControl(). Argument must be a control with onAdd and onRemove methods.")));const e=this._controls.indexOf(t);return e>-1&&this._controls.splice(e,1),t.onRemove(this),this}hasControl(t){return this._controls.indexOf(t)>-1}getContainer(){return this._container}getCanvasContainer(){return this._canvasContainer}getCanvas(){return this._canvas}resize(t){if(this._updateContainerDimensions(),this._containerWidth===this.transform.width&&this._containerHeight===this.transform.height)return this;this._resizeCanvas(this._containerWidth,this._containerHeight),this.transform.resize(this._containerWidth,this._containerHeight),this.painter.resize(Math.ceil(this._containerWidth),Math.ceil(this._containerHeight));const e=!this._moving;return e&&this.fire(new Se("movestart",t)).fire(new Se("move",t)),this.fire(new Se("resize",t)),e&&this.fire(new Se("moveend",t)),this}getBounds(){return this.transform.getBounds()}getMaxBounds(){return this.transform.getMaxBounds()||null}setMaxBounds(t){return this.transform.setMaxBounds(Xl.convert(t)),this._update()}setMinZoom(t){if((t=null==t?-2:t)>=-2&&t<=this.transform.maxZoom)return this.transform.minZoom=t,this._update(),this.getZoom()<t?this.setZoom(t):this.fire(new Se("zoomstart")).fire(new Se("zoom")).fire(new Se("zoomend")),this;throw new Error("minZoom must be between -2 and the current maxZoom, inclusive")}getMinZoom(){return this.transform.minZoom}setMaxZoom(t){if((t=null==t?22:t)>=this.transform.minZoom)return this.transform.maxZoom=t,this._update(),this.getZoom()>t?this.setZoom(t):this.fire(new Se("zoomstart")).fire(new Se("zoom")).fire(new Se("zoomend")),this;throw new Error("maxZoom must be greater than the current minZoom")}getMaxZoom(){return this.transform.maxZoom}setMinPitch(t){if((t=null==t?0:t)<0)throw new Error("minPitch must be greater than or equal to 0");if(t>=0&&t<=this.transform.maxPitch)return this.transform.minPitch=t,this._update(),this.getPitch()<t?this.setPitch(t):this.fire(new Se("pitchstart")).fire(new Se("pitch")).fire(new Se("pitchend")),this;throw new Error("minPitch must be between 0 and the current maxPitch, inclusive")}getMinPitch(){return this.transform.minPitch}setMaxPitch(t){if((t=null==t?85:t)>85)throw new Error("maxPitch must be less than or equal to 85");if(t>=this.transform.minPitch)return this.transform.maxPitch=t,this._update(),this.getPitch()>t?this.setPitch(t):this.fire(new Se("pitchstart")).fire(new Se("pitch")).fire(new Se("pitchend")),this;throw new Error("maxPitch must be greater than or equal to minPitch")}getMaxPitch(){return this.transform.maxPitch}getRenderWorldCopies(){return this.transform.renderWorldCopies}setRenderWorldCopies(t){return this.transform.renderWorldCopies=t,this.transform.renderWorldCopies||this._forceMarkerAndPopupUpdate(!0),this._update()}getLanguage(){return this._language}_parseLanguage(t){return "auto"===t?e.navigator.language:Array.isArray(t)?0===t.length?void 0:t.map((t=>"auto"===t?e.navigator.language:t)):t}setLanguage(t){const e=this._parseLanguage(t);if(!this.style||e===this._language)return this;this._language=e,this.style._reloadSources();for(const t of this._controls)t._setLanguage&&t._setLanguage(this._language);return this}getWorldview(){return this._worldview}setWorldview(t){return this.style&&t!==this._worldview?(this._worldview=t,this.style._reloadSources(),this):this}getProjection(){return this.transform.mercatorFromTransition?{name:"globe",center:[0,0]}:this.transform.getProjection()}_showingGlobe(){return "globe"===this.transform.projection.name}setProjection(t){return this._lazyInitEmptyStyle(),t?"string"==typeof t&&(t={name:t}):t=null,this._useExplicitProjection=!!t,this._prioritizeAndUpdateProjection(t,this.style.stylesheet?this.style.stylesheet.projection:null)}_updateProjectionTransition(){if("globe"!==this.getProjection().name)return;const t=this.transform,e=t.projection.name;let i;"globe"===e&&t.zoom>=Fu?(t.setMercatorFromTransition(),i=!0):"mercator"===e&&t.zoom<Fu&&(t.setProjection({name:"globe"}),i=!0),i&&(this.style.applyProjectionUpdate(),this.style._forceSymbolLayerUpdate());}_prioritizeAndUpdateProjection(t,e){return this._updateProjection(t||e||{name:"mercator"})}_updateProjection(t){let e;if(e="globe"===t.name&&this.transform.zoom>=Fu?this.transform.setMercatorFromTransition():this.transform.setProjection(t),this.style.applyProjectionUpdate(),e){this.painter.clearBackgroundTiles();for(const t in this.style._sourceCaches)this.style._sourceCaches[t].clearTiles();this._update(!0),this._forceMarkerAndPopupUpdate(!0);}return this}project(t){return this.transform.locationPoint3D(Id.convert(t))}unproject(t){return this.transform.pointLocation3D(y.convert(t))}isMoving(){return this._moving||this.handlers&&this.handlers.isMoving()||!1}isZooming(){return this._zooming||this.handlers&&this.handlers.isZooming()||!1}isRotating(){return this._rotating||this.handlers&&this.handlers.isRotating()||!1}_isDragging(){return this.handlers&&this.handlers._isDragging()||!1}_createDelegatedListener(t,e,i){if("mouseenter"===t||"mouseover"===t){let r=!1;const n=n=>{const o=e.filter((t=>this.getLayer(t))),s=o.length?this.queryRenderedFeatures(n.point,{layers:o}):[];s.length?r||(r=!0,i.call(this,new FA(t,this,n.originalEvent,{features:s}))):r=!1;},o=()=>{r=!1;};return {layers:new Set(e),listener:i,delegates:{mousemove:n,mouseout:o}}}if("mouseleave"===t||"mouseout"===t){let r=!1;const n=n=>{const o=e.filter((t=>this.getLayer(t)));(o.length?this.queryRenderedFeatures(n.point,{layers:o}):[]).length?r=!0:r&&(r=!1,i.call(this,new FA(t,this,n.originalEvent)));},o=e=>{r&&(r=!1,i.call(this,new FA(t,this,e.originalEvent)));};return {layers:new Set(e),listener:i,delegates:{mousemove:n,mouseout:o}}}{const r=t=>{const r=e.filter((t=>this.getLayer(t))),n=r.length?this.queryRenderedFeatures(t.point,{layers:r}):[];n.length&&(t.features=n,i.call(this,t),delete t.features);};return {layers:new Set(e),listener:i,delegates:{[t]:r}}}}on(t,e,i){if(void 0===i)return super.on(t,e);if(Array.isArray(e)||(e=[e]),e)for(const t of e)if(!this._isValidId(t))return this;const r=this._createDelegatedListener(t,e,i);this._delegatedListeners=this._delegatedListeners||{},this._delegatedListeners[t]=this._delegatedListeners[t]||[],this._delegatedListeners[t].push(r);for(const t in r.delegates)this.on(t,r.delegates[t]);return this}once(t,e,i){if(void 0===i)return super.once(t,e);if(Array.isArray(e)||(e=[e]),e)for(const t of e)if(!this._isValidId(t))return this;const r=this._createDelegatedListener(t,e,i);for(const t in r.delegates)this.once(t,r.delegates[t]);return this}off(t,e,i){if(void 0===i)return super.off(t,e);e=new Set(Array.isArray(e)?e:[e]);for(const t of e)if(!this._isValidId(t))return this;const r=(t,e)=>{if(t.size!==e.size)return !1;for(const i of t)if(!e.has(i))return !1;return !0},n=this._delegatedListeners?this._delegatedListeners[t]:void 0;return n&&(t=>{for(let n=0;n<t.length;n++){const o=t[n];if(o.listener===i&&r(o.layers,e)){for(const t in o.delegates)this.off(t,o.delegates[t]);return t.splice(n,1),this}}})(n),this}queryRenderedFeatures(t,e){if(!this.style)return [];if(void 0!==e||void 0===t||t instanceof y||Array.isArray(t)||(e=t,t=void 0),t=t||[[0,0],[this.transform.width,this.transform.height]],(e=e||{}).layers&&Array.isArray(e.layers))for(const t of e.layers)if(!this._isValidId(t))return [];return this.style.queryRenderedFeatures(t,e,this.transform)}querySourceFeatures(t,e){return this._isValidId(t)?this.style.querySourceFeatures(t,e):[]}isPointOnSurface(t){const{name:e}=this.transform.projection;return "globe"!==e&&"mercator"!==e&&W(`${e} projection does not support isPointOnSurface, this API may behave unexpectedly.`),this.transform.isPointOnSurface(y.convert(t))}setStyle(t,e){return !1!==(e=k({},{localIdeographFontFamily:this._localIdeographFontFamily,localFontFamily:this._localFontFamily},e)).diff&&e.localIdeographFontFamily===this._localIdeographFontFamily&&e.localFontFamily===this._localFontFamily&&this.style&&t?(this._diffStyle(t,e),this):(this._localIdeographFontFamily=e.localIdeographFontFamily,this._localFontFamily=e.localFontFamily,this._updateStyle(t,e))}_getUIString(t){const e=this._locale[t];if(null==e)throw new Error(`Missing UI string '${t}'`);return e}_updateStyle(t,e){return this.style&&(this.style.setEventedParent(null),this.style._remove(),this.style=void 0),t&&(this.style=new AA(this,e||{}),this.style.setEventedParent(this,{style:this.style}),"string"==typeof t?this.style.loadURL(t):this.style.loadJSON(t)),this._updateTerrain(),this}_lazyInitEmptyStyle(){this.style||(this.style=new AA(this,{}),this.style.setEventedParent(this,{style:this.style}),this.style.loadEmpty());}_diffStyle(t,e){if("string"==typeof t){const i=this._requestManager.normalizeStyleURL(t),r=this._requestManager.transformRequest(i,xt.Style);Tt(r,((t,i)=>{t?this.fire(new Ie(t)):i&&this._updateDiff(i,e);}));}else "object"==typeof t&&this._updateDiff(t,e);}_updateDiff(t,e){try{this.style.setState(t)&&this._update(!0);}catch(i){W(`Unable to perform style diff: ${i.message||i.error||i}.  Rebuilding the style from scratch.`),this._updateStyle(t,e);}}getStyle(){if(this.style)return this.style.serialize()}isStyleLoaded(){return this.style?this.style.loaded():(W("There is no style added to the map."),!1)}_isValidId(t){return !function(t){return t.indexOf(qT)>=0}(t)||(this.fire(new Ie(new Error(`IDs can't contain special symbols: "${t}".`))),!1)}addSource(t,e){return this._isValidId(t)?(this._lazyInitEmptyStyle(),this.style.addSource(t,e),this._update(!0)):this}isSourceLoaded(t){return !!this._isValidId(t)&&!!this.style&&this.style._isSourceCacheLoaded(t)}areTilesLoaded(){const t=this.style&&this.style._sourceCaches;for(const e in t){const i=t[e]._tiles;for(const t in i){const e=i[t];if("loaded"!==e.state&&"errored"!==e.state)return !1}}return !0}addSourceType(t,e,i){this._lazyInitEmptyStyle(),this.style.addSourceType(t,e,i);}removeSource(t){return this._isValidId(t)?(this.style.removeSource(t),this._updateTerrain(),this._update(!0)):this}getSource(t){return this._isValidId(t)?this.style.getOwnSource(t):null}addImage(t,i,{pixelRatio:r=1,sdf:n=!1,stretchX:o,stretchY:s,content:a}={}){if(this._lazyInitEmptyStyle(),i instanceof e.HTMLImageElement||e.ImageBitmap&&i instanceof e.ImageBitmap){const{width:e,height:l,data:c}=ue.getImageData(i);this.style.addImage(t,{data:new Np({width:e,height:l},c),pixelRatio:r,stretchX:o,stretchY:s,content:a,sdf:n,version:0});}else if(void 0===i.width||void 0===i.height)this.fire(new Ie(new Error("Invalid arguments to map.addImage(). The second argument must be an `HTMLImageElement`, `ImageData`, `ImageBitmap`, or object with `width`, `height`, and `data` properties with the same format as `ImageData`")));else {const{width:e,height:l}=i,c=i;this.style.addImage(t,{data:new Np({width:e,height:l},new Uint8Array(c.data)),pixelRatio:r,stretchX:o,stretchY:s,content:a,sdf:n,version:0,userImage:c}),c.onAdd&&c.onAdd(this,t);}}updateImage(t,i){const r=this.style.getImage(t);if(!r)return void this.fire(new Ie(new Error("The map has no image with that id. If you are adding a new image use `map.addImage(...)` instead.")));const n=i instanceof e.HTMLImageElement||e.ImageBitmap&&i instanceof e.ImageBitmap?ue.getImageData(i):i,{width:o,height:s}=n;void 0!==o&&void 0!==s?o===r.data.width&&s===r.data.height?(r.data.replace(n.data,!(i instanceof e.HTMLImageElement||e.ImageBitmap&&i instanceof e.ImageBitmap)),this.style.updateImage(t,r)):this.fire(new Ie(new Error(`The width and height of the updated image (${o}, ${s})\n                must be that same as the previous version of the image\n                (${r.data.width}, ${r.data.height})`))):this.fire(new Ie(new Error("Invalid arguments to map.updateImage(). The second argument must be an `HTMLImageElement`, `ImageData`, `ImageBitmap`, or object with `width`, `height`, and `data` properties with the same format as `ImageData`")));}hasImage(t){return t?!!this.style.getImage(t):(this.fire(new Ie(new Error("Missing required image id"))),!1)}removeImage(t){this.style.removeImage(t);}loadImage(t,i){Ct(this._requestManager.transformRequest(t,xt.Image),((t,r)=>{i(t,r instanceof e.HTMLImageElement?ue.getImageData(r):r);}));}listImages(){return this.style.listImages()}addModel(t,e){this._lazyInitEmptyStyle(),this.style.addModel(t,e);}hasModel(t){return t?this.style.hasModel(t):(this.fire(new Ie(new Error("Missing required model id"))),!1)}removeModel(t){this.style.removeModel(t);}listModels(){return this.style.listModels()}addLayer(t,e){return this._isValidId(t.id)?(this._lazyInitEmptyStyle(),this.style.addLayer(t,e),this._update(!0)):this}moveLayer(t,e){return this._isValidId(t)?(this.style.moveLayer(t,e),this._update(!0)):this}removeLayer(t){return this._isValidId(t)?(this.style.removeLayer(t),this._update(!0)):this}setLights(t){if(this._lazyInitEmptyStyle(),t&&1===t.length&&"flat"===t[0].type){const e=t[0];e.properties?this.style.setFlatLight(e.properties,e.id,{}):this.style.setFlatLight({},"flat");}else this.style.setLights(t),this.painter.terrain&&(this.painter.terrain.invalidateRenderCache=!0);return this._update(!0)}getLights(){const t=this.style.getLights()||[];return 0===t.length&&t.push({id:this.style.light.id,type:"flat",properties:this.style.getFlatLight()}),t}getLayer(t){return this._isValidId(t)?this.style.getOwnLayer(t):null}setLayerZoomRange(t,e,i){return this._isValidId(t)?(this.style.setLayerZoomRange(t,e,i),this._update(!0)):this}setFilter(t,e,i={}){return this._isValidId(t)?(this.style.setFilter(t,e,i),this._update(!0)):this}getFilter(t){return this._isValidId(t)?this.style.getFilter(t):null}setPaintProperty(t,e,i,r={}){return this._isValidId(t)?(this.style.setPaintProperty(t,e,i,r),this._update(!0)):this}getPaintProperty(t,e){return this._isValidId(t)?this.style.getPaintProperty(t,e):null}setLayoutProperty(t,e,i,r={}){return this._isValidId(t)?(this.style.setLayoutProperty(t,e,i,r),this._update(!0)):this}getLayoutProperty(t,e){return this._isValidId(t)?this.style.getLayoutProperty(t,e):null}setConfigProperty(t,e,i){return this.style.setConfigProperty(t,e,i),this._update(!0)}setLight(t,e={}){return console.log("The `map.setLight` function is deprecated, prefer using `map.setLights` with `flat` light type instead."),this.setLights([{id:"flat",type:"flat",properties:t}])}getLight(){return console.log("The `map.getLight` function is deprecated, prefer using `map.getLights` instead."),this.style.getFlatLight()}setTerrain(t){return this._lazyInitEmptyStyle(),!t&&this.transform.projection.requiresDraping?this.style.setTerrainForDraping():this.style.setTerrain(t),this._averageElevationLastSampledAt=-1/0,this._update(!0)}getTerrain(){return this.style?this.style.getTerrain():null}setFog(t){return this._lazyInitEmptyStyle(),this.style.setFog(t),this._update(!0)}getFog(){return this.style?this.style.getFog():null}setCamera(t){return this.style.stylesheet.camera=t,this._update(this.transform.setOrthographicProjectionAtLowPitch("orthographic"===t["camera-projection"]))}getCamera(){return this.style.stylesheet.camera}_queryFogOpacity(t){return this.style&&this.style.fog?this.style.fog.getOpacityAtLatLng(Id.convert(t),this.transform):0}setFeatureState(t,e){return this._isValidId(t.source)?(this.style.setFeatureState(t,e),this._update()):this}removeFeatureState(t,e){return this._isValidId(t.source)?(this.style.removeFeatureState(t,e),this._update()):this}getFeatureState(t){return this._isValidId(t.source)?this.style.getFeatureState(t):null}_updateContainerDimensions(){if(!this._container)return;const t=this._container.getBoundingClientRect().width||400,i=this._container.getBoundingClientRect().height||300;let r,n,o,s=this._container;for(;s&&(!n||!o);){const t=e.getComputedStyle(s).transform;t&&"none"!==t&&(r=t.match(/matrix.*\((.+)\)/)[1].split(", "),r[0]&&"0"!==r[0]&&"1"!==r[0]&&(n=r[0]),r[3]&&"0"!==r[3]&&"1"!==r[3]&&(o=r[3])),s=s.parentElement;}this._containerWidth=n?Math.abs(t/n):t,this._containerHeight=o?Math.abs(i/o):i;}_detectMissingCSS(){"rgb(250, 128, 114)"!==e.getComputedStyle(this._missingCSSCanary).getPropertyValue("background-color")&&W("This page appears to be missing CSS declarations for Mapbox GL JS, which may cause the map to display incorrectly. Please ensure your page includes mapbox-gl.css, as described in https://www.mapbox.com/mapbox-gl-js/api/.");}_setupContainer(){const t=this._container;t.classList.add("mapboxgl-map"),(this._missingCSSCanary=de("div","mapboxgl-canary",t)).style.visibility="hidden",this._detectMissingCSS();const e=this._canvasContainer=de("div","mapboxgl-canvas-container",t);this._canvas=de("canvas","mapboxgl-canvas",e),this._interactive&&(e.classList.add("mapboxgl-interactive"),this._canvas.setAttribute("tabindex","0")),this._canvas.addEventListener("webglcontextlost",this._contextLost,!1),this._canvas.addEventListener("webglcontextrestored",this._contextRestored,!1),this._canvas.setAttribute("aria-label",this._getUIString("Map.Title")),this._canvas.setAttribute("role","region"),this._updateContainerDimensions(),this._resizeCanvas(this._containerWidth,this._containerHeight);const i=this._controlContainer=de("div","mapboxgl-control-container",t),r=this._controlPositions={};["top-left","top-right","bottom-left","bottom-right"].forEach((t=>{r[t]=de("div",`mapboxgl-ctrl-${t}`,i);})),this._container.addEventListener("scroll",this._onMapScroll,!1);}_resizeCanvas(t,e){const i=ue.devicePixelRatio||1;this._canvas.width=i*Math.ceil(t),this._canvas.height=i*Math.ceil(e),this._canvas.style.width=`${t}px`,this._canvas.style.height=`${e}px`;}_addMarker(t){this._markers.push(t);}_removeMarker(t){const e=this._markers.indexOf(t);-1!==e&&this._markers.splice(e,1);}_addPopup(t){this._popups.push(t);}_removePopup(t){const e=this._popups.indexOf(t);-1!==e&&this._popups.splice(e,1);}_setupPainter(){const t=k({},ne.webGLContextAttributes,{failIfMajorPerformanceCaveat:this._failIfMajorPerformanceCaveat,preserveDrawingBuffer:this._preserveDrawingBuffer,antialias:this._antialias||!1}),e=this._canvas.getContext("webgl2",t);e?(Jt(e,!0),this.painter=new dA(e,this.transform),this.on("data",(t=>{"source"===t.dataType&&this.painter.setTileLoadedFlag(!0);})),o.testSupport(e)):this.fire(new Ie(new Error("Failed to initialize WebGL")));}_contextLost(t){t.preventDefault(),this._frame&&(this._frame.cancel(),this._frame=null),this.fire(new Se("webglcontextlost",{originalEvent:t}));}_contextRestored(t){this._setupPainter(),this.resize(),this._update(),this.fire(new Se("webglcontextrestored",{originalEvent:t}));}_onMapScroll(t){if(t.target===this._container)return this._container.scrollTop=0,this._container.scrollLeft=0,!1}loaded(){return !this._styleDirty&&!this._sourcesDirty&&!!this.style&&this.style.loaded()}_update(t){return this.style?(this._styleDirty=this._styleDirty||t,this._sourcesDirty=!0,this.triggerRepaint(),this):this}_requestRenderFrame(t){return this._update(),this._renderTaskQueue.add(t)}_cancelRenderFrame(t){this._renderTaskQueue.remove(t);}_requestDomTask(t){!this.loaded()||this.loaded()&&!this.isMoving()?t():this._domRenderTaskQueue.add(t);}_render(t){let i;const r=this.painter.context.extTimerQuery,n=ue.now();if(this.listens("gpu-timing-frame")&&(i=r.createQueryEXT(),r.beginQueryEXT(r.TIME_ELAPSED_EXT,i)),this.painter.context.setDirty(),this.painter.setBaseState(),(this.isMoving()||this.isRotating()||this.isZooming())&&(this._interactionRange[0]=Math.min(this._interactionRange[0],e.performance.now()),this._interactionRange[1]=Math.max(this._interactionRange[1],e.performance.now())),this._renderTaskQueue.run(t),this._domRenderTaskQueue.run(t),this._removed)return;this._updateProjectionTransition();const o=this._isInitialLoad?0:this._fadeDuration;if(this.style&&this._styleDirty){this._styleDirty=!1;const t=this.transform.zoom,e=this.transform.pitch,i=ue.now(),r=new Qs(t,{now:i,fadeDuration:o,pitch:e,transition:this.style.getTransition()});this.style.update(r);}this.style&&this.style.hasFogTransition()&&(this.style._markersNeedUpdate=!0,this._sourcesDirty=!0);let s=!1;if(this.style&&this._sourcesDirty?(this._sourcesDirty=!1,this.painter._updateFog(this.style),this._updateTerrain(),s=this._updateAverageElevation(n),this.style._updateSources(this.transform),this._forceMarkerAndPopupUpdate()):s=this._updateAverageElevation(n),this._placementDirty=this.style&&this.style._updatePlacement(this.painter.transform,this.showCollisionBoxes,o,this._crossSourceCollisions),this.style&&this.painter.render(this.style,{showTileBoundaries:this.showTileBoundaries,wireframe:{terrain:this.showTerrainWireframe,layers2D:this.showLayers2DWireframe,layers3D:this.showLayers3DWireframe},showOverdrawInspector:this._showOverdrawInspector,showQueryGeometry:!!this._showQueryGeometry,showTileAABBs:this.showTileAABBs,rotating:this.isRotating(),zooming:this.isZooming(),moving:this.isMoving(),fadeDuration:o,isInitialLoad:this._isInitialLoad,showPadding:this.showPadding,gpuTiming:!!this.listens("gpu-timing-layer"),gpuTimingDeferredRender:!!this.listens("gpu-timing-deferred-render"),speedIndexTiming:this.speedIndexTiming}),this.fire(new Se("render")),this.loaded()&&!this._loaded&&(this._loaded=!0,this.fire(new Se("load"))),this.style&&this.style.hasTransitions()&&(this._styleDirty=!0),this.style&&!this._placementDirty&&this.style._releaseSymbolFadeTiles(),i){const t=ue.now()-n;r.endQueryEXT(r.TIME_ELAPSED_EXT,i),setTimeout((()=>{const o=r.getQueryObjectEXT(i,r.QUERY_RESULT_EXT)/1e6;r.deleteQueryEXT(i),this.fire(new Se("gpu-timing-frame",{cpuTime:t,gpuTime:o})),e.performance.mark("frame-gpu",{startTime:n,detail:{gpuTime:o}});}),50);}if(this.listens("gpu-timing-layer")){const t=this.painter.collectGpuTimers();setTimeout((()=>{const e=this.painter.queryGpuTimers(t);this.fire(new Se("gpu-timing-layer",{layerTimes:e}));}),50);}if(this.listens("gpu-timing-deferred-render")){const t=this.painter.collectDeferredRenderGpuQueries();setTimeout((()=>{const e=this.painter.queryGpuTimeDeferredRender(t);this.fire(new Se("gpu-timing-deferred-render",{gpuTime:e}));}),50);}const a=this._sourcesDirty||this._styleDirty||this._placementDirty||s;if(a||this._repaint)this.triggerRepaint();else {const t=!this.isMoving()&&this.loaded();if(t&&(s=this._updateAverageElevation(n,!0)),s)this.triggerRepaint();else if(this._triggerFrame(!1),t&&(this.fire(new Se("idle")),this._isInitialLoad=!1,this.speedIndexTiming)){const t=this._calculateSpeedIndex();this.fire(new Se("speedindexcompleted",{speedIndex:t})),this.speedIndexTiming=!1;}}!this._loaded||this._fullyLoaded||a||(this._fullyLoaded=!0,te.mark(Qt.fullLoad),this._performanceMetricsCollection&&Wt(this._requestManager._customAccessToken,{width:this.painter.width,height:this.painter.height,interactionRange:this._interactionRange,visibilityHidden:this._visibilityHidden,terrainEnabled:!!this.painter.style.getTerrain(),fogEnabled:!!this.painter.style.getFog(),projection:this.getProjection().name,zoom:this.transform.zoom,renderer:this.painter.context.renderer,vendor:this.painter.context.vendor}),this._authenticate());}_forceMarkerAndPopupUpdate(t){for(const e of this._markers)t&&!this.getRenderWorldCopies()&&(e._lngLat=e._lngLat.wrap()),e._update();for(const e of this._popups)!t||this.getRenderWorldCopies()||e._trackPointer||(e._lngLat=e._lngLat.wrap()),e._update();}_updateAverageElevation(t,e=!1){const i=t=>(this.transform.averageElevation=t,this._update(!1),!0);if(!this.painter.averageElevationNeedsEasing())return 0!==this.transform.averageElevation&&i(0);if((e||t-this._averageElevationLastSampledAt>500)&&!this._averageElevation.isEasing(t)){const e=this.transform.averageElevation;let r=this.transform.sampleAverageElevation(),n=!1;this.transform.elevation&&(n=this.transform.elevation.exaggeration()!==this._averageElevationExaggeration,this._averageElevationExaggeration=this.transform.elevation.exaggeration()),isNaN(r)?r=0:this._averageElevationLastSampledAt=t;const o=Math.abs(e-r);if(o>1){if(this._isInitialLoad||n)return this._averageElevation.jumpTo(r),i(r);this._averageElevation.easeTo(r,t,300);}else if(o>1e-4)return this._averageElevation.jumpTo(r),i(r)}return !!this._averageElevation.isEasing(t)&&i(this._averageElevation.getValue(t))}_authenticate(){Yt(this._getMapId(),this._requestManager._skuToken,this._requestManager._customAccessToken,(t=>{if(t&&(t.message===zt||401===t.status)){const t=this.painter.context.gl;Jt(t,!1),this._logoControl instanceof SS&&this._logoControl._updateLogo(),t&&t.clear(t.DEPTH_BUFFER_BIT|t.COLOR_BUFFER_BIT|t.STENCIL_BUFFER_BIT),this._silenceAuthErrors||this.fire(new Ie(new Error("A valid Mapbox access token is required to use Mapbox GL JS. To create an account or a new access token, visit https://account.mapbox.com/")));}})),$t(this._getMapId(),this._requestManager._skuToken,this._requestManager._customAccessToken,(()=>{}));}_updateTerrain(){const t=this._isDragging();this.painter.updateTerrain(this.style,t);}_calculateSpeedIndex(){const t=this.painter.canvasCopy(),e=this.painter.getCanvasCopiesAndTimestamps();e.timeStamps.push(performance.now());const i=this.painter.context.gl,r=i.createFramebuffer();function n(t){i.framebufferTexture2D(i.FRAMEBUFFER,i.COLOR_ATTACHMENT0,i.TEXTURE_2D,t,0);const e=new Uint8Array(i.drawingBufferWidth*i.drawingBufferHeight*4);return i.readPixels(0,0,i.drawingBufferWidth,i.drawingBufferHeight,i.RGBA,i.UNSIGNED_BYTE,e),e}return i.bindFramebuffer(i.FRAMEBUFFER,r),this._canvasPixelComparison(n(t),e.canvasCopies.map(n),e.timeStamps)}_canvasPixelComparison(t,e,i){let r=i[1]-i[0];const n=t.length/4;for(let o=0;o<e.length;o++){const s=e[o];let a=0;for(let e=0;e<s.length;e+=4)s[e]===t[e]&&s[e+1]===t[e+1]&&s[e+2]===t[e+2]&&s[e+3]===t[e+3]&&(a+=1);r+=(i[o+2]-i[o+1])*(1-a/n);}return r}remove(){this._hash&&this._hash.remove();for(const t of this._controls)t.onRemove(this);this._controls=[],this._frame&&(this._frame.cancel(),this._frame=null),this._renderTaskQueue.clear(),this._domRenderTaskQueue.clear(),this.style&&this.style.destroy(),this.painter.destroy(),this.handlers&&this.handlers.destroy(),this.handlers=void 0,this.setStyle(null),void 0!==e&&(e.removeEventListener("resize",this._onWindowResize,!1),e.removeEventListener("orientationchange",this._onWindowResize,!1),e.removeEventListener(this._fullscreenchangeEvent,this._onWindowResize,!1),e.removeEventListener("online",this._onWindowOnline,!1),e.removeEventListener("visibilitychange",this._onVisibilityChange,!1));const t=this.painter.context.gl.getExtension("WEBGL_lose_context");t&&t.loseContext(),this._canvas.removeEventListener("webglcontextlost",this._contextLost,!1),this._canvas.removeEventListener("webglcontextrestored",this._contextRestored,!1),this._canvasContainer.remove(),this._controlContainer.remove(),this._missingCSSCanary.remove(),this._canvas=void 0,this._canvasContainer=void 0,this._controlContainer=void 0,this._missingCSSCanary=void 0,this._container.classList.remove("mapboxgl-map"),this._container.removeEventListener("scroll",this._onMapScroll,!1),Kt.delete(this.painter.context.gl),this._removed=!0,this.fire(new Se("remove"));}triggerRepaint(){this._triggerFrame(!0);}_triggerFrame(t){this._renderNextFrame=this._renderNextFrame||t,this.style&&!this._frame&&(this._frame=ue.frame((t=>{const e=!!this._renderNextFrame;this._frame=null,this._renderNextFrame=null,e&&this._render(t);})));}_preloadTiles(t){return R(this.style?Object.values(this.style._sourceCaches):[],((e,i)=>e._preloadTiles(t,i)),(()=>{this.triggerRepaint();})),this}_onWindowOnline(){this._update();}_onWindowResize(t){this._trackResize&&this.resize({originalEvent:t})._update();}_onVisibilityChange(){"hidden"===e.document.visibilityState&&this._visibilityHidden++;}get showTileBoundaries(){return !!this._showTileBoundaries}set showTileBoundaries(t){this._showTileBoundaries!==t&&(this._showTileBoundaries=t,this._update());}get showTerrainWireframe(){return !!this._showTerrainWireframe}set showTerrainWireframe(t){this._showTerrainWireframe!==t&&(this._showTerrainWireframe=t,this._update());}get showLayers2DWireframe(){return !!this._showLayers2DWireframe}set showLayers2DWireframe(t){this._showLayers2DWireframe!==t&&(this._showLayers2DWireframe=t,this._update());}get showLayers3DWireframe(){return !!this._showLayers3DWireframe}set showLayers3DWireframe(t){this._showLayers3DWireframe!==t&&(this._showLayers3DWireframe=t,this._update());}get speedIndexTiming(){return !!this._speedIndexTiming}set speedIndexTiming(t){this._speedIndexTiming!==t&&(this._speedIndexTiming=t,this._update());}get showPadding(){return !!this._showPadding}set showPadding(t){this._showPadding!==t&&(this._showPadding=t,this._update());}get showCollisionBoxes(){return !!this._showCollisionBoxes}set showCollisionBoxes(t){this._showCollisionBoxes!==t&&(this._showCollisionBoxes=t,t?this.style._generateCollisionBoxes():this._update());}get showOverdrawInspector(){return !!this._showOverdrawInspector}set showOverdrawInspector(t){this._showOverdrawInspector!==t&&(this._showOverdrawInspector=t,this._update());}get repaint(){return !!this._repaint}set repaint(t){this._repaint!==t&&(this._repaint=t,this.triggerRepaint());}get vertices(){return !!this._vertices}set vertices(t){this._vertices=t,this._update();}get showTileAABBs(){return !!this._showTileAABBs}set showTileAABBs(t){this._showTileAABBs!==t&&(this._showTileAABBs=t,t&&this._update());}_setCacheLimits(t,e){!function(t,e){ht=t,ut=e;}(t,e);}get version(){return i}},NavigationControl:class{constructor(t){this.options=k({},FS,t),this._container=de("div","mapboxgl-ctrl mapboxgl-ctrl-group"),this._container.addEventListener("contextmenu",(t=>t.preventDefault())),this.options.showZoom&&(j(["_setButtonTitle","_updateZoomButtons"],this),this._zoomInButton=this._createButton("mapboxgl-ctrl-zoom-in",(t=>{this._map&&this._map.zoomIn({},{originalEvent:t});})),de("span","mapboxgl-ctrl-icon",this._zoomInButton).setAttribute("aria-hidden","true"),this._zoomOutButton=this._createButton("mapboxgl-ctrl-zoom-out",(t=>{this._map&&this._map.zoomOut({},{originalEvent:t});})),de("span","mapboxgl-ctrl-icon",this._zoomOutButton).setAttribute("aria-hidden","true")),this.options.showCompass&&(j(["_rotateCompassArrow"],this),this._compass=this._createButton("mapboxgl-ctrl-compass",(t=>{const e=this._map;e&&(this.options.visualizePitch?e.resetNorthPitch({},{originalEvent:t}):e.resetNorth({},{originalEvent:t}));})),this._compassIcon=de("span","mapboxgl-ctrl-icon",this._compass),this._compassIcon.setAttribute("aria-hidden","true"));}_updateZoomButtons(){const t=this._map;if(!t)return;const e=t.getZoom(),i=e===t.getMaxZoom(),r=e===t.getMinZoom();this._zoomInButton.disabled=i,this._zoomOutButton.disabled=r,this._zoomInButton.setAttribute("aria-disabled",i.toString()),this._zoomOutButton.setAttribute("aria-disabled",r.toString());}_rotateCompassArrow(){const t=this._map;if(!t)return;const e=this.options.visualizePitch?`scale(${1/Math.pow(Math.cos(t.transform.pitch*(Math.PI/180)),.5)}) rotateX(${t.transform.pitch}deg) rotateZ(${t.transform.angle*(180/Math.PI)}deg)`:`rotate(${t.transform.angle*(180/Math.PI)}deg)`;t._requestDomTask((()=>{this._compassIcon&&(this._compassIcon.style.transform=e);}));}onAdd(t){return this._map=t,this.options.showZoom&&(this._setButtonTitle(this._zoomInButton,"ZoomIn"),this._setButtonTitle(this._zoomOutButton,"ZoomOut"),t.on("zoom",this._updateZoomButtons),this._updateZoomButtons()),this.options.showCompass&&(this._setButtonTitle(this._compass,"ResetBearing"),this.options.visualizePitch&&t.on("pitch",this._rotateCompassArrow),t.on("rotate",this._rotateCompassArrow),this._rotateCompassArrow(),this._handler=new NS(t,this._compass,this.options.visualizePitch)),this._container}onRemove(){const t=this._map;t&&(this._container.remove(),this.options.showZoom&&t.off("zoom",this._updateZoomButtons),this.options.showCompass&&(this.options.visualizePitch&&t.off("pitch",this._rotateCompassArrow),t.off("rotate",this._rotateCompassArrow),this._handler&&this._handler.off(),this._handler=void 0),this._map=void 0);}_createButton(t,e){const i=de("button",t,this._container);return i.type="button",i.addEventListener("click",e),i}_setButtonTitle(t,e){if(!this._map)return;const i=this._map._getUIString(`NavigationControl.${e}`);t.setAttribute("aria-label",i),t.firstElementChild&&t.firstElementChild.setAttribute("title",i);}},GeolocateControl:class extends Ce{constructor(t){super(),this.options=k({geolocation:e.navigator.geolocation},US,t),j(["_onSuccess","_onError","_onZoom","_finish","_setupUI","_updateCamera","_updateMarker","_updateMarkerRotation","_onDeviceOrientation"],this),this._updateMarkerRotationThrottled=SA(this._updateMarkerRotation,20),this._numberOfWatches=0;}onAdd(t){return this._map=t,this._container=de("div","mapboxgl-ctrl mapboxgl-ctrl-group"),this._checkGeolocationSupport(this._setupUI),this._container}onRemove(){void 0!==this._geolocationWatchID&&(this.options.geolocation.clearWatch(this._geolocationWatchID),this._geolocationWatchID=void 0),this.options.showUserLocation&&this._userLocationDotMarker&&this._userLocationDotMarker.remove(),this.options.showAccuracyCircle&&this._accuracyCircleMarker&&this._accuracyCircleMarker.remove(),this._container.remove(),this._map.off("zoom",this._onZoom),this._map=void 0,this._numberOfWatches=0,this._noTimeout=!1;}_checkGeolocationSupport(t){const i=(e=!!this.options.geolocation)=>{this._supportsGeolocation=e,t(e);};void 0!==this._supportsGeolocation?t(this._supportsGeolocation):void 0!==e.navigator.permissions?e.navigator.permissions.query({name:"geolocation"}).then((t=>i("denied"!==t.state))).catch((()=>i())):i();}_isOutOfMapMaxBounds(t){const e=this._map.getMaxBounds(),i=t.coords;return !!e&&(i.longitude<e.getWest()||i.longitude>e.getEast()||i.latitude<e.getSouth()||i.latitude>e.getNorth())}_setErrorState(){switch(this._watchState){case"WAITING_ACTIVE":this._watchState="ACTIVE_ERROR",this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active"),this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-active-error");break;case"ACTIVE_LOCK":this._watchState="ACTIVE_ERROR",this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active"),this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-active-error"),this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-waiting");break;case"BACKGROUND":this._watchState="BACKGROUND_ERROR",this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-background"),this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-background-error"),this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-waiting");}}_onSuccess(t){if(this._map){if(this._isOutOfMapMaxBounds(t))return this._setErrorState(),this.fire(new Se("outofmaxbounds",t)),this._updateMarker(),void this._finish();if(this.options.trackUserLocation)switch(this._lastKnownPosition=t,this._watchState){case"WAITING_ACTIVE":case"ACTIVE_LOCK":case"ACTIVE_ERROR":this._watchState="ACTIVE_LOCK",this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-waiting"),this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active-error"),this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-active");break;case"BACKGROUND":case"BACKGROUND_ERROR":this._watchState="BACKGROUND",this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-waiting"),this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-background-error"),this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-background");}this.options.showUserLocation&&"OFF"!==this._watchState&&this._updateMarker(t),this.options.trackUserLocation&&"ACTIVE_LOCK"!==this._watchState||this._updateCamera(t),this.options.showUserLocation&&this._userLocationDotMarker.removeClassName("mapboxgl-user-location-dot-stale"),this.fire(new Se("geolocate",t)),this._finish();}}_updateCamera(t){const e=new Id(t.coords.longitude,t.coords.latitude),i=t.coords.accuracy,r=k({bearing:this._map.getBearing()},this.options.fitBoundsOptions);this._map.fitBounds(e.toBounds(i),r,{geolocateSource:!0});}_updateMarker(t){if(t){const e=new Id(t.coords.longitude,t.coords.latitude);this._accuracyCircleMarker.setLngLat(e).addTo(this._map),this._userLocationDotMarker.setLngLat(e).addTo(this._map),this._accuracy=t.coords.accuracy,this.options.showUserLocation&&this.options.showAccuracyCircle&&this._updateCircleRadius();}else this._userLocationDotMarker.remove(),this._accuracyCircleMarker.remove();}_updateCircleRadius(){const t=this._map.transform,e=Vd(1,t._center.lat)*t.worldSize,i=Math.ceil(2*this._accuracy*e);this._circleElement.style.width=`${i}px`,this._circleElement.style.height=`${i}px`;}_onZoom(){this.options.showUserLocation&&this.options.showAccuracyCircle&&this._updateCircleRadius();}_updateMarkerRotation(){this._userLocationDotMarker&&"number"==typeof this._heading?(this._userLocationDotMarker.setRotation(this._heading),this._userLocationDotMarker.addClassName("mapboxgl-user-location-show-heading")):(this._userLocationDotMarker.removeClassName("mapboxgl-user-location-show-heading"),this._userLocationDotMarker.setRotation(0));}_onError(t){if(this._map){if(this.options.trackUserLocation)if(1===t.code){this._watchState="OFF",this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-waiting"),this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active"),this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active-error"),this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-background"),this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-background-error"),this._geolocateButton.disabled=!0;const t=this._map._getUIString("GeolocateControl.LocationNotAvailable");this._geolocateButton.setAttribute("aria-label",t),this._geolocateButton.firstElementChild&&this._geolocateButton.firstElementChild.setAttribute("title",t),void 0!==this._geolocationWatchID&&this._clearWatch();}else {if(3===t.code&&this._noTimeout)return;this._setErrorState();}"OFF"!==this._watchState&&this.options.showUserLocation&&this._userLocationDotMarker.addClassName("mapboxgl-user-location-dot-stale"),this.fire(new Se("error",t)),this._finish();}}_finish(){this._timeoutId&&clearTimeout(this._timeoutId),this._timeoutId=void 0;}_setupUI(t){if(void 0!==this._map){if(this._container.addEventListener("contextmenu",(t=>t.preventDefault())),this._geolocateButton=de("button","mapboxgl-ctrl-geolocate",this._container),de("span","mapboxgl-ctrl-icon",this._geolocateButton).setAttribute("aria-hidden","true"),this._geolocateButton.type="button",!1===t){W("Geolocation support is not available so the GeolocateControl will be disabled.");const t=this._map._getUIString("GeolocateControl.LocationNotAvailable");this._geolocateButton.disabled=!0,this._geolocateButton.setAttribute("aria-label",t),this._geolocateButton.firstElementChild&&this._geolocateButton.firstElementChild.setAttribute("title",t);}else {const t=this._map._getUIString("GeolocateControl.FindMyLocation");this._geolocateButton.setAttribute("aria-label",t),this._geolocateButton.firstElementChild&&this._geolocateButton.firstElementChild.setAttribute("title",t);}this.options.trackUserLocation&&(this._geolocateButton.setAttribute("aria-pressed","false"),this._watchState="OFF"),this.options.showUserLocation&&(this._dotElement=de("div","mapboxgl-user-location"),this._dotElement.appendChild(de("div","mapboxgl-user-location-dot")),this._dotElement.appendChild(de("div","mapboxgl-user-location-heading")),this._userLocationDotMarker=new DS({element:this._dotElement,rotationAlignment:"map",pitchAlignment:"map"}),this._circleElement=de("div","mapboxgl-user-location-accuracy-circle"),this._accuracyCircleMarker=new DS({element:this._circleElement,pitchAlignment:"map"}),this.options.trackUserLocation&&(this._watchState="OFF"),this._map.on("zoom",this._onZoom)),this._geolocateButton.addEventListener("click",this.trigger.bind(this)),this._setup=!0,this.options.trackUserLocation&&this._map.on("movestart",(t=>{t.geolocateSource||"ACTIVE_LOCK"!==this._watchState||t.originalEvent&&"resize"===t.originalEvent.type||(this._watchState="BACKGROUND",this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-background"),this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active"),this.fire(new Se("trackuserlocationend")));}));}}_onDeviceOrientation(t){this._userLocationDotMarker&&(t.webkitCompassHeading?this._heading=t.webkitCompassHeading:!0===t.absolute&&(this._heading=-1*t.alpha),this._updateMarkerRotationThrottled());}trigger(){if(!this._setup)return W("Geolocate control triggered before added to a map"),!1;if(this.options.trackUserLocation){switch(this._watchState){case"OFF":this._watchState="WAITING_ACTIVE",this.fire(new Se("trackuserlocationstart"));break;case"WAITING_ACTIVE":case"ACTIVE_LOCK":case"ACTIVE_ERROR":case"BACKGROUND_ERROR":this._numberOfWatches--,this._noTimeout=!1,this._watchState="OFF",this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-waiting"),this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active"),this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active-error"),this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-background"),this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-background-error"),this.fire(new Se("trackuserlocationend"));break;case"BACKGROUND":this._watchState="ACTIVE_LOCK",this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-background"),this._lastKnownPosition&&this._updateCamera(this._lastKnownPosition),this.fire(new Se("trackuserlocationstart"));}switch(this._watchState){case"WAITING_ACTIVE":this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-waiting"),this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-active");break;case"ACTIVE_LOCK":this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-active");break;case"ACTIVE_ERROR":this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-waiting"),this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-active-error");break;case"BACKGROUND":this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-background");break;case"BACKGROUND_ERROR":this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-waiting"),this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-background-error");}if("OFF"===this._watchState&&void 0!==this._geolocationWatchID)this._clearWatch();else if(void 0===this._geolocationWatchID){let t;this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-waiting"),this._geolocateButton.setAttribute("aria-pressed","true"),this._numberOfWatches++,this._numberOfWatches>1?(t={maximumAge:6e5,timeout:0},this._noTimeout=!0):(t=this.options.positionOptions,this._noTimeout=!1),this._geolocationWatchID=this.options.geolocation.watchPosition(this._onSuccess,this._onError,t),this.options.showUserHeading&&this._addDeviceOrientationListener();}}else this.options.geolocation.getCurrentPosition(this._onSuccess,this._onError,this.options.positionOptions),this._timeoutId=setTimeout(this._finish,1e4);return !0}_addDeviceOrientationListener(){const t=()=>{e.addEventListener("ondeviceorientationabsolute"in e?"deviceorientationabsolute":"deviceorientation",this._onDeviceOrientation);};void 0!==e.DeviceMotionEvent&&"function"==typeof e.DeviceMotionEvent.requestPermission?DeviceOrientationEvent.requestPermission().then((e=>{"granted"===e&&t();})).catch(console.error):t();}_clearWatch(){this.options.geolocation.clearWatch(this._geolocationWatchID),e.removeEventListener("deviceorientation",this._onDeviceOrientation),e.removeEventListener("deviceorientationabsolute",this._onDeviceOrientation),this._geolocationWatchID=void 0,this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-waiting"),this._geolocateButton.setAttribute("aria-pressed","false"),this.options.showUserLocation&&this._updateMarker(null);}},AttributionControl:AS,ScaleControl:class{constructor(t){this.options=k({},VS,t),this._isNumberFormatSupported=function(){try{return new Intl.NumberFormat("en",{style:"unit",unitDisplay:"short",unit:"meter"}),!0}catch(t){return !1}}(),j(["_update","_setScale","setUnit"],this);}getDefaultPosition(){return "bottom-left"}_update(){const t=this.options.maxWidth||100,e=this._map,i=e._containerHeight/2,r=e._containerWidth/2-t/2,n=e.unproject([r,i]),o=e.unproject([r+t,i]),s=n.distanceTo(o);if("imperial"===this.options.unit){const e=3.2808*s;e>5280?this._setScale(t,e/5280,"mile"):this._setScale(t,e,"foot");}else "nautical"===this.options.unit?this._setScale(t,s/1852,"nautical-mile"):s>=1e3?this._setScale(t,s/1e3,"kilometer"):this._setScale(t,s,"meter");}_setScale(t,e,i){this._map._requestDomTask((()=>{const r=function(t){const e=Math.pow(10,`${Math.floor(t)}`.length-1);let i=t/e;return i=i>=10?10:i>=5?5:i>=3?3:i>=2?2:i>=1?1:function(t){const e=Math.pow(10,Math.ceil(-Math.log(t)/Math.LN10));return Math.round(t*e)/e}(i),e*i}(e),n=r/e;this._container.innerHTML=this._isNumberFormatSupported&&"nautical-mile"!==i?new Intl.NumberFormat(this._language,{style:"unit",unitDisplay:"short",unit:i}).format(r):`${r}&nbsp;${jS[i]}`,this._container.style.width=t*n+"px";}));}onAdd(t){return this._map=t,this._language=t.getLanguage(),this._container=de("div","mapboxgl-ctrl mapboxgl-ctrl-scale",t.getContainer()),this._container.dir="auto",this._map.on("move",this._update),this._update(),this._container}onRemove(){this._container.remove(),this._map.off("move",this._update),this._map=void 0;}_setLanguage(t){this._language=t,this._update();}setUnit(t){this.options.unit=t,this._update();}},FullscreenControl:class{constructor(t){this._fullscreen=!1,t&&t.container&&(t.container instanceof e.HTMLElement?this._container=t.container:W("Full screen control 'container' must be a DOM element.")),j(["_onClickFullscreen","_changeIcon"],this),"onfullscreenchange"in e.document?this._fullscreenchange="fullscreenchange":"onwebkitfullscreenchange"in e.document&&(this._fullscreenchange="webkitfullscreenchange");}onAdd(t){return this._map=t,this._container||(this._container=this._map.getContainer()),this._controlContainer=de("div","mapboxgl-ctrl mapboxgl-ctrl-group"),this._checkFullscreenSupport()?this._setupUI():(this._controlContainer.style.display="none",W("This device does not support fullscreen mode.")),this._controlContainer}onRemove(){this._controlContainer.remove(),this._map=null,e.document.removeEventListener(this._fullscreenchange,this._changeIcon);}_checkFullscreenSupport(){return !(!e.document.fullscreenEnabled&&!e.document.webkitFullscreenEnabled)}_setupUI(){const t=this._fullscreenButton=de("button","mapboxgl-ctrl-fullscreen",this._controlContainer);de("span","mapboxgl-ctrl-icon",t).setAttribute("aria-hidden","true"),t.type="button",this._updateTitle(),this._fullscreenButton.addEventListener("click",this._onClickFullscreen),e.document.addEventListener(this._fullscreenchange,this._changeIcon);}_updateTitle(){const t=this._getTitle();this._fullscreenButton.setAttribute("aria-label",t),this._fullscreenButton.firstElementChild&&this._fullscreenButton.firstElementChild.setAttribute("title",t);}_getTitle(){return this._map._getUIString(this._isFullscreen()?"FullscreenControl.Exit":"FullscreenControl.Enter")}_isFullscreen(){return this._fullscreen}_changeIcon(){(e.document.fullscreenElement||e.document.webkitFullscreenElement)===this._container!==this._fullscreen&&(this._fullscreen=!this._fullscreen,this._fullscreenButton.classList.toggle("mapboxgl-ctrl-shrink"),this._fullscreenButton.classList.toggle("mapboxgl-ctrl-fullscreen"),this._updateTitle());}_onClickFullscreen(){this._isFullscreen()?e.document.exitFullscreen?e.document.exitFullscreen():e.document.webkitCancelFullScreen&&e.document.webkitCancelFullScreen():this._container.requestFullscreen?this._container.requestFullscreen():this._container.webkitRequestFullscreen&&this._container.webkitRequestFullscreen();}},Popup:class extends Ce{constructor(t){super(),this.options=k(Object.create(PS),t),j(["_update","_onClose","remove","_onMouseEvent"],this),this._classList=new Set(t&&t.className?t.className.trim().split(/\s+/):[]);}addTo(t){return this._map&&this.remove(),this._map=t,this.options.closeOnClick&&t.on("preclick",this._onClose),this.options.closeOnMove&&t.on("move",this._onClose),t.on("remove",this.remove),this._update(),t._addPopup(this),this._focusFirstElement(),this._trackPointer?(t.on("mousemove",this._onMouseEvent),t.on("mouseup",this._onMouseEvent),t._canvasContainer.classList.add("mapboxgl-track-pointer")):t.on("move",this._update),this.fire(new Se("open")),this}isOpen(){return !!this._map}remove(){this._content&&this._content.remove(),this._container&&(this._container.remove(),this._container=void 0);const t=this._map;return t&&(t.off("move",this._update),t.off("move",this._onClose),t.off("preclick",this._onClose),t.off("click",this._onClose),t.off("remove",this.remove),t.off("mousemove",this._onMouseEvent),t.off("mouseup",this._onMouseEvent),t.off("drag",this._onMouseEvent),t._canvasContainer&&t._canvasContainer.classList.remove("mapboxgl-track-pointer"),t._removePopup(this),this._map=void 0),this.fire(new Se("close")),this}getLngLat(){return this._lngLat}setLngLat(t){this._lngLat=Id.convert(t),this._pos=null,this._trackPointer=!1,this._update();const e=this._map;return e&&(e.on("move",this._update),e.off("mousemove",this._onMouseEvent),e._canvasContainer.classList.remove("mapboxgl-track-pointer")),this}trackPointer(){this._trackPointer=!0,this._pos=null,this._update();const t=this._map;return t&&(t.off("move",this._update),t.on("mousemove",this._onMouseEvent),t.on("drag",this._onMouseEvent),t._canvasContainer.classList.add("mapboxgl-track-pointer")),this}getElement(){return this._container}setText(t){return this.setDOMContent(e.document.createTextNode(t))}setHTML(t){const i=e.document.createDocumentFragment(),r=e.document.createElement("body");let n;for(r.innerHTML=t;n=r.firstChild,n;)i.appendChild(n);return this.setDOMContent(i)}getMaxWidth(){return this._container&&this._container.style.maxWidth}setMaxWidth(t){return this.options.maxWidth=t,this._update(),this}setDOMContent(t){let e=this._content;if(e)for(;e.hasChildNodes();)e.firstChild&&e.removeChild(e.firstChild);else e=this._content=de("div","mapboxgl-popup-content",this._container||void 0);if(e.appendChild(t),this.options.closeButton){const t=this._closeButton=de("button","mapboxgl-popup-close-button",e);t.type="button",t.setAttribute("aria-label","Close popup"),t.setAttribute("aria-hidden","true"),t.innerHTML="&#215;",t.addEventListener("click",this._onClose);}return this._update(),this._focusFirstElement(),this}addClassName(t){return this._classList.add(t),this._updateClassList(),this}removeClassName(t){return this._classList.delete(t),this._updateClassList(),this}setOffset(t){return this.options.offset=t,this._update(),this}toggleClassName(t){let e;return this._classList.delete(t)?e=!1:(this._classList.add(t),e=!0),this._updateClassList(),e}_onMouseEvent(t){this._update(t.point);}_getAnchor(t){if(this.options.anchor)return this.options.anchor;const e=this._map,i=this._container,r=this._pos;if(!e||!i||!r)return "bottom";const n=i.offsetWidth,o=i.offsetHeight,s=r.x<n/2,a=r.x>e.transform.width-n/2;if(r.y+t<o)return s?"top-left":a?"top-right":"top";if(r.y>e.transform.height-o){if(s)return "bottom-left";if(a)return "bottom-right"}return s?"left":a?"right":"bottom"}_updateClassList(){const t=this._container;if(!t)return;const e=[...this._classList];e.push("mapboxgl-popup"),this._anchor&&e.push(`mapboxgl-popup-anchor-${this._anchor}`),this._trackPointer&&e.push("mapboxgl-popup-track-pointer"),t.className=e.join(" ");}_update(t){const e=this._map,i=this._content;if(!e||!this._lngLat&&!this._trackPointer||!i)return;let r=this._container;if(r||(r=this._container=de("div","mapboxgl-popup",e.getContainer()),this._tip=de("div","mapboxgl-popup-tip",r),r.appendChild(i)),this.options.maxWidth&&r.style.maxWidth!==this.options.maxWidth&&(r.style.maxWidth=this.options.maxWidth),e.transform.renderWorldCopies&&!this._trackPointer&&(this._lngLat=CS(this._lngLat,this._pos,e.transform)),!this._trackPointer||t){const i=this._pos=this._trackPointer&&t?t:e.project(this._lngLat),r=LS(this.options.offset),n=this._anchor=this._getAnchor(r.y),o=LS(this.options.offset,n),s=i.add(o).round();e._requestDomTask((()=>{this._container&&n&&(this._container.style.transform=`${zS[n]} translate(${s.x}px,${s.y}px)`);}));}if(!this._marker&&e._showingGlobe()){const t=vd(e.transform,this._lngLat)?0:1;this._setOpacity(t);}this._updateClassList();}_focusFirstElement(){if(!this.options.focusAfterOpen||!this._container)return;const t=this._container.querySelector(RS);t&&t.focus();}_onClose(){this.remove();}_setOpacity(t){this._container&&(this._container.style.opacity=`${t}`),this._content&&(this._content.style.pointerEvents=t?"auto":"none");}},Marker:DS,Style:AA,LngLat:Id,LngLatBounds:Xl,Point:y,MercatorCoordinate:Yd,FreeCameraOptions:Rx,Evented:Ce,config:n,prewarm:function(){Pw().acquire(Cw);},clearPrewarmedResources:function(){const t=Dw;t&&(t.isPreloaded()&&1===t.numActive()?(t.release(Cw),Dw=null):console.warn("Could not clear WebWorkers since there are active Map instances that still reference it. The pre-warmed WebWorker pool can only be cleared when all map instances have been removed with map.remove()"));},get accessToken(){return n.ACCESS_TOKEN},set accessToken(t){n.ACCESS_TOKEN=t;},get baseApiUrl(){return n.API_URL},set baseApiUrl(t){n.API_URL=t;},get workerCount(){return zw.workerCount},set workerCount(t){zw.workerCount=t;},get maxParallelImageRequests(){return n.MAX_PARALLEL_IMAGE_REQUESTS},set maxParallelImageRequests(t){n.MAX_PARALLEL_IMAGE_REQUESTS=t;},clearStorage(t){!function(t){if(!ft())return;const i=e.caches.delete(ct);t&&i.catch(t).then((()=>t()));}(t);},workerUrl:"",workerClass:null,get loadersUrl(){return Ow()},set loadersUrl(t){!function(t){Lw=ue.resolveURL(t),kw||(kw=new Zb(Pw(),new Ce)),kw.broadcast("setLoadersUrl",Lw);}(t);},setNow:ue.setNow,restoreNow:ue.restoreNow};t.Actor=qb,t.DEMData=km,t.EXTENT=sr,t.Event=Se,t.FeatureIndex=Fm,t.KDBush=RT,t.OverscaledTileID=Rd,t.Point=y,t.Tiled3dModelBucket=Iv,t.VectorTileFeature=Xf,t.VectorTileWorkerSource=class extends Ce{constructor(t,e,i,r,n,o){super(),this.actor=t,this.layerIndex=e,this.availableImages=i,this.loadVectorData=n||aw,this.loading={},this.loaded={},this.deduped=new sw(t.scheduler),this.isSpriteLoaded=r,this.scheduler=t.scheduler,this.brightness=o;}loadTile(t,e){const i=t.uid,r=t&&t.request,n=r&&r.collectResourceTiming,o=this.loading[i]=new nw(t);o.abort=this.loadVectorData(t,((s,a)=>{const l=!this.loading[i];if(delete this.loading[i],l||s||!a)return o.status="done",l||(this.loaded[i]=o),e(s);const c=a.rawData,h={};a.expires&&(h.expires=a.expires),a.cacheControl&&(h.cacheControl=a.cacheControl),o.vectorTile=a.vectorTile||new Wf(new vm(c));const u=()=>{o.parse(o.vectorTile,this.layerIndex,this.availableImages,this.actor,((t,i)=>{if(t||!i)return e(t);const o={};if(n){const t=re(r);t.length>0&&(o.resourceTiming=JSON.parse(JSON.stringify(t)));}e(null,k({rawTileData:c.slice(0)},i,h,o));}));};this.isSpriteLoaded?u():this.once("isSpriteLoaded",(()=>{this.scheduler?this.scheduler.add(u,{type:"parseTile",isSymbolTile:t.isSymbolTile,zoom:t.tileZoom}):u();})),this.loaded=this.loaded||{},this.loaded[i]=o;}));}reloadTile(t,e){const i=this.loaded,r=t.uid,n=this;if(i&&i[r]){const o=i[r];o.showCollisionBoxes=t.showCollisionBoxes,o.enableTerrain=!!t.enableTerrain,o.projection=t.projection,o.brightness=t.brightness,o.tileTransform=_g(t.tileID.canonical,t.projection),o.extraShadowCaster=t.extraShadowCaster;const s=(t,i)=>{const r=o.reloadCallback;r&&(delete o.reloadCallback,o.parse(o.vectorTile,n.layerIndex,this.availableImages,n.actor,r)),e(t,i);};"parsing"===o.status?o.reloadCallback=s:"done"===o.status&&(o.vectorTile?o.parse(o.vectorTile,this.layerIndex,this.availableImages,this.actor,s):s());}}abortTile(t,e){const i=t.uid,r=this.loading[i];r&&(r.abort&&r.abort(),delete this.loading[i]),e();}removeTile(t,e){const i=this.loaded,r=t.uid;i&&i[r]&&delete i[r],e();}},t.convertB3dm=function(t,e){const i=Mw(t);for(const t of i){for(const e of t.meshes)Aw(e);t.lights&&(t.meshes.push(Sw(t.lights,e)),t.lightMeshIndex=t.meshes.length-1);}return i},t.createExpression=yo,t.createStyleLayer=Db,t.enforceCacheSizeLimit=function(t){mt(),dt&&dt.then((e=>{e.keys().then((i=>{for(let r=0;r<i.length-t;r++)e.delete(i[r]);}));}));},t.exported=GS,t.extend=k,t.getArrayBuffer=Et,t.getDefaultExportFromCjs=d,t.getJSON=Tt,t.getPerformanceMeasurement=re,t.getProjection=Ug,t.load3DTile=async function(t){return await Fw(),mapboxglLoaders.parse(t,mapboxglLoaders.Tiles3DLoader,{worker:!1,gltf:{decompressMeshes:!0,postProcess:!1,loadBuffers:!0,loadImages:!0}})},t.pbf=Qf,t.plugin=Js,t.pointGeometry=_,t.refProperties=Hw,t.tileToMeter=Xd,t.values=L,t.vectorTile=Bf,t.window=e;}));

define(["./shared"],(function(e){"use strict";function t(e){if("number"==typeof e||"boolean"==typeof e||"string"==typeof e||null==e)return JSON.stringify(e);if(Array.isArray(e)){let r="[";for(const i of e)r+=`${t(i)},`;return `${r}]`}let r="{";for(const i of Object.keys(e).sort())r+=`${i}:${t(e[i])},`;return `${r}}`}function r(r){let i="";for(const o of e.refProperties)i+=`/${t(r[o])}`;return i}class i{constructor(e){this.keyCache={},e&&this.replace(e);}replace(e,t){this._layerConfigs={},this._layers={},this.update(e,[],t);}update(t,i,o){this._options=o;for(const r of t)this._layerConfigs[r.id]=r,(this._layers[r.id]=e.createStyleLayer(r,this._options)).compileFilter(),this.keyCache[r.id]&&delete this.keyCache[r.id];for(const e of i)delete this.keyCache[e],delete this._layerConfigs[e],delete this._layers[e];this.familiesBySource={};const s=function(e,t){const i={};for(let o=0;o<e.length;o++){const s=t&&t[e[o].id]||r(e[o]);t&&(t[e[o].id]=s);let n=i[s];n||(n=i[s]=[]),n.push(e[o]);}const o=[];for(const e in i)o.push(i[e]);return o}(e.values(this._layerConfigs),this.keyCache);for(const e of s){const t=e.map((e=>this._layers[e.id])),r=t[0];if("none"===r.visibility)continue;const i=r.source||"";let o=this.familiesBySource[i];o||(o=this.familiesBySource[i]={});const s=r.sourceLayer||"_geojsonTileLayer";let n=o[s];n||(n=o[s]=[]),n.push(t);}}}class o{loadTile(t,r){const{uid:i,encoding:o,rawImageData:s,padding:n,buildQuadTree:a}=t,l=e.window.ImageBitmap&&s instanceof e.window.ImageBitmap?this.getImageData(s,n):s;r(null,new e.DEMData(i,l,o,t.convertToFloat,n<1,a));}getImageData(e,t){this.offscreenCanvas&&this.offscreenCanvasContext||(this.offscreenCanvas=new OffscreenCanvas(e.width,e.height),this.offscreenCanvasContext=this.offscreenCanvas.getContext("2d",{willReadFrequently:!0})),this.offscreenCanvas.width=e.width,this.offscreenCanvas.height=e.height,this.offscreenCanvasContext.drawImage(e,0,0,e.width,e.height);const r=this.offscreenCanvasContext.getImageData(-t,-t,e.width+2*t,e.height+2*t);return this.offscreenCanvasContext.clearRect(0,0,this.offscreenCanvas.width,this.offscreenCanvas.height),r}}function s(e,t){if(0!==e.length){n(e[0],t);for(var r=1;r<e.length;r++)n(e[r],!t);}}function n(e,t){for(var r=0,i=0,o=0,s=e.length,n=s-1;o<s;n=o++){var a=(e[o][0]-e[n][0])*(e[n][1]+e[o][1]),l=r+a;i+=Math.abs(r)>=Math.abs(a)?r-l+a:a-l+r,r=l;}r+i>=0!=!!t&&e.reverse();}var a=e.getDefaultExportFromCjs((function e(t,r){var i,o=t&&t.type;if("FeatureCollection"===o)for(i=0;i<t.features.length;i++)e(t.features[i],r);else if("GeometryCollection"===o)for(i=0;i<t.geometries.length;i++)e(t.geometries[i],r);else if("Feature"===o)e(t.geometry,r);else if("Polygon"===o)s(t.coordinates,r);else if("MultiPolygon"===o)for(i=0;i<t.coordinates.length;i++)s(t.coordinates[i],r);return t}));const l=e.VectorTileFeature.prototype.toGeoJSON;var u={exports:{}},h=e.pointGeometry,c=e.vectorTile.VectorTileFeature,d=f;function f(e,t){this.options=t||{},this.features=e,this.length=e.length;}function p(e,t){this.id="number"==typeof e.id?e.id:void 0,this.type=e.type,this.rawGeometry=1===e.type?[e.geometry]:e.geometry,this.properties=e.tags,this.extent=t||4096;}f.prototype.feature=function(e){return new p(this.features[e],this.options.extent)},p.prototype.loadGeometry=function(){var e=this.rawGeometry;this.geometry=[];for(var t=0;t<e.length;t++){for(var r=e[t],i=[],o=0;o<r.length;o++)i.push(new h(r[o][0],r[o][1]));this.geometry.push(i);}return this.geometry},p.prototype.bbox=function(){this.geometry||this.loadGeometry();for(var e=this.geometry,t=1/0,r=-1/0,i=1/0,o=-1/0,s=0;s<e.length;s++)for(var n=e[s],a=0;a<n.length;a++){var l=n[a];t=Math.min(t,l.x),r=Math.max(r,l.x),i=Math.min(i,l.y),o=Math.max(o,l.y);}return [t,i,r,o]},p.prototype.toGeoJSON=c.prototype.toGeoJSON;var g=e.pbf,m=d;function y(e){var t=new g;return function(e,t){for(var r in e.layers)t.writeMessage(3,v,e.layers[r]);}(e,t),t.finish()}function v(e,t){var r;t.writeVarintField(15,e.version||1),t.writeStringField(1,e.name||""),t.writeVarintField(5,e.extent||4096);var i={keys:[],values:[],keycache:{},valuecache:{}};for(r=0;r<e.length;r++)i.feature=e.feature(r),t.writeMessage(2,x,i);var o=i.keys;for(r=0;r<o.length;r++)t.writeStringField(3,o[r]);var s=i.values;for(r=0;r<s.length;r++)t.writeMessage(4,I,s[r]);}function x(e,t){var r=e.feature;void 0!==r.id&&t.writeVarintField(1,r.id),t.writeMessage(2,w,e),t.writeVarintField(3,r.type),t.writeMessage(4,b,r);}function w(e,t){var r=e.feature,i=e.keys,o=e.values,s=e.keycache,n=e.valuecache;for(var a in r.properties){var l=r.properties[a],u=s[a];if(null!==l){void 0===u&&(i.push(a),s[a]=u=i.length-1),t.writeVarint(u);var h=typeof l;"string"!==h&&"boolean"!==h&&"number"!==h&&(l=JSON.stringify(l));var c=h+":"+l,d=n[c];void 0===d&&(o.push(l),n[c]=d=o.length-1),t.writeVarint(d);}}}function S(e,t){return (t<<3)+(7&e)}function M(e){return e<<1^e>>31}function b(e,t){for(var r=e.loadGeometry(),i=e.type,o=0,s=0,n=r.length,a=0;a<n;a++){var l=r[a],u=1;1===i&&(u=l.length),t.writeVarint(S(1,u));for(var h=3===i?l.length-1:l.length,c=0;c<h;c++){1===c&&1!==i&&t.writeVarint(S(2,h-1));var d=l[c].x-o,f=l[c].y-s;t.writeVarint(M(d)),t.writeVarint(M(f)),o+=d,s+=f;}3===i&&t.writeVarint(S(7,1));}}function I(e,t){var r=typeof e;"string"===r?t.writeStringField(1,e):"boolean"===r?t.writeBooleanField(7,e):"number"===r&&(e%1!=0?t.writeDoubleField(3,e):e<0?t.writeSVarintField(6,e):t.writeVarintField(5,e));}u.exports=y,u.exports.fromVectorTileJs=y,u.exports.fromGeojsonVt=function(e,t){t=t||{};var r={};for(var i in e)r[i]=new m(e[i].features,t),r[i].name=i,r[i].version=t.version,r[i].extent=t.extent;return y({layers:r})},u.exports.GeoJSONWrapper=m;var T=e.getDefaultExportFromCjs(u.exports);const P={minZoom:0,maxZoom:16,minPoints:2,radius:40,extent:512,nodeSize:64,log:!1,generateId:!1,reduce:null,map:e=>e},k=Math.fround||(_=new Float32Array(1),e=>(_[0]=+e,_[0]));var _;const L=3,C=5,O=6;class j{constructor(e){this.options=Object.assign(Object.create(P),e),this.trees=new Array(this.options.maxZoom+1),this.stride=this.options.reduce?7:6,this.clusterProps=[];}load(e){const{log:t,minZoom:r,maxZoom:i}=this.options;t&&console.time("total time");const o=`prepare ${e.length} points`;t&&console.time(o),this.points=e;const s=[];for(let t=0;t<e.length;t++){const r=e[t];if(!r.geometry)continue;const[i,o]=r.geometry.coordinates,n=k(F(i)),a=k(Z(o));s.push(n,a,1/0,t,-1,1),this.options.reduce&&s.push(0);}let n=this.trees[i+1]=this._createTree(s);t&&console.timeEnd(o);for(let e=i;e>=r;e--){const r=+Date.now();n=this.trees[e]=this._createTree(this._cluster(n,e)),t&&console.log("z%d: %d clusters in %dms",e,n.numItems,+Date.now()-r);}return t&&console.timeEnd("total time"),this}getClusters(e,t){let r=((e[0]+180)%360+360)%360-180;const i=Math.max(-90,Math.min(90,e[1]));let o=180===e[2]?180:((e[2]+180)%360+360)%360-180;const s=Math.max(-90,Math.min(90,e[3]));if(e[2]-e[0]>=360)r=-180,o=180;else if(r>o){const e=this.getClusters([r,i,180,s],t),n=this.getClusters([-180,i,o,s],t);return e.concat(n)}const n=this.trees[this._limitZoom(t)],a=n.range(F(r),Z(s),F(o),Z(i)),l=n.data,u=[];for(const e of a){const t=this.stride*e;u.push(l[t+C]>1?E(l,t,this.clusterProps):this.points[l[t+L]]);}return u}getChildren(e){const t=this._getOriginId(e),r=this._getOriginZoom(e),i="No cluster with the specified id.",o=this.trees[r];if(!o)throw new Error(i);const s=o.data;if(t*this.stride>=s.length)throw new Error(i);const n=this.options.radius/(this.options.extent*Math.pow(2,r-1)),a=o.within(s[t*this.stride],s[t*this.stride+1],n),l=[];for(const t of a){const r=t*this.stride;s[r+4]===e&&l.push(s[r+C]>1?E(s,r,this.clusterProps):this.points[s[r+L]]);}if(0===l.length)throw new Error(i);return l}getLeaves(e,t,r){const i=[];return this._appendLeaves(i,e,t=t||10,r=r||0,0),i}getTile(e,t,r){const i=this.trees[this._limitZoom(e)],o=Math.pow(2,e),{extent:s,radius:n}=this.options,a=n/s,l=(r-a)/o,u=(r+1+a)/o,h={features:[]};return this._addTileFeatures(i.range((t-a)/o,l,(t+1+a)/o,u),i.data,t,r,o,h),0===t&&this._addTileFeatures(i.range(1-a/o,l,1,u),i.data,o,r,o,h),t===o-1&&this._addTileFeatures(i.range(0,l,a/o,u),i.data,-1,r,o,h),h.features.length?h:null}getClusterExpansionZoom(e){let t=this._getOriginZoom(e)-1;for(;t<=this.options.maxZoom;){const r=this.getChildren(e);if(t++,1!==r.length)break;e=r[0].properties.cluster_id;}return t}_appendLeaves(e,t,r,i,o){const s=this.getChildren(t);for(const t of s){const s=t.properties;if(s&&s.cluster?o+s.point_count<=i?o+=s.point_count:o=this._appendLeaves(e,s.cluster_id,r,i,o):o<i?o++:e.push(t),e.length===r)break}return o}_createTree(t){const r=new e.KDBush(t.length/this.stride|0,this.options.nodeSize,Float32Array);for(let e=0;e<t.length;e+=this.stride)r.add(t[e],t[e+1]);return r.finish(),r.data=t,r}_addTileFeatures(e,t,r,i,o,s){for(const n of e){const e=n*this.stride,a=t[e+C]>1;let l,u,h;if(a)l=D(t,e,this.clusterProps),u=t[e],h=t[e+1];else {const r=this.points[t[e+L]];l=r.properties;const[i,o]=r.geometry.coordinates;u=F(i),h=Z(o);}const c={type:1,geometry:[[Math.round(this.options.extent*(u*o-r)),Math.round(this.options.extent*(h*o-i))]],tags:l};let d;d=a||this.options.generateId?t[e+L]:this.points[t[e+L]].id,void 0!==d&&(c.id=d),s.features.push(c);}}_limitZoom(e){return Math.max(this.options.minZoom,Math.min(Math.floor(+e),this.options.maxZoom+1))}_cluster(e,t){const{radius:r,extent:i,reduce:o,minPoints:s}=this.options,n=r/(i*Math.pow(2,t)),a=e.data,l=[],u=this.stride;for(let r=0;r<a.length;r+=u){if(a[r+2]<=t)continue;a[r+2]=t;const i=a[r],h=a[r+1],c=e.within(a[r],a[r+1],n),d=a[r+C];let f=d;for(const e of c){const r=e*u;a[r+2]>t&&(f+=a[r+C]);}if(f>d&&f>=s){let e,s=i*d,n=h*d,p=-1;const g=((r/u|0)<<5)+(t+1)+this.points.length;for(const i of c){const l=i*u;if(a[l+2]<=t)continue;a[l+2]=t;const h=a[l+C];s+=a[l]*h,n+=a[l+1]*h,a[l+4]=g,o&&(e||(e=this._map(a,r,!0),p=this.clusterProps.length,this.clusterProps.push(e)),o(e,this._map(a,l)));}a[r+4]=g,l.push(s/f,n/f,1/0,g,-1,f),o&&l.push(p);}else {for(let e=0;e<u;e++)l.push(a[r+e]);if(f>1)for(const e of c){const r=e*u;if(!(a[r+2]<=t)){a[r+2]=t;for(let e=0;e<u;e++)l.push(a[r+e]);}}}}return l}_getOriginId(e){return e-this.points.length>>5}_getOriginZoom(e){return (e-this.points.length)%32}_map(e,t,r){if(e[t+C]>1){const i=this.clusterProps[e[t+O]];return r?Object.assign({},i):i}const i=this.points[e[t+L]].properties,o=this.options.map(i);return r&&o===i?Object.assign({},o):o}}function E(e,t,r){return {type:"Feature",id:e[t+L],properties:D(e,t,r),geometry:{type:"Point",coordinates:[(i=e[t],360*(i-.5)),z(e[t+1])]}};var i;}function D(e,t,r){const i=e[t+C],o=i>=1e4?`${Math.round(i/1e3)}k`:i>=1e3?Math.round(i/100)/10+"k":i,s=e[t+O],n=-1===s?{}:Object.assign({},r[s]);return Object.assign(n,{cluster:!0,cluster_id:e[t+L],point_count:i,point_count_abbreviated:o})}function F(e){return e/360+.5}function Z(e){const t=Math.sin(e*Math.PI/180),r=.5-.25*Math.log((1+t)/(1-t))/Math.PI;return r<0?0:r>1?1:r}function z(e){const t=(180-360*e)*Math.PI/180;return 360*Math.atan(Math.exp(t))/Math.PI-90}var N={exports:{}};N.exports=function(){function e(r,i,o,s){for(var n,a=s,l=o-i>>1,u=o-i,h=r[i],c=r[i+1],d=r[o],f=r[o+1],p=i+3;p<o;p+=3){var g=t(r[p],r[p+1],h,c,d,f);if(g>a)n=p,a=g;else if(g===a){var m=Math.abs(p-l);m<u&&(n=p,u=m);}}a>s&&(n-i>3&&e(r,i,n,s),r[n+2]=a,o-n>3&&e(r,n,o,s));}function t(e,t,r,i,o,s){var n=o-r,a=s-i;if(0!==n||0!==a){var l=((e-r)*n+(t-i)*a)/(n*n+a*a);l>1?(r=o,i=s):l>0&&(r+=n*l,i+=a*l);}return (n=e-r)*n+(a=t-i)*a}function r(e,t,r,o){var s={id:void 0===e?null:e,type:t,geometry:r,tags:o,minX:1/0,minY:1/0,maxX:-1/0,maxY:-1/0};return function(e){var t=e.geometry,r=e.type;if("Point"===r||"MultiPoint"===r||"LineString"===r)i(e,t);else if("Polygon"===r||"MultiLineString"===r)for(var o=0;o<t.length;o++)i(e,t[o]);else if("MultiPolygon"===r)for(o=0;o<t.length;o++)for(var s=0;s<t[o].length;s++)i(e,t[o][s]);}(s),s}function i(e,t){for(var r=0;r<t.length;r+=3)e.minX=Math.min(e.minX,t[r]),e.minY=Math.min(e.minY,t[r+1]),e.maxX=Math.max(e.maxX,t[r]),e.maxY=Math.max(e.maxY,t[r+1]);}function o(e,t,i,l){if(t.geometry){var u=t.geometry.coordinates,h=t.geometry.type,c=Math.pow(i.tolerance/((1<<i.maxZoom)*i.extent),2),d=[],f=t.id;if(i.promoteId?f=t.properties[i.promoteId]:i.generateId&&(f=l||0),"Point"===h)s(u,d);else if("MultiPoint"===h)for(var p=0;p<u.length;p++)s(u[p],d);else if("LineString"===h)n(u,d,c,!1);else if("MultiLineString"===h){if(i.lineMetrics){for(p=0;p<u.length;p++)n(u[p],d=[],c,!1),e.push(r(f,"LineString",d,t.properties));return}a(u,d,c,!1);}else if("Polygon"===h)a(u,d,c,!0);else {if("MultiPolygon"!==h){if("GeometryCollection"===h){for(p=0;p<t.geometry.geometries.length;p++)o(e,{id:f,geometry:t.geometry.geometries[p],properties:t.properties},i,l);return}throw new Error("Input data is not a valid GeoJSON object.")}for(p=0;p<u.length;p++){var g=[];a(u[p],g,c,!0),d.push(g);}}e.push(r(f,h,d,t.properties));}}function s(e,t){t.push(l(e[0])),t.push(u(e[1])),t.push(0);}function n(t,r,i,o){for(var s,n,a=0,h=0;h<t.length;h++){var c=l(t[h][0]),d=u(t[h][1]);r.push(c),r.push(d),r.push(0),h>0&&(a+=o?(s*d-c*n)/2:Math.sqrt(Math.pow(c-s,2)+Math.pow(d-n,2))),s=c,n=d;}var f=r.length-3;r[2]=1,e(r,0,f,i),r[f+2]=1,r.size=Math.abs(a),r.start=0,r.end=r.size;}function a(e,t,r,i){for(var o=0;o<e.length;o++){var s=[];n(e[o],s,r,i),t.push(s);}}function l(e){return e/360+.5}function u(e){var t=Math.sin(e*Math.PI/180),r=.5-.25*Math.log((1+t)/(1-t))/Math.PI;return r<0?0:r>1?1:r}function h(e,t,i,o,s,n,a,l){if(o/=t,n>=(i/=t)&&a<o)return e;if(a<i||n>=o)return null;for(var u=[],h=0;h<e.length;h++){var f=e[h],g=f.geometry,m=f.type,y=0===s?f.minX:f.minY,v=0===s?f.maxX:f.maxY;if(y>=i&&v<o)u.push(f);else if(!(v<i||y>=o)){var x=[];if("Point"===m||"MultiPoint"===m)c(g,x,i,o,s);else if("LineString"===m)d(g,x,i,o,s,!1,l.lineMetrics);else if("MultiLineString"===m)p(g,x,i,o,s,!1);else if("Polygon"===m)p(g,x,i,o,s,!0);else if("MultiPolygon"===m)for(var w=0;w<g.length;w++){var S=[];p(g[w],S,i,o,s,!0),S.length&&x.push(S);}if(x.length){if(l.lineMetrics&&"LineString"===m){for(w=0;w<x.length;w++)u.push(r(f.id,m,x[w],f.tags));continue}"LineString"!==m&&"MultiLineString"!==m||(1===x.length?(m="LineString",x=x[0]):m="MultiLineString"),"Point"!==m&&"MultiPoint"!==m||(m=3===x.length?"Point":"MultiPoint"),u.push(r(f.id,m,x,f.tags));}}}return u.length?u:null}function c(e,t,r,i,o){for(var s=0;s<e.length;s+=3){var n=e[s+o];n>=r&&n<=i&&(t.push(e[s]),t.push(e[s+1]),t.push(e[s+2]));}}function d(e,t,r,i,o,s,n){for(var a,l,u=f(e),h=0===o?m:y,c=e.start,d=0;d<e.length-3;d+=3){var p=e[d],v=e[d+1],x=e[d+2],w=e[d+3],S=e[d+4],M=0===o?p:v,b=0===o?w:S,I=!1;n&&(a=Math.sqrt(Math.pow(p-w,2)+Math.pow(v-S,2))),M<r?b>r&&(l=h(u,p,v,w,S,r),n&&(u.start=c+a*l)):M>i?b<i&&(l=h(u,p,v,w,S,i),n&&(u.start=c+a*l)):g(u,p,v,x),b<r&&M>=r&&(l=h(u,p,v,w,S,r),I=!0),b>i&&M<=i&&(l=h(u,p,v,w,S,i),I=!0),!s&&I&&(n&&(u.end=c+a*l),t.push(u),u=f(e)),n&&(c+=a);}var T=e.length-3;p=e[T],v=e[T+1],x=e[T+2],(M=0===o?p:v)>=r&&M<=i&&g(u,p,v,x),T=u.length-3,s&&T>=3&&(u[T]!==u[0]||u[T+1]!==u[1])&&g(u,u[0],u[1],u[2]),u.length&&t.push(u);}function f(e){var t=[];return t.size=e.size,t.start=e.start,t.end=e.end,t}function p(e,t,r,i,o,s){for(var n=0;n<e.length;n++)d(e[n],t,r,i,o,s,!1);}function g(e,t,r,i){e.push(t),e.push(r),e.push(i);}function m(e,t,r,i,o,s){var n=(s-t)/(i-t);return e.push(s),e.push(r+(o-r)*n),e.push(1),n}function y(e,t,r,i,o,s){var n=(s-r)/(o-r);return e.push(t+(i-t)*n),e.push(s),e.push(1),n}function v(e,t){for(var i=[],o=0;o<e.length;o++){var s,n=e[o],a=n.type;if("Point"===a||"MultiPoint"===a||"LineString"===a)s=x(n.geometry,t);else if("MultiLineString"===a||"Polygon"===a){s=[];for(var l=0;l<n.geometry.length;l++)s.push(x(n.geometry[l],t));}else if("MultiPolygon"===a)for(s=[],l=0;l<n.geometry.length;l++){for(var u=[],h=0;h<n.geometry[l].length;h++)u.push(x(n.geometry[l][h],t));s.push(u);}i.push(r(n.id,a,s,n.tags));}return i}function x(e,t){var r=[];r.size=e.size,void 0!==e.start&&(r.start=e.start,r.end=e.end);for(var i=0;i<e.length;i+=3)r.push(e[i]+t,e[i+1],e[i+2]);return r}function w(e,t){if(e.transformed)return e;var r,i,o,s=1<<e.z,n=e.x,a=e.y;for(r=0;r<e.features.length;r++){var l=e.features[r],u=l.geometry,h=l.type;if(l.geometry=[],1===h)for(i=0;i<u.length;i+=2)l.geometry.push(S(u[i],u[i+1],t,s,n,a));else for(i=0;i<u.length;i++){var c=[];for(o=0;o<u[i].length;o+=2)c.push(S(u[i][o],u[i][o+1],t,s,n,a));l.geometry.push(c);}}return e.transformed=!0,e}function S(e,t,r,i,o,s){return [Math.round(r*(e*i-o)),Math.round(r*(t*i-s))]}function M(e,t,r,i,o){for(var s=t===o.maxZoom?0:o.tolerance/((1<<t)*o.extent),n={features:[],numPoints:0,numSimplified:0,numFeatures:0,source:null,x:r,y:i,z:t,transformed:!1,minX:2,minY:1,maxX:-1,maxY:0},a=0;a<e.length;a++){n.numFeatures++,b(n,e[a],s,o);var l=e[a].minX,u=e[a].minY,h=e[a].maxX,c=e[a].maxY;l<n.minX&&(n.minX=l),u<n.minY&&(n.minY=u),h>n.maxX&&(n.maxX=h),c>n.maxY&&(n.maxY=c);}return n}function b(e,t,r,i){var o=t.geometry,s=t.type,n=[];if("Point"===s||"MultiPoint"===s)for(var a=0;a<o.length;a+=3)n.push(o[a]),n.push(o[a+1]),e.numPoints++,e.numSimplified++;else if("LineString"===s)I(n,o,e,r,!1,!1);else if("MultiLineString"===s||"Polygon"===s)for(a=0;a<o.length;a++)I(n,o[a],e,r,"Polygon"===s,0===a);else if("MultiPolygon"===s)for(var l=0;l<o.length;l++){var u=o[l];for(a=0;a<u.length;a++)I(n,u[a],e,r,!0,0===a);}if(n.length){var h=t.tags||null;if("LineString"===s&&i.lineMetrics){for(var c in h={},t.tags)h[c]=t.tags[c];h.mapbox_clip_start=o.start/o.size,h.mapbox_clip_end=o.end/o.size;}var d={geometry:n,type:"Polygon"===s||"MultiPolygon"===s?3:"LineString"===s||"MultiLineString"===s?2:1,tags:h};null!==t.id&&(d.id=t.id),e.features.push(d);}}function I(e,t,r,i,o,s){var n=i*i;if(i>0&&t.size<(o?n:i))r.numPoints+=t.length/3;else {for(var a=[],l=0;l<t.length;l+=3)(0===i||t[l+2]>n)&&(r.numSimplified++,a.push(t[l]),a.push(t[l+1])),r.numPoints++;o&&function(e,t){for(var r=0,i=0,o=e.length,s=o-2;i<o;s=i,i+=2)r+=(e[i]-e[s])*(e[i+1]+e[s+1]);if(r>0===t)for(i=0,o=e.length;i<o/2;i+=2){var n=e[i],a=e[i+1];e[i]=e[o-2-i],e[i+1]=e[o-1-i],e[o-2-i]=n,e[o-1-i]=a;}}(a,s),e.push(a);}}function T(e,t){var r=(t=this.options=function(e,t){for(var r in t)e[r]=t[r];return e}(Object.create(this.options),t)).debug;if(r&&console.time("preprocess data"),t.maxZoom<0||t.maxZoom>24)throw new Error("maxZoom should be in the 0-24 range");if(t.promoteId&&t.generateId)throw new Error("promoteId and generateId cannot be used together.");var i=function(e,t){var r=[];if("FeatureCollection"===e.type)for(var i=0;i<e.features.length;i++)o(r,e.features[i],t,i);else o(r,"Feature"===e.type?e:{geometry:e},t);return r}(e,t);this.tiles={},this.tileCoords=[],r&&(console.timeEnd("preprocess data"),console.log("index: maxZoom: %d, maxPoints: %d",t.indexMaxZoom,t.indexMaxPoints),console.time("generate tiles"),this.stats={},this.total=0),(i=function(e,t){var r=t.buffer/t.extent,i=e,o=h(e,1,-1-r,r,0,-1,2,t),s=h(e,1,1-r,2+r,0,-1,2,t);return (o||s)&&(i=h(e,1,-r,1+r,0,-1,2,t)||[],o&&(i=v(o,1).concat(i)),s&&(i=i.concat(v(s,-1)))),i}(i,t)).length&&this.splitTile(i,0,0,0),r&&(i.length&&console.log("features: %d, points: %d",this.tiles[0].numFeatures,this.tiles[0].numPoints),console.timeEnd("generate tiles"),console.log("tiles generated:",this.total,JSON.stringify(this.stats)));}function P(e,t,r){return 32*((1<<e)*r+t)+e}return T.prototype.options={maxZoom:14,indexMaxZoom:5,indexMaxPoints:1e5,tolerance:3,extent:4096,buffer:64,lineMetrics:!1,promoteId:null,generateId:!1,debug:0},T.prototype.splitTile=function(e,t,r,i,o,s,n){for(var a=[e,t,r,i],l=this.options,u=l.debug;a.length;){i=a.pop(),r=a.pop(),t=a.pop(),e=a.pop();var c=1<<t,d=P(t,r,i),f=this.tiles[d];if(!f&&(u>1&&console.time("creation"),f=this.tiles[d]=M(e,t,r,i,l),this.tileCoords.push({z:t,x:r,y:i}),u)){u>1&&(console.log("tile z%d-%d-%d (features: %d, points: %d, simplified: %d)",t,r,i,f.numFeatures,f.numPoints,f.numSimplified),console.timeEnd("creation"));var p="z"+t;this.stats[p]=(this.stats[p]||0)+1,this.total++;}if(f.source=e,o){if(t===l.maxZoom||t===o)continue;var g=1<<o-t;if(r!==Math.floor(s/g)||i!==Math.floor(n/g))continue}else if(t===l.indexMaxZoom||f.numPoints<=l.indexMaxPoints)continue;if(f.source=null,0!==e.length){u>1&&console.time("clipping");var m,y,v,x,w,S,b=.5*l.buffer/l.extent,I=.5-b,T=.5+b,k=1+b;m=y=v=x=null,w=h(e,c,r-b,r+T,0,f.minX,f.maxX,l),S=h(e,c,r+I,r+k,0,f.minX,f.maxX,l),e=null,w&&(m=h(w,c,i-b,i+T,1,f.minY,f.maxY,l),y=h(w,c,i+I,i+k,1,f.minY,f.maxY,l),w=null),S&&(v=h(S,c,i-b,i+T,1,f.minY,f.maxY,l),x=h(S,c,i+I,i+k,1,f.minY,f.maxY,l),S=null),u>1&&console.timeEnd("clipping"),a.push(m||[],t+1,2*r,2*i),a.push(y||[],t+1,2*r,2*i+1),a.push(v||[],t+1,2*r+1,2*i),a.push(x||[],t+1,2*r+1,2*i+1);}}},T.prototype.getTile=function(e,t,r){var i=this.options,o=i.extent,s=i.debug;if(e<0||e>24)return null;var n=1<<e,a=P(e,t=(t%n+n)%n,r);if(this.tiles[a])return w(this.tiles[a],o);s>1&&console.log("drilling down to z%d-%d-%d",e,t,r);for(var l,u=e,h=t,c=r;!l&&u>0;)u--,h=Math.floor(h/2),c=Math.floor(c/2),l=this.tiles[P(u,h,c)];return l&&l.source?(s>1&&console.log("found parent tile z%d-%d-%d",u,h,c),s>1&&console.time("drilling down"),this.splitTile(l.source,u,h,c,e,t,r),s>1&&console.timeEnd("drilling down"),this.tiles[a]?w(this.tiles[a],o):null):null},function(e,t){return new T(e,t)}}();var J=e.getDefaultExportFromCjs(N.exports);function W(t,r){const i=t.tileID.canonical;if(!this._geoJSONIndex)return r(null,null);const o=this._geoJSONIndex.getTile(i.z,i.x,i.y);if(!o)return r(null,null);const s=new class{constructor(t){this.layers={_geojsonTileLayer:this},this.name="_geojsonTileLayer",this.extent=e.EXTENT,this.length=t.length,this._features=t;}feature(t){return new class{constructor(t){this._feature=t,this.extent=e.EXTENT,this.type=t.type,this.properties=t.tags,"id"in t&&!isNaN(t.id)&&(this.id=parseInt(t.id,10));}loadGeometry(){if(1===this._feature.type){const t=[];for(const r of this._feature.geometry)t.push([new e.Point(r[0],r[1])]);return t}{const t=[];for(const r of this._feature.geometry){const i=[];for(const t of r)i.push(new e.Point(t[0],t[1]));t.push(i);}return t}}toGeoJSON(e,t,r){return l.call(this,e,t,r)}}(this._features[t])}}(o.features);let n=T(s);0===n.byteOffset&&n.byteLength===n.buffer.byteLength||(n=new Uint8Array(n)),r(null,{vectorTile:s,rawData:n.buffer});}class G extends e.VectorTileWorkerSource{constructor(e,t,r,i,o,s){super(e,t,r,i,W,s),o&&(this.loadGeoJSON=o);}loadData(t,r){const i=t&&t.request,o=i&&i.collectResourceTiming;this.loadGeoJSON(t,((s,n)=>{if(s||!n)return r(s);if("object"!=typeof n)return r(new Error(`Input data given to '${t.source}' is not a valid GeoJSON object.`));{a(n,!0);try{if(t.filter){const r=e.createExpression(t.filter,{type:"boolean","property-type":"data-driven",overridable:!1,transition:!1});if("error"===r.result)throw new Error(r.value.map((e=>`${e.key}: ${e.message}`)).join(", "));const i=n.features.filter((e=>r.value.evaluate({zoom:0},e)));n={type:"FeatureCollection",features:i};}this._geoJSONIndex=t.cluster?new j(function({superclusterOptions:t,clusterProperties:r}){if(!r||!t)return t;const i={},o={},s={accumulated:null,zoom:0},n={properties:null},a=Object.keys(r);for(const t of a){const[s,n]=r[t],a=e.createExpression(n),l=e.createExpression("string"==typeof s?[s,["accumulated"],["get",t]]:s);i[t]=a.value,o[t]=l.value;}return t.map=e=>{n.properties=e;const t={};for(const e of a)t[e]=i[e].evaluate(s,n);return t},t.reduce=(e,t)=>{n.properties=t;for(const t of a)s.accumulated=e[t],e[t]=o[t].evaluate(s,n);},t}(t)).load(n.features):J(n,t.geojsonVtOptions);}catch(s){return r(s)}this.loaded={};const l={};if(o){const r=e.getPerformanceMeasurement(i);r&&(l.resourceTiming={},l.resourceTiming[t.source]=JSON.parse(JSON.stringify(r)));}r(null,l);}}));}reloadTile(e,t){const r=this.loaded;return r&&r[e.uid]?super.reloadTile(e,t):this.loadTile(e,t)}loadGeoJSON(t,r){if(t.request)e.getJSON(t.request,r);else {if("string"!=typeof t.data)return r(new Error(`Input data given to '${t.source}' is not a valid GeoJSON object.`));try{return r(null,JSON.parse(t.data))}catch(e){return r(new Error(`Input data given to '${t.source}' is not a valid GeoJSON object.`))}}}getClusterExpansionZoom(e,t){try{t(null,this._geoJSONIndex.getClusterExpansionZoom(e.clusterId));}catch(e){t(e);}}getClusterChildren(e,t){try{t(null,this._geoJSONIndex.getChildren(e.clusterId));}catch(e){t(e);}}getClusterLeaves(e,t){try{t(null,this._geoJSONIndex.getLeaves(e.clusterId,e.limit,e.offset));}catch(e){t(e);}}}class X{constructor(t,r){this.tileID=new e.OverscaledTileID(t.tileID.overscaledZ,t.tileID.wrap,t.tileID.canonical.z,t.tileID.canonical.x,t.tileID.canonical.y),this.tileZoom=t.tileZoom,this.uid=t.uid,this.zoom=t.zoom,this.canonical=t.tileID.canonical,this.pixelRatio=t.pixelRatio,this.tileSize=t.tileSize,this.source=t.source,this.overscaling=this.tileID.overscaleFactor(),this.enableTerrain=!!t.enableTerrain,this.projection=t.projection,this.brightness=r;}async parse(t,r,i,o){this.status="parsing";const s=new e.OverscaledTileID(i.tileID.overscaledZ,i.tileID.wrap,i.tileID.canonical.z,i.tileID.canonical.x,i.tileID.canonical.y),n={},a=r.familiesBySource[i.source],l=new e.FeatureIndex(s,i.promoteId);l.bucketLayerIDs=[];const u=await e.load3DTile(t).catch((e=>o(new Error(e.message))));if(!u)return o(new Error("Could not parse tile"));const h=e.convertB3dm(u.gltf,1/e.tileToMeter(i.tileID.canonical)),c=u.gltf.json.extensionsUsed&&u.gltf.json.extensionsUsed.includes("MAPBOX_mesh_features");for(const t in a)for(const r of a[t]){const t=r[0],i=u.gltf.json.extensionsUsed,o=new e.Tiled3dModelBucket(h,s,i&&i.includes("MAPBOX_mesh_features"),this.brightness);c||(o.needsUpload=!0),n[t.id]=o;}this.status="done",o(null,{buckets:n,featureIndex:l});}}class Y{constructor(e,t,r,i,o,s){this.actor=e,this.layerIndex=t,this.brightness=s,this.loading={},this.loaded={};}loadTile(t,r){const i=t.uid,o=this.loading[i]=new X(t,this.brightness);e.getArrayBuffer(t.request,((e,s)=>{const n=!this.loading[i];return delete this.loading[i],n||e?(o.status="done",n||(this.loaded[i]=o),r(e)):s&&0!==s.byteLength?void o.parse(s,this.layerIndex,t,((e,t)=>{o.status="done",this.loaded=this.loaded||{},this.loaded[i]=o,e||!t?r(e):r(null,t);})):(o.status="done",this.loaded[i]=o,r())}));}reloadTile(e,t){const r=this.loaded,i=e.uid;if(r&&r[i]){const o=r[i];o.enableTerrain=!!e.enableTerrain,o.projection=e.projection,o.brightness=e.brightness;const s=(r,i)=>{o.reloadCallback&&(delete o.reloadCallback,this.loadTile(e,t)),t(r,i);};"parsing"===o.status?o.reloadCallback=s:"done"===o.status&&this.loadTile(e,t);}}abortTile(e,t){const r=e.uid;this.loading[r]&&delete this.loading[r],t();}removeTile(e,t){const r=this.loaded,i=e.uid;r&&r[i]&&delete r[i],t();}}class V{constructor(t){this.self=t,this.actor=new e.Actor(t,this),this.layerIndexes={},this.availableImages={},this.isSpriteLoaded={},this.projections={},this.defaultProjection=e.getProjection({name:"mercator"}),this.workerSourceTypes={vector:e.VectorTileWorkerSource,geojson:G,"batched-model":Y},this.workerSources={},this.demWorkerSources={},this.self.registerWorkerSource=(e,t)=>{if(this.workerSourceTypes[e])throw new Error(`Worker source with name "${e}" already registered.`);this.workerSourceTypes[e]=t;},this.self.registerRTLTextPlugin=t=>{if(e.plugin.isParsed())throw new Error("RTL text plugin already registered.");e.plugin.applyArabicShaping=t.applyArabicShaping,e.plugin.processBidirectionalText=t.processBidirectionalText,e.plugin.processStyledBidirectionalText=t.processStyledBidirectionalText;};}clearCaches(e,t,r){delete this.layerIndexes[e],delete this.availableImages[e],delete this.workerSources[e],delete this.demWorkerSources[e],r();}checkIfReady(e,t,r){r();}setReferrer(e,t){this.referrer=t;}spriteLoaded(t,r){this.isSpriteLoaded[t]||(this.isSpriteLoaded[t]={}),this.isSpriteLoaded[t][r.scope]=r.isLoaded;for(const i in this.workerSources[t]){const o=this.workerSources[t][i];for(const t in o)o[t]instanceof e.VectorTileWorkerSource&&(o[t].isSpriteLoaded=r.isLoaded,o[t].fire(new e.Event("isSpriteLoaded")));}}setImages(e,t,r){const{scope:i,images:o}=t;this.availableImages[e]||(this.availableImages[e]={}),this.availableImages[e][i]=o;for(const t in this.workerSources[e]){const r=this.workerSources[e][t];for(const e in r)r[e].availableImages=o;}r();}enableTerrain(e,t,r){this.terrain=t,r();}setProjection(t,r){this.projections[t]=e.getProjection(r);}setBrightness(e,t,r){this.brightness=t,r();}setLayers(e,t,r){this.getLayerIndex(e,t.scope).replace(t.layers,t.options),r();}updateLayers(e,t,r){this.getLayerIndex(e,t.scope).update(t.layers,t.removedIds,t.options),r();}loadTile(t,r,i){const o=this.enableTerrain?e.extend({enableTerrain:this.terrain},r):r;o.projection=this.projections[t]||this.defaultProjection,this.getWorkerSource(t,r.type,r.source,r.scope).loadTile(o,i);}loadDEMTile(t,r,i){const o=this.enableTerrain?e.extend({buildQuadTree:this.terrain},r):r;this.getDEMWorkerSource(t,r.source,r.scope).loadTile(o,i);}reloadTile(t,r,i){const o=this.enableTerrain?e.extend({enableTerrain:this.terrain},r):r;o.projection=this.projections[t]||this.defaultProjection,this.getWorkerSource(t,r.type,r.source,r.scope).reloadTile(o,i);}abortTile(e,t,r){this.getWorkerSource(e,t.type,t.source,t.scope).abortTile(t,r);}removeTile(e,t,r){this.getWorkerSource(e,t.type,t.source,t.scope).removeTile(t,r);}removeSource(e,t,r){if(!this.workerSources[e]||!this.workerSources[e][t.type]||!this.workerSources[e][t.type][t.source])return;const i=this.workerSources[e][t.type][t.source];delete this.workerSources[e][t.type][t.source],void 0!==i.removeSource?i.removeSource(t,r):r();}loadWorkerSource(e,t,r){try{this.self.importScripts(t.url),r();}catch(e){r(e.toString());}}syncRTLPluginState(t,r,i){try{e.plugin.setState(r);const t=e.plugin.getPluginURL();if(e.plugin.isLoaded()&&!e.plugin.isParsed()&&null!=t){this.self.importScripts(t);const r=e.plugin.isParsed();i(r?void 0:new Error(`RTL Text Plugin failed to import scripts from ${t}`),r);}}catch(e){i(e.toString());}}setLoadersUrl(e,t){this.loadersUrl=t;}getAvailableImages(e,t){this.availableImages[e]||(this.availableImages[e]={});let r=this.availableImages[e][t];return r||(r=[]),r}getLayerIndex(e,t){this.layerIndexes[e]||(this.layerIndexes[e]={});let r=this.layerIndexes[e][t];return r||(r=this.layerIndexes[e][t]=new i),r}getWorkerSource(e,t,r,i){if(this.workerSources[e]||(this.workerSources[e]={}),this.workerSources[e][t]||(this.workerSources[e][t]={}),this.isSpriteLoaded[e]||(this.isSpriteLoaded[e]={}),!this.workerSources[e][t][r]){const o={send:(t,r,i,o,s,n)=>{this.actor.send(t,r,i,e,s,n);},scheduler:this.actor.scheduler};this.workerSources[e][t][r]=new this.workerSourceTypes[t](o,this.getLayerIndex(e,i),this.getAvailableImages(e,i),this.isSpriteLoaded[e][i],void 0,this.brightness);}return this.workerSources[e][t][r]}getDEMWorkerSource(e,t,r){return this.demWorkerSources[e]||(this.demWorkerSources[e]={}),this.demWorkerSources[e][r]||(this.demWorkerSources[e][r]={}),this.demWorkerSources[e][r][t]||(this.demWorkerSources[e][r][t]=new o),this.demWorkerSources[e][r][t]}enforceCacheSizeLimit(t,r){e.enforceCacheSizeLimit(r);}getWorkerPerformanceMetrics(e,t,r){r(void 0,void 0);}}return "undefined"!=typeof WorkerGlobalScope&&"undefined"!=typeof self&&self instanceof WorkerGlobalScope&&(self.worker=new V(self)),V}));

define(["./shared"],(function(e){"use strict";return e.exported}));

//
// Our custom intro provides a specialized "define()" function, called by the
// AMD modules below, that sets up the worker blob URL and then executes the
// main module, storing its exported value as 'mapboxgl'


var mapboxgl$1 = mapboxgl;

return mapboxgl$1;

}));
//# sourceMappingURL=mapbox-gl.js.map
